
window.$tp_version = "#version#";
window.$tp_platform = "#platform#";
window.$tp_app_name = "Coin Impostor";

if (typeof window.jsb === 'object') {
    function check_assets() {
        function versionGreater(versionA, versionB) {
            if (!versionB) return 1;
            console.log("JS Custom Version Compare: version A is " + versionA + ', version B is ' + versionB);
            var vA = versionA.split('.');
            var vB = versionB.split('.');
            for (var i = 0; i < vA.length; ++i) {
                var a = parseInt(vA[i]);
                var b = parseInt(vB[i] || '0');
                if (a === b) {
                    continue;
                } else {
                    return a - b;
                }
            }
            if (vB.length > vA.length) {
                return -1;
            } else {
                return 0;
            }
        };

        function readVersion(file) {
            let version = "";
            let s = jsb.fileUtils.getStringFromFile(file);
            try {
                version = JSON.parse(s)["version"];
            } catch (e) {
                console.log("err:", file, e);
            }
            return version;
        }

        var writablePath = jsb.fileUtils.getWritablePath();
        var localVersion = readVersion("project.manifest");
        var cachedVersion = readVersion(writablePath + "hotupdate-asset/project.manifest");
        console.log("cachedVersion:", cachedVersion, "localVersion:", localVersion);
        if (versionGreater(localVersion, cachedVersion) > 0) {
            console.log("local version greater, remove hotupdate directory");
            jsb.fileUtils.removeDirectory(writablePath + "hotupdate-asset");
            localStorage.removeItem("HotUpdateSearchPaths");
        }

        var hotUpdateSearchPaths = localStorage.getItem('HotUpdateSearchPaths');
        if (hotUpdateSearchPaths) {
            var paths = JSON.parse(hotUpdateSearchPaths);
            jsb.fileUtils.setSearchPaths(paths);

            var fileList = [];
            var storagePath = paths[0] || '';
            var tempPath = storagePath + '_temp/';
            var baseOffset = tempPath.length;

            if (jsb.fileUtils.isDirectoryExist(tempPath) && !jsb.fileUtils.isFileExist(tempPath + 'project.manifest.temp')) {
                jsb.fileUtils.listFilesRecursively(tempPath, fileList);
                console.log(fileList);
                fileList.forEach(srcPath => {
                    var relativePath = srcPath.substr(baseOffset);
                    var dstPath = storagePath + relativePath;

                    if (srcPath[srcPath.length] == '/') {
                        jsb.fileUtils.createDirectory(dstPath)
                    } else {
                        if (jsb.fileUtils.isFileExist(dstPath)) {
                            jsb.fileUtils.removeFile(dstPath)
                        }
                        jsb.fileUtils.renameFile(srcPath, dstPath);
                    }
                })
                jsb.fileUtils.removeDirectory(tempPath);
            }
        }
    };
    try {
        check_assets();
    } catch (error) {
        console.log(error);
    }
}


// SystemJS support.
window.self = window;
require("src/system.bundle.js");

const importMapJson = jsb.fileUtils.getStringFromFile("src/import-map.json");
const importMap = JSON.parse(importMapJson);
System.warmup({
    importMap,
    importMapUrl: 'src/import-map.json',
    defaultHandler: (urlNoSchema) => {
        require(urlNoSchema.startsWith('/') ? urlNoSchema.substr(1) : urlNoSchema);
    },
});

System.import('./src/application.js').then(({ createApplication }) => {
    return createApplication({
        loadJsListFile: (url) => require(url),
    });
}).then((application) => {
    return application.import('cc').then((cc) => {
        require('jsb-adapter/jsb-engine.js');
        cc.sys.__init();
        cc.macro.CLEANUP_IMAGE_CACHE = false;
    }).then(() => {
        return application.start({
            settings: window._CCSettings,
            findCanvas: () => {
                var container = document.createElement('div');
                var frame = document.documentElement;
                var canvas = window.__canvas;
                return { frame, canvas, container };
            },
        });
    });
}).catch((err) => {
    console.error(err.toString());
});
