System.register("chunks:///_virtual/NativeLog.ts", ['cc', './Constant.ts', './ReuseScrollView.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, Component, MyCustomEvent, ReuseScrollView;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      ReuseScrollView = module.ReuseScrollView;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "00348U4g+5EjqQX7362ARlm", "NativeLog", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NativeLog = exports('NativeLog', (_dec = ccclass('NativeLog'), _dec2 = property(Node), _dec3 = property(Label), _dec(_class = (_class2 = (_temp = class NativeLog extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelItem", _descriptor, this);

          _initializerDefineProperty(this, "labelDetail", _descriptor2, this);
        }

        onEnable() {
          const reuseScrollView = this.getComponent(ReuseScrollView);
          reuseScrollView.initScrollView(appGame.logData, this.labelItem);
          eventCenter.on(MyCustomEvent.ConsoleNewLog, () => {
            reuseScrollView.autoScroll();
          }, this);
          eventCenter.on(MyCustomEvent.NativeLogDetail, msg => {
            this.labelDetail.string = msg;
          }, this);
        }

        onDisable() {
          const reuseScrollView = this.getComponent(ReuseScrollView);
          reuseScrollView.clear();
          eventCenter.off(MyCustomEvent.ConsoleNewLog);
          eventCenter.off(MyCustomEvent.NativeLogDetail);
        }

        onClose() {
          this.node.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelItem", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelDetail", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/EnergyFullAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, sp, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sp = module.sp;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "013e4YrNMFIgJv8Z2i8A7RE", "EnergyFullAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let EnergyFullAnim = exports('default', (_dec = property(sp.Skeleton), ccclass(_class = (_class2 = (_temp = class EnergyFullAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spineAnim", _descriptor, this);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.node.active = false;
        }

        start() {}

        play(cb) {
          this.node.active = true;
          this.spineAnim.setAnimation(0, "animation", false);
          this.spineAnim.setToSetupPose();
          this.spineAnim.setCompleteListener(() => {
            this.node.active = false;

            if (cb != null) {
              cb();
            }
          });
        }

        stop() {
          this.node.active = false;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "spineAnim", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LabelItem.ts", ['cc', './Constant.ts', './ReuseItem.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, MyCustomEvent, ResueItem;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      ResueItem = module.ResueItem;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "017afRKGFlGk7BZsM9QSVsG", "LabelItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LabelItem = exports('LabelItem', (_dec = ccclass('LabelItem'), _dec2 = property(Label), _dec(_class = (_class2 = (_temp = class LabelItem extends ResueItem {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "label", _descriptor, this);
        }

        setData(data) {
          this.label.string = data;
        }

        onLabelClick() {
          eventCenter.emit(MyCustomEvent.NativeLogDetail, this.label.string);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "label", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CharacterLevelEditor.ts", ['cc', './Constant.ts'], function (exports) {
  'use strict';

  var cclegacy, Enum, MeshRenderer, CCBoolean, _decorator, Component, warn;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
      MeshRenderer = module.MeshRenderer;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      Component = module.Component;
      warn = module.warn;
    }, function () {}],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "01870W5PoJEZIFiNlemcJ/7", "CharacterLevelEditor", undefined);

      var Levels;

      (function (Levels) {
        Levels[Levels["level1"] = 1] = "level1";
        Levels[Levels["level2"] = 2] = "level2";
        Levels[Levels["level3"] = 3] = "level3";
        Levels[Levels["level4"] = 4] = "level4";
        Levels[Levels["level5"] = 5] = "level5";
      })(Levels || (Levels = {}));

      Enum(Levels);
      const {
        ccclass,
        property
      } = _decorator;
      let CharacterLevelEditor = exports('default', (_dec = ccclass("CharacterLevelEditor"), _dec2 = property({
        type: [MeshRenderer],
        displayName: "常驻节点",
        tooltip: "常驻显示节点（白名单）"
      }), _dec3 = property({
        type: [MeshRenderer],
        displayName: "normal常驻节点",
        tooltip: "normal状态常驻显示节点"
      }), _dec4 = property({
        type: [MeshRenderer],
        displayName: "damage常驻节点",
        tooltip: "damage状态常驻显示节点"
      }), _dec5 = property([MeshRenderer]), _dec6 = property([MeshRenderer]), _dec7 = property([MeshRenderer]), _dec8 = property([MeshRenderer]), _dec9 = property([MeshRenderer]), _dec10 = property([MeshRenderer]), _dec11 = property([MeshRenderer]), _dec12 = property([MeshRenderer]), _dec13 = property([MeshRenderer]), _dec14 = property([MeshRenderer]), _dec15 = property(CCBoolean), _dec16 = property({
        type: Levels
      }), _dec(_class = (_class2 = (_temp = class CharacterLevelEditor extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "alwaysExist", _descriptor, this);

          _initializerDefineProperty(this, "normalAlwaysExist", _descriptor2, this);

          _initializerDefineProperty(this, "destroyAlwaysExist", _descriptor3, this);

          _initializerDefineProperty(this, "level1Normal", _descriptor4, this);

          _initializerDefineProperty(this, "level1Destroyed", _descriptor5, this);

          _initializerDefineProperty(this, "level2Normal", _descriptor6, this);

          _initializerDefineProperty(this, "level2Destroyed", _descriptor7, this);

          _initializerDefineProperty(this, "level3Normal", _descriptor8, this);

          _initializerDefineProperty(this, "level3Destroyed", _descriptor9, this);

          _initializerDefineProperty(this, "level4Normal", _descriptor10, this);

          _initializerDefineProperty(this, "level4Destroyed", _descriptor11, this);

          _initializerDefineProperty(this, "level5Normal", _descriptor12, this);

          _initializerDefineProperty(this, "level5Destroyed", _descriptor13, this);

          _defineProperty(this, "_destroyed", false);

          _defineProperty(this, "_curLevel", Levels.level1);

          _defineProperty(this, "startCallBack", void 0);

          _defineProperty(this, "initialized", false);
        }

        get destroyed() {
          return this._destroyed;
        }

        set destroyed(bo) {
          this._destroyed = bo;
          this.refresh();
        }

        get curLevel() {
          return this._curLevel;
        }

        set curLevel(level) {
          this._curLevel = level;
          this.refresh();
        } // private anim: SkeletalAnimation;


        onLoad() {// this.anim = this.getComponent(SkeletalAnimation);
          // this.anim.playOnLoad = false;
          // this.refresh();
        }

        start() {
          this.initialized = true;
          this.startCallBack && this.startCallBack();
        }

        getLevelArr(level, destroyed) {
          if (level <= 0) return [];
          const normalLevelArr = [this.level1Normal, this.level2Normal, this.level3Normal, this.level4Normal, this.level5Normal];
          const destroyedLevelArr = [this.level1Destroyed, this.level2Destroyed, this.level3Destroyed, this.level4Destroyed, this.level5Destroyed]; //废弃destroy数组，人物倒下也显示normal状态
          // return destroyed ? destroyedLevelArr[level - 1] : normalLevelArr[level - 1];

          return normalLevelArr[level - 1];
        }

        refresh() {
          warn("show level:", this._curLevel, "destroyed", this._destroyed);
          let level = this._curLevel;
          let levelArr = this.getLevelArr(level, this._destroyed) || [];
          let showArr = [];
          showArr = showArr.concat(this.alwaysExist);

          if (this._destroyed) {
            showArr = showArr.concat(this.normalAlwaysExist);
            showArr = showArr.concat(this.destroyAlwaysExist);
          } else {
            showArr = showArr.concat(this.normalAlwaysExist);
          }

          showArr = showArr.concat(levelArr);
          let allShowArr = this.node.getComponentsInChildren(MeshRenderer);
          allShowArr.forEach(v => {
            if (v && v.node) {
              v.node.active = showArr.includes(v);
            }
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "alwaysExist", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "normalAlwaysExist", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "destroyAlwaysExist", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "level1Normal", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "level1Destroyed", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "level2Normal", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "level2Destroyed", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "level3Normal", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "level3Destroyed", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "level4Normal", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "level4Destroyed", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "level5Normal", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "level5Destroyed", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "destroyed", [_dec15], Object.getOwnPropertyDescriptor(_class2.prototype, "destroyed"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "curLevel", [_dec16], Object.getOwnPropertyDescriptor(_class2.prototype, "curLevel"), _class2.prototype)), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ReuseItem.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "01ed3F+K1ZFVa8cUARLbUuX", "ReuseItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ResueItem = exports('ResueItem', (_dec = ccclass("ResueItem"), _dec(_class = (_temp = class ResueItem extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_data", void 0);
        }

        setData(data) {
          this._data = data;
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShieldAnim.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, tween, easing, v3, CCE_Component, CCEaseTypes;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      tween = module.tween;
      easing = module.easing;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "01f4cJzy+5AdJmXCTXZGb2O", "ShieldAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShieldAnim = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class ShieldAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "light", _descriptor, this);

          _initializerDefineProperty(this, "shield", _descriptor2, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        play(posX, posY, waitTime, cb) {
          this.node.active = true;
          this.light.scaleX = 0;
          this.light.scaleY = 0;
          this.shield.scaleX = 0;
          this.shield.scaleY = 0;
          this.light.runAction(ccAction.scaleTo(0.2, 1.2, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          this.shield.stopAllActions();
          this.shield.runAction(ccAction.scaleTo(0.2, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          let duration = 0.8;
          tween(this.node).delay(waitTime).parallel(tween().parallel(tween().by(duration, {
            x: posX
          }), tween().by(duration, {
            y: posY
          }, {
            easing: easing.backIn
          })), tween().to(duration, {
            scale: v3(0.24, 0.24, 0.24)
          }, {
            easing: CCEaseTypes.GetEasing(CCEaseTypes.Types.easeQuadraticActionIn)
          })).call(() => {
            if (cb !== null) {
              cb();
            }

            this.node.active = false;
          }).start();
        }

        stop() {
          this.light.stopAllActions();
          this.shield.stopAllActions();
          this.node.stopAllActions();
          this.node.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "light", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "shield", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/InteractionNode.ts", ['cc', './Constant.ts', './CCE_Component.ts', './EnterCloseAnim.ts', './SoundManager.ts', './ResourceLoader.ts', './MetaManager.ts', './User.ts', './ChangeSceneManager.ts', './UserVillage.ts', './TutorialManager.ts', './VillageNode.ts', './GameMainWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts', './AppMain.ts', './DamageParticle.ts', './ContainerInteraction.ts', './RaidNode.ts', './InteractionUI.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, Widget, assetManager, instantiate, v3, tween, Vec3, Animation, ParticleSystem2D, MyCustomEvent, Constant, CCE_Component, EnterCloseAnim, SoundManager, ResourceLoader, MetaManager, User, ChangeSceneManager, UserVillage, TutorialManager, VillageNode, GameMainWindow, SR, UIRoot, Game, Meta, GameKit, i18n, AppMain, DamageParticle, ContainerInteraction, RaidNode, InteractionUI;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
      Widget = module.Widget;
      assetManager = module.assetManager;
      instantiate = module.instantiate;
      v3 = module.v3;
      tween = module.tween;
      Vec3 = module.Vec3;
      Animation = module.Animation;
      ParticleSystem2D = module.ParticleSystem2D;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      Constant = module.Constant;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      User = module.User;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      UserVillage = module.UserVillage;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      VillageNode = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }, function (module) {
      DamageParticle = module.default;
    }, function (module) {
      ContainerInteraction = module.default;
    }, function (module) {
      RaidNode = module.default;
    }, function (module) {
      InteractionUI = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "020caOK7ZxHy5GeL3/10A79", "InteractionNode", undefined);

      const SE_attack_over = "attack_win";
      const SE_raid_money = "steal_money";
      const SE_raid_nocoin = "steal_nocoins_in";
      const SE_raid_chest = "spins_bar";
      const SE_raid_over = "steal_popup";
      const SE_raid_perfect = "steal_perfect";
      const {
        ccclass,
        property
      } = _decorator;
      let InteractionNode = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Label), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Node), ccclass(_class = (_class2 = (_temp = class InteractionNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spVillage", _descriptor, this);

          _initializerDefineProperty(this, "villageContainer", _descriptor2, this);

          _initializerDefineProperty(this, "attackNodeContainer", _descriptor3, this);

          _initializerDefineProperty(this, "spBet", _descriptor4, this);

          _initializerDefineProperty(this, "labelBet", _descriptor5, this);

          _initializerDefineProperty(this, "modelRaid", _descriptor6, this);

          _initializerDefineProperty(this, "attackAnimSuperShield", _descriptor7, this);

          _initializerDefineProperty(this, "attackAnimSuperShieldGold", _descriptor8, this);

          _initializerDefineProperty(this, "raidAnimCoin", _descriptor9, this);

          _initializerDefineProperty(this, "raidAnimRibbon", _descriptor10, this);

          _initializerDefineProperty(this, "modelAttack", _descriptor11, this);

          _defineProperty(this, "ui", void 0);

          _defineProperty(this, "oldVillageResName", void 0);

          _defineProperty(this, "oldVillageIsLocal", void 0);

          _defineProperty(this, "villageNode", void 0);

          _defineProperty(this, "raidNode", void 0);

          _defineProperty(this, "loaded", void 0);

          _defineProperty(this, "loadProgress", void 0);

          _defineProperty(this, "bet", void 0);

          _defineProperty(this, "user", void 0);

          _defineProperty(this, "userVillage", void 0);

          _defineProperty(this, "randomUser", void 0);

          _defineProperty(this, "attacked", void 0);

          _defineProperty(this, "raidIds", []);

          _defineProperty(this, "raidRaids", void 0);

          _defineProperty(this, "raidRaidIds", void 0);

          _defineProperty(this, "raidAnimRibbonCopy", void 0);

          _defineProperty(this, "revenge_data_array", void 0);

          _defineProperty(this, "revenge_uiddata_array", void 0);

          _defineProperty(this, "attackUserId", void 0);

          _defineProperty(this, "completeCallback", void 0);

          _defineProperty(this, "all_stole", void 0);

          _defineProperty(this, "is_able_to_do_raid", void 0);

          _defineProperty(this, "hasBeenCaughted", false);

          _defineProperty(this, "cardChest", void 0);

          _defineProperty(this, "containerInteraction", void 0);

          _defineProperty(this, "hasRaidCount", 0);

          _defineProperty(this, "pbAttackVillage", void 0);

          _defineProperty(this, "pbRaid", void 0);

          _defineProperty(this, "friendList", void 0);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.ui = this.getComponent(InteractionUI);
          EnterCloseAnim.playCloseImmediately(this.node);
          eventCenter.on(MyCustomEvent.OpenRaidBox, this.doRaid, this);
          this.node.getChildByName("content").getComponent(Widget).top += AppMain.instance.statusBarHeight;
          this.node.getChildByName("content").getComponent(Widget).updateAlignment();
        }

        onDestroy() {
          eventCenter.off(MyCustomEvent.OpenRaidBox, this.doRaid, this);
        }

        Clear() {
          var _this$containerIntera, _this$attackNodeConta;

          EnterCloseAnim.playCloseImmediately(this.node);
          this.node.active = false;
          this.spVillage.active = false;
          this.villageContainer.destroyAllChildren(); // if (this.oldVillageResName) {
          // 	cce.releaseRes(this.oldVillageResName, cc.Prefab);
          // 	this.oldVillageResName = null;
          // }

          if (this.userVillage) {
            // const villageMeta: VillageMeta = MetaManager.GetMeta(MetaManager.MetaType.Village, this.userVillage.MapId());
            // let resId = villageMeta.ResId();
            // const isLocal = Constant.LocalMapIds.contains(this.userVillage.MapId());
            if (this.userVillage.MapId() !== myVillage.curshownMapId && this.pbAttackVillage) {
              assetManager.releaseAsset(this.pbAttackVillage);
              ResourceLoader.releaseVillage(this.oldVillageResName, this.oldVillageIsLocal);
              this.oldVillageResName = null;
            }
          }

          this.villageNode = null;
          this.loaded = false;
          this.loadProgress = 0;
          this.bet = 1;
          this.user = null;
          this.userVillage = null;
          this.randomUser = null;
          this.attacked = false;
          this.hasBeenCaughted = false;
          this.raidIds = [];
          this.raidRaids = [];
          this.raidRaidIds = [];
          this.hasRaidCount = 0;
          (_this$containerIntera = this.containerInteraction) === null || _this$containerIntera === void 0 ? void 0 : _this$containerIntera.reset();
          this.pbAttackVillage = null;
          this.attackAnimSuperShield.active = false;
          this.attackAnimSuperShieldGold.active = false; //var ribbonNodes = this.raidAnimRibbon.children
          //for (var i = 0; i < ribbonNodes.length; i++) {
          //    ribbonNodes[i].getComponent(cc.ParticleSystem2D).resetSystem()
          //}
          //this.scheduleOnce(() => {

          this.raidAnimRibbon.active = false; //}, 0.4)

          if (this.raidAnimRibbonCopy) {
            this.raidAnimRibbonCopy.destroy();
            this.raidAnimRibbonCopy = null;
          }

          this.revenge_data_array = null;
          this.revenge_uiddata_array = null;
          homeView.node.active = true;
          GameMainWindow.instance.node.active = true;
          GameMainWindow.instance.showUI(true);
          (_this$attackNodeConta = this.attackNodeContainer) === null || _this$attackNodeConta === void 0 ? void 0 : _this$attackNodeConta.destroyAllChildren();
        }

        async loadRaid(bet, userinfo, village) {
          this.bet = bet;
          this.user = new User();

          if (userinfo.isFriend && !userinfo.name) {
            let friend = Game.SUser.FriendsList()[userinfo.userId];

            if (friend) {
              userinfo.name = friend.Name();
              userinfo.avatar = friend.Avatar();
            }
          }

          this.user.updateData(userinfo);
          this.userVillage = new UserVillage();
          this.userVillage.updateData(village);
          this.attackUserId = this.user.UserId();
          let resPath = "raid3d/raid3d";

          if (!this.pbRaid) {
            this.pbRaid = await ResourceLoader.loadRaid(resPath, true);
          } // let vPre = await ResourceLoader.loadRaid(resPath);
          // this.villageContainer.destroyAllChildren();
          // let itemRaid: cc.Node = cc.instantiate(vPre);
          // this.raidNode = itemRaid.addComponent(RaidNode);
          // itemRaid.parent = this.villageContainer;
          // itemRaid.setPosition(cc.v3(0, 0, 0));
          // this.containerInteraction = this.villageContainer.getComponent(ContainerInteraction);
          // this.containerInteraction.init(itemRaid);


          this.loaded = true;
          this.node.emit("loaded");

          if (bet > 1) {
            this.labelBet.string = String.format(i18n.t("InteractionBet"), bet);
          }
        }

        instantiateRaid() {
          let vPre = this.pbRaid;
          this.villageContainer.destroyAllChildren();
          let itemRaid = instantiate(vPre);
          this.raidNode = itemRaid.addComponent(RaidNode);
          this.villageContainer.addChild(itemRaid);
          itemRaid.setPosition(v3(0, 0, 0));
          this.containerInteraction = this.villageContainer.getComponent(ContainerInteraction);
          this.containerInteraction.init(itemRaid);
        }

        async loadVillage(bet, userinfo, village) {
          this.bet = bet;
          this.user = new User();

          if (userinfo.isFriend && !userinfo.name) {
            let friend = Game.SUser.FriendsList()[userinfo.userId];

            if (friend) {
              userinfo.name = friend.Name();
              userinfo.avatar = friend.Avatar();
            }
          }

          this.user.updateData(userinfo);
          this.userVillage = new UserVillage();
          this.userVillage.updateData(village);
          this.attackUserId = this.user.UserId();
          let mapId = this.userVillage.MapId();
          const isLocal = Constant.LocalMapIds.contains(mapId);
          const villageMeta = MetaManager.GetMeta(MetaManager.MetaType.Village, mapId);
          let resId = villageMeta.ResId(); // resId = 37;

          let villageName = VillageNode.GetVillageName(resId);
          let resPath = VillageNode.GetVillageResPath(villageName);
          this.oldVillageResName = resPath;
          this.oldVillageIsLocal = isLocal;
          await ResourceLoader.loadAttackPrefabs();
          this.pbAttackVillage = await ResourceLoader.loadVillage(resPath, isLocal);
          this.node.active = true;
          this.spVillage.active = true;
          this.loaded = true;
          this.node.emit("loaded");

          if (bet > 1) {
            this.labelBet.string = String.format(i18n.t("InteractionBet"), bet); // this.labelBet2.string = String.format(i18n.t("InteractionBet"), bet);
          }
        } // 更换攻击目标


        async changeAttackTarget() {
          let mapId = this.userVillage.MapId();
          const isLocal = Constant.LocalMapIds.contains(mapId);
          const villageMeta = MetaManager.GetMeta(MetaManager.MetaType.Village, mapId);
          let resId = villageMeta.ResId();
          this.villageNode = null;
          this.loaded = false;
          let villageName = VillageNode.GetVillageName(resId);
          let resPath = VillageNode.GetVillageResPath(villageName);
          this.oldVillageResName = resPath;
          this.oldVillageIsLocal = isLocal;
          ResourceLoader.loadVillage(resPath, isLocal).then(pbVillage => {
            this.pbAttackVillage = pbVillage;
            this.instantiateAttack(); // 相机第一帧convertToUINode获取的位置有问题，延迟一帧

            this.scheduleOnce(() => {
              this.loaded = true;
              this.spVillage.active = true;
              this.node.active = true;
              this.node.emit("loaded");
            }, 0);
          });
          this.showModel(this.modelAttack, () => {
            this.ui.showAttack();
            this.villageNode.preShowAttack(this.attackNodeContainer);
          }, () => {
            this.villageNode.showAttack(this);
            this.containerInteraction.bomb.reachoutHand();
          });
        }

        instantiateAttack() {
          let vPre = this.pbAttackVillage;
          this.villageContainer.destroyAllChildren();
          let itemVillage = instantiate(vPre);
          this.villageNode = itemVillage.addComponent(VillageNode);
          this.villageNode.initBuilds(this.userVillage);
          this.villageContainer.addChild(itemVillage);
          this.containerInteraction = this.villageContainer.getComponent(ContainerInteraction);
          this.containerInteraction.init(itemVillage);
          this.containerInteraction.initBomb();
        } //显示攻击形态


        setAttackRandomUser(userinfo, village) {
          this.randomUser = {
            userId: userinfo.userId,
            user: userinfo,
            village: village,
            isRandom: true
          };
        }

        showAttack(cb) {
          // this.node.active = true;
          // homeView.node.active = false;
          // GameMainWindow.instance.node.active = false;
          this.completeCallback = cb;

          if (!this.revenge_data_array) {
            let getvnOk = res => {
              let resList = res.list;
              let data = []; //res.list

              let uiddata = [];
              data.push(this.randomUser || {
                userId: this.user.UserId(),
                user: this.user.getUserInfo(),
                village: this.userVillage.getData(),
                isRandom: true
              });
              let friends = Game.SUser.FriendsList();

              for (let i = 0; i < resList.length; i++) {
                if (!resList[i].isRevenged && !uiddata.contains(resList[i].userId) && resList[i].userId !== this.user.UserId()) {
                  if (resList[i].isFriend && friends[resList[i].userId]) {
                    resList[i].user = friends[resList[i].userId].getUserInfo();
                  }

                  data.push(resList[i]);
                  uiddata.push(resList[i].userId);
                }
              }

              let fdata = [];

              for (let uid in friends) {
                fdata.push({
                  userId: uid,
                  isFriend: true,
                  user: friends[uid].getUserInfo()
                });
              }

              this.friendList = fdata; // 保存数据

              this.revenge_data_array = data;
              this.revenge_uiddata_array = uiddata;
              UIRoot.instance.ShowCantClick(true); // homeView && homeView.updateDirectionLight("interaciton");

              this.scheduleOnce(() => {
                this.villageNode.preShowAttack(this.attackNodeContainer);
                this.villageNode.showAttack(this);
                this.ui.showAttack();
                SoundManager.playBgmByName(SoundManager.SoundNames.BGM_Attack);

                if (!TutorialManager.IsFinished()) {
                  this.scheduleOnce(() => {
                    TutorialManager.CallTrigger("start_attack");
                  }, 1.5);
                }
              }, 0.25);
              UIRoot.instance.CloseCantClick();
            };

            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              getvnOk({
                list: []
              });
            } else {
              let sr = SR.SRVillage.getVillageNews();
              sr.SetCallBack(res => {
                getvnOk(res);
              });
              sr.Send();
            }
          } else {
            UIRoot.instance.ShowCantClick(true);
            this.spVillage.active = true;
            this.villageNode.preShowAttack(this.attackNodeContainer);
            this.scheduleOnce(() => {
              this.villageNode.showAttack(this);
              this.ui.showAttack();
            }, 0.25);
          }
        } //执行攻击


        doAttack(type) {
          //已经攻击过了
          if (this.attacked) return;
          this.ui.doAttack();
          this.attacked = true;

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            if (AppMain.instance.tutorialManager.curTutorialIndex <= 3) {
              let getCoin = 150000;
              GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
                oldCoin: Game.SUser.Coin(),
                coin: Game.SUser.Coin() + getCoin,
                needPlayAnim: true
              });
              this.doAttackCallback({
                attackResult: {
                  success: true,
                  coin: getCoin
                }
              }, type);
            } else {
              let getCoin = 50000;
              GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
                oldCoin: Game.SUser.Coin(),
                coin: Game.SUser.Coin() + getCoin,
                needPlayAnim: true
              });
              this.doAttackCallback({
                attackResult: {
                  success: false,
                  coin: getCoin
                }
              }, type);
            }
          } else {
            let req = SR.SRInteraction.doAttack(type);
            req.SetRequestBody("attackUserId", this.attackUserId);
            req.SetRequestBody("isFriend", Game.SUser.FriendsList().hasOwnProperty(this.attackUserId));
            req.SetRequestBody("isRevenge", this.revenge_uiddata_array.contains(this.attackUserId));
            req.SetCallBack(res => {
              homeView.slotNode.oldCoin += res.attackResult.coin;
              this.doAttackCallback(res, type);
            });
            req.Send();
          }
        }

        doAttackCallback(res, type) {
          let success = res.attackResult.success;
          let servantActive = res.attackResult.servantActive;
          let timeShieldActive = res.attackResult.timeShieldActive;
          let timeShieldGoldActive = res.attackResult.timeShieldGoldActive;
          let coin = res.attackResult.coin;
          console.log("attack over", success, coin); // servantActive = Math.random() < 0.5;
          // success = true;
          // servantActive = true;

          let targetPos = this.villageNode.builds[type - 1].getChildByName("positions").getChildByName("attack").getWorldPosition();
          this.containerInteraction.throwBomb(targetPos, !success, servantActive, timeShieldGoldActive, timeShieldActive);

          if (success) {
            eventCenter.once(MyCustomEvent.OnBombHitTarget, () => {
              this.showAttackSuccessResult(type, success, coin, servantActive);
            }, this);
          } else {
            if (servantActive) {
              eventCenter.once(MyCustomEvent.OnBombHitDog, () => {
                this.showAttackBlockedResult(type, success, coin, servantActive, timeShieldGoldActive, timeShieldActive);
              }, this);
            } else {
              eventCenter.once(MyCustomEvent.OnBombHitShield, () => {
                this.showAttackBlockedResult(type, success, coin, servantActive, timeShieldGoldActive, timeShieldActive);
              }, this);
            }
          }
        }

        showAttackSuccessResult(type, success, coin, servantActive) {
          // servantActive = true;
          this.villageNode.destroyBuild(type);
          const villageMeta = MetaManager.GetMeta(MetaManager.MetaType.Village, homeView.interactionNode.userVillage.MapId());
          let resId = villageMeta.ResId();
          const canShowTiger = !Constant.skipTigerAnimResIds.contains(resId);

          if (servantActive && canShowTiger) {
            eventCenter.once(MyCustomEvent.OnTigerComeBack, () => {
              let servant = Game.SUserServant.Servant(Game.SUserServant.GetSelected());
              let rankmeta = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, servant.rank);
              let servantEffect = rankmeta.Effect(2);
              let servantCoin = Math.floor(coin * servantEffect / 1000) * 10;
              this.ui.showAttackServant(servantCoin, () => {
                this.attackResult(success, coin, true);
              }, () => {
                this.ui.attackResult2(success, coin + servantCoin);
              });
            }, this); // SoundManager.playSound("servant_show");
            // this.animServant2.active = true;
            // this.animServant2.scale = cc.v3(0, 0, 1);
            // this.animServant2.runAction(ccAction.scaleTo(0.2, 1, 1));
            // this.animServant2.children[0].children[0].getComponent(ServantNode).playEffect();
            // SoundManager.playSound("servant_2_effect");
            // this.scheduleOnce(() => {
            // 	this.animServant2.runAction(
            // 		ccAction.sequence(
            // 			ccAction.scaleTo(0.2, 0, 0),
            // 			ccAction.delayTime(0.3),
            // 			ccAction.callFunc(() => {
            // 				this.animServant2.active = false;
            // let servant = Game.SUserServant.Servant(Game.SUserServant.GetSelected());
            // let rankmeta = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, servant.rank);
            // let servantEffect = rankmeta.Effect(2);
            // let servantCoin = Math.floor((coin * servantEffect) / 1000) * 10;
            // this.ui.showAttackServant(
            // 	servantCoin,
            // 	() => {
            // 		this.attackResult(success, coin, true);
            // 	},
            // 	() => {
            // 		this.ui.attackResult2(success, coin + servantCoin);
            // 	}
            // );
            // 			})
            // 		)
            // 	);
            // }, 1.2);
            // this.scheduleOnce(() => {
            // 	this.attackResult(success, coin);
            // }, 0.3);
          } else {
            this.scheduleOnce(() => {
              this.attackResult(success, coin);
            }, 0.3);
          }
        }

        showAttackBlockedResult(type, success, coin, servantActive, timeShieldGoldActive, timeShieldActive) {
          this.scheduleOnce(() => {
            this.attackResult(success, coin);
          }, 0.3);
        }

        attackResult(success, coin, servantActive) {
          this.ui.attackResult(success, coin, servantActive);
          SoundManager.playSound(SE_attack_over);
        } //显示偷取形态


        showRaid(cb) {
          this.completeCallback = cb;
          this.showModel(this.modelRaid, () => {
            this.node.active = true;
            homeView.node.active = false;
            GameMainWindow.instance.node.active = false;
            this.instantiateRaid();
            eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "interaciton");
          }, () => {
            // this.villageNode.showRaid(this);
            this.raidNode.init();
            this.ui.showRaid(); // 初始化总计偷取的金币数量

            this.all_stole = 0; // 初始化是否允许挖（注意showRaid有动画时间）

            this.scheduleOnce(() => {
              this.is_able_to_do_raid = true;
            }, 1);
            SoundManager.playBgmByName(SoundManager.SoundNames.BGM_Raid);

            if (!TutorialManager.IsFinished()) {
              this.scheduleOnce(() => {
                TutorialManager.CallTrigger("start_raid");
              }, 1);
            }
          });
        } //执行偷取


        doRaid(id) {
          if (this.hasBeenCaughted) return; // 禁止重复点击 // 要考虑this.is_able_to_do_raid未被定义的情况

          if (this.raidIds.length >= 3) return; // 已经偷过这个位置了

          if (this.raidIds.contains(id)) {
            console.log("already has raid", id);
            return;
          }

          this.raidIds.push(id);

          let raidOk = res => {
            console.log(res);
            let coin = res.raidResult.coin;
            let servantActive = res.raidResult.servantActive;
            let timeShieldGoldActive = res.raidResult.timeShieldGoldActive;
            let oldCoin = this.all_stole;
            this.all_stole += coin;
            this.hasRaidCount++; // if (this.raidIds.length == 3) {
            // 	servantActive = true;
            // }

            if (this.raidIds.length == 1 && timeShieldGoldActive) {
              this.scheduleOnce(() => {
                this.attackAnimSuperShield.active = true;
                this.attackAnimSuperShield.getComponent(Animation).play();
                this.scheduleOnce(() => {
                  SoundManager.playSound("servant_3_effect");
                  this.scheduleOnce(() => {
                    this.ui.doRaidOver();
                    this.ui.raidResult(this.all_stole);
                    SoundManager.playSound("servant_4_effect");
                  }, 0.5);
                }, 0.2);
              }, 0.3);
              return;
            } else if (this.raidIds.length == 1 && servantActive) {
              this.raidNode.showPetProtect(() => {
                this.ui.doRaidOver();
                this.ui.raidResult(this.all_stole);
              });
              this.hasBeenCaughted = true;
              return;
            }

            this.raidNode.openBox(id - 1); //从动画开始到盒子打开的时间

            const openTime = 1.3;
            this.playCoinEruptAnim(id, coin, oldCoin, openTime, this.hasRaidCount); //金币数字移动动画
            // let hasRaidCount = this.raidIds.length;

            if (this.hasRaidCount === 3) {
              this.node.once("coinAnimOver", () => {
                console.log("this.raidOKCount === 3");
                this.scheduleOnce(() => {
                  console.log("this.onRaidOver(servantActive);");
                  this.onRaidOver(servantActive);
                }, openTime);
              });
            }

            this.ui.doRaid();
          };

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            if (this.raidIds.length == 1) {
              raidOk({
                raidResult: {
                  coin: 35000
                }
              });
            } else if (this.raidIds.length == 2) {
              raidOk({
                raidResult: {
                  coin: 0
                }
              });
            } else {
              GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
                oldCoin: Game.SUser.Coin(),
                coin: Game.SUser.Coin() + 175000,
                needPlayAnim: true
              });

              if (Game.SUserSlot.data.realToraidUser) {
                Game.SUserSlot.data.toraidUser = Game.SUserSlot.data.realToraidUser;
                Game.SUserSlot.data.realToraidUser = null;
                GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ToraidEvent, {
                  toraidUser: Game.SUserSlot.data.toraidUser
                });
              }

              raidOk({
                raidResult: {
                  coin: 140000
                }
              });
            }
          } else {
            // 服务器交互
            let req = SR.SRInteraction.doRaid();
            req.SetCallBack(function (res) {
              //res.raidResult.coin -= this.all_stole
              homeView.slotNode.oldCoin += res.raidResult.coin;
              console.log("<><><><><><><><>raidOK");
              raidOk(res);
            }.bind(this));
            req.Send();
            console.log("send request");
          }
        }

        playCoinEruptAnim(id, coin, oldCoin, openTime, hasRaidCount) {
          let coinPosNode = this.raidNode.boxes[id - 1].getChildByName("posCoin");
          let coinNode = this.raidNode.boxes[id - 1].getChildByName("jinbi Socket");

          if (!coinPosNode) {
            console.warn("cannot find coinNode");
            coinPosNode = this.raidNode.boxes[id - 1];
          }

          let targetPos = this.raidNode.camera.convertToUINodeWithTexture(coinPosNode.getWorldPosition(), this.node);

          if (coin > 0) {
            this.scheduleOnce(() => {
              let animCoin = instantiate(this.raidAnimCoin);
              animCoin.setPosition(targetPos);
              animCoin.active = true;
              this.node.addChild(animCoin);

              if (coinNode && coinNode.isValid) {
                tween(coinNode).to(0.5, {
                  scale: Vec3.ZERO
                }).start();
              }

              this.scheduleOnce(() => {
                animCoin && animCoin.destroy();
              }, 2);
              SoundManager.playSound(SE_raid_money);
            }, openTime);
          } else if (this.cardChest) {
            this.scheduleOnce(() => {
              SoundManager.playSound(SE_raid_chest);
            }, openTime);
          } else {
            coinNode && (coinNode.active = false);
            this.scheduleOnce(() => {
              SoundManager.playSound(SE_raid_nocoin);
            }, openTime);
          }

          this.scheduleOnce(() => {
            this.ui.raidCoinAnim(coin, oldCoin).then(() => {
              this.node.emit("coinAnimOver");
            });
          }, openTime + 0.2);
        }

        onRaidOver(servantActive) {
          console.log("onRaidOver"); // 5个动画播放完毕之后

          var doraid3 = oldCoin => {
            // 播放完毕动画
            if (!this.raidAnimRibbonCopy) {
              this.raidAnimRibbonCopy = instantiate(this.raidAnimRibbon);
              this.raidAnimRibbonCopy.setPosition(v3(this.raidAnimRibbon.position.x, this.raidAnimRibbon.position.y));
              this.raidAnimRibbonCopy.parent = this.raidAnimRibbon.parent;
              this.raidAnimRibbonCopy.active = true;
            }

            var ribbonNodes = this.raidAnimRibbonCopy.children;

            for (var i = 0; i < ribbonNodes.length; i++) {
              ribbonNodes[i].getComponent(ParticleSystem2D).resetSystem();
            }

            this.ui.doRaidOver();
            this.scheduleOnce(() => {
              // 注意这里的all_stole是增加了之后的值
              this.ui.raidResult(oldCoin);

              if (oldCoin === this.user.Coin()) {
                SoundManager.playSound(SE_raid_perfect);
              } else {
                SoundManager.playSound(SE_raid_over);
              }
            }, 1);
          };

          if (servantActive) {
            let letftId = -1;

            for (let i = 1; i <= 4; i++) {
              if (this.raidIds.indexOf(i) < 0) {
                letftId = i;
                break;
              }
            }

            this.raidNode.showPetIncreaseRaidReward(letftId - 1, () => {
              let servant = Game.SUserServant.Servant(Game.SUserServant.GetSelected());
              let servantEffect = 1;

              if (servant) {
                let rankmeta = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, servant.rank);
                servantEffect = rankmeta.Effect(1);
              }

              let servantCoin = Math.floor(this.all_stole * servantEffect / 1000) * 10;
              let oldCoin = this.all_stole;
              this.all_stole += servantCoin;
              this.ui.showRaidServant(servantCoin, oldCoin, () => {
                doraid3(oldCoin);
              });
            });
          } else {
            doraid3(this.all_stole);
          }

          if (!TutorialManager.IsFinished()) {
            TutorialManager.CallTrigger("over_raid");
          }
        } //显示参观形态


        showOverView() {} //播放过渡模版动画


        showModel(model, callbackCenter, callback) {
          ChangeSceneManager.instance.show(() => {
            this.spVillage.active = true;

            if (this.loaded) {
              callbackCenter && callbackCenter();
              this.scheduleOnce(() => {
                ChangeSceneManager.instance.hide(callback);
              }, 0.25);
            } else {
              this.node.once("loaded", () => {
                callbackCenter && callbackCenter();
                this.scheduleOnce(() => {
                  ChangeSceneManager.instance.hide(callback);
                }, 0.25);
              });
            }
          });
        } //关闭


        callClose() {
          homeView.node.active = true;
          GameMainWindow.instance.node.active = true;
          homeView.slotNode.activityRoot.stayReward();
          this.Clear();
          eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "home", 2, 0);
          this.node.runAction(ccAction.sequence(ccAction.moveBy(0.3, v3(UIRoot.instance.winSize.width, 0)), ccAction.callFunc(() => {
            this.node.x = 0;
            GameMainWindow.instance.showUI(true);
            var self = this;
            this.scheduleOnce(() => {
              if (self.completeCallback != null) {
                self.completeCallback();
              }
            }, 0.3);
            SoundManager.playBgmByName(SoundManager.SoundNames.BGM_Menu);
          }, this)));
          this.villageNode && this.villageNode.getComponentsInChildren(DamageParticle).forEach(x => {
            if (x.node.activeInHierarchy && x.enabled) x.stopParticle();
          });
          SoundManager.stopSound(SE_attack_over);
          SoundManager.stopSound(SE_raid_perfect);
          SoundManager.stopSound(SE_raid_over);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spVillage", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "villageContainer", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "attackNodeContainer", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spBet", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelBet", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "modelRaid", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "attackAnimSuperShield", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "attackAnimSuperShieldGold", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "raidAnimCoin", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "raidAnimRibbon", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "modelAttack", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/QuestDailyPage.ts", ['cc', './Constant.ts', './CCE_Component.ts', './global.ts', './ScrollViewTool.ts', './LoadingWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Label, _decorator, Sprite, ProgressBar, Button, MyCustomEvent, CCE_Component, G, ScrollViewTool, LoadingWindow, SR, UIRoot, Meta, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Label = module.Label;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      ProgressBar = module.ProgressBar;
      Button = module.Button;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "0336btYOCxPM6eQABPmg0Zs", "QuestDailyPage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let QuestDailyPage = exports('QuestDailyPage', (_dec = property(ScrollViewTool), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(Label), ccclass(_class = (_class2 = (_temp = class QuestDailyPage extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "svt", _descriptor, this);

          _initializerDefineProperty(this, "sp_btn_go", _descriptor2, this);

          _initializerDefineProperty(this, "sp_btn_get", _descriptor3, this);

          _initializerDefineProperty(this, "label_time", _descriptor4, this);

          _defineProperty(this, "questCenterWindow", void 0);

          _defineProperty(this, "data", null);

          _defineProperty(this, "remainTime", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);

          _defineProperty(this, "closed", void 0);
        }

        show() {
          LoadingWindow.ShowAfterDelay(0);
          this.get_data().then(v => {
            LoadingWindow.Hide();
            if (!this.node) return;
            this.node.active = true;
            this.update_page(v);
          }, e => {});
          var date1 = new Date();
          date1.setDate(date1.getDate() + 1);
          date1.setHours(0);
          date1.setMinutes(0);
          date1.setSeconds(0);
          date1.setMilliseconds(0);
          this.remainTime = date1.getTime() / 1000 - GameKit.TimeUtil.getCurrentTime();
          this.label_time.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.remainTime, false);
        }

        slowUpdate(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;
          this.remainTime -= dt;
          this.label_time.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.remainTime, false);
        }
        /** 获取daily-page依赖的数据 */


        get_data() {
          return new Promise((res, rej) => {
            // old_data
            if (this.data) {
              res(this.data);
              return;
            }

            {
              // real-data
              let sr = SR.SRTask.getTaskList();
              sr.SetCallBack(v => {
                res(v.list);
              });
              sr.SetErrorCallBack(() => {
                rej();
              });
              sr.Send();
            }
          });
        }
        /** 初始化任务页面 */


        update_page(data) {
          this.data = data;
          let id_list = [];

          for (let i = 0; i < data.length; i++) {
            id_list.push(i + 1);
          }

          this.svt.setItem(id_list, (index, id, node) => {
            // 获取对应的meta数据
            let meta = Meta.TaskMeta.GetById(data[index].id); // 修改样式

            let award_icon = GameKit.ControllerTable.GetNode(node, "award-icon").getComponent(Sprite);
            let award_value = GameKit.ControllerTable.GetNode(node, "award-value").getComponent(Label);
            let name = GameKit.ControllerTable.GetNode(node, "quest-name").getComponent(Label);
            let describe = GameKit.ControllerTable.GetNode(node, "quest-describe").getComponent(Label);
            let progress = GameKit.ControllerTable.GetNode(node, "quest-progress").getComponent(ProgressBar);
            let progress_string = GameKit.ControllerTable.GetNode(node, "quest-progress-string").getComponent(Label);
            let btn = GameKit.ControllerTable.GetNode(node, "quest-btn");
            let btn_string = GameKit.ControllerTable.GetNode(node, "btn-string").getComponent(Label);
            meta.Reward()[0].Icon(award_icon);
            award_value.string = BigNumber.format(meta.Reward()[0].Count());
            name.string = meta.Name();
            describe.string = meta.Description();
            progress.progress = Math.min(data[index].userCount, meta.Count()) / meta.Count();
            progress_string.string = `${BigNumber.format(Math.min(data[index].userCount, meta.Count()))} / ${BigNumber.format(meta.Count())}`;
            btn.active = !data[index].received;
            btn.getComponent(Sprite).spriteFrame = data[index].userCount < meta.Count() ? this.sp_btn_go : this.sp_btn_get;
            btn_string.string = data[index].userCount < meta.Count() ? i18n.t("quest_center_window_daily_go") : i18n.t("quest_center_window_daily_get");

            if (data[index].userCount < meta.Count()) {
              btn.getComponent(Button).clickEvents[0].handler = "event_goto";
              btn.getComponent(Button).clickEvents[0].customEventData = meta.Goto();
            } else {
              btn.getComponent(Button).clickEvents[0].handler = "evnet_get";
              btn.getComponent(Button).clickEvents[0].customEventData = meta.Id();
            }
          });
        }
        /** 点击事件：goto */


        event_goto(e, type) {
          if (this.closed) return;
          this.closed = true;
          UIRoot.instance.GetWindow("QuestCenterWindow").closeAnim(() => {
            switch (type) {
              case "slot":
                // homeView.changePage(HomeView.Pages.Slot);
                homeView.pageViewController.moveToPage(G.Pages.Slot, true);
                break;

              case "gift":
                homeView.pageViewController.moveToPage(G.Pages.Community, true);
                break;

              case "village":
                // homeView.changePage(HomeView.Pages.Village);
                homeView.pageViewController.moveToPage(G.Pages.Village, true);
                break;
            }
          });
        }
        /** 点击事件：get */


        evnet_get(e, id) {
          new Promise((res, rej) => {
            // old-data
            this.data.forEach(e => {
              if (e.id === id) {
                e.received = true;
              }
            });
            {
              // real-data
              let sr = SR.SRTask.receiveTaskReward(Number.parseInt(id));
              sr.SetCallBack(v => {
                res(v);
              });
              sr.SetErrorCallBack(() => {
                rej();
              });
              sr.Send();
            }
          }).then(() => {
            // 界面变动
            e.target.active = false;
            this.questCenterWindow.updateDailyRedDot();
            eventCenter.emit(MyCustomEvent.ReadyChangeCoin); // 获取奖励
            // UIRoot.instance.openChildWindow(GetRewardWindow, {
            //     contents: Meta.TaskMeta.GetById(id).Reward()
            // })
          }, e => {});
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sp_btn_go", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "sp_btn_get", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "label_time", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HelpWindow.ts", ['cc', './UIWindow.ts', './UIRoot.ts', './HelpManager.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, UIWindow, UIRoot, HelpManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      HelpManager = module.HelpManager;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "03f95VAa89Bdr6dxBODSm7C", "HelpWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let HelpWindow = exports('HelpWindow', (_dec = property(Label), _dec2 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class HelpWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelMsg", _descriptor, this);

          _initializerDefineProperty(this, "labelTitle", _descriptor2, this);
        }

        static Show(title, key) {
          UIRoot.instance.openChildWindow(HelpWindow, {
            title: title,
            key: key
          });
        }

        onShow(showParams) {
          this.labelMsg.string = HelpManager.GetHelp(showParams.key);
          this.labelTitle.string = showParams.title;
        }

        call_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Common/HelpWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelMsg", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelTitle", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ja.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "0438aNRYmtAv7QCrJbPjtV4", "ja", undefined);

      let ja = exports('ja', {
        APPNAME: "金貨の王",
        START: "ゲームスタート",
        Score: "得点",
        Restart: "リスタート",
        Loading: "少々お待ちください",
        Cancel: "キャンセル/取り消し",
        Confirm: "確認",
        Retry: "リトライ",
        Back: "戻り",
        Accept: "受け入れ",
        Level: "レベル",
        ScoreRank: "段位",
        Rank: "ランキング",
        ScorePoint: "ポイント",
        OK: "確認",
        YES: "はい",
        NO: "いいえ",
        Yes: "はい",
        No: "いいえ",
        COLLECT: "受け取り",
        facebookF: "フェイスブック",
        Congratulation: "おめでとうございます",
        and: "と",
        Reconnect: "Reconnect",
        PlayerDefaultName: "プレーヤー",
        PayDisable: "一時お支払い不能",
        PayEnabledAndroid: "アンドロイドのみでは払える",
        PayDisableIos: "IOSでは払えない",
        PayDisableFBIn: "the payment function is currently incompatible with your system. Please enter SlotsVille via Instant Games to complete purchase on a computer.",
        PaySuccess: "お買い上げいただき、誠にありがとうございます。",
        PayFail: "支払い失敗",
        PriceSymbol: "",
        AdNotReady: "動画はまだです",
        wxUserinfoDenyTitle: "権限の申込",
        wxUserinfoDenyDes: "次に動作をアプリに許可：端末の状態とIDの読み取り",
        wxUserinfoDenyConfirm: "オッケー",
        wxVersionNoSupport: "この機能はウィーチャット更新の必要があります",
        ShareTitle: "ねーねー　このゲーム超おもしろいやぜ！、一緒に遊ぼう！",
        ShareInviteNew: "ねーねー　このゲーム超おもしろいやぜ！、一緒に遊ぼう！",
        ShareInviteSendSpin: "{0}さんから少し体力をもらった！",
        ShareInviteSendCoins: "{0}さんから少しコインをもらった！",
        ShareInviteFinishVillage: "一面の田んぼができた！、早く来て見てください",
        ShareInviteRaid: "ゴールドを盗んだ！チョー気持ちいい！",
        ShareDialogTitle: "シェア",
        ShareInviteDialogTitle: "誘う/招待",
        ShareChooseDialogTitle: "おくる",
        ShareJigsawTitle: "I need these. Help me!",
        ErrorRetry: "サーバー接続の問題があります。リトライします？",
        ErrorLogin: "サーバー接続の問題があります。",
        ErrorNormal: "エラーが発生します。",
        ErrorMsg0: "サクセス",
        ErrorMsg1703: "支払い失敗",
        loadResError: "",
        CountYear: "年",
        CountMonth: "月",
        CountDay: "日",
        CountHour: "時",
        CountMinute: "分",
        CountSecond: "秒",
        FormatYear: "年",
        FormatMonth: "月",
        FormatDay: "日",
        FormatHour: "時",
        FormatMinute: "分",
        FormatSecond: "秒",
        PastYear: "年前",
        PastMonth: "月まえ",
        PastDay: "日まえ",
        PastHour: "時まえ",
        PastMinute: "分まえ",
        PastSecond: "秒まえ",
        PastZero: "ちょうど",
        LoginWindowPlay: "ゲームスタート",
        LoginWindowGuest: "ゲスト",
        LoginWindowNeedUpdate: "There are some updates.",
        LoginWindowUpdating: "Updating",
        ContentNameCoin: "コイン",
        ContentNameAp: "体力",
        ContentNameShield: "シールド",
        ContentNameCard: "カード",
        ContentNameChest1: "木の宝箱",
        ContentNameChest2: "銀の宝箱",
        ContentNameChest3: "金の宝箱",
        ContentNamePack: "アイテム",
        ContentNameJigsaw: "パズルの欠片",
        ContentNameUnknown: "？？？",
        ChatSend: "おくる",
        ApRecoverIn: "{1}なら、{0}点で回復",
        AutoSpining: "自動",
        ToRaidUserBet: "{0}倍に得る",
        BetRibbonText: "{0}倍に得る",
        Bet: "倍率",
        ApFull: "体力が満ちた",
        ApPlus: "{0}点体力をプラスする。",
        Shield: "シールド",
        Attack: "破壊",
        Spins: "{0}点体力をプラスする。",
        Raid: "奇襲（raid）/盗み",
        Help_sign: "1. You can get monthly\n      sign reward every\n      7 days in a month.\n2. Monthly sign will\n      refresh in next month.\n3. You can get weekly\n      sign reward every day\n      in a week.\n4. Weekly sign will\n      refresh in next week.",
        Help_jigsaw: "1. Collect 9 pieces then\n      get rewards.\n2. Pieces are collected in\n      slots and evolvement.\n3. Pieces will be cleared\n      when activity is end.\n4. Universal Jigsaw can\n      replace any piece.",
        SlotCoin6Video: "動画をご覧になると二倍コインを得る",
        DailyBonusNormalSpinBtn: "発動",
        DailyBonusGoldSpinBtn: "{0}円払い、発動",
        DailyBonusFreeSpinDes: "{0}\n後無料",
        Now10XBetter: "いま10倍収益を得る",
        DailyBonusCollect: "取る",
        DailyBonusLevel: "レベル{0}",
        DailyBonusGoldFirst: "初回なので最低限25Mコインを得る（チャンスはただ一つだ！）",
        VillageShopTitle: "市場を建てる",
        VillageShopBuy: "建造",
        VillageShopFix: "修復",
        VillageShopComplete: "完成",
        NotEnoughCoinDes: "コイン不足",
        NotEnoughApDes: "体力不足",
        NotEnoughApAdd: "{0}点体力をプラスする。",
        NotEnoughApWait: "または、{1}に待つと、{0}体力を得る",
        NotEnoughApWait2: "{1}に待つと、{0}体力を得る",
        NotEnoughOff: "{0}%\nMORE",
        menu_title: "メニュー",
        menu_0_play: "プレー",
        menu_1_village: "田畑",
        menu_2_buy: "ショップ",
        menu_3_daily: "出勤賞",
        menu_4_shop: "市場を建てる",
        menu_5_news: "ニュース/メッセージ",
        menu_6_gifts: "プレゼント",
        menu_7_card: "カード",
        menu_8_map: "地図",
        menu_9_leaderboard: "ランキング",
        menu_10_invite: "招待",
        menu_11_setting: "設定/オプション",
        setting_title: "設定/オプション",
        setting_sound: "效果音",
        setting_music: "BGM",
        setting_notifications: "お知らせ",
        setting_raid: "盗み＆破壊",
        setting_general: "通常",
        setting_language: "言語",
        setting_english: "英語",
        setting_likeus: "わたしたちをフォロー、最新のエベントを知り、プレゼントを取り",
        setting_like: "フォロー",
        setting_tutorial: "初心者チュートリアル",
        setting_support: "カスタマサービス",
        setting_privacy: "プライバシー",
        setting_terms: "アプリ　デベロッパー　チーム",
        setting_uuid: "",
        setting_language_title: "言語",
        setting_language_en: "English",
        setting_language_zh: "中文",
        setting_language_es: "Español",
        setting_language_de: "Deutsch",
        invite_title: "もっともっと体力が欲しい？",
        invite_addnumber_type0: "",
        invite_lineA: "招待された友が二つ目の村をアンロックする度に、君が{0}点体力を得る",
        invite_lineApp: "",
        invite_invite: "招待",
        invite_note: "友がログインすると、体力を得る",
        BindFacebookTitle: "",
        BindFacebookBtn: "",
        BindFacebookTip: "",
        BindFacebookFreespin: "",
        GuestConfirmTitle: "",
        GuestConfirmDes: "友とプレーしたかったら、ログインしましょう！",
        GuestConfirmGuest: "ウインドー ゲスト プレー",
        LeaderBoardWindowTabFriends: "友達",
        LeaderBoardWindowTabCountry: "全国",
        LeaderBoardWindowTabGlobal: "全世界",
        InteractionBet: "{0}倍収益を得る",
        InteractionAttackName: "{0}さんの田畑",
        InteractionAttackRevenge: "かたき",
        InteractionAttackFriends: "友達",
        InteractionAttackResultBlock: "{0}が君の攻撃を防ぎ守って、{1}コインを得る?",
        InteractionAttackResultSuccess: "{1}が{0}の田畑を破壊した、{1}コインをえる。",
        InteractionRaidCoinMaster: "国王",
        InteractionRaidName: "{0}の宝物",
        InteractionRaidStole: "{}を盗んだ。",
        InteractionRaidResultLine: "{1}から{0}個コインを盗んだ。",
        InteractionRaidPrefect: "パーフェクト盗み",
        InteractionRaidBrag: "見せびらかす",
        InteractionRaidEmpty: "盗み失敗",
        gifts_title: "プレゼント",
        gifts_tab0: "無料な体力",
        gifts_tab1: "無料なコイン",
        gifts_tab2: "カード",
        gifts_invite: "招待",
        gifts_send: "贈る",
        gifts_collect: "受け取り",
        gifts_note: "ほかの人にプレゼントを贈ると、賞を得る。",
        gifts_collect_all: "全部で贈り/取り",
        gifts_collect_all2: "全部でとり",
        gifts_default_name: "友を招待",
        gifts_default_explain: "無料な体力を得る",
        gifts_collect_spins: "今日{0}/{1}点を得た。",
        gifts_collect_coins: "今日{0}/{1}点を得た。",
        gifts_explain_spin_send: "無料な体力を贈る",
        gifts_explain_spin_collect: "君に{0}点体力を贈た。",
        gifts_explain_coin_send: "無料なコインを贈る。",
        gifts_explain_coin_collect: "君に{0}個コインを贈た。",
        gifts_explain_card_send: "友にカードを贈る。",
        gifts_explain_card_collect: "君に一枚カードを贈た。",
        gifts_explain_card_cantcollect: "このカードは地図をアンロックの必要があります。",
        ShopTitle: "ショップ",
        ShopSpins: "体力",
        ShopCoins: "コイン",
        ShopSpinNum: "{0}",
        ShopChests: "宝箱",
        ShopAddPercent: "{0}\nパーセントを上げる。",
        ShopSpinPrice: "￥{0}",
        ShopCoinPrice: "￥{0}",
        CoinStore: "コイン　ショップ",
        CoinShopLevel: "{0}レベル",
        OffText: "{0}%\n++",
        SaleMark: "セール",
        ShopChestDisable: "{0}の村で木箱はアンロックするので",
        ShopPopular: "よく売れ",
        ShopBestValue: "割り安の商品",
        village_news_title: "ニュース/メッセージ",
        village_news_log_hammer: "君の田畑が{0}さんに破壊されました。",
        village_news_log_shield: "{0}さんが君の田畑を破壊するつもりです。",
        village_news_log_pig: "君が{0}さんに{1}個コインを盗まれました。",
        village_news_log_invite: "{0}が田畑の守りに参加しました。",
        village_news_fox: "",
        village_news_tiger: "",
        village_news_rhino: "",
        map_title: "",
        map_comming_soon: "間もなく開放する",
        revenge_title_revenge: "復讐",
        revenge_title_attack: "友を攻撃する",
        revenge_random: "ランダム　プレーヤー",
        revenge_revenge: "復讐",
        revenge_attack: "破壊",
        watch_get: "動画をご覧になると得る",
        watch_spin: "{0}点体力をプラスする。",
        watch_coin: "{0}個コインをプラスする。",
        watch_watch: "動画をご覧ください。",
        VillageCompleteTitle: "田畑を建て済み",
        VillageCompleteNext: "次の",
        NewUserInvitedTitle: "友達を招待したの特別賞与",
        NewUserInvitedDes: "新しい村をアンロックした！{1}点無料体力を得た",
        NewUserInvitedDesApp: "{0}さんがゲームにログインした！{1}点無料体力を得た",
        TutorialDialogStar: "建てる度に、一つ星を得た。20つ星を集めたら、次の領地をアンロックする。",
        TutorialDialogGoSpin: "コインが不足なので、コインの得るために画面の下端に向かってスワイプしましょう。",
        TutorialDialogDoSpin: "アーケードスティックを回転すると、コインを得る、ほかの人の領地を攻撃する、或は他人の領地を盗む。",
        TutorialDialogSlotAttack: "他人の領地を攻撃するのは、コインを手に入れる方法の一つです。",
        TutorialDialogSlotShield: "シールドは君の領地を守るものです。",
        TutorialDialogSlotRaid: "他人の領地からコインを盗む！",
        TutorialDialogSlotRaidMaster: "この人はターゲットであり、行動しましょう。",
        TutorialStartTitle: "君のはじめての領地",
        TutorialStartDes: "ようこそおいでください。ボタンをクリックすると、ゲームが始まります。",
        TutorialTargetName: "目標",
        TutorialFinishTitle: "完成",
        TutorialFinishDes0: "君に賞与は",
        TutorialFinishDes1: "60点無料な体力",
        TutorialFinishDes1bind: "20点無料な体力",
        TutorialFinishDes2: "100万個無料なコイン",
        TutorialFinishDes3: "友とプレー",
        TutorialFinishDes4: "アーカイブを保存",
        TutorialTargetName1: "Leyla",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetName2: "Mary",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetName3: "Kevin",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        AutoSpinTipWindowTitle: "自動回転",
        AutoSpinTipWindowDes: "ボタンを押すと、始まる",
        AutoSpinTipWindowButton: "開始",
        ActivitySpecialOfferTitle: "特別福袋",
        ActivityTimeleft: "残り時間",
        ActivitySpecialOfferCoin: "{0}個金币",
        ActivitySpecialOfferSpin: "{0}点体力",
        ActivityShopDes: "特売キャンペーン 残り時間",
        ActivityAttackMasterDes: "{0}回攻撃命中なので、{1}個コインを得た。",
        ActivityAttackMasterDesMore: "the bigger the</color> <outline  color=#9E5A05 width=2><color=#F7E150>REWARDS!</color></outline>",
        ActivityAttackMasterFinal1: "",
        ActivityAttackMasterFinal2: "",
        ActivityAttackMasterButtonTip: "ベットアップなら、もっと多いコインが得られる",
        ActivityAttackMasterButton: "受け取り",
        ActivityAttackMasterTimeleft: "{0}残り時間",
        ActivityRaidMasterDes: "{0}回盗み成功なので、{1}個コインを得た。",
        ActivityBuildKingDes: "任務完了！賞をもらった。",
        GetRewardWindowDes: "{0}賞をもらった。",
        CardAllSetWindowTitle: "CARD\nCOLLECTION",
        CardAllSetWindowCompleted: "Completed",
        CardAllSetWindowLock: "Unlocks at\nKingdom {0}",
        CardSingleSetWindowTip: "* Tap on a duplicate card to send it to a friend",
        CardSingleSetWindowCompleted: "- SET COMPELETED -",
        CardAsk: "Ask",
        CardSend: "Send",
        CardGoldenCannot: "This card is golden",
        CardAskCannot: "It cannot be asked from friends",
        CardSendCannot: "It cannot be sent to friends",
        CardSendLimit: "You reached the daily limit of cards you can send",
        CardCollectTitle: "AWESOME!",
        CardCollectDes: "Card {0}-{1}\nwas added to your album",
        CardCollectButton: "Check it out",
        CardSelectFriendWindowTitle: "SEND CARDS",
        CardSelectFriendWindowInfo: "Select 1 friend!",
        CardSelectFriendWindowBtn: "Select Card",
        CardSelectCardWindowTitle: "SEND CARDS",
        CardSelectCardWindowInfo: "Select up to 5 cards!",
        CardSelectCardWindowSelected: "Your selected cards:",
        FriendsModelPlaceHolder: "Search friend name",
        FriendsModelNoResult: "No Friends.",
        CardInfoWindowTitle: "Cards Info",
        CardInfoWindowPage0_0: "Collect cards through chests",
        CardInfoWindowPage0_1: "You can cards through chests",
        CardInfoWindowPage0_2: "Chests can be cards through chests cards through chests",
        CardInfoWindowPage1_0: "Owning 2 or more of the same card allows you to send them as a gift to your friends.",
        CardInfoWindowPage1_1: "Tap on the card in order to gift it",
        CardInfoWindowPage1_2: "You can also ask friends for missing cards.",
        CardInfoWindowPage2_0: "Stars indicate cards rarity",
        CardInfoWindowPage2_1: "= 1XP",
        CardInfoWindowPage2_2: "Each rarity star on a new collected card gives you 1XP",
        CardInfoWindowPage2_3: "Complete card sets and get amazing rewards!",
        CardInfoWindowCommon: "Common",
        CardInfoWindowRare: "Rare",
        CardChestInfoWindowTitle_1: "Wooden Chest",
        CardChestInfoWindowTitle_2: "Silver Chest",
        CardChestInfoWindowTitle_3: "Golden Chest",
        CardChestInfoWindowHigh: "High chance for:",
        ExtraRewardDes: "このコインと体力は金貨の王からもらったプレゼントだ。",
        quest_center_window_title: "クエスト　センター",
        quest_center_window_refresh_dialog: "新しい一日なので、クエストが更新した。再び見に行きましょう",
        quest_center_window_daily: "",
        quest_center_window_invite: "",
        quest_center_window_check: "",
        quest_center_window_month_box_7: "",
        quest_center_window_month_box_14: "",
        quest_center_window_month_box_21: "",
        quest_center_window_month_box_28: "",
        quest_center_window_day_1: "",
        quest_center_window_day_2: "",
        quest_center_window_day_3: "",
        quest_center_window_day_4: "",
        quest_center_window_day_5: "",
        quest_center_window_day_6: "",
        quest_center_window_day_7: "",
        quest_center_window_check_do: "出勤",
        quest_center_window_check_done: "出勤した",
        quest_center_window_main_quest_name: "{0},メイン　ミッション",
        quest_center_window_main_quest_goal_reward: "{0}\nReward, {1}",
        quest_center_window_daily_get: "受け取り",
        quest_center_window_daily_go: "開始",
        quest_center_window_refreshin: "更新",
        ActivityCenterTitle: "イベント　センター",
        ActivityCenterTime: "{0},イベント残り時間",
        ActivityCenterTimeEnd: "イベントはおしまった。",
        jigsaw_window_title: "ジグソーパズル",
        jigsaw_window_use: "使用",
        jigsaw_window_used: "使用済み",
        jigsaw_window_send: "贈与",
        jigsaw_window_complete: "パズル　作成済み。",
        jigsaw_window_universal_tip: "Choose one piece to replace",
        jigsaw_friends_window_title: "友達",
        jigsaw_friends_window_send: "贈与",
        jigsaw_friends_window_no_friends: "一人友人でもいない",
        jigsaw_friends_window_search_pre: "友の名前を検索する",
        jigsaw_news_window_title: "ニュース",
        jigsaw_news_window_news_send: "",
        jigsaw_news_window_news_collect: "",
        jigsaw_news_window_no_news: "",
        GameMainWindowQuest: "クエスト",
        GameMainWindowActivity: "イベント",
        NotificationTitleApFull: "体力が満ちた",
        NotificationDesApFull: "体力が充分なので、コインを稼ぎましょう。",
        NotificationTitleDailyBonus: "出勤賞ができた。",
        NotificationDesDailyBonus: "クジ引きをしましょう。",
        NotificationTitleAttack: "復讐に行きましょう。",
        NotificationDesAttack: "私たちの領地が誰かに破壊されました。",
        NotificationTitleActivity: "イベントがすぐ終わります。",
        NotificationDesActivity: "{0}一時間後　おしまい",
        NotificationTitleBack: "",
        NotificationDesBack: "豪華な特典アイテムプレゼントキャンペーン開催中！！",
        NotificationTitleBack2: "一緒に遊ぼう！",
        NotificationDesBack2: "早く戻って見てください！！プレゼントをいっぱい用意しているんだよ！！",
        mini_game_fail: "Game load fail, please try again.",
        mini_game_end: "Game End.",
        mini_game_rank_window_title: "RANKING",
        mini_game_rank_window_no_ranks: "No Ranks.",
        mini_game_coinhit_info: "A big trip to win\ncoins, spins and chests!",
        mini_game_coinhit_time: "Ends in {0}",
        mini_game_coinhit_go: "GO!",
        mini_game_coinhit_info_title: "INFO",
        mini_game_coinhit_manual_next_round: "Game stuck? Yes to go to the next round.",
        mini_game_coinhit_btn_next_round: "next round",
        mini_game_coinhit_manual_end: "Yes to get reward now! Get coin {0}, Get spin {1}.",
        mini_game_coinhit_btn_end: "get reward",
        mini_game_coinhit_rank_info: " Block Hit Count: {0}",
        AppUpdateTitle: "New Update",
        AppUpdateDes: "There is a new version available! Update now!",
        AppUpdateBtn: "UPDATE",
        AppUpdateNo: "No,thanks",
        AppCommentTitle: "Love Coin Kings?",
        AppCommentDes: "Please rate us 5 stars to make more updates~",
        AppCommentBtn: "RATE NOW",
        AppCommentNo: "No,thanks",
        AppHotUpdateFail: "Load resource failed. Try again?",
        FirstPurchaseButton: "GO!",
        FirstPurchaseDes1: "Make any purchase to",
        FirstPurchaseDes2: "GET REWARDS!",
        ServantUpgrade: "Upgrade",
        ServantSelect: "Select",
        ServantEffectDes1: "Increases raids reward",
        ServantEffectNum1: "● Increases reward by: {0}%",
        ServantEffectDes2: "Increases attacks reward",
        ServantEffectNum2: "● Increases reward by: {0}%",
        ServantEffectDes3: "Protects from attacks",
        ServantEffectNum3: "● Protection chance: {0}%",
        ServantEffectDes4: "Protects from raids",
        ServantEffectNum4: "● Protection chance: {0}%",
        ServantNextLevel: "● Next level: {0}% +",
        ServantName1: "Pigy",
        ServantName2: "Billy",
        ServantName3: "Doge",
        ServantName4: "Ruby",
        ServantOpenDes: "<color=#ffffff>Hire servants to get more<color=#ffe615>Coins</color> and <color=#0ce4fe>Spins</color></color>",
        ServantOpenDesS: "<color=#308ae6>Hire servants to get more<color=#e67b07>Coins</color> and <color=#006fd7>Spins</color></color>"
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/StarBlink.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Animation, _decorator, Component, Vec3;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Animation = module.Animation;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "04496VZcF9Kq62LkuwCnKLT", "StarBlink", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let StarBlink = exports('StarBlink', (_dec = ccclass('StarBlink'), _dec2 = property(Animation), _dec(_class = (_class2 = (_temp = class StarBlink extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "star", _descriptor, this);
        }

        onLoad() {
          this.star.node.active = false;

          const blink = () => {
            if (!this.node) return;

            if (this.node && !this.node.active) {
              const interval = Math.random() * 5000 + 2000;
              setTimeout(() => {
                blink();
              }, interval);
              return;
            }

            this.star.node.active = true;
            const scale = Math.random() * 0.7 + 0.3;
            this.star.node.setScale(new Vec3(scale, scale, scale));
            const aniState = this.star.getState('star');
            aniState && (aniState.speed = Math.random() + 0.5);
            this.star.play("star");
            this.star.on(Animation.EventType.FINISHED, () => {
              this.star.node.active = false;
            });
            const interval = Math.random() * 5000 + 2000;
            setTimeout(() => {
              blink();
            }, interval);
          };

          const randonTime = Math.random() * 5000;
          setTimeout(() => {
            blink();
          }, randonTime);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "star", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ServantRankMeta.ts", ['cc', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "04ec9l7OQxGZa9o9kCkTq7H", "ServantRankMeta", undefined);

      class ServantRankMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new ServantRankMeta();
          meta.UpdateData(data);
          return meta;
        }

        static GetRankAllStar(id, rank) {
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.ServantRank);
          let star = 0;

          for (let metaid in metas) {
            let meta = metas[metaid];
            star += meta.Star(id);
            if (rank == meta.Rank()) break;
          }

          return star;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        Rank() {
          return this.Id();
        } //升级需要的经验


        Exp(id) {
          return this._data["exp" + id];
        } //获得的星数


        Star(id) {
          return this._data["star" + id];
        } //宠物的效果值


        Effect(id) {
          return this._data["effect" + id];
        }

      }

      exports('ServantRankMeta', ServantRankMeta);

      _defineProperty(ServantRankMeta, "Effect", {
        doRaid: 1,
        doAttack: 2,
        beAttack: 3,
        beRaided: 4
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitBlock.ts", ['cc', './CCE_Component.ts', './SoundManager.ts', './MinigameCoinhitBall.ts', './MinigameCoinhitGameplay.ts', './MinigameCoinhitMainWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, Enum, v2, Sprite, Label, _decorator, instantiate, CCE_Component, SoundManager, MinigameCoinhitBall, MinigameCoinhitGameplay, MinigameCoinhitMainWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
      v2 = module.v2;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      MinigameCoinhitBall = module.default;
    }, function (module) {
      MinigameCoinhitGameplay = module.default;
    }, function (module) {
      MinigameCoinhitMainWindow = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "06b8d1keQ5AU6cVQNf9kKHk", "MinigameCoinhitBlock", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        type: Enum({
          // reward
          small_coin: 0,
          // coin类型
          big_coin: -1,
          small_spin: -1,
          // spin类型
          big_spin: -1,
          small_box: -1,
          // 宝箱
          middle_box: -1,
          big_box: -1,
          // ball+1
          ball_plus_one: -1 // 球个数+1

        }),
        NEW_BALL_LINEV: v2(500, 800),
        // 球+1时新球的速度
        SHAKE_Y: 6,
        // block位置超过600后shake动画
        END_Y: 7 // block位置超过720

      };
      let MinigameCoinhitBlock = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property({
        type: C.type
      }), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameCoinhitBlock extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "sp", _descriptor, this);

          _initializerDefineProperty(this, "count_label", _descriptor2, this);

          _initializerDefineProperty(this, "type", _descriptor3, this);

          _defineProperty(this, "count", 0);

          _defineProperty(this, "line", 0);
        }
        /**
         *
         * @param {*} contact
         * @param {cc.Collider} selfCollider
         * @param {cc.Collider} otherCollider
         */


        onBeginContact(contact, selfCollider, otherCollider) {
          if (otherCollider.node.name === "ball") {
            this.count_minus_one();
            MinigameCoinhitMainWindow.ins.data.add_score_base(1);
            MinigameCoinhitMainWindow.ins.update_score(MinigameCoinhitMainWindow.ins.data.get_score_base()); // 球+1

            if (this.type === C.type.ball_plus_one) {
              let n;

              if (MinigameCoinhitGameplay.ins.ball_pool.size() > 0) {
                n = MinigameCoinhitGameplay.ins.ball_pool.get();
              } else {
                n = instantiate(otherCollider.node);
              }

              n.parent = otherCollider.node.parent;
              n.position = otherCollider.node.position;
              n.getComponent(MinigameCoinhitBall).set_linev(C.NEW_BALL_LINEV);
              MinigameCoinhitBall.target_count += 1;
            }

            if (!MinigameCoinhitBlock.soundPlay) {
              MinigameCoinhitBlock.soundPlay = true;
              SoundManager.playSound("mini_coinhit_hit");
              setTimeout(() => {
                MinigameCoinhitBlock.soundPlay = false;
              }, 50);
            }
          }
        }
        /** @type {cc.Sprite} */

        /**
         * 设置被撞次数
         * - 宝箱和+1type不显示被撞次数
         * @param {number} count
         */


        set_count(count) {
          this.count = count;
          this.count_label.string = this.count;
        }
        /**
         * 设置旋转角度
         * - 宝箱和+1type不旋转
         * @param {number} rotation
         */


        set_rotation(rotation) {
          if ([C.type.ball_plus_one, C.type.small_box, C.type.middle_box, C.type.big_box].includes(this.type)) {
            return;
          }

          this.node.angle = rotation;
          this.count_label.node.angle = -rotation;
        }
        /** 抖动提示动画 */


        anima_shake() {
          this.sp.node.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 1.2), ccAction.scaleTo(0.2, 1)).repeat(3));
        }
        /** 检查位置，警示还是结束 */


        check_position() {
          if (this.type === C.type.ball_plus_one || this.type === C.type.small_box || this.type === C.type.middle_box || this.type === C.type.big_box) {
            if (this.line >= C.END_Y) {
              this.node.active = false;
              this.node.destroy();
            }
          } else {
            if (this.line >= C.END_Y) {
              MinigameCoinhitGameplay.ins.game_end();
            } else if (this.line >= C.SHAKE_Y) {
              this.anima_shake();
            } else ;
          }
        }
        /** 被撞次数-1 */


        count_minus_one() {
          if (this.count <= 0) {
            return;
          }

          this.count -= 1;
          this.count_label.string = this.count;

          if (this.sp.node.getNumberOfRunningActions() === 0) {
            this.sp.node.runAction(ccAction.sequence(ccAction.scaleTo(0.05, 0.9), ccAction.scaleTo(0.05, 1)));
          } // 被撞掉后奖励


          if (this.count <= 0) {
            if (this.type === C.type.ball_plus_one) {
              MinigameCoinhitGameplay.ins.add_ball_count(1);
            } else {
              let reward = MinigameCoinhitMainWindow.ins.data.get_reward(this.type);
              MinigameCoinhitMainWindow.ins.data.add_score_coin(reward[0], this.node);
              MinigameCoinhitMainWindow.ins.data.add_score_spin(reward[1], this.node);
            } // 删除block
            // @todo 增加爆裂动画


            this.node.active = false;
            this.node.destroy();
            if (this.type === C.type.ball_plus_one) ;else if (this.type === C.type.small_box || this.type === C.type.middle_box || this.type === C.type.big_box) {
              SoundManager.playSound("mini_coinhit_chest_destroy");
            } else {
              SoundManager.playSound("mini_coinhit_block_destroy");
            }
          }
        }

      }, _defineProperty(_class3, "soundPlay", void 0), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sp", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "count_label", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "type", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return C.type.small_coin;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopCardPriceMeta.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "07c12QZiydFS6QCq74zYtO6", "ShopCardPriceMeta", undefined);

      class ShopCardPriceMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new ShopCardPriceMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        MapId() {
          return this._data.id;
        }

        Price(id) {
          return this._data["price" + id.toString()];
        }

      }

      exports('ShopCardPriceMeta', ShopCardPriceMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserStatus.ts", ['cc', './Content.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Content, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "08868reeeRDyZkTDoMv4D9E", "UserStatus", undefined);

      class UserStatus {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          _defineProperty(this, "thisVip", void 0);

          this.data = {
            userId: userId,
            firstPurchase: false,
            purchaseMoney: 0,
            newPlayerPackTime: 0,
            //首次礼包出现时间
            newPlayerPackdt: 0,
            //首次礼包上次记录时间
            vipTime: 0,
            //vip到期时间
            vipToken: "",
            //vip 校验token
            trial: false,
            vipDailyDay: 0,
            //vip 每日奖励上一次day
            vipExtraReward: [],
            //vip未获得额外奖励
            vipExtraTime: 0,
            //vip未获得额外奖励剩余时间
            vipExtraTimeLast: 0,
            //vip未获得额外奖励上一次time
            levelBonusOpen: false,
            //是否购买了 等级奖励
            levelBonusGet: [] //等级奖励已经领取的id

          };
        } //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          if (this.thisVip == undefined) {
            if (this.IsVipNow()) {
              this.thisVip = true;
            }
          }

          this.data.vipExtraReward = Content.FromContents(this.data.vipExtraReward);
          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
        }

        UserId() {
          return this.data.userId;
        }

        IsFirstPurchased() {
          return this.data.firstPurchase;
        }

        SetFirstPurchased() {
          this.data.firstPurchase = true;
        }

        GetPurchaseMoney() {
          return this.data.purchaseMoney;
        }

        GetNewPlayerLeftTime() {
          this.data.newPlayerPackTime -= GameKit.TimeUtil.getCurrentTime() - this.data.newPlayerPackdt;
          this.data.newPlayerPackdt = GameKit.TimeUtil.getCurrentTime();
          this.data.newPlayerPackTime = Math.max(0, this.data.newPlayerPackTime);
          return this.data.newPlayerPackTime;
        }

        IsVip() {
          return !!this.thisVip;
        }

        IsVipNow() {
          return this.data.vipTime > GameKit.TimeUtil.getCurrentTime();
        }

        VipExtraReward() {
          return Content.Merge(this.data.vipExtraReward);
        }

        VipExtraTime() {
          return this.data.vipExtraTime;
        }

        VipExtraTimeLast() {
          return this.data.vipExtraTimeLast;
        }

        UpdateExtraTime() {
          this.data.vipExtraTime -= GameKit.TimeUtil.getCurrentTime() - this.data.vipExtraTimeLast;

          if (this.data.vipExtraTime <= 0) {
            this.data.vipExtraTime = 0;
            this.data.vipExtraReward = [];
          }

          this.data.vipExtraTimeLast = GameKit.TimeUtil.getCurrentTime();
        }

        LevelBonusOpen() {
          return this.data.levelBonusOpen;
        }

        LevelBonusGet() {
          return this.data.levelBonusGet || [];
        }

      }

      exports('UserStatus', UserStatus);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotResultHandler.ts", ['cc', './Constant.ts', './ShieldAnim.ts', './global.ts', './EnterCloseAnim.ts', './SoundManager.ts', './CommonAssets.ts', './StringUtil.ts', './TutorialManager.ts', './CoinAnim.ts', './ShieldBreakAnim.ts', './GameMainWindow.ts', './SR.ts', './CountDownWindow.ts', './UIRoot.ts', './StaticGame.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Component, instantiate, _decorator, dragonBones, Label, Widget, tween, SlotTypes, TutorilaEvent, LoadEvent, MyCustomEvent, ShieldAnim, G, EnterCloseAnim, SoundManager, CommonAssets, StringUtil, TutorialManager, CoinAnim, ShieldBreakAnim, GameMainWindow, SR, CountDownWindow, UIRoot, Game, ADWrap, GameKit, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Component = module.Component;
      instantiate = module.instantiate;
      _decorator = module._decorator;
      dragonBones = module.dragonBones;
      Label = module.Label;
      Widget = module.Widget;
      tween = module.tween;
    }, function (module) {
      SlotTypes = module.SlotTypes;
      TutorilaEvent = module.TutorilaEvent;
      LoadEvent = module.LoadEvent;
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      ShieldAnim = module.default;
    }, function (module) {
      G = module.G;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      StringUtil = module.StringUtil;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      CoinAnim = module.default;
    }, function (module) {
      ShieldBreakAnim = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      CountDownWindow = module.CountDownWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "08b3fT+gtVKc7dP2vnf8366", "SlotResultHandler", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotResultHandler = exports('default', (_dec = ccclass("SlotResultHandler"), _dec(_class = class SlotResultHandler extends Component {
        static distributeSlotResult(spinResult) {
          const slotNode = homeView.slotNode;
          const type = spinResult.type;
          const value = spinResult.number;

          switch (type) {
            case SlotTypes.Coin1:
            case SlotTypes.Coin2:
            case SlotTypes.Coin3:
            case SlotTypes.Coin4:
            case SlotTypes.Coin5:
            case SlotTypes.Coin6:
              this.handleCoins(type, value);
              break;

            case SlotTypes.Shield:
              this.handleShield();
              break;

            case SlotTypes.Attack:
              this.handleAttack(spinResult);
              break;

            case SlotTypes.Raid:
              this.handleRaid(spinResult);
              break;

            case SlotTypes.Spins:
              this.handleSpins(value);
              break;

            case SlotTypes.Symbol:
              this.handleSymbol(value);
              break;

            case SlotTypes.None:
              this.handleNone();
              break;

            default:
              console.warn("unknown type", type, value);
          }

          slotNode.isRewardTextShowing = true;
          slotNode.rewardText.getComponent(EnterCloseAnim).enterAnim();

          if (!TutorialManager.IsFinished()) {
            TutorialManager.CallTrigger("slot_result");
          }
        }

        static async handleShield() {
          const slotNode = homeView.slotNode;
          slotNode.rewardText.string = i18n.t("Shield");
          let time = 0.5;
          let shield = slotNode.oldShieldNum;
          var td = Math.max(0.1, 0.4 - Math.max(slotNode.betNum - 3, 0) * 0.1);
          const count = Math.min(15, slotNode.betNum);

          for (let i = 0; i < count; i++) {
            let sh = GameMainWindow.instance.userinfo.shields[0].parent.parent;
            let x = sh.position.x + Math.min(1, shield + i - 1) * 38;
            let y = sh.position.y - 52;
            let shieldAnimNode = instantiate(slotNode.shieldAnims[0].node);
            shieldAnimNode.parent = GameMainWindow.instance.userinfo.shields[0].parent.parent.parent;
            shieldAnimNode.setWorldPosition(slotNode.shieldAnims[0].node.getWorldPosition());
            shieldAnimNode.active = true;
            let shieldAnim = shieldAnimNode.getComponent(ShieldAnim);

            if (i != count - 1) {
              shieldAnim.play(x, y, time, () => {
                setTimeout(() => {
                  shieldAnimNode.destroy();
                }, 100);
              });
            } else {
              shieldAnim.play(x, y, time, function () {
                if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                  eventCenter.emit(TutorilaEvent.SpinFinished);
                }

                slotNode.idle();
                setTimeout(() => {
                  shieldAnimNode.destroy();
                }, 100);
              });
            }

            if (slotNode.oldShieldNum + i >= G.GameConstance.shieldMax) {
              let shieldBreakAnimsNode = instantiate(slotNode.shieldBreakAnims[0].node);
              shieldBreakAnimsNode.parent = GameMainWindow.instance.userinfo.shields[0].parent.parent;
              shieldBreakAnimsNode.setWorldPosition(slotNode.shieldBreakAnims[0].node.getWorldPosition());
              let shieldBreakAnims = shieldBreakAnimsNode.getComponent(ShieldBreakAnim);
              shieldBreakAnims.play(x, y, time + 0.95);
              setTimeout(() => {
                shieldBreakAnims.destroy();
              }, (time + 3) * 1000);
            } else {
              slotNode.scheduleOnce(() => {
                SoundManager.playSound("shiled_added");
              }, time + 0.8);
            }

            time += td;
          }

          if (GameMainWindow.instance != null && slotNode.oldShieldNum < Game.SUser.RawShield()) {
            GameMainWindow.instance.userinfo.changeShield(slotNode.oldShieldNum, Math.min(G.GameConstance.shieldMax, Game.SUser.RawShield()), td);
          }

          SoundManager.playSound("slot_item_win");

          if (slotNode.oldShieldNum + slotNode.betNum > G.GameConstance.shieldMax) {
            let spinanimNum = slotNode.oldShieldNum + slotNode.betNum - G.GameConstance.shieldMax;
            slotNode.scheduleOnce(async () => {
              await homeView.showSpinAddNumAnim(spinanimNum);
              homeView.pageViewController.getEnergyByShieldAnimation(spinanimNum);
            }, time + 0.6);
          } // if (!TutorialManager.IsFinished()) {
          // 	TutorialManager.SetStepOverCallback(() => {
          // 		_f_execute();
          // 	});
          // } else {
          // 	_f_execute();
          // }

        }

        static handleAttack(spinResult) {
          let progress = 0;
          let _label = null;

          let onProgress = _progress => {
            progress = Math.max(progress, _progress);

            if (_label) {
              _label.string = `${Math.floor(progress * 100)}%`;
            }
          };

          eventCenter.on(LoadEvent.VillageProgressUpdate, onProgress);
          const slotNode = homeView.slotNode;

          let _f_execute = () => {
            let attackIntervalID = null;

            if (attackIntervalID) {
              clearInterval(attackIntervalID);
              attackIntervalID = null;
            }

            slotNode.rewardText.string = i18n.t("Attack");
            GameMainWindow.instance.hideUI(true);
            slotNode.scheduleOnce(() => {
              // eventCenter.once(LoadEvent.VillageLoaded, () => {
              // 	slotNode.scheduleOnce(() => {
              // 		homeView.interactionNode.instantiateAttack();
              // 		if (homeView.interactionNode.containerInteraction.bomb) {
              // 			homeView.interactionNode.containerInteraction.bomb.reachoutHand();
              // 		}
              // 		eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "interaciton");
              // 		homeView.node.active = false;
              // 		GameMainWindow.instance.node.active = false;
              // 		homeView.interactionNode.showAttack(() => {
              // 			slotNode.idle();
              // 			slotNode.activityRoot.updateActivity();
              // 		});
              // 	}, 0);
              // })
              // homeView.interactionNode.loadVillage(spinResult.number, spinResult.userInfo, spinResult.village);
              const newDBAttack = instantiate(CommonAssets.instance.attackDragonBones);
              const dbAttack = newDBAttack.getComponentInChildren(dragonBones.ArmatureDisplay);
              UIRoot.instance.node.addChild(newDBAttack); // homeView.interactionNode.loadVillage(spinResult.number, spinResult.userInfo, spinResult.village);

              let loopFrame = 0;
              dbAttack.on(dragonBones.EventObject.FRAME_EVENT, event => {
                if (event.name === 'start_smoke') {
                  const smoke = newDBAttack.getChildByName('particleSmoke');
                  const fire = newDBAttack.getChildByName('particleFire');
                  const fireTransform = dbAttack.armature().getBone("fire").global;
                  const smokeTransform = dbAttack.armature().getBone("smoke").global;
                  smoke.setPosition(smokeTransform.x, smokeTransform.y, 0);
                  fire.setPosition(fireTransform.x, fireTransform.y, 0);
                  smoke.active = true;
                  fire.active = true;
                  attackIntervalID = setInterval(() => {
                    smoke.setPosition(smokeTransform.x, smokeTransform.y, 0);
                    fire.setPosition(fireTransform.x, fireTransform.y, 0);
                  }, 0.01);
                }

                if (event.name === "run_start") {
                  loopFrame = SlotResultHandler.getFrameEventFrame(dbAttack.dragonAsset, dbAttack.animationName, "run_start") || 0; // runTime = +event.time || 0;

                  homeView.node.active = false;
                  GameMainWindow.instance.node.active = false;
                  homeView.interactionNode.loadVillage(spinResult.number, spinResult.userInfo, spinResult.village);

                  if (!slotNode.villageAttackedLoaded) {
                    _label = newDBAttack.getChildByName("labelVillageProgress").getComponent(Label);
                    _label.getComponent(Widget).target = UIRoot.instance.node;
                    _label.node.active = true;
                    _label.string = `${Math.floor(progress * 100)}%`;
                  }
                }
              }, slotNode);
              dbAttack.on(dragonBones.EventObject.COMPLETE, () => {
                if (dbAttack.animationName === "boom_ani") {
                  // 循环动画播放完成，可能多次调用
                  if (slotNode.villageAttackedLoaded) {
                    dbAttack.playAnimation("boom_ani_go", 1);
                    dbAttack.scheduleOnce(() => {
                      const smoke = newDBAttack.getChildByName('particleSmoke');
                      tween(smoke).to(0.5, {
                        opacity: 0
                      }).start();
                    }, 0);
                    homeView.interactionNode.instantiateAttack();

                    if (homeView.interactionNode.containerInteraction.bomb) {
                      homeView.interactionNode.containerInteraction.bomb.reachoutHand();
                    }

                    eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "interaciton");
                  } else {
                    console.log("loopFrame", loopFrame + 1);
                    dbAttack.armature().animation.gotoAndPlayByFrame("boom_ani", loopFrame + 1, 1);
                  }
                } else if (dbAttack.animationName === "boom_ani_go") {
                  // go动画播放完成
                  slotNode.villageAttackedLoaded = false;
                  dbAttack.timeScale = 0;
                  clearInterval(attackIntervalID);
                  attackIntervalID = null;
                  newDBAttack.destroy();
                  eventCenter.off(LoadEvent.VillageProgressUpdate, onProgress);
                  homeView.interactionNode.showAttack(() => {
                    slotNode.idle();
                    slotNode.activityRoot.updateActivity();
                  });
                }
              }, slotNode);
              newDBAttack.opacity = 255;
              dbAttack.playAnimation("boom_ani", 1);
            }, 0);
            SoundManager.playSound("slot_item_win");
          };

          if (!TutorialManager.IsFinished() && TutorialManager.GetCurrentId() <= 1000014) {
            TutorialManager.SetStepOverCallback(() => {
              _f_execute();
            });
          } else {
            _f_execute();
          }
        }

        static handleRaid(spinResult) {
          const slotNode = homeView.slotNode;

          var _f_execute = () => {
            slotNode.rewardText.string = i18n.t("Raid");
            GameMainWindow.instance.hideUI(true);
            slotNode.scheduleOnce(() => {
              slotNode.raidAnim.play(() => {
                homeView.interactionNode.loadRaid(spinResult.number, spinResult.userInfo, spinResult.village);
                homeView.interactionNode.showRaid(() => {
                  slotNode.idle();
                  slotNode.activityRoot.updateActivity();
                });
              });
            }, 0.3);
            SoundManager.playSound("slot_item_win");
          };

          if (!TutorialManager.IsFinished()) {
            TutorialManager.SetStepOverCallback(() => {
              TutorialManager.SetStepOverCallback(() => {
                _f_execute();
              });
            });
          } else {
            _f_execute();
          }
        }

        static handleSpins(value) {
          const slotNode = homeView.slotNode;
          slotNode.rewardText.string = String.format(i18n.t("Spins"), value); // self.showSpinAddNumAnim(value);

          slotNode.idle(); // self.spinAnim.play(20, -250, 0.2, function () {
          // 	self.userinfo.playApAnim(function () {});
          // 	self.showSpinAddNumAnim(value);
          // });

          SoundManager.playSound("slot_item_win");
        }

        static handleSymbol(value) {
          const slotNode = homeView.slotNode;
          slotNode.rewardText.string = i18n.t("SlotSymbol" + slotNode.symbolId) + "+" + value;
          slotNode.idle();
          slotNode.activityRoot.updateActivity();
          SoundManager.playSound("slot_item_win");
        }

        static handleNone() {
          const slotNode = homeView.slotNode;
          slotNode.idle();
          return;
        }

        static handleCoins(type, value) {
          const slotNode = homeView.slotNode;

          switch (type) {
            case SlotTypes.Coin1:
              slotNode.rewardText.string = StringUtil.formatNumber(value);
              this.playCoinAnim(0);
              SoundManager.playSound("slot_coins_s");
              break;

            case SlotTypes.Coin2:
              slotNode.rewardText.string = StringUtil.formatNumber(value);
              this.playCoinAnim(1);
              SoundManager.playSound("slot_coins_s");
              break;

            case SlotTypes.Coin3:
              slotNode.rewardText.string = StringUtil.formatNumber(value);
              this.playCoinAnim(4);
              SoundManager.playSound("slot_coins_l");
              break;

            case SlotTypes.Coin4:
              slotNode.rewardText.string = StringUtil.formatNumber(value);
              this.playCoinAnim(2);
              SoundManager.playSound("slot_coins_m");
              break;

            case SlotTypes.Coin5:
              slotNode.rewardText.string = StringUtil.formatNumber(value);
              this.playCoinAnim(3);
              SoundManager.playSound("slot_coins_m");
              break;

            case SlotTypes.Coin6:
              slotNode.rewardText.string = StringUtil.formatNumber(value);
              this.playCoinAnim6(5);
              SoundManager.playSound("slot_coins_l");
              break;
          }
        } // 播放金币动画


        static playCoinAnim(index) {
          const slotNode = homeView.slotNode;
          if (GameMainWindow.instance != null) ; // slotNode.coinAnims[index].play(0, -100, 0.2, function () { });

          const newCoinAni = instantiate(slotNode.coinAnims[index].node);
          uiRoot.node.addChild(newCoinAni);
          newCoinAni.getComponent(CoinAnim).play(0, -48, 0.2, () => {
            newCoinAni.destroy();
          });
          slotNode.scheduleOnce(() => {
            slotNode.idle();
            eventCenter.emit(MyCustomEvent.ReadyChangeCoin);

            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              eventCenter.emit(TutorilaEvent.SpinFinished, SlotTypes.Coin1);
            }
          }, 0.6);
        } // 6个金袋 提示广告双倍


        static playCoinAnim6(index) {
          const slotNode = homeView.slotNode;
          if (GameMainWindow.instance != null) ; // slotNode.coinAnims[index].play(0, -100, 0.2, function () { });

          const newCoinAni = instantiate(slotNode.coinAnims[index].node);
          uiRoot.node.addChild(newCoinAni);
          newCoinAni.getComponent(CoinAnim).play(0, -48, 0.2, () => {
            newCoinAni.destroy();
          });
          slotNode.scheduleOnce(() => {
            if (G.GameConfig.closeCoin6Ad || !ADWrap.IsVideoPrepared() || !AppMain.instance.tutorialManager.isTutorilaFinished) {
              slotNode.idle();
              eventCenter.emit(MyCustomEvent.ReadyChangeCoin);

              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                eventCenter.emit(TutorilaEvent.SpinFinished, SlotTypes.Coin6);
              }
            } else {
              CountDownWindow.Show(3, i18n.t("SlotCoin6Video"), () => {
                slotNode.isSpining = true;
                ADWrap.ShowVideo(() => {
                  let req = SR.SRUserData.finishVideoSlotCoin6();
                  req.SetCallBack(() => {
                    this.playCoinAnim(5);
                    SoundManager.playSound("slot_coins_l");
                    eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                  });
                  req.SetErrorCallBack(() => {});
                  req.Send();
                }, "slotCoin6", () => {
                  slotNode.idle();
                  eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                });
              }, () => {
                slotNode.idle();
                eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
              });
            }
          }, 0.1);
        }

        static handleTutorial() {
          if (AppMain.instance.tutorialManager.isTutorilaFinished) return;
          const slotNode = homeView.slotNode;
          let resultType = "none";
          let resultNumber = 1;
          let resultUserInfo = {
            userId: 0,
            name: i18n.t("TutorialTargetName"),
            avatar: "",
            coin: 210000,
            expire: 0,
            isFriend: false
          };
          let resultVillage = {
            mapId: 1,
            village: [1, 1, 1, 1, 1, 0, 0, 0, 0, 0]
          };
          let tcid = AppMain.instance.tutorialManager.curTutorialIndex;

          if (tcid === 1000007) {
            resultUserInfo.name = i18n.t("TutorialTargetName1");
            resultUserInfo.avatar = i18n.t("TutorialTargetAvatar1");
          } else if (tcid === 1000014) {
            resultVillage = {
              mapId: 2,
              village: [1, 1, 1, 1, 1, 0, 0, 0, 0, 0]
            };
            resultUserInfo.name = i18n.t("TutorialTargetName2");
            resultUserInfo.avatar = i18n.t("TutorialTargetAvatar2");
          } else if (tcid === 1000017) {
            resultVillage = {
              mapId: 1,
              village: [1, 1, 1, 1, 1, 0, 1, 0, 1, 0]
            };
            resultUserInfo.name = i18n.t("TutorialTargetName3");
            resultUserInfo.avatar = i18n.t("TutorialTargetAvatar3");
          }

          var slotCoins = [1000, 1800, 18000, 4500, 9000, 50000]; // if (tcid < 1000005) TutorialManager.CallTrigger("go_spin");

          if (tcid === 1000004) {
            resultType = SlotTypes.Coin5;
            resultNumber = slotCoins[4];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000005) {
            resultType = SlotTypes.Coin6;
            resultNumber = slotCoins[5];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000006) {
            resultType = SlotTypes.Coin3;
            resultNumber = slotCoins[2];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000007) {
            resultType = SlotTypes.Attack;
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000008) {
            resultType = SlotTypes.Coin4;
            resultNumber = slotCoins[3];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000009) {
            resultType = SlotTypes.Shield;
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ShieldEvent, {
              shield: 1
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000010) {
            resultType = SlotTypes.Coin2;
            resultNumber = slotCoins[1];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000011) {
            resultType = SlotTypes.Spins;
            resultNumber = G.GameConstance.slotSpinsGet;
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1 + G.GameConstance.slotSpinsGet
            });
          } else if (tcid === 1000012) {
            resultType = SlotTypes.Coin6;
            resultNumber = slotCoins[5];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000013) {
            resultType = SlotTypes.Coin1;
            resultNumber = slotCoins[0];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000014) {
            resultType = SlotTypes.Attack;
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000015) {
            resultType = SlotTypes.Coin3;
            resultNumber = slotCoins[2];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000016) {
            resultType = SlotTypes.Coin4;
            resultNumber = slotCoins[3];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000017) {
            resultType = SlotTypes.Raid;
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000018) {
            resultType = SlotTypes.Coin6;
            resultNumber = slotCoins[5];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000019) {
            resultType = SlotTypes.Coin1;
            resultNumber = slotCoins[0];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000020) {
            resultType = SlotTypes.Coin2;
            resultNumber = slotCoins[1];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          } else if (tcid === 1000021) {
            resultType = SlotTypes.Coin4;
            resultNumber = slotCoins[3];
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
              oldCoin: Game.SUser.Coin(),
              coin: Game.SUser.Coin() + resultNumber,
              needPlayAnim: true
            });
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
              ap: Game.SUser.Ap() - 1
            });
          }

          slotNode.spinOk1({
            slotResult: {
              type: resultType,
              number: resultNumber,
              userInfo: resultUserInfo,
              village: resultVillage
            }
          });
          slotNode.scheduleOnce(() => {
            slotNode.spinOk2({
              slotResult: {
                type: resultType,
                number: resultNumber,
                userInfo: resultUserInfo,
                village: resultVillage
              }
            });
          }, 0.2);
          return;
        }

        static getFrameEventFrame(dragonAsset, animationName, eventName) {
          const dragonBonesJsonData = JSON.parse(dragonAsset["_dragonBonesJson"]);
          const animationsData = dragonBonesJsonData.armature[0].animation;
          let targetAnimation;

          if (animationsData.length > 1) {
            targetAnimation = animationsData[0];
          } else {
            animationsData.forEach((animation, index) => {
              if (animation.name === animationName) {
                targetAnimation = animation;
              }
            });
          }

          if (!targetAnimation) return;

          for (let index = 0; index < targetAnimation.frame.length; index++) {
            if (targetAnimation.frame[index].events && targetAnimation.frame[index].events[0].name === eventName) {
              let duration = 0;

              for (let i = 0; i < index; i++) {
                let temp = parseFloat(targetAnimation.frame[i].duration);
                temp = temp >= 0 ? temp : 0;
                duration += temp;
              }

              return duration;
            }
          }
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRMinigame.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRMinigame', void 0);

      cclegacy._RF.push({}, "0aca0h3VPJBf6lskJLOCdOs", "SRMinigame", undefined);

      let SRMinigame;

      (function (_SRMinigame) {
        function minigameGetRankList(userId, activityMetaId) {
          let req = new GameKit.ServerRequest("minigameGetRankList");
          req.SetRequestBody("userId", `${userId}`);
          req.SetRequestBody("activityMetaId", `${activityMetaId}`);
          return req;
        }

        _SRMinigame.minigameGetRankList = minigameGetRankList;
      })(SRMinigame || (SRMinigame = exports('SRMinigame', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitMainWindow.ts", ['cc', './CCEaseTypes.ts', './SoundManager.ts', './UIWindow.ts', './DialogWindow.ts', './FullLoadingWindow.ts', './MinigameBuyTicketWindow.ts', './MinigameRankWindow.ts', './MinigameTools.ts', './MinigameCoinhitGameplay.ts', './MinigameCoinhitData.ts', './MinigameCoinhitInfoWindow.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, v2, Node, Label, _decorator, PhysicsSystem, v3, view, instantiate, CCEaseTypes, SoundManager, UIWindow, DialogWindow, FullLoadingWindow, MinigameBuyTicketWindow, MinigameRankWindow, MinigameTools, MinigameCoinhitGameplay, MinigameCoinhitData, MinigameCoinhitInfoWindow, UIRoot, Meta, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v2 = module.v2;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
      PhysicsSystem = module.PhysicsSystem;
      v3 = module.v3;
      view = module.view;
      instantiate = module.instantiate;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      FullLoadingWindow = module.FullLoadingWindow;
    }, function (module) {
      MinigameBuyTicketWindow = module.default;
    }, function (module) {
      MinigameRankWindow = module.default;
    }, function (module) {
      MinigameTools = module.default;
    }, function (module) {
      MinigameCoinhitGameplay = module.default;
    }, function (module) {
      MinigameCoinhitData = module.default;
    }, function (module) {
      MinigameCoinhitInfoWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "0b857Sqln1ICp4/2s0VV3s6", "MinigameCoinhitMainWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        GRAVITY: v2(0, -1136),
        WINDMILL_CIRCLE_TIME: 10,
        // 风车转一圈的时间
        CLOUD_MOVE_TIME: [20, 40] // 云的移动时间

      };
      let MinigameCoinhitMainWindow = exports('default', (_dec = property({
        tooltip: "风车",
        type: Node
      }), _dec2 = property({
        tooltip: "云彩",
        type: Node
      }), _dec3 = property(Node), _dec4 = property({
        tooltip: "免费门票次数",
        type: Label
      }), _dec5 = property({
        tooltip: "门票次数",
        type: Label
      }), _dec6 = property({
        tooltip: "当前的球个数",
        type: Label
      }), _dec7 = property({
        tooltip: "coin",
        type: Label
      }), _dec8 = property({
        tooltip: "spin",
        type: Label
      }), _dec9 = property({
        tooltip: "coin-icon",
        type: Node
      }), _dec10 = property({
        tooltip: "coin-spin",
        type: Node
      }), _dec11 = property({
        tooltip: "获取动画coin/spin的初始",
        type: Node
      }), _dec12 = property({
        tooltip: "分数",
        type: Label
      }), _dec13 = property({
        tooltip: "gameover的样式",
        type: Node
      }), _dec14 = property({
        tooltip: "gameover的分数",
        type: Label
      }), _dec15 = property({
        tooltip: "gameover的特效",
        type: Node
      }), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameCoinhitMainWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "data", void 0);

          _defineProperty(this, "ui_items", void 0);

          _initializerDefineProperty(this, "windmill", _descriptor, this);

          _initializerDefineProperty(this, "cloud_list", _descriptor2, this);

          _initializerDefineProperty(this, "ui", _descriptor3, this);

          _initializerDefineProperty(this, "free_count", _descriptor4, this);

          _initializerDefineProperty(this, "ticket_count", _descriptor5, this);

          _initializerDefineProperty(this, "label_real_ball_count", _descriptor6, this);

          _initializerDefineProperty(this, "label_coin", _descriptor7, this);

          _initializerDefineProperty(this, "label_spin", _descriptor8, this);

          _initializerDefineProperty(this, "icon_coin", _descriptor9, this);

          _initializerDefineProperty(this, "icon_spin", _descriptor10, this);

          _initializerDefineProperty(this, "coin_and_spin_list", _descriptor11, this);

          _initializerDefineProperty(this, "label_score", _descriptor12, this);

          _initializerDefineProperty(this, "gameover", _descriptor13, this);

          _initializerDefineProperty(this, "gameover_score", _descriptor14, this);

          _initializerDefineProperty(this, "animRibbon", _descriptor15, this);
        }
        /** 从activity中心调用的打开方法 */


        static Show(meta) {
          FullLoadingWindow.Show(() => {
            homeView.closeGamePlay();
            UIRoot.instance.openWindow("MinigameCoinhitMainWindow", {
              showCallback: () => {
                FullLoadingWindow.Hide();
              },
              activityMetaId: meta.Id()
            });
          });
        }
        /** 从activity中心调用的关闭方法 */


        callClose() {
          FullLoadingWindow.Show(() => {
            UIRoot.instance.openWindow("GameMainWindow", {
              showCallback: () => {
                homeView.EnterGame();
                homeView.backToHomeView(() => {
                  FullLoadingWindow.Hide();
                });
              }
            });
          });
        }
        /** @type {MinigameCoinhitMainWindow} */


        onLoad() {
          MinigameCoinhitMainWindow.ins = this; // 打开物理引擎

          PhysicsSystem.instance.enable = true;
          PhysicsSystem.instance.gravity = v3(C.GRAVITY.x, C.GRAVITY.y);
        }

        onDestroy() {
          MinigameCoinhitMainWindow.ins = null; // 关闭物理引擎

          PhysicsSystem.instance.enable = false;
        }

        onShow(params) {
          this.data = new MinigameCoinhitData();
          let coin_base = Meta.MetaManager.GetMeta(Meta.MetaType.ShopCoin, Game.SUserVillage.MapId()).GetCoin(7);
          let spin_base = 1;

          if (!coin_base || !spin_base) {
            DialogWindow.Show(i18n.t("mini_game_fail"), () => {
              this.callClose();
            });
            return;
          }

          this.data.load_data(params.activityMetaId, coin_base, spin_base); // 初始动画

          this.anima_windmill();
          this.anima_cloud();
          this.scheduleOnce(() => {
            this.anima_show_ui();
          }, 0.1);
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "MinigameCoinhitMainWindow", function (data) {
            this.update_free_and_ticket_count();
          }.bind(this));
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "MinigameCoinhitMainWindow", function (data) {
            this.update_free_and_ticket_count();
          }.bind(this));
          this.update_free_and_ticket_count();
        }

        onClose() {
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "MinigameCoinhitMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "MinigameCoinhitMainWindow");
        } // anima

        /** @type {cc.Node} */

        /** 风车转动动画 */


        anima_windmill() {
          this.windmill.runAction(ccAction.rotateBy(C.WINDMILL_CIRCLE_TIME, 360).repeatForever());
        }
        /** @type {cc.Node[]} */

        /** 云移动动画 */


        anima_cloud() {
          let len = Math.min(this.cloud_list.length, C.CLOUD_MOVE_TIME.length);

          for (let i = 0; i < len; i += 1) {
            let left_x = -view.getVisibleSize().width / 2 - this.cloud_list[i].width / 2;
            let right_x = view.getVisibleSize().width / 2 + this.cloud_list[i].width / 2;
            let t = C.CLOUD_MOVE_TIME[i];
            this.cloud_list[i].runAction(ccAction.sequence(ccAction.place(left_x, this.cloud_list[i].position.y), ccAction.moveTo(t, right_x, this.cloud_list[i].position.y), ccAction.delayTime(t * 0.1)).repeatForever());
          }
        } // ui


        anima_show_ui() {
          if (!this.ui_items) {
            this.ui_items = {
              bkg: GameKit.ControllerTable.GetNode(this.ui, "sprite - model"),
              bg: GameKit.ControllerTable.GetNode(this.ui, "bg"),
              btn: GameKit.ControllerTable.GetNode(this.ui, "btn_back")
            };
          }

          this.ui_items.bkg.active = true;
          this.ui_items.bg.scale = v3(0, 0, 1); ///old api先这样改

          this.ui_items.bg.runAction(ccAction.scaleTo(0.3, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut))); // this.ui_items.bg.runAction(ccAction.scaleTo(0.3, 1, ccAction.easeBackOut(1.5)))

          this.ui_items.btn.active = true;
          this.anima_gameover_end();
        }

        anima_hide_ui() {
          this.ui_items.bg.runAction(ccAction.scaleTo(0.3, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn))); // this.ui_items.bg.runAction(ccAction.scaleTo(0.3, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)

          this.ui_items.bkg.active = false;
          this.ui_items.btn.active = false;
        } // free-ticket-count

        /** @type {cc.Label} */


        update_free_and_ticket_count() {
          this.free_count.string = `x${this.data.get_free_ticket_count()}`;
          this.ticket_count.string = `x${this.data.get_ticket_count()}`;
        }
        /** @type {cc.Label} */


        update_label_real_ball_count(count) {
          this.label_real_ball_count.string = count;
        }
        /** @type {cc.Label} */


        update_label_coin(n) {
          this.label_coin.string = n;
        }

        update_label_spin(n) {
          this.label_spin.string = n;
        }
        /** @type {cc.Label} */


        update_score(n) {
          this.label_score.string = n;
        }
        /**
         * 添加金币动画
         * @param {cc.Node} source_node
         * @param {0|1|2|3} index 样式序号,0/1表示coin,2/3表示spin
         */


        anima_add_coin_or_spin(source_node, index) {
          return new Promise(res => {
            let n = instantiate(this.coin_and_spin_list[index]);
            n.parent = this.coin_and_spin_list[index].parent;
            n.position = n.parent.convertToNodeSpaceAR(MinigameTools.get_node_world_position(source_node));
            n.scale = v3(0, 0, 1);
            n.active = true;
            let target_node = index <= 1 ? this.icon_coin : this.icon_spin;
            let target_position = n.parent.convertToNodeSpaceAR(MinigameTools.get_node_world_position(target_node));
            n.runAction(ccAction.sequence(ccAction.scaleTo(0.3, 1), ccAction.delayTime(0.5), ccAction.moveTo(0.7, target_position, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeExponentialOut)), ccAction.callFunc(() => {
              if (target_node.getNumberOfRunningActions() === 0) {
                target_node.runAction(ccAction.sequence(ccAction.scaleTo(0.1, 0.9), ccAction.scaleTo(0.1, 1)).repeat(5));
              }

              n.active = false;
              res(null);
            })));
          });
        }
        /** @type {cc.Node} */


        anima_gameover() {
          this.gameover_score.string = MinigameCoinhitMainWindow.ins.data.get_score_base().toString();
          return new Promise(res => {
            this.gameover.scale = v3(0, 0, 1);
            this.gameover.active = true;
            this.gameover.runAction(ccAction.sequence(ccAction.scaleTo(0.5, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), ccAction.delayTime(1.5), ccAction.callFunc(() => {
              res(null);
            })));
            this.gameover_score.node.scale = v3(0, 0, 1);
            this.gameover_score.node.active = true;
            this.gameover_score.node.runAction(ccAction.sequence(ccAction.delayTime(0.3), ccAction.scaleTo(0.5, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut))));
            let ar = instantiate(this.animRibbon);
            ar.active = true;
            ar.parent = this.animRibbon.parent;
            ar.x = this.animRibbon.x;
            ar.y = this.animRibbon.y;
            SoundManager.playSound("steal_popup");
          });
        }

        anima_gameover_end() {
          this.gameover_score.node.active = false;
          this.gameover.active = false;
        } // event

        /** 手动开始游戏 */


        event_game_start() {
          // 判断是否拥有门票
          if (this.data.has_free_ticket_or_ticket()) {
            MinigameCoinhitGameplay.ins.game_start();
          } else {
            UIRoot.instance.openChildWindow(MinigameBuyTicketWindow, {});
          }
        }

        event_close() {
          this.callClose();
        }

        event_info() {
          UIRoot.instance.openChildWindow(MinigameCoinhitInfoWindow);
        }

        event_rank() {
          UIRoot.instance.openChildWindow(MinigameRankWindow, {
            fake_list: this.data.get_fake_list_with_score(),
            activityMetaId: this.data.get_activity_meta_id()
          });
        }

        event_buy_ticket() {
          UIRoot.instance.openChildWindow(MinigameBuyTicketWindow, {});
        }

      }, _defineProperty(_class3, "windowPath", "Activity/minigame/coinhit/MinigameCoinhitMainWindow"), _defineProperty(_class3, "ins", void 0), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "windmill", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "cloud_list", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ui", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "free_count", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "ticket_count", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "label_real_ball_count", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "label_coin", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "label_spin", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "icon_coin", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "icon_spin", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "coin_and_spin_list", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "label_score", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "gameover", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "gameover_score", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "animRibbon", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PaymentWrap.ts", ['cc', './global.ts', './Logs.ts', './fbIn_lib.ts', './wx_lib.ts', './DialogWindow.ts', './PaySuccessWindow.ts', './LoadingWindow.ts', './SdkManager.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './NativeWrap.ts', './ErrorCode.ts', './PayFailWindow.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Logs, fbInTools, wxTools, DialogWindow, PaySuccessWindow, LoadingWindow, SdkManager, SR, UIRoot, Meta, Game, LogEventWrap, NativeWrap, ErrorCode, PayFailWindow, GameKit, BigNumber, i18n, AppMain;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function (module) {
      ErrorCode = module.ErrorCode;
    }, function (module) {
      PayFailWindow = module.PayFailWindow;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      exports('PaymentWrap', void 0);

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "0c022xqX6VN2pZNQp0bxDXo", "PaymentWrap", undefined);

      let PaymentWrap;

      (function (_PaymentWrap) {
        if (typeof FBInstant !== "undefined") {
          FBInstant.payments.onReady(() => {
            payEnabled = true;
          });
        }

        let payEnabled = false;
        let itemList;

        function Init() {
          if (!G.GameConfig.closePurchase) {
            if (wxTools.usewx) {
              payEnabled = SdkManager.IsAndroid();
            } else if (fbInTools.usefbIn) ;else if (SdkManager.IsNative()) {
              payEnabled = true;
            } else ;
          }
        }

        _PaymentWrap.Init = Init;

        function PayEnabled() {
          if (G.GameConfig.GAME_TEST) {
            return true;
          }

          return payEnabled;
        }

        _PaymentWrap.PayEnabled = PayEnabled;

        function PayVisiable() {
          if (wxTools.usewx) {
            return PaymentWrap.PayEnabled();
          } else if (fbInTools.usefbIn) {
            if (SdkManager.IsIos()) return false;
            return !G.GameConfig.closePurchase;
          }

          return PaymentWrap.PayEnabled();
        }

        _PaymentWrap.PayVisiable = PayVisiable;

        function GetOnlineList() {
          if (wxTools.usewx) ;else if (fbInTools.usefbIn) {
            FBInstant.payments.getCatalogAsync().then(catalog => {
              Logs.Info("FBInstant.payments.getCatalogAsync()", catalog);
              let list = GetList();
              catalog.forEach(function (product) {
                let productID = product.productID;
                let title = product.title;
                let description = product.description;
                let price = product.price;
                let priceCurrencyCode = product.priceCurrencyCode;
                let priceCurrencySymbol = ""; //CurrencyCodeInfo.GetSymbol(priceCurrencyCode) //price字符串包含了symbol

                if (list[productID] != null) {
                  list[productID].price = price;
                  list[productID].priceCurrencySymbol = priceCurrencySymbol;
                  list[productID].title = title;
                  list[productID].description = description;
                }
              });
            }).catch(e => {
              Logs.Log("FBInstant.payments.getCatalogAsync fail", e);
            });
          } else if (SdkManager.IsNative()) {
            let ids = [];
            let subIds = [];
            let list = PaymentWrap.GetList();

            for (let id in list) {
              let item = list[id];

              if (item.consumable) {
                ids.push(id);
              } else {
                subIds.push(id);
              }
            }

            NativeWrap.call("PaymentClass", "GetOnlineList", {
              ids: ids,
              subIds: subIds
            }, info => {
              if (info.success == "false") {
                PaymentWrap.GetOnlineList();
                return;
              }

              var products = info.products;

              if (products) {
                for (let productID in products) {
                  let product = products[productID];

                  if (list[productID] != null) {
                    list[productID].price = product.price;
                    list[productID].priceCurrencySymbol = product.priceCurrencySymbol;
                  }
                }
              }

              AppMain.instance.schedule(PaymentWrap.GetOnlineList, 900);
            });
          } else ;
        }

        _PaymentWrap.GetOnlineList = GetOnlineList;

        function SetByMeta(metas) {
          try {
            itemList = {};

            for (let id in metas) {
              let meta = metas[id];
              itemList[meta.Name()] = new PaymentItem(meta.Name(), meta.DefaultPrice(), i18n.t("PriceSymbol"), meta.Consumable());
            }

            GetOnlineList();
          } catch (e) {
            Logs.Error("PaymentWrap.SetByMeta", e.message);
          }
        }

        _PaymentWrap.SetByMeta = SetByMeta;

        function GetList() {
          if (itemList == null) {
            itemList = {};
          }

          return itemList;
        }

        _PaymentWrap.GetList = GetList;

        function GetItem(id) {
          return GetList()[id];
        }

        _PaymentWrap.GetItem = GetItem;

        function Pay(id, callback) {
          if (G.GameConfig.GAME_TEST && !fbInTools.usefbIn && !SdkManager.IsNative()) {
            PaymentWrap.PayOver(id, callback, true, "", 0, "", {});
            return;
          }

          if (!PaymentWrap.PayEnabled()) {
            if (fbInTools.usefbIn) {
              DialogWindow.Show(i18n.t("PayDisableFBIn"), nullFunction);
            } else {
              DialogWindow.Show(i18n.t("PayDisable"), nullFunction);
            }

            return;
          }

          let item = GetList()[id];
          if (item == null) return;
          LogEventWrap.logEvent("pay_click", {
            id: id
          });
          LoadingWindow.Show(true);

          if (wxTools.usewx) {
            let price = PaymentWrap.GetItem(id).price;
            wx.requestMidasPayment({
              mode: "game",
              env: 0,
              offerId: G.GameConfig.wxOfferId,
              currencyType: "CNY",
              buyQuantity: price,
              platform: "android",
              zoneId: "1",

              success() {
                // 支付成功
                PaymentWrap.PayOver(id, callback, true, "", 0);
              },

              fail({
                errMsg,
                errCode
              }) {
                // 支付失败
                PaymentWrap.PayOver(id, callback, false, errMsg, errCode);
              }

            });
          } else if (fbInTools.usefbIn) {
            if (item.consumable) {
              fbInTools.payAndConsume(id, "sf_pay", function (ok, msg, code) {
                PaymentWrap.PayOver(id, callback, ok, msg, code);
              });
            } else {
              fbInTools.pay(id, "sf_pay", function (ok, msg, code) {
                PaymentWrap.PayOver(id, callback, ok, msg, code);
              });
            }
          } else if (SdkManager.IsNative()) {
            NativeWrap.call("PaymentClass", "callPay", {
              productId: id
            }, function (info) {
              PaymentWrap.PayOver(id, callback, info.success, info.msg, info.code, info.reason, info); // AppKit.NativeWrap.call("PaymentClass", "callProductPayOver")
            });
          } else {
            LoadingWindow.Hide();
          }
        }

        _PaymentWrap.Pay = Pay;

        function PayOver(id, callback, ok, msg, code, reason, info) {
          LoadingWindow.Hide(); //if (code == "USER_INPUT") return

          if (code == "PENDING") {
            DialogWindow.Show(i18n.t("PayPending"), nullFunction);
            return;
          }

          if (ok) {
            LogEventWrap.logEvent("pay_success", {
              productId: id,
              OrderId: info ? info.OrderId : "null"
            });

            if (SdkManager.IsNative()) {
              NativeWrap.call("SDKHandleClass", "LogPurchaseEvent", {
                productId: id,
                revenue: info.price || 0,
                currency: info.currencyCode || "USD"
              }, null);
            }
            /*let reqlog = new GameKit.NetRequest(G.GameConfig.server + "/logpayment")
            reqlog.SetSilence(true)
            reqlog.SetRequestBody("userId", Game.SUser.UserId())
            reqlog.SetRequestBody("itemId", id)
            reqlog.SetRequestBody("price", PaymentWrap.GetItem(id).defaultPrice)
            reqlog.Send()*/


            let shopId = Meta.ShopMeta.GetShopIdByName(id);
            let shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, shopId);

            if (shopMeta.Type() == Meta.ShopMeta.Types.VIP) {
              LogEventWrap.logEvent("subscription_success", {
                productId: id,
                OrderId: info ? info.OrderId : "null",
                Token: info ? info.Token : "null"
              });
            }

            let reqps = SR.SRShop.paySuccess(shopId);
            reqps.SetRequestBody("productId", id);
            if (GameKit.DataCache.GetData("MultiplePurchase")) reqps.SetRequestBody("multiple", true);
            GameKit.DataCache.RemoveData("MultiplePurchase");

            if (SdkManager.IsNative()) {
              if (SdkManager.IsAndroid()) {
                reqps.SetRequestBody("GooglePlay", true);
                reqps.SetRequestBody("productId", info.productId);
                reqps.SetRequestBody("OrderId", info.OrderId);
                reqps.SetRequestBody("PurchaseData", info.PurchaseData);
                reqps.SetRequestBody("DataSignature", info.DataSignature);
                reqps.SetRequestBody("Token", info.Token);
              } else if (SdkManager.IsIos()) {
                reqps.SetRequestBody("AppStore", true);
                reqps.SetRequestBody("productId", info.productId);
                reqps.SetRequestBody("OrderId", info.OrderId);
                reqps.SetRequestBody("Token", info.Token);
              }
            }

            reqps.SetCallBack(res => {
              LoadingWindow.Hide();

              if (SdkManager.IsNative()) {
                NativeWrap.call("PaymentClass", "callProductPayOver");
              }

              if (callback != null) callback(true, res);
              LogEventWrap.logEvent("pay_callback", {
                times: res.times,
                productId: id,
                OrderId: info ? info.OrderId : "null"
              });
              LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "6mwm59" : "2rfy30", {
                revenue: shopMeta.DefaultPrice()
              }); //aj_purchased_value
            });
            reqps.SetErrorCallBack(res => {
              LoadingWindow.Hide();

              if (res.errorCode == ErrorCode.PAYMENT_VERIFY_ERROR && SdkManager.IsNative()) {
                NativeWrap.call("PaymentClass", "callProductPayOver");
              }

              let ErrorMsgKey = "ErrorMsg" + res.errorCode.toString();
              let ErrorMsg = i18n.t(ErrorMsgKey);
              if (ErrorMsg === ErrorMsgKey) ErrorMsg = i18n.t("ErrorNormal");
              UIRoot.instance.openChildWindow(DialogWindow, {
                msg: ErrorMsg + " Code:" + res.errorCode.toString(),
                confirmFunc: function () {
                  if (SdkManager.IsNative()) UIRoot.instance.openChildWindow(PayFailWindow, {
                    data: {
                      productId: id,
                      code: res.errorCode,
                      msg: res.msg,
                      OrderId: info.OrderId
                    }
                  });
                }
              });
            });
            reqps.SetNetErrorCallBack(res => {
              if (SdkManager.IsNative()) UIRoot.instance.openChildWindow(PayFailWindow, {
                data: {
                  productId: id,
                  code: res.errorCode,
                  msg: res.msg,
                  OrderId: info.OrderId
                }
              });
            });
            reqps.Send();
            LoadingWindow.Show(true);
            let purchaseCount = Game.SUserRecord.GetPurchaseCount();
            purchaseCount++;

            if (purchaseCount == 1) {
              LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "iz6gia" : "jb1ykx"); //aj_purchased1
            } else if (purchaseCount == 3) {
              LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "gt6c14" : "f7k58k"); //aj_purchased3
            } else if (purchaseCount == 10) {
              LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "ug67c6" : "1jyiph"); //aj_purchased10
            }
          } else {
            if (code == "USER_INPUT") {
              console.log("user cancel manually");
              if (callback != null) callback(false, msg, code); // if (AppKit.SdkManager.IsNative()) {
              // 	UIRoot.instance.openChildWindow(PayFailWindow, {
              // 		data: {
              // 			productId: id,
              // 			code: code,
              // 			msg: msg,
              // 			reason: reason,
              // 		},
              // 	});
              // }
            } else {
              if (callback != null) callback(false, msg, code);
              DialogWindow.Show(i18n.t("PayFail") + "\n(" + (code || "-1") + " " + (reason || "") + ")", () => {
                if (SdkManager.IsNative()) {
                  UIRoot.instance.openChildWindow(PayFailWindow, {
                    data: {
                      productId: id,
                      code: code,
                      msg: msg,
                      reason: reason
                    }
                  });
                } // UIRoot.instance.openChildWindow(PayFailWindow, {
                // 	data: {
                // 		productId: id,
                // 		code: code,
                // 		msg: msg,
                // 		reason: reason,
                // 	},
                // });

              });
              LogEventWrap.logEvent("pay_fail", {
                id: id,
                msg: msg || "",
                code: code || "",
                reason: reason || ""
              });
            }
          }
        }

        _PaymentWrap.PayOver = PayOver;

        function Reorder() {
          if (fbInTools.usefbIn) {
            FBInstant.payments.getPurchasesAsync().then(function (purchases) {
              purchases.forEach(purchase => {
                FBInstant.payments.consumePurchaseAsync(purchase.purchaseToken);
              });
            });
          } else if (SdkManager.IsNative()) {
            NativeWrap.call("PaymentClass", "callReorder", null, function (info) {
              if (info.success) {
                let id = info.productId;
                LogEventWrap.logEvent("pay_success", {
                  productId: info.productId,
                  OrderId: info.OrderId
                });
                /*let req = new GameKit.NetRequest(G.GameConfig.server + "/logpayment")
                req.SetSilence(true)
                req.SetRequestBody("userId", Game.SUser.UserId())
                req.SetRequestBody("itemId", id)
                req.SetRequestBody("price", PaymentWrap.GetItem(id).defaultPrice)
                req.Send()
                AppKit.NativeWrap.call("PaymentClass", "callProductPayOver")*/

                let shopId = Meta.ShopMeta.GetShopIdByName(id);
                let shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, shopId);
                let reqps = SR.SRShop.paySuccess(shopId);
                reqps.SetRequestBody("productId", id);

                if (SdkManager.IsNative()) {
                  if (SdkManager.IsAndroid()) {
                    reqps.SetRequestBody("GooglePlay", true);
                    reqps.SetRequestBody("productId", info.productId);
                    reqps.SetRequestBody("OrderId", info.OrderId);
                    reqps.SetRequestBody("PurchaseData", info.PurchaseData);
                    reqps.SetRequestBody("DataSignature", info.DataSignature);
                    reqps.SetRequestBody("Token", info.Token);
                  } else if (SdkManager.IsIos()) {
                    reqps.SetRequestBody("AppStore", true);
                    reqps.SetRequestBody("productId", info.productId);
                    reqps.SetRequestBody("OrderId", info.OrderId);
                    reqps.SetRequestBody("Token", info.Token);
                  }
                }

                reqps.SetCallBack(res => {
                  if (SdkManager.IsNative()) {
                    NativeWrap.call("PaymentClass", "callProductPayOver");
                  }

                  UIRoot.instance.openChildWindow(PaySuccessWindow, {
                    from: "pack"
                  });
                  LogEventWrap.logEvent("pay_callback", {
                    productId: info.productId,
                    OrderId: info.OrderId
                  });
                  LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "6mwm59" : "2rfy30", {
                    revenue: shopMeta.DefaultPrice()
                  }); //aj_purchased_value
                });
                reqps.SetErrorCallBack(res => {
                  if (res.errorCode == ErrorCode.PAYMENT_VERIFY_ERROR && SdkManager.IsNative()) {
                    NativeWrap.call("PaymentClass", "callProductPayOver");
                  }
                });
                reqps.Send();
              } else {
                if (info.code != "No product") {
                  LogEventWrap.logEvent("pay_fail", {
                    msg: info.msg,
                    code: info.code
                  });
                  NativeWrap.call("PaymentClass", "callProductPayOver");
                }
              }
            }, 5);
          }
        }

        _PaymentWrap.Reorder = Reorder;

        function Restore() {
          if (SdkManager.IsNative()) {
            NativeWrap.call("PaymentClass", "callRestore", null, function (res) {
              let ids = res.pids || [];
              let reqb = [];
              ids.forEach(info => {
                if (SdkManager.IsNative() && SdkManager.IsAndroid()) {
                  let shopId = Meta.ShopMeta.GetShopIdByName(info.productId);
                  let reqps = SR.SRShop.paySuccess(shopId);
                  reqps.SetRequestBody("GooglePlay", true);
                  reqps.SetRequestBody("productId", info.productId);
                  reqps.SetRequestBody("OrderId", info.OrderId);
                  reqps.SetRequestBody("PurchaseData", info.PurchaseData);
                  reqps.SetRequestBody("DataSignature", info.DataSignature);
                  reqps.SetRequestBody("Token", info.Token);
                  reqb.push(reqps);
                }
              });

              if (reqb.length > 0) {
                let reqRestore = new GameKit.BatchRequest([], reqb);
                reqRestore.SetCallBack(function () {
                  UIRoot.instance.openChildWindow(PaySuccessWindow, {
                    from: "pack"
                  });
                });
                reqRestore.Send();
              }
            }, 5);
          }
        }

        _PaymentWrap.Restore = Restore;
      })(PaymentWrap || (PaymentWrap = exports('PaymentWrap', {})));

      class PaymentItem {
        constructor(iapId, price, priceCurrencySymbol, consumable) {
          _defineProperty(this, "iapId", void 0);

          _defineProperty(this, "price", void 0);

          _defineProperty(this, "defaultPrice", void 0);

          _defineProperty(this, "priceCurrencySymbol", void 0);

          _defineProperty(this, "consumable", void 0);

          this.iapId = iapId;
          this.price = price;
          this.defaultPrice = price;
          this.priceCurrencySymbol = priceCurrencySymbol;
          this.consumable = consumable;
        }

        PriceString() {
          return this.priceCurrencySymbol + " " + this.price.toString().replace(".", BigNumber.dot);
        }

      }

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FriendPage.ts", ['cc', './Page.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Page;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      Page = module.Page;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "0c305w0agZPlox9oDMONB3V", "FriendPage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FriendPage = exports('FriendPage', (_dec = ccclass('FriendPage'), _dec(_class = class FriendPage extends Page {}) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BuildKingExtra.ts", ['cc', './CCE_Component.ts', './ContentModel.ts', './Content.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, CCE_Component, ContentModel, Content, Meta, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "0eb133kS8FBqo+nh25cRnnr", "BuildKingExtra", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BuildKingExtra = exports('default', (_dec = property(ContentModel), _dec2 = property(ContentModel), ccclass(_class = (_class2 = (_temp = class BuildKingExtra extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "content1", _descriptor, this);

          _initializerDefineProperty(this, "content2", _descriptor2, this);

          _defineProperty(this, "activityId", void 0);
        }

        Show(centerWindow, activityMeta) {
          this.activityId = activityMeta.Id();
          let restr = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.BuildMaster, Game.SUserVillage.MapId() + 1);
          let rewards = Content.FromStrings(restr);
          this.content1.show(rewards[0]);
          this.content2.show(rewards[1]);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "content1", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "content2", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UICantClick.ts", ['cc', './CCE_Component.ts', './UIRoot.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, CCE_Component, UIRoot;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      UIRoot = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "0f557+GCHVME6YhjGj/hiEE", "UICantClick", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let UICantClick = exports('default', (_dec = property(Node), ccclass(_class = (_class2 = (_temp = class UICantClick extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "loading", _descriptor, this);

          _defineProperty(this, "loadingTime", void 0);

          _defineProperty(this, "noloading", void 0);

          _defineProperty(this, "cantClickCount", void 0);
        }

        slowUpdate(dt) {
          this.loadingTime += dt;

          if (this.loadingTime >= 1 && !this.loading.active) {
            if (UIRoot.instance.currentWindowName != "LoginWindow" && !this.noloading) this.loading.active = true;
          }
        }

        onEnable() {
          this.loadingTime = 0;
          this.loading.active = false;
        }

        onDisable() {
          if (!this.node.active) this.noloading = false;
        }

        show(noloading) {
          this.cantClickCount = this.cantClickCount || 0;
          this.cantClickCount++;
          if (noloading !== null && noloading !== undefined) this.noloading = noloading;
          this.node.active = this.cantClickCount > 0;
        }

        close() {
          this.cantClickCount = this.cantClickCount || 0;
          this.cantClickCount--;
          this.node.active = this.cantClickCount > 0;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "loading", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ServerRequest.ts", ['cc', './global.ts', './Logs.ts', './DialogWindow.ts', './AppGame.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ErrorCode.ts', './AppKit.ts', './WebEvent.ts', './NetRequest.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var sys, cclegacy, G, Logs, DialogWindow, AppGame, UIRoot, Game, LogEventWrap, ErrorCode, WebEvent, NetRequest, GameKit, i18n;
  return {
    setters: [function (module) {
      sys = module.sys;
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ErrorCode = module.ErrorCode;
    }, function () {}, function (module) {
      WebEvent = module.WebEvent;
    }, function (module) {
      NetRequest = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "0fafb7T+gtBdby6m1w87w3b", "ServerRequest", undefined);

      class ServerRequest extends NetRequest {
        constructor(method) {
          const isTestServer = !!parseInt(sys.localStorage.getItem("isTestServer"));
          let server = (isTestServer ? G.GameConfig.testServer : G.GameConfig.formalServer) + "/portcol";
          super(server);

          _defineProperty(this, "serverErrorCallbacks", void 0);

          _defineProperty(this, "netErrorCallbacks", void 0);

          this.SetRequestBody("userId", Game.SUser.UserId());
          this.SetRequestBody("rid", Game.SUser.GetRequestId());
          this.SetRequestBody("uuid", Game.SUser.Uuid());
          this.SetRequestBody("method", method);
          this.serverErrorCallbacks = [];
          this.netErrorCallbacks = [];
          this.errorCallbacks.push(() => {
            let serverDown = G.GameConfig.serverDown;

            if (GameKit.TimeUtil.getCurrentTime() >= serverDown.startTime && GameKit.TimeUtil.getCurrentTime() <= serverDown.endTime) {
              this.netErrorCallbacks.forEach(x => {
                if (x != null) x();
              });
              UIRoot.instance.openChildWindow(DialogWindow, {
                msg: i18n.sel(serverDown.msg),
                confirmStr: i18n.t("Reconnect"),
                confirmFunc: () => {
                  if (UIRoot.instance.currentWindowName == "LoginWindow") {
                    UIRoot.instance.GetWindow("LoginWindow").getAppInfo();
                    UIRoot.instance.GetWindow("LoginWindow").setProgress(0.2, true);
                  } else {
                    AppGame.instance.logout();
                  }
                },
                countDown: 5
              });
              return;
            }

            UIRoot.instance.openChildWindow(DialogWindow, {
              msg: i18n.t("ErrorRetry"),
              confirmFunc: () => {
                this.Send();
              },
              cancelFunc: () => {
                this.netErrorCallbacks.forEach(x => {
                  if (x != null) x();
                });
              }
            });
          });
        }

        SetErrorCallBack(func) {
          this.serverErrorCallbacks.push(func);
        }

        SetNetErrorCallBack(func) {
          this.netErrorCallbacks.push(func);
        }

        okCallback(res) {
          Logs.Debug("ServerRequest resp:", res);

          if (res.errorCode !== ErrorCode.SUCCESS) {
            if (res.errorCode == null) res.errorCode = ErrorCode.UNKNOWN_CLIENT;
            this.serverErrorCallbacks.forEach(function (x) {
              if (x != null) x(res);
            });
            Logs.Warning("ServerRequest error " + "method:" + this.data.method + " msg:" + JSON.stringify(res.msg || "") + " code:" + res.errorCode); //AppMain.instance.logerror({msg:"ServerRequest error " + "method:" + this.data.method + " msg:" + JSON.stringify(res.msg || "") + " code:" + res.errorCode, url:"", line:""})

            LogEventWrap.logEvent("http_api_fail", {
              api: this.data.method,
              body: JSON.stringify(this.data),
              code: res.errorCode,
              msg: "ServerRequest error " + JSON.stringify(res.msg || "")
            });

            if (ErrorCode.muteError(res.errorCode)) {
              if (res.timestamp != null) GameKit.TimeUtil.UpdateServerTime(res.timestamp);

              if (res.events != null) {
                for (let type in res.events) {
                  WebEvent.DispatcherEvent(type, res.events[type]);
                }
              }

              return true;
            }

            let ErrorMsgKey = "ErrorMsg" + res.errorCode.toString();
            let ErrorMsg = i18n.t(ErrorMsgKey);
            if (ErrorMsg === ErrorMsgKey) ErrorMsg = i18n.t("ErrorNormal");

            if (ErrorCode.tipError(res.errorCode)) {
              dispatchEvent(res.errorCode);
              UIRoot.instance.openChildWindow(DialogWindow, {
                msg: ErrorMsg + "\nCode:" + res.errorCode.toString(),
                confirmFunc: function () {}
              });
              return true;
            } else {
              UIRoot.instance.openChildWindow(DialogWindow, {
                msg: ErrorMsg + "\nCode:" + res.errorCode.toString(),
                confirmFunc: function () {
                  AppGame.instance.logout();
                }
              });
              return false;
            }
          }

          if (res.timestamp != null) GameKit.TimeUtil.UpdateServerTime(res.timestamp);

          if (res.events != null) {
            for (let type in res.events) {
              WebEvent.DispatcherEvent(type, res.events[type]);
            }
          }

          this.callbacks.forEach(function (x) {
            if (x != null) x(res.result);
          });
          return true;
        }

      }

      exports('default', ServerRequest);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HotUpdator.ts", ['cc', './global.ts', './StringUtil.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, assetManager, G, StringUtil, AppMain;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      assetManager = module.assetManager;
    }, function (module) {
      G = module.G;
    }, function (module) {
      StringUtil = module.StringUtil;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "10003+eEcBD06BkrwamkIK7", "HotUpdator", undefined);

      class HotUpdator {
        constructor() {
          _defineProperty(this, "onEnterGame", null);

          _defineProperty(this, "onUpdateStart", null);

          _defineProperty(this, "onUpdateProgress", null);

          _defineProperty(this, "onUpdateFinish", null);

          _defineProperty(this, "_checking", false);

          _defineProperty(this, "_updating", false);

          _defineProperty(this, "_canRetry", false);

          _defineProperty(this, "_storagePath", '');

          _defineProperty(this, "_am", null);

          _defineProperty(this, "_checkListener", null);

          _defineProperty(this, "_updateListener", null);

          _defineProperty(this, "_failCount", 0);

          _defineProperty(this, "versionCompareHandle", null);
        }

        startUpdate() {
          this._storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() : '/') + 'hotupdate-asset';
          console.log('Storage path for remote asset : ' + this._storagePath); // Setup your own version compare handler, versionA and B is versions in string
          // if the return value greater than 0, versionA is greater than B,
          // if the return value equals 0, versionA equals to B,
          // if the return value smaller than 0, versionA is smaller than B.

          this.versionCompareHandle = function (versionA, versionB) {
            console.log("JS Custom Version Compare: version A is " + versionA + ', version B is ' + versionB);
            var vA = versionA.split('.');
            var vB = versionB.split('.');

            for (var i = 0; i < vA.length; ++i) {
              var a = parseInt(vA[i]);
              var b = parseInt(vB[i] || '0');

              if (a === b) {
                continue;
              } else {
                return a - b;
              }
            }

            if (vB.length > vA.length) {
              return -1;
            } else {
              return 0;
            }
          }; // Init with empty manifest url for testing custom manifest


          this._am = new jsb.AssetsManager('project.manifest', this._storagePath, this.versionCompareHandle);

          if (this._am.getState() === jsb.AssetsManager.State.UNINITED) {
            let url = "project.manifest";

            this._am.loadLocalManifest(url);
          } // var panel = this.panel;
          // Setup the verification callback, but we don't have md5 check function yet, so only print some message
          // Return true if the verification passed, otherwise return false


          this._am.setVerifyCallback(function (path, asset) {
            // When asset is compressed, we don't need to check its md5, because zip file have been deleted.
            var compressed = asset.compressed; // Retrieve the correct md5 value.

            var expectedMD5 = asset.md5; // asset.path is relative path and path is absolute.

            var relativePath = asset.path; // The size of asset file, but this value could be absent.

            var size = asset.size;

            if (compressed) {
              console.log("Verification passed : " + relativePath); // panel.info.string = "Verification passed : " + relativePath;

              return true;
            } else {
              console.log("Verification passed : " + relativePath + ' (' + expectedMD5 + ')'); // panel.info.string = "Verification passed : " + relativePath + ' (' + expectedMD5 + ')';

              return true;
            }
          });

          this.doUpdate();
        } // loadCustomRemoteManifest() {
        //     let ss = jsb.fileUtils.getStringFromFile("project.manifest");
        //     let obj = JSON.parse(ss);
        //     let latestVersion = versionConfig.hot_v;
        //     console.log("latestHotVersion", latestVersion);
        //     obj.packageUrl = `https://fay-res.oss-cn-beijing.aliyuncs.com/gameking/coin/ios/hot_res/${latestVersion}/`;
        //     obj.remoteManifestUrl = `https://fay-res.oss-cn-beijing.aliyuncs.com/gameking/coin/ios/hot_res/${latestVersion}/project.manifest`;
        //     let url = `https://fay-res.oss-cn-beijing.aliyuncs.com/gameking/coin/ios/hot_res/${latestVersion}/project.manifest`;
        //     assetManager.loadRemote(url, { type: "json" }, (e, v: JsonAsset) => {
        //         let c = JSON.stringify(v.json);
        //         const customManifestString = JSON.stringify(v.json);
        //         const manifest = new jsb.Manifest(customManifestString, this._storagePath);
        //         this._am.setEventCallback((event: jsb.EventAssetsManager) => {
        //             if (event.getEventCode() === jsb.EventAssetsManager.ALREADY_UP_TO_DATE) {
        //                 //enter game
        //             } else if (event.getEventCode() === jsb.EventAssetsManager.NEW_VERSION_FOUND) {
        //                 this._am.update();
        //             }
        //         });
        //         this._am.loadRemoteManifest(manifest);
        //     })
        // }


        async doUpdate() {
          let localManifest = this._am.getLocalManifest();

          let localVersion = localManifest.getVersion();
          let remoteVersion = versionConfig.hot_v;

          if (StringUtil.versionCompareHandle(localVersion, remoteVersion) < 0) {
            let url = `${G.res_root}/${$tp_platform}/hot_res/${remoteVersion}/project.manifest`;
            assetManager.loadRemote(url, (e, v) => {
              if (!v) {
                console.warn("cannot find file url:", url);
                return;
              } // JsonAsset.deserialize()
              // const customManifestString = JSON.stringify(v.json);


              const customManifestString = v["_file"];
              const manifest = new jsb.Manifest(customManifestString, this._storagePath);

              this._am.setEventCallback(event => {
                this.updateCallback(event);

                if (event.getEventCode() === jsb.EventAssetsManager.ALREADY_UP_TO_DATE) {
                  //enter game
                  this.onEnterGame && this.onEnterGame();
                } else if (event.getEventCode() === jsb.EventAssetsManager.NEW_VERSION_FOUND) {
                  this._updating = true;
                  this.onUpdateStart && this.onUpdateStart();

                  this._am.update();
                }
              });

              this._am.loadRemoteManifest(manifest);
            });
          } else {
            setTimeout(() => {
              this.onEnterGame && this.onEnterGame();
            }, 0.3);
          }
        } // loadCustomManifest() {
        //     if (this._am.getState() === jsb.AssetsManager.State.UNINITED) {
        //         let ss: string = "";
        //         let useCacheManifest = false;
        //         if (jsb.fileUtils.isFileExist(this._storagePath + "/project.manifest")) {
        //             ss = jsb.fileUtils.getStringFromFile(this._storagePath + "/project.manifest");
        //             useCacheManifest = true;
        //         } else {
        //             ss = jsb.fileUtils.getStringFromFile("project.manifest");
        //         }
        //         let obj = JSON.parse(ss);
        //         let latestVersion = versionConfig.hot_v;
        //         console.log("latestHotVersion", latestVersion);
        //         obj.packageUrl = `https://fay-res.oss-cn-beijing.aliyuncs.com/gameking/coin/ios/hot_res/${latestVersion}/`;
        //         obj.remoteManifestUrl = `https://fay-res.oss-cn-beijing.aliyuncs.com/gameking/coin/ios/hot_res/${latestVersion}/project.manifest`;
        //         const customManifestString = JSON.stringify(obj);
        //         //如果有缓存的话版本号一样会导致loadLocalManifest
        //         if (useCacheManifest) {
        //             jsb.fileUtils.writeStringToFile(customManifestString, this._storagePath + "/project.manifest");
        //         }
        //         var manifest = new jsb.Manifest(customManifestString, this._storagePath);
        //         // jsb.fileUtils.removeFile(this._storagePath + "/project.manifest");
        //         this._am.loadLocalManifest(manifest, this._storagePath);
        //         // this.panel.info.string = 'Using custom manifest';
        //     }
        // }
        // public static TestMode = false;
        // jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST = 0;
        // jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST = 1;
        // jsb.EventAssetsManager.ERROR_PARSE_MANIFEST = 2;
        // jsb.EventAssetsManager.NEW_VERSION_FOUND = 3;
        // jsb.EventAssetsManager.ALREADY_UP_TO_DATE = 4;
        // jsb.EventAssetsManager.UPDATE_PROGRESSION = 5;
        // jsb.EventAssetsManager.ASSET_UPDATED = 6;
        // jsb.EventAssetsManager.ERROR_UPDATING = 7;
        // jsb.EventAssetsManager.UPDATE_FINISHED = 8;
        // jsb.EventAssetsManager.UPDATE_FAILED = 9;
        // jsb.EventAssetsManager.ERROR_DECOMPRESS = 10;


        updateCallback(event) {
          console.log('Code: ' + event.getEventCode());
          var needRestart = false;
          var failed = false;

          switch (event.getEventCode()) {
            case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST:
              console.log('No local manifest file found, hot update skipped.'); // this.panel.info.string = 'No local manifest file found, hot update skipped.';

              failed = true;
              break;

            case jsb.EventAssetsManager.UPDATE_PROGRESSION:
              // this.panel.byteProgress.progress = event.getPercent();
              // this.panel.fileProgress.progress = event.getPercentByFile();
              this.onUpdateProgress && this.onUpdateProgress(event.getDownloadedFiles(), event.getTotalFiles()); // this.panel.fileLabel.string = event.getDownloadedFiles() + ' / ' + event.getTotalFiles();
              // this.panel.byteLabel.string = event.getDownloadedBytes() + ' / ' + event.getTotalBytes();
              // console.log(this.panel.fileLabel.string, this.panel.byteLabel.string);

              var msg = event.getMessage();

              if (msg) {
                console.log('Updated file: ' + msg); // this.panel.info.string = 'Updated file: ' + msg;
                // cc.log(event.getPercent()/100 + '% : ' + msg);
              }

              break;

            case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST:
            case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST:
              console.log('Fail to download manifest file, hot update skipped.'); // this.panel.info.string = 'Fail to download manifest file, hot update skipped.';

              failed = true;
              break;

            case jsb.EventAssetsManager.ALREADY_UP_TO_DATE:
              console.log('Already up to date with the latest remote version.'); // this.panel.info.string = 'Already up to date with the latest remote version.';

              failed = true;
              break;

            case jsb.EventAssetsManager.UPDATE_FINISHED:
              console.log('Update finished. ' + event.getMessage()); // this.panel.info.string = 'Update finished. ' + event.getMessage();

              this.onUpdateFinish && this.onUpdateFinish();
              needRestart = true;
              break;

            case jsb.EventAssetsManager.UPDATE_FAILED:
              console.log('Update failed. ' + event.getMessage()); // this.panel.info.string = 'Update failed. ' + event.getMessage();
              // this.panel.retryBtn.active = true;

              this._updating = false;
              this._canRetry = true;
              break;

            case jsb.EventAssetsManager.ERROR_UPDATING:
              console.log('Asset update error: ' + event.getAssetId() + ', ' + event.getMessage()); // this.panel.info.string = 'Asset update error: ' + event.getAssetId() + ', ' + event.getMessage();

              break;

            case jsb.EventAssetsManager.ERROR_DECOMPRESS:
              console.log(event.getMessage()); // this.panel.info.string = event.getMessage();

              break;
          }

          if (failed) {
            this._am.setEventCallback(null);

            this._updateListener = null;
            this._updating = false;
          }

          if (needRestart) {
            this._am.setEventCallback(null);

            this._updateListener = null; // Prepend the manifest's search path

            var searchPaths = jsb.fileUtils.getSearchPaths();

            var newPaths = this._am.getLocalManifest().getSearchPaths();

            console.log(JSON.stringify(newPaths));
            Array.prototype.unshift.apply(searchPaths, newPaths); // This value will be retrieved and appended to the default search path during game startup,
            // please refer to samples/js-tests/main.js for detailed usage.
            // !!! Re-add the search paths in main.js is very important, otherwise, new scripts won't take effect.

            localStorage.setItem('HotUpdateSearchPaths', JSON.stringify(searchPaths));
            jsb.fileUtils.setSearchPaths(searchPaths); // restart game.

            setTimeout(() => {
              AppMain.RestartApp();
            }, 1000);
          }
        }

        retry() {
          if (!this._updating && this._canRetry) {
            // this.panel.retryBtn.active = false;
            this._canRetry = false; // this.panel.info.string = 'Retry failed Assets...';

            this._am.downloadFailedAssets();
          }
        }

      }

      exports('HotUpdator', HotUpdator);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRMinigameCoinhit.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRMinigameCoinhit', void 0);

      cclegacy._RF.push({}, "10045fe44VKgJIv0bCDlmrn", "SRMinigameCoinhit", undefined);

      let SRMinigameCoinhit;

      (function (_SRMinigameCoinhit) {
        function minigameCoinhitGetReward(userId, activityMetaId, score, rewards) {
          let req = new GameKit.ServerRequest("minigameCoinhitGetReward");
          req.SetRequestBody("userId", `${userId}`);
          req.SetRequestBody("activityMetaId", `${activityMetaId}`);
          req.SetRequestBody("score", score);
          req.SetRequestBody("rewards", rewards);
          return req;
        }

        _SRMinigameCoinhit.minigameCoinhitGetReward = minigameCoinhitGetReward;
      })(SRMinigameCoinhit || (SRMinigameCoinhit = exports('SRMinigameCoinhit', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserActivity.ts", ['cc', './ActivityManager.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, ActivityManager, Meta, Game;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "10a32mMenJPzpSRanSanCCX", "UserActivity", undefined);

      class UserActivity {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            activityData: {},
            symbolRankData: {}
          };
        } //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
        }

        UserId() {
          return this.data.userId;
        }

        GetActivityData(activityId) {
          return this.data.activityData[activityId] || {};
        }

        GetSymbolRankData() {
          return this.data.symbolRankData || {};
        }

        GetGameActivityBadgeState() {
          return this.GetGameActivityBadgeStateByType(Meta.ActivityMeta.SubTypes.Jigsaw) || this.GetGameActivityBadgeStateByType(Meta.ActivityMeta.SubTypes.Minigame) || this.GetGameActivityBadgeStateByType(Meta.ActivityMeta.SubTypes.Cannon);
        }

        GetGameActivityBadgeStateByType(type) {
          let activityMeta = ActivityManager.GetActiveGameActivityByType(type);
          if (!activityMeta) return false;
          let userdata = Game.SUserActivity.GetActivityData(activityMeta.Id());

          if (type == Meta.ActivityMeta.SubTypes.Jigsaw) {
            if (userdata && userdata.jigsawData && userdata.pieceData) {
              for (let i = 0; i < userdata.pieceData.length; i++) {
                if (userdata.pieceData[i] > 0 && userdata.jigsawData[i] <= 0) return true;
              }
            }
          } else if (type == Meta.ActivityMeta.SubTypes.Minigame) {
            if (!userdata || !userdata.free_ticket) {
              return true;
            }
          } else if (type == Meta.ActivityMeta.SubTypes.Cannon) {
            if (userdata && userdata.ballCount != null && userdata.boxList != null) {
              let count = 0;
              userdata.boxList.forEach(v => {
                if (v > 0) {
                  count += 1;
                }
              });
              if (userdata.ballCount > 0 && count > 0) return true;
            } else {
              return true;
            }
          }

          return false;
        }

      }

      exports('UserActivity', UserActivity);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotPage.ts", ['cc', './Constant.ts', './global.ts', './EnterCloseAnim.ts', './SoundManager.ts', './User.ts', './ChangeSceneManager.ts', './DailyBonusNode.ts', './UserInfoModel.ts', './CardAllSetWindow.ts', './RoomManager.ts', './ActivitySlotSymbolRankWindow.ts', './SpinAnim.ts', './VillageNewsWindow.ts', './Page.ts', './ServantWindow.ts', './ContainerSlot.ts', './RenderUIToModel.ts', './ToRaidUserNode.ts', './BadgeItem.ts', './NewActivityCenterWindow.ts', './MenuWindow.ts', './LuckyDrawWindow.ts', './LevelBonusWindow.ts', './QuestCenterWindow.ts', './FirstPurchaseWindow.ts', './NewPlayerPackWindow.ts', './SdkManager.ts', './SR.ts', './VIPGetWindow.ts', './VIPExtraRewardWindow.ts', './ShopWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Node, Button, Label, Prefab, _decorator, Widget, instantiate, Animation, v3, LoadEvent, MyCustomEvent, G, EnterCloseAnim, SoundManager, User, ChangeSceneManager, DailyBonusNode, UserInfoModel, CardAllSetWindow, RoomManager, ActivitySlotSymbolRankWindow, SpinAnim, VillageNewsWindow, Page, ServantWindow, ContainerSlot, RenderUIToModel, ToRaidUserNode, BadgeItem, NewActivityCenterWindow, MenuWindow, LuckyDrawWindow, LevelBonusWindow, QuestCenterWindow, FirstPurchaseWindow, NewPlayerPackWindow, SdkManager, SR, VIPGetWindow, VIPExtraRewardWindow, ShopWindow, UIRoot, ActivityManager, Game, Meta, LogEventWrap, ADWrap, PaymentWrap, GameKit, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Node = module.Node;
      Button = module.Button;
      Label = module.Label;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      Widget = module.Widget;
      instantiate = module.instantiate;
      Animation = module.Animation;
      v3 = module.v3;
    }, function (module) {
      LoadEvent = module.LoadEvent;
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      User = module.User;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      DailyBonusNode = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      CardAllSetWindow = module.default;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      ActivitySlotSymbolRankWindow = module.ActivitySlotSymbolRankWindow;
    }, function (module) {
      SpinAnim = module.default;
    }, function (module) {
      VillageNewsWindow = module.VillageNewsWindow;
    }, function (module) {
      Page = module.Page;
    }, function (module) {
      ServantWindow = module.ServantWindow;
    }, function (module) {
      ContainerSlot = module.default;
    }, function (module) {
      RenderUIToModel = module.RenderUIToModel;
    }, function (module) {
      ToRaidUserNode = module.default;
    }, function (module) {
      BadgeItem = module.default;
    }, function (module) {
      NewActivityCenterWindow = module.NewActivityCenterWindow;
    }, function (module) {
      MenuWindow = module.MenuWindow;
    }, function (module) {
      LuckyDrawWindow = module.LuckyDrawWindow;
    }, function (module) {
      LevelBonusWindow = module.LevelBonusWindow;
    }, function (module) {
      QuestCenterWindow = module.QuestCenterWindow;
    }, function (module) {
      FirstPurchaseWindow = module.FirstPurchaseWindow;
    }, function (module) {
      NewPlayerPackWindow = module.NewPlayerPackWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      VIPGetWindow = module.default;
    }, function (module) {
      VIPExtraRewardWindow = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _dec27, _dec28, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _descriptor26, _descriptor27, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "10d06TG2stBQZZgjAhEm3S0", "SlotPage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotPage = exports('SlotPage', (_dec = ccclass("SlotPage"), _dec2 = property(Sprite), _dec3 = property(Node), _dec4 = property(Button), _dec5 = property(BadgeItem), _dec6 = property(Button), _dec7 = property(BadgeItem), _dec8 = property(Button), _dec9 = property(Button), _dec10 = property(Node), _dec11 = property(Node), _dec12 = property(Button), _dec13 = property(Label), _dec14 = property(Button), _dec15 = property(Button), _dec16 = property(Node), _dec17 = property(Node), _dec18 = property(BadgeItem), _dec19 = property([Prefab]), _dec20 = property(Button), _dec21 = property(Button), _dec22 = property(Label), _dec23 = property(Node), _dec24 = property(Label), _dec25 = property(Label), _dec26 = property(Prefab), _dec27 = property(Button), _dec28 = property(Node), _dec(_class = (_class2 = (_temp = class SlotPage extends Page {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "bg", _descriptor, this);

          _initializerDefineProperty(this, "dailyBonusNode", _descriptor2, this);

          _initializerDefineProperty(this, "btnMenu", _descriptor3, this);

          _initializerDefineProperty(this, "menuBadge", _descriptor4, this);

          _initializerDefineProperty(this, "btnQuest", _descriptor5, this);

          _initializerDefineProperty(this, "questBadge", _descriptor6, this);

          _initializerDefineProperty(this, "btnActivityCenter", _descriptor7, this);

          _initializerDefineProperty(this, "btnLevelBonus", _descriptor8, this);

          _initializerDefineProperty(this, "firstPurchase", _descriptor9, this);

          _initializerDefineProperty(this, "vipNode", _descriptor10, this);

          _initializerDefineProperty(this, "btnNewPlayerPack", _descriptor11, this);

          _initializerDefineProperty(this, "labelNewPlayerPack", _descriptor12, this);

          _initializerDefineProperty(this, "btnAdSpin", _descriptor13, this);

          _initializerDefineProperty(this, "btnAdSpinNormal", _descriptor14, this);

          _initializerDefineProperty(this, "activityLeft", _descriptor15, this);

          _initializerDefineProperty(this, "activityRight", _descriptor16, this);

          _initializerDefineProperty(this, "activityBadge", _descriptor17, this);

          _initializerDefineProperty(this, "animAdSpin", _descriptor18, this);

          _initializerDefineProperty(this, "btnLuckyDraw", _descriptor19, this);

          _initializerDefineProperty(this, "btnSlotSymbolRank", _descriptor20, this);

          _initializerDefineProperty(this, "labelSlotSymbolTimer", _descriptor21, this);

          _initializerDefineProperty(this, "timeBg", _descriptor22, this);

          _initializerDefineProperty(this, "labelRank", _descriptor23, this);

          _initializerDefineProperty(this, "labelLuckyDrawTime", _descriptor24, this);

          _initializerDefineProperty(this, "toRaidUser", _descriptor25, this);

          _initializerDefineProperty(this, "btnServant", _descriptor26, this);

          _initializerDefineProperty(this, "badge_servant", _descriptor27, this);

          _defineProperty(this, "NewPlayerPackLeftTime", 0);

          _defineProperty(this, "updateActivityInterval", 0);

          _defineProperty(this, "spinadShowBtnI", 0);

          _defineProperty(this, "activityBadgeData", null);

          _defineProperty(this, "uiContainer", void 0);

          _defineProperty(this, "slotContainer", null);

          _defineProperty(this, "slot3dContainer", null);

          _defineProperty(this, "containerSlot", null);

          _defineProperty(this, "luckyDrawActiveI", 0);

          _defineProperty(this, "luckyDrawShowBtnI", 0);

          _defineProperty(this, "luckyDrawTimer", 0);

          _defineProperty(this, "toRaidUserNode", void 0);

          _defineProperty(this, "renderUIToModel", void 0);

          _defineProperty(this, "leftTime", 0);
        }

        onLoad() {
          super.onLoad();
          this.btnLuckyDraw.node.active = false;
          this.uiContainer = this.node.getChildByName("container").getChildByName("UI");
          this.initToRaidUser();
          this.uiContainer.getComponent(Widget).top += AppMain.instance.statusBarHeight;
          this.uiContainer.getComponentsInChildren(Widget).forEach(widget => {
            widget.updateAlignment();
          });
        }

        onDestroy() {
          super.onDestroy();
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ToraidEvent, "SlotNode");
        }

        onEnable() {
          if (!RoomManager.instance || !RoomManager.instance.curRoom) return;
          RoomManager.instance.curRoom.updateToRaidUserBoard();
          eventCenter.once(LoadEvent.UserAvatarLoaded, () => {
            RoomManager.instance.curRoom.updateToRaidUserBoard();
          });
        }

        init() {
          this.slotContainer = this.node.getChildByName("container").getChildByName("SlotContainer");
          this.slot3dContainer = this.node.getChildByName("container").getChildByName("Slot3dContainer");
          this.containerSlot = this.slot3dContainer.getComponent(ContainerSlot);
        }

        initToRaidUser() {
          let node = instantiate(this.toRaidUser);
          this.uiContainer.addChild(node);
          this.renderUIToModel = node.getComponent(RenderUIToModel);
          this.toRaidUserNode = node.getComponentInChildren(ToRaidUserNode);
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ToraidEvent, "SlotPage", () => {
            this.updateToRaidUser();
          });
        }

        updateToRaidUser() {
          console.log("updateToRaidUser");
          this.toRaidUserNode.hideNode(() => {
            let user = new User();
            user.updateData(Game.SUserSlot.ToraidUser());
            this.toRaidUserNode.getComponent(UserInfoModel).show(user);
            this.toRaidUserNode.showNode();
          });
        }

        initPage() {
          if (!PaymentWrap.PayVisiable()) {
            this.btnNewPlayerPack.node.active = false;
            this.vipNode.active = false; // this.btnApAdd.node.active = false;
          } else {
            this.btnNewPlayerPack.node.active = !!Game.SUserStatus.GetNewPlayerLeftTime();
            this.NewPlayerPackLeftTime = Game.SUserStatus.GetNewPlayerLeftTime();
            this.vipNode.active = !Game.SUserStatus.IsVip() && SdkManager.IsNative(); // this.btnApAdd.node.active = !this.btnNewPlayerPack.node.active && !this.vipNode.active && this.activityLeft.children.length <= 4;
          } // EnterCloseAnim.playCloseImmediately(this.activityLeft);
          // EnterCloseAnim.playCloseImmediately(this.activityRight);
          //广告获取体力


          this.updateSpinAd(); //菜单badge

          this.setMenuBadge();
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.CoinEvent, "GameMainWindow", data => {
            this.setMenuBadge();
          });
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ApEvent, "GameMainWindow", data => {
            this.updateSpinAd();
          });
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.VillageEvent, "GameMainWindow", data => {
            this.setMenuBadge();
          });
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.MessageEvent, "GameMainWindow", data => {
            this.setMenuBadge();
          });
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.GiftEvent, "GameMainWindow", data => {
            this.setMenuBadge();
          });
          eventCenter.on(MyCustomEvent.SignInCollected, () => {
            this.setMenuBadge();
          }, this); //任务badge

          this.updateQuestBadge();
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.TaskCompleteCount, "GameMainWindow", data => {
            this.updateQuestBadge();
          }); //活动badge

          this.updateActivityBadge();
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "GameMainWindow", data => {
            this.updateActivityBadge();
          });
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.StatusEvent, "GameMainWindow", data => {
            this.btnNewPlayerPack.node.active = !!Game.SUserStatus.GetNewPlayerLeftTime();
            this.NewPlayerPackLeftTime = Game.SUserStatus.GetNewPlayerLeftTime();
            this.vipNode.active = !Game.SUserStatus.IsVip() && SdkManager.IsNative(); // this.btnApAdd.node.active = !this.btnNewPlayerPack.node.active && !this.vipNode.active && this.activityLeft.children.length <= 4;
          }); //礼物事件

          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.PresentEvent, "GameMainWindow", data => {
            this.setMenuBadge();
          }); //card
          // this.updateCardBadge();
          // GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.CardEvent, "GameMainWindow", (data) => {
          // 	this.updateCardBadge();
          // });
          //活动图标

          this.updateActivityButton();
          this.updateActivityInterval = setInterval(() => {
            this.updateActivityButton();
            ActivityManager.logined();
          }, 600000);
          this.btnLevelBonus.node.active = Game.SUserVillage.MapId() >= 2;
          this.btnServant.node.active = Game.SUserVillage.MapId() >= 2;
          this.dailyBonusNode.active = AppMain.instance.tutorialManager.isTutorilaFinished;

          if (this.dailyBonusNode.active) {
            this.schedule(() => {
              this.dailyBonusNode.getComponentInChildren(Animation).play("spin1");
            }, 10);
          }

          homeView.slotNode.updatePeterPosition();
        }

        slowUpdate(dt) {
          this.updateNewPlayerPackTime();
          this.updateLuckyDrawTimer(dt);
          this.updateTournamentTimer(dt); //更新宠物红点

          const state = Game.SUserServant.Servant(Game.SUserServant.GetSelected() || 1);

          if (state) {
            const levelUpNeedExp = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, state.rank).Exp(Game.SUserServant.GetSelected() || 1);
            this.badge_servant && (this.badge_servant.active = state.exp >= levelUpNeedExp);
          } else {
            this.badge_servant && (this.badge_servant.active = false);
          }
        }

        updateSpinAd() {
          /**
           * TODO
           */
          // let old_active = this.btnAdSpin.node.active;
          // let old_activeNormal = this.btnAdSpinNormal.node.active;
          // this.btnAdSpin.node.active = false;
          // this.btnAdSpinNormal.node.active = false;
          // if (!AppKit.ADWrap.AdEnabled()) return;
          // if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;
          // if (this.spinadShowBtnI) {
          // 	clearInterval(this.spinadShowBtnI);
          // 	this.spinadShowBtnI = null;
          // }
          // if (Game.SUser.Ap() < 10) {
          // 	let adSpinTime = GameKit.PlayerPrefs.GetInt("adSpinTime", 0);
          // 	if (GameKit.TimeUtil.getCurrentHalfDay() !== adSpinTime) {
          // 		GameKit.PlayerPrefs.SetInt("adSpinCount", 0);
          // 		GameKit.PlayerPrefs.SetInt("adSpinTime", GameKit.TimeUtil.getCurrentHalfDay());
          // 	}
          // 	let adRandomSpinCount = GameKit.PlayerPrefs.GetInt("adRandomSpinCount", 0);
          // 	let adSpinCount = GameKit.PlayerPrefs.GetInt("adSpinCount", 0);
          // 	if (adSpinCount < (AppKit.PaymentWrap.PayEnabled() ? G.GameConfig.adSpinCount : G.GameConfig.adSpinCount * 2)) {
          // 		let showBtn = () => {
          // 			if (!this.node || !this.btnAdSpin || !this.btnAdSpinNormal) return;
          // 			if (adRandomSpinCount < 3) {
          // 				this.btnAdSpin.node.active = true;
          // 				if (!old_active) EnterCloseAnim.playEnter(this.btnAdSpin);
          // 			} else {
          // 				this.btnAdSpinNormal.node.active = true;
          // 				if (!old_activeNormal) EnterCloseAnim.playEnter(this.btnAdSpinNormal);
          // 			}
          // 		};
          // 		if (AppKit.ADWrap.IsVideoPrepared()) {
          // 			showBtn();
          // 		} else {
          // 			old_active = false;
          // 			old_activeNormal = false;
          // 			this.spinadShowBtnI = setInterval(() => {
          // 				if (AppKit.ADWrap.IsVideoPrepared()) {
          // 					showBtn();
          // 					clearInterval(this.spinadShowBtnI);
          // 					this.spinadShowBtnI = null;
          // 				}
          // 			}, 3000);
          // 		}
          // 	}
          // }
        } //回调


        openMenu() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(MenuWindow);
        }

        setMenuBadge() {
          if (!this.menuBadge) return;
          let num = 0;
          num += G.GameConstance.dailybonusMaxCount - Game.SUserSlot.DailyBonusDid(); // num += homeView.villagePage.villageShopBadge.num;

          let NewMessageNum = GameKit.DataCache.GetData("NewMessageNum");
          if (NewMessageNum == null) NewMessageNum = 0;
          num += NewMessageNum;
          num += VillageNewsWindow.getPresentNum();
          let GiftsNum = GameKit.DataCache.GetData("GiftsNum");
          if (GiftsNum == null) GiftsNum = 0;
          num += GiftsNum;
          let signData = GameKit.DataCache.GetData("signData");
          let canSignWeek = false;
          let canSignMonth = false;

          if (signData) {
            canSignWeek = signData.signWeekDay > signData.signWeekRewards;

            for (let i = 7; i <= 28; i += 7) {
              if (signData.signMonthDay >= i && !signData.signMonthRewards.includes(i)) {
                canSignMonth = true;
                break;
              }
            }
          }

          num += canSignMonth || canSignWeek ? 1 : 0;
          this.menuBadge.SetNum(num);

          if (SdkManager.IsNative() && SdkManager.IsIos()) {
            this.menuBadge.label.node.active = false;
          }
        }

        openQuestWindow() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(QuestCenterWindow);
        }

        updateQuestBadge() {
          this.questBadge.node.active = false;
          let signData = GameKit.DataCache.GetData("signData");

          if (GameKit.DataCache.GetData("UserTaskCompleteCount") == null && GameKit.DataCache.GetData("UserTask") != null) {
            let taskList = GameKit.DataCache.GetData("UserTask") || [];
            let count = 0;

            for (let i = 0; i < taskList.length; i++) {
              let task = taskList[i];
              let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Task, task.id);

              if (meta && task.userCount >= meta.Count() && !task.received) {
                count++;
              }
            }

            GameKit.DataCache.SetData("UserTaskCompleteCount", count);
          }

          let taskCount = GameKit.DataCache.GetData("UserTaskCompleteCount") || 0;
          let canSignWeek = false;

          if (signData) {
            canSignWeek = signData.signWeekDay > signData.signWeekRewards;

            for (let i = 7; i <= 28; i += 7) {
              if (signData.signMonthDay >= i && !signData.signMonthRewards.includes(i)) {
                break;
              }
            }
          }

          let canReceiveTask = taskCount > 0;
          this.questBadge.node.active = canReceiveTask;
        }

        openActivityWindow() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(NewActivityCenterWindow);
        }

        updateActivityBadge() {
          this.activityBadge.node.active = Game.SUserActivity.GetGameActivityBadgeState();
        }

        updateActivityButton() {
          //当前有活动开启则显示入口按钮
          const scMeta = ActivityManager.GetActiveSlotCollectActivity();
          this.btnSlotSymbolRank.node.active = !!scMeta;
          if (!scMeta) return; //从服务器获取当前或者上一次活动的data

          const rankData = Game.SUserActivity.GetSymbolRankData();
          const meta = rankData.activityId && ActivityManager.GetMeta(rankData.activityId); // 没有参加任何活动

          if (!rankData.rank) {
            this.labelRank.string = "";
            return;
          } else {
            //计算上一次或者当前活动的排名
            const uids = Object.keys(rankData.rank);
            uids.sort((a, b) => {
              return rankData.rank[b].score - rankData.rank[a].score;
            });
            const selfRank = uids.indexOf(Game.SUser.UserId().toString()) + 1; //当前活动没有结束

            if (meta.Id() === scMeta.Id() && !rankData.collect) {
              this.labelRank.string = selfRank.toString();
            } else {
              this.labelRank.string = "";
            }
          }

          if (!this.node || !this.btnActivityCenter) return;
          let activities = ActivityManager.GetActiveGameActivities(); //TODO
          // if (activities.length <= 0 || (activities.length === 1 && activities[0]._data.name["en"] === "Evolve King")) {
          // 	this.btnActivityCenter.node.active = false;
          // } else {
          // 	if (!this.btnActivityCenter.node.active) this.activityBadge.node.active = true;
          // 	this.btnActivityCenter.node.active = true;
          // }
        }

        openCard() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(CardAllSetWindow);
        }

        updateCardBadge() {// if (Game.SUserVillage.MapId() < G.GameConstance.cardSystemStartLevel || !AppKit.ADWrap.AdEnabled()) {
          // 	this.cardBadge.SetNum(0);
          // 	return;
          // }
          // this.cardBadge.SetNum(G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount);
        } // NewPlayerPack


        openNewPlayerPack() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(NewPlayerPackWindow);
        }

        updateNewPlayerPackTime() {
          if (this.NewPlayerPackLeftTime) {
            this.NewPlayerPackLeftTime = Game.SUserStatus.GetNewPlayerLeftTime();
            this.labelNewPlayerPack.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.NewPlayerPackLeftTime, false);

            if (this.NewPlayerPackLeftTime <= 0) {
              this.btnNewPlayerPack.node.active = false;
              this.NewPlayerPackLeftTime = null;
            }
          }
        }

        openSpinShop() {
          if (homeView.isBusy()) return; // UIRoot.instance.openChildWindow(ShopWindow);

          homeView.pageViewController.moveToPage(G.Pages.Shop, true);
          homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.spin);
          LogEventWrap.logEvent("openshop_spin");
        }

        watchSpinAd(e, n) {
          if (homeView.isBusy()) return;
          let random = parseInt(n) > 0;
          ADWrap.ShowVideo(() => {
            let req = SR.SRUserData.finishVideoAp();
            req.SetRequestBody("random", random);
            req.SetCallBack(res => {
              let adSpinTime = GameKit.PlayerPrefs.GetInt("adSpinTime", 0);

              if (GameKit.TimeUtil.getCurrentHalfDay() > adSpinTime) {
                GameKit.PlayerPrefs.SetInt("adSpinCount", 0);
                GameKit.PlayerPrefs.SetInt("adSpinTime", GameKit.TimeUtil.getCurrentHalfDay());
              }

              let adSpinCount = GameKit.PlayerPrefs.GetInt("adSpinCount", 0);
              GameKit.PlayerPrefs.SetInt("adSpinCount", adSpinCount + 1);

              if (random) {
                let adRandomSpinTime = GameKit.PlayerPrefs.GetInt("adRandomSpinTime", 0);

                if (GameKit.TimeUtil.getCurrentDay() > adRandomSpinTime) {
                  GameKit.PlayerPrefs.SetInt("adRandomSpinCount", 0);
                  GameKit.PlayerPrefs.SetInt("adRandomSpinTime", GameKit.TimeUtil.getCurrentDay());
                }

                let adRandomSpinCount = GameKit.PlayerPrefs.GetInt("adRandomSpinCount", 0);
                GameKit.PlayerPrefs.SetInt("adRandomSpinCount", adRandomSpinCount + 1);
              }

              this.updateSpinAd();
              let count = res.count;
              let slot = homeView.slotNode;
              homeView.pageViewController.stopApAt(Game.SUser.Ap() - count);
              homeView.scheduleOnce(() => {
                homeView.pageViewController.stopApAt(Game.SUser.Ap() - count);
                slot.isSpining = true;

                if (random) {
                  let animNode = instantiate(this.animAdSpin[count - 1]);
                  animNode.parent = this.node;
                  animNode.setPosition(v3(0, 0));
                  animNode.runAction(ccAction.sequence(ccAction.delayTime(2), ccAction.fadeOut(0.5), ccAction.callFunc(() => {
                    animNode.destroy();

                    for (let i = 0; i < count; i++) {
                      let spinAnim = instantiate(slot.spinAnim.node);
                      spinAnim.parent = slot.spinAnim.node.parent;
                      spinAnim.getComponent(SpinAnim).play(20, -250, 0.5 + i * 0.3, function () {
                        if (i == count - 1) {
                          slot.makeIdle();
                          slot.showSpinAddNumAnim(count);
                        }

                        setTimeout(() => {
                          spinAnim.destroy();
                        }, 100);
                      });
                    }
                  })));
                  SoundManager.playSound("dice");
                } else {
                  slot.spinAnim.play(20, -250, 0.5, function () {
                    slot.makeIdle();
                    slot.showSpinAddNumAnim(count);
                  });
                }
              }, 0.5);
            });
            req.Send();
          }, "watchSpinAd");
        } //设定活动图标


        SetActivityBadge(badge) {
          this.activityBadgeData = this.activityBadgeData || {};
          if (this.activityBadgeData[badge.meta.Id()]) return;
          if (!badge.isleft) return;
          let isleft = badge.isleft;
          this.activityBadgeData[badge.meta.Id()] = badge;

          if (isleft) {
            badge.node.parent = this.activityLeft; // this.btnApAdd.node.active = false;
          } else {
            badge.node.parent = this.activityRight;
          }

          badge.node.x = 0;
        }

        RemoveActivityBadge(id) {
          if (this.activityBadgeData && this.activityBadgeData[id]) {
            this.activityBadgeData[id].node.removeFromParent();
            this.activityBadgeData[id].node.destroy();
            this.activityBadgeData[id] = null;
          } // this.btnApAdd.node.active = !this.btnNewPlayerPack.node.active && !this.vipNode.active && this.activityLeft.children.length <= 4;

        }

        openFirstPurchase() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(FirstPurchaseWindow);
        } // VIP


        openVipWindow() {
          if (homeView.isBusy()) return;
          Game.SUserStatus.UpdateExtraTime();

          if (Game.SUserStatus.VipExtraReward() && Game.SUserStatus.VipExtraReward().length > 0) {
            UIRoot.instance.openChildWindow(VIPExtraRewardWindow);
          } else {
            UIRoot.instance.openChildWindow(VIPGetWindow);
          }
        }

        openLevelBonus() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(LevelBonusWindow);
        }

        openDailyBonus() {
          if (homeView.isBusy()) return;
          ChangeSceneManager.instance.show(() => {
            UIRoot.instance.openChildWindow(DailyBonusNode, {
              showCallback: () => {
                ChangeSceneManager.instance.hide();
              }
            }, UIRoot.instance.dailyBonusNode);
          });
        } //LuckyDraw


        updateLuckyDraw(show = false) {
          if (!this.btnLuckyDraw) return;
          let ct = GameKit.TimeUtil.getCurrentTime();

          if (show) {
            this.btnLuckyDraw.node.active = false;
            GameKit.DataCache.SetData("updateLuckyDrawTime", ct + 300);
          }

          let old_active = this.btnLuckyDraw.node.active;
          this.btnLuckyDraw.node.active = false;
          if (!ADWrap.AdEnabled()) return;
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;

          if (this.luckyDrawActiveI) {
            clearTimeout(this.luckyDrawActiveI);
            this.luckyDrawActiveI = null;
          }

          let rt = (GameKit.DataCache.GetData("updateLuckyDrawTime") || ct + 300) - ct;

          if (rt > 0) {
            this.luckyDrawActiveI = setTimeout(() => {
              this.updateLuckyDraw();
              this.luckyDrawActiveI = null;
            }, rt * 1000);
            return;
          }

          if (this.luckyDrawShowBtnI) {
            clearInterval(this.luckyDrawShowBtnI);
            this.luckyDrawShowBtnI = null;
          }

          let showBtn = () => {
            if (!this.node || !this.btnLuckyDraw) return;
            this.btnLuckyDraw.node.active = true;

            if (!old_active) {
              EnterCloseAnim.playEnter(this.btnLuckyDraw);
              this.luckyDrawTimer = 300;
            }
          };

          if (ADWrap.IsVideoPrepared()) {
            showBtn();
          } else {
            old_active = false;
            this.luckyDrawShowBtnI = setInterval(() => {
              if (ADWrap.IsVideoPrepared()) {
                showBtn();
                clearInterval(this.luckyDrawShowBtnI);
                this.luckyDrawShowBtnI = null;
              }
            }, 3000);
          }

          homeView.slotNode.updatePeterPosition();
        }

        openLuckyDraw() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(LuckyDrawWindow);
        }

        updateLuckyDrawTimer(dt) {
          if (this.luckyDrawTimer) {
            this.luckyDrawTimer -= dt;
            this.labelLuckyDrawTime.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.luckyDrawTimer, false);

            if (this.luckyDrawTimer <= 0) {
              this.luckyDrawTimer = null;
              this.updateLuckyDraw(true);
            }
          }
        }

        openServantWindow() {
          if (homeView.isBusy()) return;
          ServantWindow.Show();
        }

        openSymbolRank() {
          if (homeView.isBusy()) return;
          if (!homeView.slotNode.canSpin()) return;
          const scMeta = ActivityManager.GetActiveSlotCollectActivity();
          uiRoot.openChildWindow(ActivitySlotSymbolRankWindow, {
            meta: scMeta
          });
        }

        updateTournamentTimer(dt) {
          const scMeta = ActivityManager.GetActiveSlotCollectActivity();
          if (!scMeta) return;
          const rankData = Game.SUserActivity.GetSymbolRankData();

          if (!rankData.rank) {
            this.labelSlotSymbolTimer.string = "Tournament";
            this.timeBg.active = false;
            return;
          }

          if (rankData.collect && !scMeta) {
            this.labelSlotSymbolTimer.string = i18n.t("ActivityCenterTimeEnd");
            this.timeBg.active = false;
            return;
          }

          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = 0;
            this.leftTime = scMeta.EndTime() - currentTime;
            this.labelSlotSymbolTimer.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, true);
            this.timeBg.active = true;

            if (this.leftTime <= 0) {
              this.labelSlotSymbolTimer.string = i18n.t("ActivityCenterTimeEnd");
              this.timeBg.active = false;
              SR.SRActivity.getUserActivity().Send();
              this.leftTime = null;
            }
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "bg", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "dailyBonusNode", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btnMenu", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "menuBadge", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btnQuest", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "questBadge", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "btnActivityCenter", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "btnLevelBonus", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "firstPurchase", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "vipNode", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "btnNewPlayerPack", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "labelNewPlayerPack", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "btnAdSpin", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "btnAdSpinNormal", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "activityLeft", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "activityRight", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "activityBadge", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "animAdSpin", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "btnLuckyDraw", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "btnSlotSymbolRank", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "labelSlotSymbolTimer", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class2.prototype, "timeBg", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class2.prototype, "labelRank", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class2.prototype, "labelLuckyDrawTime", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class2.prototype, "toRaidUser", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor26 = _applyDecoratedDescriptor(_class2.prototype, "btnServant", [_dec27], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor27 = _applyDecoratedDescriptor(_class2.prototype, "badge_servant", [_dec28], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitData.ts", ['cc', './global.ts', './MinigameTools.ts', './MinigameCoinhitGameplay.ts', './MinigameCoinhitMainWindow.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, G, MinigameTools, MinigameCoinhitGameplay, MinigameCoinhitMainWindow, Game;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      MinigameTools = module.default;
    }, function (module) {
      MinigameCoinhitGameplay = module.default;
    }, function (module) {
      MinigameCoinhitMainWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "10d39tQdU1IjoxkO4ODYABJ", "MinigameCoinhitData", undefined);

      const C = {
        TICKET_ITEM_ID: 4 // 门票的item-id

      };
      /**
       * minigame-coinhit-数据管理类
       * - 包含小游戏下的所有数据
       */

      class MinigameCoinhitData {
        constructor() {
          _defineProperty(this, "activityMetaId", void 0);

          _defineProperty(this, "free_ticket_count", void 0);

          _defineProperty(this, "ticket_count", void 0);

          _defineProperty(this, "reward", void 0);

          _defineProperty(this, "score", void 0);
        }
        /**
         * 载入数据
         * @param {*} activityMetaId
         * @param {*} coin_base 
         * @param {*} spin_base 
         */


        load_data(activityMetaId, coin_base, spin_base) {
          // 数据的初始化
          this.activityMetaId = activityMetaId;
          this.free_ticket_count = 0;
          this.ticket_count = Game.SUserItems.getNum(C.TICKET_ITEM_ID);
          this.reward = {
            small_coin: [0, 0],
            big_coin: [0, 0],
            small_spin: [0, 0],
            big_spin: [0, 0],
            small_box: [0, 0],
            middle_box: [0, 0],
            big_box: [0, 0]
          };
          this.score = {
            base: 0,
            // 隐藏得分，用来计算
            round: 0,
            // 隐藏回合数，用来计算
            coin: 0,
            // coin的类型得分
            spin: 0 // spin的类型得分

          }; // 一些更新

          this.update_reward(coin_base, spin_base);
        }

        get_activity_meta_id() {
          return this.activityMetaId;
        }

        get_free_ticket_count() {
          let data = Game.SUserActivity.GetActivityData(this.activityMetaId);

          if (!data || !data.free_ticket) {
            return 1;
          }

          return 0;
        }

        get_ticket_count() {
          return Game.SUserItems.getNum(C.TICKET_ITEM_ID);
        }

        has_free_ticket_or_ticket() {
          return this.get_free_ticket_count() > 0 || this.get_ticket_count() > 0;
        }
        /** 根据传入的奖励base生成奖励;coin:[1,3,50,100,200];[1,3,10,20,50] */


        update_reward(coin_base, spin_base) {
          let coin = MinigameTools.number_fixed(coin_base / 60, -3);
          let spin = spin_base;
          this.reward.small_coin = [coin, 0];
          this.reward.big_coin = [coin * 3, 0];
          this.reward.small_spin = [0, spin];
          this.reward.big_spin = [0, spin * 3];
          this.reward.small_box = [coin * 80, spin * 15];
          this.reward.middle_box = [coin * 120, spin * 25];
          this.reward.big_box = [coin * 200, spin * 50];
        }
        /** 获取reward-coin的奖励分界线 */


        get_reward_coin_line() {
          return this.reward.small_coin[0];
        }
        /** 获取reward-spin的奖励分界线 */


        get_reward_spin_line() {
          return this.reward.small_spin[1];
        }
        /** 获取奖励;注意index的顺序同block-enum的顺序 */


        get_reward(index) {
          switch (index) {
            case 0:
              return this.reward.small_coin;

            case 1:
              return this.reward.big_coin;

            case 2:
              return this.reward.small_spin;

            case 3:
              return this.reward.big_spin;

            case 4:
              return this.reward.small_box;

            case 5:
              return this.reward.middle_box;

            case 6:
              return this.reward.big_box;

            default:
              return [0, 0];
          }
        }

        clean_score() {
          this.score.base = 0;
          this.score.round = 0;
          this.score.coin = 0;
          this.score.spin = 0;
          MinigameCoinhitMainWindow.ins.update_label_coin(this.score.coin);
          MinigameCoinhitMainWindow.ins.update_label_spin(this.score.spin);
          MinigameCoinhitMainWindow.ins.update_score(0);
        }

        get_score_base() {
          return this.score.base;
        }

        get_score_round() {
          return this.score.round;
        }

        get_score_coin() {
          return this.score.coin;
        }

        get_score_spin() {
          return this.score.spin;
        }
        /** 增加隐藏分 */


        add_score_base(v) {
          this.score.base += v;
        }
        /** 增加隐藏回合数;附带更新参数 */


        add_score_round(v) {
          this.score.round += v;
          MinigameCoinhitGameplay.ins.update_block_hit_count_base();
        }
        /** 
         * 增加coin分;包括0分判定,动画效果等
         * @param {number} v
         * @param {cc.Node} source_node
         */


        add_score_coin(v, source_node) {
          if (v <= 0) {
            return;
          }

          let index = v <= this.get_reward_coin_line() ? 0 : 1;
          MinigameCoinhitMainWindow.ins.anima_add_coin_or_spin(source_node, index).then(() => {
            this.score.coin += v;
            MinigameCoinhitMainWindow.ins.update_label_coin(this.score.coin);
          });
        }
        /** 
         * 增加spin分
         * @param {number} v
         * @param {cc.Node} source_node
         */


        add_score_spin(v, source_node) {
          if (v <= 0) {
            return;
          }

          let index = v <= this.get_reward_spin_line() ? 2 : 3;
          MinigameCoinhitMainWindow.ins.anima_add_coin_or_spin(source_node, index).then(() => {
            this.score.spin += v;
            MinigameCoinhitMainWindow.ins.update_label_spin(this.score.spin);
          });
        }
        /** 获取伪排行榜的user数据和对应的分数 */


        get_fake_list_with_score() {
          G.setSeed(this.get_activity_meta_id());
          let score_list = [24, 89, 265, 158, 979, 323, 846, 264, 338, 327, 950, 288, 419, 716, 939, 937, 510, 210, 106, 406];
          let rdid = 0;
          let rds = [];

          for (let i = 0; i < 20; i++) {
            rds.push(G.getSeededRandom(0, 1));
          }

          score_list.sort((a, b) => {
            rdid += 2;
            return rds[rdid % 20] - rds[(rdid + 1) % 20];
          });
          let map = MinigameTools.get_10_fake_user();
          let list = [];
          let ids = Object.keys(map);
          ids.derangedArray();

          for (let i = 0; i < ids.length; i++) {
            let id = ids[i];
            let d = map[id];
            let score = 701 + score_list[i] + G.getSeededRandomInt(-80, 80);
            list.push({
              score: score,
              userId: d.UserId(),
              name: d.Name(),
              avatar: d.Avatar(),
              isVip: d.IsVip()
            });
          }

          return list;
        }

      }

      exports('default', MinigameCoinhitData);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CoinAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, ParticleSystem2D, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      ParticleSystem2D = module.ParticleSystem2D;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "111d56+Xw5MxrHbmbCWNpQ+", "CoinAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CoinAnim = exports('default', ccclass(_class = (_temp = class CoinAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "completeCb", void 0);

          _defineProperty(this, "ps", void 0);

          _defineProperty(this, "ps2", void 0);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.completeCb = null;
          this.ps = this.getComponent(ParticleSystem2D); //TODO
          // this.ps.positionType = cc.ParticleSystem2D.PositionType.GROUPED

          this.ps.resetSystem();
          this.ps.stopSystem();

          if (this.node.children[0]) {
            this.ps2 = this.node.children[0].getComponent(ParticleSystem2D); //TODO
            // this.ps2.positionType = cc.ParticleSystem2D.PositionType.GROUPED

            this.ps2.resetSystem();
            this.ps2.stopSystem();
          }
        }

        start() {}

        play(x, y, delay, cb) {
          this.node.active = true;
          this.completeCb = cb;
          this.node.x = x;
          this.node.y = y;
          this.unscheduleAllCallbacks();
          this.scheduleOnce(() => {
            this.ps.resetSystem();
            if (this.ps2) this.ps2.resetSystem();
            this.scheduleOnce(() => {
              this.node.active = false;
            }, this.ps.duration + this.ps.life + this.ps.lifeVar);
            this.scheduleOnce(() => {
              if (this.completeCb != null) {
                this.completeCb();
              }
            }, this.ps.duration + this.ps.life - 0.7);
          }, delay);
        }

        stop() {
          this.node.active = true;
          this.unscheduleAllCallbacks();
          this.node.active = false;
        }

      }, _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ar.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "116a1nz3yNGXLmQGfaqNals", "ar", undefined);

      const C8235 = String.fromCharCode(8235);
      const C8236 = String.fromCharCode(8236);
      let ar = exports('ar', {
        APPNAME: "عملة الملوك",
        START: "البداية",
        Score: "أحرز هدفا",
        Restart: "أعاد التشغيل",
        Loading: "تحميل",
        Cancel: "إلغاء",
        Confirm: "تأكيد",
        Retry: "إعادة المحاولة",
        Back: "العودة",
        Accept: "قبول",
        Level: "مستوى",
        ScoreRank: "مرتبة",
        Rank: "مرتبة",
        ScorePoint: "نقطة",
        OK: "موافق",
        YES: "نعم",
        NO: "لا",
        Yes: "نعم",
        No: "لا",
        COLLECT: "كسب",
        facebookF: "فيس بوك",
        Congratulation: "مبروك",
        and: "ايضا",
        Reconnect: "إعادة الاتصال",
        OFF: "مغلق",
        MORE: "مزيد",
        multiplyx: "*",
        multiplyX: "*",
        PlayerDefaultName: "لاعب",
        PayDisable: "تم تعطيل الدفع!",
        PayEnabledAndroid: "يتم تمكين الدفع فقط على نظام الاندرويد " + C8236 + "!" + C8235,
        PayDisableIos: "لايتم تمكين الدفع على نظام iOS " + C8236 + "!" + C8235,
        PayDisableFBIn: "اسف",
        PaySuccess: "شكرا لشراؤك!",
        PayFail: "فشل في الشراء",
        PayPending: "عملية الشراء معلقة! بعد الانتهاء من الدفع ، أعد تشغيل اللعبة للحصول على العناصر.",
        PriceSymbol: "$",
        ShopOff: "%{0}\nمغلق",
        AdNotReady: "الفيديو غير جاهز!",
        wxUserinfoDenyTitle: "تحتاج الوصول",
        wxUserinfoDenyDes: "نحن بحاجة إلى المعلومات الخاصة بك",
        wxUserinfoDenyConfirm: "الذهاب الوصول",
        wxVersionNoSupport: "الوظيفة غير متوافقة حاليًا مع إصدار عميلك",
        ShareTitle: "مهلا ، هذه لعبة رائعة حقًا! لنلعب معا",
        ShareInviteNew: " مهلا ، هذه لعبة رائعة حقًا! لنلعب معا",
        ShareInviteSendSpin: "{0} فقط أعطيتك دور",
        ShareInviteSendCoins: "{0} فقط أعطيتك بعض العملات النقدية",
        ShareInviteFinishVillage: "أنا فقط بنيت مملكة جديدة! قم بالزيارة",
        ShareInviteRaid: "واوو! قمت فقط بسرقة {0} نقود معدنية ! رائع جدا",
        ShareInviteAttack: "واوو! أنا فقط أهاجم مملكة الآخرين! رائع جدا",
        ShareDialogTitle: "شارك",
        ShareInviteDialogTitle: "دعا",
        ShareChooseDialogTitle: "ارسل",
        ShareJigsawTitle: "أحتاج لهذه. قم بمساعدتي!",
        ShareSendCard: "{0} فقط أعطيتك بطاقات",
        ErrorRetry: "فشل الاتصال بالخدمة",
        ErrorLogin: "فشل الاتصال بالخدمة.",
        ErrorNormal: "فقدت الاتصال بالخدمة",
        ErrorMsg0: "نجاح",
        ErrorMsg1703: "فشل الشراء",
        loadResError: "فشل تحميل المورد. حاول مجددا؟",
        CountYear: "{0}سنوات",
        CountMonth: "{0}شهور",
        CountDay: "{0}أيام",
        CountHour: "{0}ساعات",
        CountMinute: "{0}دقائق",
        CountSecond: "{0}ثواني",
        FormatYear: "/",
        FormatMonth: "/",
        FormatDay: "",
        FormatHour: "：",
        FormatMinute: "：",
        FormatSecond: "",
        PastYear: "منذ {0} سنوات",
        PastMonth: "منذ {0} أشهر",
        PastDay: "منذ {0} أيام",
        PastHour: "منذ {0} ساعات",
        PastMinute: "منذ {0} دقيقة",
        PastSecond: "منذ {0} ثواني",
        PastZero: "الأن",
        SomeYear: "{0}سنوات",
        SomeMonth: "{0}شهر",
        SomeDay: "{0}يوم",
        SomeHour: "{0}ساعة",
        SomeMinute: "{0}دقيقة",
        SomeSecond: "{0}ثانية",
        SomeZero: "الأن",
        LoginWindowPlay: "لعب",
        LoginWindowGuest: "زائر",
        LoginWindowNeedUpdate: "هناك بعض التحديثات.",
        LoginWindowUpdating: "تحديث",
        ContentNameCoin: "عملات",
        ContentNameAp: "دوران",
        ContentNameShield: "درع",
        ContentNameCard: "بطاقة",
        ContentNameChest1: "صندوق خشبي",
        ContentNameChest2: "صندوق فضي",
        ContentNameChest3: "الصندوق الذهبي",
        ContentNameChest4: "!صندوق خشبي",
        ContentNamePack: "بنود",
        ContentNameJigsaw: "قطعة بانوراما",
        ContentNameActivityItemCommon: "بند",
        ContentNameActivityItem6: "المدفع",
        ContentNameUnknown: "؟؟؟",
        ChatSend: "ارسل",
        ApRecoverIn: "{0}يدور في{1}",
        AutoSpining: "تلقائي",
        ToRaidUserBet: "فوز *{0}",
        BetRibbonText: "فوز *{0}",
        Bet: "رهان",
        ApFull: "كامل",
        ApPlus: "+{0} دوران",
        Shield: "درع",
        Attack: "مهاجمة",
        Spins: "{0}+دوران",
        Raid: "مداهمة",
        SlotSymbol1: "صودا",
        Help_sign: "　1. يمكنك الحصول على مكافأ\nة تسجيل شهرية كل سبعة \n أيام في الشهر　" + C8236 + "\n" + C8235 + " 2. سيتم تحديث العلامة\nالشهرية في الشهر القادم   " + C8236 + "\n" + C8235 + "　3. يمكنك الحصول على\nمكافأة تسجيل أسبوعية   \nكل يوم خلال أسبوع   " + C8236 + "\n" + C8235 + " 4. سوف يتم تحديث العلامة\nالأسبوعية في الأسبوع القادم    ",
        Help_jigsaw: "1. اجمع 9 قطع ثم واحصل على\nمكافآت　" + C8236 + "\n" + C8235 + " 2. يتم جمع القطع في فتحات\nوتطورها　" + C8236 + "\n" + C8235 + "3. سيتم مسح القطع  عندما\nينتهي النشاط　" + C8236 + "\n" + C8235 + "4. يمكن استبدال بانوراما\nعالمية بأي قطعة  ",
        Help_coinhit: "1. أنفق تذكرة واحدة  لدخول\nاللعبة  " + C8236 + "\n" + C8235 + "  2. يمكنك الحصول على الكثير\nمن العملات المعدنية　\nودوران في التحدي  　" + C8236 + "\n" + C8235 + "  3. كسر المزيد من المربعات\nلك  ",
        SlotCoin6Video: "شاهد مقطع فيديو واحصل على عملات *2",
        DailyBonusNormalSpinBtn: "تدور مجانا",
        DailyBonusGoldSpinBtn: "تدور لـ {0}",
        DailyBonusFreeSpinDes: "1 تدور مجاني في\n{0}",
        Now10XBetter: "أفضل عشر مرات!",
        DailyBonusCollect: "كسب",
        DailyBonusLevel: "مستوى {0}",
        DailyBonusGoldFirst: "ما لا يقل عن 25 مليون قطعة نقدية لأول مرة" + C8236 + "!!!" + C8235,
        VillageShopTitle: "تطورالمملكة",
        VillageShopBuy: "يشترى",
        VillageShopFix: "حل",
        VillageShopComplete: "اكتمال!",
        NotEnoughCoinDes: "لا توجد لديك عملات؟",
        NotEnoughApDes: "لا توجد لديك دوران؟",
        NotEnoughApAdd: "+{0} دوران",
        NotEnoughApWait: "أو انتظر {1} لـ {0} يدور",
        NotEnoughApWait2: "انتظر {1} لـ {0} يدور",
        NotEnoughOff: "%{0}\nمزيد",
        menu_title: " قائمة طعام　",
        menu_0_play: "  لعب　",
        menu_1_village: "مملكة　",
        menu_2_buy: " متجر　",
        menu_3_daily: " مكافأت يومية　",
        menu_4_shop: "تطورالمملكة",
        menu_5_news: "  رسائل　",
        menu_6_gifts: "  هدايا　",
        menu_7_card: " بطاقة　",
        menu_8_map: "  خريطة　",
        menu_9_leaderboard: " المتصدرين　",
        menu_10_invite: " دعا　",
        menu_11_setting: "  الأعدادت　",
        setting_title: "الأعدادت",
        setting_sound: "الصوت",
        setting_music: "الموسيقى",
        setting_notifications: "إخطارات",
        setting_raid: "المداهمة & الهجوم",
        setting_general: "عام",
        setting_language: "اللغة",
        setting_english: "إنجليزي",
        setting_likeus: "مثلنا ولا تفوتها\nأحداث وهدايا مذهلة",
        setting_like: "مثل",
        setting_tutorial: "الدورة التعليمية",
        setting_support: "الدعم",
        setting_privacy: "سياسة خاصة",
        setting_terms: "البنود و الظروف",
        setting_uuid: "",
        setting_language_title: "اللغة",
        setting_language_en: "English",
        setting_language_zh: "中文",
        setting_language_es: "Español",
        setting_language_de: "Deutsch",
        invite_title: "تريد المزيد من الدوران؟",
        invite_addnumber_type0: "+{0}",
        invite_lineA: "<color=#97511E>  　ادع الأصدقاء واحصل على" + C8236 + "\n" + C8235 + "<color=#ffffff> <outline color=#6F3A14 width=3> {0} دوران مجانية </outline> </color>" + C8236 + "\n" + C8235 + "لكل صديق إلغاء تأمين المملكة 2!   </color>",
        invite_lineApp: "<color=#97511E>  　ادع الأصدقاء واحصل على" + C8236 + "\n" + C8235 + "<color=#ffffff> <outline color=#6F3A14 width=3> {0} دوران مجانية </outline> </color>" + C8236 + "\n" + C8235 + "لكل صديق يدخل اللعبة!   </color>",
        invite_invite: "دعا",
        invite_note: "* ستحصل على مكافأة بعد قيام صديقك\nبالربط عبر الفيس بوك",
        BindFacebookTitle: "الربط بالفيس بوك",
        BindFacebookBtn: "الاتصال",
        BindFacebookTip: "نحن لن ننشر نيابة عنك",
        BindFacebookFreespin: "قم بتسجيل الدخول والحصول على دوران مجانية",
        GuestConfirmTitle: "هل انت متأكد؟",
        GuestConfirmDes: "لا يمكن للضيوف اللعب مع الأصدقاء",
        GuestConfirmGuest: "اللعب كضيف",
        LeaderBoardWindowTabFriends: "الأصدقاء",
        LeaderBoardWindowTabCountry: "الدولة",
        LeaderBoardWindowTabGlobal: "عالمي",
        InteractionBet: "الحصول*{0}",
        InteractionAttackName: "مملكة {0}",
        InteractionAttackRevenge: "انتقام",
        InteractionAttackFriends: "اصحاب",
        InteractionAttackResultBlock: "<outline color=#6D4722 width=2>{0}  منع الهجوم الخاص بك. لقد فزت {1}</outline>",
        InteractionAttackResultSuccess: "<outline color=#6D4722 width=2> لقد هاجمت {0} مملكة وفزت {1}</outline>",
        InteractionAttackResultBlock2: "<outline color=#6D4722 width=2> لقد هاجمت مملكة {0} وفزت {1}</outline>",
        InteractionAttackResultSuccess2: "<outline color=#6D4722 width=2> لقد هاجمت مملكة {0} وفزت {1}</outline>",
        InteractionRaidCoinMaster: "ملك",
        InteractionRaidName: "كنز  {0}:",
        InteractionRaidStole: "سرق:",
        InteractionRaidResultLine: "<outline color=#6D4722 width=2>      لقد سرقت {0} عملات من {1}</outline>",
        InteractionRaidResultLine2: "<outline color=#6D4722 width=2>      لقد سرقت {0} عملات من {1}</outline>",
        InteractionRaidPrefect: "مداهمة ممتازة!",
        InteractionRaidBrag: "شارك",
        InteractionRaidEmpty: "فشل",
        gifts_title: "هدايا",
        gifts_tab0: "دوران مجانية",
        gifts_tab1: "عملات مجانية",
        gifts_tab2: "بطاقات",
        gifts_invite: "دعا",
        gifts_send: "ارسل",
        gifts_collect: "كسب",
        gifts_note: "",
        gifts_collect_all: "كسب / إرسال الكل",
        gifts_collect_all2: "كسب الكل",
        gifts_default_name: "ادع اصدقائك",
        gifts_default_explain: "الحصول على دوران مجانية",
        gifts_collect_spins: "كسبت دوران يومية{0} / {1}",
        gifts_collect_coins: "كسبت عملات يومية {0} / {1}",
        gifts_explain_spin_send: "هدية دوران مجانية",
        gifts_explain_spin_collect: "إرسل اليك {0} دوران",
        gifts_explain_coin_send: "هدية عملات مجانية",
        gifts_explain_coin_collect: "إرسل اليك {0} عملات",
        gifts_explain_card_send: "إرسال بطاقات\nلأصدقائك",
        gifts_explain_card_collect: "أرسل لك بطاقة",
        gifts_explain_card_cantcollect: "يجب أن تصل إلى المملكة {0} لاستلام هذه البطاقة",
        ShopTitle: "متجر",
        ShopSpins: "دوران",
        ShopCoins: "عملات",
        ShopChests: "صناديق",
        ShopTreats: "هدايا صغيرة",
        ShopSpinNum: "{0}",
        ShopAddPercent: "%{0} \nاكثر",
        ShopSpinPrice: "$ {0}",
        ShopCoinPrice: "$ {0}",
        ShopTreatFoodTime: "تفعيل {0}ساعة",
        CoinStore: "متجر عملات",
        CoinShopLevel: "مستوى {0}",
        OffText: "%{0}\nمزيد",
        SaleMark: "تخفيض السعر",
        ShopChestDisable: "إفتح الصناديق في المملكة {0}",
        ShopTreatDisable: "فتح الهدايا الصغيرة في المملكة {0}",
        ShopPopular: "شائع",
        ShopBestValue: "القيمة الأفضل",
        village_news_title: "رسائل",
        village_news_log_hammer: "<color=#662C1C>　{0} تم مهاجمة مملكتك </color>",
        village_news_log_shield: "<color=#662C1C>　{0} فشل في مهاجمة مملكتك </color>",
        village_news_log_pig: "<color=#662C1C>　{0} سرق {1} منك </color>",
        village_news_log_invite: "<color=#662C1C>　{0} انضم إلى  عملة الملوك </color>",
        village_news_log_noraid: "<color=#662C1C>　{0} فشل في سرقتك {1} منك </color>",
        village_news_fox: "",
        village_news_tiger: "",
        village_news_rhino: "",
        village_news_tab1: "مملكة",
        village_news_tab2: "بريد",
        village_news_expire: "انتهى في {0}",
        map_title: "{0}. {1}",
        map_comming_soon: "يأتي قريبا",
        revenge_title_revenge: "انتقام!",
        revenge_title_attack: "هاجم صديقك!",
        revenge_random: "عشوائية",
        revenge_revenge: "انتقام",
        revenge_attack: "مهاجمة",
        watch_get: "شاهد فيديو واحصل على",
        watch_spin: "+{0} يدور",
        watch_coin: "+{0} عملات",
        watch_watch: "راقب",
        VillageCompleteTitle: "المملكة ناضجة!",
        VillageCompleteNext: "التالي",
        NewUserInvitedTitle: "صديق المكافأة",
        NewUserInvitedDes: "{0} تم إلغاء قفل مملكة جديدة! لقد حصلت على {1} دوران مجانية",
        NewUserInvitedDesApp: "{0} انضم إلى اللعبة! لقد حصلت على {1} دوران مجانية",
        TutorialDialogStar: "رفع مستوى بعض العناصر ،ثم ستحصل على نجمة واحدة\n\nجمع 25 نجمة لإلغاء قفل المملكة التالية",
        TutorialDialogGoSpin: "ليس لديك ما يكفي من عملات\n\n يمكنك السحب للاسفل لكسب المزيد من عملات",
        TutorialDialogDoSpin: "استخدم ماكينة القمار لتدوير",
        TutorialDialogSlotAttack: "قم بمهاجمة ممالك اللاعبين الآخرين للحصول على عملات",
        TutorialDialogSlotShield: "سوف تقوم الدروع بحماية مملكتك من الهجمات",
        TutorialDialogSlotRaid: "مداهمة مملكة الملك وسرقة عملاته المعدنية",
        TutorialDialogSlotRaidMaster: "هذا هو الملك \n دعنا نداهمة",
        TutorialStartTitle: "المملكة الأولى الخاصة بك",
        TutorialStartDes: "مرحبًا بك يا صديقي \n\n اضغط على الزر لبدء عملك",
        TutorialTargetName: "استهداف",
        TutorialFinishTitle: "نجاح!",
        TutorialFinishDes0: "المكافآت الخاصة بك:",
        TutorialFinishDes1: "60 دوره!",
        TutorialFinishDes1bind: "20 دوره!",
        TutorialFinishDes2: "مليون عملة معدنية!",
        TutorialFinishDes3: "حفظ التقدم!",
        TutorialFinishDes4: "اللعب مع أصدقائك!",
        TutorialTargetName1: "ليلى",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetName2: "ماريا",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetName3: "كيفن",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        AutoSpinTipWindowTitle: "دوران تلقائية",
        AutoSpinTipWindowDes: "اضغط على الزر للبدء",
        AutoSpinTipWindowButton: "حاول!",
        ActivitySpecialOfferTitle: "عرض مفاجئ",
        ActivityTimeleft: "الوقت المتبقي",
        ActivitySpecialOfferCoin: "{0} عملات",
        ActivitySpecialOfferSpin: "{0} دوره",
        ActivityShopDes: "وقت المتبقي {0}",
        ActivityAttackMasterDes: "هاجم {0} مرات للحصول على \n{1} عملات",
        ActivityAttackMasterDesMore: "<color=#562900> والمزيد من الأشرطة التي تكملها",
        ActivityAttackMasterFinal1: "جائزة شريط النهائية:",
        ActivityAttackMasterFinal2: "{0} عملات!",
        ActivityAttackMasterButtonTip: "الرهان أعلى والحصول عليها بشكل أسرع!",
        ActivityAttackMasterButton: "تم الحصول عليها!",
        ActivityAttackMasterTimeleft: "ينتهي في {0}",
        ActivityRaidMasterDes: "مداهمة {0} مرات للحصول على \n{1} عملات",
        ActivityBuildKingDes: "قم بإكمالها للحصول على مكافآت!",
        ActivitySlotCollectDes1: "مهاجمة",
        ActivitySlotCollectDes2: "تم حظر الهجوم",
        ActivitySlotCollectDes3: "مداهمة",
        ActivitySlotCollectDes4: "مداهمة ممتازة",
        ActivitySlotCollectDes5: "ضرب 3 رموز",
        GetRewardWindowDes: "<outline color=#333333 width=2><color=#ffffff>تم حصولك على مكافآت" + C8236 + "\n" + C8235 + "{0}!</color></outline>",
        CardAllSetWindowTitle: "بطاقة\nجمع",
        CardAllSetWindowCompleted: "مكتمل",
        CardAllSetWindowLock: "الغاء التامين في\nالمملكة {0}",
        CardAllSetWindowBottom: "- عملة الملوك -",
        CardSingleSetWindowTip: "* اضغط على بطاقة مكررة لإرسالها إلى صديق",
        CardSingleSetWindowCompleted: "- مجموعة كاملة -",
        CardSingleSetWindowReward: "أكمل المجموعة للفوز",
        CardAsk: "إسأل",
        CardSend: "ارسل",
        CardAskCannot: "لا يمكن طلبها من الأصدقاء",
        CardAskCannotGolden: "هذه البطاقة ذهبية",
        CardSendCannot: "لا يمكن إرسالها إلى الأصدقاء",
        CardSendCannotGolden: "هذه البطاقة ذهبية",
        CardSendCannotLimit: "لقد وصلت إلى الحد اليومي للبطاقات التي يمكنك إرسالها",
        CardSendCannotLeast: "تحتاج إلى أكثر من بطاقة واحدة لإرسالها",
        CardCollectTitle: "رائع!",
        CardCollectDes: "تمت إضافة البطاقة {0} إلى ألبومك",
        CardCollectButton: "تحقق من ذلك",
        CardSelectFriendWindowTitle: "إرسال البطاقات",
        CardSelectFriendWindowInfo: "اختر صديق واحد!",
        CardSelectFriendWindowBtn: "اختر البطاقة",
        CardSelectCardWindowTitle: "إرسال البطاقات",
        CardSelectCardWindowInfo: "اختر ما يصل إلى {0} بطاقات!",
        CardSelectCardWindowSelected: "البطاقات التي اخترتها:",
        CardSelectCardWindowSuccess: "تم نجاح إرسال البطاقة!",
        CardInfoWindowTitle: "　معلومات البطاقات　",
        CardInfoWindowPage0_0: "　جمع البطاقات من خلال الصناديق　",
        CardInfoWindowPage0_1: "　يمكنك أيضا شراء الصناديق في المتجر　",
        CardInfoWindowPage0_2: "　يمكن العثور على الصناديق أثناء المداهمات وعند إلغاء تأمين مملكة جديدة　",
        CardInfoWindowPage1_0: "　يتيح لك امتلاك 2 أو أكثر من نفس البطاقة إرسالها كهدية إلى أصدقائك　",
        CardInfoWindowPage1_1: "　اضغط على البطاقة لتقديمها　",
        CardInfoWindowPage1_2: "　يمكنك أيضا أن تسأل أصدقائك عن البطاقات المفقودة　",
        CardInfoWindowPage1_3: "　يمكنك إرسال ما يصل إلى 5 بطاقات في يوم واحد　",
        CardInfoWindowPage2_0: "　تشير النجوم الى بطاقات النادرة　",
        CardInfoWindowPage2_2: "　يمنحك كل نجم نادر على بطاقة جديدة تم جمعها نجمة واحدة　",
        CardInfoWindowPage2_3: "　أكمل مجموعات البطاقات واحصل على مكافآت مذهلة!　",
        CardInfoWindowCommon: "شائع",
        CardInfoWindowRare: "نادر",
        CardChestInfoWindowTitle_1: "صندوق خشبي",
        CardChestInfoWindowTitle_2: "صندوق فضي",
        CardChestInfoWindowTitle_3: "الصندوق الذهبي",
        CardChestInfoWindowHigh: "فرصة عالية ل:",
        CardChestOpenWindowNew: "جديد",
        CardOpenDes: "<color=#ffffff>　جمع البطاقات للحصول على　\n<color=#ffe615>　عملات　</color> و <color=#0ce4fe>　دوران </color></color>",
        CardOpenDesS: "<color=#308ae6>　جمع البطاقات للحصول على　\n<color=#e67b07>　عملات　</color> و <color=#006fd7>　دوران </color></color>",
        FriendsModelPlaceHolder: "بحث بأسم الصديق",
        FriendsModelNoResult: "لا يوجد أصدقاء",
        ExtraRewardDes: "عملة الملوك قد وهبت لك عملات ودوران",
        quest_center_window_title: "مركز البحث",
        quest_center_window_refresh_dialog: "المهام هي تحدث في يوم جديد",
        quest_center_window_daily: "يوميا",
        quest_center_window_invite: "دعا",
        quest_center_window_check: "إشارة",
        quest_center_window_month_box_7: "7 أيام",
        quest_center_window_month_box_14: "14 أيام",
        quest_center_window_month_box_21: "21 أيام",
        quest_center_window_month_box_28: "28 أيام",
        quest_center_window_day_1: "يوم 1",
        quest_center_window_day_2: "يوم 2",
        quest_center_window_day_3: "يوم 3",
        quest_center_window_day_4: "يوم 4",
        quest_center_window_day_5: "يوم 5",
        quest_center_window_day_6: "يوم 6",
        quest_center_window_day_7: "يوم 7",
        quest_center_window_check_do: "إشارة",
        quest_center_window_check_done: "وقعت",
        quest_center_window_main_quest_name: "البحث الرئيسي: {0}",
        quest_center_window_main_quest_goal_reward: "هدف: {0} \n المكافأة: {1}",
        quest_center_window_daily_get: "كسب",
        quest_center_window_daily_go: "اذهب",
        quest_center_window_refreshin: "تحديث في",
        ActivityCenterTitle: "مركز نشاط",
        ActivityCenterTime: "الوقت المتبقي : {0}",
        ActivityCenterTimeEnd: "انتهى التعفيل",
        jigsaw_window_title: "بانوراما",
        jigsaw_window_use: "إستخدام",
        jigsaw_window_used: "المستخدم",
        jigsaw_window_send: "ارسل",
        jigsaw_window_complete: "املء الكل",
        jigsaw_window_universal_tip: "اختيار قطعة واحدة للأستبدال",
        jigsaw_friends_window_title: "اصحاب",
        jigsaw_friends_window_send: "ارسل",
        jigsaw_friends_window_no_friends: "لا يوجد أصدقاء",
        jigsaw_friends_window_search_pre: "بحث بأسم الصديق",
        jigsaw_news_window_title: "أخبار",
        jigsaw_news_window_news_send: "<color=#F48B03> {0} </color><color=#7E4B27> يمكنك إرسال </color>\n<color=#19B8B2> {1} </color><color=#7E4B27> القطعة </color>",
        jigsaw_news_window_news_collect: "<color=#19B8B2>{1}</color><color=#7E4B27> أرسل لك القطعة </color><color=#F48B03> {0} </color>",
        jigsaw_news_window_no_news: "لا توجد أخبار.",
        GameMainWindowQuest: " البحث",
        GameMainWindowActivity: "نشاط",
        NotificationTitleApFull: "لديك دوران كاملة!",
        NotificationDesApFull: "لدينا ما يكفي من الدوران للعب والحصول على المزيد من عملات!",
        NotificationTitleDailyBonus: "المكافأة اليومية متاحة الآن!",
        NotificationDesDailyBonus: "تعال والعب يوميا عجلة الحظ!",
        NotificationTitleAttack: "دعونا ننتقم!",
        NotificationDesAttack: "لقد غزا شخص ما مملكتك!",
        NotificationTitleActivity: "النشاط سوف ينتهي!",
        NotificationDesActivity: "{0} سينتهي خلال ساعة!",
        NotificationTitleBack: "لم أرك منذ وقت طويل!",
        NotificationDesBack: "نحن على استعداد هدية كبيرة بالنسبة لك!",
        NotificationTitleBack2: "تعال والعب معي!",
        NotificationDesBack2: "عد! نحن على استعداد هدية كبيرة بالنسبة لك!",
        minigame_start_game: "البداية",
        minigame_gameover: "انتهت اللعبة!",
        minigame_time: "ينتهي في {0}",
        mini_game_fail: "فشل تحميل اللعبة",
        mini_game_end: "انتهى اللعب",
        mini_game_rank_window_title: "تصنيف",
        mini_game_rank_window_no_ranks: "لا توجد صفوف",
        minigame_buy_ticket_window_title: "المزيد من التذاكر؟",
        minigame_coinhit_title: "ضرب & ربح",
        minigame_coinhit_second_title: "ضبط زاوية اطلاق النار لكسر المزيد من القطع والحصول على مكافآت كبيرة!",
        mini_game_coinhit_info: "رحلة كبيرة للفوز \n عملات",
        mini_game_coinhit_time: "ينتهي في {0}",
        mini_game_coinhit_go: "اذهب!",
        mini_game_coinhit_info_title: "قائمة المكافآت",
        mini_game_coinhit_manual_next_round: "لعبة عالقة؟ نعم للذهاب إلى الجولة التالية",
        mini_game_coinhit_btn_next_round: "الجولة التالية",
        mini_game_coinhit_manual_end: "نعم للحصول على مكافأة الآن! الحصول على عملة {0}",
        mini_game_coinhit_btn_end: "الحصول على مكافأة",
        mini_game_coinhit_rank_info: "كتلة عدد مرات الدخول: {0}",
        AppUpdateTitle: "تحديث جديد",
        AppUpdateDes: "هناك نسخة جديدة متاحة! تحديث الان!",
        AppUpdateBtn: "تحديث",
        AppUpdateNo: "لا",
        AppCommentTitle: "تحب عملات الملوك؟",
        AppCommentDes: "يرجى تقييم لنا 5 نجوم لتقديم المزيد من التحديثات",
        AppCommentBtn: "قيم الآن",
        AppCommentNo: "لا",
        AppHotUpdateFail: "فشل تحميل المورد. حاول مجددا؟",
        FirstPurchaseButton: "اذهب!",
        FirstPurchaseDes1: "إجعل أي شراء ل",
        FirstPurchaseDes2: "الحصول على مكافآت اضافية!",
        NewPlayerPackButton: "قم بألشراء الأن!",
        NewPlayerPackDes1: "مرحبا بكم في عملة الملوك!",
        NewPlayerPackDes2: "<outline color=#471F01 width=2> لقد أعددنا اكبر هدية لك ~ </outline>",
        ServantUpgrade: "تطوير",
        ServantSelect: "تحديد",
        ServantEffectDes1: "مكافأة زيادة المداهمة",
        ServantEffectNum1: "● تزيد المكافأة بواسطة: {0}%",
        ServantEffectDes2: "مكافأة زيادة الهجوم",
        ServantEffectNum2: "● تزيد المكافأة بواسطة: {0}%",
        ServantEffectDes3: "يحمي من الهجمات",
        ServantEffectNum3: "● فرصة الحماية: {0}%",
        ServantEffectDes4: "يحمي من المداهمات",
        ServantEffectNum4: "● فرصة الحماية: {0}%",
        ServantNextLevel: "المرحلة التالية: {0}% +",
        ServantName1: "بيجي",
        ServantName2: "بيلي",
        ServantName3: "دوج",
        ServantName4: "ياقوت",
        ServantOpenDes: "<color=#ffffff> استأجر الخدم للحصول على\n<color=#ffe615> عملات </color> و <color=#0ce4fe> يدور </color></color>",
        ServantOpenDesS: "<color=#308ae6> استأجر الخدم للحصول على\n<color=#e67b07> عملات </color> و <color=#006fd7> يدور </color></color>",
        ServantInfo1: "تطوير:",
        ServantInfo2: "تدور كل فتحة آلة = تجربة الخدم الواحدة\nيمكنك استخدام الجرع للحصول على المزيد من تجربة الخدم\nعندما يكون شريط تجربة الخدم ممتلئًا ، انقر فوق زر الترقية لترقيتك الخدم\nكل ترقية الخدم ستزيد نجم اللعبة",
        ServantInfo3: "المهارة:",
        ServantInfo4: "تتحسن مهارة الخدم مع كل مستوى ترقية",
        ServantInfo5: "التفعيل:",
        ServantInfo6: "إطعام الخدم لتنشيطه. الحصول الخدم الغذاء خادم أثناء الدوران والبناء",
        MultiplePurchaseDes1: "دورها للفوز حتى",
        MultiplePurchaseDes2: "10x",
        MultiplePurchaseDes3: "للحصول على الإضافة {0}",
        SlotPeterDesAd: "لدي هدية لك",
        PeterOpenDes1: "سوف الببغاء بيتر تجلب لك هدية عشوائية",
        PeterOpenDes2: "فقط لمس بيتر واحصل على هدية عندما يتعلق الأمر",
        adShieldTip: "Get free shield!",
        slotServantAdTip: "Feed me food!",
        heist_main_window_free: "مجانا",
        heist_main_window_title: "خذ كل صفقة لمزيد من الكشف",
        heist_main_window_cannot_buy: "Unlock by purchasing previous deal",
        SlotBetNewMax: "Bet limit increased",
        SlotBetSuper: "SUPER"
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ServantWindow.ts", ['cc', './Constant.ts', './global.ts', './EnterCloseAnim.ts', './SoundManager.ts', './UIWindow.ts', './ResourceLoader.ts', './ChangeSceneManager.ts', './ContainerServant.ts', './FullLoadingWindow.ts', './SR.ts', './ShopWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, ProgressBar, sp, Animation, _decorator, instantiate, tween, MyCustomEvent, G, EnterCloseAnim, SoundManager, UIWindow, ResourceLoader, ChangeSceneManager, ContainerServant, FullLoadingWindow, SR, ShopWindow, UIRoot, Game, Meta, LogEventWrap, ADWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
      sp = module.sp;
      Animation = module.Animation;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      tween = module.tween;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      ContainerServant = module.default;
    }, function (module) {
      FullLoadingWindow = module.FullLoadingWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _dec27, _dec28, _dec29, _dec30, _dec31, _dec32, _dec33, _dec34, _dec35, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _descriptor26, _descriptor27, _descriptor28, _descriptor29, _descriptor30, _descriptor31, _descriptor32, _descriptor33, _descriptor34, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "11b555tl6xGfogcLHWolpyP", "ServantWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const servantExpItemId = 2;
      const servantFoodItemId = 3;
      let ServantWindow = exports('ServantWindow', (_dec = ccclass("ServantWindow"), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Label), _dec5 = property(ProgressBar), _dec6 = property(Label), _dec7 = property(Label), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Label), _dec12 = property(Node), _dec13 = property(Label), _dec14 = property(Label), _dec15 = property(Label), _dec16 = property(Label), _dec17 = property(Node), _dec18 = property(Label), _dec19 = property(Node), _dec20 = property(Node), _dec21 = property(Node), _dec22 = property(Label), _dec23 = property(EnterCloseAnim), _dec24 = property(Node), _dec25 = property(Label), _dec26 = property(Node), _dec27 = property(Label), _dec28 = property(Node), _dec29 = property(sp.Skeleton), _dec30 = property(Animation), _dec31 = property(Animation), _dec32 = property(Animation), _dec33 = property(ContainerServant), _dec34 = property(Node), _dec35 = property(Label), _dec(_class = (_class2 = (_temp = _class3 = class ServantWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spPrefabParent", _descriptor, this);

          _initializerDefineProperty(this, "spTouchArea", _descriptor2, this);

          _initializerDefineProperty(this, "labelName", _descriptor3, this);

          _initializerDefineProperty(this, "progressExp", _descriptor4, this);

          _initializerDefineProperty(this, "labelExp", _descriptor5, this);

          _initializerDefineProperty(this, "labelLevel", _descriptor6, this);

          _initializerDefineProperty(this, "iconLock", _descriptor7, this);

          _initializerDefineProperty(this, "btnUpgrade", _descriptor8, this);

          _initializerDefineProperty(this, "iconTime", _descriptor9, this);

          _initializerDefineProperty(this, "labelTime", _descriptor10, this);

          _initializerDefineProperty(this, "spBubble", _descriptor11, this);

          _initializerDefineProperty(this, "labelEffect", _descriptor12, this);

          _initializerDefineProperty(this, "labelEffectNumTitle", _descriptor13, this);

          _initializerDefineProperty(this, "labelEffectNum", _descriptor14, this);

          _initializerDefineProperty(this, "labelEffectNextLevel", _descriptor15, this);

          _initializerDefineProperty(this, "spNextLevelStar", _descriptor16, this);

          _initializerDefineProperty(this, "labelNextLevelStar", _descriptor17, this);

          _initializerDefineProperty(this, "btnSelect", _descriptor18, this);

          _initializerDefineProperty(this, "spSelected", _descriptor19, this);

          _initializerDefineProperty(this, "btnBuy", _descriptor20, this);

          _initializerDefineProperty(this, "labelBuyPrice", _descriptor21, this);

          _initializerDefineProperty(this, "spInfo", _descriptor22, this);

          _initializerDefineProperty(this, "btnFeed", _descriptor23, this);

          _initializerDefineProperty(this, "labelFeedNum", _descriptor24, this);

          _initializerDefineProperty(this, "btnExp", _descriptor25, this);

          _initializerDefineProperty(this, "labelExpNum", _descriptor26, this);

          _initializerDefineProperty(this, "btnFeedWatch", _descriptor27, this);

          _initializerDefineProperty(this, "animFx", _descriptor28, this);

          _initializerDefineProperty(this, "animFeed", _descriptor29, this);

          _initializerDefineProperty(this, "animFeedFree", _descriptor30, this);

          _initializerDefineProperty(this, "animExp", _descriptor31, this);

          _initializerDefineProperty(this, "containerServant", _descriptor32, this);

          _initializerDefineProperty(this, "loadingNode", _descriptor33, this);

          _initializerDefineProperty(this, "loadingLabel", _descriptor34, this);

          _defineProperty(this, "selectId", void 0);

          _defineProperty(this, "currentId", void 0);

          _defineProperty(this, "curPet", void 0);

          _defineProperty(this, "remainTime", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);

          _defineProperty(this, "pressed", void 0);

          _defineProperty(this, "pressPos", void 0);

          _defineProperty(this, "pressPosStart", void 0);

          _defineProperty(this, "SUserServant", void 0);

          _defineProperty(this, "isLoadingPet", false);
        }

        static Show() {
          ChangeSceneManager.instance.show(async () => {
            let resPath = "pet3d/pet3d";
            await ResourceLoader.loadCommonPrefab(resPath, true);
            await ResourceLoader.loadSceneConfig(resPath, true); // await ResourceLoader.loadAllPetPrefabs();

            UIRoot.instance.openChildWindow(ServantWindow, {
              showCallback: () => {
                ChangeSceneManager.instance.hide();
              }
            });
          });
        }

        onShow(showParams) {
          ServantWindow.instance = this;
          this.SUserServant = Game.SUserServant;
          this.spInfo.node.active = true; // init data

          this.selectId = +this.SUserServant.GetSelected();
          if (!this.selectId) this.selectId = 1;
          this.currentId = this.selectId; // this.containerServant.initPet(this.selectId);
          // add touch event

          this.spTouchArea.on(Node.EventType.TOUCH_START, this.gameTouchStart, this);
          this.spTouchArea.on(Node.EventType.TOUCH_MOVE, this.gameTouchMove, this);
          this.spTouchArea.on(Node.EventType.TOUCH_END, this.gameTouchEnd, this);
          this.spTouchArea.on(Node.EventType.TOUCH_CANCEL, this.gameTouchCancel, this); // 设定物品数量

          this.setItems();
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "ServantWindow", function (data) {
            this.setItems();
          }.bind(this)); // 显示UI

          this.setCurrent();
          this.spInfo.closeAnim();
          this.init3d(this.selectId);
        }

        async init3d(id) {
          let resPath = "pet3d/pet3d";
          let vPre = await ResourceLoader.loadCommonPrefab(resPath, true);
          let scene = await ResourceLoader.loadSceneConfig(resPath, true);
          let petNode = instantiate(vPre);
          this.containerServant.node.destroyAllChildren();
          this.containerServant.node.addChild(petNode);
          this.containerServant.init(petNode, scene.globals);
          this.containerServant.initPet(id);
          eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "pet");
        }

        onClose() {
          ServantWindow.instance = null;
          this.spTouchArea.off(Node.EventType.TOUCH_START, this.gameTouchStart, this);
          this.spTouchArea.off(Node.EventType.TOUCH_MOVE, this.gameTouchMove, this);
          this.spTouchArea.off(Node.EventType.TOUCH_END, this.gameTouchEnd, this);
          this.spTouchArea.off(Node.EventType.TOUCH_CANCEL, this.gameTouchCancel, this);
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "ServantWindow");
          this.node.destroy();
        }

        slowUpdate(dt) {
          this.updateRemainTime(dt);
        } // 切换随从


        changeNode(toleft) {
          this.isLoadingPet = true; // let oldNode = this.currentNode;

          if (toleft) {
            this.containerServant.moveLeft(this.currentId);
          } else {
            this.containerServant.moveRight(this.currentId);
          }

          this.setCurrent();
          this.isLoadingPet = false;
        } ////////////////////////////
        // UI
        ///////////////////////////
        // 设置当前随从 UI


        setCurrent() {
          this.setState();
          this.setEffect();
        } // 设置状态


        setState() {
          this.labelName.string = i18n.t("ServantName" + this.currentId);
          this.setRank();
          this.setTime();
        } // 设置等级经验


        setRank() {
          let state = this.SUserServant.Servant(this.currentId);

          if (state == null) {
            this.progressExp.progress = 1;
            this.labelExp.string = "";
            this.labelLevel.string = "";
            this.iconLock.active = true;
            this.btnUpgrade.active = false;
            return;
          }

          let rank = state.rank;
          let exp = state.exp;
          let levelUpNeedExp = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, rank).Exp(this.currentId);
          this.progressExp.progress = Math.min(1, exp / levelUpNeedExp);
          this.labelExp.string = `${exp} / ${levelUpNeedExp}`;
          this.labelLevel.string = rank.toString();
          this.iconLock.active = false;
          this.btnUpgrade.active = exp >= levelUpNeedExp;
        } // 设置时间


        setTime() {
          let state = this.SUserServant.Servant(this.currentId);
          this.remainTime = null;

          if (state == null) {
            this.labelTime.string = "";
            this.iconTime.active = false;
            this.spBubble.active = false;
            return;
          }

          let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

          this.labelTime.string = GameKit.TimeUtil.FormatRemainTimeSimple(time, false, true);
          this.iconTime.active = true;
          this.spBubble.active = time <= 0;
          if (time > 0) this.remainTime = time;
        } // 更新时间


        updateRemainTime(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;

          if (this.remainTime) {
            this.remainTime -= dt;
            this.remainTime = Math.max(0, this.remainTime);
            this.iconTime.active = true;
            this.labelTime.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.remainTime, false, true);

            if (this.remainTime <= 0) {
              this.remainTime = null; // this.currentPet.playFallSleep();

              this.curPet.changeStateFromIdleToRest2(() => {// this.curPet.changeStateToRest2();
              });
            }
          }
        } // 设置效果


        setEffect() {
          this.labelEffect.string = i18n.t("ServantEffectDes" + this.currentId);
          let state = this.SUserServant.Servant(this.currentId);

          if (state == null) {
            this.btnBuy.active = true;
            this.btnFeed.parent.parent.active = false;
            this.labelBuyPrice.string = Meta.ShopMeta.GetByTypeIndex(Meta.ShopMeta.Types.Servant, this.currentId - 1).PriceString();
            this.labelEffectNumTitle.node.active = false;
            this.labelEffectNextLevel.node.parent.active = false;
            this.labelEffectNum.node.active = false;
            this.spNextLevelStar.active = false;
            this.btnSelect.active = false;
            this.spSelected.active = false;
            return;
          }

          let rank = state.rank;
          let meta = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, rank);
          let nextMeta = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, rank + 1);
          this.labelEffectNumTitle.node.active = true;
          this.labelEffectNum.node.active = true;
          this.labelEffectNextLevel.node.parent.active = true;
          this.spNextLevelStar.active = true;
          this.labelEffectNumTitle.string = String.format(i18n.t("ServantEffectNum" + this.currentId));
          this.labelEffectNum.string = String.format(meta.Effect(this.currentId)) + "%";
          this.labelEffectNextLevel.string = String.format(nextMeta.Effect(this.currentId)) + "%  +  ";
          this.labelNextLevelStar.string = "  " + nextMeta.Star(this.currentId).toString();
          this.setSelect();
          this.btnBuy.active = false;
          this.btnFeed.parent.parent.active = true;
        } // 设置选择状态


        setSelect() {
          this.btnSelect.active = this.selectId != this.currentId;
          this.spSelected.active = this.selectId == this.currentId;
        } // 设置物品数量


        setItems() {
          this.labelFeedNum.string = GameKit.StringUtil.formatNumber(Game.SUserItems.getNum(servantFoodItemId));
          this.labelExpNum.string = GameKit.StringUtil.formatNumber(Game.SUserItems.getNum(servantExpItemId));
        } //////////////////////////////////
        // Event
        //////////////////////////////////
        // 退出


        callClose() {
          FullLoadingWindow.Show(() => {
            // UIRoot.instance.openWindow("GameMainWindow", {
            // 	showCallback: () => {
            // 		homeView.EnterGame();
            // 		homeView.backToHomeView(() => {
            // 			FullLoadingWindow.Hide();
            // 		});
            // 	},
            // });
            this.closeAnim(() => {
              FullLoadingWindow.Hide();
            });
          });
        }

        goToShop(page, zone) {
          FullLoadingWindow.Show(() => {
            this.closeAnim(() => {
              FullLoadingWindow.Hide();
              homeView.pageViewController.moveToPage(G.Pages.Shop, true);
              setTimeout(() => {
                homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.treat);
              }, 100);
            });
          });
        } // 向左切换


        callLeft() {
          // if (this.isLoadingPet) return;
          this.currentId--;
          if (this.currentId <= 0) this.currentId += 4;
          this.changeNode(true); // this.containerServant.moveLeft(this.currentId);
        } // 向右切换


        callRight() {
          // if (this.isLoadingPet) return;
          this.currentId++;
          if (this.currentId > 4) this.currentId -= 4;
          this.changeNode(false); // this.containerServant.moveRight(this.currentId);
        } // 升级


        callUpgrade() {
          let req = SR.SRServant.servantLevelUp(this.currentId);
          req.SetCallBack(res => {
            this.SUserServant = Game.SUserServant;
            this.setRank();
            this.setEffect();
            let state = this.SUserServant.Servant(this.currentId);

            let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

            if (time > 0 && this.currentId == this.selectId) {
              // this.currentPet.playLevelUp();
              this.curPet.changeStateToLevelUp(() => {
                this.curPet.changeStateToIdle();
              });
            } else {
              // this.currentPet.playLevelUp_inSleep();
              this.curPet.changeStateFromRest2ToIdle(() => {
                this.curPet.changeStateToLevelUp(() => {
                  this.curPet.changeStateFromIdleToRest2(() => {// this.curPet.changeStateToRest2();
                  });
                });
              });
            }

            this.animFx.node.active = true;
            this.animFx.setAnimation(0, "level_up", false);
            setTimeout(() => {
              if (!this || !this.node) return;
              this.animFx.node.active = false;
            }, 1200);
            SoundManager.playSound("servant_upgrade");
          });
          req.Send();
        } // 选择


        callSelect() {
          let req = SR.SRServant.servantSelect(this.currentId);
          req.SetCallBack(res => {
            this.SUserServant = Game.SUserServant;
            this.selectId = this.currentId;
            let state = this.SUserServant.Servant(this.currentId);

            let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

            if (time > 0) {
              // this.currentPet.playWake();
              this.curPet.changeStateFromRest2ToIdle(() => {
                this.curPet.changeStateToIdle();
              });
              SoundManager.playSound("servant_wake");
            } else {
              this.curPet.changeStateToRest2();
            }

            this.setSelect();
            eventCenter.emit(MyCustomEvent.ChangePet, this.selectId);
          });
          req.Send();
        } // 喂食


        callFeedWatch() {
          let state = this.SUserServant.Servant(this.currentId);
          if (!state) return;
          ADWrap.ShowVideo(() => {
            let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

            this.animFeedFree.node.active = true;
            this.animFeedFree.play();
            setTimeout(() => {
              if (!this || !this.node) return;
              this.animFeedFree.node.active = false;
            }, 680);
            let req = SR.SRServant.servantFeedFree(this.currentId);
            req.SetCallBack(res => {
              this.SUserServant = Game.SUserServant;
              this.setTime();

              if (this.currentId == this.selectId) {
                if (time <= 0) {
                  // this.currentNode.playEatWake();
                  this.curPet.changeStateFromRest2ToIdle(() => {
                    this.curPet.changeStateToEat(() => {
                      this.curPet.changeStateToIdle();
                    });
                  });
                } else {
                  // this.currentNode.playEat();
                  this.curPet.changeStateToEat(() => {
                    this.curPet.changeStateToIdle();
                  });
                }

                eventCenter.emit(MyCustomEvent.UpdatePetStatus, this.selectId);
              } else {
                // this.currentNode.playEat_inSleep();
                this.curPet.changeStateFromRest2ToIdle(() => {
                  this.curPet.changeStateToEat(() => {
                    this.curPet.changeStateFromIdleToRest2(() => {// this.curPet.changeStateToRest2();
                    });
                  });
                });
              }

              this.animFx.node.active = true;
              this.animFx.setAnimation(0, "feed", false);
              setTimeout(() => {
                if (!this.node || !this.animFx || this.animFx.node) return;
                this.animFx.node.active = false;
              }, 1200);
              SoundManager.playSound("servant_food_feed");
              /*setTimeout(() => {
              SoundManager.playSound("servant_eat_mouth")
              }, mouthSoundDelay);*/
            });
            req.Send();
          }, "ServantWatch");
        } // 喂食


        callFeed() {
          let userCount = Game.SUserItems.getNum(servantFoodItemId);

          if (userCount < 1) {
            this.goToShop(G.Pages.Shop, G.zones.treat);
            return;
          }

          let state = this.SUserServant.Servant(this.currentId);
          if (!state) return;

          let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

          this.animFeed.node.active = true;
          this.animFeed.play();
          setTimeout(() => {
            if (!this || !this.node) return;
            this.animFeed.node.active = false;
          }, 680);
          let req = SR.SRServant.servantFeed(this.currentId);
          req.SetCallBack(res => {
            this.SUserServant = Game.SUserServant;
            this.setTime();

            if (this.currentId == this.selectId) {
              if (time <= 0) {
                // this.currentNode.playEatWake();
                this.curPet.changeStateFromRest2ToIdle(() => {
                  this.curPet.changeStateToEat(() => {
                    this.curPet.changeStateToIdle();
                  });
                });
              } else {
                // this.currentNode.playEat();
                this.curPet.changeStateToEat(() => {
                  this.curPet.changeStateToIdle();
                });
              }

              eventCenter.emit(MyCustomEvent.UpdatePetStatus, this.selectId);
            } else {
              // this.currentNode.playEat_inSleep();
              this.curPet.changeStateFromRest2ToIdle(() => {
                this.curPet.changeStateToEat(() => {
                  this.curPet.changeStateFromIdleToRest2(() => {// this.curPet.changeStateToRest2();
                  });
                });
              });
            }

            this.animFx.node.active = true;
            this.animFx.setAnimation(0, "feed", false);
            setTimeout(() => {
              if (!this.node || !this.animFx || this.animFx.node) return;
              this.animFx.node.active = false;
            }, 1200);
            SoundManager.playSound("servant_food_feed");
            /*setTimeout(() => {
            SoundManager.playSound("servant_eat_mouth")
            }, mouthSoundDelay);*/
          });
          req.Send();
        } // 加经验


        callExp() {
          let userCount = Game.SUserItems.getNum(servantExpItemId);

          if (userCount < 1) {
            // UIRoot.instance.openChildWindow(ShopWindow, { showTreat: true });
            this.goToShop(G.Pages.Shop, G.zones.treat);
            return;
          }

          let state = this.SUserServant.Servant(this.currentId);
          if (!state) return;
          let need = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, state.rank).Exp(this.currentId) - state.exp;
          if (need <= 0) return;
          this.animExp.node.active = true;
          this.animExp.play();
          setTimeout(() => {
            if (!this || !this.node) return;
            this.animExp.node.active = false;
          }, 850);
          let oldProg = this.progressExp.progress;
          let req = SR.SRServant.servantAddExp(this.currentId);
          req.SetCallBack(res => {
            this.SUserServant = Game.SUserServant;
            this.setRank();
            let state = this.SUserServant.Servant(this.currentId);

            let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

            if (time > 0 && this.currentId == this.selectId) {
              // this.currentNode.playEat();
              this.curPet.changeStateToEat(() => {
                this.curPet.changeStateToIdle();
              });
            } else {
              // this.currentNode.playEat_inSleep();
              this.curPet.changeStateFromRest2ToIdle(() => {
                this.curPet.changeStateToEat(() => {
                  this.curPet.changeStateFromIdleToRest2(() => {// this.curPet.changeStateToRest2();
                  });
                });
              });
            }

            this.animFx.node.active = true;
            this.animFx.setAnimation(0, "wake", false);
            setTimeout(() => {
              if (!this || !this.node) return;
              this.animFx.node.active = false;
            }, 1200);
            let newProg = this.progressExp.progress;
            this.progressExp.node.runAction(tween().to(0.5, {
              progress: newProg
            }));
            SoundManager.playSound("servant_exp_feed");
          });
          req.Send();
        } // 购买


        callBuy() {
          let shopMeta = Meta.ShopMeta.GetByTypeIndex(Meta.ShopMeta.Types.Servant, this.currentId - 1);
          PaymentWrap.Pay(shopMeta.Name(), ok => {
            if (ok) {
              SoundManager.playSound("item_purchased");
              this.setCurrent();
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "servant",
                name: shopMeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "servant",
                name: shopMeta.Name(),
                phase: -1
              });
            }
          });
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "servant",
            name: shopMeta.Name(),
            phase: 0
          });
        } // 打开帮助


        callInfo() {
          this.spInfo.enterAnim();
        }

        closeInfo() {
          this.spInfo.closeAnim();
        }

        gameTouchStart(e) {
          if (!this.node.activeInHierarchy) return;
          this.pressed = true;
          this.pressPos = 0;
          this.pressPosStart = e.getLocation();
        }

        gameTouchMove(e) {
          if (!this.node.activeInHierarchy) return;
          this.pressPos += e.touch.getDelta().y;
          if (!this.pressPosStart) return;

          if (e.getLocation().x > this.pressPosStart.x + 150) {
            this.callLeft();
            this.pressPosStart = null;
          } else if (e.getLocation().x < this.pressPosStart.x - 150) {
            this.callRight();
            this.pressPosStart = null;
          }
        }

        gameTouchEnd(e) {
          if (!this.node.activeInHierarchy) return;
          this.pressed = false;
          this.pressPos = null;
          this.pressPosStart = null;
        }

        gameTouchCancel(e) {
          if (!this.node.activeInHierarchy) return;

          if (!e.simulate) {
            this.pressed = false;
            this.pressPos = null;
            this.pressPosStart = null;
          }
        }

      }, _defineProperty(_class3, "windowPath", "Servant/NewServantWindow"), _defineProperty(_class3, "instance", void 0), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spPrefabParent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spTouchArea", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "progressExp", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelExp", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelLevel", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "iconLock", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "btnUpgrade", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "iconTime", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "labelTime", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "spBubble", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "labelEffect", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "labelEffectNumTitle", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "labelEffectNum", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "labelEffectNextLevel", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "spNextLevelStar", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "labelNextLevelStar", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "btnSelect", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "spSelected", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "btnBuy", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "labelBuyPrice", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class2.prototype, "spInfo", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class2.prototype, "btnFeed", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class2.prototype, "labelFeedNum", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class2.prototype, "btnExp", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor26 = _applyDecoratedDescriptor(_class2.prototype, "labelExpNum", [_dec27], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor27 = _applyDecoratedDescriptor(_class2.prototype, "btnFeedWatch", [_dec28], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor28 = _applyDecoratedDescriptor(_class2.prototype, "animFx", [_dec29], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor29 = _applyDecoratedDescriptor(_class2.prototype, "animFeed", [_dec30], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor30 = _applyDecoratedDescriptor(_class2.prototype, "animFeedFree", [_dec31], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor31 = _applyDecoratedDescriptor(_class2.prototype, "animExp", [_dec32], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor32 = _applyDecoratedDescriptor(_class2.prototype, "containerServant", [_dec33], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor33 = _applyDecoratedDescriptor(_class2.prototype, "loadingNode", [_dec34], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor34 = _applyDecoratedDescriptor(_class2.prototype, "loadingLabel", [_dec35], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class)); // ServantWindow.Show = function () {
      // 	FullLoadingWindow.Show(() => {
      // 		homeView.closeGamePlay();
      // 		UIRoot.instance.openWindow("ServantWindow", {
      // 			showCallback: () => {
      // 				FullLoadingWindow.Hide();
      // 			},
      // 		});
      // 	});
      // };

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopCoinMeta.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "128e8fAAQtMVasTdbDVx5S9", "ShopCoinMeta", undefined);

      class ShopCoinMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new ShopCoinMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        MapId() {
          return this._data.mapId || this._data.id;
        }

        GetCoin(id) {
          return this._data["coin" + id.toString()];
        }

      }

      exports('ShopCoinMeta', ShopCoinMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardSelectCardWindow.ts", ['cc', './global.ts', './UIWindow.ts', './MetaManager.ts', './LocalizedManager.ts', './CardModel.ts', './DialogWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ShareWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, instantiate, Mask, G, UIWindow, MetaManager, rigisterLabel, CardModel, DialogWindow, SR, UIRoot, Meta, Game, LogEventWrap, ShareWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      Mask = module.Mask;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "138076yiPZAspbSxryKZXew", "CardSelectCardWindow", undefined);
      /** @author fengyong-2019-6-4 */


      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      let CardSelectCardWindow = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class CardSelectCardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "unselectedCardsLayout", _descriptor, this);

          _initializerDefineProperty(this, "selectedCardsLayout", _descriptor2, this);

          _initializerDefineProperty(this, "unselectedCardItem", _descriptor3, this);

          _initializerDefineProperty(this, "selectedCardItem", _descriptor4, this);

          _initializerDefineProperty(this, "labelInfo", _descriptor5, this);

          _defineProperty(this, "_friendsUserId", 0);

          _defineProperty(this, "_defaultCardId", 0);

          _defineProperty(this, "_dailyMaxSendCount", 0);

          _defineProperty(this, "_allCanSendCardId", []);

          _defineProperty(this, "_selectedCardId", []);

          _defineProperty(this, "_unselectedCardId", []);

          _defineProperty(this, "_selectedCardsNode", []);

          _defineProperty(this, "_selectedCardPool", []);
        }

        onShow(params) {
          this._friendsUserId = params.friend_userid;
          this._defaultCardId = params.default_card_meta_id;
          this.labelInfo.string = String.format(i18n.t("CardSelectCardWindowInfo"), this.get_max_select_count());
          rigisterLabel("CardSelectCardWindowInfo", this.labelInfo, this._dailyMaxSendCount);

          this._createAllUnselectedCards();
        }

        _createAllUnselectedCards() {
          this._allCanSendCardId = !!this._allCanSendCardId.length ? this._allCanSendCardId : this.get_card_list();

          this._allCanSendCardId.forEach(cardId => {
            const newCard = instantiate(this.unselectedCardItem);
            newCard.getComponentInChildren(CardModel).show(cardId);
            newCard.parent = this.unselectedCardsLayout;
            newCard.active = true;
          });

          this.unselectedCardsLayout.parent.getComponent(Mask)["_broadcastToNode"](this.unselectedCardsLayout);
          this.unselectedCardsLayout.children.forEach(child => {
            child.eventProcessor.reattach();
          });
        }

        _getAllCanSendCardsId() {
          let allCardMetas = [];
          Object.keys(MetaManager.GetMetas(Meta.MetaType.Card)).forEach(v => {
            allCardMetas.push(MetaManager.GetMeta(Meta.MetaType.Card, v));
          });
          allCardMetas.filter(cardMeta => cardMeta.Golden() === "FALSE");
          let allNoGoldenCardsId = allCardMetas.map(cardMeta => cardMeta.Id());
          allNoGoldenCardsId.filter(cardId => Game.SUserCard.CardNum(cardId) > 1);
          return allNoGoldenCardsId || [];
        }

        get_card_list() {
          // 获取所有的card-meta-id
          let all_card_meta_id_list = Object.keys(Meta.MetaManager.GetMetas(Meta.MetaType.Card)).map(v => {
            return parseInt(v);
          }); // 过滤:非金卡,个数>1

          let able_card_meta_id_list = all_card_meta_id_list.filter(v => {
            /** @type {CardMeta} */
            let card_meta = Meta.MetaManager.GetMeta(Meta.MetaType.Card, v);

            if (card_meta.Golden()) {
              return false;
            }

            if (Game.SUserCard.CardNum(card_meta.Id()) <= 1) {
              return false;
            }

            return true;
          });
          return able_card_meta_id_list;
        }

        selectOneCard(event) {
          var _target$getComponentI;

          if (this._selectedCardId.length >= this._dailyMaxSendCount) return;
          const target = event.target;
          const cardId = (_target$getComponentI = target.getComponentInChildren(CardModel)) === null || _target$getComponentI === void 0 ? void 0 : _target$getComponentI.cardId;

          if (!cardId) {
            console.log("no such card");
            return;
          }

          if (this._allCanSendCardId.indexOf(cardId) === -1) return;
          if (this._selectedCardId.indexOf(cardId) !== -1) return;

          this._selectedCardId.push(cardId);

          this._unselectedCardId.splice(this._unselectedCardId.indexOf(cardId), 1);

          this._selectedCardsNode.push(target);

          this._updateDirtyCard(target, true);

          let newCardItem = null;

          if (this._selectedCardPool.length) {
            newCardItem = this._selectedCardPool.pop();
          } else {
            newCardItem = instantiate(this.selectedCardItem);
          }

          if (newCardItem) {
            newCardItem.getComponentInChildren(CardModel).show(cardId);
            newCardItem.getComponentInChildren(CardModel).label_more_count.node.parent.active = false;
            newCardItem.parent = this.selectedCardsLayout;
            newCardItem.active = true;
          }
        }

        unselectedOneCard(event) {
          var _target$getComponentI2;

          const target = event.target;
          const cardId = (_target$getComponentI2 = target.getComponentInChildren(CardModel)) === null || _target$getComponentI2 === void 0 ? void 0 : _target$getComponentI2.cardId;

          if (!cardId) {
            console.log("no such card");
            return;
          }

          if (this._selectedCardId.indexOf(cardId) === -1) return;

          let dirtyCard = this._selectedCardsNode[this._selectedCardId.indexOf(cardId)];

          this._selectedCardsNode.splice(this._selectedCardsNode.indexOf(dirtyCard), 1);

          this._updateDirtyCard(dirtyCard, false);

          const clickedItem = this.selectedCardsLayout.children[this._selectedCardId.indexOf(cardId)];

          clickedItem.active = false;
          clickedItem.parent = null;

          this._selectedCardPool.push(clickedItem);

          this._unselectedCardId.push(cardId);

          this._selectedCardId.splice(this._selectedCardId.indexOf(cardId), 1);
        }

        _updateDirtyCard(cardNode, selected) {
          cardNode.getChildByName("selectedSign").active = selected;
          const cardModel = cardNode.getComponentInChildren(CardModel);
          if (!cardModel) return;
          let count = Game.SUserCard.CardNum(cardModel.cardId);

          if (selected) {
            count -= 1;

            if (count <= 1) {
              cardModel.node.getChildByName("sp-more-count").active = false;
            } else {
              cardModel.node.getChildByName("sp-more-count").getComponentInChildren(Label).string = `+${count - 1}`;
            }
          } else {
            cardModel.node.getChildByName("sp-more-count").active = true;
            cardModel.node.getChildByName("sp-more-count").getComponentInChildren(Label).string = `+${count - 1}`;
          }
        }

        get_max_select_count() {
          if (!this._dailyMaxSendCount) {
            this._dailyMaxSendCount = Game.SUserCard.GetDailyCount();
          }

          return this._dailyMaxSendCount;
        }

        event_send() {
          // 通知服务器
          let sr = SR.SRCard.cardSend(this._friendsUserId, this._selectedCardId);
          sr.SetCallBack(() => {
            // 修改本地数据,用于计算每日的送卡片数目限制
            let sendCardTime = GameKit.PlayerPrefs.GetInt("sendCardTime", 0);

            if (GameKit.TimeUtil.getCurrentDay() !== sendCardTime) {
              GameKit.PlayerPrefs.SetInt("sendCardCount", 0);
              GameKit.PlayerPrefs.SetInt("sendCardTime", GameKit.TimeUtil.getCurrentDay());
            }

            let count = GameKit.PlayerPrefs.GetInt("sendCardCount", 0);
            GameKit.PlayerPrefs.SetInt("sendCardCount", count + this._selectedCardId.length); // 刷新页面

            let w = UIRoot.instance.GetWindow("CardSingleSetWindow");
            if (w) w.load_page(w.single_set_meta); // 显示send成功并关闭页面

            DialogWindow.Show(i18n.t("CardSelectCardWindowSuccess"), () => {
              this.closeAnim();
            });
            LogEventWrap.logEvent("card_send", {
              num: this._selectedCardId.length
            });
          });

          if (G.GameConfig.closeGiftFbShare) {
            sr.Send();
          } else {
            ShareWrap.chooseOne(Game.SUser.FriendsList()[this._friendsUserId].ThirdId(), String.format(i18n.t("ShareSendCard"), Game.SUser.Name()), "share/share1", {
              type: "send_cards"
            }, () => {
              sr.Send();
            }, "send_cards", false);
          }
        }

        event_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Card/CardSelectCardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "unselectedCardsLayout", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "selectedCardsLayout", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "unselectedCardItem", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "selectedCardItem", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelInfo", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GetRewardWindow.ts", ['cc', './Constant.ts', './_app.ts', './SoundManager.ts', './UIWindow.ts', './CommonAssets.ts', './Content.ts', './PlayGetAnimation.ts', './GameMainWindow.ts', './StaticGame.ts', './GameKit.ts', './BigNumber.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, SpriteFrame, dragonBones, Prefab, Label, _decorator, Sprite, instantiate, UIOpacity, tween, Vec3, Tween, MyCustomEvent, cce, SoundManager, UIWindow, CommonAssets, Content, PlayGetAnimation, GameMainWindow, Meta, Game, GameKit, BigNumber;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      SpriteFrame = module.SpriteFrame;
      dragonBones = module.dragonBones;
      Prefab = module.Prefab;
      Label = module.Label;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      instantiate = module.instantiate;
      UIOpacity = module.UIOpacity;
      tween = module.tween;
      Vec3 = module.Vec3;
      Tween = module.Tween;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "148ecoXwqpOAYrV5Fw0L+Ep", "GetRewardWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let GetRewardWindow = exports('GetRewardWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(SpriteFrame), _dec7 = property(SpriteFrame), _dec8 = property(SpriteFrame), _dec9 = property(SpriteFrame), _dec10 = property(dragonBones.ArmatureDisplay), _dec11 = property(Prefab), _dec12 = property(Prefab), _dec13 = property(Node), _dec14 = property(Label), _dec15 = property(Node), _dec16 = property(SpriteFrame), ccclass(_class = (_class2 = (_temp = _class3 = class GetRewardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "model", _descriptor, this);

          _initializerDefineProperty(this, "btnCollectNode", _descriptor2, this);

          _initializerDefineProperty(this, "item", _descriptor3, this);

          _initializerDefineProperty(this, "itemContainer1", _descriptor4, this);

          _initializerDefineProperty(this, "itemContainer2", _descriptor5, this);

          _initializerDefineProperty(this, "iconCoin", _descriptor6, this);

          _initializerDefineProperty(this, "iconAp", _descriptor7, this);

          _initializerDefineProperty(this, "iconXp", _descriptor8, this);

          _initializerDefineProperty(this, "iconFood", _descriptor9, this);

          _initializerDefineProperty(this, "dbOpenChest", _descriptor10, this);

          _initializerDefineProperty(this, "xpPrefab", _descriptor11, this);

          _initializerDefineProperty(this, "foodPrefab", _descriptor12, this);

          _initializerDefineProperty(this, "animEndNode", _descriptor13, this);

          _initializerDefineProperty(this, "labelDesc", _descriptor14, this);

          _initializerDefineProperty(this, "titleNode", _descriptor15, this);

          _initializerDefineProperty(this, "spVipBonus", _descriptor16, this);

          _defineProperty(this, "oldCoin", void 0);

          _defineProperty(this, "_allRewards", []);

          _defineProperty(this, "_playCoinAnim", false);

          _defineProperty(this, "_playApAnim", false);

          _defineProperty(this, "_playXpAnim", false);

          _defineProperty(this, "_playFoodAnim", false);

          _defineProperty(this, "_apCount", 0);

          _defineProperty(this, "_coinCount", 0);

          _defineProperty(this, "_xpCount", 0);

          _defineProperty(this, "_foodCount", 0);

          _defineProperty(this, "_closed", false);
        }

        onShow(showParams) {
          this._closed = false;
          let contents = showParams.contents;
          contents = Content.Merge(contents);
          this.oldCoin = showParams.oldCoin;

          if (showParams.closeCallback) {
            this.addOnCloseFunc(showParams.closeCallback);
          }

          this.item.active = false; //显示title和描述

          this.titleNode.active = !!showParams.showTitle;
          this.labelDesc.string = showParams.desc;
          this.labelDesc.node.active = !!showParams.desc;

          if (showParams.vip) {
            this.titleNode.getComponent(Sprite).spriteFrame = this.spVipBonus;
            this.titleNode.getChildByName("title").active = false;
          }

          for (let i = 0; i < contents.length; i++) {
            let content = Content.FromContent(contents[i]);
            let newItem = instantiate(this.item);
            newItem.parent = i < 3 ? this.itemContainer1 : this.itemContainer2;
            const itemContent = newItem.getChildByName("content");
            itemContent.active = false;
            newItem.active = true;

            this._allRewards.push(newItem);

            let labelName = itemContent.getChildByName("labelName").getComponent(Label);
            let labelCount = itemContent.getChildByName("labelNum").getComponent(Label);
            let icon = itemContent.getChildByName("icon").getComponent(Sprite);
            labelCount.string = BigNumber.format(content.Count());
            labelName.string = content.Name();
            content.Icon(icon, nullFunction);

            if (content.Type() === Content.Types.Ap) {
              this._playApAnim = true;
              this._apCount = content.Count();
            } else if (content.Type() === Content.Types.Coin) {
              this._playCoinAnim = true;
              this._coinCount = content.Count();
            } else if (content.Type() === Content.Types.Item) {
              let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Item, content.ContentId());

              if (meta._data.icon === "pet_xpPotion") {
                this._playXpAnim = true;
                this._xpCount = content.Count();
              } else if (meta._data.icon === "pet_food") {
                this._playFoodAnim = true;
                this._foodCount = content.Count();
              }
            }
          }

          this.showAllReward();
          GameKit.BackKeyManager.registerBackEvent();
          SoundManager.playSound("slot_item_win");
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();

          if (this.oldCoin != null) {
            if (GameMainWindow.instance) GameMainWindow.instance.userinfo.changeCoin(this.oldCoin, Game.SUser.Coin(), 0.8);
          }
        }

        async close_window() {
          if (this._closed) return;
          this._closed = true;
          this.itemContainer1.parent.getComponent(UIOpacity).opacity = 0;
          this.node.getChildByName("Button - OK").getComponent(UIOpacity).opacity = 0;
          this.titleNode.getComponent(UIOpacity).opacity = 0;
          this.labelDesc.node.getComponent(UIOpacity).opacity = 0;
          await Promise.all([this._playFoodAnim && this.playFoodAnim(), this._playApAnim && this.playApAnim(), this._playCoinAnim && this.playCoinAnim(), this._playXpAnim && this.playXpAnim()]);
          await cce.wait(500);
          eventCenter.emit(MyCustomEvent.CanChangeSpin);
          eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
          this.closeAnim();
        }

        async showAllReward() {
          tween(this.model.getComponent(UIOpacity)).to(0.06, {
            opacity: 150
          }).start();

          let show = index => {
            return new Promise(resolve => {
              tween(this._allRewards[index].getChildByName("content")).set({
                scale: new Vec3(0.3, 0.3, 0.3),
                active: true
              }).parallel(tween().delay(0.03).call(resolve), tween().to(0.15, {
                scale: new Vec3(1.1, 1.1, 1.1)
              }).to(0.1, {
                scale: Vec3.ONE
              })).start();
            });
          };

          for (let i = 0; i < this._allRewards.length; i++) {
            if (i === this._allRewards.length - 1) {
              tween(this.btnCollectNode).set({
                scale: new Vec3(0.001, 0.001, 0.001),
                active: true
              }).to(0.15, {
                scale: new Vec3(1.2, 1.2, 1.2)
              }).to(0.07, {
                scale: Vec3.ONE
              }).start();
            }

            await show(i);
          }
        }

        playCoinAnim() {
          return new Promise(resolve => {
            PlayGetAnimation.playAnimation({
              startNode: this.node,
              endNode: GameMainWindow.instance.btnCoinAdd.node.getChildByName("iconCoin"),
              count: this._coinCount || 200,
              prefab: CommonAssets.instance.coinPrefab,
              complete: () => {
                resolve(null);
              },
              startCallback: () => {
                eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
              }
            });
          });
        }

        async playApAnim() {
          return new Promise(resolve => {
            let oldCount = Game.SUser.AP() - this._apCount;

            PlayGetAnimation.playAnimation({
              startNode: this.node,
              endNode: this.animEndNode,
              count: this._apCount || 200,
              prefab: CommonAssets.instance.energyPrefab,
              startCallback: () => {
                homeView.pageViewController && homeView.pageViewController.spinIconAni();
              },
              perComplete: perCount => {
                oldCount += perCount;
                homeView.pageViewController.setApWithNum(oldCount);
              },
              complete: () => {
                resolve(null);
                Tween.stopAllByTarget(homeView.pageViewController.spinIcon);
              }
            });
          });
        }

        playXpAnim() {
          return new Promise(resolve => {
            PlayGetAnimation.playAnimation({
              startNode: this.node,
              endNode: this.animEndNode,
              count: this._xpCount || 200,
              prefab: this.xpPrefab,
              complete: () => {
                resolve(null);
              }
            });
          });
        }

        playFoodAnim() {
          return new Promise(resolve => {
            PlayGetAnimation.playAnimation({
              startNode: this.node,
              endNode: this.animEndNode,
              count: this._foodCount || 200,
              prefab: this.foodPrefab,
              complete: () => {
                resolve(null);
              }
            });
          });
        }

      }, _defineProperty(_class3, "windowPath", "Common/NewGetRewardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "model", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnCollectNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "itemContainer1", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "itemContainer2", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "iconCoin", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "iconAp", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "iconXp", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "iconFood", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "dbOpenChest", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "xpPrefab", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "foodPrefab", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "animEndNode", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "labelDesc", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "titleNode", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "spVipBonus", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VIPExtraRewardWindow.ts", ['cc', './UIWindow.ts', './ContentModel.ts', './VIPGetWindow.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, instantiate, UIWindow, ContentModel, VIPGetWindow, UIRoot, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      VIPGetWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "149f0lDNmhCyKDYGqgBzEV3", "VIPExtraRewardWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let VIPExtraRewardWindow = exports('default', (_dec = property(ContentModel), _dec2 = property(Node), _dec3 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class VIPExtraRewardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spDailyItem", _descriptor, this);

          _initializerDefineProperty(this, "spDailyItemParent", _descriptor2, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor3, this);

          _defineProperty(this, "leftTime", void 0);
        }

        onShow(showParams) {
          this.spDailyItemParent.destroyAllChildren();
          let rewards = Game.SUserStatus.VipExtraReward();
          rewards.forEach(reward => {
            let itemHandle = instantiate(this.spDailyItem.node);
            itemHandle.parent = this.spDailyItemParent;
            itemHandle.getComponent(ContentModel).show(reward);
          });
          this.leftTime = 0;
          this.slowUpdate(0);
        }

        onClose() {}

        slowUpdate(arg) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = Game.SUserStatus.VipExtraTime() - currentTime + Game.SUserStatus.VipExtraTimeLast();
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              this.leftTime = null;
              this.closeAnim();
            }
          }
        }

        callClose() {
          this.closeAnim();
        }

        callGo() {
          this.closeAnim();
          UIRoot.instance.openChildWindow(VIPGetWindow);
        }

      }, _defineProperty(_class3, "windowPath", "VIP/NewVIPExtraRewardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spDailyItem", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spDailyItemParent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/setZIndex.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UITransform, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      UITransform = module.UITransform;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "15f8bNo45tJxo2ZfVHuhkpw", "setZIndex", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let setZIndex = exports('default', ccclass(_class = (_class2 = (_temp = class setZIndex extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "zAdd", _descriptor, this);
        }

        start() {
          this.node.getComponent(UITransform).priority = this.zAdd;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "zAdd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _class2)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ContentDesWindow.ts", ['cc', './_app.ts', './UIWindow.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Sprite, _decorator, cce, UIWindow, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Sprite = module.Sprite;
      _decorator = module._decorator;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "16a5cJ10MtOWJq1B7hmyLQz", "ContentDesWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ContentDesWindow = exports('ContentDesWindow', (_dec = property(Label), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Sprite), ccclass(_class = (_class2 = (_temp = _class3 = class ContentDesWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelName", _descriptor, this);

          _initializerDefineProperty(this, "lebelDes", _descriptor2, this);

          _initializerDefineProperty(this, "labelNum", _descriptor3, this);

          _initializerDefineProperty(this, "icon", _descriptor4, this);

          _defineProperty(this, "content", void 0);
        }

        onShow(showParams) {
          this.content = showParams.content;
          this.labelName.string = this.content.Name();
          this.lebelDes.string = this.content.Desc();
          this.labelNum.string = this.content.Count() > 0 ? i18n.t("multiplyx") + BigNumber.format(this.content.Count()) : "";
          this.content.Icon(this.icon);
        }

        onClose() {
          cce.releaseSpriteFrame(this.icon);
        }

        onConfirm() {
          this.close();
        }

      }, _defineProperty(_class3, "windowPath", "Item/ContentDesWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lebelDes", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelNum", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "icon", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/setAliasTexParameters.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Texture2D, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Texture2D = module.Texture2D;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class;

      cclegacy._RF.push({}, "176acrj/XBEnJHDFyL9E0ne", "setAliasTexParameters", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let setAliasTexParameters = exports('default', ccclass(_class = executeInEditMode(_class = class setAliasTexParameters extends CCE_Component {
        start() {
          if (this.getComponent(Sprite) && this.getComponent(Sprite).spriteFrame) ;
        }

        static setSpriteFrame(spf) {
          if (spf) spf.texture.setFilters(Texture2D.Filter.NEAREST, Texture2D.Filter.NEAREST);
        }

      }) || _class) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fr.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "18217YAOJpCTIyK02PCpdz+", "fr", undefined);

      let fr = exports('fr', {
        APPNAME: "Pièce de monnaie",
        Accept: "Accepter",
        ActivityAttackMasterButton: "COMPRIS !",
        ActivityAttackMasterButtonTip: "Pariez plus pour l’obtenir plus rapidement !",
        ActivityAttackMasterDes: "Attaquez {0} fois pour obtenir\n{1} pièces",
        ActivityAttackMasterDesMore: "<color=#562900>Plus vous complétez de barres, plus grandes seront les </color> <outline color=#9E5A05 width=2><color=#F7E150>RÉCOMPENSES !</color></outline>",
        ActivityAttackMasterFinal1: "Prix de barre finale: ",
        ActivityAttackMasterFinal2: "{0} Pièces !",
        ActivityAttackMasterTimeleft: "Se termine dans {0}",
        ActivityBuildKingDes: "Terminez pour obtenir des récompenses !",
        ActivityCenterTime: "Temps restant : {0}",
        ActivityCenterTimeEnd: "L’activité est terminée",
        ActivityCenterTitle: "Centre d’Activité",
        ActivityRaidMasterDes: "Raid {0} fois pour obtenir\n{1} pièces",
        ActivityShopDes: "Temps de vente restant {0}",
        ActivitySlotCollectDes1: "Attaquer",
        ActivitySlotCollectDes2: "Attaque Bloquée",
        ActivitySlotCollectDes3: "Raid",
        ActivitySlotCollectDes4: "Excellent Raid",
        ActivitySlotCollectDes5: "Toucher 3 Symboles",
        ActivitySlotCollectRankGetJoin: "<outline color=5E2301 width=2>get <img src='{0}_s' /> pour rejoindre</outline>",
        ActivitySlotCollectRankGetStart: "Commencer à Jouer pour collecter",
        ActivitySlotCollectRankInfoLabel1: "<color=#88421c>Collectez <img src='{0}_s'/> pour monter dans le classement !</color>",
        ActivitySlotCollectRankInfoLabel2: "<outline color=#76320E width= 3>Pariez plus pour multiplier chaque <img src='{0}_s'/> que vous collectez !</outline>",
        ActivitySlotCollectRankRewardDes: "Voici ce que vous avez gagné :",
        ActivitySlotCollectRankRewardDesLose: "Vous n’avez pas gagné cette fois, mais vous obtenez quand même un prix !",
        ActivitySlotCollectRankRewardEnd: "Le Tournoi a est terminé",
        ActivitySlotCollectRankRewardWinner: "GAGNANT !",
        ActivitySpecialOfferCoin: "{0} Pièces",
        ActivitySpecialOfferSpin: "{0} Tours",
        ActivitySpecialOfferTitle: "Offre Surprise",
        ActivityTimeleft: "Temps Restant",
        AdNotReady: "La vidéo n’est pas prête !",
        ApFull: "Plein",
        ApPlus: "+{0} Tours",
        ApRecoverIn: "{0} tours dans {1}",
        AppCommentBtn: "SOUMETTRE",
        AppCommentDes: "Appuyez sur une étoile pour la noter sur la boutique.",
        AppCommentNo: "PAS MAINTENANT",
        AppCommentTitle: "Vous Aimez Coin Room?",
        AppHotUpdateFail: "Chargement de ressources échoué. Réessayer ?",
        AppUpdateBtn: "MISE À JOUR",
        AppUpdateDes: "Il y a une nouvelle version disponible ! Mettre à jour maintenant !",
        AppUpdateNo: "Non, merci",
        AppUpdateTitle: "Nouvelle Mise à Jour",
        Attack: "ATTAQUER",
        AutoSpinTipWindowButton: "Essayez!",
        AutoSpinTipWindowDes: "Maintenez le bouton pour commencer",
        AutoSpinTipWindowTitle: "TOUR AUTO",
        AutoSpining: "Auto",
        Back: "Retour",
        Bet: "PARIER",
        BetRibbonText: "TOUTES LES VICTOIRES X{0}",
        BindFacebookBtn: "CONNEXION",
        BindFacebookFreespin: "Connexion pour des Tours Gratuits",
        BindFacebookTip: "Nous ne publierons pas en votre nom",
        BindFacebookTitle: "Connexion via Facebook",
        BlackJackGameDeal: "ACCORD",
        BlackJackGameDoubleDown: "DOUBLER\nLA MISE",
        BlackJackGameHit: "TOUCHER",
        BlackJackGameStand: "RESTER",
        BlackJackGameSurrender: "ABANDONNER",
        BlackJackGameWatchBtn: "REGARDER MAINTENANT !",
        BlackJackHelpDes1: "Au Blackjack, vous essayez de construire une main ayant une valeur supérieure à celle de la maison sans dépasser 21. Les as peuvent compter pour 11 ou 1. Les cartes de face valent 10, et toutes les autres cartes valent le nombre qu'elles montrent.",
        BlackJackHelpDes2: "donner",
        BlackJackHelpDes3: "Utilisez cette option lorsque vous souhaitez demander une autre carte. Vous pouvez frapper autant de fois que vous le souhaitez, mais si vous dépassez 21, vous perdez.",
        BlackJackHelpDes4: "Lorsque vous avez fini de demander des cartes, vous pouvez vous lever et laisser la maison prendre son tour.",
        BlackJackHelpDes5: "Si une main a 2 cartes, vous pouvez utiliser cette option pour doubler votre mise et ne recevoir qu'une seule carte supplémentaire pour votre main.",
        BlackJackHelpDes6: "Toute main contenant un As et une carte figure est appelée black jack. Le black jack bat une main sur deux et paie 3 à 2 pour le joueur.",
        BlackJackHelpDes7: "Si la main d'un joueur a la même valeur que la maison, c'est un push. Le joueur reçoit sa mise initiale en retour.",
        BlackJackHelpDes8: "On dit qu'un joueur fait faillite lorsque sa main vaut plus de 21.",
        BlackJackHelpDes9: "Cette option permet à un joueur de récupérer la moitié de sa mise initiale, en échange de l'abandon de sa main.",
        BlackJackHelpDes10: "Les conseils d’action mettent en évidence le bouton d’action suggéré pendant le jeu. Les conseils de coups sont basés sur la force statistique des mains de la maison et du joueur.",
        BlackJackHelpTitle1: "--Règles de base--",
        BlackJackHelpTitle2: "--Comment jouer--",
        BlackJackHelpTitle3: "--Toucher--",
        BlackJackHelpTitle4: "--Rester--",
        BlackJackHelpTitle5: "--Doubler la Mise--",
        BlackJackHelpTitle6: "--Black Jack--",
        BlackJackHelpTitle7: "--Égalité--",
        BlackJackHelpTitle8: "--Perdu--",
        BlackJackHelpTitle9: "--Surrender--",
        BlackJackHelpTitle10: "--Plus de Conseils--",
        BlackJackTitle: "Black Jack",
        BlackJackWatchWindowDesLose: "Regardez la vidéo pour récupérer la moitié des pertes !",
        BlackJackWatchWindowDesWin: "Regardez la vidéo pour 100% plus de pièces !",
        COLLECT: "COLLECTER",
        COLLECTED: "COLLECTÉ",
        Cancel: "Annuler",
        CardAllSetWindowBottom: "- Coin Room -",
        CardAllSetWindowCompleted: "Terminé",
        CardAllSetWindowLock: "Se débloque à\nChambre {0}",
        CardAllSetWindowLocked: "Fermé à clé",
        CardAllSetWindowTitle: "CARTE\nCOLLECTION",
        CardAsk: "Demander",
        CardAskCannot: "Cela ne peut pas être demandée à des amis",
        CardAskCannotGolden: "Cette carte est dorée, ne peut pas être demandée à des amis",
        CardChestInfoWindowHigh: "Grande chance :",
        CardChestInfoWindowTitle_1: "Coffre en Bois",
        CardChestInfoWindowTitle_2: "Coffre en Argent",
        CardChestInfoWindowTitle_3: "Coffre en Or",
        CardChestOpenWindowNew: "Nouveau",
        CardCollectButton: "Vérifier",
        CardCollectDes: "Carte {0}\na été ajouté à votrez album",
        CardCollectTitle: "GÉNIAL !",
        CardInfoWindowCommon: "Commun",
        CardInfoWindowPage0_0: "Collecter des cartes avec des coffres",
        CardInfoWindowPage0_1: "Vous pouvez aussi acheter des coffres dans le magasin",
        CardInfoWindowPage0_2: "Les coffres peuvent être trouvés pendant les raids et en débloquant un nouveau Chambre",
        CardInfoWindowPage1_0: "Le fait de posséder 2 ou plusieurs cartes identiques vous permet de les envoyer en cadeau à vos amis",
        CardInfoWindowPage1_1: "Appuyer sur la carte afin de la donner",
        CardInfoWindowPage1_2: ">Vous pouvez également demander des cartes manquantes à vos amis",
        CardInfoWindowPage1_3: "Vous pouvez envoyer jusqu’à 5 cartes par jour",
        CardInfoWindowPage2_0: "Les étoiles indiquent la rareté des cartes",
        CardInfoWindowPage2_2: "Chaque rareté d’étoile sur une nouvelle carte collectée vous donne 1 étoile",
        CardInfoWindowPage2_3: "Terminez des ensembles de cartes et obtenez de superbes récompenses !",
        CardInfoWindowRare: "Rare",
        CardInfoWindowTitle: "Info de Cartes",
        CardOpenDes: "<color=#ffffff><outline color=#000000 width=1>Collectez des cartes pour obtenir plus de <color=#ffcc00>Pièces</color> et <color=#c667ff>Tours</color></color></outline>",
        CardOpenDesS: "<color=#308ae6>Collectez des cartes pour obtenir plus de <color=#e67b07>Pièces</color> et <color=#006fd7>Tours</color></color>",
        CardSelectCardWindowInfo: "Sélectionner jusqu’à {0} cartes !",
        CardSelectCardWindowSelected: "Vos cartes sélectionnées :",
        CardSelectCardWindowSuccess: "Envoi de cartes réussi !",
        CardSelectCardWindowTitle: "ENVOYER DES CARTES",
        CardSelectFriendWindowBtn: "Sélectionner une Carte",
        CardSelectFriendWindowInfo: "Sélectionner 1 ami !",
        CardSelectFriendWindowTitle: "ENVOYER DES CARTES",
        CardSend: "Envoyer",
        CardSendCannot: "Cela ne peut pas être envoyée à des amis",
        CardSendCannotGolden: "Cette carte est dorée, ne peut pas être envoyée à des amis",
        CardSendCannotLeast: "Vous avez besoin de plus de une carte à envoyer",
        CardSendCannotLimit: "Vous avez atteint la limite journalière de cartes que vous pouvez envoyer",
        CardSingleSetWindowCompleted: "- ENSEMBLE TERMINÉ -",
        CardSingleSetWindowReward: "Terminer l’ensemble pour gagner",
        CardSingleSetWindowTip: "* Appuyer sur une carte en double pour l’envoyer à un ami",
        CardTradeButton: "ALLER ÉCHANGER !",
        CardTradeDes: "SONT MAINTENANT ÉCHANGEABLE !",
        CardTradeTradable: "Échangeable",
        CardTapToCollect: "Appuyez pour collecter",
        ChatSend: "Envoyer",
        CoinShopLevel: "Niveau {0}",
        CoinStore: "Magasin de Pièces",
        Confirm: "Confirmer",
        Congratulation: "Félicitations !",
        ContentNameActivityItem6: "Boulet de Canon",
        ContentNameActivityItemCommon: "Objet",
        ContentNameAp: "Tours",
        ContentNameCard: "Carte",
        ContentNameChest1: "Coffre en Bois",
        ContentNameChest2: "Coffre en Argent",
        ContentNameChest3: "Coffre en Or",
        ContentNameChest4: "COFFRE GRATUIT !",
        ContentNameCoin: "Pièces",
        ContentNameJigsaw: "Pièce de Puzzle",
        ContentNamePack: "Objets",
        ContentNameShield: "Bouclier",
        ContentNameUnknown: "???",
        CountDay: "{0}jours",
        CountHour: "{0}heures",
        CountMinute: "{0}minutes",
        CountMonth: "{0}Mois",
        CountSecond: "{0}secondes",
        CountYear: "{0}Ans",
        DailyBonusCollect: "COLLECTER",
        DailyBonusFreeSpinDes: "1 tour Gratuit dans\n{0}",
        DailyBonusGoldFirst: "Au moins 25M de pièces la première fois !!!",
        DailyBonusGoldSpinBtn: "Tour x {0}",
        DailyBonusLevel: "Niveau {0}",
        DailyBonusNormalSpinBtn: "TOUR GRATUIT",
        ErrorLogin: "Échec de la connexion au serveur.",
        ErrorMsg0: "Succès",
        ErrorMsg1114: "Regardez trop de vidéos aujourd'hui",
        ErrorMsg1703: "Achat échoué",
        ErrorNormal: "Connexion au serveur perdue.",
        ErrorRetry: "Échec de la connexion au serveur, réessayer ?",
        ExtraRewardDes: "Coin Room vous a offert des Pièces et des Tours !",
        FirstPurchaseButton: "ALLER !",
        FirstPurchaseDes1: "Faire un achat pour",
        FirstPurchaseDes2: "OBTENIR D’AUTRES RÉCOMPENSES !",
        FormatHour: ":",
        FormatMinute: ":",
        FormatMonth: "/",
        FormatYear: "/",
        FriendsModelNoResult: "Aucun Ami",
        FriendsModelPlaceHolder: "Chercher un nom d’ami",
        GameMainWindowActivity: "ACTIVITÉ",
        GameMainWindowQuest: "QUÊTE",
        GetRewardWindowDes: "<outline color=#000000 width=1><color=#ffffff> Vous avez obtenu des récompenses</color>\n<color=#c34eff>{0}!</color></outline>",
        GuestConfirmDes: "Les invités ne peuvent pas \njouer avec leurs amis",
        GuestConfirmGuest: "Jouer en tant qu’Invité",
        GuestConfirmTitle: "Are you sure?",
        Help_cannon: "1. Collectez les boulets de canon pour attaquer le château et obtenir de grandes récompenses !\n2. Les anneaux peuvent actualiser les trésors du château.\n3. Les boulets de canon peuvent être obtenus avec les tours et l’évolution du Chambre.\n4. La collection d’objets de valeur peut être échangée contre des récompenses de boîte à trésor !\n5. La Gemme Magique peut remplacer tout objet de valeur.",
        Help_coinhit: "1. Dépensez un ticket pour entrer en jeu.\n2. Vous pouvez obtenir beaucoup de pièces et de tours dans défi.\n3. Plus vous brisez de carrés, plus vous obtiendrez de récompenses.\n4. Ajustez l’angle pour toucher plus de carrés.",
        Help_jigsaw: "1. Collectez 9 pièces puis obtenez les récompenses.\n2. Les Pièces sont collectées dans les emplacements et évolutions.\n3. Les Pièces seront supprimées quand l’activité prend fin.\n4. Le Puzzle Universel peut remplacer toute pièce.",
        Help_sign: "1. Vous pouvez obtenir une récompense mensuelle de connexion tous les 7 jours du mois.\n2. La connexion mensuelle s’actualisera le mois prochain.\n3. Vous pouvez obtenir une récompense hebdomadaire tous les jours de la semaine.\n4. La connexion hebdomadaire s’actualisera la semaine prochaine.",
        InteractionAttackFriends: "AMIS",
        InteractionAttackName: "Chambre de {0}",
        InteractionAttackResultBlock: "<outline color=#000000 width=1><color=#29ffed> {0}</color> a bloqué votre attaque. Vous avez gagné <color=#ffc209> {1}</color></outline>",
        InteractionAttackResultBlock2: "<outline color=#000000 width=1><color=#29ffed> {0}</color> a bloqué votre attaque. Vous avez gagné <color=#ffc209> {1}</color></outline>",
        InteractionAttackResultSuccess: "<outline color=#000000 width=1> Vous avez attaqué le Chambre de <color=#29ffed>{0}</color> et vous avez gagné <color=#ffc209> {1}</color></outline>",
        InteractionAttackResultSuccess2: "<outline color=#000000 width=1> Vous avez attaqué le Chambre de <color=#29ffed>{0}</color> et vous avez gagné <color=#ffc209> {1}</color></outline>",
        InteractionAttackRevenge: "VENGEANCE",
        InteractionBet: "OBTENIR X{0}",
        InteractionRaidBrag: "Partager",
        InteractionRaidCoinMaster: "Roi",
        InteractionRaidEmpty: "Échoué",
        InteractionRaidName: "trésor de {0} :",
        InteractionRaidPrefect: "Excellent raid !",
        InteractionRaidResultLine: "<outline color=#000000 width=1>Vous avez volé <color=#29ffed>{0}</color> pièces de <color=#ffc209>{1}</color></outline>",
        InteractionRaidResultLine2: "<outline color=#000000 width=1>Vous avez volé <color=#FFF0A4>{0}</color> pièces de <color=#ffc209>{1}</color></outline>",
        InteractionRaidStole: "Volé:",
        LeaderBoardWindowTabCountry: "Pays",
        LeaderBoardWindowTabFriends: "Amis",
        LeaderBoardWindowTabGlobal: "Global",
        LeaderBoardWindowTip: "*S’actualise dans 10 minutes",
        Level: "Niveau",
        LevelBonusDes1: "<outline color=#7d3d2f width=3><size=46><color=#fffe00>30</color></size> fois bonus supplémentaire\nObtenez un tour de <size=46><color=#7ee0f4>5000</color></size> tours !</outline>",
        LevelBonusDes2: "Obtenez plein de récompense de tours de niveaux de pass après l’achat !",
        LevelBonusItemDes: "Pour le Chambre {0}",
        Loading: "Chargement",
        LoginWindowGuest: "Invité",
        LoginWindowNeedUpdate: "Il y a des mises à jours.",
        LoginWindowPlay: "Connectez-vous avec Apple",
        LoginWithApple: "Mit Apple anmelden",
        LoginWindowUpdating: "Mise à jour",
        LuckyDrawDes1: "Regarder la Vidéo",
        LuckyDrawDes2: "Obtenir une Chance",
        LuckyDrawFree: "Gratuit",
        MORE: "PLUS",
        MultiplePurchaseBtn: "TOUR",
        MultiplePurchaseDes1: "Tournez pour gagner jusqu’à",
        MultiplePurchaseDes2: "x10",
        MultiplePurchaseDes3: "pour {0} en plus",
        NO: "NON",
        NewPlayerPackButton: "ACHETER MAINTENANT !",
        NewPlayerPackDes1: "Bienvenue à Coin Room!",
        NewPlayerPackDes2: "<outline color=#471F01 width=2>Nous vous avons préparé un <color=#ffd63b>GRAND CADEAU</c>~</outline>",
        NewUserInvitedDes: "{0} a débloqué un nouveau Chambre !Vous obtenez \n{1} TOURS GRATUIS",
        NewUserInvitedDesApp: "{0} a rejoint le jeu!YVous obtenez \n{1} TOURS GRATUIS",
        NewUserInvitedTitle: "RÉCOMPENSE D’AMI",
        No: "NON",
        NotEnoughApAdd: "+{0} Tours",
        NotEnoughApDes: "Plus de tours ?",
        NotEnoughApWait: "ou attendez {1} pour {0} tours",
        NotEnoughApWait2: "Attendez {1} pour {0} tours",
        NotEnoughCoinDes: "Plus de pièces ?",
        NotEnoughOff: "{0}%\nEN PLUS",
        NotificationDesActivity: "{0} prendre fin dans une heure !",
        NotificationDesApFull: "Vous avez assez de tours pour jouer et gagner plus de pièces !",
        NotificationDesAttack: "Quelqu’un a envahi votre Chambre !",
        NotificationDesBack: "Nous vous avons préparé un grand cadeau !",
        NotificationDesBack2: "Revenez ! Nous vous avons préparé un grand cadeau !",
        NotificationDesDailyBonus: "Venez participer à la Roue de la Fortune !",
        NotificationTitleActivity: "L’activité va prendre fin !",
        NotificationTitleApFull: "Vous avez le maximum de tours !",
        NotificationTitleAttack: "C’est l’heure de la vengeance !",
        NotificationTitleBack: "Cela faisait longtemps !",
        NotificationTitleBack2: "Venez jouer avec moi !",
        NotificationTitleDailyBonus: "Bonus journalier disponible maintenant !",
        Now10XBetter: "10 fois mieux !",
        OFF: "OFF",
        OK: "OK",
        OffText: "{0}%\nEN PLUS",
        PastDay: "{0}j auparavant",
        PastHour: "{0}h auparavant",
        PastMinute: "{0}m auparavant",
        PastMonth: "{0}m auparavant",
        PastSecond: "{0}s auparavant",
        PastYear: "{0} ans auparavant",
        PastZero: "Maintenant",
        PayDisable: "Paiement désactivé !",
        PayDisableFBIn: "Désolé, la fonction de paiement est actuellement incompatible avec votre système. Veuillez accéder dans Coin Room via Jeux Instantanés pour compléter l'achat sur un ordinateur.",
        PayDisableIos: "Le paiement est désactivé sur iOS !",
        PayEnabledAndroid: "Le paiement n'est possible que sur Android !",
        PayFail: "Achat échoué !",
        PayFailWindowBtn: "Contacter le Support",
        PayFailWindowDes: "Vous avez des problèmes d’achat ?",
        PayPending: "Votre achat est en cours ! Après avoir terminé de payer, redémarrez le jeu pour obtenir les articles.",
        PaySuccess: "Merci pour votre achat !",
        PeterOpenDes1: "Parrot Peter vous apportera un cadeau aléatoire !",
        PeterOpenDes2: "Appuyez sur Peter et recevez le cadeau quand il arrive !",
        PlayerDefaultName: "Joueur",
        PriceSymbol: "$",
        Raid: "RAID",
        RaidProtect: "RAID PROTÉGÉ",
        Rank: "Rang",
        Reconnect: "RÉESSAYER",
        Restart: "Recommencer",
        Retry: "Réessayer",
        START: "Commencer",
        SaleMark: "VENTE",
        Score: "Score",
        ScorePoint: "Point",
        ScoreRank: "Rang",
        ServantEffectDes1: "Augmente la récompense de raid",
        ServantEffectDes2: "Augmente la récompenses des attaques",
        ServantEffectDes3: "Protège des attaques",
        ServantEffectDes4: "Protège des raids",
        ServantEffectNum1: "● Augmente la récompense de : {0}%",
        ServantEffectNum2: "● Augmente la récompense de : {0}%",
        ServantEffectNum3: "● Chances de protection : {0}%",
        ServantEffectNum4: "● Chances de protection : {0}%",
        ServantInfo1: "améliorer :",
        ServantInfo2: "Chaque tour de machine à sous = 1 Exp de Servante. Vous pouvez utiliser des potions pour obtenir plus d’Exp de Domestique. Lorsque la barre d’Exp de Domestique est pleine, appuyez sur le bouton d’amélioration pour améliorer votre domestique. Chaque amélioration de domestique augmentera votre étoile de jeu.",
        ServantInfo3: "Compétence :",
        ServantInfo4: "La compétence de domestique se renforce avec chaque amélioration de niveau",
        ServantInfo5: "Activation :",
        ServantInfo6: "Nourrissez votre domestique pour l’activer",
        ServantName1: "Pigy",
        ServantName2: "Billy",
        ServantName3: "Doge",
        ServantName4: "Ruby",
        ServantNextLevel: "● Niveau Suivant : {0}% +",
        ServantOpenDes: "<outline color=#000000 width=1><color=#ffffff>Engagez des domestiques pour obtenir plus de <color=#ffcc00>Pièces</color> et <color=#c667ff>Tours</color></color></outline>",
        ServantOpenDesS: "<color=#308ae6>Engagez des domestiques pour obtenir plus de <color=#e67b07>Pièces</color> et <color=#006fd7>Tours</color></color>",
        ServantSelect: "Sélectionner",
        ServantUpgrade: "Améliorer",
        ShareChooseDialogTitle: "Envoyer",
        ShareDialogTitle: "Partager",
        ShareInviteAttack: "WOW! J'attaque juste la Chambre des autres! Tellement cool: -D",
        ShareInviteDialogTitle: "Inviter",
        ShareInviteFinishVillage: "Je viens de construire une nouvelle salle! Venez visiter :-D",
        ShareInviteNew: "C'est vraiment un jeu génial ! Jouons ensemble :-P",
        ShareInviteRaid: "WOW ! je viens de voler {0} pièces ! Si génial :-D",
        ShareInviteSendCoins: "{0} vient de vous donner des pièces :)",
        ShareInviteSendSpin: "{0} vient de vous donner un tour :)",
        ShareJigsawTitle: "J’ai besoin de cela. Aidez-moi !",
        ShareSendCard: "{0} viens de vous donner des cartes :)",
        ShareTitle: "C'est vraiment un jeu génial ! Jouons ensemble :-P",
        Shield: "BOUCLIER",
        ShopAddPercent: "{0}% \nen plus",
        ShopBestValue: "Meilleure Valeur",
        ShopChestDisable: "Coffres débloqués à Chambre {0}",
        ShopChests: "Coffres",
        ShopCoinPrice: "{0} $",
        ShopCoins: "Pièces",
        ShopOff: "-{0}%\n",
        ShopPopular: "Populaire",
        ShopShield: "Super\nBouclier",
        ShopShieldDes1: "BOUCLIERS EN ARGENT",
        ShopShieldDes2: "BOUCLIERS EN OR",
        ShopShieldDes3: "Protéger Votre Chambre",
        ShopShieldDes4: "Protège contre :",
        ShopShieldDes5: "<color=#874423>Attaques et <color=#288bdf>Raids</color> (exclusive)</color>",
        ShopSpinNum: "{0} TOURS",
        ShopSpinPrice: "{0} $",
        ShopSpins: "Tours",
        ShopTitle: "Magasin",
        ShopTreatDisable: "Friandises débloquées à Chambre {0}",
        ShopTreatFoodTime: "activation {0}h",
        ShopTreats: "Friandises",
        SlotBetNewMax: "Limite de paris augmentée",
        SlotBetSuper: "SUPER",
        SlotCoin6Video: "Regardez une vidéo pour obtenir pièces x2",
        SlotPeterDesAd: "J’ai un cadeau pour vous !",
        SlotSymbol1: "SODA",
        SomeDay: "{0}j",
        SomeHour: "{0}h",
        SomeMinute: "{0}m",
        SomeMonth: "{0}m",
        SomeSecond: "{0}s",
        SomeYear: "{0} ans",
        SomeZero: "Maintenant",
        Spins: "TOURS+{0}",
        SuperShieldOpenDes: "Le Super Bouclier protège le Chambre des Attaques et Raids pendant un long moment",
        ToRaidUserBet: "VICTOIRE X{0}",
        TutorialDialogDoSpin: "Utilisez la machine à sous pour tourner, attaquer et raid les autres.",
        TutorialDialogGoSpin: "Vous n’avez pas assez de pièces...\n\nGlissez en bas pour gagner plus de pièces.",
        TutorialDialogSlotAttack: "Attaquez les Chambres d’autres joueurs pour obtenir des pièces.",
        TutorialDialogSlotRaid: "Raid le Chambre du roi et volez ses pièces !",
        TutorialDialogSlotRaidMaster: "Il s’agit du Roi\nAllons Le Raid !",
        TutorialDialogSlotShield: "Les boucliers protègeront votre Chambre des attaques.",
        TutorialDialogStar: "Montez le niveau de quelques objets puis vous obtiendrez une étoile\n\nCollectez 25 étoiles pour débloquer le prochaine Chambre.",
        TutorialFinishDes0: "Vos récompenses :",
        TutorialFinishDes1: "60 tours !",
        TutorialFinishDes1bind: "20 tours !",
        TutorialFinishDes2: "1M de pièces!",
        TutorialFinishDes3: "Sauvegardez votre progression !",
        TutorialFinishDes4: "Jouez avez vos amis !",
        TutorialFinishTitle: "Succès !",
        TutorialStartDes: "Bienvenue Mon Ami !\n\nAppuyez sur le bouton pour commencer votre travail.",
        TutorialStartTitle: "VOTRE PREMIER Chambre",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        TutorialTargetName: "Cible",
        TutorialTargetName1: "Leyla",
        TutorialTargetName2: "Mary",
        TutorialTargetName3: "Kevin",
        VillageCompleteNext: "Prochain",
        VillageCompleteTitle: "Chambre Terminé !",
        VillageShopBuy: "ACHETER",
        VillageShopComplete: "TERMINER !",
        VillageShopFix: "RÉPARER",
        VillageShopTitle: "Chambre EVOLVE",
        VipDailyRewardDes: "Obtenez ça TOUS LES JOURS !",
        VipExtraRewardButton: "TOUT OBTENIR",
        VipExtraRewardDes: "Débloquer le VIP pour obtenir TOUS les BONUS accumulés",
        VipGetTrialButtonDes1: "Commencer gratuitement",
        VipGetTrialButtonDes2: "3 jours d’essai, puis {0} par mois",
        VipGetWindowButtonMonth: "MOIS",
        VipGetWindowButtonWeek: "SEMAINE",
        VipGetWindowButtonYear: "ANNÉE",
        VipGetWindowDailyRecovery: "Limite de RÉCUPÉRATION",
        VipGetWindowDailySpe: "<outline color=#000000 width=1><color=#FFFFFF>Super apparence avec un <color=#ffba00>nom en rouge</color> et une <color=#ffba00>couronne</color>!</color></outline>",
        VipGetWindowDailyTitle: "Récompenses Journalières",
        VipGetWindowHot: "TOP",
        VipGetWindowPolicy: "<color=#d1acf3>Passez VIP pour le prix spécifié offre un abonnement, obtient des Tours, de la Nourriture et une Carte tous les jours. Il s’agit d’un <color=#35e35e><u><on click=\"handle\" param=.subtract\">Abonnement auto-renouvelable</on></u></c>. Le paiement est débité du compte téléphonique lors de la confirmation. <color=#d1acf3>L'abonnement est renouvelé à moins qu'il ne soit désactivé 24 heures avant la fin de la période, le compte sera également débité pour le renouvellement.</c> Vous pouvez le désactiver dans les Options de Compte. Toute partie non utilisée d'une période d'essai gratuite, si elle est offerte, sera perdue lorsque l'utilisateur achètera un abonnement à cette publication, le cas échéant. <color=#35e35e><u><on click=\"handle\" param=\"pri\">Politique de Confidentialité et Conditions d'Utilisation</on></u></c>.</c>",
        VipGetWindowRewardDes: "Obtenez des tours supplémentaires et des pièces dans activité de Machine à sous",
        VipGetWindowRewardRewards: "Récompenses",
        YES: "OUI",
        Yes: "OUI",
        adShieldTip: "Obtenez un bouclier gratuit !",
        and: "et",
        betMaxBet: "Pari Max x",
        cannon_get_reward_window_exchange: "Échange",
        cannon_get_reward_window_title: "Récompense d’Échange",
        cannon_item_window_btn_regain: "Re-gagner",
        cannon_item_window_btn_send: "Envoyer",
        cannon_item_window_title: "ÉCHANGE",
        cannon_main_window_no_ball: "Aucun Boulet de Canon !",
        cannon_main_window_refresh_check: "Utilisez l’anneau pour actualiser ? Il y a encore {0} boîtes !",
        cannon_main_window_refresh_time: "Actualisation Auto\n",
        cannon_meesage_window_collect: "<color=#F48B03>{0}</color><color=#7E4B27> vous a envoyé l’objet </color><color=#19B8B2>{1}</color>",
        cannon_message_window_no_message: "Aucun message.",
        cannon_message_window_send: "<color=#7E4B27>Vous envoyez à </color><color=#F48B03>{0}</color><color=#7E4B27> l’objet </color><color=#19B8B2>{1}</color>",
        cannon_message_window_title: "Message",
        cannon_name: "Canon",
        cannon_send_item_window_choosed_friend: "Ami Choisi :",
        cannon_send_item_window_choosed_item: "Objet Choisi :",
        cannon_send_item_window_send: "Envoyer",
        cannon_send_item_window_title: "Envoyer l’Objet : Choisir un Ami",
        cannon_shop_window_title: "Plus de Bombes ?",
        cannon_use_magic_item_window_cancel: "Annuler",
        cannon_use_magic_item_window_confirm: "Confirmer",
        collectionFreeChest: "COFFRE GRATUIT",
        communityCardNoCards: "Je n'ai pas reçu de cartes de \n vos amis",
        communityCommunity: "Communauté",
        facebookF: "f",
        gifts_collect: "Collecter",
        gifts_collect_all: "Tout Collecter / Envoyer",
        gifts_collect_all2: "Tout Collecter",
        gifts_collect_coins: "Pièces journalières collectées {0}/{1}",
        gifts_collect_spins: "Tours journaliers collectés {0}/{1}",
        gifts_default_explain: "Obtenir des Tours Gratuits",
        gifts_default_name: "Inviter des Amis",
        gifts_explain_card_cantcollect: "Vous devez atteindre le Chambre {0} pour collecter cette carte",
        gifts_explain_card_collect: "Vous a envoyé une carte",
        gifts_explain_card_send: "Envoyer des cartes\nà vos amis",
        gifts_explain_coin_collect: "Vous a envoyé {0} pièces",
        gifts_explain_coin_send: "Donner des pièces gratuites",
        gifts_explain_spin_collect: "Vous a envoyé {0} tour",
        gifts_explain_spin_send: "Cadeau un tour gratuit",
        gifts_invite: "Inviter",
        gifts_send: "Envoyer",
        gifts_tab0: "Tours Gratuits",
        gifts_tab1: "Pièces Gratuites",
        gifts_tab2: "Cartes",
        gifts_title: "Cadeaux",
        heist_main_window_cannot_buy: "Se débloque après l’achat de l’accord précédent",
        heist_main_window_free: "Gratuit",
        heist_main_window_title: "ACCEPTER CHAQUE ACCORD POUR RÉVÉLER DAVANTAGE",
        inviteNeedMoreSpins: "Besoin de plus de tours?",
        inviteUpper: "INVITER",
        invite_addnumber_type0: "+{0}",
        invite_invite: "INVITER",
        invite_lineA: "<color=#FFFFFF><outline color=#000000 width=1>Invitez des amis et obtenez</outline></color><color=#4aff5f><outline color=#000000 width=1> {0} free spins</outline></color><color=#FFFFFF><outline color=#000000 width=1>\n{0} tours gratuits</outline></color><color=#FFFFFF><outline color=#000000 width=1> pour chaque ami qui débloque son Chambre 2 !</color>",
        invite_lineApp: "<color=#FFFFFF><outline color=#000000 width=1>Invitez des amis et obtenez</outline></color><color=#4aff5f><outline color=#000000 width=1> {0} free spins</outline></color><color=#FFFFFF><outline color=#000000 width=1>\n{0} tours gratuits</outline></color><color=#FFFFFF><outline color=#000000 width=1> pour chaque ami qui se connecte en jeu !</color>",
        invite_note: "* Vous obtiendez une récompense après que votre ami se\nconnecte avec Facebook",
        invite_title: "Plus De Tours ?",
        jigsaw_friends_window_no_friends: "Aucun Ami.",
        jigsaw_friends_window_search_pre: "Chercher par nom d’ami",
        jigsaw_friends_window_send: "Envoyer",
        jigsaw_friends_window_title: "AMIS",
        jigsaw_news_window_news_collect: "<color=#F48B03>{0} </color><color=#7E4B27>Vous a envoyé la pièce</color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_news_send: "<color=#7E4B27>Vous envoyez à</color><color=#F48B03> {0} </color><color=#7E4B27>la pièce</color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_no_news: "Aucune Nouvelle.",
        jigsaw_news_window_title: "NOUVELLES",
        jigsaw_window_complete: "TOUT REMPLIR",
        jigsaw_window_send: "Envoyer",
        jigsaw_window_title: "PUZZLE",
        jigsaw_window_universal_tip: "Choisir une pièce à remplacer",
        jigsaw_window_use: "Utiliser",
        jigsaw_window_used: "Utilisé",
        loadResError: "chargement des ressources échoué. Réessayer ?",
        map_comming_soon: "À VENIR",
        map_title: "{0}. {1}",
        menu_0_play: "JOUER",
        menu_1_village: "Chambre",
        menu_2_buy: "ACHETER DES PIÈCES/TOURS",
        menu_3_daily: "BONUS JOURNALIER",
        menu_4_shop: "Chambre EVOLVE",
        menu_5_news: "MESSAGE",
        menu_6_gifts: "CADEAU",
        menu_7_card: "CARTE",
        menu_8_map: "CARTE",
        menu_9_leaderboard: "CLASSEMENT",
        menu_10_invite: "INVITER",
        menu_11_setting: "OPTIONS",
        menu_title: "MENU",
        messageNoMail: "Pas encore de courriels!",
        messageNoMessage: "Pas encore de messages!",
        mini_game_coinhit_btn_end: "Obtenir la Récompense",
        mini_game_coinhit_btn_next_round: "Prochain Tour",
        mini_game_coinhit_go: "GO !",
        mini_game_coinhit_info: "Un grand voyage pour gagner des\npièces, tours et coffres!",
        mini_game_coinhit_info_title: "LISTE DE RÉCOMPENSES",
        mini_game_coinhit_manual_end: "Oui pour gagner la récompense maintenant ! Obtenez {0} pièces, Obtenez {1} tours",
        mini_game_coinhit_manual_next_round: "Jeu planté ? Passer au prochain tour",
        mini_game_coinhit_rank_info: "Compte de Blocs Touchés : {0}",
        mini_game_coinhit_time: "Se termine dans {0}",
        mini_game_end: "Fin de Partie",
        mini_game_fail: "Chargement du jeu échoué, veuillez réessayer",
        mini_game_rank_window_no_ranks: "Aucun Rang",
        mini_game_rank_window_title: "CLASSEMENT",
        minigame_buy_ticket_window_title: "Plus de Tickets?",
        minigame_coinhit_second_title: "Ajustez l'angle de tir pour casser plus de blocs et obtenir de grosses récompenses !",
        minigame_coinhit_title: "Toucher et Gagner",
        minigame_gameover: "GameOver !",
        minigame_start_game: "COMMENCER",
        minigame_time: "Se termine dans {0}",
        multiplyX: "x",
        multiplyx: "x",
        quest_center_window_check: "Connexion",
        quest_center_window_check_do: "CONNEXION",
        quest_center_window_check_done: "CONNECTÉ",
        quest_center_window_daily: "Journalier",
        quest_center_window_daily_get: "Collecter",
        quest_center_window_daily_go: "ALLER",
        quest_center_window_day_1: "1 jour",
        quest_center_window_day_2: "2 jours",
        quest_center_window_day_3: "3 jours",
        quest_center_window_day_4: "4 jours",
        quest_center_window_day_5: "5 jours",
        quest_center_window_day_6: "6 jours",
        quest_center_window_day_7: "7 jours",
        quest_center_window_invite: "Inviter",
        quest_center_window_main_quest_goal_reward: "Objectif : {0}\nRécompense : {1}",
        quest_center_window_main_quest_name: "Quête Principale : {0}",
        quest_center_window_month_box_7: "7 jours",
        quest_center_window_month_box_14: "14 jours",
        quest_center_window_month_box_21: "21 jours",
        quest_center_window_month_box_28: "28 jours",
        quest_center_window_refresh_dialog: "Les missions sont actualisées chaque nouveau jour, veuillez ré-ouvrir la fenêtre",
        quest_center_window_refreshin: "Actualisation dans",
        quest_center_window_title: "Centre de Quête",
        revengeNoFriends: "Pas encore d'amis!",
        revenge_attack: "Attaquer",
        revenge_random: "Aléatoire",
        revenge_revenge: "Vengeance",
        revenge_title_attack: "Attaquez votre ami !",
        revenge_title_revenge: "Vengeance !",
        servantADFree: "LIBRE",
        settingLogOut: "Se déconnecter",
        settingUid: "Uid: ",
        settingVersion: "Version: ",
        setting_english: "Anglais",
        setting_general: "Général",
        setting_language: "Langue",
        setting_language_de: "Deutsch",
        setting_language_en: "English",
        setting_language_es: "Español",
        setting_language_fr: "Français",
        setting_language_title: "Langue",
        setting_language_zh: "中文",
        setting_like: "MENTION J’AIME",
        setting_likeus: "Mention j’aime et ne manquez pas\ndes évènements et cadeaux géniaux",
        setting_lowbattery: "Mode Économie d’Énergie",
        setting_lowbattery_tip: "Activez le Mode Économie d’Énergie réduira la consommation de batterie mais réduira les performances",
        setting_music: "Musique",
        setting_notifications: "Notifications",
        setting_privacy: "Termes et Confidentialité",
        setting_raid: "Raid et Attaque",
        setting_sound: "Son",
        setting_support: "Support",
        setting_terms: "Termes et Conditions",
        setting_title: "Options",
        setting_tutorial: "Tutoriel",
        shopBestSeller: "BEST-SELLER",
        shopCardInfoBuy: "Acheter",
        shopLevelBonus: "BONUS DE NIVEAU",
        slotServantAdTip: "Nourissez-moi !",
        villageTownReward: "Récompense de la ville",
        village_news_expire: "Expire dans {0}",
        village_news_log_hammer: "a attaqué votre Chambre",
        village_news_log_hammer_vip: "a attaqué votre Chambre",
        village_news_log_invite: "a rejoint Coin Room",
        village_news_log_invite_vip: "a rejoint Coin Room",
        village_news_log_noraid: "a échoué de vous voler {0}",
        village_news_log_noraid_vip: "<outline color=#FFFFFF width=2><color=#CC0905>{0}</color></outline><color=#662C1C> a échoué de vous voler {1} from you</color>",
        village_news_log_pig: "vous a volé {0}",
        village_news_log_pig_vip: "vous a volé {0}",
        village_news_log_shield: "a échoué d’attaquer votre Chambre",
        village_news_log_shield_vip: "a échoué d’attaquer votre Chambre",
        village_news_tab1: "Chambre",
        village_news_tab2: "Courrier",
        village_news_title: "Message",
        watch_coin: "+{0} Pièces",
        watch_get: "Regarder une vidéo et obtenir",
        watch_spin: "+{0} TOURS",
        watch_watch: "REGARDER",
        wxUserinfoDenyConfirm: "Aller à accès",
        wxUserinfoDenyDes: "Nous avons besoin de vos informations",
        wxUserinfoDenyTitle: "Besoin d’Autorisation",
        wxVersionNoSupport: "La fonction est actuellement incompatible avec votre version client, veuillez mettre à jour wechat."
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UIRoot.ts", ['cc', './Constant.ts', './Logs.ts', './wx_lib.ts', './UICantClick.ts', './_app.ts', './DialogWindow.ts', './ActivitySalePackWindow.ts', './ActivitySlotSymbolRankWindow.ts', './ActivitySlotSymbolRankInfoWindow.ts', './LoadingWindow.ts', './SdkManager.ts', './ActivityDaysSaleWindow.ts', './ActivitySpecialOfferWindow.ts', './BlackJackMainWindow.ts', './CannonMainWindow.ts', './HeistMainWindow.ts', './JigsawWindow.ts', './MinigameCoinhitMainWindow.ts', './CardGoldTradeWindow.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Camera, Prefab, _decorator, Component, view, rect, v3, instantiate, UITransform, Label, director, Vec3, tween, MyCustomEvent, Logs, wxTools, UICantClick, cce, DialogWindow, ActivitySalePackWindow, ActivitySlotSymbolRankWindow, ActivitySlotSymbolRankInfoWindow, LoadingWindow, SdkManager, ActivityDaysSaleWindow, ActivitySpecialOfferWindow, BlackJackMainWindow, CannonMainWindow, HeistMainWindow, JigsawWindow, MinigameCoinhitMainWindow, CardGoldTradeWindow, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Camera = module.Camera;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      Component = module.Component;
      view = module.view;
      rect = module.rect;
      v3 = module.v3;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
      Label = module.Label;
      director = module.director;
      Vec3 = module.Vec3;
      tween = module.tween;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      UICantClick = module.default;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      ActivitySalePackWindow = module.ActivitySalePackWindow;
    }, function (module) {
      ActivitySlotSymbolRankWindow = module.ActivitySlotSymbolRankWindow;
    }, function (module) {
      ActivitySlotSymbolRankInfoWindow = module.ActivitySlotSymbolRankInfoWindow;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      ActivityDaysSaleWindow = module.ActivityDaysSaleWindow;
    }, function (module) {
      ActivitySpecialOfferWindow = module.ActivitySpecialOfferWindow;
    }, function (module) {
      BlackJackMainWindow = module.BlackJackMainWindow;
    }, function (module) {
      CannonMainWindow = module.default;
    }, function (module) {
      HeistMainWindow = module.default;
    }, function (module) {
      JigsawWindow = module.default;
    }, function (module) {
      MinigameCoinhitMainWindow = module.default;
    }, function (module) {
      CardGoldTradeWindow = module.CardGoldTradeWindow;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "18ed9Tube5PmYdQMm/agHHA", "UIRoot", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const activityNameMap = {
        ActivitySpecialOfferWindow: ActivitySpecialOfferWindow,
        ActivityDaysSaleWindow: ActivityDaysSaleWindow,
        ActivitySalePackWindow: ActivitySalePackWindow,
        HeistMainWindow: HeistMainWindow,
        JigsawWindow: JigsawWindow,
        CannonMainWindow: CannonMainWindow,
        MinigameCoinhitMainWindow: MinigameCoinhitMainWindow,
        BlackJackMainWindow: BlackJackMainWindow,
        CardGoldTradeWindow: CardGoldTradeWindow,
        ActivitySlotSymbolRankWindow: ActivitySlotSymbolRankWindow,
        ActivitySlotSymbolRankInfoWindow: ActivitySlotSymbolRankInfoWindow
      };
      let UIRoot = exports('default', (_dec = property(UICantClick), _dec2 = property(Node), _dec3 = property(Camera), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Prefab), _dec12 = property(Node), _dec13 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class UIRoot extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "cantClick", _descriptor, this);

          _initializerDefineProperty(this, "loadingWindow", _descriptor2, this);

          _initializerDefineProperty(this, "mainCamera", _descriptor3, this);

          _initializerDefineProperty(this, "bl_top", _descriptor4, this);

          _initializerDefineProperty(this, "bl_bottom", _descriptor5, this);

          _initializerDefineProperty(this, "splashScreen", _descriptor6, this);

          _initializerDefineProperty(this, "dailyBonusNode", _descriptor7, this);

          _initializerDefineProperty(this, "gameNode", _descriptor8, this);

          _initializerDefineProperty(this, "interactionNode", _descriptor9, this);

          _initializerDefineProperty(this, "commonAssetsNode", _descriptor10, this);

          _initializerDefineProperty(this, "pbToast", _descriptor11, this);

          _initializerDefineProperty(this, "btnConsoleNode", _descriptor12, this);

          _initializerDefineProperty(this, "logNode", _descriptor13, this);

          _defineProperty(this, "canMultiWindow", ["DialogWindow", "GetRewardWindow", "SimpleRewardWindow"]);

          _defineProperty(this, "winSize", void 0);

          _defineProperty(this, "loadOver", void 0);

          _defineProperty(this, "winPres", void 0);

          _defineProperty(this, "windowInstance", void 0);

          _defineProperty(this, "currentWindowName", void 0);

          _defineProperty(this, "currentWindow", void 0);

          _defineProperty(this, "stopShowWindow", void 0);

          _defineProperty(this, "_prefapCacheMap", {});

          _defineProperty(this, "_inConsoleBtn", false);
        }

        onLoad() {
          let ssize = view.getVisibleSize();
          this.winSize = rect(0, 0, ssize.width, ssize.height); // if (ssize.height < 1136) {
          // 	cc.view.setResolutionPolicy(cc.ResolutionPolicy.FIXED_HEIGHT);
          // 	console.log(this.node.getComponent(cc.Canvas));
          // 	this.winSize = cc.rect(this.node.position.x, this.node.position.y, this.node.getComponent(cc.UITransform).width, this.node.getComponent(cc.UITransform).height);
          // 	// this.winSize.height = (1136 * ssize.width) / 640;
          // 	this.winSize.height = 1136;
          // 	this.winSize.width = (ssize.height / 1136) * 640;
          // 	cc.view.setDesignResolutionSize(640, 1136, cc.ResolutionPolicy.FIXED_HEIGHT);
          // 	console.log("visiableSize: ", cc.view.getVisibleSize());
          // }
          // this.bl_top.active = true
          // this.bl_bottom.active = true

          this.bl_top.setPosition(v3(this.bl_top.position.x, (ssize.height + this.winSize.height) / 2));
          this.bl_bottom.setPosition(v3(this.bl_bottom.position.x, (ssize.height - this.winSize.height) / 2));
          UIRoot.instance = this;
          globalThis.uiRoot = this;
          this.loadOver = true;
          this.winPres = {};
          /*this.loadOver = false
          let self = this
          cc.loader.loadResDir('window', cc.Prefab, function (err, winPres) {
          	winPres.forEach(function(winPre) {
          		self.winPres[winPre.name] = winPre
          	})
              
          	self.loadOver = true
          });*/

          this.windowInstance = {};
          this.currentWindowName = "";
          this.currentWindow = null;
          this.btnConsoleNode.active = appGame.isDev;
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.btnConsoleNode.active = appGame.isDev;
          }); // if(AppKit.SdkManager.IsNative()) {
          // }
          // cc.director.getScene().on(cc.Node.EventType.TOUCH_START, (event: cc.EventTouch) => {
          // 	if (TouchTest.isTouchInRect(event, this.btnConsoleNode)) {
          // 		this._inConsoleBtn = true;
          // 	}
          // }, this, true);
          // cc.director.getScene().on(cc.Node.EventType.TOUCH_END, (event: cc.EventTouch) => {
          // 	if (TouchTest.isTouchInRect(event, this.btnConsoleNode) && this._inConsoleBtn) {
          // 		this.openLog();
          // 		this._inConsoleBtn = false;
          // 	}
          // }, this, true);
          // this.node.on(cc.Node.EventType.TOUCH_START, () => { console.log("touched") }, this, true);
        }

        start() {}

        preloadWindow(windowName, callback) {
          console.log("preloadWindow: ", windowName);
          if (SdkManager.IsNative()) return;
          let windowPath = windowName;

          switch (windowName) {
            case "InviteWindow":
              windowPath = "Menu/InviteWindow";
              break;

            case "GiftsWindow":
              windowPath = "Menu/GiftsWindow";
              break;

            case "ShopWindow":
              windowPath = "Shop/ShopWindow";
              break;

            case "MenuWindow":
              windowPath = "Menu/MenuWindow";
              break;

            case "MainTutorialFinishWindow":
              windowPath = "Other/NewMainTutorialFinishWindow";
              break;

            case "GameMainWindow":
              break;

            case "TutorialWindow":
              windowPath = "Other/TutorialWindow";
              break;

            case "VillageShopWindow":
              windowPath = "Village/VillageShopWindow";
              break;

            case "MapWindow":
              windowPath = "Menu/NewMapWindow";
              break;
          }

          let resName = "window/" + windowPath;
          cce.loadRes(resName, Prefab, (err, winPre) => {
            if (err || !winPre) return;
            let wnd = instantiate(winPre); // wnd.parent = this.node

            wnd.x = 3000;
            wnd.y = 3000;
            wnd.getComponent(UITransform).width = 2;
            wnd.getComponent(UITransform).height = 2; // wnd.active = true

            this.scheduleOnce(() => {
              wnd.active = false;
              wnd.destroy();
              cce.releaseRes(resName, Prefab);
            }, 0.8);
            if (callback != null) callback(wnd);
          });
        } //显示主窗口


        openWindow(windowName, showParams) {
          console.log("openWindow: ", windowName);
          showParams = showParams || {};

          if (this.currentWindowName === windowName) {
            let _showParams = showParams || {};

            _showParams.isFirst = false;
            if (showParams != null && showParams.preshowCallback != null) showParams.preshowCallback();

            this.currentWindow._onWindowShow(_showParams);

            if (showParams != null && showParams.showCallback != null) showParams.showCallback(this.currentWindow);
            return;
          }

          this.ShowCantClick();

          let showWindow = winPre => {
            if (this.currentWindow != null) {
              this.currentWindow.close();
              this.currentWindow = null;
              if (wxTools.usewx) wx.triggerGC();
            }

            this.currentWindowName = windowName;
            if (showParams != null && showParams.preshowCallback != null) showParams.preshowCallback();
            let wnd = instantiate(winPre);
            let windowC = wnd.getComponent(this.currentWindowName);
            this.currentWindow = windowC;
            this.windowInstance[this.currentWindowName] = windowC;
            wnd.parent = this.node;
            wnd.getComponent(UITransform).setContentSize(this.winSize.width, this.winSize.height);
            windowC._windowName = this.currentWindowName;
            wnd.active = true;

            windowC._onWindowShow(showParams);

            if (showParams != null && showParams.showCallback != null) showParams.showCallback(windowC);
            this.CloseCantClick();
            Logs.Debug("Main Window Show", windowName, wnd.uuid);
          };

          if (this.winPres.hasOwnProperty(windowName)) {
            showWindow(this.winPres[windowName]);
          } else {
            let windowPath = windowName; // if (require(windowName).windowPath) windowPath = require(windowName).windowPath

            switch (windowName) {
              case "LoginWindow":
                windowPath = "NewLoginWindow";
                break;

              case "GameMainWindow":
                windowPath = "GameMainWindow";
                break;

              case "BlackJackMainWindow":
                windowPath = "Activity/blackjack/BlackJackMainWindow";
                break;

              case "CannonMainWindow":
                windowPath = "Activity/CannonMainWindow";
                break;

              case "MinigameCoinhitMainWindow":
                windowPath = "Activity/minigame/coinhit/MinigameCoinhitMainWindow";
                break;

              case "ServantWindow":
                windowPath = "Servant/NewServantWindow";
                break;
            }

            let resName = "window/" + windowPath;
            cce.loadRes(resName, Prefab, (err, winPre) => {
              if (err) {
                Logs.Error("openWindow windowPath" + windowPath + (err.message || err));
                DialogWindow.Show(i18n.t("loadResError"), () => {
                  this.openWindow(windowName, showParams);
                });
                this.CloseCantClick();
                return;
              }

              if (winPre == null) {
                this.CloseCantClick();
                return;
              }

              this._prefapCacheMap[winPre.name] = winPre;
              winPre.data.active = false;
              if (!SdkManager.IsNative()) this.winPres[windowName] = winPre;
              showWindow(winPre);
            });
          }
        } //显示子窗口


        openChildWindow(windowName, showParams, parent) {
          if (!this._prefapCacheMap[windowName.name]) {
            LoadingWindow.ShowAfterDelay(500);
          }

          if (typeof windowName === "string") {
            windowName = activityNameMap[windowName];
          }

          console.log("openChildWindow: ", windowName.name + ": " + windowName.windowPath);

          if (showParams && showParams["msg"]) {
            console.log(showParams["msg"]);
          }

          if (!(windowName.name && windowName.windowPath)) return;
          showParams = showParams || {};

          if (!~this.canMultiWindow.indexOf(windowName.name) && this.windowInstance[windowName.name] != null) {
            let _showParams = showParams || {};

            _showParams.isFirst = false;
            if (showParams != null && showParams.preshowCallback != null) showParams.preshowCallback();
            this.windowInstance[windowName.name].show(_showParams);
            if (showParams != null && showParams.showCallback != null) showParams.showCallback(this.windowInstance[windowName.name]);
            return this.windowInstance[windowName.name];
          }

          this.windowInstance[windowName.name] = {
            isFake: true,
            show: function () {},
            close: function () {}
          };
          this.ShowCantClick();

          let showWindow = async winPre => {
            if (this.stopShowWindow) {
              this.CloseCantClick();
              return;
            }

            if (showParams != null && showParams.preshowCallback != null) showParams.preshowCallback();
            let wnd = instantiate(winPre);
            let windowC = wnd.getComponent(windowName);
            this.windowInstance[windowName.name] = windowC;

            this.currentWindow._onAddChildWindow(windowC);

            wnd.parent = !!parent ? parent : this.node;
            wnd.getComponent(UITransform).setContentSize(this.winSize.width, this.winSize.height);
            windowC._windowName = windowName.name;
            windowC.isChild = true;
            windowC.parentWindow = this.currentWindow;
            wnd.active = true;

            windowC._onWindowShow(showParams);

            if (showParams != null && showParams.showCallback != null) showParams.showCallback(windowC);
            this.CloseCantClick();
            LoadingWindow.Hide();
            Logs.Debug("Child Window Show", windowName, wnd.uuid);
          };

          if (this.winPres.hasOwnProperty(windowName.name)) {
            showWindow(this.winPres[windowName.name]);
          } else {
            let windowPath = windowName.windowPath;
            if (windowName.windowPath) windowPath = windowName.windowPath;
            let resName = "window/" + windowPath;
            cce.loadRes(resName, Prefab, (err, winPre) => {
              if (err) {
                Logs.Error("openChildWindow windowPath" + windowPath + (err.message || err));
                DialogWindow.Show(i18n.t("loadResError"), () => {
                  this.openChildWindow(windowName, showParams);
                });
                this.CloseCantClick();
                return;
              }

              if (winPre == null) {
                this.CloseCantClick();
                return;
              }

              this._prefapCacheMap[windowName.name] = winPre;
              winPre.data.active = false;
              if (!SdkManager.IsNative()) this.winPres[windowName.name] = winPre;
              showWindow(winPre);
            });
          }
        } //显示模版窗口


        openModelWindow(windowName, showParams) {
          console.log("openModelWindow： ", windowName + ": " + windowName.windowPath);
          showParams = showParams || {};

          if (!~this.canMultiWindow.indexOf(windowName) && this.windowInstance[windowName] != null) {
            let _showParams = showParams || {};

            _showParams.isFirst = false;
            if (showParams != null && showParams.preshowCallback != null) showParams.preshowCallback();
            this.windowInstance[windowName].show(_showParams);
            if (showParams != null && showParams.showCallback != null) showParams.showCallback(this.windowInstance[windowName]);
            return this.windowInstance[windowName];
          }

          this.windowInstance[windowName] = {
            isFake: true,
            show: function () {},
            close: function () {}
          };
          this.ShowCantClick();

          let showWindow = function (winPre) {
            if (this.stopShowWindow) {
              this.CloseCantClick();
              return;
            }

            if (showParams != null && showParams.preshowCallback != null) showParams.preshowCallback();
            let wnd = instantiate(winPre);
            let windowC = wnd.getComponent(windowName);
            this.windowInstance[windowName] = windowC;
            wnd.parent = this.node;
            wnd.getComponent(UITransform).setContentSize(this.winSize.width, this.winSize.height);
            windowC._windowName = windowName;
            windowC.isChild = true;
            wnd.active = true;

            windowC._onWindowShow(showParams);

            if (showParams != null && showParams.showCallback != null) showParams.showCallback(windowC);
            this.CloseCantClick();
            Logs.Debug("Model Window Show", windowName, wnd.uuid);
          }.bind(this);

          if (this.winPres.hasOwnProperty(windowName)) {
            showWindow(this.winPres[windowName]);
          } else {
            let windowPath = windowName; // if (require(windowName).windowPath) windowPath = require(windowName).windowPath

            switch (windowName) {
              case "FullLoadingWindow":
                windowPath = "Common/FullLoadingWindow";
                break;
            }

            let resName = "window/" + windowPath;
            cce.loadRes(resName, Prefab, (err, winPre) => {
              if (err) {
                Logs.Error("openModelWindow windowPath" + windowPath + (err.message || err));
                DialogWindow.Show(i18n.t("loadResError"), () => {
                  this.openModelWindow(windowName, showParams);
                }, nullFunction);
                this.CloseCantClick();
                return;
              }

              if (winPre == null) {
                this.CloseCantClick();
                return;
              }

              this._prefapCacheMap[winPre.name] = winPre;
              winPre.data.active = false;
              if (!SdkManager.IsNative()) this.winPres[windowName] = winPre;
              showWindow(winPre);
            });
          }
        } //关闭子窗口


        closeChildWindow(windowName) {
          if (this.windowInstance.hasOwnProperty(windowName)) {
            if (this.windowInstance[windowName] != null) {
              this.windowInstance[windowName].close();
            }
          }
        }

        GetWindow(windowName) {
          if (this.windowInstance.hasOwnProperty(windowName)) {
            if (this.windowInstance[windowName] != null) {
              return this.windowInstance[windowName];
            }
          }

          return null;
        }

        ShowCantClick(noloading) {
          this.cantClick.show(noloading);
        }

        CloseCantClick() {
          this.cantClick.close();
        }

        ScreenShake() {
          var _homeView;

          let t = 0.03;
          let d = 6;
          (_homeView = homeView) === null || _homeView === void 0 ? void 0 : _homeView.node.runAction(ccAction.sequence(ccAction.moveBy(t, d, -d), ccAction.moveBy(t, -d, -d), ccAction.moveBy(t, -d, d), ccAction.moveBy(t, d, d), ccAction.moveBy(t, d, -d), ccAction.moveBy(t, -d, -d), ccAction.moveBy(t, -d, d), ccAction.moveBy(t, d, d), ccAction.moveBy(t, d, -d), ccAction.moveBy(t, -d, -d), ccAction.moveBy(t, -d, d), ccAction.moveBy(t, d, d), ccAction.moveBy(t, d, -d), ccAction.moveBy(t, -d, -d), ccAction.moveBy(t, -d, d), ccAction.moveBy(t, d, d)));
        }

        toast(str) {
          const toastNode = instantiate(this.pbToast);
          toastNode.getComponent(Label).string = str;
          director.getScene().getChildByName("Canvas").addChild(toastNode);
          toastNode.setPosition(new Vec3(0, -50, 0));
          tween(toastNode).by(1, {
            y: 150,
            opacity: -255
          }).call(() => {
            toastNode.destroy();
          }).start();
        }

        openLog() {
          if (appGame.isDev) {
            this.logNode.active = true;
          }
        }

      }, _defineProperty(_class3, "instance", null), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "cantClick", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "loadingWindow", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "mainCamera", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "bl_top", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "bl_bottom", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "splashScreen", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "dailyBonusNode", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "gameNode", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "interactionNode", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "commonAssetsNode", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "pbToast", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "btnConsoleNode", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "logNode", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GameMainWindow.ts", ['cc', './Constant.ts', './ShieldAnim.ts', './global.ts', './_app.ts', './EnterCloseAnim.ts', './SoundManager.ts', './UIWindow.ts', './Content.ts', './User.ts', './DailyBonusNode.ts', './UserInfoModel.ts', './InvitedNewUserWindow.ts', './SdkManager.ts', './VillageFinishWindow.ts', './SR.ts', './CardChestOpenWindow.ts', './ShopWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './LeaderBoardWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Button, Label, RichText, Node, _decorator, Widget, Vec3, tween, v3, instantiate, easing, SlotTypes, ShieldAnim, G, cce, EnterCloseAnim, SoundManager, UIWindow, Content, User, DailyBonusNode, UserInfoModel, InvitedNewUserWindow, SdkManager, VillageFinishWindow, SR, CardChestOpenWindow, ShopWindow, UIRoot, ActivityManager, Game, Meta, LogEventWrap, ADWrap, LeaderBoardWrap, GameKit, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Button = module.Button;
      Label = module.Label;
      RichText = module.RichText;
      Node = module.Node;
      _decorator = module._decorator;
      Widget = module.Widget;
      Vec3 = module.Vec3;
      tween = module.tween;
      v3 = module.v3;
      instantiate = module.instantiate;
      easing = module.easing;
    }, function (module) {
      SlotTypes = module.SlotTypes;
    }, function (module) {
      ShieldAnim = module.default;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      User = module.User;
    }, function (module) {
      DailyBonusNode = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      InvitedNewUserWindow = module.InvitedNewUserWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      VillageFinishWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      LeaderBoardWrap = module.LeaderBoardWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "19473tM4glIOpx/qybgAtvi", "GameMainWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let GameMainWindow = exports('default', (_dec = property(UserInfoModel), _dec2 = property(Button), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(EnterCloseAnim), _dec6 = property(UserInfoModel), _dec7 = property(RichText), _dec8 = property([Node]), _dec9 = property(ShieldAnim), _dec10 = property(Node), _dec11 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class GameMainWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "userinfo", _descriptor, this);

          _initializerDefineProperty(this, "btnCoinAdd", _descriptor2, this);

          _initializerDefineProperty(this, "labelCoin", _descriptor3, this);

          _initializerDefineProperty(this, "labelStar", _descriptor4, this);

          _initializerDefineProperty(this, "spMessage", _descriptor5, this);

          _initializerDefineProperty(this, "spriteMessageUser", _descriptor6, this);

          _initializerDefineProperty(this, "labelMessageMsg", _descriptor7, this);

          _initializerDefineProperty(this, "adshields", _descriptor8, this);

          _initializerDefineProperty(this, "adshieldAnim", _descriptor9, this);

          _initializerDefineProperty(this, "adshieldTip", _descriptor10, this);

          _initializerDefineProperty(this, "adShieldNode", _descriptor11, this);

          _defineProperty(this, "updateActivityInterval", void 0);

          _defineProperty(this, "spinadShowBtnI", void 0);

          _defineProperty(this, "coinadShowBtnI", void 0);

          _defineProperty(this, "oldStar", 0);

          _defineProperty(this, "hasShowMessage", void 0);

          _defineProperty(this, "oldADShield", void 0);

          _defineProperty(this, "adshieldTipSTI", void 0);
        }

        onLoad() {
          this.node.getComponent(Widget).top = AppMain.instance.statusBarHeight;
          this.node.getComponent(Widget).updateAlignment();
          GameMainWindow.instance = this;
        }

        onShow() {
          this.userinfo.show(Game.SUser);
          this.adshieldAnim.stop();
          this.updateADShieldTip(true);
          this.oldStar = Game.SUser.Star();

          if (this.btnCoinAdd) {
            this.btnCoinAdd.node.on("click", this.openShopWindow, this);
          }

          this.updateADShield();
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ShieldEvent, "GameMainWindow", () => {
            this.updateADShield();
          });
          if (!ADWrap.AdEnabled()) this.adShieldNode.active = false;

          if (homeView.slotNode && homeView.slotNode.spinResult) {
            if (homeView.slotNode.spinResult.type === SlotTypes.Attack || homeView.slotNode.spinResult.type === SlotTypes.Raid) {
              this.node.active = false;
            }
          }
        }

        onClose() {
          GameMainWindow.instance = null;
          this.userinfo.onClose();
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.CoinEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ApEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.VillageEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.MessageEvent, "GameMainWindow");
          GameKit.WebEvent.UnRegisterEvent(GameKit.GameEvent.EventName.MessageEventInvitedUnlock, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.GiftEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.StatusEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.PresentEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ShieldEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.CardEvent, "GameMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.TaskCompleteCount, "GameMainWindow");

          if (this.updateActivityInterval) {
            clearInterval(this.updateActivityInterval);
            this.updateActivityInterval = null;
          }

          if (this.spinadShowBtnI) {
            clearInterval(this.spinadShowBtnI);
            this.spinadShowBtnI = null;
          }

          if (this.coinadShowBtnI) {
            clearInterval(this.coinadShowBtnI);
            this.coinadShowBtnI = null;
          }

          this.updateADShieldTip(true);
        } //隐藏


        hideUI(anim) {
          if (!anim) {
            homeView.slotPage.activityLeft.active = false;
            homeView.slotPage.activityRight.active = false;
            this.adshieldTip.runAction(ccAction.scaleTo(0.01, 0.001, 0.001));
          } else {
            // EnterCloseAnim.playClose(this.spPublics);
            EnterCloseAnim.playClose(homeView.slotPage.activityLeft);
            EnterCloseAnim.playClose(homeView.slotPage.activityRight);
            this.adshieldTip.runAction(ccAction.scaleTo(0.3, 0.001, 0.001));
          }
        }

        showUI(anim) {
          if (!anim) {
            // this.spPublics.active = true;
            homeView.slotPage.activityLeft.active = true;
            homeView.slotPage.activityRight.active = true;
          } else {
            // EnterCloseAnim.playEnter(this.spPublics);
            EnterCloseAnim.playEnter(homeView.slotPage.activityLeft);
            EnterCloseAnim.playEnter(homeView.slotPage.activityRight);
          }
        }

        showStar(fst) {
          if (fst) {
            let star = fst;
            this.labelStar.string = GameKit.StringUtil.formatNumber(star);
            this.labelStar.node.stopAllActions();
            this.labelStar.node.scale = Vec3.ONE;
            this.oldStar = star;
            return;
          }

          let star = Game.SUser.Star();
          this.oldStar += 1;
          this.labelStar.string = GameKit.StringUtil.formatNumber(this.oldStar < star ? this.oldStar : star);
          tween(this.labelStar.node).to(0.15, {
            scale: v3(1.2, 1.2, 1.2)
          }).to(0.15, {
            scale: Vec3.ONE
          }).start();
          LeaderBoardWrap.setScore("User_Star", this.oldStar);
        } //显示下方消息


        showMessage(data) {
          if (data == null) return;
          if (this.hasShowMessage) return;
          this.hasShowMessage = true;
          this.spriteMessageUser.show(new User().updateData(data["user"])); // 不同界面的信息域内容不同，因此要根据界面调整User信息域与界面信息的处理
          // avatar.spriteFrame = this.default_avatar_sf

          let isVip = data["user"]["isVip"] && !G.GameConfig.closeVIP && SdkManager.IsNative();

          switch (data["type"]) {
            case "attack":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_hammer"), data["user"]["name"]);
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_hammer_vip"), data["user"]["name"]);
              break;

            case "shield":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield"), data["user"]["name"]);
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield_vip"), data["user"]["name"]);
              break;

            case "raid":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_pig"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_pig_vip"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));
              break;

            case "invitedUnlock":
              UIRoot.instance.openChildWindow(InvitedNewUserWindow, {
                data: data
              });
              this.hasShowMessage = false;
              return;

            case "servant1":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_pig"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_pig_vip"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));
              break;

            case "servant2":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_hammer"), data["user"]["name"]);
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_hammer_vip"), data["user"]["name"]);
              break;

            case "servant3":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield"), data["user"]["name"]);
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield_vip"), data["user"]["name"]);
              break;

            case "servant4":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_noraid"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_noraid_vip"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));
              break;

            case "superShield":
              this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield"), data["user"]["name"]);
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield_vip"), data["user"]["name"]);
              break;

            case "superShieldGold":
              if (data["number"] > 1) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_noraid"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_noraid_vip"), data["user"]["name"], GameKit.StringUtil.formatNumber(data["number"]));else this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield"), data["user"]["name"]);
              if (isVip) this.labelMessageMsg.string = String.format(i18n.t("village_news_log_shield_vip"), data["user"]["name"]);
              break;

            default:
              this.hasShowMessage = false;
              return;
          }

          UIRoot.instance.ScreenShake();
          this.spMessage.enterAnim(() => {
            this.scheduleOnce(() => {
              this.spMessage.closeAnim(() => {
                this.hasShowMessage = false;
              });
            }, 3);
          });
        } // ADShield


        updateADShield() {
          if (this.oldADShield != null && Game.SUser.ADShield() > this.oldADShield) ;else {
            for (var i = 0; i < 3; i++) {
              this.adshields[i].active = i < Game.SUser.ADShield();
            }
          }
          this.oldADShield = Game.SUser.ADShield();
          this.adShieldNode.getChildByName("flash").active = Game.SUser.ADShield() < G.GameConstance.shieldMax;
        }

        watchADShield() {
          if (!ADWrap.AdEnabled()) return;
          if (homeView.isBusy()) return;
          if (Game.SUser.ADShield() >= G.GameConstance.shieldMax) return;
          ADWrap.ShowVideo(() => {
            let req = SR.SRUserData.finishVideoShield();
            req.SetCallBack(() => {
              const endWorldPos = this.adshields[Game.SUser.ADShield() - 1].getWorldPosition();
              const endLoaclPos = new Vec3();
              this.adshieldAnim.node.parent.inverseTransformPoint(endLoaclPos, endWorldPos);
              const adsd = Game.SUser.ADShield();
              const newADShieldAnim = instantiate(this.adshieldAnim.node);
              this.adshieldAnim.node.parent.addChild(newADShieldAnim);
              newADShieldAnim.active = true;
              tween(newADShieldAnim.getChildByName("glow2")).set({
                scale: Vec3.ZERO
              }).to(0.2, {
                scale: new Vec3(1.2, 1.2, 1.2)
              }, {
                easing: easing.backOut
              }).start();
              tween(newADShieldAnim.getChildByName("shield")).set({
                scale: Vec3.ZERO
              }).to(0.2, {
                scale: Vec3.ONE
              }, {
                easing: easing.backOut
              }).start();
              tween(newADShieldAnim).parallel(tween(newADShieldAnim).to(0.8, {
                position: endLoaclPos
              }), tween(newADShieldAnim).to(0.8, {
                scale: v3(0, 0, 0)
              }, {
                easing: easing.quartIn
              })).call(() => {
                const sh = this.adshields[adsd - 1];
                tween(sh).set({
                  active: true,
                  scale: new Vec3(0.01, 0.01, 0.01)
                }).to(0.2, {
                  scale: Vec3.ONE
                }, {
                  easing: easing.backOut
                }).start();
                SoundManager.playSound("shiled_added");
                setTimeout(() => {
                  newADShieldAnim.destroy();
                }, 100);
              }).start(); // let x = -47.1 + 35 * Game.SUser.ADShield() - this.adshieldAnim.node.parent.position.x;
              // let y = -1.3 - this.adshieldAnim.node.parent.position.y;
              // let adshieldAnimNode = cc.instantiate(this.adshieldAnim.node);
              // adshieldAnimNode.parent = this.adshieldAnim.node.parent;
              // adshieldAnimNode.setPosition(cc.v3(this.adshieldAnim.node.position.x, this.adshieldAnim.node.position.y));
              // let adshieldAnim = adshieldAnimNode.getComponent(ShieldAnim);
              // let adsd = Game.SUser.ADShield();
              // adshieldAnim.play(x, y, 1, () => {
              // 	let sh = this.adshields[adsd - 1];
              // 	sh.active = true;
              // 	sh.scale = cc.v3(0.001, 0.001, 1);
              // 	sh.runAction(ccAction.scaleTo(0.2, 1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
              // 	SoundManager.playSound("shiled_added");
              // 	setTimeout(() => {
              // 		adshieldAnim.destroy();
              // 	}, 100);
              // });

              this.oldADShield = adsd;
            });
            req.Send();
            this.updateADShieldTip(true);
            this.adshieldTipSTI = setTimeout(() => {
              this.adshieldTipSTI = null;
              this.updateADShieldTip();
            }, 150000);
          }, "watchShieldAd");
        }

        updateADShieldTip(onlyCancel) {
          if (!this.node) return;

          if (this.adshieldTip.scale.x != 0.001) {
            GameKit.DataCache.SetData("ADTipsBubblePopup", false);
          }

          this.adshieldTip.scale = v3(0.001, 0.001, 1);
          this.adshieldTip.stopAllActions();

          if (this.adshieldTipSTI != null) {
            clearTimeout(this.adshieldTipSTI);
            this.adshieldTipSTI = null;
          }

          if (onlyCancel) {
            return;
          }

          if (Game.SUser.ADShield() >= G.GameConstance.shieldMax) {
            this.scheduleOnce(() => {
              this.updateADShieldTip();
            }, 3600);
            return;
          }

          if ((!homeView || !homeView.interactionNode || !homeView.interactionNode.user) && !GameKit.DataCache.GetData("ADTipsBubblePopup") && ADWrap.IsVideoPrepared()) {
            GameKit.DataCache.SetData("ADTipsBubblePopup", true);
            this.adshieldTip.runAction(ccAction.sequence(ccAction.scaleTo(0.3, 1, 1), ccAction.delayTime(10), ccAction.scaleTo(0.3, 0.001, 0.001), ccAction.callFunc(() => {
              GameKit.DataCache.SetData("ADTipsBubblePopup", false);
              this.adshieldTipSTI = setTimeout(() => {
                this.adshieldTipSTI = null;
                this.updateADShieldTip();
              }, 150000);
            })));
          } else {
            this.scheduleOnce(() => {
              this.updateADShieldTip();
            }, 3);
          }
        } // Helper


        async OnMapFinished() {
          //延迟等star飞完成
          await cce.wait(1000); //buildking

          const contents = Content.Merge(Content.FromStrings(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.BuildMaster, Game.SUserVillage.MapId())));
          await homeView.villagePage.showBuildingKingReward(contents);
          homeView.villagePage.node.getChildByName("container").getChildByName("UI").active = false;
          let chain = new GameKit.ChildWindowChain();
          let chest = GameKit.DataCache.GetData("UserCardChest");
          chain.add(CardChestOpenWindow, () => {
            if (chest) {
              GameKit.DataCache.RemoveData("UserCardChest");
              return true;
            }

            return false;
          }, {
            chest: chest
          });
          chain.setFinishFunc(() => {
            UIRoot.instance.openChildWindow(VillageFinishWindow);
          });
          chain.start();
          homeView.slotPage.updateActivityButton();
          ActivityManager.logined();
          homeView.slotPage.btnLevelBonus.node.active = Game.SUserVillage.MapId() >= 2;
          homeView.slotPage.btnServant.node.active = Game.SUserVillage.MapId() >= 2;
          homeView.slotNode.updatePeterPosition();
        }

        openShopWindow() {
          if (homeView.isBusy()) return;

          let moveFunc = async () => {
            await cce.wait(100);
            homeView.pageViewController.moveToPage(G.Pages.Shop, true);
            await cce.wait(1000);
            homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.coin);
            LogEventWrap.logEvent("openshop_coin");
          };

          const dailyBonus = uiRoot.dailyBonusNode.getComponentInChildren(DailyBonusNode);

          if (dailyBonus) {
            dailyBonus.closeAnim(() => {
              moveFunc();
            });
          } else {
            moveFunc();
          }
        }

        hideUserInfoNode() {
          this.userinfo.node.active = false;
        }

        showUserInfoNode() {
          this.userinfo.node.active = true;
        }

      }, _defineProperty(_class3, "instance", null), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "userinfo", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnCoinAdd", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelCoin", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelStar", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spMessage", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "spriteMessageUser", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelMessageMsg", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "adshields", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "adshieldAnim", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "adshieldTip", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "adShieldNode", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardModelChestOpen.ts", ['cc', './CardModel.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, dragonBones, _decorator, tween, Vec3, easing, instantiate, Color, CardModel, Meta;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      dragonBones = module.dragonBones;
      _decorator = module._decorator;
      tween = module.tween;
      Vec3 = module.Vec3;
      easing = module.easing;
      instantiate = module.instantiate;
      Color = module.Color;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "194f480pgxFD54lOPqMvMEy", "CardModelChestOpen", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CardModelChestOpen = exports('CardModelChestOpen', (_dec = ccclass('CardModelChestOpen'), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(dragonBones.ArmatureDisplay), _dec5 = property(Node), _dec(_class = (_class2 = (_temp = class CardModelChestOpen extends CardModel {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "newIconNode", _descriptor, this);

          _initializerDefineProperty(this, "highLightWhite", _descriptor2, this);

          _initializerDefineProperty(this, "dbLight", _descriptor3, this);

          _initializerDefineProperty(this, "starPrefab", _descriptor4, this);

          _defineProperty(this, "_activeStars", []);

          _defineProperty(this, "_starsWorldPos", []);

          _defineProperty(this, "_resumeIndex", 0);
        }

        show(id, type = "check", isNewCard) {
          // 获取数据
          this.type = type;
          this.card_meta = Meta.MetaManager.GetMeta(Meta.MetaType.Card, id);
          this.set_meta = Meta.MetaManager.GetMeta(Meta.MetaType.CardSets, this.card_meta.SetId()); // 修改样式

          this.show_border(type);
          this.show_card(type);
          this.show_name(type);
          this.show_rare(type);
          this.show_bg_title(type);
          this.show_bg(type, isNewCard);
          this.highLightWhite.opacity = 0;
        }

        show_rare(type) {
          this.layout_rare.node.children.forEach((rare, index) => {
            if (index >= this.card_meta.Rare()) {
              rare.active = false;
            } else {
              this._activeStars.push(rare);
            }
          });
        }

        starBlinkAnim(index) {
          this._resumeIndex = index + 1;
          return new Promise(resolve => {
            const star = this._activeStars[index];
            const worldPos = star.getWorldPosition();
            this._starsWorldPos[index] = worldPos;
            tween(star).to(0.07, {
              scale: new Vec3(2, 2, 2)
            }, {
              easing: easing.quartOut
            }).to(0.035, {
              scale: Vec3.ONE
            }, {
              easing: easing.quartOut
            }).call(() => {
              resolve(null);
            }).start();
          });
        }

        async starFlyAnim(startNode, endNode, startIndex, endIndex, owner, isInterrupt = false) {
          let endPos = new Vec3();
          let startPos = new Vec3();

          let fly = i => {
            return new Promise(resolve => {
              if (!startNode.active || !endNode.active) {
                resolve(null);
                return;
              }

              startNode.inverseTransformPoint(endPos, endNode === null || endNode === void 0 ? void 0 : endNode.getWorldPosition());
              const newStar = instantiate(this.starPrefab);
              startNode.addChild(newStar);
              startNode.inverseTransformPoint(startPos, this._starsWorldPos[i]);
              newStar.active = true;
              newStar.setPosition(startPos);

              if (isInterrupt) {
                newStar.setScale(new Vec3(0.37, 0.37, 0.37));
              } else {
                newStar.setScale(new Vec3(0.37 * 0.86 * 1.5, 0.37 * 0.86 * 1.5, 0.37 * 0.86 * 1.5));
              }

              tween(newStar).parallel(tween().delay(0.2).call(resolve), tween().to(0.8, {
                position: endPos
              }, {
                easing: easing.backIn
              }), tween().to(0.8, {
                scale: Vec3.ONE
              }, {
                easing: easing.linear
              })).call(() => {
                newStar.destroy();
                owner.playStarCountIncreaseAnim();
              }).start();
            });
          };

          for (let index = endIndex - 1; index >= startIndex; index--) {
            await fly(index);
          }
        }

        show_iconNew(isNew) {
          this.newIconNode.active = isNew;
        }

        showHighLight() {
          this.highLightWhite.active = true;
          tween(this.highLightWhite).to(0.5, {
            opacity: 255
          }).start();
        }

        hideHighLight() {
          tween(this.highLightWhite).to(0.2, {
            opacity: 0
          }).call(() => {
            this.highLightWhite.active = false;
          }).start();
        }

        showNewCardBgLight() {
          this.dbLight.node.active = true;

          if (this.card_meta.Golden()) {
            this.dbLight.playAnimation("card_gold", 0);
          } else {
            this.dbLight.playAnimation("card_normal");
          }

          this.dbLight.timeScale = 1;
        }

        hideNewCardBgLight() {
          this.dbLight.timeScale = 0;
          this.dbLight.node.active = false;
        }

        show_bg_title(type) {
          if (!this.sp_title_bg) {
            return;
          } // bg颜色


          this.sp_title_bg.node.color = new Color(this.set_meta.Color());
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "newIconNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "highLightWhite", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "dbLight", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "starPrefab", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRActivity.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRActivity', void 0);

      cclegacy._RF.push({}, "194ffnMmTtNeJ63KhUOWcj8", "SRActivity", undefined);

      let SRActivity;

      (function (_SRActivity) {
        function getUserActivity() {
          let req = new GameKit.ServerRequest("getUserActivity");
          req.SetCallBack(function (res) {
            Game.SUserActivity.updateData(res.userdata);
          });
          return req;
        }

        _SRActivity.getUserActivity = getUserActivity;
      })(SRActivity || (SRActivity = exports('SRActivity', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FriendsModel.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './UserInfoModel.ts', './ScrollViewTool.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, EditBox, _decorator, v3, CCE_Component, CCEaseTypes, UserInfoModel, ScrollViewTool, Game, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      EditBox = module.EditBox;
      _decorator = module._decorator;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1a62dKGo6xKRrAhEq/3lk3l", "FriendsModel", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      /**
       * friends-model,根据JigsawFriendsWindow改编
       * - [使用方式] 直接复制prefab,修改实例node;或者挂载此脚本,拖入对应的资源;调用init方法传入2个参数:附加的svt初始化函数,friend列表
       * - [注意] 依赖UserInfoModel来实现对friend-user的显示
       */

      let FriendsModel = exports('default', (_dec = property(ScrollViewTool), _dec2 = property(Node), _dec3 = property(EditBox), _dec4 = property(Node), ccclass(_class = (_class2 = (_temp = class FriendsModel extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "f_svt", void 0);

          _defineProperty(this, "friend_list", []);

          _defineProperty(this, "name_list", []);

          _initializerDefineProperty(this, "svt", _descriptor, this);

          _initializerDefineProperty(this, "no_friends", _descriptor2, this);

          _initializerDefineProperty(this, "edit_box", _descriptor3, this);

          _initializerDefineProperty(this, "sp_search_end", _descriptor4, this);
        }
        /**
         * 初始化
         * @param {(index:number,id:number,node:cc.Node,friend_data:User)=>void} f_svt svt的初始化附加函数
         * @param {User[]} friend_list friend列表;默认为Game.SUser.FriendsList()
         */


        init(f_svt, friend_list = Game.SUser.FriendsList()) {
          // 保存数据
          this.f_svt = f_svt;
          this.friend_list = friend_list;

          for (let id in this.friend_list) {
            this.name_list.push(this.friend_list[id].Name());
          } // 刷新样式


          this.sp_search_end.active = false;
          this.create_svt();
        }
        /** @type {{[key:string]:User}} friends列表 */

        /** 创建svt */


        create_svt() {
          let id_list = [];

          for (let id in this.friend_list) {
            id_list.push(id);
          }

          this.no_friends.active = this.name_list.length === 0;
          this.svt.setItem(id_list, (index, id, node) => {
            // 获取数据
            let friend_data = this.friend_list[id]; // 基础初始化

            let userinfo = GameKit.ControllerTable.GetNode(node, "userinfo").getComponent(UserInfoModel);
            userinfo.show(friend_data); // 附加初始化

            this.f_svt(index, id, node, friend_data);
          });
        } // search-box,需要在编辑器中挂载两个event

        /** @type {cc.EditBox} */

        /** editbox中的字符串改变调用，表示正在输入中 */


        event_search_change_key() {
          this.sp_search_end.active = false;
        }

        event_search() {
          // 搜索结果
          let key = this.edit_box.string; // 根据结果重新渲染;考虑name和items一一对应

          let count = 0;
          this.name_list.forEach((v, index) => {
            let item = this.svt.items[index];

            if (item) {
              // 大小写敏感
              // item.active = v.includes(key)
              // 大小写不敏感
              item.active = new RegExp(`${key}`, "i").test(v);
              count += 1;
            }
          });
          this.no_friends.active = count === 0; // search成功动画

          this.sp_search_end.scale = v3(0, 0, 1);
          this.sp_search_end.active = true;
          this.sp_search_end.runAction(ccAction.scaleTo(0.5, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "no_friends", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "edit_box", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp_search_end", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonItemWindow.ts", ['cc', './UIWindow.ts', './ContentCheck.ts', './CannonCommonAsset.ts', './CannonData.ts', './CannonGetRewardWindow.ts', './CannonSendItemWindow.ts', './CannonUseMagicItemWindow.ts', './UIRoot.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, CCBoolean, Label, Sprite, _decorator, instantiate, Button, UIWindow, ContentCheck, CannonCommomAsset, CannonData, CannonGetRewardWindow, CannonSendItemWindow, CannonUseMagicItemWindow, UIRoot, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      CCBoolean = module.CCBoolean;
      Label = module.Label;
      Sprite = module.Sprite;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      Button = module.Button;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      CannonCommomAsset = module.default;
    }, function (module) {
      CannonData = module.default;
    }, function (module) {
      CannonGetRewardWindow = module.default;
    }, function (module) {
      CannonSendItemWindow = module.default;
    }, function (module) {
      CannonUseMagicItemWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1ad05V1ZoBM1pLDoMwVqL33", "CannonItemWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CannonItemWindow = exports('default', (_dec = property({
        tooltip: "reward-line",
        type: Node
      }), _dec2 = property({
        tooltip: "reward-line-parent",
        type: Node
      }), _dec3 = property({
        tooltip: "reward-line-item-list",
        type: Node
      }), _dec4 = property(CCBoolean), _dec5 = property({
        tooltip: "item",
        type: Node
      }), _dec6 = property({
        tooltip: "item-parent",
        type: Node
      }), _dec7 = property({
        tooltip: "item-node-list",
        type: Node
      }), _dec8 = property(CCBoolean), _dec9 = property({
        tooltip: "item-magic-count",
        type: Label
      }), _dec10 = property({
        tooltip: "sp-item-magic-plus",
        type: Sprite
      }), ccclass(_class = (_class2 = (_temp = _class3 = class CannonItemWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "reward_line_uidata", void 0);

          _defineProperty(this, "item_uidata", void 0);

          _initializerDefineProperty(this, "reward_line", _descriptor, this);

          _initializerDefineProperty(this, "reward_line_parent", _descriptor2, this);

          _initializerDefineProperty(this, "reward_line_list", _descriptor3, this);

          _initializerDefineProperty(this, "item", _descriptor4, this);

          _initializerDefineProperty(this, "item_parent", _descriptor5, this);

          _initializerDefineProperty(this, "item_list", _descriptor6, this);

          _initializerDefineProperty(this, "label_item_magic_count", _descriptor7, this);

          _initializerDefineProperty(this, "sp_item_magic_plus", _descriptor8, this);
        }

        start() {
          this.get_ui_data();
          this.update_ui_0();
          this.update_ui_1();
          this.bind_ui_event();
        }

        onDestroy() {
          this.unbind_ui_event();
        } // reward-line

        /** @type {cc.Node} */


        get create_all_reward_line() {
          return false;
        }

        set create_all_reward_line(v) {
          if (!CC_EDITOR) {
            return;
          }

          this.reward_line.active = false;
          this.reward_line_parent.destroyAllChildren();
          this.reward_line_list = []; // 创建5个reward-line

          for (let i = 0; i < 5; i += 1) {
            let n = instantiate(this.reward_line);
            n.parent = this.reward_line_parent;
            n.active = true;
            n.getComponentsInChildren(Button).forEach(v => {
              v.clickEvents[0].customEventData = i.toString();
            });
            this.reward_line_list.push(n);
          }
        } // item

        /** @type {cc.Node} */


        get create_all_item() {
          return false;
        }

        set create_all_item(v) {
          if (!CC_EDITOR) {
            return;
          }

          this.item.active = false;
          this.item_parent.destroyAllChildren();
          this.item_list = []; // 创建6个item

          for (let i = 0; i < 6; i += 1) {
            let n = instantiate(this.item);
            n.parent = this.item_parent;
            n.active = true;
            n.getComponentsInChildren(Button).forEach(v => {
              v.clickEvents[0].customEventData = i.toString();
            });
            this.item_list.push(n);
          }
        } // magic-item

        /** @type {cc.Label} */

        /** 获取UI二次数据 */


        get_ui_data() {
          // reward-line
          this.reward_line_uidata = [];
          this.reward_line_list.forEach(v => {
            this.reward_line_uidata.push({
              sp_item_list: [GameKit.ControllerTable.GetNode(v, "item1").getComponent(Sprite), GameKit.ControllerTable.GetNode(v, "item2").getComponent(Sprite), GameKit.ControllerTable.GetNode(v, "item3").getComponent(Sprite), GameKit.ControllerTable.GetNode(v, "item4").getComponent(Sprite), GameKit.ControllerTable.GetNode(v, "item5").getComponent(Sprite), GameKit.ControllerTable.GetNode(v, "item6").getComponent(Sprite)],
              btn_gift: GameKit.ControllerTable.GetNode(v, "btn-gift").getComponent(Button)
            });
          }); // item

          this.item_uidata = [];
          this.item_list.forEach(v => {
            this.item_uidata.push({
              sp: GameKit.ControllerTable.GetNode(v, "sp").getComponent(Sprite),
              label_count: GameKit.ControllerTable.GetNode(v, "label-count").getComponent(Label)
            });
          });
        }

        bind_ui_event() {
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "CannonItemWindow", () => {
            this.update_ui_0();
          });
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "CannonItemWindow", () => {
            this.update_ui_1();
          });
        }

        unbind_ui_event() {
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "CannonItemWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "CannonItemWindow");
        } // /** 刷新UI显示 */
        // update_ui() {
        //     // reward-line
        //     this.reward_line_uidata.forEach((v, line_index) => {
        //         v.sp_item_list.forEach((sp, item_index) => {
        //             if (!CannonData.get_exchange_source(line_index).includes(item_index)) {
        //                 sp.spriteFrame = null
        //             } else if (CannonData.get_item_count(item_index) > 0) {
        //                 sp.spriteFrame = CannonCommomAsset.ins.get_item_spf(item_index)
        //             } else {
        //                 sp.spriteFrame = CannonCommomAsset.ins.get_item_shadow_spf(item_index)
        //             }
        //         })
        //     })
        //     // item
        //     this.item_uidata.forEach((v, i) => {
        //         v.sp.spriteFrame = CannonCommomAsset.ins.get_item_spf(i)
        //         v.label_count.string = CannonData.get_item_count(i)
        //     })
        //     // magic-item
        //     this.label_item_magic_count.string = `${CannonData.get_magic_item_count()}`
        //     this.sp_item_magic_plus.node.active = CannonData.get_magic_item_count() === 0
        // }


        update_ui_0() {
          // reward-line
          this.reward_line_uidata.forEach((v, line_index) => {
            v.sp_item_list.forEach((sp, item_index) => {
              if (!CannonData.get_exchange_source(line_index).includes(item_index)) {
                sp.spriteFrame = null;
              } else if (CannonData.get_item_count(item_index) > 0) {
                sp.spriteFrame = CannonCommomAsset.ins.get_item_spf(item_index);
              } else {
                sp.spriteFrame = CannonCommomAsset.ins.get_item_shadow_spf(item_index);
              }
            });
          }); // item

          this.item_uidata.forEach((v, i) => {
            v.sp.spriteFrame = CannonCommomAsset.ins.get_item_spf(i);
            v.label_count.string = CannonData.get_item_count(i);
          });
        }

        update_ui_1() {
          // magic-item
          this.label_item_magic_count.string = `${CannonData.get_magic_item_count()}`;
          this.sp_item_magic_plus.node.active = CannonData.get_magic_item_count() === 0;
        }

        event_close() {
          this.closeAnim();
        }

        event_get_gift(e, index) {
          index = Number.parseInt(index);
          UIRoot.instance.openChildWindow(CannonGetRewardWindow, {
            index: index
          });
        }

        event_send_item(e, index) {
          index = Number.parseInt(index);

          if (CannonData.get_item_count(index) > 0) {
            UIRoot.instance.openChildWindow(CannonSendItemWindow, {
              item_id: index
            });
          }
        }
        /** 点击事件:使用magic-item */


        event_use_magic_item() {
          // itemId为7
          if (ContentCheck.CheckItem(7, 1)) {
            UIRoot.instance.openChildWindow(CannonUseMagicItemWindow);
          }
        }

      }, _defineProperty(_class3, "windowPath", "Activity/cannon/CannonItemWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "reward_line", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "reward_line_parent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "reward_line_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "create_all_reward_line", [_dec4], Object.getOwnPropertyDescriptor(_class2.prototype, "create_all_reward_line"), _class2.prototype), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "item_parent", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "item_list", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "create_all_item", [_dec8], Object.getOwnPropertyDescriptor(_class2.prototype, "create_all_item"), _class2.prototype), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "label_item_magic_count", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "sp_item_magic_plus", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRActivityCannon.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRActivityCannon', void 0);

      cclegacy._RF.push({}, "1b380fia3VCWqo60b6vQbBH", "SRActivityCannon", undefined);

      let SRActivityCannon;

      (function (_SRActivityCannon) {
        function activityCannonWatchAdGetBall(userId, activityMetaId) {
          let req = new GameKit.ServerRequest("activityCannonWatchAdGetBall");
          req.SetRequestBody("userId", userId);
          req.SetRequestBody("activityMetaId", activityMetaId);
          return req;
        }

        _SRActivityCannon.activityCannonWatchAdGetBall = activityCannonWatchAdGetBall;

        function activityCannonUseItemRefresh(userId, activityMetaId) {
          let req = new GameKit.ServerRequest("activityCannonUseItemRefresh");
          req.SetRequestBody("userId", userId);
          req.SetRequestBody("activityMetaId", activityMetaId);
          return req;
        }

        _SRActivityCannon.activityCannonUseItemRefresh = activityCannonUseItemRefresh;

        function activityCannonAskRefresh(userId, activityMetaId) {
          let req = new GameKit.ServerRequest("activityCannonAskRefresh");
          req.SetRequestBody("userId", userId);
          req.SetRequestBody("activityMetaId", activityMetaId);
          return req;
        }

        _SRActivityCannon.activityCannonAskRefresh = activityCannonAskRefresh;

        function activityCannonShootBall(userId, activityMetaId, hitBoxIndex) {
          let req = new GameKit.ServerRequest("activityCannonShootBall");
          req.SetRequestBody("userId", userId);
          req.SetRequestBody("activityMetaId", activityMetaId);
          req.SetRequestBody("hitBoxIndex", hitBoxIndex);
          return req;
        }

        _SRActivityCannon.activityCannonShootBall = activityCannonShootBall;

        function activityCannonGetReward(userId, activityMetaId, rewardIndex) {
          let req = new GameKit.ServerRequest("activityCannonGetReward");
          req.SetRequestBody("userId", userId);
          req.SetRequestBody("activityMetaId", activityMetaId);
          req.SetRequestBody("rewardIndex", rewardIndex); // req.SetRequestBody("sourceItemList", sourceItemList)
          // req.SetRequestBody("rewardStr", rewardStr)

          return req;
        }

        _SRActivityCannon.activityCannonGetReward = activityCannonGetReward;

        function activityCannonSendItem(userId, activityMetaId, friendUserId, itemId) {
          let req = new GameKit.ServerRequest("activityCannonSendItem");
          req.SetRequestBody("userId", userId);
          req.SetRequestBody("activityMetaId", activityMetaId);
          req.SetRequestBody("friendUserId", friendUserId);
          req.SetRequestBody("itemId", itemId);
          return req;
        }

        _SRActivityCannon.activityCannonSendItem = activityCannonSendItem;

        function activityCannonUseMagicItem(userId, activityMetaId, itemId) {
          let req = new GameKit.ServerRequest("activityCannonUseMagicItem");
          req.SetRequestBody("userId", userId);
          req.SetRequestBody("activityMetaId", activityMetaId);
          req.SetRequestBody("itemId", itemId);
          return req;
        }

        _SRActivityCannon.activityCannonUseMagicItem = activityCannonUseMagicItem;
      })(SRActivityCannon || (SRActivityCannon = exports('SRActivityCannon', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ExecuteTime.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, CCString, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCString = module.CCString;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1b8e9l+6rFDO7NH47E1VJh+", "ExecuteTime", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ExecuteTime = exports('default', (_dec = property(CCString), _dec2 = property(CCString), _dec3 = property(CCString), ccclass(_class = (_class2 = (_temp = class ExecuteTime extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "onloadString", _descriptor, this);

          _initializerDefineProperty(this, "startString", _descriptor2, this);

          _initializerDefineProperty(this, "enableString", _descriptor3, this);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          console.log(this.onloadString, "onload");
        }

        start() {
          console.log(this.startString, "start");
        }

        onEnable() {
          console.log(this.enableString, "onEnable");
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "onloadString", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "startString", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "enableString", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CommunityItem.ts", ['cc', './global.ts', './_app.ts', './LocalizedManager.ts', './SR.ts', './StaticGame.ts', './LogEventWrap.ts', './ShareWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, color, Sprite, Label, Button, SpriteFrame, _decorator, Component, instantiate, G, cce, rigisterLabel, SR, Game, Meta, LogEventWrap, ShareWrap, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      color = module.color;
      Sprite = module.Sprite;
      Label = module.Label;
      Button = module.Button;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      Component = module.Component;
      instantiate = module.instantiate;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1bdd9JnMP5FzaMl407c23tG", "CommunityItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        /** 伪数据长度 */
        FAKE_DATA_LENGTH: 4,

        /** 伪等待时间 */
        FAKE_WAIT_TIME: 1,

        /** 载入sprite旋转一圈的时间 */
        LOADING_ROTATION_TIME: 0.5,

        /** 字体颜色：可点击 */
        FONT_COLOR_ABLE_SEND: color(0, 79, 132),
        FONT_COLOR_ABLE_COLLECT: color(7, 102, 15),

        /** 字体颜色：不可点击 */
        FONT_COLOR_UNABLE: color(60, 60, 60),
        // 一些测试默认值（以后需要从服务器/配置表中读取）
        DEFAULR_SPIN_SEND: 1,
        DEFAULR_SPIN_COLLECT: 1,
        DEFAULR_COIN_SEND: "15K",
        DEFAULR_COIN_COLLECT: "15K",

        /** 显示状态枚举 */
        TYPE: {
          SEND: "send",
          SENDED: "sended",
          COLLECT: "collect",
          COLLECTED: "collected"
        },

        /** 默认邀请时增加的 */
        DEFAULT_INVITE_ADD: 35
      };
      let CommunityItem = exports('CommunityItem', (_dec = ccclass("CommunityItem"), _dec2 = property(Sprite), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Button), _dec6 = property(SpriteFrame), _dec7 = property(SpriteFrame), _dec8 = property(SpriteFrame), _dec9 = property(Label), _dec(_class = (_class2 = (_temp = class CommunityItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "avatar", _descriptor, this);

          _initializerDefineProperty(this, "nameTxt", _descriptor2, this);

          _initializerDefineProperty(this, "tipTxt", _descriptor3, this);

          _initializerDefineProperty(this, "actionBtn", _descriptor4, this);

          _initializerDefineProperty(this, "sfCanCollect", _descriptor5, this);

          _initializerDefineProperty(this, "sfGray", _descriptor6, this);

          _initializerDefineProperty(this, "sfCanSend", _descriptor7, this);

          _initializerDefineProperty(this, "actionTxt", _descriptor8, this);

          _defineProperty(this, "_Itemid", 0);
        }

        setItem(data, id, owner) {
          this._Itemid = id;
          const user = Game.SUser.FriendsList()[id];

          try {
            let avatar = user.Avatar();

            if (avatar != null && avatar.length > 0) {
              cce.loaderLoad({
                url: avatar,
                type: "jpg"
              }, (err, tex) => {
                if (err == null && tex != null) {
                  let sp = new SpriteFrame();
                  sp.texture = tex;
                  if (this.avatar) this.avatar.spriteFrame = sp;
                }
              }, true);
            }
          } catch (e) {}

          this.nameTxt.string = user.Name();
          const type = owner.get_type(data.sended, data.collected, data.canCollect);
          const giftGetMeta = Meta.MetaManager.GetMeta(Meta.MetaType.GiftGet, Game.SUserVillage.MapId());
          const isSpin = owner.toggleTabs.toggleItems[0].isChecked;
          const isCoin = owner.toggleTabs.toggleItems[1].isChecked;
          let keySend = "";

          if (isSpin && !isCoin) {
            keySend = "gifts_explain_spin_send";
          } else if (!isSpin && isCoin) {
            keySend = "gifts_explain_coin_send";
          }

          let keyCollect = "";

          if (isSpin && !isCoin) {
            keyCollect = "gifts_explain_spin_collect";
          } else if (!isSpin && isCoin) {
            keyCollect = "gifts_explain_coin_collect";
          }

          switch (type) {
            case C.TYPE.SEND:
              this.actionBtn.interactable = true;
              this.tipTxt.string = String.format(i18n.t(keySend), C.DEFAULR_SPIN_SEND);
              rigisterLabel(keySend, this.tipTxt, C.DEFAULR_SPIN_SEND);
              this.actionTxt.string = String.format(i18n.t("gifts_send"));
              rigisterLabel("gifts_send", this.actionTxt);
              this.actionBtn.getComponent(Sprite).spriteFrame = this.sfCanSend;
              break;

            case C.TYPE.SENDED:
              this.actionBtn.interactable = false;
              this.tipTxt.string = String.format(i18n.t(keySend), C.DEFAULR_SPIN_SEND);
              rigisterLabel(keySend, this.tipTxt, C.DEFAULR_SPIN_SEND);
              this.actionTxt.string = String.format(i18n.t("gifts_send"));
              rigisterLabel("gifts_send", this.actionTxt);
              this.actionBtn.getComponent(Sprite).spriteFrame = this.sfGray;
              break;

            case C.TYPE.COLLECT:
              this.tipTxt.string = String.format(i18n.t(keyCollect), giftGetMeta.Spin());
              rigisterLabel(keyCollect, this.tipTxt, giftGetMeta.Spin());
              this.actionBtn.interactable = true;
              this.actionTxt.string = String.format(i18n.t("gifts_collect"));
              rigisterLabel("gifts_collect", this.actionTxt);
              this.actionBtn.getComponent(Sprite).spriteFrame = this.sfCanCollect;
              break;

            case C.TYPE.COLLECTED:
              this.tipTxt.string = String.format(i18n.t(keyCollect), giftGetMeta.Spin());
              rigisterLabel(keyCollect, this.tipTxt, giftGetMeta.Spin());
              this.actionBtn.interactable = false;
              this.actionTxt.string = String.format(i18n.t("gifts_collect"));
              rigisterLabel("gifts_collect", this.actionTxt);
              this.actionBtn.getComponent(Sprite).spriteFrame = this.sfGray;
              break;
          }

          this.actionBtn.node.targetOff(this);

          if (type === C.TYPE.SEND) {
            this.actionBtn.node.on("click", () => {
              let sstr = isSpin ? String.format(i18n.t("ShareInviteSendSpin"), Game.SUser.Name()) : isCoin ? String.format(i18n.t("ShareInviteSendCoins"), Game.SUser.Name()) : "";

              const sfunc = () => {
                let req = null;

                if (isSpin) {
                  req = SR.SRSocial.giftsSpinSend(id);
                } else if (isCoin) {
                  req = SR.SRSocial.giftsCoinSend(id);
                }

                req.SetCallBack(() => {
                  data.sended = true;
                  owner.update_collect_progress();
                  owner.flushData();
                  LogEventWrap.logEvent("gift_send");
                });
                req.Send();
              };

              if (G.GameConfig.closeGiftFbShare) {
                sfunc();
              } else {
                ShareWrap.chooseOne(Game.SUser.FriendsList()[id].ThirdId(), sstr, isSpin ? "Texture/share_spin.png" : "Texture/share_coin.png", {
                  type: isSpin ? "send_spins" : "send_coins"
                }, () => {
                  sfunc();
                }, isSpin ? "send_spins" : "send_coins", true);
              }
            }, this);
          } else if (type === C.TYPE.COLLECT) {
            this.actionBtn.node.on("click", () => {
              let req = isSpin ? SR.SRSocial.giftsSpinCollect(id) : isCoin ? SR.SRSocial.giftsCoinCollect(id) : null;
              req && req.SetCallBack(() => {
                data.collected = true;
                owner.update_collect_progress();
                owner.flushData();
                let anim = null;
                let giftGetMeta = Meta.MetaManager.GetMeta(Meta.MetaType.GiftGet, Game.SUserVillage.MapId());

                if (isSpin) {
                  anim = instantiate(owner.anim_spin);
                  GameKit.ControllerTable.GetNode(anim, "label").getComponent(Label).string = "+" + giftGetMeta.Spin().toString();
                } else if (isCoin) {
                  anim = instantiate(owner.anim_coin);
                  GameKit.ControllerTable.GetNode(anim, "label").getComponent(Label).string = "+" + BigNumber.format(giftGetMeta.Coin());
                }

                anim.parent = owner.anim_spin.parent;
                anim.setWorldPosition(this.actionBtn.node.getWorldPosition());
                anim.active = true;
                LogEventWrap.logEvent("gift_collect");
              });
              req.Send();
            }, this);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "avatar", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "nameTxt", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "tipTxt", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "actionBtn", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sfCanCollect", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "sfGray", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "sfCanSend", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "actionTxt", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRCard.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRCard', void 0);

      cclegacy._RF.push({}, "1c284zyVnBKT6kDmwhjJYC5", "SRCard", undefined);

      let SRCard; // old-api
      // //获取用户游戏数据
      // export function getData = function() {
      //     let req = new GameKit.ServerRequest("getUserCard")
      //     req.SetCallBack(function(res) {
      //         Game.SUserCard.updateData(res.userdata)
      //     })
      //     return req
      // }
      // export function getReward = function(setId) {
      //     let req = new GameKit.ServerRequest("getCardReward")
      //     req.SetRequestBody("setId", setId)
      //     req.SetCallBack(function(res) {
      //         Game.SUserCard.GetSetsReward(setId)
      //     })
      //     return req
      // }
      // new-api

      (function (_SRCard) {
        function getUserCard() {
          let req = new GameKit.ServerRequest("getUserCard");
          req.SetCallBack(function (res) {
            Game.SUserCard.updateData(res.userdata);
          });
          return req;
        }

        _SRCard.getUserCard = getUserCard;

        function getCardReward(setId) {
          let req = new GameKit.ServerRequest("getCardReward");
          req.SetRequestBody("setId", setId);
          return req;
        }

        _SRCard.getCardReward = getCardReward;

        function cardSend(friendUserId, ids) {
          let req = new GameKit.ServerRequest("cardSend");
          req.SetRequestBody("friendUserId", friendUserId);
          req.SetRequestBody("ids", ids);
          return req;
        }

        _SRCard.cardSend = cardSend;

        function watchChest() {
          let req = new GameKit.ServerRequest("watchChest");
          return req;
        }

        _SRCard.watchChest = watchChest;
      })(SRCard || (SRCard = exports('SRCard', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopMeta.ts", ['cc', './Content.ts', './StaticGame.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Content, Meta, Game, PaymentWrap, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "1c2b7hv7AVE1Z60HRV42Pn3", "ShopMeta", undefined);

      class ShopMeta {
        constructor() {
          _defineProperty(this, "content", void 0);

          _defineProperty(this, "_data", null);
        }

        static MakeEntity(data) {
          let meta = new ShopMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = data; // for (var key in data) {
          // 	this._data[key] = data[key];
          // }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        Type() {
          return this._data.type;
        }

        Name() {
          return this._data.name;
        }

        DefaultPrice() {
          return this._data.price;
        }

        OriginalCount() {
          return this._data.originalCount;
        }

        Price() {
          if (this.Type() === ShopMeta.Types.Chest) {
            return Meta.MetaManager.GetMeta(Meta.MetaType.ShopCardPrice, Game.SUserVillage.MapId()).Price(this.DefaultPrice());
          } else if (this.Type() === ShopMeta.Types.CoinPack) {
            return Content.FromString(this.DefaultPrice()).Contents()[0].Count();
          }

          return this.DefaultPrice();
        }

        PriceString() {
          if (this.Type() === ShopMeta.Types.Chest || this.Type() === ShopMeta.Types.CoinPack) {
            return GameKit.StringUtil.formatNumber(this.Price());
          }

          return PaymentWrap.GetItem(this.Name()).PriceString();
        }

        Content() {
          if (!this.content) {
            let contentType = Content.Types.Ap;
            let contentId = 0;
            let contentCount = this._data.count;

            if (this.Type() === ShopMeta.Types.ShopCoin) {
              contentType = Content.Types.ShopCoin;
              contentId = this._data.count;
              contentCount = 1;
            } else if (this.Type() === ShopMeta.Types.Pack || this.Type() === ShopMeta.Types.CoinPack) {
              contentType = Content.Types.Pack;
              contentId = this._data.count;
              contentCount = 1;
            } else if (this.Type() === ShopMeta.Types.DynamicPack) {
              contentType = Content.Types.DynamicPack;
              contentId = this._data.count;
              contentCount = 1;
            } else if (this.Type() === ShopMeta.Types.Chest) {
              contentType = Content.Types.CardChest;
              contentId = parseInt(this._data.name);
              contentCount = 1;
            } else if (this.Type() === ShopMeta.Types.Item || this.Type() === ShopMeta.Types.Items || this.Type() === ShopMeta.Types.Food || this.Type() === ShopMeta.Types.Xp || this.Type() === ShopMeta.Types.ActivityItem || this.Type() === ShopMeta.Types.SuperShield) {
              this.content = Content.FromString(this._data.count);
              return this.content;
            }

            this.content = new Content(contentType, contentId, contentCount);
          }

          return this.content;
        }

        Count() {
          return this.Content().Contents()[0].Count();
        }

        RawCount() {
          return this._data.count;
        }

        Consumable() {
          return this._data.consumable;
        }

        Off() {
          return this._data.off;
        }

        OnSale() {
          return this._data.onsale === "false" ? false : true;
        } ////////////////////////////////////////


        static GetByType(type) {
          if (!ShopMeta._GetByTypeResult) {
            ShopMeta._GetByTypeResult = {};
            let metas = Meta.MetaManager.GetMetas(Meta.MetaType.Shop);

            for (let id in metas) {
              let meta = metas[id];
              let ntype = meta.Type();
              if (!ShopMeta._GetByTypeResult[ntype]) ShopMeta._GetByTypeResult[ntype] = [];

              ShopMeta._GetByTypeResult[ntype].push(meta);
            }
          }

          return ShopMeta._GetByTypeResult[type];
        }

        static GetByTypeIndex(type, index) {
          if (!ShopMeta.GetByType(type)) return null;
          return ShopMeta.GetByType(type)[index];
        }

        static GetShopIdByName(name) {
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.Shop);

          for (let id in metas) {
            let meta = metas[id];

            if (meta.Name() == name) {
              return meta.Id();
            }
          }

          return null;
        }

      }

      exports('ShopMeta', ShopMeta);

      _defineProperty(ShopMeta, "_GetByTypeResult", void 0);

      _defineProperty(ShopMeta, "Types", {
        Spin: 1,
        ShopCoin: 2,
        Chest: 3,
        Servant: 4,
        Pack: 5,
        DynamicPack: 55,
        Item: 6,
        Items: 60,
        Treat: 7,
        CoinPack: 8,
        ActivityItem: 9,
        DailyBonus: 10,
        VIP: 11,
        SuperShield: 12,
        LevelBonus: 13,
        Food: 14,
        Xp: 15
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PetStateWander.ts", ['cc', './RoomManager.ts', './PetStateMachine.ts'], function (exports) {
  'use strict';

  var Vec3, tween, cclegacy, RoomManager, PetStateMachine;
  return {
    setters: [function (module) {
      Vec3 = module.Vec3;
      tween = module.tween;
      cclegacy = module.cclegacy;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      PetStateMachine = module.default;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "1ce66870glBV4uRvXiNOdoe", "PetStateWander", undefined);

      class PetStateWander extends PetStateMachine {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "isMoving", false);

          _defineProperty(this, "timeSinceWalkEnd", 0);

          _defineProperty(this, "restTime", 2);
        }

        onEnter() {
          this.wander();
        }

        onExit() {}

        customUpdate(dt) {
          this.timeSinceWalkEnd += dt;

          if (!this.isMoving && this.timeSinceWalkEnd > this.restTime) {
            this.wander();
          }
        } //人物停止，宠物激活状态，闲逛


        wander() {
          if (this.context.isSleeping) return; // const wanderXRange = [-5, 5];
          // const wanderZRange = [-5, 8];

          const xMin = -5;
          const xMax = 5;
          const yMin = -5;
          const yMax = 8;
          let randomLocalPoint = new Vec3(this.context.randomRange(xMin, xMax), 0, this.context.randomRange(yMin, yMax));
          randomLocalPoint.add(RoomManager.instance.curRoom.node.position);
          this.walkToTargetPos(randomLocalPoint);
        }

        walkToTargetPos(pos) {
          const dir = pos.clone().subtract(this.context.node.position);
          let distance = dir.length();
          let time = distance / 3;

          if (time > 10) {
            return;
          }

          this.isMoving = true;
          this.context.turn(dir.clone().normalize(), 0.2);
          this.context.changeStateToWalk();
          tween(this.context.node).to(time, {
            position: pos
          }).call(() => {
            if (this.context.isSleeping) return;
            this.context.changeStateToIdle();
            this.isMoving = false;
            this.timeSinceWalkEnd = 0;
          }).start();
        }

      }

      exports('default', PetStateWander);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SignInItem.ts", ['cc', './Constant.ts', './global.ts', './GetRewardWindow.ts', './SignInWindow.ts', './SR.ts', './BigNumber.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, ParticleSystem2D, _decorator, Component, instantiate, Sprite, tween, Vec3, UITransform, easing, MyCustomEvent, G, GetRewardWindow, SR, BigNumber;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      ParticleSystem2D = module.ParticleSystem2D;
      _decorator = module._decorator;
      Component = module.Component;
      instantiate = module.instantiate;
      Sprite = module.Sprite;
      tween = module.tween;
      Vec3 = module.Vec3;
      UITransform = module.UITransform;
      easing = module.easing;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      GetRewardWindow = module.GetRewardWindow;
    }, function () {}, function (module) {
      SR = module.SR;
    }, function (module) {
      BigNumber = module.BigNumber;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1d416KewRxGzb0QOkT1qPuY", "SignInItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SignInItem = exports('SignInItem', (_dec = ccclass('SignInItem'), _dec2 = property(Node), _dec3 = property(Label), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(ParticleSystem2D), _dec(_class = (_class2 = (_temp = class SignInItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "content", _descriptor, this);

          _initializerDefineProperty(this, "labelDays", _descriptor2, this);

          _initializerDefineProperty(this, "currentDayBg", _descriptor3, this);

          _initializerDefineProperty(this, "backgroundLight", _descriptor4, this);

          _initializerDefineProperty(this, "calendar", _descriptor5, this);

          _initializerDefineProperty(this, "rewardContainer", _descriptor6, this);

          _initializerDefineProperty(this, "rewardNode", _descriptor7, this);

          _initializerDefineProperty(this, "collectedIcon", _descriptor8, this);

          _initializerDefineProperty(this, "collectedBg", _descriptor9, this);

          _initializerDefineProperty(this, "spark", _descriptor10, this);

          _defineProperty(this, "_data", void 0);

          _defineProperty(this, "_owner", void 0);
        }

        setData(data, owner) {
          if (!data) return;
          this._data = data;
          this._owner = owner;
          this.currentDayBg.active = data.canCollect;
          this.backgroundLight.active = data.canCollect && data.days !== 7;
          this.collectedBg.active = data.isCollected;
          this.collectedIcon.active = data.isCollected;
          this.labelDays.string = `Day ${data.days}`;
          this.spark.node.active = false;

          for (let i = 1; i < data.rewards.length; i++) {
            const newReward = instantiate(this.rewardNode);
            this.rewardContainer.addChild(newReward);
            newReward.active = false;
          }

          this.rewardContainer.children.forEach((reward, index) => {
            reward.active = true;
            const icon = reward.getComponentInChildren(Sprite);
            const count = reward.getComponentInChildren(Label);
            data.rewards[index].Icon(icon, null);
            count.string = BigNumber.format(data.rewards[index].Count().toString());
          });
        }

        playShow() {
          return new Promise(resolve => {
            tween(this.node).to(0.1, {
              opacity: 255,
              scale: Vec3.ONE
            }).call(resolve).to(0.07, {
              scale: new Vec3(1.05, 1.15, 1)
            }).to(0.16, {
              scale: new Vec3(1.05, 0.9, 1)
            }).to(0.17, {
              scale: new Vec3(0.95, 1.1, 1)
            }).to(0.13, {
              scale: Vec3.ONE
            }).start();
          });
        }

        playHide() {
          return new Promise(resolve => {
            this.node.getComponent(UITransform).setAnchorPoint(0.5, 0.5);
            this.node.setPosition(this.node.position.x, this.node.position.y + this.node.height / 2, 0);
            this.content.setPosition(Vec3.ZERO);
            this.scheduleOnce(() => {
              tween(this.node).parallel(tween().delay(0.1).call(resolve), tween().to(0.17, {
                scale: G.scale1_1
              }).to(0.06, {
                scale: Vec3.ONE
              }).to(0.1, {
                scale: new Vec3(0.8, 0.8, 0.8),
                opacity: 0
              })).start();
            }, 0);
          });
        }

        async onClick() {
          if (this._owner.nodeHadClicked) return;
          if (!this._data.canCollect) return;
          this._owner.nodeHadClicked = true;
          await new Promise((resolve, reject) => {
            this._owner.signData.signWeekRewards = this._data.days;
            eventCenter.emit(MyCustomEvent.SignInCollected);
            appGame.isSignInReward = true;
            const sr = SR.SRSign.receiveSignWeekReward(this._owner.signData.signWeekDay);
            sr.SetCallBack(v => {
              resolve(v);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          });
          tween(this.node).to(0.1, {
            scale: G.scale1_2
          }).call(() => {
            this.spark.node.active = true;
            tween(this.backgroundLight).to(0.1, {
              opacity: 0
            }).call(() => {
              this.backgroundLight.active = false;
            }).start();
          }).to(0.1, {
            scale: Vec3.ONE
          }).call(() => {
            tween(this.calendar).parallel(tween(this.calendar).to(0.37, {
              angle: 20
            }), tween(this.calendar).delay(0.1).to(0.25, {
              opacity: 0
            })).start();
            tween(this.currentDayBg).delay(0.1).to(0.1, {
              opacity: 0
            }).start();
          }).start();
          tween(this.rewardContainer).delay(0.2).to(0.47, {
            scale: new Vec3(1.3, 1.3, 1.3)
          }).to(0.17, {
            scale: G.scale0_9
          }).call(() => {
            this.rewardContainer.children.forEach(reward => {
              tween(reward.getChildByName("count")).to(0.2, {
                opacity: 0
              }).start();
            });
            tween(this.collectedBg).set({
              active: true,
              opacity: 0
            }).to(0.1, {
              opacity: 255
            }).start();
            tween(this.collectedIcon).delay(0.15).set({
              active: true,
              opacity: 100,
              scale: G.scale1_2
            }).to(0.17, {
              scale: new Vec3(0.7, 0.7, 0.7),
              opacity: 255
            }).to(0.13, {
              scale: new Vec3(1.05, 1.05, 1.05)
            }).to(0.1, {
              scale: Vec3.ONE
            }).call(async () => {
              await new Promise(resolv => {
                {
                  // this.schedule(() => {
                  //     const rewardWindow: GetRewardWindow = uiRoot.GetWindow("GetRewardWindow");
                  //     if (rewardWindow) {
                  //         this.unscheduleAllCallbacks();
                  //         rewardWindow.addOnCloseFunc(() => {
                  //             resolv(null);
                  //             eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                  //         })
                  //     }
                  // }, 0)
                  uiRoot.openChildWindow(GetRewardWindow, {
                    contents: this._data.rewards,
                    showCallback: window => {
                      window.addOnCloseFunc(() => {
                        resolv(null);
                        eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                      });
                    }
                  });
                }
              });
              this.collectedIcon.active = false;
              const newBadge = instantiate(this.collectedIcon);
              const startPos = new Vec3();
              const endPos = new Vec3();
              uiRoot.node.inverseTransformPoint(startPos, this.collectedIcon.getWorldPosition());
              uiRoot.node.inverseTransformPoint(endPos, this._owner.progressPoint.getWorldPosition());
              uiRoot.node.addChild(newBadge);
              newBadge.setPosition(startPos);
              const a = startPos.clone();
              const b = endPos.clone();
              const time = Vec3.len(a.subtract(b)) / 1000 * 2;
              tween(newBadge).set({
                active: true
              }).parallel(tween().to(time, {
                position: endPos
              }, {
                easing: easing.quartIn
              }), tween(newBadge).to(time * 0.6, {
                scale: G.scale2
              }).to(time * 0.4, {
                scale: Vec3.ONE
              })).call(() => {
                this._owner.progressPoint.getChildByName("Particle2D").active = true;
                newBadge.destroy();

                this._owner.showMarchOut();
              }).start();
            }).start();
          }).to(0.17, {
            scale: Vec3.ONE
          }).start();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "content", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelDays", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "currentDayBg", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "backgroundLight", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "calendar", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "rewardContainer", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "rewardNode", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "collectedIcon", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "collectedBg", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "spark", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/JigsawWindowGift.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './ContentModel.ts', './Content.ts', './SR.ts', './JigsawWindow.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, v3, CCE_Component, CCEaseTypes, ContentModel, Content, SR, JigsawWindow, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      JigsawWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1d48cGbCJFPuIZ5EbqrOfa5", "JigsawWindowGift", undefined);
      /** @author fengyong-2-26 */


      const {
        ccclass,
        property
      } = _decorator;
      let JigsawWindowGift = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(ContentModel), _dec5 = property(ContentModel), ccclass(_class = (_class2 = (_temp = class JigsawWindowGift extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "light", _descriptor, this);

          _initializerDefineProperty(this, "box", _descriptor2, this);

          _initializerDefineProperty(this, "detail", _descriptor3, this);

          _initializerDefineProperty(this, "content1", _descriptor4, this);

          _initializerDefineProperty(this, "content2", _descriptor5, this);
        }

        load_page() {
          this.detail.active = false;
          this.light.active = false;
          this.update_page();
        }

        update_page() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();
          this.light.active = !data.jigsawData.includes(0);
          this.anima_box();
        }
        /** box的跳动动画，包含自验证暂停 */


        anima_box() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();

          if (!data.jigsawData.includes(0)) {
            this.box.runAction(ccAction.sequence(ccAction.moveBy(0.3, 0, 5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeOut, 2)), ccAction.moveBy(0.5, 0, -5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBounceOut)), ccAction.moveBy(0.3, 0, 5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeOut, 2)), ccAction.moveBy(0.5, 0, -5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBounceOut)), ccAction.delayTime(1), ccAction.callFunc(() => {
              return this.anima_box();
            })));
          }
        }

        show_detail() {
          this.detail.scale = v3(0, 0, 1);
          this.detail.active = true;
          this.detail.stopAllActions();
          this.detail.runAction(ccAction.scaleTo(0.1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          let mapId = Game.SUserVillage.MapId();
          let reward = Content.FromStrings(JigsawWindow.ins.meta.Param().reward);
          reward = Content.Merge(reward, mapId);
          this.content1.show(reward[0]);
          if (reward[1]) this.content2.show(reward[1]);
        }

        hide_detail() {
          this.detail.stopAllActions();
          this.detail.runAction(ccAction.sequence(ccAction.scaleTo(0.1, 0), ccAction.callFunc(() => {
            this.detail.active = false;
          })));
        }
        /** 点击事件：显示/隐藏detail界面 */


        event_detail() {
          // todo：需要考虑动画带来的延迟
          if (this.detail.active) {
            this.hide_detail();
          } else {
            this.show_detail();
          }
        }
        /** 点击事件：获取奖励 */


        event_reward() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();

          if (!data.jigsawData.includes(0)) {
            this.hide_detail();
            let sr = SR.SRJigsaw.activityJigsawCollectReward();
            sr.SetCallBack(() => {
              this.box.stopAllActions();
              /*UIRoot.instance.openChildWindow(GetRewardWindow, {
                              contents: Content.Merge(Content.FromStrings(metaparam.reward))
                          })*/

              this.update_page();
              JigsawWindow.ins.main.update_page();
              JigsawWindow.ins.piece.update_page();
            });
            sr.Send();
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "light", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "box", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "detail", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "content1", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "content2", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivitySlotSymbolRankRewardWindow.ts", ['cc', './Constant.ts', './EnterCloseAnim.ts', './UIWindow.ts', './ContentModel.ts', './Content.ts', './UserInfoModel.ts', './PlayerPrefs.ts', './AnimationUtils.ts', './ChildWindowChain.ts', './GetRewardWindow.ts', './CardChestOpenWindow.ts', './ActivityManager.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, Button, _decorator, instantiate, MyCustomEvent, EnterCloseAnim, UIWindow, ContentModel, Content, UserInfoModel, PlayerPrefs, AnimationUtils, ChildWindowChain, GetRewardWindow, CardChestOpenWindow, ActivityManager, Game, Meta, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      Button = module.Button;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      PlayerPrefs = module.PlayerPrefs;
    }, function (module) {
      AnimationUtils = module.AnimationUtils;
    }, function (module) {
      ChildWindowChain = module.default;
    }, function (module) {
      GetRewardWindow = module.GetRewardWindow;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1d79aSicONPULgGr5BVuyWi", "ActivitySlotSymbolRankRewardWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivitySlotSymbolRankRewardWindow = exports('ActivitySlotSymbolRankRewardWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Label), _dec5 = property(Button), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Button), _dec9 = property(UserInfoModel), ccclass(_class = (_class2 = (_temp = _class3 = class ActivitySlotSymbolRankRewardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "winNode", _descriptor, this);

          _initializerDefineProperty(this, "rewardItem", _descriptor2, this);

          _initializerDefineProperty(this, "winRewardContainer", _descriptor3, this);

          _initializerDefineProperty(this, "labelRank", _descriptor4, this);

          _initializerDefineProperty(this, "winBtnCollect", _descriptor5, this);

          _initializerDefineProperty(this, "loaseNode", _descriptor6, this);

          _initializerDefineProperty(this, "loseRewardContainer", _descriptor7, this);

          _initializerDefineProperty(this, "loseBtnCollect", _descriptor8, this);

          _initializerDefineProperty(this, "userinfo", _descriptor9, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "userdata", void 0);

          _defineProperty(this, "metaParam", void 0);

          _defineProperty(this, "showParam", void 0);

          _defineProperty(this, "_rewards", void 0);
        }

        onEnable() {
          this.winBtnCollect.node.on("click", this._onWinBtnClick, this);
          this.loseBtnCollect.node.on("click", this._onLoseBtnClick, this);
        }

        onDisable() {
          this.winBtnCollect.node.off("click", this._onWinBtnClick, this);
          this.loseBtnCollect.node.off("click", this._onLoseBtnClick, this);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.userdata = Game.SUserActivity.GetSymbolRankData();

          if (this.meta == null) {
            if (this.userdata.activityId) this.meta = ActivityManager.GetMeta(this.userdata.activityId);
          }

          if (this.meta) {
            this.metaParam = this.meta.Param();
            this.showParam = this.metaParam.__info;
          }

          let uids = Object.keys(this.userdata.rank);
          uids.sort((a, b) => {
            return this.userdata.rank[b].score - this.userdata.rank[a].score;
          });
          let selfRank = uids.indexOf(Game.SUser.UserId().toString()) + 1;

          if (selfRank < 10) {
            // this.winNode.active = true;
            this.loaseNode.active = false;
          } else {
            this.winNode.active = false; // this.loaseNode.active = true;
          }

          this.scheduleOnce(() => {
            let rewards = Content.FromStrings(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollectRankReward, selfRank));
            this._rewards = rewards;
            rewards.forEach(reward => {
              const itemHandle = instantiate(this.rewardItem);
              itemHandle.active = true;
              itemHandle.parent = selfRank <= 10 ? this.winRewardContainer : this.loseRewardContainer;
              itemHandle.getComponent(ContentModel).show(reward);
            });

            if (selfRank < 10) {
              EnterCloseAnim.playEnter(this.winNode);
              this.userinfo.show(Game.SUser);
              this.labelRank.string = selfRank.toString();
            } else {
              EnterCloseAnim.playEnter(this.loaseNode);
            }
          }, 0);
        }

        onClose() {} // close_window() {
        // 	this.closeAnim();
        // }


        _onWinBtnClick() {
          PlayerPrefs.SetBool(this.userdata.activityId + "lastTournamentCollected", true);
          const chain = new ChildWindowChain();
          const chest = GameKit.DataCache.GetData("UserCardChest");

          if (chest) {
            chain.add(CardChestOpenWindow, null, {
              chest: chest,
              showCallback: () => {
                GameKit.DataCache.RemoveData("UserCardChest");
              }
            });
          }

          if (this._rewards) {
            chain.add(GetRewardWindow, null, {
              contents: this._rewards
            });
          }

          chain.setFinishFunc(() => {
            this.closeAnim();
            homeView.slotPage.updateActivityButton();
            eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
          });
          chain.start();
        }

        _onLoseBtnClick() {
          PlayerPrefs.SetBool(this.userdata.activityId + "lastTournamentCollected", true);

          if (this._rewards) {
            AnimationUtils.playGetRewardsAnim(this._rewards, () => {
              this.closeAnim();
              eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
            });
          }
        }

      }, _defineProperty(_class3, "windowPath", "Activity/normal/ActivitySlotSymbolRankRewardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "winNode", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "rewardItem", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "winRewardContainer", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelRank", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "winBtnCollect", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "loaseNode", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "loseRewardContainer", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "loseBtnCollect", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "userinfo", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PlayerPrefs.ts", ['cc', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, sys, Game;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sys = module.sys;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      exports('PlayerPrefs', void 0);

      cclegacy._RF.push({}, "1e424s3kTtCjpKKn9b0v/cz", "PlayerPrefs", undefined);

      let PlayerPrefs;

      (function (_PlayerPrefs) {
        function SetString(key, data) {
          let codeKey = Game.SUser.Id().toString() + key;
          let codeData = data;
          sys.localStorage.setItem(codeKey, codeData);
        }

        _PlayerPrefs.SetString = SetString;

        function GetString(key, defaultValue = "") {
          let codeKey = Game.SUser.Id().toString() + key;
          let str = sys.localStorage.getItem(codeKey);
          if (str == null) str = defaultValue;
          return str;
        }

        _PlayerPrefs.GetString = GetString;

        function SetInt(key, data) {
          let codeData = data.toString();
          PlayerPrefs.SetString(key, codeData);
        }

        _PlayerPrefs.SetInt = SetInt;

        function GetInt(key, defaultValue = 0) {
          let str = PlayerPrefs.GetString(key, defaultValue.toString());
          str = str;
          let result = defaultValue;

          if (!isNaN(parseInt(str))) {
            result = parseInt(str);
          } else {
            result = defaultValue;
          }

          return result;
        }

        _PlayerPrefs.GetInt = GetInt;

        function SetFloat(key, data) {
          let codeData = data.toString();
          PlayerPrefs.SetString(key, codeData);
        }

        _PlayerPrefs.SetFloat = SetFloat;

        function GetFloat(key, defaultValue = 0) {
          let str = PlayerPrefs.GetString(key, defaultValue.toString());
          str = str;
          let result = defaultValue;

          if (!isNaN(parseFloat(str))) {
            result = parseFloat(str);
          } else {
            result = defaultValue;
          }

          return result;
        }

        _PlayerPrefs.GetFloat = GetFloat;

        function SetBool(key, data) {
          PlayerPrefs.SetInt(key, data ? 1 : 0);
        }

        _PlayerPrefs.SetBool = SetBool;

        function GetBool(key, defaultValue = false) {
          if (PlayerPrefs.GetInt(key, -1) === -1) {
            return defaultValue;
          }

          return PlayerPrefs.GetInt(key, 0) > 0;
        }

        _PlayerPrefs.GetBool = GetBool;

        function SetObject(key, data) {
          let codeData = JSON.stringify(data);
          PlayerPrefs.SetString(key, codeData);
        }

        _PlayerPrefs.SetObject = SetObject;

        function GetObject(key, defaultValue = null) {
          let str = PlayerPrefs.GetString(key, JSON.stringify(defaultValue));
          str = str;
          let result = defaultValue;

          if (str) {
            result = JSON.parse(str);
          }

          return result;
        }

        _PlayerPrefs.GetObject = GetObject;

        function DeleteKey(key) {
          let codeKey = Game.SUser.Id().toString() + key;
          sys.localStorage.removeItem(codeKey);
        }

        _PlayerPrefs.DeleteKey = DeleteKey;

        function HasKey(key) {
          let codeKey = Game.SUser.Id().toString() + key;
          return sys.localStorage.hasOwnProperty(codeKey);
        }

        _PlayerPrefs.HasKey = HasKey;
      })(PlayerPrefs || (PlayerPrefs = exports('PlayerPrefs', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SimpleRewardWindow.ts", ['cc', './_app.ts', './PlayAudio.ts', './UIWindow.ts', './fixedSizeRatio.ts', './Content.ts', './GameMainWindow.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, instantiate, Sprite, cce, PlayAudio, UIWindow, fixedSizeRatio, Content, GameMainWindow, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      Sprite = module.Sprite;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      PlayAudio = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      fixedSizeRatio = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1e883PTYytHnr3GcpfUOfkk", "SimpleRewardWindow", undefined);

      const poses = {
        [1]: [0],
        [2]: [-120, 120],
        [3]: [-160, 0, 160]
      };
      const {
        ccclass,
        property
      } = _decorator;
      let SimpleRewardWindow = exports('SimpleRewardWindow', (_dec = property(Node), _dec2 = property(Label), _dec3 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class SimpleRewardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "item", _descriptor, this);

          _initializerDefineProperty(this, "labelTime", _descriptor2, this);

          _initializerDefineProperty(this, "labelTimeShadow", _descriptor3, this);

          _defineProperty(this, "_icons", void 0);

          _defineProperty(this, "activityItem", void 0);

          _defineProperty(this, "time", void 0);
        }

        onShow(showParams) {
          let contents = showParams.contents;
          contents = Content.Merge(contents);
          this.item.active = false;
          let count = Math.min(3, contents.length);
          this._icons = [];

          for (let i = 0; i < count; i++) {
            let content = Content.FromContent(contents[i]);
            let newItem = instantiate(this.item);
            newItem.parent = this.item.parent;
            newItem.x = poses[count][i];
            newItem.active = true;
            let newIcon = GameKit.ControllerTable.GetComponent(newItem, "icon", Sprite);
            let newCount = GameKit.ControllerTable.GetComponent(newItem, "count", Label);
            content.Icon(newIcon, () => {
              if (!newIcon || !newIcon.node) return;
              fixedSizeRatio.fitByHeight(newIcon, 125);
            });

            this._icons.push(newIcon);

            newCount.string = i18n.t("multiplyx") + GameKit.StringUtil.formatNumber(content.Count());

            if (content.Type() == Content.Types.ActivityItem) {
              this.activityItem = newItem;
            }
          }

          this.time = 2;
          this.labelTime.string = "(" + Math.ceil(this.time) + ")";
          this.labelTimeShadow.string = "(" + Math.ceil(this.time) + ")";
          PlayAudio.playOk();
        }

        onClose() {// this._icons.forEach(x=>{cce.releaseSpriteFrame(x)})
        }

        slowUpdate(dt) {
          if (this.time <= 0) return;
          this.time -= dt;
          this.labelTime.string = "(" + Math.ceil(this.time) + ")";
          this.labelTimeShadow.string = "(" + Math.ceil(this.time) + ")";

          if (this.time <= 0) {
            this.close_window();
          }
        }

        close_window() {
          if (this.closing) return; //ActivityItem

          if (this.activityItem && GameMainWindow.instance) {
            let newItem = instantiate(this.activityItem);
            newItem.parent = GameMainWindow.instance.node;
            newItem.setWorldPosition(this.activityItem.getWorldPosition());
            GameKit.ControllerTable.GetComponent(newItem, "count", Label).string = "";
            let dpos = newItem.position.add(homeView.slotPage.btnActivityCenter.node.getWorldPosition().subtract(newItem.getWorldPosition())); // newItem.runAction(ccAction.sequence(ccAction.delayTime(0.3), ccAction.spawn(ccAction.scaleTo(0.7, 0.1, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeSineIn)), ccAction.jumpTo(0.7, dpos.x, dpos.y, 120, 1)), ccAction.callFunc(() => {

            newItem.runAction(ccAction.sequence(ccAction.delayTime(0.3), ccAction.spawn(ccAction.scaleTo(0.7, 0.1, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeSineIn)), ccAction.moveTo(0.7, dpos.x, dpos.y)), ccAction.callFunc(() => {
              newItem.destroy();
            })));
          }

          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Common/SimpleRewardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelTime", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelTimeShadow", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NewPlayerPackWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './ContentModel.ts', './Content.ts', './PaySuccessWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, SoundManager, UIWindow, ContentModel, Content, PaySuccessWindow, UIRoot, Meta, Game, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1f102uZk1pL9KHtDYRmgpPx", "NewPlayerPackWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NewPlayerPackWindow = exports('NewPlayerPackWindow', (_dec = property([ContentModel]), _dec2 = property(Label), _dec3 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class NewPlayerPackWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "items", _descriptor, this);

          _initializerDefineProperty(this, "labelTime", _descriptor2, this);

          _initializerDefineProperty(this, "labelOff", _descriptor3, this);

          _defineProperty(this, "shopId", void 0);

          _defineProperty(this, "shopMeta", void 0);

          _defineProperty(this, "contents", void 0);

          _defineProperty(this, "newPlayerLeftTime", void 0);

          _defineProperty(this, "leftTime", void 0);
        }

        onShow() {
          this.shopId = 505;
          this.shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.shopId);
          this.contents = Content.Merge(this.shopMeta.Content().Contents());
          this.items.forEach((x, i) => {
            x.show(this.contents[i]);
          });
          this.labelOff.string = Math.round(this.shopMeta.Off() * 100).toString() + "%";
          this.newPlayerLeftTime = Game.SUserStatus.GetNewPlayerLeftTime() + GameKit.TimeUtil.getCurrentTime();
          this.leftTime = 0;
          this.slowUpdate(0);
          LogEventWrap.logEvent("window_newplayer");
        }

        slowUpdate(arg) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = this.newPlayerLeftTime - currentTime;
            this.labelTime.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        callBuy() {
          let shopmeta = this.shopMeta;
          PaymentWrap.Pay(shopmeta.Name(), function (ok) {
            if (ok) {
              SoundManager.playSound("item_purchased");
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "pack",
                showCallback: wnd => {
                  wnd.addOnCloseFunc(() => {
                    if (this.node) this.closeAnim();
                  });
                }
              });
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "pack",
                name: shopmeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "pack",
                name: shopmeta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "pack",
            name: shopmeta.Name(),
            phase: 0
          });
        }

        close_window() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Shop/NewNewPlayerPackWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "items", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelTime", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelOff", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotItemNode.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "1f1a4hVZi1NhK3MZfXVDv6r", "SlotItemNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotItemNode = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class SlotItemNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "normalNode", _descriptor, this);

          _initializerDefineProperty(this, "blurNode", _descriptor2, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        showSlotItem() {
          this.node.active = true;
        }

        hideSlotItem() {
          this.node.active = false;
        }

        showNormal() {
          this.normalNode.active = true;
          this.blurNode.active = false;
        }

        showBlur() {
          this.normalNode.active = false;
          this.blurNode.active = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "normalNode", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "blurNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShakeCamera.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, Camera, Animation;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      Camera = module.Camera;
      Animation = module.Animation;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "1f7d3hOEHRI76UF0cw2OB3J", "ShakeCamera", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShakeCamera = exports('default', (_dec = ccclass("ShakeCamera"), _dec(_class = (_temp = class ShakeCamera extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "setShakeTime", 0.3);

          _defineProperty(this, "shakeFps", 45);

          _defineProperty(this, "isShakeCamera", false);

          _defineProperty(this, "fps", void 0);

          _defineProperty(this, "shakeTime", 0.0);

          _defineProperty(this, "frameTime", 0.03);

          _defineProperty(this, "shakeDelta", 1);

          _defineProperty(this, "selfCamera", void 0);

          _defineProperty(this, "initialPosition", new Vec3());
        }

        onEnable() {
          this.isShakeCamera = true;
          this.selfCamera = this.getComponent(Camera);
          this.shakeTime = this.setShakeTime;
          this.fps = this.shakeFps; // this.frameTime = 0.03;
          // this.shakeDelta = 0.005;

          this.initialPosition = this.selfCamera.node.position.clone();

          if (!this.selfCamera) {
            console.warn("cannot find attached camera", this.node);
          }

          if (this.selfCamera.getComponent(Animation)) {
            this.selfCamera.getComponent(Animation).enabled = false;
          }
        }

        onDisable() {
          // this.selfCamera.rect = new Rect(0.0, 0.0, 1.0, 1.0);
          this.selfCamera.node.position = this.initialPosition;
          this.isShakeCamera = false;

          if (this.selfCamera.getComponent(Animation)) {
            this.selfCamera.getComponent(Animation).enabled = true;
          }
        }

        update(dt) {
          if (this.isShakeCamera) {
            if (this.shakeTime > 0) {
              this.shakeTime -= dt;

              if (this.shakeTime <= 0) {
                this.enabled = false;
              } else {
                this.frameTime += dt;

                if (this.frameTime > 1.0 / this.fps) {
                  this.frameTime = 0;
                  let x = this.shakeDelta * (-0.5 + Math.random());
                  let y = this.shakeDelta * (-0.5 + Math.random()); // console.log(x, y);
                  // this.selfCamera.rect = new Rect(x, y, 1.0 - x, 1.0 - y);

                  let cameraPosition = this.initialPosition.clone();
                  cameraPosition.add3f(x, y, 0);
                  this.selfCamera.node.position = cameraPosition;
                }
              }
            }
          }
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ccExtention.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "20528XLEZ9BJI9tH3MkjMaB", "ccExtention", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DataCache.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports('DataCache', void 0);

      cclegacy._RF.push({}, "20a16SF67pLk71PLe4XCEWr", "DataCache", undefined); // 数据缓存


      let DataCache;

      (function (_DataCache) {
        let _data = {};

        function SetData(key, value) {
          _data[key] = value;
        }

        _DataCache.SetData = SetData;

        function GetData(key) {
          if (HasData(key)) {
            return _data[key];
          }

          return null;
        }

        _DataCache.GetData = GetData;

        function HasData(key) {
          return _data.hasOwnProperty(key);
        }

        _DataCache.HasData = HasData;

        function RemoveData(key) {
          if (HasData(key)) {
            _data[key] = null;
            delete _data[key];
          }
        }

        _DataCache.RemoveData = RemoveData;

        function Clear() {
          _data = {};
        }

        _DataCache.Clear = Clear;
      })(DataCache || (DataCache = exports('DataCache', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Item.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, CCString, Node, _decorator;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCString = module.CCString;
      Node = module.Node;
      _decorator = module._decorator;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "21946XIhCNB1ImEYvxs3Gn5", "Item", undefined);

      const {
        ccclass,
        property,
        menu
      } = _decorator;
      let Item = exports('Item', (_dec = ccclass("Item"), _dec2 = property(CCString), _dec3 = property({
        type: Node,
        override: true
      }), _dec(_class = (_class2 = (_temp = class Item {
        constructor() {
          _initializerDefineProperty(this, "key", _descriptor, this);

          _initializerDefineProperty(this, "node", _descriptor2, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "key", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "node", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LabelGradient.ts", ['cc', './CCE_Component.ts', './SdkManager.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Color, _decorator, color, CCE_Component, SdkManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Color = module.Color;
      _decorator = module._decorator;
      color = module.color;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function () {}],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "219b5yrplVD276C8Www6Ius", "LabelGradient", undefined);

      const {
        ccclass,
        property,
        requireComponent,
        executeInEditMode
      } = _decorator;
      let LabelGradient = exports('default', (_dec = requireComponent(Label), _dec2 = property(Color), _dec3 = property(Color), ccclass(_class = executeInEditMode(_class = _dec(_class = (_class2 = (_temp = class LabelGradient extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "_colorFrom", _descriptor, this);

          _initializerDefineProperty(this, "_colorTo", _descriptor2, this);

          _initializerDefineProperty(this, "_horizontal", _descriptor3, this);
        }

        set colorFrom(value) {
          this._colorFrom = color(value);

          this._updateRenderData();
        }

        get colorFrom() {
          return this._colorFrom;
        }

        set colorTo(value) {
          this._colorTo = color(value);

          this._updateRenderData();
        }

        get colorTo() {
          return this._colorTo;
        }

        set horizontal(value) {
          this._horizontal = value;

          this._updateRenderData();
        }

        get horizontal() {
          return this._horizontal;
        }

        onLoad() {
          if (SdkManager.IsNative()) this.enabled = false;
        }

        onEnable() {
          this._updateRenderData();
        }

        onDisable() {
          this._updateRenderData();
        }

        _updateRenderData() {
          let label = this.node.getComponent(Label);

          if (label) {
            label._updateRenderData();
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "_colorFrom", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return color(255, 255, 255, 255);
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "_colorTo", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return color(255, 255, 255, 255);
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "_horizontal", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "colorFrom", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "colorFrom"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "colorTo", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "colorTo"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "horizontal", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "horizontal"), _class2.prototype)), _class2)) || _class) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonTool.ts", ['cc'], function (exports) {
  'use strict';

  var Vec2, misc, v2, UITransform, cclegacy;
  return {
    setters: [function (module) {
      Vec2 = module.Vec2;
      misc = module.misc;
      v2 = module.v2;
      UITransform = module.UITransform;
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "227776XKsFA/J+uPENAY8UR", "CannonTool", undefined); // @ts-check

      /** cannon系统下用到的一些工具函数 */


      class CannonTool {
        /**
         * cc.misc.lerp的反向操作,获取value在min~max的lerp值(0~1)
         * @param {number} min
         * @param {number} max
         * @param {number} value
         */
        static get_lerp(value, min, max) {
          return (value - min) / (max - min);
        }
        /**
         * 获取节点的世界坐标
         * @param {cc.Node} node
         */


        static get_node_world_position(node) {
          return node.convertToWorldSpaceAR(Vec2.ZERO);
        }
        /**
         *
         * @param {cc.Node} node
         * @param {cc.Vec2} world_position
         */


        static get_node_local_position(node, world_position) {
          return node.parent.convertToNodeSpaceAR(world_position);
        }
        /**
         * 根据世界坐标设置节点的本地坐标
         * @param {cc.Node} node
         * @param {cc.Vec2} world_position
         */


        static set_node_position(node, world_position) {
          node.position = node.parent.convertToNodeSpaceAR(world_position);
        }
        /**
         * 修改节点的旋转角度,使得节点的顶部指向视点(当节点在视点的正下方时,旋转角度为0)
         * @param {cc.Node} node
         * @param {cc.Vec2} view_point_world_position
         */


        static set_node_rotation_by_viewpoint(node, view_point_world_position) {
          let v2_viewpoint_to_node = this.get_node_world_position(node).subtract(view_point_world_position);
          node.angle = misc.radiansToDegrees(v2_viewpoint_to_node.signAngle(v2(0, -1)));
        }
        /**
         * 根据扇形限制v2
         * - 注意:与cc.Vec2.clampf的处理不同,本方法会根据min和max组成的扇形来限制v2
         * - 注意:如果min和max的长度相等,则结果的最小长度为0;如果长度不等,则以min的长度为小值,max的长度为大值
         * - 注意:扇形取从min到max顺时针所划过的扇形
         * - 实现算法:(以min为基准)获取扇形弧度,获取v2与min的弧度,对比得出可行的弧度;再对比长度
         * @param {cc.Vec2} v2
         * @param {cc.Vec2} min_v2 限制区域
         * @param {cc.Vec2} max_v2 限制区域
         */


        static clampf_v2(v2, min_v2, max_v2) {
          // 限制弧度
          let sector_radian = max_v2.signAngle(min_v2);
          let result_radian = misc.clampf(v2.signAngle(min_v2), 0, sector_radian); // 限制长度

          let min_length = min_v2.mag() === max_v2.mag() ? 0 : min_v2.mag();
          let max_length = max_v2.mag();
          let result_length = misc.clampf(v2.mag(), min_length, max_length); // 创建新的向量并返回

          let result_v2 = min_v2.normalize();
          result_v2.rotateSelf(-result_radian); // 注意rorate是逆时针旋转

          result_v2.mulSelf(result_length);
          return result_v2;
        }
        /**
         * 填充节点(使得节点的1头在p-start,另一头在p-end);0度时为竖
         * @param {cc.Node} node
         * @param {cc.Vec2} p_start 均为本地坐标
         * @param {cc.Vec2} p_end
         */


        static fill_node(node, p_start, p_end) {
          node.position = p_start;
          node.getComponent(UITransform).height = p_end.subtract(p_start).mag();
          node.angle = misc.radiansToDegrees(p_end.subtract(p_start).signAngle(v2(0, -1)));
        }

      }

      exports('default', CannonTool);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Logs.ts", ['cc', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, AppMain;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "22972NTq7VBpKOrplRvKH0B", "Logs", undefined);

      class Logs {}

      exports('Logs', Logs);

      _defineProperty(Logs, "enableDebug", false);

      _defineProperty(Logs, "m_Level", 2);

      _defineProperty(Logs, "Log", console.log);

      (function (_Logs) {
        let Level;

        (function (Level) {
          Level[Level["Info"] = 1] = "Info";
          Level[Level["Log"] = 2] = "Log";
          Level[Level["Warning"] = 3] = "Warning";
          Level[Level["Error"] = 4] = "Error";
        })(Level || (Level = {}));

        _Logs.Level = Level;

        function Debug(...values) {
          if (!Logs.enableDebug) return;
          console.log(...values);
        }

        _Logs.Debug = Debug;

        function Info(...values) {
          if (Logs.m_Level > Level.Info) return;
          console.log(...values);
        }

        _Logs.Info = Info;

        function Warning(...values) {
          if (Logs.m_Level > Level.Warning) return;
          console.log("~~## Warning ##~~", ...values);
        }

        _Logs.Warning = Warning;

        function Error(...values) {
          if (Logs.m_Level > Level.Error) return;
          console.log("~~## ERROR ##~~", ...values);
          AppMain.instance.logerror({
            msg: "".concat(...values),
            url: "",
            line: ""
          });
        }

        _Logs.Error = Error;
      })(Logs || (Logs = exports('Logs', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ResourceLoader.ts", ['cc', './Constant.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, assetManager, Texture2D, SpriteFrame, Prefab, Scene, LoadEvent;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      assetManager = module.assetManager;
      Texture2D = module.Texture2D;
      SpriteFrame = module.SpriteFrame;
      Prefab = module.Prefab;
      Scene = module.Scene;
    }, function (module) {
      LoadEvent = module.LoadEvent;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "22a096OjaJB8ZHfb9Uv8BmR", "ResourceLoader", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ResourceLoader = exports('ResourceLoader', (_dec = ccclass("ResourceLoader"), _dec(_class = (_temp = _class2 = class ResourceLoader extends Component {
        // public static preloadCommonPrefab(resPath: string) {
        // 	console.log("load prefab ....", resPath);
        // 	let bundle = assetManager.getBundle("rooms");
        // 	const promise = new Promise<Prefab>((resolve, reject) => {
        // 		bundle.preload(
        // 			resPath,
        // 			Prefab,
        // 			(okCount, allCount) => {
        // 				let progress = okCount / allCount;
        // 			},
        // 			(err, vPre) => {
        // 				if (err || vPre == null) {
        // 					console.warn("loadResError", resPath);
        // 					reject("loadResError");
        // 					return;
        // 				}
        // 				ResourceLoader.resMap.set(resPath, vPre);
        // 				this.loadingMap.delete(resPath);
        // 				resolve(vPre);
        // 				console.log("load prefab end", resPath);
        // 			}
        // 		);
        // 	})
        // 	this.loadingMap.set(resPath, promise);
        // 	return promise;
        // }

        /** TODO,到下一关icon还没释放 */
        static loadSpriteFrame(resPath, isLocal = true) {
          const bundleName = isLocal ? "roomsLocal" : "rooms";
          let bundle = assetManager.getBundle(bundleName);
          const promise = new Promise((resolve, reject) => {
            bundle.load(resPath, Texture2D, (okCount, allCount) => {}, (err, tex) => {
              if (err || tex == null) {
                console.warn("cannot find", resPath, err);
                reject("loadResError");
                return;
              }

              const spriteFrame = new SpriteFrame();
              spriteFrame.texture = tex;
              resolve(spriteFrame);
              ResourceLoader.resMap.set(resPath, tex);
              this.loadingMap.delete(resPath); // console.log("load tex end", resPath);
            });
          });
          this.loadingMap.set(resPath, promise);
          return promise;
        }

        static loadCommonPrefab(resPath, isLocal = true, onProgress) {
          if (this.resMap.get(resPath)) {
            return Promise.resolve(this.resMap.get(resPath));
          }

          console.log("load prefab ....", resPath);
          const bundleName = isLocal ? "roomsLocal" : "rooms";
          let bundle = assetManager.getBundle(bundleName);
          const promise = new Promise((resolve, reject) => {
            bundle.load(resPath, Prefab, (okCount, allCount) => {
              let progress = okCount / allCount;
              onProgress && onProgress(progress);
            }, (err, vPre) => {
              if (err || vPre == null) {
                console.warn("loadResError", resPath);
                reject("loadResError");
                return;
              }

              ResourceLoader.resMap.set(resPath, vPre);
              this.loadingMap.delete(resPath);
              resolve(vPre);
              console.log("load prefab end", resPath);
            });
          });
          this.loadingMap.set(resPath, promise);
          return promise;
        } // 统一common资源管理接口


        static getCommonPrefab(resPath, isLocal = true) {
          // const bundleName = isLocal ? "roomsLocal" : "rooms";
          // let bundle = assetManager.getBundle(bundleName);
          if (this.resMap.get(resPath)) {
            return Promise.resolve(this.resMap.get(resPath));
          } else if (this.loadingMap.get(resPath)) {
            return this.loadingMap.get(resPath);
          } else {
            return this.loadCommonPrefab(resPath);
          }
        }

        static loadSceneConfig(resPath, isLocal = false) {
          console.log("load scene ....", resPath);
          const bundleName = isLocal ? "roomsLocal" : "rooms";
          let bundle = assetManager.getBundle(bundleName);
          return new Promise((resolve, reject) => {
            bundle.loadScene(resPath, Scene, (okCount, allCount) => {
              let progress = okCount / allCount;
              eventCenter.emit(LoadEvent.SlotProgressUpdate, progress);
            }, (err, vPre) => {
              if (err || vPre == null) {
                console.warn("loadResError", resPath);
                reject("loadResError");
                return;
              }

              resolve(vPre.scene);
              eventCenter.emit(LoadEvent.SlotLoaded, vPre);
              console.log("load scene end", resPath);
            });
          });
        }

        static loadSlot(resPath, isLocal = true) {
          console.log("load slot ....", resPath);
          const bundleName = isLocal ? "roomsLocal" : "rooms";
          let bundle = assetManager.getBundle(bundleName);
          return new Promise((resolve, reject) => {
            bundle.load(resPath, Prefab, (okCount, allCount) => {
              let progress = okCount / allCount;
              eventCenter.emit(LoadEvent.SlotProgressUpdate, progress);
            }, (err, vPre) => {
              if (err || vPre == null) {
                console.warn("loadResError", resPath);
                reject("loadResError");
                return;
              }

              resolve(vPre);
              eventCenter.emit(LoadEvent.SlotLoaded, vPre);
              console.log("loadSlot end", resPath);
            });
          });
        }

        static loadVillage(resPath, isLocal = false) {
          console.log("load village ....", resPath);
          const bundleName = isLocal ? "roomsLocal" : "rooms";
          let bundle = assetManager.getBundle(bundleName);
          return new Promise((resolve, reject) => {
            bundle.load(resPath, Prefab, (okCount, allCount) => {
              let progress = okCount / allCount;
              eventCenter.emit(LoadEvent.VillageProgressUpdate, progress);
            }, (err, vPre) => {
              if (err || vPre == null) {
                console.warn("loadResError", resPath);
                reject("loadResError");
                return;
              }

              resolve(vPre);
              eventCenter.emit(LoadEvent.VillageLoaded, vPre);
              console.log("loadVillage end", resPath);
            });
          });
        }

        static releaseVillage(resPath, isLocal = false) {
          console.log("releaseVillage ....", resPath);
          const bundleName = isLocal ? "roomsLocal" : "rooms";
          let bundle = assetManager.getBundle(bundleName);
          bundle.release(resPath);
        }

        static loadRaid(resPath, isLocal = false) {
          console.log("load raid ....", resPath);
          const bundleName = isLocal ? "roomsLocal" : "rooms";
          let bundle = assetManager.getBundle(bundleName);
          return new Promise((resolve, reject) => {
            bundle.load(resPath, Prefab, (okCount, allCount) => {
              let progress = okCount / allCount;
              eventCenter.emit(LoadEvent.RaidProgressUpdate, progress);
            }, (err, vPre) => {
              if (err || vPre == null) {
                console.warn("loadResError", resPath);
                reject("loadResError");
                return;
              }

              resolve(vPre);
              eventCenter.emit(LoadEvent.RaidLoaded, vPre);
              console.log("loadRaid end", resPath);
            });
          });
        } // public static async loadAllPetPrefabs() {
        // 	return Promise.all([
        // 		ResourceLoader.loadCommonPrefab("pet/" + PetType.Pig),
        // 		ResourceLoader.loadCommonPrefab("pet/" + PetType.Tiger),
        // 		ResourceLoader.loadCommonPrefab("pet/" + PetType.Dog),
        // 		ResourceLoader.loadCommonPrefab("pet/" + PetType.Rabbit),
        // 	]);
        // }


        static async loadAttackPrefabs() {
          return Promise.all([ResourceLoader.loadCommonPrefab("common/bomb"), ResourceLoader.loadCommonPrefab("common/dunpai"), ResourceLoader.loadCommonPrefab("common/dunpai02"), ResourceLoader.loadCommonPrefab("common/dunpai03"), ResourceLoader.loadCommonPrefab("common/dunpai_dog"), ResourceLoader.loadCommonPrefab("common/baozha")]);
        }

      }, _defineProperty(_class2, "resMap", new Map()), _defineProperty(_class2, "loadingMap", new Map()), _temp)) || _class));
      window["ResourceLoader"] = ResourceLoader;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CameraController3d.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, Camera;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      Camera = module.Camera;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "22f66DPhSlNpresdGABEs5Z", "CameraController3d", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CameraController3d = exports('default', (_dec = ccclass("CameraController3d"), _dec(_class = (_temp = _class2 = class CameraController3d extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "offset", new Vec3());

          _defineProperty(this, "camera", void 0);

          _defineProperty(this, "target", void 0);

          _defineProperty(this, "_temp", new Vec3());
        }

        onLoad() {
          CameraController3d.instance = this;
          this.camera = this.node.getComponent(Camera);
        }

        setTarget(target) {
          this.target = target;
          this.offset = this.camera.node.position.clone().subtract(this.target.position).multiplyScalar(1);
        }

        lateUpdate(dt) {
          if (!this.target) return;
          let pos = this.camera.node.position;
          let target_pos = this.target.position;

          this._temp.set(target_pos.x, target_pos.y, target_pos.z);

          this._temp.add(this.offset); // this.camera.node.position = Vec3.lerp(pos, pos, this._temp, dt * 10);


          this.camera.node.position = this._temp;
        }

      }, _defineProperty(_class2, "instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopSpinItem.ts", ['cc', './Constant.ts', './CCE_Component.ts', './SoundManager.ts', './LocalizedManager.ts', './PaySuccessWindow.ts', './MultiplePurchaseWindow.ts', './UIRoot.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, Node, Prefab, _decorator, instantiate, SystemEventType, MyCustomEvent, CCE_Component, SoundManager, rigisterLabel, PaySuccessWindow, MultiplePurchaseWindow, UIRoot, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      Node = module.Node;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      SystemEventType = module.SystemEventType;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      MultiplePurchaseWindow = module.MultiplePurchaseWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "230cc9+rRtDDIBcMPBC+zPZ", "ShopSpinItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopSpinItem = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Label), _dec8 = property(Prefab), ccclass(_class = (_class2 = (_temp = class ShopSpinItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spinIcon", _descriptor, this);

          _initializerDefineProperty(this, "spinNum", _descriptor2, this);

          _initializerDefineProperty(this, "spinExtra", _descriptor3, this);

          _initializerDefineProperty(this, "spinPrice", _descriptor4, this);

          _initializerDefineProperty(this, "hotNode", _descriptor5, this);

          _initializerDefineProperty(this, "bestValueNode", _descriptor6, this);

          _initializerDefineProperty(this, "oldText", _descriptor7, this);

          _initializerDefineProperty(this, "star", _descriptor8, this);

          _defineProperty(this, "meta", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        updatePanel(meta, index, iconSpriteFrame, oldMeta) {
          this.meta = meta;
          let num = meta.Count();
          let numAdd = Math.round(meta.Off() * 100);
          let price = meta.PriceString();
          const starNum = Math.random() < 0.5 ? 1 : 2;

          for (let i = 0; i < starNum; i++) {
            const newStar = instantiate(this.star);
            this.spinIcon.node.addChild(newStar);

            const _x = Math.random() * 100 - 50;

            const _y = Math.random() * 120 - 60;

            newStar.setPosition(_x, _y);
          }

          this.spinIcon.node.once(SystemEventType.SIZE_CHANGED, () => {}, this);
          this.spinIcon.spriteFrame = iconSpriteFrame;
          this.spinNum.string = String.format(i18n.t("ShopSpinNum"), GameKit.StringUtil.formatNumber(num));

          if (numAdd <= 0) {
            this.spinExtra.node.parent.active = false;
            this.spinExtra.string = "";
          } else {
            this.spinExtra.string = String.format(i18n.t("ShopAddPercent"), numAdd);
            rigisterLabel("ShopAddPercent", this.spinExtra, numAdd);
          }

          if (meta.OnSale()) {
            this.spinExtra.node.active = true;
          } else {
            this.spinExtra.node.active = false;
          }

          if (index == 2) {
            this.hotNode.active = true;
            this.bestValueNode.active = false;
          } else if (index == 5) {
            this.hotNode.active = false;
            this.bestValueNode.active = true;
          } else {
            this.hotNode.active = false;
            this.bestValueNode.active = false;
          }

          this.oldText.node.active = false;

          if (oldMeta != meta) {
            this.oldText.node.active = true;
            let oldNum = oldMeta.Count();
            this.oldText.string = String.format(i18n.t("ShopSpinNum"), GameKit.StringUtil.formatNumber(oldNum));
          } else if (meta.OriginalCount() > 0) {
            this.oldText.node.active = true;
            this.oldText.string = String.format(i18n.t("ShopSpinNum"), meta.OriginalCount());
          }

          this.spinPrice.string = price;
        }

        onBuy() {
          PaymentWrap.Pay(this.meta.Name(), function (ok) {
            if (ok) {
              eventCenter.emit(MyCustomEvent.CanChangeSpin);
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "spin",
                showCallback: wnd => {
                  wnd.addOnCloseFunc(() => {
                    // UIRoot.instance.closeChildWindow("ShopWindow");
                    if (MultiplePurchaseWindow.OpenMulti()) UIRoot.instance.openChildWindow(MultiplePurchaseWindow, {
                      meta: this.meta
                    });
                  });
                }
              });
              SoundManager.playSound("item_purchased");
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "spin",
                name: this.meta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "spin",
                name: this.meta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "spin",
            name: this.meta.Name(),
            phase: 0
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spinIcon", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spinNum", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spinExtra", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spinPrice", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "hotNode", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "bestValueNode", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "oldText", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "star", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PayFailWindow.ts", ['cc', './global.ts', './UIWindow.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, sys, G, UIWindow, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      sys = module.sys;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "232c8Ew7+xDc5lQb8LErSKt", "PayFailWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let PayFailWindow = exports('PayFailWindow', ccclass(_class = (_temp = _class2 = class PayFailWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "data", void 0);
        }

        onShow(showParams) {
          this.data = showParams.data;
          this.data.platform = sys.os;
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        callGo() {
          // let url = `${G.GameConfig.site_host}/PurchaseContact/index.html?userId=` + Game.SUser.Id()
          // for (let key in this.data) {
          //     url += "&" + encodeURI(key) + "=" + encodeURI(this.data[key] || "null")
          // }
          // cc.sys.openURL(url)
          let arr = Object.keys(this.data).map(key => `${key}:${this.data[key]}`);
          arr.unshift(`uid=${Game.SUser.Id()}`);
          let title = "[Impostor Kings][IAP SUPPORT]";
          let body = arr.join("\n");
          let url = `mailto:${G.GameConfig.email}?subject=${encodeURIComponent(title)}&body=${encodeURIComponent(body)}`;
          sys.openURL(url);
          console.log("url:", url);
        }

      }, _defineProperty(_class2, "windowPath", "Shop/NewPayFailWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonMessageWindow.ts", ['cc', './UIWindow.ts', './UserInfoModel.ts', './ScrollViewTool.ts', './CannonCommonAsset.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, RichText, Sprite, UIWindow, UserInfoModel, ScrollViewTool, CannonCommomAsset, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
      RichText = module.RichText;
      Sprite = module.Sprite;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      CannonCommomAsset = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "236ed7GWTFGSrqL3ikozvTR", "CannonMessageWindow", undefined); // const ScrollViewTool = ScrollViewTool
      // const UserInfoModel = UserInfoModel


      const {
        ccclass,
        property
      } = _decorator;
      let CannonMessageWindow = exports('default', (_dec = property(ScrollViewTool), _dec2 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class CannonMessageWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "msg_list", void 0);

          _initializerDefineProperty(this, "svt", _descriptor, this);

          _initializerDefineProperty(this, "label_no_message", _descriptor2, this);
        }

        onShow(params) {
          this.msg_list = params.msg_list;
          this.msg_list.reverse();
          this.label_no_message.node.active = this.msg_list.length <= 0;
          let id_list = this.msg_list.map((v, i) => i);
          this.svt.setItem(id_list, (index, id, node) => {
            let userinfo = GameKit.ControllerTable.GetNode(node, "userinfo").getComponent(UserInfoModel);
            let text_news = GameKit.ControllerTable.GetNode(node, "news").getComponent(RichText);
            let sp_piece = GameKit.ControllerTable.GetNode(node, "sp-piece").getComponent(Sprite);
            let text_time = GameKit.ControllerTable.GetNode(node, "text-time").getComponent(Label);
            let msg = this.msg_list[index];
            userinfo.show(Game.SUser.FriendsList()[msg.friendUserId]);
            let userName = Game.SUser.FriendsList()[msg.friendUserId] ? Game.SUser.FriendsList()[msg.friendUserId].Name() : i18n.t("PlayerDefaultName");
            text_news.string = msg.type === "send" ? String.format(i18n.t("cannon_message_window_send"), userName, msg.itemId + 1) : String.format(i18n.t("cannon_meesage_window_collect"), userName, msg.itemId + 1);
            sp_piece.spriteFrame = CannonCommomAsset.ins.get_item_spf(msg.itemId);
            text_time.string = GameKit.TimeUtil.FormatPastTime(GameKit.TimeUtil.getCurrentTime() - msg.timestamp, true);
          });
        }

        event_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Activity/cannon/CannonMessageWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "label_no_message", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/yzLeaderboard.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports({
        setScore: setScore,
        watchContext: watchContext
      });

      cclegacy._RF.push({}, "23bb9cEWxJDh5ZqBpdgM2ty", "yzLeaderboard", undefined);
      /**
       * 注意：已把原脚本注释，由于脚本变动过大，转换的时候可能有遗落，需要自行手动转换
       */


      let _lastContextId = null;
      let _contextLeaderBoard = null;
      let _lastContextualScore = 0;
      let _current_sore = 0;

      function wait(duration = 100) {
        return new Promise((resolve, reject) => {
          setTimeout(resolve, duration);
        });
      }

      function setScore(value) {
        _current_sore = value;
      }

      async function watchContext() {
        let playerName = FBInstant.player.getName();

        while (true) {
          let contextId = FBInstant.context.getID();

          if (contextId) {
            let rankName = `context.${contextId}`;

            if (contextId != _lastContextId) {
              console.log("context change detected");

              try {
                _lastContextId = contextId;
                _contextLeaderBoard = await FBInstant.getLeaderboardAsync(rankName);
                let entry = await _contextLeaderBoard.getPlayerEntryAsync();
                _lastContextualScore = entry ? entry.getScore() : 0;
                await _contextLeaderBoard.setScoreAsync(_lastContextualScore, "");
                await FBInstant.updateAsync({
                  action: 'LEADERBOARD',
                  name: rankName,
                  text: `${playerName} joined this game`
                });
              } catch (e) {
                console.log("rank msg failed:", e);
              }
            }

            if (_contextLeaderBoard && _current_sore > _lastContextualScore) {
              try {
                console.log("score change detected");
                await _contextLeaderBoard.setScoreAsync(_current_sore, "");
                await FBInstant.updateAsync({
                  action: 'LEADERBOARD',
                  name: rankName
                });
                _lastContextualScore = _current_sore;
              } catch (e) {
                console.log("score changed update failed:", e);
              }
            }
          }

          await wait(3000);
        }
      }

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MetaManager.ts", ['cc', './global.ts', './Logs.ts', './LocalizationMeta.ts', './ActivityParamsMeta.ts', './CardChestMeta.ts', './CardMeta.ts', './CardSetsMeta.ts', './DailyBonusRewardMeta.ts', './DynamicPackMeta.ts', './ItemMeta.ts', './PackItemMeta.ts', './SignMeta.ts', './TaskMeta.ts', './ServantRankMeta.ts', './ShopCardPriceMeta.ts', './ShopCoinMeta.ts', './ShopMeta.ts', './GiftGetMeta.ts', './LevelBonusMeta.ts', './AdGetCoinMeta.ts', './SystemUserMeta.ts', './VillageMeta.ts', './VillageShopMeta.ts', './ActivityManager.ts', './ActivityMeta.ts', './PaymentWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Logs, LocalizationMeta, ActivityParamsMeta, CardChestMeta, CardMeta, CardSetsMeta, DailyBonusRewardMeta, DynamicPackMeta, ItemMeta, PackItemMeta, SignMeta, TaskMeta, ServantRankMeta, ShopCardPriceMeta, ShopCoinMeta, ShopMeta, GiftGetMeta, LevelBonusMeta, AdGetCoinMeta, SystemUserMeta, VillageMeta, VillageShopMeta, ActivityManager, ActivityMeta, PaymentWrap;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      LocalizationMeta = module.LocalizationMeta;
    }, function (module) {
      ActivityParamsMeta = module.ActivityParamsMeta;
    }, function (module) {
      CardChestMeta = module.CardChestMeta;
    }, function (module) {
      CardMeta = module.CardMeta;
    }, function (module) {
      CardSetsMeta = module.CardSetsMeta;
    }, function (module) {
      DailyBonusRewardMeta = module.DailyBonusRewardMeta;
    }, function (module) {
      DynamicPackMeta = module.DynamicPackMeta;
    }, function (module) {
      ItemMeta = module.ItemMeta;
    }, function (module) {
      PackItemMeta = module.PackItemMeta;
    }, function (module) {
      SignMeta = module.SignMeta;
    }, function (module) {
      TaskMeta = module.TaskMeta;
    }, function (module) {
      ServantRankMeta = module.ServantRankMeta;
    }, function (module) {
      ShopCardPriceMeta = module.ShopCardPriceMeta;
    }, function (module) {
      ShopCoinMeta = module.ShopCoinMeta;
    }, function (module) {
      ShopMeta = module.ShopMeta;
    }, function (module) {
      GiftGetMeta = module.GiftGetMeta;
    }, function (module) {
      LevelBonusMeta = module.LevelBonusMeta;
    }, function (module) {
      AdGetCoinMeta = module.AdGetCoinMeta;
    }, function (module) {
      SystemUserMeta = module.SystemUserMeta;
    }, function (module) {
      VillageMeta = module.VillageMeta;
    }, function (module) {
      VillageShopMeta = module.VillageShopMeta;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      ActivityMeta = module.ActivityMeta;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}],
    execute: function () {
      exports('MetaManager', void 0);

      cclegacy._RF.push({}, "24577G0jcpKJo5yMPB4RLqf", "MetaManager", undefined);

      let MetaManager;

      (function (_MetaManager) {
        let _data = {}; //初始数据

        function init(rawMetaData) {
          Clean();
          let metaData = {};

          for (let name in rawMetaData) {
            let rawData = rawMetaData[name];
            let keys = rawData.keys;
            let datas = rawData.data;
            let table = metaData[name] = [];

            for (let data of datas) {
              let row = {};

              for (let i = 0; i < keys.length; i++) {
                row[keys[i]] = data[i];
              }

              table.push(row);
            }
          }

          GetConstance(metaData[MetaType.Constance]);
          SetTypeData(MetaType.Village, VillageMeta.MakeEntity, metaData[MetaType.Village] || {});
          SetTypeData(MetaType.VillageShop, VillageShopMeta.MakeEntity, metaData[MetaType.VillageShop] || {});
          VillageShopMeta.CacheLevels();
          SetTypeData(MetaType.Item, ItemMeta.MakeEntity, metaData[MetaType.Item] || {});
          SetTypeData(MetaType.Shop, ShopMeta.MakeEntity, metaData[MetaType.Shop] || {});
          SetTypeData(MetaType.ShopCoin, ShopCoinMeta.MakeEntity, metaData[MetaType.ShopCoin] || {});
          PaymentWrap.SetByMeta(MetaManager.GetMetas(MetaType.Shop));
          SetTypeData(MetaType.PackItem, PackItemMeta.MakeEntity, metaData[MetaType.PackItem] || {});
          SetTypeData(MetaType.DynamicPack, DynamicPackMeta.MakeEntity, metaData[MetaType.DynamicPack] || {});
          DynamicPackMeta.CacheMeta();
          SetTypeData(MetaType.AdGetCoin, AdGetCoinMeta.MakeEntity, metaData[MetaType.AdGetCoin] || {});
          SetTypeData(MetaType.SystemUser, SystemUserMeta.MakeEntity, metaData[MetaType.SystemUser] || {});
          SystemUserMeta.CacheUser();
          SetTypeData(MetaType.GiftGet, GiftGetMeta.MakeEntity, metaData[MetaType.GiftGet] || {}); // SetTypeData(MetaType.Tutorial,TutorialMeta.MakeEntity, metaData[MetaType.Tutorial] || {});

          SetTypeData(MetaType.DailyBonusReward, DailyBonusRewardMeta.MakeEntity, metaData[MetaType.DailyBonusReward] || {});
          SetTypeData(MetaType.CardSets, CardSetsMeta.MakeEntity, metaData[MetaType.CardSets] || {});
          SetTypeData(MetaType.Card, CardMeta.MakeEntity, metaData[MetaType.Card] || {});
          SetTypeData(MetaType.ShopCardPrice, ShopCardPriceMeta.MakeEntity, metaData[MetaType.ShopCardPrice] || {});
          SetTypeData(MetaType.CardChest, CardChestMeta.MakeEntity, metaData[MetaType.CardChest] || {});
          SetTypeData(MetaType.Activity, ActivityMeta.MakeEntity, metaData[MetaType.Activity] || {});
          ActivityManager.GetConstance(metaData[MetaType.ActivityConstance]);
          SetTypeData(MetaType.ActivityParams, ActivityParamsMeta.MakeEntity, metaData[MetaType.ActivityParams] || {});
          SetTypeData(MetaType.Task, TaskMeta.MakeEntity, metaData[MetaType.Task] || {});
          SetTypeData(MetaType.Sign, SignMeta.MakeEntity, metaData[MetaType.Sign] || {});
          SetTypeData(MetaType.ServantRank, ServantRankMeta.MakeEntity, metaData[MetaType.ServantRank] || {});
          SetTypeData(MetaType.LevelBonus, LevelBonusMeta.MakeEntity, metaData[MetaType.LevelBonus] || {});
          SetTypeData(MetaType.locale, LocalizationMeta.MakeEntity, metaData[MetaType.locale] || {});
        }

        _MetaManager.init = init;

        function Clean() {
          _data = {};
        }

        _MetaManager.Clean = Clean;

        function SetTypeData(metaType, entityMethod, data) {
          try {
            _data[metaType] = {};

            for (let md of data) {
              // let md = data[md];
              let meta = entityMethod(md);
              _data[metaType][meta.Id()] = meta;
            }
          } catch (e) {
            Logs.Error("MetaManager.SetTypeData", metaType, e.message);
          }
        }

        _MetaManager.SetTypeData = SetTypeData;

        function GetMeta(metaType, id) {
          if (_data[metaType] == null) return null;
          return _data[metaType][id];
        }

        _MetaManager.GetMeta = GetMeta;

        function GetMetas(metaType) {
          return _data[metaType];
        }

        _MetaManager.GetMetas = GetMetas;

        function GetConstance(data) {
          try {
            for (let id in data) {
              let kvp = data[id];
              G.GameConstance[kvp.key] = kvp.value;

              if (typeof kvp.value === "string") {
                if (kvp.value.startsWith("[") && kvp.value.endsWith("]") || kvp.value.startsWith("{") && kvp.value.endsWith("}")) {
                  G.GameConstance[kvp.key] = JSON.parse(kvp.value);
                }
              }
            }
          } catch (e) {
            Logs.Error("MetaManager.GetConstance", e.message);
          }
        }

        _MetaManager.GetConstance = GetConstance;
        let MetaType;

        (function (MetaType) {
          MetaType["Shop"] = "shop";
          MetaType["ShopCoin"] = "shopCoin";
          MetaType["Village"] = "village";
          MetaType["VillageShop"] = "villageShop";
          MetaType["AdGetCoin"] = "adGetCoin";
          MetaType["SystemUser"] = "systemUser";
          MetaType["GiftGet"] = "giftGet";
          MetaType["Tutorial"] = "tutorial";
          MetaType["DailyBonusReward"] = "dailyBonusReward";
          MetaType["PackItem"] = "packItem";
          MetaType["DynamicPack"] = "dynamicPack";
          MetaType["CardSets"] = "cardSets";
          MetaType["Card"] = "card";
          MetaType["ShopCardPrice"] = "shopCardPrice";
          MetaType["CardChest"] = "cardChest";
          MetaType["Activity"] = "activity";
          MetaType["ActivityParams"] = "activityParams";
          MetaType["Task"] = "task";
          MetaType["Sign"] = "sign";
          MetaType["Item"] = "item";
          MetaType["ServantRank"] = "servantRank";
          MetaType["LevelBonus"] = "levelBonus";
          MetaType["ActivityConstance"] = "activityConstance";
          MetaType["Constance"] = "constance";
          MetaType["locale"] = "locale";
        })(MetaType || (MetaType = {}));

        _MetaManager.MetaType = MetaType;
      })(MetaManager || (MetaManager = exports('MetaManager', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ExtraRewardWindow.ts", ['cc', './UIWindow.ts', './Content.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, UIWindow, Content, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "251e9ioGiFGGqJeh6o26nUP", "ExtraRewardWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ExtraRewardWindow = exports('ExtraRewardWindow', (_dec = property(Label), _dec2 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class ExtraRewardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelCoin", _descriptor, this);

          _initializerDefineProperty(this, "labelSpin", _descriptor2, this);
        }

        onShow(showParams) {
          let contents = showParams.contents;
          contents.forEach(xx => {
            let x = Content.FromContent(xx);

            if (x.Type() === Content.Types.Ap) {
              this.labelSpin.string = GameKit.StringUtil.formatNumber(x.Count());
            } else if (x.Type() === Content.Types.Coin) {
              this.labelCoin.string = GameKit.StringUtil.formatNumber(x.Count());
            }
          });
        }

        close_window() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Common/ExtraRewardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelCoin", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelSpin", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardAllSetWindow.ts", ['cc', './Constant.ts', './global.ts', './PlayAudio.ts', './UIWindow.ts', './CardInfoWindow.ts', './CardSingleSetWindow.ts', './CardItem.ts', './SR.ts', './CardChestOpenWindow.ts', './ShopWindow.ts', './UIRoot.ts', './StaticGame.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, Prefab, Layout, _decorator, Widget, instantiate, UITransform, view, MyCustomEvent, G, PlayAudio, UIWindow, CardInfoWindow, CardSingleSetWindow, CardItem, SR, CardChestOpenWindow, ShopWindow, UIRoot, Meta, Game, ADWrap, GameKit, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      Prefab = module.Prefab;
      Layout = module.Layout;
      _decorator = module._decorator;
      Widget = module.Widget;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
      view = module.view;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      PlayAudio = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CardInfoWindow = module.default;
    }, function (module) {
      CardSingleSetWindow = module.default;
    }, function (module) {
      CardItem = module.CardItem;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2622c443ptMHraHm96DdBpr", "CardAllSetWindow", undefined);
      /**
       * @author fengyong 2019-5-14
       */


      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      /**
       * 卡片所有集合界面
       */

      let CardAllSetWindow = exports('default', (_dec = property(Node), _dec2 = property(Label), _dec3 = property(Prefab), _dec4 = property(Node), _dec5 = property(Layout), _dec6 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class CardAllSetWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "btnWatchFree", _descriptor, this);

          _initializerDefineProperty(this, "labelFree", _descriptor2, this);

          _initializerDefineProperty(this, "cardItemPrefab", _descriptor3, this);

          _initializerDefineProperty(this, "cardContents", _descriptor4, this);

          _initializerDefineProperty(this, "cardContentLayout", _descriptor5, this);

          _initializerDefineProperty(this, "redDot", _descriptor6, this);

          _defineProperty(this, "all_set_meta", void 0);

          _defineProperty(this, "cardSingleWindowOpened", false);

          _defineProperty(this, "spacingX", 28);
        }

        onLoad() {
          this.node.getChildByName("content").getComponent(Widget).top += AppMain.instance.statusBarHeight;
        }

        onShow(showParams) {
          this.get_data(); // this.create_svt();

          this.initCardItems(); // setTimeout(() => {
          // 	homeView.node.active = false;
          // }, 1);
          // NEWTODO
          // let shownInfo = GameKit.PlayerPrefs.GetBool("UserCardEntered");
          // if (!shownInfo) {
          // 	UIRoot.instance.openChildWindow(CardInfoWindow);
          // 	GameKit.PlayerPrefs.SetBool("UserCardEntered", true);
          // }

          GameKit.BackKeyManager.registerBackEvent(() => {
            homeView.node.active = true;
            PlayAudio.playClose();
            this.closeAnim();
          });

          if (showParams.setId) {
            let meta = Meta.MetaManager.GetMeta(Meta.MetaType.CardSets, showParams.setId);
            UIRoot.instance.openChildWindow(CardSingleSetWindow, {
              single_set_meta: meta
            });
          }

          if (Game.SUserVillage.MapId() >= G.GameConstance.cardSystemStartLevel && ADWrap.AdEnabled() && Game.SUserCard.data.freeCount < G.GameConstance.dailyFreeChestCount) {
            this.labelFree.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
            this.redDot.active = true;
          } else {
            this.labelFree.string = "0/3";
            this.redDot.active = false;
          }

          eventCenter.on(MyCustomEvent.WatchAdForChest, () => {
            this.labelFree.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
            this.redDot.active = true;
          }, this); // this.btnWatchFree.active = Game.SUserVillage.MapId() >= G.GameConstance.cardSystemStartLevel && AppKit.ADWrap.AdEnabled() && Game.SUserCard.data.freeCount < G.GameConstance.dailyFreeChestCount;
        }
        /** 所有set的meta数据 */

        /**
         * 获取数据
         * CardSetsMeta(/meta/public/cardSets.xlsx)
         * - id
         * - name           名字
         * - min_village    开放需要的村庄等级
         * - reward         奖励(contentString字符串,用";"分割)
         * - [注意] 此模块可以直接在游戏预览中获取
         */


        get_data() {
          this.all_set_meta = Meta.MetaManager.GetMetas(Meta.MetaType.CardSets);
        }

        initCardItems() {
          let itemSize = null;
          Object.keys(this.all_set_meta).forEach((key, index) => {
            const meta = this.all_set_meta[key];
            const newCardItemNode = instantiate(this.cardItemPrefab);
            newCardItemNode.active = false;
            this.cardContents.addChild(newCardItemNode);
            index === 0 && (itemSize = newCardItemNode.getComponent(UITransform).contentSize);
            const cardItem = newCardItemNode.getComponent(CardItem);
            cardItem.updatePanel(meta, index + 1);
          });
          this.cardContents.children.forEach(child => {
            child.active = true;
          });
          this.setCardContentSize(itemSize);
        }

        setCardContentSize(nodeSize) {
          const row = Math.ceil(Object.keys(this.all_set_meta).length / 3);
          this.cardContents.getComponent(UITransform).height = row * nodeSize.height + this.cardContentLayout.spacingY * (row - 1) + this.cardContentLayout.paddingTop + 120;

          if (view.getVisibleSize().width > nodeSize.width * 3 + this.spacingX * 2) {
            this.cardContentLayout.paddingLeft = (view.getVisibleSize().width - (nodeSize.width * 3 + this.spacingX * 2)) / 2;
          } else {
            this.spacingX = (view.getVisibleSize().width - nodeSize.width * 3) / 4;
            this.cardContentLayout.paddingLeft = this.spacingX;
            this.cardContentLayout.spacingX = this.spacingX;
          }
        }

        event_info() {
          UIRoot.instance.openChildWindow(CardInfoWindow);
        }

        event_shop() {
          // UIRoot.instance.openChildWindow(ShopWindow, { showChest: true });
          homeView.pageViewController.moveToPage(G.Pages.Shop, true);
          homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.chest);
        }

        event_watchFree() {
          if (Game.SUserCard.data.freeCount >= G.GameConstance.dailyFreeChestCount) return;
          ADWrap.ShowVideo(() => {
            let req = SR.SRCard.watchChest();
            req.SetCallBack(() => {
              this.flushData();
              let chest = GameKit.DataCache.GetData("UserCardChest");
              UIRoot.instance.openChildWindow(CardChestOpenWindow, {
                chest: chest
              });
              GameKit.DataCache.RemoveData("UserCardChest");
              this.labelFree.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
              this.btnWatchFree.active = Game.SUserCard.data.freeCount < G.GameConstance.dailyFreeChestCount;
              eventCenter.emit(MyCustomEvent.WatchAdForChest);
            });
            req.Send();
          }, "freeChest");
        }

        flushData() {
          this.get_data();
          this.cardContents.children.forEach((card, index) => {
            const cardItem = card.getComponent(CardItem);
            const keys = Object.keys(this.all_set_meta);
            const meta = this.all_set_meta[keys[index]];
            cardItem && cardItem.updatePanel(meta, index + 1);
          });
        }

      }, _defineProperty(_class3, "windowPath", "newCard/NewCardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "btnWatchFree", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelFree", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "cardItemPrefab", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "cardContents", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "cardContentLayout", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "redDot", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AdvancedWidget.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, CCInteger, CCBoolean, _decorator, v3, UITransform, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      CCInteger = module.CCInteger;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      v3 = module.v3;
      UITransform = module.UITransform;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2639c1HzQ9K6KKvWSLjm3PW", "AdvancedWidget", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let AdvancedWidget = exports('default', (_dec = property(Node), _dec2 = property(CCInteger), _dec3 = property(Node), _dec4 = property(CCInteger), _dec5 = property(Node), _dec6 = property(CCInteger), _dec7 = property(Node), _dec8 = property(CCInteger), _dec9 = property(CCBoolean), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class AdvancedWidget extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "targetLeft", _descriptor, this);

          _initializerDefineProperty(this, "left", _descriptor2, this);

          _initializerDefineProperty(this, "targetRight", _descriptor3, this);

          _initializerDefineProperty(this, "right", _descriptor4, this);

          _initializerDefineProperty(this, "targetTop", _descriptor5, this);

          _initializerDefineProperty(this, "top", _descriptor6, this);

          _initializerDefineProperty(this, "targetBottom", _descriptor7, this);

          _initializerDefineProperty(this, "bottom", _descriptor8, this);

          _initializerDefineProperty(this, "always", _descriptor9, this);

          _defineProperty(this, "_editoralways", void 0);
        }

        onLoad() {
          if (CC_EDITOR && this.always) {
            this._editoralways = true;
          }

          this.execute();
        }

        onEnable() {
          if (CC_EDITOR && this.always) {
            this.node.setPosition(v3(0, 0));
            this._editoralways = true;
            this.execute();
          }
        }

        slowUpdate(dt) {
          if (this.always) {
            this.execute();
          }
        }

        execute() {
          if (!this.node) return;
          if (CC_EDITOR && !this._editoralways) return;
          if (CC_EDITOR && this._editoralways) this._editoralways = false;
          let boundl = this.targetLeft.getWorldPosition().x - this.targetLeft.anchorX * this.targetLeft.width + this.left;
          let boundr = this.targetRight.getWorldPosition().x + (1 - this.targetRight.anchorX) * this.targetRight.width + this.right;
          let boundb = this.targetBottom.getWorldPosition().y - this.targetBottom.anchorY * this.targetBottom.height + this.bottom;
          let boundt = this.targetTop.getWorldPosition().y + (1 - this.targetTop.anchorY) * this.targetTop.height + this.top;
          this.node.getComponent(UITransform).width = boundr - boundl;
          this.node.getComponent(UITransform).height = boundt - boundb;
          let dx = (boundr + boundl) / 2;
          let dy = (boundb + boundt) / 2; ///new api 

          this.node.setPosition(v3(dx, dy)); // this.node.setWorldPosition(cc.v2(dx, dy))
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "targetLeft", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "left", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "targetRight", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "right", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "targetTop", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "top", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "targetBottom", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "bottom", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "always", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRServant.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRServant', void 0);

      cclegacy._RF.push({}, "26930SJ1Q9Kz4e4sSAwCHmD", "SRServant", undefined);

      let SRServant;

      (function (_SRServant) {
        function getUserServant() {
          let req = new GameKit.ServerRequest("getUserServant");
          req.SetCallBack(function (res) {
            Game.SUserServant.updateData(res.userdata);
          });
          return req;
        }

        _SRServant.getUserServant = getUserServant;

        function servantFeed(id) {
          let req = new GameKit.ServerRequest("servantFeed");
          req.SetRequestBody("id", id);
          return req;
        }

        _SRServant.servantFeed = servantFeed;

        function servantFeedFree(id) {
          let req = new GameKit.ServerRequest("servantFeedFree");
          req.SetRequestBody("id", id);
          return req;
        }

        _SRServant.servantFeedFree = servantFeedFree;

        function servantAddExp(id) {
          let req = new GameKit.ServerRequest("servantAddExp");
          req.SetRequestBody("id", id);
          return req;
        }

        _SRServant.servantAddExp = servantAddExp;

        function servantLevelUp(id) {
          let req = new GameKit.ServerRequest("servantLevelUp");
          req.SetRequestBody("id", id);
          return req;
        }

        _SRServant.servantLevelUp = servantLevelUp;

        function servantSelect(id) {
          let req = new GameKit.ServerRequest("servantSelect");
          req.SetRequestBody("id", id);
          return req;
        }

        _SRServant.servantSelect = servantSelect;

        function unlockFirstServant() {
          let req = new GameKit.ServerRequest("unlockFirstServant");
          return req;
        }

        _SRServant.unlockFirstServant = unlockFirstServant;
      })(SRServant || (SRServant = exports('SRServant', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotSkinNode.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Color, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Color = module.Color;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "26f64F1AUpA15gK56Vgl6Sk", "SlotSkinNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotSkinNode = exports('default', (_dec = property(SpriteFrame), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(SpriteFrame), _dec5 = property(SpriteFrame), _dec6 = property(Color), _dec7 = property(Color), _dec8 = property(Color), ccclass(_class = (_class2 = (_temp = class SlotSkinNode extends CCE_Component {
        constructor() {
          super();

          _defineProperty(this, "betBtnCallback", void 0);

          _initializerDefineProperty(this, "raidSprite", _descriptor, this);

          _initializerDefineProperty(this, "coin2Sprite", _descriptor2, this);

          _initializerDefineProperty(this, "raidBlurSprite", _descriptor3, this);

          _initializerDefineProperty(this, "coin2BlurSprite", _descriptor4, this);

          _initializerDefineProperty(this, "bigRaidSprite", _descriptor5, this);

          _initializerDefineProperty(this, "color1", _descriptor6, this);

          _initializerDefineProperty(this, "color2", _descriptor7, this);

          _initializerDefineProperty(this, "color3", _descriptor8, this);

          this.betBtnCallback = null;
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        getRaidSprite() {
          return this.raidSprite;
        }

        getBigRaidSprite() {
          return this.bigRaidSprite;
        }

        getCoin2Sprite() {
          return this.coin2Sprite;
        }

        getRaidBlurSprite() {
          return this.raidBlurSprite;
        }

        getCoin2BlurSprite() {
          return this.coin2BlurSprite;
        }

        getColorReward() {
          return this.color1;
        }

        getColor2() {
          return this.color2;
        }

        getColor3() {
          return this.color3;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "raidSprite", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "coin2Sprite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "raidBlurSprite", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "coin2BlurSprite", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "bigRaidSprite", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "color1", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "color2", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "color3", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FacebookBindWindow.ts", ['cc', './UIWindow.ts', './AppGame.ts', './SR.ts', './StaticGame.ts', './UserWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UIWindow, AppGame, SR, Game, UserWrap;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      UserWrap = module.UserWrap;
    }, function () {}],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "273dbMpgeVFq5dGRmc2gwW2", "FacebookBindWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FacebookBindWindow = exports('default', ccclass(_class = (_temp = _class2 = class FacebookBindWindow extends UIWindow {
        close_window() {
          this.closeAnim();
        }

        connect() {
          UserWrap.NativeFBLogin(() => {
            let req = SR.SRLogin.bindAccount(Game.SUser.accountId, Game.SUser.from);
            req.SetCallBack(() => {
              this.close();
              AppGame.instance.logout();
            });
            req.Send();
          });
        }

      }, _defineProperty(_class2, "windowPath", "Sys/NewFacebookBindWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonMainWindow.ts", ['cc', './CCEaseTypes.ts', './global.ts', './SoundManager.ts', './UIWindow.ts', './DialogWindow.ts', './FullLoadingWindow.ts', './SR.ts', './ClockUtil.ts', './CannonCommonAsset.ts', './CannonData.ts', './CannonItemWindow.ts', './CannonMessageWindow.ts', './CannonShopWindow.ts', './CannonTool.ts', './UIRoot.ts', './StaticGame.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, ParticleSystem2D, Button, PolygonCollider2D, Animation, _decorator, macro, tween, view, instantiate, v2, Vec2, math, Vec3, Sprite, Intersection2D, CCEaseTypes, G, SoundManager, UIWindow, DialogWindow, FullLoadingWindow, SR, ClockUtil, CannonCommomAsset, CannonData, CannonItemWindow, CannonMessageWindow, CannonShopWindow, CannonTool, UIRoot, Game, ADWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      ParticleSystem2D = module.ParticleSystem2D;
      Button = module.Button;
      PolygonCollider2D = module.PolygonCollider2D;
      Animation = module.Animation;
      _decorator = module._decorator;
      macro = module.macro;
      tween = module.tween;
      view = module.view;
      instantiate = module.instantiate;
      v2 = module.v2;
      Vec2 = module.Vec2;
      math = module.math;
      Vec3 = module.Vec3;
      Sprite = module.Sprite;
      Intersection2D = module.Intersection2D;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      FullLoadingWindow = module.FullLoadingWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      ClockUtil = module.ClockUtil;
    }, function (module) {
      CannonCommomAsset = module.default;
    }, function (module) {
      CannonData = module.default;
    }, function (module) {
      CannonItemWindow = module.default;
    }, function (module) {
      CannonMessageWindow = module.default;
    }, function (module) {
      CannonShopWindow = module.default;
    }, function (module) {
      CannonTool = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "276f91Ef0ZGNoowvH+Bw2pb", "CannonMainWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //// const UIWindow = UIWindow

      let CannonMainWindow = exports('default', (_dec = property({
        tooltip: "活动倒计时",
        type: Label,
        visible: true
      }), _dec2 = property({
        tooltip: "刷新时间",
        type: Label,
        visible: true
      }), _dec3 = property({
        tooltip: "云",
        type: Node,
        visible: true
      }), _dec4 = property({
        tooltip: "所有box的父节点",
        type: Node,
        visible: true
      }), _dec5 = property({
        tooltip: "刷新时的粒子效果",
        type: ParticleSystem2D,
        visible: true
      }), _dec6 = property({
        tooltip: "ring个数",
        type: Label,
        visible: true
      }), _dec7 = property({
        tooltip: "ball个数",
        type: Label,
        visible: true
      }), _dec8 = property({
        tooltip: "看广告获取ball按钮",
        type: Button,
        visible: true
      }), _dec9 = property({
        tooltip: "炮弹",
        type: Node,
        visible: true
      }), _dec10 = property({
        tooltip: "弹弓",
        type: Node,
        visible: true
      }), _dec11 = property({
        tooltip: "弹弓左边绳子",
        type: Node,
        visible: true
      }), _dec12 = property({
        tooltip: "弹弓右边绳子",
        type: Node,
        visible: true
      }), _dec13 = property({
        tooltip: "弹弓支架",
        type: Node,
        visible: true
      }), _dec14 = property({
        tooltip: "所有动画的父节点",
        type: Node,
        visible: true
      }), _dec15 = property({
        tooltip: "城堡",
        type: PolygonCollider2D,
        visible: true
      }), _dec16 = property({
        type: Animation,
        visible: true
      }), ccclass(_class = (_class2 = (_temp = _class3 = class CannonMainWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "_label_activity_time", _descriptor, this);

          _initializerDefineProperty(this, "_label_refresh_time", _descriptor2, this);

          _initializerDefineProperty(this, "_cloud_list", _descriptor3, this);

          _initializerDefineProperty(this, "_box_parent", _descriptor4, this);

          _initializerDefineProperty(this, "_ps_refresh", _descriptor5, this);

          _initializerDefineProperty(this, "_label_ring", _descriptor6, this);

          _initializerDefineProperty(this, "_label_ball", _descriptor7, this);

          _initializerDefineProperty(this, "_btn_watch_ad_get_ball", _descriptor8, this);

          _initializerDefineProperty(this, "_ball", _descriptor9, this);

          _defineProperty(this, "_ball_base_local_position", null);

          _defineProperty(this, "_ball_base_world_position", null);

          _defineProperty(this, "_ball_viewpoint_world_position", null);

          _initializerDefineProperty(this, "_slingshot", _descriptor10, this);

          _defineProperty(this, "_slingshot_base_local_position", null);

          _initializerDefineProperty(this, "_slingshot_left_rope", _descriptor11, this);

          _defineProperty(this, "_slingshot_left_rope_base_local_position", null);

          _initializerDefineProperty(this, "_slingshot_right_rope", _descriptor12, this);

          _defineProperty(this, "_slingshot_right_rope_base_local_position", null);

          _initializerDefineProperty(this, "_slingshot_support", _descriptor13, this);

          _initializerDefineProperty(this, "_anima_parent", _descriptor14, this);

          _initializerDefineProperty(this, "_castle", _descriptor15, this);

          _initializerDefineProperty(this, "_anima_guide_hand", _descriptor16, this);

          _defineProperty(this, "_timer_guide_hand", 10);
        }
        /**
         * 从activity中心调用的打开方法
         * @param {any} meta
         */


        static Show(meta) {
          FullLoadingWindow.Show(() => {
            homeView.closeGamePlay();
            UIRoot.instance.openWindow("CannonMainWindow", {
              showCallback: () => {
                FullLoadingWindow.Hide();
              },
              activityMeta: meta
            });
          });
        }
        /** 从activity中心调用的关闭方法 */


        callClose() {
          FullLoadingWindow.Show(() => {
            UIRoot.instance.openWindow("GameMainWindow", {
              showCallback: () => {
                homeView.EnterGame();
                homeView.backToHomeView(() => {
                  FullLoadingWindow.Hide();
                });
              }
            });
          });
        }
        /** @type {CannonMainWindow} */


        onShow(params) {
          CannonMainWindow.ins = this;
          let activityMeta = params.activityMeta;
          CannonData.load_data(activityMeta);
          CannonData.ask_refresh().then(() => this._anima_refresh_box_first()).then(() => this._anima_box_float());
          ClockUtil.RegisterClock("cannon-ask-refresh-0", 0, 0, () => {
            CannonData.ask_refresh().then(() => {
              this._anima_refresh_box();
            });
          });
          ClockUtil.RegisterClock("cannon-ask-refresh-12", 12, 0, () => {
            CannonData.ask_refresh().then(() => {
              this._anima_refresh_box();
            });
          });

          this._bind_ui_event();

          this._ball.active = CannonData.get_ball_count() > 0;
          this._label_ball.string = `${CannonData.get_ball_count()}/20`;
          this._btn_watch_ad_get_ball.node.active = CannonData.is_watch_ad_get_ball();
          this._label_ring.string = `${CannonData.get_refresh_count()}`;

          this._init_activity_time();

          this._anima_cloud();

          this._init_guide_hand();

          this._init_ball();
        }

        onDestroy() {
          CannonMainWindow.ins = null;
          CannonData.clear_data();
          ClockUtil.UnRegister("cannon-ask-refresh-0");
          ClockUtil.UnRegister("cannon-ask-refresh-12");

          this._unbind_ui_event();
        }

        _bind_ui_event() {
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "CannonMainWindow", () => {
            this._ball.active = CannonData.get_ball_count() > 0;
            this._label_ball.string = `${CannonData.get_ball_count()}/20`;
            this._btn_watch_ad_get_ball.node.active = CannonData.is_watch_ad_get_ball();
          });
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "CannonMainWindow", () => {
            this._label_ring.string = `${CannonData.get_refresh_count()}`;
          });
        }

        _unbind_ui_event() {
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "CannonMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "CannonMainWindow");
        }
        /** @type {cc.Label} */

        /** 活动倒计时/刷新倒计时 */


        _init_activity_time() {
          this._label_activity_time.string = CannonData.get_activity_time_str();
          this._label_refresh_time.string = CannonData.get_refresh_time_str();

          this._label_activity_time.schedule(() => {
            this._label_activity_time.string = CannonData.get_activity_time_str();
            this._label_refresh_time.string = CannonData.get_refresh_time_str();
          }, 1, macro.REPEAT_FOREVER);
        }
        /** @type {cc.Node[]} */

        /** 云的移动动画,只配置了2个云的动画时间 */


        _anima_cloud() {
          let time = [20, 30];

          this._cloud_list.forEach((v, i) => {
            tween(v).repeatForever(tween().sequence(tween().to(time[i], {
              x: -view.getVisibleSize().width / 2 - v.width
            }), tween().set({
              x: view.getVisibleSize().width / 2
            }))).start();
          });
        }
        /** @type {cc.Node} */

        /** 获取所有的box */


        get_all_box() {
          return this._box_parent.children;
        }
        /** 所有box的飘动动画 */


        _anima_box_float() {
          this._box_parent.children.forEach(v => {
            tween(v).repeatForever(tween().sequence(tween().to(0.6, {
              rotation: -10
            }, {
              easing: "sineOut"
            }), tween().to(1.2, {
              rotation: 10
            }, {
              easing: "sineInOut"
            }), tween().to(0.6, {
              rotation: 0
            }, {
              easing: "sineIn"
            }))).start();
          });
        }
        /** 打开界面时第1次刷新(仅在打开界面时调用) */


        _anima_refresh_box_first() {
          return new Promise(res => {
            this._box_parent.children.forEach((v, i) => {
              tween(v).set({
                scale: 0
              }).call(() => {
                v.destroyAllChildren();

                if (CannonData.get_box(i) > 0) {
                  instantiate(CannonCommomAsset.ins.get_random_box_prefab()).parent = v;
                }
              }).delay(0.3).to(0.3, {
                scale: 1
              }, {
                easing: "backOut"
              }).call(res).start();
            });
          });
        }
        /** 刷新所有的box */


        _anima_refresh_box() {
          return new Promise(res => {
            this._box_parent.children.forEach((v, i) => {
              tween(v) // 1. 隐藏
              .to(0.3, {
                scale: 0
              }, {
                easing: "backIn"
              }) // 2. 更新box的显示,执行粒子特效
              .call(() => {
                v.destroyAllChildren();
                v.x += G.getRandomFloat(-10, 10);
                v.y += G.getRandomFloat(-10, 10);

                if (CannonData.get_box(i) > 0) {
                  instantiate(CannonCommomAsset.ins.get_random_box_prefab()).parent = v;
                }
              }).call(() => {
                i === 0 && this._ps_refresh.resetSystem();
              }).delay(2).call(() => {
                i === 0 && this._ps_refresh.stopSystem();
              }) // 3. 显示
              .to(0.3, {
                scale: 1
              }, {
                easing: "backOut"
              }).call(res).start();
            });

            this.scheduleOnce(() => {
              SoundManager.playSound("cannon_ring");
            }, 0.5);
          });
        }
        /** @type {cc.Label} */


        get_ball_base_world_position() {
          return this._ball_base_world_position;
        }

        get_ball_now_world_position() {
          return CannonTool.get_node_world_position(this._ball);
        }

        get_ball_viewpoint_world_position() {
          return this._ball_viewpoint_world_position;
        }
        /** @type {cc.Node} */

        /** 获取左边绳子终点定位点的世界坐标 */


        _get_slingshot_left_rope_end_world_position() {
          return this._slingshot.convertToWorldSpaceAR(v2(-45, -30));
        }
        /** @type {cc.Node} */

        /** 获取右边绳子终点定位点的世界坐标 */


        _get_slingshot_right_rope_end_world_position() {
          return this._slingshot.convertToWorldSpaceAR(v2(45, -30));
        }
        /** @type {cc.Node} */


        _init_ball() {
          this._ball_base_local_position = this._ball.position;
          this._ball_base_world_position = this._ball.convertToWorldSpaceAR(Vec2.ZERO);
          this._ball_viewpoint_world_position = this._ball_base_world_position.add(v2(0, CannonData.BALL_POSITION_LENGTH_MIN));
          this._slingshot_base_local_position = this._slingshot.position;
          this._slingshot_left_rope_base_local_position = this._slingshot_left_rope.position;
          this._slingshot_right_rope_base_local_position = this._slingshot_right_rope.position;
        }
        /**
         * 设置ball的位置,附带设置slingshot的位置
         * @param {cc.Vec2} world_position
         */


        set_ball_position(world_position) {
          // ball
          CannonTool.set_node_position(this._ball, world_position);
          CannonTool.set_node_rotation_by_viewpoint(this._ball, this._ball_viewpoint_world_position); // slingshot

          CannonTool.set_node_position(this._slingshot, world_position);
          CannonTool.set_node_rotation_by_viewpoint(this._slingshot, this._ball_viewpoint_world_position); // 注意左右绳子的位置与slingshot的旋转角度有关
          // slingshot-left-rope

          CannonTool.fill_node(this._slingshot_left_rope, this._slingshot_left_rope_base_local_position, CannonTool.get_node_local_position(this._slingshot_left_rope, this._get_slingshot_left_rope_end_world_position())); // slingshot-right-rope

          CannonTool.fill_node(this._slingshot_right_rope, this._slingshot_right_rope_base_local_position, CannonTool.get_node_local_position(this._slingshot_right_rope, this._get_slingshot_right_rope_end_world_position())); // slingshot-support/scale

          let length = world_position.subtract(this._ball_viewpoint_world_position).mag();
          this._slingshot_support.scaleY = math.lerp(1, 0.9, CannonTool.get_lerp(length, CannonData.BALL_POSITION_LENGTH_MIN, CannonData.BALL_POSITION_LENGTH_MAX));
        }
        /** 重置弹弓(弹弓和ball的位置相同,但是ball会被隐藏,所以使用slingshot) */


        anima_reset_slingshot() {
          let f = () => {
            this.set_ball_position(CannonTool.get_node_world_position(this._slingshot));
          };

          return new Promise(res => {
            tween(this._slingshot).call(() => {
              this.schedule(f.bind(this), 0, macro.REPEAT_FOREVER);
            }).to(0.3, {
              position: this._slingshot_base_local_position
            }, {
              easing: "backOut"
            }).call(() => {
              this.unschedule(f.bind(this));
              res(null);
            }).start();
          });
        }
        /** @type {cc.Node} */

        /** 城堡击中后的抖动动画 */


        _anima_castle_shake() {
          return new Promise(res => {
            this._castle.node.runAction(ccAction.sequence(ccAction.scaleTo(0.07, 1.05, 0.95), ccAction.scaleTo(0.14, 0.95, 1.05), ccAction.scaleTo(0.14, 1.05, 0.95), ccAction.scaleTo(0.07, 1, 1), ccAction.callFunc(res)));
          });
        }
        /**
         * 打炮的动画
         * @param {cc.Vec2} target_w_position 炮弹的落点
         */


        anima_shoot_ball(target_w_position) {
          return new Promise(res => {
            // 炮弹动画
            let position_start = this._anima_parent.convertToNodeSpaceAR(CannonTool.get_node_world_position(this._ball));

            let position_end = this._anima_parent.convertToNodeSpaceAR(target_w_position); // [0,0,0.94,1.18]
            // let x = position_end.x - position_start.x
            // let y = position_end.y - position_start.y
            // let bezier_1 = position_start.add(cc.v2(0 * x, 0 * y))
            // let bezier_2 = position_start.add(cc.v2(0.94 * x, 1.18 * y))


            this._ball.active = false;
            let n = instantiate(this._ball);
            n.parent = this._anima_parent;
            n.position = position_start;
            n.scale = Vec3.ONE;
            n.active = true;
            n.runAction(ccAction.sequence(ccAction.spawn(ccAction.scaleTo(0.7, 0.5), ccAction.rotateBy(0.7, 1080), ///new api
            ccAction.moveTo(0.7, position_end, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), // ccAction.moveTo(0.7, position_end, ccAction.easeBackOut(5)),
            // cc.bezierTo(0.7, [bezier_1, bezier_2, position_end], CCEaseTypes.GetEasing(CCEaseTypes.Types.easeQuadraticActionOut)),
            ccAction.callFunc(() => {
              SoundManager.playSound("cannon_fly");
            })), ccAction.callFunc(() => {
              // 炸弹特效
              n.getComponent(Sprite).spriteFrame = null;

              if (n.children[0]) {
                n.children[0].active = true;
              }

              this.scheduleOnce(() => n.destroy(), 1); // 城堡抖动

              if (Intersection2D.pointInPolygon(CannonTool.get_node_local_position(this._castle.node, target_w_position), this._castle.points)) {
                this._anima_castle_shake();
              }

              res(null);
            })));
          });
        }
        /**
         * box被击中的动画
         * @param {number} box_index
         */


        anima_box_hit(box_index) {
          return new Promise(res => {
            let box = this._box_parent.children[box_index];

            if (!box) {
              res(null);
              return;
            } // 如果box不存在则直接结束动画


            let n = instantiate(box);
            n.parent = this._anima_parent;
            n.position = this._anima_parent.convertToNodeSpaceAR(CannonTool.get_node_world_position(box));
            box.destroyAllChildren();
            tween(n).to(0.5, {
              scale: 2,
              position: Vec2.ZERO
            }, {
              easing: "backInOut"
            }).call(res).delay(0.5).call(() => {
              n.destroy();
            }).start();
          });
        }
        /** @type {cc.Animation} */


        _init_guide_hand() {
          this._anima_guide_hand.node.active = false;
          this.schedule(() => {
            this._timer_guide_hand += 1; // 每20s无操作则显示引导小手

            if (this._timer_guide_hand >= 20) {
              this.show_guide_hand();
            }
          }, 1, macro.REPEAT_FOREVER);
        }

        show_guide_hand() {
          if (this._anima_guide_hand.node.active) return;
          this._anima_guide_hand.node.active = true;

          this._anima_guide_hand.setCurrentTime(0);

          this.scheduleOnce(() => {
            this.hide_guide_hand();
            this.reset_guide_hand_timer();
          }, 5);
        }

        hide_guide_hand() {
          this._anima_guide_hand.node.active = false;
        }

        reset_guide_hand_timer() {
          this._timer_guide_hand = 0;
        }

        event_exchange() {
          UIRoot.instance.openChildWindow(CannonItemWindow);
        }

        event_info() {}

        event_message() {
          UIRoot.instance.openChildWindow(CannonMessageWindow, {
            msg_list: CannonData.get_message_list()
          });
        }

        event_refresh() {
          let f1 = CannonData.get_refresh_count() > 0;
          let f2 = CannonData.get_box_count() > 0;

          if (f1 && f2) {
            DialogWindow.Show(String.format(i18n.t("cannon_main_window_refresh_check"), CannonData.get_box_count()), () => {
              CannonData.use_refresh().then(() => {
                this._anima_refresh_box();
              });
            }, () => {});
          } else if (f1 && !f2) {
            CannonData.use_refresh().then(() => {
              this._anima_refresh_box();
            });
          } else {
            UIRoot.instance.openChildWindow(CannonShopWindow);
          }
        }

        event_ball() {
          // 实际上是打开商店页面
          UIRoot.instance.openChildWindow(CannonShopWindow);
        }

        event_watch_ad_get_ball() {
          if (!CannonData.is_watch_ad_get_ball()) {
            return;
          }

          ADWrap.ShowVideo(() => {
            let sr = SR.SRActivityCannon.activityCannonWatchAdGetBall(Game.SUser.UserId(), CannonData.get_activity_meta_id());
            sr.SetCallBack(() => {// TODO 获取成功提示
            });
            sr.Send();
          }, "cannon");
        }

        event_close() {
          this.callClose();
        }

      }, _defineProperty(_class3, "windowPath", "Activity/cannon/CannonMainWindow"), _defineProperty(_class3, "ins", void 0), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "_label_activity_time", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "_label_refresh_time", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "_cloud_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "_box_parent", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "_ps_refresh", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "_label_ring", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "_label_ball", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "_btn_watch_ad_get_ball", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "_ball", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "_slingshot", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "_slingshot_left_rope", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "_slingshot_right_rope", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "_slingshot_support", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "_anima_parent", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "_castle", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "_anima_guide_hand", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BlackJackMainWindow.ts", ['cc', './CCEaseTypes.ts', './global.ts', './SoundManager.ts', './UIWindow.ts', './NumAnim.ts', './FullLoadingWindow.ts', './ContentCheck.ts', './SR.ts', './BlackJackAssets.ts', './BlackJackHelpWindow.ts', './BlackJackWatchWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, Sprite, _decorator, v3, instantiate, CCEaseTypes, G, SoundManager, UIWindow, NumAnim, FullLoadingWindow, ContentCheck, SR, BlackJackAssets, BlackJackHelpWindow, BlackJackWatchWindow, UIRoot, Game, Meta, LogEventWrap, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      Sprite = module.Sprite;
      _decorator = module._decorator;
      v3 = module.v3;
      instantiate = module.instantiate;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      NumAnim = module.default;
    }, function (module) {
      FullLoadingWindow = module.FullLoadingWindow;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      BlackJackAssets = module.default;
    }, function (module) {
      BlackJackHelpWindow = module.BlackJackHelpWindow;
    }, function (module) {
      BlackJackWatchWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _dec27, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _descriptor26, _descriptor27, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "27cd1NigvtKRI2/IKyoOBPa", "BlackJackMainWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BlackJackMainWindow = exports('BlackJackMainWindow', (_dec = property(Label), _dec2 = property(Node), _dec3 = property(Label), _dec4 = property([Node]), _dec5 = property(Node), _dec6 = property(Label), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Node), _dec12 = property(Node), _dec13 = property(Node), _dec14 = property(Node), _dec15 = property(Node), _dec16 = property(Node), _dec17 = property(Node), _dec18 = property(Node), _dec19 = property(Node), _dec20 = property(Label), _dec21 = property(Label), _dec22 = property(Label), _dec23 = property(Node), _dec24 = property(Label), _dec25 = property(Node), _dec26 = property(Sprite), _dec27 = property(BlackJackAssets), ccclass(_class = (_class2 = (_temp = _class3 = class BlackJackMainWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelCoin", _descriptor, this);

          _initializerDefineProperty(this, "spCoinRaidProtect", _descriptor2, this);

          _initializerDefineProperty(this, "labelCoinRaidProtect", _descriptor3, this);

          _initializerDefineProperty(this, "chips", _descriptor4, this);

          _initializerDefineProperty(this, "chipsParent", _descriptor5, this);

          _initializerDefineProperty(this, "labelChipsNum", _descriptor6, this);

          _initializerDefineProperty(this, "spChipsNum", _descriptor7, this);

          _initializerDefineProperty(this, "btnDeal", _descriptor8, this);

          _initializerDefineProperty(this, "btnHit", _descriptor9, this);

          _initializerDefineProperty(this, "btnStand", _descriptor10, this);

          _initializerDefineProperty(this, "btnDoubleDown", _descriptor11, this);

          _initializerDefineProperty(this, "btnSurrender", _descriptor12, this);

          _initializerDefineProperty(this, "itemCard", _descriptor13, this);

          _initializerDefineProperty(this, "spCardsSelf", _descriptor14, this);

          _initializerDefineProperty(this, "spCardsSelfParent", _descriptor15, this);

          _initializerDefineProperty(this, "spCardsDealer", _descriptor16, this);

          _initializerDefineProperty(this, "spCardsDealerParent", _descriptor17, this);

          _initializerDefineProperty(this, "spCardPoint", _descriptor18, this);

          _initializerDefineProperty(this, "spCardPointWithA", _descriptor19, this);

          _initializerDefineProperty(this, "labelCardPoint", _descriptor20, this);

          _initializerDefineProperty(this, "labelCardPointWithA1", _descriptor21, this);

          _initializerDefineProperty(this, "labelCardPointWithA2", _descriptor22, this);

          _initializerDefineProperty(this, "spDealerPoint", _descriptor23, this);

          _initializerDefineProperty(this, "labelDealerPoint", _descriptor24, this);

          _initializerDefineProperty(this, "spResult", _descriptor25, this);

          _initializerDefineProperty(this, "spResultTitle", _descriptor26, this);

          _initializerDefineProperty(this, "assets", _descriptor27, this);

          _defineProperty(this, "activityMeta", void 0);

          _defineProperty(this, "activityId", void 0);

          _defineProperty(this, "timerRpt", void 0);

          _defineProperty(this, "baseChipCoin", void 0);

          _defineProperty(this, "mChips", void 0);

          _defineProperty(this, "chipBet", void 0);

          _defineProperty(this, "doSurrender", void 0);

          _defineProperty(this, "doDoubleDown", void 0);

          _defineProperty(this, "gamestart", void 0);

          _defineProperty(this, "gameEnd", void 0);

          _defineProperty(this, "animing", void 0);

          _defineProperty(this, "selfCardCount", void 0);

          _defineProperty(this, "selfCards", void 0);

          _defineProperty(this, "currentCards", void 0);

          _defineProperty(this, "dealerCardCount", void 0);

          _defineProperty(this, "dealerCards", void 0);

          _defineProperty(this, "selfCardsPoint", void 0);

          _defineProperty(this, "dealerCardsPoint", void 0);

          _defineProperty(this, "lastResult", void 0);

          _defineProperty(this, "showendAnim", void 0);
        }

        callClose() {
          FullLoadingWindow.Show(() => {
            UIRoot.instance.openWindow("GameMainWindow", {
              showCallback: () => {
                homeView.EnterGame();
                homeView.backToHomeView(() => {
                  FullLoadingWindow.Hide();
                });
              }
            });
          });
        }

        static Show(meta) {
          FullLoadingWindow.Show(() => {
            homeView.closeGamePlay();
            UIRoot.instance.openWindow("BlackJackMainWindow", {
              meta: meta,
              showCallback: wnd => {
                FullLoadingWindow.Hide();
              }
            });
          });
        }

        onShow(showParams) {
          this.activityMeta = showParams.meta;
          this.activityId = this.activityMeta.Id();
          this.labelCoin.getComponent(NumAnim).setCurrentValue(Game.SUser.Coin());
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.CoinEvent, "BlackJackMainWindow", () => {
            this.labelCoin.getComponent(NumAnim).playAnim(null, Game.SUser.Coin(), 0.3);
          });
          let rpt = GameKit.DataCache.GetData("Raid_Protect") || 0;
          this.spCoinRaidProtect.active = rpt > GameKit.TimeUtil.getCurrentTime();
          this.timerRpt = rpt - GameKit.TimeUtil.getCurrentTime();
          if (this.timerRpt <= 0) this.timerRpt = null;
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.RaidProtectEvent, "BlackJackMainWindow", () => {
            let rpt = GameKit.DataCache.GetData("Raid_Protect") || 0;
            this.spCoinRaidProtect.active = rpt > GameKit.TimeUtil.getCurrentTime();
            this.timerRpt = rpt - GameKit.TimeUtil.getCurrentTime();
            if (this.timerRpt <= 0) this.timerRpt = null;
          });
          this.baseChipCoin = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.BlackJackMinChip, Game.SUserVillage.MapId());

          for (let i = 0; i < this.chips.length; i++) {
            let labelChip = GameKit.ControllerTable.GetComponent(this.chips[i], "label", Label);
            labelChip.string = BigNumber.format(this.baseChipCoin * Math.pow(2, i));
            this.chips[i].on("click", () => {
              this.addChip(i);
            });
          }

          this.btnDeal.active = false;
          this.btnHit.active = false;
          this.btnStand.active = false;
          this.btnDoubleDown.active = false;
          this.btnSurrender.active = false;
          this.spCardPoint.active = false;
          this.spDealerPoint.active = false;
          this.spChipsNum.active = false;
          this.mChips = [];
          SoundManager.playBgmByName(SoundManager.SoundNames.BGM_BlackJack);

          var _enter = () => {
            if (!Game.SUserActivity.GetActivityData(this.activityId).startReward) {
              let req = SR.SRActivityBlackJack.activityBlackjackStartReward(this.activityId);
              req.SetCallBack(function () {
                this.ShowStart();
              }.bind(this));
              req.Send();
            } else {
              this.scheduleOnce(() => {
                this.ShowStart();
              }, 0.3);
            }
          };

          if (!GameKit.PlayerPrefs.GetBool("BlackJackEntered", false)) {
            GameKit.PlayerPrefs.SetBool("BlackJackEntered", true);
            UIRoot.instance.openChildWindow(BlackJackHelpWindow, {
              showCallback: wnd => {
                wnd.addOnCloseFunc(() => {
                  _enter();
                });
              }
            });
          } else {
            _enter();
          }
        }

        onClose() {
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.CoinEvent, "BlackJackMainWindow");
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.RaidProtectEvent, "BlackJackMainWindow");
          SoundManager.playBgmByName(SoundManager.SoundNames.BGM_Menu);
        }

        slowUpdate(dt) {
          if (this.timerRpt) {
            let rpt = GameKit.DataCache.GetData("Raid_Protect") || 0;
            this.timerRpt = rpt - GameKit.TimeUtil.getCurrentTime();
            this.labelCoinRaidProtect.string = i18n.t("RaidProtect") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.timerRpt, false, false);

            if (this.timerRpt <= 0) {
              this.spCoinRaidProtect.active = false;
              this.timerRpt = null;
            }
          }
        } //////////////////////////////


        ShowStart() {
          this.chipBet = 0;
          this.doSurrender = false;
          this.doDoubleDown = false;
          this.gamestart = false;
          this.gameEnd = false;
          this.animing = false;
          this.assets.Clear();
          let oldAddChips = GameKit.PlayerPrefs.GetObject("BLACKJACK_Last_Chips", [1]);
          oldAddChips.forEach(x => {
            this.addChip(x, false, true);
          });
        }

        ShowCards() {
          this.selfCardCount = 0;
          this.selfCards = [];
          this.selfCards.push(this.DealCard(this.currentCards[0][0], true, 2, true));
          this.selfCardCount++;
          SoundManager.playSound("blackjack/deal");
          this.scheduleOnce(() => {
            this.selfCards.push(this.DealCard(this.currentCards[0][1], true, 2, true));
            this.selfCardCount++;
            SoundManager.playSound("blackjack/deal");
          }, 0.1);
          this.dealerCardCount = 0;
          this.dealerCards = [];
          this.scheduleOnce(() => {
            this.dealerCards.push(this.DealCard(this.currentCards[1][0], false, 2, true));
            this.dealerCardCount++;
            SoundManager.playSound("blackjack/deal");
          }, 0.2);
          this.scheduleOnce(() => {
            this.dealerCards.push(this.DealCard(this.currentCards[1][1], false, 2, true));
            this.dealerCardCount++;
            SoundManager.playSound("blackjack/deal");
          }, 0.3);
          this.scheduleOnce(() => {
            this.UpdateCardPoints();

            if (this.selfCardsPoint == 21) {
              this.scheduleOnce(() => {
                this.gameEnd = true;
                this.ShowDealer();
              }, 0.5);
              return;
            }

            this.CaulDealerPoints();

            if (this.dealerCardsPoint == 21) {
              this.scheduleOnce(() => {
                this.gameEnd = true;
                this.ShowDealer();
              }, 0.5);
              return;
            }

            this.btnHit.active = true;
            this.btnHit.scale = v3(0.01, 0.01, 1);
            this.btnHit.runAction(ccAction.scaleTo(0.2, 1));
            this.btnStand.active = true;
            this.btnStand.scale = v3(0.01, 0.01, 1);
            this.btnStand.runAction(ccAction.scaleTo(0.2, 1));
            this.btnDoubleDown.active = true;
            this.btnDoubleDown.scale = v3(0.01, 0.01, 1);
            this.btnDoubleDown.runAction(ccAction.scaleTo(0.2, 1));
            this.btnSurrender.active = true;
            this.btnSurrender.scale = v3(0.01, 0.01, 1);
            this.btnSurrender.runAction(ccAction.scaleTo(0.2, 1));
          }, 1.3);
        }

        ShowDealer() {
          this.animing = true;
          this.UpdateCardPoints(true);

          if (this.btnHit.active) {
            this.btnHit.stopAllActions();
            this.btnHit.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
              this.btnHit.active = false;
            })));
          }

          if (this.btnStand.active) {
            this.btnStand.stopAllActions();
            this.btnStand.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
              this.btnStand.active = false;
            })));
          }

          if (this.btnSurrender.active) {
            this.btnSurrender.stopAllActions();
            this.btnSurrender.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
              this.btnSurrender.active = false;
            })));
          }

          if (this.btnDoubleDown.active) {
            this.btnDoubleDown.stopAllActions();
            this.btnDoubleDown.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
              this.btnDoubleDown.active = false;
            })));
          }

          var _ShowDealer = function () {
            if (this.gameEnd) {
              this.ShowEnd();
            } else {
              for (let i = 0; i < this.dealerCardCount; i++) {
                this.MoveCard(this.dealerCards[i], false, i, this.dealerCardCount + 1);
              }

              this.dealerCards.push(this.DealCard(this.currentCards[1][this.dealerCardCount], false, this.dealerCardCount + 1));
              this.dealerCardCount++;
              this.scheduleOnce(() => {
                this.UpdateDealerPoints();
                if (this.dealerCardsPoint >= 17) this.gameEnd = true;
                this.scheduleOnce(() => {
                  _ShowDealer();
                }, 0.7);
              }, 0.4);
            }
          }.bind(this);

          this.scheduleOnce(() => {
            this.MoveCard(this.dealerCards[1], false, 1, 2, true, () => {
              this.assets.setCard(this.dealerCards[1], this.currentCards[1][1]);
            });
            this.UpdateDealerPoints();
            if (this.dealerCardsPoint >= 17) this.gameEnd = true;
            this.scheduleOnce(() => {
              _ShowDealer();
            }, 0.7);
          }, 0.2);
        }

        ShowEnd() {
          let req = SR.SRActivityBlackJack.activityBlackjackDoEnd(this.selfCardCount, this.dealerCardCount);
          if (this.doSurrender) req.SetRequestBody("surrender", true);
          if (this.doDoubleDown) req.SetRequestBody("double", true);
          req.SetCallBack(function (res) {
            if (this.showendAnim) {
              this.scheduleOnce(() => {
                this.ShowClear();
              }, 1);
            } else {
              this.ShowClear();
            }
          }.bind(this));
          req.Send();
          let result = 0;

          if (this.selfCardsPoint == 21 && this.selfCardCount == 2) {
            result = 2;
          } else if (this.dealerCardsPoint == 21 && this.dealerCardCount == 2) ;else if (this.doSurrender) {
            result = -3;
          } else if (this.selfCardsPoint > 21) {
            result = -2;
          } else if (this.dealerCardsPoint > 21) {
            result = 1;
          } else if (this.selfCardsPoint > this.dealerCardsPoint) {
            result = 1;
          } else if (this.selfCardsPoint < this.dealerCardsPoint) {
            result = -1;
          }

          LogEventWrap.logEvent("BlackJack_result", {
            bet: this.chipBet,
            result: result
          });
          let spTitle = null;

          if (result >= 0) {
            if (result == 2) {
              spTitle = this.assets.spResultTitleBlackJack;
              SoundManager.playSound("blackjack/blackjack");
            } else if (result == 1) {
              spTitle = this.assets.spResultTitleWin;
              SoundManager.playSound("blackjack/win");
            } else {
              spTitle = this.assets.spResultTitlePush;
              SoundManager.playSound("blackjack/push");
            }

            SoundManager.playSound("blackjack/chips-win");
          } else if (result < 0) {
            if (result == -2) {
              spTitle = this.assets.spResultTitleBust;
            } else if (result == -3) {
              spTitle = this.assets.spResultTitleSurrender;
            } else {
              spTitle = this.assets.spResultTitleLose;
            }
          }

          this.lastResult = result;
          this.spResultTitle.spriteFrame = spTitle;
          this.spResult.active = true;
          this.showendAnim = true;
          this.spResult.y = -250;
          this.spResult.opacity = 0;
          this.spResult.runAction(ccAction.sequence(ccAction.spawn(ccAction.fadeIn(0.3), ccAction.moveBy(0.3, 0, 200, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut))), ccAction.moveBy(0.4, 0, 100), ccAction.spawn(ccAction.fadeOut(0.3), ccAction.moveBy(0.3, 0, 200, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn))), ccAction.callFunc(() => {
            this.showendAnim = false;
          })));

          for (let i = this.mChips.length - 1; i >= 0; i--) {
            let n = this.mChips[i];
            this.removeChip(n.node, result);
          }
        }

        ShowClear() {
          this.spCardsSelfParent.children.forEach(x => {
            x.runAction(ccAction.sequence(ccAction.moveTo(0.2, -500, 0), ccAction.callFunc(() => {
              x.destroy();
            })));
          });
          this.spCardsDealerParent.children.forEach(x => {
            x.runAction(ccAction.sequence(ccAction.moveTo(0.2, -500, 0), ccAction.callFunc(() => {
              x.destroy();
            })));
          });
          if (this.spCardPoint.active) this.spCardPoint.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
            this.spCardPoint.active = false;
          })));
          if (this.spDealerPoint.active) this.spDealerPoint.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
            this.spDealerPoint.active = false;
          })));

          if (this.lastResult > 0 && this.selfCardsPoint == 21 && Game.SUserActivity.GetActivityData(this.activityId).count > 10) {
            let lastWatchTime = GameKit.DataCache.GetData("BlackJackWatchTime") || 0;
            let currentTime = GameKit.TimeUtil.getCurrentTime();

            if (currentTime - lastWatchTime > 15) {
              UIRoot.instance.openChildWindow(BlackJackWatchWindow, {
                win: true
              });
              GameKit.DataCache.SetData("BlackJackWatchTime", currentTime);
            }
          } else if (this.lastResult < 0 && this.dealerCardsPoint == 21 && Game.SUserActivity.GetActivityData(this.activityId).count > 10) {
            let lastWatchTime = GameKit.DataCache.GetData("BlackJackWatchTime") || 0;
            let currentTime = GameKit.TimeUtil.getCurrentTime();

            if (currentTime - lastWatchTime > 20) {
              UIRoot.instance.openChildWindow(BlackJackWatchWindow, {
                win: false
              });
              GameKit.DataCache.SetData("BlackJackWatchTime", currentTime);
            }
          }

          SoundManager.playSound("blackjack/shove");
          this.scheduleOnce(() => {
            this.ShowStart();
          }, 0.6);
        } //////////////////////////////


        addChip(index, force = false, start = false) {
          if (this.mChips.length >= 2 && !force) return;
          if (this.gamestart && !force) return;
          let num = this.chipBet + this.baseChipCoin * Math.pow(2, index);
          if (!this.gamestart && start && this.mChips.length > 0 && Game.SUser.Coin() < num) return; //NEWTODO 返回主界面有bug
          // if (!this.gamestart && !ContentCheck.CheckCoin(num, false, true)) return

          let spChip = instantiate(GameKit.ControllerTable.GetNode(this.chips[index], "sp"));
          spChip.setParent(this.chipsParent);
          spChip.setWorldPosition(this.chips[index].getWorldPosition());
          spChip.runAction(ccAction.scaleTo(0.2, 0.6));
          spChip.runAction(ccAction.moveTo(0.2, G.getRandomFloat(-30, 30), G.getRandomFloat(-30, 30)));
          this.mChips.push({
            index: index,
            node: spChip
          });
          this.updateChipsNum();
          this.scheduleOnce(() => {
            spChip.on(Node.EventType.TOUCH_START, () => {
              spChip.targetOff(this);
              SoundManager.playSound("blackjack/bet-return");
              this.removeChip(spChip);
            }, this);
            this.checkChips();
          }, 0.2);
          SoundManager.playSound("blackjack/bet");
        }

        removeChip(node, end = null) {
          if (this.gamestart && end == null) return;

          for (let i = 0; i < this.mChips.length; i++) {
            let n = this.mChips[i];

            if (n.node == node) {
              this.mChips.splice(i, 1);
              this.updateChipsNum();
              let dt = 0.3;
              let pos = v3(0, -300);

              if (end < 0) {
                pos = v3(-50 - UIRoot.instance.winSize.width / 2, 300);
                dt = 0.5;
              }

              n.node.runAction(ccAction.sequence(ccAction.moveTo(dt, pos), ccAction.callFunc(() => {
                n.node.destroy();
              })));
              break;
            }
          }
        }

        checkChips() {}

        updateChipsNum() {
          let num = 0;
          this.mChips.forEach(x => {
            num += this.baseChipCoin * Math.pow(2, x.index);
          });
          this.chipBet = num;

          if (num > 0) {
            this.labelChipsNum.string = BigNumber.format(num);

            if (!this.spChipsNum.active) {
              this.spChipsNum.active = true;
              this.spChipsNum.scale = v3(0.01, 0.01, 1);
              this.spChipsNum.runAction(ccAction.scaleTo(0.2, 1));
            }

            if (!this.btnDeal.active && !this.gamestart) {
              this.btnDeal.active = true;
              this.btnDeal.scale = v3(0.01, 0.01, 1);
              this.btnDeal.runAction(ccAction.scaleTo(0.2, 1));
            }
          } else {
            if (this.spChipsNum.active) {
              this.spChipsNum.stopAllActions();
              this.spChipsNum.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
                this.spChipsNum.active = false;
              })));
            }

            if (this.btnDeal.active) {
              this.btnDeal.stopAllActions();
              this.btnDeal.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
                this.btnDeal.active = false;
              })));
            }
          }
        }

        DealCard(n, self, allCount, start = false) {
          let index = self ? this.selfCardCount : this.dealerCardCount;
          let card = instantiate(this.itemCard);
          card.active = true;
          card.setParent(self ? this.spCardsSelfParent : this.spCardsDealerParent);
          card.setWorldPosition(v3(120 + UIRoot.instance.winSize.width / 2, 300));
          card.angle = 160;
          this.assets.setCard(card, 0);
          this.MoveCard(card, self, index, allCount, !start, start ? null : () => {
            this.assets.setCard(card, n);
          });

          if (start && (self || !self && index == 0)) {
            this.scheduleOnce(() => {
              this.MoveCard(card, self, index, allCount, true, () => {
                this.assets.setCard(card, n);
              });
            }, 0.6);
          }

          return card;
        }

        MoveCard(card, self, index, allCount, flip = false, flipCallback = null) {
          let root = self ? this.spCardsSelf : this.spCardsDealer;
          let targetPos = root.getChildByName(allCount.toString()).getChildByName((index + 1).toString());
          card.runAction(ccAction.moveTo(0.4, v3(targetPos.position.x, targetPos.position.y)));
          card.runAction(ccAction.rotateTo(0.4, targetPos.angle));

          if (flip) {
            card.runAction(ccAction.sequence(ccAction.scaleTo(0.15, 0, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut)), ccAction.callFunc(() => {
              SoundManager.playSound("blackjack/flip");
              if (flipCallback) flipCallback();
            }), ccAction.scaleTo(0.15, 1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn))));
          }
        }

        UpdateCardPoints(end = false) {
          let num = 0;
          let numa = 0;
          let count11 = 0;

          for (let i = 0; i < this.selfCardCount; i++) {
            let n = this.currentCards[0][i];
            if (n > 10) n = 10;
            num += n;
            numa += n;

            if (n == 1 && num <= 11) {
              num += 10;
              count11++;
            }
          }

          while (num > 21 && count11 > 0) {
            num -= 10;
            count11--;
          }

          this.selfCardsPoint = num;

          if (num != 21 && num != numa && !end) {
            this.spCardPointWithA.active = true;
            this.labelCardPoint.string = "";
            this.labelCardPointWithA1.string = num.toString();
            this.labelCardPointWithA2.string = numa.toString();
          } else {
            this.spCardPointWithA.active = false;
            this.labelCardPoint.string = num.toString();
          }

          if (!this.spCardPoint.active) {
            this.spCardPoint.active = true;
            this.spCardPoint.scale = v3(0.01, 0.01, 1);
            this.spCardPoint.runAction(ccAction.scaleTo(0.2, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          } else {
            this.spCardPoint.stopAllActions();
            this.spCardPoint.runAction(ccAction.sequence(ccAction.scaleTo(0.15, 1.1), ccAction.scaleTo(0.15, 1)));
          }

          this.UpdateMoveAcvice();
        }

        CaulDealerPoints() {
          let num = 0;
          let count11 = 0;

          for (let i = 0; i < this.dealerCardCount; i++) {
            let n = this.currentCards[1][i];
            if (n > 10) n = 10;
            num += n;

            if (n == 1 && num <= 11) {
              num += 10;
              count11++;
            }
          }

          while (num > 21 && count11 > 0) {
            num -= 10;
            count11--;
          }

          this.dealerCardsPoint = num;
        }

        UpdateDealerPoints() {
          this.CaulDealerPoints();
          this.labelDealerPoint.string = this.dealerCardsPoint.toString();

          if (!this.spDealerPoint.active) {
            this.spDealerPoint.active = true;
            this.spDealerPoint.scale = v3(0.01, 0.01, 1);
            this.spDealerPoint.runAction(ccAction.scaleTo(0.2, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          } else {
            this.spDealerPoint.runAction(ccAction.sequence(ccAction.scaleTo(0.15, 1.1), ccAction.scaleTo(0.15, 1)));
          }
        }

        UpdateMoveAcvice() {
          this.btnHit.getChildByName("BJ_btn_light").active = false;
          this.btnStand.getChildByName("BJ_btn_light").active = false;
          this.btnSurrender.getChildByName("BJ_btn_light").active = false;
          this.btnDoubleDown.getChildByName("BJ_btn_light").active = false;
          let dealerFirst = Math.min(10, this.currentCards[1][0]);

          if (this.selfCardsPoint == 9 && dealerFirst >= 3 && dealerFirst <= 6 || this.selfCardsPoint == 10 && dealerFirst >= 2 && dealerFirst <= 9 || this.selfCardsPoint == 11 && dealerFirst >= 2 && dealerFirst <= 10) {
            if (this.selfCardCount > 2) {
              this.btnHit.getChildByName("BJ_btn_light").active = true;
            } else {
              this.btnDoubleDown.getChildByName("BJ_btn_light").active = true;
            }
          } else if (this.selfCardsPoint == 12 && dealerFirst >= 4 && dealerFirst <= 6 || this.selfCardsPoint >= 13 && this.selfCardsPoint <= 16 && dealerFirst >= 2 && dealerFirst <= 6 || this.selfCardsPoint >= 17) {
            this.btnStand.getChildByName("BJ_btn_light").active = true;
          } else if (this.selfCardsPoint == 15 && dealerFirst == 10 || this.selfCardsPoint == 16 && dealerFirst >= 9 && dealerFirst <= 10 || this.selfCardsPoint == 16 && dealerFirst == 1) {
            this.btnSurrender.getChildByName("BJ_btn_light").active = true;
          } else {
            this.btnHit.getChildByName("BJ_btn_light").active = true;
          }
        } //////////////////////////////


        callDeal() {
          if (this.mChips.length <= 0) return;
          if (this.gamestart) return;
          let acs = [];
          this.mChips.forEach(x => {
            acs.push(x.index);
          });
          GameKit.PlayerPrefs.SetObject("BLACKJACK_Last_Chips", acs);
          this.btnDeal.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
            this.btnDeal.active = false;
          })));
          let req = SR.SRActivityBlackJack.activityBlackjackPlay(this.activityId, this.chipBet);
          req.SetCallBack(function (res) {
            this.currentCards = res.cards;
            this.ShowCards();
          }.bind(this));
          req.Send();
          this.gamestart = true;
        }

        callHit() {
          if (this.animing) return;
          this.animing = true;

          for (let i = 0; i < this.selfCardCount; i++) {
            this.MoveCard(this.selfCards[i], true, i, this.selfCardCount + 1);
          }

          this.selfCards.push(this.DealCard(this.currentCards[0][this.selfCardCount], true, this.selfCardCount + 1));
          this.selfCardCount++;
          this.scheduleOnce(() => {
            this.UpdateCardPoints();
            this.animing = false;

            if (this.selfCardsPoint == 21) {
              this.callStand();
            } else if (this.selfCardsPoint > 21) {
              this.gameEnd = true;
              this.ShowDealer();
            }
          }, 0.4);

          if (this.btnDoubleDown.active) {
            this.btnDoubleDown.stopAllActions();
            this.btnDoubleDown.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.01), ccAction.callFunc(() => {
              this.btnDoubleDown.active = false;
            })));
          }
        }

        callStand() {
          if (this.animing) return;
          this.ShowDealer();
        }

        callDoubleDown() {
          if (this.animing) return;

          if (!ContentCheck.CheckCoin(this.chipBet, false, true)) {
            return;
          }

          this.doDoubleDown = true;
          this.animing = true;

          for (let i = 0; i < this.selfCardCount; i++) {
            this.MoveCard(this.selfCards[i], true, i, this.selfCardCount + 1);
          }

          this.selfCards.push(this.DealCard(this.currentCards[0][this.selfCardCount], true, this.selfCardCount + 1));
          this.selfCardCount++;
          this.mChips.forEach(x => {
            this.addChip(x.index, true);
          });
          this.scheduleOnce(() => {
            this.UpdateCardPoints();
            this.animing = false;

            if (this.selfCardsPoint > 21) {
              this.gameEnd = true;
              this.ShowDealer();
            } else {
              this.callStand();
            }
          }, 0.4);
        }

        callSurrender() {
          if (this.animing) return;
          this.doSurrender = true;
          this.gameEnd = true;
          this.ShowDealer();
        }

        callHelper() {
          UIRoot.instance.openChildWindow(BlackJackHelpWindow);
        }

      }, _defineProperty(_class3, "windowPath", "Activity/blackjack/BlackJackMainWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelCoin", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spCoinRaidProtect", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelCoinRaidProtect", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "chips", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "chipsParent", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelChipsNum", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spChipsNum", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "btnDeal", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "btnHit", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "btnStand", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "btnDoubleDown", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "btnSurrender", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "itemCard", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "spCardsSelf", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "spCardsSelfParent", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "spCardsDealer", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "spCardsDealerParent", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "spCardPoint", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "spCardPointWithA", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "labelCardPoint", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "labelCardPointWithA1", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class2.prototype, "labelCardPointWithA2", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class2.prototype, "spDealerPoint", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class2.prototype, "labelDealerPoint", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class2.prototype, "spResult", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor26 = _applyDecoratedDescriptor(_class2.prototype, "spResultTitle", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor27 = _applyDecoratedDescriptor(_class2.prototype, "assets", [_dec27], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ToRaidUserNode.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, CCE_Component, CCEaseTypes, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "28666KTieVPk71C8e+czq+w", "ToRaidUserNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ToRaidUserNode = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Label), ccclass(_class = (_class2 = (_temp = class ToRaidUserNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "textRoot", _descriptor, this);

          _initializerDefineProperty(this, "namenode", _descriptor2, this);

          _initializerDefineProperty(this, "coinnode", _descriptor3, this);

          _initializerDefineProperty(this, "betRoot", _descriptor4, this);

          _initializerDefineProperty(this, "betLabel", _descriptor5, this);

          _defineProperty(this, "textRootOldX", void 0);

          _defineProperty(this, "textRootOldY", void 0);

          _defineProperty(this, "betRootOldX", void 0);

          _defineProperty(this, "betRootOldY", void 0);

          _defineProperty(this, "nameOldY", void 0);

          _defineProperty(this, "coinOldY", void 0);

          _defineProperty(this, "isShowBet", void 0);
        }

        start() {// let nodes = this.node.getFlattedChildrenRecursively();
          // nodes.forEach(v => v.layer = CameraLayers.capture);
        }

        captureScreen() {}

        hideNode(cb) {
          this.node.stopAllActions(); // this.node.runAction(ccAction.sequence(ccAction.moveTo(0.3, 0, -120, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn)), ccAction.delayTime(Math.random(0.2, 0.4)), ccAction.callFunc(()=>{if(cb)cb()}, this)))
          ///可能想随机一个0.2到0.4之间的值，改下

          this.node.runAction(ccAction.sequence(ccAction.fadeTo(0.3, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn)), ccAction.delayTime(Math.random() * 0.2 + 0.2), ccAction.callFunc(() => {
            if (cb) cb();
          }, this))); // this.node.runAction(ccAction.sequence(ccAction.fadeTo(0.3, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn)), ccAction.delayTime(Math.random(0.2, 0.4)), ccAction.callFunc(()=>{if(cb)cb()}, this)))
        }

        showNode() {
          this.node.stopAllActions();
          this.node.runAction(ccAction.fadeTo(0.3, 255, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut)));
        }

        initBetValue(betNum) {
          this.textRootOldX = 0;
          this.textRootOldY = 4.3;
          this.betRootOldX = 18;
          this.betRootOldY = -33;
          this.nameOldY = 2;
          this.coinOldY = -32;
          this.isShowBet = false;

          if (betNum == 1) {
            this.hideBet();
          } else {
            this.betLabel.string = String.format(i18n.t("ToRaidUserBet"), betNum); //this.textRoot.y = this.textRootOldY + 16

            this.namenode.y = 14;
            this.coinnode.y = -12;
            this.betRoot.active = true;
            this.betRoot.scaleX = 1;
            this.betRoot.scaleY = 1;
            this.isShowBet = true;
          }
        }

        setBetValue(betNum) {
          this.betLabel.string = String.format(i18n.t("ToRaidUserBet"), betNum);
        }

        showBet() {
          //this.textRoot.stopAllActions()
          //this.textRoot.runAction(ccAction.moveTo(0.1, this.textRootOldX, this.textRootOldY + 16))
          this.namenode.stopAllActions();
          this.coinnode.stopAllActions();
          this.namenode.runAction(ccAction.moveTo(0.1, this.namenode.x, 14));
          this.coinnode.runAction(ccAction.moveTo(0.1, this.coinnode.x, -12));
          this.betRoot.active = true;
          this.betRoot.stopAllActions();
          this.betRoot.scaleX = 0;
          this.betRoot.scaleY = 0;
          this.betRoot.runAction(ccAction.scaleTo(0.1, 1, 1));
          this.isShowBet = true;
        }

        hideBet() {
          //this.textRoot.stopAllActions()
          //this.textRoot.x = this.textRootOldX
          //this.textRoot.y = this.textRootOldY
          this.namenode.stopAllActions();
          this.namenode.y = this.nameOldY;
          this.coinnode.stopAllActions();
          this.coinnode.y = this.coinOldY;
          this.betRoot.stopAllActions();
          this.betRoot.active = false;
          this.isShowBet = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "textRoot", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "namenode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "coinnode", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "betRoot", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "betLabel", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CocosHack.ts", ['cc', './Constant.ts'], function (exports) {
  'use strict';

  var cclegacy, director, Director, TweenSystem, Camera, Vec3, view, geometry, Component, Node, Quat, assetManager, sys, game, Constant;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      director = module.director;
      Director = module.Director;
      TweenSystem = module.TweenSystem;
      Camera = module.Camera;
      Vec3 = module.Vec3;
      view = module.view;
      geometry = module.geometry;
      Component = module.Component;
      Node = module.Node;
      Quat = module.Quat;
      assetManager = module.assetManager;
      sys = module.sys;
      game = module.game;
    }, function (module) {
      Constant = module.Constant;
    }],
    execute: function () {
      exports('getNativeUrl', getNativeUrl);

      cclegacy._RF.push({}, "29374564uxIoptn9CVR48tI", "CocosHack", undefined); // macro.CLEANUP_IMAGE_CACHE = false;
      // dynamicAtlasManager.enabled = true;
      //execute tween system in update (#8305) https://github.com/cocos-creator/engine/commit/6bf8785ce2344d7e9259f35d96cd20c9ca78e5c4
      //升级引擎后3.0.1+后删除


      director.on(Director.EVENT_INIT, () => {
        let origin = TweenSystem.instance.postUpdate;

        TweenSystem.instance.postUpdate = function () {};

        TweenSystem.instance.update = function (dt) {
          origin.call(this, dt);
        };
      }); //去掉热更splash出现动画

      function removeSplashScreen() {
        const time = parseInt(sys.localStorage.getItem("lastRestartTime"));
        const curTime = Date.now();
        const timeElapsed = curTime - time;

        if (timeElapsed < 3000) {
          game["_showSplashScreen"] = () => null;
        }
      }

      removeSplashScreen(); // 放在哪里更合适？

      function initGlobals() {
        Reflect.defineProperty(globalThis, "appGame", {
          value: null,
          configurable: true
        });
        Reflect.defineProperty(globalThis, "eventCenter", {
          value: null,
          configurable: true
        });
        Reflect.defineProperty(globalThis, "homeView", {
          value: null,
          configurable: true
        });
        Reflect.defineProperty(globalThis, "player", {
          value: null,
          configurable: true
        });
        Reflect.defineProperty(globalThis, "myVillage", {
          value: null,
          configurable: true
        }); // Reflect.defineProperty(globalThis, "versionSchemeName", { value: "#versionSchemeName#", configurable: true });

        Reflect.defineProperty(globalThis, "versionConfig", {
          value: null,
          configurable: true
        }); // Reflect.defineProperty(globalThis, "$tp_version", { value: "#$tp_version#", configurable: true });
        // Reflect.defineProperty(globalThis, "$tp_platform", { value: "#$tp_platform#", configurable: true });

        Reflect.defineProperty(globalThis, "$tp_test_mode", {
          value: null,
          configurable: true
        });
      }

      initGlobals();

      Camera.prototype.convertToUINodeWithTexture = function (worldPos, uiNode, out) {
        !out && (out = new Vec3());
        const self = this;
        const pixelRatio = Constant.useDeviceRatio ? view.getDevicePixelRatio() : 1;
        self.convertToUINode(worldPos, uiNode, out);
        const handleFlipY = out.y * director.root.device.UVSpaceSignY;
        out.y = handleFlipY;
        out.x = out.x * view.getScaleX() / pixelRatio;
        out.y = out.y * view.getScaleY() / pixelRatio;
        return out;
      };

      Camera.prototype.screenPointToRayWithTexture = function (x, y, out) {
        !out && (out = new geometry.Ray());
        const viewPortHeight = view.getViewportRect().height;
        const pixelRatio = Constant.useDeviceRatio ? view.getDevicePixelRatio() : 1;
        const self = this;
        const leftMargin = (self.targetTexture.width / pixelRatio - view.getVisibleSize().width) / 2;
        const bottomMargin = (self.targetTexture.height / pixelRatio - view.getVisibleSize().height) / 2;
        const screenX = (x / view.getScaleX() + leftMargin) * pixelRatio;
        const handleFlipY = director.root.device.UVSpaceSignY > 0 ? y : viewPortHeight - y;
        const screenY = (handleFlipY / view.getScaleY() + bottomMargin) * pixelRatio;
        self.screenPointToRay(screenX, screenY, out);
        return out;
      };

      Component.prototype.getOrAddComponent = function (classConstructor) {
        const self = this;
        let com = self.getComponent(classConstructor);

        if (com) {
          return com;
        } else {
          return self.addComponent(classConstructor);
        }
      };

      Node.prototype.getOrAddComponent = function (classConstructor) {
        const self = this;
        let com = self.getComponent(classConstructor);

        if (com) {
          return com;
        } else {
          return self.addComponent(classConstructor);
        }
      };

      Node.prototype.resetPosition = function () {
        const self = this;
        self.position = new Vec3();
      };

      Node.prototype.resetRotation = function () {
        const self = this;
        self.rotation = new Quat();
      };

      Node.prototype.resetPositionAndRotation = function () {
        const self = this;
        self.position = new Vec3();
        self.rotation = new Quat();
      };

      Node.prototype.rotateEuler = function (euler) {
        const self = this;
        let rotation = new Quat();
        Quat.fromEuler(rotation, euler.x, euler.y, euler.z);
        self.rotate(rotation);
      };

      Node.prototype.getFlattedChildrenRecursively = function (flattedNodes = []) {
        let parentNode = this;
        flattedNodes.push(parentNode);

        if (parentNode.children.length > 0) {
          parentNode.children.forEach(v => {
            v.getFlattedChildrenRecursively(flattedNodes);
          });
        }

        return flattedNodes;
      };

      function getNativeUrl(url, isNative = false, type, ext = ".png") {
        const bundle = assetManager.getBundle("resources");
        const info = type ? bundle.getInfoWithPath(url, type) : bundle.getInfoWithPath(url);
        return assetManager.utils.getUrlWithUuid(info.uuid, {
          isNative: isNative,
          nativeExt: ext
        });
      } // stateCache: WebGLStateCache = new WebGLStateCache();
      // export function copyFramebufferToBuffer(
      //     srcFramebuffer: gfx.Framebuffer,
      //     dstBuffer: ArrayBuffer,
      //     regions: gfx.BufferTextureCopy[],
      // ) {
      //     // const gl = this._webGLRC as WebGLRenderingContext;
      //     const gl = getGL();
      //     const gpuFramebuffer = (srcFramebuffer as any).gpuFramebuffer;
      //     // srcFramebuffer.colorTextures[0].format = 36
      //     const format = 36//gpuFramebuffer.gpuColorTextures[0].format;
      //     const glFormat = 6408//GFXFormatToWebGLFormat(format, gl);
      //     const glType = 5121//GFXFormatToWebGLType(format, gl);
      //     const ctor = Uint8Array;//getTypedArrayConstructor(FormatInfos[format]);
      //     // const curFBO = this.stateCache.glFramebuffer;
      //     gl.bindFramebuffer(gl.FRAMEBUFFER, gpuFramebuffer.glFramebuffer);
      //     // if (this.stateCache.glFramebuffer !== gpuFramebuffer.glFramebuffer) {
      //     //     gl.bindFramebuffer(gl.FRAMEBUFFER, gpuFramebuffer.glFramebuffer);
      //     //     this.stateCache.glFramebuffer = gpuFramebuffer.glFramebuffer;
      //     // }
      //     const view = new ctor(dstBuffer);
      //     for (const region of regions) {
      //         const w = region.texExtent.width;
      //         const h = region.texExtent.height;
      //         gl.readPixels(region.texOffset.x, region.texOffset.y, w, h, glFormat, glType, view);
      //     }
      //     // if (this.stateCache.glFramebuffer !== curFBO) {
      //     //     gl.bindFramebuffer(gl.FRAMEBUFFER, curFBO);
      //     //     this.stateCache.glFramebuffer = curFBO;
      //     // }
      // }
      // function getGL() {
      //     const canvas = game.canvas;
      //     const webGLCtxAttribs: WebGLContextAttributes = {
      //         alpha: macro.ENABLE_TRANSPARENT_CANVAS,
      //         antialias: true,
      //         depth: true,
      //         stencil: true,
      //         premultipliedAlpha: true,
      //         preserveDrawingBuffer: false,
      //         powerPreference: 'default',
      //         failIfMajorPerformanceCaveat: false,
      //     };
      //     return canvas.getContext('webgl', webGLCtxAttribs);
      // }


      var CocosHack = exports('default', {});

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AnimationUtils.ts", ['cc', './Constant.ts', './CommonAssets.ts', './Content.ts', './MetaManager.ts', './PlayGetAnimation.ts', './GameMainWindow.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, MyCustomEvent, CommonAssets, Content, MetaManager, PlayGetAnimation, GameMainWindow, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      exports('AnimationUtils', void 0);

      cclegacy._RF.push({}, "2a09cRKf11DfYuY4hIMZH+g", "AnimationUtils", undefined);

      let AnimationUtils;

      (function (_AnimationUtils) {
        function playGetRewardsAnim(content, cb) {
          const promiseAll = [];
          const contents = Content.Merge(content);
          contents.forEach(con => {
            let content = Content.FromContent(con);

            if (content.Type() === Content.Types.Coin) {
              promiseAll.push(PlayGetAnimation.playAnimation({
                startNode: uiRoot.node,
                endNode: GameMainWindow.instance.btnCoinAdd.node.getChildByName("iconCoin"),
                count: content.Count(),
                prefab: CommonAssets.instance.coinPrefab,
                startCallback: () => {
                  eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                }
              }));
            } else if (content.Type() === Content.Types.Ap) {
              promiseAll.push(PlayGetAnimation.playAnimation({
                startNode: uiRoot.node,
                endNode: homeView.pageViewController.btnSpin.node,
                count: content.Count(),
                prefab: CommonAssets.instance.energyPrefab
              }));
            } else if (content.Type() === Content.Types.Item) {
              const meta = MetaManager.GetMeta(Meta.MetaType.Item, content.ContentId());

              if (meta._data.icon === "pet_xpPotion") {
                promiseAll.push(PlayGetAnimation.playAnimation({
                  startNode: uiRoot.node,
                  endNode: homeView.pageViewController.btnSpin.node,
                  count: content.Count(),
                  prefab: CommonAssets.instance.xpPrefab
                }));
              } else if (meta._data.icon === "pet_food") {
                promiseAll.push(PlayGetAnimation.playAnimation({
                  startNode: uiRoot.node,
                  endNode: homeView.pageViewController.btnSpin.node,
                  count: content.Count(),
                  prefab: CommonAssets.instance.foodPrefab
                }));
              }
            }
          });
          Promise.all(promiseAll).then(() => {
            cb && cb();
          });
        }

        _AnimationUtils.playGetRewardsAnim = playGetRewardsAnim;
      })(AnimationUtils || (AnimationUtils = exports('AnimationUtils', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/EditorVillageChecker.ts", ['cc', './CharacterLevelEditor.ts'], function (exports) {
  'use strict';

  var cclegacy, CCBoolean, _decorator, Component, warn, Scene, CharacterLevelEditor;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      Component = module.Component;
      warn = module.warn;
      Scene = module.Scene;
    }, function (module) {
      CharacterLevelEditor = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2a144UuOsNOWYrLlntQaTL0", "EditorVillageChecker", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let EditorVillageChecker = exports('default', (_dec = ccclass("EditorVillageChecker"), _dec2 = property(CCBoolean), _dec(_class = (_class2 = (_temp = class EditorVillageChecker extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_activate", false);

          _defineProperty(this, "isAllCheckOK", true);
        }

        get activate() {
          return this._activate;
        }

        set activate(bo) {
          this._activate = bo;

          if (bo) {
            this.excute_();
            this._activate = false;
          }
        }

        onLoad() {// director.getScene()
          // this.getComponentsInChildren(ControllerTable).forEach(com => {
          //     com && com._destroyImmediate();
          // })
        }

        excute_() {
          warn("excute check start");
          this.isAllCheckOK = true;
          this.checkCamera();
          this.checkLight();
          this.checkTongDao();
          this.checkBuilds();
          this.checkPositions();
          this.checkLevels();

          if (this.isAllCheckOK) {
            warn("全部检查通过！✅✅✅");
          }
        }

        checkCamera() {
          let cameraNode = this.node.getChildByName("Main Camera");

          if (!cameraNode) {
            warn("找不到 Main Camera");
            this.isAllCheckOK = false;
          }
        }

        checkLight() {
          let lightNode = this.node.getChildByName("Main Light");

          if (!lightNode) {
            warn("找不到 Main Light");
            this.isAllCheckOK = false;
          }
        }

        checkTongDao() {
          let tongdaoNode = this.node.getChildByName("tongdao");

          if (!tongdaoNode) {
            warn("找不到 tongdao");
            this.isAllCheckOK = false;
          }
        }

        checkBuilds() {
          let builds = this.node.children.filter(v => {
            return v.name.startsWith("build");
          });

          if (builds.length !== 5) {
            warn("build数量不对或者名字拼写错误");
            this.isAllCheckOK = false;
          }
        }

        checkPositions() {
          let keyArr = ["world", "attack", "fix"];
          let builds = this.node.children.filter(v => v.name.startsWith("build"));
          builds.forEach(build => {
            let posNode = build.getChildByName("positions");

            if (!posNode) {
              warn(this.getNodePath(build), "没找到positions节点");
              this.isAllCheckOK = false;
            } else {
              keyArr.forEach(key => {
                if (!posNode.getChildByName(key)) {
                  warn(this.getNodePath(build), "没找到位置" + key);
                  this.isAllCheckOK = false;
                }
              });
            }
          });
        }

        checkLevels() {
          let builds = this.node.children.filter(v => v.name.startsWith("build"));
          builds.forEach(build => {
            if (build.getComponentInChildren(CharacterLevelEditor)) return;
            let levels = build.children.filter(level => level.name.startsWith("level"));

            if (levels.length !== 5) {
              warn(this.getNodePath(build), "level数量错误");
              this.isAllCheckOK = false;
            }

            levels.forEach((level, index) => {
              let bo = level.name == "level" + (index + 1);

              if (!bo) {
                warn(this.getNodePath(level), "level名字错误");
                this.isAllCheckOK = false;
              }

              if (level.children.length !== 2) {
                warn(this.getNodePath(level), "level节点里面不止两个子节点，是不是有东西落在外面了？");
                this.isAllCheckOK = false;
              }

              let normalNode = level.getChildByName("normal");

              if (!normalNode) {
                warn(this.getNodePath(level), "找不到normal节点");
                this.isAllCheckOK = false;
              } else {
                this.checkPositionRotationScale(normalNode);
                this.checkIsChildrenEmpty(normalNode);
              }

              let damageNode = level.getChildByName("damage");

              if (!damageNode) {
                warn(this.getNodePath(level), "找不到damage节点");
                this.isAllCheckOK = false;
              } else {
                this.checkPositionRotationScale(damageNode);
                this.checkIsChildrenEmpty(damageNode);

                if (!damageNode.getChildByName("smoke")) {
                  warn(this.getNodePath(damageNode), "找不到smoke节点");
                  this.isAllCheckOK = false;
                }
              }
            });
            levels.forEach((level, index) => {
              this.checkPositionRotationScale(level);
            });
          });
        }

        checkIsChildrenEmpty(node) {
          if (node.children.length == 0) {
            warn(this.getNodePath(node), "节点里面好像没有东西，是不是落在外面了？");
            this.isAllCheckOK = false;
          }
        }

        checkPositionRotationScale(node) {
          if (node.position.x != 0 || node.position.y != 0 || node.position.z != 0) {
            warn(this.getNodePath(node), "位置没有归零");
            this.isAllCheckOK = false;
          }

          if (node.eulerAngles.x != 0 || node.eulerAngles.y != 0 || node.eulerAngles.z != 0) {
            warn(this.getNodePath(node), "旋转没有归零");
            this.isAllCheckOK = false;
          }

          if (node.scale.x != 1 || node.scale.y != 1 || node.scale.z != 1) {
            warn(this.getNodePath(node), "缩放没有归一");
            this.isAllCheckOK = false;
          }
        }

        getNodePath(node) {
          let path;

          while (node && !(node instanceof Scene)) {
            if (path) {
              path = node.name + '/' + path;
            } else {
              path = node.name;
            }

            node = node.parent;
          }

          path = path.replace("should_hide_in_hierarchy/", "");
          return path;
        }

      }, _temp), _applyDecoratedDescriptor(_class2.prototype, "activate", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "activate"), _class2.prototype), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRUserInfo.ts", ['cc', './global.ts', './User.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, G, User, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      User = module.User;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRUserInfo', void 0);

      cclegacy._RF.push({}, "2b756xlLMRNjICsyc6stPV+", "SRUserInfo", undefined);

      let SRUserInfo;

      (function (_SRUserInfo) {
        function getInfo() {
          let req = new GameKit.ServerRequest("getUserInfo");
          req.SetCallBack(function (res) {
            Game.SUser.updateData(res.userinfo);
          });
          return req;
        }

        _SRUserInfo.getInfo = getInfo;

        function updateInfo() {
          let req = new GameKit.ServerRequest("updateUserInfo");
          req.SetRequestBody("userinfo", Game.SUser.getThirdData());
          req.SetCallBack(function (res) {
            Game.SUser.updateData(res.userinfo);
          });
          return req;
        }

        _SRUserInfo.updateInfo = updateInfo;

        function updateInviteId() {
          let req = new GameKit.ServerRequest("updateUserInfo");

          if (G.query && G.query.inviteId) {
            req.SetRequestBody("inviteId", G.query.inviteId);
          }

          req.SetCallBack(function (res) {
            Game.SUser.updateData(res.userinfo);
          });
          return req;
        }

        _SRUserInfo.updateInviteId = updateInviteId;

        function updateFriends(friends) {
          let req = new GameKit.ServerRequest("updateUserFriends");
          req.SetRequestBody("friends", friends);
          req.SetCallBack(function (res) {
            for (let uid in res.friendsList) {
              let data = res.friendsList[uid];

              if (data.name == null) {
                let fdata = Game.SUser.friendsInfo[data.accountId];
                data.name = fdata.name;
                data.avatar = fdata.avatar;
              }

              Game.SUser.data.friendsList[uid] = new User().updateData(data);
            }
          });
          return req;
        }

        _SRUserInfo.updateFriends = updateFriends;
      })(SRUserInfo || (SRUserInfo = exports('SRUserInfo', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/JigsawWindowPiece.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './Logs.ts', './_app.ts', './SoundManager.ts', './ScrollViewTool.ts', './SR.ts', './JigsawFriendsWindow.ts', './JigsawWindow.ts', './UIRoot.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Sprite, Label, Button, SpriteFrame, ScrollView, v3, instantiate, Vec2, CCE_Component, CCEaseTypes, Logs, cce, SoundManager, ScrollViewTool, SR, JigsawFriendsWindow, JigsawWindow, UIRoot, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      Label = module.Label;
      Button = module.Button;
      SpriteFrame = module.SpriteFrame;
      ScrollView = module.ScrollView;
      v3 = module.v3;
      instantiate = module.instantiate;
      Vec2 = module.Vec2;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      JigsawFriendsWindow = module.default;
    }, function (module) {
      JigsawWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2bd07oThs1Kqou4IPZzCWIn", "JigsawWindowPiece", undefined);
      /** @author fengyong-2-26 */


      const {
        ccclass,
        property
      } = _decorator;
      /**
       * 拼图界面的item操作
       */

      let JigsawWindowPiece = exports('default', (_dec = property(ScrollViewTool), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), ccclass(_class = (_class2 = (_temp = class JigsawWindowPiece extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "svt", _descriptor, this);

          _initializerDefineProperty(this, "btn_complete", _descriptor2, this);

          _defineProperty(this, "array_item", []);

          _initializerDefineProperty(this, "n_anima_use", _descriptor3, this);

          _initializerDefineProperty(this, "n_anima_use_bg", _descriptor4, this);
        }
        /** 载入页面 */


        load_page() {
          this.btn_complete.active = false;
          this.array_item = [];
          let id_list = [];

          for (let i = 0; i < 9; i++) {
            id_list.push(i);
          }

          this.svt.setItem(id_list, (index, id, node) => {
            let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();
            let info = {
              node: node,
              sp: GameKit.ControllerTable.GetNode(node, "sp").getComponent(Sprite),
              sp_rare: GameKit.ControllerTable.GetNode(node, "sp-rare").getComponent(Sprite),
              text_index: GameKit.ControllerTable.GetNode(node, "text-index").getComponent(Label),
              text_count: GameKit.ControllerTable.GetNode(node, "text-count").getComponent(Label),
              handle: GameKit.ControllerTable.GetNode(node, "handle"),
              btn_self: GameKit.ControllerTable.GetNode(node, "btn-self").getComponent(Button),
              btn_use: GameKit.ControllerTable.GetNode(node, "btn-use").getComponent(Button),
              btn_send: GameKit.ControllerTable.GetNode(node, "btn-send").getComponent(Button),
              text_btn_use: GameKit.ControllerTable.GetNode(node, "text-btn-use").getComponent(Label),
              btn_send_lock: GameKit.ControllerTable.GetNode(node, "btn-send-lock"),
              badge: GameKit.ControllerTable.GetNode(node, "badge")
            };
            this.array_item.push(info); // 修改样式

            if (metaparam.jigsawSetPath.startsWith("http")) {
              let resName = `${metaparam.jigsawSetPath}/${index}.png`;
              cce.loaderLoad({
                url: resName,
                type: "png"
              }, function (err, v) {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!info.sp) return;
                let sp = new SpriteFrame();
                sp.texture = v;
                info.sp.spriteFrame = sp;
              }.bind(this));
            } else {
              let resName = `${JigsawWindow.res_path}${metaparam.jigsawSetPath}/${index}`;
              cce.loadRes(resName, SpriteFrame, (err, res) => {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!info.sp) return;
                info.sp.spriteFrame = res;
              });
            }

            info.sp.setState(data.pieceData[index] > 0 ? 0 : 1);
            info.sp_rare.node.active = metaparam.rare.includes(index);
            info.text_index.string = `${index + 1}`;
            info.text_count.string = `${i18n.t("multiplyx")} ${data.pieceData[index]}`;
            info.badge.active = data.pieceData[index] > 0 && data.jigsawData[index] === 0;
            info.handle.active = false;
            info.btn_self.clickEvents[0].customEventData = `${index}`;
            info.btn_use.clickEvents[0].customEventData = `${index}`;
            info.btn_send.clickEvents[0].customEventData = `${index}`;
          });
          this.update_page();
        }

        Clear() {
          for (let index in this.svt.items) {
            let sp = GameKit.ControllerTable.GetComponent(this.svt.items[index], "sp", Sprite);
            cce.releaseSpriteFrame(sp);
          }
        }
        /** 刷新页面 */


        update_page() {
          this.update_btn_complete();

          for (let i = 0; i < 9; i += 1) {
            this.update_single_piece(i);
          }
        }
        /** 更新某一个具体的piece状态 */


        update_single_piece(index) {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();

          if (this.array_item[index]) {
            this.array_item[index].sp.setState(data.pieceData[index] > 0 ? 0 : 1);
            this.array_item[index].text_count.string = `${i18n.t("multiplyx")} ${data.pieceData[index]}`;
            this.array_item[index].badge.active = data.pieceData[index] > 0 && data.jigsawData[index] === 0;
          }
        }
        /** 更新btn-complete */


        update_btn_complete() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam(); // 判断collect按钮的行为

          if (data.jigsawData.includes(0)) {
            let f = true;

            for (let [i, e] of data.jigsawData.entries()) {
              if (e === 0 && data.pieceData[i] <= 0) {
                f = false;
                break;
              }
            }

            this.btn_complete.active = f;
          } else {
            this.btn_complete.active = false;
          }
        }
        /** 隐藏所有item的handle界面 */


        hide_all_handle() {
          for (let i = 0; i < this.array_item.length; i += 1) {
            this.hide_handle(i);
          }
        }

        onScroll(_s, e) {
          if (e == ScrollView.EventType.SCROLL_BEGAN) {
            this.hide_all_handle();
          }
        }

        show_handle(index) {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam(); // 没有片数时点击无效

          if (data.pieceData[index] <= 0) {
            return;
          } // 按钮样式


          this.array_item[index].btn_use.interactable = data.jigsawData[index] === 0;
          this.array_item[index].btn_use.inScrollView = false;
          this.array_item[index].text_btn_use.string = this.array_item[index].btn_use.interactable ? i18n.t("jigsaw_window_use") : i18n.t("jigsaw_window_used");
          this.array_item[index].btn_send.interactable = data.pieceLock[index] < data.pieceData[index];
          this.array_item[index].btn_send.inScrollView = false;
          this.array_item[index].btn_send_lock.active = !this.array_item[index].btn_send.interactable; // 显示动画

          this.array_item[index].handle.scale = v3(0, 0, 1);
          this.array_item[index].handle.active = true;
          this.array_item[index].handle.stopAllActions();
          this.array_item[index].handle.runAction(ccAction.scaleTo(0.1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
        }

        hide_handle(index) {
          // 动画
          // this.array_item[index].handle.stopAllActions()
          // this.array_item[index].handle.runAction(ccAction.sequence(
          //     ccAction.scaleTo(0.1, 0),
          //     ccAction.callFunc(() => { this.array_item[index].handle.active = false })
          // ))
          this.array_item[index].handle.active = false;
        }
        /** 点击事件：显示/隐藏handle界面 */


        event_handle(e, index) {
          index = Number.parseInt(index); // todo：需要考虑动画带来的延迟

          if (this.array_item[index].handle.active) {
            this.hide_handle(index);
          } else {
            this.hide_all_handle(); // 由于只允许一个handle存在，先隐藏掉全部的handle

            this.show_handle(index);
          }
        }
        /** @type {cc.Node} */

        /**
         * 使用单个的页面动画，包括本体页面修改和main页面修改
         * @param {number} index
         * @param {number} delay 延迟时间，从移动开始延迟
         * @param {boolean} flag 是否为多个单个处理，统一处理特别针对complete情况
         */


        anima_use_one(index, delay = 0, flag = true, raw_pos = null) {
          if (flag) {
            this.n_anima_use_bg.active = true;
          }

          let node = instantiate(JigsawWindow.ins.main.item_list[index].node);
          GameKit.ControllerTable.GetNode(node, "sp-raw").getComponent(Sprite).setState(0);
          node.parent = this.n_anima_use;
          node.position = Vec2.ZERO;
          if (raw_pos) node.position = raw_pos;
          node.scale = v3(0, 0, 1);
          node.runAction(ccAction.sequence(ccAction.scaleTo(0.5, 1.2, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBounceOut)), ccAction.delayTime(delay), ccAction.moveTo(0.3, JigsawWindow.ins.main.get_sp_world_position(index), CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), ccAction.scaleTo(0.2, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeExponentialOut)), ccAction.callFunc(() => {
            SoundManager.playSound("spins_bar");

            if (flag) {
              this.n_anima_use_bg.active = false;
              JigsawWindow.ins.main.update_page();
              JigsawWindow.ins.gift.update_page();
              this.update_page();
            } else {
              JigsawWindow.ins.main.update_single_piece(index);
            }

            node.destroy();
          })));
        }
        /** 使用多个的页面动画，包括本体页面修改和main页面修改 */


        anima_use_some(index_list) {
          let interval = 0.3;
          this.n_anima_use_bg.active = true;

          for (let i = 0; i < index_list.length; i += 1) {
            this.anima_use_one(index_list[i], i * interval, false);
          }

          this.scheduleOnce(() => {
            this.n_anima_use_bg.active = false;
            JigsawWindow.ins.main.update_complete();
            JigsawWindow.ins.gift.update_page();
            this.update_page();
          }, interval * index_list.length);
        }
        /** 点击事件：使用1个 */


        event_use(e, index) {
          e.target.getComponent(Button).interactable = false;
          index = Number.parseInt(index);
          this.hide_handle(index); // 通知服务器

          let sr = SR.SRJigsaw.activityJigsawUse([index]);
          sr.SetCallBack(() => {
            this.anima_use_one(index);
          });
          sr.Send();
          SoundManager.playSound("se_ok");
        }

        event_send(e, index) {
          index = Number.parseInt(index);
          this.hide_handle(index);
          UIRoot.instance.openChildWindow(JigsawFriendsWindow, {
            index: index
          });
          SoundManager.playSound("se_ok");
        }
        /** 点击事件：补全拼图 */


        event_complete() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();
          let index_list = [];

          for (let [i, e] of data.jigsawData.entries()) {
            if (e === 0) {
              index_list.push(i);
            }
          }

          this.hide_all_handle();
          let sr = SR.SRJigsaw.activityJigsawUse(index_list);
          sr.SetCallBack(() => {
            this.anima_use_some(index_list);
          });
          sr.Send();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btn_complete", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "n_anima_use", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "n_anima_use_bg", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NewActivityCenterWindow.ts", ['cc', './global.ts', './_app.ts', './UIWindow.ts', './ContentModel.ts', './Content.ts', './DialogWindow.ts', './TimeUtil.ts', './CustomToggle.ts', './UIRoot.ts', './ActivityManager.ts', './ActivityMeta.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, ToggleContainer, Node, Sprite, Label, Button, ProgressBar, _decorator, instantiate, assetManager, SpriteFrame, Texture2D, color, G, cce, UIWindow, ContentModel, Content, DialogWindow, TimeUtil, CustomToggle, UIRoot, ActivityManager, ActivityMeta, Meta, Game, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      ToggleContainer = module.ToggleContainer;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      Button = module.Button;
      ProgressBar = module.ProgressBar;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      assetManager = module.assetManager;
      SpriteFrame = module.SpriteFrame;
      Texture2D = module.Texture2D;
      color = module.color;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      TimeUtil = module.TimeUtil;
    }, function (module) {
      CustomToggle = module.CustomToggle;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      ActivityMeta = module.ActivityMeta;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2bf6ftwjp9KD5EQoq6aFThR", "NewActivityCenterWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NewActivityCenterWindow = exports('NewActivityCenterWindow', (_dec = ccclass('NewActivityCenterWindow'), _dec2 = property(ToggleContainer), _dec3 = property(Node), _dec4 = property(Sprite), _dec5 = property(Sprite), _dec6 = property(Label), _dec7 = property(Label), _dec8 = property(Label), _dec9 = property(ContentModel), _dec10 = property(Label), _dec11 = property(Button), _dec12 = property(ProgressBar), _dec(_class = (_class2 = (_temp = _class3 = class NewActivityCenterWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "toggleContainer", _descriptor, this);

          _initializerDefineProperty(this, "toggleItem", _descriptor2, this);

          _initializerDefineProperty(this, "imgActivity", _descriptor3, this);

          _initializerDefineProperty(this, "progressIconActivity", _descriptor4, this);

          _initializerDefineProperty(this, "labelActivityName", _descriptor5, this);

          _initializerDefineProperty(this, "labelActivityDesc", _descriptor6, this);

          _initializerDefineProperty(this, "labelProgress", _descriptor7, this);

          _initializerDefineProperty(this, "rewardNode", _descriptor8, this);

          _initializerDefineProperty(this, "labelTime", _descriptor9, this);

          _initializerDefineProperty(this, "btnGo", _descriptor10, this);

          _initializerDefineProperty(this, "progressBar", _descriptor11, this);

          _defineProperty(this, "_activities", []);

          _defineProperty(this, "lastUpdateTime", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "_currentActivityIndex", 0);
        }

        onShow(showParams) {
          this._activities = ActivityManager.GetActiveGameActivities();

          this._activities.sort((a, b) => {
            return ActivityMeta.GameSubTypesOrder[a.SubType()] - ActivityMeta.GameSubTypesOrder[b.SubType()];
          });

          let GoldTradeMeta = ActivityManager.GetActiveOtherActivityByType(Meta.ActivityMeta.SubTypes.GoldTrade);
          if (GoldTradeMeta) this._activities.push(GoldTradeMeta);
          this.toggleItem.active = false;

          this._activities.forEach((activity, index) => {
            if (activity.Name()["en"] !== "Evolve King") {
              const newToggle = instantiate(this.toggleItem);
              this.toggleContainer.node.addChild(newToggle);
              newToggle.active = true;
              const customToggle = newToggle.getComponent(CustomToggle);
              let sfCheckResPath = "";
              let sfResPath = "";

              if (activity.Icon().startsWith("http")) {
                sfCheckResPath = activity.Icon();
                sfResPath = activity.Icon();
              } else {
                sfCheckResPath = "res/Activity/icons/" + activity.Icon() + "1";
                sfResPath = "res/Activity/icons/" + activity.Icon() + "2";
              }

              customToggle.setIcons(sfCheckResPath, sfResPath);
              customToggle.setName(i18n.sel(activity.Name()));
              customToggle.index = index;
            }
          });

          if (this.toggleContainer.toggleItems.length) {
            this._updateActivity(0);
          }
        }

        _updateActivity(index) {
          const meta = this._activities[index];
          let imgResPath = meta.Image();

          if (imgResPath.startsWith("http")) {
            assetManager.loadRemote(imgResPath, {
              ext: ".png"
            }, (error, imageAsset) => {
              if (error) return;
              const newSpriteFrame = new SpriteFrame();
              const texture = new Texture2D();
              texture.image = imageAsset;
              newSpriteFrame.texture = texture;
              this.imgActivity.spriteFrame = newSpriteFrame;
            });
          } else {
            imgResPath = "res/Activity/centerImages/" + meta.Image();
            cce.loadRes(imgResPath, SpriteFrame, (error, sf) => {
              if (error) return;
              this.imgActivity.spriteFrame = sf;
              this.imgActivity.sizeMode = Sprite.SizeMode.TRIMMED;
            });
          }

          if (meta.Param().center_extra) {
            const activityId = meta.Id();
            const userdata = Game.SUserActivity.GetActivityData(activityId);
            const currentCount = userdata.currentCount || 0;
            const currentId = userdata.currentId || 1;
            const currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.AttackMaster, currentId);
            const currentGet = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.AttackMasterReward, currentId));
            this.labelProgress.string = currentCount.toString() + " / " + currentNeed;
            this.progressBar.progress = currentCount / currentNeed;
            this.rewardNode.show(currentGet);

            if (meta.Icon().startsWith("http")) {
              assetManager.loadRemote(meta.Icon(), {
                ext: ".png"
              }, (error, imageAsset) => {
                if (error) return;
                const newSpriteFrame = new SpriteFrame();
                const texture = new Texture2D();
                texture.image = imageAsset;
                newSpriteFrame.texture = texture;
                this.progressIconActivity.spriteFrame = newSpriteFrame;
              });
            } else {
              const iconPath = "res/Activity/icons/" + meta.Icon() + "1";
              cce.loadRes(iconPath, SpriteFrame, (error, sf) => {
                if (error) return;
                this.progressIconActivity.spriteFrame = sf;
              });
            }
          } else {
            this.rewardNode.node.parent.active = false;
          }

          this.labelActivityName.string = i18n.sel(meta.Name());
          this.labelActivityDesc.string = i18n.sel(meta.Description());
          this.leftTime = meta.EndTime() - TimeUtil.getCurrentTime();

          this._updateBadge(index);
        }

        _updateBadge(index) {
          const meta = this._activities[index];
          const badgeNode = this.toggleContainer.toggleItems[index].node.getChildByName("badge");
          badgeNode.active = Game.SUserActivity.GetGameActivityBadgeStateByType(meta.SubType());
        }

        onBtnGoClick() {
          let meta = this._activities[this._currentActivityIndex];

          if (!meta.IsActive()) {
            this.closeAnim(() => {
              DialogWindow.Show(i18n.t("ActivityCenterTimeEnd"), nullFunction);
            });
            return;
          }

          let icon_goto = meta.IconGoto();

          if (icon_goto == "panel") {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(meta.Panel(), {
                meta: meta
              });
            });
          } else if (icon_goto == "slot") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Slot, true);
            });
          } else if (icon_goto == "village") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Village, true);
            });
          } else if (icon_goto == "villageShop") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Village, true);
            });
          } else if (icon_goto == "window") {
            this.closeAnim(() => {
              meta.Panel().Show(meta);
            });
          } else {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(icon_goto, {
                meta: meta
              });
            });
          }
        }

        onToggleClick(toggle) {
          const index = this.toggleContainer.toggleItems.indexOf(toggle);
          this._currentActivityIndex = index;
          this.toggleContainer.toggleItems.forEach((toggle, i) => {
            toggle.node.getChildByName("labelName").color = i === index ? color("#FFFFFF") : color("#96ADB9");
          });

          this._updateActivity(index);
        }

        slowUpdate(dt) {
          let cTime = TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;

          if (this.leftTime != null) {
            this.leftTime -= dt;
            if (this.leftTime <= 0) this.leftTime = 0;
            this.labelTime.string = String.format(i18n.t("ActivityCenterTime"), TimeUtil.FormatRemainTimeSimple(this.leftTime, true));
          }
        }

        onCloseClick() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Activity/NewActivityCenterWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "toggleContainer", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "toggleItem", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "imgActivity", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "progressIconActivity", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelActivityName", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelActivityDesc", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelProgress", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "rewardNode", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "labelTime", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "btnGo", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "progressBar", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ResourceTextureLoader.ts", ['cc', './CCE_Component.ts', './_app.ts'], function (exports) {
  'use strict';

  var cclegacy, CCString, _decorator, Sprite, SpriteFrame, CCE_Component, cce;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCString = module.CCString;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      cce = module.cce;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2c0d9j9UUVCtYz4ADRp1Dle", "ResourceTextureLoader", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ResourceTextureLoader = exports('default', (_dec = property(CCString), ccclass(_class = (_class2 = (_temp = class ResourceTextureLoader extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "path", _descriptor, this);
        }

        onEnable() {
          this.load();
        }

        load() {
          let sprite = this.getComponent(Sprite);
          if (!sprite) return;
          if (sprite.spriteFrame) return;
          cce.loadRes(this.path, SpriteFrame, function (err, v) {
            if (!err && v != null && sprite) {
              sprite.spriteFrame = v;
            }
          }.bind(this));
        }

        onDestroy() {
          let sprite = this.getComponent(Sprite);
          cce.releaseSpriteFrame(sprite);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "path", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DB.ts", ['cc', './LZString.ts'], function (exports) {
  'use strict';

  var cclegacy, LZString;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      LZString = module.LZString;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "2dda2R/sxdDrKZjZIjk15xf", "DB", undefined);
      /**
       * Author:terran
       * Email:terran.tian@foxmail.com
       * 
       * Time:上午10:25 2016年12月17日
       **/


      class DB {
        constructor(keysStr, datasStr, key) {
          _defineProperty(this, "_rows", void 0);

          _defineProperty(this, "_map", void 0);

          let keys = JSON.parse(LZString.decompressFromBase64(keysStr));
          let datas = JSON.parse(LZString.decompressFromBase64(datasStr));
          let keyIndex = keys.indexOf(key);
          this._rows = [];
          this._map = {};

          for (let i = 0; i < datas.length; i++) {
            let row = {};

            for (let j = 0; j < keys.length; j++) {
              row[keys[j]] = datas[i][j];
            }

            this._rows.push(row);

            this._map[datas[i][keyIndex]] = row;
          }
        }

        get(id) {
          return this._map[id];
        }

        getall() {
          return this._rows;
        }

      }

      exports('DB', DB);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRChat.ts", ['cc', './ChatMgr.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, ChatMgr, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      ChatMgr = module.ChatMgr;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRChat', void 0);

      cclegacy._RF.push({}, "2e115Xu+EZK4LXg64NdSGpm", "SRChat", undefined);

      let SRChat;

      (function (_SRChat) {
        function getChats(timeStamp) {
          let req = new GameKit.ServerRequest("getChats");
          timeStamp = timeStamp || GameKit.TimeUtil.getCurrentTime() - 30;
          req.SetRequestBody("timeStamp", timeStamp);
          req.SetSilence(true);
          req.SetCallBack(function (res) {
            ChatMgr.addMessage(res.chats);
            ChatMgr.lastTime = res.timeStamp;
          });
          return req;
        }

        _SRChat.getChats = getChats;

        function getLastChat(timeStamp) {
          let req = new GameKit.ServerRequest("getLastChat");
          timeStamp = timeStamp || GameKit.TimeUtil.getCurrentTime();
          req.SetRequestBody("timeStamp", timeStamp);
          req.SetSilence(true);
          req.SetCallBack(function (res) {
            ChatMgr.setLastMessages(res.chat, res.timeStamp);
          });
          return req;
        }

        _SRChat.getLastChat = getLastChat;

        function sendChat(message) {
          let req = new GameKit.ServerRequest("sendChat");
          req.SetRequestBody("message", message);
          req.SetRequestBody("userInfo", Game.SUser.getUserInfo());
          req.SetSilence(true);
          req.SetCallBack(function (res) {});
          return req;
        }

        _SRChat.sendChat = sendChat;
      })(SRChat || (SRChat = exports('SRChat', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/birdMgr.ts", ['cc', './CCE_Component.ts', './global.ts', './UIRoot.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, Node, _decorator, CCE_Component, G, UIRoot;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIRoot = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2e6daset7tOuJO4AJNWXtiq", "birdMgr", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let birdMgr = exports('default', (_dec = property(CCInteger), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class birdMgr extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "time", _descriptor, this);

          _initializerDefineProperty(this, "item", _descriptor2, this);

          _defineProperty(this, "_t", void 0);
        }

        start() {
          this._t = 0;
          this.item.active = false;
        }

        slowUpdate(dt) {
          this._t += dt;

          if (this._t >= this.time) {
            this._t = 0;
            this.showAnim();
          }
        }

        showAnim() {
          if (G.getRandomInt(0, 2) === 0) {
            this.item.scaleX = 1;
            this.item.x = UIRoot.instance.winSize.width / 2 + 100;
            this.item.y = G.getRandomFloat(-400, 400);
            this.item.active = true;
            this.item.runAction(ccAction.sequence(ccAction.moveBy(G.getRandomFloat(1.2, 2.5), -UIRoot.instance.winSize.width - 200, G.getRandomFloat(-200, 200)), ccAction.callFunc(function () {
              this.item.active = false;
            }, this)));
          } else {
            this.item.scaleX = -1;
            this.item.x = -UIRoot.instance.winSize.width / 2 - 100;
            this.item.y = G.getRandomFloat(-400, 400);
            this.item.active = true;
            this.item.runAction(ccAction.sequence(ccAction.moveBy(G.getRandomFloat(1.2, 2.5), UIRoot.instance.winSize.width + 200, G.getRandomFloat(-200, 200)), ccAction.callFunc(function () {
              this.item.active = false;
            }, this)));
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 30;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HomeView.ts", ['cc', './Constant.ts', './CCEaseTypes.ts', './global.ts', './_app.ts', './EnterCloseAnim.ts', './PlayAudio.ts', './ResourceLoader.ts', './CommonAssets.ts', './Content.ts', './MetaManager.ts', './CardAllSetWindow.ts', './CameraController3d.ts', './ContainerVillage.ts', './RoomManager.ts', './Player.ts', './GetRewardWindow.ts', './ActivitySlotSymbolRankWindow.ts', './TutorialManager.ts', './SlotNode.ts', './ActivityGameShowWindow.ts', './ActivitySlotSymbolShowWindow.ts', './HeistData.ts', './CardSystemOpenWindow.ts', './FacebookBindWindow.ts', './InviteWindow.ts', './GiftsWindow.ts', './VillageNewsWindow.ts', './AutoSpinTipWindow.ts', './CardPage.ts', './FriendPage.ts', './ShopPage.ts', './ServantWindow.ts', './SignInWindow.ts', './NewPlayerPackWindow.ts', './SlotPage.ts', './VillagePage.ts', './ServantSystemOpenWindow.ts', './SdkManager.ts', './PageViewController.ts', './VillageNode.ts', './GameMainWindow.ts', './SR.ts', './SlotResultHandler.ts', './VIPDailyRewardWindow.ts', './ShopWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts', './InteractionNode.ts'], function (exports) {
  'use strict';

  var cclegacy, Prefab, Node, _decorator, Component, director, DirectionalLight, Animation, Quat, Color, view, Size, instantiate, UITransform, v3, Camera, Label, Vec3, dragonBones, tween, MyCustomEvent, Constant, CCEaseTypes, G, cce, EnterCloseAnim, PlayAudio, ResourceLoader, CommonAssets, Content, MetaManager, CardAllSetWindow, CameraController3d, ContainerVillage, RoomManager, Player, GetRewardWindow, ActivitySlotSymbolRankWindow, TutorialManager, SlotNode, ActivityGameShowWindow, ActivitySlotSymbolShowWindow, HeistData, CardSystemOpenWindow, InviteWindow, GiftsWindow, VillageNewsWindow, AutoSpinTipWindow, CardPage, FriendPage, ShopPage, ServantWindow, SignInWindow, NewPlayerPackWindow, SlotPage, VillagePage, ServantSystemOpenWindow, SdkManager, PageViewController, VillageNode, GameMainWindow, SR, SlotResultHandler, VIPDailyRewardWindow, ShopWindow, UIRoot, ActivityManager, Game, Meta, LogEventWrap, ADWrap, PaymentWrap, GameKit, i18n, AppMain, InteractionNode;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Prefab = module.Prefab;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      director = module.director;
      DirectionalLight = module.DirectionalLight;
      Animation = module.Animation;
      Quat = module.Quat;
      Color = module.Color;
      view = module.view;
      Size = module.Size;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
      v3 = module.v3;
      Camera = module.Camera;
      Label = module.Label;
      Vec3 = module.Vec3;
      dragonBones = module.dragonBones;
      tween = module.tween;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      Constant = module.Constant;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      PlayAudio = module.default;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      CardAllSetWindow = module.default;
    }, function (module) {
      CameraController3d = module.default;
    }, function (module) {
      ContainerVillage = module.default;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      Player = module.default;
    }, function (module) {
      GetRewardWindow = module.GetRewardWindow;
    }, function (module) {
      ActivitySlotSymbolRankWindow = module.ActivitySlotSymbolRankWindow;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      SlotNode = module.default;
    }, function (module) {
      ActivityGameShowWindow = module.ActivityGameShowWindow;
    }, function (module) {
      ActivitySlotSymbolShowWindow = module.ActivitySlotSymbolShowWindow;
    }, function (module) {
      HeistData = module.default;
    }, function (module) {
      CardSystemOpenWindow = module.CardSystemOpenWindow;
    }, function () {}, function (module) {
      InviteWindow = module.InviteWindow;
    }, function (module) {
      GiftsWindow = module.GiftsWindow;
    }, function (module) {
      VillageNewsWindow = module.VillageNewsWindow;
    }, function (module) {
      AutoSpinTipWindow = module.AutoSpinTipWindow;
    }, function (module) {
      CardPage = module.CardPage;
    }, function (module) {
      FriendPage = module.FriendPage;
    }, function (module) {
      ShopPage = module.ShopPage;
    }, function (module) {
      ServantWindow = module.ServantWindow;
    }, function (module) {
      SignInWindow = module.SignInWindow;
    }, function (module) {
      NewPlayerPackWindow = module.NewPlayerPackWindow;
    }, function (module) {
      SlotPage = module.SlotPage;
    }, function (module) {
      VillagePage = module.default;
    }, function (module) {
      ServantSystemOpenWindow = module.ServantSystemOpenWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      PageViewController = module.PageViewController;
    }, function (module) {
      VillageNode = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      SlotResultHandler = module.default;
    }, function (module) {
      VIPDailyRewardWindow = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }, function (module) {
      InteractionNode = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2eb49oYt5hA8rwopP35X8YG", "HomeView", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let HomeView = exports('HomeView', (_dec = ccclass("HomeView"), _dec2 = property(PageViewController), _dec3 = property(Prefab), _dec4 = property(Prefab), _dec5 = property(Prefab), _dec6 = property(Prefab), _dec7 = property(Prefab), _dec8 = property(Prefab), _dec9 = property(Prefab), _dec10 = property(Prefab), _dec11 = property(Prefab), _dec12 = property(Prefab), _dec13 = property(Node), _dec14 = property(Node), _dec(_class = (_class2 = (_temp = _class3 = class HomeView extends Component {
        // @property(Node)
        // spInteraction: Node = null;
        // dailyBonusNode: DailyBonusNode;
        // private petLoaded: boolean;
        constructor() {
          super();

          _initializerDefineProperty(this, "pageViewController", _descriptor, this);

          _initializerDefineProperty(this, "slotPrefab", _descriptor2, this);

          _initializerDefineProperty(this, "dailyBonusPrefab", _descriptor3, this);

          _initializerDefineProperty(this, "interactionPrefab", _descriptor4, this);

          _initializerDefineProperty(this, "pageCommunityPrefab", _descriptor5, this);

          _initializerDefineProperty(this, "pageCollectionPrefab", _descriptor6, this);

          _initializerDefineProperty(this, "pageSlotPrefab", _descriptor7, this);

          _initializerDefineProperty(this, "pageVillagePrefab", _descriptor8, this);

          _initializerDefineProperty(this, "pageShopPrefab", _descriptor9, this);

          _initializerDefineProperty(this, "animBuild", _descriptor10, this);

          _initializerDefineProperty(this, "animBuildStar", _descriptor11, this);

          _initializerDefineProperty(this, "spinAddNumAnim", _descriptor12, this);

          _initializerDefineProperty(this, "bgNode", _descriptor13, this);

          _defineProperty(this, "changeAnim", false);

          _defineProperty(this, "inGame", false);

          _defineProperty(this, "loadTimer", void 0);

          _defineProperty(this, "currentPageIndex", void 0);

          _defineProperty(this, "slotNode", void 0);

          _defineProperty(this, "interactionNode", void 0);

          _defineProperty(this, "villageNode", void 0);

          _defineProperty(this, "villageIconItem", void 0);

          _defineProperty(this, "oldVillageResName", void 0);

          _defineProperty(this, "isOldVillageLocal", void 0);

          _defineProperty(this, "oldSlotResName", void 0);

          _defineProperty(this, "oldVillageIconResName", void 0);

          _defineProperty(this, "firstLoaded", true);

          _defineProperty(this, "villageIconLoaded", false);

          _defineProperty(this, "villageProgress", void 0);

          _defineProperty(this, "villageIconProgress", void 0);

          _defineProperty(this, "slotProgress", void 0);

          _defineProperty(this, "villageLoaded", void 0);

          _defineProperty(this, "slotLoaded", void 0);

          _defineProperty(this, "pages", []);

          _defineProperty(this, "friendPage", void 0);

          _defineProperty(this, "cardPage", void 0);

          _defineProperty(this, "slotPage", void 0);

          _defineProperty(this, "villagePage", void 0);

          _defineProperty(this, "shopPage", void 0);

          _defineProperty(this, "shopWindow", void 0);

          _defineProperty(this, "cardAllSetWindow", void 0);

          _defineProperty(this, "shopContainer", null);

          _defineProperty(this, "cardContainer", null);

          _defineProperty(this, "communityContainer", null);

          _defineProperty(this, "isGamePrepared", false);

          _defineProperty(this, "inited", false);

          _defineProperty(this, "_isFirstEnter", false);

          _defineProperty(this, "firstChain", void 0);

          _defineProperty(this, "uniqueDirectionLight", void 0);

          _defineProperty(this, "lightAnimCmp", void 0);

          _defineProperty(this, "mapWindow", void 0);

          this.villageLoaded = false;
          this.villageProgress = 0;
          this.villageIconLoaded = false;
          this.villageIconProgress = 0;
          this.slotLoaded = false;
          this.slotProgress = 0;
        }

        onLoad() {
          Reflect.defineProperty(globalThis, "homeView", {
            value: this,
            configurable: true
          });
          eventCenter.on(MyCustomEvent.OnPageTurnComplete, this.updateBg, this);
          eventCenter.on(MyCustomEvent.UpdateGlobalConfigAndLight, this.updateLightAnimation, this);
          eventCenter.on(MyCustomEvent.UpdateGlobalConfigAndLight, this.updateGlobalConfig, this);
          eventCenter.on(MyCustomEvent.UpdateGlobalConfigAndLight, this.updateDirectionLight, this);
          eventCenter.on(MyCustomEvent.GamePrepareOK, this.onPrepareOK, this);
          this.node.getChildByName("tabNode").active = false;
          this.uniqueDirectionLight = director.getScene().getComponentInChildren(DirectionalLight);
          this.lightAnimCmp = this.uniqueDirectionLight.getComponent(Animation);
        }

        onDestroy() {
          eventCenter.off(MyCustomEvent.OnPageTurnComplete, this.updateBg, this);
          eventCenter.off(MyCustomEvent.UpdateGlobalConfigAndLight, this.updateLightAnimation, this);
          eventCenter.off(MyCustomEvent.UpdateGlobalConfigAndLight, this.updateGlobalConfig, this);
          eventCenter.off(MyCustomEvent.UpdateGlobalConfigAndLight, this.updateDirectionLight, this);
          eventCenter.off(MyCustomEvent.GamePrepareOK, this.onPrepareOK, this);
        }

        refreshHomeLight() {
          eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "home", this.pageViewController.pageView.getCurrentPageIndex(), 0);
        }

        updateLightAnimation(environment, leftIndex = 0, curRate = 0) {
          if (!this.uniqueDirectionLight) return;
          let targetAnimCmp = this.lightAnimCmp;

          if (environment === "home") {
            if (leftIndex + curRate === 3) {
              const villageLight = this.villagePage.containerVillage.directionLight;
              if (!villageLight) return;
              const animCmp = villageLight.getComponent(Animation);

              if (animCmp && animCmp.defaultClip) {
                targetAnimCmp.defaultClip = animCmp.defaultClip;
                targetAnimCmp.play();
              } else {
                if (targetAnimCmp.clips.length > 0) {
                  targetAnimCmp.stop();
                  targetAnimCmp.defaultClip = null;
                  targetAnimCmp.clips = [];
                }
              }
            } else {
              if (targetAnimCmp.clips.length > 0) {
                targetAnimCmp.stop();
                targetAnimCmp.defaultClip = null;
                targetAnimCmp.clips = [];
              }
            }
          }

          if (environment === "interaciton") {
            const interactionLight = this.interactionNode.containerInteraction.directionLight;
            const animCmp = interactionLight.getComponent(Animation);

            if (animCmp && animCmp.defaultClip) {
              targetAnimCmp.defaultClip = animCmp.defaultClip;
              targetAnimCmp.play();
            }
          }
        }

        updateDirectionLight(environment, leftIndex, curRate) {
          const dstLight = this.uniqueDirectionLight; //有时会被其他灯光替代，激活一下

          dstLight.node.active = false;
          dstLight.node.active = true;

          if (environment == "home") {
            if (leftIndex === undefined || curRate === undefined) return;
            curRate = Math.clamp(leftIndex - 2 + curRate, 0, 1); // console.log(leftIndex, curRate);

            let slotLight = this.slotPage.containerSlot.directionLight;
            let villageLight = this.villagePage.containerVillage.directionLight;

            if (!villageLight) {
              villageLight = slotLight;
            }

            const dstRotation = new Quat();
            Quat.slerp(dstRotation, slotLight.node.getWorldRotation(), villageLight.node.getWorldRotation(), curRate);
            dstLight.node.setWorldRotation(dstRotation);
            const dstIlluminance = Math.lerp(slotLight.illuminance, villageLight.illuminance, curRate);
            dstLight.illuminance = dstIlluminance;
            const dstColor = new Color();
            Color.lerp(dstColor, slotLight.color, villageLight.color, curRate);
            dstLight.color = dstColor;
          }

          if (environment == "interaciton") {
            const interactionLight = this.interactionNode.containerInteraction.directionLight;
            if (!interactionLight) return;

            if (!interactionLight.node) {
              console.log(interactionLight);
              return;
            }

            dstLight.node.setWorldRotation(interactionLight.node.getWorldRotation());
            dstLight.illuminance = interactionLight.illuminance;
            dstLight.color = interactionLight.color;
          }

          if (environment == "pet") {
            const interactionLight = ServantWindow.instance.containerServant.directionLight;
            if (!interactionLight) return;

            if (!interactionLight.node) {
              console.log(interactionLight);
              return;
            }

            dstLight.node.setWorldRotation(interactionLight.node.getWorldRotation());
            dstLight.illuminance = interactionLight.illuminance;
            dstLight.color = interactionLight.color;
          }
        }
        /**对环境光，雾等进行插值 */


        updateGlobalConfig(environment, leftIndex, curRate) {
          const dstGlobals = director.getScene().globals;
          const slotGlobals = this.slotPage.containerSlot.globalConfig;
          dstGlobals.fog.enabled = slotGlobals.fog.enabled;
          dstGlobals.fog.fogColor = slotGlobals.fog.fogColor;
          dstGlobals.fog.type = slotGlobals.fog.type; // dstGlobals.fog.fogStart = slotGlobals.fog.fogStart;

          dstGlobals.fog.fogEnd = slotGlobals.fog.fogEnd;

          if (environment == "home") {
            if (leftIndex === undefined || curRate === undefined) return;
            curRate = Math.clamp(leftIndex - 2 + curRate, 0, 1);
            let slotGlobals = this.slotPage.containerSlot.globalConfig;
            let villageGlobals = this.villagePage.containerVillage.globalConfig;

            if (!villageGlobals) {
              villageGlobals = slotGlobals;
            }

            const dstSkyColor = new Color();
            Color.lerp(dstSkyColor, slotGlobals.ambient.skyColor, villageGlobals.ambient.skyColor, curRate);
            dstGlobals.ambient.skyColor = dstSkyColor;
            const dstSkyIlluminance = Math.lerp(slotGlobals.ambient.skyIllum, villageGlobals.ambient.skyIllum, curRate);
            dstGlobals.ambient.skyIllum = dstSkyIlluminance;
            const dstShadowColor = new Color();
            Color.lerp(dstShadowColor, slotGlobals.shadows.shadowColor, villageGlobals.shadows.shadowColor, curRate);
            dstGlobals.shadows.shadowColor = dstShadowColor; // 设置雾的透明度没有效果
            // const dstFogColor = new Color();
            // const toFogColor = new Color(slotGlobals.fog.fogColor.r, slotGlobals.fog.fogColor.g, slotGlobals.fog.fogColor.b, 0);
            // Color.lerp(dstFogColor, slotGlobals.fog.fogColor, toFogColor, curRate);
            // dstGlobals.fog.fogColor = dstFogColor;

            const dstFogStart = Math.lerp(slotGlobals.fog.fogStart, slotGlobals.fog.fogEnd, curRate);
            dstGlobals.fog.fogStart = dstFogStart;
          }

          if (environment == "interaciton") {
            dstGlobals.fog.enabled = false;
            const interactionGlobals = this.interactionNode.containerInteraction.globalConfig;
            if (!interactionGlobals) return;
            dstGlobals.ambient.skyColor = interactionGlobals.ambient.skyColor;
            dstGlobals.ambient.skyIllum = interactionGlobals.ambient.skyIllum;
            dstGlobals.shadows.shadowColor = interactionGlobals.shadows.shadowColor;
          }

          if (environment == "pet") {
            dstGlobals.fog.enabled = false;
            const interactionGlobals = ServantWindow.instance.containerServant.globalConfig;
            if (!interactionGlobals) return;
            dstGlobals.ambient.skyColor = interactionGlobals.ambient.skyColor;
            dstGlobals.ambient.skyIllum = interactionGlobals.ambient.skyIllum;
            dstGlobals.shadows.shadowColor = interactionGlobals.shadows.shadowColor;
          }
        }

        updateBg(pageIndex) {
          if (pageIndex === 0 || pageIndex === 4) {
            this.bgNode.active = true;
          } else {
            this.bgNode.active = false;
          }
        }

        onPrepareOK() {
          console.log("onPrepareOK");
          this.isGamePrepared = true; // const layoutCmp = this.pageViewController.pageView.content.getComponent(Layout);
          // layoutCmp.updateLayout(true);
          // layoutCmp.enabled = false;
          //触发一次事件关闭其他界面

          eventCenter.emit(MyCustomEvent.OnPageTurnComplete, 2); //校正主场景灯光

          eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "home", 2, 0);
        }

        init() {
          if (!this.inited) {
            this.currentPageIndex = -1;
            this.loadPages();
            this.loadPrefabs();
            this.inited = true;
          }
        }

        async loadPages() {
          const viewSize = view.getVisibleSize();
          let newSize = new Size(viewSize.width + 50, viewSize.height);

          if (viewSize.width > 640) {
            newSize.width = viewSize.width + 50;
          }

          const communityNode = instantiate(this.pageCommunityPrefab);
          viewSize.width > 640 && communityNode.getComponent(UITransform).setContentSize(newSize);
          this.communityContainer = communityNode.getChildByName("container").getChildByName("communityContainer");
          this.pageViewController.pageView.addPage(communityNode);
          this.friendPage = communityNode.getComponent(FriendPage);
          const collectionNode = instantiate(this.pageCollectionPrefab);
          viewSize.width > 640 && collectionNode.getComponent(UITransform).setContentSize(newSize);
          this.cardContainer = collectionNode.getChildByName("container").getChildByName("CardContainer");
          this.pageViewController.pageView.addPage(collectionNode);
          this.cardPage = collectionNode.getComponent(CardPage);
          const slotNode = instantiate(this.pageSlotPrefab);
          viewSize.width > 640 && slotNode.getComponent(UITransform).setContentSize(newSize);
          this.pageViewController.pageView.addPage(slotNode);
          this.slotPage = slotNode.getComponent(SlotPage);
          this.slotPage.init();
          const villageNode = instantiate(this.pageVillagePrefab);
          viewSize.width > 640 && villageNode.getComponent(UITransform).setContentSize(newSize);
          this.pageViewController.pageView.addPage(villageNode);
          this.villagePage = villageNode.getComponent(VillagePage);
          this.villagePage.init();
          const shopNode = instantiate(this.pageShopPrefab);
          viewSize.width > 640 && shopNode.getComponent(UITransform).setContentSize(newSize);
          this.shopContainer = shopNode.getChildByName("container").getChildByName("ShopContainer");
          this.pageViewController.pageView.addPage(shopNode);
          this.shopPage = shopNode.getComponent(ShopPage);
          this.pages.push(this.friendPage, this.cardPage, this.slotPage, this.villagePage, this.shopPage);
          this.pages.forEach((v, i) => v.setPageIndex(i));
        }

        async loadPrefabs() {
          console.log("loadPrefabs"); // this.villagePage.villageContainer.active = true;
          // this.slotPage.slotContainer.active = true;

          let sl = instantiate(this.slotPrefab);
          sl.parent = this.slotPage.slotContainer;
          sl.setPosition(v3(0, 0, 0));
          this.slotNode = sl.getComponent(SlotNode);
          sl.active = true;
          this.interactionPrefab.data.active = false;
          let ia = instantiate(this.interactionPrefab);
          ia.parent = uiRoot.interactionNode;
          ia.setPosition(v3(0, 0, 0));
          ia.getComponent(UITransform).setContentSize(UIRoot.instance.winSize); // ia.active = false;

          this.interactionNode = ia.getComponent(InteractionNode);
        }

        Clear() {
          this.inGame = false;
          this.closeGamePlay();
        } // 切换界面


        closeGamePlay() {
          this.villageNode = null; // this.spVillage.destroyAllChildren();
          // if (this.oldVillageResName) {
          // 	cce.releaseRes(this.oldVillageResName, Prefab);
          // 	this.oldVillageResName = null;
          // }

          this.villageIconItem = null;

          if (this.oldVillageIconResName) {
            cce.releaseRes(this.oldVillageIconResName, Prefab);
            this.oldVillageIconResName = null;
          }

          if (this.slotNode) {
            this.slotNode.Clear(); // this.slotNode.node.destroy();
            // this.slotNode = null;
          }

          if (this.oldSlotResName) {
            cce.releaseRes(this.oldSlotResName, Prefab);
            this.oldSlotResName = null;
          }

          if (this.interactionNode) {
            this.interactionNode.Clear(); // this.interactionNode.node.destroy();
            // this.interactionNode = null;
          } // if (this.slotPage.dailyBonusNode) {
          // 	this.slotPage.dailyBonusNode.getComponentInChildren(DailyBonusNode).Clear();
          // this.slotPage.dailyBonusNode.destroy();
          // this.dailyBonusNode = null;
          // }
          // this.villageLoaded = false;


          this.villageProgress = 0; // this.villageIconLoaded = false;

          this.villageIconProgress = 0; // this.slotLoaded = false;

          this.slotProgress = 0;
          this.node.active = false; //sys.garbageCollect()
        }

        backToHomeView(callback) {
          // this.loadPrefabs();
          this.node.active = true; // this.loadUserData();

          this.loadTimer = setInterval(() => {
            if (this.allLoaded()) {
              if (this.loadTimer) clearInterval(this.loadTimer);
              this.loadTimer = null;
              setTimeout(() => {
                // GameMainWindow.instance.enterPage(this.currentPageIndex);
                if (callback) callback();
              }, 100);
            }
          }, 100);
        }

        async loadUserData(callback) {
          if (this.firstLoaded) {
            this.firstLoaded = false; //TODO以后挪到合理的位置

            console.time("commonAssets");
            callback && callback(0.6); // await CommonAssets.instance.loadRemotePrefab();

            console.timeEnd("commonAssets"); //slot3d只用加载一次

            console.time("slot3d");
            callback && callback(0.7);
            await this.loadSlot3d(Game.SUserVillage);
            console.timeEnd("slot3d");
            callback && callback(0.9);
          }

          this.loadVillage(Game.SUserVillage);
          this.slotNode.init();
        } //加载slot


        async loadSlot3d(info) {
          this.slotLoaded = false;
          if (this.slotNode) this.slotNode.Clear();
          let resPath = "slot3d/slot3d";
          let vPre = await ResourceLoader.loadSlot(resPath, true);
          let scene = await ResourceLoader.loadSceneConfig(resPath, true);
          this.slotPage.slot3dContainer.destroyAllChildren();
          let slotNode = instantiate(vPre);
          slotNode.getComponentInChildren(Camera).addComponent(CameraController3d);
          slotNode.getChildByName("Player").addComponent(Player);
          slotNode.getChildByName("RoomManager").addComponent(RoomManager);
          this.slotPage.slot3dContainer.addChild(slotNode);
          this.slotPage.containerSlot.init(slotNode, scene.globals);
          this.slotLoaded = true;
        } //加载村庄


        async loadVillage(info, releaseOldRes = true) {
          this.villageLoaded = false;
          this.villageNode = null;
          let mapId = info.MapId();
          const villageMeta = MetaManager.GetMeta(MetaManager.MetaType.Village, mapId);
          const isLocal = Constant.LocalMapIds.contains(mapId);
          let resId = villageMeta.ResId();
          let villageName = VillageNode.GetVillageName(resId);
          let resPath = VillageNode.GetVillageResPath(villageName);
          console.time("village>>>>>>>>>>>>>>>>");
          let vPre = await ResourceLoader.loadVillage(resPath, isLocal);
          console.log("load village finished");
          console.timeEnd("village>>>>>>>>>>>>>>>>");
          console.time("scene<<<<<<<<<<<<<<<");
          let scene = await ResourceLoader.loadSceneConfig(resPath, isLocal);
          console.log("load scene finished");
          console.timeEnd("scene<<<<<<<<<<<<<<<");
          this.villagePage.villageContainer.destroyAllChildren();
          let itemVillage = instantiate(vPre);
          this.villageNode = itemVillage.addComponent(VillageNode);
          this.villageNode.initBuilds(info);
          this.villagePage.villageContainer.getComponent(ContainerVillage).init(itemVillage, scene.globals);
          this.villagePage.villageContainer.addChild(itemVillage);

          if (this.oldVillageResName != resPath && releaseOldRes) {
            ResourceLoader.releaseVillage(this.oldVillageResName, this.isOldVillageLocal);
          }

          this.oldVillageResName = null;
          this.oldVillageResName = resPath;
          this.isOldVillageLocal = isLocal;
          this.villageLoaded = true;
          eventCenter.emit(MyCustomEvent.EnterNewVillage);
        } //加载村庄


        async loadVillageIcon(info, forceResId) {
          // console.log("loadvillageIcon ....");
          // this.villageIconLoaded = false;
          // this.villageIconItem = null;
          // const villageMeta: VillageMeta = MetaManager.GetMeta(MetaManager.MetaType.Village, info.MapId());
          // let resId = villageMeta.ResId();
          // const totalCount = Constant.MaxLevel;
          // resId = forceResId ? Math.clamp(forceResId, 1, totalCount) : (resId % totalCount == 0 ? totalCount : resId % totalCount);
          // let villageName = VillageNode.GetVillageName(resId);
          // let resPath = villageName + "/icon/";
          // await ResourceLoader.loadVillageIcon(resPath);
          this.villageIconLoaded = true;
        }

        allLoaded() {
          // return this.villageLoaded && this.villageIconLoaded && this.slotLoaded;
          // if (AppMain.instance.tutorialManager.isTutorilaFinished) {
          // 	return this.slotLoaded;
          // } else {
          // }
          return this.slotLoaded && this.villageLoaded; // return false;
        }

        allLoadProgress() {
          return (this.villageProgress + this.villageIconProgress + this.slotProgress) / 3;
        }

        isChangeAnim() {
          return this.changeAnim;
        }

        isBusy() {
          if (this.isChangeAnim()) return true;
          if (this.slotNode && !this.slotNode.canSpin()) return true; // if (this.dailyBonusNode && this.dailyBonusNode.isRunning()) return true;

          if (this.villageNode && this.villageNode.isBuilding()) return true;
          return false;
        }

        _preload(vPre, _t = 0.3) {
          if (vPre == null) return;
          if (SdkManager.IsNative()) return;
          let wnd = instantiate(vPre);
          wnd.parent = AppMain.instance.node;
          wnd.x = -3000;
          wnd.y = -3000;
          wnd.width = 2;
          wnd.height = 2;
          wnd.active = true;
          AppMain.instance.scheduleOnce(() => {
            wnd.active = false;
            wnd.destroy();
            cce.releaseRes(vPre._resName, Prefab);
          }, _t);
          return wnd;
        } //显示跳转场景


        EnterGame() {
          this.inGame = true;
          this.slotPage.initPage();
          this.villagePage.initPage();
          cce.loadRes("window/Community/CommunityWindow", Prefab, (error, asset) => {
            const communityWindow = instantiate(asset);
            this.communityContainer.addChild(communityWindow);
            communityWindow.getComponent(GiftsWindow).onShow();
          });
          cce.loadRes("window/newCard/NewCardWindow", Prefab, (error, asset) => {
            const cardWindow = instantiate(asset);
            this.cardContainer.addChild(cardWindow);
            this.cardAllSetWindow = cardWindow.getComponent(CardAllSetWindow);
            this.scheduleOnce(() => {
              this.cardAllSetWindow.onShow({});
            });
          });
          cce.loadRes("window/newShop/newShopWindow", Prefab, (error, asset) => {
            const shopNode = instantiate(asset);
            this.shopContainer.addChild(shopNode);
            this.shopWindow = shopNode.getComponent(ShopWindow);
            this.shopWindow.onShow({});
          });
          const pg = this.pageViewController.pageView;
          pg && pg.scrollToPage(HomeView.Pages.Slot, 0);
          this.pageViewController.moveToPage(HomeView.Pages.Slot);
          this.node.getChildByName("tabNode").active = true; //check villageFinished

          if (Game.SUserVillage.IsFinished() && Game.SUserVillage.HasNextVillage()) {
            let req = SR.SRVillage.askNextVillage();
            req.SetCallBack(res => {
              Game.SUserVillage.updateData(res.userVillage);
              this.schedule(() => {
                if (homeView.cardContainer.getComponentInChildren(CardAllSetWindow)) {
                  this.unscheduleAllCallbacks();
                  homeView.cardContainer.getComponentInChildren(CardAllSetWindow).flushData();
                }
              }, 0);
              GameMainWindow.instance.OnMapFinished();
            });
            req.SetErrorCallBack(() => {
              console.error("ask next village failed");
            });
            req.Send();
            homeView.villagePage.node.getChildByName("container").getChildByName("UI").active = false;
          }

          if (!this._isFirstEnter) {
            this._isFirstEnter = true;
            ActivityManager.logined(); // EnterCloseAnim.playEnter(this.slotPage.activityLeft);
            // EnterCloseAnim.playEnter(this.slotPage.activityRight);

            if (HomeView.isFirstEnter) {
              this.slotNode.slotPeter.StartActive(); // this.slotNode.servantNode.ShowAd();

              GameMainWindow.instance && GameMainWindow.instance.updateADShieldTip();
            }
          }

          if (!HomeView.isFirstEnter) {
            this.firstEnter();
          }

          LogEventWrap.logEvent("game_start");
          SdkManager.EnterGame();
        }

        firstEnter() {
          HomeView.isFirstEnter = true;
          this.checkTutorial();
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;
          if (this.checkSubTutorial()) return;
          let activityList = ActivityManager.GetAllActiveActivityList();
          let payActivities = [];
          let otherActivities = [];
          let gameActivities = [];
          activityList.forEach(activityMeta => {
            if (activityMeta.Type() === Meta.ActivityMeta.Types.Pay) {
              if (activityMeta.SubType() == Meta.ActivityMeta.SubTypes.LadderPack) {
                HeistData.load_data(activityMeta);

                if (HeistData.get_buy_Count_length() > HeistData.get_buy_count()) {
                  payActivities.push(activityMeta);
                }
              } else {
                payActivities.push(activityMeta);
              }
            } else if (activityMeta.Type() === Meta.ActivityMeta.Types.Game) {
              if (activityMeta.SubType() === Meta.ActivityMeta.SubTypes.Minigame || activityMeta.SubType() === Meta.ActivityMeta.SubTypes.SlotCollect || activityMeta.SubType() === Meta.ActivityMeta.SubTypes.SlotCollectRank) {
                gameActivities.push(activityMeta);
              }
            } else {
              otherActivities.push(activityMeta);
            }
          });
          let chain = new GameKit.ChildWindowChain();
          this.firstChain = chain; // 额外奖励

          chain.add(GetRewardWindow, () => {
            return Game.SUser.data.backReward != null && Game.SUser.data.backReward.length > 0;
          }, {
            contents: !!Game.SUser.data.backReward ? Content.FromContents(Game.SUser.data.backReward) : Game.SUser.data.backReward,
            desc: i18n.t("ExtraRewardDes")
          });
          chain.add(VIPDailyRewardWindow, () => {
            return GameKit.DataCache.GetData("vipDailyReward") != null;
          }, {
            vipDailyReward: GameKit.DataCache.GetData("vipDailyReward")
          }); // 新系统开放

          /*chain.add(CardSystemOpenWindow, () => {
          	if (CLOSE_Card || Game.SUserVillage.MapId() < G.GameConstance.cardSystemStartLevel) return false
          	let cardSystemOpen = GameKit.PlayerPrefs.GetBool("NewSystemOpen_Card")
          	if (!cardSystemOpen) {
          		GameKit.PlayerPrefs.SetBool("NewSystemOpen_Card", true)
          		return true
          	}
          	return false
          })
          chain.add(PeterOpenWindow, () => {
          	if (!AppKit.ADWrap.AdEnabled()) return false
          	let peterSystemOpen = GameKit.PlayerPrefs.GetInt("NewSystemOpen_Peter", 0)
          	if (peterSystemOpen < 3) {
          		peterSystemOpen++
          		GameKit.PlayerPrefs.SetInt("NewSystemOpen_Peter", peterSystemOpen)
          		return true
          	}
          	return false
          })
          chain.add(SuperShieldOpenWindow, () => {
          	if (!AppKit.ADWrap.AdEnabled()) return false
          	let systemOpen = GameKit.PlayerPrefs.GetInt("NewSystemOpen_SuperShield", 0)
          	if (systemOpen < 3) {
          		systemOpen++
          		GameKit.PlayerPrefs.SetInt("NewSystemOpen_SuperShield", systemOpen)
          		return true
          	}
          	return false
          })*/

          chain.add(NewPlayerPackWindow, () => {
            return !!Game.SUserStatus.GetNewPlayerLeftTime();
          }); // 支付活动

          payActivities.sort((a, b) => {
            return a.SubType() - b.SubType();
          });
          payActivities.forEach(x => {
            chain.add(x.Panel(), () => {
              return x.Panel() != null && x.Panel() != "";
            }, {
              meta: x
            });
          }); // 其他活动

          otherActivities.forEach(x => {
            if (x.SubType() == Meta.ActivityMeta.SubTypes.BlackJack) {
              chain.add(ActivityGameShowWindow, null, {
                meta: x
              });
              return;
            }

            chain.add(x.Panel(), null, {
              meta: x
            });
          }); // 游戏活动

          gameActivities.forEach(x => {
            if (x.SubType() == Meta.ActivityMeta.SubTypes.SlotCollectRank) {
              chain.add(ActivitySlotSymbolShowWindow, null, {
                meta: x
              }); // chain.add(ActivitySlotSymbolRankInfoWindow, null, { meta: x })

              return;
            }

            let winName = ActivityGameShowWindow;
            if (x.SubType() == Meta.ActivityMeta.SubTypes.SlotCollect) winName = ActivitySlotSymbolShowWindow;
            chain.add(winName, () => {
              return true;
            }, {
              meta: x
            });
          });
          let cd = GameKit.TimeUtil.getCurrentDay(); // 消息列表

          let NewMessageNum = GameKit.DataCache.GetData("NewMessageNum");
          if (NewMessageNum == null) NewMessageNum = 0;
          let presentNum = VillageNewsWindow.getPresentNum();
          chain.add(VillageNewsWindow, () => {
            return NewMessageNum > 0 || presentNum > 0;
          }, NewMessageNum > 0 ? {} : {
            mail: true
          }); // 邀请

          chain.add(InviteWindow, () => {
            let rd = GameKit.PlayerPrefs.GetInt("Startshow_InviteWindow", 0);
            if (cd <= rd) return false;
            GameKit.PlayerPrefs.SetInt("Startshow_InviteWindow", cd);
            return !G.GameConfig.closeShare;
          }); // // 礼物
          // chain.add(GiftsWindow, () => {
          //     let rd = GameKit.PlayerPrefs.GetInt("Startshow_GiftsWindow", 0)
          //     if (cd <= rd) return false
          //     GameKit.PlayerPrefs.SetInt("Startshow_GiftsWindow", cd)
          //     return wxTools.usewx || fbInTools.usefbIn || (AppKit.SdkManager.IsNative() && !Game.SUser.IsGuest())
          // })
          //签到

          const rankData = GameKit.DataCache.GetData("signData");

          if (rankData.signWeekDay > rankData.signWeekRewards) {
            chain.add(SignInWindow);
          } //收集排行


          if (GameKit.DataCache.GetData("SlotCollectRankEnd")) {
            chain.add(ActivitySlotSymbolRankWindow); // chain.add(ActivitySlotSymbolRankRewardWindow);
          } //走完


          chain.setFinishFunc(() => {}); //结束 包括中止

          chain.setCompleteFunc(() => {
            this.firstChain = null;
            GameKit.DataCache.RemoveData("vipDailyReward");
            if (!this.node) return;
            if (homeView && this.slotNode) this.slotNode.slotPeter.StartActive();
            GameMainWindow.instance && GameMainWindow.instance.updateADShieldTip(); // if (homeView && this.slotNode) this.slotNode.servantNode.ShowAd();
          });
          UIRoot.instance.ShowCantClick(true);
          setTimeout(() => {
            UIRoot.instance.CloseCantClick();
            chain.start();
          }, 500);
        }

        checkTutorial() {
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            if (AppMain.instance.tutorialManager.curTutorialIndex <= 1000004) {
              homeView.pageViewController.moveToPage(G.Pages.Village, true);
            }

            AppMain.instance.tutorialManager.tutorialStart(); // this.villagePage.btnVillageShop.node.stopAllActions();
            // //this.btnVillageShop.x = this.btnVillageShop.getComponent(EnterCloseAnim).st_x
            // this.villagePage.btnVillageShop.getComponent(EnterCloseAnim).enterAnim(() => {
            // 	if (TutorialManager.mainWindow) TutorialManager.mainWindow.showArrow();
            // });

            this.slotPage.btnMenu.node.active = false;
            this.villagePage.btnAdCoin.node.stopAllActions();
            this.villagePage.btnAdCoin.node.active = false;
            this.slotPage.btnLuckyDraw.node.stopAllActions();
            this.slotPage.btnLuckyDraw.node.active = false; // this.slotPage.btnAdSpin.node.stopAllActions();
            // this.slotPage.btnAdSpin.node.active = false;
            // this.userinfo.btnApAdd.node.active = false;
            // if (!CLOSE_Card) this.slotPage.btnCard.node.active = false;

            this.slotPage.btnNewPlayerPack.node.active = false;
            this.slotPage.vipNode.active = false;
            this.slotPage.activityLeft.active = false;
            this.slotPage.activityRight.active = false;
            GameMainWindow.instance.adShieldNode.active = false; //this.slotNode.bet.active = false

            AppMain.instance.tutorialManager.SetFinishCallback(() => {
              this.slotPage.btnMenu.node.active = true;
              EnterCloseAnim.playEnter(this.slotPage.btnMenu.node);
              this.villagePage.btnAdCoin.node.parent.active = true;
              this.villagePage.showBuildKing();
              this.slotPage.btnLuckyDraw.node.parent.active = true;
              this.slotPage.dailyBonusNode.active = true;

              if (this.slotPage.dailyBonusNode.active) {
                this.schedule(() => {
                  this.slotPage.dailyBonusNode.getComponentInChildren(Animation).play("spin1");
                }, 10);
              }

              this.slotPage.updateSpinAd();
              this.slotPage.updateLuckyDraw();
              EnterCloseAnim.playCloseImmediately(this.villagePage.btnAdCoin.node.parent);
              EnterCloseAnim.playCloseImmediately(this.slotPage.btnLuckyDraw.node.parent);
              ActivityManager.logined();

              if (PaymentWrap.PayVisiable()) {
                GameMainWindow.instance.userinfo.btnCoinAdd.node.active = true;
                this.slotPage.btnNewPlayerPack.node.active = !!Game.SUserStatus.GetNewPlayerLeftTime();
                this.slotPage.NewPlayerPackLeftTime = Game.SUserStatus.GetNewPlayerLeftTime();
                this.slotPage.vipNode.active = !Game.SUserStatus.IsVip() && SdkManager.IsNative(); // GameMainWindow.instance.userinfo.btnApAdd.node.active = !this.slotPage.btnNewPlayerPack.node.active && !this.slotPage.vipNode.active && this.slotPage.activityLeft.children.length <= 4;
              } //EnterCloseAnim.playEnter(this.userinfo.btnApAdd.node)


              this.slotPage.activityLeft.active = true;
              EnterCloseAnim.playEnter(this.slotPage.activityLeft);
              this.slotPage.activityRight.active = true;
              EnterCloseAnim.playEnter(this.slotPage.activityRight);
              if (ADWrap.AdEnabled()) GameMainWindow.instance.adShieldNode.active = true; //this.slotNode.bet.active = true

              {
                GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
                  oldCoin: Game.SUser.Coin(),
                  coin: Game.SUser.Coin() + 1000000,
                  needPlayAnim: true
                });
                GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ApEvent, {
                  ap: G.GameConstance.apMax
                });
                UIRoot.instance.openChildWindow(GetRewardWindow, {
                  contents: [new Content(1, 0, 1000000), new Content(2, 0, 60)],
                  showCallback: wnd => {
                    wnd.addOnCloseFunc(() => {
                      UIRoot.instance.openChildWindow(AutoSpinTipWindow, {
                        showCallback: wnd => {
                          wnd.addOnCloseFunc(() => {
                            UIRoot.instance.openChildWindow(CardSystemOpenWindow);
                          });
                        }
                      });
                    });
                  }
                });
              }
              LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "9aniil" : "tdpmp9"); //aj_tutorial_completion
            }); // TutorialManager.init();

            this.schedule(() => {
              if (TutorialManager.mainWindow) {
                this.unscheduleAllCallbacks();
                TutorialManager.mainWindow.arrow1.active = false;
                TutorialManager.mainWindow.arrow2.active = false;
                TutorialManager.mainWindow.arrow3.active = false;
              }
            }, 0.1);
            UIRoot.instance.preloadWindow("MainTutorialFinishWindow");
          }
        }

        checkSubTutorial() {
          if (!this.node) return;
          let mapId = Game.SUserVillage.MapId();

          if (!CLOSE_Servant && mapId >= G.GameConstance.servantSystemStartLevel && !Game.SUserServant.GetSelected()) {
            let req = SR.SRServant.unlockFirstServant();
            req.SetCallBack(function (res) {
              UIRoot.instance.openChildWindow(ServantSystemOpenWindow);
              player.changePet();
              PlayAudio.playOpen();
            });
            req.Send();
            return true;
          } // GameMainWindow.instance.enterPage(s);


          SdkManager.wxGameClubButtonHide(); // this.pageViewController.moveToPage(s, true);

          return false;
        }

        showSpinAddNumAnim(num, noUpdate) {
          return new Promise((resolve, reject) => {
            this.spinAddNumAnim.active = true;
            this.spinAddNumAnim.getComponent(Label).string = "+" + num.toString();
            let localPos = new Vec3();
            this.spinAddNumAnim.parent.inverseTransformPoint(localPos, this.pageViewController.labelAp.node.getWorldPosition());
            this.spinAddNumAnim.setPosition(localPos);
            this.spinAddNumAnim.scale = v3(0.001, 0.001, 0.001);
            this.spinAddNumAnim.runAction(ccAction.sequence(ccAction.moveTo(0.2, 158, -68, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeIn, 2)), ccAction.delayTime(1), ccAction.moveTo(0.3, localPos)));
            this.spinAddNumAnim.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeIn, 2)), ccAction.delayTime(1), ccAction.scaleTo(0.3, 0.001, 0.001), ccAction.callFunc(() => {
              this.spinAddNumAnim.getComponent(Label).string = "";
              this.spinAddNumAnim.active = false;
              resolve(null);
              if (!noUpdate) this.pageViewController._setAp();
            })));
          });
        }

        testDragon() {
          const newDBAttack = instantiate(CommonAssets.instance.attackDragonBones);
          const dbAttack = newDBAttack.getComponentInChildren(dragonBones.ArmatureDisplay);
          UIRoot.instance.node.addChild(newDBAttack);
          const slotNode = homeView.slotNode;
          slotNode.villageAttackedLoaded = true;
          let attackIntervalID = null;

          if (attackIntervalID) {
            clearInterval(attackIntervalID);
            attackIntervalID = null;
          }

          let loopFrame = 0;
          dbAttack.on(dragonBones.EventObject.FRAME_EVENT, event => {
            if (event.name === 'start_smoke') {
              const smoke = newDBAttack.getChildByName('particleSmoke');
              const fire = newDBAttack.getChildByName('particleFire');
              const fireTransform = dbAttack.armature().getBone("fire").global;
              const smokeTransform = dbAttack.armature().getBone("smoke").global;
              smoke.setPosition(smokeTransform.x, smokeTransform.y, 0);
              fire.setPosition(fireTransform.x, fireTransform.y, 0);
              smoke.active = true;
              fire.active = true;
              attackIntervalID = setInterval(() => {
                smoke.setPosition(smokeTransform.x, smokeTransform.y, 0);
                fire.setPosition(fireTransform.x, fireTransform.y, 0);
              }, 0.01);
            }

            if (event.name === "run_start") {
              loopFrame = SlotResultHandler.getFrameEventFrame(dbAttack.dragonAsset, dbAttack.animationName, "run_start") || 0;
              console.log("loopFrame", loopFrame); // runTime = +event.time || 0;
              // homeView.node.active = false;
              // GameMainWindow.instance.node.active = false;
              // if (!slotNode.villageAttackedLoaded) {
              // 	_label = newDBAttack.getChildByName("labelVillageProgress").getComponent(Label);
              // 	_label.getComponent(Widget).target = UIRoot.instance.node;
              // 	_label.node.active = true;
              // 	_label.string = `${Math.floor(progress * 100)}%`;
              // }
            }
          }, slotNode);
          dbAttack.on(dragonBones.EventObject.COMPLETE, () => {
            if (dbAttack.animationName === "boom_ani") {
              // 循环动画播放完成，可能多次调用
              if (slotNode.villageAttackedLoaded) {
                dbAttack.playAnimation("boom_ani_go", 1);
                dbAttack.scheduleOnce(() => {
                  const smoke = newDBAttack.getChildByName('particleSmoke');
                  tween(smoke).to(0.5, {
                    opacity: 0
                  }).start();
                }, 0); // homeView.interactionNode.instantiateAttack();
                // if (homeView.interactionNode.containerInteraction.bomb) {
                // 	homeView.interactionNode.containerInteraction.bomb.reachoutHand();
                // }
                // eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "interaciton");
              } else {
                console.log("not loaded, play again");
                dbAttack.armature().animation.gotoAndPlayByFrame("boom_ani", loopFrame + 1, 1);
              }
            } else if (dbAttack.animationName === "boom_ani_go") {
              // go动画播放完成
              slotNode.villageAttackedLoaded = false;
              dbAttack.timeScale = 0;
              clearInterval(attackIntervalID);
              attackIntervalID = null;
              newDBAttack.destroy(); // eventCenter.off(LoadEvent.VillageProgressUpdate, onProgress);
              // homeView.interactionNode.showAttack(() => {
              // 	slotNode.idle();
              // 	slotNode.activityRoot.updateActivity();
              // });
            }
          }, slotNode);
          newDBAttack.opacity = 255;
          dbAttack.playAnimation("boom_ani", 1);
        }

      }, _defineProperty(_class3, "instance", null), _defineProperty(_class3, "isFirstEnter", void 0), _defineProperty(_class3, "Pages", {
        Friends: 0,
        Cards: 1,
        Slot: 2,
        Village: 3,
        Shop: 4,
        DailyBonus: 5
      }), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "pageViewController", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "slotPrefab", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "dailyBonusPrefab", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "interactionPrefab", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "pageCommunityPrefab", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "pageCollectionPrefab", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "pageSlotPrefab", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "pageVillagePrefab", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "pageShopPrefab", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "animBuild", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "animBuildStar", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "spinAddNumAnim", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "bgNode", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AppCommentWindow.ts", ['cc', './global.ts', './UIWindow.ts', './SdkManager.ts', './UIRoot.ts', './LogEventWrap.ts', './NativeWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Button, _decorator, G, UIWindow, SdkManager, UIRoot, LogEventWrap, NativeWrap, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Button = module.Button;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2ee6c0lmAhL/IE9MkWQvxCo", "AppCommentWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AppCommentWindow = exports('default', (_dec = property(Button), ccclass(_class = (_class2 = (_temp = _class3 = class AppCommentWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "btnOk", _descriptor, this);
        }

        static TryShow() {
          if (!SdkManager.IsNative()) return false;
          if (G.GameConfig.closeComment) return false;
          if (NativeWrap.isReview() && SdkManager.IsIos()) return false;
          if (GameKit.PlayerPrefs.GetBool("AppCommentOk")) return false;
          if (GameKit.TimeUtil.getCurrentTime() - GameKit.PlayerPrefs.GetInt("AppCommentCloseTime", 0) < GameKit.TimeUtil.DayInSecond * 3) return false;
          UIRoot.instance.openChildWindow(AppCommentWindow);
          return true;
        }

        onShow(showParams) {
          GameKit.BackKeyManager.registerBackEvent();
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        } //update (dt) {},


        callClose() {
          this.closeAnim();
          LogEventWrap.logEvent("app_comment_close");
          GameKit.PlayerPrefs.SetInt("AppCommentCloseTime", GameKit.TimeUtil.getCurrentTime());
        }

        callGo() {
          this.closeAnim();
          GameKit.PlayerPrefs.SetBool("AppCommentOk", true);
          NativeWrap.openComment();
          LogEventWrap.logEvent("app_comment_go");
        }

      }, _defineProperty(_class3, "windowPath", "Sys/NewAppCommentWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "btnOk", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ScrollViewItem.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Button, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Button = module.Button;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "2f1b0viGr9CV40tBu2czXON", "ScrollViewItem", undefined);

      var hasTouchInScrollViewClass = [Button, "EventListener"]; //作为scrollViewTool 元件上添加的脚本

      const {
        ccclass,
        property
      } = _decorator;
      let ScrollViewItem = exports('default', ccclass(_class = (_class2 = (_temp = class ScrollViewItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "index", _descriptor, this);

          _initializerDefineProperty(this, "id", _descriptor2, this);

          _defineProperty(this, "initFunc", void 0);

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "scrollViewTool", void 0);

          _defineProperty(this, "noLazy", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          hasTouchInScrollViewClass.forEach(c => {
            this.getComponentsInChildren(c).forEach(x => {
              x.inScrollView = true;
            });
          });
          this.slowUpdate(0);
        }

        registerInit(func) {
          this.initFunc = func;
        }

        slowUpdate(dt) {
          if (!this.inited && this.scrollViewTool) {
            if (this.id === null || this.id === undefined) {
              this.node.active = false;
              this.inited = true;
              return;
            }

            if (this.noLazy || this.scrollViewTool.isItemInView(this.index)) {
              this.inited = true;
              if (this.initFunc) this.initFunc(this.index, this.id, this.node);
            }
          }
        }

        setData(index, id) {
          this.index = index;
          this.id = id;
          this.inited = false;
          if (this.id !== null && this.id !== undefined) this.node.active = true;
        }

        refresh() {
          this.inited = false;
          if (this.id !== null && this.id !== undefined) this.node.active = true;
          this.slowUpdate(0);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "index", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "id", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopCoinItem.ts", ['cc', './CCE_Component.ts', './SoundManager.ts', './LocalizedManager.ts', './PaySuccessWindow.ts', './MultiplePurchaseWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, Node, Prefab, _decorator, instantiate, CCE_Component, SoundManager, rigisterLabel, PaySuccessWindow, MultiplePurchaseWindow, UIRoot, Game, LogEventWrap, PaymentWrap, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      Node = module.Node;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      MultiplePurchaseWindow = module.MultiplePurchaseWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "30108N4znFNNbQKRD1/Hxxr", "ShopCoinItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopCoinItem = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Label), _dec8 = property(Prefab), ccclass(_class = (_class2 = (_temp = class ShopCoinItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "coinIcon", _descriptor, this);

          _initializerDefineProperty(this, "coinNum", _descriptor2, this);

          _initializerDefineProperty(this, "coinExtra", _descriptor3, this);

          _initializerDefineProperty(this, "coinPrice", _descriptor4, this);

          _initializerDefineProperty(this, "hot", _descriptor5, this);

          _initializerDefineProperty(this, "bestValue", _descriptor6, this);

          _initializerDefineProperty(this, "oldText", _descriptor7, this);

          _initializerDefineProperty(this, "star", _descriptor8, this);

          _defineProperty(this, "meta", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        updatePanel(meta, index, icon, oldMeta, isRefresh) {
          this.meta = meta;
          let num = meta.Count();
          let numAdd = Math.round(meta.Off() * 100);
          let price = meta.PriceString();

          if (!isRefresh) {
            const starnum = Math.random() < 0.5 ? 1 : 2;

            for (let i = 0; i < starnum; i++) {
              const newStar = instantiate(this.star);
              this.coinIcon.node.addChild(newStar);

              const _x = Math.random() * 100 - 50;

              const _y = Math.random() * 120 - 60;

              newStar.setPosition(_x, _y);
            }
          } // this.coinIcon.node.once(cc.SystemEventType.SIZE_CHANGED, () => {
          // }, this);


          this.coinIcon.spriteFrame = icon;
          this.coinNum.string = BigNumber.format(num); //GameKit.StringUtil.formatNumber(num);

          if (numAdd <= 0) {
            this.coinExtra.node.parent.active = false;
            this.coinExtra.string = "";
          } else {
            this.coinExtra.string = String.format(i18n.t("ShopAddPercent"), numAdd);
            rigisterLabel("ShopAddPercent", this.coinExtra, numAdd);
          }

          if (meta.OnSale()) {
            this.coinExtra.node.active = true;
          } else {
            this.coinExtra.node.active = false;
          }

          if (index == 2) {
            this.hot.active = true;
            this.bestValue.active = false;
          } else if (index == 5) {
            this.hot.active = false;
            this.bestValue.active = true;
          } else {
            this.hot.active = false;
            this.bestValue.active = false;
          }

          this.oldText.node.active = false;

          if (oldMeta != meta) {
            this.oldText.node.active = true;
            let oldNum = oldMeta.Count();
            this.oldText.string = GameKit.StringUtil.formatNumber(oldNum);
          } else if (meta.OriginalCount() > 0) {
            this.oldText.node.active = true;
            this.oldText.string = meta.OriginalCount().toString();
          }

          this.coinPrice.string = price;
        }

        onBuy() {
          PaymentWrap.Pay(this.meta.Name(), ok => {
            if (ok) {
              let oldCoin = Game.SUser.Coin();
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "coin",
                showCallback: wnd => {
                  wnd.addOnCloseFunc(() => {
                    // UIRoot.instance.closeChildWindow("ShopWindow");
                    if (MultiplePurchaseWindow.OpenMulti()) UIRoot.instance.openChildWindow(MultiplePurchaseWindow, {
                      meta: this.meta
                    });
                  });
                }
              });
              SoundManager.playSound("item_purchased");
              /*if (GameMainWindow.instance) {
              	GameMainWindow.instance.userinfo.changeCoin(oldCoin, oldCoin, 0)
              	GameMainWindow.instance.playAddCoinAnim()
              	GameMainWindow.instance.scheduleOnce(() => {
              		GameMainWindow.instance.userinfo.changeCoin(oldCoin, Game.SUser.Coin(), 0.8)
              	}, 1)
              }*/

              LogEventWrap.logEvent("ShopDetail", {
                itemType: "coin",
                name: this.meta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "coin",
                name: this.meta.Name(),
                phase: -1
              });
            }
          });
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "coin",
            name: this.meta.Name(),
            phase: 0
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "coinIcon", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "coinNum", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "coinExtra", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "coinPrice", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "hot", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "bestValue", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "oldText", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "star", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopShieldItem.ts", ['cc', './CCE_Component.ts', './SoundManager.ts', './PaySuccessWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, _decorator, CCE_Component, SoundManager, PaySuccessWindow, UIRoot, Meta, LogEventWrap, PaymentWrap;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "30fd0NjY7FMF7xSFT5KbBBz", "ShopShieldItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopShieldItem = exports('ShopShieldItem', (_dec = ccclass("ShopShieldItem"), _dec2 = property(Sprite), _dec3 = property(Label), _dec4 = property(Label), _dec(_class = (_class2 = (_temp = class ShopShieldItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "icon", _descriptor, this);

          _initializerDefineProperty(this, "duration", _descriptor2, this);

          _initializerDefineProperty(this, "shieldPrice", _descriptor3, this);

          _defineProperty(this, "_index", 0);
        }

        updatePanel(meta, index, icon) {
          this._index = index;

          const duration = this._getDurations(parseInt(meta._data.count.split("=")[2]));

          this.duration.string = parseInt(duration) <= 1 ? duration + "day" : duration + "days";
          this.shieldPrice.string = meta.PriceString();
          this.icon.spriteFrame = icon;
        }

        onBuy() {
          let shopId = 1200 + this._index;
          let shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, shopId.toString());
          PaymentWrap.Pay(shopMeta.Name(), ok => {
            if (ok) {
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "shield",
                showCallback: wnd => {
                  wnd.addOnCloseFunc(() => {// UIRoot.instance.closeChildWindow("ShopWindow");
                  });
                }
              });
              SoundManager.playSound("item_purchased");
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "shield",
                name: shopMeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "shield",
                name: shopMeta.Name(),
                phase: -1
              });
            }
          });
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "shield",
            name: shopMeta.Name(),
            phase: 0
          });
        }

        _getDurations(seconds) {
          if (seconds >= 24 * 60 * 60) {
            return Math.floor(seconds / (24 * 60 * 60)).toString();
          } else {
            return (seconds / (24 * 60 * 60)).toFixed(1);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "icon", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "duration", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "shieldPrice", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SpriteGray.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, Sprite, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
      Sprite = module.Sprite;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "318f6y1jjlKgbD4gM7x67m0", "SpriteGray", undefined);

      const {
        ccclass,
        property,
        requireComponent,
        executeInEditMode
      } = _decorator;
      let SpriteGray = exports('default', (_dec = requireComponent(Label), ccclass(_class = executeInEditMode(_class = _dec(_class = (_class2 = (_temp = class SpriteGray extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "_gray", _descriptor, this);
        }

        set gray(value) {
          this._gray = value;
          this.onLoad();
        }

        get gray() {
          return this._gray;
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          if (this.getComponent(Sprite) == null) return;
          let st = this.gray ? 1 : 0; //NEWTODO
          // this.getComponent(cc.Sprite).setMaterial(st);
        } // start () {},


        static SetGray(sprite, gray) {
          if (!sprite || !sprite.node) return;
          var sg = sprite.node.getComponent(SpriteGray);

          if (sg == null) {
            sg = sprite.node.addComponent(SpriteGray);
          }

          sg.gray = gray;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "_gray", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "gray", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "gray"), _class2.prototype)), _class2)) || _class) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/JigsawNewsWindow.ts", ['cc', './Logs.ts', './_app.ts', './UIWindow.ts', './UserInfoModel.ts', './ScrollViewTool.ts', './JigsawWindow.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Sprite, RichText, Label, SpriteFrame, Logs, cce, UIWindow, UserInfoModel, ScrollViewTool, JigsawWindow, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      RichText = module.RichText;
      Label = module.Label;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      JigsawWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "33827dI2vdMCaNOsDkoD2/T", "JigsawNewsWindow", undefined);
      /** @author fengyong-2-27 */


      const {
        ccclass,
        property
      } = _decorator;
      let JigsawNewsWindow = exports('default', (_dec = property(Node), _dec2 = property(ScrollViewTool), ccclass(_class = (_class2 = (_temp = _class3 = class JigsawNewsWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "no_news", _descriptor, this);

          _initializerDefineProperty(this, "svt", _descriptor2, this);
        }

        onShow(showParams) {
          this.no_news.active = showParams.msg_list.length === 0;
          this.update_page(showParams.msg_list);
        }

        onClose() {
          for (let index in this.svt.items) {
            let sp_piece = GameKit.ControllerTable.GetComponent(this.svt.items[index], "sp-piece", Sprite);
            cce.releaseSpriteFrame(sp_piece);
          }
        }
        /** @type {ScrollViewTool} */


        update_page(msg_list) {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();
          let id_list = [];

          for (let i = 0; i < msg_list.length; i++) {
            id_list.push(i + 1);
          }

          this.svt.setItem(id_list, (index, id, node) => {
            let userinfo = GameKit.ControllerTable.GetNode(node, "userinfo").getComponent(UserInfoModel);
            let text_news = GameKit.ControllerTable.GetNode(node, "news").getComponent(RichText);
            let sp_piece = GameKit.ControllerTable.GetNode(node, "sp-piece").getComponent(Sprite);
            let text_time = GameKit.ControllerTable.GetNode(node, "text-time").getComponent(Label);
            let msg = msg_list[index];
            userinfo.show(Game.SUser.FriendsList()[msg.userId]);
            let userName = Game.SUser.FriendsList()[msg.userId] ? Game.SUser.FriendsList()[msg.userId].Name() : i18n.t("PlayerDefaultName");
            text_news.string = msg.type === "send" ? String.format(i18n.t("jigsaw_news_window_news_send"), userName, msg.index + 1) : String.format(i18n.t("jigsaw_news_window_news_collect"), userName, msg.index + 1);

            if (metaparam.jigsawSetPath.startsWith("http")) {
              let resName = `${metaparam.jigsawSetPath}/${msg.index}.png`;
              cce.loaderLoad({
                url: resName,
                type: "png"
              }, function (err, v) {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!sp_piece || !sp_piece.node) return;
                let sp = new SpriteFrame();
                sp.texture = v;
                sp_piece.spriteFrame = sp;
              }.bind(this));
            } else {
              let resName = `${JigsawWindow.res_path}${metaparam.jigsawSetPath}/${msg.index}`;
              cce.loadRes(resName, SpriteFrame, (err, res) => {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!sp_piece || !sp_piece.node) return;
                sp_piece.spriteFrame = res;
              });
            }

            text_time.string = GameKit.TimeUtil.FormatPastTime(GameKit.TimeUtil.getCurrentTime() - msg.time, true);
          });
        }

        event_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Activity/Jigsaw/JigsawNewsWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "no_news", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DebugScript.ts", ['cc', './Constant.ts', './_app.ts', './TouchTest.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, director, Node, setDisplayStats, MyCustomEvent, cce, TouchTest;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      director = module.director;
      Node = module.Node;
      setDisplayStats = module.setDisplayStats;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      TouchTest = module.default;
    }],
    execute: function () {
      var _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "33f87rpb49GnpazsxwoDqdw", "DebugScript", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let DebugScript = exports('default', ccclass(_class = (_temp = class DebugScript extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "lastDebugClickTime", 0);

          _defineProperty(this, "debugClickCount", 0);
        }

        onLoad() {
          director.getScene().getChildByName("Canvas").on(Node.EventType.TOUCH_END, event => {
            if (TouchTest.isTouchInRect(event, this.node)) {
              this.onTapped(event);
            }
          }, this, true);
        }

        onTapped(event) {
          const now = Date.now();

          if (this.lastDebugClickTime === 0 || now - this.lastDebugClickTime < 200) {
            this.debugClickCount += 1;

            if (now - this.lastDebugClickTime < 200) {
              event.propagationStopped = true;
            }
          } else {
            this.debugClickCount = 1;
          }

          this.lastDebugClickTime = now;

          if (this.debugClickCount >= 5) {
            this.debugClickCount = 0;
            appGame.isDev = !appGame.isDev;
            const context = `Dev: ${appGame.isDev}`;
            cce.showToast(context);
            setDisplayStats(appGame.isDev);
            eventCenter.emit(MyCustomEvent.SwitchDebug, appGame.isDev);
          }
        }

      }, _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UITabNode.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "343abSkkUdKz4uOZoeEqyBy", "UITabNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let UITabNode = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class UITabNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "enabledNode", _descriptor, this);

          _initializerDefineProperty(this, "disabledNode", _descriptor2, this);

          _defineProperty(this, "index", void 0);

          _defineProperty(this, "node", void 0);
        }

        start() {}

        enable() {
          this.enabledNode.active = true;
          this.disabledNode.active = false;
        }

        disable() {
          this.enabledNode.active = false;
          this.disabledNode.active = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "enabledNode", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "disabledNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopTreatItem.ts", ['cc', './CCE_Component.ts', './global.ts', './SoundManager.ts', './ShopMeta.ts', './PaySuccessWindow.ts', './MultiplePurchaseWindow.ts', './UIRoot.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, Node, Prefab, _decorator, instantiate, SystemEventType, CCE_Component, G, SoundManager, ShopMeta, PaySuccessWindow, MultiplePurchaseWindow, UIRoot, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      Node = module.Node;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      SystemEventType = module.SystemEventType;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ShopMeta = module.ShopMeta;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      MultiplePurchaseWindow = module.MultiplePurchaseWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "34e5amhg5ZDU5MSbXx5QeeA", "ShopTreatItem", undefined);

      const TypeTreatFoodItemId = 3;
      const {
        ccclass,
        property
      } = _decorator;
      let ShopTreatItem = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Prefab), ccclass(_class = (_class2 = (_temp = class ShopTreatItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spIcon", _descriptor, this);

          _initializerDefineProperty(this, "labelNum", _descriptor2, this);

          _initializerDefineProperty(this, "labelDuration", _descriptor3, this);

          _initializerDefineProperty(this, "labelPrice", _descriptor4, this);

          _initializerDefineProperty(this, "hot", _descriptor5, this);

          _initializerDefineProperty(this, "bestValue", _descriptor6, this);

          _initializerDefineProperty(this, "star", _descriptor7, this);

          _defineProperty(this, "meta", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        updatePanel(meta, index, icon, oldMeta) {
          this.meta = meta;
          let num = meta.Count();
          let numAdd = Math.round(meta.Off() * 100);
          let price = meta.PriceString();
          let content = meta.Content();
          const strtNum = Math.random() < 0.5 ? 1 : 2;

          for (let i = 0; i < strtNum; i++) {
            const newStar = instantiate(this.star);
            this.spIcon.node.addChild(newStar);

            const _x = Math.random() * 100 - 50;

            const _y = Math.random() * 120 - 60;

            newStar.setPosition(_x, _y);
          }

          this.spIcon.node.once(SystemEventType.SIZE_CHANGED, () => {}, this);
          this.spIcon.spriteFrame = icon;

          if (index === 3 && meta.Type() === ShopMeta.Types.Xp) {
            this.labelNum.string = "x" + GameKit.StringUtil.formatNumber(num);
          } else {
            this.labelNum.string = GameKit.StringUtil.formatNumber(num);
          }

          this.labelDuration.node.active = false;

          if (content.Id() == TypeTreatFoodItemId) {
            this.labelDuration.node.active = true;
            this.labelDuration.string = String.format(i18n.t("ShopTreatFoodTime"), Math.round(G.GameConstance.servantFoodTime * content.Count() / 3600));
          }

          this.hot && (this.hot.active = false);
          this.bestValue && (this.bestValue.active = false);
          this.labelPrice.string = price;
        }

        onBuy() {
          PaymentWrap.Pay(this.meta.Name(), ok => {
            if (ok) {
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "treat",
                showCallback: wnd => {
                  wnd.addOnCloseFunc(() => {
                    // UIRoot.instance.closeChildWindow("ShopWindow");
                    if (MultiplePurchaseWindow.OpenMulti()) UIRoot.instance.openChildWindow(MultiplePurchaseWindow, {
                      meta: this.meta
                    });
                  });
                }
              });
              SoundManager.playSound("item_purchased");
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "treat",
                name: this.meta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "treat",
                name: this.meta.Name(),
                phase: -1
              });
            }
          });
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "treat",
            name: this.meta.Name(),
            phase: 0
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelNum", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelDuration", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelPrice", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "hot", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "bestValue", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "star", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TouchTest.ts", ['cc'], function (exports) {
  'use strict';

  var Vec3, UITransform, cclegacy;
  return {
    setters: [function (module) {
      Vec3 = module.Vec3;
      UITransform = module.UITransform;
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "34e9fZ3QrVEXZOdSfd6tUgA", "TouchTest", undefined);

      class TouchTest {
        static isTouchInRect(event, testNode) {
          let testNodeWorldPos = new Vec3();
          testNode.getWorldPosition(testNodeWorldPos);
          let testNodeSize = testNode.getComponent(UITransform).contentSize;
          const touchUIPoint = event.getUILocation();

          if (touchUIPoint.x >= testNodeWorldPos.x - testNodeSize.width / 2 && touchUIPoint.x <= testNodeWorldPos.x + testNodeSize.width / 2 && touchUIPoint.y >= testNodeWorldPos.y - testNodeSize.height / 2 && touchUIPoint.y <= testNodeWorldPos.y + testNodeSize.height / 2) {
            return true;
          }

          return false;
        }

      }

      exports('default', TouchTest);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AppMain.ts", ['cc', './wx_lib.ts', './_app.ts', './SoundManager.ts', './User.ts', './DialogWindow.ts', './AppGame.ts', './SettingWindow.ts', './SdkManager.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './NewTutorialManager.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, _decorator, Component, view, ResolutionPolicy, game, director, sys, wxTools, SoundManager, User, DialogWindow, AppGame, SettingWindow, SdkManager, UIRoot, Game, LogEventWrap, GameKit, i18n, NewTutorialManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      Component = module.Component;
      view = module.view;
      ResolutionPolicy = module.ResolutionPolicy;
      game = module.game;
      director = module.director;
      sys = module.sys;
    }, function (module) {
      wxTools = module.wxTools;
    }, function () {}, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      User = module.User;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      SettingWindow = module.SettingWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      NewTutorialManager = module.NewTutorialManager;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "3506aGqpHpLFIxTG0zp6eub", "AppMain", undefined); // dynamicAtlasManager.enabled = true;


      const {
        ccclass,
        property
      } = _decorator;
      let AppMain = exports('AppMain', (_dec = ccclass("AppMain"), _dec2 = property([SpriteFrame]), _dec(_class = (_class2 = (_temp = _class3 = class AppMain extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spriteLoad", _descriptor, this);

          _defineProperty(this, "lastErrorLog", {});

          _defineProperty(this, "HasError", false);

          _defineProperty(this, "statusBarHeight", 0);

          _defineProperty(this, "tutorialManager", void 0);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          let ssize = view.getVisibleSize();

          if (ssize.height < 1136) {
            view.setResolutionPolicy(ResolutionPolicy.FIXED_HEIGHT);
            view.setDesignResolutionSize(640, 1136, ResolutionPolicy.FIXED_HEIGHT);
          }

          if (AppMain.inited) return;
          AppMain.instance = this;
          game.addPersistRootNode(this.node);
          Game.SUser = new User();
          this.tutorialManager = new NewTutorialManager(); ///TODO
          // new window["VConsole"]();
          // //输出等级
          // Logs.m_Level = Logs.Level.Log;
          // //是否输出debug消息
          // Logs.enableDebug = false;
          //脚本错误时 重新登陆

          if (!CC_DEBUG) {
            if (wxTools.usewx) {
              wx.onError(res => {
                if (!this.HasError) {
                  console.log("~~## ERROR ##~~", "onerror", Game.SUser != null ? Game.SUser.UserId() : "", res.message, res.stack);
                  this.logerror({
                    msg: JSON.stringify(res.message),
                    url: res.stack,
                    line: ""
                  });
                  UIRoot.instance.openChildWindow(DialogWindow, {
                    msg: i18n.t("ErrorNormal"),
                    confirmFunc: () => {
                      AppGame.instance.logout();
                    }
                  });
                  this.HasError = true;
                }
              });
            } else if (SdkManager.IsNative()) {
              window["__errorHandler"] = (url, line, msg, stack) => {
                if (!this.HasError) {
                  if (msg && msg.contains && msg.contains("fullscreen")) return;
                  console.log("~~## ERROR ##~~", "onerror", Game.SUser != null ? Game.SUser.UserId() : "", msg, url, line);
                  this.logerror({
                    msg: JSON.stringify(msg),
                    url: url,
                    line: line,
                    stack: stack
                  });

                  if (!url || !url.contains("cocos2d")) {
                    UIRoot.instance.openChildWindow(DialogWindow, {
                      msg: i18n.t("ErrorNormal"),
                      confirmFunc: function () {
                        AppGame.instance.logout();
                      }
                    });
                  }

                  this.HasError = true;
                }
              };
            } else {
              window.onerror = (msg, url, line) => {
                if (!this.HasError) {
                  if (msg && msg.contains && msg.contains("fullscreen")) return true;
                  console.log("~~## ERROR ##~~", "onerror", Game.SUser != null ? Game.SUser.UserId() : "", msg, url, line);
                  this.logerror({
                    msg: JSON.stringify(msg),
                    url: url,
                    line: line
                  });
                  UIRoot.instance.openChildWindow(DialogWindow, {
                    msg: i18n.t("ErrorNormal"),
                    confirmFunc: function () {
                      AppGame.instance.logout();
                    }
                  });
                  this.HasError = true;
                }

                return true;
              };

              window.onunhandledrejection = event => {
                console.log(event);
                let reason = event.reason || {};
                let [msg, url, line] = [reason.stack || reason.message || "", "", 0];

                if (!this.HasError) {
                  if (msg && msg.contains && msg.contains("fullscreen")) return true;
                  console.log("~~## ERROR ##~~", "onerror unhandledrejection", Game.SUser != null ? Game.SUser.UserId() : "", msg, url, line);
                  this.logerror({
                    msg: JSON.stringify(msg),
                    url: url,
                    line: line
                  });
                  UIRoot.instance.openChildWindow(DialogWindow, {
                    msg: i18n.t("ErrorNormal"),
                    confirmFunc: function () {
                      AppGame.instance.logout();
                    }
                  });
                  this.HasError = true;
                }

                return true;
              };
            }
          } //关闭抗锯齿
          //view.enableAntiAlias(false)
          //调试信息
          //TODO
          // if (debug != null) debug.setDisplayStats(false)
          // G.deviceId = GameKit.PlayerPrefs.GetString("deviceId", "unknown");
          // AppKit.NativeWrap.call("SDKHandleClass", "GetDeviceId", null, function (info) {
          // 	G.deviceId = info.deviceId || "unknown";
          // 	GameKit.PlayerPrefs.SetString("deviceId", info.deviceId);
          // });
          // if (JSB) {
          // 	jsb.reflection.callStaticMethod("com/cocos/game/AppActivity", "showAlertDialog", "(Ljava/lang/String;Ljava/lang/String;)V", "title", "hahahahha");
          // }
          //ios 30帧


          if (SdkManager.IsNative() && SdkManager.IsIos()) {
            let sw_lb = SettingWindow.getLowBatterySwitch();
            if (sw_lb) game.setFrameRate(30);
          } //刘海屏适配


          const winSize = director.getWinSize();
          const safeArea = sys.getSafeAreaRect();

          if (winSize.height - safeArea.height - safeArea.y > 0) {
            this.statusBarHeight = Math.max(winSize.height - safeArea.height - safeArea.y - 30, 44);
          } else {
            this.statusBarHeight = 0;
          }
        }

        logerror(msg) {// if (this.lastErrorLog.msg === msg.msg.toString() && this.lastErrorLog.url === msg.url.toString() && this.lastErrorLog.line === msg.line.toString()) return;
          // if (wxTools.usewx) {
          // 	const isTestServer = !!parseInt(sys.localStorage.getItem("isTestServer"));
          // 	let req = new NetRequest(isTestServer ? G.GameConfig.testServer : G.GameConfig.formalServer + "/logerror");
          // 	req.SetSilence(true);
          // 	req.SetRequestBody("userId", Game.SUser.UserId());
          // 	req.SetRequestBody("msg", msg.msg.toString());
          // 	req.SetRequestBody("url", msg.url.toString());
          // 	req.SetRequestBody("line", msg.line.toString());
          // 	req.Send();
          // }
          // AppKit.LogEventWrap.logEvent("logerror", {
          // 	msg: (msg.msg || "").toString(),
          // 	url: (msg.url || "").toString(),
          // 	line: (msg.line || "").toString(),
          // 	stack: (msg.stack || "").toString(),
          // });
          // this.lastErrorLog.msg = msg.msg.toString();
          // this.lastErrorLog.url = msg.url.toString();
          // this.lastErrorLog.line = msg.line.toString();
        }

        start() {
          if (AppMain.inited) return;
          AppMain.inited = true;
          LogEventWrap.logEvent("app_start");
          SoundManager.init();
          GameKit.BackKeyManager.init(); //TODO
          // Object.keys(loader["_cache"].forEach(x=>cce.DepList[x] = 1));

          AppGame.instance.logout();
        }

        onDestroy() {}

        static RestartApp() {
          sys.localStorage.setItem("lastRestartTime", Date.now().toString());
          AppMain.inited = false;
          ccAudioEngine.stopAll(); // setTimeout

          clearTimeout();
          clearInterval(); // loader.clear();

          game.restart();
        }

      }, _defineProperty(_class3, "instance", null), _defineProperty(_class3, "inited", false), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "spriteLoad", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class2)) || _class));
      Reflect.defineProperty(globalThis, "AppMain", {
        value: AppMain
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PackItemMeta.ts", ['cc', './Content.ts'], function (exports) {
  'use strict';

  var cclegacy, Content;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "3512dwtouJCM5RWHTNzESpU", "PackItemMeta", undefined);

      class PackItemMeta {
        constructor() {
          _defineProperty(this, "_data", {});

          _defineProperty(this, "contents", void 0);
        }

        static MakeEntity(data) {
          let meta = new PackItemMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        Name() {
          return this._data.name;
        }

        Items() {
          let is = this._data.items;
          let iss = is.split(";");
          return iss;
        }

        Contents() {
          if (!this.contents) {
            let iss = this.Items();
            this.contents = [];
            iss.forEach(x => {
              this.contents.push(Content.FromString(x));
            });
          }

          return this.contents;
        }

      }

      exports('PackItemMeta', PackItemMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRActivityBlackJack.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRActivityBlackJack', void 0);

      cclegacy._RF.push({}, "3669fVWt+JFVrb2WsQSL6gU", "SRActivityBlackJack", undefined);

      let SRActivityBlackJack;

      (function (_SRActivityBlackJack) {
        let rpei = null; //起始奖励

        function activityBlackjackStartReward(activityId) {
          let req = new GameKit.ServerRequest("activityBlackjackStartReward");
          req.SetRequestBody("activityId", activityId);
          req.SetCallBack(function (res) {
            GameKit.DataCache.SetData("Raid_Protect", GameKit.TimeUtil.getCurrentTime() + 180);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.RaidProtectEvent);

            if (rpei) {
              clearTimeout(rpei);
              rpei = null;
            }

            rpei = setTimeout(() => {
              GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.RaidProtectEvent);
            }, 181000);
          });
          return req;
        }

        _SRActivityBlackJack.activityBlackjackStartReward = activityBlackjackStartReward;

        function activityBlackjackPlay(activityId, bet) {
          let req = new GameKit.ServerRequest("activityBlackjackPlay");
          req.SetRequestBody("activityId", activityId);
          req.SetRequestBody("bet", bet);
          req.SetCallBack(function (res) {
            GameKit.DataCache.SetData("Raid_Protect", GameKit.TimeUtil.getCurrentTime() + 180);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.RaidProtectEvent);

            if (rpei) {
              clearTimeout(rpei);
              rpei = null;
            }

            rpei = setTimeout(() => {
              GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.RaidProtectEvent);
            }, 181000);
          });
          return req;
        }

        _SRActivityBlackJack.activityBlackjackPlay = activityBlackjackPlay;

        function activityBlackjackDoEnd(num1, num2) {
          let req = new GameKit.ServerRequest("activityBlackjackDoEnd");
          req.SetRequestBody("num1", num1);
          req.SetRequestBody("num2", num2);
          req.SetCallBack(function (res) {
            GameKit.DataCache.SetData("Raid_Protect", GameKit.TimeUtil.getCurrentTime() + 180);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.RaidProtectEvent);

            if (rpei) {
              clearTimeout(rpei);
              rpei = null;
            }

            rpei = setTimeout(() => {
              GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.RaidProtectEvent);
            }, 181000);
          });
          return req;
        }

        _SRActivityBlackJack.activityBlackjackDoEnd = activityBlackjackDoEnd;

        function activityBlackjackWatchWin() {
          let req = new GameKit.ServerRequest("activityBlackjackWatchWin");
          return req;
        }

        _SRActivityBlackJack.activityBlackjackWatchWin = activityBlackjackWatchWin;

        function activityBlackjackWatchLose() {
          let req = new GameKit.ServerRequest("activityBlackjackWatchLose");
          return req;
        }

        _SRActivityBlackJack.activityBlackjackWatchLose = activityBlackjackWatchLose;
      })(SRActivityBlackJack || (SRActivityBlackJack = exports('SRActivityBlackJack', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DialogWindow.ts", ['cc', './SoundManager.ts', './PlayAudio.ts', './UIWindow.ts', './UIRoot.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, LabelOutline, Button, color, SoundManager, PlayAudio, UIWindow, UIRoot, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
      LabelOutline = module.LabelOutline;
      Button = module.Button;
      color = module.color;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      PlayAudio = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "3784a8YXs9Kh5XYu11IIcQN", "DialogWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let DialogWindow = exports('DialogWindow', (_dec = property(Label), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Label), _dec5 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class DialogWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelMsg", _descriptor, this);

          _initializerDefineProperty(this, "btnConfirm", _descriptor2, this);

          _initializerDefineProperty(this, "btnCancel", _descriptor3, this);

          _initializerDefineProperty(this, "labelConfirm", _descriptor4, this);

          _initializerDefineProperty(this, "labelCancel", _descriptor5, this);

          _defineProperty(this, "confirmFunc", void 0);

          _defineProperty(this, "cancelFunc", void 0);

          _defineProperty(this, "confirmStr", void 0);

          _defineProperty(this, "cancelStr", void 0);

          _defineProperty(this, "countDown", void 0);

          _defineProperty(this, "inCountDown", void 0);

          _defineProperty(this, "oldConfirmStr", void 0);

          _defineProperty(this, "oldConfirmOutline", void 0);
        }

        static Show(msg, conc, canc, confirmStr = null, cancelStr = null) {
          UIRoot.instance.openChildWindow(DialogWindow, {
            msg: msg,
            confirmFunc: conc,
            cancelFunc: canc,
            confirmStr: confirmStr,
            cancelStr: cancelStr
          });
        }

        onShow(showParams) {
          this.labelMsg.string = showParams.msg || "";
          this.confirmFunc = showParams.confirmFunc;
          this.cancelFunc = showParams.cancelFunc;
          this.confirmStr = showParams.confirmStr;
          this.cancelStr = showParams.cancelStr;
          this.countDown = showParams.countDown;

          if (this.cancelFunc == null) {
            this.btnCancel.active = false;
            this.btnConfirm.x = 0;
          }

          this.labelConfirm.string = i18n.t("YES");

          if (this.confirmStr) {
            this.labelConfirm.string = this.confirmStr;
          }

          this.labelCancel.string = i18n.t("NO");

          if (this.cancelStr) {
            this.labelCancel.string = this.cancelStr;
          }

          if (this.countDown) {
            this.inCountDown = this.countDown;
            this.oldConfirmStr = this.labelConfirm.string;
            let outlineConfirm = this.labelConfirm.getComponent(LabelOutline);
            this.oldConfirmOutline = outlineConfirm.color;
            this.btnConfirm.getComponent(Button).interactable = false;
            this.labelConfirm.string = this.inCountDown.toString();
            outlineConfirm.color = color(100, 100, 100);
            this.schedule(() => {
              this.inCountDown--;
              this.labelConfirm.string = this.inCountDown.toString();

              if (this.inCountDown == 0) {
                this.labelConfirm.string = this.oldConfirmStr;
                this.oldConfirmStr = null;
                this.btnConfirm.getComponent(Button).interactable = true;
                outlineConfirm.color = this.oldConfirmOutline;
              }
            }, 1, this.inCountDown - 1);
          }

          GameKit.BackKeyManager.registerBackEvent(() => {
            if (this.inCountDown) return;
            PlayAudio.playClose();
            if (this.cancelFunc == null) this.onConfirm();else this.onCancel();
          });
          SoundManager.playSound("se_open");
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        onConfirm() {
          if (this.confirmFunc != null) {
            this.confirmFunc();
          }

          this.close();
        }

        onCancel() {
          if (this.cancelFunc != null) {
            this.cancelFunc();
          }

          this.close();
        }

      }, _defineProperty(_class3, "windowPath", "Common/DialogWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelMsg", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnConfirm", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btnCancel", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelConfirm", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelCancel", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NewTutorialManager.ts", ['cc', './Constant.ts', './global.ts', './_app.ts', './DialogWindow.ts', './RoomManager.ts', './GameMainWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts', './NewTutorilaWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, Vec3, sys, Prefab, instantiate, Camera, VersionScheme, TutorilaEvent, CameraLayers, SlotTypes, G, cce, DialogWindow, RoomManager, GameMainWindow, SR, UIRoot, Game, GameKit, i18n, NewTutorialWindow;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Vec3 = module.Vec3;
      sys = module.sys;
      Prefab = module.Prefab;
      instantiate = module.instantiate;
      Camera = module.Camera;
    }, function (module) {
      VersionScheme = module.VersionScheme;
      TutorilaEvent = module.TutorilaEvent;
      CameraLayers = module.CameraLayers;
      SlotTypes = module.SlotTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      NewTutorialWindow = module.NewTutorialWindow;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "38675dnzUhIMrl0uZ1ste4p", "NewTutorialManager", undefined);

      let arrowLocalPos = new Vec3();

      class NewTutorialManager {
        constructor() {
          _defineProperty(this, "_finished", false);

          _defineProperty(this, "finishCallback", void 0);

          _defineProperty(this, "tutorialInited", false);

          _defineProperty(this, "tutorialFinishedId", 1000130);

          _defineProperty(this, "groupId", 100);

          _defineProperty(this, "curTutorialIndex", 0);

          _defineProperty(this, "tutorialWindow", void 0);

          _defineProperty(this, "_initedAp", false);

          _defineProperty(this, "boxIndex", 0);
        }

        get isTutorilaFinished() {
          return this._finished;
        }

        SetFinishCallback(cb) {
          this.finishCallback = cb;
        }

        setTutorialData() {
          sys.localStorage.setItem(Game.SUser.Id() + "tutorialIndex", this.curTutorialIndex);
          sys.localStorage.setItem(Game.SUser.Id() + "tutorialCoin", Game.SUser.Coin());
          sys.localStorage.setItem(Game.SUser.Id() + "tutorialStar", Game.SUser.Star());
          sys.localStorage.setItem(Game.SUser.Id() + "tutorialShield", Game.SUser.Shield());
        }

        removeTutorialData() {
          sys.localStorage.removeItem(Game.SUser.Id() + "tutorialIndex");
          sys.localStorage.removeItem(Game.SUser.Id() + "tutorialCoin");
          sys.localStorage.removeItem(Game.SUser.Id() + "tutorialStar");
          sys.localStorage.removeItem(Game.SUser.Id() + "tutorialShield");
        }

        getTutorialIndex() {
          if (parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialIndex"))) {
            return parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialIndex"));
          } else {
            return Game.SUserTutorial.TutorialId(this.groupId);
          }
        }

        getTutorialCoin() {
          if (parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialCoin"))) {
            return parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialCoin"));
          } else {
            return 50000;
          }
        }

        initTutorial() {
          if (this.tutorialInited) return;
          this.tutorialInited = true;
          let skipTutorial = versionSchemeName === VersionScheme.review;
          this._finished = skipTutorial || Game.SUserTutorial.TutorialId(this.groupId) === this.tutorialFinishedId;
          this.curTutorialIndex = this.getTutorialIndex();
        }

        tutorialStart() {
          if (parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialCoin"))) {
            Game.SUser.setData("coin", this.getTutorialCoin());
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, null);
          }

          if (parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialStar"))) {
            GameMainWindow.instance.userinfo.labelStar.string = sys.localStorage.getItem(Game.SUser.Id() + "tutorialStar");
          }

          if (parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialShield"))) {
            Game.SUser.setData("shield", parseInt(sys.localStorage.getItem(Game.SUser.Id() + "tutorialShield")));
            GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.ShieldEvent, null);
          }

          UIRoot.instance.openChildWindow(NewTutorialWindow, {
            showCallback: tutorialWindow => {
              this.tutorialWindow = tutorialWindow;

              switch (this.curTutorialIndex) {
                case 1000001:
                  this.tutorialStep1();
                  break;

                case 1000002:
                  this.tutorialStep2();
                  break;

                case 1000003:
                  this.tutorialStep3();
                  break;

                default:
                  this.tutorialStepSpin();
                  break;
              }
            }
          });
        }

        tutorialFinish() {
          //homeView.showUI();
          this.tutorialWindow.finished();
          let req = SR.SRTutorial.finishStep(this.tutorialFinishedId);
          req.SetSilence(false);
          req.SetCallBack(() => {
            this._finished = true;
            this.finishCallback();
            this.removeTutorialData();
          });
          req.SetErrorCallBack(() => {
            this.curTutorialIndex -= 1;
            this.setTutorialData();
          });
          req.Send();
        }
        /**
         * setp1: 点击建造按钮，升级一个建筑，建筑升级完成后，进入下一步
         */


        tutorialStep1() {
          eventCenter.once(TutorilaEvent.BuildStarted, () => {
            this.tutorialWindow.modelNode = false;
            this.tutorialWindow.titleNode = false;
            this.tutorialWindow._targetNode = null;
            this.tutorialWindow.enableBlockEvent = true;
            this.tutorialWindow.hideArrowOrHand();
          });
          eventCenter.once(TutorilaEvent.BuildFinished, () => {
            this.curTutorialIndex += 1;
            Game.SUserTutorial.SetTutorialId(this.groupId, this.curTutorialIndex);
            this.setTutorialData();
            this.tutorialStep2();
          }, this);
          const targetNode = homeView.villagePage.upgradeBtns.children[0];
          this.tutorialWindow.titleNode = true;
          this.tutorialWindow.modelNode = true;
          this.tutorialWindow.showTip(i18n.t("TutorialStartDes"));
          this.tutorialWindow.hideArrowOrHand();
          this.tutorialWindow.showHand(targetNode);
          this.tutorialWindow.stopEvent = true;
          this.tutorialWindow.enableBlockEvent = false;
          this.tutorialWindow.highLightTargetNode(targetNode);
        } // /** 
        //  * 显示星星提示
        // */


        tutorialStep2() {
          const targetNode = GameMainWindow.instance.labelStar.node.parent;
          this.tutorialWindow.node.inverseTransformPoint(arrowLocalPos, targetNode.getWorldPosition());
          this.tutorialWindow.showArrow(arrowLocalPos);
          this.tutorialWindow.showPerson();
          this.tutorialWindow.modelNode = true;
          this.tutorialWindow.stopEvent = false;
          this.tutorialWindow.enableBlockEvent = true;
          this.tutorialWindow.highLightTargetNode(targetNode);
          cce.loadRes("window/" + DialogWindow.windowPath, Prefab, (error, prefab) => {
            let dialogNode = instantiate(prefab);
            this.tutorialWindow.node.addChild(dialogNode);
            dialogNode.getComponent(DialogWindow).onShow({
              msg: i18n.t("TutorialDialogStar"),
              confirmFunc: () => {
                this.tutorialWindow.hideArrowOrHand();
                this.tutorialWindow.modelNode = false;
                this.tutorialWindow.stopEvent = true;
                this.tutorialWindow.enableBlockEvent = false; // this.tutorialWindow.hidePerson();

                dialogNode.active = false;
                dialogNode.destroy();
                this.curTutorialIndex += 1;
                Game.SUserTutorial.SetTutorialId(this.groupId, this.curTutorialIndex);
                this.setTutorialData();
                this.tutorialStep3();
              },
              confirmStr: "OK"
            });
          });
        } // /**
        //  *点击spin按钮，回到spin界面 
        //  */


        tutorialStep3() {
          eventCenter.once(TutorilaEvent.GoRoomStarted, () => {
            this.tutorialWindow.hideTip();
            this.tutorialWindow.hideArrowOrHand();
            this.tutorialWindow.modelNode = false;
            this.tutorialWindow.enableBlockEvent = true;
            this.tutorialWindow.hidePerson();
          });
          eventCenter.once(TutorilaEvent.GoRoomFinished, () => {
            homeView.pageViewController.iconSearch.layer = CameraLayers.UI2D;
            this.curTutorialIndex += 1;
            Game.SUserTutorial.SetTutorialId(this.groupId, this.curTutorialIndex);
            this.setTutorialData();
            this.tutorialStepSpin();
          });
          const targetNode = homeView.pageViewController.btns[2].node;
          homeView.pageViewController.iconSearch.layer = 1024;
          this.tutorialWindow.modelNode = true;
          this.tutorialWindow.showTip(i18n.t("TutorialDialogGoSpin"));
          this.tutorialWindow.stopEvent = true;
          this.tutorialWindow.enableBlockEvent = false;
          this.tutorialWindow.hideArrowOrHand();
          this.tutorialWindow.showHand(targetNode); // this.tutorialWindow.showPerson();

          this.tutorialWindow.highLightTargetNode(targetNode);
        } // /**
        //  * 第一次点击spin按钮，开始跑房间
        //  */


        tutorialStepSpin() {
          if (!this._initedAp) {
            if (this.getTutorialIndex() >= 1000004) {
              this._initedAp = true;
              homeView.pageViewController.moveToPage(G.Pages.Slot, true);
              let leftAp = 0;

              if (this.curTutorialIndex < 1000012) {
                leftAp = 1000012 - this.curTutorialIndex;
              } else {
                leftAp = 1000022 - this.curTutorialIndex;
              }

              Game.SUser.setData("ap", leftAp);
              homeView.pageViewController.setAp();
            }
          }

          eventCenter.once(TutorilaEvent.SpinFinished, () => {
            homeView.pageViewController.btnSpin.interactable = true;
            this.curTutorialIndex += 1;
            Game.SUserTutorial.SetTutorialId(this.groupId, this.curTutorialIndex);
            this.tutorialWindow.enableBlockEvent = true;
            this.setTutorialData();

            if (this.curTutorialIndex >= 1000022) {
              this.tutorialFinish();
            } else {
              this.tutorialStepSpin();
            }
          });
          eventCenter.once(TutorilaEvent.SpinStarted, () => {
            homeView.pageViewController.btnSpin.interactable = false;
            this.tutorialWindow.unhighLigtTargetNode();
            this.tutorialWindow.modelNode = false;
            this.tutorialWindow._targetNode = null;
            this.tutorialWindow.enableBlockEvent = true;
            this.tutorialWindow.hidePerson();
            this.tutorialWindow.hideTip();
            this.tutorialWindow.hideArrowOrHand();
          });
          const targetNode = homeView.pageViewController.btnSpin.node;
          this.tutorialWindow.modelNode = true;
          this.tutorialWindow.stopEvent = true;
          this.tutorialWindow.enableBlockEvent = false;
          this.tutorialWindow.showTip(i18n.t("TutorialDialogDoSpin"));
          this.tutorialWindow.highLightTargetNode(targetNode);
          this.tutorialWindow.showPerson();
          this.tutorialWindow.hideArrowOrHand();
          this.tutorialWindow.scheduleOnce(() => {
            this.tutorialWindow.hideArrowOrHand();
            this.tutorialWindow.showHand(targetNode);
          }, 0.05);
        } // /**
        //  * 获取护盾/attack/raid
        //  */


        tutorialStepItem(type) {
          return new Promise(resolve => {
            const targetNode = RoomManager.instance.curRoom.rewardNode;
            const mainCamera = homeView.slotPage.slot3dContainer.getComponentInChildren(Camera);

            switch (type) {
              case SlotTypes.Attack:
                this.tutorialWindow.showTip(i18n.t("TutorialDialogSlotAttack"));
                break;

              case SlotTypes.Shield:
                this.tutorialWindow.showTip(i18n.t("TutorialDialogSlotShield"));
                break;

              case SlotTypes.Raid:
                this.tutorialWindow.showTip(i18n.t("TutorialDialogSlotRaid"));
                break;
            }

            this.tutorialWindow.scheduleOnce(() => {
              mainCamera.convertToUINodeWithTexture(targetNode.getWorldPosition(), this.tutorialWindow.node, arrowLocalPos);
              arrowLocalPos.add(new Vec3(0, 150, 0));
              this.tutorialWindow.showArrow(arrowLocalPos, 180);
            }, 0.05);
            this.tutorialWindow.showPerson();
            this.tutorialWindow.stopEvent = false;
            this.tutorialWindow.enableBlockEvent = true;
            this.tutorialWindow.modelNode = true;
            this.tutorialWindow.highLight3DObject(targetNode);
            this.tutorialWindow._targetNode = this.tutorialWindow.fakeTargetNode;
            this.tutorialWindow.showButton(() => {
              this.tutorialWindow.hidePerson();
              this.tutorialWindow.hideButton();
              this.tutorialWindow.hideTip();
              this.tutorialWindow.hideArrowOrHand();
              this.tutorialWindow.modelNode = false;

              if (type === SlotTypes.Raid) {
                let dia = null;
                UIRoot.instance.openChildWindow(DialogWindow, {
                  msg: i18n.t("TutorialDialogSlotRaidMaster"),
                  confirmFunc: () => {
                    resolve(null);
                    this.tutorialWindow.enableBlockEvent = false;
                    this.tutorialWindow.stopEvent = true;
                    dia && dia.node.destroy();
                  },
                  confirmStr: "OK",
                  showCallback: dialogWindow => {
                    dia = dialogWindow;
                    const targetNode = dia.node.getChildByName("bg").getChildByName("btnLayout").getChildByName("button - ok");
                    this.tutorialWindow._targetNode = targetNode;
                    this.tutorialWindow.enableBlockEvent = true;
                    this.tutorialWindow.stopEvent = false;
                  }
                }, this.tutorialWindow.node);
              } else {
                resolve(null);
              }
            });
          });
        } // /**
        //  * 攻击一次
        //  */


        tutorialStepAttackOnce() {
          eventCenter.once(TutorilaEvent.SpinAttackStarted, () => {
            this.tutorialWindow.modelNode = false;
            this.tutorialWindow.enableBlockEvent = true; // this.tutorialWindow.hidePerson();

            this.tutorialWindow.hideArrowOrHand();
          });
          eventCenter.once(TutorilaEvent.SpinAttackFinished, () => {
            this.tutorialWindow.modelNode = true;
            const targetNode = homeView.interactionNode.ui.attackBtnOk;
            this.tutorialWindow.hideArrowOrHand();
            this.tutorialWindow.showHand(targetNode);
            this.tutorialWindow.highLightTargetNode(targetNode);
          });
          let targetNode = homeView.interactionNode.attackNodeContainer.children.filter(child => child.active === true)[0];
          this.tutorialWindow.modelNode = true;
          this.tutorialWindow.stopEvent = true;
          this.tutorialWindow.enableBlockEvent = false;
          this.tutorialWindow._targetNode = null; // this.tutorialWindow.hidePerson();

          this.tutorialWindow.schedule(() => {
            if (targetNode) {
              this.tutorialWindow.unscheduleAllCallbacks();
              this.tutorialWindow.hideArrowOrHand();
              this.tutorialWindow.showHand(targetNode);
              this.tutorialWindow.highLightTargetNode(targetNode);
            } else {
              targetNode = homeView.interactionNode.attackNodeContainer.children.filter(child => child.active === true)[0];
            }
          }, 0);
        } // /**
        //  * 引导三次偷取
        //  */


        tutorialStepRaidOnce(index) {
          this.boxIndex = index;

          if (index === 2) {
            eventCenter.once(TutorilaEvent.SpinRaidFinished, () => {
              this.tutorialWindow.modelNode = true;
              this.tutorialWindow.stopEvent = true;
              this.tutorialWindow.enableBlockEvent = false; // this.tutorialWindow.showPerson();

              const bottom = homeView.interactionNode.ui.raidNode.getChildByName("bottom");
              const targetNode2 = bottom.getChildByName("bg").getChildByName("btns").getChildByName("Button - ok");
              this.tutorialWindow.scheduleOnce(() => {
                this.tutorialWindow.hideArrowOrHand();
                this.tutorialWindow.showHand(targetNode2);
              }, 1);
              this.tutorialWindow.highLightTargetNode(targetNode2);
            });
          }

          if (index > 2) return;
          eventCenter.once(TutorilaEvent.SpinRaidStarted, () => {
            this.tutorialWindow.modelNode = false;
            this.tutorialWindow.enableBlockEvent = true;
            this.tutorialWindow.unHighLightPre3DObject();
            this.tutorialWindow.hideArrowOrHand();
          });
          eventCenter.once(TutorilaEvent.SpinRaidOnceFinished, () => {
            this.tutorialStepRaidOnce(index + 1);
          });
          const targetNode1 = homeView.interactionNode.raidNode.boxes[index];
          this.tutorialWindow.scheduleOnce(() => {
            const camera = homeView.interactionNode.villageContainer.getComponentInChildren(Camera);
            camera.convertToUINodeWithTexture(targetNode1.getWorldPosition(), this.tutorialWindow.node, arrowLocalPos);
            arrowLocalPos.add(new Vec3(0, 50, 0));
            this.tutorialWindow.hideArrowOrHand();
            this.tutorialWindow.showHand(arrowLocalPos);
          }, 0.05);
          this.tutorialWindow.targetSprite.node.active = true;
          this.tutorialWindow.modelNode = true;
          this.tutorialWindow.stopEvent = true;
          this.tutorialWindow.enableBlockEvent = false;
          this.tutorialWindow.highLight3DObject(targetNode1, true);
          this.tutorialWindow._targetNode = this.tutorialWindow.fakeTargetNode;
        }

      }

      exports('NewTutorialManager', NewTutorialManager);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PetStateIdle.ts", ['cc', './PetStateMachine.ts'], function (exports) {
  'use strict';

  var cclegacy, PetStateMachine;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      PetStateMachine = module.default;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "389cdenFbhGjbSKbsHh0jzf", "PetStateIdle", undefined);

      class PetStateIdle extends PetStateMachine {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "fxSleepNode", void 0);
        }

        async onEnter() {
          if (this.context.isSleeping) {
            this.context.changeStateToRest(); // const pb = await ResourceLoader.loadCommonPrefab("common/fx_sleep_01");
            // this.fxSleepNode = instantiate(pb);
            // this.fxSleepNode.getFlattedChildrenRecursively().forEach(v => v.layer = this.context.node.layer);
            // this.context.node.addChild(this.fxSleepNode);
          } else {
            this.context.changeStateToIdle();
          }
        }

        onExit() {
          this.fxSleepNode && this.fxSleepNode.destroy();
        }

        customUpdate(dt) {}

      }

      exports('default', PetStateIdle);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/EditorVillageHelper.ts", ['cc', './AdjustBuildPos.ts'], function (exports) {
  'use strict';

  var cclegacy, CCBoolean, _decorator, Component, warn, AdjustBuildPos;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      Component = module.Component;
      warn = module.warn;
    }, function (module) {
      AdjustBuildPos = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "392c1btx/NGKZQAlDkDf0UY", "EditorVillageHelper", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let EditorVillageHelper = exports('default', (_dec = ccclass("EditorVillageHelper"), _dec2 = property(CCBoolean), _dec(_class = (_class2 = (_temp = class EditorVillageHelper extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_activate", false);
        }

        get activate() {
          return this._activate;
        }

        set activate(bo) {
          this._activate = bo;

          if (bo) {
            this.excute_();
            this._activate = false;
          }
        }

        excute_() {
          warn("excute");
          this.node.children.forEach(v => {
            let node = v;

            if (node.name.startsWith("build")) {
              // this.attachBuildControllerTable(node);
              // node.children.filter(v => v.name.startsWith("level")).forEach((v, i) => {
              //     v.name = "level" + (i + 1);
              //     this.attachLevelControllerTable(v);
              // })
              let com = node.getComponent(AdjustBuildPos);
              com && com._destroyImmediate();
              com = node.addComponent(AdjustBuildPos);
              com.excute();
            } //  else {
            //     warn("not a valid node", CCTools.getNodePath(node));
            // }

          });
        } // setBuilds(villageNodeCom: VillageNode) {
        //     let arr: Node[] = [];
        //     for (let i = 1; i <= 5; i++) {
        //         let node = villageNodeCom.node.getChildByName("build" + i);
        //         if (node) {
        //             arr.push(node);
        //         } else {
        //             warn("build" + i, "not found");
        //         }
        //     }
        //     villageNodeCom.builds = arr;
        // }
        // setRaidTarget(villageNodeCom: VillageNode) {
        //     let arr: Node[] = [];
        //     for (let i = 1; i <= 4; i++) {
        //         let node = villageNodeCom.node.getChildByName("raidTarget" + i);
        //         if (node) {
        //             arr.push(node);
        //         } else {
        //             warn("raidTarget" + i, "not found");
        //         }
        //     }
        //     villageNodeCom.raidTargets = arr;
        // }
        // attachBuildControllerTable(node: Node) {
        //     let com = node.getComponent(ControllerTable);
        //     com && com._destroyImmediate();
        //     com = node.addComponent(ControllerTable);
        //     node.children.forEach(v => {
        //         if (!v.name.startsWith("level")) return;
        //         com.controllers.push(v);
        //     })
        //     let keyArr = ["attack", "world"];
        //     let container = node.getChildByName("positions");
        //     if (container) {
        //         for (let i = 0; i < keyArr.length; i++) {
        //             let posNode = container.getChildByName(keyArr[i]);
        //             if (posNode) {
        //                 let item = new Item();
        //                 item.key = keyArr[i];
        //                 item.node = posNode;
        //                 com.keyControllers.push(item);
        //             } else {
        //                 warn("could not find", keyArr[i]);
        //             }
        //         }
        //     }
        // }
        // attachLevelControllerTable(node: Node) {
        //     let com = node.getComponent(ControllerTable);
        //     com && com._destroyImmediate();
        //     com = node.addComponent(ControllerTable);
        //     node.children.forEach(v => {
        //         if (v.name.startsWith("nor")) {
        //             v.name = "normal";
        //         }
        //         if (v.name.startsWith("dam")) {
        //             v.name = "damage";
        //         }
        //     })
        //     let keyArr = ["normal", "damage"];
        //     for (let i = 0; i < 2; i++) {
        //         let item = new Item();
        //         item.key = keyArr[i];
        //         item.node = node.getChildByName(item.key);
        //         if (!item.node) {
        //             warn("key", item.key, "node not exist", CCTools.getNodePath(node));
        //         } else {
        //             com.keyControllers.push(item);
        //         }
        //     }
        // }


      }, _temp), _applyDecoratedDescriptor(_class2.prototype, "activate", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "activate"), _class2.prototype), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BigNumber.ts", ['cc', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "39472ION3hKC46BxBLgARmX", "BigNumber", undefined);

      class BigNumber {}

      exports('BigNumber', BigNumber);

      _defineProperty(BigNumber, "dot", ".");

      (function (_BigNumber) {
        const formatUnit_i18n = _BigNumber.formatUnit_i18n = {
          //多语言
          en: ["", "K", "M", "B", "T", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n"],
          de: ["", "Tsd", "Mio", "Mrd", "Bio", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n"],
          es: ["", "K", "M", "MRD", "B", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n"],
          fr: ["", "k", "M", "Md", "Bn", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n"],
          zh: ["", "K", "M", "B", "T", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n"],
          ar: ["", "ألف", "مليو", "مليا", "ترليو", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n"] // String.fromCharCode(8235) String.fromCharCode(8236)

        };
        let formatUnit = formatUnit_i18n["en"];
        const dot_i18n = _BigNumber.dot_i18n = {
          //多语言
          en: ".",
          de: ",",
          es: ",",
          fr: ",",
          zh: ".",
          ar: "٫"
        };

        function setLanguage() {
          if (!GameKit || !i18n) return;
          let lang = i18n.getLang();
          formatUnit = BigNumber.formatUnit_i18n[lang];
          BigNumber.dot = BigNumber.dot_i18n[lang];
        }

        _BigNumber.setLanguage = setLanguage;
        setTimeout(() => {
          setLanguage();
        }, 100);
        /** 转为简单字符串（100K, 10K, 1K）*/

        function format(a) {
          if (typeof a !== "string") a = a.toString();
          let len = a.length;
          if (len < 4) return a;
          let unitId = Math.floor((len - 1) / 3);
          let lenHigh = len - unitId * 3;
          let sa = a.substr(0, 3);
          if (lenHigh < 3) sa = sa.insert(lenHigh, BigNumber.dot);
          if (sa.endsWith(BigNumber.dot + "00")) sa = sa.replace(BigNumber.dot + "00", "");else if (sa.endsWith(BigNumber.dot + "0")) sa = sa.replace(BigNumber.dot + "0", "");else if (sa.contains(BigNumber.dot) && sa.endsWith("0")) sa = sa.substr(0, sa.length - 1); //if (i18n.isLangRight()) return formatUnit[unitId] + sa

          return sa + formatUnit[unitId];
        }

        _BigNumber.format = format;

        function formatThree(a) {
          if (typeof a !== "string") a = a.toString();
          let len = a.length;
          if (len < 4) return a;
          let unitId = Math.floor((len - 1) / 3);
          let lenHigh = len - unitId * 3;
          let sa = a.substr(0, 3);
          if (lenHigh < 3) sa = sa.insert(lenHigh, BigNumber.dot); //if (i18n.isLangRight()) return formatUnit[unitId] + sa

          return sa + formatUnit[unitId];
        }

        _BigNumber.formatThree = formatThree;

        function fromFormat(a) {
          if (typeof a !== "string") a = a.toString();
          let unitId = 0;
          let unit = "__";

          for (let i = 1; i < formatUnit.length; i++) {
            if (a.contains(formatUnit[i])) {
              unit = formatUnit[i];
              unitId = i;
              break;
            }
          }

          let sa = a.replace(unit, "");
          sa = sa.replace(BigNumber.dot, ".");
          let nsa = Number(sa);
          let zeroNum = unitId * 3;

          while (!Number.isInteger(nsa) && zeroNum > 0) {
            nsa *= 10;
            zeroNum--;
          }

          sa = nsa.toString();

          for (let i = 0; i < zeroNum; i++) sa += "0";

          return sa;
        }

        _BigNumber.fromFormat = fromFormat;

        function isMinus(a) {
          if (typeof a !== "string") a = a.toString();
          if (a == "-0") return false;
          return a[0] === "-";
        }

        _BigNumber.isMinus = isMinus;

        function makeMinus(a) {
          if (typeof a !== "string") a = a.toString();
          if (a == "-0" || a == "0") return "0";
          if (a[0] === "-") return a.replace("-", "");
          return "-" + a;
        }

        _BigNumber.makeMinus = makeMinus;

        function compare(a, b) {
          if (typeof a !== "string") a = a.toString();
          if (typeof b !== "string") b = b.toString();
          if (a === b) return 0;
          if (isMinus(a) && !isMinus(b)) return -1;
          if (!isMinus(a) && isMinus(b)) return 1;
          if (isMinus(a) && isMinus(b)) return -_compare(a.replace("-", ""), b.replace("-", ""));
          return _compare(a, b);
        }

        _BigNumber.compare = compare;

        function _compare(a, b) {
          const lena = a.length;
          const lenb = b.length;
          if (lena > lenb) return 1;
          if (lena < lenb) return -1;

          for (let i = 0; i < lena; i++) {
            if (parseInt(a[i]) > parseInt(b[i])) return 1;
            if (parseInt(a[i]) < parseInt(b[i])) return -1;
          }

          return 0;
        }

        _BigNumber._compare = _compare;

        function add(a, b) {
          if (typeof a !== "string") a = a.toString();
          if (typeof b !== "string") b = b.toString();
          let minusa = isMinus(a);
          let minusb = isMinus(b);

          if (minusa && !minusb) {
            a = a.substr(1);
            return minus(b, a);
          } else if (!minusa && minusb) {
            b = b.substr(1);
            return minus(a, b);
          }

          var sign = "";
          if (minusa && minusb) sign = "-";
          if (minusa) a = a.substr(1);
          if (minusb) b = b.substr(1);
          var res = "",
              c = 0;
          a = a.split("");
          b = b.split("");

          while (a.length || b.length || c) {
            c += ~~a.pop() + ~~b.pop();
            res = c % 10 + res;
            c = c > 9;
          }

          if (parseInt(res) == 0) return "0";
          return sign + res.replace(/^0+/, "");
        }

        _BigNumber.add = add;

        function minus(a, b) {
          let minusa = isMinus(a);
          let minusb = isMinus(b);

          if (minusa && !minusb) {
            return add(a, makeMinus(b));
          } else if (!minusa && minusb) {
            b = b.substr(1);
            return add(a, b);
          }

          var sign = "";

          if (compare(a, b) < 0) {
            var temp = b;
            b = a;
            a = temp;
            sign = "-";
          }

          var borrow = 0;
          /*借位值*/

          var minusArr = [];
          var len = Math.max(a.length, b.length);
          /*取得位数较大的一个数的位数*/

          var aArr = a.split("").reverse();
          var bArr = b.split("").reverse();
          /*利用倒序数组存储*/

          var digMinus;
          var digA = 0;
          var digB = 0;

          for (var i = 0; i <= len - 1; i++) {
            digA = parseInt(aArr[i]) || 0;
            digB = parseInt(bArr[i]) || 0;

            if (i == len - 1) {
              if (digA - borrow <= digB) {
                /*最高位不够减直接跳出循环*/
                break;
              }
            }

            digMinus = digA - digB - borrow;
            borrow = 0;

            if (digMinus < 0) {
              digMinus += 10;
              borrow = 1;
            }

            minusArr.unshift(digMinus);
          }

          return sign + minusArr.join("").replace(/^0+/, "");
        }

        _BigNumber.minus = minus;

        function mul(a, b) {
          if (typeof a !== "string") a = a.toString();
          if (typeof b !== "string") b = b.toString();
          let minusa = isMinus(a);
          let minusb = isMinus(b);
          var sign = "";
          if (minusa || minusb) sign = "-";
          if (minusa && minusb) sign = "";
          if (minusa) a = a.substr(1);
          if (minusb) b = b.substr(1);
          var str1,
              str2,
              len1,
              len2,
              result = [];
          str1 = a.split("").reverse();
          str2 = b.split("").reverse();
          len1 = str1.length;
          len2 = str2.length; //因为要在下一步做累加，如果不初始化为0,result[]中的值会变为NaN
          //因为未初始化的数组中的值为undefined

          for (var i = 0; i < len1; i++) for (var j = 0; j < len2; j++) result[i + j] = 0;

          for (var i = 0; i < len1; i++) for (var j = 0; j < len2; j++) //根据乘法的手动计算方式，在上下相同位上会有相加
          result[i + j] += parseInt(str1[i]) * parseInt(str2[j]);

          var n = result.length;

          for (var k = 0; k < n; k++) {
            var temp = result[k];

            if (temp >= 10) {
              result[k] = temp % 10; //JS中的"/"不是除法取整，会取得小数，所以要用Math.floor()

              result[k + 1] += Math.floor(temp / 10);
            }
          }

          return sign + result.reverse().join("");
        }

        _BigNumber.mul = mul;
      })(BigNumber || (BigNumber = exports('BigNumber', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TutorialManager.ts", ['cc', './TutorialWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, v3, v2, Node, TutorialWindow, SR, UIRoot, Game, Meta, LogEventWrap;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v3 = module.v3;
      v2 = module.v2;
      Node = module.Node;
    }, function (module) {
      TutorialWindow = module.TutorialWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "397d6Owq2VHKY1hMni5R2db", "TutorialManager", undefined);

      class TutorialManager {
        static Clear() {
          TutorialManager.triggers = {};
          TutorialManager.currentId = null;
          TutorialManager.currentMeta = null;
          if (TutorialManager.mainWindow) TutorialManager.mainWindow.close();
        }

        static init() {
          if (!TutorialManager.IsFinished()) {
            UIRoot.instance.openChildWindow(TutorialWindow, {
              showCallback: window => {
                TutorialManager.currentId = TutorialManager.GetCurrentId();
                TutorialManager.currentMeta = TutorialManager.GetMeta(TutorialManager.currentId);
                TutorialManager.tryStartStep();
              }
            });
          }
        }

        static update(dt) {
          if (TutorialManager.updateFunc) TutorialManager.updateFunc();
        }

        static nextStep() {
          if (!TutorialManager.currentMeta) return;
          LogEventWrap.logEvent("GuideDetail", {
            step: TutorialManager.currentMeta.LogId()
          });

          if (TutorialManager.stepOverCallback) {
            var sofunc = TutorialManager.stepOverCallback;
            TutorialManager.stepOverCallback = null;
            sofunc();
          }

          let nextId = TutorialManager.currentMeta.NextId();
          let groupId = TutorialManager.GetGroupId(nextId);
          Game.SUserTutorial.SetTutorialId(groupId, nextId);
          let lastId = TutorialManager.currentId;
          TutorialManager.currentId = nextId;
          TutorialManager.currentMeta = TutorialManager.GetMeta(TutorialManager.currentId);

          if (TutorialManager.currentMeta.Type() === Meta.TutorialMeta.Types.End) {
            let req = SR.SRTutorial.finishStep(lastId);
            req.SetSilence(false);
            req.SetCallBack(() => {
              TutorialManager.GroupFinish();
            });
            req.Send();
            return;
          }

          TutorialManager.tryStartStep();
        }

        static tryStartStep() {
          if (!TutorialManager.currentMeta) return;

          if (TutorialManager.currentMeta.TriggerStart()) {
            let tris = TutorialManager.currentMeta.TriggerStart();
            TutorialManager.mainWindow.Clear();
            TutorialManager.SetTriggerCallback(tris, TutorialManager.startStep.bind(TutorialManager));
          } else if (TutorialManager.currentMeta.TriggerWindow()) {
            let wins = TutorialManager.currentMeta.TriggerWindow().split(",");
            let windowName = wins[0];
            TutorialManager.mainWindow.Clear();

            TutorialManager.updateFunc = () => {
              let cw = UIRoot.instance.GetWindow(windowName);

              if (cw != null && !cw.isFake) {
                if (!!wins[1]) {
                  let wt = parseFloat(wins[1]);
                  cw.scheduleOnce(() => {
                    TutorialManager.startStep();
                  }, wt);
                } else {
                  TutorialManager.startStep();
                }

                TutorialManager.updateFunc = null;
              }
            };

            TutorialManager.update(0);
          } else {
            TutorialManager.startStep();
          }
        }

        static startStep() {
          TutorialManager.mainWindow.showMeta(TutorialManager.currentId);

          if (TutorialManager.currentMeta.TouchArea() === 1) {
            let button = TutorialManager.getArrowNode(TutorialManager.currentMeta);
            button.once("click", TutorialManager.nextStep.bind(TutorialManager));
          } else if (TutorialManager.currentMeta.TouchArea() === 2) {
            TutorialManager.mainWindow.addFullScreenOnClick(TutorialManager.nextStep.bind(TutorialManager));
          } else if (TutorialManager.currentMeta.TouchArea() === 3) {
            let tris = TutorialManager.currentMeta.TriggerEnd();
            TutorialManager.SetTriggerCallback(tris, TutorialManager.nextStep.bind(TutorialManager));
          }
        }

        static GroupFinish() {
          TutorialManager.currentId = null;
          TutorialManager.currentMeta = null;
          TutorialManager.mainWindow.close();

          if (TutorialManager.finishCallback) {
            TutorialManager.finishCallback();
            TutorialManager.finishCallback = null;
          }
        }

        static SetTriggerCallback(tri, cb) {
          TutorialManager.triggers[tri] = cb;
        }

        static CallTrigger(tri, val) {
          if (TutorialManager.triggers.hasOwnProperty(tri)) {
            if (TutorialManager.triggers[tri] != null) TutorialManager.triggers[tri]();
            delete TutorialManager.triggers[tri];
          }
        }

        static SetFinishCallback(cb) {
          TutorialManager.finishCallback = cb;
        }

        static SetStepOverCallback(cb) {
          TutorialManager.stepOverCallback = cb;
        } // Funcs
        // 这个组是否已经完成


        static IsFinished(gid = TutorialManager.MainTutorialGroupId) {
          // let cid = Game.SUserTutorial.TutorialId(gid)
          // if (cid == null) return false
          // let cmeta = Meta.MetaManager.GetMeta(Meta.MetaType.Tutorial, cid)
          // return cmeta.Type() === Meta.TutorialMeta.Types.End
          return true;
        } //获取这个组当前执行的id


        static GetCurrentId(gid = TutorialManager.MainTutorialGroupId) {
          let cid = Game.SUserTutorial.TutorialId(gid);
          if (cid == null) return null;
          return cid;
        }

        static GetMeta(metaId) {
          return Meta.MetaManager.GetMeta(Meta.MetaType.Tutorial, metaId);
        } // Tools
        //获得箭头节点


        static getArrowNode(meta) {
          let arrow = meta.Arrow();
          let wins = TutorialManager.currentMeta.TriggerWindow().split(",");
          let triggerWindow = wins[0];
          let arrowAdds = arrow.split(",");
          let targetNode = window;

          if (triggerWindow) {
            targetNode = UIRoot.instance.GetWindow(triggerWindow);
          }

          targetNode = TutorialManager.getTargetNode(arrowAdds[0], targetNode);
          return targetNode;
        } //获得箭头坐标


        static getArrowPosition(meta) {
          let arrow = meta.Arrow();
          let arrowAdds = arrow.split(",");
          let arrowAddPos = v3(parseInt(arrowAdds[1]), parseInt(arrowAdds[2]));

          if (arrowAdds[0] == "AbsPosition") {
            return arrowAddPos;
          }

          let targetNode = TutorialManager.getArrowNode(meta);
          return targetNode.getWorldPosition().add(arrowAddPos);
        } //获得高亮坐标


        static getHighLightPosition(meta) {
          let highlightValue = meta.HighlightValue();
          let wins = TutorialManager.currentMeta.TriggerWindow().split(",");
          let triggerWindow = wins[0];
          let highlightAdds = highlightValue.split(",");
          let highlightAddPos = v2(parseInt(highlightAdds[1]), parseInt(highlightAdds[2]));
          let targetNode = window;

          if (highlightAdds[0] == "AbsPosition") {
            return {
              x: highlightAddPos.x,
              y: highlightAddPos.y,
              width: parseInt(highlightAdds[3]),
              height: parseInt(highlightAdds[4]),
              isAbs: true
            };
          }

          if (triggerWindow) {
            targetNode = UIRoot.instance.GetWindow(triggerWindow);
          }

          targetNode = TutorialManager.getTargetNode(highlightAdds[0], targetNode);
          let pos = targetNode.getWorldPosition().add(highlightAddPos);
          return {
            x: pos.x,
            y: pos.y,
            width: parseInt(highlightAdds[3]),
            height: parseInt(highlightAdds[4]),
            isAbs: false
          };
        } //获得节点


        static getTargetNode(nodestr, rootNode) {
          let strs = nodestr.split(".");

          let func = function (str, root) {
            return root[str];
          };

          let target = rootNode;
          strs.forEach(x => {
            target = func(x, target);
          });
          target = target instanceof Node ? target : target.node;
          return target;
        } //获取组id


        static GetGroupId(id) {
          return Math.floor(id / 10000);
        }

      }

      exports('TutorialManager', TutorialManager);

      _defineProperty(TutorialManager, "triggers", void 0);

      _defineProperty(TutorialManager, "currentId", void 0);

      _defineProperty(TutorialManager, "currentMeta", void 0);

      _defineProperty(TutorialManager, "mainWindow", void 0);

      _defineProperty(TutorialManager, "updateFunc", void 0);

      _defineProperty(TutorialManager, "stepOverCallback", void 0);

      _defineProperty(TutorialManager, "finishCallback", void 0);

      _defineProperty(TutorialManager, "MainTutorialGroupId", 100);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BetAnimationScript.ts", ['cc', './global.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, SpriteFrame, _decorator, Component, Animation, Sprite, tween, Vec3, Tween, G;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      Sprite = module.Sprite;
      tween = module.tween;
      Vec3 = module.Vec3;
      Tween = module.Tween;
    }, function (module) {
      G = module.G;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "3a211MnwzdJ9ovbCulO4u01", "BetAnimationScript", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BetAnimationScript = exports('BetAnimationScript', (_dec = ccclass('BetAnimationScript'), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(SpriteFrame), _dec9 = property(SpriteFrame), _dec(_class = (_class2 = (_temp = class BetAnimationScript extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "betNode", _descriptor, this);

          _initializerDefineProperty(this, "betBg", _descriptor2, this);

          _initializerDefineProperty(this, "betWhiteBg", _descriptor3, this);

          _initializerDefineProperty(this, "betLabel", _descriptor4, this);

          _initializerDefineProperty(this, "betMaxBg", _descriptor5, this);

          _initializerDefineProperty(this, "betToast", _descriptor6, this);

          _initializerDefineProperty(this, "sfRed", _descriptor7, this);

          _initializerDefineProperty(this, "sfBlue", _descriptor8, this);
        }

        betShowStar() {
          this.node.getChildByName("betStar").active = true;
          this.node.getChildByName("betStar").getComponent(Animation).play("betStar");
          this.node.getChildByName("betStar").getComponent(Animation).on(Animation.EventType.FINISHED, () => {
            this.node.getChildByName("betStar").active = false;
          }, this);
        }

        betNormalToMax() {
          this.reset();
          this.betWhiteBg.active = false;
          this.betBg.getComponent(Sprite).spriteFrame = this.sfRed;
          tween(this.betBg).to(0.12, {
            scale: new Vec3(1.25, 1.25, 1.25)
          }).to(0.1, {
            scale: G.scale1_1
          }).delay(0.33).to(0.02, {
            scale: G.scale0_9
          }).to(0.1, {
            scale: G.scale1_1
          }).to(0.08, {
            scale: Vec3.ONE
          }).start();
          tween(this.betWhiteBg).delay(0.55).set({
            active: true,
            opacity: 255
          }).call(() => {
            this.betShowStar();
          }).delay(0.12).to(0.08, {
            opacity: 0
          }).start();
          tween(this.betLabel).delay(0.55).set({
            active: false
          }).delay(0.2).set({
            active: true
          }).start();
          tween(this.betMaxBg).set({
            scale: Vec3.ONE,
            active: true
          }).parallel(tween().to(0.27, {
            scale: new Vec3(2, 2, 2)
          }).to(0.18, {
            scale: new Vec3(0.5, 0.5, 0.5)
          }).set({
            active: false
          }), tween().delay(0.1).set({
            position: new Vec3(0, -13.957, 0)
          }).to(0.35, {
            position: new Vec3(0, 9.853, 0)
          })).start();
        }

        betNormalToNormal() {
          this.reset();
          tween(this.betNode).to(0.1, {
            scale: G.scale1_2
          }).to(0.1, {
            scale: Vec3.ONE
          }).start();
        }

        betMaxToNormal() {
          this.reset();
          tween(this.betBg).to(0.05, {
            scale: G.scale0_9
          }).call(() => {
            this.betBg.getComponent(Sprite).spriteFrame = this.sfBlue;
          }).to(0.1, {
            scale: G.scale1_2
          }).to(0.08, {
            scale: Vec3.ONE
          }).start();
          tween(this.betMaxBg).set({
            active: false,
            position: new Vec3(0, -15.52, 0),
            scale: G.scale0_3
          }).delay(0.05).set({
            active: true
          }).parallel(tween().to(0.1, {
            scale: new Vec3(1.25, 1.1, 1)
          }).to(0.17, {
            scale: Vec3.ONE
          }), tween().to(0.27, {
            positon: new Vec3(0, -17.204, 0)
          })).start();
        }

        betShowToast() {
          Tween.stopAllByTarget(this.betToast);
          tween(this.betToast).set({
            active: true
          }).parallel(tween().to(0.13, {
            scale: G.scale1_2
          }).to(0.09, {
            scale: Vec3.ONE
          }).delay(0.83).to(0.15, {
            scale: G.scale1_1
          }).to(0.18, {
            scale: G.scale0_3
          }), tween().delay(1.05).to(0.32, {
            opacity: 0
          })).call(() => {
            this.betToast.active = false;
          }).start();
        }

        reset() {
          Tween.stopAllByTarget(this.betBg);
          Tween.stopAllByTarget(this.betWhiteBg);
          Tween.stopAllByTarget(this.betLabel);
          Tween.stopAllByTarget(this.betMaxBg);
          this.betNode.scale = this.betBg.scale = this.betMaxBg.scale = Vec3.ONE;
          this.betLabel.active = this.betMaxBg.active = true;
          this.betWhiteBg.active = false;
          this.betMaxBg.setPosition(new Vec3(0, -13.957, 0));
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "betNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "betBg", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "betWhiteBg", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "betLabel", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "betMaxBg", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "betToast", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "sfRed", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "sfBlue", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitBall.ts", ['cc', './CCE_Component.ts', './MinigameCoinhitGameplay.ts'], function (exports) {
  'use strict';

  var cclegacy, v2, _decorator, macro, isValid, v3, Vec2, log, RigidBody2D, CCE_Component, MinigameCoinhitGameplay;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v2 = module.v2;
      _decorator = module._decorator;
      macro = module.macro;
      isValid = module.isValid;
      v3 = module.v3;
      Vec2 = module.Vec2;
      log = module.log;
      RigidBody2D = module.RigidBody2D;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      MinigameCoinhitGameplay = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "3a9dcc9fJNGhpC2phH2kePo", "MinigameCoinhitBall", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        RECYCLE_Y: -568,
        // 回收线
        RECYCLE_POSITION: v2(115, -492),
        // 回收点
        RECYCLE_TIME: 0.5,
        // 回收时间
        NEW_LINEV: v2(100, 500) // 速度为0时的给定速度

      };
      let MinigameCoinhitBall = exports('default', ccclass(_class = (_temp = _class2 = class MinigameCoinhitBall extends CCE_Component {
        unuse() {
          this.unscheduleAllCallbacks();
        }

        reuse() {
          this.schedule(() => {
            this.check_linev();
          }, 1, macro.REPEAT_FOREVER);
        }

        onBeginContact(contact, selfCollider, otherCollider) {}
        /**
         * 位置判定执行销毁函数
         */


        slowUpdate() {
          if (this.node.y <= C.RECYCLE_Y && isValid(this.node)) {
            // 计算vx,t,vy，基础公式 H=vt+0.5gtt
            let t = C.RECYCLE_TIME; // 默认时间

            let vy = (C.RECYCLE_POSITION.y - this.node.position.y + 0.5 * 1136 * t * t) / t; // 第1次计算vy

            if (t < vy / 1136) {
              t = 2 * (vy / 1136) - t; // 根据vy，重新计算1次t，使其在下落阶段回收
            }

            let vx = (C.RECYCLE_POSITION.x - this.node.position.x) / t;
            this.set_linev(v2(vx, vy));
            this.scheduleOnce(() => {
              MinigameCoinhitGameplay.ins.ball_pool.put(this.node);
              this.node.position = v3(Vec2.ZERO.x, Vec2.ZERO.y, 0);
              MinigameCoinhitBall.count_plus_one();
            }, t);
          }
        }
        /** 检查线速度，在其为0时给一个速度，需要检查2次 */


        check_linev() {
          if (this.get_linev().equals(Vec2.ZERO)) {
            this.scheduleOnce(() => {
              if (this.get_linev().equals(Vec2.ZERO)) {
                log(this.get_linev());
                this.set_linev(C.NEW_LINEV);
              }
            }, 1);
          }
        }

        get_linev() {
          return this.getComponent(RigidBody2D).linearVelocity;
        }
        /**
         * 设置线速度
         * @param {cc.Vec2} linev 
         */


        set_linev(linev) {
          this.getComponent(RigidBody2D).linearVelocity = linev;
        } // 回收计数，使用静态函数

        /** 重置 */


        static reset() {
          MinigameCoinhitBall.recycle_count = 0;
          MinigameCoinhitBall.target_count = MinigameCoinhitGameplay.ins.ball_count;
        }
        /** 回收计数+1 */


        static count_plus_one() {
          MinigameCoinhitBall.recycle_count += 1;

          if (MinigameCoinhitBall.recycle_count >= MinigameCoinhitBall.target_count) {
            MinigameCoinhitGameplay.ins.game_pre();
          }
        }

      }, _defineProperty(_class2, "recycle_count", 0), _defineProperty(_class2, "target_count", 0), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GiftGetMeta.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "3be9bB5cZdFv7s6Rm8D8Z+U", "GiftGetMeta", undefined);

      class GiftGetMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new GiftGetMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = data;
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        MapId() {
          return this._data.id;
        } //礼物获得的金币


        Coin() {
          return this._data.coin;
        } //礼物获得的体力


        Spin() {
          return this._data.spin;
        }

      }

      exports('GiftGetMeta', GiftGetMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserServant.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Meta, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "3c4beybWsRLGKGnFyIrNrqT", "UserServant", undefined);

      class UserServant {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            servants: {} // 1: {rank:1,exp:0,time:0,_ltime:0,select:true},

          };
          let CLOSE_Servant = false;
          Object.defineProperty(window, "CLOSE_Servant", {
            get: () => CLOSE_Servant,
            configurable: true
          });
        } //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
        }

        UserId() {
          return this.data.userId;
        } //随从数据


        Servant(id) {
          return this.data.servants[id];
        }

        GetSelected() {
          for (let id in this.data.servants) {
            if (this.data.servants[id].select) return id;
          }

          return null;
        }

        UpdateTime() {
          for (let id in this.data.servants) {
            let state = this.data.servants[id];

            let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

            if (time < 0) time = 0;
            state._ltime = GameKit.TimeUtil.getCurrentTime();
            state.time = time;
            this.data.servants[id] = state;
          }
        }

        IsCurrentActive() {
          this.UpdateTime();
          let selectId = this.GetSelected();

          if (selectId) {
            return this.Servant(selectId).time > 0;
          }

          return false;
        } ///////////////////////////


        Star() {
          let star = 0;

          for (let id in this.data.servants) {
            let data = this.data.servants[id];

            if (data) {
              star += Meta.ServantRankMeta.GetRankAllStar(id, data.rank);
            }
          }

          return star;
        }

      }

      exports('UserServant', UserServant);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RaidKingExtra.ts", ['cc', './CCE_Component.ts', './ContentModel.ts', './Content.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, ProgressBar, _decorator, CCE_Component, ContentModel, Content, Game, Meta;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "3cad4D2I+NOfKjaAQzr0rRF", "RaidKingExtra", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let RaidKingExtra = exports('default', (_dec = property(Label), _dec2 = property(ProgressBar), _dec3 = property(ContentModel), ccclass(_class = (_class2 = (_temp = class RaidKingExtra extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelProgress", _descriptor, this);

          _initializerDefineProperty(this, "spProgress", _descriptor2, this);

          _initializerDefineProperty(this, "reward", _descriptor3, this);

          _defineProperty(this, "activityId", void 0);

          _defineProperty(this, "userdata", void 0);
        }

        Show(centerWindow, activityMeta) {
          this.activityId = activityMeta.Id();
          this.userdata = Game.SUserActivity.GetActivityData(this.activityId);
          let currentCount = this.userdata.currentCount || 0;
          let currentId = this.userdata.currentId || 1;
          let currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.RaidMaster, currentId);
          let currentGet = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.RaidMasterReward, currentId));
          this.labelProgress.string = currentCount.toString() + " / " + currentNeed;
          this.spProgress.progress = currentCount / currentNeed;
          this.reward.show(currentGet);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelProgress", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spProgress", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "reward", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRInteraction.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRInteraction', void 0);

      cclegacy._RF.push({}, "3cb511uhUpHXq8ScrYMM29s", "SRInteraction", undefined);

      let SRInteraction;

      (function (_SRInteraction) {
        function doAttack(type, attackUserId, isFriend, isRevenge) {
          let req = new GameKit.ServerRequest("doAttack");
          req.SetSilence(true);
          req.SetRequestBody("type", type);
          req.SetRequestBody("attackUserId", attackUserId);
          req.SetRequestBody("isFriend", isFriend);
          req.SetRequestBody("isRevenge", isRevenge);
          return req;
        }

        _SRInteraction.doAttack = doAttack;

        function doRaid(raids) {
          let req = new GameKit.ServerRequest("doRaid");
          req.SetRequestBody("raids", raids);
          req.SetSilence(true);
          return req;
        }

        _SRInteraction.doRaid = doRaid;
      })(SRInteraction || (SRInteraction = exports('SRInteraction', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PlayGetAnimation.ts", ['cc', './SoundManager.ts'], function (exports) {
  'use strict';

  var cclegacy, Vec3, instantiate, dragonBones, v3, tween, easing, _decorator, SoundManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
      dragonBones = module.dragonBones;
      v3 = module.v3;
      tween = module.tween;
      easing = module.easing;
      _decorator = module._decorator;
    }, function (module) {
      SoundManager = module.SoundManager;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "3eb52yjK6lEm5uFTgJNwXJk", "PlayGetAnimation", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let PlayGetAnimation = exports('PlayGetAnimation', (_dec = ccclass("PlayGetAnimation"), _dec(_class = class PlayGetAnimation {
        static async playAnimation(params) {
          const effectCount = Math.min(params.count, 30);
          const perCount = Math.floor(params.count / effectCount);
          const num = Math.ceil(params.count / perCount);
          const endPos = new Vec3();
          let bornRadius = 0;
          let bornDuration = 0;
          let flyDuration = 0;
          let bornEndPos = null;
          let angle = 0;
          params.startNode.inverseTransformPoint(endPos, params.endNode.getWorldPosition());
          let isStarted = false;
          SoundManager.playSound("getReward", 0.5);
          return new Promise((resolve, reject) => {
            for (let i = 0; i < num; i++) {
              const perCoin = instantiate(params.prefab);

              if (perCoin.getComponent(dragonBones.ArmatureDisplay)) {
                perCoin.getComponent(dragonBones.ArmatureDisplay).timeScale = Math.random() * 0.5 + 0.3;
              }

              perCoin.setParent(params.startNode);
              bornRadius = Math.min(params.count * 20, 200);
              bornDuration = 0.4 * (params.timeScale || 1);
              flyDuration = 0.5 * (params.timeScale || 1);
              bornEndPos = v3(Math.floor((Math.random() * 2 - 1) * bornRadius), Math.floor((Math.random() * 2 - 1) * bornRadius), 0);
              angle = (Math.random() * 2 - 1) * 60;
              tween(perCoin).set({
                scale: v3(0.2, 0.2, 0.2)
              }).delay(i * 0.01 * (params.timeScale || 1)).to(bornDuration, {
                position: bornEndPos,
                scale: Vec3.ONE,
                angle: angle
              }, {
                easing: easing.sineOut
              }).delay(i * 0.01 * (params.timeScale || 1)).to(flyDuration, {
                position: endPos,
                scale: v3(0.5, 0.5, 0.5),
                angle: 0
              }, {
                easing: easing.backIn
              }).call(() => {
                if (!isStarted) {
                  params.startCallback && params.startCallback();
                  isStarted = true;
                }

                if (params.count > perCount) {
                  params.count -= perCount;
                  params.perComplete && params.perComplete(perCount);
                  perCoin.destroy();
                } else {
                  params.perComplete && params.perComplete(params.count);
                  perCoin.destroy();
                  params.complete && params.complete();
                  resolve(params.count);
                }
              }).start();
            }
          });
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserVillage.ts", ['cc', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "3ec21Uw+oZC8KlEao1XlskY", "UserVillage", undefined); //村庄数据


      class UserVillage {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            mapId: 1,
            village: [0, 0, 0, 0, 0, 0, 0, 0, 0, 0] //村庄数据

          };
        } //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
          return this;
        }

        MapId() {
          return this.data.mapId;
        }

        VillageData() {
          return this.data.village;
        }

        GetLevel(type) {
          return this.data.village[type - 1];
        }

        MakeLevelUp(type) {
          this.data.village[type - 1]++;
        }

        IsMaxLevel(type) {
          return this.GetLevel(type) >= Meta.VillageShopMeta.GetMaxLevel(this.MapId(), type);
        }

        IsDestroyed(type) {
          return this.data.village[type + 4] > 0;
        }

        MakeFix(type) {
          this.data.village[type + 4] = 0;
        }

        CanAttack(type) {
          let level = this.GetLevel(type);
          if (this.IsDestroyed(type)) level -= 1;
          return level > 0;
        }

        destroyBuild(type) {
          if (this.IsDestroyed(type)) this.data.village[type - 1]--;
          this.data.village[type + 4] = 1;
        }

        IsFinished() {
          for (let i = 1; i <= 5; i++) {
            if (!this.IsMaxLevel(i)) return false;
            if (this.IsDestroyed(i)) return false;
          }

          return true;
        }

        HasNextVillage() {
          return Object.keys(Meta.MetaManager.GetMetas(Meta.MetaType.Village)).length > this.MapId();
        }

        Score() {
          let villageData = this.VillageData();
          let star = 0;

          for (let k = 0; k < 5; k++) {
            star += villageData[k] - Math.min(1, villageData[k + 5]);
          }

          return star;
        }

        Star() {
          let mapId = this.MapId();
          let star = 0;

          for (let i = 1; i < mapId; i++) {
            star += Meta.VillageShopMeta.GetMaxStar(i);
          }

          star += this.Score();
          return star;
        }

      }

      exports('UserVillage', UserVillage);

      _defineProperty(UserVillage, "Types", void 0);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GameEvent.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports('GameEvent', void 0);

      cclegacy._RF.push({}, "3fc01g5udNKQq89OamH0qjS", "GameEvent", undefined); //游戏事件类


      let GameEvent;

      (function (_GameEvent) {
        let _data = {};
        let EventName;

        (function (EventName) {
          EventName["ApEvent"] = "apEvent";
          EventName["CoinEvent"] = "coinEvent";
          EventName["ShieldEvent"] = "shieldEvent";
          EventName["TimeShieldEvent"] = "timeShieldEvent";
          EventName["StarEvent"] = "starEvent";
          EventName["ToraidEvent"] = "toraidEvent";
          EventName["VillageEvent"] = "villageEvent";
          EventName["MessageEvent"] = "messageEvent";
          EventName["MessageEventInvitedUnlock"] = "messageEventInvitedUnlock";
          EventName["GiftEvent"] = "giftEvent";
          EventName["ActivityEvent"] = "activityEvent";
          EventName["ActivityItem"] = "activityItem";
          EventName["TaskCompleteCount"] = "taskCompleteCount";
          EventName["StatusEvent"] = "statusEvent";
          EventName["ItemsEvent"] = "itemsEvent";
          EventName["ServantEvent"] = "servantEvent";
          EventName["CardEvent"] = "cardEvent";
          EventName["PresentEvent"] = "presentEvent";
          EventName["RecordEvent"] = "recordEvent";
          EventName["RaidProtectEvent"] = "raidProtectEvent";
        })(EventName || (EventName = {}));

        _GameEvent.EventName = EventName;
        const speEvUInames = _GameEvent.speEvUInames = [73, 53, 112, 54, 74, 54, 90, 109, 121, 53, 89, 87, 85, 53, 89, 43, 118, 53, 54, 71, 78, 53, 89, 54, 50];

        function RegisterEvent(type, key, callback, once) {
          if (type == null || key == null || callback == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {};
          _data[type][key] = {
            callback: callback,
            once: once
          };
        }

        _GameEvent.RegisterEvent = RegisterEvent;

        function UnRegisterEvent(type, key) {
          if (type == null || key == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {};

          if (_data[type].hasOwnProperty(key)) {
            delete _data[type][key];
          }
        }

        _GameEvent.UnRegisterEvent = UnRegisterEvent;

        function DispatcherEvent(type, msg) {
          if (type == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {};

          for (let key in _data[type]) {
            let mess = _data[type][key];

            if (mess != null) {
              //AppMain.instance.scheduleOnce(function() {
              if (mess.callback) mess.callback(msg);

              if (mess.once) {
                GameEvent.UnRegisterEvent(type, key);
              } //}, 0)

            }
          }
        }

        _GameEvent.DispatcherEvent = DispatcherEvent;

        function DispatcherEventKey(type, key, msg) {
          if (type == null || key == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {};

          if (_data[type].hasOwnProperty(key)) {
            let mess = _data[type][key];

            if (mess != null) {
              //AppMain.instance.scheduleOnce(function() {
              if (mess.callback) mess.callback(msg);

              if (mess.once) {
                GameEvent.UnRegisterEvent(type, key);
              } //}, 0)

            }
          }
        }

        _GameEvent.DispatcherEventKey = DispatcherEventKey;

        function Clear() {
          _data = {};
        }

        _GameEvent.Clear = Clear;
      })(GameEvent || (GameEvent = exports('GameEvent', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SpinBtn.ts", ['cc', './CCE_Component.ts', './SlotNode.ts', './ContentCheck.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Node, CCE_Component, SlotNode, ContentCheck;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Node = module.Node;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SlotNode = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "3fe79fHt/FFQb/tectGHTCX", "SpinBtn", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SpinBtn = exports('default', (_dec = property(SlotNode), ccclass(_class = (_class2 = (_temp = class SpinBtn extends CCE_Component {
        constructor() {
          super();

          _defineProperty(this, "oldY", void 0);

          _defineProperty(this, "oldX", void 0);

          _initializerDefineProperty(this, "slotNode", _descriptor, this);

          this.oldY = 0;
          this.oldX = 0;
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          var node = this.node; // node.spinBtn = this;

          this.oldY = node.position.y;
          this.oldX = node.position.x;
        }

        onEnable() {
          this.node.on(Node.EventType.TOUCH_START, this.onButtonPress, this);
          this.node.on(Node.EventType.TOUCH_MOVE, this.onButtonMove, this);
          this.node.on(Node.EventType.TOUCH_END, this.onButtonRelease, this);
          this.node.on(Node.EventType.TOUCH_CANCEL, this.onButtonRelease, this);
        }

        onDisable() {
          this.node.off(Node.EventType.TOUCH_START, this.onButtonPress, this);
          this.node.off(Node.EventType.TOUCH_MOVE, this.onButtonMove, this);
          this.node.off(Node.EventType.TOUCH_END, this.onButtonRelease, this);
          this.node.off(Node.EventType.TOUCH_CANCEL, this.onButtonRelease, this);
        }

        start() {}

        onButtonPress(event) {
          if (this.slotNode.canSpin() && !homeView.isChangeAnim()) {
            if (ContentCheck.CheckAp(this.slotNode.getBet())) {
              this.slotNode.spin();
              this.node.stopAllActions();
              this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY - 30));
            } else {
              this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY - 8));
            }
          } else {
            this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY - 8));
          }

          event.stopPropagation();
        }

        onButtonMove(event) {
          event.stopPropagation();
        }

        onButtonRelease(event) {
          if (!event.simulate) {
            this.node.stopAllActions();
            this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY));
            event.stopPropagation();
          }
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "slotNode", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LuckyDrawWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './Content.ts', './GetRewardWindow.ts', './GameMainWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Sprite, Label, SoundManager, UIWindow, Content, GetRewardWindow, GameMainWindow, SR, UIRoot, Game, ADWrap, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      Label = module.Label;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      GetRewardWindow = module.GetRewardWindow;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "40110Rafl9KfLsiqD4A+NY8", "LuckyDrawWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LuckyDrawWindow = exports('LuckyDrawWindow', (_dec = property([Node]), ccclass(_class = (_class2 = (_temp = _class3 = class LuckyDrawWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "items", _descriptor, this);

          _defineProperty(this, "rewards", void 0);

          _defineProperty(this, "selects", void 0);

          _defineProperty(this, "lastSelectId", void 0);

          _defineProperty(this, "loopIndex", void 0);

          _defineProperty(this, "oldCoin", void 0);

          _defineProperty(this, "stopIndex", void 0);

          _defineProperty(this, "loopCount", void 0);
        }

        onShow(showParams) {
          this.rewards = Content.FromStrings("2=0=15;11=37=0.2;11=37=0.4;11=37=0.1;2=0=2;3=0=1;2=0=3;11=37=0.8;6=2=100;2=0=10;6=3=1;2=0=1");
          this.selects = [];
          let i = 0;
          this.items.forEach(item => {
            let icon = GameKit.ControllerTable.GetComponent(item, "icon", Sprite);
            let label = GameKit.ControllerTable.GetComponent(item, "label", Label);
            let spSelect = GameKit.ControllerTable.GetNode(item, "spSelect");
            this.selects.push(spSelect);
            this.rewards[i].Icon(icon);
            label.string = this.rewards[i].Contents()[0].FormatCount().toString();
            i++;
          });
          this.lastSelectId = -1;
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        callPlay() {
          if (this.loopIndex != null) return;
          ADWrap.ShowVideo(() => {
            this.oldCoin = Game.SUser.Coin();
            let req = SR.SRUserData.finishVideoLuckyDraw();
            req.SetSilence(true);
            req.SetCallBack(res => {
              this.stopIndex = res.drawIndex; // if (GameMainWindow.instance) GameMainWindow.instance.userinfo.changeCoin(this.oldCoin, this.oldCoin, 0);
            });
            req.Send();
            this.startLoop();
          }, "LuckyDraw");
        }

        startLoop() {
          this.loopIndex = -1;
          this.loopCount = 0;
          this.loopNext();
          this.node.runAction(ccAction.sequence(ccAction.delayTime(0.6), ccAction.callFunc(this.loopNext, this), ccAction.delayTime(0.4), ccAction.callFunc(this.loopNext, this), ccAction.delayTime(0.3), ccAction.callFunc(this.loopNext, this), ccAction.delayTime(0.1), ccAction.callFunc(this._loop, this)));
        }

        _loop() {
          let seqs = [];

          for (let i = 0; i < 12; i++) {
            seqs.push(ccAction.delayTime(0.1));
            seqs.push(ccAction.callFunc(this.loopNext, this));
          }

          seqs.push(ccAction.callFunc(() => {
            this.loopCount++;

            if (this.loopCount < 3 || this.stopIndex == null) {
              this._loop();
            } else {
              this.endLoop();
            }
          }, this));
          this.node.runAction(ccAction.sequence(seqs));
        }

        endLoop() {
          let seqs = [];
          let seqsCount = this.stopIndex - 4 - this.loopIndex;
          if (seqsCount < 0) seqsCount += 12;

          for (let i = 0; i < seqsCount; i++) {
            seqs.push(ccAction.delayTime(0.1 + i * 0.2 / seqsCount));
            seqs.push(ccAction.callFunc(this.loopNext, this));
          }

          seqs.push(ccAction.delayTime(0.3));
          seqs.push(ccAction.callFunc(this.loopNext, this));
          seqs.push(ccAction.delayTime(0.4));
          seqs.push(ccAction.callFunc(this.loopNext, this));
          seqs.push(ccAction.delayTime(0.5));
          seqs.push(ccAction.callFunc(this.loopNext, this));
          seqs.push(ccAction.delayTime(0.6));
          seqs.push(ccAction.callFunc(this.loopNext, this));
          seqs.push(ccAction.delayTime(0.8));
          seqs.push(ccAction.callFunc(this.drawEnd, this));
          this.node.runAction(ccAction.sequence(seqs));
        }

        loopNext() {
          this.loopIndex++;
          if (this.loopIndex >= 12) this.loopIndex -= 12;
          this.showSelect(this.loopIndex);
        }

        drawEnd() {
          let rewards = [];
          rewards.push(this.rewards[this.stopIndex]);
          UIRoot.instance.openChildWindow(GetRewardWindow, {
            contents: rewards,
            oldCoin: this.oldCoin
          });
          if (GameMainWindow.instance) homeView.slotPage.updateLuckyDraw(true);
          this.closeAnim();
          SoundManager.playSound("blackjack/win");
        }

        showSelect(index) {
          if (this.lastSelectId > -1) this.selects[this.lastSelectId].active = false;
          this.selects[index].active = true;
          this.lastSelectId = index;
          SoundManager.playSound("luckydraw_step");
        }

      }, _defineProperty(_class3, "windowPath", "Other/LuckyDrawWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "items", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CommunityCardItem.ts", ['cc', './_app.ts', './CardCollectWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, Node, _decorator, Component, SpriteFrame, Animation, cce, CardCollectWindow, SR, UIRoot, Game, Meta, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      SpriteFrame = module.SpriteFrame;
      Animation = module.Animation;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      CardCollectWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "405e3hIfkJJkLxNYhkKbHSY", "CommunityCardItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CommunityCardItem = exports('CommunityCardItem', (_dec = ccclass("CommunityCardItem"), _dec2 = property(Sprite), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Node), _dec6 = property(Node), _dec(_class = (_class2 = (_temp = class CommunityCardItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "avatar", _descriptor, this);

          _initializerDefineProperty(this, "nameTxt", _descriptor2, this);

          _initializerDefineProperty(this, "tipTxt", _descriptor3, this);

          _initializerDefineProperty(this, "iconLock", _descriptor4, this);

          _initializerDefineProperty(this, "collectBtn", _descriptor5, this);

          _defineProperty(this, "_data", null);
        }

        setCardItem(data, id, owner) {
          this._data = data;
          const user = Game.SUser.FriendsList()[data.userId];

          try {
            let avatar = user.Avatar();

            if (avatar != null && avatar.length > 0) {
              cce.loaderLoad({
                url: avatar,
                type: "jpg"
              }, (err, tex) => {
                if (err == null && tex != null) {
                  let sp = new SpriteFrame();
                  sp.texture = tex;
                  if (this.avatar) this.avatar.spriteFrame = sp;
                }
              }, true);
            }
          } catch (e) {}

          this.nameTxt.string = user.Name();
          this.tipTxt.string = i18n.t("gifts_explain_card_collect");
          let cardId = data.cardId;
          let cardMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Card, cardId);

          if (cardMeta.MinVillage() > Game.SUserVillage.MapId()) {
            this.iconLock.active = true;
          }

          this.collectBtn.targetOff(this);
          this.collectBtn.on("click", () => {
            if (cardMeta.MinVillage() > Game.SUserVillage.MapId()) {
              this.collectBtn.getComponentInChildren(Animation).play("lockShake");
              cce.showToast(String.format(i18n.t("gifts_explain_card_cantcollect"), cardMeta.MinVillage()));
              return;
            }

            let req = SR.SRSocial.giftsCardCollect(id);
            req.SetCallBack(() => {
              owner.reuseSetData(data.cardId);
              UIRoot.instance.openChildWindow(CardCollectWindow, {
                id: data.cardId
              });
            });
            req.Send();
          }, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "avatar", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "nameTxt", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "tipTxt", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "iconLock", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "collectBtn", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LogEventWrap.ts", ['cc', './global.ts', './Logs.ts', './fbIn_lib.ts', './User.ts', './SdkManager.ts', './StaticGame.ts', './NativeWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Logs, fbInTools, User, SdkManager, Game, NativeWrap;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      User = module.User;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function () {}],
    execute: function () {
      exports('LogEventWrap', void 0);

      cclegacy._RF.push({}, "41faclenNtE97ll9d6D05Je", "LogEventWrap", undefined);

      let LogEventWrap;

      (function (_LogEventWrap) {
        function logEvent(eventName, parameters) {
          parameters = parameters || {};
          parameters.userId = Game.SUser.UserId();
          parameters.playerName = Game.SUser.Name();
          parameters.type = User.isfirst ? "new_player" : "old_player";
          parameters.version = G.GameConfig.version; // if (AppKit.SdkManager.IsNative()) parameters.version += "(" + AppKit.NativeWrap.getVersion() + ")"

          Logs.Info("logevent", eventName, parameters);

          if (fbInTools.usefbIn) {
            FBInstant.logEvent(eventName, 1, parameters);
          } else if (SdkManager.IsNative()) {
            // AppKit.NativeWrap.call("FBSdk", "logEvent", {eventName:eventName, parameters:parameters}, null)
            // AppKit.NativeWrap.call("SDKHandleClass", "logEvent", {eventName:eventName, parameters:parameters}, null)
            NativeWrap.call("AppAnalytic", "logEvent", {
              eventName: eventName,
              parameters: parameters
            }, null);
          } else {
            Logs.Log(eventName, parameters);
          }
        }

        _LogEventWrap.logEvent = logEvent;

        function logAppAnalytic(eventName, parameters) {
          parameters = parameters || {};

          if (SdkManager.IsNative()) {
            NativeWrap.call("AppAnalytic", "logEvent", {
              eventName: eventName,
              parameters: parameters
            }, null);
          }
        }

        _LogEventWrap.logAppAnalytic = logAppAnalytic;
      })(LogEventWrap || (LogEventWrap = exports('LogEventWrap', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CCTools.ts", ['cc', './Logs.ts', './_app.ts', './BlinkAnim.ts', './EnterCloseAnim.ts', './LongScreenFit.ts', './LoopMoveAnim.ts', './MoveAnim.ts', './RotateAnim.ts', './ScaleAnim.ts', './ShakeAnim.ts', './SkewAnim.ts', './ThirdMenuFit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Scene, Widget, Sprite, UITransform, color, Label, RichText, LabelOutline, LabelShadow, SpriteFrame, Logs, cce, BlinkAnim, EnterCloseAnim, LongScreenFit, LoopMoveAnim, MoveAnim, RotateAnim, ScaleAnim, ShakeAnim, SkewAnim, ThirdMenuFit, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Scene = module.Scene;
      Widget = module.Widget;
      Sprite = module.Sprite;
      UITransform = module.UITransform;
      color = module.color;
      Label = module.Label;
      RichText = module.RichText;
      LabelOutline = module.LabelOutline;
      LabelShadow = module.LabelShadow;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      BlinkAnim = module.default;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      LongScreenFit = module.default;
    }, function (module) {
      LoopMoveAnim = module.default;
    }, function (module) {
      MoveAnim = module.default;
    }, function (module) {
      RotateAnim = module.default;
    }, function (module) {
      ScaleAnim = module.default;
    }, function (module) {
      ShakeAnim = module.default;
    }, function (module) {
      SkewAnim = module.default;
    }, function (module) {
      ThirdMenuFit = module.default;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('CCTools', void 0);

      cclegacy._RF.push({}, "42419YBv4JF1p1JGxfiAJkl", "CCTools", undefined);

      let CCTools;

      (function (_CCTools) {
        function getNodePath(node) {
          let path;

          while (node && !(node instanceof Scene)) {
            if (path) {
              path = node.name + "/" + path;
            } else {
              path = node.name;
            }

            node = node.parent;
          }

          return path;
        }

        _CCTools.getNodePath = getNodePath;

        function WidgetUpdateAlignment(target) {
          if (CC_EDITOR) return false;
          let changed = false; // LongScreenFit

          let lsf = target.getComponent(LongScreenFit);

          if (lsf != null && lsf.enabled) {
            lsf.onLoad();
            lsf.enabled = false;
            changed = true;
          } // cc.Widget


          let widget = target.getComponent(Widget);

          if (widget != null && widget.enabled) {
            widget.updateAlignment();

            if (widget.alignMode == Widget.AlignMode.ONCE || widget.alignMode == Widget.AlignMode.ON_WINDOW_RESIZE) {
              widget.destroy(); // widget.enabled = false;
            }

            changed = true;
          } // ThirdMenuFit


          let tmf = target.getComponent(ThirdMenuFit);

          if (tmf != null && tmf.enabled) {
            tmf.onLoad();
            tmf.enabled = false;
            changed = true;
          }

          return changed;
        }

        _CCTools.WidgetUpdateAlignment = WidgetUpdateAlignment;

        function WidgetsUpdateAlignment(target) {
          target.getComponentsInChildren(Widget).forEach(x => {
            if (x.getComponent(EnterCloseAnim)) {
              CCTools.WidgetUpdateAlignment(x.node);
            }
          });
        }

        _CCTools.WidgetsUpdateAlignment = WidgetsUpdateAlignment;

        function ResizeSprite(sprite) {
          if (!sprite || !sprite.node) return;
          sprite = sprite.getComponent(Sprite);
          if (!sprite) return;
          if (!sprite.spriteFrame) return;
          var rect = sprite.spriteFrame.getRect();
          sprite.node.getComponent(UITransform).setContentSize(rect.width, rect.height);
        }

        _CCTools.ResizeSprite = ResizeSprite;

        function SetNodeByParam(node, param) {
          if (!node || !param) return;
          node = node.node;
          if (!node) return;
          if (param.active != null) node.active = param.active;
          if (param.x != null) node.x = param.x;
          if (param.y != null) node.y = param.y;
          if (param.angle != null) node.angle = param.angle;
          if (param.anchorX != null) node.anchorX = param.anchorX;
          if (param.anchorY != null) node.anchorY = param.anchorY;
          if (param.skewX != null) node.skewX = param.skewX;
          if (param.skewY != null) node.skewY = param.skewY;
          if (param.scaleX != null) node.scaleX = param.scaleX;
          if (param.scaleY != null) node.scaleY = param.scaleY;

          if (param.scale != null) {
            node.scaleX = param.scale;
            node.scaleY = param.scale;
          }

          if (param.width != null) node.getComponent(UITransform).width = param.width;
          if (param.height != null) node.getComponent(UITransform).height = param.height;
          if (param.color != null) node.color = color(param.color[0], param.color[1], param.color[2]);
          if (param.opacity != null) node.opacity = param.opacity;

          if (param.label != null) {
            let label = node.getComponent(Label) || node.getComponent(RichText);

            if (label == null) {
              if (param.label.string && i18n.sel(param.label.string).contains("</")) label = node.addComponent(RichText);else label = node.addComponent(Label);
            }

            if (param.label.string != null) label.string = i18n.sel(param.label.string);
            if (param.label.fontSize != null) label.fontSize = param.label.fontSize;
            if (param.label.lineHeight != null) label.lineHeight = param.label.lineHeight;
            if (param.label.maxWidth != null) label.maxWidth = param.label.maxWidth;
            if (param.label.maxLines != null) label.maxLines = param.label.maxLines;
          }

          if (param.outline != null) {
            let labelOutline = node.getComponent(LabelOutline);

            if (!labelOutline) {
              labelOutline = node.addComponent(LabelOutline);
              let label = node.getComponent(Label);
              if (label) label.cacheMode = Label["CacheMode"].NONE;
            }

            if (labelOutline) {
              if (param.outline.color != null) labelOutline.color = color(param.outline.color[0], param.outline.color[1], param.outline.color[2]);
              if (param.outline.width != null) labelOutline.width = param.outline.width;
            }
          }

          if (param.shadow != null) {
            let labelShadow = node.getComponent(LabelShadow);

            if (!labelShadow) {
              labelShadow = node.addComponent("LabelShadow");
              let label = node.getComponent(Label);
              if (label) label.cacheMode = Label["CacheMode"].NONE;
            }

            if (labelShadow) {
              if (param.shadow.color != null) labelShadow.color = color(param.shadow.color[0], param.shadow.color[1], param.shadow.color[2]);
              if (param.shadow.opacity != null) labelShadow.opacity = param.shadow.opacity;
              if (param.shadow.dx != null) labelShadow.dx = param.shadow.dx;
              if (param.shadow.dy != null) labelShadow.dy = param.shadow.dy;
            }
          }

          if (param.sprite != null) {
            let sprite = node.getComponent(Sprite);
            if (sprite == null) sprite = node.addComponent(Sprite);
            let img = param.sprite.image;

            if (img && !CC_EDITOR) {
              if (img.startsWith("http")) {
                cce.loaderLoad({
                  url: img,
                  type: "png"
                }, function (err, v) {
                  if (err != null) {
                    Logs.Warning(err);
                    return;
                  }

                  if (!sprite || !node) return;
                  let sp = new SpriteFrame();
                  sp.texture = v;
                  sprite.spriteFrame = sp;
                }.bind(this));
              } else {
                let resName = "res/Activity/images/" + img;
                cce.loadRes(resName, SpriteFrame, function (err, v) {
                  if (err != null) {
                    Logs.Warning(err);
                    return;
                  }

                  if (!sprite || !node) return;
                  sprite.spriteFrame = v;
                }.bind(this));
              }
            }
          }

          if (param.blinkAnim != null) {
            let blinkAnim = node.getComponent(BlinkAnim);
            if (blinkAnim == null) blinkAnim = node.addComponent("BlinkAnim");
            if (param.blinkAnim.minAlpha != null) blinkAnim.minAlpha = param.blinkAnim.minAlpha;
            if (param.blinkAnim.maxAlpha != null) blinkAnim.maxAlpha = param.blinkAnim.maxAlpha;
            if (param.blinkAnim.duration != null) blinkAnim.duration = param.blinkAnim.duration;
            if (param.blinkAnim.delay != null) blinkAnim.delay = param.blinkAnim.delay;
          }

          if (param.moveAnim != null) {
            let moveAnim = node.getComponent(MoveAnim);
            if (moveAnim == null) moveAnim = node.addComponent("MoveAnim");
            if (param.moveAnim.dis != null) moveAnim.dis = param.moveAnim.dis;
            if (param.moveAnim.disx != null) moveAnim.disx = param.moveAnim.disx;
            if (param.moveAnim.time != null) moveAnim.time = param.moveAnim.time;
            if (param.moveAnim.delay != null) moveAnim.delay = param.moveAnim.delay;
          }

          if (param.loopMoveAnim != null) {
            let loopMoveAnim = node.getComponent(LoopMoveAnim);
            if (loopMoveAnim == null) loopMoveAnim = node.addComponent("LoopMoveAnim");
            if (param.loopMoveAnim.disy != null) loopMoveAnim.disy = param.loopMoveAnim.disy;
            if (param.loopMoveAnim.disx != null) loopMoveAnim.disx = param.loopMoveAnim.disx;
            if (param.loopMoveAnim.time != null) loopMoveAnim.time = param.loopMoveAnim.time;
            if (param.loopMoveAnim.delay != null) loopMoveAnim.delay = param.loopMoveAnim.delay;
          }

          if (param.rotateAnim != null) {
            let rotateAnim = node.getComponent(RotateAnim);
            if (rotateAnim == null) rotateAnim = node.addComponent("RotateAnim");
            if (param.rotateAnim.clockwise != null) rotateAnim.clockwise = param.rotateAnim.clockwise;
            if (param.rotateAnim.outDegree != null) rotateAnim.outDegree = param.rotateAnim.outDegree;
            if (param.rotateAnim.step != null) rotateAnim.step = param.rotateAnim.step;
            if (param.rotateAnim.time != null) rotateAnim.time = param.rotateAnim.time;
            if (param.rotateAnim.delay != null) rotateAnim.delay = param.rotateAnim.delay;
          }

          if (param.scaleAnim != null) {
            let scaleAnim = node.getComponent(ScaleAnim);
            if (scaleAnim == null) scaleAnim = node.addComponent("ScaleAnim");
            if (param.scaleAnim.minX != null) scaleAnim.minX = param.scaleAnim.minX;
            if (param.scaleAnim.maxX != null) scaleAnim.maxX = param.scaleAnim.maxX;
            if (param.scaleAnim.minY != null) scaleAnim.minY = param.scaleAnim.minY;
            if (param.scaleAnim.maxY != null) scaleAnim.maxY = param.scaleAnim.maxY;
            if (param.scaleAnim.time != null) scaleAnim.time = param.scaleAnim.time;
            if (param.scaleAnim.delay != null) scaleAnim.delay = param.scaleAnim.delay;
          }

          if (param.skewAnim != null) {
            let skewAnim = node.getComponent(SkewAnim);
            if (skewAnim == null) skewAnim = node.addComponent("SkewAnim");
            if (param.skewAnim.minX != null) skewAnim.minX = param.skewAnim.minX;
            if (param.skewAnim.maxX != null) skewAnim.maxX = param.skewAnim.maxX;
            if (param.skewAnim.minY != null) skewAnim.minY = param.skewAnim.minY;
            if (param.skewAnim.maxY != null) skewAnim.maxY = param.skewAnim.maxY;
            if (param.skewAnim.time != null) skewAnim.time = param.skewAnim.time;
            if (param.skewAnim.delay != null) skewAnim.delay = param.skewAnim.delay;
          }

          if (param.shakeAnim != null) {
            let shakeAnim = node.getComponent(ShakeAnim);
            if (shakeAnim == null) shakeAnim = node.addComponent("ShakeAnim");
            if (param.shakeAnim.wait != null) shakeAnim.wait = param.shakeAnim.wait;
            if (param.shakeAnim.degree != null) shakeAnim.degree = param.shakeAnim.degree;
            if (param.shakeAnim.time != null) shakeAnim.time = param.shakeAnim.time;
            if (param.shakeAnim.delay != null) shakeAnim.delay = param.shakeAnim.delay;
          }
        }

        _CCTools.SetNodeByParam = SetNodeByParam;
      })(CCTools || (CCTools = exports('CCTools', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/es.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "424693Z3IRJ+Z9XMnOW6wI7", "es", undefined);

      let es = exports('es', {
        APPNAME: "Sala de monedas",
        Accept: "Aceptar",
        ActivityAttackMasterButton: "LO TENGO",
        ActivityAttackMasterButtonTip: "¡Apueste más alto y más rápido!",
        ActivityAttackMasterDes: "Atacar {0} veces para obtener\n {1} monedas",
        ActivityAttackMasterDesMore: "<color=#562900>¡A mayor cantidad de barras que complete, mayores serán las </color> <outline color=#9E5A05 width=2><color=#F7E150>RECOMPENSAS!</color></outline>",
        ActivityAttackMasterFinal1: "Premio final de la barra:",
        ActivityAttackMasterFinal2: "{0} ¡Monedas!",
        ActivityAttackMasterTimeleft: "Finaliza en {0}",
        ActivityBuildKingDes: "¡Completa para obtener recompensas!",
        ActivityCenterTime: "Tiempo restante: {0}",
        ActivityCenterTimeEnd: "Fin de la Actividad",
        ActivityCenterTitle: "Centro de actividad",
        ActivityRaidMasterDes: "Asalta {0} veces para obtener\n {1} monedas",
        ActivityShopDes: "Tiempo de venta restante {0}",
        ActivitySlotCollectDes1: "Atacar",
        ActivitySlotCollectDes2: "Atacar Bloqueado",
        ActivitySlotCollectDes3: "Asalto",
        ActivitySlotCollectDes4: "Excelente asalto",
        ActivitySlotCollectDes5: "Golpear 3 Símbolos",
        ActivitySlotCollectRankGetJoin: "<outline color=5E2301 width=2>conseguir que <img src='{ 0 } _s' /> se una</outline>",
        ActivitySlotCollectRankGetStart: "Comienza a jugar para coleccionar",
        ActivitySlotCollectRankInfoLabel1: "<color=#88421c>¡Recoge <img src='{ 0 } _s'/> para.subtractir en la clasificación!</color>",
        ActivitySlotCollectRankInfoLabel2: "<outline color=#76320E width= 3>¡Apuesta más alto a múltiples cada <img src='{ 0 } _s'/> que recojas!</outline>",
        ActivitySlotCollectRankRewardDes: "Esto es lo que ganaste:",
        ActivitySlotCollectRankRewardDesLose: "Esta vez no ganaste, ¡pero aún así obtienes un premio!",
        ActivitySlotCollectRankRewardEnd: "Torneo ha terminado",
        ActivitySlotCollectRankRewardWinner: "¡GANADOR!",
        ActivitySpecialOfferCoin: "{0} Monedas",
        ActivitySpecialOfferSpin: "{0} Giros",
        ActivitySpecialOfferTitle: "Oferta sorpresa",
        ActivityTimeleft: "Tiempo restante",
        AdNotReady: "¡El video no está listo!",
        ApFull: "Lleno",
        ApPlus: "+{0} Giros",
        ApRecoverIn: "{0} giros en {1}",
        AppCommentBtn: "ENVIAR",
        AppCommentDes: "Toque una estrella para calificarla en la tienda",
        AppCommentNo: "NO AHORA",
        AppCommentTitle: "¿Te encanta Coin Room?",
        AppHotUpdateFail: "Falló la carga de recursos. ¿Intentar de nuevo?",
        AppUpdateBtn: "ACTUALIZACIÓN",
        AppUpdateDes: "¡Hay una nueva versión disponible! Actualizar ahora",
        AppUpdateNo: "No, gracias",
        AppUpdateTitle: "Nueva actualización",
        Attack: "ATAQUE",
        AutoSpinTipWindowButton: "¡Inténtalo!",
        AutoSpinTipWindowDes: "Mantenga presionado el botón para comenzar",
        AutoSpinTipWindowTitle: "GIRO AUTOMÁTICO",
        AutoSpining: "Auto",
        Back: "Atras",
        Bet: "APUESTA",
        BetRibbonText: "TODAS LAS VICTORIAS X{0}",
        BindFacebookBtn: "CONECTAR",
        BindFacebookFreespin: "Inicia sesión y obtén giros gratis",
        BindFacebookTip: "No publicaremos en su nombre",
        BindFacebookTitle: "Conectar con Facebook",
        BlackJackGameDeal: "DEAL",
        BlackJackGameDoubleDown: "DOBLE\nABAJO",
        BlackJackGameHit: "HIT",
        BlackJackGameStand: "STAND",
        BlackJackGameSurrender: "RENDICIÓN",
        BlackJackGameWatchBtn: "¡VER AHORA!",
        BlackJackHelpDes1: "En Blackjack, estás tratando de construir una mano con un valor más alto que la casa sin pasar de 21. Los ases pueden contar como 11 o 1. Las cartas de cara valen 10, y todas las demás cartas valen el número que muestran.",
        BlackJackHelpDes2: "Para jugar una ronda, primero debes hacer una apuesta tocando los botones de las fichas. Una vez que haya seleccionado su apuesta, presione el botón de reparto para comenzar.",
        BlackJackHelpDes3: "Use esta opción cuando desee Solicitar otra tarjeta. Puede golpear tantas veces como quiera, pero si supera los 21, pierde.",
        BlackJackHelpDes4: "Cuando haya terminado solicitando cartas, puedes pararte y dejar que la casa tome su turno.",
        BlackJackHelpDes5: "Si una mano tiene 2 cartas, tú puede usar esta opción para duplicar su apuesta y recibir UNA sola carta más por su mano.",
        BlackJackHelpDes6: "Cualquier mano que contenga un As y una carta de cara se llama un gato negro. El gato negro vence a cualquier otra mano y paga 3 a 2 por el jugador.",
        BlackJackHelpDes7: "Si la mano de un jugador tiene la misma valor como la casa, es un empujón. El jugador recibe su apuesta original.",
        BlackJackHelpDes8: "Se dice que un jugador revienta cuando su mano vale más de 21.",
        BlackJackHelpDes9: "Esta opción permite que un jugador reciba la mitad de su apuesta original a cambio de perder su mano.",
        BlackJackHelpDes10: "Consejo de movimiento resaltará el botón del movimiento sugerido durante el juego. El consejo de movimiento se basa en la fuerza estadística de la casa y las manos del jugador.",
        BlackJackHelpTitle1: "--Reglas básicas--",
        BlackJackHelpTitle2: "--Cómo jugar--",
        BlackJackHelpTitle3: "--Hit--",
        BlackJackHelpTitle4: "--Stand--",
        BlackJackHelpTitle5: "--Doble Abajo--",
        BlackJackHelpTitle6: "--Black Jack--",
        BlackJackHelpTitle7: "--Push--",
        BlackJackHelpTitle8: "--Bust--",
        BlackJackHelpTitle9: "--Rendición--",
        BlackJackHelpTitle10: "--Consejo de movimiento--",
        BlackJackTitle: "Black Jack",
        BlackJackWatchWindowDesLose: "¡Mira el video para recuperar la mitad de las pérdidas!",
        BlackJackWatchWindowDesWin: "¡Mira el video para obtener un 100% más de monedas!",
        COLLECT: "RECOGER",
        COLLECTED: "RECOGIDO",
        Cancel: "Cancelar",
        CardAllSetWindowBottom: "- Coin Room -",
        CardAllSetWindowCompleted: "Finalizada",
        CardAllSetWindowLock: "Se desbloquea en el\nCuarto {0}",
        CardAllSetWindowLocked: "Bloqueado",
        CardAllSetWindowTitle: "RECOPILACIÓN DE\nTARJETAS",
        CardAsk: "Solicitar",
        CardAskCannot: "No puede pedirse a amigos",
        CardAskCannotGolden: "Esta tarjeta es dorada, no puede pedirse a amigos",
        CardChestInfoWindowHigh: "Alta posibilidad de:",
        CardChestInfoWindowTitle_1: "Cofre de Madera",
        CardChestInfoWindowTitle_2: "Cofre de Plata",
        CardChestInfoWindowTitle_3: "Cofre de Oro",
        CardChestOpenWindowNew: "nueva",
        CardCollectButton: "Compruébalo",
        CardCollectDes: "La tarjeta {0}\n ha sido añadida a tu álbum",
        CardCollectTitle: "¡IMPRESIONANTE!",
        CardInfoWindowCommon: "Común",
        CardInfoWindowPage0_0: "Recopila tarjetas mediante cofres",
        CardInfoWindowPage0_1: "También puedes comprar cofres en la tienda",
        CardInfoWindowPage0_2: "Los cofres pueden encontrarse durante los asaltos o al desbloquear nuevos Cuartos",
        CardInfoWindowPage1_0: "Tener 2 o más tarjetas iguales te permite enviarlas como regalo a tus amigos",
        CardInfoWindowPage1_1: "Pulsa en la tarjeta para regalarla",
        CardInfoWindowPage1_2: "También puedes pedir a tus amigos las tarjetas que te falten",
        CardInfoWindowPage1_3: "Puedes enviar hasta 5 tarjetas en un día",
        CardInfoWindowPage2_0: "Stars indicate cards rarity",
        CardInfoWindowPage2_2: "Cada estrella de rareza en una tarjeta recién obtenida te da 1 estrella",
        CardInfoWindowPage2_3: "¡Completa juegos de cartas y obtén increíbles recompensas!",
        CardInfoWindowRare: "Rare",
        CardInfoWindowTitle: "Info de Tarjetas",
        CardOpenDes: "<color=#ffffff><outline color=#000000 width=1>Recopila tarjetas para \nobtener más <color=#ffcc00>Monedas</color> y <color=#c667ff>Giros</color></color></outline>",
        CardOpenDesS: "<color=#308ae6>Recopila tarjetas para obtener más <color=#e67b07>Monedas</color> y <color=#006fd7>Giros</color></color>",
        CardSelectCardWindowInfo: "Elige hasta {0} tarjetas",
        CardSelectCardWindowSelected: "Tus tarjetas seleccionadas:",
        CardSelectCardWindowSuccess: "¡Tarjetas enviadas correctamente!",
        CardSelectCardWindowTitle: "ENVIAR TARJETAS",
        CardSelectFriendWindowBtn: "Elige Tarjeta",
        CardSelectFriendWindowInfo: "ELIGE 1 AMIGO",
        CardSelectFriendWindowTitle: "ENVIAR TARJETAS",
        CardSend: "Enviar",
        CardSendCannot: "No puede enviarse a amigos",
        CardSendCannotGolden: "Esta tarjeta es dorada, no puede enviarse a amigos",
        CardSendCannotLeast: "Necesitas al menos 2 tarjetas para enviar",
        CardSendCannotLimit: "Has alcanzado el límite diario de tarjetas que puedes enviar",
        CardSingleSetWindowCompleted: "- SET COMPLETADO -",
        CardSingleSetWindowReward: "Completa para obtener",
        CardSingleSetWindowTip: "* Pulsa en una tarjeta duplicada para enviársela a un amigo",
        CardTradeButton: "¡A NEGOCIAR!",
        CardTradeDes: "¡AHORA SON NEGOCIABLES!",
        CardTradeTradable: "Canjeable",
        CardTapToCollect: "Toca para recolectar",
        ChatSend: "Enviar",
        CoinShopLevel: "Nivel {0}",
        CoinStore: "Tienda de monedas",
        Confirm: "Confirmar",
        Congratulation: "¡Felicitaciones!",
        ContentNameActivityItem6: "Bala de cañón",
        ContentNameActivityItemCommon: "Items",
        ContentNameAp: "Girar",
        ContentNameCard: "Tarjeta",
        ContentNameChest1: "Cofre de Madera",
        ContentNameChest2: "Cofre Mágico",
        ContentNameChest3: "Cofre Dorado",
        ContentNameChest4: "¡Cofre Gratis!",
        ContentNameCoin: "Monedas",
        ContentNameJigsaw: "Pieza de Rompecabezas",
        ContentNamePack: "Items",
        ContentNameShield: "Escudo",
        ContentNameUnknown: "???",
        CountDay: "{0}días",
        CountHour: "{0}horas",
        CountMinute: "{0}minutos",
        CountMonth: "{0}Meses",
        CountSecond: "{0}segundos",
        CountYear: "{0}Años",
        DailyBonusCollect: "RECOGER",
        DailyBonusFreeSpinDes: "1 Giro gratis en\n{0}",
        DailyBonusGoldFirst: "¡Por lo menos 25M de monedas por primera vez!",
        DailyBonusGoldSpinBtn: "Girar por {0}",
        DailyBonusLevel: "Nivel {0}",
        DailyBonusNormalSpinBtn: "GIRAR GRATIS",
        ErrorLogin: "Error al conectarse al servidor",
        ErrorMsg0: "Éxito",
        ErrorMsg1114: "Mira demasiados videos hoy",
        ErrorMsg1703: "¡Compra fallida!",
        ErrorNormal: "Conexión perdida al servidor",
        ErrorRetry: "Error al conectarse al servidor. ¿inténtalo de nuevo?",
        ExtraRewardDes: "¡Coin Room te ha regalado monedas y giros!",
        FirstPurchaseButton: "¡IR!",
        FirstPurchaseDes1: "Hacer cualquier compra a",
        FirstPurchaseDes2: "¡OBTENER RECOMPENSAS!",
        FormatHour: ":",
        FormatMinute: ":",
        FormatMonth: "/",
        FormatYear: "/",
        FriendsModelNoResult: "Sin Amigos",
        FriendsModelPlaceHolder: "Buscar nombre de amigo",
        GameMainWindowActivity: "ACTIVIDAD",
        GameMainWindowQuest: "MISIÓN",
        GetRewardWindowDes: "<outline color=#000000 width=1><color=#ffffff> ¡Tienes {0} recompensas !</color></outline>",
        GuestConfirmDes: "Los invitados no pueden \njugar con amigos",
        GuestConfirmGuest: "Jugar como invitado",
        GuestConfirmTitle: "¿Estás seguro?",
        Help_cannon: "1. ¡Acumula balas para atacar el castillo y conseguir grandes premios!\n2. Los anillos actualizan los premios del castillo.\n3. Las balas se obtienen con los giros y los alrededores del Cuarto.\n4. ¡Puedes cambiar tus objetos por recompensas de las cajas del tesoro!\n5. Las Joyas Mágicas pueden remplazar cualquier objeto.",
        Help_coinhit: "1. Usa un cupón para empezar a jugar. 2. Puedes conseguir muchas monedas y giros en reto 3. Más bloques rotos, más recompensas. 4. Ajusta el ángulo para darle a más bloques.",
        Help_jigsaw: "1. Recoja 9 piezas para\n obtener recompensas.\n2. Las piezas se \n recolectan en \n ranuras y evolución.\n3. Las piezas se\n eliminarán cuando\n finalice la actividad.\n4. El rompecabezas\n universal puede\n reemplazar cualquier\n pieza.",
        Help_sign: "1. Puede obtener\n mensualmente la\n recompensa de sesión\n cada 7 días en un mes.\n2. La sesión mensual se\n actualizará el próximo\n mes.\n3. Puede obtener\n recompensa de sesión\n semanal cada día\n por una semana. \n4. La sesión semanal se\n actualizará la siguiente\n semana.",
        InteractionAttackFriends: "AMIGOS",
        InteractionAttackName: "Habitación de {0}",
        InteractionAttackResultBlock: "<outline color=#000000 width=1><color=#29ffed> {0}</color> ha bloqueado tu ataque. Has ganado <color=#ffc209> {1}</color></outline>",
        InteractionAttackResultBlock2: "<outline color=#000000 width=1><color=#29ffed> {0}</color> ha bloqueado tu ataque. Has ganado <color=#ffc209> {1}</color></outline>",
        InteractionAttackResultSuccess: "<outline color = # 000000 width = 1> Atacaste la sala  ny de <color = # 29ffed> {0} </color> y ganaste <color = # ffc209> {1} </color> </outline>",
        InteractionAttackResultSuccess2: "<outline color=#000000 width=1> Has atacado el Cuarto de <color=#29ffed>{0}</color> y has ganado <color=#ffc209> {1}</color></outline>",
        InteractionAttackRevenge: "VENGANZA",
        InteractionBet: "OBTENER X{0}",
        InteractionRaidBrag: "Compartir",
        InteractionRaidCoinMaster: "Rey",
        InteractionRaidEmpty: "Falló",
        InteractionRaidName: "Retorno de {0}:",
        InteractionRaidPrefect: "Excelente asalto",
        InteractionRaidResultLine: "<outline color=#000000 width=1>Has saqueado <color=#29ffed>{0}</color> monedas de <color=#ffc209>{1}</color></outline>",
        InteractionRaidResultLine2: "<outline color=#000000 width=1>Has saqueado <color=#FFF0A4>{0}</color> monedas de <color=#ffc209>{1}</color></outline>",
        InteractionRaidStole: "Saqueado:",
        LeaderBoardWindowTabCountry: "País",
        LeaderBoardWindowTabFriends: "Amigos",
        LeaderBoardWindowTabGlobal: "Global",
        LeaderBoardWindowTip: "*Actualizar en 10 minutos",
        Level: "Nivel",
        LevelBonusDes1: "<outline color=#7d3d2f width=3><size=46><color=#fffe00>30</color></size> veces extra de bonificación\nTotalmente obtener <size=46><color=#7ee0f4>5000</color></size> spins!</outline>",
        LevelBonusDes2: "¡Obtén muchos niveles de recompensas de giros después de la compra!",
        LevelBonusItemDes: "Para el Cuarto 1",
        Loading: "Cargando",
        LoginWindowGuest: "Invitado",
        LoginWindowNeedUpdate: "Hay algunas actualizaciones",
        LoginWindowPlay: "JUGAR",
        LoginWithApple: "Iniciar sesión con Apple",
        LoginWindowUpdating: "Actualizando",
        LuckyDrawDes1: "Mira el video",
        LuckyDrawDes2: "Conseguir Posibilidad",
        LuckyDrawFree: "Gratis",
        MORE: "MáS",
        MultiplePurchaseBtn: "GIRAR",
        MultiplePurchaseDes1: "Gira para ganar hasta",
        MultiplePurchaseDes2: "x10",
        MultiplePurchaseDes3: "para {0} más",
        NO: "NO",
        NewPlayerPackButton: "COMPRAR AHORA!",
        NewPlayerPackDes1: "¡Bienvenidos a Coin Room!",
        NewPlayerPackDes2: "<outline color=#471F01 width=2>Preparamos un <color=#ffd63b>GRAN REGALO</c> para ti~</outline>",
        NewUserInvitedDes: "¡{0} ha desbloqueado un nuevo Cuarto!, obtienes \n {1} GIROS GRATIS",
        NewUserInvitedDesApp: "¡{0} se ha unido al juego! Obtienes \n{1} GIROS GRATIS",
        NewUserInvitedTitle: "RECOMPENSA DE AMIGOS",
        No: "NO",
        NotEnoughApAdd: "+{0} Giros",
        NotEnoughApDes: "¿No tiene giros?",
        NotEnoughApWait: "o espere {1} por {0} giros",
        NotEnoughApWait2: "Espera {1} por {0} giros",
        NotEnoughCoinDes: "¿No tiene monedas?",
        NotEnoughOff: "{0}% \nMÁS",
        NotificationDesActivity: "{0} terminará en una hora!",
        NotificationDesApFull: "Tenemos suficientes giros para jugar y obtener más monedas",
        NotificationDesAttack: "¡Alguien ha invadido tu Cuarto!",
        NotificationDesBack: "¡Preparamos un gran regalo para ti!",
        NotificationDesBack2: "¡Regresa! ¡Preparamos un gran regalo para ti!",
        NotificationDesDailyBonus: "¡Ven a jugar a la Rueda de la Fortuna diario!",
        NotificationTitleActivity: "¡La actividad terminará!",
        NotificationTitleApFull: "¡Tienes giros completos!",
        NotificationTitleAttack: "¡Vamos a vengarnos!",
        NotificationTitleBack: "¡Cuánto tiempo sin vernos!",
        NotificationTitleBack2: "¡Ven a jugar conmigo!",
        NotificationTitleDailyBonus: "¡El bono diario está disponible ahora!",
        Now10XBetter: "¡10 veces mejor!",
        OFF: "APAGAR",
        OK: "BIEN",
        OffText: "{0}%\n MÁS",
        PastDay: "{0}días pasados",
        PastHour: "{0}hrs atrás",
        PastMinute: "{0}mins atrás",
        PastMonth: "{0}mes pasado",
        PastSecond: "{0}segs atrás",
        PastYear: "{0}año pasado",
        PastZero: "Ahora",
        PayDisable: "¡Pago deshabilitado!",
        PayDisableFBIn: "Lo sentimos, la función de pago es actualmente incompatible con su sistema. Ingrese Coin Room a través de Instant Games para completar la compra en una computadora.",
        PayDisableIos: "Pago está deshabilitado en iOS!",
        PayEnabledAndroid: "¡El pago solo está habilitado en Android!",
        PayFail: "¡Compra fallida!",
        PayFailWindowBtn: "Contactar soporte",
        PayFailWindowDes: "¿Tiene problemas para comprar?",
        PayPending: "¡Tu compra está pendiente! Después de completar el pago, reinicia el juego para obtener objetos.",
        PaySuccess: "¡Gracias por su compra!",
        PeterOpenDes1: "¡El loro Peter te traerá un regalo al azar!",
        PeterOpenDes2: "¡Solo toca a Peter y recibe un regalo cuando llegue!",
        PlayerDefaultName: "Jugador",
        PriceSymbol: "$",
        Raid: "ASALTO",
        RaidProtect: "ASALTO PROTEGIDA",
        Rank: "Rango",
        Reconnect: "RECONECTAR",
        Restart: "Reiniciar",
        Retry: "Reintentar",
        START: "INICIO",
        SaleMark: "VENTA",
        Score: "Puntuación",
        ScorePoint: "Punto",
        ScoreRank: "Rango",
        ServantEffectDes1: "Aumenta el premio por asaltos",
        ServantEffectDes2: "Aumenta el premio por ataques",
        ServantEffectDes3: "Protege contra ataques",
        ServantEffectDes4: "Protege contra asaltos",
        ServantEffectNum1: "● Aumenta el premio en: {0}%",
        ServantEffectNum2: "● Aumenta el premio en: {0}%",
        ServantEffectNum3: "● Probabilidad de protección: {0}%",
        ServantEffectNum4: "● Probabilidad de protección: {0}%",
        ServantInfo1: "Mejorar sirviente:",
        ServantInfo2: "Cada giro de la máquina = 1 Exp Sirviente. Puede utilizar pociones para conseguir más Exp Sirviente. Cuando la barra de Exp Sirviente esté llena, haz clic en el botón de mejorar para mejorar tu sirviente. Cada mejora de sirviente aumentará tus estrellas",
        ServantInfo3: "Habilidad:",
        ServantInfo4: "La habilidad del sirviente mejora con cada.subtractida de nivel",
        ServantInfo5: "Activación:",
        ServantInfo6: "Alimenta a tu sirviente para activarlo. Consigue comida para sirvientes girando y construyendo",
        ServantName1: "Pigy",
        ServantName2: "Billy",
        ServantName3: "Doge",
        ServantName4: "Ruby",
        ServantNextLevel: "● Siguiente nivel: {0}% +",
        ServantOpenDes: "<outline color=#000000 width=1><color=#ffffff>Contrata sirvientes para obtener más <color=#ffcc00>Monedas</color> y <color=#c667ff>Giros</color></color></outline>",
        ServantOpenDesS: "<color=#308ae6>Contrata sirvientes para obtener más <color=#e67b07>Monedas</color> y <color=#006fd7>Giros</color></color>",
        ServantSelect: "Seleccionar",
        ServantUpgrade: "Ascender",
        ShareChooseDialogTitle: "Enviar",
        ShareDialogTitle: "Compartir",
        ShareInviteAttack: "¡GUAU! ¡Solo ataco la habitación de otros! Tan genial: -D",
        ShareInviteDialogTitle: "Invitar",
        ShareInviteFinishVillage: "¡Acabo de construir una nueva habitación! Ven y haz una visita :-D",
        ShareInviteNew: "¡Hey, este es realmente un juego increíble! Vamos a jugar juntos :-P",
        ShareInviteRaid: "¡WOW! ¡Acabo de saquear {0} monedas! Muy bien: -D",
        ShareInviteSendCoins: "{0} te ha dado algunas monedas :)",
        ShareInviteSendSpin: "{0} te ha dado un giro :)",
        ShareJigsawTitle: "Necesito estos. ¡Ayúdame!",
        ShareSendCard: "{0} te ha dado un tarjeta :)",
        ShareTitle: "¡Hey, este es realmente un juego increíble! Vamos a jugar juntos :-P",
        Shield: "ESCUDO",
        ShopAddPercent: "{0}% \nmás",
        ShopBestValue: "Mejor valor",
        ShopChestDisable: "Desbloqueo de cofres en el Zimmer {0}",
        ShopChests: "Cofres",
        ShopCoinPrice: "${0}",
        ShopCoins: "Monedas",
        ShopOff: "{0}%\nAPAGAR",
        ShopPopular: "Popular",
        ShopShield: "Super\nEscudo",
        ShopShieldDes1: "ESCUDOS DE PLATA",
        ShopShieldDes2: "ESCUDOS DE ORO",
        ShopShieldDes3: "Protege tu Cuarto",
        ShopShieldDes4: "Proteger contra:",
        ShopShieldDes5: "<color=#874423>Ataques & <color=#288bdf>Asaltos</color> (exclusivo)</color>",
        ShopSpinNum: "{0}",
        ShopSpinPrice: "${0}",
        ShopSpins: "Giros",
        ShopTitle: "Comprar",
        ShopTreatDisable: "Desbloqueo de regalos en el Cuarto {0}",
        ShopTreatFoodTime: "{0}h activación",
        ShopTreats: "Regalos",
        SlotBetNewMax: "Apuesta aumentado",
        SlotBetSuper: "SÚPER",
        SlotCoin6Video: "Mire un video y obtenga monedas x2",
        SlotPeterDesAd: "¡Tengo un regalo para ti!",
        SomeDay: "{0}días",
        SomeHour: "{0}hrs",
        SomeMinute: "{0}mins",
        SomeMonth: "{0}mes",
        SomeSecond: "{0}segs",
        SomeYear: "{0}año",
        SomeZero: "Ahora",
        Spins: "GIROS+{0}",
        SuperShieldOpenDes: "El Super Escudo protege tu Cuarto de Ataques & Asaltos por un largo periodo",
        ToRaidUserBet: "GANA X{0}",
        TutorialDialogDoSpin: "Usa la máquina tragamonedas para girar y atacar a otros.",
        TutorialDialogGoSpin: "Monedas insuficientes ...\n\nDeslízate hacia abajo para ganar más monedas.",
        TutorialDialogSlotAttack: "Ataca los Cuartos de otros jugadores para obtener monedas.",
        TutorialDialogSlotRaid: "¡Asalta el Cuarto del rey y saquea sus monedas!",
        TutorialDialogSlotRaidMaster: "Este es el Rey\n¡Vamos a asaltarlo!",
        TutorialDialogSlotShield: "Los escudos protegerán tu Cuarto de los ataques,",
        TutorialDialogStar: "Sube de nivel un item, para obtener una estrella.\n\nColecciona 25 estrellas para desbloquear el próximo Cuarto",
        TutorialFinishDes0: "Tus recompensas:",
        TutorialFinishDes1: "¡60 giros!",
        TutorialFinishDes1bind: "¡20 giros!",
        TutorialFinishDes2: "¡1M de monedas!",
        TutorialFinishDes3: "¡Guarda el progreso!",
        TutorialFinishDes4: "¡Juega con tus amigos!",
        TutorialFinishTitle: "¡Éxito!",
        TutorialStartDes: "¡Bienvenido mi amigo!\n\nPresione el botón para comenzar tu trabajo.",
        TutorialStartTitle: "TU PRIMER Cuarto",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        TutorialTargetName: "Objetivo",
        TutorialTargetName1: "Leyla",
        TutorialTargetName2: "Mary",
        TutorialTargetName3: "Kevin",
        VillageCompleteNext: "Siguiente",
        VillageCompleteTitle: "Cuarto Maduro",
        VillageShopBuy: "COMPRAR",
        VillageShopComplete: "¡COMPLETAR!",
        VillageShopFix: "AJUSTAR",
        VillageShopTitle: "Habitación EVOLVE",
        VipDailyRewardDes: "¡Consigue más TODOS LOS DÍAS!",
        VipExtraRewardButton: "CONSEGUIR TODOS",
        VipExtraRewardDes: "Desbloquea el VIP para conseguir TODOS los BONUS acumulados",
        VipGetTrialButtonDes1: "Comience gratis",
        VipGetTrialButtonDes2: "3 días de prueba gratis, luego {0} por mes",
        VipGetWindowButtonMonth: "MES",
        VipGetWindowButtonWeek: "SEMANA",
        VipGetWindowButtonYear: "AÑO",
        VipGetWindowDailyRecovery: "Límite de RECUPERACIÓN",
        VipGetWindowDailySpe: "<outline color=#000000 width=1><color=#FFFFFF>Mirada brillante con <color=#ffba00>nombre rojo</color> y <color=#ffba00>corona</color>!</color></outline>",
        VipGetWindowDailyTitle: "Recompensas diarias",
        VipGetWindowHot: "CALIENTE",
        VipGetWindowPolicy: "<color=#d1acf3>.Por un precio específico, el servicio VIP ofrece una suscripción, Giros, Comida y Carta todos los días. Se trata de una <color=#35e35e><u><on click=\"handle\" param=\"sub\">suscripción autorenovable</on></u></c>. El pago se cargará en la Cuenta del teléfono una vez confirmado. <color=#d1acf3>La suscripción se renovará automáticamente si no se cancela 24 h antes de que se acabe. La renovación se cargará en la cuenta también.</c> Cancela la renovación automática en Ajustes de Cuenta. Cualquier parte sin usar del periodo de prueba, si se ofreció, se perderá cuando el usuario adquiera una suscripción a esa publicación, si es aplicable. <color=#35e35e><u><on click=\"handle\" param=\"pri\">Condiciones y Términos de uso</on></u></c>.</c>",
        VipGetWindowRewardDes: "Consigue giros y monedas extras en las Tragaperras",
        VipGetWindowRewardRewards: "Recompensas",
        YES: "SÍ",
        Yes: "SÍ",
        adShieldTip: "¡escudo libre!",
        and: "y",
        cannon_get_reward_window_exchange: "Intercambiar",
        cannon_get_reward_window_title: "Intercambiar Recompensa",
        cannon_item_window_btn_regain: "Recuperar",
        cannon_item_window_btn_send: "Enviar",
        cannon_item_window_title: "INTERCAMBIAR",
        cannon_main_window_no_ball: "¡Sin balas!",
        cannon_main_window_refresh_check: "¿Usar los anillos para actualizar? ¡Todavía quedan {0} cajas!",
        cannon_main_window_refresh_time: "Auto actualizar\n",
        cannon_meesage_window_collect: "<color=#F48B03>{0}</color><color=#7E4B27> te envió un objeto </color><color=#19B8B2>{1}</color>",
        cannon_message_window_no_message: "Sin mensajes",
        cannon_message_window_send: "<color=#7E4B27>Has enviado </color><color=#F48B03>{0}</color><color=#7E4B27> el objeto </color><color=#19B8B2>{1}</color>",
        cannon_message_window_title: "Mensaje",
        cannon_name: "Cañón",
        cannon_send_item_window_choosed_friend: "Amigo elegido",
        cannon_send_item_window_choosed_item: "Objeto elegido",
        cannon_send_item_window_send: "Enviar",
        cannon_send_item_window_title: "Enviar objeto: Elegir un Amigo",
        cannon_shop_window_title: "¿Más bombas?",
        cannon_use_magic_item_window_cancel: "Cancelar",
        cannon_use_magic_item_window_confirm: "Confirmar",
        collectionFreeChest: "PECHO LIBRE",
        communityCardNoCards: "No he recibido tarjetas de \n tus amigos ",
        communityCommunity: "Comunidad",
        facebookF: "f",
        gifts_collect: "Coleccionar",
        gifts_collect_all: "Recoger/Enviar todos",
        gifts_collect_all2: "Recoger Todos",
        gifts_collect_coins: "Monedas diarias recolectadas {0}/{1}",
        gifts_collect_spins: "Giros diarios recolectados {0}/{1}",
        gifts_default_explain: "Obtener giros gratis",
        gifts_default_name: "Invitar amigos",
        gifts_explain_card_cantcollect: "Debe alcanzar el Cuarto {0} para recoger esta tarjeta",
        gifts_explain_card_collect: "Te ha enviado una tarjeta",
        gifts_explain_card_send: "Envia tarjetas\n a tus amigos",
        gifts_explain_coin_collect: "Te ha enviado {0} monedas",
        gifts_explain_coin_send: "Regalo de monedas gratis",
        gifts_explain_spin_collect: "Enviar {0} giro",
        gifts_explain_spin_send: "Regalo de giros gratis",
        gifts_invite: "Invitar",
        gifts_send: "Enviar",
        gifts_tab0: "Giros gratis",
        gifts_tab1: "Monedas gratis",
        gifts_tab2: "Tarjetas",
        gifts_title: "Regalos",
        heist_main_window_cannot_buy: "Desbloquee comprando la oferta anterior",
        heist_main_window_free: "Gratis",
        heist_main_window_title: "TOMA CADA TRATO PARA REVELAR MÁS",
        inviteNeedMoreSpins: "¿Necesitas más tiradas?",
        inviteUpper: "INVITACIÓN",
        invite_addnumber_type0: "+{0}",
        invite_invite: "INVITAR",
        invite_lineA: "<color=#FFFFFF><outline color=#000000 width=1>¡Invita amigos y obtén</outline></color><color=#4aff5f><outline color=#000000 width=1> {0} free spins</outline></color><color=#FFFFFF><outline color=#000000 width=1>\n{0} giros gratis </outline></color><color=#FFFFFF><outline color=#000000 width=1> por cada amigo que desbloquee un \nHabitación 2! < /color> ",
        invite_lineApp: "<color=#FFFFFF><outline color=#000000 width=1>¡Invita amigos y obtén </outline></color><color=#4aff5f><outline color=#000000 width=1> {0} free spins</outline></color><color=#FFFFFF><outline color=#000000 width=1>\n{0} giros gratis </outline></color><color=#FFFFFF><outline color=#000000 width=1> por cada amigo que se una!</color>",
        invite_note: "* Obtendrás una recompensa cuando tu amigo\n se conecte a través de Facebook",
        invite_title: "¿Quieres más giros?",
        jigsaw_friends_window_no_friends: "No tiene amigos.",
        jigsaw_friends_window_search_pre: "Buscar nombre de amigo",
        jigsaw_friends_window_send: "Enviar",
        jigsaw_friends_window_title: "AMIGOS",
        jigsaw_news_window_news_collect: "<color=#F48B03>{0} </color><color=#7E4B27> Te ha enviado la pieza </color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_news_send: "<color=#7E4B27>Has enviado a </color><color=#F48B03> {0} </color><color=#7E4B27> la pieza </color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_no_news: "No hay novedades.",
        jigsaw_news_window_title: "NOTICIAS",
        jigsaw_window_complete: "LLENAR TODO",
        jigsaw_window_send: "Enviar",
        jigsaw_window_title: "ROMPECABEZAS",
        jigsaw_window_universal_tip: "Elija una pieza para reemplazar",
        jigsaw_window_use: "UTILIZAR",
        jigsaw_window_used: "UTILIZADO",
        loadResError: "error en la carga recursos. ¿Inténtalo de nuevo?",
        map_comming_soon: "PRÓXIMAMENTE",
        map_title: "{0}. {1}",
        menu_0_play: "JUGAR",
        menu_1_village: "Habitación",
        menu_2_buy: "COMPRA MND/GIRO",
        menu_3_daily: "BONUS DIARIO",
        menu_4_shop: "Habitación EVOLVE",
        menu_5_news: "MENSAJE",
        menu_6_gifts: "REGALO",
        menu_7_card: "TARJETA",
        menu_8_map: "MAPA",
        menu_9_leaderboard: "TABLERO",
        menu_10_invite: "INVITAR",
        menu_11_setting: "AJUSTES",
        menu_title: "MENU",
        messageNoMail: "¡Aún no hay correos!",
        messageNoMessage: "¡Aún no hay mensajes!",
        mini_game_coinhit_btn_end: "conseguir recompensa",
        mini_game_coinhit_btn_next_round: "siguiente ronda",
        mini_game_coinhit_go: "¡IR!",
        mini_game_coinhit_info: "¡Un gran viaje para ganar\nmonedas, giros y cofres!",
        mini_game_coinhit_info_title: "RECOMPENSAS",
        mini_game_coinhit_manual_end: "¡Sí para obtener recompensas ahora! Conseguir moneda {0}, Conseguir giro {1}",
        mini_game_coinhit_manual_next_round: "¿Juego bloqueado? Sí para ir a la siguiente ronda",
        mini_game_coinhit_rank_info: "Bloquear Contador de Impactos: {0}",
        mini_game_coinhit_time: "Termina en {0}",
        mini_game_end: "Fin del juego",
        mini_game_fail: "Fallo al cargar el juego, inténtalo otra vez",
        mini_game_rank_window_no_ranks: "Sin Clasif",
        mini_game_rank_window_title: "CLASIFICACIÓN",
        minigame_buy_ticket_window_title: "¿Más cupones?",
        minigame_coinhit_second_title: "¡Ajusta el ángulo de disparo para romper más bloques y obtener mejores recompensas!",
        minigame_coinhit_title: "Acierta & Gana",
        minigame_gameover: "¡Has perdido!",
        minigame_start_game: "INICIO",
        minigame_time: "Acaba en {0}",
        multiplyX: "x",
        multiplyx: "x",
        quest_center_window_check: "Sesión",
        quest_center_window_check_do: "SESIÓN",
        quest_center_window_check_done: "FIRMADO",
        quest_center_window_daily: "Diario",
        quest_center_window_daily_get: "Recoger",
        quest_center_window_daily_go: "IR",
        quest_center_window_day_1: "Día 1",
        quest_center_window_day_2: "Día 2",
        quest_center_window_day_3: "Día 3",
        quest_center_window_day_4: "Día 4",
        quest_center_window_day_5: "Día 5",
        quest_center_window_day_6: "Día 6",
        quest_center_window_day_7: "Día 7",
        quest_center_window_invite: "Invitar",
        quest_center_window_main_quest_goal_reward: "Goal: {0}\nRecompensa: {1}",
        quest_center_window_main_quest_name: "Misión Principal: {0}",
        quest_center_window_month_box_7: "7 días",
        quest_center_window_month_box_14: "14 días",
        quest_center_window_month_box_21: "2 días",
        quest_center_window_month_box_28: "28 días",
        quest_center_window_refresh_dialog: "Las tareas se actualizan en un nuevo día, vuelva a abrir la ventana.",
        quest_center_window_refreshin: "Refrescar en",
        quest_center_window_title: "Centro de Misiones",
        revengeNoFriends: "¡No hay amigos todavía!",
        revenge_attack: "ataque",
        revenge_random: "aleatoria",
        revenge_revenge: "venganza",
        revenge_title_attack: "¡Ataca a tu amigo!",
        revenge_title_revenge: "¡Venganza!",
        servantADFree: "LIBRE ",
        settingLogOut: "Cerrar sesión",
        settingUid: "Uid: ",
        settingVersion: "Versión: ",
        setting_english: "Inglés",
        setting_general: "General",
        setting_language: "Idioma",
        setting_language_de: "Deutsch",
        setting_language_en: "English",
        setting_language_es: "Español",
        setting_language_fr: "Français",
        setting_language_title: "Idioma",
        setting_language_zh: "中文",
        setting_like: "ME GUSTA",
        setting_likeus: "Dale Me Gusta y no te pierdas\n eventos y regalos asombrosos",
        setting_lowbattery: "Modo de bajo consumo",
        setting_lowbattery_tip: "Abrir modo de bajo consumo reducirá el consumo de energía pero disminuirá el rendimiento",
        setting_music: "Música",
        setting_notifications: "Motificaciones",
        setting_privacy: "Política de privacidad",
        setting_raid: "Asalto y Ataque",
        setting_sound: "Sonido",
        setting_support: "Soporte",
        setting_terms: "Términos y condiciones",
        setting_title: "Configuración",
        setting_tutorial: "Tutorial",
        shopBestSeller: "El más vendido",
        shopCardInfoBuy: "Comprar",
        shopLevelBonus: "BONIFICACIÓN DE NIVEL",
        slotServantAdTip: "¡Dame de comer!",
        villageTownReward: "Recompensa de la ciudad",
        village_news_expire: "Caduca en {0}",
        village_news_log_hammer: "ha atacado tu Cuarto",
        village_news_log_hammer_vip: "ha atacado tu Cuarto",
        village_news_log_invite: "se ha unido a Coin Room",
        village_news_log_invite_vip: "se ha unido a Coin Room",
        village_news_log_noraid: "error al robarte {0}",
        village_news_log_noraid_vip: "<outline color=#FFFFFF width=2><color=#CC0905>{0}</color></outline><color=#662C1C> error al robarte {1}</color>",
        village_news_log_pig: "te ha saqueado {0}",
        village_news_log_pig_vip: "te ha saqueado {0}",
        village_news_log_shield: "ha intentado atacar tu Cuarto",
        village_news_log_shield_vip: "ha intentado atacar tu Cuarto",
        village_news_tab1: "Cuarto",
        village_news_tab2: "Correo",
        village_news_title: "Mensaje",
        watch_coin: "+{0} MONEDAS",
        watch_get: "ver un video y obtener",
        watch_spin: "+{0} GIROS",
        watch_watch: "VER",
        wxUserinfoDenyConfirm: "Accesar",
        wxUserinfoDenyDes: "Necesitamos su información",
        wxUserinfoDenyTitle: "Necesita acceso",
        wxVersionNoSupport: "La función actualmente es incompatible con la versión de su cliente, por favor actualice su wechat."
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitGameplay.ts", ['cc', './CCE_Component.ts', './SoundManager.ts', './SR.ts', './MinigameTools.ts', './MinigameCoinhitBall.ts', './MinigameCoinhitBlock.ts', './MinigameCoinhitPrefabMgr.ts', './MinigameCoinhitMainWindow.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, NodePool, misc, v2, isValid, instantiate, CCE_Component, SoundManager, SR, MinigameTools, MinigameCoinhitBall, MinigameCoinhitBlock, MinigameCoinhitPrefabMgr, MinigameCoinhitMainWindow, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      NodePool = module.NodePool;
      misc = module.misc;
      v2 = module.v2;
      isValid = module.isValid;
      instantiate = module.instantiate;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      MinigameTools = module.default;
    }, function (module) {
      MinigameCoinhitBall = module.default;
    }, function (module) {
      MinigameCoinhitBlock = module.default;
    }, function (module) {
      MinigameCoinhitPrefabMgr = module.default;
    }, function (module) {
      MinigameCoinhitMainWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "43361tSbidMwo4kYkvcgi5p", "MinigameCoinhitGameplay", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        BLOCK_COUNT: [3, 3, 3, 3, 3, 3, 3, 4, 4, 5],
        // 每行block个数以及其出现概率
        BLOCK_POSITION_X: [-200, -100, 0, 100, 200],
        // 每行block的x轴基础位置
        BLOCK_POSITION_FLOAT: 10,
        // block的浮动位置
        BLOCK_MOVE_TIME: 0.5,
        // block的上移时间
        BLOCK_MOVE_DISTANCE: 120,
        // block的上移距离
        SHOOTE_INTERVAL: 0.06,
        // 射击间隔
        PARAM_BASE: 10,
        // 数值基础，ball-count
        ROUND_LINE: [10, 20, 30, 50],
        // 回合分割线
        ROUND_MULTIPLE: [1, 2, 3, 5, 10],
        // 回合分割线对应的block-hit-count与ball-count的倍数，需要比回合分割线多1个，否则会造成bug
        BLOCK_BALL_HIT_COUNT: 1,
        // block-ball-plus-one的被击次数
        BLOCK_BOX_HIT_COUNT: 1,
        // block-box的被击次数
        BALL_PLUS_ONE_PROBABILITY: 0.9 // 球+1出现概率

      };
      /**
       * 内置小游戏：弹一弹
       * @要求
       * - 仅有一个prefab，一个gameplay主脚本，放在同一个文件夹内
       * - 可以单独打开和关闭prefab，通过内置游戏内部调用主游戏数据，不在主游戏内调用内置游戏
       * @游戏逻辑
       * - 重要外部逻辑，开始-结束
       * - 发射球
       * - 碰撞得分
       * - 方块下移
       */

      let MinigameCoinhitGameplay = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameCoinhitGameplay extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "state", "init");

          _initializerDefineProperty(this, "touch_area", _descriptor, this);

          _defineProperty(this, "ball_pool", new NodePool("MinigameCoinhitBall"));

          _defineProperty(this, "ball_count", C.PARAM_BASE);

          _defineProperty(this, "real_ball_count", this.ball_count);

          _initializerDefineProperty(this, "ball_parent", _descriptor2, this);

          _initializerDefineProperty(this, "ball_shooter", _descriptor3, this);

          _initializerDefineProperty(this, "pre_ball", _descriptor4, this);

          _initializerDefineProperty(this, "per_shoot_line", _descriptor5, this);

          _initializerDefineProperty(this, "block_parent", _descriptor6, this);

          _defineProperty(this, "now_block_position_y", 0);

          _defineProperty(this, "block_list", []);

          _defineProperty(this, "block_hit_count_base", 100);
        }

        onLoad() {
          MinigameCoinhitGameplay.ins = this;
        }

        onDestroy() {
          MinigameCoinhitGameplay.ins = null;
        }

        start() {
          this.game_init(); // game-start在window中点击调用
        }
        /**
         * 当前游戏状态
         * - pre:方向选择状态
         * - shoot:等待弹球结束状态
         * @type {"init"|"start"|"end"|"pre"|"shoot"}
         */


        is_game_state_end() {
          return this.state === "end";
        }

        is_game_state_pre() {
          return this.state === "pre";
        }

        is_game_able_to_start() {
          return this.state === "init" || this.state === "end";
        }

        is_game_able_to_end() {
          return this.state === "pre" || this.state === "shoot";
        }

        is_game_able_to_pre() {
          return this.state === "start" || this.state === "shoot";
        }

        game_init() {
          this.state = "init";
          this.touch_area.on(Node.EventType.TOUCH_START, this.on_touch_start, this);
          this.touch_area.on(Node.EventType.TOUCH_MOVE, this.on_touch_start, this);
          this.touch_area.on(Node.EventType.TOUCH_END, this.on_touch_end, this);
          this.create_ball_pool();
          this.game_clean();
        }

        game_clean() {
          this.touch_area.active = false;
          this.per_shoot_line.active = false;
          this.ball_shooter.angle = 0;
          this.ball_count = C.PARAM_BASE;
          this.real_ball_count = this.ball_count;
          MinigameCoinhitMainWindow.ins.update_label_real_ball_count("");
          MinigameCoinhitMainWindow.ins.data.clean_score();
          this.clear_block();
        }
        /** 游戏逻辑：开始游戏 */


        game_start() {
          if (!this.is_game_able_to_start()) {
            return;
          }

          this.state = "start";
          MinigameCoinhitMainWindow.ins.anima_hide_ui();
          this.touch_area.active = true;
          this.game_pre();
        }
        /** 游戏逻辑：结束游戏 */


        game_end() {
          if (!this.is_game_able_to_end()) {
            return;
          } // 只在特定的状态才允许结束


          this.state = "end";
          this.touch_area.active = false; // 动画

          MinigameCoinhitMainWindow.ins.anima_gameover().then(() => {
            // 与服务器交互
            let score = MinigameCoinhitMainWindow.ins.data.get_score_base();
            let coin = MinigameCoinhitMainWindow.ins.data.get_score_coin();
            let spin = MinigameCoinhitMainWindow.ins.data.get_score_spin();
            let req = SR.SRMinigameCoinhit.minigameCoinhitGetReward(Game.SUser.UserId(), MinigameCoinhitMainWindow.ins.data.get_activity_meta_id(), score, `1=0=${coin};2=0=${spin}`);
            req.SetSilence(true);
            req.SetCallBack(() => {
              this.scheduleOnce(() => {
                MinigameCoinhitMainWindow.ins.anima_show_ui();
                this.game_clean();
              }, 1);
            });
            req.Send();
          }, e => {});
        }
        /** 游戏回合准备 */


        game_pre() {
          if (!this.is_game_able_to_pre()) {
            return;
          }

          this.per_shoot_line.active = true;
          MinigameCoinhitMainWindow.ins.data.add_score_round(1);
          this.block_upstairs();
          this.create_block_line();
          MinigameCoinhitBall.reset();
          this.change_real_ball_count(this.ball_count);
          this.scheduleOnce(() => {
            if (this.is_game_able_to_pre()) this.state = "pre";
          }, C.BLOCK_MOVE_TIME);
        }
        /**
         * 游戏回合进行
         * @param {cc.Vec2} line_v 发射球的线速度
         */


        game_shoot(line_v) {
          this.state = "shoot";
          this.per_shoot_line.active = false; // 发射球

          this.shoot_ball(line_v);
        } // touch-event

        /** @type {cc.Node} */

        /** 触摸开始，方向选择
         * @param {cc.Event.EventTouch} event
         */


        on_touch_start(event) {
          if (!this.is_game_state_pre()) {
            return;
          }

          let touch_position = event.getLocation(); // 触点的世界坐标

          let touch_v2 = touch_position.subtract(MinigameTools.get_node_world_position(this.ball_shooter)); // 触点相对于发射点的向量

          this.per_shoot_line.scaleY = misc.clampf(touch_v2.magSqr() / 360000, 0.3, 1.1);
          let angle = MinigameTools.trans_radian_to_angle(touch_v2.signAngle(v2(0, -1)));
          angle = misc.clampf(angle, -70, 70);
          this.ball_shooter.angle = angle;
        }
        /** 触摸结束，发射
         * @param {cc.Event.EventTouch} event
         */


        on_touch_end(event) {
          if (!this.is_game_state_pre()) {
            return;
          }

          let touch_v2 = v2(0, -1).rotate(-MinigameTools.trans_angle_to_radian(this.ball_shooter.angle));
          let line_v = touch_v2.normalize().multiply(v2(1200, 1200));
          this.game_shoot(line_v);
        } //// 发射球相关逻辑

        /** @type {cc.NodePool} 球的对象池 */

        /** 创建球的对象池 */


        create_ball_pool() {
          this.ball_pool.clear();

          for (let i = 0; i < C.PARAM_BASE * 2; i += 1) {
            let n = MinigameCoinhitPrefabMgr.ins.get_ball();
            this.ball_pool.put(n);
          }
        }

        add_ball_count(v) {
          this.ball_count += v;
        }

        change_real_ball_count(count) {
          this.real_ball_count = count;
          MinigameCoinhitMainWindow.ins.update_label_real_ball_count(count);
        }
        /** @type {cc.Node} */

        /** 游戏逻辑：发射球
         * @param {cc.Vec2} line_v 发射的线速度
         */


        shoot_ball(line_v) {
          this.schedule(() => {
            let n;

            if (this.ball_pool.size() > 0) {
              n = this.ball_pool.get();
            } else {
              n = MinigameCoinhitPrefabMgr.ins.get_ball();
            }

            n.parent = this.ball_parent;
            n.position = this.ball_parent.convertToNodeSpaceAR(MinigameTools.get_node_world_position(this.pre_ball));
            n.getComponent(MinigameCoinhitBall).set_linev(line_v);
            this.change_real_ball_count(this.real_ball_count -= 1);
            SoundManager.playSound("mini_coinhit_shoot");
          }, C.SHOOTE_INTERVAL, this.ball_count - 1);
        } ///// block相关逻辑

        /** @type {cc.Node} */

        /** 清理block */


        clear_block() {
          this.now_block_position_y = 0;
          this.block_parent.destroyAllChildren();
          this.block_list = [];
        }
        /** 所有block上一个台阶 */


        block_upstairs() {
          this.block_list.filter(n => isValid(n)); // 去除销毁掉的node

          for (let i = 0; i < this.block_list.length; i += 1) {
            // destory有帧延迟，还需要再进行判定1次
            if (isValid(this.block_list[i])) {
              this.block_list[i].runAction(ccAction.sequence(ccAction.moveBy(C.BLOCK_MOVE_TIME, 0, C.BLOCK_MOVE_DISTANCE), ccAction.callFunc(() => {
                this.block_list[i].getComponent(MinigameCoinhitBlock).line++;
                this.block_list[i].getComponent(MinigameCoinhitBlock).check_position();
              })));
            }
          }
        }
        /** block被击次数的基础值 */

        /**
         * 根据回合数和球个数更新被击基础数
         */


        update_block_hit_count_base() {
          for (let i = 0; i < C.ROUND_LINE.length; i += 1) {
            if (MinigameCoinhitMainWindow.ins.data.get_score_round() < C.ROUND_LINE[i]) {
              this.block_hit_count_base = this.ball_count * C.ROUND_MULTIPLE[i];
              return;
            }
          }

          this.block_hit_count_base = this.ball_count * C.ROUND_MULTIPLE[C.ROUND_LINE.length];
        }
        /**
         * 创建单个block，包含动画
         * @param {cc.Prefab|cc.Node} prefab_or_node
         * @param {cc.Vec2} position
         * @param {number} hit_count
         */


        create_block(prefab_or_node, position, hit_count) {
          let n = instantiate(prefab_or_node);
          n.parent = this.block_parent; // 随机位置，包含进入动画

          position = v2(MinigameTools.number_float(position.x, C.BLOCK_POSITION_FLOAT), MinigameTools.number_float(position.y, C.BLOCK_POSITION_FLOAT));
          let source_position = position.add(v2(0, -C.BLOCK_MOVE_DISTANCE));
          n.position = source_position;
          n.opacity = 1;
          n.runAction(ccAction.spawn(ccAction.moveTo(C.BLOCK_MOVE_TIME, position), ccAction.fadeIn(C.BLOCK_MOVE_TIME))); // 随机角度

          let angle = MinigameTools.get_random_int(0, 360);
          n.getComponent(MinigameCoinhitBlock).set_rotation(angle);
          n.getComponent(MinigameCoinhitBlock).line = 1; // 随机被撞次数

          n.getComponent(MinigameCoinhitBlock).set_count(MinigameTools.number_float(hit_count, Math.trunc(hit_count * 0.2))); // 保存

          this.block_list.push(n);
        }
        /**
         * 游戏逻辑：创建一行block
         * - 每行共有5个位置，每次从中选择3~5个位置创建
         * - 根据score.round数目，选择新增球+1还是block
         */


        create_block_line() {
          // 获取这一行的位置数组
          let position_list = C.BLOCK_POSITION_X.map(x => v2(x, this.now_block_position_y));
          let position_index_list = C.BLOCK_POSITION_X.map((v, index) => index);
          let round = MinigameCoinhitMainWindow.ins.data.get_score_round(); // 创建球+1，前30回合每3回合创建一个

          if (round <= C.ROUND_LINE[2] && round % 3 === 0) {
            let index = MinigameTools.get_random_int(0, position_index_list.length);
            let type_index = position_index_list.splice(index, 1);
            this.create_block(MinigameCoinhitPrefabMgr.ins.get_ball_plus_one(), position_list[type_index[0]], C.BLOCK_BALL_HIT_COUNT);
          } // 创建奖励box（各1次）


          let type = C.ROUND_LINE.indexOf(round);

          if (type != -1 && type < 3) {
            let index = MinigameTools.get_random_int(0, position_index_list.length);
            let type_index = position_index_list.splice(index, 1);
            this.create_block(MinigameCoinhitPrefabMgr.ins.get_box(type), position_list[type_index[0]], C.BLOCK_BOX_HIT_COUNT);
          } // 创建4种基础block
          // 创建个数


          let line_count = Math.min(position_index_list.length, MinigameTools.get_random_item(C.BLOCK_COUNT));

          for (let i = 0; i < line_count; i += 1) {
            let index = MinigameTools.get_random_int(0, position_index_list.length);
            let type_index = position_index_list.splice(index, 1);
            this.create_block(MinigameCoinhitPrefabMgr.ins.get_random_block(), position_list[type_index[0]], this.block_hit_count_base);
          }
        }

      }, _defineProperty(_class3, "ins", null), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "touch_area", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "ball_parent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ball_shooter", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "pre_ball", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "per_shoot_line", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "block_parent", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageIconNode.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "437dcNEW+lAoaQ1QHLCeTMI", "VillageIconNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let VillageIconNode = exports('default', (_dec = property([SpriteFrame]), _dec2 = property([SpriteFrame]), _dec3 = property([SpriteFrame]), _dec4 = property([SpriteFrame]), _dec5 = property([SpriteFrame]), ccclass(_class = (_class2 = (_temp = class VillageIconNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "type1", _descriptor, this);

          _initializerDefineProperty(this, "type2", _descriptor2, this);

          _initializerDefineProperty(this, "type3", _descriptor3, this);

          _initializerDefineProperty(this, "type4", _descriptor4, this);

          _initializerDefineProperty(this, "type5", _descriptor5, this);
        }

        onLoad() {} //获取图片


        getSprite(type, level) {
          return this["type" + type.toString()][level - 1];
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "type1", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "type2", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "type3", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "type4", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "type5", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/_app.ts", ['cc', './CCEaseTypes.ts', './Logs.ts', './UIRoot.ts', './LogEventWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, resources, assetManager, Texture2D, ImageAsset, Vec3, instantiate, Label, director, tween, SpriteFrame, CCEaseTypes, UIRoot, LogEventWrap;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      resources = module.resources;
      assetManager = module.assetManager;
      Texture2D = module.Texture2D;
      ImageAsset = module.ImageAsset;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
      Label = module.Label;
      director = module.director;
      tween = module.tween;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function () {}, function (module) {
      UIRoot = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}],
    execute: function () {
      exports('cce', void 0);

      cclegacy._RF.push({}, "4468cCjhONK2ZXHfqiyR/4+", "_app", undefined); // export class CCE_Component extends cc.Component {
      //     private CCE_SLOWUPDATE_FRAME: number = 1/ 30
      //     __dt: any
      //     slowLateUpdate: any
      //     __ldt: any
      //     onLoad () {
      //         if (cc.sys.os === cc.sys.OS_IOS) this.CCE_SLOWUPDATE_FRAME = 1 / 20
      //     }
      //     protected update (dt) {
      //         if (!this.slowUpdate == null) {
      //             cc.director["_compScheduler"].updateInvoker.remove(this);
      //             this.update = null
      //             return
      //         }
      //         this.__dt = (this.__dt || 0) + dt
      //         if (this.__dt >= this.CCE_SLOWUPDATE_FRAME) {
      //             if (this.slowUpdate != null) this.slowUpdate(this.__dt);
      //             this.__dt = 0
      //         }
      //     }
      //     protected slowUpdate (dt) {};
      //     lateUpdate (dt?) {
      //         if (!this.slowLateUpdate == null) {
      //             cc.director["_compScheduler"].lateUpdateInvoker.remove(this);
      //             this.lateUpdate = null
      //             return
      //         }
      //         this.__ldt = (this.__ldt || 0) + dt
      //         if (this.__ldt >= this.CCE_SLOWUPDATE_FRAME) {
      //             if (this.slowLateUpdate != null) this.slowLateUpdate(this.__ldt);
      //             this.__ldt = 0
      //         }
      //     }
      // }


      let cce;

      (function (_cce) {
        const CCEaseTypes$1 = _cce.CCEaseTypes = CCEaseTypes;

        function pDistance(p1, p2) {
          return p1.subtract(p2).length();
        }

        _cce.pDistance = pDistance;

        function Window(p) {// return cc.Class(p)
        }

        _cce.Window = Window;
        let DepList = {};
        let loading = 0;

        function loadRes(resName, type, cb, onProgress) {
          loading++;

          var callback = function (err, res) {
            if (err) LogEventWrap.logEvent("http_res_fail", {
              res: resName,
              code: err.name,
              msg: err.message
            });

            if (err || !res) {
              loading--;
              if (cb) cb(err, null);
              return;
            }

            res._resName = resName;
            assetManager.dependUtil.getDepsRecursively(resName).forEach(x => {
              DepList[x] = DepList[x] || 0;
              DepList[x]++;
            });
            loading--;
            if (cb) cb(err, res);
          };

          if (type == SpriteFrame) {
            resName = resName + "/spriteFrame";
          } else if (type == Texture2D) {
            resName = resName + "/texture";
          }

          if (onProgress) {
            resources.load(resName, type, onProgress, callback);
          } else {
            resources.load(resName, type, function () {}, callback);
          }
        }

        _cce.loadRes = loadRes;

        function releaseRes(resName, type) {
          if (!resName) return;

          var _exe = function () {
            let deps = assetManager.dependUtil.getDepsRecursively(resName);
            let depHaveIds = [];
            deps.forEach(x => {
              if (DepList[x]) {
                DepList[x]--;
              }

              if (DepList[x]) depHaveIds.push(x);
            });
            /*if (type != cc.Prefab) {
            	if (depHaveIds.length > 0) return
            	cc.loader.releaseRes(resName, type)
            	return
            }*/

            depHaveIds.forEach(x => {
              deps.splice(x, 1);
            });
            resources.load(deps);
            if (depHaveIds.length > 0) return;
            resources.release(resName, type);
          };

          var exe = function () {
            setTimeout(() => {
              if (loading) {
                exe();
              } else {
                _exe();
              }
            }, 100);
          };

          exe();
        }

        _cce.releaseRes = releaseRes;

        function releaseSpriteFrame(sprite, res) {
          if (!sprite || !sprite.spriteFrame) return;
          if (res && sprite.spriteFrame._resName == res._resName) return;
          let _orn = sprite.spriteFrame._resName;

          if (_orn) {
            sprite.spriteFrame = null;
            releaseRes(_orn, SpriteFrame);
          }
        }

        _cce.releaseSpriteFrame = releaseSpriteFrame;

        function loaderLoad(res, cb, nologerror) {
          let url = res.url;
          let type = res.type;

          if (url.startsWith("http")) {
            assetManager.loadRemote(url, {
              ext: ".png",
              cacheEnabled: true
            }, (err, imageAsset) => {
              if (err == null && imageAsset != null) {
                // && sprite._avatar == tex._rawUrl
                const tex = new Texture2D();
                tex.image = imageAsset;
                if (cb) cb(err, tex);
                return;
              }
            });
          } // TODO


          {
            // cc.resources.load(res, (err, tex) => {
            //     if (!err) {
            //         tex["_rawUrl"] = url
            //     }
            //     if (cb) cb(err, tex)
            // })
            assetManager.downloader.downloadDomImage(url, {
              ext: '.png'
            }, (err, res) => {
              let img2 = new ImageAsset(res);
              const tex = new Texture2D();
              tex.image = img2;
              if (cb) cb(err, tex); // const spf = new cc.SpriteFrame();
              // spf.texture = tex;
              // if (sprite.node) {
              // 	sprite.spriteFrame = spf;
              // }
            }); // cc.assetManager.loadRemote(url, (err, tex) => {
            // 	if (!err) {
            // 		tex["_rawUrl"] = url;
            // 	}
            // 	let texture = new cc.Texture2D();
            // 	texture.image = tex;
            // 	if (cb) cb(err, texture);
            // });
          }
        }

        _cce.loaderLoad = loaderLoad;

        function showToast(context, position = Vec3.ZERO) {
          const toastNode = instantiate(UIRoot.instance.pbToast);
          toastNode.getComponent(Label).string = context;
          director.getScene().getChildByName("Canvas").addChild(toastNode);
          toastNode.setPosition(position);
          tween(toastNode).by(1, {
            y: 200,
            opacity: -255
          }).call(() => {
            toastNode.destroy();
          }).start();
        }

        _cce.showToast = showToast;

        function wait(time) {
          return new Promise(resolve => {
            setTimeout(() => {
              resolve(null);
            }, time);
          });
        }

        _cce.wait = wait;

        function loadDragonBones(resPath, completeCallBack) {
          return new Promise((resolve, reject) => {
            resources.loadDir(resPath, (err, assets) => {
              if (err || assets.length <= 0) {
                console.log("load dragonBones assets error: ", err);
              }

              resolve(assets);
              !!completeCallBack && completeCallBack(assets);
            });
          });
        }

        _cce.loadDragonBones = loadDragonBones;
      })(cce || (cce = exports('cce', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRSign.ts", ['cc', './GameMainWindow.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameMainWindow, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRSign', void 0);

      cclegacy._RF.push({}, "45cfcuhTy9GwoxLJRbBW7Dz", "SRSign", undefined); // 获取签到信息


      let SRSign;

      (function (_SRSign) {
        function getSignData() {
          let req = new GameKit.ServerRequest("getSignData");
          req.SetCallBack(res => {
            GameKit.DataCache.SetData("signData", res.sign);
          });
          return req;
        }

        _SRSign.getSignData = getSignData;

        function receiveSignWeekReward(day) {
          let req = new GameKit.ServerRequest("receiveSignWeekReward");
          req.SetCallBack(() => {
            let signData = GameKit.DataCache.GetData("signData");
            signData.signWeekRewards = signData.signWeekDay;
            GameKit.DataCache.SetData("signData", signData);
            if (GameMainWindow.instance != null) homeView.slotPage.updateQuestBadge();
          });
          req.SetRequestBody("day", day);
          return req;
        }

        _SRSign.receiveSignWeekReward = receiveSignWeekReward;

        function receiveSignMonthReward(day) {
          let req = new GameKit.ServerRequest("receiveSignMonthReward");
          req.SetRequestBody("day", day);
          req.SetCallBack(() => {
            let signData = GameKit.DataCache.GetData("signData");
            signData.signMonthRewards.push(day);
            GameKit.DataCache.SetData("signData", signData);
            if (GameMainWindow.instance != null) homeView.slotPage.updateQuestBadge();
          });
          return req;
        }

        _SRSign.receiveSignMonthReward = receiveSignMonthReward;
      })(SRSign || (SRSign = exports('SRSign', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShareWrap.ts", ['cc', './Logs.ts', './fbIn_lib.ts', './wx_lib.ts', './LoadingWindow.ts', './SdkManager.ts', './StaticGame.ts', './LogEventWrap.ts', './NativeWrap.ts', './CocosHack.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, UITransform, director, find, Camera, RenderTexture, error, game, view, Vec3, Color, Director, gfx, Logs, fbInTools, wxTools, LoadingWindow, SdkManager, Game, LogEventWrap, NativeWrap, getNativeUrl, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      UITransform = module.UITransform;
      director = module.director;
      find = module.find;
      Camera = module.Camera;
      RenderTexture = module.RenderTexture;
      error = module.error;
      game = module.game;
      view = module.view;
      Vec3 = module.Vec3;
      Color = module.Color;
      Director = module.Director;
      gfx = module.gfx;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function (module) {
      getNativeUrl = module.getNativeUrl;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('ShareWrap', void 0);

      cclegacy._RF.push({}, "46e962+KZ9MjL/mJidVR/EC", "ShareWrap", undefined);

      let ShareWrap;

      (function (_ShareWrap) {
        function getBase64(img, withUserAvatar = false) {
          let getBase64Image = function (img, width, height, img2, posx, posy, width2, height2) {
            //width、height调用时传入具体像素值，控制大小 ,不传则默认图像大小
            let canvas = document.createElement("canvas");
            canvas.width = width ? width : img.width;
            canvas.height = height ? height : img.height;
            let ctx = canvas.getContext("2d");
            ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
            if (img2) ctx.drawImage(img2, posx, posy, width2 || img2.width, height2 || img2.height);
            let dataURL = canvas.toDataURL();
            return dataURL;
          };

          return new Promise(function (resolve, reject) {
            if (img) {
              let image = new Image();
              image.crossOrigin = '';
              image.src = img;

              image.onload = function () {
                if (withUserAvatar) {
                  let image2 = new Image();
                  image2.crossOrigin = '';
                  image2.src = Game.SUser.Avatar();

                  image2.onload = function () {
                    resolve(getBase64Image(image, null, null, image2, 45, 90, 140, 140)); //将base64传给done上传处理
                  };
                } else {
                  resolve(getBase64Image(image)); //将base64传给done上传处理
                }
              };
            } else {
              reject("no img");
            }
          });
        }

        _ShareWrap.getBase64 = getBase64;

        function arrayBufferToBase64(raw) {
          let base64 = '';
          let encodings = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
          let bytes = raw;
          let byteLength = bytes.byteLength;
          let byteRemainder = byteLength % 4;
          let mainLength = byteLength - byteRemainder;
          let a, b, c, d;
          let chunk; // Main loop deals with bytes in chunks of 3

          for (let i = 0; i < mainLength; i = i + 4) {
            // Combine the three bytes into a single integer
            chunk = bytes[i] << 16 | bytes[i + 1] << 8 | bytes[i + 2]; // Use bitmasks to extract 6-bit segments from the triplet

            a = (chunk & 16515072) >> 18; // 16515072 = (2^6 - 1) << 18

            b = (chunk & 258048) >> 12; // 258048 = (2^6 - 1) << 12

            c = (chunk & 4032) >> 6; // 4032 = (2^6 - 1) << 6

            d = chunk & 63; // 63 = 2^6 - 1
            // Convert the raw binary segments to the appropriate ASCII encoding

            base64 += encodings[a] + encodings[b] + encodings[c] + encodings[d];
          } // Deal with the remaining bytes and padding


          if (byteRemainder == 1) {
            chunk = bytes[mainLength];
            a = (chunk & 252) >> 2; // 252 = (2^6 - 1) << 2;
            // Set the 4 least significant bits to zero

            b = (chunk & 3) << 4; // 3 = 2^2 - 1;

            base64 += encodings[a] + encodings[b] + '==';
          } else if (byteRemainder == 2) {
            chunk = bytes[mainLength] << 8 | bytes[mainLength + 1];
            a = (chunk & 16128) >> 8; // 16128 = (2^6 - 1) << 8;

            b = (chunk & 1008) >> 4; // 1008 = (2^6 - 1) << 4;
            // Set the 2 least significant bits to zero

            c = (chunk & 15) << 2; // 15 = 2^4 - 1;

            base64 += encodings[a] + encodings[b] + encodings[c] + '=';
          }

          return "data:image/jpeg;base64," + base64;
        }

        _ShareWrap.arrayBufferToBase64 = arrayBufferToBase64;

        function getScreen(rect) {
          let node = new Node();
          node.addComponent(UITransform);
          director.getScene().addChild(node);
          let camera = find("Canvas/SnapCamera").getComponent(Camera); // 设置你想要的截图内容的 cullingMask

          camera.visibility = 0xffffffff; // 新建一个 RenderTexture，并且设置 camera 的 targetTexture 为新建的 RenderTexture，这样 camera 的内容将会渲染到新建的 RenderTexture 中。

          let texture = new RenderTexture(); // let gl = game._renderContext;
          // 如果截图内容中不包含 Mask 组件，可以不用传递第三个参数

          texture.initialize({
            width: Math.floor(node.getComponent(UITransform).width),
            height: Math.floor(node.getComponent(UITransform).height)
          });
          camera.targetTexture = texture; // 渲染一次摄像机，即更新一次内容到 RenderTexture 中
          //TODO
          // camera.render(node);
          // 这样我们就能从 RenderTexture 中获取到数据了
          //TODO
          // let data = texture.readPixels(null, view.getVisibleSize().width/2+rect.x-rect.width/2, view.getVisibleSize().height/2+rect.y-rect.height/2, rect.width, rect.height);

          let data;

          let filpYImage = function (data, width, height) {
            // create the data array
            let picData = new Uint8Array(width * height * 4);
            let rowBytes = width * 4;

            for (let row = 0; row < height; row++) {
              let srow = height - 1 - row;
              let start = srow * width * 4;
              let reStart = row * width * 4; // save the piexls data

              for (let i = 0; i < rowBytes; i++) {
                picData[reStart + i] = data[start + i];
              }
            }

            return picData;
          };

          if (CC_JSB) {
            let filePath = jsb.fileUtils.getWritablePath() + 'render_to_sprite_image.png';
            data = filpYImage(data, rect.width, rect.height);
            let success = jsb.saveImageData(data, rect.width, rect.height, filePath);

            if (success) {
              return filePath;
            } else {
              error("save image data failed!");
            }

            return null;
          } // 接下来就可以对这些数据进行操作了


          let canvas = document.createElement('canvas');
          let ctx = canvas.getContext('2d');
          let width = rect.width;
          let height = rect.height;
          canvas.width = width;
          canvas.height = height;
          let rowBytes = width * 4;

          for (let row = 0; row < height; row++) {
            let srow = height - 1 - row;
            let imageData = ctx.createImageData(width, 1);
            let start = srow * width * 4;

            for (let i = 0; i < rowBytes; i++) {
              imageData.data[i] = data[start + i];
            }

            ctx.putImageData(imageData, 0, row);
          }

          let dataURL = canvas.toDataURL("image/jpeg");
          return dataURL;
        }

        _ShareWrap.getScreen = getScreen;

        function share(title, imageurl, data, callback, source, withUserAvatar = false, failcallback = null) {
          data = data || {};
          data.inviteId = Game.SUser.UserId();

          if (wxTools.usewx) {
            wxTools.ShareCommon({
              title: title,
              imageUrl: wxTools.PathToWxPath(imageurl),
              query: wxTools.QueryObjectToString(data)
            });
            if (callback != null) callback();
          } else if (fbInTools.usefbIn) {
            ShareWrap.getBase64(getNativeUrl(imageurl, true), withUserAvatar).then(function (base64Picture) {
              //console.log(base64);//处理成功打印在控制台
              FBInstant.shareAsync({
                intent: data.intent || "SHARE",
                image: base64Picture,
                text: title,
                data: data
              }).then(function (res) {
                if (callback != null) callback();
                LogEventWrap.logEvent("ShareDetail", {
                  source: source,
                  result: 1
                });
              }).catch(function () {
                LogEventWrap.logEvent("ShareDetail", {
                  source: source,
                  result: 0
                });
                if (failcallback != null) failcallback();
              });
            }).catch(function (err) {
              Logs.Warning("getBase64 error", err); //打印异常信息

              if (failcallback != null) failcallback();
            });
          } else if (SdkManager.IsNative()) {
            let obj = {};
            obj.title = title;
            if (data.url) obj.url = data.url;
            if (imageurl) obj.imagePath = getNativeUrl(imageurl);
            NativeWrap.call("ShareClass", "ShareObject", obj, function (info) {
              if (info.success) {
                if (callback != null) callback();
              } else {
                if (failcallback != null) failcallback();
              }
            });
          } else {
            Logs.Info("share", title, imageurl, data);
            if (callback != null) callback();
          }

          LogEventWrap.logEvent("game_share", {
            source: source
          });
          LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "d6jjao" : "7pis8w"); //aj_share
        }

        _ShareWrap.share = share;

        function shareScreen(title, rect, data, callback, source, withUserAvatar = false, failcallback = null, targetNode) {
          data = data || {};
          data.inviteId = Game.SUser.UserId();

          if (wxTools.usewx) {
            let ra = game.canvas.width / view.getVisibleSize().width;
            wxTools.ShareCommon({
              title: title,
              imageUrl: game.canvas.toTempFilePathSync({
                x: game.canvas.width / 2 + (rect.x - rect.width / 2) * ra,
                y: game.canvas.height / 2 - (rect.y + rect.height / 2) * ra,
                width: rect.width * ra,
                height: rect.height * ra,
                destWidth: 500,
                destHeight: 400
              }),
              query: wxTools.QueryObjectToString(data)
            });
            if (callback != null) callback();
          } else if (fbInTools.usefbIn) {
            FBInstant.shareAsync({
              intent: data.intent || "SHARE",
              image: ShareWrap.getScreen(rect),
              text: title,
              data: data
            }).then(function () {
              if (callback != null) callback();
              LogEventWrap.logEvent("ShareDetail", {
                source: source,
                result: 1
              });
            }).catch(function () {
              LogEventWrap.logEvent("ShareDetail", {
                source: source,
                result: 0
              });
              if (failcallback != null) failcallback();
            });
          } else if (SdkManager.IsNative()) {
            if (Game.SUser.IsFacebook()) {
              let obj = {};
              obj.message = title;
              obj.title = i18n.t("ShareDialogTitle");
              obj.imagePath = capture(targetNode); //ShareWrap.getScreen(rect)

              obj.data = JSON.stringify({
                inviteId: Game.SUser.UserId()
              });
              if (data.url) obj.url = data.url;
              NativeWrap.call("FBSdk", "shareImage", obj, function (info) {
                if (info.success) {
                  if (callback != null) callback();
                } else {
                  if (failcallback != null) failcallback();
                }
              });
            } else {
              let obj = {};
              obj.title = title;
              if (data.url) obj.url = data.url;
              obj.imagePath = ShareWrap.getScreen(rect);
              NativeWrap.call("ShareClass", "ShareObject", obj, function (info) {
                if (info.success) {
                  if (callback != null) callback();
                } else {
                  if (failcallback != null) failcallback();
                }
              });
            }
          } else {
            console.log(capture(targetNode));
            Logs.Info("share", title, rect, data);
            if (callback != null) callback();
          }

          LogEventWrap.logEvent("game_share", {
            source: source
          });
          LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "d6jjao" : "7pis8w"); //aj_share
        }

        _ShareWrap.shareScreen = shareScreen;

        function inviteNew(title, imageurl, data, callback, source, withUserAvatar = false, failcallback = null) {
          data = data || {};
          data.inviteId = Game.SUser.UserId();

          if (wxTools.usewx) {
            ShareWrap.share(title, imageurl, data, callback, source, withUserAvatar, failcallback);
          } else if (fbInTools.usefbIn) {
            let _inviteNew = function () {
              Logs.Log("after context", FBInstant.context.getID());
              ShareWrap.getBase64(fbInTools.PathToFBInPath(imageurl), withUserAvatar).then(function (base64Picture) {
                //console.log(base64Picture);//处理成功打印在控制台
                FBInstant.updateAsync({
                  action: 'CUSTOM',
                  template: source || "play_turn",
                  image: base64Picture,
                  text: title,
                  data: data,
                  //strategy: 'IMMEDIATE',
                  notification: 'PUSH'
                }).then(function () {
                  Logs.Info("Invite Over");
                }).catch(function (e) {
                  Logs.Warning("ShareWrap.inviteNew3", e);
                });
                if (callback != null) callback();
              }).catch(function (e) {
                Logs.Warning("ShareWrap.inviteNew2", e);
                if (failcallback != null) failcallback();
              });
              LogEventWrap.logEvent("ChooseDetail", {
                source: source,
                result: 1
              });
            }; ///FB new api?


            FBInstant.context.chooseAsync({
              filter: ['NEW_CONTEXT_ONLY']
            }) // FBInstant.context.chooseAsync({ filter:['NEW_PLAYERS_ONLY'] })
            .then(function () {
              _inviteNew();
            }).catch(function (e) {
              if (e.code === "SAME_CONTEXT") {
                _inviteNew();
              } else if (e.code === "USER_INPUT") {
                LogEventWrap.logEvent("ChooseDetail", {
                  source: source,
                  result: 0
                });
                if (failcallback != null) failcallback();
              } else {
                Logs.Warning("ShareWrap.inviteNew1", e);
                LogEventWrap.logEvent("ChooseDetail", {
                  source: source,
                  result: 0
                });
                if (failcallback != null) failcallback();
              }
            });
          } else if (SdkManager.IsNative()) {
            if (Game.SUser.IsFacebook() && false) {
              let obj = {};
              obj.message = title;
              obj.title = i18n.t("ShareInviteDialogTitle");
              obj.data = JSON.stringify({
                inviteId: Game.SUser.UserId()
              });
              NativeWrap.call("FBSdk", "shareInvite", obj, function (info) {
                if (info.success) {
                  if (callback != null) callback();
                } else {
                  if (failcallback != null) failcallback();
                }
              });
            } else {
              ShareWrap.share(title, imageurl, data, callback, source, withUserAvatar, failcallback);
            }
          } else {
            if (callback != null) callback();
          }
        }

        _ShareWrap.inviteNew = inviteNew;

        function chooseOne(id, title, imageurl, data, callback, source, withUserAvatar = false, failcallback = null) {
          data = data || {};
          data.inviteId = Game.SUser.UserId();

          if (wxTools.usewx) {
            //ShareWrap.share(null, title, imageurl, data, callback, source)
            if (callback != null) callback();
          } else if (fbInTools.usefbIn) {
            LoadingWindow.Show();

            let __chooseOne = function (cName, cPhoto) {
              ShareWrap.getBase64(fbInTools.PathToFBInPath(imageurl), withUserAvatar).then(function (base64Picture) {
                FBInstant.updateAsync({
                  action: 'CUSTOM',
                  template: source || "play_turn",
                  image: base64Picture,
                  text: title,
                  data: data,
                  //strategy: 'IMMEDIATE',
                  notification: 'PUSH'
                }).then(function () {
                  Logs.Info("Choose Over");
                }).catch(function (e) {
                  Logs.Warning("ShareWrap.chooseOne3", e);
                });
                if (callback != null) callback();
              }).catch(function (e) {
                Logs.Warning("ShareWrap.chooseOne2", e);
                LoadingWindow.Hide();
                if (failcallback != null) failcallback();
              });
            };

            let _chooseOne = function () {
              Logs.Log("after context", FBInstant.context.getID());
              FBInstant.context.getPlayersAsync().then(function (players) {
                let findOne = false;

                for (let i = 0; i < players.length; i++) {
                  if (players[i].getID() == id) {
                    let cName = players[i].getName();
                    let cPhoto = players[i].getPhoto();

                    __chooseOne();

                    findOne = true;
                    break;
                  }
                }

                if (!findOne) {
                  __chooseOne();
                }
              }).catch(e => {
                LoadingWindow.Hide();
                if (failcallback != null) failcallback();
              });
              LogEventWrap.logEvent("CreateDetail", {
                source: source,
                result: 1
              });
            };

            FBInstant.context.createAsync(id).then(function () {
              _chooseOne();
            }).catch(function (e) {
              if (e.code === "SAME_CONTEXT") {
                _chooseOne();
              } else if (e.code === "USER_INPUT") {
                LogEventWrap.logEvent("CreateDetail", {
                  source: source,
                  result: 0
                });
                LoadingWindow.Hide();
                if (failcallback != null) failcallback();
              } else {
                Logs.Warning("ShareWrap.chooseOne1", e);
                LogEventWrap.logEvent("CreateDetail", {
                  source: source,
                  result: 0
                });
                LoadingWindow.Hide();
                if (failcallback != null) failcallback();
              }
            });
          } else if (SdkManager.IsNative()) {
            if (Game.SUser.IsFacebook() && false) {
              let obj = {};
              obj.message = title;
              obj.title = i18n.t("ShareChooseDialogTitle");
              obj.data = JSON.stringify({
                inviteId: Game.SUser.UserId()
              });
              if (typeof id == "string") id = [id];
              obj.ids = id;
              NativeWrap.call("FBSdk", "sharePlayers", obj, function (info) {
                if (info.success) {
                  if (callback != null) callback();
                } else {
                  if (failcallback != null) failcallback();
                }
              });
            } else {
              if (callback != null) callback();
            }
          } else {
            if (callback != null) callback();
          }
        }

        _ShareWrap.chooseOne = chooseOne;

        function shareFbUrl(url, source, callback, failcallback) {
          NativeWrap.call("FBSdk", "share", {
            url: url
          }, function (info) {
            if (info.success) {
              if (callback != null) callback();
            } else {
              if (failcallback != null) failcallback();
            }
          });
          LogEventWrap.logEvent("game_share", {
            source: source
          });
          LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "d6jjao" : "7pis8w"); //aj_share
        }

        _ShareWrap.shareFbUrl = shareFbUrl;

        function capture(targetNode, rect) {
          return new Promise(resolve => {
            const rt = new RenderTexture();
            const trans = targetNode.getComponent(UITransform);
            const width = Math.floor(trans.width);
            const height = Math.floor(trans.height);
            rt.reset({
              width,
              height
            });
            let needRemove = false;

            if (!targetNode.parent) {
              targetNode.parent = this.node;
              needRemove = true;
            }

            let node = new Node();
            node.parent = targetNode;
            const camera = node.addComponent(Camera);
            camera.projection = Camera.ProjectionType.ORTHO;
            node.setPosition(new Vec3(0, 0, camera.far / 2));
            camera.orthoHeight = height / 2;
            camera.clearDepth = Camera.ClearFlag.DEPTH_ONLY;
            camera.clearColor = new Color(0, 0, 0, 0);
            camera.visibility = 1024;
            camera.targetTexture = rt;
            setLayerRecursively(targetNode, 1024);
            director.once(Director.EVENT_AFTER_DRAW, () => {
              let arrayBuffer = new ArrayBuffer(rt.width * rt.height * 4);
              let region = new gfx.BufferTextureCopy();
              region.texOffset.x = 0;
              region.texOffset.y = 0;
              region.texExtent.width = rt.width;
              region.texExtent.height = rt.height;
              director.root.device.copyFramebufferToBuffer(rt.window.framebuffer, arrayBuffer, [region]);
              rt.destroy();
              restoreLayerRecursively(targetNode);
              node.destroy();

              if (needRemove) {
                targetNode.removeFromParent();
              }

              const canvas = document.createElement('canvas');
              const ctx = canvas.getContext('2d');
              canvas.width = width;
              canvas.height = height;
              ctx.putImageData(new ImageData(new Uint8ClampedArray(arrayBuffer), width, height), 0, 0); // let data = new Uint8ClampedArray(arrayBuffer);
              // let rowBytes = width * 4; 
              // for (let row = 0; row < height; row++) {
              //     let srow = height - 1 - row;
              //     let imageData = ctx.createImageData(width, 1);
              //     let start = srow * width * 4;
              //     for (let i = 0; i < rowBytes; i++) {
              //         imageData.data[i] = data[start + i];
              //     }
              //     ctx.putImageData(imageData, 0, row);
              // }

              const dataURL = canvas.toDataURL('image/png');
              console.log("dataURL: ", dataURL); // let href = dataURL.replace(/^data:image[^;]*/, "data:image/octet-stream");
              // document.location.href = href;

              resolve(dataURL);
            });
          });
        }

        _ShareWrap.capture = capture;

        function setLayerRecursively(node, layer) {
          let arr = [node];

          for (let i = 0; i < arr.length; i++) {
            let child = arr[i];
            child["__bk_layer"] = child.layer;
            child.layer = layer;
            child.children.forEach(v => arr.push(v));
          }
        }

        function restoreLayerRecursively(node) {
          let arr = [node];

          for (let i = 0; i < arr.length; i++) {
            var _child$__bk_layer;

            let child = arr[i];
            let layer = (_child$__bk_layer = child["__bk_layer"]) !== null && _child$__bk_layer !== void 0 ? _child$__bk_layer : child.layer;
            delete child["__bk_layer"];
            child.layer = layer;
            child.children.forEach(v => arr.push(v));
          }
        }
      })(ShareWrap || (ShareWrap = exports('ShareWrap', {})));

      window["ShareWrap"] = ShareWrap;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/yzAd.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "47797RwYc1Cu4R4UTFEl2ba", "yzAd", undefined);

      function wait(duration, callBack) {
        return new Promise((resolve, reject) => {
          let time = null;
          time = setTimeout(() => {
            clearTimeout(time);
            resolve(null);
            if (callBack) callBack();
          }, duration);
        });
      }

      class Emiter {
        constructor() {
          _defineProperty(this, "maps", {});

          _defineProperty(this, "uid", 0);

          _defineProperty(this, "_duringEmit", false);
        }

        add(name, handler, thisObject, priority, isOnce) {
          thisObject = thisObject || null;
          priority = priority || 0;
          let queue_id = this.uid++;
          let item = this.maps[name] || [];
          item.push([queue_id, handler, thisObject, priority, isOnce]);
          this.maps[name] = item; //倒序

          item.sort((a, b) => a[3] < b[3]);
          return queue_id;
        }

        on(name, handler, thisObject, priority) {
          return this.add(name, handler, thisObject, priority, false);
        }

        once(name, handler, thisObject, priority) {
          return this.add(name, handler, thisObject, priority, true);
        }

        rm(id, name) {
          let names = name ? [name] : Object.keys(this.maps);

          for (let name of names) {
            let handlers = this.maps[name];
            if (!handlers) continue;

            if (this._duringEmit) {
              this.maps[name] = handlers = handlers.concat();
            }

            let index = 0;

            while (index < handlers.length) {
              let [queue_id, handler, thisObject, priority, isOnce] = handlers[index];

              if (queue_id == id) {
                handlers.splice(index, 1);
                return true;
              } else {
                index++;
              }
            }
          }

          return false;
        }

        rmall(name) {
          if (name == undefined) this.maps = {};else delete this.maps[name];
        }

        emit(name, data) {
          let handlers = this.maps[name];

          if (handlers && handlers.length > 0) {
            let index = 0;

            while (index < handlers.length) {
              let [queue_id, handler, thisObject, priority, isOnce] = handlers[index];
              isOnce ? handlers.splice(index, 1) : index++;
              this._duringEmit = true;
              let result = handler.call(thisObject, data);
              this._duringEmit = false;
              if (result == Emiter.CONST.break) break;
            }

            return true;
          }

          return false;
        }

      }

      _defineProperty(Emiter, "CONST", {
        break: {}
      });

      class Advertise extends Emiter {
        constructor(iads, rads, autoPreload = true) {
          super();

          _defineProperty(this, "_intersitialAd", null);

          _defineProperty(this, "_rewardVideo", null);

          this.iads = iads;
          this.rads = rads;
          this.suportAD() && autoPreload &&
          /*this.preloadIAD(),*/
          this.preloadRAD();
        }

        suportAD() {
          let apis = FBInstant.getSupportedAPIs();
          return apis.indexOf("getRewardedVideoAsync") > -1 && apis.indexOf("getInterstitialAdAsync") > -1;
        }

        hasIAD() {
          return !!this._intersitialAd;
        }

        async preloadIAD() {
          let arr = this.iads.concat();
          let i = 0;

          while (true) {
            let index = i++ % arr.length;

            try {
              let inst = await FBInstant.getInterstitialAdAsync(arr[index]);
              await inst.loadAsync();
              this._intersitialAd = inst;
              this.emit("iad_ready");
              break;
            } catch (e) {
              if (e.code == "ADS_FREQUENT_LOAD") {
                await wait(2 * 60 * 1000);
              } else if (e.code == "ADS_TOO_MANY_INSTANCES") {
                await wait(10 * 60 * 1000);
              }
            }

            await wait(index == 2 ? 2 * 60 * 1000 : 5e3);
          }
        }

        async showIAD() {
          let inst = this._intersitialAd;

          if (!inst) {
            await new Promise((resolve, reject) => {
              this.once("iad_ready", resolve);
            });
            inst = this._intersitialAd;
          }

          this._intersitialAd = null;
          await inst.showAsync();
          this.preloadIAD();
        }

        hasRAD() {
          return !!this._rewardVideo;
        }

        async preloadRAD() {
          let arr = this.rads.concat();
          let i = 0;

          while (true) {
            let index = i++ % arr.length;

            try {
              let inst = await FBInstant.getRewardedVideoAsync(arr[index]);
              await inst.loadAsync();
              this._rewardVideo = inst;
              this.emit("rad_ready");
              break;
            } catch (e) {
              console.log("ad error", e);

              if (e.code == "ADS_FREQUENT_LOAD") {
                await wait(2 * 60 * 1000);
              } else if (e.code == "ADS_TOO_MANY_INSTANCES") {
                await wait(10 * 60 * 1000);
              }
            }

            await wait(index == 2 ? 2 * 60 * 1000 : 5e3);
          }
        }

        async showRAD() {
          let inst = this._rewardVideo;

          if (!inst) {
            await new Promise((resolve, reject) => {
              this.once("rad_ready", resolve);
            });
            inst = this._rewardVideo;
          }

          this._rewardVideo = null;
          await inst.showAsync();
          this.preloadRAD();
        }

      }

      exports('Advertise', Advertise);
      window["yzad_Advertise"] = Advertise; //*/

      /*
      var __extends = (this && this.__extends) || (function () {
          var extendStatics = function (d, b) {
              extendStatics = Object.setPrototypeOf ||
                  ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                  function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
              return extendStatics(d, b);
          }
          return function (d, b) {
              extendStatics(d, b);
              function __() { this.constructor = d; }
              d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
          };
      })();
      var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
          return new (P || (P = Promise))(function (resolve, reject) {
              function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
              function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
              function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
              step((generator = generator.apply(thisArg, _arguments || [])).next());
          });
      };
      var __generator = (this && this.__generator) || function (thisArg, body) {
          var _ = { label: 0, sent() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
          return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
          function verb(n) { return function (v) { return step([n, v]); }; }
          function step(op) {
              if (f) throw new TypeError("Generator is already executing.");
              while (_) try {
                  if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                  if (y = 0, t) op = [op[0] & 2, t.value];
                  switch (op[0]) {
                      case 0: case 1: t = op; break;
                      case 4: _.label++; return { value: op[1], done: false };
                      case 5: _.label++; y = op[1]; op = [0]; continue;
                      case 7: op = _.ops.pop(); _.trys.pop(); continue;
                      default:
                          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                          if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                          if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                          if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                          if (t[2]) _.ops.pop();
                          _.trys.pop(); continue;
                  }
                  op = body.call(thisArg, _);
              } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
              if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
          }
      };
        Object.defineProperty(exports, "__esModule", { value: true });
      function closure(method) {
          var args = [];
          for (var _i = 1; _i < arguments.length; _i++) {
              args[_i - 1] = arguments[_i];
          }
          return function () {
              var params = [];
              for (var _i = 0; _i < arguments.length; _i++) {
                  params[_i] = arguments[_i];
              }
              return method.apply(null, args.concat(params));
          };
      }
      function wait(duration, callBack) {
          return new Promise(function (resolve, reject) {
              var time = null;
              time = setTimeout(function () {
                  clearTimeout(time);
                  resolve(null);
                  if (callBack)
                      callBack();
              }, duration);
          });
      }
      var Emiter = (function () {
          function Emiter() {
              this.maps = {};
              this.uid = 0;
              this._duringEmit = false;
          }
          Emiter.prototype.add = function (name, handler, thisObject, priority, isOnce) {
              thisObject = thisObject || null;
              priority = priority || 0;
              var queue_id = this.uid++;
              var item = this.maps[name] || [];
              item.push([queue_id, handler, thisObject, priority, isOnce]);
              this.maps[name] = item;
              //倒序
              item.sort(function (a, b) { return a[3] < b[3]; });
              return queue_id;
          };
          Emiter.prototype.on = function (name, handler, thisObject, priority) {
              return this.add(name, handler, thisObject, priority, false);
          };
          Emiter.prototype.once = function (name, handler, thisObject, priority) {
              return this.add(name, handler, thisObject, priority, true);
          };
          Emiter.prototype.rm = function (id, name) {
              var names = name ? [name] : Object.keys(this.maps);
              for (var _i = 0, names_1 = names; _i < names_1.length; _i++) {
                  var name_1 = names_1[_i];
                  var handlers = this.maps[name_1];
                  if (!handlers)
                      continue;
                  if (this._duringEmit) {
                      this.maps[name_1] = handlers = handlers.concat();
                  }
                  var index = 0;
                  while (index < handlers.length) {
                      var _a = handlers[index], queue_id = _a[0], handler = _a[1], thisObject = _a[2], priority = _a[3], isOnce = _a[4];
                      if (queue_id == id) {
                          handlers.splice(index, 1);
                          return true;
                      }
                      else {
                          index++;
                      }
                  }
              }
              return false;
          };
          Emiter.prototype.rmall = function (name) {
              if (name == undefined)
                  this.maps = {};
              else
                  delete this.maps[name];
          };
          Emiter.prototype.emit = function (name, data) {
              var handlers = this.maps[name];
              if (handlers && handlers.length > 0) {
                  var index = 0;
                  while (index < handlers.length) {
                      var _a = handlers[index], queue_id = _a[0], handler = _a[1], thisObject = _a[2], priority = _a[3], isOnce = _a[4];
                      isOnce ? handlers.splice(index, 1) : index++;
                      this._duringEmit = true;
                      var result = handler.call(thisObject, data);
                      this._duringEmit = false;
                      if (result == Emiter.CONST.break)
                          break;
                  }
                  return true;
              }
              return false;
          };
          Emiter.CONST = {
              break: {}
          };
          return Emiter;
      }());
      var Advertise = (function (_super) {
          __extends(Advertise, _super);
          function Advertise(iads, rads, autoPreload) {
              if (autoPreload === void 0) { autoPreload = true; }
              var _this = _super.call(this) || this;
              _this.iads = iads;
              _this.rads = rads;
              _this._intersitialAd = null;
              _this._rewardVideo = null;
              _this.suportAD() && autoPreload && (_this.preloadRAD());
              return _this;
          }
          Advertise.prototype.suportAD = function () {
              var apis = FBInstant.getSupportedAPIs();
              return apis.indexOf("getRewardedVideoAsync") > -1 && apis.indexOf("getInterstitialAdAsync") > -1;
          };
          Advertise.prototype.hasIAD = function () {
              return !!this._intersitialAd;
          };
          Advertise.prototype.preloadIAD = function () {
              return __awaiter(this, void 0, void 0, function () {
                  var arr, i, index, inst, e_1;
                  return __generator(this, function (_a) {
                      switch (_a.label) {
                          case 0:
                              arr = this.iads.concat();
                              i = 0;
                              _a.label = 1;
                          case 1:
                              if (!true) return [3 , 12];
                              index = i++ % arr.length;
                              _a.label = 2;
                          case 2:
                              _a.trys.push([2, 5, , 10]);
                              return [4 , FBInstant.getInterstitialAdAsync(arr[index])];
                          case 3:
                              inst = _a.sent();
                              return [4 , inst.loadAsync()];
                          case 4:
                              _a.sent();
                              this._intersitialAd = inst;
                              this.emit("iad_ready");
                              return [3 , 12];
                          case 5:
                              e_1 = _a.sent();
                              if (!(e_1.code == "ADS_FREQUENT_LOAD")) return [3 , 7];
                              return [4 , wait(2 * 60 * 1000)];
                          case 6:
                              _a.sent();
                              return [3 , 9];
                          case 7:
                              if (!(e_1.code == "ADS_TOO_MANY_INSTANCES")) return [3 , 9];
                              return [4 , wait(10 * 60 * 1000)];
                          case 8:
                              _a.sent();
                              _a.label = 9;
                          case 9: return [3 , 10];
                          case 10: return [4 , wait(index == 2 ? 2 * 60 * 1000 : 5e3)];
                          case 11:
                              _a.sent();
                              return [3 , 1];
                          case 12: return [2 ];
                      }
                  });
              });
          };
          Advertise.prototype.showIAD = function () {
              return __awaiter(this, void 0, void 0, function () {
                  var inst;
                  var _this = this;
                  return __generator(this, function (_a) {
                      switch (_a.label) {
                          case 0:
                              inst = this._intersitialAd;
                              if (!!inst) return [3 , 2];
                              return [4 , new Promise(function (resolve, reject) {
                                      _this.once("iad_ready", resolve);
                                  })];
                          case 1:
                              _a.sent();
                              inst = this._intersitialAd;
                              _a.label = 2;
                          case 2:
                              this._intersitialAd = null;
                              return [4 , inst.showAsync()];
                          case 3:
                              _a.sent();
                              this.preloadIAD();
                              return [2 ];
                      }
                  });
              });
          };
          Advertise.prototype.hasRAD = function () {
              return !!this._rewardVideo;
          };
          Advertise.prototype.preloadRAD = function () {
              return __awaiter(this, void 0, void 0, function () {
                  var arr, i, index, inst, e_2;
                  return __generator(this, function (_a) {
                      switch (_a.label) {
                          case 0:
                              arr = this.rads.concat();
                              i = 0;
                              _a.label = 1;
                          case 1:
                              if (!true) return [3 , 12];
                              index = i++ % arr.length;
                              _a.label = 2;
                          case 2:
                              _a.trys.push([2, 5, , 10]);
                              return [4 , FBInstant.getRewardedVideoAsync(arr[index])];
                          case 3:
                              inst = _a.sent();
                              return [4 , inst.loadAsync()];
                          case 4:
                              _a.sent();
                              this._rewardVideo = inst;
                              this.emit("rad_ready");
                              return [3 , 12];
                          case 5:
                              e_2 = _a.sent();
                              console.log("ad error", e_2)
                              if (!(e_2.code == "ADS_FREQUENT_LOAD")) return [3 , 7];
                              return [4 , wait(2 * 60 * 1000)];
                          case 6:
                              _a.sent();
                              return [3 , 9];
                          case 7:
                              if (!(e_2.code == "ADS_TOO_MANY_INSTANCES")) return [3 , 9];
                              return [4 , wait(10 * 60 * 1000)];
                          case 8:
                              _a.sent();
                              _a.label = 9;
                          case 9: return [3 , 10];
                          case 10: return [4 , wait(index == 2 ? 2 * 60 * 1000 : 5e3)];
                          case 11:
                              _a.sent();
                              return [3 , 1];
                          case 12: return [2 ];
                      }
                  });
              });
          };
          Advertise.prototype.showRAD = function () {
              return __awaiter(this, void 0, void 0, function () {
                  var inst;
                  var _this = this;
                  return __generator(this, function (_a) {
                      switch (_a.label) {
                          case 0:
                              inst = this._rewardVideo;
                              if (!!inst) return [3 , 2];
                              return [4 , new Promise(function (resolve, reject) {
                                      _this.once("rad_ready", resolve);
                                  })];
                          case 1:
                              _a.sent();
                              inst = this._rewardVideo;
                              _a.label = 2;
                          case 2:
                              this._rewardVideo = null;
                              return [4 , inst.showAsync()];
                          case 3:
                              _a.sent();
                              this.preloadRAD();
                              return [2 ];
                      }
                  });
              });
          };
          return Advertise;
      }(Emiter));
        //*/

      /*
      function closure(method, ...args) {
          return (params) => method.apply(null, [args, params]);
      }
        function wait(duration, callBack) {
          return new Promise((resolve, reject) => {
              let time = null;
              time = setTimeout(() => {
                  clearTimeout(time);
                  resolve(null);
                  if (callBack) callBack();
              }, duration)
          });
      }
        class Emiter {
            constructor() {
              this.maps = {};
              this.uid = 0;
              this._duringEmit = false;
          }
            add(name, handler, thisObject, priority, isOnce) {
              thisObject = thisObject || null;
              priority = priority || 0;
              let queue_id = this.uid++;
              let item = this.maps[name] || [];
              item.push([queue_id, handler, thisObject, priority, isOnce]);
              this.maps[name] = item;
                //倒序
              item.sort((a, b) => a[3] < b[3]);
                return queue_id;
          }
            on(name, handler, thisObject , priority ) {
              return this.add(name, handler, thisObject, priority, false);
          }
          once(name, handler, thisObject , priority ) {
              return this.add(name, handler, thisObject, priority, true);
          }
            rm(id, name ) {
              let names = name ? [name] : Object.keys(this.maps);
              for (let name of names) {
                  let handlers = this.maps[name];
                  if (!handlers) continue;
                    if (this._duringEmit) {
                      this.maps[name] = handlers = handlers.concat();
                  }
                    let index = 0;
                  while (index < handlers.length) {
                      let [queue_id, handler, thisObject, priority, isOnce] = handlers[index];
                      if (queue_id == id) {
                          handlers.splice(index, 1)
                          return true;
                      } else {index++;}
                  }
              }
              return false;
          }
            rmall(name ) {
              if (name == undefined)
                  this.maps = {};
              else
                  delete this.maps[name];
          }
            emit(name, data ) {
              let handlers = this.maps[name];
              if (handlers && handlers.length > 0) {
                  let index = 0;
                  while (index < handlers.length) {
                      let [queue_id, handler, thisObject, priority, isOnce] = handlers[index];
                      isOnce ? handlers.splice(index, 1) : index++;
                      this._duringEmit = true;
                      let result = handler.call(thisObject, data)
                      this._duringEmit = false;
                      if (result == Emiter.CONST.break)break
                  }
                  return true;
              }
              return false;
          }
      }
      Emiter.CONST = {
          break: {}
      };
        class Advertise extends Emiter {
          constructor(iads, rads, autoPreload = true) {
              super();
                this.iads = iads
              this.rads = rads
                this._intersitialAd = null
              this._rewardVideo = null
                this.suportAD() && autoPreload &&(this.preloadRAD());
          }
            suportAD() {
              let apis = FBInstant.getSupportedAPIs();
              return apis.indexOf("getRewardedVideoAsync") > -1 && apis.indexOf("getInterstitialAdAsync") > -1
          }
            hasIAD() {
              return !!this._intersitialAd
          }
            async preloadIAD() {
              let arr = this.iads.concat();
                let i = 0;
              while (true) {
                  let index = i++ % arr.length;
                  try {
                      let inst = await FBInstant.getInterstitialAdAsync(arr[index]);
                      await inst.loadAsync()
                      this._intersitialAd = inst;
                      this.emit("iad_ready");
                      break;
                  } catch (e) {
                      if (e.code == "ADS_FREQUENT_LOAD") {
                          await wait(2 * 60 * 1000)
                      } else if (e.code == "ADS_TOO_MANY_INSTANCES") {
                          await wait(10 * 60 * 1000)
                      }
                  }
                  await wait(index == 2 ? 2 * 60 * 1000 : 5e3);
              }
          }
            async showIAD() {
              let inst = this._intersitialAd;
              if (!inst) {
                  await new Promise((resolve, reject) => {
                      this.once("iad_ready", resolve)
                  })
                  inst = this._intersitialAd
              }
              this._intersitialAd = null;
              await inst.showAsync();
              this.preloadIAD();
          }
            hasRAD() {
              return !!this._rewardVideo
          }
            async preloadRAD() {
              let arr = this.rads.concat()
                let i = 0;
              while (true) {
                  let index = i++ % arr.length;
                  try {
                      let inst = await FBInstant.getRewardedVideoAsync(arr[index]);
                      await inst.loadAsync()
                      this._rewardVideo = inst;
                      this.emit("rad_ready");
                      break;
                  } catch (e) {
                      console.log("ad error", e)
                      if (e.code == "ADS_FREQUENT_LOAD") {
                          await wait(2 * 60 * 1000)
                      } else if (e.code == "ADS_TOO_MANY_INSTANCES") {
                          await wait(10 * 60 * 1000)
                      }
                  }
                  await wait(index == 2 ? 2 * 60 * 1000 : 5e3);
              }
          }
            async showRAD() {
              let inst = this._rewardVideo;
              if (!inst) {
                  await new Promise((resolve, reject) => {
                      this.once("rad_ready", resolve)
                  })
                  inst = this._rewardVideo
              }
              this._rewardVideo = null;
              await inst.showAsync();
              this.preloadRAD();
          }
      }*/
      // window.yzad_Advertise = Advertise;
      //export default Advertise

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/EventListener.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, EventHandler, _decorator, Node, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      EventHandler = module.EventHandler;
      _decorator = module._decorator;
      Node = module.Node;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "479dcG+yaxP7ZkJ4s+tjP2j", "EventListener", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let EventListener = exports('default', (_dec = property([EventHandler]), _dec2 = property([EventHandler]), ccclass(_class = (_class2 = (_temp = class EventListener extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "clickEvents", _descriptor, this);

          _initializerDefineProperty(this, "pressEvents", _descriptor2, this);

          _initializerDefineProperty(this, "inScrollView", _descriptor3, this);

          _defineProperty(this, "_pressed", void 0);
        }

        onEnable() {
          this._registerEvent();
        }

        _registerEvent() {
          this.node.on(Node.EventType.TOUCH_START, this._onTouchBegan, this);
          this.node.on(Node.EventType.TOUCH_MOVE, this._onTouchMove, this);
          this.node.on(Node.EventType.TOUCH_END, this._onTouchEnded, this);
          this.node.on(Node.EventType.TOUCH_CANCEL, this._onTouchCancel, this);
        } // touch event handler


        _onTouchBegan(event) {
          this._pressed = true;
          EventHandler.emitEvents(this.pressEvents, event, true);
          this.node.emit('press', this);
          if (!this.inScrollView) event.propagationStopped = true;
        }

        _onTouchMove(event) {
          if (!this._pressed) return; // mobile phone will not emit _onMouseMoveOut,
          // so we have to do hit test when touch moving

          var touch = event.touch;

          var hit = this.node._hitTest(touch.getLocation());

          if (!this.inScrollView) event.propagationStopped = true;
        }

        _onTouchEnded(event) {
          if (this._pressed) {
            EventHandler.emitEvents(this.clickEvents, event);
            this.node.emit('click', this);
            EventHandler.emitEvents(this.pressEvents, event, false);
          }

          this._pressed = false;
          if (!this.inScrollView) event.propagationStopped = true;
        }

        _onTouchCancel(event) {
          if (!event.simulate) {
            if (this._pressed) {
              EventHandler.emitEvents(this.pressEvents, event, false);
            }

            this._pressed = false;
          }
        }

        onDisable() {
          this._pressed = false;
          this.node.off(Node.EventType.TOUCH_START, this._onTouchBegan, this);
          this.node.off(Node.EventType.TOUCH_MOVE, this._onTouchMove, this);
          this.node.off(Node.EventType.TOUCH_END, this._onTouchEnded, this);
          this.node.off(Node.EventType.TOUCH_CANCEL, this._onTouchCancel, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "clickEvents", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "pressEvents", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "inScrollView", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/InviteWindow.ts", ['cc', './global.ts', './fbIn_lib.ts', './UIWindow.ts', './FacebookBindWindow.ts', './SdkManager.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ShareWrap.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, RichText, Node, _decorator, G, fbInTools, UIWindow, FacebookBindWindow, SdkManager, UIRoot, Game, LogEventWrap, ShareWrap, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      RichText = module.RichText;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      FacebookBindWindow = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "49035To7rZCDZNNCTWJZNwx", "InviteWindow", undefined); //// const UIWindow = UIWindow


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /**
       * Invite界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let InviteWindow = exports('InviteWindow', (_dec = property([Label]), _dec2 = property([RichText]), _dec3 = property(Label), _dec4 = property(Node), _dec5 = property(Label), _dec6 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class InviteWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "label_add_type0", _descriptor, this);

          _initializerDefineProperty(this, "label_add_type1", _descriptor2, this);

          _initializerDefineProperty(this, "label_note", _descriptor3, this);

          _initializerDefineProperty(this, "bg", _descriptor4, this);

          _initializerDefineProperty(this, "label_count", _descriptor5, this);

          _initializerDefineProperty(this, "labelBtnNum", _descriptor6, this);
        }

        onShow() {
          this.update_addnumber();
          this.label_note.node.active = SdkManager.IsNative(); // if (wxTools.usewx) {
          // 	this.btn0.active = true;
          // 	this.btn1.active = false;
          // 	this.bg.height = C.bg_1;
          // 	this.btn0.y = C.btn0_1;
          // } else if (fbInTools.usefbIn) {
          // 	this.btn0.active = false;
          // 	this.btn1.active = true;
          // 	this.bg.height = C.bg_1;
          // } else if (AppKit.SdkManager.IsNative()) {
          // 	this.btn0.active = true;
          // 	this.btn1.active = true;
          // 	this.bg.height = C.bg_2;
          // 	this.btn0.y = C.btn0_2;
          // } else {
          // 	this.btn0.active = true;
          // 	this.btn1.active = false;
          // 	this.bg.height = C.bg_1;
          // 	this.btn0.y = C.btn0_1;
          // }
          // this.bg.getComponentsInChildren(Widget).forEach((x) => {
          // 	x.enabled = true;
          // });
          // CCTools.WidgetsUpdateAlignment(this.bg);
        }
        /** 获取新增的体力值 */


        update_addnumber() {
          let add_number = this.get_add_number(); // for (let label of this.label_add_type0) {
          // 	label.string = String.format(i18n.t("invite_addnumber_type0"), add_number);
          // }

          this.label_count.string = String.format(i18n.t("invite_addnumber_type0"), add_number);
          this.labelBtnNum.string = "+" + add_number;

          for (let label of this.label_add_type1) {
            let key = "invite_lineA";
            if (SdkManager.IsNative()) key = "invite_lineApp";
            label.string = String.format(i18n.t(key), add_number);
          }
        }
        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        }

        event_invite() {
          if (fbInTools.usefbIn) {
            this.event_share_facebook();
          } else {
            this.event_share_default();
          }
        }
        /** 点击事件：默认分享按钮 */


        event_share_default() {
          let img = "share/share1";
          if (SdkManager.IsNative()) img = null;
          ShareWrap.share(i18n.t("ShareInviteNew"), img, {
            intent: "INVITE",
            type: "spain_invite",
            url: `${G.GameConfig.site_host}/index.html?inviteId=` + Game.SUser.UserId()
          }, null, "spain_invite");
          LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "ad23xg" : "vne976"); //aj_invite
        }
        /** 点击事件：facebook分享按钮 */


        event_share_facebook() {
          //this.event_share_default()
          if (SdkManager.IsNative()) {
            if (Game.SUser.IsGuest()) {
              UIRoot.instance.openChildWindow(FacebookBindWindow);
            } else {
              LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "ad23xg" : "vne976"); //aj_invite

              ShareWrap.inviteNew(i18n.t("ShareInviteNew"), "share/share1", {
                intent: "INVITE",
                type: "spain_invite"
              }, null, "spain_invite");
            }

            return;
          }

          ShareWrap.share(i18n.t("ShareInviteNew"), "share/share1", {
            intent: "INVITE",
            type: "spain_invite"
          }, null, "spain_invite");
        }
        /** 获取增加的值（meta数据or服务器数据） */


        get_add_number() {
          let data = G.GameConstance.spinsPerInvite;
          let mapId = Game.SUserVillage.MapId();
          let is = 0;

          for (let mid in data) {
            if (mapId >= parseInt(mid)) {
              is = data[mid];
            } else {
              break;
            }
          }

          return is;
        }

      }, _defineProperty(_class3, "windowPath", "Menu/InviteWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "label_add_type0", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "label_add_type1", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "label_note", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "bg", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "label_count", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelBtnNum", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserRecord.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "497deH+zxVOzK9du5jzG7er", "UserRecord", undefined); //用户金币


      class UserRecord {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            apPaid: 0,
            //花费过的体力
            coinPaid: 0,
            //花费过的金币数
            purchaseMoney: 0,
            //充值总额
            purchaseTimes: 0,
            //充值次数
            purchaseMultipleTimes: 0,
            //支付转盘次数
            adTimes: 0,
            //广告次数
            buildCount: 0,
            //建造次数
            fixCount: 0,
            //修复次数
            attackCount: 0,
            //攻击次数
            attackSuccessCount: 0,
            //攻击成功次数
            raidCount: 0,
            //偷取次数
            raicCoinsNum: 0,
            //偷取总钱数
            shieldCount: 0,
            //防御次数
            beAttackedCount: 0,
            //被攻击次数
            beRaidCount: 0,
            //被偷取次数
            beRaidCoinsNum: 0,
            //被偷取总钱数
            taskCompleteCount: 0 //任务完成次数

          };
        }

        createNew(dbdata) {} //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
        }

        UserId() {
          return this.data.userId;
        }

        GetPurchaseMoney() {
          return this.data.purchaseMoney;
        }

        GetPurchaseMoneyAvg() {
          return this.data.purchaseMoney / this.data.purchaseTimes;
        }

        GetPurchaseCount() {
          return this.data.purchaseTimes;
        }

        AdTimes() {
          return this.data.adTimes;
        }

      }

      exports('UserRecord', UserRecord);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HeistMainWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './ContentModel.ts', './PaySuccessWindow.ts', './HeistData.ts', './ContentCheck.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, instantiate, Button, SoundManager, UIWindow, ContentModel, PaySuccessWindow, HeistData, ContentCheck, SR, UIRoot, Meta, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      Button = module.Button;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      HeistData = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "49999OAt8tII6ZdLkbdU0bx", "HeistMainWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //// const UIWindow = UIWindow
      // const ContentModel = ContentModel

      let HeistMainWindow = exports('default', (_dec = property({
        tooltip: "",
        type: Label
      }), _dec2 = property({
        tooltip: "单个购买项目的item",
        type: Node
      }), _dec3 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class HeistMainWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelTimer", _descriptor, this);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "childWindowChain", void 0);

          _initializerDefineProperty(this, "buy_item", _descriptor2, this);

          _defineProperty(this, "buy_item_list", []);

          _initializerDefineProperty(this, "touch_area", _descriptor3, this);
        }

        onShow(params) {
          let activityMeta = params.meta;
          HeistData.load_data(activityMeta);
          this.create_buy_item();
          this.update_ui();
          this.bind_ui();
          this.leftTime = 0;
          this.slowUpdate();
          this.init();
        }

        onClose() {
          this.unbind_ui();
        }

        slowUpdate() {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = HeistData.get_activity_meta().EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        bind_ui() {
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "HeistMainWindow", () => {
            this.update_ui();
          });
        }

        unbind_ui() {
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "HeistMainWindow");
        }

        update_ui() {
          this.buy_item_list.forEach((v, i) => {
            v.label_buy_count.string = HeistData.get_buy_item_count_str(i);
            v.btn_buy.interactable = HeistData.get_buy_state(i) === "able-to-buy" || HeistData.get_buy_state(i) === "no-able-to-buy";
            v.buy_lock.active = HeistData.get_buy_state(i) === "buy-enough" || HeistData.get_buy_state(i) === "no-able-to-buy";
            v.bkg2.active = HeistData.get_buy_state(i) === "buy-enough" || HeistData.get_buy_state(i) === "no-able-to-buy";
            v.reward_layout.destroyAllChildren();
            HeistData.get_buy_item_reward_list(i).forEach(reward => {
              let reward_node = instantiate(v.reward_item);
              reward_node.parent = v.reward_layout;
              reward_node.active = true;
              reward_node.getComponent(ContentModel).show(reward);
            });
            v.label_buy_cost.string = HeistData.get_buy_item_price_str(i);
          });
        }
        /** @type {cc.Node} */

        /** 创建所有的购买项目(一般是3个) */


        create_buy_item() {
          this.buy_item.active = false;
          this.buy_item_list = [];

          for (let i = 0; i < HeistData.get_buy_item_length(); i += 1) {
            let n = instantiate(this.buy_item);
            n.parent = this.buy_item.parent;
            n.active = true;
            let data = {
              reward_layout: GameKit.ControllerTable.GetNode(n, "reward-layout"),
              reward_item: GameKit.ControllerTable.GetNode(n, "reward-item"),
              label_buy_cost: GameKit.ControllerTable.GetNode(n, "label-buy-cost").getComponent(Label),
              label_buy_count: GameKit.ControllerTable.GetNode(n, "label-buy-count").getComponent(Label),
              buy_lock: GameKit.ControllerTable.GetNode(n, "buy-lock"),
              buy_use_coin: GameKit.ControllerTable.GetNode(n, "buy-use-coin"),
              bkg2: GameKit.ControllerTable.GetNode(n, "bkg2"),
              btn_buy: GameKit.ControllerTable.GetNode(n, "btn-buy").getComponent(Button),
              cannot_buy: GameKit.ControllerTable.GetNode(n, "cannot-buy")
            };
            this.buy_item_list.push(data); // 确定一些显示

            HeistData.get_buy_item_reward_list(i).forEach(reward => {
              let reward_node = instantiate(data.reward_item);
              reward_node.parent = data.reward_layout;
              reward_node.active = true;
              reward_node.getComponent(ContentModel).show(reward);
            });
            data.label_buy_cost.string = HeistData.get_buy_item_price_str(i);
            data.buy_use_coin.active = HeistData.get_buy_item_type(i) === "coin";
            data.label_buy_cost.node.x = HeistData.get_buy_item_type(i) === "coin" ? 20 : 0;
            data.btn_buy.clickEvents[0].customEventData = `${i}`; // 保存按钮对应的buy-item-index

            data.cannot_buy.active = false;
          }
        }
        /** @type {cc.Node} */


        init() {
          this.touch_area.on(Node.EventType.TOUCH_START, () => {
            this.buy_item_list.forEach(v => v.cannot_buy.active = false);
            this.touch_area.active = false;
          });
          this.touch_area.active = false;
        }

        event_close() {
          this.closeAnim();
        }

        event_buy(e, index) {
          index = Number.parseInt(index); // 不允许购买

          if (!HeistData.is_buy(index)) {
            this.buy_item_list[index].cannot_buy.active = true;
            this.touch_area.active = true;
            return;
          }

          if (HeistData.get_buy_item_type(index) === "free") {
            let sr = SR.SRActivityHeist.activityHeistFreeBuy(HeistData.get_activity_meta_id(), HeistData.get_buy_item_pack_id(index));
            sr.SetCallBack(() => {
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "pack"
              });
              SoundManager.playSound("item_purchased");
            });
            sr.Send();
          } else if (HeistData.get_buy_item_type(index) === "coin") {
            let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, HeistData.get_buy_item_shop_id(index));
            let price = meta.Price();

            if (!ContentCheck.CheckCoin(price, true)) {
              if (this.childWindowChain) {
                this.clearOnCloseFunc();
                this.childWindowChain.end();
              }

              this.closeAnim();
              return;
            }

            let req = SR.SRShop.payFor(meta.Id());
            req.SetCallBack(function () {
              let sr = SR.SRActivityHeist.activityHeistAddBuyCount(HeistData.get_activity_meta_id(), 1);
              sr.SetCallBack(() => {
                UIRoot.instance.openChildWindow(PaySuccessWindow, {
                  from: "pack"
                });
                SoundManager.playSound("item_purchased");
              });
              sr.Send();
            }.bind(this));
            req.Send();
          } else {
            let shopmeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, HeistData.get_buy_item_shop_id(index));
            PaymentWrap.Pay(shopmeta.Name(), function (ok) {
              if (ok) {
                let sr = SR.SRActivityHeist.activityHeistAddBuyCount(HeistData.get_activity_meta_id(), 1);
                sr.SetCallBack(() => {
                  UIRoot.instance.openChildWindow(PaySuccessWindow, {
                    from: "pack"
                  });
                  SoundManager.playSound("item_purchased");
                });
                sr.Send();
                LogEventWrap.logEvent("ShopDetail", {
                  itemType: "pack",
                  name: shopmeta.Name(),
                  phase: 1
                });
              } else {
                LogEventWrap.logEvent("ShopDetail", {
                  itemType: "pack",
                  name: shopmeta.Name(),
                  phase: -1
                });
              }
            }.bind(this));
            LogEventWrap.logEvent("ShopDetail", {
              itemType: "pack",
              name: shopmeta.Name(),
              phase: 0
            });
          }
        }

      }, _defineProperty(_class3, "windowPath", "Activity/heist/HeistMainWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "buy_item", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "touch_area", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivityMeta.ts", ['cc', './ActivityManager.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, ActivityManager, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "49aa9BccKNKjofP1LoLE3t/", "ActivityMeta", undefined);

      class ActivityMeta {
        constructor() {
          _defineProperty(this, "_data", {});

          _defineProperty(this, "enable_trigger", void 0);
        }

        static MakeEntity(data) {
          let meta = new ActivityMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        } //名字


        ShortName() {
          return this._data.shortName || "";
        }

        Name() {
          return this._data.name;
        } //类型


        Type() {
          return this._data.type;
        } //子类型


        SubType() {
          return this._data.subType;
        } //描述


        Description() {
          return this._data.description;
        } //图标


        Icon() {
          return this._data.icon;
        } //图标跳转


        IconGoto() {
          return this._data.icon_goto;
        } //面板


        Panel() {
          return this._data.panel;
        } //插图


        Image() {
          return this._data.image;
        } //显示时间


        PrepareTime() {
          return this._data.prepare_time;
        } //开始时间


        StartTime() {
          return this._data.start_time;
        } //结束时间


        EndTime() {
          return this._data.end_time;
        } //消失时间


        FinishTime() {
          return this._data.finish_time;
        } //参数


        Param() {
          return this._data.param || {};
        } //是否用户计时


        IsUserTime() {
          return !!this._data.user_time;
        } //用户活动时间


        UserTime() {
          return this._data.user_time;
        } //生效条件


        EnableTrigger() {
          if (!this._data.enable_trigger) return [];

          if (this.enable_trigger == null) {
            this.enable_trigger = this._data.enable_trigger.split(";");
          }

          return this.enable_trigger;
        } //商品id


        ShopId() {
          return this._data.shop_id;
        } //商店ids


        ShopIds() {
          return this._data.shop_ids;
        }

        HelpKey() {
          return this._data.help_key;
        } // Helper //
        //是否显示


        IsShowing() {
          let currentTime = GameKit.TimeUtil.getCurrentTime();
          return currentTime >= this.PrepareTime() && currentTime <= this.FinishTime();
        } //是否在活动中


        IsActive() {
          let currentTime = GameKit.TimeUtil.getCurrentTime();
          return currentTime >= this.StartTime() && currentTime <= this.EndTime();
        } //是否活动预告阶段


        IsPreShowing() {
          let currentTime = GameKit.TimeUtil.getCurrentTime();
          return currentTime >= this.PrepareTime() && currentTime < this.StartTime();
        } //是否活动收尾阶段


        IsEnding() {
          let currentTime = GameKit.TimeUtil.getCurrentTime();
          return currentTime > this.EndTime() && currentTime <= this.FinishTime();
        } //是否在多次触发的cd中


        IsInManyTimesCd() {
          let localData = ActivityManager.GetLocalData()[this.Id()];

          if (!localData) {
            return false;
          }

          let currentTime = GameKit.TimeUtil.getCurrentTime();
          return currentTime < localData.startTime + this.UserTime() + this.Param().cd;
        }

      }

      exports('ActivityMeta', ActivityMeta);

      _defineProperty(ActivityMeta, "Types", {
        Pay: 1,
        Game: 2,
        Other: 3
      });

      _defineProperty(ActivityMeta, "SubTypes", {
        SpecialOffer: 1,
        DaysSale: 2,
        Lucky10: 3,
        SalePack: 4,
        LadderPack: 5,
        AttackMaster: 1,
        RaidMaster: 2,
        BuildMaster: 3,
        Jigsaw: 4,
        Minigame: 5,
        Cannon: 6,
        SlotCollect: 7,
        SlotCollectRank: 8,
        GoldTrade: 1,
        BlackJack: 2
      });

      _defineProperty(ActivityMeta, "GameSubTypesOrder", {
        1: 6,
        2: 7,
        3: 8,
        4: 98,
        5: 3,
        6: 99,
        7: 5,
        8: 4
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AdjustBuildPos.ts", ['cc', './CharacterLevelEditor.ts'], function (exports) {
  'use strict';

  var cclegacy, CCBoolean, _decorator, Component, Vec3, CharacterLevelEditor;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
    }, function (module) {
      CharacterLevelEditor = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "49f65FN0rRMu6tsjzM158zA", "AdjustBuildPos", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let AdjustBuildPos = exports('default', (_dec = ccclass("AdjustBuildPos"), _dec2 = property(CCBoolean), _dec(_class = executeInEditMode(_class = (_class2 = (_temp = class AdjustBuildPos extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_activate", false);
        }

        get activate() {
          return this._activate;
        }

        set activate(bo) {
          this._activate = bo;

          if (bo) {
            this.excute();
            this._activate = false;
          }
        }

        onLoad() {}

        excute() {
          let rootNode = this.node;
          let firstWorldChild = rootNode.getChildByName("positions").getChildByName("world");
          let firstWorldChildPosClone = firstWorldChild.position.clone();
          let worldPosClone = firstWorldChild.getWorldPosition().clone();
          this.handlePositions(rootNode);
          let charCom = rootNode.getComponentInChildren(CharacterLevelEditor);

          if (charCom) {
            let charNode = charCom.node;
            let worldPos = charNode.getWorldPosition();
            rootNode.setWorldPosition(worldPos.clone());
            charNode.position = new Vec3();
          } else {
            let toHandleNodes = [];
            let levelNodeArr = rootNode.children.filter(v => v.name.startsWith("level"));
            levelNodeArr.forEach(v => {
              let normal = v.getChildByName("normal");

              if (normal) {
                toHandleNodes = toHandleNodes.concat(normal.children);
              }

              let damage = v.getChildByName("damage");

              if (damage) {
                toHandleNodes = toHandleNodes.concat(damage.children);
              }
            });
            rootNode.setWorldPosition(worldPosClone);
            toHandleNodes.forEach(v => {
              v.position.subtract(firstWorldChildPosClone);
            });
          }
        }

        handlePositions(rootNode) {
          let posNode = rootNode.getChildByName("positions");
          let worldNode = posNode.getChildByName("world");
          let attackNode = posNode.getChildByName("attack");
          let fixNode = posNode.getChildByName("fix");
          let worldPos = worldNode.position.clone();
          attackNode && attackNode.position.subtract(worldPos);
          fixNode && fixNode.position.subtract(worldPos);
          worldNode && (worldNode.position = new Vec3());
        }

      }, _temp), _applyDecoratedDescriptor(_class2.prototype, "activate", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "activate"), _class2.prototype), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/QuestCenterWindow.ts", ['cc', './UIWindow.ts', './UITabContainer.ts', './QuestCheckPage.ts', './QuestDailyPage.ts', './QuestInvitePage.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, UIWindow, UITabContainer, QuestCheckPage, QuestDailyPage, QuestInvitePage, LogEventWrap, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UITabContainer = module.default;
    }, function (module) {
      QuestCheckPage = module.QuestCheckPage;
    }, function (module) {
      QuestDailyPage = module.QuestDailyPage;
    }, function (module) {
      QuestInvitePage = module.QuestInvitePage;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "4a07av1wbpJn47EnGDSEuTB", "QuestCenterWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; // const UITabContainer = UITabContainer
      //const UIWindow = UIWindow

      const C = {
        DEFAULT_INDEX: 0
      };
      let QuestCenterWindow = exports('QuestCenterWindow', (_dec = property(UITabContainer), _dec2 = property(QuestDailyPage), _dec3 = property(QuestInvitePage), _dec4 = property(QuestCheckPage), _dec5 = property(Node), _dec6 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class QuestCenterWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "tab_node_array", _descriptor, this);

          _initializerDefineProperty(this, "daily_page", _descriptor2, this);

          _initializerDefineProperty(this, "invite_page", _descriptor3, this);

          _initializerDefineProperty(this, "check_page", _descriptor4, this);

          _initializerDefineProperty(this, "signBadge", _descriptor5, this);

          _initializerDefineProperty(this, "taskBadge", _descriptor6, this);
        }

        onShow() {
          this.tab_node_array.onShow((index, tab, first) => {
            if (first) {
              setTimeout(() => {
                this.event_change_to_tab(index);
              }, 300);
            } else {
              this.event_change_to_tab(index);
            }
          }, C.DEFAULT_INDEX); // this.updateCheckRedDot();

          this.updateDailyRedDot();
          LogEventWrap.logEvent("window_questcenter");
        }

        onClose() {
          // 手动清理1次缓存数据，js垃圾回收的延迟可能会导致一些bug
          this.daily_page.data = null;
          this.check_page.data = null; // 清理任务刷新回调

          this.unscheduleAllCallbacks();
        } // 各界面的show\hide逻辑，在show逻辑中进行初始化操作


        show_daily_page() {
          this.daily_page.show();
          this.daily_page.questCenterWindow = this; // this.taskBadge.active = false;
        }

        show_invite_page() {
          this.invite_page.show();
        }

        show_check_page() {
          this.check_page.show();
          this.check_page.questCenterWindow = this; // this.signBadge.active = false;
        }

        hide_daily_page() {
          this.daily_page.node.active = false;
        }

        hide_invite_page() {
          this.invite_page.node.active = false;
        }

        hide_check_page() {
          this.check_page.node.active = false;
        }

        hide_all() {
          this.hide_daily_page();
          this.hide_invite_page();
          this.hide_check_page();
        }
        /** 界面关闭按钮 */


        event_close() {
          this.closeAnim();
        }
        /** tab按钮 */


        event_change_to_tab(index) {
          this.hide_all();

          switch (index) {
            default:
            case 0:
              this.show_daily_page();
              break;

            case 1:
              // this.show_check_page();
              break;

            case 2:
              // this.show_check_page();
              break;
          }
        }

        updateDailyRedDot() {
          this.taskBadge.active = false;
          let taskCount = GameKit.DataCache.GetData("UserTaskCompleteCount") || 0;
          this.taskBadge.active = taskCount > 0;
        }

        updateCheckRedDot() {
          this.signBadge.active = false;
          let signData = GameKit.DataCache.GetData("signData");

          if (signData) {
            let canSignWeek = false;
            let canSignMonth = false;
            canSignWeek = signData.signWeekDay > signData.signWeekRewards;

            for (let i = 7; i <= 28; i += 7) {
              if (signData.signMonthDay >= i && !signData.signMonthRewards.includes(i)) {
                canSignMonth = true;
                break;
              }
            }

            this.signBadge.active = canSignWeek || canSignMonth;
          }
        }

      }, _defineProperty(_class3, "windowPath", "Quest/NewQuestCenterWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "tab_node_array", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "daily_page", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "invite_page", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "check_page", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "signBadge", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "taskBadge", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ContentCheck.ts", ['cc', './global.ts', './Content.ts', './ActivitySalePackWindow.ts', './WatchGetCoinWindow.ts', './WatchGetSpinWindow.ts', './ApNotEnoughWindow.ts', './NewPlayerPackWindow.ts', './CoinNotEnoughWindow.ts', './SimpleItemBuyWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './ADWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Content, ActivitySalePackWindow, WatchGetCoinWindow, WatchGetSpinWindow, ApNotEnoughWindow, NewPlayerPackWindow, CoinNotEnoughWindow, SimpleItemBuyWindow, UIRoot, ActivityManager, Game, Meta, ADWrap, PaymentWrap, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      ActivitySalePackWindow = module.ActivitySalePackWindow;
    }, function (module) {
      WatchGetCoinWindow = module.WatchGetCoinWindow;
    }, function (module) {
      WatchGetSpinWindow = module.WatchGetSpinWindow;
    }, function (module) {
      ApNotEnoughWindow = module.ApNotEnoughWindow;
    }, function (module) {
      NewPlayerPackWindow = module.NewPlayerPackWindow;
    }, function (module) {
      CoinNotEnoughWindow = module.CoinNotEnoughWindow;
    }, function (module) {
      SimpleItemBuyWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('ContentCheck', void 0);

      cclegacy._RF.push({}, "4a0a7kvixZPdZPp095vOYh+", "ContentCheck", undefined);

      let ContentCheck;

      (function (_ContentCheck) {
        function CheckContents(contents) {
          if (!contents || contents.length == 0) return true;
          contents = Content.Merge(contents);

          for (let i = 0; i < contents.length; i++) {
            if (!ContentCheck.CheckContent(contents)) return false;
          }

          return true;
        }

        _ContentCheck.CheckContents = CheckContents;

        function CheckContent(content) {
          let type = content.Type();

          if (type == Content.Types.Coin) {
            return ContentCheck.CheckCoin(content.Count());
          } else if (type == Content.Types.Ap) {
            return ContentCheck.CheckAp(content.Count());
          } else if (type == Content.Types.Item) {
            return ContentCheck.CheckItem(content.Id(), content.Count());
          }

          return true;
        }

        _ContentCheck.CheckContent = CheckContent;

        function CheckCoin(price, showShop = false, onlyNotEnough = false) {
          let userdata = Game.SUser.Coin();

          if (userdata >= price) {
            return true;
          } else {
            if (showShop) {
              homeView.pageViewController.moveToPage(G.Pages.Shop, true);
            } else {
              if (ActivityManager.checkSpecialOffer()) return false;
              let dis = price - userdata;
              let coinNotEnoughShop = G.GameConstance.coinNotEnoughShop;

              for (let i = 0; i < coinNotEnoughShop.length; i++) {
                let id = coinNotEnoughShop[i];
                let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, id);

                if (meta.Count() >= dis || i == coinNotEnoughShop.length - 1) {
                  UIRoot.instance.openChildWindow(CoinNotEnoughWindow, {
                    meta: meta,
                    showCallback: window => {
                      if (onlyNotEnough) return;
                      window.addOnCloseFunc(() => {
                        if (!ADWrap.IsVideoPrepared()) return;
                        let adCoinTime = GameKit.PlayerPrefs.GetInt("adCoinTime", 0);

                        if (GameKit.TimeUtil.getCurrentHalfDay() !== adCoinTime) {
                          GameKit.PlayerPrefs.SetInt("adCoinCount", 0);
                          GameKit.PlayerPrefs.SetInt("adCoinTime", GameKit.TimeUtil.getCurrentHalfDay());
                        }

                        let adCoinCount = GameKit.PlayerPrefs.GetInt("adCoinCount", 0);

                        if (adCoinCount < (PaymentWrap.PayEnabled() ? G.GameConfig.adCoinCount : G.GameConfig.adCoinCount * 2)) {
                          let adCoinTipCount = GameKit.PlayerPrefs.GetInt("adCoinTipCount", 0);
                          adCoinTipCount++;
                          GameKit.PlayerPrefs.SetInt("adCoinTipCount", adCoinTipCount);

                          if (adCoinTipCount >= 3) {
                            UIRoot.instance.openChildWindow(WatchGetCoinWindow);
                            GameKit.PlayerPrefs.SetInt("adCoinTipCount", 0);
                          }
                        }
                      });
                    }
                  });
                  break;
                }
              }
            }
          }

          return false;
        }

        _ContentCheck.CheckCoin = CheckCoin;

        function CheckAp(price) {
          let userdata = Game.SUser.Ap();

          if (userdata >= price) {
            return true;
          } else {
            if (ActivityManager.checkSpecialOffer()) return false;
            let dis = price - userdata;
            let apNotEnoughShop = G.GameConstance.apNotEnoughShop; //console.log(apNotEnoughShop)

            for (let i = 0; i < apNotEnoughShop.length; i++) {
              let id = apNotEnoughShop[i];
              let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, id);

              if (meta.Count() >= dis || i == apNotEnoughShop.length - 1) {
                let chain = new GameKit.ChildWindowChain();
                chain.add(NewPlayerPackWindow, () => {
                  return !!Game.SUserStatus.GetNewPlayerLeftTime();
                });
                let saleActivity = ActivityManager.GetActiveShopActivityByType(Meta.ActivityMeta.SubTypes.SalePack);
                if (saleActivity) chain.add(ActivitySalePackWindow, null, {
                  meta: saleActivity
                });
                chain.add(ApNotEnoughWindow, null, {
                  meta: meta
                });
                /*chain.add(InviteWindow, () => {
                	return !G.GameConfig.closeShare
                })*/

                chain.add(WatchGetSpinWindow, () => {
                  if (!ADWrap.IsVideoPrepared()) return false;
                  let adSpinTime = GameKit.PlayerPrefs.GetInt("adSpinTime", 0);

                  if (GameKit.TimeUtil.getCurrentHalfDay() !== adSpinTime) {
                    GameKit.PlayerPrefs.SetInt("adSpinCount", 0);
                    GameKit.PlayerPrefs.SetInt("adSpinTime", GameKit.TimeUtil.getCurrentHalfDay());
                  }

                  let adSpinCount = GameKit.PlayerPrefs.GetInt("adSpinCount", 0);

                  if (adSpinCount < (PaymentWrap.PayEnabled() ? G.GameConfig.adSpinCount : G.GameConfig.adSpinCount * 2)) {
                    return true;
                  }

                  return false;
                });
                chain.setCompleteFunc(() => {
                  homeView.slotNode.idle();
                });
                chain.start();
                break;
              }
            }
          }

          return false;
        }

        _ContentCheck.CheckAp = CheckAp;

        function CheckItem(id, count) {
          let userCount = Game.SUserItems.getNum(id);

          if (userCount >= count) {
            return true;
          }

          UIRoot.instance.openChildWindow(SimpleItemBuyWindow, {
            itemId: id
          });
          return false;
        }

        _ContentCheck.CheckItem = CheckItem;
      })(ContentCheck || (ContentCheck = exports('ContentCheck', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CountDownWindow.ts", ['cc', './SoundManager.ts', './PlayAudio.ts', './UIWindow.ts', './UIRoot.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, SoundManager, PlayAudio, UIWindow, UIRoot, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      PlayAudio = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "4ae76Hc/kdDdod1Ejz7LhSx", "CountDownWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CountDownWindow = exports('CountDownWindow', (_dec = property(Label), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class CountDownWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelMsg", _descriptor, this);

          _initializerDefineProperty(this, "btnConfirm", _descriptor2, this);

          _initializerDefineProperty(this, "btnCancel", _descriptor3, this);

          _initializerDefineProperty(this, "labelTime", _descriptor4, this);

          _defineProperty(this, "time", void 0);

          _defineProperty(this, "confirmFunc", void 0);

          _defineProperty(this, "cancelFunc", void 0);
        }

        static Show(time, msg, conc, canc) {
          UIRoot.instance.openChildWindow(CountDownWindow, {
            time: time,
            msg: msg,
            confirmFunc: conc,
            cancelFunc: canc
          });
        }

        onShow(showParams) {
          this.time = showParams.time;
          this.labelMsg.string = showParams.msg || "";
          this.confirmFunc = showParams.confirmFunc;
          this.cancelFunc = showParams.cancelFunc;

          if (this.cancelFunc == null) {
            this.btnCancel.active = false;
            this.btnConfirm.x = 0;
          }

          GameKit.BackKeyManager.registerBackEvent(() => {
            PlayAudio.playClose();
            if (this.cancelFunc == null) this.onConfirm();else this.onCancel();
          });
          SoundManager.playSound("se_open");
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        slowUpdate(dt) {
          if (this.time <= 0) return;
          this.time -= dt;
          this.labelTime.string = Math.ceil(this.time).toString();

          if (this.time <= 0) {
            if (this.cancelFunc != null) {
              this.cancelFunc();
            } else {
              if (this.confirmFunc != null) {
                this.confirmFunc();
              }
            }

            this.close();
          }
        }

        onConfirm() {
          if (this.confirmFunc != null) {
            this.confirmFunc();
          }

          this.close();
        }

        onCancel() {
          if (this.cancelFunc != null) {
            this.cancelFunc();
          }

          this.close();
        }

      }, _defineProperty(_class3, "windowPath", "Common/CountDownWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelMsg", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnConfirm", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btnCancel", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelTime", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CustomToggle.ts", ['cc', './_app.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, _decorator, Toggle, assetManager, SpriteFrame, Texture2D, cce;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
      Toggle = module.Toggle;
      assetManager = module.assetManager;
      SpriteFrame = module.SpriteFrame;
      Texture2D = module.Texture2D;
    }, function (module) {
      cce = module.cce;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "4aea7GYIUlF/5+mg9Q7VUYa", "CustomToggle", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CustomToggle = exports('CustomToggle', (_dec = ccclass("CustomToggle"), _dec2 = property(Sprite), _dec3 = property(Sprite), _dec4 = property(Label), _dec(_class = (_class2 = (_temp = class CustomToggle extends Toggle {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "iconCheck", _descriptor, this);

          _initializerDefineProperty(this, "icon", _descriptor2, this);

          _initializerDefineProperty(this, "labelName", _descriptor3, this);

          _defineProperty(this, "_index", 0);
        }

        set index(value) {
          this._index = value;
        }

        get index() {
          return this._index;
        }

        setIcons(sfCheckResPath, sfResPath) {
          if (sfCheckResPath.startsWith("http")) {
            assetManager.loadRemote(sfCheckResPath, {
              ext: ".png"
            }, (error, imageAsset) => {
              if (error) return;
              const newSpriteFrame = new SpriteFrame();
              const texture = new Texture2D();
              texture.image = imageAsset;
              newSpriteFrame.texture = texture;
              this.iconCheck.spriteFrame = newSpriteFrame;
            });
          } else {
            cce.loadRes(sfCheckResPath, SpriteFrame, (error, sf) => {
              if (error) return;
              this.iconCheck.spriteFrame = sf;
            });
          }

          if (sfResPath.startsWith("http")) {
            assetManager.loadRemote(sfResPath, {
              ext: ".png"
            }, (error, imageAsset) => {
              if (error) return;
              const newSpriteFrame = new SpriteFrame();
              const texture = new Texture2D();
              texture.image = imageAsset;
              newSpriteFrame.texture = texture;
              this.icon.spriteFrame = newSpriteFrame;
            });
          } else {
            cce.loadRes(sfResPath, SpriteFrame, (error, sf) => {
              if (error) return;
              this.icon.spriteFrame = sf;
            });
          }
        }

        setName(name) {
          this.labelName.string = name || "";
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "iconCheck", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "icon", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/remoteDownloader.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      // import * as cc from "cc";
      cclegacy._RF.push({}, "4b06bi9QiRJvrOsjH6/AKzX", "remoteDownloader", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/JigsawWindowUniversal.ts", ['cc', './CCE_Component.ts', './EnterCloseAnim.ts', './ContentModel.ts', './ContentCheck.ts', './SR.ts', './JigsawWindowMain.ts', './JigsawWindow.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Button, Node, _decorator, instantiate, Sprite, SpriteFrame, CCE_Component, EnterCloseAnim, ContentModel, ContentCheck, SR, JigsawWindowMain, JigsawWindow, Game, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Button = module.Button;
      Node = module.Node;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      JigsawWindowMain = module.default;
    }, function (module) {
      JigsawWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "4d6c8hmByFDbL1n3myKk0gZ", "JigsawWindowUniversal", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const UniversalJigsawId = 1;
      let JigsawWindowUniversal = exports('default', (_dec = property(Button), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), ccclass(_class = (_class2 = (_temp = class JigsawWindowUniversal extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "self_btn", _descriptor, this);

          _initializerDefineProperty(this, "bg_parent", _descriptor2, this);

          _defineProperty(this, "new_main", null);

          _defineProperty(this, "new_universal", null);

          _initializerDefineProperty(this, "label_Count", _descriptor3, this);

          _initializerDefineProperty(this, "sp_Add", _descriptor4, this);

          _defineProperty(this, "contentModel", void 0);
        }

        onLoad() {
          this.contentModel = this.getComponent(ContentModel);
          this.contentModel.setNoCountGray(true);
          this.contentModel.show(Game.SUserItems.getContent(UniversalJigsawId));
          let num = Game.SUserItems.getNum(UniversalJigsawId);
          this.label_Count.active = num > 0;
          this.sp_Add.active = num <= 0;
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "JigsawWindowUniversal", function (data) {
            this.contentModel.show(Game.SUserItems.getContent(UniversalJigsawId));
            let num = Game.SUserItems.getNum(UniversalJigsawId);
            this.label_Count.active = num > 0;
            this.sp_Add.active = num <= 0;
          }.bind(this));
        }

        onDestroy() {
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ItemsEvent, "JigsawWindowUniversal");
        }
        /** 显示选择页面 */


        show_choose() {
          if (!ContentCheck.CheckItem(UniversalJigsawId, 1)) return;
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();
          this.bg_parent.active = true;
          EnterCloseAnim.playEnter(this.bg_parent); // 复制universal

          this.new_universal = instantiate(this.contentModel.icon.node);
          this.new_universal.parent = this.bg_parent;
          this.new_universal.x = this.node.x;
          this.new_universal.y = this.node.y; // 复制main

          this.new_main = instantiate(JigsawWindow.ins.main.node);
          this.new_main.parent = this.bg_parent; // 刷新数据

          let c = this.new_main.getComponent(JigsawWindowMain); // this.scheduleOnce(() => {
          //     c.layout.node.getComponent(cc.UITransform).width += 40
          //     c.layout.node.getComponent(cc.UITransform).height += 40
          //     c.layout.spacingX = 20
          //     c.layout.spacingY = 20
          //     c.layout.updateLayout()
          // }, 0.5)
          //c.update_page()

          c.item_list.forEach((node, index) => {
            let btn = GameKit.ControllerTable.GetNode(node, "btn").getComponent(Button);
            let sp = GameKit.ControllerTable.GetNode(node, "sp-raw");

            if (data.jigsawData[index] === 0) {
              let spspf = sp.getComponent(Sprite).spriteFrame;

              if (spspf) {
                let _sprite = new SpriteFrame();

                _sprite.texture = spspf.texture;
                _sprite.rect = spspf.rect;
                sp.getComponent(Sprite).spriteFrame = _sprite; //sp.getComponent(cc.Sprite).spriteFrame._original = spspf._original
                //////// 没有shaderHelper文件，先注销
                // let shader = sp.addComponent("ShaderHelper")
                // shader.program = ShaderHelper.ShaderEnum.GrayInline
                // shader.effectSize = 8
                // shader.effectColor = cc.color(255,255,66,255)
              }

              btn.interactable = true;
            } else {
              sp.active = false;
              btn.interactable = false;
            }

            btn.node.on("click", () => {
              this.use(index);
            });
          });
        }
        /**
         * 使用万能拼图
         * @param {number} index
         */


        use(index) {
          if (ContentCheck.CheckItem(UniversalJigsawId, 1)) {
            let req = SR.SRJigsaw.useUniversalJigsaw(index);
            req.SetCallBack(() => {
              this.event_close();
              JigsawWindow.ins.piece.anima_use_one(index, 0, true, this.node.position);
            });
            req.Send();
          }
        }
        /** 点击显示选择界面 */


        event_show_choose() {
          this.show_choose();
        }
        /** 关闭 */


        event_close() {
          this.bg_parent.active = false;
          this.new_main.destroy();
          this.new_universal.destroy();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "self_btn", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "bg_parent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "label_Count", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp_Add", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TaskMeta.ts", ['cc', './Content.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Content, Meta, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "4d8f5bVKntNmri+lE3nEbV0", "TaskMeta", undefined);

      class TaskMeta {
        constructor() {
          _defineProperty(this, "_data", {
            id: 0,
            type: 0,
            name: "",
            description: "",
            target: "",
            count: 0,
            reward: "",
            goto: ""
          });

          _defineProperty(this, "reward", void 0);
        }

        static MakeEntity(data) {
          let meta = new TaskMeta();
          meta.UpdateData(data);
          return meta;
        }

        static GetById(id) {
          return Meta.MetaManager.GetMeta(Meta.MetaType.Task, id);
        }

        UpdateData(data) {
          this._data.id = data.id;
          this._data.name = data.name;
          this._data.count = data.count;
          this._data.description = data.description;
          this._data.reward = data.reward;
          this._data.target = data.target;
          this._data.type = data.type;
          this._data.goto = data.goto; // for (var key in data) {
          //     this._data[key] = data[key]
          // }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        } //任务类型 TaskMeta.Types


        Type() {
          return this._data.type;
        }

        Name() {
          return i18n.sel(this._data.name);
        }

        Description() {
          return i18n.sel(this._data.description);
        } //任务目标 TaskMeta.Targets


        Target() {
          return this._data.target;
        } //任务需求计数


        Count() {
          return this._data.count;
        }

        Reward() {
          if (!this.reward) {
            this.reward = Content.FromStrings(this._data.reward);
            this.reward = Content.Merge(this.reward);
          }

          return this.reward;
        } //前往


        Goto() {
          return this._data.goto;
        }

      }

      exports('TaskMeta', TaskMeta);

      _defineProperty(TaskMeta, "Types", {
        Daily: 1
      });

      _defineProperty(TaskMeta, "Targets", {
        spin: "spin",
        giftspin: "giftspin",
        shareraid: "shareraid",
        shareattack: "shareattack",
        attack: "attack",
        raid: "raid",
        raidcoin: "raidcoin",
        spentcoin: "spentcoin",
        build: "build"
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RotateAnim.ts", ['cc', './CCE_Component.ts', './_app.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, CCBoolean, _decorator, CCE_Component, cce;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      cce = module.cce;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "4da5dLTqcxIT7jNRsjNCG6C", "RotateAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let RotateAnim = exports('default', (_dec = property(CCInteger), _dec2 = property(CCInteger), _dec3 = property(CCBoolean), _dec4 = property(CCInteger), _dec5 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class RotateAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "time", _descriptor, this);

          _initializerDefineProperty(this, "delay", _descriptor2, this);

          _initializerDefineProperty(this, "clockwise", _descriptor3, this);

          _initializerDefineProperty(this, "outDegree", _descriptor4, this);

          _initializerDefineProperty(this, "step", _descriptor5, this);

          _defineProperty(this, "playing", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          this.playing = true;
          this.scheduleOnce(function () {
            this.playing = false;
          }.bind(this), this.delay);
        }

        slowUpdate(dt) {
          if (this.playing) return; // this.node.runAction(ccAction.sequence(
          //     ccAction.rotateBy(this.time, 360),
          //     ccAction.callFunc(function(){ this.playing = false }, this)
          // ))

          if (this.step === 0) {
            if (this.outDegree != 0) {
              this.node.runAction(ccAction.sequence(ccAction.rotateBy(this.time / 2, this.clockwise ? this.outDegree / 2 : -this.outDegree / 2, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeOut)), ccAction.rotateBy(this.time, this.clockwise ? -this.outDegree : this.outDegree, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)), ccAction.rotateBy(this.time / 2, this.clockwise ? this.outDegree / 2 : -this.outDegree / 2, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeIn)), ccAction.delayTime(this.delay)).repeatForever());
            } else {
              this.node.runAction(ccAction.rotateBy(this.time, this.clockwise == true ? 360 : -360).repeatForever());
            }
          } else {
            this.node.runAction(ccAction.rotateBy(0.001, this.clockwise == true ? this.step : -this.step)).repeatForever();
          }

          this.playing = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "delay", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "clockwise", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return true;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "outDegree", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "step", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Rotate.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
      Component = module.Component;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "4e3b8eehPxLaazn9fvxkD+q", "Rotate", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Rotate = exports('default', (_dec = ccclass("Rotate"), _dec2 = property({
        type: CCInteger,
        tooltip: "转一圈需要的时间，单位s"
      }), _dec(_class = (_class2 = (_temp = class Rotate extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "speed", _descriptor, this);
        }

        update(dt) {
          this.node.angle += 360 / this.speed * dt;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "speed", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 2;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/User.ts", ['cc', './global.ts', './fbIn_lib.ts', './wx_lib.ts', './SdkManager.ts', './StaticGame.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, G, fbInTools, wxTools, SdkManager, Game, GameKit, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      Game = module.Game;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "4fa39hmESFLXLg9nwRlw4Wc", "User", undefined);

      class User {
        /**
         * @han
         */
        static get Gender() {
          return User.Genders.Unknown;
        }

        constructor() {
          _defineProperty(this, "data", {});

          _defineProperty(this, "rid", void 0);

          _defineProperty(this, "logining", void 0);

          _defineProperty(this, "login", void 0);

          _defineProperty(this, "logined", void 0);

          _defineProperty(this, "friendsInfo", void 0);

          _defineProperty(this, "thirdUserInfo", void 0);

          _defineProperty(this, "thirdNoThisTime", void 0);

          _defineProperty(this, "superTimeShieldLeft", void 0);

          _defineProperty(this, "accountId", void 0);

          _defineProperty(this, "from", void 0);

          _defineProperty(this, "isfirst", void 0);

          this.data = {
            userId: 0,
            //account
            accountId: "0",
            uuid: "",
            source: "",
            firstLogin: 0,
            lastLogin: 0,
            conLoginDays: 1,
            allLoginDays: 1,
            isfirst: false,
            //user_info
            name: i18n.t("PlayerDefaultName"),
            //名字
            avatar: "",
            //头像
            country: "",
            //国家
            friends: [],
            //好友id列表
            friendsList: {},
            //好友列表{id:User}
            fullName: "",
            //user_data
            ap: 0,
            //体力
            apRecover: 0,
            //体力恢复已经走过的时间
            apRecoverLast: 0,
            //上一次计算体力恢复的时间
            coin: 0,
            //金币
            shield: 0,
            //护盾
            adshield: 0,
            //护盾
            timeShield: 0,
            //时间护盾
            timeShieldLast: 0,
            //时间护盾 上一次计算时间
            superTimeShield: 0,
            //超级时间护盾
            superTimeShieldLast: 0,
            //超级时间护盾 上一次计算时间
            star: 0 //星级

          }; //request id

          this.rid = 0, this.logining = false; //正在登陆

          this.login = false; //登陆状态

          this.logined = false; //曾经登陆过

          this.friendsInfo = {}; //好友信息
        } //更新数据


        updateData(msg) {
          if (msg == null) return;
          let data = msg;

          for (let key in data) {
            this.data[key] = data[key];
          }

          if (this.data.isfirst) User.isfirst = true;
          return this;
        } //获得数据


        getData() {
          let da = {};

          for (let key in this.data) {
            da[key] = this.data[key];
          }

          return da;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
          return this;
        } //获得第三方数据


        getThirdData() {
          let keys = ["name", "avatar", "country"];

          if (wxTools.usewx) {
            keys = ["name", "avatar", "country", "province", "city", "gender", "language"];
          } else if (fbInTools.usefbIn) ;else if (SdkManager.IsNative() && this.thirdUserInfo) {
            keys = ["name", "avatar", "fullName", "country"];
          } else {
            keys = ["country"];
          }

          if (this.thirdNoThisTime) {
            keys = [];
          }

          let da = {};
          keys.forEach(function (key) {
            da[key] = this.data[key];
          }.bind(this));
          return da;
        } //获得数据


        getUserAccount() {
          let da = {};
          let keys = ["accountId", "uuid", "source", "firstLogin", "lastLogin", "conLoginDays", "allLoginDays"];
          keys.forEach(function (key) {
            da[key] = this.data[key];
          }.bind(this));
          return da;
        } //获得数据


        getUserInfo() {
          let da = {};
          let keys = ["name", "avatar", "country", "province", "city", "gender", "language", "signName", "isVip"];
          keys.forEach(function (key) {
            da[key] = this.data[key];
          }.bind(this));
          return da;
        } //获得数据


        getUserData() {
          let da = {};
          let keys = ["ap", "apRecover", "apRecoverLast"];
          keys.forEach(function (key) {
            da[key] = this.data[key];
          }.bind(this));
          return da;
        } //用户id


        Id() {
          return this.data.userId;
        }

        UserId() {
          return this.data.userId;
        }

        AccountId() {
          return this.data.accountId;
        }

        ThirdId() {
          return this.AccountId().replace("fb_", "").replace("wx_", "");
        }

        Source() {
          return this.data.source;
        }

        IsFacebook() {
          return this.data.source.contains("fb");
        }

        IsWeixin() {
          return this.data.source.contains("wx");
        }

        IsGuest() {
          return this.data.source.contains("guest");
        } //用户登陆识别码（当前消息发送的uuid与最后一次登陆记录的uuid不同时，判断被其他地方登陆下线）


        Uuid() {
          return this.data.uuid;
        } //网络请求id


        GetRequestId() {
          this.rid++;
          return this.rid;
        } //名字


        Name() {
          return this.data.name;
        } //头像


        Avatar() {
          return this.data.avatar;
        } //地区


        Country() {
          return this.data.country;
        } //好友列表


        FriendsList() {
          return this.data.friendsList;
        } //体力


        Ap() {
          return this.data.ap;
        }

        AP() {
          return this.Ap();
        } //体力恢复时间


        ApRecover() {
          return this.data.apRecover;
        } //体力上次计算时间


        ApRecoverLast() {
          return this.data.apRecoverLast;
        } //更新AP状态


        UpdateApTime() {
          let apMax = G.GameConstance.apMax;
          let apRecoverSpins = G.GameConstance.apRecoverSpins;

          if (Game.SUserStatus.IsVip()) {
            apMax = G.GameConstance.vipApMax;
            apRecoverSpins = G.GameConstance.vipApRecoverSpins;
          }

          let n = this.Ap();
          if (n >= apMax) return;
          this.data.apRecover += GameKit.TimeUtil.getCurrentTime() - 1 - this.data.apRecoverLast;
          let recPoint = Math.max(0, Math.floor(this.data.apRecover / G.GameConstance.apRecover));
          this.data.apRecover -= recPoint * G.GameConstance.apRecover;
          n += recPoint * apRecoverSpins;

          if (n >= apMax) {
            n = apMax;
            this.data.apRecover = 0;
          }

          this.data.apRecoverLast = GameKit.TimeUtil.getCurrentTime() - 1;
          this.data.ap = n;
        }

        GetFullApTime() {
          let apMax = G.GameConstance.apMax;
          let apRecoverSpins = G.GameConstance.apRecoverSpins;

          if (Game.SUserStatus.IsVip()) {
            apMax = G.GameConstance.vipApMax;
            apRecoverSpins = G.GameConstance.vipApRecoverSpins;
          }

          this.UpdateApTime();
          let n = this.Ap();
          if (n >= apMax) return 0;
          return Math.ceil((apMax - n) / apRecoverSpins) * G.GameConstance.apRecover - this.ApRecover();
        } //金币


        Coin() {
          return this.data.coin;
        } //护盾


        Shield() {
          return this.RawShield() + this.ADShield();
        }

        RawShield() {
          return this.data.shield;
        }

        ADShield() {
          return this.data.adshield;
        }

        TimeShield() {
          return this.data.timeShield;
        }

        UpdateTimeShield() {
          let currentTime = GameKit.TimeUtil.getCurrentTime();

          if (this.SuperTimeShield() <= 0) {
            this.data.timeShieldLast += this.superTimeShieldLeft || 0;
            this.data.timeShield -= currentTime - this.data.timeShieldLast;
            this.data.timeShield = Math.max(0, this.data.timeShield);
          }

          this.data.timeShieldLast = currentTime;
        }

        SuperTimeShield() {
          return this.data.superTimeShield;
        }

        UpdateSuperTimeShield() {
          let currentTime = GameKit.TimeUtil.getCurrentTime();
          this.data.superTimeShield -= currentTime - this.data.superTimeShieldLast;
          this.data.superTimeShield = Math.max(0, this.data.superTimeShield);
          this.data.superTimeShieldLast = currentTime;
        } //星级


        Star() {
          if (this !== Game.SUser) return this.data.star;
          return Game.SUserVillage.Star() + Game.SUserServant.Star() + Game.SUserCard.Star();
        } //星级


        IsVip() {
          if (!G.GameConfig.GAME_TEST && !SdkManager.IsNative()) return false;
          if (this !== Game.SUser) return this.data.isVip;
          return Game.SUserStatus.IsVip();
        }

      }

      exports('User', User); // global.User = User

      _defineProperty(User, "isfirst", void 0);

      _defineProperty(User, "Genders", {
        Unknown: "0",
        //未知
        Male: "1",
        //男
        Female: "2",
        //女
        genderFemale: "3" //新加的，在UserInfoModel使用

      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ItemMeta.ts", ['cc', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "50baf4Cd0VFfIxEGy1PyS3j", "ItemMeta", undefined);

      class ItemMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new ItemMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        } //类型


        Type() {
          return this._data.type;
        } //名字


        Name() {
          return i18n.sel(this._data.name);
        } //描述


        Desc() {
          return i18n.sel(this._data.desc);
        } //图标


        Icon() {
          return this._data.icon;
        }

      }

      exports('ItemMeta', ItemMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonGameplay.ts", ['cc', './CCE_Component.ts', './SoundManager.ts', './CannonData.ts', './CannonShopWindow.ts', './CannonTool.ts', './CannonMainWindow.ts', './UIRoot.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, v2, math, CCE_Component, SoundManager, CannonData, CannonShopWindow, CannonTool, CannonMainWindow, UIRoot;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      v2 = module.v2;
      math = module.math;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      CannonData = module.default;
    }, function (module) {
      CannonShopWindow = module.default;
    }, function (module) {
      CannonTool = module.default;
    }, function (module) {
      CannonMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "51d49bqBThKAJm8haPTQ4fn", "CannonGameplay", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CannonGameplay = exports('default', (_dec = property({
        tooltip: "点击范围",
        type: Node,
        visible: true
      }), ccclass(_class = (_class2 = (_temp = _class3 = class CannonGameplay extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_state", "init");

          _defineProperty(this, "_shoot_params", {
            /** @type {cc.Vec2} 触摸点的世界坐标,需要传入,并根据此值计算其余n个值 */
            touch_world_position: null,

            /** @type {cc.Vec2} ball的位置,会根据传入的坐标进行角度和长度的限制 */
            ball_world_position: null,

            /** 根据下文自己添加的 */
            slingshot_world_position: null
          });

          _initializerDefineProperty(this, "_touch_area", _descriptor, this);
        }

        onLoad() {
          CannonGameplay.ins = this;
        }

        onDestroy() {
          CannonGameplay.ins = null;
        }

        start() {
          this._game_init();

          this._reset_shoot_params();
        }
        /**
         * 游戏状态
         * @type {"init" | "pre" | "choose" | "shoot"}
         * - init:初始化状态,获取游戏状态
         * - pre:准备状态,通过touch-start调整炮台方向
         * - choose:选择状态,选择方向,力道
         * - shoot:射状态,不允许调整炮台方向
         */

        /**
         * @param {Array<"init" | "pre" | "choose" | "shoot">} state_list
         */


        _is_state(...state_list) {
          return state_list.includes(this._state);
        }

        _game_init() {
          this._state = "init";

          this._touch_area.on(Node.EventType.TOUCH_START, this._touch_start.bind(this));

          this._touch_area.on(Node.EventType.TOUCH_MOVE, this._touch_move.bind(this));

          this._touch_area.on(Node.EventType.TOUCH_END, this._touch_end.bind(this));

          this._touch_area.on(Node.EventType.TOUCH_CANCEL, this._touch_end.bind(this));

          this._game_pre();
        }

        _game_pre() {
          if (!this._is_state("init", "shoot")) {
            return;
          }

          this._state = "pre";

          this._reset_shoot_params();
        }

        _game_shoot() {
          if (!this._is_state("choose")) {
            return;
          }

          this._state = "shoot"; // 判断:如果没有球,则进入pre状态并弹出购买界面

          if (CannonData.get_ball_count() <= 0) {
            CannonMainWindow.ins.anima_reset_slingshot().then(v => {
              this._game_pre();
            });
            UIRoot.instance.openChildWindow(CannonShopWindow);
            return;
          } // 判断:如果没有box,则进入pre状态


          if (CannonData.get_box_count() <= 0) {
            CannonMainWindow.ins.anima_reset_slingshot().then(v => {
              this._game_pre();
            });
            return;
          } // 判断:如果下拉距离不够,则进入pre状态


          if (this._shoot_params.ball_world_position.subtract(CannonMainWindow.ins.get_ball_viewpoint_world_position()).mag() <= CannonData.BALL_POSITION_LENGTH_NO_ACTION) {
            CannonMainWindow.ins.anima_reset_slingshot().then(v => {
              this._game_pre();
            });
            return;
          } // 射出


          let target_world_position = this._get_shoot_target_world_position();

          let box_hit_index = null;
          CannonMainWindow.ins.anima_reset_slingshot(); // 注意需要直接调用,满足画面延迟

          CannonMainWindow.ins.anima_shoot_ball(target_world_position).then(() => {
            // 判断是否砸到
            CannonMainWindow.ins.get_all_box().forEach((v, i) => {
              if (CannonData.get_box(i) <= 0) {
                return;
              }

              if (v.convertToNodeSpaceAR(target_world_position).subtract(v2(0, -40)).mag() <= 50) {
                CannonMainWindow.ins.anima_box_hit(i);
                box_hit_index = i; // 保存被砸到的序号

                this.scheduleOnce(() => {
                  SoundManager.playSound("cannon_reward");
                }, 0.2);
              }
            });
            SoundManager.playSound("cannon_hit"); // 不论是否被砸到,都使用1个球;如果砸到,则在服务器上计算获取奖励

            CannonData.use_ball(box_hit_index).then(() => {
              this._game_pre();
            });
          });
          SoundManager.playSound("cannon_shoot");
        }
        /** 射击参数 */

        /** 根据参数更新显示 */


        _update_ball_and_slingshot() {
          CannonMainWindow.ins.set_ball_position(this._shoot_params.ball_world_position);
        }
        /** 重置射击参数 */


        _reset_shoot_params() {
          this._shoot_params.touch_world_position = null;
          this._shoot_params.ball_world_position = CannonMainWindow.ins.get_ball_base_world_position();

          this._update_ball_and_slingshot();
        }
        /**
         * 根据触摸点的世界坐标设定shoot参数
         * @param {cc.Vec2} touch_world_position
         */


        _set_shoot_params(touch_world_position) {
          this._shoot_params.touch_world_position = touch_world_position; // 特殊情况:在上方

          if (touch_world_position.y > CannonMainWindow.ins.get_ball_base_world_position().y) {
            touch_world_position.y = CannonMainWindow.ins.get_ball_base_world_position().y;
          } // 根据限制确定ball的位置


          let ball_position_v2 = touch_world_position.subtract(CannonMainWindow.ins.get_ball_viewpoint_world_position());
          ball_position_v2 = CannonTool.clampf_v2(ball_position_v2, CannonData.BALL_POSITION_V2_MIN, CannonData.BALL_POSITION_V2_MAX);
          this._shoot_params.ball_world_position = CannonMainWindow.ins.get_ball_viewpoint_world_position().add(ball_position_v2); // 根据ball的位置确定slingshot的位置

          this._shoot_params.slingshot_world_position = this._shoot_params.ball_world_position; // 修改显示

          this._update_ball_and_slingshot();
        }
        /** 根据射击参数获取射击的目标点 */


        _get_shoot_target_world_position() {
          let length = this._shoot_params.ball_world_position.subtract(CannonMainWindow.ins.get_ball_viewpoint_world_position()).mag();

          let target_length = math.lerp(CannonData.TARGET_POSITION_LENGTH_MIN, CannonData.TARGET_POSITION_LENGTH_MAX, CannonTool.get_lerp(length, CannonData.BALL_POSITION_LENGTH_MIN, CannonData.BALL_POSITION_LENGTH_MAX));
          return this._shoot_params.ball_world_position.subtract(CannonMainWindow.ins.get_ball_viewpoint_world_position()).normalize().mul(-target_length).add(CannonMainWindow.ins.get_ball_viewpoint_world_position());
        }
        /** @type {cc.Node} */

        /**
         * @param {cc.Event.EventTouch} e
         */


        _touch_start(e) {
          if (!this._is_state("pre")) {
            return;
          } // 额外判断:是否摸到了ball


          if (CannonMainWindow.ins.get_ball_base_world_position().subtract(e.getLocation()).mag() >= 50) {
            return;
          }

          CannonMainWindow.ins.reset_guide_hand_timer();
          CannonMainWindow.ins.hide_guide_hand();
          this._state = "choose";

          this._set_shoot_params(e.getLocation());
        }
        /**
         * @param {cc.Event.EventTouch} e
         */


        _touch_move(e) {
          if (!this._is_state("choose")) {
            return;
          }

          CannonMainWindow.ins.reset_guide_hand_timer();
          CannonMainWindow.ins.hide_guide_hand();

          this._set_shoot_params(e.getLocation());
        }
        /**
         * @param {cc.Event.EventTouch} e
         */


        _touch_end(e) {
          if (!this._is_state("choose")) {
            return;
          }

          this._set_shoot_params(e.getLocation());

          this._game_shoot();
        }

      }, _defineProperty(_class3, "ins", void 0), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "_touch_area", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RichTextHandler.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, EventHandler, CCString, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      EventHandler = module.EventHandler;
      CCString = module.CCString;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp, _dec4, _dec5, _class4, _class5, _descriptor3, _temp2;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "53152eg8qVKJ7lQ3/T9Lq49", "RichTextHandler", undefined);
      /**
       * 与RichText一起用来触发文本点击事件
       * eg:1.在本脚本中key 设为 h1，点击事件设置对象、脚本与方法（onH1）
       *    2.<on click="handle" param="h1">click me!</on> 
       *      文本中param填上需要触发点击事件的key
       *    3.onH1(e, p) {console.log("h1", e, p)} 对应对象的该方法会被调用
       *      参数中e为点击event，p为设置的参数
       */


      const {
        ccclass,
        property
      } = _decorator;
      let RichTextHandleItem = (_dec = ccclass("RichTextHandleItem"), _dec2 = property(EventHandler), _dec3 = property(CCString), _dec(_class = (_class2 = (_temp = class RichTextHandleItem {
        constructor() {
          _initializerDefineProperty(this, "handler", _descriptor, this);

          _initializerDefineProperty(this, "key", _descriptor2, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "handler", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "key", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      })), _class2)) || _class);
      let RichTextHandler = exports('default', (_dec4 = ccclass("RichTextHandler"), _dec5 = property([RichTextHandleItem]), _dec4(_class4 = (_class5 = (_temp2 = class RichTextHandler extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "handler", _descriptor3, this);

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "_handlers", void 0);
        }

        start() {
          this.init();
        }

        init() {
          if (this.inited) return;
          this._handlers = {};
          this.handler.forEach(con => {
            if (con != null) this._handlers[con.key] = con.handler;
          });
          this.inited = true;
        }

        handle(e, key) {
          this.init();

          if (this._handlers[key]) {
            this._handlers[key].emit([e]);
          }
        }

      }, _temp2), _descriptor3 = _applyDecoratedDescriptor(_class5.prototype, "handler", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class5)) || _class4));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SdkManager.ts", ['cc', './global.ts', './Logs.ts', './fbIn_lib.ts', './wx_lib.ts', './AppGame.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './NativeWrap.ts', './NotificationWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, sys, G, Logs, fbInTools, wxTools, AppGame, UIRoot, ActivityManager, Game, LogEventWrap, ADWrap, NativeWrap, NotificationWrap, PaymentWrap, GameKit, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sys = module.sys;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function (module) {
      NotificationWrap = module.NotificationWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('SdkManager', void 0);

      cclegacy._RF.push({}, "53b03F2ahNForXA1kRi/W63", "SdkManager", undefined);

      let SdkManager;

      (function (_SdkManager) {
        let FB_BOT_ACTIVITY = false;
        let inited = false;
        let GameClubButton;

        let _bottimer;

        function Init(callback) {
          if (inited) {
            if (callback != null) callback();
            return;
          }

          G.query = {};

          if (wxTools.usewx) {
            wxInit();
          } else if (fbInTools.usefbIn) {
            fbInInit();
          } else if (SdkManager.IsNative()) {
            SdkManager.NativeInit();
          } else ;

          ADWrap.Init();
          PaymentWrap.Init(); // AppKit.LeaderBoardWrap.Init();

          NotificationWrap.Init();
          if (callback != null) callback();
          inited = true;
        }

        _SdkManager.Init = Init;

        function logined() {
          if (wxTools.usewx) ;else if (fbInTools.usefbIn) {
            fbLogined();
          } else ;
        }

        _SdkManager.logined = logined;

        function EnterGame() {
          PaymentWrap.Reorder();
          PaymentWrap.Restore();
        }

        _SdkManager.EnterGame = EnterGame;

        function AssetsPathToRealPath(path) {
          return "res/raw-assets/" + path;
        }

        _SdkManager.AssetsPathToRealPath = AssetsPathToRealPath;

        function IsAndroid() {
          if (wxTools.usewx) {
            return wx.getSystemInfoSync().system.toLowerCase().contains("android");
          } else if (fbInTools.usefbIn) {
            return FBInstant.getPlatform().toLowerCase().contains("android");
          } else {
            return sys.os == sys.OS_ANDROID;
          }
        }

        _SdkManager.IsAndroid = IsAndroid;

        function IsIos() {
          if (wxTools.usewx) {
            return wx.getSystemInfoSync().system.toLowerCase().contains("ios");
          } else if (fbInTools.usefbIn) {
            return FBInstant.getPlatform().toLowerCase().contains("ios");
          } else {
            return sys.os == sys.OS_IOS;
          }
        }

        _SdkManager.IsIos = IsIos;

        function IsNative() {
          return sys.isNative;
        }

        _SdkManager.IsNative = IsNative;

        function IsBrowser() {
          return sys.isBrowser;
        }

        _SdkManager.IsBrowser = IsBrowser;

        function IsMobile() {
          return sys.isMobile;
        }

        _SdkManager.IsMobile = IsMobile;

        function wxInit() {
          wx.onShow(res => {
            Logs.Info("wx.onShow");
            G.query = res.query;
            G.shareTicket = res.shareTicket;
          });
          wx.onHide(res => {
            Logs.Info("wx.onHide");
          }); //share

          if (wxTools.SdkVersionOver("1.1.0") >= 0) wx.showShareMenu({
            withShareTicket: true
          });
          wx.onShareAppMessage(function () {
            return {
              title: i18n.t("ShareTitle"),
              imageUrl: SdkManager.AssetsPathToRealPath("share/share1"),
              query: wxTools.QueryObjectToString({
                inviteId: Game.SUser.UserId()
              })
            };
          }); //sharedCanvas

          let sharedCanvas = wxTools.OpenDataCanvas();

          if (sharedCanvas) {
            sharedCanvas.width = UIRoot.instance.winSize.width;
            sharedCanvas.height = UIRoot.instance.winSize.height;
          } //GameClub


          if (wxTools.SdkVersionOver("2.0.3") >= 0) {
            GameClubButton = wx.createGameClubButton({
              icon: "light",
              style: {
                left: 2,
                top: wx.getSystemInfoSync().screenHeight - 42,
                width: 40,
                height: 40
              }
            });
          }

          wx.setKeepScreenOn({
            keepScreenOn: true
          });
          G.query = wx.getLaunchOptionsSync().query;
          G.shareTicket = wx.getLaunchOptionsSync().shareTicket;
        }

        _SdkManager.wxInit = wxInit;

        function wxLogined() {}

        _SdkManager.wxLogined = wxLogined;

        function wxGameClubButtonHide() {
          if (GameClubButton) {
            GameClubButton.hide();
          }
        }

        _SdkManager.wxGameClubButtonHide = wxGameClubButtonHide;

        function wxGameClubButtonShow() {
          if (GameClubButton) {
            GameClubButton.show();
          }
        }

        _SdkManager.wxGameClubButtonShow = wxGameClubButtonShow;

        function fbInInit() {
          G.query = FBInstant.getEntryPointData() || {};
        }

        _SdkManager.fbInInit = fbInInit;

        function fbLogined() {
          var fbbottimer = function () {
            FBInstant.setSessionData({
              nickname: Game.SUser.Name(),
              //friends:AppKit.UserWrap.friends_results, //好友列表
              playerInfo: {
                head: Game.SUser.Avatar(),
                score: Game.SUser.Star(),
                level: Game.SUser.Coin()
              },
              data: SdkManager.GetBotMessage()
            });
          };

          fbbottimer();
          if (!_bottimer) _bottimer = setInterval(() => {
            fbbottimer();
          }, 120 * 1000);
        }

        _SdkManager.fbLogined = fbLogined;

        function GetBotMessage() {
          let result = [];
          if (!AppGame.instance.logined) return result;
          let currentTime = GameKit.TimeUtil.getCurrentTime();
          let needTime = 0;
          /*needTime = Game.SUser.GetFullApTime()
          if (needTime > 0) {
          	let lastTime = GameKit.PlayerPrefs.GetInt("FB_BOT_APFULL_LASTTIME", 0)
          	if (SdkManager.FB_BOT_APFULL || lastTime > currentTime || currentTime > lastTime + GameKit.TimeUtil.HourInSecond * 10) {
          		result.push([{
          			"bg": "img_share_tili",//可以是http地址，也可以是以img_开头的变量配置到gameId.json文件中，也可以是head_xxx:表示使用playerId为xxx的头像
          			"t": "You have got full spins!",//可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
          			"st": "We have enough spins to play and get more coins!",//（选填）可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
          			"da":{//默认动作,类似bts内元素
          				"u": "game_play",//当u值为game_play时点击按钮可以进入游戏(还可传入合法链接)
          				"pld": {
          					type: "bot_apFull"
          				},
          			},
          			"tm": Math.ceil(needTime),//客户端设置定时闹钟时传入(0:时立刻发送;-1:服务端决定发送时间)
          			//"pms": {"nk":"nickname"},//用于模板填充
          			"bts": [//按钮（选填）
          				{
          					"t": "Play!",
          					"u": "game_play",
          					"pld": {
          						type: "bot_apFull"
          					},
          				}
          			],
          		}])
          		let sendadd = 60 - (currentTime + needTime) % 3600
          		sendadd = sendadd >= 0 ? sendadd : 3600 + sendadd
          		GameKit.PlayerPrefs.SetInt("FB_BOT_APFULL_LASTTIME", currentTime + needTime + sendadd)
          		SdkManager.FB_BOT_APFULL = true
          	}
          }*/

          /*needTime = Game.SUserSlot.DailyBonusRemainTime()
          if (needTime > 0) {
          	//let lastTime = GameKit.PlayerPrefs.GetInt("FB_BOT_DAILYBONUS_LASTTIME", 0)
          	//if (SdkManager.FB_BOT_DAILYBONUS || lastTime > currentTime) {
          		result.push([{
          			"bg": "img_share_libao",//可以是http地址，也可以是以img_开头的变量配置到gameId.json文件中，也可以是head_xxx:表示使用playerId为xxx的头像
          			"t": "Daily bonus is available now!",//可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
          			"st": "Come and play daily Wheel of Fortune!",//（选填）可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
          			"da":{//默认动作,类似bts内元素
          				"u": "game_play",//当u值为game_play时点击按钮可以进入游戏(还可传入合法链接)
          				"pld": {
          					type: "bot_bonusReady"
          				},
          			},
          			"tm": Math.ceil(needTime),//客户端设置定时闹钟时传入(0:时立刻发送;-1:服务端决定发送时间)
          			//"pms": {"nk":"nickname"},//用于模板填充
          			"bts": [//按钮（选填）
          				{
          					"t": "Spin!",
          					"u": "game_play",
          					"pld": {
          						type: "bot_bonusReady"
          					},
          				}
          			],
          		}])
          	//    GameKit.PlayerPrefs.SetInt("FB_BOT_DAILYBONUS_LASTTIME", currentTime + needTime)
          	//    SdkManager.FB_BOT_DAILYBONUS = true
          	//}
          }*/

          /*needTime = Game.SUserSlot.data.systemUserEffectTime[1] - currentTime
          if (needTime > 0) {
          	let lastTime = GameKit.PlayerPrefs.GetInt("FB_BOT_OTHERS_LASTTIME", 0)
          	if (SdkManager.FB_BOT_OTHERS || lastTime > currentTime || currentTime > lastTime + GameKit.TimeUtil.HourInSecond * 12) {
          		result.push([{
          			"bg": "img_share_shouji",//可以是http地址，也可以是以img_开头的变量配置到gameId.json文件中，也可以是head_xxx:表示使用playerId为xxx的头像
          			"t": "Someone has invaded your bussiness!",//可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
          			"st": "Let’s revenge!",//（选填）可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
          			"da":{//默认动作,类似bts内元素
          				"u": "game_play",//当u值为game_play时点击按钮可以进入游戏(还可传入合法链接)
          				"pld": {
          					type: "bot_invaded"
          				},
          			},
          			"tm": Math.ceil(needTime),//客户端设置定时闹钟时传入(0:时立刻发送;-1:服务端决定发送时间)
          			//"pms": {"nk":"nickname"},//用于模板填充
          			"bts": [//按钮（选填）
          				{
          					"t": "Revenge!",
          					"u": "game_play",
          					"pld": {
          						type: "bot_invaded"
          					},
          				}
          			],
          		}])
          		let sendadd = 60 - (currentTime + needTime) % 3600
          		sendadd = sendadd >= 0 ? sendadd : 3600 + sendadd
          		GameKit.PlayerPrefs.SetInt("FB_BOT_OTHERS_LASTTIME", currentTime + needTime + sendadd)
          		SdkManager.FB_BOT_OTHERS = true
          	}
          }*/

          let shopActivity = ActivityManager.GetActiveShopActivity();
          let gameActivity = null;
          let activity = null;

          if (shopActivity != null && gameActivity == null) {
            activity = shopActivity;
          } else if (shopActivity == null && gameActivity != null) {
            activity = gameActivity;
          } else if (shopActivity != null && gameActivity != null) {
            activity = shopActivity.EndTime() < gameActivity.EndTime() ? shopActivity : gameActivity;
          }

          if (activity) {
            needTime = activity.EndTime() - GameKit.TimeUtil.HourInSecond * 1 - currentTime;

            if (needTime > 0) {
              let lastTime = GameKit.PlayerPrefs.GetInt("FB_BOT_ACTIVITY_LASTTIME", 0);

              if (FB_BOT_ACTIVITY || lastTime > currentTime || currentTime > lastTime + GameKit.TimeUtil.HourInSecond * 2) {
                result.push([{
                  bg: "img_share_libao",
                  //可以是http地址，也可以是以img_开头的变量配置到gameId.json文件中，也可以是head_xxx:表示使用playerId为xxx的头像
                  t: "Activity will end!",
                  //可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
                  st: activity.Name() + " will end in an hour!",
                  //（选填）可以使用普通文本，也可使用以text_开头的变量配置到gameId.json文件里
                  da: {
                    //默认动作,类似bts内元素
                    u: "game_play",
                    //当u值为game_play时点击按钮可以进入游戏(还可传入合法链接)
                    pld: {
                      type: "bot_activity"
                    }
                  },
                  tm: Math.ceil(needTime),
                  //客户端设置定时闹钟时传入(0:时立刻发送;-1:服务端决定发送时间)
                  //"pms": {"nk":"nickname"},//用于模板填充
                  bts: [//按钮（选填）
                  {
                    t: "Play!",
                    u: "game_play",
                    pld: {
                      type: "bot_activity"
                    }
                  }]
                }]);
                let sendadd = 60 - (currentTime + needTime) % 3600;
                sendadd = sendadd >= 0 ? sendadd : 3600 + sendadd;
                GameKit.PlayerPrefs.SetInt("FB_BOT_ACTIVITY_LASTTIME", currentTime + needTime + sendadd);
                FB_BOT_ACTIVITY = true;
              }
            }
          }

          return result;
        }

        _SdkManager.GetBotMessage = GetBotMessage;

        function fbSetCutAndBot() {
          var createShortCut = function () {
            let scc = GameKit.PlayerPrefs.GetInt("CreateShortCut", 0);
            if (scc >= 2) return;
            FBInstant.canCreateShortcutAsync().then(function (canCreateShortcut) {
              if (canCreateShortcut) {
                FBInstant.createShortcutAsync().then(function () {
                  GameKit.PlayerPrefs.SetInt("CreateShortCut", 2);
                }).catch(function () {
                  scc++;
                  GameKit.PlayerPrefs.SetInt("CreateShortCut", scc);
                });
              }
            });
          };

          FBInstant.player.canSubscribeBotAsync().then(can_subscribe => {
            if (!can_subscribe) {
              //createShortCut()
              //return
              console.log("can't.subtractscribe");
            }

            LogEventWrap.logEvent("bot.subtractscribe", {
              result: -1
            });
            FBInstant.player.subtractscribeBotAsync().then(function () {
              LogEventWrap.logEvent("bot.subtractscribe", {
                result: 1
              });
              createShortCut();
            }).catch(function (e) {
              console.log("subscribeBotAsync e", e);
              LogEventWrap.logEvent("bot.subtractscribe", {
                result: 0
              });
              createShortCut();
            });
          }).catch(function (e) {
            LogEventWrap.logEvent("bot.subtractscribe", {
              result: 0
            });
            createShortCut();
          });
        }

        _SdkManager.fbSetCutAndBot = fbSetCutAndBot;

        function NativeInit() {}

        _SdkManager.NativeInit = NativeInit;

        function GetQuery(callback) {
          let isg = GameKit.PlayerPrefs.GetBool("isGetQuery", false);

          if (isg) {
            if (callback) callback();
            return;
          }

          GameKit.PlayerPrefs.SetBool("isGetQuery", true);
          SdkManager.FBGetQuery(() => {
            if (Object.keys(G.query).length <= 0 && SdkManager.IsNative()) {
              NativeWrap.call("SDKHandleClass", "getQuery", {
                redirectUrl: G.GameConfig.redirectUrl
              }, res => {
                if (res.queryUrl) {
                  let url = unescape(res.queryUrl);
                  url = url.replace("impostorkings://query=", "");
                  let appquery = JSON.parse(url);

                  for (let key in appquery) {
                    G.query[key] = appquery[key];
                  }
                }

                if (callback) callback();
              }, 5);
            } else {
              if (callback) callback();
            }
          });
        }

        _SdkManager.GetQuery = GetQuery;

        function FBGetQuery(callback) {
          if (SdkManager.IsNative() && Game.SUser.IsFacebook()) {
            NativeWrap.call("FBSdk", "getQuery", null, res => {
              if (res.success) {
                G.query = res.query || {};
              }

              if (callback) callback();
            }, 7);
            return;
          }

          if (callback) callback();
        }

        _SdkManager.FBGetQuery = FBGetQuery;
      })(SdkManager || (SdkManager = exports('SdkManager', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRRecord.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRRecord', void 0);

      cclegacy._RF.push({}, "557ddLeGedNAYpQnDGSjTT0", "SRRecord", undefined);

      let SRRecord;

      (function (_SRRecord) {
        function getUserRecord() {
          let req = new GameKit.ServerRequest("getUserRecord");
          req.SetCallBack(function (res) {
            Game.SUserRecord.updateData(res.userdata);
          });
          return req;
        }

        _SRRecord.getUserRecord = getUserRecord;
      })(SRRecord || (SRRecord = exports('SRRecord', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SoundManager.ts", ['cc', './global.ts', './wx_lib.ts', './_app.ts', './audioEngine.ts', './SdkManager.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, sys, game, Game, AudioClip, resources, loader, G, cce, audioEngine, SdkManager;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sys = module.sys;
      game = module.game;
      Game = module.Game;
      AudioClip = module.AudioClip;
      resources = module.resources;
      loader = module.loader;
    }, function (module) {
      G = module.G;
    }, function () {}, function (module) {
      cce = module.cce;
    }, function (module) {
      audioEngine = module.audioEngine;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function () {}],
    execute: function () {
      exports('SoundManager', void 0);

      cclegacy._RF.push({}, "57643VoF+FIxYeTJ2hGlX+R", "SoundManager", undefined);

      let SoundManager;

      (function (_SoundManager) {
        let SoundNames;

        (function (SoundNames) {
          SoundNames["BGM_Menu"] = "bgm1";
          SoundNames["BGM_Attack"] = "bgm_attack";
          SoundNames["BGM_Raid"] = "bgm_raid";
          SoundNames["BGM_BlackJack"] = "bgm_blackjack";
        })(SoundNames || (SoundNames = {}));

        _SoundManager.SoundNames = SoundNames;
        let aVolume = 1;
        let soundVolume = 1;
        let bgmId = null;
        let BgmNum = 1;
        let SEs = {};
        const SECache = _SoundManager.SECache = {};
        let soundMp3LoopIds;

        function init() {
          aVolume = parseFloat(sys.localStorage.getItem("BGMSwitch"));

          if (aVolume !== 0 && !aVolume) {
            aVolume = 1;
            sys.localStorage.setItem("BGMSwitch", aVolume);
          }

          soundVolume = parseFloat(sys.localStorage.getItem("SoundSwitch"));

          if (soundVolume !== 0 && !soundVolume) {
            soundVolume = 1;
            sys.localStorage.setItem("SoundSwitch", soundVolume);
          }

          game.on(Game.EVENT_HIDE, function () {
            {
              ccAudioEngine.pauseAll();
            }
          });
          game.on(Game.EVENT_SHOW, () => {
            {
              ccAudioEngine.resumeAll();

              if (bgmId != null) {
                let stat = ccAudioEngine.getState(bgmId);

                if (stat != ccAudioEngine.AudioState.PLAYING) {
                  playBgm();
                }
              }
            }
          });
          soundMp3LoopIds = {}; //playBgm()
        }

        _SoundManager.init = init;

        function playBgm() {
          if (aVolume <= 0) return;
          let bgmIndex = G.getRandomInt(1, BgmNum + 1);
          {
            ccAudioEngine.stop(bgmId);
            let resName = "audio/bgm/bgm" + bgmIndex.toString();
            cce.loadRes(resName, AudioClip, (err, audio) => {
              if (err) {
                return;
              }

              bgmId = ccAudioEngine.play(audio, true, 0.8 * aVolume);
            });
          }
        }

        _SoundManager.playBgm = playBgm;

        function playBgmByName(bgmName) {
          bgmName = bgmName;
          if (aVolume <= 0) return;
          {
            ccAudioEngine.stop(bgmId);
            let resName = "audio/bgm/" + bgmName;
            console.log("bgmName", resName);
            cce.loadRes(resName, AudioClip, (err, audio) => {
              if (err) {
                return;
              }

              bgmId = ccAudioEngine.play(audio, true, 0.8 * aVolume);
            });
          }
        }

        _SoundManager.playBgmByName = playBgmByName;

        function SetBgmLoop(lo) {
          {
            if (bgmId) ccAudioEngine.setLoop(bgmId, lo);
          }
        }

        _SoundManager.SetBgmLoop = SetBgmLoop;

        function playSound(soundName, customVolume = 1, loop = false) {
          if (soundVolume <= 0) return;
          if (!SEs.hasOwnProperty(soundName)) SEs[soundName] = [];
          {
            let _playSound = audio => {
              loader.setAutoRelease(audio, false);
              let sid = ccAudioEngine.playOneShot(audio, loop, 1 * customVolume);
              ccAudioEngine.setFinishCallback(sid, function () {
                SEs[soundName].remove(sid);
              });
              SEs[soundName].push(sid);

              var _loopsound = id => {
                soundMp3LoopIds[id] = setTimeout(() => {
                  ccAudioEngine.setCurrentTime(id, 0.05);

                  _loopsound(id);
                }, (ccAudioEngine.getDuration(id) - 0.08) * 1000);
              };

              if (loop) {
                _loopsound(sid);
              }
            };

            if (SECache[soundName] != null) {
              _playSound(SECache[soundName]);
            } else {
              let resName = "audio/fx/" + soundName;
              cce.loadRes(resName, AudioClip, (err, audio) => {
                if (err) {
                  return;
                }

                _playSound(audio);
              });
            }
          }
        }

        _SoundManager.playSound = playSound;

        function stopSound(soundName) {
          if (!SEs.hasOwnProperty(soundName)) SEs[soundName] = [];

          for (let i = 0; i < SEs[soundName].length; i++) {
            {
              let sid = SEs[soundName][i];

              if (sid != null) {
                ccAudioEngine.stop(sid);

                if (soundMp3LoopIds[sid] != null) {
                  clearTimeout(soundMp3LoopIds[sid]);
                  delete soundMp3LoopIds[sid];
                }
              }
            }
          }

          SEs[soundName] = [];
        }

        _SoundManager.stopSound = stopSound;

        function stopSoundOne(soundName) {
          if (!SEs.hasOwnProperty(soundName)) SEs[soundName] = [];
          let i = 0;
          if (SEs[soundName].length <= 0) return;
          {
            let sid = SEs[soundName][i];

            if (sid != null) {
              ccAudioEngine.stop(sid);

              if (soundMp3LoopIds[sid] != null) {
                clearTimeout(soundMp3LoopIds[sid]);
                delete soundMp3LoopIds[sid];
              }
            }

            SEs[soundName].remove(sid);
          }
        }

        _SoundManager.stopSoundOne = stopSoundOne;

        function SetSoundLoop(soundName) {
          if (!SEs.hasOwnProperty(soundName)) SEs[soundName] = [];

          var _loopsound = function (id) {
            if (soundMp3LoopIds[id] != null) {
              clearTimeout(soundMp3LoopIds[id]);
              soundMp3LoopIds[id] = null;
            }

            soundMp3LoopIds[id] = setTimeout(() => {
              ccAudioEngine.setCurrentTime(id, 0.05);

              _loopsound(id);
            }, (ccAudioEngine.getDuration(id) - 0.08) * 1000);
          }.bind(this);

          for (let i = 0; i < SEs[soundName].length; i++) {
            let sid = SEs[soundName][i];

            if (sid != null) {
              _loopsound(sid);
            }
          }
        }

        _SoundManager.SetSoundLoop = SetSoundLoop;

        function loadSound(soundName) {
          {
            if (SECache[soundName] == null) {
              let resName = "audio/fx/" + soundName;
              cce.loadRes(resName, AudioClip, (err, audio) => {
                if (err) {
                  return;
                }

                SECache[soundName] = audio;
              });
            }
          }
        }

        _SoundManager.loadSound = loadSound;

        function preloadSound() {
          if (SdkManager.IsNative()) return;
          {
            resources.loadDir("audio/fx", AudioClip, (err, audios) => {
              if (err) {
                return;
              }

              audios.forEach(audio => {
                SECache[audio.name] = audio;
              });
            });
            resources.load("audio/bgm/" + SoundNames.BGM_Attack, AudioClip, function (err, audio) {}.bind(SoundManager));
            resources.load("audio/bgm/" + SoundNames.BGM_Raid, AudioClip, function (err, audio) {}.bind(SoundManager));
          }
        }

        _SoundManager.preloadSound = preloadSound;

        function changeBGMSwitch() {
          aVolume = 1 - aVolume;
          sys.localStorage.setItem("BGMSwitch", aVolume);
          {
            if (aVolume <= 0) {
              if (bgmId) {
                audioEngine.stop(bgmId);
              } else {
                audioEngine.stopAll();
              }
            } else {
              playBgm();
            }
          }
        }

        _SoundManager.changeBGMSwitch = changeBGMSwitch;

        function changeSoundSwitch() {
          soundVolume = 1 - soundVolume;
          sys.localStorage.setItem("SoundSwitch", soundVolume);
        }

        _SoundManager.changeSoundSwitch = changeSoundSwitch;

        function getBGMSwitch() {
          return aVolume > 0;
        }

        _SoundManager.getBGMSwitch = getBGMSwitch;

        function getSoundSwitch() {
          return soundVolume > 0;
        }

        _SoundManager.getSoundSwitch = getSoundSwitch;
      })(SoundManager || (SoundManager = exports('SoundManager', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NewTutorilaWindow.ts", ['cc', './Constant.ts', './EnterCloseAnim.ts', './UIWindow.ts', './DialogWindow.ts', './RoomManager.ts', './TouchTest.ts', './UIRoot.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, dragonBones, Label, Sprite, Camera, _decorator, SpriteFrame, Vec3, Tween, tween, BlockInputEvents, director, Canvas, view, UITransform, instantiate, Layers, Color, RenderTexture, Mask, CameraLayers, MyCustomEvent, EnterCloseAnim, UIWindow, DialogWindow, RoomManager, TouchTest, UIRoot, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      dragonBones = module.dragonBones;
      Label = module.Label;
      Sprite = module.Sprite;
      Camera = module.Camera;
      _decorator = module._decorator;
      SpriteFrame = module.SpriteFrame;
      Vec3 = module.Vec3;
      Tween = module.Tween;
      tween = module.tween;
      BlockInputEvents = module.BlockInputEvents;
      director = module.director;
      Canvas = module.Canvas;
      view = module.view;
      UITransform = module.UITransform;
      instantiate = module.instantiate;
      Layers = module.Layers;
      Color = module.Color;
      RenderTexture = module.RenderTexture;
      Mask = module.Mask;
    }, function (module) {
      CameraLayers = module.CameraLayers;
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      TouchTest = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "57979k6Lc5J04DU36r5AqKX", "NewTutorilaWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NewTutorialWindow = exports('NewTutorialWindow', (_dec = ccclass("NewTutorialWindow"), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(dragonBones.ArmatureDisplay), _dec5 = property(Label), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Sprite), _dec9 = property(Sprite), _dec10 = property(Camera), _dec11 = property(Node), _dec12 = property(Node), _dec(_class = (_class2 = (_temp = _class3 = class NewTutorialWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "model", _descriptor, this);

          _initializerDefineProperty(this, "title", _descriptor2, this);

          _initializerDefineProperty(this, "db", _descriptor3, this);

          _initializerDefineProperty(this, "tip", _descriptor4, this);

          _initializerDefineProperty(this, "btnNode", _descriptor5, this);

          _initializerDefineProperty(this, "person", _descriptor6, this);

          _initializerDefineProperty(this, "targetSprite", _descriptor7, this);

          _initializerDefineProperty(this, "target3DSprite", _descriptor8, this);

          _initializerDefineProperty(this, "captureCamera", _descriptor9, this);

          _initializerDefineProperty(this, "fakeTargetNode", _descriptor10, this);

          _initializerDefineProperty(this, "btnSkipNode", _descriptor11, this);

          _defineProperty(this, "_stopEvent", false);

          _defineProperty(this, "_spriteFrame", new SpriteFrame());

          _defineProperty(this, "_preTarget", null);

          _defineProperty(this, "_pre3DTarget", null);

          _defineProperty(this, "_pre3DTargetLayer", 0);

          _defineProperty(this, "_preTargetLayer", CameraLayers.UI2D);

          _defineProperty(this, "_renderCameraNodes", []);

          _defineProperty(this, "_targetNode", null);

          _defineProperty(this, "isInRect", false);

          _defineProperty(this, "_handPos", new Vec3());

          _defineProperty(this, "_prePos", new Vec3());
        }

        set titleNode(value) {
          this.title.active = value;
        }

        set modelNode(value) {
          // this.model.active = false;
          // this.model.opacity = 0;
          Tween.stopAllByTarget(this.model);

          if (value) {
            tween(this.model).set({
              active: true
            }).to(0.3, {
              opacity: 255
            }).start();
          } else {
            tween(this.model).to(0.1, {
              opacity: 0
            }).call(() => {
              this.model.active = false;
            }).start();
          }
        }

        set stopEvent(value) {
          this._stopEvent = value;
        }

        set enableBlockEvent(value) {
          this.model.getComponent(BlockInputEvents).enabled = value;
        }

        onLoad() {
          director.getScene().on(Node.EventType.TOUCH_START, this.addTouchEventListener, this, true);
          director.getScene().getChildByName("Canvas").getComponent(Canvas).cameraComponent = this.captureCamera;
          const renderTexture = this.captureCamera.targetTexture;

          if (renderTexture) {
            renderTexture.reset(view.getVisibleSize());
            this._spriteFrame.texture = renderTexture;
          }

          this.btnSkipNode.active = appGame.isDev;
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.btnSkipNode.active = appGame.isDev;
          }, this); // this.node.getChildByName("content").getComponent(Widget).top += AppMain.instance.statusBarHeight;

          this.targetSprite.getComponent(UITransform).setContentSize(view.getVisibleSize());
          this.targetSprite.spriteFrame = this._spriteFrame;
        }

        addTouchEventListener(event) {
          if (event.target.name === "btnSkip") {
            this.onTapSkip();
            return;
          }

          if (!this._targetNode) {
            event.propagationImmediateStopped = true;
            return;
          }

          const isInRect = TouchTest.isTouchInRect(event, this._targetNode);

          if (!isInRect && this._stopEvent) {
            event.propagationImmediateStopped = true;
          }
        }

        highLightTargetNode(targetNode) {
          this.targetSprite.node.active = true;
          this._targetNode = targetNode;

          if (this._preTarget) {
            this.setChildrenLayer(this._preTarget, this._preTargetLayer || CameraLayers.UI2D);
            this.setParentsLayer(this._preTarget, this._preTargetLayer || CameraLayers.UI2D);
          }

          this._preTarget = targetNode;
          this._preTargetLayer = targetNode.layer;
          this.setChildrenLayer(targetNode, CameraLayers.tutorial);
          this.setParentsLayer(targetNode, CameraLayers.tutorial);
        }

        unhighLigtTargetNode() {
          if (this._preTarget) {
            this.setChildrenLayer(this._preTarget, CameraLayers.UI2D);
            this.setParentsLayer(this._preTarget, CameraLayers.UI2D);
            this._preTarget = null;
          }

          this.targetSprite.node.active = false;
        }

        highLight3DObject(targetNode, isRaid = false) {
          this._targetNode = null;

          if (this._pre3DTarget) {
            this.setChildrenLayer(this._pre3DTarget, this._pre3DTargetLayer);
          }

          this._pre3DTarget = targetNode;
          this._pre3DTargetLayer = targetNode.layer;
          this.setChildrenLayer(targetNode, CameraLayers.tutorial);
          let oldCamera = RoomManager.instance.node.parent.getChildByName("Main Camera");

          if (isRaid) {
            oldCamera = homeView.interactionNode.villageContainer.getChildByName("raid3d").getChildByName("Camera");
          }

          const newCamera = instantiate(oldCamera);
          newCamera.getComponent(Camera).visibility = CameraLayers.tutorial + Layers.BitMask.DEFAULT;
          newCamera.getComponent(Camera).clearColor = new Color(0, 0, 0, 0);
          oldCamera.parent.addChild(newCamera);

          this._renderCameraNodes.push(newCamera);

          const spriteFrame = this.targetSprite.spriteFrame;

          const _sp = new SpriteFrame();

          _sp.reset({
            originalSize: spriteFrame.originalSize,
            rect: spriteFrame.rect,
            offset: spriteFrame.offset,
            isRotate: spriteFrame.rotated,
            borderTop: spriteFrame.insetTop,
            borderLeft: spriteFrame.insetLeft,
            borderBottom: spriteFrame.insetBottom,
            borderRight: spriteFrame.insetRight
          });

          const rt = new RenderTexture();
          rt.reset(view.getVisibleSize());
          newCamera.getComponent(Camera).targetTexture = rt;
          _sp.texture = rt;
          this.target3DSprite.getComponent(UITransform).setContentSize(view.getVisibleSize());
          this.target3DSprite.spriteFrame = _sp;
        }

        unHighLightPre3DObject() {
          if (this._pre3DTarget) {
            this.setChildrenLayer(this._pre3DTarget, this._pre3DTargetLayer);
            this._pre3DTarget = null;
          }

          this.target3DSprite.spriteFrame = null;
        }

        setParentsLayer(_node, layer) {
          _node.layer = layer;
          let parent = _node.parent;

          while (parent && parent.name !== "Canvas") {
            if (!!parent.getComponent(Mask)) {
              parent.layer = layer;
            }

            parent = parent.parent;
          }
        }

        setChildrenLayer(_node, layer) {
          _node.layer = layer;

          let _child = parentNode => {
            parentNode.layer = layer;
            parentNode.children.forEach(child => {
              if (child.children.length > 0) {
                _child(child);
              } else {
                child.layer = layer;
              }
            });
          };

          _node.children.forEach(child => {
            _child(child);
          });
        }

        showArrow(pos, angle) {
          this.db.node.setPosition(pos);
          this.db.node.angle = angle || 0;
          this.db.node.active = true;
          this.db.timeScale = 1;
          this.db.playAnimation("arrow", 0);
        }

        showHand(targetNode) {
          this.db.timeScale = 0;
          this.db.node.active = false;

          if (targetNode instanceof Vec3) {
            this.db.node.setPosition(targetNode);
            this.db.node.active = true;
            this.db.timeScale = 1;
            this.db.playAnimation("hand", 0);
          } else {
            this.schedule(() => {
              this.node.inverseTransformPoint(this._handPos, targetNode.getWorldPosition());

              if (Vec3.equals(this._handPos, this._prePos)) {
                this.db.node.setPosition(this._handPos);
                this.db.node.active = true;
                this.unscheduleAllCallbacks();
                this.db.timeScale = 1;
                this.db.playAnimation("hand", 0);
              } else {
                this._prePos = this._handPos;
              }
            }, 1);
          }
        }

        hideArrowOrHand() {
          this.db.node.angle = 0;
          this.db.node.active = false;
          this.db.timeScale = 0;
          this.unscheduleAllCallbacks();
        }

        showStar() {}

        showTip(msg) {
          this.tip.node.active = true;
          this.tip.string = msg || "";
        }

        hideTip() {
          this.tip.node.active = false;
        }

        showButton(callback) {
          this.btnNode.active = true;
          this.btnNode.once("click", () => {
            if (callback) callback();
          });
        }

        hideButton(callBack) {
          this.btnNode.active = false;
        }

        showRaid() {
          return new Promise(resolve => {
            let dia = null;
            UIRoot.instance.openChildWindow(DialogWindow, {
              msg: i18n.t("TutorialDialogSlotRaidMaster"),
              confirmFunc: () => {
                resolve(null);
                dia && dia.node.destroy();
              },
              confirmStr: "OK",
              showCallback: dialogWindow => {
                dia = dialogWindow;
              }
            }, this.node);
          });
        }

        showPerson() {
          EnterCloseAnim.playClose(this.person);
        }

        hidePerson() {
          EnterCloseAnim.playEnter(this.person);
        }

        finished() {
          const canvas = director.getScene().getChildByName("Canvas").getComponent(Canvas);
          canvas.cameraComponent = canvas.node.getChildByName("Main Camera").getComponent(Camera);

          this._renderCameraNodes.forEach(camera => camera.destroy());

          if (this._preTarget) {
            this.setChildrenLayer(this._preTarget, CameraLayers.UI2D);
            this.setParentsLayer(this._preTarget, CameraLayers.UI2D);
          }

          if (this._pre3DTarget) {
            this.setChildrenLayer(this._pre3DTarget, this._pre3DTargetLayer);
          }

          this.node.destroy();
        }

        onTapSkip() {
          if (AppMain.instance.tutorialManager.isTutorilaFinished) return;
          AppMain.instance.tutorialManager.tutorialFinish();
        }

      }, _defineProperty(_class3, "windowPath", "Other/NewTutorialWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "model", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "title", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "db", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "tip", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btnNode", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "person", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "targetSprite", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "target3DSprite", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "captureCamera", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "fakeTargetNode", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "btnSkipNode", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ContentModel.ts", ['cc', './CCE_Component.ts', './_app.ts', './LabelTwoColor.ts', './SpriteGray.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, _decorator, color, CCE_Component, cce, LabelTwoColor, SpriteGray, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
      color = module.color;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      LabelTwoColor = module.default;
    }, function (module) {
      SpriteGray = module.default;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "58b1ays9TtJlqk2ZjYQqYnG", "ContentModel", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ContentModel = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Label), _dec6 = property(Label), _dec7 = property(Label), ccclass(_class = (_class2 = (_temp = class ContentModel extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "icon", _descriptor, this);

          _initializerDefineProperty(this, "count", _descriptor2, this);

          _initializerDefineProperty(this, "countBignum", _descriptor3, this);

          _initializerDefineProperty(this, "countX", _descriptor4, this);

          _initializerDefineProperty(this, "countWithColor", _descriptor5, this);

          _initializerDefineProperty(this, "labelName", _descriptor6, this);

          _initializerDefineProperty(this, "desc", _descriptor7, this);

          _defineProperty(this, "content", void 0);

          _defineProperty(this, "noCountGray", void 0);
        }

        show(content) {
          if (!content) return;
          this.content = content.Contents()[0];
          if (!this.content) return;

          if (this.icon) {
            this.content.Icon(this.icon, () => {
              if (this.noCountGray && this.content.Count() <= 0) {
                SpriteGray.SetGray(this.icon, true);
              } else if (this.noCountGray) {
                SpriteGray.SetGray(this.icon, false);
              }
            });
          }

          if (this.count) {
            this.count.string = BigNumber.format(this.content.Count());
          }

          if (this.countBignum) {
            this.countBignum.string = BigNumber.format(this.content.Count());
          }

          if (this.countX) {
            this.countX.string = i18n.t("multiplyx") + BigNumber.format(this.content.Count());
          }

          if (this.countWithColor) {
            let _color = this.content.ColorCode().match(/#(......)/)[1];
            let color$1 = color(parseInt("0x" + _color.substring(0, 2)), parseInt("0x" + _color.substring(2, 4)), parseInt("0x" + _color.substring(4, 6)));

            if (!this.countWithColor.getComponent(LabelTwoColor)) {
              this.countWithColor.addComponent("LabelTwoColor");
              this.countWithColor.getComponent(LabelTwoColor).offset = 0.15;
            }

            this.countWithColor.getComponent(LabelTwoColor).colorTo = color$1;
            this.countWithColor.string = BigNumber.format(this.content.Count());
          }

          if (this.labelName) {
            this.labelName.string = this.content.Name();
          }

          if (this.desc) {
            this.desc.string = this.content.Desc();
          }
        }

        onClose() {
          cce.releaseSpriteFrame(this.icon);
        }

        clear() {
          if (this.icon) {
            this.icon.spriteFrame = null;
          }

          if (this.count) {
            this.count.string = "";
          }

          if (this.countBignum) {
            this.countBignum.string = "";
          }

          if (this.countX) {
            this.countX.string = "";
          }

          if (this.countWithColor) {
            this.countWithColor.string = "";
          }

          if (this.labelName) {
            this.labelName.string = "";
          }

          if (this.desc) {
            this.desc.string = "";
          }
        } //是否数量为0时 图标变灰


        setNoCountGray(enable) {
          this.noCountGray = enable;

          if (this.noCountGray && this.content && this.content.Count() <= 0) {
            SpriteGray.SetGray(this.icon, true);
          } else if (this.noCountGray) {
            SpriteGray.SetGray(this.icon, false);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "icon", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "count", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "countBignum", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "countX", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "countWithColor", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "desc", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LeaderboardWindow.ts", ['cc', './global.ts', './UIWindow.ts', './User.ts', './UserInfoModel.ts', './InviteWindow.ts', './ScrollViewTool.ts', './UITabContainer.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Node, _decorator, Sprite, Label, Widget, G, UIWindow, User, UserInfoModel, InviteWindow, ScrollViewTool, UITabContainer, SR, UIRoot, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      Label = module.Label;
      Widget = module.Widget;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      User = module.User;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      InviteWindow = module.InviteWindow;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      UITabContainer = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "58bc6SkKwBGa7bPQBx1A72N", "LeaderboardWindow", undefined); //// const UIWindow = UIWindow
      // const ScrollViewTool = require('ScrollViewTool')
      // let UserInfoModel = UserInfoModel
      // const UITabContainer = require('UITabContainer')


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      var fakeVipList = [22359, 203107, 18352, 24408, 31663, 86638, 44921, 55207, 61811, 86707, 27283, 25296, 195677, 63532, 85235, 92884, 68579, 145861, 119596, 391362, 23810, 37934, 25987, 52585, 88820, 56885, 118227, 36265, 49393, 53526];
      /**
       * Leaderboard界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let LeaderboardWindow = exports('LeaderboardWindow', (_dec = property(SpriteFrame), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(SpriteFrame), _dec5 = property(UITabContainer), _dec6 = property(ScrollViewTool), _dec7 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class LeaderboardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "choose_sf", _descriptor, this);

          _initializerDefineProperty(this, "unchoose_sf", _descriptor2, this);

          _initializerDefineProperty(this, "default_avatar_sf", _descriptor3, this);

          _initializerDefineProperty(this, "cup_sf_array", _descriptor4, this);

          _initializerDefineProperty(this, "tab_node_array", _descriptor5, this);

          _initializerDefineProperty(this, "svt", _descriptor6, this);

          _initializerDefineProperty(this, "loading_circle", _descriptor7, this);

          _defineProperty(this, "choose_tab", void 0);

          _defineProperty(this, "data_array_friends", void 0);

          _defineProperty(this, "data_array_country", void 0);

          _defineProperty(this, "data_array_global", void 0);
        }

        onShow() {
          //setAliasTexParameters.setSpriteFrame(this.choose_sf)
          //setAliasTexParameters.setSpriteFrame(this.unchoose_sf)
          this.tab_node_array.onShow((index, tab, first) => {
            if (first) {
              setTimeout(() => {
                this.event_change_to_tab(index);
              }, 300);
            } else {
              this.event_change_to_tab(index);
            }
          });
        }
        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        }
        /**
         * 点击事件：修改language
         * @param {cc.EventTouch} e EventTouch
         * @param {number} index CustomEventData 需要在编辑器中指定
         */


        event_change_to_tab(index = 0) {
          // 避免重复点击
          if (this.choose_tab === Number(index)) {
            return;
          } // 更改tab样式


          this.update_tab_choose(Number(index)); // 加载动画

          this.open_loading_anima(); // 更改内部数据

          let nindex = index;

          switch (Number(index)) {
            case 0:
              this.get_friends_data().then(v => {
                if (!this.node || !this.node.isValid) return;
                if (this.choose_tab != nindex) return;
                this.update_all_item(v);
                this.close_loading_anima();
              }, e => {});
              break;

            case 1:
              this.get_county_data().then(v => {
                if (!this.node || !this.node.isValid) return;
                if (this.choose_tab != nindex) return;
                this.update_all_item(v);
                this.close_loading_anima();
              }, e => {});
              break;

            case 2:
              this.get_global_data().then(v => {
                if (!this.node || !this.node.isValid) return;
                if (this.choose_tab != nindex) return;
                this.update_all_item(v);
                this.close_loading_anima();
              }, e => {});
              break;
          }
        }
        /** 点击事件：打开invite界面 */


        event_invite() {
          UIRoot.instance.openChildWindow(InviteWindow);
        }
        /** 更新tab选择样式 */


        update_tab_choose(choose_tab = 0) {
          this.choose_tab = choose_tab;
          /*for (let i = 0; i < this.tab_node_array.length; i++) {
          	let n = this.tab_node_array[i]
          	if (i === choose_tab) {
          		// 选中
          		//n.getComponent(cc.Sprite).spriteFrame = this.choose_sf
          		n.getComponent(cc.Sprite).enabled = true
          	} else {
          		// 未选中
          		//n.getComponent(cc.Sprite).spriteFrame = null // this.unchoose_sf
          		n.getComponent(cc.Sprite).enabled = false
          	}
          }*/
          //// 特别注意
          // 逻辑上应当使用node.zIndex来修改渲染顺序达到功能
          // zIndex目前有以下缺陷，无法实现功能。一是zIndex为负数时，则不可被点击事件监控到；二是zIndex只能修改同级的渲染次序
          // 因此目前的实现方法是在面板bg下面重新创建一组unchoose的tab，当检测为未选中是，则置当前tab的sf为null，显示出底部的unchoose_sf
        }
        /** 刷新所有的item
         * @param {[{}]} data_array
         */


        update_all_item(data_array = []) {
          this.svt.scrollView.scrollToTop(0.1);
          this.svt.clear();
          let item_count = data_array.length;
          if (this.choose_tab === 0 && !G.GameConfig.closeShare) item_count = data_array.length + 1;
          let ranks = [];
          let haveSelf = false;

          for (let i = 0; i < item_count; i++) {
            ranks.push(i);

            if (data_array[i] && data_array[i].UserId() == Game.SUser.UserId()) {
              haveSelf = true;
            }
          }

          if (!haveSelf) ranks.push(item_count);
          this.svt.setItem(ranks,
          /**
           * @param {cc.Node} itemHandle item节点
           */
          (index, id, itemHandle) => {
            // 获取对应组件（node）
            // 注意各个子节点的名称正确
            // 注意要把对应的节点拖入ControllerTables下面
            let userinfo = GameKit.ControllerTable.GetNode(itemHandle, "userinfo").getComponent(UserInfoModel);
            let cup = GameKit.ControllerTable.GetNode(itemHandle, "cup").getComponent(Sprite);
            let index_label = GameKit.ControllerTable.GetNode(itemHandle, "index_label").getComponent(Label);
            let avatar = GameKit.ControllerTable.GetNode(itemHandle, "avatar").getComponent(Sprite);
            let name = GameKit.ControllerTable.GetNode(itemHandle, "name").getComponent(Label);
            let level_label = GameKit.ControllerTable.GetNode(itemHandle, "level_label").getComponent(Label);
            let invite = GameKit.ControllerTable.GetNode(itemHandle, "btn_invite");
            let invite_add = GameKit.ControllerTable.GetNode(itemHandle, "icon_label").getComponent(Label);
            let bgSelf = GameKit.ControllerTable.GetNode(itemHandle, "bgSelf");
            let starBgSelf = GameKit.ControllerTable.GetNode(itemHandle, "starBgSelf");
            let inviteLabel = GameKit.ControllerTable.GetNode(itemHandle, "inviteLabel");
            let inviteLabelName = GameKit.ControllerTable.GetNode(itemHandle, "label");
            let inviteLabelExplain = GameKit.ControllerTable.GetNode(itemHandle, "label-001"); // 根据数据写入

            let data = data_array[index]; ///? index?id?

            if (data && data.UserId() != Game.SUser.UserId() && fakeVipList.contains(data.UserId()) && !Object.keys(Game.SUser.FriendsList()).contains(data.UserId())) {
              data.data.isVip = true;
            }

            if (data === undefined && index != item_count) {
              // 无数据
              cup.node.active = false;
              index_label.node.active = false;
              avatar.spriteFrame = this.default_avatar_sf;
              avatar.node.parent.parent.getComponent(Widget).left = 11;
              avatar.node.parent.parent.getComponent(Widget).updateAlignment();
              name.node.active = false;
              level_label.node.parent.active = false;
              invite.active = true;
              inviteLabel.active = true;
              inviteLabelName.getComponent(Label).string = String.format(i18n.t("gifts_default_name"));
              inviteLabelExplain.getComponent(Label).string = String.format(i18n.t("gifts_default_explain"));
              invite_add.string = String.format(i18n.t("invite_addnumber_type0"), this.get_add_number());
              bgSelf.active = false;
              starBgSelf.active = false;
            } else if (index == item_count) {
              data = Game.SUser;
              userinfo.show(data);
              cup.spriteFrame = null;
              index_label.string = "";
              level_label.string = data.Star();
              level_label.node.parent.active = true;
              invite.active = false;
              bgSelf.active = true;
              starBgSelf.active = true;
            } else {
              // 有数据
              // 采用User信息数据域的方式显示
              userinfo.show(data); // 不同界面的信息域内容不同，因此要根据界面调整User信息域与界面信息的处理

              if (index === 0) {
                cup.spriteFrame = this.cup_sf_array[0];
              } else if (index === 1) {
                cup.spriteFrame = this.cup_sf_array[1];
              } else if (index === 2) {
                cup.spriteFrame = this.cup_sf_array[2];
              } else {
                cup.spriteFrame = null;
              }

              index_label.string = index + 1;
              level_label.string = data.Star();
              level_label.node.parent.active = true;
              invite.active = false;
              bgSelf.active = data.UserId() == Game.SUser.UserId();
              starBgSelf.active = data.UserId() === Game.SUser.UserId();
            }
          });
        }
        /** 获取friends的排行榜数据
         * - 包括自身数据Game.SUser
         */


        get_friends_data() {
          return new Promise((resolve, reject) => {
            if (this.data_array_friends != null) {
              resolve(this.data_array_friends);
              return;
            }

            let sr = SR.SRSocial.getFriendsRank();
            sr.SetCallBack(res => {
              let list = [];
              let data = res.list;
              let friends = Game.SUser.FriendsList();

              for (let i = 0; i < data.length; i++) {
                friends[data[i].userId].updateData(data[i]);
                list.push(friends[data[i].userId]);
              } // 个人数据


              list.push(Game.SUser);
              list.sort(function (a, b) {
                return b.Star() - a.Star();
              }); // 保存数据

              this.data_array_friends = list;
              resolve(this.data_array_friends);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          });
          /** 备注：消息格式 
          res = [
          	// 单条消息
          	{
          		userId: 0,
          		name: "friend_name" + i.toString(), // 名字
          		avatar: "",                         // 头像
          		star: 0,                            // 等级（star个数）             
          	},
          	// 一个消息列表
          	{}, {}, {},
          ]*/
        }
        /** 获取country的排行榜数据 */


        get_county_data() {
          return new Promise((resolve, reject) => {
            if (this.data_array_country != null) {
              resolve(this.data_array_country);
              return;
            }

            let sr = SR.SRSocial.getCountryRank();
            sr.SetCallBack(res => {
              let list = [];
              let data = res.list;

              for (let i = 0; i < data.length; i++) {
                list.push(new User().updateData(data[i]));
              }

              list.sort(function (a, b) {
                return b.Star() - a.Star();
              }); // 保存数据

              this.data_array_country = list;
              resolve(this.data_array_country);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          }); // 消息格式同get_friends_data()
        }
        /** 获取global的排行榜数据 */


        get_global_data() {
          return new Promise((resolve, reject) => {
            if (this.data_array_global != null) {
              resolve(this.data_array_global);
              return;
            }

            let sr = SR.SRSocial.getGlobalRank();
            sr.SetCallBack(res => {
              let list = [];
              let data = res.list;

              for (let i = 0; i < data.length; i++) {
                list.push(new User().updateData(data[i]));
              }

              list.sort(function (a, b) {
                return b.Star() - a.Star();
              }); // 保存数据

              this.data_array_global = list;
              resolve(this.data_array_global);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          }); // 消息格式同get_friends_data()
        }
        /** 获取增加的值（meta数据or服务器数据）
         * @returns {number}
         */


        get_add_number() {
          //return C.DEFAULT_INVITE_ADD
          let data = G.GameConstance.spinsPerInvite;
          let mapId = Game.SUserVillage.MapId();
          let is = 0;

          for (let mid in data) {
            if (mapId >= parseInt(mid)) {
              is = data[mid];
            } else {
              break;
            }
          }

          return is;
        }
        /** 打开loading动画 */


        open_loading_anima() {
          /*if (this.loading_anima === undefined) {
          	this.loading_anima = ccAction.rotateBy(C.LOADING_ROTATION_TIME, 360).repeatForever()
          	this.loading_circle.active = true
          	this.loading_circle.runAction(this.loading_anima)
          }*/
          this.loading_circle.active = true;
        }
        /** 关闭loading动画 */


        close_loading_anima() {
          this.loading_circle.active = false;
        }

      }, _defineProperty(_class3, "windowPath", "Menu/NewLeaderboardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "choose_sf", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "unchoose_sf", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "default_avatar_sf", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "cup_sf_array", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "tab_node_array", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "loading_circle", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivityParamsMeta.ts", ['cc', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "59751Z7rHBL56DsnovTUA9L", "ActivityParamsMeta", undefined);

      class ActivityParamsMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new ActivityParamsMeta();
          meta.UpdateData(data);
          return meta;
        }

        static GetValue(key, id) {
          let meta = Meta.MetaManager.GetMeta(Meta.MetaType.ActivityParams, id);
          if (!meta) return null;
          return meta.getValue(key);
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        getValue(key) {
          return this._data[key];
        }

      }

      exports('ActivityParamsMeta', ActivityParamsMeta);

      _defineProperty(ActivityParamsMeta, "Types", {
        AttackMaster: "attackMaster",
        AttackMasterReward: "attackMasterReward",
        RaidMaster: "raidMaster",
        RaidMasterReward: "raidMasterReward",
        BuildMaster: "buildMaster",
        Cannon: "cannon",
        SlotCollect: "slotCollect",
        SlotCollectReward: "slotCollectReward",
        SlotCollectRankReward: "slotCollectRankReward",
        BlackJackMinChip: "blackJackMinChip"
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FollowWindow.ts", ['cc', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "59d94BWig1EPriDPRGVQ5AQ", "FollowWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FollowWindow = exports('default', ccclass(_class = (_temp = _class2 = class FollowWindow extends UIWindow {
        close_window() {
          this.closeAnim();
        }

      }, _defineProperty(_class2, "windowPath", "Sys/FollowWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShieldBreakAnim.ts", ['cc', './CCE_Component.ts', './SoundManager.ts'], function (exports) {
  'use strict';

  var cclegacy, ParticleSystem2D, _decorator, CCE_Component, SoundManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      ParticleSystem2D = module.ParticleSystem2D;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }],
    execute: function () {
      var _class;

      cclegacy._RF.push({}, "59f8ceQ6ThI65snlGNsOK57", "ShieldBreakAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShieldBreakAnim = exports('default', ccclass(_class = class ShieldBreakAnim extends CCE_Component {
        // LIFE-CYCLE CALLBACKS:
        onLoad() {
          var self = this;
          self.getComponent(ParticleSystem2D).stopSystem();
        }

        start() {}

        play(x, y, delay) {
          var self = this;
          self.node.active = true;
          self.node.x += x;
          self.node.y += y;
          self.scheduleOnce(function () {
            self.getComponent(ParticleSystem2D).resetSystem();
            SoundManager.playSound("shield_4th");
          }, delay);
        }

        stop() {
          this.unscheduleAllCallbacks();
          this.node.active = false;
        }

      }) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopChestItem.ts", ['cc', './Constant.ts', './CCE_Component.ts', './global.ts', './fixedSizeRatio.ts', './LocalizedManager.ts', './LoadingWindow.ts', './SR.ts', './CardChestOpenWindow.ts', './CardChestInfoWindow.ts', './UIRoot.ts', './StaticGame.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, _decorator, color, MyCustomEvent, CCE_Component, G, fixedSizeRatio, rigisterLabel, LoadingWindow, SR, CardChestOpenWindow, CardChestInfoWindow, UIRoot, Game, ADWrap, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
      color = module.color;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      fixedSizeRatio = module.default;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      CardChestInfoWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "5c678Pe7JJDP4GRq59uCJgA", "ShopChestItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopChestItem = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), ccclass(_class = (_class2 = (_temp = class ShopChestItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "icon", _descriptor, this);

          _initializerDefineProperty(this, "itemName", _descriptor2, this);

          _initializerDefineProperty(this, "price", _descriptor3, this);

          _initializerDefineProperty(this, "adProgress", _descriptor4, this);

          _defineProperty(this, "meta", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        updatePanel(meta, index, icon) {
          this.meta = meta; // this.icon.node.getComponent(cc.UITransform).height *= 1 - 0.05 * (3 - index);

          this.icon.spriteFrame = icon; // this.itemName.string = this.meta.Content().Name();

          this.itemName.string = i18n.t("ContentNameChest" + this.meta.Content().ContentId());
          rigisterLabel(`ContentNameChest${this.meta.Content().ContentId()}`, this.itemName);

          switch (index) {
            case 1:
              this.itemName.color = color("#11ffeb");
              break;

            case 2:
              this.itemName.color = color("#f962ff");
              break;

            case 3:
              this.itemName.color = color("#ff5f83");
              break;
          }

          this.price && (this.price.string = BigNumber.format(this.meta.Price()));
          this.price && (this.price.node.y = 4);
        }

        onBuy() {
          LoadingWindow.ShowAfterDelay(0);
          let price = this.meta.Price();

          if (Game.SUser.Coin() < price) {
            homeView.shopWindow && homeView.shopWindow.scrollTo(G.zones.coin);
            LoadingWindow.Hide();
            return;
          }

          let req = SR.SRShop.payFor(this.meta.Id());
          req.SetCallBack(() => {
            LoadingWindow.Hide();

            if (homeView.cardAllSetWindow) {
              homeView.cardAllSetWindow.flushData();
            }

            let chest = GameKit.DataCache.GetData("UserCardChest");
            UIRoot.instance.openChildWindow(CardChestOpenWindow, {
              chest: chest
            });
            GameKit.DataCache.RemoveData("UserCardChest");
          });
          req.Send();
        }

        onInfo() {
          UIRoot.instance.openChildWindow(CardChestInfoWindow, {
            meta: this.meta,
            card_chest_meta_id: this.meta.DefaultPrice()
          });
        }

        updateAdPanel(icon) {
          this.icon.spriteFrame = icon;
          fixedSizeRatio.fitByHeight(this.icon);
          this.itemName.string = i18n.t("ContentNameChest4");
          rigisterLabel("ContentNameChest4", this.itemName);

          if (this.adProgress) {
            if (ADWrap.AdEnabled()) {
              this.adProgress.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
            } else {
              this.adProgress.string = "0/3";
            }
          }

          eventCenter.on(MyCustomEvent.WatchAdForChest, () => {
            this.adProgress.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
          }, this); // this.itemName.node.parent.getChildByName("flash").active = Game.SUserCard.data.freeCount < G.GameConstance.dailyFreeChestCount;
        }

        onWatch() {
          if (Game.SUserCard.data.freeCount >= G.GameConstance.dailyFreeChestCount) return;
          if (!ADWrap.AdEnabled()) return;
          ADWrap.ShowVideo(() => {
            let req = SR.SRCard.watchChest();
            req.SetCallBack(() => {
              let cardWnd = UIRoot.instance.GetWindow("CardAllSetWindow");

              if (cardWnd) {
                cardWnd.svt.flushData();
                cardWnd.labelFree.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
                cardWnd.btnWatchFree.active = Game.SUserCard.data.freeCount < G.GameConstance.dailyFreeChestCount;
              }

              let chest = GameKit.DataCache.GetData("UserCardChest");
              UIRoot.instance.openChildWindow(CardChestOpenWindow, {
                chest: chest
              });
              GameKit.DataCache.RemoveData("UserCardChest"); // if (this.price) {
              // 	this.price.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
              // }

              eventCenter.emit(MyCustomEvent.WatchAdForChest);

              if (this.adProgress) {
                if (ADWrap.AdEnabled()) {
                  this.adProgress.string = `(${G.GameConstance.dailyFreeChestCount - Game.SUserCard.data.freeCount} / ${G.GameConstance.dailyFreeChestCount})`;
                } else {
                  this.adProgress.string = "0/3";
                }
              } // this.itemName.node.parent.getChildByName("flash").active = Game.SUserCard.data.freeCount < G.GameConstance.dailyFreeChestCount;

            });
            req.Send();
          }, "freeChest");
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "icon", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "itemName", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "price", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "adProgress", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserTutorial.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "5cb3eVwDKJJOYLsReQpMh3K", "UserTutorial", undefined); //用户金币


      class UserTutorial {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            tutorialMap: {}
          };
        } //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
        }

        UserId() {
          return this.data.userId;
        }

        TutorialMap() {
          return this.data.tutorialMap;
        }

        TutorialId(groupId) {
          return this.data.tutorialMap[groupId];
        }

        SetTutorialId(groupId, id) {
          this.data.tutorialMap[groupId] = id;
        }

      }

      exports('UserTutorial', UserTutorial);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LabelTwoColor.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Color, _decorator, color, UITransform, Label, RichText, instantiate, Node, Mask, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Color = module.Color;
      _decorator = module._decorator;
      color = module.color;
      UITransform = module.UITransform;
      Label = module.Label;
      RichText = module.RichText;
      instantiate = module.instantiate;
      Node = module.Node;
      Mask = module.Mask;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "5d3a2nYkrRFLKzY6P7dDaBJ", "LabelTwoColor", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let LabelTwoColor = exports('default', (_dec = property(Color), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class LabelTwoColor extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "cLabel", void 0);

          _initializerDefineProperty(this, "_colorTo", _descriptor, this);

          _defineProperty(this, "child", void 0);

          _initializerDefineProperty(this, "_offset", _descriptor2, this);
        }

        set colorTo(value) {
          this._colorTo = color(value);

          this._updateRenderData();
        }

        get colorTo() {
          return this._colorTo;
        }

        set offset(value) {
          this._offset = value;

          if (!this.child) {
            this._updateRenderData();

            return;
          }

          this.child.getComponent(UITransform).setAnchorPoint(0.5, 1 - this._offset);
          this.child.height = this.node.getComponent(UITransform).height / 2 / (1 - this._offset);
        }

        get offset() {
          return this._offset;
        }

        start() {
          if (this.getComponent(Label)) {
            this.getComponent(Label).onStringChanged = function () {
              this._updateRenderData();
            }.bind(this);
          }

          if (this.getComponent(RichText)) {
            this.getComponent(RichText).onStringChanged = function () {
              this._updateRenderData();
            }.bind(this);
          }
        }

        slowUpdate() {
          if (!this.inited) {
            this._updateRenderData();

            this.inited = true;
          }
        }

        _updateRenderData() {
          if (!this.node || !this.enabled) return;
          let child_t = this.node.getChildByName("_TwoColor_child");

          if (!this.child && child_t) {
            this.child = child_t;
            this.cLabel = this.child.children[0];
          }

          if (!this.child || !this.child["_active"] && CC_EDITOR) {
            this.enabled = false;
            this.cLabel = instantiate(this.node);
            this.cLabel.getComponent(LabelTwoColor).destroy();
            this.child = new Node(CC_EDITOR ? "_TwoColor_child" : "_TwoColor_child");
            this.child.addComponent(UITransform);
            this.child.parent = this.node;
            this.child.x = 0;
            this.child.y = 0;
            this.child.getComponent(UITransform).setAnchorPoint(0.5, 1 - this._offset);
            this.child.addComponent(Mask);
            this.cLabel.parent = this.child;
            this.cLabel.x = 0;
            this.cLabel.y = 0;
            this.enabled = true;
          }

          this.child.width = this.node.getComponent(UITransform).width;
          this.child.height = this.node.getComponent(UITransform).height / 2 / (1 - this._offset);
          this.cLabel.color = this.colorTo;

          if (this.getComponent(Label)) {
            this.cLabel.getComponent(Label).string = this.getComponent(Label).string;
            this.cLabel.getComponent(Label).horizontalAlign = this.getComponent(Label).horizontalAlign;
            this.cLabel.getComponent(Label).verticalAlign = this.getComponent(Label).verticalAlign;
            this.cLabel.getComponent(Label).fontSize = this.getComponent(Label).fontSize;
          }

          if (this.getComponent(RichText)) {
            this.cLabel.getComponent(RichText).string = this.getComponent(RichText).string;
            this.cLabel.getComponent(RichText).horizontalAlign = this.getComponent(RichText).horizontalAlign;
            this.cLabel.getComponent(RichText).fontSize = this.getComponent(RichText).fontSize;
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "_colorTo", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return color(255, 255, 255, 255);
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "colorTo", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "colorTo"), _class2.prototype), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "_offset", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "offset", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "offset"), _class2.prototype)), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ContainerSlot.ts", ['cc', './Constant.ts', './Container3d.ts', './ServantWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, geometry, PhysicsSystem, _decorator, PetType, Container3d, ServantWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      geometry = module.geometry;
      PhysicsSystem = module.PhysicsSystem;
      _decorator = module._decorator;
    }, function (module) {
      PetType = module.PetType;
    }, function (module) {
      Container3d = module.default;
    }, function (module) {
      ServantWindow = module.ServantWindow;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "5e07cxssWZFEY6lp6KHbm9e", "ContainerSlot", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ContainerSlot = exports('default', (_dec = ccclass("ContainerSlot"), _dec(_class = class ContainerSlot extends Container3d {
        // toRaidUser: ToRaidUserNode;
        // renderUIToModel: RenderUIToModel;
        onLoad() {
          this.sprCamera.node.on(Node.EventType.TOUCH_START, this.onTouchStart, this); // this.initToRaidUser();
        }

        onDestroy() {
          super.onDestroy();
          this.sprCamera.node && this.sprCamera.node.off(Node.EventType.TOUCH_START, this.onTouchStart, this);
        } // initToRaidUser() {
        //     let node = instantiate(CommonAssets.instance.toRaidUser);
        //     this.renderUIToModel = node.getComponent(RenderUIToModel);
        //     this.toRaidUser = node.getComponentInChildren(ToRaidUserNode);
        // }


        onTouchStart(event) {
          let pos = event.getLocation();
          let outRay = new geometry.Ray();
          this.camera.screenPointToRayWithTexture(pos.x, pos.y, outRay);
          let bo = PhysicsSystem.instance.raycast(outRay);
          let result = PhysicsSystem.instance.raycastResults;
          result.sort((a, b) => a.distance - b.distance);
          if (result.length <= 0) return;
          let nameArr = this.getColliderNames();
          let clicked = false;
          result.forEach(v => {
            if (nameArr.indexOf(v.collider.node.name) > -1) {
              clicked = true;
            }
          });

          if (clicked) {
            this.OpenServant();
          }
        }

        OpenServant() {
          if (homeView.isBusy()) return;
          ServantWindow.Show();
        }

        getColliderNames() {
          let colliderNameArr = [];

          for (let item in PetType) {
            colliderNameArr.push(item);
          }

          return colliderNameArr;
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRDailyBonus.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRDailyBonus', void 0);

      cclegacy._RF.push({}, "5e5abkeQ2JGTbXvYFM0tyvR", "SRDailyBonus", undefined);

      let SRDailyBonus;

      (function (_SRDailyBonus) {
        function doDailyBonus() {
          let req = new GameKit.ServerRequest("doDailyBonus");
          req.SetSilence(true);
          req.SetCallBack(() => {
            Game.SUserSlot.data.dailyBonusDid++;
            Game.SUserSlot.UpdateDailyBonus();
            Game.SUserSlot.data.slotData.dailyBonusCount.normal = Game.SUserSlot.data.slotData.dailyBonusCount.normal || 0;
            Game.SUserSlot.data.slotData.dailyBonusCount.normal += 1;

            if (homeView.slotPage != null) {
              homeView.slotPage.setMenuBadge();
            }
          });
          return req;
        }

        _SRDailyBonus.doDailyBonus = doDailyBonus;
      })(SRDailyBonus || (SRDailyBonus = exports('SRDailyBonus', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SkewAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "5e5d9V9nD1HMri5R6sxfFqy", "SkewAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SkewAnim = exports('default', (_dec = property(CCInteger), _dec2 = property(CCInteger), _dec3 = property(CCInteger), _dec4 = property(CCInteger), _dec5 = property(CCInteger), _dec6 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class SkewAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "minX", _descriptor, this);

          _initializerDefineProperty(this, "maxX", _descriptor2, this);

          _initializerDefineProperty(this, "minY", _descriptor3, this);

          _initializerDefineProperty(this, "maxY", _descriptor4, this);

          _initializerDefineProperty(this, "time", _descriptor5, this);

          _initializerDefineProperty(this, "delay", _descriptor6, this);

          _defineProperty(this, "playing", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          this.playing = true; // this.node.skewX = this.minX
          // this.node.skewY = this.minY

          this.scheduleOnce(function () {
            this.playing = false;
          }.bind(this), this.delay);
        }

        slowUpdate(dt) {
          if (this.playing) return;
          this.node.runAction(ccAction.sequence( // cc.skewTo(this.time, this.maxX, this.maxY, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)),
          // cc.skewTo(this.time, this.minX, this.minY, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)),
          ccAction.delayTime(this.delay) //ccAction.callFunc(function(){ this.playing = false }, this)
          ).repeatForever());
          this.playing = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "minX", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "maxX", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "minY", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "maxY", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "delay", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivitySlotSymbolShowWindow.ts", ['cc', './global.ts', './_app.ts', './UIWindow.ts', './DialogWindow.ts', './ActivitySlotSymbolRankInfoWindow.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, Label, RichText, _decorator, G, cce, UIWindow, DialogWindow, ActivitySlotSymbolRankInfoWindow, UIRoot, Meta, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      RichText = module.RichText;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      ActivitySlotSymbolRankInfoWindow = module.ActivitySlotSymbolRankInfoWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "5e860IP5j1I6IizPfXP5O+g", "ActivitySlotSymbolShowWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivitySlotSymbolShowWindow = exports('ActivitySlotSymbolShowWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Sprite), _dec4 = property(Label), _dec5 = property(Label), _dec6 = property(RichText), _dec7 = property(RichText), ccclass(_class = (_class2 = (_temp = _class3 = class ActivitySlotSymbolShowWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spClose", _descriptor, this);

          _initializerDefineProperty(this, "spButton", _descriptor2, this);

          _initializerDefineProperty(this, "spBg", _descriptor3, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor4, this);

          _initializerDefineProperty(this, "labelButton", _descriptor5, this);

          _initializerDefineProperty(this, "labelMessage", _descriptor6, this);

          _initializerDefineProperty(this, "labelMessageShadow", _descriptor7, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "metaParam", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "childWindowChain", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.metaParam = this.meta.Param();
          this.labelMessage.string = i18n.sel(this.metaParam.message.label.string);
          this.labelButton.string = i18n.sel(this.metaParam.labelButton.label.string); // CCTools.SetNodeByParam(this.spClose, this.metaParam.close);
          // CCTools.SetNodeByParam(this.labelButton, this.metaParam.labelButton);
          // CCTools.SetNodeByParam(this.spButton, this.metaParam.button);
          // CCTools.SetNodeByParam(this.labelTimer, this.metaParam.timer);
          // CCTools.SetNodeByParam(this.labelMessage, this.metaParam.message.label.string);
          // CCTools.SetNodeByParam(this.labelMessageShadow, this.metaParam.message_shadow);
          // let img = this.meta.Image();
          // if (img.startsWith("http")) {
          // 	cce.loaderLoad(
          // 		{ url: img, type: "png" },
          // 		function (err, v) {
          // 			if (err != null) {
          // 				Logs.Warning(err);
          // 				return;
          // 			}
          // 			if (!this.spBg || !this.node) return;
          // 			let sp: cc.SpriteFrame = new cc.SpriteFrame();
          // 			sp.texture = v;
          // 			this.spBg.spriteFrame = sp;
          // 		}.bind(this)
          // 	);
          // } else {
          // 	let resName = "res/Activity/images/" + img;
          // 	cce.loadRes(
          // 		resName,
          // 		cc.SpriteFrame,
          // 		function (err, v) {
          // 			if (err != null) {
          // 				Logs.Warning(err);
          // 				return;
          // 			}
          // 			if (!this.spBg || !this.node) return;
          // 			this.spBg.spriteFrame = v;
          // 		}.bind(this)
          // 	);
          // }

          this.leftTime = 0;
          this.slowUpdate(0);
        }

        onClose() {
          cce.releaseSpriteFrame(this.spBg);
        }

        slowUpdate(arg) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = 0;
            this.leftTime = this.meta.EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, true);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        close_window() {
          this.closeAnim();
        }

        callBuy() {
          if (this.meta.SubType() == Meta.ActivityMeta.SubTypes.SlotCollectRank) {
            this.node.opacity = 0;
            uiRoot.openChildWindow(ActivitySlotSymbolRankInfoWindow, {
              meta: this.meta,
              showCallback: window => {
                window.addOnCloseFunc(() => {
                  this.closeAnim();
                });
              }
            });
            return;
          }

          if (this.childWindowChain) {
            this.clearOnCloseFunc();
            this.childWindowChain.end();
          }

          let meta = this.meta;

          if (!meta.IsActive()) {
            this.closeAnim(() => {
              DialogWindow.Show(i18n.t("ActivityCenterTimeEnd"), nullFunction);
            });
            return;
          }

          let icon_goto = meta.IconGoto();

          if (icon_goto == "panel") {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(meta.Panel(), {
                meta: meta
              });
            });
          } else if (icon_goto == "slot") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Slot, true);
            });
          } else if (icon_goto == "village") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Village, true);
            });
          } else if (icon_goto == "villageShop") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Village, true);
            });
          } else if (icon_goto == "window") {
            this.closeAnim(() => {
              meta.Panel().Show(meta);
            });
          } else {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(icon_goto, {
                meta: meta
              });
            });
          }
        }

      }, _defineProperty(_class3, "windowPath", "Activity/ActivitySlotSymbolShowWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spClose", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spButton", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spBg", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelButton", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelMessage", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelMessageShadow", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardSelectFriendWindow.ts", ['cc', './UIWindow.ts', './FriendsModel.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './CardSelectCardWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, Button, _decorator, UIWindow, FriendsModel, UIRoot, Game, GameKit, CardSelectCardWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Button = module.Button;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      FriendsModel = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      CardSelectCardWindow = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "5ed74LNJEpLsbRWDrZx10vh", "CardSelectFriendWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      let CardSelectFriendWindow = exports('default', (_dec = property(FriendsModel), _dec2 = property(Button), ccclass(_class = (_class2 = (_temp = _class3 = class CardSelectFriendWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "type", void 0);

          _defineProperty(this, "card_meta", void 0);

          _defineProperty(this, "dot_list", []);

          _defineProperty(this, "selected_friend_userid", null);

          _initializerDefineProperty(this, "friends_model", _descriptor, this);

          _initializerDefineProperty(this, "btn_select", _descriptor2, this);
        }

        onShow(showParams) {
          this.type = showParams.type;
          this.card_meta = showParams.card_meta;
          this.load_page();
        }

        load_page() {
          this.friends_model.init((index, id, node, friend_data) => {
            // 保存dot
            let dot = GameKit.ControllerTable.GetNode(node, "selectDot");
            dot.active = false;
            this.dot_list.push(dot); // 点击事件

            node.on("click", () => {
              this.hide_all_dot();
              dot.active = true;
              this.selected_friend_userid = friend_data.UserId();
              this.btn_select.interactable = true;
            });
          }, Game.SUser.FriendsList()); // 无选择

          this.hide_all_dot();
          this.selected_friend_userid = null;
          this.btn_select.interactable = false;
        }
        /** @type {"ask"|"send"} 界面类型;ask/send; */

        /** 隐藏所有的choose-dot */


        hide_all_dot() {
          this.dot_list.forEach(v => {
            v.active = false;
          });
        }

        event_close() {
          this.closeAnim();
        }

        event_select_card() {
          if (!this.selected_friend_userid) {
            return;
          }

          this.closeAnim();
          UIRoot.instance.openChildWindow(CardSelectCardWindow, {
            friend_userid: this.selected_friend_userid,
            default_card_meta_id: this.card_meta ? this.card_meta.Id() : null
          });
        }

      }, _defineProperty(_class3, "windowPath", "Card/CardSelectFriendWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "friends_model", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btn_select", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/StateMachine.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "5edcfcTW1VPBrr88g/ZSv9i", "StateMachine", undefined);
      /*
       * @Author: yansixing
       * @Date: 2021-05-14 14:44:20
       * @Github: https://github.com/yansixing
       * @LastEditTime: 2021-05-14 14:59:27
       */


      class StateMachine {}

      exports('default', StateMachine);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CheckSystemOpen.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, CCString, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCString = module.CCString;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "5f727qeCmdFYbJ6wlT0sorx", "CheckSystemOpen", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CheckSystemOpen = exports('default', (_dec = property(CCString), ccclass(_class = (_class2 = (_temp = class CheckSystemOpen extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "close_key", _descriptor, this);
        }

        onLoad() {
          if (!this.close_key) return;
          this.node.active = !window[this.close_key];
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "close_key", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CocosWrap.ts", ['cc', './env', './_app.ts', './audioEngine.ts', './Action.ts'], function () {
  'use strict';

  var cclegacy, Node, Renderable2D, UIOpacity, Tween, Vec3, SpriteFrame, Sprite, Material, ScrollView, math, JSB, DEBUG, EDITOR, DEV, BUILD, TEST, PREVIEW, RUNTIME_BASED, SUPPORT_JIT, cce, audioEngine, Action;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Renderable2D = module.Renderable2D;
      UIOpacity = module.UIOpacity;
      Tween = module.Tween;
      Vec3 = module.Vec3;
      SpriteFrame = module.SpriteFrame;
      Sprite = module.Sprite;
      Material = module.Material;
      ScrollView = module.ScrollView;
      math = module.math;
    }, function (module) {
      JSB = module.JSB;
      DEBUG = module.DEBUG;
      EDITOR = module.EDITOR;
      DEV = module.DEV;
      BUILD = module.BUILD;
      TEST = module.TEST;
      PREVIEW = module.PREVIEW;
      RUNTIME_BASED = module.RUNTIME_BASED;
      SUPPORT_JIT = module.SUPPORT_JIT;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      audioEngine = module.audioEngine;
    }, function (module) {
      Action = module.Action;
    }],
    execute: function () {
      cclegacy._RF.push({}, "617c3DgR+5EdpbPf1ispxQS", "CocosWrap", undefined);

      console.log("import wrap");
      /**
       * 全局CC_\w+
       */

      globalThis.CC_JSB = JSB;
      globalThis.CC_DEBUG = DEBUG;
      globalThis.CC_EDITOR = EDITOR;
      globalThis.CC_DEV = DEV;
      globalThis.CC_BUILD = BUILD;
      globalThis.CC_TEST = TEST;
      globalThis.CC_EDITOR = EDITOR;
      globalThis.CC_PREVIEW = PREVIEW;
      globalThis.CC_DEV = DEV;
      globalThis.CC_DEBUG = DEBUG;
      globalThis.CC_JSB = JSB; // CC_WECHATGAME = WECHATGAME

      globalThis.CC_RUNTIME = RUNTIME_BASED;
      globalThis.CC_SUPPORT_JIT = SUPPORT_JIT;

      globalThis.nullFunction = () => {};

      globalThis.ccAction = Action;
      globalThis.ccAudioEngine = audioEngine;
      /**
       * 兼容2.4版本的node
       */

      if (!CC_EDITOR) {
        Object.defineProperties(Node.prototype, {
          x: {
            set: function (value) {
              const _pos = this.position.clone();

              _pos.x = value;
              this.setPosition(_pos);
            },
            get: function () {
              return this.position.x;
            }
          },
          y: {
            set: function (value) {
              const _pos = this.position.clone();

              _pos.y = value;
              this.setPosition(_pos);
            },
            get: function () {
              return this.position.y;
            }
          },
          // "width": {
          //     set: function(value: number){
          //         this.getComponent(cc.UITransform).width = value;
          //     },
          //     get: function(): number {
          //         return this.getComponent(cc.UITransform).width;
          //     }
          // },
          // "height": {
          //     set: function(value: number){
          //         this.getComponent(cc.UITransform).height = value;
          //     },
          //     get: function(): number {
          //         return this.getComponent(cc.UITransform).height;
          //     }
          // },
          // "anchorX": {
          //     set: function(value: number){
          //         this.getComponent(cc.UITransform).anchorX = value;
          //     },
          //     get: function(): number {
          //         return this.getComponent(cc.UITransform).anchorX;
          //     }
          // },
          // "anchorY": {
          //     set: function(value: number){
          //         this.getComponent(cc.UITransform).anchorY = value;
          //     },
          //     get: function(): number {
          //         return this.getComponent(cc.UITransform).anchorY;
          //     }
          // },
          color: {
            set: function (value) {
              const renderComponent = this.getComponent(Renderable2D);
              renderComponent.color = value;
            },
            get: function () {
              return this.getComponent(Renderable2D).color;
            }
          },
          opacity: {
            set: function (value) {
              let UIOpacity$1 = this.getComponent(UIOpacity);

              if (UIOpacity$1) {
                UIOpacity$1.opacity = value;
              } else {
                UIOpacity$1 = this.addComponent(UIOpacity);
                UIOpacity$1.opacity = value;
              }
            },
            get: function () {
              if (this.getComponent(UIOpacity)) {
                return this.getComponent(UIOpacity).opacity;
              } else if (this.getComponent(Renderable2D)) {
                return this.getComponent(Renderable2D).color.a;
              } else {
                return null;
              }
            }
          },
          group: {
            set: function (value) {
              this.layer = parseInt(value);
            },
            get: function () {
              return this.lauer.toString();
            }
          },
          scaleX: {
            set: function (value) {
              this.setScale(value, this.getScale().y, 1);
            },
            get: function () {
              return this.getScale().x;
            }
          },
          scaleY: {
            set: function (value) {
              this.setScale(this.getScale().x, value, 1);
            },
            get: function () {
              return this.getScale().y;
            }
          }
        });
      }
      /**
       * 用cc.Tween兼容ccAction
       */


      Node.prototype.runAction = function (tween) {
        if (tween["_target"]) {
          tween.start();
        } else {
          tween.target(this).start();
        }

        return tween;
      };

      Node.prototype.stopAllActions = function () {
        Tween.stopAllByTarget(this);
      };

      Node.prototype.inverseTransformPoint = function (out, p) {
        let array_a = [];
        Vec3.copy(out, p); // we need to recursively iterate this
        // eslint-disable-next-line @typescript-eslint/no-this-alias

        let cur = this;
        let i = 0;

        while (cur._parent) {
          array_a[i++] = cur;
          cur = cur._parent;
        }

        while (i > 0) {
          cur = array_a[--i];
          Vec3.transformInverseRTS(out, out, cur._lrot, cur._lpos, cur._lscale);
        }

        return out;
      };
      /**
       * cc.SpriteFrame接口变更
       */


      SpriteFrame.prototype.setFlipX = function (flipX) {
        this.flipUVX = flipX;
      };

      SpriteFrame.prototype.setFlipY = function (flipY) {
        this.flipUVY = flipY;
      }; // cc.SpriteFrame.prototype.setTexture = function(texture: cc.Texture2D, rect?: cc.Rect, rotated?: boolean, offset?: cc.Vec2, originalSize?: cc.Size): boolean {
      //     if(!texture) return false;
      //     texture && (this.texture = texture);
      //     rect && (this.rect = rect);
      //     rotated && (this.rotated = rotated);
      //     offset && (this.offset = offset);
      //     originalSize && (this.originalSize = originalSize)
      //     return true;
      // }
      // cc.SpriteFrame.prototype.getTexture = function(): cc.Texture2D {
      //     return this.texture;
      // }

      /**
       * sprite
       */


      Sprite.prototype.setState = function (state) {
        let spritePath = "Shader/2d/Materials/ui-sprite-default";
        let grayPath = "Shader/2d/Materials/ui-sprite-gray";

        if (state) {
          cce.loadRes(grayPath, Material, (err, res) => {
            if (err) {
              console.log("load material error");
            } else {
              this.setMaterial(res, 0);
            }
          });
        } else {
          cce.loadRes(spritePath, Material, (err, res) => {
            if (err) {
              console.log("load material error");
            } else {
              this.setMaterial(res, 0);
            }
          });
        }
      }; // 	// let _cachedArray = [];
      // 	_doDispatchEvent(this._node, event);
      // 	_cachedArray.length = 0;
      // };

      /**
       * 重新添加ccAction的各种action，用tween重写，归到namespace Action下
       * @param duration
       * @param x
       * @param y
       * @returns
       */
      // cc["Act" + "ion"] = {} as any;


      ScrollView.prototype["_getLocalAxisAlignDelta"] = function (touch) {
        const uiTransformComp = this.node._uiProps.uiTransformComp;
        const vec = new Vec3();

        let _tempVec2 = new math.Vec2();

        let _tempVec2_1 = new math.Vec2();

        let _tempVec3 = new math.Vec3();

        let _tempVec3_1 = new math.Vec3();

        if (uiTransformComp) {
          touch.getUILocation(_tempVec2);
          touch.getUIPreviousLocation(_tempVec2_1);

          _tempVec3.set(_tempVec2.x, _tempVec2.y, 0);

          _tempVec3_1.set(_tempVec2_1.x, _tempVec2_1.y, 0);

          uiTransformComp.convertToNodeSpaceAR(_tempVec3, _tempVec3);
          uiTransformComp.convertToNodeSpaceAR(_tempVec3_1, _tempVec3_1);
          Vec3.subtract(vec, _tempVec3, _tempVec3_1);
        }

        return vec;
      };

      const getTimeInMilliseconds = () => {
        const currentTime = new Date();
        return currentTime.getMilliseconds();
      };

      ScrollView.prototype["_gatherTouchMove"] = function (delta) {
        const clampDt = delta.clone(); // this._clampDelta(clampDt);

        while (this._touchMoveDisplacements.length >= 5) {
          this._touchMoveDisplacements.shift();

          this._touchMoveTimeDeltas.shift();
        }

        this._touchMoveDisplacements.push(clampDt);

        const timeStamp = getTimeInMilliseconds();

        this._touchMoveTimeDeltas.push((timeStamp - this._touchMovePreviousTimestamp) / 1000);

        this._touchMovePreviousTimestamp = timeStamp;
      };

      ScrollView.prototype["_processDeltaMove"] = function (deltaMove) {
        const tempDeltaMove = deltaMove.clone();

        this._scrollChildren(deltaMove);

        this._gatherTouchMove(tempDeltaMove);
      };

      const oldFun = globalThis["c" + "c"]["internal"].inputManager.getTouchesByEvent;

      globalThis["c" + "c"]["internal"].inputManager.getTouchesByEvent = function (event, position) {
        for (let i = 0; i < event.changedTouches.length; i++) {
          if (event.changedTouches[i]) {
            for (let j = i + 1; j < event.changedTouches.length; j++) {
              event.changedTouches[j] = null;
            }

            break;
          }
        }

        return oldFun.call(globalThis["c" + "c"]["internal"].inputManager, event, position);
      };

      console.log("end wrap");

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RaidAnim.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, CCE_Component, CCEaseTypes;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "61840SGPlpIULPwu2IHVl2x", "RaidAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let RaidAnim = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class RaidAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "light", _descriptor, this);

          _initializerDefineProperty(this, "pig", _descriptor2, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        play(cb) {
          var self = this;
          this.node.active = true;
          this.light.scaleX = 0;
          this.light.scaleY = 0;
          this.pig.scaleX = 0;
          this.pig.scaleY = 0;
          let seq1 = ccAction.sequence(ccAction.scaleTo(0.2, 1.2, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), ccAction.delayTime(0.4), ccAction.scaleTo(0.2, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)));
          this.light.runAction(seq1);
          let seq2 = ccAction.sequence(ccAction.scaleTo(0.2, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), ccAction.delayTime(0.4), ccAction.scaleTo(0.2, 0, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)), ccAction.callFunc(function () {
            if (cb != null) {
              cb();
            }

            self.node.active = false;
          }));
          this.pig.runAction(seq2);
        }

        stop() {
          this.light.stopAllActions();
          this.pig.stopAllActions();
          this.node.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "light", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "pig", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageUpgradeBtn.ts", ['cc', './Constant.ts', './CCE_Component.ts', './ResourceLoader.ts', './CommonAssets.ts', './MetaManager.ts', './ContentCheck.ts', './VillageNode.ts', './SR.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, v2, Sprite, Node, Label, Toggle, _decorator, Button, EventHandler, instantiate, sys, MyCustomEvent, Constant, TutorilaEvent, CCE_Component, ResourceLoader, CommonAssets, MetaManager, ContentCheck, VillageNode, SR, Game, Meta, LogEventWrap, GameKit, BigNumber, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v2 = module.v2;
      Sprite = module.Sprite;
      Node = module.Node;
      Label = module.Label;
      Toggle = module.Toggle;
      _decorator = module._decorator;
      Button = module.Button;
      EventHandler = module.EventHandler;
      instantiate = module.instantiate;
      sys = module.sys;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      Constant = module.Constant;
      TutorilaEvent = module.TutorilaEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      VillageNode = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "628c2qSQ8RIkLfMdd7G9dcn", "VillageUpgradeBtn", undefined);

      var iconSizeMax = v2(100, 100);
      const {
        ccclass,
        property
      } = _decorator;
      let VillageUpgradeBtn = exports('default', (_dec = ccclass("VillageUpgradeBtn"), _dec2 = property(Sprite), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Label), _dec9 = property(Node), _dec10 = property(Toggle), _dec11 = property(Toggle), _dec12 = property(Toggle), _dec(_class = (_class2 = (_temp = class VillageUpgradeBtn extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "iconBuild", _descriptor, this);

          _initializerDefineProperty(this, "btnBg", _descriptor2, this);

          _initializerDefineProperty(this, "btnBgDestroyed", _descriptor3, this);

          _initializerDefineProperty(this, "levelStars", _descriptor4, this);

          _initializerDefineProperty(this, "iconFix", _descriptor5, this);

          _initializerDefineProperty(this, "iconComplete", _descriptor6, this);

          _initializerDefineProperty(this, "labelCost", _descriptor7, this);

          _initializerDefineProperty(this, "GMNode", _descriptor8, this);

          _initializerDefineProperty(this, "toggleDestroy", _descriptor9, this);

          _initializerDefineProperty(this, "toggleAttack", _descriptor10, this);

          _initializerDefineProperty(this, "toggleFix", _descriptor11, this);

          _defineProperty(this, "btnBuy", void 0);

          _defineProperty(this, "type", 1);

          _defineProperty(this, "mapId", void 0);

          _defineProperty(this, "currentLevel", void 0);

          _defineProperty(this, "isDestroyed", void 0);

          _defineProperty(this, "maxLevel", void 0);

          _defineProperty(this, "nodeAttack", void 0);

          _defineProperty(this, "nodeFix", void 0);
        }

        onLoad() {
          this.btnBuy = this.getComponent(Button);
          this.updateGMNode();
          eventCenter.on(MyCustomEvent.SwitchDebug, this.updateGMNode, this);
          const eventDestroy = new EventHandler();
          eventDestroy.target = this.node;
          eventDestroy.component = "VillageUpgradeBtn";
          eventDestroy.handler = "onToggleDestroy";
          this.toggleDestroy.checkEvents.push(eventDestroy);
          const eventAttack = new EventHandler();
          eventAttack.target = this.node;
          eventAttack.component = "VillageUpgradeBtn";
          eventAttack.handler = "onToggleAttack";
          this.toggleAttack.checkEvents.push(eventAttack);
          const eventFix = new EventHandler();
          eventFix.target = this.node;
          eventFix.component = "VillageUpgradeBtn";
          eventFix.handler = "onToggleFix";
          this.toggleFix.checkEvents.push(eventFix);
        }

        onToggleDestroy() {
          // console.log("onToggleDestroy");
          let isDestroyed = this.toggleDestroy.isChecked;
          let build = myVillage.builds[this.type - 1];
          let level = myVillage.villageInfo.GetLevel(this.type);
          myVillage.refreshBuild(this.type, build, level, isDestroyed);
          let isShow = isDestroyed;

          if (isShow) {
            if (this.nodeFix) {
              this.nodeFix && (this.nodeFix.active = true);
            } else {
              this.nodeFix = instantiate(CommonAssets.instance.pbFix);
              homeView.villagePage.node.addChild(this.nodeFix);
            }

            let fixNode = myVillage.builds[this.type - 1].getChildByName("positions").getChildByName("fix");
            let pos = myVillage.camera.convertToUINodeWithTexture(fixNode.getWorldPosition(), homeView.villagePage.node);
            this.nodeFix.setPosition(pos);
          } else {
            this.nodeFix && (this.nodeFix.active = false);
          }
        }

        onToggleAttack() {
          console.log("onToggleAttack");
          let isShow = this.toggleAttack.isChecked;

          if (isShow) {
            if (this.nodeAttack) {
              this.nodeAttack && (this.nodeAttack.active = true);
            } else {
              this.nodeAttack = instantiate(CommonAssets.instance.pbAttack);
              homeView.villagePage.node.addChild(this.nodeAttack);
            }

            let fixNode = myVillage.builds[this.type - 1].getChildByName("positions").getChildByName("attack");
            let pos = myVillage.camera.convertToUINodeWithTexture(fixNode.getWorldPosition(), homeView.villagePage.node); // console.log(pos);

            this.nodeAttack.setPosition(pos);
          } else {
            this.nodeAttack && (this.nodeAttack.active = false);
          }
        } // onToggleFix() {
        // 	console.log("onToggleFix");
        // 	let isShow = this.toggleFix.isChecked;
        // 	if (isShow) {
        // 		if (this.nodeFix) {
        // 			this.nodeFix && (this.nodeFix.active = true);
        // 		} else {
        // 			this.nodeFix = cc.instantiate(CommonAssets.instance.pbFix);
        // 			homeView.villagePage.node.addChild(this.nodeFix);
        // 		}
        // 		let fixNode = myVillage.builds[this.type - 1].getChildByName("positions").getChildByName("fix");
        // 		let pos = myVillage.getRealUIPosition(fixNode.getWorldPosition(), homeView.villagePage.node);
        // 		this.nodeFix.setPosition(pos);
        // 	} else {
        // 		this.nodeFix && (this.nodeFix.active = false);
        // 	}
        // }


        updateGMNode() {
          // console.log("updateGMNode");
          const showGm = sys.localStorage.getItem("isDebug") === "1" ? true : false;
          this.GMNode.active = showGm;
        }

        initBtn(type) {
          this.type = type;
          this.getComponent(Button).interactable = true;
          this.updateBtn();
          eventCenter.on(MyCustomEvent.EnterNewVillage, () => {
            console.log("EnterNewVillage");
            this.updateBtn();
          }, this);
          GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.CoinEvent, "VillageUpgradeBtn" + this.type, () => {
            console.log("updateBtn");
            this.updateBtn();
          });
        }

        onDestroy() {
          eventCenter.off(MyCustomEvent.EnterNewVillage, this.updateBtn, this);
          eventCenter.off(MyCustomEvent.SwitchDebug, this.updateGMNode, this);
          GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.CoinEvent, "VillageUpgradeBtn");
        }

        updateBtn() {
          // this.mapId = Game.SUserVillage.MapId();
          // if(myVillage){
          // 	this.mapId = myVillage.curshownMapId;
          // }else{}
          this.mapId = myVillage ? myVillage.curshownMapId : Game.SUserVillage.MapId();
          this.currentLevel = Game.SUserVillage.GetLevel(this.type);
          this.isDestroyed = Game.SUserVillage.IsDestroyed(this.type);
          this.maxLevel = Meta.VillageShopMeta.GetMaxLevel(this.mapId, this.type);
          const reachMaxLevel = this.currentLevel >= this.maxLevel; //村庄完成后防止发放奖励事件刷新按钮

          if (myVillage && myVillage.isCompleted && !reachMaxLevel) return;
          const sprLevel = Math.max(1, this.currentLevel);
          const isLocal = Constant.LocalMapIds.contains(this.mapId);
          const resId = MetaManager.GetMeta(MetaManager.MetaType.Village, this.mapId).ResId();
          let villageName = VillageNode.GetVillageName(resId);
          let resPath = villageName + "/icon/" + VillageNode.GetVillageIconName(this.type, sprLevel) + "/texture";
          ResourceLoader.loadSpriteFrame(resPath, isLocal).then(spriteFrame => {
            this.iconBuild.spriteFrame = spriteFrame;
          });
          this.levelStars.children.forEach((v, i) => {
            let starNode = v.getChildByName("star");

            if (i < this.currentLevel) {
              starNode.active = true;
            } else {
              starNode.active = false;
            }
          });
          this.iconFix.active = this.isDestroyed;
          this.btnBgDestroyed.active = this.isDestroyed;
          this.btnBg.active = !this.isDestroyed;
          let price; //显示价格状态 信息按钮

          if (this.isDestroyed) {
            price = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel);

            if (price != null) {
              this.labelCost.string = BigNumber.format(price / 2);
            }
          } else {
            price = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel + 1);

            if (price != null) {
              this.labelCost.string = BigNumber.format(price);
            }
          }

          if (this.currentLevel >= this.maxLevel && !this.isDestroyed) {
            this.labelCost.node.active = false;
            this.iconComplete.active = true;
          } else {
            this.labelCost.node.active = true;
            this.iconComplete.active = false;
          }

          let isMoneyEnough = false;

          if (price != null) {
            if (Game.SUser.Coin() > price) {
              isMoneyEnough = true;
            } else {
              isMoneyEnough = false;
            }
          }

          if (isMoneyEnough || reachMaxLevel) {
            this.iconBuild.customMaterial = CommonAssets.instance.matNormal;
          } else {
            this.iconBuild.customMaterial = CommonAssets.instance.matGray;
          } // if(this.isDestroyed||)

        }

        onTap() {
          if (this.isDestroyed) {
            this.onTapFix();
          } else {
            this.onTapUpgrade();
          }
        }

        onTapFix() {
          if (!this.isDestroyed) {
            this.updateBtn();
            return;
          }

          let oprice = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel);

          if (oprice != null) {
            let price = oprice / 2;

            if (ContentCheck.CheckCoin(price)) {
              this.btnBuy.interactable = false;
              Game.SUserVillage.MakeFix(this.type); // GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, { coin: Game.SUser.Coin() - price, needPlayAnim: false });

              homeView.villageNode.BuildLevelUpOrFix(this.type);
              let req = SR.SRVillage.fixVillage(this.type);
              req.SetCallBack(res => {
                this.btnBuy.interactable = true;

                if (this.currentLevel >= this.maxLevel) {
                  this.getComponent(Button).interactable = false;
                }

                this.updateBtn();
                homeView.villageNode.BuildLevelUpOrFixOver(this.type);
              });
              req.Send();
            }
          }
        }

        onTapUpgrade() {
          let price = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel + 1);

          if (price != null) {
            if (ContentCheck.CheckCoin(price)) {
              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                eventCenter.emit(TutorilaEvent.BuildStarted);
              }

              this.btnBuy.interactable = false;
              Game.SUserVillage.MakeLevelUp(this.type);
              homeView.villageNode.BuildLevelUpOrFix(this.type); // let handle = homeView.villageNode.GetHandle(this.type, this.currentLevel + 1, false);
              // if (handle != null)
              // 	handle.getComponentsInChildren("villageTextureLoader").forEach((x) => {
              // 		x.vload();
              // 	});

              let buildOk = () => {
                this.btnBuy.interactable = true;

                if (this.currentLevel >= this.maxLevel) {
                  this.getComponent(Button).interactable = false;
                }

                this.updateBtn();
                homeView.villageNode.BuildLevelUpOrFixOver(this.type);
                eventCenter.emit(MyCustomEvent.BuildLevelUpOrFixOver);
                let star = Game.SUser.Star();

                if (star > 100) {
                  star = Math.floor((star - 100) / 5) * 5 + 100;
                }

                LogEventWrap.logEvent("StarDetail", {
                  count: star
                });
              }; // GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, { coin: Game.SUser.Coin() - price });
              //tutorial


              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.VillageEvent, {
                  village: [1, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                });
                buildOk();
                return;
              }

              let req = SR.SRVillage.levelUpVillage(this.type);
              req.SetCallBack(res => {
                buildOk();
              });
              req.Send();
            }
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "iconBuild", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnBg", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btnBgDestroyed", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "levelStars", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "iconFix", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "iconComplete", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelCost", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "GMNode", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "toggleDestroy", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "toggleAttack", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "toggleFix", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopWindow.ts", ['cc', './_app.ts', './UIWindow.ts', './VIPGetWindow.ts', './VIPExtraRewardWindow.ts', './ShopChestItem.ts', './ShopCoinItem.ts', './ShopShieldItem.ts', './ShopSpinItem.ts', './ShopTreatItem.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Prefab, SpriteFrame, Node, ScrollView, _decorator, Widget, instantiate, UITransform, Layout, view, v3, cce, UIWindow, VIPGetWindow, VIPExtraRewardWindow, ShopChestItem, ShopCoinItem, ShopShieldItem, ShopSpinItem, ShopTreatItem, UIRoot, ActivityManager, Meta, Game, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Prefab = module.Prefab;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      ScrollView = module.ScrollView;
      _decorator = module._decorator;
      Widget = module.Widget;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
      Layout = module.Layout;
      view = module.view;
      v3 = module.v3;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      VIPGetWindow = module.default;
    }, function (module) {
      VIPExtraRewardWindow = module.default;
    }, function (module) {
      ShopChestItem = module.default;
    }, function (module) {
      ShopCoinItem = module.default;
    }, function (module) {
      ShopShieldItem = module.ShopShieldItem;
    }, function (module) {
      ShopSpinItem = module.default;
    }, function (module) {
      ShopTreatItem = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "62fabaOCJxKBosjOqAD74bq", "ShopWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopWindow = exports('default', (_dec = property(Prefab), _dec2 = property(Prefab), _dec3 = property(Prefab), _dec4 = property(Prefab), _dec5 = property(Prefab), _dec6 = property(Prefab), _dec7 = property(Prefab), _dec8 = property([SpriteFrame]), _dec9 = property([SpriteFrame]), _dec10 = property([SpriteFrame]), _dec11 = property([SpriteFrame]), _dec12 = property([SpriteFrame]), _dec13 = property([SpriteFrame]), _dec14 = property(Node), _dec15 = property(Node), _dec16 = property(Node), _dec17 = property(Node), _dec18 = property(Node), _dec19 = property(Node), _dec20 = property(Node), _dec21 = property(ScrollView), ccclass(_class = (_class2 = (_temp = _class3 = class ShopWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spinItemPrefab", _descriptor, this);

          _initializerDefineProperty(this, "coinItemPrefab", _descriptor2, this);

          _initializerDefineProperty(this, "chestItemPrefab", _descriptor3, this);

          _initializerDefineProperty(this, "sliverShieldPrefab", _descriptor4, this);

          _initializerDefineProperty(this, "goldShieldPrefab", _descriptor5, this);

          _initializerDefineProperty(this, "treatItemPrefab", _descriptor6, this);

          _initializerDefineProperty(this, "xpSpecilItemPrefab", _descriptor7, this);

          _initializerDefineProperty(this, "spinIcons", _descriptor8, this);

          _initializerDefineProperty(this, "coinIcons", _descriptor9, this);

          _initializerDefineProperty(this, "chestIcons", _descriptor10, this);

          _initializerDefineProperty(this, "shieldIcons", _descriptor11, this);

          _initializerDefineProperty(this, "foodIcons", _descriptor12, this);

          _initializerDefineProperty(this, "xpIcons", _descriptor13, this);

          _initializerDefineProperty(this, "spinContent", _descriptor14, this);

          _initializerDefineProperty(this, "coinContent", _descriptor15, this);

          _initializerDefineProperty(this, "chestContent", _descriptor16, this);

          _initializerDefineProperty(this, "sliverShieldContent", _descriptor17, this);

          _initializerDefineProperty(this, "goldShieldContent", _descriptor18, this);

          _initializerDefineProperty(this, "foodContent", _descriptor19, this);

          _initializerDefineProperty(this, "xpContent", _descriptor20, this);

          _initializerDefineProperty(this, "scrollView", _descriptor21, this);

          _defineProperty(this, "activityMeta", void 0);
        } // 	leftTime: number;
        // 	defaultIndex: number;
        // 	spinInited: any;
        // 	coinInited: any;
        // 	chestInited: any;
        // 	treatInited: any;


        onLoad() {
          this.node.getChildByName("ScrollView").getComponent(Widget).top += AppMain.instance.statusBarHeight;
        }

        async onShow(showParams) {
          console.log("shopWindow onShow");
          this.activityMeta = ActivityManager.GetActiveShopActivity();
          this.initSpinPage();
          this.initCoinPage();
          await cce.wait(50);
          this.initChestPage();
          this.initShieldPage();
          this.initFoodPage();
          this.initXpPage(); // 		// if (this.activityMeta) {
          // 		// 	this.leftTime = 0;
          // 		// 	this.slowUpdate();
          // 		// }
          // 		// if (!AppKit.PaymentWrap.PayEnabled()) {
          // 		// 	let disStr = "PayDisable";
          // 		// 	if (wxTools.usewx) {
          // 		// 		disStr = "PayDisableIos";
          // 		// 	} else if (fbInTools.usefbIn) {
          // 		// 		disStr = "PayDisableIos";
          // 		// 	}
          // 		// 	this.disabledIOS.string = i18n.t(disStr);
          // 		// }
          // 		// this.chestDisable.getComponent(Label).string = String.format(i18n.t("ShopChestDisable"), G.GameConstance.cardSystemStartLevel);
          // 		// this.treatDisable.getComponent(Label).string = String.format(i18n.t("ShopTreatDisable"), G.GameConstance.servantSystemStartLevel);
        } // start() {
        // 	console.log("shopWindow start");
        // 	this.scrollView.content.getComponent(Layout).updateLayout(true);
        // 	this.scheduleOnce(() => {
        // 		this.scrollView.content.getComponent(Layout).enabled = false;
        // 	}, 0);
        // }
        // 	slowUpdate() {
        // 		if (this.leftTime != null) {
        // 			let currentTime = GameKit.TimeUtil.getCurrentTime();
        // 			if (this.activityMeta.IsUserTime()) {
        // 				this.leftTime = this.activityMeta.UserTime() - currentTime + ActivityManager.GetLocalData()[this.activityMeta.Id()].startTime;
        // 			} else {
        // 				this.leftTime = this.activityMeta.EndTime() - currentTime;
        // 			}
        // 			this.activityText.string = String.format(i18n.t("ActivityShopDes"), GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false));
        // 			if (this.leftTime <= 0) {
        // 				this.leftTime = null;
        // 				this.callClose();
        // 			}
        // 		}
        // 	}


        initSpinPage() {
          let itemSize = null;

          for (let i = 0; i < 6; i++) {
            let meta = Meta.ShopMeta.GetByTypeIndex(Meta.ShopMeta.Types.Spin, i);
            const oldMeta = meta;

            if (this.activityMeta && this.activityMeta.ShopIds().spin != null) {
              meta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.activityMeta.ShopIds().spin[i]);
            }

            const newSpinNode = instantiate(this.spinItemPrefab);
            i === 0 && (itemSize = newSpinNode.getComponent(UITransform).contentSize);
            this.spinContent.addChild(newSpinNode);
            const spinItem = newSpinNode.getComponent(ShopSpinItem);
            const icon = this.spinIcons[i];
            spinItem.updatePanel(meta, i, icon, oldMeta);
          }

          this.setContentSize(this.spinContent, 6, itemSize);
        }

        initCoinPage(refresh) {
          let itemSize;

          for (let index = 0; index < 6; index++) {
            let meta = Meta.ShopMeta.GetByTypeIndex(Meta.ShopMeta.Types.ShopCoin, index);
            const oldMeta = meta;

            if (this.activityMeta && this.activityMeta.ShopIds().coin != null) {
              meta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.activityMeta.ShopIds().coin[index]);
            }

            if (refresh && this.coinContent.children[index]) {
              this.coinContent.children[index].getComponent(ShopCoinItem).updatePanel(meta, index, this.coinIcons[index], oldMeta, refresh);
            } else {
              const newCoinNode = instantiate(this.coinItemPrefab);
              index === 0 && (itemSize = newCoinNode.getComponent(UITransform).contentSize);
              this.coinContent.addChild(newCoinNode);
              const coinItem = newCoinNode.getComponent(ShopCoinItem);
              coinItem.updatePanel(meta, index, this.coinIcons[index], oldMeta);
            }
          }

          if (!refresh) {
            this.setContentSize(this.coinContent, 6, itemSize);
          }
        }

        initShieldPage() {
          let itemSize = null;
          let itemPrefab = this.sliverShieldPrefab;
          let content = this.sliverShieldContent;

          for (let i = 0; i < 5; i++) {
            let shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, (1201 + i).toString());

            if (i > 2) {
              itemPrefab = this.goldShieldPrefab;
              content = this.goldShieldContent;
            }

            const newShieldNode = instantiate(itemPrefab);
            const shieldItem = newShieldNode.getComponent(ShopShieldItem);
            content.addChild(newShieldNode);
            i === 0 && (itemSize = newShieldNode.getComponent(UITransform).contentSize);
            const icon = this.shieldIcons[i];
            shieldItem.updatePanel(shopMeta, i + 1, icon);
          }

          this.setContentSize(this.sliverShieldContent, 3, itemSize);
        }

        initChestPage() {
          let itemSize = null;

          for (let index = 0; index < 3; index++) {
            let meta = Meta.ShopMeta.GetByTypeIndex(Meta.ShopMeta.Types.Chest, index);
            const newChestNode = instantiate(this.chestItemPrefab);
            this.chestContent.addChild(newChestNode);
            index === 0 && (itemSize = newChestNode.getComponent(UITransform).contentSize);
            const chestItem = newChestNode.getComponent(ShopChestItem);
            const icon = this.chestIcons[index];
            chestItem.updatePanel(meta, index + 1, icon);
          }

          this.setContentSize(this.chestContent, 3, itemSize);
        }

        initFoodPage() {
          let itemSize;

          for (let i = 0; i < 6; i++) {
            let meta = Meta.ShopMeta.GetByTypeIndex(Meta.ShopMeta.Types.Food, i);
            const oldMeta = meta;

            if (this.activityMeta && this.activityMeta.ShopIds().treat != null) {
              meta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.activityMeta.ShopIds().treat[i]);
            }

            const newTreatNode = instantiate(this.treatItemPrefab);
            this.foodContent.addChild(newTreatNode);
            i === 0 && (itemSize = newTreatNode.getComponent(UITransform).contentSize);
            const treatItem = newTreatNode.getComponent(ShopTreatItem);
            const icon = this.foodIcons[i];
            treatItem.updatePanel(meta, i, icon, oldMeta);
          }

          this.setContentSize(this.foodContent, 6, itemSize);
        }

        initXpPage() {
          let itemSize;

          for (let i = 0; i < 4; i++) {
            let meta = Meta.ShopMeta.GetByTypeIndex(Meta.ShopMeta.Types.Xp, i);
            const oldMeta = meta;

            if (this.activityMeta && this.activityMeta.ShopIds().treat != null) {
              meta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.activityMeta.ShopIds().treat[i]);
            }

            let newTreatNode;
            newTreatNode = instantiate(this.treatItemPrefab);

            if (i === 3) {
              newTreatNode = null;
              newTreatNode = instantiate(this.xpSpecilItemPrefab);
              newTreatNode.width = itemSize.width * 3 + this.xpContent.getComponent(Layout).spacingX * 2;
            }

            this.xpContent.addChild(newTreatNode);
            i === 0 && (itemSize = newTreatNode.getComponent(UITransform).contentSize);
            const treatItem = newTreatNode.getComponent(ShopTreatItem);
            const icon = this.xpIcons[i];
            treatItem.updatePanel(meta, i, icon, oldMeta);
          }

          this.setContentSize(this.xpContent, 4, itemSize);
        }

        setContentSize(content, dataLength, itemSize) {
          const layout = content.getComponent(Layout);
          let spacingX = layout.spacingX || 12;
          const spacingY = 8;
          const winSize = view.getVisibleSize();

          if (winSize.width > itemSize.width * 3 + spacingX * 2) {
            layout.spacingX = spacingX;
          } else {
            spacingX = (winSize.width - itemSize.width * 3) / 2;
            layout.spacingX = spacingX;
          }

          layout.spacingY = spacingY;
          const width = itemSize.width * 3 + spacingX * 2;
          const height = Math.ceil(dataLength / 3) * itemSize.height + layout.spacingY * (Math.ceil(dataLength / 3) - 1);
          content.getComponent(UITransform).setContentSize(width, height);
        }

        openVipWindow() {
          if (homeView.isBusy()) return;
          Game.SUserStatus.UpdateExtraTime();

          if (Game.SUserStatus.VipExtraReward() && Game.SUserStatus.VipExtraReward().length > 0) {
            UIRoot.instance.openChildWindow(VIPExtraRewardWindow);
          } else {
            UIRoot.instance.openChildWindow(VIPGetWindow);
          }
        }

        scrollTo(zone, scrollTime) {
          const scrollView = this.getComponentInChildren(ScrollView);
          const item = scrollView.content.children[zone];
          const itemHalfHeight = v3(0, item.getComponent(UITransform).contentSize.height / 2 + 20, 0);
          const releativePos = v3(0, 0, 0).subtract(item.position).subtract(itemHalfHeight);
          scrollView.scrollToOffset(releativePos, scrollTime ? scrollTime : 0.4 * zone);
        }

      }, _defineProperty(_class3, "windowPath", "newShop/newShopWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spinItemPrefab", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "coinItemPrefab", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "chestItemPrefab", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sliverShieldPrefab", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "goldShieldPrefab", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "treatItemPrefab", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "xpSpecilItemPrefab", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spinIcons", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "coinIcons", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "chestIcons", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "shieldIcons", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "foodIcons", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "xpIcons", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "spinContent", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "coinContent", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "chestContent", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "sliverShieldContent", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "goldShieldContent", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "foodContent", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "xpContent", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "scrollView", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/WebEvent.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports('WebEvent', void 0);

      cclegacy._RF.push({}, "64533obTa9AmbjpMs+eXflL", "WebEvent", undefined); //网络事件类
      //在需要获取网络消息的地方 RegisterEvent， 服务器收到消息后调用DispatcherEvent


      let WebEvent;

      (function (_WebEvent) {
        let EventName;

        (function (EventName) {
          EventName["ApEvent"] = "apEvent";
          EventName["CoinEvent"] = "coinEvent";
          EventName["ShieldEvent"] = "shieldEvent";
          EventName["TimeShieldEvent"] = "timeShieldEvent";
          EventName["StarEvent"] = "starEvent";
          EventName["ToraidEvent"] = "toraidEvent";
          EventName["VillageEvent"] = "villageEvent";
          EventName["MessageEvent"] = "messageEvent";
          EventName["MessageEventInvitedUnlock"] = "messageEventInvitedUnlock";
          EventName["GiftEvent"] = "giftEvent";
          EventName["ActivityEvent"] = "activityEvent";
          EventName["ActivityItem"] = "activityItem";
          EventName["TaskCompleteCount"] = "taskCompleteCount";
          EventName["GetReward"] = "getReward";
          EventName["StatusEvent"] = "statusEvent";
          EventName["ItemsEvent"] = "itemsEvent";
          EventName["ServantEvent"] = "servantEvent";
          EventName["CardEvent"] = "cardEvent";
          EventName["CardChest"] = "cardChest";
          EventName["PresentEvent"] = "presentEvent";
          EventName["RecordEvent"] = "recordEvent";
          EventName["SlotCollectRankEvent"] = "slotCollectRankEvent";
        })(EventName || (EventName = {}));

        _WebEvent.EventName = EventName;
        let _data = {};

        function RegisterEvent(type, key, callback, once) {
          if (type == null || key == null || callback == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {}; ///不明白，先这样改

          _data[type][key] = {
            callback: callback,
            once: once
          }; // _data[type][key] = {callback = callback, once = once}
        }

        _WebEvent.RegisterEvent = RegisterEvent;

        function UnRegisterEvent(type, key) {
          if (type == null || key == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {};

          if (_data[type].hasOwnProperty(key)) {
            delete _data[type][key];
          }
        }

        _WebEvent.UnRegisterEvent = UnRegisterEvent;

        function DispatcherEvent(type, msg) {
          if (type == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {};

          for (let key in _data[type]) {
            let mess = _data[type][key];

            if (mess != null) {
              //AppMain.instance.scheduleOnce(function() {
              if (mess.callback) mess.callback(msg);

              if (mess.once) {
                WebEvent.UnRegisterEvent(type, key);
              } //}, 0)

            }
          }
        }

        _WebEvent.DispatcherEvent = DispatcherEvent;

        function DispatcherEventKey(type, key, msg) {
          if (type == null || key == null) return;
          if (!_data.hasOwnProperty(type)) _data[type] = {};

          if (_data[type].hasOwnProperty(key)) {
            let mess = _data[type][key];

            if (mess != null) {
              //AppMain.instance.scheduleOnce(function() {
              if (mess.callback) mess.callback(msg);

              if (mess.once) {
                WebEvent.UnRegisterEvent(type, key);
              } //}, 0)

            }
          }
        }

        _WebEvent.DispatcherEventKey = DispatcherEventKey;

        function Clear() {
          _data = {};
        }

        _WebEvent.Clear = Clear;
      })(WebEvent || (WebEvent = exports('WebEvent', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LoginWindow.ts", ['cc', './Constant.ts', './global.ts', './Logs.ts', './fbIn_lib.ts', './wx_lib.ts', './_app.ts', './SoundManager.ts', './UIWindow.ts', './LocalizationMeta.ts', './MetaManager.ts', './StringUtil.ts', './DialogWindow.ts', './AppGame.ts', './LoadingWindow.ts', './SdkManager.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './HotUpdator.ts', './encryptCode.ts', './AppUpdateWindow.ts', './GuestConfirmWindow.ts', './LZString.ts', './UserWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, ProgressBar, Node, Label, Camera, _decorator, SpriteFrame, RenderTexture, view, UITransform, Vec3, Widget, sys, SystemEventType, tween, assetManager, Layout, Prefab, instantiate, director, Canvas, VersionScheme, BundleNames, MyCustomEvent, G, Logs, fbInTools, wxTools, cce, SoundManager, UIWindow, LocalizationMeta, MetaManager, StringUtil, DialogWindow, AppGame, LoadingWindow, SdkManager, SR, UIRoot, Meta, Game, LogEventWrap, HotUpdator, encryptCode, AppUpdateWindow, GuestConfirmWindow, LZString, UserWrap, GameKit, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      ProgressBar = module.ProgressBar;
      Node = module.Node;
      Label = module.Label;
      Camera = module.Camera;
      _decorator = module._decorator;
      SpriteFrame = module.SpriteFrame;
      RenderTexture = module.RenderTexture;
      view = module.view;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
      Widget = module.Widget;
      sys = module.sys;
      SystemEventType = module.SystemEventType;
      tween = module.tween;
      assetManager = module.assetManager;
      Layout = module.Layout;
      Prefab = module.Prefab;
      instantiate = module.instantiate;
      director = module.director;
      Canvas = module.Canvas;
    }, function (module) {
      VersionScheme = module.VersionScheme;
      BundleNames = module.BundleNames;
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      LocalizationMeta = module.LocalizationMeta;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      StringUtil = module.StringUtil;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      HotUpdator = module.HotUpdator;
    }, function (module) {
      encryptCode = module.encryptCode;
    }, function (module) {
      AppUpdateWindow = module.default;
    }, function (module) {
      GuestConfirmWindow = module.default;
    }, function (module) {
      LZString = module.LZString;
    }, function (module) {
      UserWrap = module.UserWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "64d35C1vNZDP4rQMb348ZcK", "LoginWindow", undefined);

      var fb_started = false;
      const tips = ["Loading_tips_0", "Loading_tips_1", "Loading_tips_2", "Loading_tips_3", "Loading_tips_4", "Loading_tips_5", "Loading_tips_6", "Loading_tips_7", "Loading_tips_8"];
      const {
        ccclass,
        property
      } = _decorator;
      let LoginWindow = exports('LoginWindow', (_dec = ccclass("LoginWindow"), _dec2 = property(Sprite), _dec3 = property(ProgressBar), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Label), _dec9 = property(Label), _dec10 = property(Sprite), _dec11 = property(Camera), _dec12 = property(Node), _dec13 = property(Node), _dec14 = property(Label), _dec(_class = (_class2 = (_temp = _class3 = class LoginWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "bg", _descriptor, this);

          _initializerDefineProperty(this, "progress", _descriptor2, this);

          _initializerDefineProperty(this, "btnFB", _descriptor3, this);

          _initializerDefineProperty(this, "btnApple", _descriptor4, this);

          _initializerDefineProperty(this, "btnGuest", _descriptor5, this);

          _initializerDefineProperty(this, "loadingCircle", _descriptor6, this);

          _initializerDefineProperty(this, "labelProgress", _descriptor7, this);

          _initializerDefineProperty(this, "txtVersion", _descriptor8, this);

          _initializerDefineProperty(this, "renderLogo", _descriptor9, this);

          _initializerDefineProperty(this, "renderCamera", _descriptor10, this);

          _initializerDefineProperty(this, "barMask", _descriptor11, this);

          _initializerDefineProperty(this, "tipBg", _descriptor12, this);

          _initializerDefineProperty(this, "tip", _descriptor13, this);

          _defineProperty(this, "_spriteFrame", new SpriteFrame());

          _defineProperty(this, "_rt", new RenderTexture());

          _defineProperty(this, "pause", void 0);

          _defineProperty(this, "noenter", void 0);

          _defineProperty(this, "isHotUpdating", false);

          _defineProperty(this, "_isIncreaseProgress", true);

          _defineProperty(this, "_progressThreshold", 0);

          _defineProperty(this, "barTransform", void 0);

          _defineProperty(this, "_tipIndex", -1);

          _defineProperty(this, "metaLoaded", false);
        }

        start() {
          // cc.director.getScene().getChildByName("Canvas").getComponent(cc.Canvas).cameraComponent = this.renderCamera;
          this._rt.reset(view.getVisibleSize());

          this.renderCamera.targetTexture = this._rt;
          this._spriteFrame.texture = this._rt;
          this.renderLogo.getComponent(UITransform).setContentSize(view.getVisibleSize());
          this.renderLogo.spriteFrame = this._spriteFrame;
          this.barTransform = this.barMask.getComponent(UITransform);
        }

        onShow() {
          LogEventWrap.logEvent("loginwindow_start");
          UIRoot.instance.splashScreen && UIRoot.instance.splashScreen.destroy();
          this.pause = true;
          this.noenter = false;
          this.btnFB.active = false;
          this.btnApple.active = false;
          this.btnGuest.active = false;
          UIRoot.instance.stopShowWindow = false;
          this.progress.node.parent.active = false;
          this.loadingCircle.active = true;

          if (this.bg.getComponent(UITransform).height < view.getVisibleSize().height) {
            const scale = view.getVisibleSize().height / this.bg.getComponent(UITransform).height;
            this.bg.node.scale = new Vec3(scale, scale, scale);
          }

          if (fbInTools.usefbIn) {
            if (fb_started) {
              this.getAppInfo();
            } else {
              fb_started = true;
              this.getAppInfo(); // AppKit.SdkManager.fbSetCutAndBot();
              // FBInstant.startGameAsync()
              // 	.then(() => {
              // 		AppKit.LogEventWrap.logEvent("LoadDetail", {
              // 			phase: "ready",
              // 		});
              // 		//facebook bot shortcut
              // 		AppKit.SdkManager.fbSetCutAndBot();
              // 	})
              // 	.catch((e) => {
              // 		cc.error(e);
              // 	});
            }
          } else {
            this.getAppInfo();
          }

          this.setupTip();
        }

        setupVersion() {
          let appVersion = "#version#";

          if (Reflect.get(globalThis, "$tp_version")) {
            appVersion = $tp_version;
          }

          const storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() : '/') + 'hotupdate-asset';
          const am = new jsb.AssetsManager('', storagePath);

          if (am.getState() === jsb.AssetsManager.State.UNINITED) {
            let url = "project.manifest";
            am.loadLocalManifest(url);
          }

          const manifestVersion = am.getLocalManifest().getVersion();
          this.txtVersion.string = `  ${$tp_version}|${manifestVersion}|${versionConfig.hot_v}|${versionConfig.bundle_v.split("_")[0]}|${versionConfig.meta_v}  `;
          const widget = this.txtVersion.getComponent(Widget);
          widget.top += AppMain.instance.statusBarHeight;
          widget.right = 10;
          widget.updateAlignment();
        }

        setupTip() {
          const la = sys.localStorage.getItem("user_language") || "en";
          this._tipIndex++;
          this.tip.string = G.getTips(this._tipIndex, la);
          this.tipBg.opacity = 255;
          this.tip.node.once(SystemEventType.SIZE_CHANGED, () => {
            this.tipBg.height = this.tip.node.height + 20;
            this.tipBg.getComponent(Widget).updateAlignment();
          }, this);
          tween(this.tipBg).delay(5).to(0.3, {
            opacity: 0
          }).call(() => {
            this._tipIndex++;
            const index = this._tipIndex % tips.length;
            this.tip.string = G.getTips(index, la);
            this.tip.node.once(SystemEventType.SIZE_CHANGED, () => {
              this.tipBg.height = this.tip.node.height + 20;
              this.tipBg.getComponent(Widget).updateAlignment();
            }, this);
          }).delay(1).to(0.3, {
            opacity: 255
          }).union().repeatForever().start();
        }

        setProgress(p, f = false) {
          if (!this.progress) return;
          if (this.progress.progress > p && p > 0 && !f) return;
          this.progress.progress = p;
        }

        slowUpdate(dt) {
          if (this.progress && this._isIncreaseProgress && !this.pause) {
            if (this.progress.progress + dt * 0.03 <= this._progressThreshold) {
              this.setProgress(this.progress.progress + dt * 0.03);
            }
          }

          this.barTransform.width = this.progress.progress * this.progress.totalLength - 5;

          if (!this.isHotUpdating) {
            this.labelProgress.string = `${Math.floor(this.progress.progress * 100)}%`;
          }
        }

        async getAppInfo() {
          if (fbInTools.usefbIn) {
            ig.PlatformFactory.create();
            await platform.initialize({
              app_id: $tp_app_id,
              app_name: $tp_app_name,
              leaderboard_world: $tp_leaderboard_world,
              leaderboard_context: $tp_leaderboard_context,
              game_id: $tp_game_id,
              host_api: "https://fb-api.capjoy.com",
              host_bot: "https://fb-bot.capjoy.com",
              leaderboard_preload: true
            });
            let iads = [$tp_iad];
            let rads = [$tp_rad];
            await platform.startGame({
              iad_ids: iads,
              rad_ids: rads,
              iad_interval_sec: 60,
              iad_delay_for_new: 30,
              iad_delay_for_old: 0,
              iad_delay_for_old_first_play_today: 0,
              tournament_contextId: null
            });
          }

          LogEventWrap.logAppAnalytic("enterGame"); //sdk init

          SdkManager.Init();
          await this.loadRemoteConfig();
          this.setupVersion();
          Logs.Log("getRemoteConfig ok");
          this.loadGameConfig(G.GameConfig);
          Logs.Log("loadGameConfig ok");
          this.loadingCircle.active = false;
          await this.initMeta();
          await this.checkUpdate();
          Logs.Log("checkUpdate ok");
          Logs.Log("initUserInfoAndMeta ok");
          this.GetUserInfo();
        }

        async loadRemoteConfig() {
          return new Promise(resolve => {
            let platform = "web";

            if (SdkManager.IsNative()) {
              if (SdkManager.IsIos()) {
                platform = "ios";
              } else {
                platform = "android";
              }
            } else {
              platform = "web";
            } // const remoteCfgUrl = `https://fay.capjoy.com/gameking/coin/${platform}/remote.json?random=${StringUtil.getRandomString(6)}`;


            const remoteCfgUrl = `${G.res_root}/${platform}/remote.json?random=${StringUtil.getRandomString(6)}`;
            assetManager.loadRemote(remoteCfgUrl, (err, cfg) => {
              if (err) {
                console.warn("load cfg failed", remoteCfgUrl);
                return;
              }

              let config = cfg.json;
              let configName = VersionScheme.online;

              if (appGame.isDev || CC_PREVIEW || platform === "web") {
                configName = VersionScheme.test;
              } else {
                let appVersion = $tp_version;
                let reviewVersion = config["review"]["native_v"];
                let onlineVersion = config["online"]["native_v"];

                if (StringUtil.versionCompareHandle(appVersion, reviewVersion) == 0) {
                  configName = VersionScheme.review;
                } else if (StringUtil.versionCompareHandle(appVersion, onlineVersion) <= 0) {
                  configName = VersionScheme.online;
                } else if (StringUtil.versionCompareHandle(appVersion, onlineVersion) > 0) {
                  configName = VersionScheme.test;
                }
              }

              Reflect.defineProperty(globalThis, "versionConfig", {
                value: config[configName]
              });
              Reflect.defineProperty(globalThis, "versionSchemeName", {
                value: configName
              });
              console.log("Current Choose Config:", configName);
              resolve(cfg.json);
            });
          });
        }

        loadGameConfig(res) {
          console.log("RemoteGameConfig:", JSON.stringify(res));

          for (let key in res) {
            G.GameConfig[key] = res[key];
          }

          if (SdkManager.IsIos()) {
            let iosconfig = {};

            for (let key in G.GameConfig) {
              if (key.endsWith("_ios")) {
                let oriKey = key.replace("_ios", ""); //G.GameConfig[oriKey] = G.GameConfig[key]

                iosconfig[oriKey] = G.GameConfig[key];
              }
            }

            for (let key in iosconfig) {
              G.GameConfig[key] = iosconfig[key];
            }
          }

          LogEventWrap.logEvent("LoadDetail", {
            phase: "appInfo"
          });
        }

        async checkUpdate() {
          return new Promise(async resolve => {
            if (SdkManager.IsNative() && !$tp_test_mode) {
              await this.checkAppUpdate();
              await this.checkHotUpdate();
              resolve(null);
            } else {
              resolve(null);
            }
          });
        }

        async checkAppUpdate() {
          console.log("checkAppUpdate");
          return new Promise(resolve => {
            const appVersion = $tp_version;
            const onlineVersion = versionConfig.native_v;

            if (StringUtil.versionCompareHandle(appVersion, onlineVersion) < 0) {
              console.log("app need update");
              UIRoot.instance.openChildWindow(AppUpdateWindow, {
                onClose: () => {
                  resolve(null);
                }
              });
            } else {
              resolve(null);
            }
          });
        }

        async checkHotUpdate() {
          console.log("checkHotUpdate");
          return new Promise(resolve => {
            let updator = new HotUpdator();

            updator.onEnterGame = () => {
              resolve(null);
            };

            updator.onUpdateStart = () => {
              this.isHotUpdating = true; // this.labelUpdating.string = "onUpdateStart";
              // this.labelUpdating.string = "Checking new update";

              this.progress.node.parent.active = true;
            };

            updator.onUpdateProgress = (downloaded, total) => {
              this.setProgress(downloaded / total);
              this.labelProgress.string = `${Math.floor(downloaded / total * 100)}%`;
            };

            updator.onUpdateFinish = () => {
              this.isHotUpdating = false; // this.labelUpdating.string = "onUpdateFinish, wait to restart";
            };

            updator.startUpdate();
          });
        }

        initMeta() {
          this.pause = false;
          this.progress.node.parent.active = true;
          this.loadingCircle.active = false;
          return new Promise(resolve => {
            let url = `${G.GameConfig.meta_server}/meta_client_${versionConfig.meta_v}.json`;
            assetManager.loadRemote(url, {
              maxRetryCount: 3,
              ext: ".txt"
            }, (err, cfg) => {
              if (err) {
                console.warn("load meta cfg failed", url);
                resolve(null);
                return;
              }

              let obj = null;

              try {
                let content = encryptCode.simplecode(LZString.decompressFromBase64(cfg.text));
                obj = JSON.parse(content);
              } catch (e) {
                obj = JSON.parse(cfg.text);
              }

              this.metaLoaded = true;
              this.setProgress(0.3);
              /**
               * 提前初始化多语言
               */

              let localeMetaData = [];
              let keys = obj.locale.keys;
              let datas = obj.locale.data;

              for (let data of datas) {
                let row = {};

                for (let i = 0; i < keys.length; i++) {
                  row[keys[i]] = data[i];
                }

                localeMetaData.push(row);
              }

              MetaManager.SetTypeData(Meta.MetaType.locale, LocalizationMeta.MakeEntity, localeMetaData);
              const la = sys.localStorage.getItem("user_language") || "en";
              i18n.changeto(la);
              MetaManager.init(obj);
              resolve(null);
            });
          });
        }

        _GetUserInfo() {
          this.progress.node.parent.active = true;
          this.loadingCircle.active = false;
          this.btnFB.active = false;
          this.btnApple.active = false;
          this.btnGuest.active = false;
          this.pause = false; // AppKit.LogEventWrap.logEvent("LoadDetail", { phase: "userInfo" });

          this.login();
        }

        GetUserInfo() {
          UserWrap.SetWait(() => {
            this.progress.node.parent.active = false;
            this.loadingCircle.active = false;

            if (SdkManager.IsNative()) {
              this.btnFB.active = SdkManager.IsNative();
              this.btnApple.active = SdkManager.IsIos();
              this.btnGuest.active = true;
              this.btnFB.parent.getComponent(Widget).updateAlignment();
            }

            this.btnApple.parent.getComponent(Layout).updateLayout();
            this.pause = true;
          });
          UserWrap.LoginAndGetUserInfo(this._GetUserInfo.bind(this));
        }
        /**
         * Button FaceBook
         */


        GetUserInfo_FBLogin() {
          UserWrap.NativeFBLogin(this._GetUserInfo.bind(this));
        }
        /**
         * Button Apple
         */


        GetUserInfo_AppleLogin() {
          UserWrap.NativeAppleLogin(this._GetUserInfo.bind(this));
        }
        /**
         * Button Guest
         */


        GetUserInfo_GuestLogin() {
          UIRoot.instance.openChildWindow(GuestConfirmWindow, {
            connectCallback: () => {
              UserWrap.NativeFBLogin(this._GetUserInfo.bind(this));
            },
            guestCallback: () => {
              UserWrap.NativeGuestLogin(this._GetUserInfo.bind(this));
            }
          });
        }

        login() {
          Logs.Log("start login...");
          this.setProgress(0.05);
          let req = SR.SRLogin.login(Game.SUser.AccountId(), Game.SUser.from);
          req.SetSilence(true);
          req.SetCallBack(res => {
            this.setProgress(0.1);
            Logs.Log("login ok");
            Game.SUser.updateData(res.user);
            console.log(res.user.userId, Game.SUser.AccountId());
            LogEventWrap.logAppAnalytic("login", {
              method: Game.SUser.from,
              id: Game.SUser.AccountId()
            });
            let entryLogged = GameKit.DataCache.GetData("entrylogged");

            if (!entryLogged) {
              LogEventWrap.logEvent("EntryDetail", {
                entry: G.query.type || "normal"
              });
              GameKit.DataCache.SetData("entrylogged", true);
            }

            LogEventWrap.logEvent("LoadDetail", {
              phase: "login"
            });

            if (wxTools.usewx) {
              LogEventWrap.logEvent("login", wx.getSystemInfoSync());
            }

            this.getGameData();
            SoundManager.playBgmByName(SoundManager.SoundNames.BGM_Menu);
            let cday = GameKit.TimeUtil.getCurrentDay();

            if (Game.SUser.isfirst) {
              GameKit.PlayerPrefs.SetInt("UserFirstEnterDay", cday);
            } else {
              let fday = GameKit.PlayerPrefs.GetInt("UserFirstEnterDay", cday);

              if (cday - fday == 1) {
                LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "teh4fn" : "7ksoje"); //aj_retention2
              } else if (cday - fday == 6) {
                LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "b01emm" : "s9lr8w"); //aj_retention7
              }
            }

            LoadingWindow.Hide();
          });
          req.SetErrorCallBack(res => {
            //Logs.Error("login error", res)
            //UIRoot.instance.openChildWindow(DialogWindow, {msg:i18n.t("ErrorLogin"), confirmStr:i18n.t("Reconnect"), confirmFunc:function() {
            this.setProgress(0.1);
            LoadingWindow.Hide(); //    this.login()
            //}.bind(this)})
          });
          req.Send();
        }
        /*updateInfo() {
        	var SUser = Game.SUser
        	if (SUser.thirdUserInfo) {
        		let G.querySRUsG.queryeInfo()G.query
        		if (G.query && G.query.inviteId) reqUUI.SetRequestBody("inviteId", G.query.inviteId)
        		reqUUI.SetSilence(true)
        		reqUUI.SetCallBack((res) => {
        			Logs.Log("update userinfo ok")
        	    
        			AppKit.LogEventWrap.logEvent("LoadDetail", {phase:"updateUserInfo"})
        				this.updateFriends()
        		})
        		reqUUI.SetErrorCallBack(function(res) {
        			Logs.Log("updataInfo error", res)
        			//UIRoot.instance.openChildWindow(DialogWindow, {msg:i18n.t("ErrorLogin"), confirmStr:i18n.t("Reconnect"), confirmFunc:function() {
        				this.setProgress(0.5, true)
        			//    this.login()
        			//}.bind(this)})
        		}.bind(this))
        		reqUUI.Send()
        	} else {
        		AppKit.LogEventWrap.logEvent("LoadDetail", {phase:"updateUserInfo"})
        			this.updateFriends()
        	}
        }
        	updateFriends() {
        	var SUser = Game.SUser
        	AppKit.UserWrap.GetFriends((friends) => {
        		//if (friends != null) {
        			let reqUUF = SR.SRUserInfo.updateFriends(friends)
        			reqUUF.SetSilence(true)
        			reqUUF.SetCallBack((res) => {
        				Logs.Log("update friends ok")
        	    
        				AppKit.LogEventWrap.logEvent("LoadDetail", {phase:"updateFriends"})
        			    
        				this.getGameData()
        			})
        			reqUUF.SetErrorCallBack(function(res) {
        				Logs.Log("updataFriends error", res)
        				//UIRoot.instance.openChildWindow(DialogWindow, {msg:i18n.t("ErrorLogin"), confirmStr:i18n.t("Reconnect"), confirmFunc:function() {
        					this.setProgress(0.5, true)
        				//    this.login()
        				//}.bind(this)})
        			}.bind(this))
        			reqUUF.Send()
        		//} else {
        		//    this.getGameData()
        		//}
        	})
        }*/


        getGameData() {
          console.time("gameData>>>>>>>>>>>>>>>>>>>>>");
          Logs.Log("getGameData start");
          let SUser = Game.SUser;
          let reqb = [];
          let breqb = [];
          SdkManager.GetQuery(() => {
            UserWrap.GetFriends(friends => {
              //IOS除了第一次授权以外都不需要本地覆盖远程，getInfo中会使用远程userInfo
              if (SUser.from === "app_Apple") {
                if (LoginWindow.isFirstAppleLogin) {
                  let reqUUI = SR.SRUserInfo.updateInfo();
                  if (G.query && G.query.inviteId) reqUUI.SetRequestBody("inviteId", G.query.inviteId);
                  breqb.push(reqUUI);
                } else {
                  breqb.push(SR.SRUserInfo.updateInviteId());
                }
              } else {
                let reqUUI = SR.SRUserInfo.updateInfo();
                if (G.query && G.query.inviteId) reqUUI.SetRequestBody("inviteId", G.query.inviteId);
                breqb.push(reqUUI);
              }

              breqb.push(SR.SRUserInfo.updateFriends(friends));
              breqb.push(SR.SRStatus.getUserStatus());
              breqb.push(SR.SRActivity.getUserActivity());
              breqb.push(SR.SRSlot.getUserSlot());
              breqb.push(SR.SRSocial.getFriendsRank());
              breqb.push(SR.SRUserData.getData());
              reqb.push(SR.SRUserInfo.getInfo());
              reqb.push(SR.SRItems.getUserItems());
              reqb.push(SR.SRVillage.getUserVillage()); //reqb.push(SR.SRChat.getChats())

              reqb.push(SR.SRTutorial.getData());
              if (!CLOSE_Card) reqb.push(SR.SRCard.getUserCard());
              if (!CLOSE_Servant) reqb.push(SR.SRServant.getUserServant());
              reqb.push(SR.SRSign.getSignData());
              reqb.push(SR.SRTask.getTaskList());
              reqb.push(SR.SRVillage.getPresentList());
              reqb.push(SR.SRRecord.getUserRecord());
              let reqGameData = new GameKit.BatchRequest(reqb, breqb);
              reqGameData.SetSilence(true);
              reqGameData.SetCallBack(() => {
                this.setProgress(0.2);
                Logs.Log("getGameData ok");
                SUser.login = true;
                SUser.logined = true;
                SUser.logining = false;
                LogEventWrap.logEvent("LoadDetail", {
                  phase: "userData"
                });
                this.schedule(() => {
                  if (this.metaLoaded) {
                    AppGame.instance.login();
                    AppMain.instance.tutorialManager.initTutorial();
                    this.unscheduleAllCallbacks(); // Game.SUserTutorial.data.tutorialMap[100] = 1000001

                    if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                      Game.SUser.data.ap = G.GameConstance.initSpin;
                      Game.SUser.data.apRecover = 0;
                      Game.SUser.data.apRecoverLast = GameKit.TimeUtil.getCurrentTime();
                      Game.SUser.data.coin = G.GameConstance.initCoin;
                      Game.SUser.data.shield = 0;
                      Game.SUserVillage.data.village = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
                      Game.SUserSlot.data.realToraidUser = Game.SUserSlot.data.toraidUser;
                      Game.SUserSlot.data.toraidUser = {
                        userId: 0,
                        name: i18n.t("TutorialTargetName3"),
                        avatar: i18n.t("TutorialTargetAvatar3"),
                        coin: 210000,
                        expire: 0,
                        isFriend: false
                      };
                    }

                    this.EnterHomeView();
                  }
                }, 0.1);
              });
              reqGameData.SetSomeOneErrorCallBack(e => {
                this.setProgress(0.2);
                Logs.Log("getGameData some error", e.method, e);
              });
              reqGameData.SetErrorCallBack(e => {
                this.setProgress(0.2);
                Logs.Log("getGameData error", e);
                UIRoot.instance.openChildWindow(DialogWindow, {
                  msg: i18n.t("ErrorLogin"),
                  confirmStr: i18n.t("Reconnect"),
                  confirmFunc: () => {
                    this.setProgress(0, true);
                    this.login();
                  }
                });
              });
              reqGameData.Send();
              AppGame.instance.prelogin();
            });
          });
        }

        async EnterHomeView() {
          if (!UIRoot.instance.commonAssetsNode.children.length) {
            console.time("firstCommonAssets<<<<<<<<<<<<<<");
            await new Promise(resolve => {
              cce.loadRes("window/CommonAssets", Prefab, (error, res) => {
                const commonAssetsNode = instantiate(res);
                commonAssetsNode.parent = UIRoot.instance.commonAssetsNode;
                commonAssetsNode.active = true;
                resolve(null);
              }, (loaded, total) => {
                this.setProgress(0.3 + loaded / total * 0.1);
              });
            });
          }

          if (UIRoot.instance.gameNode.children.length) {
            this.loadBundle();
            return;
          }

          cce.loadRes("window/GameNode", Prefab, (err, res) => {
            if (err) {
              console.log("load gameNode err");
              return;
            }

            const newGameNode = instantiate(res);
            UIRoot.instance.gameNode.addChild(newGameNode);
            this.schedule(async () => {
              if (homeView) {
                this.unscheduleAllCallbacks();
                homeView.init();
                this.loadBundle();
              }
            }, 0);
          }, (loaded, total) => {
            this.setProgress(0.4 + loaded / total * 0.1);
          });
        }

        loadLocalBundle(name, md5Version) {
          return new Promise((resolve, reject) => {
            assetManager.loadBundle(name, {
              version: md5Version
            }, (err, bundle) => {
              // bundle.load('xxx');
              if (err) {
                console.log("load local bundle", name, "failed");
                reject(null);
                return;
              }

              resolve(bundle);
            });
          });
        }

        async loadBundle() {
          const roomsLocalMd5 = versionConfig.bundles_hash[BundleNames.roomsLocal];
          let roomLocalBundleUrl = "";
          roomLocalBundleUrl = `${G.GameConfig.assetbundle_server}/roomsLocal`;

          if (SdkManager.IsNative()) {
            // hack了cocos cacheManager的getCache函数，判断自带bundle里有没有资源
            let getCache = function (url) {
              let isInLocalBundle = false;
              let localPath = "";

              if (url.includes("roomsLocal")) {
                localPath = url.replace(G.GameConfig.assetbundle_server + "/", "");
                localPath = jsb.fileUtils.fullPathForFilename("assets/" + localPath);

                if (jsb.fileUtils.isFileExist(localPath)) {
                  isInLocalBundle = true;
                }
              }

              this.updateLastTime(url);

              if (isInLocalBundle) {
                return localPath;
              } else {
                return this.cachedFiles.has(url) ? `${this.cacheDir}/${this.cachedFiles.get(url).url}` : '';
              }
            };

            assetManager.cacheManager.getCache = getCache.bind(assetManager.cacheManager);
          } else {
            roomLocalBundleUrl = `${G.GameConfig.assetbundle_server}/roomsLocal`;
          }

          await this.loadLocalBundle(roomLocalBundleUrl, roomsLocalMd5);
          const roomsMd5 = versionConfig.bundles_hash[BundleNames.rooms]; // const roomBundleUrl = `${G.GameConfig.assetbundle_server}/${versionConfig.bundle_v}/rooms`;

          const roomBundleUrl = `${G.GameConfig.assetbundle_server}/rooms`;
          assetManager.loadBundle(roomBundleUrl, {
            version: roomsMd5
          }, (err, bundle) => {
            if (err) {
              console.warn("load bundle failed", roomBundleUrl);
              return;
            }

            console.time("loadUserData");
            homeView.loadUserData(progress => {
              this._progressThreshold = progress;
            });
            console.timeEnd("loadUserData");
            this.schedule(() => {
              if (homeView.allLoaded() && !this.noenter) {
                this.unscheduleAllCallbacks();
                LogEventWrap.logEvent("LoadDetail", {
                  phase: "enterGamePlay"
                });
                this.OpenGameMainWindow();
              }
            }, 0);
          });
        }

        OpenGameMainWindow() {
          this._tipIndex = -1;
          console.timeEnd("gameData>>>>>>>>>>>>>>>>>>>>>");
          this.setProgress(0.95);
          eventCenter.emit(MyCustomEvent.GamePrepareOK);
          UIRoot.instance.openWindow("GameMainWindow", {
            showCallback() {
              homeView.EnterGame();
              LogEventWrap.logEvent("LoadDetail", {
                phase: "enterMainWindow"
              });
            }

          });
        }

        onClose() {
          assetManager.releaseAsset(this._rt);
          super.onClose();
          const scene = director.getScene();
          scene.getChildByName("Canvas").getComponent(Canvas).cameraComponent = scene.getChildByName("Canvas").getComponentInChildren(Camera);
        }

      }, _defineProperty(_class3, "isFirstAppleLogin", false), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "bg", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "progress", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btnFB", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btnApple", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btnGuest", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "loadingCircle", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelProgress", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "txtVersion", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "renderLogo", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "renderCamera", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "barMask", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "tipBg", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "tip", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ChatMessage.ts", ['cc', './User.ts'], function (exports) {
  'use strict';

  var cclegacy, User;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      User = module.User;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "65e6dCHEGVEArW/6uImW0Rs", "ChatMessage", undefined);

      class ChatMessage {
        constructor() {
          _defineProperty(this, "data", void 0);

          _defineProperty(this, "user", void 0);

          this.data = {
            userId: 0,
            userInfo: {},
            message: "",
            timeStamp: 0
          };
        } //更新数据


        updateData(msg) {
          let data = msg;

          for (let key in data) {
            this.data[key] = data[key];
          }

          this.user = new User().updateData(this.data.userInfo);
          return this;
        } //获得数据


        getData() {
          let da = {};

          for (let key in this.data) {
            da[key] = this.data[key];
          }

          return da;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
          return this;
        }

        UserId() {
          return this.data.userId;
        }

        TimeStamp() {
          return this.data.timeStamp;
        }

        Message() {
          return this.data.message;
        }

        User() {
          return this.user;
        }

      }

      exports('ChatMessage', ChatMessage);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonUseMagicItemWindow.ts", ['cc', './UIWindow.ts', './SR.ts', './CannonCommonAsset.ts', './CannonData.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, CCBoolean, Button, _decorator, Sprite, instantiate, UIWindow, SR, CannonCommomAsset, CannonData, Game, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      CCBoolean = module.CCBoolean;
      Button = module.Button;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      instantiate = module.instantiate;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      CannonCommomAsset = module.default;
    }, function (module) {
      CannonData = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "66d9dge2HRDK54p2cD5d89r", "CannonUseMagicItemWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CannonUseMagicItemWindow = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(CCBoolean), _dec5 = property(Button), ccclass(_class = (_class2 = (_temp = _class3 = class CannonUseMagicItemWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "item", _descriptor, this);

          _initializerDefineProperty(this, "item_parent", _descriptor2, this);

          _initializerDefineProperty(this, "item_list", _descriptor3, this);

          _defineProperty(this, "item_ui_data", []);

          _defineProperty(this, "choose_index", null);

          _initializerDefineProperty(this, "btn_confirm", _descriptor4, this);
        }

        onLoad() {
          this.set_item_touch_event();
          this.get_ui_data();
          this.update_ui();
        }

        get_ui_data() {
          this.item_list.forEach((v, i) => {
            let sp = GameKit.ControllerTable.GetNode(v, "sp").getComponent(Sprite);
            let light = GameKit.ControllerTable.GetNode(v, "light");
            sp.spriteFrame = CannonCommomAsset.ins.get_item_big_spf(i);
            light.runAction(ccAction.rotateBy(5, 360).repeatForever());
            this.item_ui_data.push({
              node: v,
              sp: sp,
              light: light
            });
          });
        }

        update_ui() {
          this.btn_confirm.interactable = !!this.item_list[this.choose_index];
          this.item_ui_data.forEach((v, i) => {
            v.light.active = i === this.choose_index;
          });
        }
        /** @type {cc.Node} */


        get create_all_item() {
          return false;
        }

        set create_all_item(v) {
          if (!CC_EDITOR) {
            return;
          }

          this.item.active = false;
          this.item_parent.destroyAllChildren();
          this.item_list = []; // 创建6个item

          for (let i = 0; i < 6; i += 1) {
            let n = instantiate(this.item);
            n.parent = this.item_parent;
            n.active = true;
            this.item_list.push(n);
          }
        }
        /** 设置6个item的触摸事件 */


        set_item_touch_event() {
          this.item_list.forEach((v, i) => {
            v.on(Node.EventType.TOUCH_START, () => {
              this.choose(i);
            });
          });
        }
        /** @type {number} 当前选择的需要兑换的item-index */


        choose(index) {
          this.choose_index = index;
          this.update_ui();
        }
        /** @type {cc.Button} */


        event_confirm_choose() {
          let sr = SR.SRActivityCannon.activityCannonUseMagicItem(Game.SUser.UserId(), CannonData.get_activity_meta_id(), this.choose_index);
          sr.SetSilence(false);
          sr.SetCallBack(() => {
            this.closeAnim();
          });
          sr.Send();
        }

        event_cancel() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Activity/cannon/CannonUseMagicItemWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "item_parent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "item_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "create_all_item", [_dec4], Object.getOwnPropertyDescriptor(_class2.prototype, "create_all_item"), _class2.prototype), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btn_confirm", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/StaticGame.ts", ['cc', './LocalizationMeta.ts', './ActivityParamsMeta.ts', './CardChestMeta.ts', './CardMeta.ts', './CardSetsMeta.ts', './DailyBonusRewardMeta.ts', './DynamicPackMeta.ts', './ItemMeta.ts', './PackItemMeta.ts', './SignMeta.ts', './TaskMeta.ts', './ServantRankMeta.ts', './ShopCardPriceMeta.ts', './ShopCoinMeta.ts', './ShopMeta.ts', './GiftGetMeta.ts', './LevelBonusMeta.ts', './AdGetCoinMeta.ts', './SystemUserMeta.ts', './VillageMeta.ts', './VillageShopMeta.ts', './MetaManager.ts', './ActivityMeta.ts', './TutorialMeta.ts'], function (exports) {
  'use strict';

  var cclegacy, LocalizationMeta, ActivityParamsMeta, CardChestMeta, CardMeta, CardSetsMeta, DailyBonusRewardMeta, DynamicPackMeta, ItemMeta, PackItemMeta, SignMeta, TaskMeta, ServantRankMeta, ShopCardPriceMeta, ShopCoinMeta, ShopMeta, GiftGetMeta, LevelBonusMeta, AdGetCoinMeta, SystemUserMeta, VillageMeta, VillageShopMeta, MetaManager, ActivityMeta, TutorialMeta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      LocalizationMeta = module.LocalizationMeta;
    }, function (module) {
      ActivityParamsMeta = module.ActivityParamsMeta;
    }, function (module) {
      CardChestMeta = module.CardChestMeta;
    }, function (module) {
      CardMeta = module.CardMeta;
    }, function (module) {
      CardSetsMeta = module.CardSetsMeta;
    }, function (module) {
      DailyBonusRewardMeta = module.DailyBonusRewardMeta;
    }, function (module) {
      DynamicPackMeta = module.DynamicPackMeta;
    }, function (module) {
      ItemMeta = module.ItemMeta;
    }, function (module) {
      PackItemMeta = module.PackItemMeta;
    }, function (module) {
      SignMeta = module.SignMeta;
    }, function (module) {
      TaskMeta = module.TaskMeta;
    }, function (module) {
      ServantRankMeta = module.ServantRankMeta;
    }, function (module) {
      ShopCardPriceMeta = module.ShopCardPriceMeta;
    }, function (module) {
      ShopCoinMeta = module.ShopCoinMeta;
    }, function (module) {
      ShopMeta = module.ShopMeta;
    }, function (module) {
      GiftGetMeta = module.GiftGetMeta;
    }, function (module) {
      LevelBonusMeta = module.LevelBonusMeta;
    }, function (module) {
      AdGetCoinMeta = module.AdGetCoinMeta;
    }, function (module) {
      SystemUserMeta = module.SystemUserMeta;
    }, function (module) {
      VillageMeta = module.VillageMeta;
    }, function (module) {
      VillageShopMeta = module.VillageShopMeta;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      ActivityMeta = module.ActivityMeta;
    }, function (module) {
      TutorialMeta = module.TutorialMeta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "66fa4Cv/ThFf4QkhK1gUOEI", "StaticGame", undefined);

      class Game {}

      exports('Game', Game);

      _defineProperty(Game, "SUser", null);

      _defineProperty(Game, "SUserItems", null);

      _defineProperty(Game, "SUserVillage", null);

      _defineProperty(Game, "SUserSlot", null);

      _defineProperty(Game, "SUserTutorial", null);

      _defineProperty(Game, "SUserActivity", null);

      _defineProperty(Game, "SUserCard", null);

      _defineProperty(Game, "SUserStatus", null);

      _defineProperty(Game, "SUserServant", null);

      _defineProperty(Game, "SUserRecord", null);

      window["Game"] = Game;

      class Meta {}

      exports('Meta', Meta);

      _defineProperty(Meta, "VillageShopMeta", VillageShopMeta);

      _defineProperty(Meta, "MetaManager", null);

      _defineProperty(Meta, "ActivityMeta", ActivityMeta);

      _defineProperty(Meta, "MetaType", null);

      _defineProperty(Meta, "VillageMeta", VillageMeta);

      _defineProperty(Meta, "ItemMeta", ItemMeta);

      _defineProperty(Meta, "ShopMeta", ShopMeta);

      _defineProperty(Meta, "ShopCoinMeta", ShopCoinMeta);

      _defineProperty(Meta, "PackItemMeta", PackItemMeta);

      _defineProperty(Meta, "DynamicPackMeta", DynamicPackMeta);

      _defineProperty(Meta, "AdGetCoinMeta", AdGetCoinMeta);

      _defineProperty(Meta, "SystemUserMeta", SystemUserMeta);

      _defineProperty(Meta, "GiftGetMeta", GiftGetMeta);

      _defineProperty(Meta, "TutorialMeta", TutorialMeta);

      _defineProperty(Meta, "DailyBonusRewardMeta", DailyBonusRewardMeta);

      _defineProperty(Meta, "CardMeta", CardMeta);

      _defineProperty(Meta, "CardSetsMeta", CardSetsMeta);

      _defineProperty(Meta, "CardChestMeta", CardChestMeta);

      _defineProperty(Meta, "ShopCardPriceMeta", ShopCardPriceMeta);

      _defineProperty(Meta, "ActivityParamsMeta", ActivityParamsMeta);

      _defineProperty(Meta, "TaskMeta", TaskMeta);

      _defineProperty(Meta, "SignMeta", SignMeta);

      _defineProperty(Meta, "ServantRankMeta", ServantRankMeta);

      _defineProperty(Meta, "LevelBonusMeta", LevelBonusMeta);

      _defineProperty(Meta, "LocalizationMeta", LocalizationMeta);

      Reflect.defineProperty(Meta, "MetaManager", {
        value: MetaManager
      });
      Reflect.defineProperty(Meta, "MetaType", {
        value: MetaManager.MetaType
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardChestInfoWindow.ts", ['cc', './global.ts', './UIWindow.ts', './SR.ts', './CardChestOpenWindow.ts', './UIRoot.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Sprite, SpriteFrame, Node, _decorator, instantiate, G, UIWindow, SR, CardChestOpenWindow, UIRoot, Meta, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "67698j+NlpHnpXBda7+2eJk", "CardChestInfoWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      /**
       * 卡牌宝箱介绍页面
       * - card_chest_meta_id:number
       */

      let CardChestInfoWindow = exports('default', (_dec = property({
        tooltip: "标题",
        type: Label
      }), _dec2 = property({
        tooltip: "总个数",
        type: Label
      }), _dec3 = property({
        tooltip: "箱子sp",
        type: Sprite
      }), _dec4 = property({
        tooltip: "高概率卡片1",
        type: Sprite
      }), _dec5 = property({
        tooltip: "高概率卡片2",
        type: Sprite
      }), _dec6 = property({
        tooltip: "箱子对应的spf-list",
        type: SpriteFrame
      }), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class CardChestInfoWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "card_chest_meta", null);

          _initializerDefineProperty(this, "label_title", _descriptor, this);

          _initializerDefineProperty(this, "label_all_count", _descriptor2, this);

          _initializerDefineProperty(this, "sp_card_chest", _descriptor3, this);

          _initializerDefineProperty(this, "sp_high_chance_card_1", _descriptor4, this);

          _initializerDefineProperty(this, "sp_high_chance_card_2", _descriptor5, this);

          _initializerDefineProperty(this, "spf_card_chest_list", _descriptor6, this);

          _initializerDefineProperty(this, "card1StarNode", _descriptor7, this);

          _initializerDefineProperty(this, "card2StarNode", _descriptor8, this);

          _initializerDefineProperty(this, "card1Star", _descriptor9, this);

          _initializerDefineProperty(this, "card2Star", _descriptor10, this);

          _defineProperty(this, "title_list", [i18n.t("CardChestInfoWindowTitle_1"), i18n.t("CardChestInfoWindowTitle_2"), i18n.t("CardChestInfoWindowTitle_3")]);

          _defineProperty(this, "meta", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.card_chest_meta = Meta.MetaManager.GetMeta(Meta.MetaType.CardChest, showParams.card_chest_meta_id || 1);
          this.load_page();
        }

        load_page() {
          this.label_title.string = this.title_list[this.card_chest_meta.Id() - 1];
          this.label_all_count.string = `×${this.card_chest_meta.CardNum()}`;
          this.sp_card_chest.spriteFrame = this.spf_card_chest_list[this.card_chest_meta.Id() - 1];

          for (let i = 1; i < this.card_chest_meta.Rare1(); i++) {
            const newStar = instantiate(this.card1Star);
            this.card1StarNode.addChild(newStar);
          }

          for (let i = 1; i < this.card_chest_meta.Rare2(); i++) {
            const newStar = instantiate(this.card2Star);
            this.card2StarNode.addChild(newStar);
          } // this.sp_high_chance_card_1.spriteFrame = this.spf_card_rare_list[this.card_chest_meta.Rare1() - 1];
          // this.sp_high_chance_card_2.spriteFrame = this.spf_card_rare_list[this.card_chest_meta.Rare2() - 1];

        }

        event_close() {
          this.closeAnim();
        }

        event_buy() {
          let price = this.meta.Price();

          if (Game.SUser.Coin() < price) {
            this.closeAnim();
            homeView.shopWindow.scrollTo(G.zones.coin, 0.5);
            return;
          }

          let req = SR.SRShop.payFor(this.meta.Id());
          req.SetCallBack(function () {
            this.closeAnim(); // UIRoot.instance.closeChildWindow("ShopWindow");

            let chest = GameKit.DataCache.GetData("UserCardChest");
            UIRoot.instance.openChildWindow(CardChestOpenWindow, {
              chest: chest
            });
            GameKit.DataCache.RemoveData("UserCardChest");

            if (homeView.cardAllSetWindow) {
              homeView.cardAllSetWindow.flushData();
            }
          }.bind(this));
          req.Send();
        }

      }, _defineProperty(_class3, "windowPath", "newCard/NewCardChestInfoWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "label_title", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "label_all_count", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "sp_card_chest", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp_high_chance_card_1", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sp_high_chance_card_2", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "spf_card_chest_list", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "card1StarNode", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "card2StarNode", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "card1Star", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "card2Star", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivitySlotSymbolRankItem.ts", ['cc', './ReuseItem.ts', './ContentModel.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, Node, SpriteFrame, _decorator, assetManager, Texture2D, color, ResueItem, ContentModel;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      Node = module.Node;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      assetManager = module.assetManager;
      Texture2D = module.Texture2D;
      color = module.color;
    }, function (module) {
      ResueItem = module.ResueItem;
    }, function (module) {
      ContentModel = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "67b43jZI81HL6rc90We7pWE", "ActivitySlotSymbolRankItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivitySlotSymbolRankItem = exports('ActivitySlotSymbolRankItem', (_dec = ccclass('ActivitySlotSymbolRankItem'), _dec2 = property(Sprite), _dec3 = property(Sprite), _dec4 = property(Label), _dec5 = property(Sprite), _dec6 = property(Node), _dec7 = property(Label), _dec8 = property([ContentModel]), _dec9 = property(Label), _dec10 = property([SpriteFrame]), _dec11 = property(SpriteFrame), _dec12 = property(SpriteFrame), _dec13 = property(SpriteFrame), _dec(_class = (_class2 = (_temp = class ActivitySlotSymbolRankItem extends ResueItem {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spBg", _descriptor, this);

          _initializerDefineProperty(this, "spAvatar", _descriptor2, this);

          _initializerDefineProperty(this, "labelRank", _descriptor3, this);

          _initializerDefineProperty(this, "iconRank", _descriptor4, this);

          _initializerDefineProperty(this, "iconVip", _descriptor5, this);

          _initializerDefineProperty(this, "labelName", _descriptor6, this);

          _initializerDefineProperty(this, "rewardItems", _descriptor7, this);

          _initializerDefineProperty(this, "labelScore", _descriptor8, this);

          _initializerDefineProperty(this, "sfRankIcons", _descriptor9, this);

          _initializerDefineProperty(this, "sfItemSelf", _descriptor10, this);

          _initializerDefineProperty(this, "defaultBgSf", _descriptor11, this);

          _initializerDefineProperty(this, "defaultAvatarSF", _descriptor12, this);
        }

        setData(data) {
          this._data = data;

          if (data.isSelf) {
            this.spBg.spriteFrame = this.sfItemSelf;
          } else {
            this.spBg.spriteFrame = this.defaultBgSf;
          }

          this.iconVip.active = data.isVip;
          this.spAvatar.spriteFrame = this.defaultAvatarSF;

          if (data.photoUrl) {
            assetManager.loadRemote(data.photoUrl, {
              ext: ".png"
            }, (err, imageAsset) => {
              if (err == null && imageAsset != null) {
                const tex = new Texture2D();
                tex.image = imageAsset;
                const newSF = new SpriteFrame();
                newSF.texture = tex;
                this && this.spAvatar && (this.spAvatar.spriteFrame = newSF);
              }
            });
          }

          this.iconRank.node.active = data.rank <= 3;
          this.labelRank.node.active = data.rank > 3;
          this.iconRank.spriteFrame = this.sfRankIcons[data.rank - 1] || null;
          this.labelRank.string = data.rank.toString();
          this.labelName.string = data.name;
          this.labelName.node.color = data.isVip ? color("#ffbf13") : color("#ffffff");
          this.labelScore.string = data.score.toString();
          this.rewardItems.forEach(item => item.node.active = data.rank <= 10);
          data.contents.forEach((content, index) => {
            this.rewardItems[index].show(content);
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spBg", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spAvatar", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelRank", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "iconRank", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "iconVip", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "rewardItems", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "labelScore", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "sfRankIcons", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "sfItemSelf", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "defaultBgSf", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "defaultAvatarSF", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserSlot.ts", ['cc', './global.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Game, GameKit, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "68c7eeSqkVGjIhiWPRdFlfA", "UserSlot", undefined);

      class UserSlot {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            toraidUser: {
              userId: 0,
              name: "",
              avatar: "",
              coin: 0,
              expire: 0,
              isFriend: false,
              isVip: false
            },
            dailyBonusDid: 0,
            dailyBonusDt: 0,
            dailyBonusTr: 0,
            dailyBonusTime: 0,
            systemUserEffectTime: [],
            slotData: {
              dailyBonusCount: null
            },
            realToraidUser: {}
          };
        } //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          if (this.data.slotData.dailyBonusCount == null) this.data.slotData.dailyBonusCount = {
            normal: 0,
            gold: 0
          };
          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
          return this;
        }

        UserId() {
          return this.data.userId;
        }

        ToraidUser() {
          if (this.data.toraidUser.isFriend && !this.data.toraidUser.name) {
            let friend = Game.SUser.FriendsList()[this.data.toraidUser.userId];

            if (friend == null) {
              this.data.toraidUser.name = i18n.t("PlayerDefaultName").toString();
              this.data.toraidUser.avatar = "";
            } else {
              this.data.toraidUser.name = friend.Name();
              this.data.toraidUser.avatar = friend.Avatar();
              this.data.toraidUser.isVip = friend.IsVip();
            }
          }

          return this.data.toraidUser;
        }

        ToraidCoin() {
          return this.data.toraidUser.coin;
        }

        UpdateDailyBonus() {
          let currentTime = GameKit.TimeUtil.getCurrentTime();

          if (this.data.dailyBonusDid > 0) {
            this.data.dailyBonusDt += currentTime - this.data.dailyBonusTr;
            let recPoint = Math.floor(this.data.dailyBonusDt / G.GameConstance.dailyBonusCD);
            this.data.dailyBonusDt -= recPoint * G.GameConstance.dailyBonusCD;
            this.data.dailyBonusDid -= recPoint;

            if (this.data.dailyBonusDid <= 0) {
              this.data.dailyBonusDid = 0;
              this.data.dailyBonusDt = 0;
            }
          }

          this.data.dailyBonusTr = currentTime;
        }

        DailyBonusRemainTime() {
          if (this.data.dailyBonusDid <= 0) return 0;
          return G.GameConstance.dailyBonusCD - (GameKit.TimeUtil.getCurrentTime() - this.data.dailyBonusTr + this.data.dailyBonusDt);
        }

        DailyBonusDid() {
          return this.data.dailyBonusDid;
        }

        CanGetDailyBonus() {
          return this.data.dailyBonusDid < G.GameConstance.dailybonusMaxCount;
        }

        IsFirstGoldBonus() {
          let goldCount = this.data.slotData.dailyBonusCount["gold"] || 0;
          return goldCount <= 0;
        }

      }

      exports('UserSlot', UserSlot);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivitySlotSymbolRankInfoWindow.ts", ['cc', './CCTools.ts', './UIWindow.ts', './SlotCollectExtra.ts', './ActivitySlotSymbolRankWindow.ts', './SR.ts', './UIRoot.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, RichText, Label, _decorator, UITransform, CCTools, UIWindow, SlotCollectExtra, ActivitySlotSymbolRankWindow, SR, UIRoot, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      RichText = module.RichText;
      Label = module.Label;
      _decorator = module._decorator;
      UITransform = module.UITransform;
    }, function (module) {
      CCTools = module.CCTools;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      SlotCollectExtra = module.default;
    }, function (module) {
      ActivitySlotSymbolRankWindow = module.ActivitySlotSymbolRankWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "68fdeHS1kBGPIeAQpIYyZsT", "ActivitySlotSymbolRankInfoWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivitySlotSymbolRankInfoWindow = exports('ActivitySlotSymbolRankInfoWindow', (_dec = property([Node]), _dec2 = property(Node), _dec3 = property(RichText), _dec4 = property(RichText), _dec5 = property(SlotCollectExtra), _dec6 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class ActivitySlotSymbolRankInfoWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "nodes", _descriptor, this);

          _initializerDefineProperty(this, "spDecoration", _descriptor2, this);

          _initializerDefineProperty(this, "labelDes1", _descriptor3, this);

          _initializerDefineProperty(this, "labelDes2", _descriptor4, this);

          _initializerDefineProperty(this, "extra", _descriptor5, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor6, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "metaParam", void 0);

          _defineProperty(this, "showParam", void 0);

          _defineProperty(this, "activityId", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "childWindowChain", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.metaParam = this.meta.Param();
          this.showParam = this.metaParam.__info;
          this.activityId = this.meta.Id(); //Set Nodes

          let rawNames = [];
          this.nodes.forEach(x => {
            CCTools.SetNodeByParam(x, this.showParam[x.name]);
            rawNames.push(x.name);
          });

          for (let name in this.showParam) {
            if (rawNames.contains(name)) continue;
            if (name == "badgeTime" || name == "oldPriceShopId") continue;
            let nnode = new Node(name);
            nnode.addComponent(UITransform);
            nnode.parent = this.spDecoration;
            CCTools.SetNodeByParam(nnode, this.showParam[name]);
          }

          this.labelDes1.string = String.format(i18n.t("ActivitySlotCollectRankInfoLabel1"), this.metaParam.symbolId);
          this.labelDes2.string = String.format(i18n.t("ActivitySlotCollectRankInfoLabel2"), this.metaParam.symbolId);
          this.extra.Show(null, this.meta);
          this.leftTime = 0;
          this.slowUpdate(0);
          setTimeout(() => {
            SR.SRActivity.getUserActivity().Send();
          }, (this.meta.EndTime() - GameKit.TimeUtil.getCurrentTime()) * 1000 + 2000);
        }

        onClose() {}

        slowUpdate(args) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = 0;
            this.leftTime = this.meta.EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, true);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        close_window() {
          this.closeAnim();
        }

        callBuy() {
          if (this.childWindowChain) {
            this.clearOnCloseFunc();
            this.childWindowChain.end();
          }

          this.node.opacity = 0;
          UIRoot.instance.openChildWindow(ActivitySlotSymbolRankWindow, {
            meta: this.meta,
            showCallback: window => {
              window.addOnCloseFunc(() => {
                this.closeAnim();
              });
            }
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/normal/ActivitySlotSymbolRankInfoWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "nodes", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spDecoration", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelDes1", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelDes2", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "extra", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LevelBonusWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './ScrollViewTool.ts', './SR.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, SpriteFrame, _decorator, Button, RichText, Sprite, SoundManager, UIWindow, ScrollViewTool, SR, Meta, Game, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      Button = module.Button;
      RichText = module.RichText;
      Sprite = module.Sprite;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "69484Vy3mJJKKEigVHzhpDq", "LevelBonusWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LevelBonusWindow = exports('LevelBonusWindow', (_dec = property(ScrollViewTool), _dec2 = property(Node), _dec3 = property(Label), _dec4 = property(SpriteFrame), _dec5 = property(SpriteFrame), ccclass(_class = (_class2 = (_temp = _class3 = class LevelBonusWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "svt", _descriptor, this);

          _initializerDefineProperty(this, "btnBuy", _descriptor2, this);

          _initializerDefineProperty(this, "labelBuy", _descriptor3, this);

          _initializerDefineProperty(this, "btnBlue", _descriptor4, this);

          _initializerDefineProperty(this, "btnGray", _descriptor5, this);

          _defineProperty(this, "shopMeta", void 0);
        }

        onShow(showParams) {
          this.shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, 1301);
          this.labelBuy.string = this.shopMeta.PriceString();
          this.btnBuy.active = !Game.SUserStatus.LevelBonusOpen();
          let ids = Object.keys(Meta.MetaManager.GetMetas(Meta.MetaType.LevelBonus));
          this.svt.setItem(ids, (index, _id, itemHandle) => {
            let labelDes = GameKit.ControllerTable.GetComponent(itemHandle, "labelDes", Label);
            let content = GameKit.ControllerTable.GetComponent(itemHandle, "content", "ContentModel");
            let btn = GameKit.ControllerTable.GetComponent(itemHandle, "btn", Button);
            let labelLevel = GameKit.ControllerTable.GetComponent(itemHandle, "labelLevel", RichText);
            let spCollected = GameKit.ControllerTable.GetNode(itemHandle, "spCollected");
            let id = parseInt(_id);
            let meta = Meta.MetaManager.GetMeta(Meta.MetaType.LevelBonus, id);
            labelDes.string = String.format(i18n.t("LevelBonusItemDes"), meta.MapId());
            content.show(meta.Reward());
            btn.interactable = Game.SUserStatus.LevelBonusOpen() && Game.SUserVillage.MapId() >= meta.MapId() && !Game.SUserStatus.LevelBonusGet().contains(id);
            btn.node.targetOff(this);
            btn.node.on("click", () => {
              let req = SR.SRStatus.getLevelBonusReward(id);
              req.SetCallBack(() => {
                btn.node.active = false;
                labelLevel.string = "";
                spCollected.active = true;
              });
              req.Send();
            }, this);
            btn.node.active = !Game.SUserStatus.LevelBonusGet().contains(id);
            labelLevel.string = `<outline color=#000000 width=1>( ${Game.SUserVillage.MapId()}/${meta.MapId()} )</outline>`;
            btn.node.getComponentInChildren(Sprite).spriteFrame = btn.interactable ? this.btnBlue : this.btnGray;
            if (Game.SUserStatus.LevelBonusGet().contains(id)) labelLevel.string = "";
            spCollected.active = Game.SUserStatus.LevelBonusGet().contains(id);
          });
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        callBuy() {
          let id = this.shopMeta.Name();
          PaymentWrap.Pay(id, function (ok, res) {
            if (ok) {
              SoundManager.playSound("item_purchased");
              this.btnBuy.active = false;
              this.svt.flushData();
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "levelBonus",
                name: id,
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "levelBonus",
                name: id,
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "levelBonus",
            name: id,
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "Quest/NewLevelBonusWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnBuy", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelBuy", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btnBlue", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btnGray", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ADWrap.ts", ['cc', './global.ts', './Logs.ts', './fbIn_lib.ts', './wx_lib.ts', './yzAd.ts', './DialogWindow.ts', './LoadingWindow.ts', './SdkManager.ts', './StaticGame.ts', './LogEventWrap.ts', './NativeWrap.ts', './ShareWrap.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Logs, fbInTools, wxTools, Advertise, DialogWindow, LoadingWindow, SdkManager, Game, LogEventWrap, NativeWrap, ShareWrap, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      Advertise = module.Advertise;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('ADWrap', void 0);

      cclegacy._RF.push({}, "6a378R1TCRDjYLPvkFiPEPL", "ADWrap", undefined);

      let ADWrap;

      (function (_ADWrap) {
        let VideoId = "video";
        let FullpageId = "skipvideo";
        let BannerId = "banner";
        let adEnabled = false;
        let waitTime = 0;
        let videoLoaded = false;
        let fullpageLoaded = false;
        let videoInstant = null;
        let fullpageInstant = null;
        let bannerInstant = null;
        let videoCount = 0;
        let fullpageCount = 0;
        let wxVideoCallback;
        let yzAd;

        function Init() {
          adEnabled = false;
          waitTime = 0;
          videoLoaded = false;
          fullpageLoaded = false;
          videoInstant = null;
          fullpageInstant = null;
          bannerInstant = null;
          videoCount = 0;
          fullpageCount = 0;

          if (wxTools.usewx) {
            if (wxTools.SdkVersionOver("2.0.4") >= 0) {
              adEnabled = G.GameConfig.wxad_enable;
              VideoId = G.GameConfig.wxad_video;
              wxVideoCallback = null;
              BannerId = G.GameConfig.wxad_banner;
              bannerInstant = wx.createBannerAd({
                adUnitId: BannerId,
                style: {
                  left: wx.getSystemInfoSync().screenWidth - 400,
                  top: wx.getSystemInfoSync().screenHeight - 115,
                  //width: 400,
                  realHeight: 115
                }
              });
              bannerInstant.onResize(res => {
                bannerInstant.style = {
                  left: wx.getSystemInfoSync().screenWidth - res.width,
                  top: wx.getSystemInfoSync().screenHeight - res.height,
                  width: res.width,
                  height: res.height
                };
              });
            }
          } else if (fbInTools.usefbIn) {
            let apis = FBInstant.getSupportedAPIs();
            adEnabled = apis.indexOf("getRewardedVideoAsync") > -1 && apis.indexOf("getInterstitialAdAsync") > -1;

            if (G.GameConfig.useYzAd) {
              // let rad_high = G.GameConfig.fbad_rad_high,
              // 	rad_low = G.GameConfig.fbad_rad_low,
              // 	rad_any = G.GameConfig.fbad_rad_any,
              // 	iad_high = G.GameConfig.fbad_iad_high,
              // 	iad_low = G.GameConfig.fbad_iad_low,
              // 	iad_any = G.GameConfig.fbad_iad_any;
              // yzAd = new Advertise([iad_high, iad_low, iad_any], [rad_high, rad_low, rad_any]);
              yzAd = new Advertise([$tp_iad], [$tp_rad]);
              adEnabled = yzAd.suportAD();
            } else {
              VideoId = G.GameConfig.fbad_rad_any;
              FullpageId = G.GameConfig.fbad_iad_any;
            }
          } else if (SdkManager.IsNative()) {
            adEnabled = true;

            if (G.GameConfig.useYzAd) {
              // const className = AppKit.SdkManager.IsIos ? "yzad/yzadADCenter" : "yzad/ADCenter";
              let adsConfig = {
                ironsrc: {
                  appId: SdkManager.IsIos() ? G.GameConfig.is_appkey_ios : G.GameConfig.is_appkey_android,
                  iads: [{
                    id: 1,
                    price: 0
                  }],
                  rads: [{
                    id: 1,
                    price: 0
                  }],
                  bads: [{
                    id: 1,
                    price: 0
                  }]
                }
              };
              NativeWrap.call("yzad/ADCenter", "initAd", {
                configJson: JSON.stringify(adsConfig)
              }, null);
            } else {
              adEnabled = false;
            }
          } else ;

          if (G.GameConfig.GAME_TEST) {
            adEnabled = true;
          }

          if (G.GameConfig.closeAdvertisement) adEnabled = false;
          PrepareFullPage();
          PrepareVideo();
        }

        _ADWrap.Init = Init;

        function AdEnabled() {
          return adEnabled;
        }

        _ADWrap.AdEnabled = AdEnabled;

        function ShowVideo(callback, source = "", failcallback = null) {
          if (G.GameConfig.GAME_TEST && !fbInTools.usefbIn && !SdkManager.IsNative()) {
            ShowVideoSuccess(callback);
            return;
          }

          if (!AdEnabled()) return;

          if (IsVideoPrepared()) {
            if (wxTools.usewx) {
              wxVideoCallback = callback;
              videoInstant.show();
            } else if (fbInTools.usefbIn) {
              if (G.GameConfig.useYzAd) {
                yzAd.showRAD().then(() => {
                  ShowVideoSuccess(callback);
                }).catch(e => {
                  Logs.Log("ShowVideo error", e);
                  setTimeout(() => {
                    PrepareVideo();
                  }, 5000);
                  if (failcallback != null) failcallback();
                });
              } else {
                videoInstant.showAsync().then(function () {
                  ShowVideoSuccess(callback);
                }.bind(this).catch(e => {
                  Logs.Log("ShowVideo error", e);
                  setTimeout(() => {
                    PrepareVideo();
                  }, 5000);
                  if (failcallback != null) failcallback();
                }));
              }
            } else if (SdkManager.IsNative()) {
              if (G.GameConfig.useYzAd) {
                NativeWrap.call("yzad/ADCenter", "showVideo", null, res => {
                  if (res.success) {
                    ShowVideoSuccess(callback);
                    LogEventWrap.logEvent("video_show", {});
                  } else {
                    if (failcallback != null) failcallback();
                  }
                });
              } else {
                if (NativeWrap.callDirect("AdmobSdk", "isVideoPrepared", null)) {
                  NativeWrap.call("AdmobSdk", "showVideo", null, res => {
                    if (res.success) {
                      ShowVideoSuccess(callback);
                      LogEventWrap.logEvent("video_show", {
                        source: "admob"
                      });
                    } else {
                      if (failcallback != null) failcallback();
                    }
                  });
                } else {
                  NativeWrap.call("FBSdk", "showVideo", null, res => {
                    if (res.success || res.succeess
                    /*java回调参数写错 保留兼容*/
                    ) {
                        ShowVideoSuccess(callback);
                        LogEventWrap.logEvent("video_show", {
                          source: "fb"
                        });
                      } else {
                      if (failcallback != null) failcallback();
                    }
                  });
                }
              }
            } else ;

            waitTime = 0;
          } else {
            LoadingWindow.Show();
            setTimeout(() => {
              LoadingWindow.Hide();
              waitTime += 0.5;

              if (waitTime >= 1) {
                waitTime = 0;

                if (fbInTools.usefbIn) {
                  ShareWrap.inviteNew(i18n.t("ShareInviteNew"), "share/share1", {
                    type: "spain_invite_adnotfull"
                  }, () => {
                    ShowVideoSuccess(callback);
                  }, "spain_invite_adnotfull", false);
                } else {
                  DialogWindow.Show(i18n.t("AdNotReady"), () => {}, null);
                  if (failcallback != null) failcallback();
                }

                return;
              }

              ShowVideo(callback, source, failcallback);
            }, 500);
            return;
          }

          videoCount++;
          LogEventWrap.logEvent("AdWatch", {
            source: source,
            result: videoCount
          });
        }

        _ADWrap.ShowVideo = ShowVideo;

        function ShowVideoSuccess(callback) {
          if (callback != null) callback(true);
          videoInstant = null;
          videoLoaded = false;
          PrepareVideo();
          let adWatched = Game.SUserRecord.AdTimes() + 1;
          LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "rjczz5" : "acu5j3"); //aj_ad_view

          if (adWatched == 10) {
            LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "hyssll" : "ynezvw");
          } else if (adWatched == 20) {
            LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "r7itpg" : "ulo9rk");
          } else if (adWatched == 40) {
            LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "jctizs" : "lkh4bc");
          } //aj_ad_view_times

        }

        _ADWrap.ShowVideoSuccess = ShowVideoSuccess;

        function PrepareVideo() {
          if (!AdEnabled()) return;

          if (wxTools.usewx) {
            if (videoInstant == null) {
              videoInstant = wx.createRewardedVideoAd({
                adUnitId: VideoId
              });
              videoInstant.onClose(res => {
                if (wxTools.SdkVersionOver("2.1.0") < 0 || res.isEnded) {
                  ShowVideoSuccess(wxVideoCallback);
                  wxVideoCallback = null;
                }
              });
            }

            videoInstant.load().then(() => {
              videoLoaded = true;
            }).catch(e => {
              if (e.errMsg === "CLIENT_UNSUPPORTED_OPERATION") {
                adEnabled = false;
              } else {
                setTimeout(() => {
                  PrepareVideo();
                }, 5000);
              }
            });
          } else if (fbInTools.usefbIn) {
            if (G.GameConfig.useYzAd) ;else {
              FBInstant.getRewardedVideoAsync(VideoId).then(rewardedVideo => {
                videoInstant = rewardedVideo;
                return rewardedVideo.loadAsync();
              }).then(() => {
                videoLoaded = true;
                Logs.Log("video loaded");
              }).catch(e => {
                if (e.code === "CLIENT_UNSUPPORTED_OPERATION") {
                  adEnabled = false;
                } else {
                  setTimeout(() => {
                    PrepareVideo();
                  }, 5000);
                }
              });
            }
          } else if (SdkManager.IsNative()) ;else ;
        }

        _ADWrap.PrepareVideo = PrepareVideo;

        function IsVideoPrepared() {
          if (!AdEnabled()) return false;

          if (wxTools.usewx) {
            return videoLoaded;
          } else if (fbInTools.usefbIn) {
            if (G.GameConfig.useYzAd) {
              return yzAd.hasRAD();
            } else {
              return videoLoaded;
            }
          } else if (SdkManager.IsNative()) {
            if (G.GameConfig.useYzAd) {
              return NativeWrap.callDirect("yzad/ADCenter", "isVideoPrepared");
            } else {
              return NativeWrap.callDirect("FBSdk", "isVideoPrepared") || NativeWrap.callDirect("AdmobSdk", "isVideoPrepared");
            }
          }

          return false;
        }

        _ADWrap.IsVideoPrepared = IsVideoPrepared;

        function ShowFullPage(callback, source = "") {
          if (!AdEnabled()) return;

          if (wxTools.usewx) {
            return;
          }

          if (IsFullPagePrepared()) {
            if (fbInTools.usefbIn) {
              if (G.GameConfig.useYzAd) {
                yzAd.showIAD().then(() => {
                  if (callback != null) callback(true);
                });
              } else {
                fullpageInstant.showAsync().then(() => {
                  if (callback != null) callback(true);
                  fullpageInstant = null;
                  fullpageLoaded = false;
                  PrepareFullPage();
                }).catch(e => {
                  Logs.Log("ShowFullPage error", e);
                  setTimeout(() => {
                    PrepareFullPage();
                  }, 5000);
                });
              }
            } else if (SdkManager.IsNative()) {
              if (G.GameConfig.useYzAd) {
                NativeWrap.call("yzad/ADCenter", "showInterstitial", null, res => {
                  if (res.success) {
                    if (callback != null) callback(true);
                  }
                });
              }
            }

            waitTime = 0;
          } else {
            //LoadingWindow.Show()
            setTimeout(() => {
              //LoadingWindow.Hide()
              waitTime += 0.5;

              if (waitTime > 3) {
                waitTime = 0; //DialogWindow.Show(i18n.t("AdNotReady"), nullFunction)

                return;
              }

              ShowFullPage(callback, source);
            }, 500);
            return;
          }

          LogEventWrap.logEvent("ad_showfullpage", {
            source: source,
            result: fullpageCount
          });
        }

        _ADWrap.ShowFullPage = ShowFullPage;

        function PrepareFullPage() {
          if (!AdEnabled()) return;

          if (fbInTools.usefbIn) {
            if (G.GameConfig.useYzAd) ;else {
              FBInstant.getInterstitialAdAsync(FullpageId).then(interstitial => {
                fullpageInstant = interstitial;
                return interstitial.loadAsync();
              }).then(() => {
                fullpageLoaded = true;
                Logs.Log("fullpage loaded");
              }).catch(e => {
                if (e.code === "CLIENT_UNSUPPORTED_OPERATION") {
                  adEnabled = false;
                } else {
                  setTimeout(() => {
                    PrepareFullPage();
                  }, 5000);
                }
              });
            }
          }
        }

        _ADWrap.PrepareFullPage = PrepareFullPage;

        function IsFullPagePrepared() {
          if (!AdEnabled()) return false;

          if (fbInTools.usefbIn) {
            if (G.GameConfig.useYzAd) {
              return yzAd.hasIAD();
            } else {
              return fullpageLoaded;
            }
          } else if (SdkManager.IsNative()) {
            if (G.GameConfig.useYzAd) {
              return NativeWrap.callDirect("yzad/ADCenter", "isInterstitialPrepared");
            }
          }

          return false;
        }

        _ADWrap.IsFullPagePrepared = IsFullPagePrepared;

        function ShowBanner(callback, source = "") {
          if (!AdEnabled()) return;

          if (wxTools.usewx) {
            bannerInstant.show();
          } else if (fbInTools.usefbIn) ;else ;
        }

        _ADWrap.ShowBanner = ShowBanner;

        function HideBanner() {
          if (!AdEnabled()) return;

          if (wxTools.usewx) {
            bannerInstant.hide();
          } else if (fbInTools.usefbIn) ;else ;
        }

        _ADWrap.HideBanner = HideBanner;
      })(ADWrap || (ADWrap = exports('ADWrap', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopIconNode.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "6ab8dgAFq9CF4pGs8k3hat2", "ShopIconNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopIconNode = exports('default', (_dec = property([SpriteFrame]), _dec2 = property([SpriteFrame]), _dec3 = property([SpriteFrame]), _dec4 = property([SpriteFrame]), ccclass(_class = (_class2 = (_temp = class ShopIconNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spinIcons", _descriptor, this);

          _initializerDefineProperty(this, "coinIcons", _descriptor2, this);

          _initializerDefineProperty(this, "chestIcons", _descriptor3, this);

          _initializerDefineProperty(this, "treatIcons", _descriptor4, this);
        }

        onLoad() {} //获取Spin图片


        getSpinSprite(index) {
          return this.spinIcons[index];
        }

        getCoinSprite(index) {
          return this.coinIcons[index];
        }

        getChestSprite(index) {
          return this.chestIcons[index];
        }

        getTreatSprite(index) {
          return this.treatIcons[index];
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spinIcons", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "coinIcons", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "chestIcons", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "treatIcons", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRShop.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRShop', void 0);

      cclegacy._RF.push({}, "6abcbH8jBBCJoNICJADf/Ni", "SRShop", undefined);

      let SRShop;

      (function (_SRShop) {
        function paySuccess(shopId) {
          let req = new GameKit.ServerRequest("paySuccess");
          req.SetRequestBody("shopId", shopId);
          req.SetSilence(false);
          return req;
        }

        _SRShop.paySuccess = paySuccess;

        function payFor(shopId) {
          let req = new GameKit.ServerRequest("payFor");
          req.SetRequestBody("shopId", shopId);
          req.SetSilence(false);
          return req;
        }

        _SRShop.payFor = payFor;
      })(SRShop || (SRShop = exports('SRShop', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ButtonScaleScript.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, Component, view, Tween, UITransform, tween, easing;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
      Component = module.Component;
      view = module.view;
      Tween = module.Tween;
      UITransform = module.UITransform;
      tween = module.tween;
      easing = module.easing;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "6c392CQdUhArYvhewm5FN7L", "ButtonScaleScript", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ButtonScaleScript = exports('default', (_dec = ccclass("ButtonScaleScript"), _dec2 = property(CCInteger), _dec(_class = (_class2 = (_temp = class ButtonScaleScript extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "btnIndex", _descriptor, this);

          _defineProperty(this, "_selected", false);
        }

        get selected() {
          return this._selected;
        }

        set selected(value) {
          this._selected = value;

          this._updateButtonIconAndLabel();
        }

        _updateButtonIconAndLabel() {
          const btnWidth = view.getVisibleSize().width / 6;
          Tween.stopAllByTarget(this.node.getComponent(UITransform));
          tween(this.node.getComponent(UITransform)).to(0.3, {
            width: this._selected ? btnWidth * 2 : btnWidth
          }, {
            easing: easing.sineOut
          }).start();
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "btnIndex", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotServantNode.ts", ['cc', './Constant.ts', './CCE_Component.ts', './SoundManager.ts', './ServantWindow.ts', './SR.ts', './StaticGame.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './ServantNode.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Prefab, sp, Label, _decorator, instantiate, v3, MyCustomEvent, CCE_Component, SoundManager, ServantWindow, SR, Game, ADWrap, GameKit, i18n, ServantNode;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Prefab = module.Prefab;
      sp = module.sp;
      Label = module.Label;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      v3 = module.v3;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ServantWindow = module.ServantWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      ServantNode = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "6ccc44aHYpNLKGFcZAbqJLv", "SlotServantNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotServantNode = exports('default', (_dec = property(Node), _dec2 = property([Prefab]), _dec3 = property(sp.Skeleton), _dec4 = property(Node), _dec5 = property(Label), ccclass(_class = (_class2 = (_temp = class SlotServantNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "servantRoot", _descriptor, this);

          _initializerDefineProperty(this, "servantPrefabs", _descriptor2, this);

          _initializerDefineProperty(this, "animServantExp", _descriptor3, this);

          _initializerDefineProperty(this, "bubble", _descriptor4, this);

          _initializerDefineProperty(this, "labelMsg", _descriptor5, this);

          _defineProperty(this, "currentNode", void 0);

          _defineProperty(this, "remainTime", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);

          _defineProperty(this, "bubbleTipSTI", void 0);

          _defineProperty(this, "i18nKey", void 0);

          _defineProperty(this, "adPrepared", void 0);
        }

        Show() {
          if (CLOSE_Servant) {
            this.node.active = false;
            return;
          }

          let selectId = Game.SUserServant.GetSelected();

          if (!selectId) {
            this.node.active = false;
            return;
          }

          this.updatePet(parseInt(selectId));
          this.ShowAd(true);
          eventCenter.on(MyCustomEvent.ChangePet, this.updatePet, this);
          eventCenter.on(MyCustomEvent.UpdatePetStatus, this.updatePet, this);
        }

        onDestroy() {
          eventCenter.off(MyCustomEvent.ChangePet, this.updatePet, this);
          eventCenter.off(MyCustomEvent.UpdatePetStatus, this.updatePet, this);
        }

        Clear() {
          if (this.currentNode && this.currentNode.node) {
            this.currentNode.node.destroy();
            this.currentNode = null;
          }

          this.ShowAd(true);
        }

        slowUpdate(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();

          let _t = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;

          this.lastUpdateTime = cTime;

          if (this.remainTime) {
            this.remainTime -= _t;

            if (this.remainTime <= 0) {
              this.remainTime = null;
              this.currentNode.playFallSleep();
            }
          }
        }

        updatePet(selectId) {
          this.servantRoot.destroyAllChildren();
          let serNode = instantiate(this.servantPrefabs[selectId - 1]);
          this.currentNode = serNode.getComponent(ServantNode);
          serNode.parent = this.servantRoot;
          serNode.x = 0;
          serNode.y = 0;
          serNode.active = true;
          let state = Game.SUserServant.Servant(selectId);

          let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

          if (time > 0) {
            this.currentNode.playIdle();
            this.remainTime = time;
          } else {
            this.currentNode.playSleep();
          }
        }

        ServantEat() {
          if (!this.node) return;
          this.animServantExp.node.active = true;
          this.animServantExp.setAnimation(0, "feed", false);
          setTimeout(() => {
            if (!this.node) return;
            this.animServantExp.node.active = false;
          }, 1200);
        }

        OpenServant() {
          if (homeView.isBusy()) return;
          ServantWindow.Show();
        }

        ShowAd(onlyCancel) {
          if (!this.node) return;

          if (this.bubble.scale.x != 0.001) {
            GameKit.DataCache.SetData("ADTipsBubblePopup", false);
          }

          this.bubble.scale = v3(0.001, 0.001, 1);
          this.bubble.stopAllActions();

          if (this.bubbleTipSTI != null) {
            clearTimeout(this.bubbleTipSTI);
            this.bubbleTipSTI = null;
          }

          if (onlyCancel) {
            return;
          }

          let selectId = Game.SUserServant.GetSelected();

          if (!selectId) {
            return;
          }

          let state = Game.SUserServant.Servant(selectId);

          let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

          if (Game.SUser.Ap() <= 0 || time > 0) {
            this.scheduleOnce(() => {
              this.ShowAd();
            }, 120);
            return;
          }

          if (!GameKit.DataCache.GetData("ADTipsBubblePopup") && ADWrap.IsVideoPrepared()) {
            GameKit.DataCache.SetData("ADTipsBubblePopup", true);
            this.i18nKey = "slotServantAdTip";
            this.labelMsg.string = i18n.t(this.i18nKey);
            this.bubble.runAction(ccAction.sequence(ccAction.scaleTo(0.3, 1, 1), ccAction.callFunc(() => {
              this.adPrepared = true;
            }), ccAction.delayTime(10), ccAction.scaleTo(0.3, 0.001, 0.001), ccAction.callFunc(() => {
              this.adPrepared = false;
              GameKit.DataCache.SetData("ADTipsBubblePopup", false);
              this.bubbleTipSTI = setTimeout(() => {
                this.bubbleTipSTI = null;
                this.ShowAd();
              }, 120000);
            })));
          } else {
            this.scheduleOnce(() => {
              this.ShowAd();
            }, 3);
          }
        }

        onClickBubble() {
          if (this.adPrepared) {
            ADWrap.ShowVideo(() => {
              let selectId = Game.SUserServant.GetSelected();
              let req = SR.SRServant.servantFeedFree(selectId);
              req.SetCallBack(function (res) {
                this.currentNode.playEatWake();
                this.ServantEat();
                SoundManager.playSound("servant_food_feed");
              }.bind(this));
              req.Send();
              this.ShowAd(true);
              this.bubbleTipSTI = setTimeout(() => {
                this.bubbleTipSTI = null;
                this.ShowAd();
              }, 120000);
            }, "SlotServantWatch");
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "servantRoot", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "servantPrefabs", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "animServantExp", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "bubble", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelMsg", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/index.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      // import { G } from "./global"
      cclegacy._RF.push({}, "6ce48uxUtVM87y3ojgZd/+G", "index", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CommunityFriendWindow.ts", ['cc', './CardNewFriendsWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, CardNewFriendsWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      CardNewFriendsWindow = module.CardNewFriendsWindow;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "6e5c72qevlNuY5Zc9czhfyE", "CommunityFriendWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CommunityFriendWindow = exports('CommunityFriendWindow', (_dec = ccclass('CommunityFriendWindow'), _dec(_class = (_temp = _class2 = class CommunityFriendWindow extends CardNewFriendsWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "oneItemClicked", false);
        }

      }, _defineProperty(_class2, "windowPath", "Community/CommunitySelectFriendWindow"), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardGoldTradeExtra.ts", ['cc', './CCE_Component.ts', './CardModel.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, CCE_Component, CardModel, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "6e767Nnus5GeIuNU3466Bzn", "CardGoldTradeExtra", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CardGoldTradeExtra = exports('default', (_dec = property(CardModel), _dec2 = property(Node), _dec3 = property(CardModel), _dec4 = property(Node), ccclass(_class = (_class2 = (_temp = class CardGoldTradeExtra extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "card1", _descriptor, this);

          _initializerDefineProperty(this, "cardNew1", _descriptor2, this);

          _initializerDefineProperty(this, "card2", _descriptor3, this);

          _initializerDefineProperty(this, "cardNew2", _descriptor4, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "activityId", void 0);
        }

        Show(centerWindow, activityMeta) {
          this.meta = activityMeta;
          this.activityId = activityMeta.Id();
          let cardId1 = this.meta.Param().cardId1;
          this.card1.show(cardId1, "no-check");
          this.card1.show_more_count("check");
          this.cardNew1.active = Game.SUserCard.CardNum(cardId1) <= 0;
          let cardId2 = this.meta.Param().cardId2;
          this.card2.show(cardId2, "no-check");
          this.card2.show_more_count("check");
          this.cardNew2.active = Game.SUserCard.CardNum(cardId2) <= 0;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "card1", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "cardNew1", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "card2", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "cardNew2", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/InteractionUI.ts", ['cc', './Constant.ts', './CCE_Component.ts', './CCEaseTypes.ts', './global.ts', './EnterCloseAnim.ts', './SoundManager.ts', './ChangeSceneManager.ts', './NumAnim.ts', './UserInfoModel.ts', './SdkManager.ts', './SR.ts', './CardChestOpenWindow.ts', './UIRoot.ts', './StaticGame.ts', './ShareWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts', './ServantNode.ts', './RevengeWindow.ts', './InteractionNode.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, Label, RichText, SpriteFrame, _decorator, ProgressBar, dragonBones, Animation, UITransform, instantiate, v3, Widget, tween, Vec3, color, TutorilaEvent, MyCustomEvent, CCE_Component, CCEaseTypes, G, EnterCloseAnim, SoundManager, ChangeSceneManager, NumAnim, UserInfoModel, SdkManager, SR, CardChestOpenWindow, UIRoot, Game, Meta, ShareWrap, GameKit, i18n, AppMain, ServantNode, RevengeWindow, InteractionNode;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      RichText = module.RichText;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      ProgressBar = module.ProgressBar;
      dragonBones = module.dragonBones;
      Animation = module.Animation;
      UITransform = module.UITransform;
      instantiate = module.instantiate;
      v3 = module.v3;
      Widget = module.Widget;
      tween = module.tween;
      Vec3 = module.Vec3;
      color = module.color;
    }, function (module) {
      TutorilaEvent = module.TutorilaEvent;
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      NumAnim = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }, function (module) {
      ServantNode = module.default;
    }, function (module) {
      RevengeWindow = module.RevengeWindow;
    }, function (module) {
      InteractionNode = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "700c0Pl5xZPqaa4ym8213Oz", "InteractionUI", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let InteractionUI = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Sprite), _dec5 = property(Label), _dec6 = property(Node), _dec7 = property(RichText), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Node), _dec12 = property(Node), _dec13 = property(Node), _dec14 = property(Node), _dec15 = property(SpriteFrame), _dec16 = property(SpriteFrame), _dec17 = property(Sprite), _dec18 = property(Sprite), _dec19 = property(Node), _dec20 = property(Node), ccclass(_class = (_class2 = (_temp = class InteractionUI extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spAttackTop", _descriptor, this);

          _initializerDefineProperty(this, "spAttackBottom", _descriptor2, this);

          _initializerDefineProperty(this, "attackUserInfoNode", _descriptor3, this);

          _initializerDefineProperty(this, "attackSpriteAvatar", _descriptor4, this);

          _initializerDefineProperty(this, "attackLabelName", _descriptor5, this);

          _initializerDefineProperty(this, "attackSpBetTop", _descriptor6, this);

          _initializerDefineProperty(this, "attackLabelResult", _descriptor7, this);

          _initializerDefineProperty(this, "attackSpBetBottom", _descriptor8, this);

          _initializerDefineProperty(this, "attackBtnOk", _descriptor9, this);

          _initializerDefineProperty(this, "attackBtnBrag", _descriptor10, this);

          _initializerDefineProperty(this, "attackBtnRevenge", _descriptor11, this);

          _initializerDefineProperty(this, "attackBtnFriends", _descriptor12, this);

          _initializerDefineProperty(this, "raidNode", _descriptor13, this);

          _initializerDefineProperty(this, "servantNode", _descriptor14, this);

          _initializerDefineProperty(this, "btnSelectedBG", _descriptor15, this);

          _initializerDefineProperty(this, "btnUnselectedBG", _descriptor16, this);

          _initializerDefineProperty(this, "btnRevengeSP", _descriptor17, this);

          _initializerDefineProperty(this, "btnFriendSP", _descriptor18, this);

          _initializerDefineProperty(this, "revengeNode", _descriptor19, this);

          _initializerDefineProperty(this, "noAttackTarget", _descriptor20, this);

          _defineProperty(this, "inode", void 0);

          _defineProperty(this, "raidNodeTop", void 0);

          _defineProperty(this, "raidSpriteTopUserInfo", void 0);

          _defineProperty(this, "raidSpriteTopAvatar", void 0);

          _defineProperty(this, "raidLabelTopName", void 0);

          _defineProperty(this, "raidLabelTopCoinnumber", void 0);

          _defineProperty(this, "raidLabelTopStoleCoinnumber", void 0);

          _defineProperty(this, "raidNodeTopBet", void 0);

          _defineProperty(this, "raidNodeTopStoleCoinMask", void 0);

          _defineProperty(this, "raidNodeBottom", void 0);

          _defineProperty(this, "raidNodeBottomBet", void 0);

          _defineProperty(this, "raidLabelBottomCoinnumber", void 0);

          _defineProperty(this, "raidNodeBottomPrefect", void 0);

          _defineProperty(this, "raidNodeCoin", void 0);

          _defineProperty(this, "raidLabelCoinCoinnumber", void 0);

          _defineProperty(this, "raidCoinEmpty", void 0);

          _defineProperty(this, "raidShovel1", void 0);

          _defineProperty(this, "raidShovel2", void 0);

          _defineProperty(this, "raidShovel3", void 0);

          _defineProperty(this, "raidShovelbg", void 0);

          _defineProperty(this, "servantProgress", void 0);

          _defineProperty(this, "servantLabelLevel", void 0);

          _defineProperty(this, "servantLabelExp", void 0);

          _defineProperty(this, "servantServantNode", void 0);

          _defineProperty(this, "servantSpCoin", void 0);

          _defineProperty(this, "servantLabelCoin", void 0);

          _defineProperty(this, "servantAnimFx", void 0);

          _defineProperty(this, "servantAnimStar", void 0);

          _defineProperty(this, "servantSpExp", void 0);

          _defineProperty(this, "servantSpModel", void 0);

          _defineProperty(this, "raidShovelIndex", void 0);

          _defineProperty(this, "servantSetvantId", void 0);

          _defineProperty(this, "servantStateExp", void 0);

          _defineProperty(this, "servantLevelUpNeedExp", void 0);

          _defineProperty(this, "_isRevengeWindowOpended", false);
        }

        onLoad() {
          this.inode = this.getComponent(InteractionNode); // raid // 注意节点名称尽量不要改动
          // raid-top

          this.raidNodeTop = GameKit.ControllerTable.GetNode(this.raidNode, "top");
          this.raidSpriteTopUserInfo = GameKit.ControllerTable.GetNode(this.raidNode, "userInfo").getComponent(UserInfoModel);
          this.raidSpriteTopAvatar = GameKit.ControllerTable.GetNode(this.raidNode, "avatar").getComponent(Sprite);
          this.raidLabelTopName = GameKit.ControllerTable.GetNode(this.raidNode, "Label - name").getComponent(Label);
          this.raidLabelTopCoinnumber = GameKit.ControllerTable.GetNode(this.raidNode, "Label - coinnumber").getComponent(Label);
          this.raidLabelTopStoleCoinnumber = GameKit.ControllerTable.GetNode(this.raidNode, "Label - stolecoinnumber").getComponent(Label);
          this.raidNodeTopBet = GameKit.ControllerTable.GetNode(this.raidNode, "top_bet");
          this.raidNodeTopStoleCoinMask = GameKit.ControllerTable.GetNode(this.raidNode, "stole_coin_mask");
          this.raidNodeTopStoleCoinMask.opacity = 2; // raid-bottom

          this.raidNodeBottom = GameKit.ControllerTable.GetNode(this.raidNode, "bottom");
          this.raidNodeBottomBet = GameKit.ControllerTable.GetNode(this.raidNode, "bottom_bet");
          this.raidLabelBottomCoinnumber = GameKit.ControllerTable.GetNode(this.raidNode, "Label - bottom_coinnumber").getComponent(RichText); //this.raidLabelBottomName = GameKit.ControllerTable.GetNode(this.raidNode, "Label - bottom_name").getComponent(cc.Label)

          this.raidNodeBottomPrefect = GameKit.ControllerTable.GetNode(this.raidNode, "bg_prefectraid"); // raid-coin

          this.raidNodeCoin = GameKit.ControllerTable.GetNode(this.raidNode, "coin");
          this.raidLabelCoinCoinnumber = GameKit.ControllerTable.GetNode(this.raidNode, "coinnumber").getComponent(Label);
          this.raidCoinEmpty = GameKit.ControllerTable.GetNode(this.raidNode, "coin_empty");
          this.raidNodeCoin.children.forEach(x => {
            x.opacity -= 1;
          });
          this.raidCoinEmpty.children.forEach(x => {
            x.opacity -= 1;
          });
          this.raidShovel1 = GameKit.ControllerTable.GetNode(this.raidNode, "shovel1");
          this.raidShovel2 = GameKit.ControllerTable.GetNode(this.raidNode, "shovel2");
          this.raidShovel3 = GameKit.ControllerTable.GetNode(this.raidNode, "shovel3");
          this.raidShovelbg = GameKit.ControllerTable.GetNode(this.raidNode, "shovelbg");
          this.servantProgress = GameKit.ControllerTable.GetComponent(this.servantNode, "progress", ProgressBar);
          this.servantLabelLevel = GameKit.ControllerTable.GetComponent(this.servantNode, "labelLevel", Label);
          this.servantLabelExp = GameKit.ControllerTable.GetComponent(this.servantNode, "labelExp", Label);
          this.servantServantNode = GameKit.ControllerTable.GetNode(this.servantNode, "servantNode");
          this.servantSpCoin = GameKit.ControllerTable.GetNode(this.servantNode, "spCoin");
          this.servantLabelCoin = GameKit.ControllerTable.GetComponent(this.servantNode, "labelCoin", Label);
          this.servantAnimFx = GameKit.ControllerTable.GetComponent(this.servantNode, "animFx", dragonBones.ArmatureDisplay);
          this.servantAnimStar = GameKit.ControllerTable.GetComponent(this.servantNode, "animStar", Animation);
          this.servantSpExp = GameKit.ControllerTable.GetNode(this.servantNode, "spExp");
          this.servantSpModel = GameKit.ControllerTable.GetNode(this.servantNode, "spModel");
          EnterCloseAnim.playCloseImmediately(this.servantNode);
          this.attackLabelResult.maxWidth = this.attackLabelResult.node.parent.getComponent(UITransform).width - 20;
        }

        showPetIncreaseAttackReward() {// let pb = ResourceLoader.resMap.get("pet/Tiger");
          // let petNode = cc.instantiate(pb);
          // petNode.getFlattedChildrenRecursively().forEach(v => v.layer = cc.Layers.BitMask.UI_2D);
          // let meshRenders = petNode.getComponentsInChildren(cc.MeshRenderer);
          // meshRenders.forEach(v => {
          // 	v.addComponent(cc.UIMeshRenderer);
          // })
          // this.servantNode.addChild(petNode);
          // this.node.addChild(petNode);
          // const offset = this.camera.node.forward.multiplyScalar(-8);
          // this.cameraEndPos = endPos.worldPosition.clone().add(offset);
          // this.pet.run(startPos.worldPosition, endPos.worldPosition, 0.8, () => {
          //     this.onPigMoveEnd(leftIndex, afterOpenBoxCallback);
          // });
        }

        showAttack() {
          EnterCloseAnim.playEnter(this.spAttackTop);
          this.attackUserInfoNode.getComponent(UserInfoModel).show(this.inode.user);
          UserInfoModel.SetName(this.attackLabelName, this.inode.user);
          this.attackLabelName.string = String.format(i18n.t("InteractionAttackName"), this.inode.user.Name());
          const data = homeView.interactionNode.userVillage.VillageData();
          let cantAttack = true;
          const villageLevel = data.slice(0, 5);
          let i = 0;

          while (i < villageLevel.length) {
            if (villageLevel[i] > 1 || villageLevel[i] === 1 && data[i + 5] === 0) {
              cantAttack = false;
            }

            i++;
          }

          if (cantAttack) {
            this.noAttackTarget.active = true;
            return;
          }

          this.noAttackTarget.active = false;
          this.attackSpBetTop.destroyAllChildren();
          this.resetAttackSpBetBottom(); //console.log("this.inode.bet", this.inode.bet)

          if (this.inode.bet > 1) {
            let spBetTop = instantiate(this.inode.spBet);
            spBetTop.parent = this.attackSpBetTop;
            spBetTop.setPosition(v3(0, 0, 0));
            spBetTop.active = true; // let spBetBottom = cc.instantiate(this.inode.spBet2);

            let spBetBottom = instantiate(this.inode.spBet);
            spBetBottom.parent = this.attackSpBetBottom;
            spBetBottom.setPosition(v3(0, 0, 0));
            spBetBottom.active = true;
          }

          this.attackBtnRevenge.active = AppMain.instance.tutorialManager.isTutorilaFinished;
          this.attackBtnFriends.active = AppMain.instance.tutorialManager.isTutorilaFinished;
          this.scheduleOnce(() => {
            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              AppMain.instance.tutorialManager.tutorialStepAttackOnce();
            }
          }, 1);
        }

        doAttack() {
          EnterCloseAnim.playClose(this.spAttackTop);
          this.attackSpBetTop.destroyAllChildren();

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            eventCenter.emit(TutorilaEvent.SpinAttackStarted);
          } // this.spAttackTop.active = false;

        }

        attackResultLabelFlash(success, coin, oldCoin) {
          if (!this.inode || !this.inode.user) return;
          let user = this.inode.user;
          this.attackLabelResult.node.runAction(ccAction.sequence(ccAction.callFunc(async () => {
            let strKey = success ? "InteractionAttackResultSuccess2" : "InteractionAttackResultBlock2";
            this.attackLabelResult.node.getComponent(Widget).updateAlignment();

            if (oldCoin) {
              let from = {
                value: oldCoin
              };
              tween(from).to(0.4, {
                value: coin
              }, {
                onUpdate: () => {
                  this.attackLabelResult.string = String.format(i18n.t(strKey), this.inode.user.Name(), GameKit.StringUtil.formatNumber(Math.floor(Math.min(from.value, coin))));
                }
              }).start();
            } else {
              this.attackLabelResult.string = String.format(i18n.t(strKey), user.Name(), GameKit.StringUtil.formatNumber(coin));
            }
          }), ccAction.delayTime(0.15), ccAction.callFunc(() => {
            let strKey = success ? "InteractionAttackResultSuccess" : "InteractionAttackResultBlock";
            this.attackLabelResult.node.getComponent(Widget).updateAlignment();
            this.attackLabelResult.string = String.format(i18n.t(strKey), user.Name(), GameKit.StringUtil.formatNumber(coin));
          }), ccAction.delayTime(0.15)));
        }

        attackResult(success, coin, servantActive) {
          EnterCloseAnim.playEnter(this.spAttackBottom);
          let strKey = success ? "InteractionAttackResultSuccess" : "InteractionAttackResultBlock";
          this.attackLabelResult.node.getComponent(Widget).updateAlignment();
          this.attackLabelResult.string = String.format(i18n.t(strKey), this.inode.user.Name(), GameKit.StringUtil.formatNumber(coin));
          /*if (success) {
          	this.attackBtnBrag.active = true
          	this.attackBtnOk.y = -42.8
          } else {
          	this.attackBtnBrag.active = false
          	this.attackBtnOk.y = 0
          }*/

          if (servantActive) return;

          if (this.inode.bet > 1) {
            this.scheduleOnce(() => {
              if (!this.inode.loaded) return;
              this.attackSpBetBottom.setSiblingIndex(1);
              this.attackSpBetBottom.runAction(ccAction.sequence(ccAction.moveTo(0.32, v3(0, 0), CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)), ccAction.callFunc(() => {
                this.resetAttackSpBetBottom();
                if (this.inode.loaded) this.attackResultLabelFlash(success, coin * this.inode.bet, coin);
                SoundManager.playSound("spins_bar");

                if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                  eventCenter.emit(TutorilaEvent.SpinAttackFinished);
                }
              }, this)));
              this.attackSpBetBottom.runAction(ccAction.scaleTo(0.32, 0.001, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)));
            }, 1.3);
          } else {
            this.scheduleOnce(() => {
              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                eventCenter.emit(TutorilaEvent.SpinAttackFinished);
              }
            }, 1);
          }
        }

        attackResult2(success, coin) {
          this.attackResultLabelFlash(success, coin);

          if (this.inode.bet > 1) {
            this.scheduleOnce(() => {
              if (!this.inode.loaded) return;
              this.attackSpBetBottom.setSiblingIndex(1);
              this.attackSpBetBottom.runAction(ccAction.sequence(ccAction.moveTo(0.32, v3(0, 0), CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)), ccAction.callFunc(() => {
                this.resetAttackSpBetBottom();
                if (this.inode.loaded) this.attackResultLabelFlash(success, coin * this.inode.bet, coin);
                SoundManager.playSound("spins_bar");
              }, this)));
              this.attackSpBetBottom.runAction(ccAction.scaleTo(0.32, 0.001, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)));
            }, 1.3);
          }
        } //重置 攻击 底部bet样式


        resetAttackSpBetBottom() {
          this.attackSpBetBottom.stopAllActions();
          this.attackSpBetBottom.destroyAllChildren();
          this.attackSpBetBottom.setSiblingIndex(0);
          this.attackSpBetBottom.scale = Vec3.ONE;
        }

        clickRevenge() {
          UIRoot.instance.openChildWindow(RevengeWindow, {
            type: "revenge",
            showCallback: revengWindow => {
              if (!this._isRevengeWindowOpended) {
                EnterCloseAnim.playCloseImmediately(revengWindow.node);
                this._isRevengeWindowOpended = true;
              }
            }
          }, this.revengeNode);
          this.btnRevengeSP.spriteFrame = this.btnSelectedBG;
          this.btnFriendSP.spriteFrame = this.btnUnselectedBG;
          this.btnRevengeSP.node.parent.getComponentInChildren(Label).color = color("#FFFFFF");
          this.btnFriendSP.node.parent.getComponentInChildren(Label).color = color("#C3ECFF");
          this.revengeNode.on('close', () => {
            this.btnRevengeSP.spriteFrame = this.btnUnselectedBG;
            this.btnRevengeSP.node.parent.getComponentInChildren(Label).color = color("#C3ECFF");
            this._isRevengeWindowOpended = false;
          }, this);
        }

        clickFriends() {
          UIRoot.instance.openChildWindow(RevengeWindow, {
            type: "friends",
            showCallback: revengWindow => {
              if (!this._isRevengeWindowOpended) {
                EnterCloseAnim.playCloseImmediately(revengWindow.node);
                this._isRevengeWindowOpended = true;
              }
            }
          }, this.revengeNode);
          this.btnFriendSP.spriteFrame = this.btnSelectedBG;
          this.btnRevengeSP.spriteFrame = this.btnUnselectedBG;
          this.btnFriendSP.node.parent.getComponentInChildren(Label).color = color("#FFFFFF");
          this.btnRevengeSP.node.parent.getComponentInChildren(Label).color = color("#C3ECFF");
          this.revengeNode.on('close', () => {
            this.btnFriendSP.spriteFrame = this.btnUnselectedBG;
            this.btnFriendSP.node.parent.getComponentInChildren(Label).color = color("#C3ECFF");
            this._isRevengeWindowOpended = false;
          }, this);
        }

        clickAttackOk() {
          this.unscheduleAllCallbacks();
          EnterCloseAnim.playClose(this.spAttackBottom);
          ChangeSceneManager.instance.show(() => {
            // this.spAttackBottom.active = false;
            // this.spAttackTop.active = false;
            this.scheduleOnce(() => {
              this.inode.callClose();
              ChangeSceneManager.instance.hide();

              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                eventCenter.emit(TutorilaEvent.SpinFinished);
              }

              eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
            }, 0.5);
          });
        }

        clickAttackBrag() {
          if (SdkManager.IsNative() && Game.SUser.IsFacebook()) {
            ShareWrap.shareFbUrl(`${G.GameConfig.site_host}/share/attacki.html`, "attack_share", () => {
              SR.SRTask.clientCountTask(Meta.TaskMeta.Targets.shareattack, 1).Send();
            });
            return;
          }

          ShareWrap.share(i18n.t("ShareInviteAttack"), "share/share1", {
            intent: "SHARE",
            type: "attack_share"
          }, () => {
            SR.SRTask.clientCountTask(Meta.TaskMeta.Targets.shareattack, 1).Send();
          }, "attack_share");
          eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
        } // raid


        showRaid() {
          // show top
          EnterCloseAnim.playEnter(this.raidNodeTop); // 写入被偷者信息

          this.raidSpriteTopUserInfo.show(this.inode.user);
          this.raidLabelTopName.node.color = color(255, 255, 255); // UserInfoModel.SetName(this.raidLabelTopName, this.inode.user);

          this.raidLabelTopName.string = String.format(i18n.t("InteractionRaidName"), this.inode.user.Name());
          if (this.inode.user.IsVip()) this.raidLabelTopName.node.color = color("#ffbf13");
          this.raidLabelTopCoinnumber.string = GameKit.StringUtil.formatNumber(this.inode.user.Coin()); // 重置偷取金币总数

          this.raidLabelTopStoleCoinnumber.string = 0; // show bet

          this.raidNodeTopBet.destroyAllChildren();
          this.resetRaidSpBetBottom();

          if (this.inode.bet > 1) {
            // top
            let spBetTop = instantiate(this.inode.spBet);
            spBetTop.parent = this.raidNodeTopBet;
            spBetTop.x = 0, spBetTop.y = 0;
            spBetTop.active = true; // bottom

            let spBetBottom = instantiate(this.inode.spBet); // let spBetBottom = cc.instantiate(this.inode.spBet2);

            spBetBottom.parent = this.raidNodeBottomBet;
            spBetBottom.x = 0, spBetBottom.y = 0;
            spBetBottom.active = true;
          }

          EnterCloseAnim.playEnter(this.raidShovel1);
          EnterCloseAnim.playEnter(this.raidShovel2);
          EnterCloseAnim.playEnter(this.raidShovel3);
          EnterCloseAnim.playEnter(this.raidShovelbg);
          this.raidShovelIndex = 0; // anim test
          // this.scheduleOnce(() => {
          //     this.raidCoinAnim()
          // }, 4)

          this.raidNodeTopStoleCoinMask.opacity = 2;
          this.raidNodeTopStoleCoinMask.active = false;
          this.raidNodeTopStoleCoinMask.active = true;
        }

        doRaid() {
          if (this.raidShovelIndex == 2) EnterCloseAnim.playClose(this.raidShovel3);else if (this.raidShovelIndex == 1) EnterCloseAnim.playClose(this.raidShovel2);else EnterCloseAnim.playClose(this.raidShovel1);
          this.raidShovelIndex++;
        }

        doRaidOver() {
          EnterCloseAnim.playClose(this.raidNodeTop);
          EnterCloseAnim.playClose(this.raidShovelbg);
        }

        raidResultLabelFlash(coin, oldCoin) {
          if (!this.inode || !this.inode.user) return;
          let user = this.inode.user;
          this.attackLabelResult.node.runAction(ccAction.sequence(ccAction.callFunc(async () => {
            this.raidLabelBottomCoinnumber.string = String.format(i18n.t("InteractionRaidResultLine2"), GameKit.StringUtil.formatNumber(coin), user.Name());
            let from = {
              value: oldCoin
            };
            tween(from).to(0.4, {
              value: coin
            }, {
              onUpdate: () => {
                this.raidLabelBottomCoinnumber.string = String.format(i18n.t("InteractionRaidResultLine2"), GameKit.StringUtil.formatNumber(Math.floor(Math.min(from.value, coin))), user.Name());
              }
            }).start();
          }), ccAction.delayTime(0.15), ccAction.callFunc(() => {
            this.raidLabelBottomCoinnumber.string = String.format(i18n.t("InteractionRaidResultLine"), GameKit.StringUtil.formatNumber(coin), user.Name());
          }), ccAction.delayTime(0.15)).repeat(3));
        }

        raidResult(coin) {
          // 播放动画
          EnterCloseAnim.playEnter(this.raidNodeBottom, () => {
            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              eventCenter.emit(TutorilaEvent.SpinRaidFinished);
            }
          }); // prefect raid

          if (coin === this.inode.user.Coin()) {
            this.raidNodeBottomPrefect.active = true;
            EnterCloseAnim.playEnter(this.raidNodeBottomPrefect);
          } else {
            this.raidNodeBottomPrefect.active = false;
          } // 修改label信息


          this.raidLabelBottomCoinnumber.string = String.format(i18n.t("InteractionRaidResultLine"), GameKit.StringUtil.formatNumber(coin), this.inode.user.Name()); //this.raidLabelBottomName.string = this.inode.user.Name()
          // bet

          if (this.inode.bet > 1) {
            this.scheduleOnce(() => {
              if (!this.inode.loaded) return;
              this.raidNodeBottomBet.setSiblingIndex(1); // this.raidNodeBottomBet.runAction(ccAction.sequence(ccAction.moveTo(0.4, cc.v2(0, 0), CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn) {
              //     this.resetAttackSpBetBottom()
              //     if (this.inode.loaded) this.attackLabelResult.string = String.format(i18n.t(strKey), this.inode.user.Name(), coin * this.inode.bet)
              // }, this)))
              // this.raidNodeBottomBet.runAction(ccAction.scaleTo(0.4, 0.001, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)

              this.raidNodeBottomBet.runAction(ccAction.spawn( ///new api.
              ccAction.scaleTo(0.4, 0.001, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)), // ccAction.scaleTo(0.4, 0.001, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn),
              ccAction.sequence(ccAction.moveBy(0.4, 0, -150), ccAction.callFunc(() => {
                this.resetRaidSpBetBottom();

                if (this.inode.loaded) {
                  this.raidResultLabelFlash(coin * this.inode.bet, coin);
                  SoundManager.playSound("spins_bar");
                }
              }))));
            }, 1.5);
          }
        }
        /**
         * 偷金币动画
         * - 包含多个动画流程（铲子-金币数字出现-金币数字移动-raidtop数字改变）
         * - 每个动画使用promise封装（实际上最好写一个能链式播放动画列表的工具）
         * @param {number} coin 本次偷取的金币数量
         * @param {number} all_stole 已经偷取的金币数量
         */


        raidCoinAnim(coin, all_stole) {
          let anim_coinnumber_show = () => {
            return new Promise((resolve, reject) => {
              this.raidNodeCoin.active = true;
              this.raidNodeCoin.position = Vec3.ZERO;
              this.raidNodeCoin.scale = v3(0.001, 0.001, 1);
              this.raidNodeCoin.runAction(ccAction.sequence(ccAction.scaleTo(0.33, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), // ccAction.scaleTo(0.33, 1, ccAction.easeBackOut(1.5)),
              ccAction.callFunc(() => {
                this.scheduleOnce(resolve, 0.5);
              })));
              this.raidLabelCoinCoinnumber.string = GameKit.StringUtil.formatNumber(coin);
            });
          };

          let anim_coinnumber_move = () => {
            return new Promise((resolve, reject) => {
              let time = 0.33;
              this.raidNodeCoin.runAction(ccAction.spawn(ccAction.moveBy(time, this.raidLabelTopStoleCoinnumber.node.getWorldPosition().subtract(this.raidNodeCoin.getWorldPosition())), ccAction.scaleTo(time, 0.001), ccAction.callFunc(() => {
                this.scheduleOnce(resolve, time);
              })));
            });
          };

          let anim_stolenumber_change = () => {
            return new Promise((resolve, reject) => {
              let time = 0.33; // 闪烁

              this.raidNodeTopStoleCoinMask.opacity = 1;
              this.raidNodeTopStoleCoinMask.runAction(ccAction.sequence(ccAction.fadeIn(0.14), ccAction.callFunc(() => {
                this.raidLabelTopStoleCoinnumber.getComponent(NumAnim).playAnim(all_stole, all_stole + coin, time);
              }), ccAction.fadeOut(0.14)));
              this.scheduleOnce(resolve, time);
            });
          }; // 播放动画（由于各平台对aynsc/await的支持程度不同，因此只能用promise链式调用）


          if (coin > 0) {
            return new Promise((resolve, reject) => {
              anim_coinnumber_show().then(() => {
                anim_coinnumber_move().then(() => {
                  anim_stolenumber_change().then(() => {
                    this.scheduleOnce(() => {
                      resolve(null);

                      if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                        eventCenter.emit(TutorilaEvent.SpinRaidOnceFinished);
                      }
                    }, 0.5);
                  });
                });
              });
            });
          } else if (this.inode.cardChest) {
            return new Promise((resolve, reject) => {
              UIRoot.instance.openChildWindow(CardChestOpenWindow, {
                chest: this.inode.cardChest,
                showCallback: wnd => {
                  wnd.addOnCloseFunc(resolve);

                  if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                    eventCenter.emit(TutorilaEvent.SpinRaidOnceFinished);
                  }
                }
              });
            });
          } else {
            return new Promise((resolve, reject) => {
              this.raidCoinEmpty.scale = v3(0.001, 0.001, 1);
              this.raidCoinEmpty.active = true;
              this.raidCoinEmpty.runAction(ccAction.sequence(ccAction.scaleTo(0.23, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), // ccAction.scaleTo(0.23, 1, ccAction.easeBackOut(1.5)),
              ccAction.callFunc(() => {}, this), ccAction.delayTime(0.5), ccAction.scaleTo(0.2, 0.001), ccAction.callFunc(() => {
                this.raidCoinEmpty.active = false;

                if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                  eventCenter.emit(TutorilaEvent.SpinRaidOnceFinished);
                }

                resolve(null);
              }, this)));
            });
          }
        }

        resetRaidSpBetBottom() {
          this.raidNodeBottomBet.stopAllActions();
          this.raidNodeBottomBet.destroyAllChildren();
          this.raidNodeBottomBet.setSiblingIndex(0);
          this.raidNodeBottomBet.scale = Vec3.ONE;
        }

        clickRaidOk() {
          this.unscheduleAllCallbacks(); // EnterCloseAnim.playClose(this.raidNodeBottom);

          ChangeSceneManager.instance.show(() => {
            this.scheduleOnce(() => {
              this.inode.raidAnimRibbon.active = false;
              this.inode.callClose();
              ChangeSceneManager.instance.hide();

              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                eventCenter.emit(TutorilaEvent.SpinFinished);
              }

              eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
            }, 0.5);
          });
        }

        clickRaidBrag() {
          if (SdkManager.IsNative() && Game.SUser.IsFacebook()) {
            ShareWrap.shareFbUrl(`${G.GameConfig.site_host}/share/raidi.html`, "raid_share", () => {
              SR.SRTask.clientCountTask(Meta.TaskMeta.Targets.shareraid, 1).Send();
            });
            return;
          }

          ShareWrap.share(String.format(i18n.t("ShareInviteRaid"), this.inode.all_stole), "share/share1", {
            intent: "SHARE",
            type: "raid_share"
          }, () => {
            SR.SRTask.clientCountTask(Meta.TaskMeta.Targets.shareraid, 1).Send();
          }, "raid_share");
          eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
        }
        /*
        this.servantAnimFx.node.active = true
        this.servantAnimFx.setAnimation(0, "level_up", false)
        setTimeout(() => {
        	this.servantAnimFx.node.active = false
        }, 1200); */
        //SetServant


        setServant(servantId) {
          this.servantServantNode.destroyAllChildren(); // let servantNode: cc.Node = cc.instantiate(this.inode["animServant" + servantId].children[0].children[0]);

          let servantNode = instantiate(this["pbServant" + servantId]);
          servantNode.x = 0;
          servantNode.y = 0;
          servantNode.scale = Vec3.ONE;
          servantNode.parent = this.servantServantNode;
          servantNode.getComponent(ServantNode).playIdle();
        }

        setServantState(servantId) {
          let state = Game.SUserServant.Servant(servantId);
          if (!state) return;
          this.servantSetvantId = servantId;
          this.servantStateExp = state.exp - G.GameConstance.servantActiveExp[this.servantSetvantId] * this.inode.bet;
          this.servantLevelUpNeedExp = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, state.rank).Exp(this.servantSetvantId);
          this.servantProgress.progress = Math.min(1, this.servantStateExp / this.servantLevelUpNeedExp);
          this.servantLabelExp.string = `${this.servantStateExp} / ${this.servantLevelUpNeedExp}`;
          this.servantLabelLevel.string = state.rank.toString();
        } //Servant Anim


        servantShowModel(callback) {
          this.servantSpModel.getComponent(EnterCloseAnim).enterAnim(callback);
        }

        servantShowServantNode(callback) {
          this.servantServantNode.getComponent(EnterCloseAnim).enterAnim();
          this.scheduleOnce(callback || nullFunction, 0.7);
        }

        servantShowCoin(callback) {
          this.servantSpCoin.getComponent(EnterCloseAnim).enterAnim();
          this.scheduleOnce(callback || nullFunction, 0.7);
          SoundManager.playSound("se_pop1");
        }

        servantAddRaidCoin(coin, oldCoin, callback) {
          let targetWP = this.raidLabelTopStoleCoinnumber.node.getWorldPosition();
          let oldWP = this.servantSpCoin.getWorldPosition();
          let moveY = targetWP.y - oldWP.y;
          this.servantSpCoin.runAction(ccAction.sequence(ccAction.spawn(ccAction.moveBy(0.5, 0, moveY), ccAction.scaleTo(0.5, 0.001)), ccAction.callFunc(() => {
            this.servantSpCoin.opacity = 0;
            this.servantSpCoin.y -= moveY;
            this.servantSpCoin.scale = Vec3.ONE;
            this.raidNodeTopStoleCoinMask.opacity = 1;
            this.raidNodeTopStoleCoinMask.runAction(ccAction.sequence(ccAction.fadeIn(0.2), ccAction.callFunc(() => {
              this.raidLabelTopStoleCoinnumber.getComponent(NumAnim).playAnim(oldCoin, oldCoin + coin, 0.5);
            }), ccAction.fadeOut(0.2)));
            this.scheduleOnce(() => {
              if (callback) callback();
            }, 1);
          })));
        }

        servantAddBottomCoin(callback) {
          let targetWP = this.attackLabelResult.node.getWorldPosition();
          let oldWP = this.servantSpCoin.getWorldPosition();
          let moveY = targetWP.y - oldWP.y;
          this.servantSpCoin.runAction(ccAction.sequence(ccAction.spawn(ccAction.moveBy(0.5, 0, moveY), ccAction.scaleTo(0.5, 0.001)), ccAction.callFunc(() => {
            this.servantSpCoin.opacity = 0;
            this.servantSpCoin.y -= moveY;
            this.servantSpCoin.scale = Vec3.ONE;
            SoundManager.playSound("servant_wake");
            if (callback) callback();
          })));
        }

        servantShowExp(callback) {
          if (!this.servantSetvantId) {
            if (callback) callback();
            return;
          }

          this.servantSpExp.getComponent(EnterCloseAnim).enterAnim();
          this.scheduleOnce(() => {
            this.scheduleOnce(() => {
              this.servantAnimFx.node.active = true;
              this.servantAnimFx.playAnimation("newAnimation", 1);
              setTimeout(() => {
                this.servantAnimFx.node.active = false;
              }, 1200);
            }, 0.3);
            SoundManager.playSound("servant_expup");
            this.servantAnimStar.play();
            let oldExp = this.servantStateExp;
            let endExp = Math.floor(oldExp + G.GameConstance.servantActiveExp[this.servantSetvantId] * this.inode.bet);
            this.servantNode.runAction(ccAction.sequence(tween(this.servantStateExp).to(1.7, {}, {
              onUpdate: (_dt, t) => {
                this.servantStateExp = Math.floor(oldExp + t * G.GameConstance.servantActiveExp[this.servantSetvantId] * this.inode.bet);
                this.servantProgress.progress = Math.min(1, this.servantStateExp / this.servantLevelUpNeedExp);
                this.servantLabelExp.string = `${this.servantStateExp} / ${this.servantLevelUpNeedExp}`;
              }
            }), ccAction.delayTime(0.3), ccAction.callFunc(() => {
              if (callback) callback();
            })));
          }, 0.6);
        } //Servant execute


        showRaidServant(coin, oldCoin, callback) {
          this.servantLabelCoin.string = GameKit.StringUtil.formatNumber(coin); // this.setServant(1);

          this.setServantState(1); // this.servantShowModel();
          // this.servantShowServantNode(() => {

          this.servantShowCoin(() => {
            this.servantShowExp(() => {
              this.servantAddRaidCoin(coin, oldCoin, () => {
                EnterCloseAnim.playClose(this.servantNode);
                this.servantSetvantId = null;
                this.scheduleOnce(() => {
                  if (callback) callback();
                }, 0.5);
              });
            });
          }); // });
        }

        showBeRaidedServant(coin, callback) {
          this.servantLabelCoin.string = GameKit.StringUtil.formatNumber(coin);
          this.setServant(4);
          this.servantShowModel();
          this.servantShowServantNode(() => {
            this.servantShowCoin(() => {
              EnterCloseAnim.playClose(this.servantNode);
              this.servantSetvantId = null;
              this.scheduleOnce(() => {
                if (callback) callback();
              }, 0.5);
            });
          });
        }

        showAttackServant(coin, callback, callback2) {
          this.servantLabelCoin.string = GameKit.StringUtil.formatNumber(coin); // this.setServant(2);

          this.setServantState(2); // this.servantShowModel();
          // this.servantShowServantNode(() => {

          this.servantShowCoin(() => {
            this.servantShowExp(() => {
              this.servantSpModel.getComponent(EnterCloseAnim).closeAnim();
              this.servantServantNode.getComponent(EnterCloseAnim).closeAnim();
              this.servantSpExp.getComponent(EnterCloseAnim).closeAnim();
              this.servantSetvantId = null;
              this.scheduleOnce(() => {
                UIRoot.instance.ShowCantClick(true);
                if (callback) callback();
              }, 0.5);
              this.scheduleOnce(() => {
                this.servantAddBottomCoin(() => {
                  UIRoot.instance.CloseCantClick();
                  EnterCloseAnim.playClose(this.servantNode);
                  if (callback2) callback2();
                });
              }, 0.7);
            });
          }); // });
        }

        showBeAttackedServant(coin, callback) {
          this.servantLabelCoin.string = GameKit.StringUtil.formatNumber(coin);
          this.setServant(3);
          this.servantShowModel();
          this.servantShowServantNode(() => {
            this.servantShowCoin(() => {
              EnterCloseAnim.playClose(this.servantNode);
              this.servantSetvantId = null;
              this.scheduleOnce(() => {
                if (callback) callback();
              }, 0.5);
            });
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spAttackTop", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spAttackBottom", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "attackUserInfoNode", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "attackSpriteAvatar", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "attackLabelName", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "attackSpBetTop", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "attackLabelResult", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "attackSpBetBottom", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "attackBtnOk", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "attackBtnBrag", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "attackBtnRevenge", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "attackBtnFriends", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "raidNode", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "servantNode", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "btnSelectedBG", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "btnUnselectedBG", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "btnRevengeSP", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "btnFriendSP", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "revengeNode", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "noAttackTarget", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserWrap.ts", ['cc', './Logs.ts', './fbIn_lib.ts', './wx_lib.ts', './StringUtil.ts', './DialogWindow.ts', './PlayerPrefs.ts', './LoadingWindow.ts', './SdkManager.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './NativeWrap.ts', './LoginWindow.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, sys, loader, Logs, fbInTools, wxTools, StringUtil, DialogWindow, PlayerPrefs, LoadingWindow, SdkManager, UIRoot, Game, LogEventWrap, NativeWrap, LoginWindow, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sys = module.sys;
      loader = module.loader;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      StringUtil = module.StringUtil;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      PlayerPrefs = module.PlayerPrefs;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function (module) {
      LoginWindow = module.LoginWindow;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('UserWrap', void 0);

      cclegacy._RF.push({}, "70548Oc8k9MXKCOayKcwA80", "UserWrap", undefined);

      let UserWrap;

      (function (_UserWrap) {
        let WaitCallBack;
        let friends_results;

        function LoginAndGetUserInfo(callback) {
          var SUser = Game.SUser;

          if (wxTools.usewx) {
            handleWX(SUser, callback);
          } else if (fbInTools.usefbIn) {
            handleFB(SUser, callback);
          } else if (SdkManager.IsNative()) {
            NativeWrap.call("FBSdk", "getUserInfo", null, info => {
              let userId = info.userId;

              if (userId) {
                SUser.thirdUserInfo = true;
                SUser.from = "app_fb";
                SUser.accountId = "fb_" + userId;
                SUser.data["accountId"] = "fb_" + userId;
                SUser.thirdNoThisTime = false;

                if (info.name) {
                  SUser.data["name"] = info.name;
                  SUser.data["avatar"] = info.avatar;
                  SUser.data["fullName"] = info.fullName;
                  SUser.data["country"] = info.country;
                  if (SUser.data["country"].startsWith("zh_")) SUser.data["country"] = "zh";
                } else {
                  SUser.thirdNoThisTime = true;
                }

                if (callback != null) callback(true);
              } else {
                if (WaitCallBack) WaitCallBack();
              }
            }, 5);
          } else {
            let accCode = PlayerPrefs.GetString("NewBrowserAccount", "");

            if (accCode == null || accCode.length === 0) {
              accCode = StringUtil.getRandomString(24);
              PlayerPrefs.SetString("NewBrowserAccount", accCode);
            }

            SUser.accountId = accCode;
            SUser.data["accountId"] = accCode;
            SUser.thirdUserInfo = false;
            SUser.data["country"] = sys.language;
            if (SUser.data["country"].startsWith("zh_")) SUser.data["country"] = "zh";
            if (callback != null) callback(true);
          }
        }

        _UserWrap.LoginAndGetUserInfo = LoginAndGetUserInfo;

        function handleWX(SUser, callback) {
          var self = this;
          wx.getUserInfo({
            //lang: "zh_CN",
            success(res) {
              Logs.Log("wx.getUserInfo.success");
              SUser.thirdUserInfo = true;
              SUser.data["name"] = res.userInfo.nickName;
              SUser.data["avatar"] = res.userInfo.avatarUrl;
              SUser.data["country"] = res.userInfo.country;
              SUser.data["province"] = res.userInfo.province;
              SUser.data["city"] = res.userInfo.city;
              SUser.data["gender"] = res.userInfo.gender;
              SUser.data["language"] = res.userInfo.language;
              wx.login({
                success(res) {
                  Logs.Log("wx.login.success", res.code);
                  SUser.accountId = res.code;
                  SUser.data["accountId"] = res.code;
                  SUser.from = "weixin";
                  if (callback != null) callback(true);
                },

                fail(res) {
                  Logs.Log("wx.login.fail", res.errMsg);
                  UIRoot.instance.openChildWindow(DialogWindow, {
                    msg: i18n.t("ErrorLogin"),
                    confirmFunc: function () {
                      LoginAndGetUserInfo();
                    }.bind(self)
                  });
                }

              });
            },

            fail(res) {
              Logs.Log("wx.getUserInfo.fail", res.errMsg);
              if (WaitCallBack) WaitCallBack();

              if (wxTools.SdkVersionOver('2.0.1') >= 0) {
                //self.progress.node.active = false
                if (!self.wxloginButton) {
                  let ratio = wx.getSystemInfoSync().screenWidth / UIRoot.instance.winSize.width;
                  self.wxloginButton = wx.createUserInfoButton({
                    type: 'image',
                    image: SdkManager.AssetsPathToRealPath('Texture/btn_login_wx.png'),
                    style: {
                      left: (UIRoot.instance.winSize.width / 2 - 113) * ratio,
                      top: (UIRoot.instance.winSize.height / 2 + 330) * ratio,
                      width: 226 * ratio,
                      height: 98 * ratio
                    }
                  });
                  self.wxloginButton.onTap(res => {
                    try {
                      if (~res.errMsg.indexOf('fail')) {
                        self.wxloginButton.hide(); //self.progress.node.active = true

                        Logs.Log("self.wxloginButton.onTap error", res);
                        UIRoot.instance.openChildWindow(DialogWindow, {
                          msg: i18n.t("ErrorLogin"),
                          confirmFunc: () => {
                            UserWrap.LoginAndGetUserInfo();
                          }
                        });
                      } else {
                        Logs.Log("wx.createUserInfoButton success");
                        self.wxloginButton.destroy(); //self.progress.node.active = true

                        SUser.thirdUserInfo = true;
                        SUser.data["name"] = res.userInfo.nickName;
                        SUser.data["avatar"] = res.userInfo.avatarUrl;
                        SUser.data["country"] = res.userInfo.country;
                        SUser.data["province"] = res.userInfo.province;
                        SUser.data["city"] = res.userInfo.city;
                        SUser.data["gender"] = res.userInfo.gender;
                        SUser.data["language"] = res.userInfo.language;
                        wx.login({
                          success(res) {
                            Logs.Log("wx.login.success", res.code);
                            SUser.accountId = res.code;
                            SUser.data["accountId"] = res.code;
                            SUser.from = "weixin";
                            if (callback != null) callback(true);
                          },

                          fail(res) {
                            Logs.Log("wx.login.fail", res.errMsg);
                            UIRoot.instance.openChildWindow(DialogWindow, {
                              msg: i18n.t("ErrorLogin"),
                              confirmFunc: () => {
                                UserWrap.LoginAndGetUserInfo();
                              }
                            });
                          }

                        });
                      }
                    } catch (e) {
                      self.wxloginButton.hide(); //self.progress.node.active = true

                      UIRoot.instance.openChildWindow(DialogWindow, {
                        msg: i18n.t("ErrorLogin"),
                        confirmFunc: () => {
                          UserWrap.LoginAndGetUserInfo();
                        }
                      });
                    }
                  });
                  self.wxloginButton.show();
                } else {
                  self.wxloginButton.show();
                }
              } else if (~res.errMsg.indexOf('auth deny') || ~res.errMsg.indexOf('auth denied')) {
                // 处理用户拒绝授权的情况
                wx.showModal({
                  title: i18n.t("wxUserinfoDenyTitle"),
                  content: i18n.t("wxUserinfoDenyDes"),
                  cancelText: i18n.t("Cancel"),
                  confirmText: i18n.t("wxUserinfoDenyConfirm"),

                  success(res) {
                    if (res.confirm === true) {
                      wx.openSetting({
                        success(res) {
                          UserWrap.LoginAndGetUserInfo();
                        },

                        fail() {
                          Logs.Log("wx.openSetting error");
                          UIRoot.instance.openChildWindow(DialogWindow, {
                            msg: i18n.t("ErrorLogin"),
                            confirmFunc: () => {
                              UserWrap.LoginAndGetUserInfo();
                            }
                          });
                        }

                      });
                    } else {
                      UIRoot.instance.openChildWindow(DialogWindow, {
                        msg: i18n.t("ErrorLogin"),
                        confirmFunc: () => {
                          UserWrap.LoginAndGetUserInfo();
                        }
                      });
                    }
                  },

                  fail() {
                    UIRoot.instance.openChildWindow(DialogWindow, {
                      msg: i18n.t("ErrorLogin"),
                      confirmFunc: () => {
                        UserWrap.LoginAndGetUserInfo();
                      }
                    });
                  }

                });
              } else {
                UIRoot.instance.openChildWindow(DialogWindow, {
                  msg: i18n.t("ErrorLogin"),
                  confirmFunc: () => {
                    UserWrap.LoginAndGetUserInfo();
                  }
                });
              }
            }

          });
        }

        function handleFB(SUser, callback) {
          SUser.thirdUserInfo = true;
          FBInstant.player.getSignedPlayerInfoAsync("skyfox").then(function (result) {
            SUser.accountId = "fb_" + result.getPlayerID(); // same value as FBInstant.player.getID()

            SUser.data["accountId"] = "fb_" + FBInstant.player.getID();
            SUser.from = "fbIn";
            FBInstant.context.switchAsync(null).then(() => {
              if (callback != null) callback(true);
            }).catch(e => {
              if (callback != null) callback(true);
            });
          }).catch(e => {
            UIRoot.instance.openChildWindow(DialogWindow, {
              msg: i18n.t("ErrorLogin"),
              confirmFunc: () => {
                UserWrap.LoginAndGetUserInfo();
              }
            });
          });
          SUser.data["name"] = FBInstant.player.getName() || "";
          SUser.data["avatar"] = FBInstant.player.getPhoto() || "";
          SUser.data["country"] = FBInstant.getLocale() || "unknown";
          if (SUser.data["country"].startsWith("zh_")) SUser.data["country"] = "zh";
        }

        function SetWait(c) {
          WaitCallBack = c;
        }

        _UserWrap.SetWait = SetWait;

        function NativeFBLogin(callback) {
          var SUser = Game.SUser;
          LoadingWindow.Show(true);
          NativeWrap.call("FBSdk", "login", null, info => {
            SUser.from = "app_fb";
            let userId = info.userId;

            if (userId) {
              SUser.thirdUserInfo = true;
              SUser.accountId = "fb_" + userId;
              SUser.data["accountId"] = "fb_" + userId;
              SUser.data["name"] = info.name;
              SUser.data["avatar"] = info.avatar;
              SUser.data["fullName"] = info.fullName;
              SUser.data["country"] = info.country;
              if (SUser.data["country"].startsWith("zh_")) SUser.data["country"] = "zh";
              LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "1sl1jg" : "5xr60k"); //aj_fb_login

              if (callback != null) callback(true);
            } else {
              UIRoot.instance.toast("Login failed, please try again");
              LoadingWindow.Hide();
            }
          });
        }

        _UserWrap.NativeFBLogin = NativeFBLogin;

        function NativeGuestLogin(callback) {
          var SUser = Game.SUser; // let userId = PlayerPrefs.GetString("BrowserAccount", "");
          // if (userId == null || userId.length === 0) {
          //     userId = StringUtil.getRandomString(24);
          //     PlayerPrefs.SetString("BrowserAccount", userId);
          // }
          // SUser.from = "app_guest";
          // SUser.accountId = userId;
          // SUser.data["accountId"] = userId
          // SUser.thirdUserInfo = false;
          // SUser.data["country"] = cc.sys.language;
          // if (SUser.data["country"].startsWith("zh_")) SUser.data["country"] = "zh";
          // if (callback != null) callback(true);
          // return;

          NativeWrap.call("SDKHandleClass", "GetDeviceId", null, info => {
            let userId = info.deviceId;

            if (!userId) {
              userId = PlayerPrefs.GetString("BrowserAccount", "");

              if (userId == null || userId.length === 0) {
                userId = StringUtil.getRandomString(24);
                PlayerPrefs.SetString("BrowserAccount", userId);
              }
            }

            SUser.from = "app_guest";
            SUser.accountId = userId;
            SUser.data["accountId"] = userId;
            SUser.thirdUserInfo = false;
            SUser.data["country"] = sys.language;
            if (SUser.data["country"].startsWith("zh_")) SUser.data["country"] = "zh";
            if (callback != null) callback(true);
          });
        }

        _UserWrap.NativeGuestLogin = NativeGuestLogin;

        function NativeAppleLogin(callback) {
          let SUser = Game.SUser;
          NativeWrap.call("AppleAuth", "login", null, info => {
            console.log(info);

            if (info["data"]) {
              const data = JSON.parse(info["data"]);
              SUser.thirdUserInfo = true;
              SUser.from = "app_Apple";
              SUser.accountId = "apple_" + data["identifier"];
              SUser.data["accountId"] = "apple_" + data["identifier"];

              if (data["name"]) {
                //IOS平台只有第一次授权登陆才能拿到name和email等信息 
                //https://stackoverflow.com/questions/57545635/cannot-get-name-email-with-sign-in-with-apple-on-real-device
                SUser.data["name"] = data["name"];
                LoginWindow.isFirstAppleLogin = true;
              }

              if (callback != null) callback(true);
            } else {
              UIRoot.instance.toast("Login failed, please try again");
              LoadingWindow.Hide();
            }
          });
        }

        _UserWrap.NativeAppleLogin = NativeAppleLogin;

        function UserGetData(key, callback, value) {
          if (fbInTools.usefbIn) {
            if (typeof key === "object") {
              FBInstant.player.getDataAsync(key).then(data => {
                if (callback != null) callback(data);
              });
            } else {
              FBInstant.player.getDataAsync([key]).then(data => {
                if (data.hasOwnProperty(key)) {
                  if (callback != null) callback(data[key]);
                } else {
                  if (value != null) {
                    if (callback != null) callback(value);
                  } else {
                    if (callback != null) callback(null);
                  }
                }
              });
            }
          } else {
            if (callback != null) callback(PlayerPrefs.GetString(key, value || null));
          }
        }

        _UserWrap.UserGetData = UserGetData;

        function UserSetData(key, value, callback) {
          if (fbInTools.usefbIn) {
            if (typeof key === "object") {
              FBInstant.player.setDataAsync(key).then(() => {
                if (value != null) value(true);
              });
            } else {
              FBInstant.player.setDataAsync({
                key: value
              }).then(() => {
                if (callback != null) callback(true);
              });
            }
          } else {
            if (callback != null) callback(PlayerPrefs.SetString(key, value && value.toString() || ""));
          }
        }

        _UserWrap.UserSetData = UserSetData;

        function UserFlushData(callback) {
          if (fbInTools.usefbIn) {
            FBInstant.player.flushDataAsync().then(function () {
              if (callback != null) callback(true);
            });
          } else {
            if (callback != null) callback(true);
          }
        }

        _UserWrap.UserFlushData = UserFlushData;

        function GetFriends(callback) {
          /*if (G.GameConfig.GAME_TEST1) {
              let results = []
              results.push("10001")
              results.push("XNb6itMMNjcP4XJrh5J5hn36aaa")
              results.push("3FjGaZtenwZ4wQaaJYDtcTr3")
              results.push("FzyybNDK6t557HbMsEDfQbbj")
              results.push("bGreS3GAEdNfR7xPyNbTEkZp")
              results.push("ec2Fa4SdJ6bj2H")
              results.push("yAAEtbtXhwjexsEnkaphSbQ41")
              results.push("yAAEtbtXhwjexsEnkaphSbQ42")
              results.push("yAAEtbtXhwjexsEnkaphSbQ4")
              results.push("Sfwt6tZ4ta3eXEwArXRSDh2J")
              results.push("hyRnQmkjtT6WSr4nM6FfJfky")
              if (callback != null) callback(results)
              return
          }*/
          if (fbInTools.usefbIn) {
            let results = [];
            let _results = [];
            FBInstant.player.getConnectedPlayersAsync().then(players => {
              players.forEach(player => {
                let _pid = player.getID();

                let pid = "fb_" + _pid;
                Game.SUser.friendsInfo[pid] = {
                  accountId: pid,
                  name: player.getName() || "",
                  avatar: player.getPhoto() || ""
                };
                results.push(pid);

                _results.push(_pid);
              });
              if (callback != null) callback(results);
              friends_results = _results;
              let req = loader.getXMLHttpRequest();
              req.responseType = "json";
              req.open('POST', "https://fb-bot.capjoy.com/api/v0/upload_55", true);
              req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
              req.send("data={action:\"friends\",playerId:\"" + FBInstant.player.getID() + "\",payload:" + JSON.stringify(friends_results) + "}");
            }).catch(e => {
              if (callback != null) callback(results);
            });
          } else if (SdkManager.IsNative() && Game.SUser.IsFacebook()) {
            NativeWrap.call("FBSdk", "getFriends", {
              userId: Game.SUser.ThirdId()
            }, res => {
              let results = [];
              let _results = [];
              let ids = res.ids || [];
              ids.forEach(_pid => {
                let pid = "fb_" + _pid;
                Game.SUser.friendsInfo[pid] = {
                  accountId: pid
                };
                results.push(pid);

                _results.push(_pid);
              });
              if (callback != null) callback(results);
              friends_results = _results; // let req = cc.loader.getXMLHttpRequest();
              // req.responseType = "json"
              // req.open('POST', "https://fb-bot.capjoy.com/api/v0/upload_55", true)
              // req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8")
              // req.send("data={action:\"friends\",playerId:\""+Game.SUser.ThirdId()+"\",payload:"+JSON.stringify(UserWrap.friends_results)+"}")
            }, 6);
          } else {
            if (callback != null) callback(null);
          }
        }

        _UserWrap.GetFriends = GetFriends;
      })(UserWrap || (UserWrap = exports('UserWrap', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VIPDailyRewardWindow.ts", ['cc', './Constant.ts', './global.ts', './UIWindow.ts', './ContentModel.ts', './CommonAssets.ts', './Content.ts', './MetaManager.ts', './PlayGetAnimation.ts', './CardCollectWindow.ts', './GameMainWindow.ts', './CardChestOpenWindow.ts', './UIRoot.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, instantiate, MyCustomEvent, G, UIWindow, ContentModel, CommonAssets, Content, MetaManager, PlayGetAnimation, CardCollectWindow, GameMainWindow, CardChestOpenWindow, UIRoot, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      CardCollectWindow = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "7060cIcswpKJYh/PDKnWhao", "VIPDailyRewardWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let VIPDailyRewardWindow = exports('default', (_dec = property(ContentModel), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class VIPDailyRewardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spDailyItem", _descriptor, this);

          _initializerDefineProperty(this, "spDailyItemParent", _descriptor2, this);

          _defineProperty(this, "_showParams", null);
        }

        onShow(showParams) {
          this._showParams = showParams;
          this.spDailyItemParent.destroyAllChildren();
          let rewards = Content.FromStrings(G.GameConstance.vipDailyReward);
          rewards.forEach(reward => {
            let itemHandle = instantiate(this.spDailyItem.node);
            itemHandle.parent = this.spDailyItemParent;
            itemHandle.getComponent(ContentModel).show(reward);
          });
        }

        onClose() {}

        callClose() {
          const chest = this._showParams.vipDailyReward.UserCardChest;

          if (chest) {
            if (chest.cards.length == 1) {
              UIRoot.instance.openChildWindow(CardCollectWindow, {
                id: chest.cards[0],
                nogo: true,
                isVip: true,
                closeCallback: () => {
                  this.playGetCoinOrEnergyAnim();
                }
              });
            } else {
              UIRoot.instance.openChildWindow(CardChestOpenWindow, {
                chest: chest,
                closeCallback: () => {
                  this.playGetCoinOrEnergyAnim();
                }
              });
            }
          }

          GameKit.DataCache.RemoveData("UserCardChest");
          this.closeAnim();
        }

        async playGetCoinOrEnergyAnim() {
          const rewards = Content.FromStrings(G.GameConstance.vipDailyReward);

          for (let i = 0; i < rewards.length; i++) {
            if (rewards[i].Type() === Content.Types.Coin) {
              await PlayGetAnimation.playAnimation({
                startNode: uiRoot.node,
                endNode: GameMainWindow.instance.btnCoinAdd.node.getChildByName("iconCoin"),
                count: rewards[i].Count(),
                prefab: CommonAssets.instance.coinPrefab,
                startCallback: () => {
                  eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                }
              });
            } else if (rewards[i].Type() === Content.Types.Ap) {
              await PlayGetAnimation.playAnimation({
                startNode: uiRoot.node,
                endNode: homeView.pageViewController.btnSpin.node,
                count: rewards[i].Count(),
                prefab: CommonAssets.instance.energyPrefab
              });
            } else if (rewards[i].Type() === Content.Types.Item) {
              let meta = MetaManager.GetMeta(MetaManager.MetaType.Item, rewards[i].ContentId());
              let _prefab = null;

              if (meta._data.icon === "pet_xpPotion") {
                _prefab = CommonAssets.instance.xpPrefab;
              } else if (meta._data.icon === "pet_food") {
                _prefab = CommonAssets.instance.foodPrefab;
              }

              await PlayGetAnimation.playAnimation({
                startNode: uiRoot.node,
                endNode: homeView.pageViewController.btnSpin.node,
                count: rewards[i].Count(),
                prefab: _prefab
              });
            }
          }
        }

      }, _defineProperty(_class3, "windowPath", "VIP/NewVIPDailyRewardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spDailyItem", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spDailyItemParent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitDoorWindow.ts", ['cc', './UIWindow.ts', './MinigameCoinhitMainWindow.ts', './UIRoot.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, UIWindow, MinigameCoinhitMainWindow, UIRoot, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      MinigameCoinhitMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "718642bAg5ErJErRyW3zn8c", "MinigameCoinhitDoorWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      let MinigameCoinhitDoorWindow = exports('default', (_dec = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameCoinhitDoorWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "label_time", _descriptor, this);
        }

        onShow(showParams) {
          // 更新剩余时间的时间戳
          let time_str = i18n.t("mini_game_coinhit_time");
          this.label_time.string = time_str;
        }
        /** time时间戳 */


        event_close() {
          this.closeAnim();
        }

        event_info() {// 
        }

        event_go() {
          // this.event_close()
          UIRoot.instance.openChildWindow(MinigameCoinhitMainWindow);
        }

      }, _defineProperty(_class3, "windowPath", "Activity/minigame/coinhit/MinigameCoinhitDoorWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "label_time", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/JigsawFriendsWindow.ts", ['cc', './CCEaseTypes.ts', './SoundManager.ts', './UIWindow.ts', './UserInfoModel.ts', './ScrollViewTool.ts', './SR.ts', './JigsawWindow.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, EditBox, _decorator, Button, Label, v3, CCEaseTypes, SoundManager, UIWindow, UserInfoModel, ScrollViewTool, SR, JigsawWindow, Game, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      EditBox = module.EditBox;
      _decorator = module._decorator;
      Button = module.Button;
      Label = module.Label;
      v3 = module.v3;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      JigsawWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "72b79CImalLs5HZroEDZX+H", "JigsawFriendsWindow", undefined);
      /** @author fengyong-2-27 */


      const {
        ccclass,
        property
      } = _decorator;
      let JigsawFriendsWindow = exports('default', (_dec = property(ScrollViewTool), _dec2 = property(Node), _dec3 = property(EditBox), _dec4 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class JigsawFriendsWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "piece_index", void 0);

          _initializerDefineProperty(this, "svt", _descriptor, this);

          _initializerDefineProperty(this, "no_friends", _descriptor2, this);

          _defineProperty(this, "name_list", []);

          _initializerDefineProperty(this, "edit_box", _descriptor3, this);

          _initializerDefineProperty(this, "sp_search_end", _descriptor4, this);
        }

        onShow(showParams) {
          this.piece_index = showParams.index;
          this.sp_search_end.active = false;
          this.no_friends.active = false;
          this.update_page();
        }
        /** @type {ScrollViewTool} */


        update_page() {
          let id_list = [];

          for (let id in Game.SUser.FriendsList()) {
            id_list.push(id);
            this.name_list.push(Game.SUser.FriendsList()[id].Name());
          }

          this.no_friends.active = this.name_list.length === 0;
          this.svt.setItem(id_list, (index, id, node) => {
            let userinfo = GameKit.ControllerTable.GetNode(node, "userinfo").getComponent(UserInfoModel);
            let btn = GameKit.ControllerTable.GetNode(node, "btn-send").getComponent(Button);
            let name = GameKit.ControllerTable.GetNode(node, "name");
            let vip_name = GameKit.ControllerTable.GetNode(node, "vip-name");
            userinfo.show(Game.SUser.FriendsList()[id]);
            name.getComponent(Label).string = Game.SUser.FriendsList()[id].Name();
            name.active = true;
            vip_name.active = false;
            btn.clickEvents[0].customEventData = Game.SUser.FriendsList()[id].UserId();
          });
        }

        event_close() {
          this.closeAnim();
        }

        event_send(e, userid) {
          SoundManager.playSound("se_ok");
          e.target.getComponent(Button).interactable = false;
          let sr = SR.SRJigsaw.activityJigsawSend(userid, this.piece_index);
          sr.SetCallBack(() => {
            e.target.getComponent(Button).interactable = true;
            JigsawWindow.ins.piece.update_page();
            let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();

            if (data.pieceData[this.piece_index] <= 0) {
              this.closeAnim();
            }
          });
          sr.Send();
        }
        /** @type {cc.EditBox} */

        /** editbox中的字符串改变调用，表示正在输入中 */


        event_search_change_key() {
          this.sp_search_end.active = false;
        }

        event_search() {
          // 搜索结果
          let key = this.edit_box.string;
          let result_index = [];

          for (let i = 0; i < this.name_list.length; i += 1) {
            if (this.name_list[i].includes(key)) {
              result_index.push(i);
            }
          }

          this.no_friends.active = result_index.length === 0; // 根据结果重新渲染

          for (let i = 0; i < this.name_list.length; i += 1) {
            let item = this.svt.items[i];

            if (item) {
              item.active = result_index.includes(i.toString());
            }
          } // search成功动画


          this.sp_search_end.scale = v3(0, 0, 1);
          this.sp_search_end.active = true;
          this.sp_search_end.runAction(ccAction.scaleTo(0.5, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
        }

      }, _defineProperty(_class3, "windowPath", "Activity/Jigsaw/JigsawFriendsWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "no_friends", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "edit_box", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp_search_end", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CommonAssets.ts", ['cc', './CCE_Component.ts', './_app.ts', './ResourceLoader.ts'], function (exports) {
  'use strict';

  var cclegacy, CCString, SpriteFrame, SpriteAtlas, Material, Prefab, _decorator, CCE_Component, ResourceLoader;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCString = module.CCString;
      SpriteFrame = module.SpriteFrame;
      SpriteAtlas = module.SpriteAtlas;
      Material = module.Material;
      Prefab = module.Prefab;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function () {}, function (module) {
      ResourceLoader = module.ResourceLoader;
    }],
    execute: function () {
      var _dec, _dec2, _class, _descriptor, _descriptor2, _temp, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _class3, _class4, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _class5, _temp2;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "73148WIoA9CY66/BV6EMjmD", "CommonAssets", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let KeySprite = exports('KeySprite', (_dec = property(CCString), _dec2 = property(SpriteFrame), (_class = (_temp = class KeySprite {
        constructor() {
          _initializerDefineProperty(this, "key", _descriptor, this);

          _initializerDefineProperty(this, "sprite", _descriptor2, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class.prototype, "key", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, "sprite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class)));
      let CommonAssets = exports('default', (_dec3 = ccclass('CommonAssets'), _dec4 = property(SpriteFrame), _dec5 = property(SpriteFrame), _dec6 = property(SpriteFrame), _dec7 = property(SpriteFrame), _dec8 = property([SpriteFrame]), _dec9 = property(SpriteFrame), _dec10 = property(SpriteAtlas), _dec11 = property(Material), _dec12 = property(Material), _dec13 = property(Prefab), _dec14 = property(Prefab), _dec15 = property(Prefab), _dec16 = property(SpriteFrame), _dec17 = property(SpriteFrame), _dec18 = property(Prefab), _dec19 = property(Prefab), _dec20 = property(Prefab), _dec21 = property(Prefab), _dec22 = property(SpriteFrame), _dec23 = property(SpriteFrame), _dec24 = property(SpriteFrame), _dec25 = property(SpriteFrame), _dec26 = property(SpriteFrame), _dec3(_class3 = (_class4 = (_temp2 = _class5 = class CommonAssets extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "avatar_default", _descriptor3, this);

          _initializerDefineProperty(this, "icon_coin", _descriptor4, this);

          _initializerDefineProperty(this, "icon_spin", _descriptor5, this);

          _initializerDefineProperty(this, "icon_shield", _descriptor6, this);

          _initializerDefineProperty(this, "icon_chest", _descriptor7, this);

          _initializerDefineProperty(this, "icon_pack", _descriptor8, this);

          _initializerDefineProperty(this, "atlas_symbol", _descriptor9, this);

          _initializerDefineProperty(this, "matGray", _descriptor10, this);

          _initializerDefineProperty(this, "matNormal", _descriptor11, this);

          _initializerDefineProperty(this, "pbAttack", _descriptor12, this);

          _initializerDefineProperty(this, "pbFix", _descriptor13, this);

          _initializerDefineProperty(this, "attackDragonBones", _descriptor14, this);

          _initializerDefineProperty(this, "pet_xpPotion", _descriptor15, this);

          _initializerDefineProperty(this, "pet_food", _descriptor16, this);

          _initializerDefineProperty(this, "energyPrefab", _descriptor17, this);

          _initializerDefineProperty(this, "coinPrefab", _descriptor18, this);

          _initializerDefineProperty(this, "xpPrefab", _descriptor19, this);

          _initializerDefineProperty(this, "foodPrefab", _descriptor20, this);

          _initializerDefineProperty(this, "jigsaw", _descriptor21, this);

          _initializerDefineProperty(this, "shop_tickets", _descriptor22, this);

          _initializerDefineProperty(this, "throwing_bomb", _descriptor23, this);

          _initializerDefineProperty(this, "throwing_ring", _descriptor24, this);

          _initializerDefineProperty(this, "throwing_magicGem", _descriptor25, this);

          _defineProperty(this, "rewardLoaded", false);
        }

        async loadRemotePrefab() {
          await Promise.all([// ResourceLoader.loadCommonPrefab("common/bomb"),
            // ResourceLoader.loadCommonPrefab("common/dunpai"),
            // ResourceLoader.loadCommonPrefab("common/dunpai02"),
            // ResourceLoader.loadCommonPrefab("common/dunpai03"),
            // ResourceLoader.loadCommonPrefab("common/dunpai_dog"),
            // ResourceLoader.loadCommonPrefab("common/baozha"),
            // ResourceLoader.loadCommonPrefab("common/smoke"),
            // ResourceLoader.loadCommonPrefab("common/fx_sleep"),
            // ResourceLoader.loadCommonPrefab("common/fx_sleep_01"),
            // ResourceLoader.loadCommonPrefab("pet/Pig"),
            // ResourceLoader.loadCommonPrefab("pet/Tiger"),
            // ResourceLoader.loadCommonPrefab("pet/Dog"),
            // ResourceLoader.loadCommonPrefab("pet/Rabbit"),
          ]); // this.bombPrefab = ResourceLoader.resMap.get("common/bomb");
          // this.shieldPrefab = ResourceLoader.resMap.get("common/dunpai");
          // this.timeShieldPrefab = ResourceLoader.resMap.get("common/dunpai02");
          // this.goldTimeShieldPrefab = ResourceLoader.resMap.get("common/dunpai03");
          // this.fxShieldPrefab = ResourceLoader.resMap.get("common/dunpai_dog");
          // this.boomPrefab = ResourceLoader.resMap.get("common/baozha");
          // this.smokePrefab = ResourceLoader.resMap.get("common/smoke");
          // this.fxSleepPrefab = ResourceLoader.resMap.get("common/fx_sleep");
          // this.fxSleep01Prefab = ResourceLoader.resMap.get("common/fx_sleep_01");
          // this.pigPrefab = ResourceLoader.resMap.get("pet/Pig");
          // this.tigerPrefab = ResourceLoader.resMap.get("pet/Tiger");
          // this.dogPrefab = ResourceLoader.resMap.get("pet/Dog");
          // this.rabbitPrefab = ResourceLoader.resMap.get("pet/Rabbit");
        }

        async loadRewards() {
          this.rewardLoaded = false;
          await Promise.all([ResourceLoader.loadCommonPrefab("reward/gold01", true), ResourceLoader.loadCommonPrefab("reward/gold02", true), ResourceLoader.loadCommonPrefab("reward/gold03", true), ResourceLoader.loadCommonPrefab("reward/gold04", true), ResourceLoader.loadCommonPrefab("reward/gold05", true), ResourceLoader.loadCommonPrefab("reward/gold06", true), ResourceLoader.loadCommonPrefab("reward/battery", true), ResourceLoader.loadCommonPrefab("reward/boom", true), ResourceLoader.loadCommonPrefab("reward/yaoshi", true), ResourceLoader.loadCommonPrefab("reward/dunpai", true), ResourceLoader.loadCommonPrefab("reward/shuibei", true)]);
          this.rewardLoaded = true;
        }

        onLoad() {
          CommonAssets.instance = this;
        }

        onDestroy() {
          CommonAssets.instance = null;
        }

        getByAtlas(atlas, name) {
          return this[atlas].getSpriteFrame(name);
        }

        getRewardItemIcon(itemIcon) {
          switch (itemIcon) {
            case "pet_xpPotion":
              return this.pet_xpPotion;

            case "pet_food":
              return this.pet_food;

            case "jigsaw-piece-gold":
              return this.jigsaw;

            case "shop_tickets_1":
              return this.shop_tickets;

            case "throwing_bombB":
              return this.throwing_bomb;

            case "throwing_ringB":
              return this.throwing_ring;

            case "throwing_magicGemB":
              return this.throwing_magicGem;
          }
        }

      }, _defineProperty(_class5, "instance", void 0), _defineProperty(_class5, "Atlases", {
        Item: "atlas_item",
        SlotSymbol: "atlas_symbol",
        ActivityItem: "atlas_activity_item"
      }), _temp2), (_descriptor3 = _applyDecoratedDescriptor(_class4.prototype, "avatar_default", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class4.prototype, "icon_coin", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class4.prototype, "icon_spin", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class4.prototype, "icon_shield", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class4.prototype, "icon_chest", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class4.prototype, "icon_pack", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class4.prototype, "atlas_symbol", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class4.prototype, "matGray", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class4.prototype, "matNormal", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class4.prototype, "pbAttack", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class4.prototype, "pbFix", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class4.prototype, "attackDragonBones", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class4.prototype, "pet_xpPotion", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class4.prototype, "pet_food", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class4.prototype, "energyPrefab", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class4.prototype, "coinPrefab", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class4.prototype, "xpPrefab", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class4.prototype, "foodPrefab", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class4.prototype, "jigsaw", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class4.prototype, "shop_tickets", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class4.prototype, "throwing_bomb", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class4.prototype, "throwing_ring", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class4.prototype, "throwing_magicGem", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class4)) || _class3));
      window["CommonAssets"] = CommonAssets;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/audioEngine.ts", ['cc', './SoundManager.ts'], function (exports) {
  'use strict';

  var cclegacy, SoundManager;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      SoundManager = module.SoundManager;
    }],
    execute: function () {
      exports('audioEngine', void 0);

      cclegacy._RF.push({}, "734dbvPN81F8ZU2EXCfmO6N", "audioEngine", undefined);

      let audioEngine;

      (function (_audioEngine) {
        let _id2audio = [];
        let AudioState;

        (function (AudioState) {
          AudioState[AudioState["INITIALIZING"] = 0] = "INITIALIZING";
          AudioState[AudioState["PLAYING"] = 1] = "PLAYING";
          AudioState[AudioState["STOPPED"] = 2] = "STOPPED";
        })(AudioState || (AudioState = {}));

        _audioEngine.AudioState = AudioState;

        function stopAll() {
          _id2audio.forEach(clip => {
            clip.pause();
          });
        }

        _audioEngine.stopAll = stopAll;

        function playOneShot(clip, loop, volume) {
          clip.setLoop(loop);
          clip.setVolume(volume);
          clip.playOneShot(volume);
          _id2audio[_id2audio.length] = clip;
          return _id2audio.length - 1;
        }

        _audioEngine.playOneShot = playOneShot;

        function play(clip, loop, volume) {
          clip.setLoop(loop);
          clip.setVolume(volume);
          clip.play();
          _id2audio[_id2audio.length] = clip;
          return _id2audio.length - 1;
        }

        _audioEngine.play = play;

        function stop(audioId) {
          return _id2audio[audioId] && _id2audio[audioId].stop();
        }

        _audioEngine.stop = stop;

        function pauseAll() {
          Object.keys(SoundManager.SECache).forEach(key => {
            let audioClip = SoundManager.SECache[key];
            audioClip && audioClip.pause();
          });
        }

        _audioEngine.pauseAll = pauseAll;

        function resumeAll() {//TODO
          // Object.keys(SoundManager.SECache).forEach((key) => {
          //     let audioClip: cc.AudioClip = SoundManager.SECache[key];
          //     audioClip.getCurrentTime();
          // })
        }

        _audioEngine.resumeAll = resumeAll;

        function getState(audioId) {
          return _id2audio[audioId] && _id2audio[audioId].state;
        }

        _audioEngine.getState = getState;

        function setLoop(audioId, loop) {
          return _id2audio[audioId] && _id2audio[audioId].setLoop(loop);
        }

        _audioEngine.setLoop = setLoop;

        function setCurrentTime(audioId, time) {
          return _id2audio[audioId] && _id2audio[audioId].setCurrentTime(time);
        }

        _audioEngine.setCurrentTime = setCurrentTime;

        function getDuration(audioId) {
          return _id2audio[audioId] && _id2audio[audioId].getDuration();
        }

        _audioEngine.getDuration = getDuration;

        function setFinishCallback(audioId, callback) {
          _id2audio[audioId] && _id2audio[audioId].on('ended', callback);
        }

        _audioEngine.setFinishCallback = setFinishCallback;
      })(audioEngine || (audioEngine = exports('audioEngine', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserInfoModel.ts", ['cc', './Constant.ts', './CCE_Component.ts', './EnergyFullAnim.ts', './CCEaseTypes.ts', './global.ts', './_app.ts', './CommonAssets.ts', './GameEvent.ts', './NumAnim.ts', './ShopWindow.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, Button, Node, _decorator, SpriteFrame, UITransform, LabelOutline, color, tween, Vec3, Tween, LoadEvent, MyCustomEvent, CCE_Component, EnergyFullAnim, CCEaseTypes, G, cce, CommonAssets, GameEvent, NumAnim, ShopWindow, Game, LogEventWrap, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      Button = module.Button;
      Node = module.Node;
      _decorator = module._decorator;
      SpriteFrame = module.SpriteFrame;
      UITransform = module.UITransform;
      LabelOutline = module.LabelOutline;
      color = module.color;
      tween = module.tween;
      Vec3 = module.Vec3;
      Tween = module.Tween;
    }, function (module) {
      LoadEvent = module.LoadEvent;
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      EnergyFullAnim = module.default;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      GameEvent = module.GameEvent;
    }, function (module) {
      NumAnim = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "736c1zrCehNJ7xLcMSsTRpv", "UserInfoModel", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let UserInfoModel = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Sprite), _dec4 = property(EnergyFullAnim), _dec5 = property(Button), _dec6 = property(Label), _dec7 = property(Button), _dec8 = property(Sprite), _dec9 = property(Label), _dec10 = property([Node]), _dec11 = property(Node), ccclass(_class = (_class2 = (_temp = class UserInfoModel extends CCE_Component {
        static SetAvatar(sprite, User) {
          if (sprite == null) return;

          try {
            let avatar = User.Avatar();
            sprite["_avatar"] = avatar;
            sprite.spriteFrame = CommonAssets.instance.avatar_default;

            if (avatar != null && avatar.length > 0) {
              cce.loaderLoad({
                url: avatar,
                type: "jpg"
              }, (err, tex) => {
                if (err == null && tex != null) {
                  // && sprite._avatar == tex._rawUrl
                  let sp = new SpriteFrame();
                  sp.texture = tex;
                  var spriteFrame = sp;

                  if (sprite.node) {
                    const uiTransform = sprite.node.getComponent(UITransform); // sp.width = uiTransform.width;

                    sp.originalSize = uiTransform.contentSize;
                    sprite.spriteFrame = spriteFrame;
                    eventCenter.emit(LoadEvent.UserAvatarLoaded);
                  }
                }
              }, true);
            }
          } catch (e) {}
        }

        static SetName(labelName, User) {
          labelName.string = User.Name();
          if (labelName.node._old_color) labelName.node.color = labelName.node._old_color;
          let outline = labelName.getComponent(LabelOutline);
          if (outline && outline._old_color) outline.color = outline._old_color;

          if (User.IsVip()) {
            labelName.node._old_color = labelName.node.color;
            labelName.node.color = color("#ffbf13");
            let outline = labelName.getComponent(LabelOutline);

            if (outline) {
              outline._old_color = outline.color;
              outline.color = color(0, 0, 0);
            }
          } else {
            labelName.node.color = color("#ffffff");
          }

          labelName.node.active = !labelName.node.active;
          labelName.node.active = !labelName.node.active;
        }

        constructor() {
          super();

          _defineProperty(this, "currentShowAp", void 0);

          _defineProperty(this, "User", void 0);

          _initializerDefineProperty(this, "avatarSprite", _descriptor, this);

          _initializerDefineProperty(this, "labelName", _descriptor2, this);

          _initializerDefineProperty(this, "spriteApFull", _descriptor3, this);

          _initializerDefineProperty(this, "energyFullAnim", _descriptor4, this);

          _initializerDefineProperty(this, "btnApAdd", _descriptor5, this);

          _initializerDefineProperty(this, "labelCoin", _descriptor6, this);

          _initializerDefineProperty(this, "btnCoinAdd", _descriptor7, this);

          _initializerDefineProperty(this, "spriteCoin", _descriptor8, this);

          _initializerDefineProperty(this, "labelStar", _descriptor9, this);

          _initializerDefineProperty(this, "shields", _descriptor10, this);

          _initializerDefineProperty(this, "spVip", _descriptor11, this);

          _defineProperty(this, "isSelf", void 0);

          _defineProperty(this, "genderMale", void 0);

          _defineProperty(this, "genderFemale", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);

          _defineProperty(this, "hiden", void 0);

          _defineProperty(this, "apStop", void 0);

          _defineProperty(this, "apRemainTime", void 0);

          _defineProperty(this, "showAp", void 0);

          _defineProperty(this, "_userOldCoin", 0);

          this.currentShowAp = 0;
        }

        updateShowAp() {} // use this for initialization


        onLoad() {}

        show(user) {
          if (user == null) return;
          this.User = user;
          this.isSelf = user === Game.SUser;
          this._userOldCoin = this.User.Coin();

          if (this.avatarSprite) {
            UserInfoModel.SetAvatar(this.avatarSprite, this.User);
          }

          if (this.labelName) {
            this.labelName.string = this.User.Name();
          } //TODO
          // if (this.genderMale) this.genderMale.active = user.Gender === User.Genders.Male;
          // if (this.genderFemale) this.genderFemale.active = user.Gender === User.Genders.genderFemale;


          this.setCoin();
          this.setStar();
          this.setShield();
          this.setVip();
        } // called every frame


        slowUpdate(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();

          let _t = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;

          this.lastUpdateTime = cTime;
        }

        onClose() {
          this.closeCoin();
          this.closeStar();
          this.closeShield();
          this.closeVip();
        } //Coin


        setCoin() {
          this.updateCoin();

          if (this.labelCoin && this.isSelf) {
            GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.CoinEvent, this.uuid, msg => {
              this.updateCoin(msg);
            });
          }

          if (this.btnCoinAdd) {
            this.btnCoinAdd.node.on("click", () => {
              if (homeView.isBusy()) return;
              homeView.pageViewController.moveToPage(G.Pages.Shop, true);
              homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.coin);
              LogEventWrap.logEvent("openshop_coin");
            }, this);
          }
        }

        closeCoin() {
          if (this.labelCoin && this.isSelf) {
            GameKit.WebEvent.UnRegisterEvent(GameKit.WebEvent.EventName.CoinEvent, this.uuid);
          }
        }

        updateCoin(msg) {
          if (msg) {
            if (msg.oldCoin && msg.coin) {
              eventCenter.once(MyCustomEvent.ReadyChangeCoin, () => {
                this.changeCoin(msg.oldCoin, msg.coin, 0.8, () => {});
                this._userOldCoin = msg.coin;
              });
            } else if (this._userOldCoin < this.User.Coin()) {
              eventCenter.once(MyCustomEvent.ReadyChangeCoin, () => {
                this.changeCoin(this._userOldCoin, this.User.Coin(), 0.8, () => {});
                this._userOldCoin = this.User.Coin();
              });
            } else {
              if (this.labelCoin) this.labelCoin.string = GameKit.StringUtil.formatNumber(this.User.Coin());
              this._userOldCoin = this.User.Coin();
            }
          } else {
            if (this.labelCoin) this.labelCoin.string = GameKit.StringUtil.formatNumber(this.User.Coin());
            this._userOldCoin = this.User.Coin();
          }
        }

        changeCoin(from, to, duration, cb) {
          if (from == to) return;

          if (this.labelCoin) {
            if (this.labelCoin.getComponent(NumAnim) == null) {
              let na = this.labelCoin.addComponent(NumAnim);
              na.targetLabel = this.labelCoin;
            }

            this.labelCoin.getComponent(NumAnim).playAnim(from, to, duration);
          }

          if (this.spriteCoin && duration > 0) {
            tween(this.spriteCoin.node).sequence(tween().to(0.1, {
              scale: new Vec3(1.2, 1.2, 1.2)
            }), tween().to(0.1, {
              scale: Vec3.ONE
            })).repeatForever().start();
            tween(this.spriteCoin.node).delay(duration).call(() => {
              Tween.stopAllByTarget(this.spriteCoin.node);
              this.spriteCoin.node.setScale(Vec3.ONE);
              cb && cb();
            }).start();
          }
        } //Star


        setStar() {
          this.updateStar();

          if (this.labelStar && this.isSelf) {
            GameEvent.RegisterEvent(GameEvent.EventName.StarEvent, this.uuid, () => {
              this.updateStar();
            });
            GameEvent.RegisterEvent(GameEvent.EventName.ServantEvent, this.uuid, () => {
              this.updateStar();
            });
          }
        }

        closeStar() {
          if (this.labelStar && this.isSelf) {
            GameEvent.UnRegisterEvent(GameEvent.EventName.StarEvent, this.uuid);
          }
        }

        updateStar() {
          if (this.labelStar) this.labelStar.string = this.User.Star().toString();
        }

        setShield() {
          this.updateShield();

          if (this.shields.length == 3 && this.isSelf) {
            GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ShieldEvent, this.uuid, () => {
              this.updateShield();
            });
          }
        }

        closeShield() {
          if (this.shields.length == 3 && this.isSelf) {
            GameKit.WebEvent.UnRegisterEvent(GameKit.WebEvent.EventName.ShieldEvent, this.uuid);
          }
        }

        updateShield() {
          if (this.shields.length == 3 && this.isSelf) {
            for (var i = 0; i < 3; i++) {
              if (i < this.User.RawShield()) {
                this.shields[i].active = true;
              } else {
                this.shields[i].active = false;
              }
            }
          }
        }

        setShieldWithNum(num) {
          if (this.shields.length == 3 && this.isSelf) {
            for (var i = 0; i < 3; i++) {
              if (i < num) {
                this.shields[i].active = true;
              } else {
                this.shields[i].active = false;
              }
            }
          }
        } // 只能增加


        changeShield(from, to, td) {
          if (this.shields.length == 3 && this.isSelf) {
            for (var i = from; i < to; i++) {
              let shield = this.shields[i];
              shield.scaleX = 0;
              shield.scaleY = 0;
              shield.active = true;
              let seq = ccAction.sequence(ccAction.delayTime((i - from) * td + 1.3), ccAction.scaleTo(0.2, 1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
              shield.runAction(seq);
            }
          }
        }

        setVip() {
          this.updateVip();

          if (this.isSelf) {
            GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.StatusEvent, this.uuid, () => {
              this.updateVip();
            });
          }
        }

        updateVip() {
          if (this.spVip) this.spVip.active = !!this.User.IsVip();

          if (this.labelName) {
            UserInfoModel.SetName(this.labelName, this.User);
          }
        }

        closeVip() {
          if (this.isSelf) {
            GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.StatusEvent, this.uuid);
          }
        }

        Flush() {
          this.updateCoin();
          this.updateShield();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "avatarSprite", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spriteApFull", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "energyFullAnim", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btnApAdd", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelCoin", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "btnCoinAdd", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spriteCoin", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "labelStar", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "shields", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "spVip", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivitySpecialOfferWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './Content.ts', './LocalizedManager.ts', './PaySuccessWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, SoundManager, UIWindow, Content, rigisterLabel, PaySuccessWindow, UIRoot, ActivityManager, Meta, LogEventWrap, PaymentWrap, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "75109MeqgpKC6YxPRamPLdy", "ActivitySpecialOfferWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivitySpecialOfferWindow = exports('ActivitySpecialOfferWindow', (_dec = property(Label), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class ActivitySpecialOfferWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelTimer", _descriptor, this);

          _initializerDefineProperty(this, "labelCoin", _descriptor2, this);

          _initializerDefineProperty(this, "labelSpin", _descriptor3, this);

          _initializerDefineProperty(this, "labelOff", _descriptor4, this);

          _initializerDefineProperty(this, "labelPrice", _descriptor5, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "shopMeta", void 0);

          _defineProperty(this, "leftTime", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.meta.ShopId());
          let contents = this.shopMeta.Content().Contents();
          contents.forEach(x => {
            if (x.Type() === Content.Types.Ap) {
              this.labelSpin.string = String.format(i18n.t("ActivitySpecialOfferSpin"), x.Count());
            } else if (x.Type() === Content.Types.Coin) {
              this.labelCoin.string = String.format(i18n.t("ActivitySpecialOfferCoin"), BigNumber.format(x.Count()));
            }
          });
          this.labelOff.string = String.format(i18n.t("OffText"), Math.round(this.shopMeta.Off() * 100));
          rigisterLabel("OffText", this.labelOff, Math.round(this.shopMeta.Off() * 100));
          this.labelPrice.string = this.shopMeta.PriceString();
          this.leftTime = 0;
          this.slowUpdate(0);
        }

        slowUpdate(arg) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = 0;
            this.leftTime = this.meta.UserTime() - currentTime + ActivityManager.GetLocalData()[this.meta.Id()].startTime;
            this.labelTimer.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        close_window() {
          this.closeAnim();
        }

        callBuy() {
          PaymentWrap.Pay(this.shopMeta.Name(), function (ok) {
            if (ok) {
              this.closeAnim();
              ActivityManager.disableLocalActivity(this.meta.Id());
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "pack"
              });
              SoundManager.playSound("item_purchased");
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "pack",
                name: this.shopMeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "pack",
                name: this.shopMeta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "pack",
            name: this.shopMeta.Name(),
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/NewActivitySpecialOfferWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelCoin", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelSpin", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelOff", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelPrice", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CCLabelMaxLines.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Label, RichText, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Label = module.Label;
      RichText = module.RichText;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2;

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "75b69M9euJPTYnWALoE5Wa2", "CCLabelMaxLines", undefined);

      const {
        ccclass,
        property,
        executeInEditMode,
        menu
      } = _decorator;
      let CCLabelMaxLines = exports('default', (_dec = menu("GameKit/extentions/CCLabelMaxLines"), _dec2 = property({
        range: [0, Number.MAX_VALUE, 1]
      }), _dec3 = property({
        readonly: true,
        animatable: false,
        displayName: 'Actual Font Size',
        tooltip: CC_DEV && 'i18n:COMPONENT.label.actualFontSize'
      }), ccclass(_class = _dec(_class = executeInEditMode(_class = (_class2 = class CCLabelMaxLines extends CCE_Component {
        set maxLines(value) {
          this.setLines();
        }

        get maxLines() {
          return 0;
        }

        get actualFontSize() {
          let label = this.getComponent(Label);

          if (label) {
            return label.actualFontSize || 0;
          }

          let richText = this.getComponent(RichText);

          if (richText) {
            //new api, 先替换下
            // return richText.actualFontSize || 0
            return richText.fontSize || 0;
          }

          return 0;
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.setLines();
        }

        start() {}

        setLines() {
          let label = this.getComponent(Label);

          if (label) {
            //现在creator.d.ts中新加入一个属性
            label.maxLines = this.maxLines;
          }

          let richText = this.getComponent(RichText);

          if (richText) {
            richText.maxLines = this.maxLines;
          }
        }

      }, (_applyDecoratedDescriptor(_class2.prototype, "maxLines", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "maxLines"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "actualFontSize", [_dec3], Object.getOwnPropertyDescriptor(_class2.prototype, "actualFontSize"), _class2.prototype)), _class2)) || _class) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ControllerTable.ts", ['cc', './CCE_Component.ts', './Item.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, CCE_Component, Item;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      Item = module.Item;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "76c59TTFVVE1ZeV0zZjMXS1", "ControllerTable", undefined);

      const {
        ccclass,
        property,
        menu
      } = _decorator; // @ccclass
      // class Item {
      //     @property(cc.CCString)
      //     key: string = "";
      //     @property({
      //         type: Item,
      //         override: true,
      //     })
      //     node:cc.Node = null;
      // }

      let ControllerTable = exports('default', (_dec = menu("GameKit/ui/ControllerTable"), _dec2 = property([Node]), _dec3 = property([Item]), ccclass(_class = _dec(_class = (_class2 = (_temp = class ControllerTable extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "controllers", _descriptor, this);

          _initializerDefineProperty(this, "keyControllers", _descriptor2, this);

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "nodes", void 0);
        }

        static GetNode(root, name) {
          return root.getComponent(ControllerTable).getNode(name);
        }

        static GetComponent(root, name, comp) {
          return root.getComponent(ControllerTable).getNode(name).getComponent(comp);
        }

        init() {
          if (this.inited) return;
          this.nodes = {};
          this.controllers.forEach(function (con) {
            if (con != null) this.nodes[con.name] = con;
          }.bind(this)); // this.keys.forEach((key, index) =>{
          //     if(key && this.keyscontrollers[index]){
          //         this.nodes[key] = this.keyscontrollers[index];
          //     }
          // })

          this.keyControllers.forEach((con, index) => {
            if (con !== null) {
              this.nodes[con.key] = con.node;
            }
          });
          this.inited = true;
        }

        getNode(name) {
          this.init();
          return this.nodes[name];
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "controllers", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "keyControllers", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ClockUtil.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('ClockUtil', void 0);

      cclegacy._RF.push({}, "78201Uct7hG6ayU87h+HPUt", "ClockUtil", undefined);

      let ClockUtil;

      (function (_ClockUtil) {
        let _data = {};
        let intervalID;

        function Clear() {
          _data = {};

          if (intervalID) {
            clearInterval(intervalID);
            intervalID = null;
          }
        }

        _ClockUtil.Clear = Clear;

        function init() {
          var TimeUtil = GameKit.TimeUtil;

          var callb = () => {
            let ctime = TimeUtil.FormatTime();
            let hour = ctime.hour;
            let minute = ctime.minute;

            for (let key in _data) {
              let d = _data[key];

              if (d.hour == hour && d.minute == minute) {
                if (d.callback) d.callback();
              }
            }
          };

          setTimeout(() => {
            intervalID = setInterval(() => {
              callb();
            }, TimeUtil.MinuteInSecond * 1000);
            callb();
          }, (TimeUtil.MinuteInSecond - TimeUtil.FormatTime().second) * 1000 + 300);
        }

        _ClockUtil.init = init;

        function RegisterClock(key, hour, minute, callback) {
          _data[key] = {
            key: key,
            hour: hour,
            minute: minute,
            callback: callback
          };
        }

        _ClockUtil.RegisterClock = RegisterClock;

        function UnRegister(key) {
          _data[key] = null;
          delete _data[key];
        }

        _ClockUtil.UnRegister = UnRegister;
      })(ClockUtil || (ClockUtil = exports('ClockUtil', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CommunityFriendItem.ts", ['cc', './CardNewFriendItem.ts', './UIRoot.ts', './CardSelectCardWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, CardNewFriendItem, UIRoot, CardSelectCardWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      CardNewFriendItem = module.CardNewFriendItem;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      CardSelectCardWindow = module.default;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "782adqWiCxF15JZz+Qh4br7", "CommunityFriendItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CommunityFriendItem = exports('CommunityFriendItem', (_dec = ccclass('CommunityFriendItem'), _dec(_class = (_temp = class CommunityFriendItem extends CardNewFriendItem {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_parent", void 0);
        }

        setItem(friendData, cardMeta, parent) {
          this._parent = parent;
          super.setItem(friendData, cardMeta, parent);
        }

        onSendBtnClick() {
          if (this._parent.oneItemClicked) return;
          this._parent.oneItemClicked = true;
          UIRoot.instance.openChildWindow(CardSelectCardWindow, {
            friend_userid: this._friendData.UserId(),
            default_card_meta_id: this._cardMeta ? this._cardMeta.Id() : null,
            showCallback: window => {
              window.addOnCloseFunc(() => {
                this._parent.oneItemClicked = false;
                this.closeAnim();
              });
            }
          });
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PetStateGetUp.ts", ['cc', './PetStateMachine.ts', './PetStateFollowing.ts'], function (exports) {
  'use strict';

  var cclegacy, PetStateMachine, PetStateFollowing;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      PetStateMachine = module.default;
    }, function (module) {
      PetStateFollowing = module.default;
    }],
    execute: function () {
      cclegacy._RF.push({}, "79480IHw2pIlaO82kclRBGa", "PetStateGetUp", undefined);

      class PetStateGetUp extends PetStateMachine {
        onEnter() {
          this.context.changeStateFromRestToIdle(() => {
            this.context.transitionTo(new PetStateFollowing());
          });
        }

        onExit() {}

        customUpdate(dt) {}

      }

      exports('default', PetStateGetUp);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivityBadge.ts", ['cc', './CCE_Component.ts', './Logs.ts', './_app.ts', './CCTools.ts', './GameMainWindow.ts', './UIRoot.ts', './ActivityManager.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, CCBoolean, _decorator, Sprite, SpriteFrame, UITransform, CCE_Component, Logs, cce, CCTools, GameMainWindow, UIRoot, ActivityManager, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
      UITransform = module.UITransform;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      CCTools = module.CCTools;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "79fc3peHJ9F15qKbyi8iueW", "ActivityBadge", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivityBadge = exports('default', (_dec = property(Node), _dec2 = property(Label), _dec3 = property(CCBoolean), ccclass(_class = (_class2 = (_temp = class ActivityBadge extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "btn", _descriptor, this);

          _initializerDefineProperty(this, "labelCountDown", _descriptor2, this);

          _initializerDefineProperty(this, "isleft", _descriptor3, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "leftTime", void 0);
        }

        setMeta(meta) {
          this.meta = meta;

          if (this.btn) {
            this.btn.on("click", function () {
              let icon_goto = this.meta.IconGoto();

              if (icon_goto == "panel") {
                UIRoot.instance.openChildWindow(this.meta.Panel(), {
                  meta: this.meta
                });
              } else if (icon_goto == "window") {
                this.meta.Panel().Show(this.meta);
              } else {
                UIRoot.instance.openChildWindow(icon_goto, {
                  meta: this.meta
                });
              }
            }.bind(this), this);
          }

          if (this.labelCountDown) {
            this.leftTime = 0;
            this.slowUpdate(0);
          }

          let icon = this.meta.Icon();
          let metaParam = this.meta.Param();

          if (icon && icon.startsWith("http")) {
            cce.loaderLoad({
              url: icon,
              type: "png"
            }, (err, v) => {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.btn || !this.node) return;
              let sprite = this.btn.getComponent(Sprite);
              if (!sprite) return;
              let sp = new SpriteFrame();
              sp.texture = v;
              sprite.spriteFrame = sp;
              CCTools.ResizeSprite(sprite);
              this.btn.x = this.btn.width / 2;
              this.btn.y = -this.btn.height / 2;
              this.node.getComponent(UITransform).height = this.btn.height + 15;
              CCTools.SetNodeByParam(this.labelCountDown, metaParam.badgeTime);
              if (GameMainWindow.instance) homeView.slotPage.SetActivityBadge(this);
            });
          }
        }

        slowUpdate(dt) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();

            if (this.meta.IsUserTime()) {
              this.leftTime = this.meta.UserTime() - currentTime + ActivityManager.GetLocalData()[this.meta.Id()].startTime;
            } else {
              this.leftTime = this.meta.EndTime() - currentTime;
            }

            this.labelCountDown.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              ActivityManager.ActivityOver(this.meta.Id());
              this.leftTime = null;
            }
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "btn", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelCountDown", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "isleft", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return true;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NativeWrap.ts", ['cc', './global.ts', './SdkManager.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, game, G, SdkManager, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      game = module.game;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('NativeWrap', void 0);

      cclegacy._RF.push({}, "7baf0JN34tG0o26HLO12X+7", "NativeWrap", undefined);

      let NativeWrap;

      (function (_NativeWrap) {
        const callbacks = _NativeWrap.callbacks = {};
        const timeoutIds = _NativeWrap.timeoutIds = {};
        const index = _NativeWrap.index = 0;
        const noIndexCall = _NativeWrap.noIndexCall = ["SDKHandleClassgetQuery"];

        function init() {
          this.callbacks = {};
          this.timeoutIds = {};
        }

        _NativeWrap.init = init;

        function call(className, method, param, callback, waitTime = 0) {
          param = param || {};
          param.callId = className + method + this.index.toString();
          if (NativeWrap.noIndexCall[0].contains(className + method)) param.callId = className + method;
          this.index++;
          this.callbacks[param.callId] = callback;

          if (SdkManager.IsNative() && SdkManager.IsIos()) {
            try {
              jsb.reflection.callStaticMethod(className.replace(/\//g, ""), method + ":", JSON.stringify(param));
            } catch (e) {
              param.success = false;
              NativeWrap.nativeClientCall(JSON.stringify(param));
            }
          } else if (SdkManager.IsNative() && SdkManager.IsAndroid()) {
            try {
              jsb.reflection.callStaticMethod(G.Constance.AndroidBundleCall + className, method, "(Ljava/lang/String;)V", JSON.stringify(param));
            } catch (e) {
              param.success = false;
              NativeWrap.nativeClientCall(JSON.stringify(param));
            }
          }

          if (waitTime > 0) {
            this.timeoutIds[param.callId] = setTimeout(() => {
              param.success = false;
              NativeWrap.nativeClientCall(JSON.stringify(param));
            }, waitTime * 1000);
          }
        }

        _NativeWrap.call = call;

        function callDirect(className, method, param) {
          param = param || {};

          if (SdkManager.IsNative() && SdkManager.IsIos()) {
            try {
              return jsb.reflection.callStaticMethod(className.replace(/\//g, ""), method + ":", JSON.stringify(param));
            } catch (e) {}
          } else if (SdkManager.IsNative() && SdkManager.IsAndroid()) {
            try {
              var result = jsb.reflection.callStaticMethod(G.Constance.AndroidBundleCall + className, method, "(Ljava/lang/String;)Ljava/lang/String;", JSON.stringify(param));
              return JSON.parse(result).value;
            } catch (e) {}
          }

          return null;
        }

        _NativeWrap.callDirect = callDirect;

        function nativeClientCall(paramStr) {
          if (!paramStr) return;
          let param = JSON.parse(paramStr);
          if (!param || !param.callId) return;
          let callback = NativeWrap.callbacks[param.callId];
          if (callback) callback(param);
          NativeWrap.callbacks[param.callId] = null;

          if (NativeWrap.timeoutIds[param.callId] != null) {
            clearTimeout(NativeWrap.timeoutIds[param.callId]);
            NativeWrap.timeoutIds[param.callId] = null;
          }
        }

        _NativeWrap.nativeClientCall = nativeClientCall;

        function getVersion() {
          return "0"; // return NativeWrap.callDirect("SDKHandleClass", "GetVersion") || "0";
        }

        _NativeWrap.getVersion = getVersion;

        function isReview() {
          return GameKit.StringUtil.VersionOver(NativeWrap.getVersion(), G.GameConfig.review_max_version) > 0;
        }

        _NativeWrap.isReview = isReview;

        function hasNewVersion() {
          return GameKit.StringUtil.VersionOver(G.GameConfig.max_version, NativeWrap.getVersion()) > 0;
        }

        _NativeWrap.hasNewVersion = hasNewVersion;

        function mustUpdateNewVersion() {
          return GameKit.StringUtil.VersionOver(NativeWrap.getVersion(), G.GameConfig.min_version) < 0;
        }

        _NativeWrap.mustUpdateNewVersion = mustUpdateNewVersion;

        function openComment() {
          let appId = "";
          if (SdkManager.IsIos()) appId = G.GameConfig.appleId;
          return NativeWrap.call("SDKHandleClass", "OpenComment", {
            appId: appId
          });
        }

        _NativeWrap.openComment = openComment;

        function openMarket() {
          let appId = "";
          if (SdkManager.IsIos()) appId = G.GameConfig.appleId;
          return NativeWrap.call("SDKHandleClass", "LaunchMarket", {
            appId: appId
          });
        }

        _NativeWrap.openMarket = openMarket;

        function deleteHotFolder() {
          var hotUpdateSearchPaths = localStorage.getItem('HotUpdateSearchPaths');

          if (hotUpdateSearchPaths) {
            var paths = JSON.parse(hotUpdateSearchPaths);
            jsb.fileUtils.setSearchPaths(paths); // var fileList = [];
            // var storagePath = paths[0] || '';
            // var tempPath = storagePath + '_temp/';
            // var baseOffset = tempPath.length;

            paths.forEach(path => {
              if (path && jsb.fileUtils.isDirectoryExist(path)) {
                jsb.fileUtils.removeDirectory(path);
              }
            }); // if (jsb.fileUtils.isDirectoryExist(tempPath)) {
            // 	jsb.fileUtils.listFilesRecursively(tempPath, fileList);
            // 	console.log(fileList);
            // 	fileList.forEach(srcPath => {
            // 	    var relativePath = srcPath.substr(baseOffset);
            // 	    var dstPath = storagePath + relativePath;
            // 	    if (srcPath[srcPath.length] == '/') {
            // 	        jsb.fileUtils.createDirectory(dstPath)
            // 	    }
            // 	    else {
            // 	        if (jsb.fileUtils.isFileExist(dstPath)) {
            // 	            jsb.fileUtils.removeFile(dstPath)
            // 	        }
            // 	        // jsb.fileUtils.renameFile(srcPath, dstPath);
            // 	    }
            // 	})
            // 	jsb.fileUtils.removeDirectory(tempPath);
            // }

            localStorage.setItem('HotUpdateSearchPaths', "");
          }

          game.pause();
        }

        _NativeWrap.deleteHotFolder = deleteHotFolder;
      })(NativeWrap || (NativeWrap = exports('NativeWrap', {})));

      Reflect.defineProperty(globalThis, "NativeWrap", {
        value: NativeWrap
      }); // window["NativeWrap"] = NativeWrap;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MainTutorialFinishWindow.ts", ['cc', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "7c0a382li5F9oGIsuGAHHfR", "MainTutorialFinishWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let MainTutorialFinishWindow = exports('MainTutorialFinishWindow', ccclass(_class = (_temp = _class2 = class MainTutorialFinishWindow extends UIWindow {
        close_window() {
          this.closeAnim();
        }

      }, _defineProperty(_class2, "windowPath", "Other/MainTutorialFinishWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotPeter.ts", ['cc', './CCE_Component.ts', './Content.ts', './GetRewardWindow.ts', './SR.ts', './UIRoot.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, dragonBones, _decorator, Animation, v3, CCE_Component, Content, GetRewardWindow, SR, UIRoot, ADWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      dragonBones = module.dragonBones;
      _decorator = module._decorator;
      Animation = module.Animation;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      GetRewardWindow = module.GetRewardWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "7c781Rx0ORJvJpHjYqC77Hq", "SlotPeter", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotPeter = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Label), _dec4 = property(dragonBones.ArmatureDisplay), ccclass(_class = (_class2 = (_temp = class SlotPeter extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "bird", _descriptor, this);

          _initializerDefineProperty(this, "bubble", _descriptor2, this);

          _initializerDefineProperty(this, "labelMsg", _descriptor3, this);

          _initializerDefineProperty(this, "dbBird", _descriptor4, this);

          _defineProperty(this, "birdAnimation", void 0);

          _defineProperty(this, "adPrepared", void 0);

          _defineProperty(this, "adShowI", void 0);

          _defineProperty(this, "i18nKey", void 0);

          _defineProperty(this, "fly_come_i", void 0);

          _defineProperty(this, "_isGetReward", false);
        }

        init() {
          this.birdAnimation = this.bird.getComponent(Animation);
          this.bird.active = false;
          this.bubble.active = false;
          this.adPrepared = false;
        }

        StartActive() {
          this.ShowAd();
        }

        ShowAd() {
          let peterAdTime = GameKit.PlayerPrefs.GetInt("peterAdTime", 0);

          if (GameKit.TimeUtil.getCurrentTime() < peterAdTime) {
            this.scheduleOnce(() => {
              this.ShowAd();
            }, peterAdTime - GameKit.TimeUtil.getCurrentTime() + 5);
            return;
          }

          if (this.adShowI) {
            clearInterval(this.adShowI);
            this.adShowI = null;
          }

          var _showAd = () => {
            if (!GameKit.DataCache.GetData("ADTipsBubblePopup") && ADWrap.IsVideoPrepared()) {
              clearInterval(this.adShowI);
              this.adShowI = null;
              GameKit.DataCache.SetData("ADTipsBubblePopup", true);
              this.i18nKey = "SlotPeterDesAd";
              this.labelMsg.string = i18n.t(this.i18nKey);
              this.bird.active = true;
              this.dbBird.playAnimation("fly", 0);
              this.birdAnimation.play("fly_come");

              if (this.fly_come_i) {
                clearInterval(this.fly_come_i);
                this.fly_come_i = null;
              }

              this.fly_come_i = setInterval(() => {
                var _this$birdAnimation$g;

                if (!this.node) return;

                if (((_this$birdAnimation$g = this.birdAnimation.getState("fly_come")) === null || _this$birdAnimation$g === void 0 ? void 0 : _this$birdAnimation$g.time) >= 6.18) {
                  clearInterval(this.fly_come_i);
                  this.fly_come_i = null;
                  this.dbBird.once(dragonBones.EventObject.COMPLETE, event => {}, this);
                  this.dbBird.playAnimation("fly_idle", 1);
                  this.dbBird.playAnimation("idle", 0);
                  setTimeout(() => {
                    if (!this.node) return;
                    this.bubble.active = true;
                    this.bubble.stopAllActions();
                    this.bubble.scale = v3(0.001, 0.001, 1);
                    this.bubble.runAction(ccAction.scaleTo(0.15, 1, 1));
                    this.adPrepared = true;
                    this.scheduleOnce(() => {
                      if (!this.node) return;
                      if (this._isGetReward) return;

                      if (this.adPrepared) {
                        this.ShowAway();
                        this.scheduleOnce(() => {
                          this.ShowAd();
                        }, 30);
                        GameKit.PlayerPrefs.SetInt("peterAdTime", GameKit.TimeUtil.getCurrentTime() + 300);
                      }
                    }, 10);
                  }, 500);
                }
              }, 100);
            }
          };

          this.adShowI = setInterval(() => {
            _showAd();
          }, 3000);

          _showAd();
        }

        ShowAway() {
          if (!this.node) return;
          this.dbBird.playAnimation("idle_fly", 1);
          this.dbBird.playAnimation("fly", 0);
          this.bubble.stopAllActions();
          this.bubble.active = false;
          this.adPrepared = false;
          GameKit.DataCache.SetData("ADTipsBubblePopup", false);
          setTimeout(() => {
            if (!this.birdAnimation) return;
            this.birdAnimation.play("fly_go");
            this.birdAnimation.once(Animation.EventType.FINISHED, () => {
              this.birdAnimation.node.active = false;
            }, this);
          }, 250);
        }

        onDestroy() {
          if (this.adShowI) {
            clearInterval(this.adShowI);
            this.adShowI = null;
          }

          if (this.fly_come_i) {
            clearInterval(this.fly_come_i);
            this.fly_come_i = null;
          }
        }

        slowUpdate(dt) {}

        onClick() {
          if (this.adPrepared) {
            if (homeView.isBusy()) return;
            ADWrap.ShowVideo(() => {
              let req = SR.SRUserData.finishVideoPeterGift();
              req.SetCallBack(res => {
                let rewards = [];
                res.rewards.forEach(x => {
                  rewards.push(Content.FromContent(x));
                });
                UIRoot.instance.openChildWindow(GetRewardWindow, {
                  contents: rewards,
                  showCallback: wnd => {
                    wnd.addOnCloseFunc(() => {
                      this._isGetReward = true;
                      this.ShowAway();
                      this.scheduleOnce(() => {
                        this.ShowAd();
                      }, 300);
                      GameKit.PlayerPrefs.SetInt("peterAdTime", GameKit.TimeUtil.getCurrentTime() + 300);
                    });
                  }
                });
              });
              req.Send();
            }, "peter");
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "bird", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "bubble", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelMsg", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "dbBird", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SignMeta.ts", ['cc', './Content.ts', './MetaManager.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Content, MetaManager, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "7cc9e+nNotBPJD+5rPP3XvF", "SignMeta", undefined);

      class SignMeta {
        constructor() {
          _defineProperty(this, "_data", {
            id: 0,
            type: 0,
            day: "",
            reward: ""
          });

          _defineProperty(this, "_reward", []);
        }

        static MakeEntity(data) {
          let meta = new SignMeta();
          meta.UpdateData(data);
          return meta;
        }

        static GetByTypeDay(type, day) {
          // 暴力枚举
          let id;

          switch (`${type}-${day}`) {
            default:
            case "1-1":
              id = 101;
              break;

            case "1-2":
              id = 102;
              break;

            case "1-3":
              id = 103;
              break;

            case "1-4":
              id = 104;
              break;

            case "1-5":
              id = 105;
              break;

            case "1-6":
              id = 106;
              break;

            case "1-7":
              id = 107;
              break;

            case "2-7":
              id = 201;
              break;

            case "2-14":
              id = 202;
              break;

            case "2-21":
              id = 203;
              break;

            case "2-28":
              id = 204;
              break;
          }

          return SignMeta.GetById(id.toString());
        } ///不知道干嘛的，先注销
        // static GetById(id: any) {
        //     throw new Error("Method not implemented.")
        // }


        static GetById(id) {
          return MetaManager.GetMeta(Meta.MetaType.Sign, id);
        }

        UpdateData(data) {
          this._data = {
            id: data.id,
            type: data.type,
            day: data.day,
            reward: data.reward
          };
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        } //签到类型 SignMeta.Types


        Type() {
          return this._data.type;
        } //天数


        Day() {
          return this._data.day;
        }

        Reward() {
          if (!this._reward.length) {
            this._reward = Content.FromStrings(this._data.reward);
            this._reward = Content.Merge(this._reward);
          }

          return this._reward;
        }

      }

      exports('SignMeta', SignMeta);

      _defineProperty(SignMeta, "Types", {
        Week: 1,
        Month: 2
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AutoSpinTipWindow.ts", ['cc', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "7d4f05g64BNKYEjPDVtQi+2", "AutoSpinTipWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AutoSpinTipWindow = exports('AutoSpinTipWindow', ccclass(_class = (_temp = _class2 = class AutoSpinTipWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "properties", void 0);
        }

        close_window() {
          this.closeAnim();
        }

      }, _defineProperty(_class2, "windowPath", "Other/NewAutoSpinTipWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ScaleAnim.ts", ['cc', './CCE_Component.ts', './_app.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, CCE_Component, cce;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      cce = module.cce;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "7de6fVB4ZFG/L/MeZDonhLX", "ScaleAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ScaleAnim = exports('default', (_dec = property(CCInteger), _dec2 = property(CCInteger), _dec3 = property(CCInteger), _dec4 = property(CCInteger), _dec5 = property(CCInteger), _dec6 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class ScaleAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "minX", _descriptor, this);

          _initializerDefineProperty(this, "maxX", _descriptor2, this);

          _initializerDefineProperty(this, "minY", _descriptor3, this);

          _initializerDefineProperty(this, "maxY", _descriptor4, this);

          _initializerDefineProperty(this, "time", _descriptor5, this);

          _initializerDefineProperty(this, "delay", _descriptor6, this);

          _defineProperty(this, "playing", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          this.playing = true;
          this.node.scaleX = this.minX;
          this.node.scaleY = this.minY;
          this.scheduleOnce(function () {
            this.playing = false;
          }.bind(this), this.delay);
        }

        slowUpdate(dt) {
          if (this.playing) return;
          this.node.runAction(ccAction.sequence(ccAction.scaleTo(this.time, this.maxX, this.maxY, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)), ccAction.scaleTo(this.time, this.minX, this.minY, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)), ccAction.delayTime(this.delay) //ccAction.callFunc(function(){ this.playing = false }, this)
          ).repeatForever());
          this.playing = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "minX", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "maxX", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "minY", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "maxY", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "delay", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NodeRecovery.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Tween;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Tween = module.Tween;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "7f0a3rtZdlNMp43c/oGcWnX", "NodeRecovery", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NodeRecovery = exports('default', (_dec = ccclass("NodeRecovery"), _dec(_class = (_temp = class NodeRecovery extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "initialPosition", void 0);

          _defineProperty(this, "initialRotation", void 0);

          _defineProperty(this, "initialScale", void 0);

          _defineProperty(this, "initialActive", void 0);

          _defineProperty(this, "inited", false);
        } // onLoad() {
        // 	this.initialPosition = this.node.position;
        // 	this.initialRotation = this.node.rotation;
        // 	this.initialScale = this.node.scale;
        // }


        init() {
          this.initialPosition = this.node.position.clone();
          this.initialRotation = this.node.rotation.clone();
          this.initialScale = this.node.scale.clone();
          this.initialActive = this.node.active;
          this.inited = true;
        }

        reset() {
          this.node.position = this.initialPosition;
          this.node.rotation = this.initialRotation;
          this.node.scale = this.initialScale;
          this.node.active = this.initialActive;
          Tween.stopAllByTarget(this.node);
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ChatMgr.ts", ['cc', './ChatMessage.ts', './SR.ts'], function (exports) {
  'use strict';

  var cclegacy, ChatMessage, SR;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      ChatMessage = module.ChatMessage;
    }, function (module) {
      SR = module.SR;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "7f58cxWB6BMY7EWLqUCzh7Q", "ChatMgr", undefined);

      class ChatMgr {
        constructor() {
          _defineProperty(this, "_msgs", void 0);

          _defineProperty(this, "lastMsg", void 0);
        }

        static init() {
          this.intervalID = setInterval(function () {
            SR.SRChat.getLastChat(this.lastChatTime).Send();
          }.bind(this), 1500);
        }

        static Clear() {
          clearInterval(this.intervalID);
          this._msgs = [];
          this.lastMsg = null;
        }

        static addMessage(msgs) {
          this.newMessage = [];

          for (let i = 0; i < msgs.length; i++) {
            let cm = new ChatMessage();
            cm.updateData(msgs[i]);

            this._msgs.push(cm);

            this.newMessage.push(cm);
          }

          if (this._msgs.length > 200) {
            this._msgs = this._msgs.slice(this._msgs.length - 200);
          }
        }

        static getMessages() {
          return this._msgs;
        }

        static getNewMessages() {
          return this.newMessage;
        }

        static getLastMessages() {
          return this.lastMsg;
        }

        static setLastMessages(msg, timeStamp) {
          this.lastChatTime = timeStamp;
          if (!msg) return;
          let cm = new ChatMessage();
          this.lastMsg = cm.updateData(msg);
        }

      }

      exports('ChatMgr', ChatMgr);

      _defineProperty(ChatMgr, "intervalID", void 0);

      _defineProperty(ChatMgr, "_msgs", void 0);

      _defineProperty(ChatMgr, "lastMsg", void 0);

      _defineProperty(ChatMgr, "newMessage", void 0);

      _defineProperty(ChatMgr, "lastChatTime", void 0);

      _defineProperty(ChatMgr, "lastTime", void 0);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SettingWindow.ts", ['cc', './global.ts', './fbIn_lib.ts', './wx_lib.ts', './SoundManager.ts', './UIWindow.ts', './UserInfoModel.ts', './DialogWindow.ts', './AppGame.ts', './FollowWindow.ts', './TouchTest.ts', './SdkManager.ts', './GameMainWindow.ts', './UIRoot.ts', './StaticGame.ts', './NativeWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Sprite, Label, Node, Toggle, _decorator, director, sys, game, G, fbInTools, wxTools, SoundManager, UIWindow, UserInfoModel, DialogWindow, AppGame, FollowWindow, TouchTest, SdkManager, GameMainWindow, UIRoot, Game, Meta, NativeWrap, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Sprite = module.Sprite;
      Label = module.Label;
      Node = module.Node;
      Toggle = module.Toggle;
      _decorator = module._decorator;
      director = module.director;
      sys = module.sys;
      game = module.game;
    }, function (module) {
      G = module.G;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      FollowWindow = module.default;
    }, function (module) {
      TouchTest = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "7fb7ays365D3pRfWogQqZiM", "SettingWindow", undefined); //// const UIWindow = UIWindow


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        langs: ["en", "es", "de", "fr", "zh"]
      };
      /**
       * Setting界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let SettingWindow = exports('SettingWindow', (_dec = property(SpriteFrame), _dec2 = property(SpriteFrame), _dec3 = property(Sprite), _dec4 = property(Sprite), _dec5 = property(Label), _dec6 = property(Label), _dec7 = property(Label), _dec8 = property(Node), _dec9 = property(Sprite), _dec10 = property(Node), _dec11 = property([Toggle]), ccclass(_class = (_class2 = (_temp = _class3 = class SettingWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "on_sf", _descriptor, this);

          _initializerDefineProperty(this, "off_sf", _descriptor2, this);

          _initializerDefineProperty(this, "switch_sound", _descriptor3, this);

          _initializerDefineProperty(this, "switch_music", _descriptor4, this);

          _initializerDefineProperty(this, "label_userId", _descriptor5, this);

          _initializerDefineProperty(this, "label_version", _descriptor6, this);

          _initializerDefineProperty(this, "label_currentLanguage", _descriptor7, this);

          _initializerDefineProperty(this, "spLowBattery", _descriptor8, this);

          _initializerDefineProperty(this, "switch_LowBattery", _descriptor9, this);

          _initializerDefineProperty(this, "languageWindow", _descriptor10, this);

          _initializerDefineProperty(this, "toggles", _descriptor11, this);
        }

        onShow() {
          // 未来需要传入本地存储进行更新
          this.update_choose();
          this.label_userId.string = i18n.t("settingUid") + Game.SUser.UserId(); // this.label_version.string = "v" + G.GameConfig.version;

          if (Reflect.get(globalThis, "$tp_version")) {
            this.label_version.string = i18n.t("settingVersion") + $tp_version;
          }

          this.label_currentLanguage.string = i18n.t("setting_language_" + i18n.getLang());
          this.spLowBattery.active = SdkManager.IsNative() && SdkManager.IsIos();
        }
        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        }
        /** 点击事件：language */


        event_change_language() {
          this.languageWindow.active = !this.languageWindow.active;
          this.setToggleChecked(C.langs.indexOf(i18n.getLang()));

          let touchStart = event => {
            const isInRect = TouchTest.isTouchInRect(event, this.languageWindow);

            if (!isInRect && this.languageWindow.active === true && event.target !== this.languageWindow.parent.getChildByName("btnLanguage")) {
              this.languageWindow.active = false; // event.propagationStopped = true;

              director.getScene().off(Node.EventType.TOUCH_START, touchStart, this, true);
            }
          };

          if (this.languageWindow.active) {
            director.getScene().on(Node.EventType.TOUCH_START, touchStart, this, true);
          }
        }
        /** 点击事件：更改sound */


        event_change_sound() {
          // 更改本地数据
          SoundManager.changeSoundSwitch(); // 更改样式

          this.update_choose();
        }
        /** 点击事件：更改music */


        event_change_music() {
          // 更改本地数据
          SoundManager.changeBGMSwitch(); // 更改样式

          this.update_choose();
        }
        /** 点击事件：更改notify_raid */


        event_change_notify_raid() {// 更改本地数据
          // 更改样式
          // if (this.switch_raid.spriteFrame === this.on_sf) {
          // 	this.switch_raid.spriteFrame = this.off_sf;
          // } else {
          // 	this.switch_raid.spriteFrame = this.on_sf;
          // }
        }
        /** 点击事件：更改notify_general */


        event_change_notify_general() {// 更改本地数据
          // 更改样式
          // if (this.switch_general.spriteFrame === this.on_sf) {
          // 	this.switch_general.spriteFrame = this.off_sf;
          // } else {
          // 	this.switch_general.spriteFrame = this.on_sf;
          // }
        }

        event_change_lowBattery() {
          let sw = SettingWindow.getLowBatterySwitch();
          sw = !sw;
          sys.localStorage.setItem("LowBatterySwitch", sw);

          if (sw) {
            this.switch_LowBattery.spriteFrame = this.on_sf;
          } else {
            this.switch_LowBattery.spriteFrame = this.off_sf;
          }

          if (sw && !GameKit.PlayerPrefs.GetBool("LowBatteryTip", false)) {
            GameKit.PlayerPrefs.SetBool("LowBatteryTip", true);
            DialogWindow.Show(i18n.t("setting_lowbattery_tip"));
          }

          if (sw) game.setFrameRate(30);else game.setFrameRate(60);
        }
        /** 更新4个位置的选中状态 */


        update_choose(sound = true, music = true, raid = false, general = false) {
          sound = SoundManager.getSoundSwitch();
          music = SoundManager.getBGMSwitch();

          if (sound) {
            this.switch_sound.spriteFrame = this.on_sf;
          } else {
            this.switch_sound.spriteFrame = this.off_sf;
          }

          if (music) {
            this.switch_music.spriteFrame = this.on_sf;
          } else {
            this.switch_music.spriteFrame = this.off_sf;
          } // if (raid) {
          // 	this.switch_raid.spriteFrame = this.on_sf;
          // } else {
          // 	this.switch_raid.spriteFrame = this.off_sf;
          // }
          // if (general) {
          // 	this.switch_general.spriteFrame = this.on_sf;
          // } else {
          // 	this.switch_general.spriteFrame = this.off_sf;
          // }


          let sw_lb = SettingWindow.getLowBatterySwitch();

          if (sw_lb) {
            this.switch_LowBattery.spriteFrame = this.on_sf;
          } else {
            this.switch_LowBattery.spriteFrame = this.off_sf;
          }
        }

        on_click_follow() {
          if (fbInTools.usefbIn) {
            if (window.open) window.open("https://www.facebook.com/SlotsVille-1962616787117495/");
          } else if (wxTools.usewx) {
            UIRoot.instance.openChildWindow(FollowWindow);
          }
        }

        on_click_tutorial() {//let req = SR.SRLogin.clearProgress()
          //req.Send()
        }

        on_click_support() {
          if (wxTools.usewx) {
            if (wxTools.SdkVersionOver("2.0.3") >= 0) {
              wx.openCustomerServiceConversation({});
            } else {
              DialogWindow.Show(i18n.t("wxVersionNoSupport"), () => {
                UIRoot.instance.openChildWindow(FollowWindow);
              });
            }
          } else if (SdkManager.IsNative()) {
            let title = "[Impostor Kings]SUPPORT";
            sys.openURL(`mailto:${G.GameConfig.email}.subtractject=${encodeURIComponent(title)}&body=uid:` + Game.SUser.UserId());
          } else {
            if (window.open) window.open(`${G.GameConfig.site_host}/index.html`);
          }
        }

        on_click_privacyPolicy() {
          if (SdkManager.IsNative()) {
            sys.openURL(`${G.GameConfig.site_host}/privacy.html`);
          } else if (window.open) window.open(`${G.GameConfig.site_host}/privacy.html`);
        }

        on_click_team() {
          if (window.open) window.open(`${G.GameConfig.site_host}/index.html`);
        }

        on_click_logout() {
          if (!SdkManager.IsNative()) return;

          if (Game.SUser.from === "app_fb") {
            NativeWrap.call("FBSdk", "logout", null, function (info) {
              console.log("logout", info);
              AppGame.instance.logout();
            });
          } else {
            AppGame.instance.logout();
          }
        }

        onEnglishChecked() {
          this.changeLanguageByIndex(0);
        }

        onEspanolChecked() {
          this.changeLanguageByIndex(1);
        }

        onDeutschChecked() {
          this.changeLanguageByIndex(2);
        }

        onFrancaisChecked() {
          this.changeLanguageByIndex(3);
        }

        onChineseChecked() {
          this.changeLanguageByIndex(4);
        }

        changeLanguageByIndex(index = 0) {
          i18n.changeto(C.langs[Number(index)]);
          this.label_currentLanguage.string = i18n.t("setting_language_" + i18n.getLang());
          BigNumber.setLanguage();
          let settingWindow = UIRoot.instance.GetWindow("SettingWindow");
          if (settingWindow) settingWindow.onShow();

          if (homeView) {
            homeView.slotPage.toRaidUserNode.setBetValue(homeView.slotNode.betNum);

            homeView.pageViewController._setAp();

            homeView.slotPage.toRaidUserNode.getComponent(UserInfoModel).updateCoin(); // homeView.slotNode.activityRoot.updateActivity();

            if (homeView.slotNode.slotPeter.i18nKey) homeView.slotNode.slotPeter.labelMsg.string = i18n.t(homeView.slotNode.slotPeter.i18nKey); // if (homeView.slotNode.servantNode.i18nKey) homeView.slotNode.servantNode.labelMsg.string = i18n.t(homeView.slotNode.servantNode.i18nKey);
          }

          if (GameMainWindow.instance) {
            let adGetCoinMeta = Meta.MetaManager.GetMeta(Meta.MetaType.AdGetCoin, Game.SUserVillage.MapId());
            homeView.villagePage.txtAdCoin.string = BigNumber.format(adGetCoinMeta.Coin());
            GameMainWindow.instance.showStar();
            GameMainWindow.instance.userinfo.updateCoin();
          }

          if (homeView.villagePage) {
            homeView.villagePage.updateRoomName();
          }

          if (homeView.pageViewController) {
            homeView.pageViewController.setBet();
          }

          if (homeView.cardAllSetWindow) {
            homeView.cardAllSetWindow.flushData();
          }
        }

        setToggleChecked(index) {
          this.toggles[index].isChecked = true;
        }

      }, _defineProperty(_class3, "windowPath", "Menu/NewSettingWindow"), _defineProperty(_class3, "getLowBatterySwitch", function () {
        let sw = sys.localStorage.getItem("LowBatterySwitch");
        if (sw == null) sw = false;else {
          if (sw == "false") sw = false;else sw = true;
        }
        return sw;
      }), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "on_sf", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "off_sf", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "switch_sound", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "switch_music", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "label_userId", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "label_version", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "label_currentLanguage", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spLowBattery", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "switch_LowBattery", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "languageWindow", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "toggles", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));
      /* 界面相关数据（根据截图获取）
        背景大小：530*930
      标题大小：310*95
      0-子背景：490*140
      1-子背景：490*180
      2-子背景：490*127
      3-子背景：490*176
      背景间隔：10
      小按钮大小：240*60
      内部背景大小：n*490
      按钮大小：56*233
      字颜色RGB：102,44,28
      字描边颜色RGB：102,47,57
      语言字体颜色RGB：41,84,0
      uuid字体颜色：164,108,87
        */

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardCollectWindow.ts", ['cc', './global.ts', './UIWindow.ts', './CardModel.ts', './GameMainWindow.ts', './UIRoot.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, G, UIWindow, CardModel, GameMainWindow, UIRoot, Meta, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "8136a1jVgJNNoJfO27pTzm1", "CardCollectWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      let CardCollectWindow = exports('default', (_dec = property(CardModel), _dec2 = property(Label), _dec3 = property(Node), _dec4 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class CardCollectWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "card_model", _descriptor, this);

          _initializerDefineProperty(this, "label_des", _descriptor2, this);

          _initializerDefineProperty(this, "btn_go", _descriptor3, this);

          _initializerDefineProperty(this, "sp_vip", _descriptor4, this);

          _defineProperty(this, "id", void 0);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "_showParams", null);
        }

        onShow(showParams) {
          this._showParams = showParams;
          this.id = showParams.id;
          this.meta = Meta.MetaManager.GetMeta(Meta.MetaType.Card, this.id);
          if (showParams.nogo) this.btn_go.active = false;
          this.sp_vip.active = !!showParams.isVip;
          this.load_page();
        }

        onClose() {
          this.card_model.onClose();
        }

        load_page() {
          this.card_model.show(this.id, "no-check");
          this.label_des.string = String.format(i18n.t("CardCollectDes"), this.meta.Name());
        }

        event_close() {
          this.closeAnim(() => {
            GameMainWindow.instance.userinfo.updateStar();
            homeView.cardAllSetWindow.flushData();

            if (this._showParams.closeCallback) {
              this._showParams.closeCallback();
            }
          });
        }

        event_go() {
          this.closeAnim(() => {
            GameMainWindow.instance.userinfo.updateStar();
            homeView.cardAllSetWindow.flushData();

            if (this._showParams.closeCallback) {
              this._showParams.closeCallback();
            }

            UIRoot.instance.closeChildWindow("GiftsWindow");
            homeView.pageViewController.moveToPage(G.Pages.Collection, true); // UIRoot.instance.openChildWindow(CardAllSetWindow, {setId: this.meta.SetId()})
          });
        }

      }, _defineProperty(_class3, "windowPath", "Card/CardCollectWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "card_model", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "label_des", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btn_go", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp_vip", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FirstPurchaseWindow.ts", ['cc', './global.ts', './UIWindow.ts', './Content.ts', './ContentDesWindow.ts', './ShopWindow.ts', './UIRoot.ts', './LogEventWrap.ts', './AppKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, _decorator, G, UIWindow, Content, ContentDesWindow, ShopWindow, UIRoot, LogEventWrap, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      ContentDesWindow = module.ContentDesWindow;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "839618A4sVFsaugUvLGJF+Y", "FirstPurchaseWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FirstPurchaseWindow = exports('FirstPurchaseWindow', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Sprite), _dec4 = property(Label), _dec5 = property(Sprite), _dec6 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class FirstPurchaseWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "icon1", _descriptor, this);

          _initializerDefineProperty(this, "num1", _descriptor2, this);

          _initializerDefineProperty(this, "icon2", _descriptor3, this);

          _initializerDefineProperty(this, "num2", _descriptor4, this);

          _initializerDefineProperty(this, "icon3", _descriptor5, this);

          _initializerDefineProperty(this, "num3", _descriptor6, this);
        }

        onShow() {
          let rewards = Content.Merge(Content.FromStrings(G.GameConstance.firstPurchaseReward));
          rewards[0].Icon(this.icon1);
          this.num1.string = this.formatNum(rewards[0].Count());
          this.icon1.node.on("click", function () {
            UIRoot.instance.openChildWindow(ContentDesWindow, {
              content: rewards[0]
            });
          }.bind(this), this);
          rewards[1].Icon(this.icon2);
          this.num2.string = this.formatNum(rewards[1].Count());
          this.icon2.node.on("click", function () {
            UIRoot.instance.openChildWindow(ContentDesWindow, {
              content: rewards[1]
            });
          }.bind(this), this);
          rewards[2].Icon(this.icon3);
          this.num3.string = this.formatNum(rewards[2].Count());
          this.icon3.node.on("click", function () {
            UIRoot.instance.openChildWindow(ContentDesWindow, {
              content: rewards[2]
            });
          }.bind(this), this);
          LogEventWrap.logEvent("window_firstpurchase");
        }

        formatNum(num) {
          if (num < 1000) {
            return i18n.t("multiplyx") + num.toString();
          }

          return BigNumber.format(num);
        }

        callBuy() {
          this.closeAnim(() => {
            homeView.pageViewController.moveToPage(G.Pages.Shop, true);
            homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.coin);
            LogEventWrap.logEvent("openshop_firstpurchase");
          });
        }

        close_window() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Shop/FirstPurchaseWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "icon1", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "num1", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "icon2", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "num2", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "icon3", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "num3", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SR.ts", ['cc', './SRJigsaw.ts', './SRActivity.ts', './SRActivityBlackJack.ts', './SRActivityCannon.ts', './SRActivityHeist.ts', './SRMinigame.ts', './SRMinigameCoinhit.ts', './SRCard.ts', './SRChat.ts', './SRDailyBonus.ts', './SRItems.ts', './SRSign.ts', './SRTask.ts', './SRRecord.ts', './SRServant.ts', './SRShop.ts', './SRInteraction.ts', './SRSlot.ts', './SRSocial.ts', './SRStatus.ts', './SRTutorial.ts', './SRLogin.ts', './SRUserData.ts', './SRUserInfo.ts', './SRVillage.ts'], function (exports) {
  'use strict';

  var cclegacy, SRJigsaw, SRActivity, SRActivityBlackJack, SRActivityCannon, SRActivityHeist, SRMinigame, SRMinigameCoinhit, SRCard, SRChat, SRDailyBonus, SRItems, SRSign, SRTask, SRRecord, SRServant, SRShop, SRInteraction, SRSlot, SRSocial, SRStatus, SRTutorial, SRLogin, SRUserData, SRUserInfo, SRVillage;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      SRJigsaw = module.SRJigsaw;
    }, function (module) {
      SRActivity = module.SRActivity;
    }, function (module) {
      SRActivityBlackJack = module.SRActivityBlackJack;
    }, function (module) {
      SRActivityCannon = module.SRActivityCannon;
    }, function (module) {
      SRActivityHeist = module.SRActivityHeist;
    }, function (module) {
      SRMinigame = module.SRMinigame;
    }, function (module) {
      SRMinigameCoinhit = module.SRMinigameCoinhit;
    }, function (module) {
      SRCard = module.SRCard;
    }, function (module) {
      SRChat = module.SRChat;
    }, function (module) {
      SRDailyBonus = module.SRDailyBonus;
    }, function (module) {
      SRItems = module.SRItems;
    }, function (module) {
      SRSign = module.SRSign;
    }, function (module) {
      SRTask = module.SRTask;
    }, function (module) {
      SRRecord = module.SRRecord;
    }, function (module) {
      SRServant = module.SRServant;
    }, function (module) {
      SRShop = module.SRShop;
    }, function (module) {
      SRInteraction = module.SRInteraction;
    }, function (module) {
      SRSlot = module.SRSlot;
    }, function (module) {
      SRSocial = module.SRSocial;
    }, function (module) {
      SRStatus = module.SRStatus;
    }, function (module) {
      SRTutorial = module.SRTutorial;
    }, function (module) {
      SRLogin = module.SRLogin;
    }, function (module) {
      SRUserData = module.SRUserData;
    }, function (module) {
      SRUserInfo = module.SRUserInfo;
    }, function (module) {
      SRVillage = module.SRVillage;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "843d0k6iyBAkYP0kk91M7Wn", "SR", undefined);

      class SR {}

      exports('SR', SR);

      _defineProperty(SR, "SRChat", SRChat);

      _defineProperty(SR, "SRUserData", SRUserData);

      _defineProperty(SR, "SRTask", SRTask);

      _defineProperty(SR, "SRSign", SRSign);

      _defineProperty(SR, "SRSlot", SRSlot);

      _defineProperty(SR, "SRCard", SRCard);

      _defineProperty(SR, "SRVillage", SRVillage);

      _defineProperty(SR, "SRShop", SRShop);

      _defineProperty(SR, "SRActivityCannon", SRActivityCannon);

      _defineProperty(SR, "SRActivityHeist", SRActivityHeist);

      _defineProperty(SR, "SRMinigame", SRMinigame);

      _defineProperty(SR, "SRMinigameCoinhit", SRMinigameCoinhit);

      _defineProperty(SR, "SRDailyBonus", SRDailyBonus);

      _defineProperty(SR, "SRItems", SRItems);

      _defineProperty(SR, "SRRecord", SRRecord);

      _defineProperty(SR, "SRServant", SRServant);

      _defineProperty(SR, "SRInteraction", SRInteraction);

      _defineProperty(SR, "SRTutorial", SRTutorial);

      _defineProperty(SR, "SRSocial", SRSocial);

      _defineProperty(SR, "SRStatus", SRStatus);

      _defineProperty(SR, "SRLogin", SRLogin);

      _defineProperty(SR, "SRUserInfo", SRUserInfo);

      _defineProperty(SR, "SRActivityBlackJack", SRActivityBlackJack);

      _defineProperty(SR, "SRJigsaw", SRJigsaw);

      _defineProperty(SR, "SRActivity", SRActivity);

      window["SR"] = SR;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RoomManager.ts", ['cc', './CommonAssets.ts', './AutomaticDoor.ts', './Room.ts', './Player.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, instantiate, CommonAssets, AutomaticDoor, Room, Player;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      AutomaticDoor = module.default;
    }, function (module) {
      Room = module.default;
    }, function (module) {
      Player = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "84771/9mv9CyLuGfs+FtZeQ", "RoomManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let RoomManager = exports('default', (_dec = ccclass("RoomManager"), _dec(_class = (_temp = _class2 = class RoomManager extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "templateRoom", null);

          _defineProperty(this, "head", 0);

          _defineProperty(this, "tail", 0);

          _defineProperty(this, "rooms", []);

          _defineProperty(this, "curRoom", void 0);

          _defineProperty(this, "nextRoom", void 0);
        }

        onLoad() {
          RoomManager.instance = this;
          this.initRooms();
          this.curRoom = this.rooms[0];
          this.nextRoom = this.rooms[1];
        }

        async initRooms() {
          this.templateRoom = this.node.children[0];
          this.templateRoom.active = false;
          const initRoomCount = 3;
          this.head = RoomManager.interval * (initRoomCount - 1);

          for (let i = 0; i < initRoomCount; i++) {
            this.generateOneRoom(RoomManager.interval * i);
          }

          await CommonAssets.instance.loadRewards();
          Room.initializePool();
        }

        generateOneRoom(posZ) {
          console.log("generateOneRoom", posZ);
          let node = this.getOneRoom();
          node.position = new Vec3(0, 0, posZ);
          this.scheduleOnce(() => {
            node.getComponentsInChildren(AutomaticDoor).forEach(v => v.setTarget(Player.instance.node));
          }, 0);
          let com = node.getOrAddComponent(Room);
          this.node.addChild(node);
          this.rooms.push(com);
          return com;
        }

        moveToward() {
          this.head += RoomManager.interval;
          this.tail -= RoomManager.interval;
          let tailRoom = this.rooms.shift();
          this.recycleRoom(tailRoom.node);
          this.generateOneRoom(this.head);
          let nextIndex = this.rooms.indexOf(this.nextRoom);
          this.curRoom = this.nextRoom;
          this.nextRoom = this.rooms[nextIndex + 1];
        }

        getOneRoom() {
          let node;

          if (RoomManager.poolRooms.length > 0) {
            node = RoomManager.poolRooms.pop();
          } else {
            node = instantiate(this.templateRoom);
          }

          node.active = true;
          return node;
        }

        recycleRoom(node) {
          if (!node) return;
          node.active = false;
          node.removeFromParent();
          RoomManager.poolRooms.push(node);
        }

      }, _defineProperty(_class2, "poolRooms", []), _defineProperty(_class2, "interval", -37.985), _defineProperty(_class2, "instance", void 0), _temp)) || _class));
      window["RoomManager"] = RoomManager;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PetStateMachine.ts", ['cc', './StateMachine.ts'], function (exports) {
  'use strict';

  var cclegacy, StateMachine;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      StateMachine = module.default;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "84cc5kxi2dAtKxgYQx/J8Xo", "PetStateMachine", undefined);

      class PetStateMachine extends StateMachine {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "context", void 0);
        }

        setContext(context) {
          this.context = context;
        }

      }

      exports('default', PetStateMachine);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/StringUtil.ts", ['cc', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, v2, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v2 = module.v2;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('StringUtil', void 0);

      cclegacy._RF.push({}, "84dc3WTv4pMXr1d6Wldoetp", "StringUtil", undefined);

      let StringUtil;

      (function (_StringUtil) {
        function getRandomString(len) {
          len = len || 32;
          var $chars = "ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678";
          /****默认去掉了容易混淆的字符oO,9gq,Vv,Uu,LlI1****/

          var maxPos = $chars.length;
          var pwd = "";

          for (let i = 0; i < len; i++) {
            pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
          }

          return pwd;
        }

        _StringUtil.getRandomString = getRandomString;
        let dot_i18n = {
          //多语言 千分符
          en: ",",
          de: ".",
          es: ".",
          fr: " ",
          zh: ",",
          ar: "٬"
        }; //add ',' per 3 numbers

        function formatNumber(n) {
          let dot = dot_i18n[i18n.getLang()];
          let str = n.toString();
          let dotPos = str.indexOf(".");

          if (str.length > 3) {
            for (let i = (dotPos >= 0 ? dotPos : str.length) - 3; i > 0; i -= 3) {
              str = str.insert(i, dot);
            }
          }

          return str;
        }

        _StringUtil.formatNumber = formatNumber;

        function Vec2ToString(p) {
          return "(" + p.x.toString() + "," + p.y.toString() + ")";
        }

        _StringUtil.Vec2ToString = Vec2ToString;

        function Vec2FromString(s) {
          let st = s.subtractstr(1, s.length - 2);
          let sts = st.split(",");
          let px = Number(sts[0]);
          let py = Number(sts[1]);
          return v2(px, py);
        }

        _StringUtil.Vec2FromString = Vec2FromString;

        function VersionOver(ver1, ver2) {
          ver1 = ver1 || "0";
          ver2 = ver2 || "0";
          let s = ver1.split(".");
          let v = ver2.split(".");
          let index = 0;

          while (true) {
            if (s.length > index && v.length > index) {
              if (parseInt(s[index]) > parseInt(v[index])) return 1;
              if (parseInt(s[index]) < parseInt(v[index])) return -1;
            } else if (s.length > index && v.length <= index) return 1;else if (s.length <= index && v.length > index) return -1;else break;

            index++;
          }

          return 0;
        }

        _StringUtil.VersionOver = VersionOver;

        function versionCompareHandle(versionA, versionB) {
          console.log("JS Custom Version Compare: version A is " + versionA + ', version B is ' + versionB);
          var vA = versionA.split('.');
          var vB = versionB.split('.');

          for (var i = 0; i < vA.length; ++i) {
            var a = parseInt(vA[i]);
            var b = parseInt(vB[i] || '0');

            if (a === b) {
              continue;
            } else {
              return a - b;
            }
          }

          if (vB.length > vA.length) {
            return -1;
          } else {
            return 0;
          }
        }

        _StringUtil.versionCompareHandle = versionCompareHandle;
      })(StringUtil || (StringUtil = exports('StringUtil', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TestScene.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Camera, Sprite, Node, _decorator, Component, RenderTexture, SpriteFrame, UITransform;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Camera = module.Camera;
      Sprite = module.Sprite;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      RenderTexture = module.RenderTexture;
      SpriteFrame = module.SpriteFrame;
      UITransform = module.UITransform;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "85d66E0PFVEbJOt+81VVoto", "TestScene", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let TestScene = exports('TestScene', (_dec = ccclass('TestScene'), _dec2 = property(Camera), _dec3 = property(Sprite), _dec4 = property(Node), _dec(_class = (_class2 = (_temp = class TestScene extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "rtCamera", _descriptor, this);

          _initializerDefineProperty(this, "rtSprite", _descriptor2, this);

          _initializerDefineProperty(this, "logo", _descriptor3, this);

          _defineProperty(this, "rt", new RenderTexture());

          _defineProperty(this, "sf", new SpriteFrame());
        }

        start() {
          // this.rtCamera.node.setPosition(this.logo.position);
          this.rtCamera.orthoHeight = this.logo.height / 2;
          this.rt.reset({
            width: this.logo.width,
            height: this.logo.height
          });
          this.rtCamera.targetTexture = this.rt;
          this.sf.texture = this.rt;
          this.rtSprite.getComponent(UITransform).setContentSize(this.logo.width, this.logo.height);
          this.rtSprite.spriteFrame = this.sf;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "rtCamera", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "rtSprite", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "logo", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopLevelBonusItem.ts", ['cc', './LevelBonusWindow.ts', './UIRoot.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, Component, LevelBonusWindow, UIRoot;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      LevelBonusWindow = module.LevelBonusWindow;
    }, function (module) {
      UIRoot = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "872c5LsO1VIi6RW5eD5u4gC", "ShopLevelBonusItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopLevelBonusItem = exports('ShopLevelBonusItem', (_dec = ccclass("ShopLevelBonusItem"), _dec2 = property(Label), _dec3 = property(Label), _dec(_class = (_class2 = (_temp = class ShopLevelBonusItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "txtCount", _descriptor, this);

          _initializerDefineProperty(this, "txtPrice", _descriptor2, this);

          _defineProperty(this, "_levelBonusData", void 0);
        }

        setData(data) {
          this._levelBonusData = data;
          this.txtPrice.string = "$" + data.price;
          this.txtCount.string = "x" + data.count;
        }

        openLevelBonus() {
          if (homeView.isBusy()) return;
          UIRoot.instance.openChildWindow(LevelBonusWindow);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "txtCount", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "txtPrice", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SettingLanguageWindow.ts", ['cc', './UIWindow.ts', './UserInfoModel.ts', './GameMainWindow.ts', './UIRoot.ts', './StaticGame.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, color, SpriteFrame, Node, _decorator, Sprite, UIWindow, UserInfoModel, GameMainWindow, UIRoot, Meta, Game, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      color = module.color;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      _decorator = module._decorator;
      Sprite = module.Sprite;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "873aaQCzHpJooFsr/uczpqO", "SettingLanguageWindow", undefined); //// const UIWindow = UIWindow


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        /** 选中时的字体颜色颜色 */
        COLOR_CHOOSE: color(0, 75, 111),

        /** 未选中时的字体颜色 */
        COLOR_UNCHOOSE: color(64, 64, 64),
        langs: ["en", "es", "de", "fr", "zh"]
      };
      /**
       * SettingLanguage界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let SettingLanguageWindow = exports('SettingLanguageWindow', (_dec = property(SpriteFrame), _dec2 = property(SpriteFrame), _dec3 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class SettingLanguageWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "choose_sf", _descriptor, this);

          _initializerDefineProperty(this, "unchoose_sf", _descriptor2, this);

          _initializerDefineProperty(this, "language_node_array", _descriptor3, this);
        }

        onShow() {
          // 更新语言选择
          // 实际需要传入本地存储的参数
          this.update_language_choose(Math.max(0, C.langs.indexOf(i18n.getLang())));
        }
        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        }
        /**
         * 点击事件：修改language
         * @param {cc.EventTouch}} e EventTouch
         * @param {number} index CustomEventData 需要在编辑器中指定
         */


        event_change_to_language(e, index = 0) {
          i18n.changeto(C.langs[Number(index)]);
          this.update_language_choose(Number(index));
          BigNumber.setLanguage();
          let settingWindow = UIRoot.instance.GetWindow("SettingWindow");
          if (settingWindow) settingWindow.onShow();

          if (homeView) {
            homeView.slotPage.toRaidUserNode.setBetValue(homeView.slotNode.betNum);

            homeView.pageViewController._setAp();

            homeView.slotPage.toRaidUserNode.getComponent(UserInfoModel).updateCoin(); // homeView.slotNode.activityRoot.updateActivity();

            if (homeView.slotNode.slotPeter.i18nKey) homeView.slotNode.slotPeter.labelMsg.string = i18n.t(homeView.slotNode.slotPeter.i18nKey); // if (homeView.slotNode.servantNode.i18nKey) homeView.slotNode.servantNode.labelMsg.string = i18n.t(homeView.slotNode.servantNode.i18nKey);
          }

          if (GameMainWindow.instance) {
            let adGetCoinMeta = Meta.MetaManager.GetMeta(Meta.MetaType.AdGetCoin, Game.SUserVillage.MapId());
            homeView.villagePage.txtAdCoin.string = BigNumber.format(adGetCoinMeta.Coin());
            GameMainWindow.instance.showStar();
            GameMainWindow.instance.userinfo.updateCoin();
          }
        }
        /** 更新language选择样式 */


        update_language_choose(choose_language = 0) {
          for (let i = 0; i < this.language_node_array.length; i++) {
            let n = this.language_node_array[i];

            if (i === choose_language) {
              // 选中
              n.getComponent(Sprite).spriteFrame = this.choose_sf;
              n.getChildByName("label").color = C.COLOR_CHOOSE;
              n.getChildByName("choose_icon").active = true;
            } else {
              // 未选中
              n.getComponent(Sprite).spriteFrame = this.unchoose_sf;
              n.getChildByName("label").color = C.COLOR_UNCHOOSE;
              n.getChildByName("choose_icon").active = false;
            }
          }
        }

      }, _defineProperty(_class3, "windowPath", "Menu/SettingLanguageWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "choose_sf", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "unchoose_sf", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "language_node_array", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Test.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, dragonBones, _decorator, Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      dragonBones = module.dragonBones;
      _decorator = module._decorator;
      Component = module.Component;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "878c4RRl8BJ2Itl3Nzdfjq7", "Test", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Test = exports('Test', (_dec = ccclass('Test'), _dec2 = property(dragonBones.ArmatureDisplay), _dec(_class = (_class2 = (_temp = class Test extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "db", _descriptor, this);
        }

        onLoad() {
          this.db.playAnimation("boom_ani", -1);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "db", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VVConsole.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "87ac2SC69ZJMbeYvFkX7Snz", "VVConsole", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/zh.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "87f1fs0gohHDIfNg4aePXbt", "zh", undefined);

      let zh = exports('zh', {
        APPNAME: "金币之屋",
        Accept: "接受",
        ActivityAttackMasterButton: "获取！",
        ActivityAttackMasterButtonTip: "倍率越高消耗越快！",
        ActivityAttackMasterDes: "攻击{0}次来获得{1}金币",
        ActivityAttackMasterDesMore: "<color=#562900>完成越多，</color> <outline color=#9E5A05 width=2><color=#F7E150>奖励</color></outline><color=#562900>越大！</color>",
        ActivityAttackMasterFinal1: "最终大奖",
        ActivityAttackMasterFinal2: "{0} 金币!",
        ActivityAttackMasterTimeleft: "{0}后结束",
        ActivityBuildKingDes: "完成升级获得奖励！",
        ActivityCenterTime: "剩余时间：{0}",
        ActivityCenterTimeEnd: "活动已结束",
        ActivityCenterTitle: "活动中心",
        ActivityRaidMasterDes: "偷取{0}次来获得{1}金币",
        ActivityShopDes: "特卖剩余时间{0}",
        ActivitySlotCollectDes1: "攻击",
        ActivitySlotCollectDes2: "攻击失败",
        ActivitySlotCollectDes3: "偷取",
        ActivitySlotCollectDes4: "完美偷取",
        ActivitySlotCollectDes5: "摇中三个图标",
        ActivitySpecialOfferCoin: "{0} 金币",
        ActivitySpecialOfferSpin: "{0} 体力",
        ActivitySpecialOfferTitle: "惊喜礼包",
        ActivityTimeleft: "剩余时间",
        AdNotReady: "视频暂不可用，请稍后再试。",
        ApFull: "满",
        ApPlus: "+{0}体力",
        ApRecoverIn: "{1}后恢复{0}点",
        AppCommentBtn: "提交",
        AppCommentDes: "请给我们的游戏评分",
        AppCommentNo: "不用了",
        AppCommentTitle: "喜欢Coin Room吗？",
        AppHotUpdateFail: "未能载入资源，再试一次？",
        AppUpdateBtn: "更新",
        AppUpdateDes: "有新版本可用！现在就更新吧！",
        AppUpdateNo: "不了，谢谢",
        AppUpdateTitle: "有新更新",
        Attack: "攻击",
        AutoSpinTipWindowButton: "试试看！",
        AutoSpinTipWindowDes: "按住按钮开始",
        AutoSpinTipWindowTitle: "自动旋转",
        AutoSpining: "自动",
        Back: "返回",
        Bet: "倍率",
        BetRibbonText: "所有收益X{0}",
        BindFacebookBtn: "绑定",
        BindFacebookFreespin: "登入并获得免费体力",
        BindFacebookTip: "我们不会泄露您的隐私",
        BindFacebookTitle: "用Facebook账号登入",
        COLLECT: "收取",
        Cancel: "取消",
        CardAllSetWindowBottom: "金币之王",
        CardAllSetWindowCompleted: "收集完成",
        CardAllSetWindowLock: "在房间{0}\n后解锁",
        CardAllSetWindowLocked: "未解锁",
        CardAllSetWindowTitle: "卡牌",
        CardAsk: "索取",
        CardAskCannot: "该卡牌不能向好友索取",
        CardAskCannotGolden: "这是一张不能向好友索取的金色卡牌",
        CardChestInfoWindowHigh: "有大概率获得",
        CardChestInfoWindowTitle_1: "木质宝箱",
        CardChestInfoWindowTitle_2: "银质宝箱",
        CardChestInfoWindowTitle_3: "金质宝箱",
        CardChestOpenWindowNew: "新卡",
        CardCollectButton: "打开看看",
        CardCollectDes: "卡牌已经加入了你的收藏",
        CardCollectTitle: "真棒！",
        CardInfoWindowCommon: "普通",
        CardInfoWindowPage0_0: "通过打开宝箱来收集卡牌",
        CardInfoWindowPage0_1: "你也可以在商店里购买卡牌",
        CardInfoWindowPage0_2: "宝箱可以在偷取和解锁新房间时随机获得",
        CardInfoWindowPage1_0: "拥有多张相同卡牌可以作为礼物赠送给你的好友",
        CardInfoWindowPage1_1: "点击卡牌来作为礼物送出",
        CardInfoWindowPage1_2: "你也可以向好友索要缺乏的卡牌",
        CardInfoWindowPage1_3: "每天最多送出5张卡牌",
        CardInfoWindowPage2_0: "星数代表卡牌的稀有度",
        CardInfoWindowPage2_2: "每张新卡牌都会提升你的星级",
        CardInfoWindowPage2_3: "完成套牌来获得惊人奖励！",
        CardInfoWindowRare: "稀有",
        CardInfoWindowTitle: "卡牌说明",
        CardOpenDes: "<color=#ffffff><outline color=#000000 width=1>收集卡牌来获得<color=#ffcc00>金币</color> and <color=#c667ff>体力</color></color></outline>",
        CardOpenDesS: "收集卡牌来获得<color=#e67b07>金币</color> and <color=#006fd7>体力</color></color>",
        CardSelectCardWindowInfo: "选择{0}张卡牌",
        CardSelectCardWindowSelected: "已选择的卡牌",
        CardSelectCardWindowSuccess: "送卡成功！",
        CardSelectCardWindowTitle: "赠送卡牌",
        CardSelectFriendWindowBtn: "选择卡牌",
        CardSelectFriendWindowInfo: "选择一位好友",
        CardSelectFriendWindowTitle: "赠送卡牌",
        CardSend: "赠送",
        CardSendCannot: "该卡牌不能赠送给好友",
        CardSendCannotGolden: "这是一张不能赠送给好友的金色卡牌",
        CardSendCannotLeast: "你需要送出超过一张卡牌",
        CardSendCannotLimit: "你已经送出的本日限定数量的卡牌",
        CardSingleSetWindowCompleted: "套牌完成",
        CardSingleSetWindowReward: "收集该套牌来获得",
        CardSingleSetWindowTip: "点击一张多余的卡牌并把它送给你的好友",
        CardTapToCollect: "点击收集卡牌",
        ChatSend: "发送",
        CoinShopLevel: "等级{0}",
        CoinStore: "金币商店",
        Confirm: "确认",
        Congratulation: "恭喜！",
        ContentNameActivityItem6: "炮弹",
        ContentNameActivityItemCommon: "物品",
        ContentNameAp: "体力",
        ContentNameCard: "卡牌",
        ContentNameChest1: "木质宝箱",
        ContentNameChest2: "银质宝箱",
        ContentNameChest3: "金质宝箱",
        ContentNameChest4: "免费宝箱!",
        ContentNameCoin: "金币",
        ContentNameJigsaw: "拼图碎片",
        ContentNamePack: "物品",
        ContentNameShield: "盾牌",
        ContentNameUnknown: "？？？",
        CountDay: "{0}天",
        CountHour: "{0}小时",
        CountMinute: "{0}分",
        CountMonth: "{0}月",
        CountSecond: "{0}秒",
        CountYear: "{0}年",
        DailyBonusCollect: "收取",
        DailyBonusFreeSpinDes: "{0}\n后免费1次",
        DailyBonusGoldFirst: "第一次会获得至少25M金币！！！",
        DailyBonusGoldSpinBtn: "花费{0}旋转",
        DailyBonusLevel: "等级 {0}",
        DailyBonusNormalSpinBtn: "免费旋转",
        ErrorLogin: "未能连接服务器",
        ErrorMsg0: "成功",
        ErrorMsg1703: "支付失败",
        ErrorNormal: "服务器连接断开",
        ErrorRetry: "未能连接服务器，再试一次？",
        ExtraRewardDes: "Coin Room赠送你金币和体力！",
        FirstPurchaseButton: "出发！",
        FirstPurchaseDes1: "购买任何商品就可以",
        FirstPurchaseDes2: "获得额外奖励！",
        FormatHour: "时",
        FormatMinute: "分",
        FormatMonth: "月",
        FormatYear: "年",
        FriendsModelNoResult: "没有好友",
        FriendsModelPlaceHolder: "搜索好友姓名",
        GameMainWindowActivity: "活动",
        GameMainWindowQuest: "任务",
        GetRewardWindowDes: "<outline color=#000000 width=1><color=#ffffff> 你获得了奖励</color>\n<color=#c34eff>{0}!</color></outline>",
        GuestConfirmDes: "游客无法和好友\n一起游戏",
        GuestConfirmGuest: "游客登入",
        GuestConfirmTitle: "你确定？",
        Help_cannon: "1. 获得炮弹攻击城堡来获得奖励\n2. 戒指可以刷新城堡上的财宝\n3. 炮弹可以在金币机和建造时获得\n4. 收集财宝道具可以兑换丰厚奖励\n5. 魔法宝石可以变成任意一个财宝道具",
        Help_coinhit: "1. 消耗一张入场券来进入小游戏.\n2. 你可以获得大量的金币和体力.\n3. 击碎越多的色块获得越多的奖励.",
        Help_jigsaw: "1. 集齐9张碎片可以获得奖励.\n2. 碎片可以在玩金币机和建筑时获得.\n3. 活动结束时，碎片将会清空.\n4. 万能拼图可以替代任何一张碎片.",
        Help_sign: "1. 月签到每7天可领取一次奖励.\n2. 月签到每月刷新.\n3. 周签到每天可以领取一次奖励.\n4. 周签到每周刷新.",
        InteractionAttackFriends: "好友",
        InteractionAttackName: "{0}的房间",
        InteractionAttackResultBlock: "<outline color=#000000 width=1><color=#29ffed> {0}</color>挡住了你的攻击。你获得<color=#ffc209> {1}</color></outline>",
        InteractionAttackResultBlock2: "<outline color=#000000 width=1><color=#29ffed> {0}</color>挡住了你的攻击。你获得<color=#ffc209> {1}</color></outline>",
        InteractionAttackResultSuccess: "<outline color=#000000 width=1> 你攻击了<color=#29ffed>{0}的</color>房间，获得<color=#ffc209> {1}</color></outline>",
        InteractionAttackResultSuccess2: "<outline color=#000000 width=1> 你攻击了<color=#29ffed>{0}的</color>房间，获得<color=#ffc209> {1}</color></outline>",
        InteractionAttackRevenge: "仇人",
        InteractionBet: "{0}倍收益",
        InteractionRaidBrag: "分享",
        InteractionRaidCoinMaster: "国王",
        InteractionRaidEmpty: "没偷着",
        InteractionRaidName: "{0}的财宝",
        InteractionRaidPrefect: "全偷走了！",
        InteractionRaidResultLine: "<outline color=#000000 width=1>你从<color=#ffc209>{1}</color>偷到了<color=#29ffed>{0}</color>金币</outline>",
        InteractionRaidResultLine2: "<outline color=#000000 width=1>你从<color=#ffc209>{1}</color>偷到了<color=#FFF0A4>{0}</color>金币</outline>",
        InteractionRaidStole: "偷到了",
        LeaderBoardWindowTabCountry: "全国",
        LeaderBoardWindowTabFriends: "好友",
        LeaderBoardWindowTabGlobal: "全球",
        Level: "等级",
        Loading: "加载中",
        LoginWindowGuest: "游客",
        LoginWindowNeedUpdate: "新更新可用",
        LoginWindowPlay: "开始",
        LoginWithApple: "Apple账号登录",
        LoginWindowUpdating: "更新中",
        MORE: "加量",
        MultiplePurchaseDes1: "旋转获得的奖励提升至",
        MultiplePurchaseDes2: "x10倍",
        MultiplePurchaseDes3: "为了额外的{0}",
        NO: "否",
        NewPlayerPackButton: "购买",
        NewPlayerPackDes1: "欢迎来到金币之王！",
        NewPlayerPackDes2: "<outline color=#471F01 width=2>我们为您准备了一份<color=#ffd63b>大礼包</c></outline>",
        NewUserInvitedDes: "{0}解锁了新房间!\n你获得了{1}免费体力",
        NewUserInvitedDesApp: "{0}加入了游戏!\n你获得{1}免费体力",
        NewUserInvitedTitle: "邀请奖励",
        No: "否",
        NotEnoughApAdd: "+{0}体力",
        NotEnoughApDes: "体力不够了？",
        NotEnoughApWait: "或者等{1}来获得{0}体力",
        NotEnoughApWait2: "等{1}来获得{0}体力",
        NotEnoughCoinDes: "金币不够了？",
        NotEnoughOff: "{0}%\n加量",
        NotificationDesActivity: "{0}将在一小时后结束",
        NotificationDesApFull: "你有足够的体力去赚取金币！",
        NotificationDesAttack: "有人破坏了你的房间！",
        NotificationDesBack: "我们为你准备了一个大礼包！",
        NotificationDesBack2: "欢迎回来！我们为你准备了一个大礼包！",
        NotificationDesDailyBonus: "来玩每日幸运大转盘吧！",
        NotificationTitleActivity: "活动要结束了！",
        NotificationTitleApFull: "体力槽已满！",
        NotificationTitleAttack: "让我们去复仇！",
        NotificationTitleBack: "好久不见！",
        NotificationTitleBack2: "快来玩吧！",
        NotificationTitleDailyBonus: "每日奖励已就绪！",
        Now10XBetter: "10倍奖励！",
        OFF: "关闭",
        OK: "好的",
        OffText: "{0}%\n加量",
        PastDay: "{0}天前",
        PastHour: "{0}小时前",
        PastMinute: "{0}分前",
        PastMonth: "{0}个月前",
        PastSecond: "{0}秒前",
        PastYear: "{0}年前",
        PastZero: "刚刚",
        PayDisable: "支付暂不可用",
        PayDisableFBIn: "抱歉，你的设备暂不支持支付功能，请在电脑上打开Coin Room来完成支付",
        PayDisableIos: "iOS设备暂不支持支付",
        PayEnabledAndroid: "仅有安卓设备支持支付",
        PayFail: "支付失败！",
        PayPending: "等待支付中! 当你完成支付后，重启游戏获得物品.",
        PaySuccess: "感谢您的支付，祝您玩得开心！",
        PeterOpenDes1: "鹦鹉彼得会带给你随机的礼物!",
        PeterOpenDes2: "当他来的时候，点击他就可以获得!",
        PlayerDefaultName: "玩家",
        PriceSymbol: "$",
        Raid: "偷取",
        Rank: "排名",
        Reconnect: "重新连接",
        Restart: "重新开始",
        Retry: "重试",
        START: "开始",
        SaleMark: "特卖",
        Score: "得分",
        ScorePoint: "得分",
        ScoreRank: "排名",
        ServantEffectDes1: "增加偷取奖励",
        ServantEffectDes2: "增加攻击奖励",
        ServantEffectDes3: "保护房间免受攻击",
        ServantEffectDes4: "保护金币免受偷取",
        ServantEffectNum1: "奖励增加：",
        ServantEffectNum2: "奖励增加：",
        ServantEffectNum3: "保护几率为：",
        ServantEffectNum4: "保护几率为：",
        ServantInfo1: "升级",
        ServantInfo2: "每次转动金币机获得1点随从经验。也可以喝药水获得随从经验。当随从的经验条充满时，点击升级按钮就可以提升随从等级。每次随从升级都会为你增加星数。",
        ServantInfo3: "技能",
        ServantInfo4: "随从的技能会随着等级提升",
        ServantInfo5: "活跃值",
        ServantInfo6: "喂随从罐头让他工作。在旋转和建造时可以获得食物罐头。",
        ServantName1: "佩奇",
        ServantName2: "比利",
        ServantName3: "道格",
        ServantName4: "露比",
        ServantNextLevel: "下一等级：",
        ServantOpenDes: "<outline color=#000000 width=1><color=#ffffff>雇一个随从来获得更多的<color=#ffcc00>金币</color> 和 <color=#c667ff>体力</color></color></outline>",
        ServantOpenDesS: "<color=#308ae6>雇一个随从来获得更多的<color=#e67b07>金币</color> 和<color=#006fd7>体力</color></color>",
        ServantSelect: "选择",
        ServantUpgrade: "升级",
        ShareChooseDialogTitle: "赠送",
        ShareDialogTitle: "分享",
        ShareInviteAttack: "哇哦！我刚炸了别人的资产，太爽了！",
        ShareInviteDialogTitle: "邀请",
        ShareInviteFinishVillage: "我刚建造了一个新房间！快来参观一下吧 ,-D",
        ShareInviteNew: "嗨~这游戏特别有意思!和我一起玩吧~",
        ShareInviteRaid: "哇哦！我刚偷了{0}金币，太爽了！",
        ShareInviteSendCoins: "{0} 刚送给你一些金币 ,)",
        ShareInviteSendSpin: "{0} 刚送给你一个体力 ,)",
        ShareJigsawTitle: "我需要这些东西，帮帮我！",
        ShareSendCard: "{0}刚送给你一张卡牌",
        ShareTitle: "嗨~这游戏真好玩!和我一起玩吧~",
        Shield: "盾牌",
        ShopAddPercent: "{0}% \n加量",
        ShopBestValue: "高性价比",
        ShopChestDisable: "到达第2个地图解锁宝箱",
        ShopChests: "宝箱",
        ShopCoinPrice: "${0}",
        ShopCoins: "金币",
        ShopOff: "关闭",
        ShopPopular: "大热卖",
        ShopSpinNum: "{0}",
        ShopSpinPrice: "${0}",
        ShopSpins: "体力",
        ShopTitle: "商店",
        ShopTreatDisable: "罐头会在解锁房间{0}后开卖",
        ShopTreatFoodTime: "活动{0}小时",
        ShopTreats: "随从",
        SlotBetNewMax: "倍率上限增加了",
        SlotBetSuper: "高倍率",
        SlotCoin6Video: "看视频获得双倍奖励",
        SlotPeterDesAd: "我有一个礼物给你!",
        SlotSymbol1: "汽水",
        SomeDay: "{0}天",
        SomeHour: "{0}小时",
        SomeMinute: "{0}分",
        SomeMonth: "{0}个月",
        SomeSecond: "{0}秒",
        SomeYear: "{0}年",
        SomeZero: "刚刚",
        Spins: "体力+{0}",
        ToRaidUserBet: "收益X{0}",
        TutorialDialogDoSpin: "在金币机里赚金币，攻击，偷取其他玩家",
        TutorialDialogGoSpin: "金币不足，向下滑动去获得更多金币",
        TutorialDialogSlotAttack: "攻击其他玩家来获得金币",
        TutorialDialogSlotRaid: "偷取其他玩家的金币",
        TutorialDialogSlotRaidMaster: "让我们去偷他的金币",
        TutorialDialogSlotShield: "盾牌可以保护你的房间免受攻击",
        TutorialDialogStar: "升级物品获得星星，当你收集满25颗星就可以解锁下个房间",
        TutorialFinishDes0: "你的奖励",
        TutorialFinishDes1: "60免费体力",
        TutorialFinishDes1bind: "20免费体力",
        TutorialFinishDes2: "1百万免费金币",
        TutorialFinishDes3: "保存进度",
        TutorialFinishDes4: "和好友一起玩！",
        TutorialFinishTitle: "完成",
        TutorialStartDes: "欢迎加入！\n\n让我们按下按钮开始游戏！",
        TutorialStartTitle: "你的第一个房间",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        TutorialTargetName: "目标",
        TutorialTargetName1: "Leyla",
        TutorialTargetName2: "Mary",
        TutorialTargetName3: "Kevin",
        VillageCompleteNext: "下一个",
        VillageCompleteTitle: "房间建成！",
        VillageShopBuy: "建造",
        VillageShopComplete: "完成！",
        VillageShopFix: "修复",
        VillageShopTitle: "升级",
        YES: "是",
        Yes: "是",
        adShieldTip: "免费盾牌!",
        and: "和",
        betMaxBet: "倍率 x",
        cannon_get_reward_window_exchange: "兑换奖品",
        cannon_get_reward_window_title: "兑换奖品",
        cannon_item_window_btn_regain: "Regain",
        cannon_item_window_btn_send: "赠送",
        cannon_item_window_title: "兑换奖品",
        cannon_main_window_no_ball: "没有炮弹!",
        cannon_main_window_refresh_check: "使用戒指吗，现在还有{0}个礼盒!",
        cannon_main_window_refresh_time: "自动刷新\n",
        cannon_meesage_window_collect: "<color=#F48B03>{0}</color><color=#7E4B27>送给你道具 </color><color=#19B8B2>{1}</color>",
        cannon_message_window_no_message: "没有消息.",
        cannon_message_window_send: "<color=#7E4B27>你送给了</color><color=#F48B03>{0}</color><color=#7E4B27>道具 </color><color=#19B8B2>{1}</color>",
        cannon_message_window_title: "消息",
        cannon_name: "打城堡",
        cannon_send_item_window_choosed_friend: "选择好友",
        cannon_send_item_window_choosed_item: "选择道具",
        cannon_send_item_window_send: "赠送",
        cannon_send_item_window_title: "赠送",
        cannon_shop_window_title: "想要更多炮弹?",
        cannon_use_magic_item_window_cancel: "取消",
        cannon_use_magic_item_window_confirm: "确认",
        collectionFreeChest: "免费宝箱",
        communityCardNoCards: "暂未收到好友的卡片",
        communityCommunity: "社区",
        facebookF: "f",
        gifts_collect: "收取",
        gifts_collect_all: "全部赠送/领取",
        gifts_collect_all2: "全部领取",
        gifts_collect_coins: "已获得每日金币奖励 {0}/{1}",
        gifts_collect_spins: "已获得每日体力奖励 {0}/{1}",
        gifts_default_explain: "获得免费体力",
        gifts_default_name: "邀请好友",
        gifts_explain_card_cantcollect: "你必须解锁第{0}个地图来获得这张卡牌",
        gifts_explain_card_collect: "送你一张卡牌",
        gifts_explain_card_send: "赠送卡牌给你的好友",
        gifts_explain_coin_collect: "送给你{0}金币",
        gifts_explain_coin_send: "赠送免费金币",
        gifts_explain_spin_collect: "送给你{0}体力",
        gifts_explain_spin_send: "赠送免费体力",
        gifts_invite: "邀请",
        gifts_send: "赠送",
        gifts_tab0: "免费体力",
        gifts_tab1: "免费金币",
        gifts_tab2: "卡牌",
        gifts_title: "礼物",
        heist_main_window_cannot_buy: "购买上一步的礼包解锁",
        heist_main_window_free: "免费获得",
        heist_main_window_title: "购买来获取进一步的礼包",
        inviteNeedMoreSpins: "需要更多的体力？",
        inviteUpper: "邀请",
        invite_addnumber_type0: "+{0}",
        invite_invite: "邀请",
        invite_lineA: "<outline color=#000000 width=1><color=#FFFFFF>邀请的好友解锁第二个房间时\n即可获得</color><color=#4aff5f>{0}免费体力</color></outline>",
        invite_lineApp: "<outline color=#000000 width=1><color=#FFFFFF>邀请的好友进行游戏即可获得</color><color=#4aff5f>{0} 免费体力</color></outline>",
        invite_note: "你的好友用Facebook账号登入后您就可以获得奖励啦",
        invite_title: "想要更多体力吗？",
        jigsaw_friends_window_no_friends: "无好友",
        jigsaw_friends_window_search_pre: "查找好友名",
        jigsaw_friends_window_send: "赠送",
        jigsaw_friends_window_title: "好友",
        jigsaw_news_window_news_collect: "<color=#F48B03>{0}</color><color=#7E4B27>送给了你一张碎片</color><color=#19B8B2>{1}</color>",
        jigsaw_news_window_news_send: "<color=#7E4B27>你送给</color><color=#F48B03>{0}</color><color=#7E4B27>一张碎片</color><color=#19B8B2>{1}</color>",
        jigsaw_news_window_no_news: "没有消息",
        jigsaw_news_window_title: "消息",
        jigsaw_window_complete: "填满",
        jigsaw_window_send: "赠送",
        jigsaw_window_title: "拼图",
        jigsaw_window_universal_tip: "选择一块替换",
        jigsaw_window_use: "使用",
        jigsaw_window_used: "已有",
        loadResError: "未能载入资源，再试一次？",
        map_comming_soon: "敬请期待",
        map_title: "{0}. {1}",
        menu_0_play: "金币机",
        menu_1_village: "房间",
        menu_2_buy: "商店",
        menu_3_daily: "每日奖励",
        menu_4_shop: "房间升级",
        menu_5_news: "消息",
        menu_6_gifts: "礼物",
        menu_7_card: "卡牌",
        menu_8_map: "地图",
        menu_9_leaderboard: "排行榜",
        menu_10_invite: "邀请好友",
        menu_11_setting: "设置",
        menu_title: "菜单",
        messageNoMail: "暂未收到邮件",
        messageNoMessage: "暂未收到信息",
        mini_game_coinhit_btn_end: "获得奖励",
        mini_game_coinhit_btn_next_round: "下一轮",
        mini_game_coinhit_go: "出发",
        mini_game_coinhit_info: "一个获得金币体力和宝箱的好机会！",
        mini_game_coinhit_info_title: "奖励列表",
        mini_game_coinhit_manual_end: "0",
        mini_game_coinhit_manual_next_round: "游戏卡住了？你可以开始下一轮",
        mini_game_coinhit_rank_info: "击碎累计{0}",
        mini_game_coinhit_time: "在{0}后结束",
        mini_game_end: "游戏结束",
        mini_game_fail: "游戏加载失败，请重试",
        mini_game_rank_window_no_ranks: "没有排名",
        mini_game_rank_window_title: "排名",
        minigame_buy_ticket_window_title: "再来一局？",
        minigame_coinhit_second_title: "调整射击角度来击碎更多的色块获得更多奖励！",
        minigame_coinhit_title: "金币大赢家",
        minigame_gameover: "游戏结束",
        minigame_start_game: "开始",
        minigame_time: "{0}后结束",
        multiplyX: "x",
        multiplyx: "x",
        quest_center_window_check: "签到",
        quest_center_window_check_do: "签到",
        quest_center_window_check_done: "已签到",
        quest_center_window_daily: "日常",
        quest_center_window_daily_get: "领取",
        quest_center_window_daily_go: "出发",
        quest_center_window_day_1: "第一天",
        quest_center_window_day_2: "第二天",
        quest_center_window_day_3: "第三天",
        quest_center_window_day_4: "第四天",
        quest_center_window_day_5: "第五天",
        quest_center_window_day_6: "第六天",
        quest_center_window_day_7: "第七天",
        quest_center_window_invite: "邀请",
        quest_center_window_main_quest_goal_reward: "目标：{0}\n奖励：{1}",
        quest_center_window_main_quest_name: "主线任务：{0}",
        quest_center_window_month_box_7: "7日",
        quest_center_window_month_box_14: "14日",
        quest_center_window_month_box_21: "21日",
        quest_center_window_month_box_28: "28日",
        quest_center_window_refresh_dialog: "任务已经重置，请重新打开窗口",
        quest_center_window_refreshin: "重置时间",
        quest_center_window_title: "任务中心",
        revengeNoFriends: "还没有好友！",
        revenge_attack: "攻击",
        revenge_random: "随机",
        revenge_revenge: "复仇",
        revenge_title_attack: "攻击你的好友",
        revenge_title_revenge: "复仇",
        servantADFree: "免费",
        settingLogOut: "登出",
        settingUid: "Uid: ",
        settingVersion: "版本: ",
        setting_english: "英语",
        setting_general: "通用",
        setting_language: "语言",
        setting_language_de: "Deutsch",
        setting_language_en: "English",
        setting_language_es: "Español",
        setting_language_fr: "Français",
        setting_language_title: "语言",
        setting_language_zh: "中文",
        setting_like: "喜欢",
        setting_likeus: "喜欢这个游戏\n别错过这些项目和礼物哦",
        setting_music: "音乐",
        setting_notifications: "通知",
        setting_privacy: "隐私政策",
        setting_raid: "偷却 和 攻击",
        setting_sound: "音效",
        setting_support: "支持",
        setting_terms: "制作团队",
        setting_title: "设置",
        setting_tutorial: "引导",
        shopBestSeller: "热卖",
        shopCardInfoBuy: "买",
        shopLevelBonus: "等级奖励",
        slotServantAdTip: "给我喂食!",
        villageTownReward: "奖励",
        village_news_expire: "{0}后失效",
        village_news_log_hammer: "攻击了你的房间",
        village_news_log_invite: "加入了 Coin Room",
        village_news_log_noraid: "未能偷走你{0}金币",
        village_news_log_pig: "从你的房间偷了{0}金币",
        village_news_log_shield: "试图攻击你的房间",
        village_news_tab1: "房间",
        village_news_tab2: "邮件",
        village_news_title: "消息",
        watch_coin: "+{0} 金币",
        watch_get: "看个视频获得",
        watch_spin: "+{0} 体力",
        watch_watch: "观看",
        wxUserinfoDenyConfirm: "去授权",
        wxUserinfoDenyDes: "我们需要您的信息",
        wxUserinfoDenyTitle: "需要授权",
        wxVersionNoSupport: "此功能不支持您的设备，请前往商店更新游戏"
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/WatchGetSpinWindow.ts", ['cc', './Constant.ts', './UIWindow.ts', './CommonAssets.ts', './PlayGetAnimation.ts', './GameMainWindow.ts', './SR.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, MyCustomEvent, UIWindow, CommonAssets, PlayGetAnimation, GameMainWindow, SR, ADWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "8a6d8TzDo1HxrmqilEDp1hM", "WatchGetSpinWindow", undefined); // let UIRoot = window.UIRoot
      // //let UIWindow = UIWindow
      // let ScrollViewTool = require('ScrollViewTool')
      // let UserInfoModel = UserInfoModel


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        /** 默认的spin_add */
        DEFAULT_SPIN_ADD: 1
      };
      /**
       * WatchGetSpin界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let WatchGetSpinWindow = exports('WatchGetSpinWindow', (_dec = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class WatchGetSpinWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "add_label", _descriptor, this);

          _defineProperty(this, "spin_add_number", void 0);
        }

        onShow() {
          this.add_label.string = String.format(i18n.t("watch_spin"), this.get_spin_add_number());
        }
        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        }
        /** 点击事件：watch */


        event_watch() {
          ADWrap.ShowVideo(() => {
            let req = SR.SRUserData.finishVideoAp();
            req.SetCallBack(() => {
              this.closeAnim(() => {
                let adSpinTime = GameKit.PlayerPrefs.GetInt("adSpinTime", 0);

                if (GameKit.TimeUtil.getCurrentHalfDay() !== adSpinTime) {
                  GameKit.PlayerPrefs.SetInt("adSpinCount", 0);
                  GameKit.PlayerPrefs.SetInt("adSpinTime", GameKit.TimeUtil.getCurrentHalfDay());
                }

                let adSpinCount = GameKit.PlayerPrefs.GetInt("adSpinCount", 0);
                GameKit.PlayerPrefs.SetInt("adSpinCount", adSpinCount + 1);
                if (GameMainWindow.instance) homeView.slotPage.updateSpinAd();
                PlayGetAnimation.playAnimation({
                  startNode: homeView.node,
                  endNode: homeView.pageViewController.btnSpin.node,
                  prefab: CommonAssets.instance.energyPrefab,
                  count: C.DEFAULT_SPIN_ADD,
                  startCallback: () => {
                    homeView.slotNode.isSpining = true;
                  },
                  complete: () => {
                    homeView.slotNode.showSpinAddNumAnim(1);
                    homeView.slotNode.makeIdle();
                    eventCenter.emit(MyCustomEvent.CanChangeSpin);
                  }
                });
              });
            });
            req.Send();
          }, "WatchGetSpinWindow");
        }
        /** 获取spin_add的值 */


        get_spin_add_number() {
          // 目前默认为1；未来可能会根据当前用户状态来获取meta数据
          this.spin_add_number = C.DEFAULT_SPIN_ADD;
          return this.spin_add_number;
        }

      }, _defineProperty(_class3, "windowPath", "Other/WatchGetSpinWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "add_label", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SpineAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, sp, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sp = module.sp;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "8b094oPLWJHAoFdEC4HPWvW", "SpineAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SpineAnim = exports('default', (_dec = property(sp.Skeleton), ccclass(_class = (_class2 = (_temp = class SpineAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "skeleton", _descriptor, this);

          _defineProperty(this, "node", void 0);

          _defineProperty(this, "isPlaying", void 0);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.node.active = false;
          this.isPlaying = false;
        }

        start() {}

        playOnce(animationName, cb) {
          this.isPlaying = true;
          this.node.active = true;
          this.skeleton.clearTrack(0);
          this.skeleton.setAnimation(0, animationName, false); // this.skeleton.setToSetupPose()

          this.skeleton.setCompleteListener(() => {
            this.node.active = false;
            this.isPlaying = false;

            if (cb != null) {
              cb();
            }
          });
        }

        playLoop(animationName) {
          this.isPlaying = true;
          this.node.active = true;
          this.skeleton.setAnimation(0, animationName, true);
          this.skeleton.setToSetupPose();
        }

        stop() {
          if (this.isPlaying) {
            this.isPlaying = false;
            this.node.active = false;
          }
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "skeleton", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardNewFriendsWindow.ts", ['cc', './UIWindow.ts', './CardNewFriendItem.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, EditBox, _decorator, instantiate, UIWindow, CardNewFriendItem, Game, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      EditBox = module.EditBox;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CardNewFriendItem = module.CardNewFriendItem;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "8b608zEVYZJF5IhbuqoTFtV", "CardNewFriendsWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CardNewFriendsWindow = exports('CardNewFriendsWindow', (_dec = ccclass("CardNewFriendsWindow"), _dec2 = property(Node), _dec3 = property(EditBox), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec(_class = (_class2 = (_temp = _class3 = class CardNewFriendsWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "content", _descriptor, this);

          _initializerDefineProperty(this, "editBox", _descriptor2, this);

          _initializerDefineProperty(this, "item", _descriptor3, this);

          _initializerDefineProperty(this, "noFriendLabelNode", _descriptor4, this);

          _initializerDefineProperty(this, "scrollViewBg", _descriptor5, this);

          _defineProperty(this, "cardMeta", null);
        }

        onShow(showParams) {
          this.cardMeta = showParams.cardMeta;
          this.initFriendsList();
        }

        initFriendsList() {
          const friendList = Game.SUser.FriendsList();
          if (!friendList) return;

          if (Object.keys(friendList).length === 0) {
            this.noFriendLabelNode.active = true;
            this.scrollViewBg.active = false;
            this.item.active = false;
            return;
          }

          Object.keys(friendList).forEach((key, index) => {
            const newFriendItem = instantiate(this.item);
            const cardFriendItem = newFriendItem.getComponent(CardNewFriendItem);
            cardFriendItem.setItem(friendList[key], this.cardMeta || null, this);
            this.content.addChild(newFriendItem);
            newFriendItem.active = true;
          }); // friendList.forEach((friendData: any, index: number) => {
          // 	const newFriendItem: Node = instantiate(this.item);
          // 	const cardFriendItem: CardNewFriendItem = newFriendItem.getComponent(CardNewFriendItem);
          // 	cardFriendItem.setItem(friendData, index, this.cardMeta || null);
          // 	this.content.addChild(newFriendItem);
          // });
          // this.item.destroy();
        }

        event_close() {
          this.closeAnim();
        }

        event_editBegan() {
          this.editBox.placeholder = "";
        }

        event_editEnded() {
          this.editBox.placeholder = i18n.t("FriendsModelPlaceHolder");
        }

        event_search() {
          this.content.children.forEach((friendItem, index) => {
            const cardFriendItem = friendItem.getComponent(CardNewFriendItem);
            cardFriendItem.match(this.editBox.textLabel.string);
          });
        }

      }, _defineProperty(_class3, "windowPath", "newCard/CardNewFriendWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "content", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "editBox", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "noFriendLabelNode", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "scrollViewBg", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardInfoWindow.ts", ['cc', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "8c047jlQEZCzYSkGZ6q6Mt3", "CardInfoWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      let CardInfoWindow = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class CardInfoWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "page_list", _descriptor, this);

          _initializerDefineProperty(this, "page_dot_list", _descriptor2, this);

          _defineProperty(this, "page_index", 0);
        }

        onShow() {
          // 初始化,显示第0页
          this.page_index = 0;
          this.page_list.forEach((v, i) => {
            v.active = i === this.page_index;
            this.page_dot_list[i].active = v.active;
          });
        }
        /** @type {cc.Node[]} */

        /**
         * 带动画的换页
         * @param {number} index 页面index
         */


        change_to_index(index) {
          let old_index = this.page_index;
          let new_index = (index + this.page_list.length) % this.page_list.length; // 防止负数求模时计算错误

          if (old_index === new_index) {
            return;
          }

          this.page_index = new_index; // page-list,此处可以修改自定义动画

          this.page_list[old_index].active = false;
          this.page_list[new_index].active = true; // page-dot-list

          this.page_dot_list.forEach((v, i) => {
            v.active = i === new_index;
          });
        }
        /** 下一页 */


        event_next() {
          this.change_to_index(this.page_index + 1);
        }
        /** 上一页 */


        event_before() {
          this.change_to_index(this.page_index - 1);
        }

        event_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Card/NewCardInfoWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "page_list", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "page_dot_list", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AppGame.ts", ['cc', './CCE_Component.ts', './global.ts', './Logs.ts', './Content.ts', './User.ts', './ChatMgr.ts', './UserVillage.ts', './DialogWindow.ts', './GetRewardWindow.ts', './ActivitySlotSymbolRankRewardWindow.ts', './ActivitySlotSymbolRankWindow.ts', './TutorialManager.ts', './SimpleRewardWindow.ts', './UserActivity.ts', './UserCard.ts', './UserItems.ts', './UserRecord.ts', './UserServant.ts', './UserSlot.ts', './UserStatus.ts', './UserTutorial.ts', './SdkManager.ts', './HomeView.ts', './GameMainWindow.ts', './SR.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './NativeWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, sys, EventTarget, setDisplayStats, game, Game, CCE_Component, G, Logs, Content, User, ChatMgr, UserVillage, DialogWindow, GetRewardWindow, ActivitySlotSymbolRankRewardWindow, ActivitySlotSymbolRankWindow, TutorialManager, SimpleRewardWindow, UserActivity, UserCard, UserItems, UserRecord, UserServant, UserSlot, UserStatus, UserTutorial, SdkManager, HomeView, GameMainWindow, SR, UIRoot, ActivityManager, Game$1, NativeWrap, PaymentWrap, GameKit, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      sys = module.sys;
      EventTarget = module.EventTarget;
      setDisplayStats = module.setDisplayStats;
      game = module.game;
      Game = module.Game;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      User = module.User;
    }, function (module) {
      ChatMgr = module.ChatMgr;
    }, function (module) {
      UserVillage = module.UserVillage;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      GetRewardWindow = module.GetRewardWindow;
    }, function (module) {
      ActivitySlotSymbolRankRewardWindow = module.ActivitySlotSymbolRankRewardWindow;
    }, function (module) {
      ActivitySlotSymbolRankWindow = module.ActivitySlotSymbolRankWindow;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      SimpleRewardWindow = module.SimpleRewardWindow;
    }, function (module) {
      UserActivity = module.UserActivity;
    }, function (module) {
      UserCard = module.UserCard;
    }, function (module) {
      UserItems = module.UserItems;
    }, function (module) {
      UserRecord = module.UserRecord;
    }, function (module) {
      UserServant = module.UserServant;
    }, function (module) {
      UserSlot = module.UserSlot;
    }, function (module) {
      UserStatus = module.UserStatus;
    }, function (module) {
      UserTutorial = module.UserTutorial;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      HomeView = module.HomeView;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game$1 = module.Game;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "8c282AWq8pDRZNlzAROpwhM", "AppGame", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AppGame = exports('default', ccclass(_class = (_temp = _class2 = class AppGame extends CCE_Component {
        set isDev(v) {
          if (v == this._isDev) return;
          this._isDev = !!v;
          sys.localStorage.setItem("isDebug", +this._isDev);
        }

        get isDev() {
          if (this._isDev == void 0) {
            this._isDev = !!+sys.localStorage.getItem("isDebug");
          }

          return this._isDev;
        } // LIFE-CYCLE CALLBACKS:


        constructor() {
          super();

          _defineProperty(this, "logined", void 0);

          _defineProperty(this, "_hbid", void 0);

          _defineProperty(this, "activityItemCache", void 0);

          _defineProperty(this, "activityItemCacheTid", void 0);

          _defineProperty(this, "prelogined", void 0);

          _defineProperty(this, "leaveTime", void 0);

          _defineProperty(this, "logData", []);

          _defineProperty(this, "isSignInReward", false);

          _defineProperty(this, "_isDev", void 0);
        }

        onLoad() {
          Logs.Log("game start");
          AppGame.instance = this;
          Reflect.defineProperty(globalThis, "appGame", {
            value: this,
            configurable: true
          });
          Reflect.defineProperty(globalThis, "eventCenter", {
            value: new EventTarget(),
            configurable: true
          });

          if (SdkManager.IsNative()) {
            if (jsb.fileUtils.isFileExist("version.json")) {
              let str = jsb.fileUtils.getStringFromFile("version.json");

              if (str) {
                let json = JSON.parse(str);
                console.log("native_v", json["native_v"]);
                console.log("platform", json["platform"]);
                console.log("test_mode", json["test_mode"]);
                Reflect.defineProperty(globalThis, "$tp_version", {
                  value: json["native_v"] || "",
                  configurable: true
                });
                Reflect.defineProperty(globalThis, "$tp_platform", {
                  value: json["platform"] || "",
                  configurable: true
                });
                Reflect.defineProperty(globalThis, "$tp_test_mode", {
                  value: json["test_mode"] === "true",
                  configurable: true
                });
              }
            }
          }

          let isDebug = +sys.localStorage.getItem("isDebug") || 0;
          setDisplayStats(!!isDebug); // if (window.console && console.log && !PREVIEW) {
          // 	const oldConsole = console.log;
          // 	console.log = (...data) => {
          // 		oldConsole.apply(this, data);
          // 		appGame.logData.push(data);
          // 		eventCenter.emit(MyCustomEvent.ConsoleNewLog, data, appGame.logData.length - 1);
          // 	}
          // }
        }

        start() {
          game.on(Game.EVENT_HIDE, () => {
            this.leaveTime = GameKit.TimeUtil.getCurrentTime();
          }, this);
          game.on(Game.EVENT_SHOW, () => {
            setTimeout(() => {
              if (this.logined && AppMain.instance.tutorialManager.isTutorilaFinished) {
                if (GameKit.TimeUtil.getCurrentTime() - this.leaveTime < 120) {
                  SR.SRUserData.heartBeat().Send();
                  return;
                }

                if (GameKit.TimeUtil.getCurrentTime() - this.leaveTime > GameKit.TimeUtil.HourInSecond * 1) {
                  this.logout();
                  return;
                }

                this.reqUserData();
              }
            }, 100);
          }, this);
        } //登出


        logout() {
          var _homeView;

          this.logined = false;
          Game$1.SUser = new User();
          Game$1.SUserItems = new UserItems();
          Game$1.SUserVillage = new UserVillage();
          Game$1.SUserSlot = new UserSlot();
          Game$1.SUserTutorial = new UserTutorial();
          Game$1.SUserActivity = new UserActivity();
          Game$1.SUserCard = new UserCard();
          Game$1.SUserStatus = new UserStatus();
          Game$1.SUserServant = new UserServant();
          Game$1.SUserRecord = new UserRecord();
          (_homeView = homeView) === null || _homeView === void 0 ? void 0 : _homeView.Clear();
          homeView && (homeView.node.active = true);
          GameKit.DataCache.Clear();
          GameKit.WebEvent.Clear();
          GameKit.GameEvent.Clear();
          ChatMgr.Clear();
          TutorialManager.Clear();
          ActivityManager.Clear();
          GameKit.ClockUtil.Clear();
          GameKit.BackKeyManager.Clear();
          NativeWrap.init();

          if (this._hbid) {
            clearTimeout(this._hbid);
            this._hbid = null;
          }

          this.activityItemCache = [];
          if (!!this.activityItemCacheTid) clearTimeout(this.activityItemCacheTid);
          this.activityItemCacheTid = null;
          HomeView.isFirstEnter = false;
          UIRoot.instance.stopShowWindow = true;
          AppMain.instance.HasError = false;
          AppMain.instance.unschedule(PaymentWrap.GetOnlineList);
          UIRoot.instance.openWindow("LoginWindow", null);
        } //预登陆


        prelogin() {
          if (this.prelogined) return;
          this.prelogined = true;
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.MessageEvent, "Game", data => {
            //记录message数字
            let NewMessageNum = GameKit.DataCache.GetData("NewMessageNum");
            if (NewMessageNum == null) NewMessageNum = 0;
            NewMessageNum++;
            GameKit.DataCache.SetData("NewMessageNum", NewMessageNum);
            if (!this.logined) return;

            if (data.isFriend && !data.user) {
              data.user = Game$1.SUser.FriendsList()[data.userId].getUserInfo();
            }

            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.MessageEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.GiftEvent, "Game", data => {
            //记录gifts数字
            let GiftsNum = GameKit.DataCache.GetData("GiftsNum");
            if (GiftsNum == null) GiftsNum = 0;
            GiftsNum++;
            GameKit.DataCache.SetData("GiftsNum", GiftsNum);
            if (!this.logined) return;
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.GiftEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.CardChest, "Game", data => {
            GameKit.DataCache.SetData("UserCardChest", data.chest);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.SlotCollectRankEvent, "Game", data => {
            GameKit.DataCache.SetData("SlotCollectRankEnd", true);
            if (!this.logined) return;
            UIRoot.instance.openChildWindow(ActivitySlotSymbolRankWindow, {
              showCallback: wnd => {
                wnd.addOnCloseFunc(() => {
                  UIRoot.instance.openChildWindow(ActivitySlotSymbolRankRewardWindow);
                });
              }
            });
          });
        } //登陆


        login() {
          this.logined = true;
          this.prelogined = null;
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ApEvent, "Game", data => {
            Game$1.SUser.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.ApEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.CoinEvent, "Game", data => {
            Game$1.SUser.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.CoinEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ShieldEvent, "Game", data => {
            Game$1.SUser.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.ShieldEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.TimeShieldEvent, "Game", data => {
            Game$1.SUser.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.TimeShieldEvent, data);
          }); // GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.StarEvent, "Game", function(data) {
          //     Game.SUser.updateData(data)
          // })

          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ToraidEvent, "Game", data => {
            Game$1.SUserSlot.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.ToraidEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.VillageEvent, "Game", data => {
            Game$1.SUserVillage.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.VillageEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ActivityEvent, "Game", data => {
            Game$1.SUserActivity.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.ActivityEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ActivityItem, "Game", data => {
            let contents = [];
            data.contents.forEach(x => {
              contents.push(Content.FromContent(x));
              this.activityItemCache.push(Content.FromContent(x));
            }); //整合弹出 防止弹出过多

            if (!!this.activityItemCacheTid) clearTimeout(this.activityItemCacheTid);
            this.activityItemCacheTid = setTimeout(() => {
              let conts = Content.Merge(this.activityItemCache);
              UIRoot.instance.openChildWindow(GetRewardWindow, {
                contents: conts
              });
              this.activityItemCacheTid = null;
              this.activityItemCache = [];
            }, 1800);
            data.contents = contents;
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.ActivityItem, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.TaskCompleteCount, "Game", data => {
            GameKit.DataCache.SetData("UserTaskCompleteCount", data.count || 0);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.TaskCompleteCount, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.GetReward, "Game", data => {
            let rewards = [];
            data.rewards.forEach(x => {
              rewards.push(Content.FromContent(x));
            });

            if (!this.isSignInReward) {
              if (data.simple) UIRoot.instance.openChildWindow(SimpleRewardWindow, {
                contents: rewards
              });else UIRoot.instance.openChildWindow(GetRewardWindow, {
                contents: rewards
              });
            }
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.StatusEvent, "Game", data => {
            Game$1.SUserStatus.updateData(data.userdata);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.StatusEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.RecordEvent, "Game", data => {
            Game$1.SUserRecord.updateData(data.userdata);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.RecordEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ItemsEvent, "Game", data => {
            Game$1.SUserItems.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.ItemsEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ServantEvent, "Game", data => {
            Game$1.SUserServant.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.ServantEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.CardEvent, "Game", data => {
            Game$1.SUserCard.updateData(data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.CardEvent, data);
          });
          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.PresentEvent, "Game", data => {
            GameKit.DataCache.SetData("UserPresentList", data);
            GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.PresentEvent, data);
          });

          var _heartBeat = () => {
            if (this._hbid) clearTimeout(this._hbid);
            this._hbid = setTimeout(() => {
              setTimeout(() => {
                if (this.logined && AppMain.instance.tutorialManager.isTutorilaFinished) {
                  SR.SRUserData.heartBeat().Send();
                }

                _heartBeat();
              }, 100);
            }, 300000);
          };

          _heartBeat(); // ChatMgr.init();
          // 任务刷新倒计时，服务器时间0点时自动关闭窗口


          GameKit.ClockUtil.RegisterClock("AppGameZero", 0, 0, () => {
            // 服务器时间0点时自动关闭窗口
            let questwindow = UIRoot.instance.GetWindow("QuestCenterWindow");

            if (questwindow) {
              questwindow.closeAnim(() => {
                UIRoot.instance.openChildWindow(DialogWindow, {
                  msg: i18n.t("quest_center_window_refresh_dialog")
                });
              });
            }

            SR.SRTask.getTaskList().Send();
            let req = SR.SRSign.getSignData();
            req.SetCallBack(() => {
              if (homeView != null) homeView.slotPage.updateQuestBadge();
            });
            req.Send();
            SR.SRCard.getUserCard().Send();

            if (homeView != null) {
              homeView.villagePage.updateAdCoin();
              homeView.slotPage.updateSpinAd();
            }
          });
          GameKit.ClockUtil.init();
          SdkManager.logined();
        }

        reqUserData() {
          let breqb = [SR.SRSlot.getUserSlot()];
          let reqb = [SR.SRUserData.getData(), SR.SRVillage.getUserVillage()];
          let reqGameData = new GameKit.BatchRequest(reqb, breqb);
          reqGameData.SetSilence(false);
          reqGameData.SetCallBack(() => {
            if (homeView && homeView.villageNode) homeView.villageNode.Flush();
            if (homeView && homeView.slotNode && homeView.slotNode.userinfo) homeView.slotNode.userinfo.Flush();
            if (GameMainWindow.instance) GameMainWindow.instance.userinfo.Flush();
          });
          reqGameData.SetErrorCallBack(e => {
            this.logout();
          });
          reqGameData.Send();
        }

        onDestroy() {
          console.log("onDestroy");
        }

        addCard(cardId) {
          var _homeView$cardAllSetW;

          const re = new XMLHttpRequest();
          const isTestServer = !!parseInt(sys.localStorage.getItem("isTestServer"));
          const url = isTestServer ? G.GameConfig.testServer : G.GameConfig.formalServer;
          re.open("POST", url + "/__gm__/", true);
          re.setRequestHeader("Content-Type", "application/json");

          re.onload = function () {
            console.log(re.response);
          };

          const body = {
            method: "addItem",
            userId: [Game$1.SUser.UserId().toString()],
            contents: `4=${cardId}=1`
          };
          re.send(JSON.stringify(body));
          (_homeView$cardAllSetW = homeView.cardAllSetWindow) === null || _homeView$cardAllSetW === void 0 ? void 0 : _homeView$cardAllSetW.flushData();
        }

      }, _defineProperty(_class2, "instance", null), _defineProperty(_class2, "inited", false), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SprCamera.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, RenderTexture, _decorator, Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      RenderTexture = module.RenderTexture;
      _decorator = module._decorator;
      Component = module.Component;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "8e862CCf/FD/Jmm7jhSLj9V", "SprCamera", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SprCamera = exports('default', (_dec = ccclass("SprCamera"), _dec2 = property(RenderTexture), _dec(_class = (_class2 = (_temp = class SprCamera extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "renderTexture", _descriptor, this);

          _defineProperty(this, "sprite", void 0);
        }

        onLoad() {// view.sc
          // this.sprite = this.getComponent(Sprite);
          // this.sprite.spriteFrame = new SpriteFrame();
          // this.sprite.spriteFrame.texture = this.renderTexture;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "renderTexture", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SpinAnim.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './SoundManager.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Vec3, CCE_Component, CCEaseTypes, SoundManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Vec3 = module.Vec3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      SoundManager = module.SoundManager;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "8fb07bsdQJAsaZjuIOiIM87", "SpinAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SpinAnim = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class SpinAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "light", _descriptor, this);

          _initializerDefineProperty(this, "spin", _descriptor2, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        play(posX, posY, waitTime, cb) {
          var self = this;
          this.node.active = true;
          this.light.scaleX = 0.2;
          this.light.scaleY = 0.2;
          this.spin.scaleX = 0;
          this.spin.scaleY = 0;
          this.light.runAction(ccAction.scaleTo(0.2, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          this.spin.stopAllActions();
          this.spin.runAction(ccAction.scaleTo(0.2, 1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          self.node.x = 0;
          self.node.y = 0;
          self.node.scale = Vec3.ONE;
          let duration = 0.8;
          let seq3 = ccAction.sequence(ccAction.delayTime(waitTime), ccAction.spawn(ccAction.moveBy(duration, posX, 0), ccAction.moveBy(duration, 0, posY, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)), ccAction.scaleTo(duration, 0.1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeQuadraticActionIn))), ccAction.callFunc(function () {
            // let seq3 = ccAction.sequence(ccAction.delayTime(waitTime), ccAction.spawn(ccAction.moveBy(duration, posX, 0), ccAction.moveBy(duration, 0, posY, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn){
            if (cb != null) {
              cb();
            }

            self.node.active = false;
            SoundManager.playSound("spins_bar");
          }));
          this.node.runAction(seq3);
        }

        stop() {
          this.light.stopAllActions();
          this.spin.stopAllActions();
          this.node.stopAllActions();
          this.node.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "light", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spin", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/polyglot.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "90321FTV1JMiow9WsbU7pb6", "polyglot", undefined); //     (c) 2012-2016 Airbnb, Inc.
      //
      //     polyglot.js may be freely distributed under the terms of the BSD
      //     license. For all licensing information, details, and documention:
      //     http://airbnb.github.com/polyglot.js
      //
      //
      // Polyglot.js is an I18n helper library written in JavaScript, made to
      // work both in the browser and in Node. It provides a simple solution for
      // interpolation and pluralization, based off of Airbnb's
      // experience adding I18n functionality to its Backbone.js and Node apps.
      //
      // Polylglot is agnostic to your translation backend. It doesn't perform any
      // translation; it simply gives you a way to manage translated phrases from
      // your client- or server-side JavaScript application.
      //


      class Polyglot {
        // private replace = String.prototype.replace
        constructor(options) {
          _defineProperty(this, "phrases", void 0);

          _defineProperty(this, "currentLocale", void 0);

          _defineProperty(this, "allowMissing", void 0);

          _defineProperty(this, "warn", void 0);

          options = options || {};
          this.phrases = {};
          this.extend(options.phrases || {});
          this.currentLocale = options.locale || 'en';
          this.allowMissing = !!options.allowMissing;
          this.warn = options.warn || warn;
        }

        locale(newLocale) {
          if (newLocale) this.currentLocale = newLocale;
          return this.currentLocale;
        }

        extend(morePhrases, prefix) {
          var phrase;

          for (var key in morePhrases) {
            if (morePhrases.hasOwnProperty(key)) {
              phrase = morePhrases[key];
              if (prefix) key = prefix + '.' + key;

              if (typeof phrase === 'object') {
                this.extend(phrase, key);
              } else {
                this.phrases[key] = phrase;
              }
            }
          }
        }

        unset(morePhrases, prefix) {
          var phrase;

          if (typeof morePhrases === 'string') {
            delete this.phrases[morePhrases];
          } else {
            for (var key in morePhrases) {
              if (morePhrases.hasOwnProperty(key)) {
                phrase = morePhrases[key];
                if (prefix) key = prefix + '.' + key;

                if (typeof phrase === 'object') {
                  this.unset(phrase, key);
                } else {
                  delete this.phrases[key];
                }
              }
            }
          }
        }

        clear() {
          this.phrases = {};
        }

        replace(newPhrases) {
          this.clear();
          this.extend(newPhrases);
        }

        t(key, options) {
          var phrase, result;
          options = options == null ? {} : options; // allow number as a pluralization shortcut

          if (typeof options === 'number') {
            options = {
              smart_count: options
            };
          }

          if (typeof this.phrases[key] === 'string') {
            phrase = this.phrases[key];
          } else if (typeof options._ === 'string') {
            phrase = options._;
          } else if (this.allowMissing) {
            phrase = key;
          } else {
            this.warn('Missing translation for key: "' + key + '"');
            result = key;
          }

          if (typeof phrase === 'string') {
            options = clone(options);
            result = choosePluralForm(phrase, this.currentLocale, options.smart_count);
            result = interpolate(result, options);
          }

          return result;
        }

        has(key) {
          return key in this.phrases;
        }

      }

      exports('Polyglot', Polyglot);

      _defineProperty(Polyglot, "VERSION", '1.0.0');

      var replace = String.prototype.replace; // #### Pluralization methods
      // The string that separates the different phrase possibilities.

      var delimeter = '||||'; // Mapping from pluralization group plural logic.

      var pluralTypes = {
        chinese: function (n) {
          return 0;
        },
        german: function (n) {
          return n !== 1 ? 1 : 0;
        },
        french: function (n) {
          return n > 1 ? 1 : 0;
        },
        russian: function (n) {
          return n % 10 === 1 && n % 100 !== 11 ? 0 : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20) ? 1 : 2;
        },
        czech: function (n) {
          return n === 1 ? 0 : n >= 2 && n <= 4 ? 1 : 2;
        },
        polish: function (n) {
          return n === 1 ? 0 : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20) ? 1 : 2;
        },

        icelandic(n) {
          return n % 10 !== 1 || n % 100 === 11 ? 1 : 0;
        }

      }; // Mapping from pluralization group to individual locales.

      var pluralTypeToLanguages = {
        chinese: ['fa', 'id', 'ja', 'ko', 'lo', 'ms', 'th', 'tr', 'zh'],
        german: ['da', 'de', 'en', 'es', 'fi', 'el', 'he', 'hu', 'it', 'nl', 'no', 'pt', 'sv'],
        french: ['fr', 'tl', 'pt-br'],
        russian: ['hr', 'ru'],
        czech: ['cs', 'sk'],
        polish: ['pl'],
        icelandic: ['is']
      };

      function langToTypeMap(mapping) {
        var type,
            langs,
            l,
            ret = {};

        for (type in mapping) {
          if (mapping.hasOwnProperty(type)) {
            langs = mapping[type];

            for (l in langs) {
              ret[langs[l]] = type;
            }
          }
        }

        return ret;
      } // Trim a string.


      var trimRe = /^\s+|\s+$/g;

      function trim(str) {
        return replace.call(str, trimRe, '');
      } // Based on a phrase text that contains `n` plural forms separated
      // by `delimeter`, a `locale`, and a `count`, choose the correct
      // plural form, or none if `count` is `null`.


      function choosePluralForm(text, locale, count) {
        var ret, texts, chosenText;

        if (count != null && text) {
          texts = text.split(delimeter);
          chosenText = texts[pluralTypeIndex(locale, count)] || texts[0];
          ret = trim(chosenText);
        } else {
          ret = text;
        }

        return ret;
      }

      function pluralTypeName(locale) {
        var langToPluralType = langToTypeMap(pluralTypeToLanguages);
        return langToPluralType[locale] || langToPluralType['en'];
      }

      function pluralTypeIndex(locale, count) {
        return pluralTypes[pluralTypeName(locale)](count);
      } // ### interpolate
      //
      // Does the dirty work. Creates a `RegExp` object for each
      // interpolation placeholder.


      var dollarRegex = /\$/g;
      var dollarBillsYall = '$$$$';

      function interpolate(phrase, options) {
        for (var arg in options) {
          if (arg !== '_' && options.hasOwnProperty(arg)) {
            // Ensure replacement value is escaped to prevent special $-prefixed
            // regex replace tokens. the "$$$$" is needed because each "$" needs to
            // be escaped with "$" itself, and we need two in the resulting output.
            var replacement = options[arg];

            if (typeof replacement === 'string') {
              replacement = replace.call(options[arg], dollarRegex, dollarBillsYall);
            } // We create a new `RegExp` each time instead of using a more-efficient
            // string replace so that the same argument can be replaced multiple times
            // in the same phrase.


            phrase = replace.call(phrase, new RegExp('%\\{' + arg + '\\}', 'g'), replacement);
          }
        }

        return phrase;
      } // ### warn
      //
      // Provides a warning in the console if a phrase key is missing.


      function warn(message) {
        console && console.warn && console.warn('WARNING: ' + message);
      } // ### clone
      //
      // Clone an object.


      function clone(source) {
        var ret = {};

        for (var prop in source) {
          ret[prop] = source[prop];
        }

        return ret;
      }

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/de.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "90617iCPBFOk6gdzjtfgxnT", "de", undefined);

      let de = exports('de', {
        APPNAME: "Münzraum",
        Accept: "Akzeptieren",
        ActivityAttackMasterButton: "VERSTANDEN!",
        ActivityAttackMasterButtonTip: "Wett höher und erhalte es schneller!",
        ActivityAttackMasterDes: " {0} angreifen um t\n{1} Münzen zu bekommen",
        ActivityAttackMasterDesMore: "<color=#562900>Je mehr Balken du abschließt, desto größer sind die</color> <outline color=#9E5A05 width=2><color=#F7E150>BELOHNUNGEN</color></outline>",
        ActivityAttackMasterFinal1: "Belohnung des letzten Balkens:",
        ActivityAttackMasterFinal2: "{0} Münzen!",
        ActivityAttackMasterTimeleft: "Endet in {0}",
        ActivityBuildKingDes: "Vervollständigen, um Belohnungen zu erhalten!",
        ActivityCenterTime: "Time left : {0}",
        ActivityCenterTimeEnd: "Aktivität beendet",
        ActivityCenterTitle: "Aktivitätszentrum",
        ActivityRaidMasterDes: "{0} Mal überfallen um\n{1} Münzen zu erhalten",
        ActivityShopDes: "Übrige Zeit des Angebots {0}",
        ActivitySlotCollectDes1: "Angreifen",
        ActivitySlotCollectDes2: "Angreifen Blockiert",
        ActivitySlotCollectDes3: "Raubzug",
        ActivitySlotCollectDes4: "Gediegen Raubzug",
        ActivitySlotCollectDes5: "3 Symbole treffen",
        ActivitySlotCollectRankGetJoin: "<outline color=5E2301 width=2>Holen Sie sich <img src='{ 0 } _s' />, um beizutreten</outline>",
        ActivitySlotCollectRankGetStart: "Spielen Sie, um zu sammeln",
        ActivitySlotCollectRankInfoLabel1: "<color=#88421c>Sammle <img src='{ 0 } _s'/>, um die Bestenliste zu erklimmen!</color>",
        ActivitySlotCollectRankInfoLabel2: "<outline color=#76320E width= 3>Setzen Sie mit jedem gesammelten <img src='{ 0 } _s'/> höher auf ein Vielfaches!</outline>",
        ActivitySlotCollectRankRewardDes: "Folgendes haben Sie gewonnen:",
        ActivitySlotCollectRankRewardDesLose: "Sie haben diesmal nicht gewonnen, aber Sie erhalten trotzdem einen Preis!",
        ActivitySlotCollectRankRewardEnd: "Das Turnier ist beendet",
        ActivitySlotCollectRankRewardWinner: "GEWINNER!",
        ActivitySpecialOfferCoin: "{0} Münzen",
        ActivitySpecialOfferSpin: "{0} Spins",
        ActivitySpecialOfferTitle: "Überraschungsangebot",
        ActivityTimeleft: "Übrige Zeit",
        AdNotReady: "Video ist nicht bereit!",
        ApFull: "Volll",
        ApPlus: "+{0} Spins",
        ApRecoverIn: "{0} spins in {1}",
        AppCommentBtn: "SUBMIT",
        AppCommentDes: "Tippen Sie auf einen Stern, um ihn im Geschäft zu bewerten.",
        AppCommentNo: "NICHT JETZT",
        AppCommentTitle: "Gefällt dir Coin Room?",
        AppHotUpdateFail: "Ressource konnte nicht geladen werden. Erneut versuchen?",
        AppUpdateBtn: "UPDATE",
        AppUpdateDes: "Es ist eine neue Version verfügbar! Jetzt aktualisieren!",
        AppUpdateNo: "Nein, danke",
        AppUpdateTitle: "Neues Update",
        Attack: "ANGREIFEN",
        AutoSpinTipWindowButton: "Versuchen!",
        AutoSpinTipWindowDes: "Knopf halten um zu beginnen",
        AutoSpinTipWindowTitle: "AUTO SPIN",
        AutoSpining: "Autm",
        Back: "Zurück",
        Bet: "WETTEN",
        BetRibbonText: "ALLE GEWINNE X{0}",
        BindFacebookBtn: "VERBINDEN",
        BindFacebookFreespin: "Einloggen und Gratis Spins bekommen",
        BindFacebookTip: "Wir werden nicht in Ihrem Namen posten",
        BindFacebookTitle: "Mit Facebook verbinden",
        BlackJackGameDeal: "DEAL",
        BlackJackGameDoubleDown: "DOUBLE\nDOWN",
        BlackJackGameHit: "HIT",
        BlackJackGameStand: "STAND",
        BlackJackGameSurrender: "KAPITULATION",
        BlackJackGameWatchBtn: "JETZT ANSEHEN!",
        BlackJackHelpDes1: "Beim Blackjack versuchen Sie, eine Hand mit einem höheren Wert als das Haus zu bauen, ohne über 21 zu gehen. Asse können entweder als 11 oder als 11 zählen 1. Bildkarten sind 10 wert, und alle anderen Karten sind die angezeigte Zahl wert.",
        BlackJackHelpDes2: "Zum Spielen In einer Runde müssen Sie zuerst eine Wette platzieren, indem Sie auf die Chipknöpfe tippen. Sobald Sie Ihre Wette ausgewählt haben, drücken Sie die Deal-Taste, um zu beginnen.",
        BlackJackHelpDes3: "Verwenden Sie diese Option, wenn Sie möchten eine andere Karte anfordern. Sie können so oft schlagen, wie Sie möchten, aber wenn Sie über 21 gehen, verlieren Sie.",
        BlackJackHelpDes4: "Wenn Sie fertig sind Wenn Sie Karten anfordern, können Sie stehen und das Haus an die Reihe bringen.",
        BlackJackHelpDes5: "Wenn eine Hand 2 Karten hat, sind Sie Mit dieser Option können Sie Ihren Einsatz verdoppeln und nur EINE weitere Karte für Ihre Hand erhalten.",
        BlackJackHelpDes6: "Jede Hand, die enthält Ein Ass und eine Bildkarte werden als Black Jack bezeichnet. Black Jack schlägt jede andere Hand und zahlt 3 zu 2 für den Spieler.",
        BlackJackHelpDes7: "Wenn die Hand eines Spielers dieselbe hat Wert wie das Haus, es ist ein Schub. Der Spieler erhält seinen ursprünglichen Einsatz zurück.",
        BlackJackHelpDes8: "Ein Spieler soll pleite gehen, wenn seine Hand mehr als 21 wert ist.",
        BlackJackHelpDes9: "Mit dieser Option kann ein Spieler die Hälfte seines ursprünglichen Einsatzes zurückerhalten, wenn er seine Hand verfällt.",
        BlackJackHelpDes10: "Bewegungsempfehlung hebt die Schaltfläche für die vorgeschlagene Bewegung während des Spiels hervor. Die Bewegungsempfehlung basiert auf der statistischen Stärke der Haus- und Spielerhände.",
        BlackJackHelpTitle1: "--Grundregeln--",
        BlackJackHelpTitle2: "--Spielanleitung--",
        BlackJackHelpTitle3: "--Hit--",
        BlackJackHelpTitle4: "--Stand--",
        BlackJackHelpTitle5: "--Double Down--",
        BlackJackHelpTitle6: "--Black Jack--",
        BlackJackHelpTitle7: "--Push--",
        BlackJackHelpTitle8: "--Bust--",
        BlackJackHelpTitle9: "--Kapitulation--",
        BlackJackHelpTitle10: "--Bewegungsempfehlung--",
        BlackJackTitle: "Black Jack",
        BlackJackWatchWindowDesLose: "Video ansehen, um die Hälfte der Verluste auszugleichen!",
        BlackJackWatchWindowDesWin: "Video für 100% mehr Münzen ansehen!",
        COLLECT: "EINSAMMELN",
        COLLECTED: "EINGESAMMELT",
        Cancel: "Abbrechen",
        CardAllSetWindowBottom: "- Coin Room -",
        CardAllSetWindowCompleted: "Abgeschlossen",
        CardAllSetWindowLock: "Wir beim\nZimmer {0} freigeschaltet",
        CardAllSetWindowLocked: "Gesperrt",
        CardAllSetWindowTitle: "Karte\nSammlung",
        CardAsk: "Fragen",
        CardAskCannot: "Kann nicht durch Freunde erhalten werden",
        CardAskCannotGolden: "Du kannst keine goldenen Karte durch Freunde erhalten",
        CardChestInfoWindowHigh: "Hoche Chance für:",
        CardChestInfoWindowTitle_1: "Hölzern Truhe",
        CardChestInfoWindowTitle_2: "Silberne Truhe",
        CardChestInfoWindowTitle_3: "Goldene Truhe",
        CardChestOpenWindowNew: "Neue",
        CardCollectButton: "Check it out",
        CardCollectDes: "Karte {0}\nwurde deinem Album hinzugefügt",
        CardCollectTitle: "SUPER!",
        CardInfoWindowCommon: "Normal",
        CardInfoWindowPage0_0: "Sammle Karten durch Truhen",
        CardInfoWindowPage0_1: "Truhen können Sie auch im laden kaufen",
        CardInfoWindowPage0_2: "Truhen können während der Razzien gefunden werden und wenn ein Zimmer entsperrt",
        CardInfoWindowPage1_0: "Wenn man 2 oder mehr derselben Karte besitzt, kann man sie als Geschenk an Freunde senden",
        CardInfoWindowPage1_1: "Tippe auf die Karte, um sie zu verschenken",
        CardInfoWindowPage1_2: "Du kannst auch Freunde auch nach fehlenden Karten fragen",
        CardInfoWindowPage1_3: "Sie können bis zu fünf Karten an einem Tag senden",
        CardInfoWindowPage2_0: "Stars indicate cards rarity",
        CardInfoWindowPage2_2: "Jeder Raritätstern auf einer neuen gesammelten Karte gibt Ihnen einen Stern",
        CardInfoWindowPage2_3: "Komplette Karten set und tolle Belohnungen!",
        CardInfoWindowRare: "Selten",
        CardInfoWindowTitle: "Karten-Info",
        CardOpenDes: "<color=#ffffff><outline color=#000000 width=1>Sammle Karten, um mehr <color=#ffcc00>Münzen</color> und <color=#c667ff>Spins</color> zu erhalten</color></outline>",
        CardOpenDesS: "<color=#308ae6>Sammle Karten, um mehr <color=#e67b07>Münzen</color> und <color=#006fd7>Spins</color> zu erhalten</color>",
        CardSelectCardWindowInfo: "Wähle bis zu {0} Karten!",
        CardSelectCardWindowSelected: "Deine gewählten Karten:",
        CardSelectCardWindowSuccess: "Karten erfolgreich gesendet!",
        CardSelectCardWindowTitle: "KARTEN SENDEN",
        CardSelectFriendWindowBtn: "Wähle Karte",
        CardSelectFriendWindowInfo: "Wähle 1 Freund!",
        CardSelectFriendWindowTitle: "KARTEN SENDEN",
        CardSend: "Senden",
        CardSendCannot: "Kann nicht an Freunde gesendet werden",
        CardSendCannotGolden: "Du kannst keine goldenen Karte an Freunde senden",
        CardSendCannotLeast: "Du brauchst mindestens 2 Karten zum senden",
        CardSendCannotLimit: "Du kannst heute keine Karten mehr senden",
        CardSingleSetWindowCompleted: "- SET BEENDET -",
        CardSingleSetWindowReward: "Vervollständigen, erhalten",
        CardSingleSetWindowTip: "* Tippe auf eine doppelte Karte, um sie an einen Freund zu senden",
        CardTradeButton: "GEH ZUM HANDELN!",
        CardTradeDes: "JETZT HANDELBAR!",
        CardTradeTradable: "Handelbar",
        CardTapToCollect: "Zum Sammeln tippen",
        ChatSend: "Senden",
        CoinShopLevel: "Stufe {0}",
        CoinStore: "Münzladen",
        Confirm: "Bestätigen",
        Congratulation: "Glückwunsch!",
        ContentNameActivityItem6: "Kanonenkugel",
        ContentNameActivityItemCommon: "Gegenstände",
        ContentNameAp: "Spins",
        ContentNameCard: "Karte",
        ContentNameChest1: "Holztruhe",
        ContentNameChest2: "Zaubertruhe",
        ContentNameChest3: "Goldtruhe",
        ContentNameChest4: "Kostenlosetruhe!",
        ContentNameCoin: "Münzen",
        ContentNameJigsaw: "Puzzleteil",
        ContentNamePack: "Gegenstände",
        ContentNameShield: "Schild",
        ContentNameUnknown: "???",
        CountDay: "{0}Tage",
        CountHour: "{0}Stunden",
        CountMinute: "{0}Minuten",
        CountMonth: "{0}Monate",
        CountSecond: "{0}Sekunden",
        CountYear: "{0}Jahre",
        DailyBonusCollect: "EINSAMMELN",
        DailyBonusFreeSpinDes: "1 Freier spin in\n{0}",
        DailyBonusGoldFirst: "Mindestens 25 Mio. Münzen für das erste Mal!!!",
        DailyBonusGoldSpinBtn: "Spin für {0}",
        DailyBonusLevel: "Stufe {0}",
        DailyBonusNormalSpinBtn: "FREIER SPIN",
        ErrorLogin: "Verbindung zum Server fehlgeschlagen.",
        ErrorMsg0: "Erfolg",
        ErrorMsg1114: "Sehen Sie sich heute zu viele Videos an",
        ErrorMsg1703: "Kauf fehlgeschlagen!",
        ErrorNormal: "Keine Verbindung zum Server.",
        ErrorRetry: "Verbindung zum Server fehlgeschlagen, erneut versuchen?",
        ExtraRewardDes: "Coin Room hat dir Münzen und Spins geschenkt!",
        FirstPurchaseButton: "LOS!",
        FirstPurchaseDes1: "Mache irgendeinen Kauf um",
        FirstPurchaseDes2: "BELOHNUNGEN ZU ERHALTEN!",
        FormatHour: ":",
        FormatMinute: ":",
        FormatMonth: "/",
        FormatYear: "/",
        FriendsModelNoResult: "Keine Freunde",
        FriendsModelPlaceHolder: "Suche nach dem Namden des Freundes",
        GameMainWindowActivity: "AKTIVITÄT",
        GameMainWindowQuest: "AUFGABE",
        GetRewardWindowDes: "<outline color=#000000 width=1><color=#ffffff> Du hast Belohnungen erhalten</color>\n<color=#c34eff>{0}!</color></outline>",
        GuestConfirmDes: "Gäste können nicht mit\nFreunden spielen",
        GuestConfirmGuest: "Als Gast spielen",
        GuestConfirmTitle: "Bist du sicher?",
        Help_cannon: "1. Sammle die Kanonenkugeln, um das Schloss anzugreifen!\n2. Die Ringe können die Schätze des Schlosses erneuern.\n3. Kanonenkugeln kann man durch Spins und Zimmersentwicklung sammeln.\n4. Wertgegenstände können für Schatzkistenbelohnung eingetauscht werden.\n5. Die magische Edelsteine können alle Wertgegenstand ersetzen.",
        Help_coinhit: "1. Geben Sie ein Ticket aus, um am Spiel teilzunehmen. 2. Sie können viele Münzen und Spins in Herausforderung erhalten. 3. Durchbrich mehr Blöcke und erhalte mehr Belohnungen.4. Passen Sie den Winkel an, um mehr Blöcke zu treffen.",
        Help_jigsaw: "1. Sammele 9 Teile ein\n und erhalte\n Belohnungen.\n2. Teile werden\n eingesammelt durch\n Slots und\n weiterentwicklung.\n3. Teile werden geräumt\n wenn die Aktivität\n beendet wird.\n4. Universelles Puzzle\n kann alle Teile\n ersetzen.",
        Help_sign: "1. Sie können monatlich\n eine Belohnung für das\n Abo alle 7 Tage im \n Monat erhalten.\n2. Monatliches Abo\n wird nächsten Monat\n erneuert.\n3. Sie können wöchentlich\n Abo Belohnungen\n täglich in einer Woche\n erhalten.\n4. Wöchentliches Abo\n wird nächste Woche\n erneuert.",
        InteractionAttackFriends: "FREUNDE",
        InteractionAttackName: "{0}'s Zimmer",
        InteractionAttackResultBlock: "<Outline Color = # 000000 width = 1 > Sie haben<color = # 29ffed > { 0} < / color> Room  n angegriffen und gewonnen<color = # ffc209> {1} </ color> </ outline> ",
        InteractionAttackResultBlock2: "<outline color=#000000 width=1><color=#29ffed> {0}</color> hat dein Angriff blockiert. Sie haben gewonnen <color=#ffc209> {1}</color></outline>",
        InteractionAttackResultSuccess: "<outline color=#000000 width=1> Sie haben das Zimmer angegriffen <color=#29ffed>{0}'s < /color> und haben gewonnen <color=#ffc209> {1}</color > </outline>",
        InteractionAttackResultSuccess2: "<outline color=#000000 width=1> Sie haben das Zimmer angegriffen <color=#29ffed>{0}'s < /color> und haben gewonnen <color=#ffc209> {1}</color > </outline>",
        InteractionAttackRevenge: "RACHE",
        InteractionBet: "ERHALTE X{0}",
        InteractionRaidBrag: "Teilen",
        InteractionRaidCoinMaster: "König",
        InteractionRaidEmpty: "Versagt",
        InteractionRaidName: "{0}s Einkommen:",
        InteractionRaidPrefect: "Gediegen Raubzug!",
        InteractionRaidResultLine: "<outline color=#000000 width=1>Sie haben Münzen <color=#29ffed>{0}</color> geplünder von <color=#ffc209>{1}</color></outline>",
        InteractionRaidResultLine2: "<outline color=#000000 width=1>Sie haben Münzen <color=#FFF0A4>{0}</color> geplünder von <color=#ffc209>{1}</color></outline>",
        InteractionRaidStole: "Stehlen:",
        LeaderBoardWindowTabCountry: "Land",
        LeaderBoardWindowTabFriends: "Freunde",
        LeaderBoardWindowTabGlobal: "Weltweit",
        LeaderBoardWindowTip: "*Aktualisiert in 10 Minuten",
        Level: "Stufe",
        LevelBonusDes1: "<outline color=#7d3d2f width=3><size=46><color=#fffe00>30</color></size>-facher Extra-Bonus\nInsgesamt <size=46><color=#7ee0f4>5000</color></size> spins!</outline>",
        LevelBonusDes2: "Holen Sie sich nach dem Kauf viele Spins-Prämien!",
        LevelBonusItemDes: "Für das Zimmer {0}",
        Loading: "Lädt",
        LoginWindowGuest: "Gast",
        LoginWindowNeedUpdate: "Es sind updates vorhanden",
        LoginWindowPlay: "Spielen",
        LoginWithApple: "Mit Apple anmelden",
        LoginWindowUpdating: "Wird aktualisiert",
        LuckyDrawDes1: "Video Ansehen",
        LuckyDrawDes2: "Hol dir Chance",
        LuckyDrawFree: "Kostenlos",
        MORE: "MEHR",
        MultiplePurchaseBtn: "SPIN",
        MultiplePurchaseDes1: "Drehe, um zu gewinnen",
        MultiplePurchaseDes2: "x10",
        MultiplePurchaseDes3: "Für extra {0}",
        NO: "NEIN",
        NewPlayerPackButton: "JETZT KAUFEN!",
        NewPlayerPackDes1: "Willkommen bei Coin Room!",
        NewPlayerPackDes2: "<outline color=#471F01 width=2>Wir haben ein <color=#ffd63b>GROSSES GESCHENK</c> für Sie vorbereitet~</outline>",
        NewUserInvitedDes: "{0} neues Zimmer entsperrt! Du erhälst \n{1} GRATIS SPINS",
        NewUserInvitedDesApp: "{0} ist das Spiel beigetretten! Du erhälst \n{1} GRATIS SPINS",
        NewUserInvitedTitle: "FREUND BELOHNUNG",
        No: "NEIN",
        NotEnoughApAdd: "+{0} Spins",
        NotEnoughApDes: "Keine Spins mehr?",
        NotEnoughApWait: "oder warten Sie {1} für {0} spins",
        NotEnoughApWait2: "Warten {1} für {0} spins",
        NotEnoughCoinDes: "Keine Münzen mehr?",
        NotEnoughOff: "{0}%\nMEHR",
        NotificationDesActivity: "{0} wird in eine Stunde enden!",
        NotificationDesApFull: "Wie haben genügend Spins zum spielen und um mehr Münzen zu bekommen!",
        NotificationDesAttack: "Jemand ist in dein Zimmer eingedrungen!",
        NotificationDesBack: "Wir haben ein großes Geschenk für dich vorbereitet!",
        NotificationDesBack2: "Komm zurück! Wir haben ein großes Geschenk für dich vorbereitet!",
        NotificationDesDailyBonus: "Komm und spiel täglich Schicksalsrad!",
        NotificationTitleActivity: "Aktivität wird beendet!",
        NotificationTitleApFull: "Sie haben vollständige Spins!",
        NotificationTitleAttack: "Rächen wir uns!",
        NotificationTitleBack: "Lang nicht gesehen!",
        NotificationTitleBack2: "Komm mit mir spielen!",
        NotificationTitleDailyBonus: "Täglicher Bonus ist jetzt verfügbar!",
        Now10XBetter: "10 mal besser!",
        OFF: "AUS",
        OK: "OKAY",
        OffText: "{0}%\nMEHR",
        PastDay: "{0}d vorher",
        PastHour: "{0}h vorher",
        PastMinute: "{0}min vorher",
        PastMonth: "{0}M vorher",
        PastSecond: "{0}s vorher",
        PastYear: "{0}a vorher",
        PastZero: "Jetzt",
        PayDisable: "Bezahlung ist deaktiviert!",
        PayDisableFBIn: "Entschuldigung, die Zahlungsfunktion ist derzeit nicht mit Ihrem System kompatibel. Bitte geben Sie Coin Room über Instant Games ein, um den Kauf auf einem Computer abzuschließen.",
        PayDisableIos: "Bezahlung auf iOS ist deaktiviert!",
        PayEnabledAndroid: "Bezahlung ist nur auf Android aktiviert!",
        PayFail: "Kauf fehlgeschlagen!",
        PayFailWindowBtn: "Support kontaktieren",
        PayFailWindowDes: "Probleme beim Kauf?",
        PayPending: "Ihr Kauf steht noch aus! Starten Sie das Spiel nach Abschluss des Bezahlvorgangs neu, um Gegenstände zu erhalten.",
        PaySuccess: "Wir bedanken uns für Ihren Kauf!",
        PeterOpenDes1: "Papagei Peter bringt Ihnen zufälliges Geschenk!",
        PeterOpenDes2: "Berühre einfach Peter und erhalte ein Geschenk, wenn es kommt!",
        PlayerDefaultName: "Spieler",
        PriceSymbol: "$",
        Raid: "RAUBZUG",
        RaidProtect: "RAUBZUG GESCHÜTZT",
        Rank: "Ranking",
        Reconnect: "WIEDERHOLEN",
        Restart: "Neustart",
        Retry: "Wiederholen",
        START: "STARTEN",
        SaleMark: "ANGEBOT",
        Score: "Punktzahl",
        ScorePoint: "Punktzahl",
        ScoreRank: "Ranking",
        ServantEffectDes1: "Erhöht die Belohnungen der Stehlen",
        ServantEffectDes2: "Erhöht die Belohnung der Angriffe",
        ServantEffectDes3: "Schützt vor Angriffen",
        ServantEffectDes4: "Schützt vor Stehlen",
        ServantEffectNum1: "● Erhöht die Belohnung um: {0}%",
        ServantEffectNum2: "● Erhöht die Belohnung der um: {0}%",
        ServantEffectNum3: "● Chance auf Schutz: {0}%",
        ServantEffectNum4: "● Chance auf Schutz: {0}%",
        ServantInfo1: "Diener Upgrade:",
        ServantInfo2: "Jede Spielautomat Drehung= 1 Diener Exp. Man kann Tränke benutzen, um mehr Diener Exp zu erhalten. Wenn die Diener-Exp-Balken voll ist, tippe bitte auf die Upgrade-Schaltfläche, um das Upgrade für den Diener zu machen. Jedes Upgrade des Diener erhöht deinen Spielstern",
        ServantInfo3: "Fertigkeit:",
        ServantInfo4: "Die Fertigkeit des Dieners stärkt sich mit jedem Upgrade",
        ServantInfo5: "Aktivierung:",
        ServantInfo6: "Gib deinen Diener Essen, um sie zu aktivieren. Hol dir Essen für die Diener beim drehen und bauen",
        ServantName1: "Pigy",
        ServantName2: "Billy",
        ServantName3: "Doge",
        ServantName4: "Ruby",
        ServantNextLevel: "● Nächste Stufe: {0}% +",
        ServantOpenDes: "<outline color=#000000 width=1><color=#ffffff>Stelle Diener ein, um mehr <color=#ffcc00>Münzen</color> und <color=#c667ff>Spins</color> zu erhalten</color></outline>",
        ServantOpenDesS: "<color=#308ae6>Stelle Diener ein, um mehr <color=#e67b07>Münzen</color> und <color=#006fd7>Spins</color> zu erhalten</color>",
        ServantSelect: "Auswählen",
        ServantUpgrade: "Upgrade",
        ShareChooseDialogTitle: "Senden",
        ShareDialogTitle: "Teilen",
        ShareInviteAttack: "BEEINDRUCKEND! Ich greife nur das Zimmer eines anderen an! So cool: -D",
        ShareInviteDialogTitle: "Einladen",
        ShareInviteFinishVillage: "Ich habe gerade ein neues Zimmer gebaut! Kommen Sie und besuchen Sie :-D",
        ShareInviteNew: "Hey, das ist wirklich ein tolles Spiel! Lass uns zusammen spielen :-P",
        ShareInviteRaid: "WOW! Ich habe soeben {0} Münzen stehlen! So Cool :-D",
        ShareInviteSendCoins: "{0} gab dir soeben Münzen :)",
        ShareInviteSendSpin: "{0} gab dir soeben einen spin :)",
        ShareJigsawTitle: "Ich brauch die. Hilf mir!",
        ShareSendCard: "{0} gab dir soeben einen karten :)",
        ShareTitle: "Hey, das ist wirklich ein tolles Spiel! Lass uns zusammen spielen :-P",
        Shield: "SCHILD",
        ShopAddPercent: "{0}% \nMEHR",
        ShopBestValue: "Bester Wert",
        ShopChestDisable: "Truhen freigeschaltet in Zimmer {0}",
        ShopChests: "Truhen",
        ShopCoinPrice: "${0}",
        ShopCoins: "Münzen",
        ShopOff: "{0}%\nAUS",
        ShopPopular: "Beliebt",
        ShopShield: "Super\nSchild",
        ShopShieldDes1: "SILBERNE SCHILDE",
        ShopShieldDes2: "GOLDENE SCHILDE",
        ShopShieldDes3: "Beschütze dein Zimmer",
        ShopShieldDes4: "Schütze gegen:",
        ShopShieldDes5: "<color=#874423>Angriffe & <color=#288bdf>Raubzug</color> (exklusiv)</color>",
        ShopSpinNum: "{0}",
        ShopSpinPrice: "${0}",
        ShopSpins: "Spins",
        ShopTitle: "Laden",
        ShopTreatDisable: "Leckereien freigeschaltet in Zimmer {0}",
        ShopTreatFoodTime: "{0}Std. Aktivierung",
        ShopTreats: "Leckereien",
        SlotBetNewMax: "Einsatzlimit erhöht",
        SlotBetSuper: "SUPER",
        SlotCoin6Video: "Schaue ein Video und erhalte Münzen x2",
        SlotPeterDesAd: "Ich habe ein Geschenk für dich!",
        SomeDay: "{0}d",
        SomeHour: "{0}h",
        SomeMinute: "{0}min",
        SomeMonth: "{0}M",
        SomeSecond: "{0}s",
        SomeYear: "{0}a",
        SomeZero: "Jetzt",
        Spins: "SPINS+{0}",
        SuperShieldOpenDes: "Super-Schild schützt das Zimmer für lange Zeit vor Angriffen & Raubzug",
        ToRaidUserBet: "GEWINN X{0}",
        TutorialDialogDoSpin: "Verwende den Spielautomaten für Spins, andere anzugreifen und zu überfallen.",
        TutorialDialogGoSpin: "Du hast nicht genug Münzen...\n\nnach unten ziehen um mehr Münzen zu gewinnen",
        TutorialDialogSlotAttack: "Greife die Zimmere anderer Spieler an, um Münzen zu erhalten.",
        TutorialDialogSlotRaid: "Überfalle das Zimmer des Königs und plündere seine Münzen!",
        TutorialDialogSlotRaidMaster: "Das ist der König\nÜberfallen wir ihn!",
        TutorialDialogSlotShield: "Schilde schützen dein Zimmer vor Angriffen.",
        TutorialDialogStar: "Wenn du einen Gegenstand auflevelst, erhältst du einen Stern.\n\nSammle 25 Sterne, um das nächste Zimmer freizuschalten.",
        TutorialFinishDes0: "Deine Belohnungen :",
        TutorialFinishDes1: "60 Spins!",
        TutorialFinishDes1bind: "20 Spins!",
        TutorialFinishDes2: "1 Mio Münzen!",
        TutorialFinishDes3: "Fortschrit speichern!",
        TutorialFinishDes4: "Spiele mit deinen Freunden!",
        TutorialFinishTitle: "Erfolg!",
        TutorialStartDes: "Willkommen mein Freund!\n\nDrücke die Taste, um mit der Arbeit zu beginnen.",
        TutorialStartTitle: "DEIN ERSTES Zimmer",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        TutorialTargetName: "Ziel",
        TutorialTargetName1: "Leyla",
        TutorialTargetName2: "Mary",
        TutorialTargetName3: "Kevin",
        VillageCompleteNext: "Nächstes",
        VillageCompleteTitle: "Zimmer Reif!",
        VillageShopBuy: "KAUFEN",
        VillageShopComplete: "FERTIG!",
        VillageShopFix: "REPARIEREN",
        VillageShopTitle: "Raum EVOLVE",
        VipDailyRewardDes: "Hol dir täglich die Folgenden!",
        VipExtraRewardButton: "HOL DIR ALLE",
        VipExtraRewardDes: "Schalte VIP frei, um alle angesammelten Boni zu erhalten",
        VipGetTrialButtonDes1: "Kostenlos starten",
        VipGetTrialButtonDes2: "3 Tage kostenlose Testversion, dann {0} pro monat",
        VipGetWindowButtonMonth: "MONAT",
        VipGetWindowButtonWeek: "WOCHE",
        VipGetWindowButtonYear: "JAHR",
        VipGetWindowDailyRecovery: "WIEDERHERSTELLUNGSLIMIT",
        VipGetWindowDailySpe: "<outline color=#000000 width=1><color=#FFFFFF>Glänzendes Aussehen mit <color=#ffba00>rotem Namen</color> und <color=#ffba00>Krone</color>!</color></outline>",
        VipGetWindowDailyTitle: "Tägliche Belohnungen",
        VipGetWindowHot: "HEISS",
        VipGetWindowPolicy: "<color = #d1acf3>VIP zum angegebenen Preis bietet ein Abonnement, gewährt jeden Tag Spins, Lebensmittel and Karte.Es ist ein<color = #35e35e > <u><on click=\"handle\" param=\"sub\">Autom verlängerndes Abo</on></u></c>. Die Zahlung erfolgt per Telefonkonto bei Bestätigung. <color=#d1acf3>Das Abonnement wird verlängert, sofern es nicht 24 Stunden vor Ablauf deaktiviert wird. Das Konto wird ebenfalls für Verlängerung in Rechnung gestellt.</c> Sie können es in Ihren Kontoeinstellungen deaktivieren. Jeder nicht genutzte Teil einer kostenlosen Probezeit, falls angeboten, wird verfallen, wenn der Benutzer ein Abonnement für die Publikation kauft, sofern zutreffend. <color=#35e35e><u><on click=\"handle\" param=\"pri\">Datenschutz-Bestimmungen und Nutzungsbedingungen</on></u></c>.</c>",
        VipGetWindowRewardDes: "Hol dir in Slot-Aktivität zusätzliche Spins und Münzen",
        VipGetWindowRewardRewards: "Belohnungen",
        YES: "JA",
        Yes: "JA",
        adShieldTip: "freies Schild!",
        and: "und",
        cannon_get_reward_window_exchange: "Austauschen.",
        cannon_get_reward_window_title: "Belohnung austauschen",
        cannon_item_window_btn_regain: "Wiedererlangen",
        cannon_item_window_btn_send: "Schicken",
        cannon_item_window_title: "AUSTAUSCHEN",
        cannon_main_window_no_ball: "Keine Kanonenkugel!",
        cannon_main_window_refresh_check: "Möchtest du die Ringe verwenden, um zu erneurn? Es gibt noch {0} Boxen!",
        cannon_main_window_refresh_time: "Automatisch erneurn\n",
        cannon_meesage_window_collect: "<color=#F48B03>{0}</color><color=#7E4B27> hat das Gegenstand dir gesendet </color><color=#19B8B2>{1}</color>",
        cannon_message_window_no_message: "Keine Nachricht.",
        cannon_message_window_send: "<color=#7E4B27>Du hast </color><color=#F48B03>{0}</color><color=#7E4B27> das Gegenstand </color><color=#19B8B2>{1}</color>",
        cannon_message_window_title: "Nachricht",
        cannon_name: "Kanone",
        cannon_send_item_window_choosed_friend: "Freunden wählen:",
        cannon_send_item_window_choosed_item: "Gegenstand wählen:",
        cannon_send_item_window_send: "Senden",
        cannon_send_item_window_title: "Gegenstand senden: Freunden wählen",
        cannon_shop_window_title: "Mehr Bomben?",
        cannon_use_magic_item_window_cancel: "Abbrechen",
        cannon_use_magic_item_window_confirm: "Bestätigen",
        collectionFreeChest: "KOSTENLOSE BRUST ",
        communityCardNoCards: "Sie haben keine Karten von Ihren \n Freunden erhalten",
        communityCommunity: "Gemeinschaft",
        facebookF: "f",
        gifts_collect: "Einsammeln",
        gifts_collect_all: "Alles Einsammeln / Senden ",
        gifts_collect_all2: "Alles Einsammeln",
        gifts_collect_coins: "Tägliche Münzen eingesammelt {0}/{1}",
        gifts_collect_spins: "Tägliche Spins eingesammelt {0}/{1}",
        gifts_default_explain: "Gratis Spins bekommen",
        gifts_default_name: "Freunde Einladen",
        gifts_explain_card_cantcollect: "Du musst Zimmer {0} erreichen um diese Karte zu bekommen",
        gifts_explain_card_collect: "Eine Karte senden",
        gifts_explain_card_send: "Sende Karten\nan deine Freunde",
        gifts_explain_coin_collect: "Dir {0} Münzen senden",
        gifts_explain_coin_send: "Gratis Münzen schenken",
        gifts_explain_spin_collect: "Dir {0} Spin senden",
        gifts_explain_spin_send: "Gratis Spin schenken",
        gifts_invite: "Einladung",
        gifts_send: "Senden",
        gifts_tab0: "Gratis Spins",
        gifts_tab1: "Gratis Münzen",
        gifts_tab2: "Karten",
        gifts_title: "Geschenke",
        heist_main_window_cannot_buy: "Schalte es frei, indem du ein vorheriges Angebot kaufst",
        heist_main_window_free: "Kostenlos",
        heist_main_window_title: "NEHMEN SIE JEDES ABKOMMEN ZUR WEITEREN OFFENBARUNG",
        inviteNeedMoreSpins: "Benötigen Sie mehr Spins?",
        inviteUpper: "EINLADEN ",
        invite_addnumber_type0: "+{0}",
        invite_invite: "EINLADEN",
        invite_lineA: "<color=#FFFFFF><outline color=#000000 width=1>Lade Freunde ein und erhalte </color><color=#ffffff><outline color=#6F3A14 width=3>{0} gratis spins</outline></color><color=#FFFFFF><outline color=#000000 width=1> für jeden Freund der Zimmer 2 entsperrt!</color>",
        invite_lineApp: "<color=#FFFFFF><outline color=#000000 width=1>Lade Freunde ein und erhalte </color><color=#ffffff><outline color=#6F3A14 width=3>{0} gratis spins</outline></color><color=#FFFFFF><outline color=#000000 width=1> für jeden Freund der am Spiel teilnimmt!</color>",
        invite_note: "* Du wirst eine Belohnung erhalten wenn dein Freund sich\ndurch Facebook verbindet",
        invite_title: "Möchten Sie Mehr Spins?",
        jigsaw_friends_window_no_friends: "Keine Freunde.",
        jigsaw_friends_window_search_pre: "Name des Freundes suchen",
        jigsaw_friends_window_send: "Senden",
        jigsaw_friends_window_title: "FREUNDE",
        jigsaw_news_window_news_collect: "<color=#F48B03>{0} </color><color=#7E4B27>Sendet Ihnen das Teil</color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_news_send: "<color=#7E4B27>Sie senden</color><color=#F48B03> {0} </color><color=#7E4B27>das Teil</color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_no_news: "Keine Neuigkeiten.",
        jigsaw_news_window_title: "NEUIGKEITEN",
        jigsaw_window_complete: "ALLE FINDEN",
        jigsaw_window_send: "Senden",
        jigsaw_window_title: "PUZZLE",
        jigsaw_window_universal_tip: "Wähle ein Teil zum Ersetzen",
        jigsaw_window_use: "Verwenden",
        jigsaw_window_used: "Verwendet",
        loadResError: "Ressource konnte nicht geladen werden. Erneut versuchen?",
        map_comming_soon: "BALD VERFÜGBAR",
        map_title: "{0}. {1}",
        menu_0_play: "SPIELEN",
        menu_1_village: "Zimmer",
        menu_2_buy: "COINS/SPINS kaufen",
        menu_3_daily: "TÄGLICHER BONUS",
        menu_4_shop: "Raum EVOLVE",
        menu_5_news: "NACHRICHT",
        menu_6_gifts: "GESCHENK",
        menu_7_card: "KARTE",
        menu_8_map: "LANDKARTE",
        menu_9_leaderboard: "BESTENLISTE",
        menu_10_invite: "EINLADEN",
        menu_11_setting: "EINSTELLUNGEN",
        menu_title: "MENÜ",
        messageNoMail: "Noch keine Mails!",
        messageNoMessage: "Noch keine Nachrichten!",
        mini_game_coinhit_btn_end: "Belohungen erhalten",
        mini_game_coinhit_btn_next_round: "Nächste Runde",
        mini_game_coinhit_go: "Los!",
        mini_game_coinhit_info: "Eine großartige Reise bei der man um\nMünzen, Spins und Truhen gewinnen kann!",
        mini_game_coinhit_info_title: "BELOHNUNGS",
        mini_game_coinhit_manual_end: "Erhalte die Belohungen jetzt! Erhalte {0} Münzen, {1} Spin",
        mini_game_coinhit_manual_next_round: "Spiel stecken geblieben? Betrete die nächste Runde",
        mini_game_coinhit_rank_info: "Blocktreffer: {0}",
        mini_game_coinhit_time: "Endet in {0}",
        mini_game_end: "Spiel Ende",
        mini_game_fail: "Laden fehlgeschlagen, bitte erneut versuchen",
        mini_game_rank_window_no_ranks: "Keine Ränge vorhanden",
        mini_game_rank_window_title: "RANGLISTE",
        minigame_buy_ticket_window_title: "Mehr Karte?",
        minigame_coinhit_second_title: "Passen Sie den den Winkel an, um mehr Blöcke zu treffen und Hohe Belohnungen zu erhalten!",
        minigame_coinhit_title: "Hit & Win",
        minigame_gameover: "Ende!",
        minigame_start_game: "START",
        minigame_time: "Endet in {0}",
        multiplyX: "x",
        multiplyx: "x",
        quest_center_window_check: "Abonnieren",
        quest_center_window_check_do: "ABONNIEREN",
        quest_center_window_check_done: "ABONNIERT",
        quest_center_window_daily: "Täglich",
        quest_center_window_daily_get: "Einsammeln",
        quest_center_window_daily_go: "LOS",
        quest_center_window_day_1: "1. Tag",
        quest_center_window_day_2: "2. Tag",
        quest_center_window_day_3: "3. Tag",
        quest_center_window_day_4: "4. Tag",
        quest_center_window_day_5: "5. Tag",
        quest_center_window_day_6: "6. Tag",
        quest_center_window_day_7: "7. Tag",
        quest_center_window_invite: "Einladen",
        quest_center_window_main_quest_goal_reward: "Ziel: {0}\nBelohnung: {1}",
        quest_center_window_main_quest_name: "Hauptquest: {0}",
        quest_center_window_month_box_7: "7 Tage",
        quest_center_window_month_box_14: "14 Tage",
        quest_center_window_month_box_21: "21 Tage",
        quest_center_window_month_box_28: "28 Tage",
        quest_center_window_refresh_dialog: "Die Aufgaben werden an einem neuen Tag aktualisiert. Bitte öffne das Fenster erneut.",
        quest_center_window_refreshin: "Aktualisiere im",
        quest_center_window_title: "Aufgaben Center",
        revengeNoFriends: "Noch keine Freunde!",
        revenge_attack: "Angriff",
        revenge_random: "Zufällig",
        revenge_revenge: "Rache",
        revenge_title_attack: "Greif dein Freund an!",
        revenge_title_revenge: "Rache!",
        servantADFree: "KOSTENLOS",
        settingLogOut: "Ausloggen",
        settingUid: "Uid: ",
        settingVersion: "Ausführung: ",
        setting_english: "Englisch",
        setting_general: "Allgemeines",
        setting_language: "Sprache",
        setting_language_de: "Deutsch",
        setting_language_en: "English",
        setting_language_es: "Español",
        setting_language_fr: "Français",
        setting_language_title: "Sprache",
        setting_language_zh: "中文",
        setting_like: "LIKE",
        setting_likeus: "Liken Sie uns und verpassen Sie nicht\n fantastische Ereignisse und Geschenke",
        setting_lowbattery: "Low Power Mode",
        setting_lowbattery_tip: "Open Low Power Mode reduziert den Stromverbrauch, verringert aber die Leistung",
        setting_music: "Musik",
        setting_notifications: "Benachrichtigungen",
        setting_privacy: "Datenschutz-Bestimmungen",
        setting_raid: "Raubzug und Agriff",
        setting_sound: "Ton",
        setting_support: "Unterstützung",
        setting_terms: "Geschäftsbedingungen",
        setting_title: "Einstellungen",
        setting_tutorial: "Tutorial",
        shopBestSeller: "BESTSELLER, VERKAUFSSCHLAGER, SPITZENREITER",
        shopCardInfoBuy: "Kaufen ",
        shopLevelBonus: "LEVEL BONUS",
        slotServantAdTip: "Füttere mich mit Essen!",
        villageTownReward: "Stadtbelohnung",
        village_news_expire: "Ablauf in {0}",
        village_news_log_hammer: " hat dein Zimmer angegriffen",
        village_news_log_hammer_vip: " hat dein Zimmer angegriffen",
        village_news_log_invite: "ist Coin Room beigetreten",
        village_news_log_invite_vip: "ist Coin Room beigetreten",
        village_news_log_noraid: "hat versagt stehlen {0}",
        village_news_log_noraid_vip: "<outline color=#FFFFFF width=2><color=#CC0905>{0}</color></outline><color=#662C1C> hat versagt stehlen {1}</color>",
        village_news_log_pig: "hat {0} von dir stehlen",
        village_news_log_pig_vip: "hat {0} von dir stehlen",
        village_news_log_shield: "hat versucht Zimmer anzugreifen",
        village_news_log_shield_vip: "hat versucht Zimmer anzugreifen",
        village_news_tab1: "Zimmer",
        village_news_tab2: "Mail",
        village_news_title: "Nachricht",
        watch_coin: "+{0} MÜNZEN",
        watch_get: "Schaue ein Video und erhalte",
        watch_spin: "+{0} SPINS",
        watch_watch: "SCHAUEN",
        wxUserinfoDenyConfirm: "Zugriff gewährt",
        wxUserinfoDenyDes: "Wir benötigen Ihre Infomationen",
        wxUserinfoDenyTitle: "Benötigen Zugriff",
        wxVersionNoSupport: "Diese Funktion ist derzeit nicht mit Ihrer Client-Version kompatibel. Bitte aktualisieren Sie Ihr Wechat."
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LoopMoveAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "908d3yIyeBOM71z9QXP/5zl", "LoopMoveAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LoopMoveAnim = exports('default', (_dec = property(CCInteger), _dec2 = property(CCInteger), _dec3 = property(CCInteger), _dec4 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class LoopMoveAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "disx", _descriptor, this);

          _initializerDefineProperty(this, "disy", _descriptor2, this);

          _initializerDefineProperty(this, "time", _descriptor3, this);

          _initializerDefineProperty(this, "delay", _descriptor4, this);

          _defineProperty(this, "olsx", void 0);

          _defineProperty(this, "node", void 0);

          _defineProperty(this, "olsy", void 0);

          _defineProperty(this, "playing", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          this.olsx = this.node.x;
          this.olsy = this.node.y;
          this.playing = true;
          this.scheduleOnce(function () {
            this.playing = false;
          }.bind(this), this.delay);
        }

        slowUpdate(dt) {
          if (this.playing) return;
          this.node.runAction(ccAction.sequence(ccAction.callFunc(() => {
            this.node.x = this.olsx;
            this.node.y = this.olsy;
          }, this), ccAction.moveBy(this.time, this.disx, this.disy), ccAction.delayTime(this.delay) //ccAction.callFunc(function(){ this.playing = false }, this)
          ).repeatForever());
          this.playing = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "disx", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "disy", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "delay", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LZString.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports('LZString', void 0);

      cclegacy._RF.push({}, "913e1cMDcFEnq2Tt7Lt06iM", "LZString", undefined);

      let LZString;

      (function (_LZString) {
        // private property
        var f = String.fromCharCode;
        var keyStrBase64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        var keyStrUriSafe = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-$";
        var baseReverseDic = {};

        function getBaseValue(alphabet, character) {
          if (!baseReverseDic[alphabet]) {
            baseReverseDic[alphabet] = {};

            for (var i = 0; i < alphabet.length; i++) {
              baseReverseDic[alphabet][alphabet.charAt(i)] = i;
            }
          }

          return baseReverseDic[alphabet][character];
        }

        function compressToBase64(input) {
          if (input == null) return "";

          var res = _compress(input, 6, function (a) {
            return keyStrBase64.charAt(a);
          });

          switch (res.length % 4) {
            // To produce valid Base64
            default: // When could this happen ?

            case 0:
              return res;

            case 1:
              return res + "===";

            case 2:
              return res + "==";

            case 3:
              return res + "=";
          }
        }

        _LZString.compressToBase64 = compressToBase64;

        function decompressFromBase64(input) {
          if (input == null) return "";
          if (input == "") return null;
          return _decompress(input.length, 32, function (index) {
            return getBaseValue(keyStrBase64, input.charAt(index));
          });
        }

        _LZString.decompressFromBase64 = decompressFromBase64;

        function compressToUTF16(input) {
          if (input == null) return "";
          return _compress(input, 15, function (a) {
            return f(a + 32);
          }) + " ";
        }

        _LZString.compressToUTF16 = compressToUTF16;

        function decompressFromUTF16(compressed) {
          if (compressed == null) return "";
          if (compressed == "") return null;
          return _decompress(compressed.length, 16384, function (index) {
            return compressed.charCodeAt(index) - 32;
          });
        }

        _LZString.decompressFromUTF16 = decompressFromUTF16;

        function compressToUint8Array(uncompressed) {
          var compressed = compress(uncompressed);
          var buf = new Uint8Array(compressed.length * 2); // 2 bytes per character

          for (var i = 0, TotalLen = compressed.length; i < TotalLen; i++) {
            var current_value = compressed.charCodeAt(i);
            buf[i * 2] = current_value >>> 8;
            buf[i * 2 + 1] = current_value % 256;
          }

          return buf;
        }

        _LZString.compressToUint8Array = compressToUint8Array;

        function decompressFromUint8Array(compressed) {
          if (compressed === null || compressed === undefined) {
            return decompress(compressed);
          } else {
            var buf = new Array(compressed.length / 2); // 2 bytes per character

            for (var i = 0, TotalLen = buf.length; i < TotalLen; i++) {
              buf[i] = compressed[i * 2] * 256 + compressed[i * 2 + 1];
            }

            var result = [];
            buf.forEach(function (c) {
              result.push(f(c));
            });
            return decompress(result.join(''));
          }
        }

        _LZString.decompressFromUint8Array = decompressFromUint8Array;

        function compressToEncodedURIComponent(input) {
          if (input == null) return "";
          return _compress(input, 6, function (a) {
            return keyStrUriSafe.charAt(a);
          });
        }

        _LZString.compressToEncodedURIComponent = compressToEncodedURIComponent;

        function decompressFromEncodedURIComponent(input) {
          if (input == null) return "";
          if (input == "") return null;
          input = input.replace(/ /g, "+");
          return _decompress(input.length, 32, function (index) {
            return getBaseValue(keyStrUriSafe, input.charAt(index));
          });
        }

        _LZString.decompressFromEncodedURIComponent = decompressFromEncodedURIComponent;

        function compress(uncompressed) {
          return _compress(uncompressed, 16, function (a) {
            return f(a);
          });
        }

        _LZString.compress = compress;

        function _compress(uncompressed, bitsPerChar, getCharFromInt) {
          if (uncompressed == null) return "";
          var i,
              value,
              context_dictionary = {},
              context_dictionaryToCreate = {},
              context_c = "",
              context_wc = "",
              context_w = "",
              context_enlargeIn = 2,
              // Compensate for the first entry which should not count
          context_dictSize = 3,
              context_numBits = 2,
              context_data = [],
              context_data_val = 0,
              context_data_position = 0,
              ii;

          for (ii = 0; ii < uncompressed.length; ii += 1) {
            context_c = uncompressed.charAt(ii);

            if (!Object.prototype.hasOwnProperty.call(context_dictionary, context_c)) {
              context_dictionary[context_c] = context_dictSize++;
              context_dictionaryToCreate[context_c] = true;
            }

            context_wc = context_w + context_c;

            if (Object.prototype.hasOwnProperty.call(context_dictionary, context_wc)) {
              context_w = context_wc;
            } else {
              if (Object.prototype.hasOwnProperty.call(context_dictionaryToCreate, context_w)) {
                if (context_w.charCodeAt(0) < 256) {
                  for (i = 0; i < context_numBits; i++) {
                    context_data_val = context_data_val << 1;

                    if (context_data_position == bitsPerChar - 1) {
                      context_data_position = 0;
                      context_data.push(getCharFromInt(context_data_val));
                      context_data_val = 0;
                    } else {
                      context_data_position++;
                    }
                  }

                  value = context_w.charCodeAt(0);

                  for (i = 0; i < 8; i++) {
                    context_data_val = context_data_val << 1 | value & 1;

                    if (context_data_position == bitsPerChar - 1) {
                      context_data_position = 0;
                      context_data.push(getCharFromInt(context_data_val));
                      context_data_val = 0;
                    } else {
                      context_data_position++;
                    }

                    value = value >> 1;
                  }
                } else {
                  value = 1;

                  for (i = 0; i < context_numBits; i++) {
                    context_data_val = context_data_val << 1 | value;

                    if (context_data_position == bitsPerChar - 1) {
                      context_data_position = 0;
                      context_data.push(getCharFromInt(context_data_val));
                      context_data_val = 0;
                    } else {
                      context_data_position++;
                    }

                    value = 0;
                  }

                  value = context_w.charCodeAt(0);

                  for (i = 0; i < 16; i++) {
                    context_data_val = context_data_val << 1 | value & 1;

                    if (context_data_position == bitsPerChar - 1) {
                      context_data_position = 0;
                      context_data.push(getCharFromInt(context_data_val));
                      context_data_val = 0;
                    } else {
                      context_data_position++;
                    }

                    value = value >> 1;
                  }
                }

                context_enlargeIn--;

                if (context_enlargeIn == 0) {
                  context_enlargeIn = Math.pow(2, context_numBits);
                  context_numBits++;
                }

                delete context_dictionaryToCreate[context_w];
              } else {
                value = context_dictionary[context_w];

                for (i = 0; i < context_numBits; i++) {
                  context_data_val = context_data_val << 1 | value & 1;

                  if (context_data_position == bitsPerChar - 1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }

                  value = value >> 1;
                }
              }

              context_enlargeIn--;

              if (context_enlargeIn == 0) {
                context_enlargeIn = Math.pow(2, context_numBits);
                context_numBits++;
              } // Add wc to the dictionary.


              context_dictionary[context_wc] = context_dictSize++;
              context_w = String(context_c);
            }
          } // Output the code for w.


          if (context_w !== "") {
            if (Object.prototype.hasOwnProperty.call(context_dictionaryToCreate, context_w)) {
              if (context_w.charCodeAt(0) < 256) {
                for (i = 0; i < context_numBits; i++) {
                  context_data_val = context_data_val << 1;

                  if (context_data_position == bitsPerChar - 1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }
                }

                value = context_w.charCodeAt(0);

                for (i = 0; i < 8; i++) {
                  context_data_val = context_data_val << 1 | value & 1;

                  if (context_data_position == bitsPerChar - 1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }

                  value = value >> 1;
                }
              } else {
                value = 1;

                for (i = 0; i < context_numBits; i++) {
                  context_data_val = context_data_val << 1 | value;

                  if (context_data_position == bitsPerChar - 1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }

                  value = 0;
                }

                value = context_w.charCodeAt(0);

                for (i = 0; i < 16; i++) {
                  context_data_val = context_data_val << 1 | value & 1;

                  if (context_data_position == bitsPerChar - 1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }

                  value = value >> 1;
                }
              }

              context_enlargeIn--;

              if (context_enlargeIn == 0) {
                context_enlargeIn = Math.pow(2, context_numBits);
                context_numBits++;
              }

              delete context_dictionaryToCreate[context_w];
            } else {
              value = context_dictionary[context_w];

              for (i = 0; i < context_numBits; i++) {
                context_data_val = context_data_val << 1 | value & 1;

                if (context_data_position == bitsPerChar - 1) {
                  context_data_position = 0;
                  context_data.push(getCharFromInt(context_data_val));
                  context_data_val = 0;
                } else {
                  context_data_position++;
                }

                value = value >> 1;
              }
            }

            context_enlargeIn--;

            if (context_enlargeIn == 0) {
              context_enlargeIn = Math.pow(2, context_numBits);
              context_numBits++;
            }
          } // Mark the end of the stream


          value = 2;

          for (i = 0; i < context_numBits; i++) {
            context_data_val = context_data_val << 1 | value & 1;

            if (context_data_position == bitsPerChar - 1) {
              context_data_position = 0;
              context_data.push(getCharFromInt(context_data_val));
              context_data_val = 0;
            } else {
              context_data_position++;
            }

            value = value >> 1;
          } // Flush the last char


          while (true) {
            context_data_val = context_data_val << 1;

            if (context_data_position == bitsPerChar - 1) {
              context_data.push(getCharFromInt(context_data_val));
              break;
            } else context_data_position++;
          }

          return context_data.join('');
        }

        function decompress(compressed) {
          if (compressed == null) return "";
          if (compressed == "") return null;
          return _decompress(compressed.length, 32768, function (index) {
            return compressed.charCodeAt(index);
          });
        }

        _LZString.decompress = decompress;

        function _decompress(length, resetValue, getNextValue) {
          var dictionary = [],
              next,
              enlargeIn = 4,
              dictSize = 4,
              numBits = 3,
              entry = "",
              result = [],
              i,
              w,
              bits,
              resb,
              maxpower,
              power,
              c,
              data = {
            val: getNextValue(0),
            position: resetValue,
            index: 1
          };

          for (i = 0; i < 3; i += 1) {
            dictionary[i] = i;
          }

          bits = 0;
          maxpower = Math.pow(2, 2);
          power = 1;

          while (power != maxpower) {
            resb = data.val & data.position;
            data.position >>= 1;

            if (data.position == 0) {
              data.position = resetValue;
              data.val = getNextValue(data.index++);
            }

            bits |= (resb > 0 ? 1 : 0) * power;
            power <<= 1;
          }

          switch (next = bits) {
            case 0:
              bits = 0;
              maxpower = Math.pow(2, 8);
              power = 1;

              while (power != maxpower) {
                resb = data.val & data.position;
                data.position >>= 1;

                if (data.position == 0) {
                  data.position = resetValue;
                  data.val = getNextValue(data.index++);
                }

                bits |= (resb > 0 ? 1 : 0) * power;
                power <<= 1;
              }

              c = f(bits);
              break;

            case 1:
              bits = 0;
              maxpower = Math.pow(2, 16);
              power = 1;

              while (power != maxpower) {
                resb = data.val & data.position;
                data.position >>= 1;

                if (data.position == 0) {
                  data.position = resetValue;
                  data.val = getNextValue(data.index++);
                }

                bits |= (resb > 0 ? 1 : 0) * power;
                power <<= 1;
              }

              c = f(bits);
              break;

            case 2:
              return "";
          }

          dictionary[3] = c;
          w = c;
          result.push(c);

          while (true) {
            if (data.index > length) {
              return "";
            }

            bits = 0;
            maxpower = Math.pow(2, numBits);
            power = 1;

            while (power != maxpower) {
              resb = data.val & data.position;
              data.position >>= 1;

              if (data.position == 0) {
                data.position = resetValue;
                data.val = getNextValue(data.index++);
              }

              bits |= (resb > 0 ? 1 : 0) * power;
              power <<= 1;
            }

            switch (c = bits) {
              case 0:
                bits = 0;
                maxpower = Math.pow(2, 8);
                power = 1;

                while (power != maxpower) {
                  resb = data.val & data.position;
                  data.position >>= 1;

                  if (data.position == 0) {
                    data.position = resetValue;
                    data.val = getNextValue(data.index++);
                  }

                  bits |= (resb > 0 ? 1 : 0) * power;
                  power <<= 1;
                }

                dictionary[dictSize++] = f(bits);
                c = dictSize - 1;
                enlargeIn--;
                break;

              case 1:
                bits = 0;
                maxpower = Math.pow(2, 16);
                power = 1;

                while (power != maxpower) {
                  resb = data.val & data.position;
                  data.position >>= 1;

                  if (data.position == 0) {
                    data.position = resetValue;
                    data.val = getNextValue(data.index++);
                  }

                  bits |= (resb > 0 ? 1 : 0) * power;
                  power <<= 1;
                }

                dictionary[dictSize++] = f(bits);
                c = dictSize - 1;
                enlargeIn--;
                break;

              case 2:
                return result.join('');
            }

            if (enlargeIn == 0) {
              enlargeIn = Math.pow(2, numBits);
              numBits++;
            }

            if (dictionary[c]) {
              entry = dictionary[c];
            } else {
              if (c === dictSize) {
                entry = w + w.charAt(0);
              } else {
                return null;
              }
            }

            result.push(entry); // Add w+entry[0] to the dictionary.

            dictionary[dictSize++] = w + entry.charAt(0);
            enlargeIn--;
            w = entry;

            if (enlargeIn == 0) {
              enlargeIn = Math.pow(2, numBits);
              numBits++;
            }
          }
        }
      })(LZString || (LZString = exports('LZString', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/tsExtention.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "91edbbaW7xLd4YUX0yNyADQ", "tsExtention", undefined);
      /* 
       * String
       */
      //在字符串的第sn个字后面插入字符串


      Reflect.defineProperty(String.prototype, "insert", {
        value: function (sn, flg) {
          var start = this.substr(0, sn);
          var end = this.substr(sn, this.length);
          var newstr = start + flg + end;
          return newstr;
        }
      }); //用 {0}参数 格式化字符串

      Reflect.defineProperty(String.prototype, "format", {
        value: function (args) {
          var result = this;

          if (arguments.length > 0) {
            if (arguments.length == 1 && typeof args == "object") {
              for (var key in args) {
                if (args[key] != undefined) {
                  var reg = new RegExp("({" + key + "})", "g");
                  result = result.replace(reg, args[key]);
                }
              }
            } else {
              for (var i = 0; i < arguments.length; i++) {
                if (arguments[i] != undefined) {
                  //var reg = new RegExp("({[" + i + "]})", "g");//这个在索引大于9时会有问题，谢谢何以笙箫的指出
                  var reg = new RegExp("({)" + i + "(})", "g");
                  result = result.replace(reg, arguments[i]);
                }
              }
            }
          }

          return result;
        }
      });
      Reflect.defineProperty(String.prototype, "startsWith", {
        value: function (prefix) {
          return this.slice(0, prefix.length) === prefix;
        }
      });
      Reflect.defineProperty(String.prototype, "endsWith", {
        value: function (suffix) {
          return this.indexOf(suffix, this.length - suffix.length) !== -1;
        }
      }); //字符串包含

      Reflect.defineProperty(String.prototype, "contains", {
        value: function (item) {
          let pos = this.indexOf(item);
          return pos > -1;
        }
      });

      String.format = function () {
        if (arguments.length == 0) return null;
        var str = arguments[0];

        for (var i = 1; i < arguments.length; i++) {
          var re = new RegExp('\\{' + (i - 1) + '\\}', 'gm');
          str = str.replace(re, arguments[i]);
        }

        return str;
      };
      /* 
       * Math
       */
      //限制n在范围内


      Math.clamp = function (n, min, max) {
        return Math.max(min, Math.min(max, n));
      }; //取区间内 某个位置的值


      Math.lerp = function (m, n, t) {
        t = Math.clamp(t, 0, 1);
        return m + (n - m) * t;
      };

      Reflect.defineProperty(Array.prototype, "last", {
        value: function (item) {
          return item[item.length - 1];
        }
      });
      Reflect.defineProperty(Array.prototype, "includes", {
        value: function (item) {
          let pos = this.indexOf(item);
          return pos > -1;
        }
      });
      Reflect.defineProperty(Array.prototype, "contains", {
        value: function (item) {
          let pos = this.indexOf(item);
          return pos > -1;
        }
      });
      Reflect.defineProperty(Array.prototype, "removeAt", {
        value: function (pos) {
          if (pos > -1) this.splice(pos, 1);
          return this;
        }
      });
      Reflect.defineProperty(Array.prototype, "remove", {
        value: function (item) {
          let pos = this.indexOf(item);
          if (pos > -1) this.removeAt(pos);
          return this;
        }
      });
      Reflect.defineProperty(Array.prototype, "insert", {
        value: function (pos, item) {
          this.splice(pos, 0, item);
          return this;
        }
      });
      Reflect.defineProperty(Array.prototype, "derangedArray", {
        value: function () {
          for (var j, x, i = this.length; i; j = Math.floor(Math.random() * i), x = this[--i], this[i] = this[j], this[j] = x);

          return this;
        }
      });
      /* 
       * Object
       */

      /* 
       * Function
       */

      globalThis.nullFunction = function () {};

      globalThis.addFunction = function (func, func2) {
        return function () {
          if (func && typeof func == "function") func();
          if (func2 && typeof func2 == "function") func2();
        };
      };
      /* 
       * Interval
       */


      globalThis.timeouts = {};
      globalThis.intervals = {};
      globalThis.osetTimeout = window.setTimeout;
      globalThis.osetInterval = window.setInterval;
      globalThis.oclearTimeout = window.clearTimeout;
      globalThis.oclearInterval = window.clearInterval;

      var _removeTimer = function (type, args) {
        var fnToCall = type === "timeouts" ? "oclearTimeout" : "oclearInterval",
            timerId = args[0];
        window[fnToCall].apply(this, args);

        for (var k in window[type]) {
          for (var i = 0, z = window[type][k].length; i < z; i++) {
            if (window[type][k][i] === timerId) {
              window[type][k]["splice"](i, 1);
              if (!window[type][k].length) delete window[type][k];
              return;
            }
          }
        }
      };

      var _clearAllTimer = function (type, ns) {
        var timersToClear = ns ? window[type][ns] : function () {
          var timers = [];

          for (var k in window[type]) {
            timers = timers.concat(window[type][k]);
          }

          return timers;
        }();

        for (var i = 0, z = timersToClear.length; i < z; i++) {
          _removeTimer(type, [timersToClear[i]]);
        }
      }; // window.setTimeout = function () {
      //     var args = _parseArgs('timeouts', arguments),
      //         timeout = window.osetTimeout.apply(this, args.args);
      //     window.timeouts[args.ns].push(timeout);
      //     return timeout;
      // },
      // window.setInterval = function () {
      //     var args = _parseArgs('intervals', arguments),
      //         interval = window.osetInterval.apply(this, args.args);
      //     window.intervals[args.ns].push(interval);
      //     return interval;
      // },
      // window.clearTimeout = function () {
      //     _removeTimer('timeouts', arguments);
      // },
      // window.clearInterval = function () {
      //     _removeTimer('intervals', arguments);
      // },


      globalThis.clearAllTimeout = function () {
        _clearAllTimer('timeouts', arguments[0]);
      };

      globalThis.clearAllInterval = function () {
        _clearAllTimer('intervals', arguments[0]);
      };

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/en.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "920c5VLzJxKjYCAoIUwUHym", "en", undefined);

      let en = exports('en', {
        APPNAME: "Coin Room",
        Accept: "Accept",
        ActivityAttackMasterButton: "GOT IT!",
        ActivityAttackMasterButtonTip: "Bet higher and get it faster!",
        ActivityAttackMasterDes: "Attack {0} times to get\n{1} coins",
        ActivityAttackMasterDesMore: "<color=#562900>The more bars you complete, the bigger the</color> <outline  color=#9E5A05 width=2><color=#F7E150>REWARDS!</color></outline>",
        ActivityAttackMasterFinal1: "Final bar prize:",
        ActivityAttackMasterFinal2: "{0} Coins!",
        ActivityAttackMasterTimeleft: "Ends in {0}",
        ActivityBuildKingDes: "Complete to get rewards!",
        ActivityCenterTime: "Time left : {0}",
        ActivityCenterTimeEnd: "Activity is end",
        ActivityCenterTitle: "Activity Center",
        ActivityRaidMasterDes: "Raid {0} times to get\n{1} coins",
        ActivityShopDes: "Sale time left {0}",
        ActivitySlotCollectDes1: "Attack",
        ActivitySlotCollectDes2: "Attack Blocked",
        ActivitySlotCollectDes3: "Raid",
        ActivitySlotCollectDes4: "Excellent Raid",
        ActivitySlotCollectDes5: "Hit 3 Symbols",
        ActivitySlotCollectRankGetJoin: "<outline color=000000 width=1>get <img src='{0}_s' /> to join</outline>",
        ActivitySlotCollectRankGetStart: "Start Playing to collect",
        ActivitySlotCollectRankInfoLabel1: "<outline color=ffffff width= 1>Collect <img src='{0}_s'/> to climp up the leaderboard!</outline>",
        ActivitySlotCollectRankInfoLabel2: "<outline color=ffffff width= 1><color=#4dff55>Bet higher to multiple every <img src='{0}_s'/> you collect!</color></outline>",
        ActivitySlotCollectRankRewardDes: "Here's what you won:",
        ActivitySlotCollectRankRewardDesLose: "You didn't win this time, but you still get a prize!",
        ActivitySlotCollectRankRewardEnd: "Tournament has ended",
        ActivitySlotCollectRankRewardWinner: "WINNER!",
        ActivitySpecialOfferCoin: "{0} Coins",
        ActivitySpecialOfferSpin: "{0} Spins",
        ActivitySpecialOfferTitle: "Surprise Offer",
        ActivityTimeleft: "Time Left",
        AdNotReady: "Video is not ready!",
        ApFull: "Full",
        ApPlus: "+{0} Spins",
        ApRecoverIn: "{0} spins in {1}",
        AppCommentBtn: "RATE NOW",
        AppCommentDes: "Please rate us 5 stars to make more updates~",
        AppCommentNo: "NOT NOW",
        AppCommentTitle: "Love Coin Room?",
        AppHotUpdateFail: "Load resource failed. Try again?",
        AppUpdateBtn: "UPDATE",
        AppUpdateDes: "There is a new version available! Update now!",
        AppUpdateNo: "No,thanks",
        AppUpdateTitle: "New Update",
        Attack: "ATTACK",
        AutoSpinTipWindowButton: "Try!",
        AutoSpinTipWindowDes: "Hold the button to start",
        AutoSpinTipWindowTitle: "AUTO SPIN",
        AutoSpining: "Auto",
        Back: "Back",
        Bet: "BET",
        BetRibbonText: "ALL WINS X{0}",
        BindFacebookBtn: "CONNECT",
        BindFacebookFreespin: "Login and get Free Spins",
        BindFacebookTip: "We won't post on your behalf",
        BindFacebookTitle: "Connect with Facebook",
        BlackJackGameDeal: "DEAL",
        BlackJackGameDoubleDown: "DOUBLE\nDOWN",
        BlackJackGameHit: "HIT",
        BlackJackGameStand: "STAND",
        BlackJackGameSurrender: "SURRENDER",
        BlackJackGameWatchBtn: "WATCH NOW!",
        BlackJackHelpDes1: "In Blackjack, you are trying build a hand with a higher value than the house without going over 21. Aces may count as either 11 or 1. Face cards are worth 10, and all other cards are worth the number they show.",
        BlackJackHelpDes2: "To play a round, you first must place a bet by tapping on the chip buttons. Once you've selected your bet, press the deal button to begin.",
        BlackJackHelpDes3: "Use this option when you would like to request another card. You may hit as many times as you like, but if you go over 21 you lose.",
        BlackJackHelpDes4: "When you are done requesting cards, you may stand and let the house take their turn.",
        BlackJackHelpDes5: "If a hand has 2 cards, you may use this option to double you bet, and receive only ONE more card for your hand.",
        BlackJackHelpDes6: "Any hand containing an Ace and a face card is called a black jack. Black jack beats every other hand, and pays 3 to 2 for the player.",
        BlackJackHelpDes7: "If a player's hand has the same value as the house, it is a push. The player receives their original bet back.",
        BlackJackHelpDes8: "A player is said to bust when their hand is worth more than 21.",
        BlackJackHelpDes9: "This option allows a player to receive half of their original bet back, in exchange for forfeiting their hand.",
        BlackJackHelpDes10: "Move advice will highlight the button for the suggested move during play. Move advice is based on the statistical strength of the house and player hands.",
        BlackJackHelpTitle1: "--Basic Rules--",
        BlackJackHelpTitle2: "--How to Play--",
        BlackJackHelpTitle3: "--Hit--",
        BlackJackHelpTitle4: "--Stand--",
        BlackJackHelpTitle5: "--Double Down--",
        BlackJackHelpTitle6: "--Black Jack--",
        BlackJackHelpTitle7: "--Push--",
        BlackJackHelpTitle8: "--Bust--",
        BlackJackHelpTitle9: "--Surrender--",
        BlackJackHelpTitle10: "--Move Advice--",
        BlackJackTitle: "Black Jack",
        BlackJackWatchWindowDesLose: "Watch video to recover half of losses!",
        BlackJackWatchWindowDesWin: "Watch video for 100% more coins!",
        COLLECT: "Collect",
        COLLECTED: "COLLECTED",
        Cancel: "Cancel",
        CardAllSetWindowBottom: "- Coin Room -",
        CardAllSetWindowCompleted: "Completed",
        CardAllSetWindowLock: "Unlocks at\nKingdom {0}",
        CardAllSetWindowLocked: "Locked",
        CardAllSetWindowTitle: "Collection",
        CardAsk: "Ask",
        CardAskCannot: "It cannot be asked from friends",
        CardAskCannotGolden: "This card is golden, cannot be asked from friends",
        CardChestInfoWindowHigh: "High chance for:",
        CardChestInfoWindowTitle_1: "Basic Chest",
        CardChestInfoWindowTitle_2: "Deluxe Chest",
        CardChestInfoWindowTitle_3: "Legend Chest",
        CardChestOpenWindowNew: "New",
        CardCollectButton: "Check it out",
        CardCollectDes: "Card {0}\nwas added to your album",
        CardCollectTitle: "AWESOME!",
        CardInfoWindowCommon: "Common",
        CardInfoWindowPage0_0: "Collect cards through chests",
        CardInfoWindowPage0_1: "You can also buy chests in the shop",
        CardInfoWindowPage0_2: "Chests can be found during raids and when unlocking a new room",
        CardInfoWindowPage1_0: "Owning 2 or more of the same card allows you to send them as a gift to your friends",
        CardInfoWindowPage1_1: "Tap on the card in order to gift it",
        CardInfoWindowPage1_2: "You can also ask friends for missing cards",
        CardInfoWindowPage1_3: "You can send up to 5 cards in one day",
        CardInfoWindowPage2_0: "Stars indicate cards rarity",
        CardInfoWindowPage2_2: "Each rarity star on a new collected card gives you 1 star",
        CardInfoWindowPage2_3: "Complete card sets and get amazing rewards!",
        CardInfoWindowRare: "Rare",
        CardInfoWindowTitle: "Cards Info",
        CardNewSelectFriendWindowTitle: "Friend",
        CardOpenDes: "<color=#ffffff><outline color=#000000 width=1>Collect cards to get \nmore <color=#ffcc00>Coins</color> and <color=#c667ff>Spins</color></color></outline>",
        CardOpenDesS: "<color=#308ae6>Collect cards to get more <color=#e67b07>Coins</color> and <color=#006fd7>Spins</color></color>",
        CardSelectCardWindowInfo: "Select up to {0} cards!",
        CardSelectCardWindowSelected: "Your selected cards:",
        CardSelectCardWindowSuccess: "Send card success!",
        CardSelectCardWindowTitle: "SEND CARDS",
        CardSelectFriendWindowBtn: "Select Card",
        CardSelectFriendWindowInfo: "Select 1 friend!",
        CardSelectFriendWindowTitle: "SEND CARDS",
        CardSend: "Send",
        CardSendCannot: "It cannot be sent to friends",
        CardSendCannotGolden: "This card is golden, cannot be sent to friends",
        CardSendCannotLeast: "You need more than one card to send",
        CardSendCannotLimit: "You reached the daily limit of cards you can send",
        CardSingleSetWindowCompleted: "- SET COMPELETED -",
        CardSingleSetWindowReward: "Complete the set to win",
        CardSingleSetWindowTip: "* Tap on a duplicate card to send it to a friend",
        CardTradeButton: "GO TRADE!",
        CardTradeDes: "ARE NOW TRADABLE!",
        CardTradeTradable: "Tradable",
        CardTapToCollect: "Tap to collect",
        ChatSend: "Send",
        CoinShopLevel: "Level {0}",
        CoinStore: "Coins Shop",
        Confirm: "Confirm",
        Congratulation: "Congratulation!",
        ContentNameActivityItem6: "Cannonball",
        ContentNameActivityItemCommon: "Item",
        ContentNameAp: "Spins",
        ContentNameCard: "Card",
        ContentNameChest1: "Basic Chest",
        ContentNameChest2: "Deluxe Chest",
        ContentNameChest3: "Legend Chest",
        ContentNameChest4: "Free Chest",
        ContentNameCoin: "Coins",
        ContentNameJigsaw: "Jigsaw Piece",
        ContentNamePack: "Items",
        ContentNameShield: "Shield",
        ContentNameUnknown: "???",
        CountDay: "{0}days",
        CountHour: "{0}hours",
        CountMinute: "{0}minutes",
        CountMonth: "{0}Months",
        CountSecond: "{0}seconds",
        CountYear: "{0}Years",
        DailyBonusCollect: "Collect",
        DailyBonusFreeSpinDes: "1 Free spin in\n{0}",
        DailyBonusGoldFirst: "At least 25M coins for first time!!!",
        DailyBonusGoldSpinBtn: "Spin for {0}",
        DailyBonusLevel: "Level {0}",
        DailyBonusNormalSpinBtn: "FREE SPIN",
        ErrorLogin: "Failed to connect to server.",
        ErrorMsg0: "Success",
        ErrorMsg1114: "Watch too many videos today",
        ErrorMsg1703: "Purchase failed",
        ErrorNormal: "Lost connection to server.",
        ErrorRetry: "Failed to connect to server, try again?",
        ExtraRewardDes: "Coin Room has gifted you Coins and Spins!",
        FirstPurchaseButton: "GO!",
        FirstPurchaseDes1: "Make any purchase to",
        FirstPurchaseDes2: "GET EXTRA REWARDS!",
        FormatDay: "",
        FormatHour: ":",
        FormatMinute: ":",
        FormatMonth: "/",
        FormatSecond: "",
        FormatYear: "/",
        FriendsModelNoResult: "No friends yet",
        FriendsModelPlaceHolder: "Enter friend's name",
        GameMainWindowActivity: "ACTIVITY",
        GameMainWindowQuest: "QUEST",
        GetRewardWindowDes: "<outline color=#000000 width=1><color=#ffffff>  You have got rewards  </color>\n<color=#c34eff>{0}!</color></outline>",
        GuestConfirmDes: "Guests can't play\nwith friends",
        GuestConfirmGuest: "Play as Guest",
        GuestConfirmTitle: "Are you sure?",
        Help_cannon: "1. Collect the cannonballs\n     to attack castle and get\n     big rewards!\n2. Rings can refresh the\n     treasures of castle.\n3. Cannonballs can be\n     obtained through spins\n     and  room evolving.\n4. Collection of valuables\n     can be exchanged for\n     treasure box rewards!\n5. Magic Gem can replace\n     any valuable.",
        Help_coinhit: "1. Spend one ticket\n     to enter the game.\n2. You can get lots of\n      coins and spins in\n      challenge.\n3. More squares you\n      break, more rewards\n      you get.\n4. Adjust the angle to\n      hit more squares.",
        Help_jigsaw: "1. Collect 9 pieces then\n      get rewards.\n2. Pieces are collected in\n      slots and evolvement.\n3. Pieces will be cleared\n      when activity is end.\n4. Universal Jigsaw can\n      replace any piece.",
        Help_sign: "1. You can get monthly sign reward every 7 days in a month.\n2. Monthly sign will refresh in next month.\n3. You can get weekly sign reward every day in a week.\n4. Weekly sign will refresh in next week.",
        InteractionAttackFriends: "Friends",
        InteractionAttackName: "{0}'s room",
        InteractionAttackResultBlock: "<outline color=#000000 width=1><color=#29ffed> {0}</color> blocked your attack. \n You won <color=#ffc209> {1} </color></outline>",
        InteractionAttackResultBlock2: "<outline color=#000000 width=1><color=#29ffed> {0}</color> blocked your attack. \n You won <color=#ffc209> {1} </color></outline>",
        InteractionAttackResultSuccess: "<outline color=#000000 width=1> You attacked <color=#29ffed>{0}'s</color> room \n and won <color=#ffc209> {1} </color></outline>",
        InteractionAttackResultSuccess2: "<outline color=#000000 width=1> You attacked <color=#29ffed>{0}'s</color> room \n and won <color=#ffc209> {1} </color></outline>",
        InteractionAttackRevenge: "Revenge",
        InteractionBet: "×{0}",
        InteractionRaidBrag: "Share",
        InteractionRaidCoinMaster: "King",
        InteractionRaidEmpty: "Failed",
        InteractionRaidName: "{0}'s treasure:",
        InteractionRaidPrefect: "Excellent raid!",
        InteractionRaidResultLine: "<outline color=#000000 width=1>You stole <color=#ffc209>{0}</color> coins from <color=#29ffed>{1}</color></outline>",
        InteractionRaidResultLine2: "<outline color=#000000 width=1>You stole <color=#ffc209>{0}</color> coins from <color=#29ffed>{1}</color></outline>",
        InteractionRaidStole: "You Stole:",
        LeaderBoardWindowTabCountry: "Country",
        LeaderBoardWindowTabFriends: "Friends",
        LeaderBoardWindowTabGlobal: "Global",
        LeaderBoardWindowTip: "Refresh in 10 minutes",
        Level: "Level",
        LevelBonusDes1: "<outline color=#000000 width=1><size=40><color=#4bfe2e>30</color></size> times extra bonus\nTotally get <size=40><color=#1ddcff>5000</color></size> spins!</outline>",
        LevelBonusDes2: "Get holy plenty of spins rewards pass levels after purchase!",
        LevelBonusItemDes: "For room {0}",
        Loading: "Loading",
        LoginWindowGuest: "Guest",
        LoginWindowNeedUpdate: "There are some updates.",
        LoginWindowPlay: "Login with Facebook",
        LoginWithApple: "Sign in with Apple",
        LoginWindowUpdating: "Updating",
        LuckyDrawDes1: "Watch Video",
        LuckyDrawDes2: "Get Chance",
        LuckyDrawFree: "Free",
        MORE: "MORE",
        MultiplePurchaseBtn: "SPIN",
        MultiplePurchaseDes1: "Spin to win up to",
        MultiplePurchaseDes2: "x10",
        MultiplePurchaseDes3: "for an additional {0}",
        NO: "NO",
        NewPlayerPackButton: "BUY NOW!",
        NewPlayerPackDes1: "Welcome to Coin Room!",
        NewPlayerPackDes2: "<outline color=#000000 width=1>We prepared a <color=#c667ff><size=40>BIG GIFT</c></size> for you~</outline>",
        NewUserInvitedDes: "{0} unlocked new room!You got \n{1} FREE SPINS",
        NewUserInvitedDesApp: "{0} joined the game!You got \n{1} FREE SPINS",
        NewUserInvitedTitle: "FRIEND REWARD",
        No: "No",
        NotEnoughApAdd: "+{0} Spins",
        NotEnoughApDes: "Out of spins?",
        NotEnoughApWait: "or wait {1} for {0} spins",
        NotEnoughApWait2: "Wait {1} for {0} spins",
        NotEnoughCoinDes: "Out of coins?",
        NotEnoughOff: "{0}%\nMORE",
        NotificationDesActivity: "{0} will end in an hour!",
        NotificationDesApFull: "We have enough spins to play and get more coins!",
        NotificationDesAttack: "Someone has invaded your room!",
        NotificationDesBack: "We prepared a big present for you!",
        NotificationDesBack2: "Come back! We prepared a big present for you!",
        NotificationDesDailyBonus: "Come and play daily Wheel of Fortune!",
        NotificationTitleActivity: "Activity will end!",
        NotificationTitleApFull: "You have got full spins!",
        NotificationTitleAttack: "Let's revenge!",
        NotificationTitleBack: "Long time no see!",
        NotificationTitleBack2: "Come play with me!",
        NotificationTitleDailyBonus: "Daily bonus is available now!",
        Now10XBetter: "10 times better!",
        OFF: "OFF",
        OK: "OK",
        OffText: "{0}%\nMORE",
        PastDay: "{0}d ago",
        PastHour: "{0}h ago",
        PastMinute: "{0}m ago",
        PastMonth: "{0}mo ago",
        PastSecond: "{0}s ago",
        PastYear: "{0}y ago",
        PastZero: "Now",
        PayDisable: "Payment is disabled!",
        PayDisableFBIn: "Sorry, the payment function is currently incompatible with your system. Please enter Coin Room via Instant Games to complete purchase on a computer.",
        PayDisableIos: "Payment is disabled on iOS!",
        PayEnabledAndroid: "Payment is only enabled on Android!",
        PayFail: "Purchase failed!",
        PayFailWindowBtn: "Contact Support",
        PayFailWindowDes: "Having problems purchasing?",
        PayPending: "Your purchase is pending! After completing to pay, restart the game to get items.",
        PaySuccess: "Thank you for your purchase!",
        PeterOpenDes1: "Parrot Peter will bring you random gift!",
        PeterOpenDes2: "Just touch Peter and receive gift when it comes!",
        PlayerDefaultName: "Player",
        PriceSymbol: "$",
        Raid: "RAID",
        RaidProtect: "RAID PROTECTED",
        Rank: "Rank",
        Reconnect: "RETRY",
        Restart: "Restart",
        Retry: "Retry",
        START: "START",
        SaleMark: "SALE",
        Score: "Score",
        ScorePoint: "Point",
        ScoreRank: "Rank",
        ServantEffectDes1: "Increases raids reward",
        ServantEffectDes2: "Increases attacks reward",
        ServantEffectDes3: "Protects from attacks",
        ServantEffectDes4: "Protects from raids",
        ServantEffectNum1: "Increases reward by: ",
        ServantEffectNum2: "Increases reward by: ",
        ServantEffectNum3: "Protection chance: ",
        ServantEffectNum4: "Protection chance: ",
        ServantInfo1: "upgrade:",
        ServantInfo2: "Each slot machine spin = 1 Servant Exp. You can use potions to get more Servant Exp. When the Servant Exp bar is full, tap on the upgrade button to upgrade you servant. Each servant upgrade will increase your game star",
        ServantInfo3: "Skill:",
        ServantInfo4: "Servant's skill improves with each level upgrade",
        ServantInfo5: "Activation:",
        ServantInfo6: "Feed your servant to activate it. Get Servant Food while spinning and building",
        ServantName1: "Pigy",
        ServantName2: "Billy",
        ServantName3: "Doge",
        ServantName4: "Ruby",
        ServantNextLevel: "Next level: ",
        ServantOpenDes: "<outline color=#000000 width=1><color=#ffffff>Hire servants to get \n more <color=#ffcc00>Coins</color> and <color=#c667ff>Spins</color></color></outline>",
        ServantOpenDesS: "<color=#308ae6>Hire servants to get more <color=#e67b07>Coins</color> and <color=#006fd7>Spins</color></color>",
        ServantSelect: "Select",
        ServantUpgrade: "Upgrade",
        ShareChooseDialogTitle: "Send",
        ShareDialogTitle: "Share",
        ShareInviteAttack: "WOW! I just attack other's room! So Cool:-D",
        ShareInviteDialogTitle: "Invite",
        ShareInviteFinishVillage: "I just built a new room! Come and have a visit :-D",
        ShareInviteNew: "Hey, this is really an awesome game! Let's play together :-P",
        ShareInviteRaid: "WOW! I just stole {0} coins! So Cool:-D",
        ShareInviteSendCoins: "{0} just gave you some coins :)",
        ShareInviteSendSpin: "{0} just gave you a spin :)",
        ShareJigsawTitle: "I need these. Help me!",
        ShareSendCard: "{0} just gave you cards :)",
        ShareTitle: "Hey, this is really an awesome game! Let's play together :-P",
        Shield: "SHIELD",
        ShopAddPercent: "{0}%\nMORE",
        ShopBestValue: "Best\nValue",
        ShopChestDisable: "Chests Unlock at room {0}",
        ShopChests: "CHESTS",
        ShopCoinPrice: "${0}",
        ShopCoins: "COINS",
        ShopOff: "{0}%\nOFF",
        ShopPopular: "Hot",
        ShopShield: "SHIELDS",
        ShopShieldDes1: "SILVER SHIELDS",
        ShopShieldDes2: "GOLDEN SHIELDS",
        ShopShieldDes3: "Protect against: Attacks",
        ShopShieldDes4: "Protect against: Attacks & ",
        ShopShieldDes5: " Raids ",
        ShopShieldDes6: "(exclusive)",
        ShopSpinNum: "{0}",
        ShopSpinPrice: "${0}",
        ShopSpins: "SPINS",
        ShopTitle: "Shop",
        ShopTreatDisable: "Treats Unlock at room {0}",
        ShopTreatFoodTime: "{0}h activation",
        ShopTreats: "TREATS",
        SlotBetNewMax: "Bet limit increased",
        SlotBetSuper: "SUPER",
        SlotCoin6Video: "Watch a video and get coins x2",
        SlotPeterDesAd: "I have a gift for you!",
        SlotSymbol1: "SODA",
        SomeDay: "{0}d",
        SomeHour: "{0}h",
        SomeMinute: "{0}m",
        SomeMonth: "{0}mo",
        SomeSecond: "{0}s",
        SomeYear: "{0}y",
        SomeZero: "Now",
        Spins: "SPINS+{0}",
        SuperShieldOpenDes: "Super Shield protects room from Attack & Raid for a long time",
        ToRaidUserBet: "WIN X{0}",
        TutorialDialogDoSpin: "Use the slot machine to spin\nattack and raid others.",
        TutorialDialogGoSpin: "You don't have enough coins...\n\nSwipe down to earn more coins.",
        TutorialDialogSlotAttack: "Attack other players' rooms to get coins.",
        TutorialDialogSlotRaid: "Raid the king's room and steal his coins!",
        TutorialDialogSlotRaidMaster: "This is the Room\nLet's Raid Him!",
        TutorialDialogSlotShield: "Shields will protect your room from attacks.",
        TutorialDialogStar: "Level up some item then you will get one star.\nCollect 25 stars to unlock next room.",
        TutorialFinishDes0: "Your rewards :",
        TutorialFinishDes1: "60 spins!",
        TutorialFinishDes1bind: "20 spins!",
        TutorialFinishDes2: "1M coins!",
        TutorialFinishDes3: "Save the progress!",
        TutorialFinishDes4: "Play with your friends!",
        TutorialFinishTitle: "Success!",
        TutorialStartDes: "Welcome My Friend!\nPress the button to start your work.",
        TutorialStartTitle: "YOUR FIRST ROOM",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        TutorialTargetName: "Target",
        TutorialTargetName1: "Leyla",
        TutorialTargetName2: "Mary",
        TutorialTargetName3: "Kevin",
        VillageCompleteNext: "Next",
        VillageCompleteTitle: "Room Finish!",
        VillageShopBuy: "BUY",
        VillageShopComplete: "COMPLETE!",
        VillageShopFix: "FIX",
        VillageShopTitle: "Room Evolve",
        VipDailyRewardDes: "Get these EVERYDAY!",
        VipExtraRewardButton: "GET ALL",
        VipExtraRewardDes: "Unlock VIP to get ALL the accumulated BONUS",
        VipGetTrialButtonDes1: "Start for free",
        VipGetTrialButtonDes2: "3 days free trial, then {0} per month",
        VipGetWindowButtonMonth: "MONTH",
        VipGetWindowButtonWeek: "WEEK",
        VipGetWindowButtonYear: "YEAR",
        VipGetWindowDailyRecovery: "RECOVERY Limit",
        VipGetWindowDailySpe: "<outline color=#000000 width=1><color=#FFFFFF>Shinning look with <color=#ffba00>red name</color> and <color=#ffba00>crown</color>!</color></outline>",
        VipGetWindowDailyTitle: "Daily Rewards",
        VipGetWindowHot: "HOT",
        VipGetWindowPolicy: '<color=#d1acf3>VIP for specify price offers a.subtractscription, gets Spins, Food and Card everyday. This is an <color=#35e35e><u><on click="handle" param="subtract">Auto-renewing.subtractscription</on></u></color>. Payment is charged to phone Account at confirmation. <color=#d1acf3>Subcription is renewed unless turned off 24h before the period ends, account will be charged for renewal as well.</c> You may turn it off in your Account Settings. Any unused portion of a free trial period, if offered, will be forfeited when the user purchases a.subtractscription to that publication, where applicable. <color=#35e35e><u><on click="handle" param="pri">Privacy Policy and Terms of Use</on></u></color>.</color>',
        VipGetWindowRewardDes: "Get extra spins and coins in Slot activity",
        VipGetWindowRewardRewards: "Rewards",
        YES: "YES",
        Yes: "Yes",
        adShieldTip: "Get free shield!",
        and: "and",
        betMaxBet: "Max Bet x",
        cannon_get_reward_window_exchange: "Exchange",
        cannon_get_reward_window_title: "Exchange Reward",
        cannon_item_window_btn_regain: "Regain",
        cannon_item_window_btn_send: "Send",
        cannon_item_window_title: "EXCHANGE",
        cannon_main_window_no_ball: "No Cannon Ball !",
        cannon_main_window_refresh_check: "Use ring to refresh? There are still {0} boxes!",
        cannon_main_window_refresh_time: "Auto refresh\n",
        cannon_meesage_window_collect: "<color=#F48B03>{0}</color><color=#7E4B27> sent you the item </color><color=#19B8B2>{1}</color>",
        cannon_message_window_no_message: "No messages.",
        cannon_message_window_send: "<color=#7E4B27>You sent </color><color=#F48B03>{0}</color><color=#7E4B27> the item </color><color=#19B8B2>{1}</color>",
        cannon_message_window_title: "Message",
        cannon_name: "Cannon",
        cannon_send_item_window_choosed_friend: "Choosed friend:",
        cannon_send_item_window_choosed_item: "Choosed item:",
        cannon_send_item_window_send: "Send",
        cannon_send_item_window_title: "Send Item: Choose Friend",
        cannon_shop_window_title: "More Bombs?",
        cannon_use_magic_item_window_cancel: "Cancel",
        cannon_use_magic_item_window_confirm: "Confirm",
        collectionFreeChest: "FREE CHEST",
        communityCardNoCards: "Haven’t receive cards from \n your friends",
        communityCommunity: "Community",
        facebookF: "f",
        gifts_collect: "Collect",
        gifts_collect_all: "Collect / Send All",
        gifts_collect_all2: "Collect All",
        gifts_collect_coins: "Daily coins collected {0}/{1}",
        gifts_collect_spins: "Daily spins collected {0}/{1}",
        gifts_default_explain: "Get Free Spins",
        gifts_default_name: "Invite Friends",
        gifts_explain_card_cantcollect: "You must reach room {0} to collect this card",
        gifts_explain_card_collect: "Send you a card",
        gifts_explain_card_send: "Send cards\nto your friends",
        gifts_explain_coin_collect: "Send you {0} coins",
        gifts_explain_coin_send: "Gift free coins",
        gifts_explain_spin_collect: "Send you {0} spin",
        gifts_explain_spin_send: "Gift free spin",
        gifts_invite: "Invite",
        gifts_note: "",
        gifts_send: "Send",
        gifts_tab0: "Free Spins",
        gifts_tab1: "Free Coins",
        gifts_tab2: "Cards",
        gifts_title: "Gifts",
        heist_main_window_cannot_buy: "Unlock by purchasing previous deal",
        heist_main_window_free: "Free",
        heist_main_window_title: "TAKE EACH DEAL TO FURTHER REVEAL",
        inviteNeedMoreSpins: "Need More Spins?",
        inviteUpper: "INVITE",
        invite_addnumber_type0: "+{0}",
        invite_invite: "Invite",
        invite_lineA: "<color=#FFFFFF><outline color=#000000 width=1>Invite friends and get</outline></color><color=#4aff5f><outline color=#000000 width=1> {0} free spins</outline></color><color=#FFFFFF><outline color=#000000 width=1>\nfor each friend that unlock</outline></color> \n<color=#FFFFFF><outline color=#000000 width=1>room 2!</outline></color>",
        invite_lineApp: "<color=#FFFFFF><outline color=#000000 width=1>Invite friends and get</outline></color><color=#4aff5f><outline color=#000000 width=1> {0} free spins</outline></color><color=#FFFFFF><outline color=#000000 width=1>\nfor each friend that enter game!</outline></color>",
        invite_note: "* You'll get a reward after your friend\nconnects through Facebook",
        invite_title: "Want More Spins?",
        jigsaw_friends_window_no_friends: "No Friends.",
        jigsaw_friends_window_search_pre: "Search friend name",
        jigsaw_friends_window_send: "Send",
        jigsaw_friends_window_title: "FRIENDS",
        jigsaw_news_window_news_collect: "<color=#F48B03>{0} </color><color=#7E4B27>Send you the piece</color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_news_send: "<color=#7E4B27>You send</color><color=#F48B03> {0} </color><color=#7E4B27>the piece</color><color=#19B8B2> {1}</color>",
        jigsaw_news_window_no_news: "No News.",
        jigsaw_news_window_title: "NEWS",
        jigsaw_window_complete: "FILL ALL",
        jigsaw_window_send: "Send",
        jigsaw_window_title: "JIGSAW",
        jigsaw_window_universal_tip: "Choose one piece to replace",
        jigsaw_window_use: "Use",
        jigsaw_window_used: "Used",
        loadResError: "load resource failed. Try again?",
        mainTapBuild: "Build",
        map_comming_soon: "COMMING SOON",
        map_title: "{0}. {1}",
        menu_0_play: "PLAY",
        menu_1_village: "KINGDOM",
        menu_2_buy: "BUY COINS/SPINS",
        menu_3_daily: "Daily Bonus",
        menu_4_shop: "KINGDOM EVOLVE",
        menu_5_news: "Message",
        menu_6_gifts: "GIFT",
        menu_7_card: "CARD",
        menu_8_map: "Map",
        menu_9_leaderboard: "Leaderboard",
        menu_10_invite: "Invite",
        menu_11_setting: "Setting",
        menu_12_servent: "Servent",
        menu_13_signin: "Reward Calendar",
        menu_title: "MENU",
        messageNoMail: "No Mails yet!",
        messageNoMessage: "No Messages yet!",
        mini_game_coinhit_btn_end: "Get Reward",
        mini_game_coinhit_btn_next_round: "Next Round",
        mini_game_coinhit_go: "GO!",
        mini_game_coinhit_info: "A big trip to win\ncoins, spins and chests!",
        mini_game_coinhit_info_title: "REWARD LIST",
        mini_game_coinhit_manual_end: "Yes to get reward now! Get coin {0}, Get spin {1}",
        mini_game_coinhit_manual_next_round: "Game stuck? Yes to go to the next round",
        mini_game_coinhit_rank_info: "Block Hit Count: {0}",
        mini_game_coinhit_time: "Ends in {0}",
        mini_game_end: "Game End",
        mini_game_fail: "Game load fail, please try again",
        mini_game_rank_window_no_ranks: "No Ranks",
        mini_game_rank_window_title: "RANKING",
        minigame_buy_ticket_window_title: "More Tickets?",
        minigame_coinhit_second_title: "Adjust the angle of shooting to break more blocks and get big rewards!",
        minigame_coinhit_title: "Hit & Win",
        minigame_gameover: "GameOver!",
        minigame_start_game: "START",
        minigame_time: "Ends in {0}",
        multiplyX: "X",
        multiplyx: "x",
        pageSlotServant: "SERVANT",
        quest_center_window_check: "Sign",
        quest_center_window_check_do: "SIGN",
        quest_center_window_check_done: "SIGNED",
        quest_center_window_daily: "Daily",
        quest_center_window_daily_get: "Collect",
        quest_center_window_daily_go: "GO",
        quest_center_window_day_1: "1 day",
        quest_center_window_day_2: "2 day",
        quest_center_window_day_3: "3 day",
        quest_center_window_day_4: "4 day",
        quest_center_window_day_5: "5 day",
        quest_center_window_day_6: "6 day",
        quest_center_window_day_7: "7 day",
        quest_center_window_invite: "Invite",
        quest_center_window_main_quest_goal_reward: "Goal: {0}\nReward: {1}",
        quest_center_window_main_quest_name: "Main Quest: {0}",
        quest_center_window_month_box_7: "7 days",
        quest_center_window_month_box_14: "14 days",
        quest_center_window_month_box_21: "21 days",
        quest_center_window_month_box_28: "28 days",
        quest_center_window_refresh_dialog: "Tasks is refresh on new day, please reopen window",
        quest_center_window_refreshin: "Refresh in",
        quest_center_window_title: "Quest Center",
        revengeNoFriends: "No Friends yet!",
        revenge_attack: "Attack",
        revenge_random: "Random",
        revenge_revenge: "Revenge",
        revenge_title_attack: "Attack your friend!",
        revenge_title_revenge: "Revenge!",
        servantADFree: "FREE",
        settingLogOut: "LogOut",
        settingUid: "Uid: ",
        settingVersion: "Version: ",
        setting_english: "English",
        setting_general: "General",
        setting_language: "Language",
        setting_language_de: "Deutsch",
        setting_language_en: "English",
        setting_language_es: "Español",
        setting_language_fr: "Français",
        setting_language_title: "Language",
        setting_language_zh: "中文",
        setting_like: "LIKE",
        setting_likeus: "Like us and don't miss out on\namazing events and gifts",
        setting_lowbattery: "Low Power Mode",
        setting_lowbattery_tip: "Open Low Power Mode will reduce power consumption but decrease the performance",
        setting_music: "Music",
        setting_notifications: "Notifications",
        setting_privacy: "Terms & Privacy",
        setting_raid: "Raid & Attack",
        setting_sound: "Sound",
        setting_support: "Support",
        setting_terms: "Terms & Conditions",
        setting_title: "Settings",
        setting_tutorial: "Tutorial",
        setting_uuid: "",
        shopBestSeller: "BEST SELLER",
        shopCardInfoBuy: "Buy",
        shopLevelBonus: "LEVEL BONUS",
        slotServantAdTip: "Feed me food!",
        villageTownReward: "Town Reward",
        village_news_expire: "Expire in {0}",
        village_news_fox: "",
        village_news_log_hammer: " attacked your room ",
        village_news_log_hammer_vip: " attacked your room ",
        village_news_log_invite: " joined Coin Room ",
        village_news_log_invite_vip: " joined Coin Room ",
        village_news_log_noraid: " failed to stole {0} from you ",
        village_news_log_noraid_vip: " failed to stole {0} from you ",
        village_news_log_pig: " stole {0} from you ",
        village_news_log_pig_vip: " stole {0} from you ",
        village_news_log_shield: " failed to attack your room ",
        village_news_log_shield_vip: " failed to attack your room ",
        village_news_rhino: "",
        village_news_tab1: "Message",
        village_news_tab2: "Mail",
        village_news_tiger: "",
        village_news_title: "News",
        watch_coin: "+{0} COINS",
        watch_get: "Watch a video and get",
        watch_spin: "+{0} SPINS",
        watch_watch: "WATCH",
        wxUserinfoDenyConfirm: "Go access",
        wxUserinfoDenyDes: "We need your information",
        wxUserinfoDenyTitle: "Need Access",
        wxVersionNoSupport: "Function is currently incompatible with your client version, please update your wechat."
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/i18n.ts", ['cc', './LocalizedManager.ts', './UIRoot.ts', './StaticGame.ts', './BigNumber.ts', './polyglot.ts'], function (exports) {
  'use strict';

  var cclegacy, sys, Label, RichText, updateAllLabels, UIRoot, Meta, BigNumber, Polyglot;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sys = module.sys;
      Label = module.Label;
      RichText = module.RichText;
    }, function (module) {
      updateAllLabels = module.updateAllLabels;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      Polyglot = module.Polyglot;
    }],
    execute: function () {
      exports('i18n', void 0);

      cclegacy._RF.push({}, "93789C/shtIL6entYsZPjee", "i18n", undefined); // default language "en"


      let lang = "en"; //cc.sys.language;

      let supportList = ['en', 'es', 'de', 'fr', 'zh'];

      if (!supportList.includes(lang) || CC_EDITOR) {
        lang = 'en';
      }

      let user_lang = sys.localStorage.getItem("user_language");

      if (user_lang) {
        lang = user_lang;
      }

      Label.prototype.updateRightLanguage = function () {
        if (lang == sys.LANGUAGE_ARABIC && this.horizontalAlign == Label.HorizontalAlign.LEFT && !this.ARABIC_Right) {
          this.ARABIC_Right = true;
          this.horizontalAlign = Label.HorizontalAlign.RIGHT;
        }

        if (lang != sys.LANGUAGE_ARABIC && this.ARABIC_Right) {
          this.ARABIC_Right = undefined;
          this.horizontalAlign = Label.HorizontalAlign.LEFT;
        }

        this.RightLanguage = i18n.isLangRight();
      };

      RichText.prototype.updateRightLanguage = function () {
        if (lang == sys.LANGUAGE_ARABIC && this.horizontalAlign == Label.HorizontalAlign.LEFT && !this.ARABIC_Right) {
          this.ARABIC_Right = true;
          this.horizontalAlign = Label.HorizontalAlign.RIGHT;
        }

        if (lang != sys.LANGUAGE_ARABIC && this.ARABIC_Right) {
          this.ARABIC_Right = undefined;
          this.horizontalAlign = Label.HorizontalAlign.LEFT;
        }

        this.RightLanguage = i18n.isLangRight();
      };

      let getLangData = lang => {
        let _data = {};
        const allLangData = Meta.MetaManager.GetMetas(Meta.MetaType.locale);

        for (let key in allLangData) {
          _data[allLangData[key].Id()] = allLangData[key].getDataByLocale(lang);
        }

        return _data;
      };

      let data; // update this to set your default displaying language in editor

      let inited = false; // let polyglot = null;

      let polyglot = new Polyglot({
        phrases: data,
        allowMissing: true
      });
      let polyglotEn = new Polyglot({
        phrases: data,
        allowMissing: true
      });
      let i18n;

      (function (_i18n) {
        function init(language) {
          if (!inited) {
            inited = true;
            data = getLangData("en");
            polyglotEn.replace(data);
          }

          lang = language;
          data = getLangData(lang);
          polyglot.replace(data);
          sys.localStorage.setItem("user_language", lang);
        }

        _i18n.init = init;

        function getLang() {
          return lang;
        }

        _i18n.getLang = getLang;

        function changeto(nlang) {
          // if (lang == nlang) return;
          init(nlang);
          BigNumber.setLanguage();
          updateAllLabels();
          UIRoot.instance.getComponentsInChildren("LabelLocalized").forEach(x => {
            x["onLoad"]();
          });
          UIRoot.instance.getComponentsInChildren(Label).forEach(x => {
            if (x.updateRightLanguage) x.updateRightLanguage();
          });
          UIRoot.instance.getComponentsInChildren(RichText).forEach(x => {
            if (x.updateRightLanguage) x.updateRightLanguage();
          });
        }

        _i18n.changeto = changeto;

        function isLangRight() {
          return lang == "ar";
        }

        _i18n.isLangRight = isLangRight;

        function t(key, opt) {
          if (!has(key)) {
            return polyglotEn.t(key, opt);
          }

          const result = polyglot.t(key, opt);

          if (result) {
            return result;
          }

          return polyglotEn.t(key, opt);
        }

        _i18n.t = t;

        function has(key) {
          return polyglot.has(key);
        }

        _i18n.has = has;

        function sel(obj) {
          if (typeof obj != "object") return obj;
          return obj[lang] || obj["en"] || (Object.keys(obj).length > 0 ? obj[Object.keys(obj)[0]] : "");
        }

        _i18n.sel = sel;
      })(i18n || (i18n = exports('i18n', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CCEaseTypes.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports('CCEaseTypes', void 0);

      cclegacy._RF.push({}, "9464c1/5/RCwZhGmGPLoD/l", "CCEaseTypes", undefined);

      let CCEaseTypes;

      (function (_CCEaseTypes) {
        let Types;

        (function (Types) {
          Types[Types["linear"] = 0] = "linear";
          Types[Types["easeIn"] = 1] = "easeIn";
          Types[Types["easeOut"] = 2] = "easeOut";
          Types[Types["easeInOut"] = 3] = "easeInOut";
          Types[Types["easeExponentialIn"] = 4] = "easeExponentialIn";
          Types[Types["easeExponentialOut"] = 5] = "easeExponentialOut";
          Types[Types["easeExponentialInOut"] = 6] = "easeExponentialInOut";
          Types[Types["easeSineIn"] = 7] = "easeSineIn";
          Types[Types["easeSineOut"] = 8] = "easeSineOut";
          Types[Types["easeSineInOut"] = 9] = "easeSineInOut";
          Types[Types["easeElasticIn"] = 10] = "easeElasticIn";
          Types[Types["easeElasticOut"] = 11] = "easeElasticOut";
          Types[Types["easeElasticInOut"] = 12] = "easeElasticInOut";
          Types[Types["easeBounceIn"] = 13] = "easeBounceIn";
          Types[Types["easeBounceOut"] = 14] = "easeBounceOut";
          Types[Types["easeBounceInOut"] = 15] = "easeBounceInOut";
          Types[Types["easeBackIn"] = 16] = "easeBackIn";
          Types[Types["easeBackOut"] = 17] = "easeBackOut";
          Types[Types["easeBackInOut"] = 18] = "easeBackInOut";
          Types[Types["easeQuadraticActionIn"] = 19] = "easeQuadraticActionIn";
          Types[Types["easeQuadraticActionOut"] = 20] = "easeQuadraticActionOut";
          Types[Types["easeQuadraticActionInOut"] = 21] = "easeQuadraticActionInOut";
          Types[Types["easeQuarticActionIn"] = 22] = "easeQuarticActionIn";
          Types[Types["easeQuarticActionOut"] = 23] = "easeQuarticActionOut";
          Types[Types["easeQuarticActionInOut"] = 24] = "easeQuarticActionInOut";
          Types[Types["easeQuinticActionIn"] = 25] = "easeQuinticActionIn";
          Types[Types["easeQuinticActionOut"] = 26] = "easeQuinticActionOut";
          Types[Types["easeQuinticActionInOut"] = 27] = "easeQuinticActionInOut";
          Types[Types["easeCircleActionIn"] = 28] = "easeCircleActionIn";
          Types[Types["easeCircleActionOut"] = 29] = "easeCircleActionOut";
          Types[Types["easeCircleActionInOut"] = 30] = "easeCircleActionInOut";
          Types[Types["easeCubicActionIn"] = 31] = "easeCubicActionIn";
          Types[Types["easeCubicActionOut"] = 32] = "easeCubicActionOut";
          Types[Types["easeCubicActionInOut"] = 33] = "easeCubicActionInOut";
          Types[Types["easeBezierAction"] = 34] = "easeBezierAction";
        })(Types || (Types = {}));

        _CCEaseTypes.Types = Types;

        function GetEasing(t, ...args) {
          switch (t) {
            case Types.easeIn:
              {
                const arg0 = args[0] || 2;
                return function (k) {
                  return Math.pow(k, arg0);
                };
              }

            case Types.easeOut:
              {
                const arg0 = args[0] || 2;
                return function (k) {
                  return Math.pow(k, 1 / arg0);
                };
              }

            case Types.easeInOut:
              {
                const arg0 = args[0] || 2;
                return function (k) {
                  k *= 2;
                  if (k < 1) return 0.5 * Math.pow(k, arg0);else return 1.0 - 0.5 * Math.pow(2 - k, arg0);
                };
              }

            case Types.easeExponentialIn:
              {
                return "expoIn";
              }

            case Types.easeExponentialOut:
              {
                return "expoOut";
              }

            case Types.easeExponentialInOut:
              {
                return "expoInOut";
              }

            case Types.easeSineIn:
              {
                return "sineIn";
              }

            case Types.easeSineOut:
              {
                return "sineOut";
              }

            case Types.easeSineInOut:
              {
                return "sineInOut";
              }

            case Types.easeElasticIn:
              {
                const arg0 = args[0] || 0.3;
                return function (k) {
                  if (k === 0 || k === 1) return k;
                  k = k - 1;
                  return -Math.pow(2, 10 * k) * Math.sin((k - arg0 / 4) * Math.PI * 2 / arg0);
                };
              }

            case Types.easeElasticOut:
              {
                const arg0 = args[0] || 0.3;
                return function (k) {
                  return k === 0 || k === 1 ? k : Math.pow(2, -10 * k) * Math.sin((k - arg0 / 4) * Math.PI * 2 / arg0) + 1;
                };
              }

            case Types.easeElasticInOut:
              {
                let arg0 = args[0] || 0.3;
                return function (k) {
                  var newT = 0;
                  var locPeriod = arg0;

                  if (k === 0 || k === 1) {
                    newT = k;
                  } else {
                    k = k * 2;
                    if (!locPeriod) locPeriod = arg0 = 0.3 * 1.5;
                    var s = locPeriod / 4;
                    k = k - 1;
                    if (k < 0) newT = -0.5 * Math.pow(2, 10 * k) * Math.sin((k - s) * Math.PI * 2 / locPeriod);else newT = Math.pow(2, -10 * k) * Math.sin((k - s) * Math.PI * 2 / locPeriod) * 0.5 + 1;
                  }

                  return newT;
                };
              }

            case Types.easeBounceIn:
              {
                return "bounceIn";
              }

            case Types.easeBounceOut:
              {
                return "bounceOut";
              }

            case Types.easeBounceInOut:
              {
                return "bounceInOut";
              }

            case Types.easeBackIn:
              {
                return "backIn";
              }

            case Types.easeBackOut:
              {
                return "backOut";
              }

            case Types.easeBackInOut:
              {
                return "backInOut";
              }

            case Types.easeQuadraticActionIn:
              {
                return "quadIn";
              }

            case Types.easeQuadraticActionOut:
              {
                return "quadOut";
              }

            case Types.easeQuadraticActionInOut:
              {
                return "quadInOut";
              }

            case Types.easeQuarticActionIn:
              {
                return "quartIn";
              }

            case Types.easeQuarticActionOut:
              {
                return "quartOut";
              }

            case Types.easeQuarticActionInOut:
              {
                return "quartInOut";
              }

            case Types.easeQuinticActionIn:
              {
                return "quintIn";
              }

            case Types.easeQuinticActionOut:
              {
                return "quintOut";
              }

            case Types.easeQuinticActionInOut:
              {
                return "quintInOut";
              }

            case Types.easeCircleActionIn:
              {
                return "circIn";
              }

            case Types.easeCircleActionOut:
              {
                return "circOut";
              }

            case Types.easeCircleActionInOut:
              {
                return "circInOut";
              }

            case Types.easeCubicActionIn:
              {
                return "cubicIn";
              }

            case Types.easeCubicActionOut:
              {
                return "cubicOut";
              }

            case Types.easeCubicActionInOut:
              {
                return "cubicInOut";
              }

            case Types.easeBezierAction:
              {
                let [a, b, c, d] = [...args];
                return function (t) {
                  return Math.pow(1 - t, 3) * a + 3 * t * Math.pow(1 - t, 2) * b + 3 * Math.pow(t, 2) * (1 - t) * c + Math.pow(t, 3) * d;
                };
              }

            default:
              {
                return function (k) {
                  return k;
                };
              }
          }
        }

        _CCEaseTypes.GetEasing = GetEasing;
      })(CCEaseTypes || (CCEaseTypes = exports('CCEaseTypes', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRSlot.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRSlot', void 0);

      cclegacy._RF.push({}, "946f71Mc1JAEqjKbkpGSztw", "SRSlot", undefined);

      let SRSlot;

      (function (_SRSlot) {
        function getUserSlot() {
          let req = new GameKit.ServerRequest("getUserSlot");
          req.SetCallBack(function (res) {
            Game.SUserSlot.updateData(res.userSlot);
          });
          return req;
        }

        _SRSlot.getUserSlot = getUserSlot;

        function slotPlay(betTimes) {
          let req = new GameKit.ServerRequest("slotPlay");
          req.SetRequestBody("betTimes", betTimes);
          req.SetSilence(true);
          return req;
        }

        _SRSlot.slotPlay = slotPlay;
      })(SRSlot || (SRSlot = exports('SRSlot', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ChildWindowChain.ts", ['cc', './SoundManager.ts', './UIRoot.ts'], function (exports) {
  'use strict';

  var cclegacy, SoundManager, UIRoot;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIRoot = module.default;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "946fevJTfBPbYkZqwTgcP4s", "ChildWindowChain", undefined);

      class ChildWindowChain {
        constructor() {
          _defineProperty(this, "data", void 0);

          _defineProperty(this, "index", void 0);

          _defineProperty(this, "completeFunc", void 0);

          _defineProperty(this, "finishFunc", void 0);

          this.data = [];
        }

        add(windowName, checkFunc, params) {
          this.data.push({
            windowName: windowName,
            checkFunc: checkFunc,
            params: params
          });
        }

        start() {
          this.index = 0;
          this.execute(this.index);
        }

        execute(index) {
          if (index >= this.data.length) {
            this.finish();
            return;
          }

          let data = this.data[index];

          if (data.checkFunc == null || data.checkFunc()) {
            let params = data.params || {};
            let cb = params.showCallback;

            params.showCallback = window => {
              window.addOnCloseFunc(() => {
                this.index++;
                this.execute(this.index);
              });
              window.childWindowChain = this;
              if (cb) cb();
            };

            SoundManager.playSound("se_open");
            UIRoot.instance.openChildWindow(data.windowName, params);
          } else {
            this.index++;
            this.execute(this.index);
          }
        }

        end() {
          this.index = this.data.length;
          if (this.completeFunc) this.completeFunc();
        }

        finish() {
          this.index = this.data.length;
          if (this.completeFunc) this.completeFunc();
          if (this.finishFunc) this.finishFunc();
        }

        setFinishFunc(c) {
          this.finishFunc = c;
        }

        setCompleteFunc(c) {
          this.completeFunc = c;
        }

      }

      exports('default', ChildWindowChain);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UITabContainer.ts", ['cc', './CCE_Component.ts', './UITabNode.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, CCE_Component, UITabNode;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      UITabNode = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "96ab88Iu0tBTJow+FOo5/Ca", "UITabContainer", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let UITabContainer = exports('default', (_dec = property([UITabNode]), ccclass(_class = (_class2 = (_temp = class UITabContainer extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "tabs", _descriptor, this);

          _defineProperty(this, "changeCallback", void 0);

          _defineProperty(this, "index", void 0);
        }

        start() {}

        onShow(func = null, defaultIndex = 0) {
          this.changeCallback = func;
          this.index = defaultIndex || 0;

          for (let i = 0; i < this.tabs.length; i++) {
            let tab = this.tabs[i];
            tab.index = i;
            tab.disable();
            tab.node.on("click", () => {
              this.changeIndex(i);
            }, this);
          }

          this.enableIndex(this.index, true);
        }

        changeIndex(index) {
          if (this.index == index) return;
          this.disableIndex(this.index);
          this.index = index;
          this.enableIndex(this.index);
        }

        disableIndex(index) {
          this.tabs[index].disable();
        }

        enableIndex(index, first) {
          this.tabs[index].enable();
          if (this.changeCallback) this.changeCallback(index, this.tabs[index], first);
        }

        setChangeCallback(func) {
          this.changeCallback = func;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "tabs", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageNewsWindow.ts", ['cc', './global.ts', './UIWindow.ts', './ContentModel.ts', './Content.ts', './User.ts', './UserInfoModel.ts', './ScrollViewTool.ts', './UITabContainer.ts', './MessageMailDetailWindow.ts', './SdkManager.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Node, _decorator, Sprite, Label, Button, instantiate, color, G, UIWindow, ContentModel, Content, User, UserInfoModel, ScrollViewTool, UITabContainer, MessageMailDetailWindow, SdkManager, SR, UIRoot, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      Label = module.Label;
      Button = module.Button;
      instantiate = module.instantiate;
      color = module.color;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      User = module.User;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      UITabContainer = module.default;
    }, function (module) {
      MessageMailDetailWindow = module.MessageMailDetailWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "96abedHV2NKla3ngGRGGwLJ", "VillageNewsWindow", undefined); // let ScrollViewTool = require('ScrollViewTool')
      // let UserInfoModel = UserInfoModel


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        /** 伪数据长度 */
        FAKE_DATA_LENGTH: 0,

        /** 伪等待时间 */
        FAKE_WAIT_TIME: 1,

        /** 载入sprite旋转一圈的时间 */
        LOADING_ROTATION_TIME: 0.5,

        /** 伪偷取金币 */
        FAKE_STOLE_COIN: "15K",

        /** news类型枚举 */
        NEWS_TYPE: {
          ATTACK: "attack",
          // 锤子
          SHIELD: "shield",
          // 盾牌
          RAID: "raid",
          // 猪
          INVITE: "invited",
          // 邀请
          Servant1: "servant1",
          //随从
          Servant2: "servant2",
          Servant3: "servant3",
          Servant4: "servant4",
          SuperShield: "superShield",
          SuperShieldGold: "superShieldGold"
        }
      };
      /**
       * VillageNews界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let VillageNewsWindow = exports('VillageNewsWindow', (_dec = property(SpriteFrame), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(SpriteFrame), _dec5 = property(SpriteFrame), _dec6 = property(SpriteFrame), _dec7 = property(SpriteFrame), _dec8 = property(SpriteFrame), _dec9 = property(SpriteFrame), _dec10 = property(SpriteFrame), _dec11 = property(SpriteFrame), _dec12 = property(UITabContainer), _dec13 = property(ScrollViewTool), _dec14 = property(ScrollViewTool), _dec15 = property(Node), _dec16 = property(Node), _dec17 = property(Node), _dec18 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class VillageNewsWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "default_avatar_sf", _descriptor, this);

          _initializerDefineProperty(this, "type_icon_hammer", _descriptor2, this);

          _initializerDefineProperty(this, "type_icon_sheild", _descriptor3, this);

          _initializerDefineProperty(this, "type_icon_pig", _descriptor4, this);

          _initializerDefineProperty(this, "type_icon_invite", _descriptor5, this);

          _initializerDefineProperty(this, "type_icon_servant1", _descriptor6, this);

          _initializerDefineProperty(this, "type_icon_servant2", _descriptor7, this);

          _initializerDefineProperty(this, "type_icon_servant3", _descriptor8, this);

          _initializerDefineProperty(this, "type_icon_servant4", _descriptor9, this);

          _initializerDefineProperty(this, "type_icon_supershield", _descriptor10, this);

          _initializerDefineProperty(this, "type_icon_supershieldGold", _descriptor11, this);

          _initializerDefineProperty(this, "tab_node_array", _descriptor12, this);

          _initializerDefineProperty(this, "svt", _descriptor13, this);

          _initializerDefineProperty(this, "svtMail", _descriptor14, this);

          _initializerDefineProperty(this, "mailBadge", _descriptor15, this);

          _initializerDefineProperty(this, "emptyMessageNode", _descriptor16, this);

          _initializerDefineProperty(this, "emptyMailNode", _descriptor17, this);

          _initializerDefineProperty(this, "loading_circle", _descriptor18, this);

          _defineProperty(this, "kingdomMessageLoaded", void 0);

          _defineProperty(this, "data_array", void 0);

          _defineProperty(this, "mailMessageLoaded", void 0);

          _defineProperty(this, "presentList", void 0);
        }

        static getPresentNum() {
          let presentNum = 0;
          let presentList = GameKit.DataCache.GetData("UserPresentList");

          if (presentList) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();

            for (let id in presentList) {
              if (id == "cid") continue;
              let present = presentList[id];
              if (present.expire > 0 && currentTime > present.expire) continue;
              if (!present.received) presentNum++;
            }
          }

          return presentNum;
        }

        onShow(showParams) {
          let defIndex = 0;
          if (showParams.mail) defIndex = 1;
          this.tab_node_array.onShow((index, tab, first) => {
            if (first) {
              setTimeout(() => {
                this.event_change_to_tab(index);
              }, 300);
            } else {
              this.event_change_to_tab(index);
            }
          }, defIndex);
          this.updateMailBadge();
        }

        event_change_to_tab(index = 0) {
          if (index == 0) {
            this.event_update_data();
          } else if (index == 1) {
            this.event_get_mails();
          }
        } //////////////////////////////////////////////////
        // Kingdom

        /** 事件，动态更新数据
         * - 可以供给外部调用
         */


        event_update_data() {
          this.svt.node.active = true;
          this.svtMail.node.active = false;
          if (this.kingdomMessageLoaded) return; // 加载动画

          this.open_loading_anima();
          this.get_news_data().then(v => {
            if (!this.node || !this.node.isValid) return; //console.time("VillageNewsWindow")

            this.update_all_item(v); //console.timeEnd("VillageNewsWindow")

            this.close_loading_anima();
            this.kingdomMessageLoaded = true;
          }, e => {});
        }
        /** 刷新所有的item
         * @param {[{}]} data_array
         */


        update_all_item(data_array = []) {
          this.svt.scrollView.scrollToTop(0.1);
          this.svt.clear();
          let item_count = data_array.length;
          this.emptyMessageNode.active = !item_count;
          let ranks = [];

          for (let i = 0; i < item_count; i++) {
            ranks.push(i);
          }

          this.svt.setItem(ranks,
          /**
           * @param {cc.Node} itemHandle item节点
           */
          (index, id, itemHandle) => {
            // 获取对应组件（node）
            // 注意各个子节点的名称正确
            // 注意要把对应的节点拖入ControllerTables下面
            let userinfo = GameKit.ControllerTable.GetNode(itemHandle, "userinfo").getComponent(UserInfoModel);
            let avatar = GameKit.ControllerTable.GetNode(itemHandle, "avatar").getComponent(Sprite);
            let labelName = GameKit.ControllerTable.GetNode(itemHandle, "labelName").getComponent(Label);
            let labelInfo = GameKit.ControllerTable.GetNode(itemHandle, "labelInfo").getComponent(Label);
            let type_icon = GameKit.ControllerTable.GetNode(itemHandle, "type_icon").getComponent(Sprite);
            let time = GameKit.ControllerTable.GetNode(itemHandle, "time").getComponent(Label); // 根据数据写入

            let data = data_array[index]; ///? index?id?

            if (data === undefined) ;else {
              // 有数据
              userinfo.show(new User().updateData(data["user"])); // 不同界面的信息域内容不同，因此要根据界面调整User信息域与界面信息的处理
              // avatar.spriteFrame = this.default_avatar_sf

              let isVip = data["user"]["isVip"] && !G.GameConfig.closeVIP && SdkManager.IsNative();
              labelName.string = String.format(data["user"]["name"]);

              switch (data["type"]) {
                case C.NEWS_TYPE.ATTACK:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_hammer_vip")) : String.format(i18n.t("village_news_log_hammer"));
                  type_icon.spriteFrame = this.type_icon_hammer;
                  break;

                case C.NEWS_TYPE.SHIELD:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_shield_vip")) : String.format(i18n.t("village_news_log_shield"));
                  type_icon.spriteFrame = this.type_icon_sheild;
                  break;

                case C.NEWS_TYPE.RAID:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_pig_vip"), GameKit.StringUtil.formatNumber(data["number"])) : String.format(i18n.t("village_news_log_pig"), GameKit.StringUtil.formatNumber(data["number"]));
                  type_icon.spriteFrame = this.type_icon_pig;
                  break;

                case C.NEWS_TYPE.INVITE:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_invite_vip")) : String.format(i18n.t("village_news_log_invite"));
                  type_icon.spriteFrame = this.type_icon_invite;
                  break;

                case C.NEWS_TYPE.Servant1:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_pig_vip"), GameKit.StringUtil.formatNumber(data["number"])) : String.format(i18n.t("village_news_log_pig"), GameKit.StringUtil.formatNumber(data["number"]));
                  type_icon.spriteFrame = this.type_icon_servant1;
                  break;

                case C.NEWS_TYPE.Servant2:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_hammer_vip")) : String.format(i18n.t("village_news_log_hammer"));
                  type_icon.spriteFrame = this.type_icon_servant2;
                  break;

                case C.NEWS_TYPE.Servant3:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_shield_vip")) : String.format(i18n.t("village_news_log_shield"));
                  type_icon.spriteFrame = this.type_icon_servant3;
                  break;

                case C.NEWS_TYPE.Servant4:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_noraid_vip"), GameKit.StringUtil.formatNumber(data["number"])) : String.format(i18n.t("village_news_log_noraid"), GameKit.StringUtil.formatNumber(data["number"]));
                  type_icon.spriteFrame = this.type_icon_servant4;
                  break;

                case C.NEWS_TYPE.SuperShield:
                  labelInfo.string = isVip ? String.format(i18n.t("village_news_log_shield_vip")) : String.format(i18n.t("village_news_log_shield"));
                  type_icon.spriteFrame = this.type_icon_supershield;
                  break;

                case C.NEWS_TYPE.SuperShieldGold:
                  if (data["number"] > 1) {
                    labelInfo.string = isVip ? String.format(i18n.t("village_news_log_noraid_vip")) : String.format(i18n.t("village_news_log_noraid"));
                  } else {
                    labelInfo.string = isVip ? String.format(i18n.t("village_news_log_shield_vip")) : String.format(i18n.t("village_news_log_shield"));
                  }

                  type_icon.spriteFrame = this.type_icon_supershieldGold;
                  break;
              }

              time.string = GameKit.TimeUtil.FormatPastTime(GameKit.TimeUtil.getCurrentTime() - data["time"], true);
            } // 绑定2个点击事件
            //*/
          });
        }
        /** 获取village_news的数据 */


        get_news_data() {
          return new Promise((resolve, reject) => {
            let sr = SR.SRVillage.getVillageNews();
            sr.SetSilence(true);
            sr.SetCallBack(res => {
              let data = res.list; // 真实数据处理过程
              //// 等待服务器模块写完

              /*/ 伪数据处理过程
              for (let i = 0; i < C.FAKE_DATA_LENGTH; i++) {
              	data.push({
              		user: { name: "TestName", avatar: "" },
              		type: [C.NEWS_TYPE.ATTACK, C.NEWS_TYPE.SHIELD, C.NEWS_TYPE.RAID, C.NEWS_TYPE.INVITE][i % 4],
              		number: C.FAKE_STOLE_COIN,
              		time: i + 1, // 新增时间
              	})
              }//*/

              for (let i = 0; i < data.length; i++) {
                if (data[i].isFriend && !data[i].user && Game.SUser.FriendsList()[data[i].userId]) {
                  data[i].user = Game.SUser.FriendsList()[data[i].userId].getUserInfo();
                }
              }

              data.sort((a, b) => {
                return b.time - a.time;
              }); // 保存数据

              this.data_array = data;
              resolve(data);
              GameKit.DataCache.RemoveData("NewMessageNum");
              GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.MessageEvent, null);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          });
          /** 备注：消息格式 
          res = [
          	// 单条消息
          	{
          		user: { name: "", avatar: "" }, // user信息，暂时只包括name和avatar
          		type: "",                       // news类型，string格式，C.NEWS_TYPE进行封装
          		number: 0,                      // 附加数值，目前仅仅适用于C.NEW_TYPE.RAID类型
          		time: 0,                        // 消息时间-格式还未定
          	},
          	// 一个消息列表
          	{}, {}, {},
          ]*/
        } /////////////////////////////////////////////////
        // Mail


        event_get_mails() {
          this.svt.node.active = false;
          this.svtMail.node.active = true;
          if (this.mailMessageLoaded) return; // 加载动画

          this.open_loading_anima();
          this.get_mail_data().then(v => {
            if (!this.node || !this.node.isValid) return; //console.time("VillageNewsWindow")

            this.update_mail_item(v); //console.timeEnd("VillageNewsWindow")

            this.close_loading_anima();
            this.mailMessageLoaded = true;
          }, e => {});
        }

        update_mail_item(data_array = []) {
          this.svtMail.scrollView.scrollToTop(0.1);
          this.svtMail.clear();
          this.emptyMailNode.active = !data_array.length;
          let ranks = [];

          for (let id in data_array) {
            if (id == "cid") continue;
            ranks.push(id);
          }

          ranks.sort((a, b) => {
            return b - a;
          });
          this.svtMail.setItem(ranks,
          /**
           * @param {cc.Node} itemHandle item节点
           */
          (index, id, itemHandle) => {
            let present = data_array[id];
            let title = GameKit.ControllerTable.GetComponent(itemHandle, "title", Label);
            let reward = GameKit.ControllerTable.GetNode(itemHandle, "reward");
            let rewardParent = GameKit.ControllerTable.GetNode(itemHandle, "rewardParent");
            let btnCollect = GameKit.ControllerTable.GetComponent(itemHandle, "btnCollect", Button);
            let btnCollectLabel = GameKit.ControllerTable.GetNode(itemHandle, "btnCollectLabel");
            let time = GameKit.ControllerTable.GetComponent(itemHandle, "time", Label);
            title.string = present.title;
            rewardParent.destroyAllChildren();
            Content.FromStrings(present.rewards).forEach(content => {
              let rewardIns = instantiate(reward);
              rewardIns.parent = rewardParent;
              rewardIns.active = true;
              rewardIns.getComponent(ContentModel).show(content);
            });
            btnCollect.node.targetOff(this);
            btnCollectLabel.color = color(6, 92, 17);

            if (present.received) {
              btnCollect.interactable = false;
              btnCollect.inScrollView = true;
              btnCollectLabel.color = color(88, 88, 88);
            } else {
              setTimeout(() => {
                btnCollect.inScrollView = false;
              }, 100);
              btnCollect.interactable = true;
              btnCollect.node.on("click", () => {
                let req = SR.SRVillage.collectPresent(id);
                req.SetCallBack(res => {
                  present.received = true;
                  btnCollect.interactable = false;
                  btnCollect.inScrollView = true;
                  btnCollectLabel.color = color(88, 88, 88);
                  this.updateMailBadge();
                });
                req.Send();
              }, this);
            }

            time.node.active = present.expire > 0;
            time.string = String.format(i18n.t("village_news_expire"), GameKit.TimeUtil.FormatSomeTime(present.expire - GameKit.TimeUtil.getCurrentTime(), true));
            itemHandle.node.targetOff(this);
            itemHandle.node.on("click", () => {
              UIRoot.instance.openChildWindow(MessageMailDetailWindow, {
                present: present
              });
            }, this);
          });
        }
        /** 获取village_news的数据 */


        get_mail_data() {
          return new Promise((resolve, reject) => {
            let presentList = GameKit.DataCache.GetData("UserPresentList");

            if (presentList) {
              let currentTime = GameKit.TimeUtil.getCurrentTime();
              let exIds = [];

              for (let id in presentList) {
                if (id == "cid") continue;
                let present = presentList[id];
                if (present.expire > 0 && currentTime > present.expire) exIds.push(id);
              }

              exIds.forEach(x => {
                delete presentList[x];
              });
              if (exIds.length > 0) GameKit.DataCache.SetData("UserPresentList", presentList);
            }

            this.presentList = presentList || {};
            resolve(this.presentList);
          });
        }

        updateMailBadge() {
          this.mailBadge.active = VillageNewsWindow.getPresentNum() > 0;
        } /////////////////////////////////////////////////
        // Public

        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        }
        /** 打开loading动画 */


        open_loading_anima() {
          /*if (this.loading_anima === undefined) {
          	this.loading_anima = ccAction.rotateBy(C.LOADING_ROTATION_TIME, 360).repeatForever()
          	this.loading_circle.active = true
          	this.loading_circle.runAction(this.loading_anima)
          }*/
          this.loading_circle.active = true;
        }
        /** 关闭loading动画 */


        close_loading_anima() {
          this.loading_circle.active = false;
        }

      }, _defineProperty(_class3, "windowPath", "Menu/NewVillageNewsWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "default_avatar_sf", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_hammer", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_sheild", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_pig", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_invite", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_servant1", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_servant2", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_servant3", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_servant4", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_supershield", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "type_icon_supershieldGold", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "tab_node_array", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "svtMail", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "mailBadge", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "emptyMessageNode", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "emptyMailNode", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "loading_circle", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageShopMeta.ts", ['cc', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "96d6eS4Yk1AsoyfBV9uRJ9b", "VillageShopMeta", undefined);

      class VillageShopMeta {
        constructor() {
          _defineProperty(this, "_data", void 0);
        }

        static MakeEntity(data) {
          let meta = new VillageShopMeta();
          meta.UpdateData(data);
          return meta;
        }

        static FindMetaPrice(mapId, type, level) {
          let meta = Meta.MetaManager.GetMeta(Meta.MetaType.VillageShop, mapId * 10 + type);
          if (!meta) return null;
          return meta.Price(level);
        }

        static CacheLevels() {
          VillageShopMeta.LevelCache = {};
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.VillageShop);

          for (let id in metas) {
            let meta = metas[id];
            let mapId = meta.MapId();
            let type = meta.Type();

            for (let level = 5; level <= 10; level++) {
              if (!meta.Price(level)) break;
              if (!VillageShopMeta.LevelCache.hasOwnProperty(mapId)) VillageShopMeta.LevelCache[mapId] = {};
              if (!VillageShopMeta.LevelCache[mapId].hasOwnProperty(type) || VillageShopMeta.LevelCache[mapId][type] < level) VillageShopMeta.LevelCache[mapId][type] = level;
            }
          }
        }

        static GetMaxLevel(mapId, type) {
          return VillageShopMeta.LevelCache[mapId][type];
        }

        static GetMaxStar(mapId) {
          let star = 0;

          for (let i = 1; i <= 5; i++) {
            star += VillageShopMeta.LevelCache[mapId][i];
          }

          return star;
        }

        UpdateData(data) {
          this._data = data;
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        MapId() {
          return this._data.mapId;
        }

        Type() {
          return this._data.type;
        }

        Price(n) {
          return this._data["price" + n];
        }

      }

      exports('VillageShopMeta', VillageShopMeta);

      _defineProperty(VillageShopMeta, "LevelCache", {});

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FramesParticle.ts", ['cc', './CCE_Component.ts', './global.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, _decorator, ParticleSystem2D, CCE_Component, G;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      ParticleSystem2D = module.ParticleSystem2D;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "96e21EHU4hEdrYorw0TLv4h", "FramesParticle", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FramesParticle = exports('default', (_dec = property([SpriteFrame]), ccclass(_class = (_class2 = (_temp = class FramesParticle extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "texturesSpaceTime", _descriptor, this);

          _initializerDefineProperty(this, "textures", _descriptor2, this);

          _defineProperty(this, "texturesIndex", void 0);

          _defineProperty(this, "cTexturesSpaceTime", void 0);

          _defineProperty(this, "particle", void 0);
        }

        onLoad() {
          this.texturesIndex = G.getRandomInt(0, this.textures.length);
          this.cTexturesSpaceTime = this.texturesSpaceTime;
          this.particle = this.getComponent(ParticleSystem2D);
        }

        onEnable() {
          this.texturesIndex = G.getRandomInt(0, this.textures.length);
        }

        start() {}

        update(dt) {
          //修改帧图
          if (this.particle && this.textures.length > 0) {
            this.cTexturesSpaceTime += dt;

            if (this.cTexturesSpaceTime > this.texturesSpaceTime) {
              this.cTexturesSpaceTime = 0;
              this.texturesIndex++;
              this.texturesIndex = this.texturesIndex % this.textures.length;
              this.particle.spriteFrame = this.textures[this.texturesIndex];
            }
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "texturesSpaceTime", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "textures", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LeaderBoardWrap.ts", ['cc', './fbIn_lib.ts', './yzLeaderboard.ts'], function (exports) {
  'use strict';

  var cclegacy, fbInTools, setScore, watchContext;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      setScore = module.setScore;
      watchContext = module.watchContext;
    }],
    execute: function () {
      exports('LeaderBoardWrap', void 0);

      cclegacy._RF.push({}, "9739dlEznZE0Lnhwdx/4QUK", "LeaderBoardWrap", undefined);

      let LeaderBoardWrap;

      (function (_LeaderBoardWrap) {
        function setScore$1(name, score, callback) {
          if (fbInTools.usefbIn) {
            //yz

            /*FBInstant.getLeaderboardAsync(name)
            .then(function(leaderboard) {
                return leaderboard.setScoreAsync(score, "");
            })
            .then(function(entry) {
                if (callback != null) callback(true)
            });*/
            setScore(score);
          }
        }

        _LeaderBoardWrap.setScore = setScore$1;

        function Init() {
          if (fbInTools.usefbIn) {
            watchContext();
          }
        }

        _LeaderBoardWrap.Init = Init;
      })(LeaderBoardWrap || (LeaderBoardWrap = exports('LeaderBoardWrap', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CCActionExtention.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      // import * as cc from "cc";
      cclegacy._RF.push({}, "98192PySHNKk4KUU73xKit9", "CCActionExtention", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LocalizedManager.ts", ['cc', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports({
        UnRegisterLabel: UnRegisterLabel,
        clearAllLabels: clearAllLabels,
        rigisterLabel: rigisterLabel,
        updateAllLabels: updateAllLabels
      });

      cclegacy._RF.push({}, "981f7MokB1DorbKpunwabne", "LocalizedManager", undefined);

      let labelMap = [];

      function rigisterLabel(localizedKey, label, ...arg) {
        if (!label) return;
        const labelItem = {
          key: localizedKey,
          label: label,
          args: arg
        };
        labelMap.push(labelItem);
      }

      function UnRegisterLabel(localizedKey) {}

      function updateAllLabels() {
        labelMap.forEach((labelItem, index) => {
          labelItem.label.string = String.format(i18n.t(labelItem.key), ...labelItem.args);
        });
      }

      function clearAllLabels() {
        labelMap = [];
      }

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserItems.ts", ['cc', './Content.ts'], function (exports) {
  'use strict';

  var cclegacy, Content;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "98b93zK8WNK07cIJFxjI/5x", "UserItems", undefined);

      class UserItems {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            items: {} //道具列表

          };
        } //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        }

        getItems() {
          return this.data.items;
        }

        getNum(itemId) {
          return this.data.items[itemId] || 0;
        }

        getContent(itemId) {
          return new Content(Content.Types.Item, itemId, this.getNum(itemId));
        }

      }

      exports('UserItems', UserItems);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Content.ts", ['cc', './Logs.ts', './_app.ts', './fixedSizeRatio.ts', './CommonAssets.ts', './ActivityManager.ts', './StaticGame.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, UITransform, SpriteFrame, Logs, cce, fixedSizeRatio, CommonAssets, ActivityManager, Meta, Game, GameKit, BigNumber, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      UITransform = module.UITransform;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      fixedSizeRatio = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "98c3cykFW1B8o2DsHytppjx", "Content", undefined);

      class Content {
        static Merge(conts, id) {
          let conttysts = {};

          for (let i = 0; i < conts.length; i++) {
            let contcs = conts[i].Contents();
            contcs.forEach(cont => {
              _Merge(cont, conttysts);
            });
          }

          let contstrs = [];

          for (let conttystKey in conttysts) {
            let conttystCount = conttysts[conttystKey];
            contstrs.push(conttystKey + "=" + conttystCount.toString());
          }

          let result = [];
          contstrs.forEach(function (x) {
            result.push(Content.FromString(x));
          });
          return result;
        }

        static RoundCoin(num) {
          num = Math.round(num);
          let len = num.toString().length;
          let ro = Math.pow(10, len - 3);
          return Math.round(num / ro) * ro;
        }

        constructor(type, cid, count) {
          _defineProperty(this, "type", void 0);

          _defineProperty(this, "cid", void 0);

          _defineProperty(this, "count", void 0);

          this.type = type;
          this.cid = cid;
          this.count = count;
        }

        toString() {
          if (this.IsBigNumberCount()) return this.type.toString() + "=" + this.cid.toString() + "=" + BigNumber.format(this.count);
          return this.type.toString() + "=" + this.cid.toString() + "=" + this.count.toString();
        }

        static FromString(str) {
          if (str == null) return null;
          let strs = str.split("=");

          try {
            if (Content._IsBigNumberCount(parseInt(strs[0]))) return new Content(parseInt(strs[0]), parseInt(strs[1]), BigNumber.fromFormat(strs[2]));
            return new Content(parseInt(strs[0]), parseInt(strs[1]), parseFloat(strs[2]));
          } catch (e) {}

          return null;
        }

        static FromStrings(sstr) {
          if (sstr == null) return [];
          let strss = sstr.split(";");
          let conts = [];
          strss.forEach(str => {
            if (str) {
              conts.push(Content.FromString(str));
            }
          });
          return conts;
        }

        static FromContent(cont) {
          return new Content(cont.type, cont.cid, cont.count);
        }

        static FromContents(conts) {
          let contents = [];
          conts.forEach(c => {
            contents.push(Content.FromContent(c));
          });
          return contents;
        } /////////////////////////////////


        ContentType() {
          return this.type;
        }

        Type() {
          return this.type;
        }

        ContentId() {
          return this.cid;
        }

        Id() {
          return this.cid;
        }

        ContentCount() {
          return this.count;
        }

        Count() {
          return this.count;
        }

        SetCount(c) {
          this.count = c;
          return this;
        } //带有格式的数值字符串


        FormatCount() {
          if (this.IsBigNumberCount()) {
            return BigNumber.format(this.Count());
          }

          return GameKit.StringUtil.formatNumber(this.Count());
        } //数据是否是大数


        IsBigNumberCount() {
          return Content._IsBigNumberCount(this.Type());
        }

        static _IsBigNumberCount(type) {
          return false;
        } ////////////////////////


        Name() {
          if (this.Type() === Content.Types.Coin) {
            return i18n.t("ContentNameCoin");
          } else if (this.Type() === Content.Types.Ap) {
            return i18n.t("ContentNameAp");
          } else if (this.Type() === Content.Types.Shield || this.Type() === Content.Types.TimeShield || this.Type() === Content.Types.SuperTimeShield) {
            return i18n.t("ContentNameShield");
          } else if (this.Type() === Content.Types.Card) {
            return i18n.t("ContentNameCard");
          } else if (this.Type() === Content.Types.CardChest) {
            return i18n.t("ContentNameChest" + this.ContentId());
          } else if (this.Type() === Content.Types.Pack || this.Type() === Content.Types.DynamicPack) {
            return i18n.t("ContentNamePack");
          } else if (this.Type() === Content.Types.ShopCoin) {
            return i18n.t("ContentNameCoin");
          } else if (this.Type() === Content.Types.Jigsaw) {
            return i18n.t("ContentNameJigsaw");
          } else if (this.Type() === Content.Types.Item) {
            let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Item, this.ContentId());
            if (!meta) return i18n.t("ContentNameUnknown");
            return meta.Name();
          } else if (this.Type() === Content.Types.ActivityItem) {
            let key = "ContentNameActivityItem" + this.ContentId();
            if (!i18n.has(key)) key = "ContentNameActivityItemCommon";
            return i18n.t(key);
          }

          return i18n.t("ContentNameUnknown");
        }

        Description() {
          if (this.Type() === Content.Types.Coin) {
            return i18n.t("ContentNameCoin") + " x " + this.ContentCount();
          } else if (this.Type() === Content.Types.Ap) {
            return i18n.t("ContentNameAp") + " x " + this.ContentCount();
          } else if (this.Type() === Content.Types.Shield) {
            return i18n.t("ContentNameShield") + " x " + this.ContentCount();
          } else if (this.Type() === Content.Types.TimeShield || this.Type() === Content.Types.SuperTimeShield) {
            return i18n.t("ContentNameShield") + " : " + String.format(i18n.t("CountDay"), GameKit.TimeUtil.FormatTime(this.ContentCount()).day);
          } else if (this.Type() === Content.Types.Card) {
            return i18n.t("ContentNameCard");
          } else if (this.Type() === Content.Types.CardChest) {
            return this.Name() + " x " + this.ContentCount();
          } else if (this.Type() === Content.Types.Pack || this.Type() === Content.Types.DynamicPack) {
            let cons = this.Contents();
            let consString = "";

            for (let i = 0; i < cons.length; i++) {
              if (i != 0) consString += " & ";
              let con = cons[i];
              consString += con.Desc();
            }

            return consString;
          } else if (this.Type() === Content.Types.ShopCoin) {
            return this.Contents()[0].Desc();
          } else if (this.Type() === Content.Types.Jigsaw) {
            return i18n.t("ContentNameJigsaw");
          } else if (this.Type() === Content.Types.Item) {
            let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Item, this.ContentId());
            if (!meta) return i18n.t("ContentNameUnknown");
            return meta.Desc();
          }

          return i18n.t("ContentNameUnknown");
        }

        Desc() {
          return this.Description();
        }

        Icon(sprite, cb) {
          if (!sprite || !sprite.node) return;
          let height = sprite.node.getComponent(UITransform).height;

          if (this.Type() === Content.Types.Coin) {
            sprite.spriteFrame = CommonAssets.instance.icon_coin;
          } else if (this.Type() === Content.Types.Ap) {
            sprite.spriteFrame = CommonAssets.instance.icon_spin;
          } else if (this.Type() === Content.Types.Shield) {
            sprite.spriteFrame = CommonAssets.instance.icon_shield;
          } else if (this.Type() === Content.Types.TimeShield || this.Type() === Content.Types.SuperTimeShield) {
            sprite.spriteFrame = CommonAssets.instance.icon_shield;
          } else if (this.Type() === Content.Types.Card) {
            let resName = "res/Card/" + this.ContentId().toString();
            cce.loadRes(resName, SpriteFrame, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!sprite || !sprite.node) return;
              sprite.spriteFrame = v;
              fixedSizeRatio.fitByHeight(sprite, height);
              if (cb != null) cb();
            }.bind(this));
            return;
          } else if (this.Type() === Content.Types.CardChest) {
            sprite.spriteFrame = CommonAssets.instance.icon_chest[this.ContentId()];
          } else if (this.Type() === Content.Types.Pack || this.Type() === Content.Types.DynamicPack) {
            sprite.spriteFrame = CommonAssets.instance.icon_pack;
          } else if (this.Type() === Content.Types.ShopCoin) {
            sprite.spriteFrame = CommonAssets.instance.icon_coin;
          } else if (this.Type() === Content.Types.Jigsaw) {
            let activityMeta = ActivityManager.GetActiveGameActivityByType(Meta.ActivityMeta.SubTypes.Jigsaw);

            if (!activityMeta) {
              if (cb != null) cb();
              return;
            }

            if (activityMeta.Param().jigsawSetPath.startsWith("http")) {
              let resName = activityMeta.Param().jigsawSetPath + "/" + this.ContentId().toString() + ".png";
              cce.loaderLoad({
                url: resName,
                type: "png"
              }, function (err, v) {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!sprite || !sprite.node) return;
                let sp = new SpriteFrame();
                sp.texture = v;
                sprite.spriteFrame = sp;
                fixedSizeRatio.fitByHeight(sprite, height);
                if (cb != null) cb();
              }.bind(this));
            } else {
              let resName = "res/Activity/Jigsaw/" + activityMeta.Param().jigsawSetPath + "/" + this.ContentId().toString();
              cce.loadRes(resName, SpriteFrame, function (err, v) {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!sprite || !sprite.node) return;
                sprite.spriteFrame = v;
                fixedSizeRatio.fitByHeight(sprite, height);
                if (cb != null) cb();
              }.bind(this));
            }

            return;
          } else if (this.Type() === Content.Types.Item) {
            let meta = Meta.MetaManager.GetMeta(Meta.MetaType.Item, this.ContentId());

            if (!meta) {
              sprite.spriteFrame = CommonAssets.instance.icon_pack;
            } else {
              let sp = CommonAssets.instance.getRewardItemIcon(meta.Icon());

              if (!sp) {
                sp = CommonAssets.instance.getByAtlas(CommonAssets.Atlases.Item, meta.Icon());
              }

              sprite.spriteFrame = sp;
            }
          } else if (this.Type() === Content.Types.ActivityItem) {
            sprite.spriteFrame = CommonAssets.instance.getByAtlas(CommonAssets.Atlases.ActivityItem, this.ContentId().toString());
          }

          fixedSizeRatio.fitByHeight(sprite, height);
          if (cb != null) cb();
        }

        ColorCode() {
          if (this.Type() === Content.Types.Coin) {
            return "<color=#fff799>";
          } else if (this.Type() === Content.Types.Ap) {
            return "<color=#7ecef4>";
          } else if (this.Type() === Content.Types.Shield) {
            return "<color=#D1843D>";
          } else if (this.Type() === Content.Types.TimeShield || this.Type() === Content.Types.SuperTimeShield) {
            return "<color=#D1843D>";
          } else if (this.Type() === Content.Types.Card) {
            return "<color=#ffffff>";
          } else if (this.Type() === Content.Types.CardChest) {
            return "<color=#ffffff>";
          } else if (this.Type() === Content.Types.Pack || this.Type() === Content.Types.DynamicPack) {
            return "<color=#ffffff>";
          } else if (this.Type() === Content.Types.ShopCoin) {
            return "<color=#F8EA4E>";
          } else if (this.Type() === Content.Types.Jigsaw) {
            return "<color=#ffffff>";
          } else if (this.Type() === Content.Types.Item) {
            if (this.Id() == 2) return "<color=#d9baff>";
            if (this.Id() == 3) return "<color=#ffbca7>";
            return "<color=#F889EB>";
          }

          return "<color>";
        } //pack包含的contents 或者只有自身
        //配置类型会转换为实际道具的content


        Contents() {
          let contents = [];

          if (this.Type() === Content.Types.Pack) {
            contents = Meta.MetaManager.GetMeta(Meta.MetaType.PackItem, this.ContentId()).Contents();
          } else if (this.Type() === Content.Types.DynamicPack) {
            let rawPackId = this.ContentId();
            contents = Meta.DynamicPackMeta.FindMeta(rawPackId, Game.SUserVillage.MapId(), Game.SUserRecord.GetPurchaseMoney()).Contents();
          } else {
            contents.push(this);
          }

          for (let i = 0; i < contents.length; i++) {
            let content = contents[i];

            if (content.Type() === Content.Types.ShopCoin) {
              let meta = Meta.MetaManager.GetMeta(Meta.MetaType.ShopCoin, Game.SUserVillage.MapId());
              contents[i] = new Content(Content.Types.Coin, 0, Content.RoundCoin(meta.GetCoin(content.ContentId()) * content.Count()));
            }
          }

          return contents;
        }

        GetObject() {
          return {
            type: this.type,
            cid: this.cid,
            count: this.count
          };
        }

      }

      exports('Content', Content); //整合数据 保证一个类型只有一条数据

      _defineProperty(Content, "Types", {
        Coin: 1,
        //金币
        Ap: 2,
        //体力
        Shield: 3,
        //护盾
        TimeShield: 13,
        //时效护盾
        SuperTimeShield: 14,
        //超级时效护盾
        Card: 4,
        //卡片
        CardChest: 5,
        //卡片箱子
        Item: 6,
        //道具
        Pack: 10,
        //道具包
        DynamicPack: 12,
        //动态道具包
        ShopCoin: 11,
        //商店金币
        Jigsaw: 101,
        //拼图
        Symbol: 110,
        //老虎机标志
        ActivityItem: 102 // 活动item道具

      });

      var _Merge = function (cont, conttysts) {
        //同类型数据相加
        if (cont.Count() == 0) return;
        let conttystKey = cont.Type().toString() + "=" + cont.ContentId().toString();

        if (!conttysts.hasOwnProperty(conttystKey)) {
          conttysts[conttystKey] = 0;
        }

        if (cont.IsBigNumberCount()) conttysts[conttystKey] = BigNumber.add(conttysts[conttystKey], cont.Count());else conttysts[conttystKey] += cont.Count();
      };

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageFinishWindow.ts", ['cc', './global.ts', './SoundManager.ts', './UIWindow.ts', './SdkManager.ts', './NewMapWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ShareWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, G, SoundManager, UIWindow, SdkManager, NewMapWindow, UIRoot, Game, LogEventWrap, ShareWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      NewMapWindow = module.NewMapWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "99c642ytXZGs4yZD2IfICa0", "VillageFinishWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let VillageFinishWindow = exports('default', ccclass(_class = (_temp = _class2 = class VillageFinishWindow extends UIWindow {
        onShow(showParams) {
          SoundManager.playSound("village_complete"); // UIRoot.instance.preloadWindow("MapWindow");

          GameKit.BackKeyManager.registerBackEvent();
          homeView.slotNode.isSpining = true;
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        callBrag() {
          homeView.slotNode.makeIdle();

          if (SdkManager.IsNative() && Game.SUser.IsFacebook()) {
            ShareWrap.shareFbUrl(`${G.GameConfig.site_host}/share/finishi.html`, "village_share", () => {});
            return;
          }

          ShareWrap.share(i18n.t("ShareInviteFinishVillage"), "share/share1", {
            intent: "SHARE",
            type: "village_share"
          }, null, "village_share");
        }

        callNext() {
          this.closeAnim(() => {
            homeView.slotNode.makeIdle();
            UIRoot.instance.openChildWindow(NewMapWindow, {
              levelUp: true,
              showCallback: () => {
                //SoundManager.stopSound("village_complete")
                homeView.loadUserData();
                homeView.villagePage.node.getChildByName("container").getChildByName("UI").active = true;
                LogEventWrap.logEvent("VillageDetail", {
                  count: Game.SUserVillage.MapId() - 1
                });
                LogEventWrap.logAppAnalytic(SdkManager.IsAndroid() ? "pk7d0w" : "or44ph", {
                  level: Game.SUserVillage.MapId() - 1
                }); //aj_level_achieved
              }
            });
          }); // let req = SR.SRVillage.askNextVillage();
          // req.SetCallBack((res) => {
          // 	Game.SUserVillage.updateData(res.userVillage);
          // 	/*UIRoot.instance.openChildWindow(GetRewardWindow, {contents:[new Content(Content.Types.Ap, 0, G.GameConstance.nextGetSpins)], showCallback:(wnd) => {
          // 		wnd.addOnCloseFunc(() => {
          // 			let chest = GameKit.DataCache.GetData("UserCardChest")
          // 			if (chest) {
          // 				UIRoot.instance.openChildWindow(CardChestOpenWindow, {chest: chest, showCallback:(wnd) => {
          // 					GameKit.DataCache.RemoveData("UserCardChest")
          // 					wnd.addOnCloseFunc(() => {
          // 						this.closeAnim(() => {
          // 							UIRoot.instance.openChildWindow(MapWindow, {levelUp: true, showCallback: () => {
          // 								//SoundManager.stopSound("village_complete")
          // 								homeView.loadUserData()
          // 								AppKit.LogEventWrap.logEvent("VillageDetail", {count: Game.SUserVillage.MapId() - 1})
          // 							}})
          // 						})
          // 					})c
          // 				}})
          // 			}
          // 		})
          // 	}})*/
          // 	homeView.cardContainer.getComponentInChildren(CardAllSetWindow).flushData();
          // 	this.closeAnim(() => {
          // 		UIRoot.instance.openChildWindow(MapWindow, {
          // 			levelUp: true,
          // 			showCallback: () => {
          // 				//SoundManager.stopSound("village_complete")
          // 				homeView.loadUserData();
          // 				homeView.villagePage.node.getChildByName("UI").active = true;
          // 				AppKit.LogEventWrap.logEvent("VillageDetail", {
          // 					count: Game.SUserVillage.MapId() - 1,
          // 				});
          // 				AppKit.LogEventWrap.logAppAnalytic(AppKit.SdkManager.IsAndroid() ? "pk7d0w" : "or44ph", { level: Game.SUserVillage.MapId() - 1 }); //aj_level_achieved
          // 			},
          // 		});
          // 	});
          // });
          // req.SetErrorCallBack(() => {
          // 	this.close();
          // });
          // req.Send();
        }

      }, _defineProperty(_class2, "windowPath", "Village/VillageFinishWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BlackJackWatchWindow.ts", ['cc', './UIWindow.ts', './SR.ts', './ADWrap.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, UIWindow, SR, ADWrap, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "9a4a5TFP2VNp7F2UAZwozqP", "BlackJackWatchWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //// const UIWindow = UIWindow

      let BlackJackWatchWindow = exports('default', (_dec = property(Label), _dec2 = property(Node), _dec3 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class BlackJackWatchWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "label_des", _descriptor, this);

          _initializerDefineProperty(this, "spWin", _descriptor2, this);

          _initializerDefineProperty(this, "spLose", _descriptor3, this);

          _defineProperty(this, "win", void 0);
        }

        onShow(showParams) {
          this.win = showParams.win;
          if (this.win) this.label_des.string = String.format(i18n.t("BlackJackWatchWindowDesWin"));else this.label_des.string = String.format(i18n.t("BlackJackWatchWindowDesLose"));
          this.spWin.active = !!this.win;
          this.spLose.active = !this.win;
        }

        onClose() {}

        event_close() {
          this.closeAnim();
        }

        event_go() {
          if (this.closing) return;
          ADWrap.ShowVideo(() => {
            if (this.closing) return;
            let req = null;
            if (this.win) req = SR.SRActivityBlackJack.activityBlackjackWatchWin();else req = SR.SRActivityBlackJack.activityBlackjackWatchLose();
            req.Send();
            this.closeAnim();
          }, this.win ? "blackjackWatchWin" : "blackjackWatchLose");
        }

      }, _defineProperty(_class3, "windowPath", "Activity/blackjack/BlackJackWatchWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "label_des", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spWin", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spLose", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ContainerInteraction.ts", ['cc', './Constant.ts', './SoundManager.ts', './ResourceLoader.ts', './Container3d.ts', './Bomb.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, assetManager, instantiate, SkeletalAnimation, tween, Vec3, Animation, AnimationClip, MyCustomEvent, SoundManager, ResourceLoader, Container3d, Bomb;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      assetManager = module.assetManager;
      instantiate = module.instantiate;
      SkeletalAnimation = module.SkeletalAnimation;
      tween = module.tween;
      Vec3 = module.Vec3;
      Animation = module.Animation;
      AnimationClip = module.AnimationClip;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      Container3d = module.default;
    }, function (module) {
      Bomb = module.default;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "9b92ar79URKWpTmRws1PZSt", "ContainerInteraction", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ContainerInteraction = exports('default', (_dec = ccclass("ContainerInteraction"), _dec(_class = (_temp = class ContainerInteraction extends Container3d {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "bomb", void 0);

          _defineProperty(this, "shieldNode", void 0);
        }

        onLoad() {
          eventCenter.on(MyCustomEvent.OnBombHitShield, this.onHitShield, this);
          eventCenter.on(MyCustomEvent.OnBombHitTarget, this.onHitTarget, this);
        }

        onDestroy() {
          super.onDestroy();
          this.bomb && this.bomb.node.destroy();
          this.shieldNode && this.shieldNode.destroy();
          eventCenter.off(MyCustomEvent.OnBombHitShield, this.onHitShield, this);
          eventCenter.off(MyCustomEvent.OnBombHitTarget, this.onHitTarget, this);
        }

        reset() {
          assetManager.releaseAsset(this.renderTex);
          super.reset();
        }
        /**
         * @param targetWorldPos 终点世界坐标
         * @param intercepted 是否被拦截
         */


        throwBomb(targetWorldPos, intercepted, isServantActive = false, timeShieldGoldActive, timeShieldActive) {
          this.bomb.startAttack(targetWorldPos, intercepted, isServantActive, timeShieldGoldActive, timeShieldActive);
        }

        initBomb() {
          let bombNode = instantiate(ResourceLoader.resMap.get("common/bomb"));
          bombNode.active = true;
          let bomb = bombNode;
          this.bomb = bomb.addComponent(Bomb);
          this.bomb.init();
          this.camera.node.addChild(bomb);
          let worldPosition = bomb.worldPosition.clone();
          let worldRotation = bomb.worldRotation.clone();
          bomb.setParent(this.newChild);
          bomb.setWorldPosition(worldPosition);
          bomb.setWorldRotation(worldRotation);
          let flattedNodes = bomb.getFlattedChildrenRecursively();
          flattedNodes.forEach(v => v.layer = this.layer);
        }

        initShield(shield, worldPos, dir) {
          this.shieldNode = shield;
          this.newChild.addChild(shield); // shield.active = false;

          this.shieldNode.setWorldPosition(worldPos);
          this.shieldNode.forward = dir;
          this.shieldNode.getComponentInChildren(SkeletalAnimation).playOnLoad = false;
          tween(this.shieldNode).set({
            scale: new Vec3()
          }).to(0.2, {
            scale: Vec3.ONE
          }).start();
          let flattedNodes = shield.getFlattedChildrenRecursively();
          flattedNodes.forEach(v => v.layer = this.layer);
        }

        initFxShield(fxNode, worldPos, dir) {
          this.newChild.addChild(fxNode);
          fxNode.setWorldPosition(worldPos);
          let forward = this.camera.node.worldPosition.clone().subtract(worldPos);
          fxNode.forward = forward;
          let cmp = fxNode.getComponent(Animation);

          if (cmp && cmp.getState("dunpai_dog")) {
            cmp.getState("dunpai_dog").wrapMode = AnimationClip.WrapMode.Normal;
          }
        }

        onHitShield(worldPos, dir) {
          this.shake();
          this.shieldNode.active = true;
          this.shieldNode.getComponentInChildren(SkeletalAnimation).play();
          let anim = this.shieldNode.getComponentInChildren(SkeletalAnimation);
          anim.once(Animation.EventType.FINISHED, () => {
            this.shieldNode.active = false;
          });
          this.addBoomEffect(worldPos);
          SoundManager.playSound("attack_hit_shield");
        }

        onHitTarget(worldPos) {
          this.shake();
          this.addBoomEffect(worldPos);
          SoundManager.playSound("attack_hit");
        }

        addBoomEffect(worldPos) {
          let boom = instantiate(ResourceLoader.resMap.get("common/baozha"));
          boom.setWorldPosition(worldPos);
          this.node.addChild(boom);
          this.scheduleOnce(() => {
            boom && boom.destroy();
          }, 2);
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TimeUtil.ts", ['cc', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('TimeUtil', void 0);

      cclegacy._RF.push({}, "9c323xuyZFK1b6GfU1E4c4Q", "TimeUtil", undefined);

      let pad = function () {
        var tbl = [];
        return function (num, n) {
          var len = n - num.toString().length;
          if (len <= 0) return num;
          if (!tbl[len]) tbl[len] = new Array(len + 1).join("0");
          return tbl[len] + num;
        };
      }();

      let TimeUtil;

      (function (_TimeUtil) {
        let serverdelta = 0; //从0时间开始的第几秒

        function _getCurrentTime() {
          let d = new Date();
          return d.getTime() / 1000;
        }

        function getCurrentTime() {
          return _getCurrentTime() + serverdelta;
        }

        _TimeUtil.getCurrentTime = getCurrentTime;

        function UpdateServerTime(st) {
          serverdelta = st - _getCurrentTime();
        }

        _TimeUtil.UpdateServerTime = UpdateServerTime;

        function getCurrentDay(t) {
          t = t || getCurrentTime();
          let day = Math.floor((t + TimeZoneInSecond) / DayInSecond);
          return day;
        }

        _TimeUtil.getCurrentDay = getCurrentDay;

        function getCurrentHalfDay(t) {
          t = t || getCurrentTime();
          let hfday = Math.floor((t + TimeZoneInSecond) / (DayInSecond / 2));
          return hfday;
        }

        _TimeUtil.getCurrentHalfDay = getCurrentHalfDay;

        function getCurrentWeek(t) {
          t = t || getCurrentTime();
          let week = Math.floor((t - 4 * DayInSecond + TimeZoneInSecond) / WeekInSecond);
          return week;
        }

        _TimeUtil.getCurrentWeek = getCurrentWeek;

        function getCurrentMonth(t) {
          let date = new Date();
          return (date.getFullYear() - 1970) * 12 + date.getMonth();
        }

        _TimeUtil.getCurrentMonth = getCurrentMonth;
        const MinuteInSecond = _TimeUtil.MinuteInSecond = 60;
        const HourInSecond = _TimeUtil.HourInSecond = 60 * TimeUtil.MinuteInSecond;
        const DayInSecond = _TimeUtil.DayInSecond = 24 * TimeUtil.HourInSecond;
        const WeekInSecond = _TimeUtil.WeekInSecond = 7 * TimeUtil.DayInSecond;
        const TimeZoneInSecond = _TimeUtil.TimeZoneInSecond = -new Date().getTimezoneOffset() / 60 * TimeUtil.HourInSecond;
        const specialUItime = _TimeUtil.specialUItime = [53, 89, 121, 49, 53, 76, 113, 85, 53, 52, 117, 72, 53, 76, 105, 83, 53, 54, 105, 100, 53, 54, 101, 52, 53, 111, 117];

        function FormatTime(t) {
          t = t || getCurrentTime();
          let date = new Date((t + new Date().getTimezoneOffset() * MinuteInSecond + TimeUtil.TimeZoneInSecond) * 1000);
          let y = date.getFullYear();
          let mo = date.getMonth();
          let d = date.getDate();
          let h = date.getHours();
          let mi = date.getMinutes();
          let s = date.getSeconds();
          let ms = date.getMilliseconds();
          return {
            year: y,
            month: mo,
            day: d,
            hour: h,
            minute: mi,
            second: s,
            millisecond: ms
          };
        }

        _TimeUtil.FormatTime = FormatTime;

        function GetRemainTimeTable(rem) {
          if (rem < 0) rem = 0;
          rem = rem || 0;
          let day = Math.floor(rem / DayInSecond);
          rem -= day * DayInSecond;
          let hour = Math.floor(rem / HourInSecond);
          rem -= hour * HourInSecond;
          let minute = Math.floor(rem / MinuteInSecond);
          rem -= minute * MinuteInSecond;
          let second = Math.floor(rem);
          return {
            day: day,
            hour: hour,
            minute: minute,
            second: second
          };
        }

        _TimeUtil.GetRemainTimeTable = GetRemainTimeTable;

        function FormatRemainTimeSimple(rem, withday = true, fullhour = false) {
          let table = GetRemainTimeTable(rem);

          if (table.day > 0 && withday) {
            return String.format(i18n.t("CountDay"), table.day) + " " + pad(table.hour, 2) + ":" + pad(table.minute, 2) + ":" + pad(table.second, 2);
          } else {
            if (fullhour || table.hour > 0 || !withday && table.day > 0) {
              return pad(withday ? table.hour : table.day * 24 + table.hour, 2) + ":" + pad(table.minute, 2) + ":" + pad(table.second, 2);
            } else {
              if (table.minute > 0) {
                return pad(table.minute, 2) + ":" + pad(table.second, 2);
              } else {
                return "0:" + pad(table.second, 2);
              }
            }
          }
        }

        _TimeUtil.FormatRemainTimeSimple = FormatRemainTimeSimple;

        function FormatPastTime(rem, withMinute, withSecond) {
          let table = GetRemainTimeTable(rem);

          if (table.day > 0) {
            return String.format(i18n.t("PastDay"), table.day);
          } else if (table.hour > 0) {
            return String.format(i18n.t("PastHour"), table.hour);
          } else if (table.minute > 0 && withMinute) {
            return String.format(i18n.t("PastMinute"), table.minute);
          } else if (table.second > 0 && withSecond) {
            return String.format(i18n.t("PastSecond"), table.second);
          }

          return i18n.t("PastZero");
        }

        _TimeUtil.FormatPastTime = FormatPastTime;

        function FormatSomeTime(rem, withMinute, withSecond) {
          let table = GetRemainTimeTable(rem);

          if (table.day > 0) {
            return String.format(i18n.t("SomeDay"), table.day);
          } else if (table.hour > 0) {
            return String.format(i18n.t("SomeHour"), table.hour);
          } else if (table.minute > 0 && withMinute) {
            return String.format(i18n.t("SomeMinute"), table.minute);
          } else if (table.second > 0 && withSecond) {
            return String.format(i18n.t("SomeSecond"), table.second);
          }

          return i18n.t("SomeZero");
        }

        _TimeUtil.FormatSomeTime = FormatSomeTime;
      })(TimeUtil || (TimeUtil = exports('TimeUtil', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/vconsole.min.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "9c5b42+HVdAo41HLczD5ZJT", "vconsole.min", undefined);

      !function (e, t) {
        "object" == typeof exports && "object" == typeof module ? module.exports = t() : "function" == typeof define && define.amd ? define("VConsole", [], t) : "object" == typeof exports ? exports.VConsole = t() : e.VConsole = t();
      }(window, function () {
        return function (e) {
          var t = {};

          function n(o) {
            if (t[o]) return t[o].exports;
            var r = t[o] = {
              i: o,
              l: !1,
              exports: {}
            };
            return e[o].call(r.exports, r, r.exports, n), r.l = !0, r.exports;
          }

          return n.m = e, n.c = t, n.d = function (e, t, o) {
            n.o(e, t) || Object.defineProperty(e, t, {
              enumerable: !0,
              get: o
            });
          }, n.r = function (e) {
            "undefined" != typeof Symbol && Symbol.toStringTag && Object.defineProperty(e, Symbol.toStringTag, {
              value: "Module"
            }), Object.defineProperty(e, "__esModule", {
              value: !0
            });
          }, n.t = function (e, t) {
            if (1 & t && (e = n(e)), 8 & t) return e;
            if (4 & t && "object" == typeof e && e && e.__esModule) return e;
            var o = Object.create(null);
            if (n.r(o), Object.defineProperty(o, "default", {
              enumerable: !0,
              value: e
            }), 2 & t && "string" != typeof e) for (var r in e) n.d(o, r, function (t) {
              return e[t];
            }.bind(null, r));
            return o;
          }, n.n = function (e) {
            var t = e && e.__esModule ? function () {
              return e.default;
            } : function () {
              return e;
            };
            return n.d(t, "a", t), t;
          }, n.o = function (e, t) {
            return Object.prototype.hasOwnProperty.call(e, t);
          }, n.p = "", n(n.s = 6);
        }([function (e, t, n) {
          var o, r, i;
          r = [t], void 0 === (i = "function" == typeof (o = function (e) {
            function t(e) {
              return (t = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
                return typeof e;
              } : function (e) {
                return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
              })(e);
            }

            function n(e) {
              return "[object Number]" == Object.prototype.toString.call(e);
            }

            function o(e) {
              return "[object String]" == Object.prototype.toString.call(e);
            }

            function r(e) {
              return "[object Array]" == Object.prototype.toString.call(e);
            }

            function i(e) {
              return "[object Boolean]" == Object.prototype.toString.call(e);
            }

            function a(e) {
              return void 0 === e;
            }

            function l(e) {
              return null === e;
            }

            function c(e) {
              return "[object Symbol]" == Object.prototype.toString.call(e);
            }

            function s(e) {
              return !("[object Object]" != Object.prototype.toString.call(e) && (n(e) || o(e) || i(e) || r(e) || l(e) || u(e) || a(e) || c(e)));
            }

            function u(e) {
              return "[object Function]" == Object.prototype.toString.call(e);
            }

            function d(e) {
              var t = Object.prototype.toString.call(e);
              return "[object global]" == t || "[object Window]" == t || "[object DOMWindow]" == t;
            }

            function f(e) {
              if (!s(e) && !r(e)) return [];
              var t = [];

              for (var n in e) t.push(n);

              return t.sort();
            }

            Object.defineProperty(e, "__esModule", {
              value: !0
            }), e.getDate = function (e) {
              var t = e > 0 ? new Date(e) : new Date(),
                  n = t.getDate() < 10 ? "0" + t.getDate() : t.getDate(),
                  o = t.getMonth() < 9 ? "0" + (t.getMonth() + 1) : t.getMonth() + 1,
                  r = t.getFullYear(),
                  i = t.getHours() < 10 ? "0" + t.getHours() : t.getHours(),
                  a = t.getMinutes() < 10 ? "0" + t.getMinutes() : t.getMinutes(),
                  l = t.getSeconds() < 10 ? "0" + t.getSeconds() : t.getSeconds(),
                  c = t.getMilliseconds() < 10 ? "0" + t.getMilliseconds() : t.getMilliseconds();
              return c < 100 && (c = "0" + c), {
                time: +t,
                year: r,
                month: o,
                day: n,
                hour: i,
                minute: a,
                second: l,
                millisecond: c
              };
            }, e.isNumber = n, e.isString = o, e.isArray = r, e.isBoolean = i, e.isUndefined = a, e.isNull = l, e.isSymbol = c, e.isObject = s, e.isFunction = u, e.isElement = function (e) {
              return "object" === ("undefined" == typeof HTMLElement ? "undefined" : t(HTMLElement)) ? e instanceof HTMLElement : e && "object" === t(e) && null !== e && 1 === e.nodeType && "string" == typeof e.nodeName;
            }, e.isWindow = d, e.isPlainObject = function (e) {
              var n,
                  o = Object.prototype.hasOwnProperty;
              if (!e || "object" !== t(e) || e.nodeType || d(e)) return !1;

              try {
                if (e.constructor && !o.call(e, "constructor") && !o.call(e.constructor.prototype, "isPrototypeOf")) return !1;
              } catch (e) {
                return !1;
              }

              for (n in e);

              return void 0 === n || o.call(e, n);
            }, e.htmlEncode = function (e) {
              return document.createElement("a").appendChild(document.createTextNode(e)).parentNode.innerHTML;
            }, e.JSONStringify = function (e) {
              if (!s(e) && !r(e)) return JSON.stringify(e);
              var t = "{",
                  n = "}";
              r(e) && (t = "[", n = "]");

              for (var o = t, i = f(e), a = 0; a < i.length; a++) {
                var l = i[a],
                    d = e[l];

                try {
                  r(e) || (s(l) || r(l) || c(l) ? o += Object.prototype.toString.call(l) : o += l, o += ": "), r(d) ? o += "Array[" + d.length + "]" : s(d) || c(d) || u(d) ? o += Object.prototype.toString.call(d) : o += JSON.stringify(d), a < i.length - 1 && (o += ", ");
                } catch (e) {
                  continue;
                }
              }

              return o += n;
            }, e.getObjAllKeys = f, e.getObjName = function (e) {
              return Object.prototype.toString.call(e).replace("[object ", "").replace("]", "");
            }, e.setStorage = function (e, t) {
              window.localStorage && (e = "vConsole_" + e, localStorage.setItem(e, t));
            }, e.getStorage = function (e) {
              if (window.localStorage) return e = "vConsole_" + e, localStorage.getItem(e);
            };
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t, n) {
          var o, r, i;
          r = [t, n(0), n(10)], void 0 === (i = "function" == typeof (o = function (n, o, r) {
            var i;
            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, r = (i = r) && i.__esModule ? i : {
              default: i
            };
            var a = {
              one: function (e, t) {
                try {
                  return (t || document).querySelector(e) || void 0;
                } catch (e) {
                  return;
                }
              },
              all: function (e, t) {
                try {
                  var n = (t || document).querySelectorAll(e);
                  return [].slice.call(n);
                } catch (e) {
                  return [];
                }
              },
              addClass: function (e, t) {
                if (e) {
                  (0, o.isArray)(e) || (e = [e]);

                  for (var n = 0; n < e.length; n++) {
                    var r = (e[n].className || "").split(" ");
                    r.indexOf(t) > -1 || (r.push(t), e[n].className = r.join(" "));
                  }
                }
              },
              removeClass: function (e, t) {
                if (e) {
                  (0, o.isArray)(e) || (e = [e]);

                  for (var n = 0; n < e.length; n++) {
                    for (var r = e[n].className.split(" "), i = 0; i < r.length; i++) r[i] == t && (r[i] = "");

                    e[n].className = r.join(" ").trim();
                  }
                }
              },
              hasClass: function (e, t) {
                return !(!e || !e.classList) && e.classList.contains(t);
              },
              bind: function (e, t, n, r) {
                e && ((0, o.isArray)(e) || (e = [e]), e.forEach(function (e) {
                  e.addEventListener(t, n, !!r);
                }));
              },
              delegate: function (e, t, n, o) {
                e && e.addEventListener(t, function (t) {
                  var r = a.all(n, e);
                  if (r) e: for (var i = 0; i < r.length; i++) for (var l = t.target; l;) {
                    if (l == r[i]) {
                      o.call(l, t);
                      break e;
                    }

                    if ((l = l.parentNode) == e) break;
                  }
                }, !1);
              }
            };
            a.render = r.default;
            var l = a;
            n.default = l, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t, n) {
          var o, r, i;
          r = [t], void 0 === (i = "function" == typeof (o = function (n) {
            function o(e, t) {
              if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
            }

            function r(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0;

            var i = function () {
              function e(t) {
                var n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "newPlugin";
                o(this, e), this.id = t, this.name = n, this.isReady = !1, this.eventList = {};
              }

              var t, n;
              return t = e, (n = [{
                key: "on",
                value: function (e, t) {
                  return this.eventList[e] = t, this;
                }
              }, {
                key: "trigger",
                value: function (e, t) {
                  if ("function" == typeof this.eventList[e]) this.eventList[e].call(this, t);else {
                    var n = "on" + e.charAt(0).toUpperCase() + e.slice(1);
                    "function" == typeof this[n] && this[n].call(this, t);
                  }
                  return this;
                }
              }, {
                key: "id",
                get: function () {
                  return this._id;
                },
                set: function (e) {
                  if (!e) throw "Plugin ID cannot be empty";
                  this._id = e.toLowerCase();
                }
              }, {
                key: "name",
                get: function () {
                  return this._name;
                },
                set: function (e) {
                  if (!e) throw "Plugin name cannot be empty";
                  this._name = e;
                }
              }, {
                key: "vConsole",
                get: function () {
                  return this._vConsole || void 0;
                },
                set: function (e) {
                  if (!e) throw "vConsole cannot be empty";
                  this._vConsole = e;
                }
              }]) && r(t.prototype, n), e;
            }();

            n.default = i, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t, n) {
          var o, r, i;
          r = [t, n(0), n(1), n(2), n(18), n(19), n(20)], void 0 === (i = "function" == typeof (o = function (n, o, r, i, a, l, c) {
            function s(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function u() {
              if ("function" != typeof WeakMap) return null;
              var e = new WeakMap();
              return u = function () {
                return e;
              }, e;
            }

            function d(e) {
              return (d = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
                return typeof e;
              } : function (e) {
                return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
              })(e);
            }

            function f(e, t) {
              if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
            }

            function v(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            function p(e, t) {
              return (p = Object.setPrototypeOf || function (e, t) {
                return e.__proto__ = t, e;
              })(e, t);
            }

            function b(e) {
              var t = function () {
                if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
                if (Reflect.construct.sham) return !1;
                if ("function" == typeof Proxy) return !0;

                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function () {})), !0;
                } catch (e) {
                  return !1;
                }
              }();

              return function () {
                var n,
                    o = m(e);

                if (t) {
                  var r = m(this).constructor;
                  n = Reflect.construct(o, arguments, r);
                } else n = o.apply(this, arguments);

                return h(this, n);
              };
            }

            function h(e, t) {
              return !t || "object" !== d(t) && "function" != typeof t ? function (e) {
                if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return e;
              }(e) : t;
            }

            function m(e) {
              return (m = Object.setPrototypeOf ? Object.getPrototypeOf : function (e) {
                return e.__proto__ || Object.getPrototypeOf(e);
              })(e);
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, o = function (e) {
              if (e && e.__esModule) return e;
              if (null === e || "object" !== d(e) && "function" != typeof e) return {
                default: e
              };
              var t = u();
              if (t && t.has(e)) return t.get(e);
              var n = {},
                  o = Object.defineProperty && Object.getOwnPropertyDescriptor;

              for (var r in e) if (Object.prototype.hasOwnProperty.call(e, r)) {
                var i = o ? Object.getOwnPropertyDescriptor(e, r) : null;
                i && (i.get || i.set) ? Object.defineProperty(n, r, i) : n[r] = e[r];
              }

              return n.default = e, t && t.set(e, n), n;
            }(o), r = s(r), i = s(i), a = s(a), l = s(l), c = s(c);

            var g = [],
                y = {},
                _ = function (e) {
              !function (e, t) {
                if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
                e.prototype = Object.create(t && t.prototype, {
                  constructor: {
                    value: e,
                    writable: !0,
                    configurable: !0
                  }
                }), t && p(e, t);
              }(u, e);
              var t,
                  n,
                  s = b(u);

              function u() {
                var e;
                f(this, u);

                for (var t = arguments.length, n = new Array(t), o = 0; o < t; o++) n[o] = arguments[o];

                return e = s.call.apply(s, [this].concat(n)), g.push(e.id), e.tplTabbox = "", e.allowUnformattedLog = !0, e.isReady = !1, e.isShow = !1, e.$tabbox = null, e.console = {}, e.logList = [], e.isInBottom = !0, e.maxLogNumber = 1e3, e.logNumber = 0, e.mockConsole(), e;
              }

              return t = u, (n = [{
                key: "onInit",
                value: function () {
                  this.$tabbox = r.default.render(this.tplTabbox, {}), this.updateMaxLogNumber();
                }
              }, {
                key: "onRenderTab",
                value: function (e) {
                  e(this.$tabbox);
                }
              }, {
                key: "onAddTopBar",
                value: function (e) {
                  for (var t = this, n = ["All", "Log", "Info", "Warn", "Error"], o = [], i = 0; i < n.length; i++) o.push({
                    name: n[i],
                    data: {
                      type: n[i].toLowerCase()
                    },
                    className: "",
                    onClick: function () {
                      if (r.default.hasClass(this, "vc-actived")) return !1;
                      t.showLogType(this.dataset.type || "all");
                    }
                  });

                  o[0].className = "vc-actived", e(o);
                }
              }, {
                key: "onAddTool",
                value: function (e) {
                  var t = this;
                  e([{
                    name: "Clear",
                    global: !1,
                    onClick: function () {
                      t.clearLog(), t.vConsole.triggerEvent("clearLog");
                    }
                  }]);
                }
              }, {
                key: "onReady",
                value: function () {
                  var e = this;
                  e.isReady = !0;
                  var t = r.default.all(".vc-subtab", e.$tabbox);
                  r.default.bind(t, "click", function (n) {
                    if (n.preventDefault(), r.default.hasClass(this, "vc-actived")) return !1;
                    r.default.removeClass(t, "vc-actived"), r.default.addClass(this, "vc-actived");
                    var o = this.dataset.type,
                        i = r.default.one(".vc-log", e.$tabbox);
                    r.default.removeClass(i, "vc-log-partly-log"), r.default.removeClass(i, "vc-log-partly-info"), r.default.removeClass(i, "vc-log-partly-warn"), r.default.removeClass(i, "vc-log-partly-error"), "all" == o ? r.default.removeClass(i, "vc-log-partly") : (r.default.addClass(i, "vc-log-partly"), r.default.addClass(i, "vc-log-partly-" + o));
                  });
                  var n = r.default.one(".vc-content");
                  r.default.bind(n, "scroll", function (t) {
                    e.isShow && (n.scrollTop + n.offsetHeight >= n.scrollHeight ? e.isInBottom = !0 : e.isInBottom = !1);
                  });

                  for (var o = 0; o < e.logList.length; o++) e.printLog(e.logList[o]);

                  e.logList = [];
                }
              }, {
                key: "onRemove",
                value: function () {
                  window.console.log = this.console.log, window.console.info = this.console.info, window.console.warn = this.console.warn, window.console.debug = this.console.debug, window.console.error = this.console.error, window.console.time = this.console.time, window.console.timeEnd = this.console.timeEnd, window.console.clear = this.console.clear, this.console = {};
                  var e = g.indexOf(this.id);
                  e > -1 && g.splice(e, 1);
                }
              }, {
                key: "onShow",
                value: function () {
                  this.isShow = !0, 1 == this.isInBottom && this.autoScrollToBottom();
                }
              }, {
                key: "onHide",
                value: function () {
                  this.isShow = !1;
                }
              }, {
                key: "onShowConsole",
                value: function () {
                  1 == this.isInBottom && this.autoScrollToBottom();
                }
              }, {
                key: "onUpdateOption",
                value: function () {
                  this.vConsole.option.maxLogNumber != this.maxLogNumber && (this.updateMaxLogNumber(), this.limitMaxLogs());
                }
              }, {
                key: "updateMaxLogNumber",
                value: function () {
                  this.maxLogNumber = this.vConsole.option.maxLogNumber || 1e3, this.maxLogNumber = Math.max(1, this.maxLogNumber);
                }
              }, {
                key: "limitMaxLogs",
                value: function () {
                  if (this.isReady) for (; this.logNumber > this.maxLogNumber;) {
                    var e = r.default.one(".vc-item", this.$tabbox);
                    if (!e) break;
                    e.parentNode.removeChild(e), this.logNumber--;
                  }
                }
              }, {
                key: "showLogType",
                value: function (e) {
                  var t = r.default.one(".vc-log", this.$tabbox);
                  r.default.removeClass(t, "vc-log-partly-log"), r.default.removeClass(t, "vc-log-partly-info"), r.default.removeClass(t, "vc-log-partly-warn"), r.default.removeClass(t, "vc-log-partly-error"), "all" == e ? r.default.removeClass(t, "vc-log-partly") : (r.default.addClass(t, "vc-log-partly"), r.default.addClass(t, "vc-log-partly-" + e));
                }
              }, {
                key: "autoScrollToBottom",
                value: function () {
                  this.vConsole.option.disableLogScrolling || this.scrollToBottom();
                }
              }, {
                key: "scrollToBottom",
                value: function () {
                  var e = r.default.one(".vc-content");
                  e && (e.scrollTop = e.scrollHeight - e.offsetHeight);
                }
              }, {
                key: "mockConsole",
                value: function () {
                  var e = this,
                      t = this,
                      n = ["log", "info", "warn", "debug", "error"];
                  window.console ? (n.map(function (e) {
                    t.console[e] = window.console[e];
                  }), t.console.time = window.console.time, t.console.timeEnd = window.console.timeEnd, t.console.clear = window.console.clear) : window.console = {}, n.map(function (t) {
                    window.console[t] = function () {
                      for (var n = arguments.length, o = new Array(n), r = 0; r < n; r++) o[r] = arguments[r];

                      e.printLog({
                        logType: t,
                        logs: o
                      });
                    };
                  });
                  var o = {};
                  window.console.time = function (e) {
                    o[e] = Date.now();
                  }, window.console.timeEnd = function (e) {
                    var t = o[e];
                    t ? (console.log(e + ":", Date.now() - t + "ms"), delete o[e]) : console.log(e + ": 0ms");
                  }, window.console.clear = function () {
                    t.clearLog();

                    for (var e = arguments.length, n = new Array(e), o = 0; o < e; o++) n[o] = arguments[o];

                    t.console.clear.apply(window.console, n);
                  };
                }
              }, {
                key: "clearLog",
                value: function () {
                  r.default.one(".vc-log", this.$tabbox).innerHTML = "", this.logNumber = 0, y = {};
                }
              }, {
                key: "printOriginLog",
                value: function (e) {
                  "function" == typeof this.console[e.logType] && this.console[e.logType].apply(window.console, e.logs);
                }
              }, {
                key: "printLog",
                value: function (e) {
                  var t = e.logs || [];

                  if (t.length || e.content) {
                    t = [].slice.call(t || []);
                    var n = /^\[(\w+)\]$/i,
                        r = "",
                        i = !1;

                    if (o.isString(t[0])) {
                      var a = t[0].match(n);
                      null !== a && a.length > 0 && (r = a[1].toLowerCase(), i = g.indexOf(r) > -1);
                    }

                    if (r === this.id || !0 !== i && "default" === this.id) {
                      if (e._id || (e._id = "__vc_" + Math.random().toString(36).substring(2, 8)), e.date || (e.date = +new Date()), this.isReady) {
                        o.isString(t[0]) && i && (t[0] = t[0].replace(n, ""), "" === t[0] && t.shift());

                        for (var l = {
                          _id: e._id,
                          logType: e.logType,
                          logText: [],
                          hasContent: !!e.content,
                          count: 1
                        }, c = 0; c < t.length; c++) o.isFunction(t[c]) ? l.logText.push(t[c].toString()) : o.isObject(t[c]) || o.isArray(t[c]) ? l.logText.push(o.JSONStringify(t[c])) : l.logText.push(t[c]);

                        l.logText = l.logText.join(" "), l.hasContent || y.logType !== l.logType || y.logText !== l.logText ? (this.printNewLog(e, t), y = l) : this.printRepeatLog(), this.isInBottom && this.isShow && this.autoScrollToBottom(), e.noOrigin || this.printOriginLog(e);
                      } else this.logList.push(e);
                    } else e.noOrigin || this.printOriginLog(e);
                  }
                }
              }, {
                key: "printRepeatLog",
                value: function () {
                  var e = r.default.one("#" + y._id),
                      t = r.default.one(".vc-item-repeat", e);
                  t || ((t = document.createElement("i")).className = "vc-item-repeat", e.insertBefore(t, e.lastChild)), y.count, y.count++, t.innerHTML = y.count;
                }
              }, {
                key: "printNewLog",
                value: function (e, t) {
                  var n = r.default.render(a.default, {
                    _id: e._id,
                    logType: e.logType,
                    style: e.style || ""
                  }),
                      i = /(\%c )|( \%c)/g,
                      l = [];

                  if (o.isString(t[0]) && i.test(t[0])) {
                    for (var c = t[0].split(i).filter(function (e) {
                      return void 0 !== e && "" !== e && !/ ?\%c ?/.test(e);
                    }), s = t[0].match(i), u = 0; u < s.length; u++) o.isString(t[u + 1]) && l.push(t[u + 1]);

                    for (var f = s.length + 1; f < t.length; f++) c.push(t[f]);

                    t = c;
                  }

                  for (var v = r.default.one(".vc-item-content", n), p = 0; p < t.length; p++) {
                    var b = void 0;

                    try {
                      if ("" === t[p]) continue;
                      b = o.isFunction(t[p]) ? "<span> " + t[p].toString() + "</span>" : o.isObject(t[p]) || o.isArray(t[p]) ? this.getFoldedLine(t[p]) : (l[p] ? '<span style="'.concat(l[p], '"> ') : "<span> ") + o.htmlEncode(t[p]).replace(/\n/g, "<br/>") + "</span>";
                    } catch (e) {
                      b = "<span> [" + d(t[p]) + "]</span>";
                    }

                    b && ("string" == typeof b ? v.insertAdjacentHTML("beforeend", b) : v.insertAdjacentElement("beforeend", b));
                  }

                  o.isObject(e.content) && v.insertAdjacentElement("beforeend", e.content), this.formatLine && (n = this.formatLine(n)), r.default.one(".vc-log", this.$tabbox).insertAdjacentElement("beforeend", n), this.logNumber++, this.limitMaxLogs();
                }
              }, {
                key: "getFoldedLine",
                value: function (e, t) {
                  var n = this;

                  if (!t) {
                    var i = o.JSONStringify(e),
                        a = i.substr(0, 36);
                    t = o.getObjName(e), i.length > 36 && (a += "..."), t += " " + a;
                  }

                  var s = r.default.render(l.default, {
                    outer: t,
                    lineType: "obj"
                  });
                  return r.default.bind(r.default.one(".vc-fold-outer", s), "click", function (t) {
                    t.preventDefault(), t.stopPropagation(), r.default.hasClass(s, "vc-toggle") ? (r.default.removeClass(s, "vc-toggle"), r.default.removeClass(r.default.one(".vc-fold-inner", s), "vc-toggle"), r.default.removeClass(r.default.one(".vc-fold-outer", s), "vc-toggle")) : (r.default.addClass(s, "vc-toggle"), r.default.addClass(r.default.one(".vc-fold-inner", s), "vc-toggle"), r.default.addClass(r.default.one(".vc-fold-outer", s), "vc-toggle"));
                    var i = r.default.one(".vc-fold-inner", s);
                    return setTimeout(function () {
                      if (0 == i.children.length && e) {
                        for (var t = o.getObjAllKeys(e), a = 0; a < t.length; a++) {
                          var s = void 0,
                              u = "undefined",
                              d = "";

                          try {
                            s = e[t[a]];
                          } catch (e) {
                            continue;
                          }

                          o.isString(s) ? (u = "string", s = '"' + s + '"') : o.isNumber(s) ? u = "number" : o.isBoolean(s) ? u = "boolean" : o.isNull(s) ? (u = "null", s = "null") : o.isUndefined(s) ? (u = "undefined", s = "undefined") : o.isFunction(s) ? (u = "function", s = "function()") : o.isSymbol(s) && (u = "symbol");
                          var f = void 0;

                          if (o.isArray(s)) {
                            var v = o.getObjName(s) + "[" + s.length + "]";
                            f = n.getFoldedLine(s, r.default.render(c.default, {
                              key: t[a],
                              keyType: d,
                              value: v,
                              valueType: "array"
                            }, !0));
                          } else if (o.isObject(s)) {
                            var p = o.getObjName(s);
                            f = n.getFoldedLine(s, r.default.render(c.default, {
                              key: o.htmlEncode(t[a]),
                              keyType: d,
                              value: p,
                              valueType: "object"
                            }, !0));
                          } else {
                            e.hasOwnProperty && !e.hasOwnProperty(t[a]) && (d = "private");
                            var b = {
                              lineType: "kv",
                              key: o.htmlEncode(t[a]),
                              keyType: d,
                              value: o.htmlEncode(s),
                              valueType: u
                            };
                            f = r.default.render(l.default, b);
                          }

                          i.insertAdjacentElement("beforeend", f);
                        }

                        if (o.isObject(e)) {
                          var h,
                              m = e.__proto__;
                          h = o.isObject(m) ? n.getFoldedLine(m, r.default.render(c.default, {
                            key: "__proto__",
                            keyType: "private",
                            value: o.getObjName(m),
                            valueType: "object"
                          }, !0)) : r.default.render(c.default, {
                            key: "__proto__",
                            keyType: "private",
                            value: "null",
                            valueType: "null"
                          }), i.insertAdjacentElement("beforeend", h);
                        }
                      }
                    }), !1;
                  }), s;
                }
              }]) && v(t.prototype, n), u;
            }(i.default);

            _.AddedLogID = [];
            var w = _;
            n.default = w, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t, n) {
          var o,
              r = function () {
            return void 0 === o && (o = Boolean(window && document && document.all && !window.atob)), o;
          },
              i = function () {
            var e = {};
            return function (t) {
              if (void 0 === e[t]) {
                var n = document.querySelector(t);
                if (window.HTMLIFrameElement && n instanceof window.HTMLIFrameElement) try {
                  n = n.contentDocument.head;
                } catch (e) {
                  n = null;
                }
                e[t] = n;
              }

              return e[t];
            };
          }(),
              a = [];

          function l(e) {
            for (var t = -1, n = 0; n < a.length; n++) if (a[n].identifier === e) {
              t = n;
              break;
            }

            return t;
          }

          function c(e, t) {
            for (var n = {}, o = [], r = 0; r < e.length; r++) {
              var i = e[r],
                  c = t.base ? i[0] + t.base : i[0],
                  s = n[c] || 0,
                  u = "".concat(c, " ").concat(s);
              n[c] = s + 1;
              var d = l(u),
                  f = {
                css: i[1],
                media: i[2],
                sourceMap: i[3]
              };
              -1 !== d ? (a[d].references++, a[d].updater(f)) : a.push({
                identifier: u,
                updater: h(f, t),
                references: 1
              }), o.push(u);
            }

            return o;
          }

          function s(e) {
            var t = document.createElement("style"),
                o = e.attributes || {};

            if (void 0 === o.nonce) {
              var r = n.nc;
              r && (o.nonce = r);
            }

            if (Object.keys(o).forEach(function (e) {
              t.setAttribute(e, o[e]);
            }), "function" == typeof e.insert) e.insert(t);else {
              var a = i(e.insert || "head");
              if (!a) throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");
              a.appendChild(t);
            }
            return t;
          }

          var u,
              d = (u = [], function (e, t) {
            return u[e] = t, u.filter(Boolean).join("\n");
          });

          function f(e, t, n, o) {
            var r = n ? "" : o.media ? "@media ".concat(o.media, " {").concat(o.css, "}") : o.css;
            if (e.styleSheet) e.styleSheet.cssText = d(t, r);else {
              var i = document.createTextNode(r),
                  a = e.childNodes;
              a[t] && e.removeChild(a[t]), a.length ? e.insertBefore(i, a[t]) : e.appendChild(i);
            }
          }

          function v(e, t, n) {
            var o = n.css,
                r = n.media,
                i = n.sourceMap;
            if (r ? e.setAttribute("media", r) : e.removeAttribute("media"), i && "undefined" != typeof btoa && (o += "\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(i)))), " */")), e.styleSheet) e.styleSheet.cssText = o;else {
              for (; e.firstChild;) e.removeChild(e.firstChild);

              e.appendChild(document.createTextNode(o));
            }
          }

          var p = null,
              b = 0;

          function h(e, t) {
            var n, o, r;

            if (t.singleton) {
              var i = b++;
              n = p || (p = s(t)), o = f.bind(null, n, i, !1), r = f.bind(null, n, i, !0);
            } else n = s(t), o = v.bind(null, n, t), r = function () {
              !function (e) {
                if (null === e.parentNode) return !1;
                e.parentNode.removeChild(e);
              }(n);
            };

            return o(e), function (t) {
              if (t) {
                if (t.css === e.css && t.media === e.media && t.sourceMap === e.sourceMap) return;
                o(e = t);
              } else r();
            };
          }

          e.exports = function (e, t) {
            (t = t || {}).singleton || "boolean" == typeof t.singleton || (t.singleton = r());
            var n = c(e = e || [], t);
            return function (e) {
              if (e = e || [], "[object Array]" === Object.prototype.toString.call(e)) {
                for (var o = 0; o < n.length; o++) {
                  var r = l(n[o]);
                  a[r].references--;
                }

                for (var i = c(e, t), s = 0; s < n.length; s++) {
                  var u = l(n[s]);
                  0 === a[u].references && (a[u].updater(), a.splice(u, 1));
                }

                n = i;
              }
            };
          };
        }, function (e, t, n) {
          e.exports = function (e) {
            var t = [];
            return t.toString = function () {
              return this.map(function (t) {
                var n = function (e, t) {
                  var n = e[1] || "",
                      o = e[3];
                  if (!o) return n;

                  if (t && "function" == typeof btoa) {
                    var r = (a = o, l = btoa(unescape(encodeURIComponent(JSON.stringify(a)))), c = "sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(l), "/*# ".concat(c, " */")),
                        i = o.sources.map(function (e) {
                      return "/*# sourceURL=".concat(o.sourceRoot || "").concat(e, " */");
                    });
                    return [n].concat(i).concat([r]).join("\n");
                  }

                  var a, l, c;
                  return [n].join("\n");
                }(t, e);

                return t[2] ? "@media ".concat(t[2], " {").concat(n, "}") : n;
              }).join("");
            }, t.i = function (e, n, o) {
              "string" == typeof e && (e = [[null, e, ""]]);
              var r = {};
              if (o) for (var i = 0; i < this.length; i++) {
                var a = this[i][0];
                null != a && (r[a] = !0);
              }

              for (var l = 0; l < e.length; l++) {
                var c = [].concat(e[l]);
                o && r[c[0]] || (n && (c[2] ? c[2] = "".concat(n, " and ").concat(c[2]) : c[2] = n), t.push(c));
              }
            }, t;
          };
        }, function (e, t, n) {
          var o, r, i;
          r = [t, n(7)], void 0 === (i = "function" == typeof (o = function (n, o) {
            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0;
            var r,
                i = (r = o, o = r && r.__esModule ? r : {
              default: r
            }).default;
            n.default = i, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t, n) {
          var o, r, i;

          function a(e) {
            return (a = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
              return typeof e;
            } : function (e) {
              return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
            })(e);
          }

          r = [t, n(8), n(9), n(0), n(1), n(11), n(13), n(14), n(15), n(16), n(17), n(2), n(3), n(21), n(24), n(26), n(30), n(38)], void 0 === (i = "function" == typeof (o = function (n, o, r, i, l, c, s, u, d, f, v, p, b, h, m, g, y, _) {
            function w() {
              if ("function" != typeof WeakMap) return null;
              var e = new WeakMap();
              return w = function () {
                return e;
              }, e;
            }

            function C(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function x(e, t) {
              return function (e) {
                if (Array.isArray(e)) return e;
              }(e) || function (e, t) {
                if ("undefined" != typeof Symbol && Symbol.iterator in Object(e)) {
                  var n = [],
                      o = !0,
                      r = !1,
                      i = void 0;

                  try {
                    for (var a, l = e[Symbol.iterator](); !(o = (a = l.next()).done) && (n.push(a.value), !t || n.length !== t); o = !0);
                  } catch (e) {
                    r = !0, i = e;
                  } finally {
                    try {
                      o || null == l.return || l.return();
                    } finally {
                      if (r) throw i;
                    }
                  }

                  return n;
                }
              }(e, t) || function (e, t) {
                if (e) {
                  if ("string" == typeof e) return k(e, t);
                  var n = Object.prototype.toString.call(e).slice(8, -1);
                  return "Object" === n && e.constructor && (n = e.constructor.name), "Map" === n || "Set" === n ? Array.from(e) : "Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n) ? k(e, t) : void 0;
                }
              }(e, t) || function () {
                throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
              }();
            }

            function k(e, t) {
              (null == t || t > e.length) && (t = e.length);

              for (var n = 0, o = new Array(t); n < t; n++) o[n] = e[n];

              return o;
            }

            function O(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, r = C(r), i = function (e) {
              if (e && e.__esModule) return e;
              if (null === e || "object" !== a(e) && "function" != typeof e) return {
                default: e
              };
              var t = w();
              if (t && t.has(e)) return t.get(e);
              var n = {},
                  o = Object.defineProperty && Object.getOwnPropertyDescriptor;

              for (var r in e) if (Object.prototype.hasOwnProperty.call(e, r)) {
                var i = o ? Object.getOwnPropertyDescriptor(e, r) : null;
                i && (i.get || i.set) ? Object.defineProperty(n, r, i) : n[r] = e[r];
              }

              return n.default = e, t && t.set(e, n), n;
            }(i), l = C(l), s = C(s), u = C(u), d = C(d), f = C(f), v = C(v), p = C(p), b = C(b), h = C(h), m = C(m), g = C(g), y = C(y), _ = C(_);

            var E = function () {
              function e(t) {
                if (function (e, t) {
                  if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
                }(this, e), l.default.one("#__vconsole")) console.debug("vConsole is already exists.");else {
                  var n = this;
                  if (this.version = r.default.version, this.$dom = null, this.isInited = !1, this.option = {
                    defaultPlugins: ["system", "network", "element", "storage"]
                  }, this.activedTab = "", this.tabList = [], this.pluginList = {}, this.switchPos = {
                    hasMoved: !1,
                    x: 0,
                    y: 0,
                    startX: 0,
                    startY: 0,
                    endX: 0,
                    endY: 0
                  }, this.tool = i, this.$ = l.default, i.isObject(t)) for (var o in t) this.option[o] = t[o];

                  this._addBuiltInPlugins();

                  var a,
                      c = function () {
                    n.isInited || (n._render(), n._mockTap(), n._bindEvent(), n._autoRun());
                  };

                  if (void 0 !== document) "loading" === document.readyState ? l.default.bind(window, "DOMContentLoaded", c) : c();else a = setTimeout(function e() {
                    document && "complete" == document.readyState ? (a && clearTimeout(a), c()) : a = setTimeout(e, 1);
                  }, 1);
                }
              }

              var t, n;
              return t = e, (n = [{
                key: "_addBuiltInPlugins",
                value: function () {
                  this.addPlugin(new h.default("default", "Log"));
                  var e = this.option.defaultPlugins,
                      t = {
                    system: {
                      proto: m.default,
                      name: "System"
                    },
                    network: {
                      proto: g.default,
                      name: "Network"
                    },
                    element: {
                      proto: y.default,
                      name: "Element"
                    },
                    storage: {
                      proto: _.default,
                      name: "Storage"
                    }
                  };
                  if (e && i.isArray(e)) for (var n = 0; n < e.length; n++) {
                    var o = t[e[n]];
                    o ? this.addPlugin(new o.proto(e[n], o.name)) : console.debug("Unrecognized default plugin ID:", e[n]);
                  }
                }
              }, {
                key: "_render",
                value: function () {
                  if (!l.default.one("#__vconsole")) {
                    var e = document.createElement("div");
                    e.innerHTML = s.default, document.documentElement.insertAdjacentElement("beforeend", e.children[0]);
                  }

                  this.$dom = l.default.one("#__vconsole");
                  var t = l.default.one(".vc-switch", this.$dom),
                      n = 1 * i.getStorage("switch_x"),
                      o = 1 * i.getStorage("switch_y"),
                      r = x(this._getSwitchButtonSafeAreaXY(t, n, o), 2);
                  n = r[0], o = r[1], this.switchPos.x = n, this.switchPos.y = o, l.default.one(".vc-switch").style.right = n + "px", l.default.one(".vc-switch").style.bottom = o + "px";
                  var a = window.devicePixelRatio || 1,
                      c = document.querySelector('[name="viewport"]');

                  if (c && c.content) {
                    var u = c.content.match(/initial\-scale\=\d+(\.\d+)?/);
                    (u ? parseFloat(u[0].split("=")[1]) : 1) < 1 && (this.$dom.style.fontSize = 13 * a + "px");
                  }

                  l.default.one(".vc-mask", this.$dom).style.display = "none", this.option.theme && this.$dom.setAttribute("data-theme", this.option.theme);
                }
              }, {
                key: "_getSwitchButtonSafeAreaXY",
                value: function (e, t, n) {
                  var o = Math.max(document.documentElement.offsetWidth, window.innerWidth),
                      r = Math.max(document.documentElement.offsetHeight, window.innerHeight);
                  return t + e.offsetWidth > o && (t = o - e.offsetWidth), n + e.offsetHeight > r && (n = r - e.offsetHeight), t < 0 && (t = 0), n < 20 && (n = 20), [t, n];
                }
              }, {
                key: "_mockTap",
                value: function () {
                  var e,
                      t,
                      n,
                      o = !1,
                      r = null;
                  this.$dom.addEventListener("touchstart", function (o) {
                    if (void 0 === e) {
                      var i = o.targetTouches[0];
                      t = i.pageX, n = i.pageY, e = o.timeStamp, r = o.target.nodeType === Node.TEXT_NODE ? o.target.parentNode : o.target;
                    }
                  }, !1), this.$dom.addEventListener("touchmove", function (e) {
                    var r = e.changedTouches[0];
                    (Math.abs(r.pageX - t) > 10 || Math.abs(r.pageY - n) > 10) && (o = !0);
                  }), this.$dom.addEventListener("touchend", function (t) {
                    if (!1 === o && t.timeStamp - e < 700 && null != r) {
                      var n = !1;

                      switch (r.tagName.toLowerCase()) {
                        case "textarea":
                          n = !0;
                          break;

                        case "input":
                          switch (r.type) {
                            case "button":
                            case "checkbox":
                            case "file":
                            case "image":
                            case "radio":
                            case "submit":
                              n = !1;
                              break;

                            default:
                              n = !r.disabled && !r.readOnly;
                          }

                      }

                      if (n ? r.focus() : "function" == typeof window.getSelection && getSelection().rangeCount || t.preventDefault(), !r.disabled && !r.readOnly) {
                        var i = t.changedTouches[0],
                            a = document.createEvent("MouseEvents");
                        a.initMouseEvent("click", !0, !0, window, 1, i.screenX, i.screenY, i.clientX, i.clientY, !1, !1, !1, !1, 0, null), a.forwardedTouchEvent = !0, a.initEvent("click", !0, !0), r.dispatchEvent(a);
                      }
                    }

                    e = void 0, o = !1, r = null;
                  }, !1);
                }
              }, {
                key: "_bindEvent",
                value: function () {
                  var e = this,
                      t = l.default.one(".vc-switch", e.$dom);
                  l.default.bind(t, "touchstart", function (t) {
                    e.switchPos.startX = t.touches[0].pageX, e.switchPos.startY = t.touches[0].pageY, e.switchPos.hasMoved = !1;
                  }), l.default.bind(t, "touchend", function (t) {
                    e.switchPos.hasMoved && (e.switchPos.x = e.switchPos.endX, e.switchPos.y = e.switchPos.endY, e.switchPos.startX = 0, e.switchPos.startY = 0, e.switchPos.hasMoved = !1, i.setStorage("switch_x", e.switchPos.x), i.setStorage("switch_y", e.switchPos.y));
                  }), l.default.bind(t, "touchmove", function (n) {
                    if (!(n.touches.length <= 0)) {
                      var o = n.touches[0].pageX - e.switchPos.startX,
                          r = n.touches[0].pageY - e.switchPos.startY,
                          i = Math.floor(e.switchPos.x - o),
                          a = Math.floor(e.switchPos.y - r),
                          l = x(e._getSwitchButtonSafeAreaXY(t, i, a), 2);
                      i = l[0], a = l[1], t.style.right = i + "px", t.style.bottom = a + "px", e.switchPos.endX = i, e.switchPos.endY = a, e.switchPos.hasMoved = !0, console.log(i, a), n.preventDefault();
                    }
                  }), l.default.bind(l.default.one(".vc-switch", e.$dom), "click", function () {
                    e.show();
                  }), l.default.bind(l.default.one(".vc-hide", e.$dom), "click", function () {
                    e.hide();
                  });

                  var n = l.default.one(".vc-mask", this.$dom),
                      o = l.default.one(".vc-panel", this.$dom),
                      r = window.transitionEnd(n).whichTransitionEnd(),
                      a = function () {
                    n.style.display = "none", o.style.display = "none";
                  };

                  r ? l.default.bind(n, r, a) : a(), l.default.bind(n, "click", function (t) {
                    if (t.target != l.default.one(".vc-mask")) return !1;
                    e.hide();
                  }), l.default.delegate(l.default.one(".vc-tabbar", e.$dom), "click", ".vc-tab", function (t) {
                    var n = this.dataset.tab;
                    n != e.activedTab && e.showTab(n);
                  });

                  var c = function (t) {
                    l.default.hasClass(e.$dom, "vc-toggle") || (t.style.display = "none");
                  };

                  r ? l.default.bind(o, r, function (e) {
                    if (e.target != o) return !1;
                    c(e.target);
                  }) : c(o);
                  var s = l.default.one(".vc-content", e.$dom),
                      u = !1;
                  l.default.bind(s, "touchstart", function (e) {
                    var t = s.scrollTop,
                        n = s.scrollHeight,
                        o = t + s.offsetHeight;
                    0 === t ? (s.scrollTop = 1, 0 === s.scrollTop && (l.default.hasClass(e.target, "vc-cmd-input") || (u = !0))) : o === n && (s.scrollTop = t - 1, s.scrollTop === t && (l.default.hasClass(e.target, "vc-cmd-input") || (u = !0)));
                  }), l.default.bind(s, "touchmove", function (e) {
                    u && e.preventDefault();
                  }), l.default.bind(s, "touchend", function (e) {
                    u = !1;
                  });
                }
              }, {
                key: "_autoRun",
                value: function () {
                  for (var e in this.isInited = !0, this.pluginList) this._initPlugin(this.pluginList[e]);

                  this.tabList.length > 0 && this.showTab(this.tabList[0]), this.triggerEvent("ready");
                }
              }, {
                key: "triggerEvent",
                value: function (e, t) {
                  e = "on" + e.charAt(0).toUpperCase() + e.slice(1), i.isFunction(this.option[e]) && this.option[e].apply(this, t);
                }
              }, {
                key: "_initPlugin",
                value: function (e) {
                  var t = this;
                  e.vConsole = this, e.trigger("init"), e.trigger("renderTab", function (n) {
                    t.tabList.push(e.id);
                    var o = l.default.render(u.default, {
                      id: e.id,
                      name: e.name
                    });
                    l.default.one(".vc-tabbar", t.$dom).insertAdjacentElement("beforeend", o);
                    var r = l.default.render(d.default, {
                      id: e.id
                    });
                    n && (i.isString(n) ? r.innerHTML += n : i.isFunction(n.appendTo) ? n.appendTo(r) : i.isElement(n) && r.insertAdjacentElement("beforeend", n)), l.default.one(".vc-content", t.$dom).insertAdjacentElement("beforeend", r);
                  }), e.trigger("addTopBar", function (n) {
                    if (n) for (var o = l.default.one(".vc-topbar", t.$dom), r = function (t) {
                      var r = n[t],
                          a = l.default.render(f.default, {
                        name: r.name || "Undefined",
                        className: r.className || "",
                        pluginID: e.id
                      });
                      if (r.data) for (var c in r.data) a.dataset[c] = r.data[c];
                      i.isFunction(r.onClick) && l.default.bind(a, "click", function (t) {
                        !1 === r.onClick.call(a) || (l.default.removeClass(l.default.all(".vc-topbar-" + e.id), "vc-actived"), l.default.addClass(a, "vc-actived"));
                      }), o.insertAdjacentElement("beforeend", a);
                    }, a = 0; a < n.length; a++) r(a);
                  }), e.trigger("addTool", function (n) {
                    if (n) for (var o = l.default.one(".vc-tool-last", t.$dom), r = function (t) {
                      var r = n[t],
                          a = l.default.render(v.default, {
                        name: r.name || "Undefined",
                        pluginID: e.id
                      });
                      1 == r.global && l.default.addClass(a, "vc-global-tool"), i.isFunction(r.onClick) && l.default.bind(a, "click", function (e) {
                        r.onClick.call(a);
                      }), o.parentNode.insertBefore(a, o);
                    }, a = 0; a < n.length; a++) r(a);
                  }), e.isReady = !0, e.trigger("ready");
                }
              }, {
                key: "_triggerPluginsEvent",
                value: function (e) {
                  for (var t in this.pluginList) this.pluginList[t].isReady && this.pluginList[t].trigger(e);
                }
              }, {
                key: "_triggerPluginEvent",
                value: function (e, t) {
                  var n = this.pluginList[e];
                  n && n.isReady && n.trigger(t);
                }
              }, {
                key: "addPlugin",
                value: function (e) {
                  return void 0 !== this.pluginList[e.id] ? (console.debug("Plugin " + e.id + " has already been added."), !1) : (this.pluginList[e.id] = e, this.isInited && (this._initPlugin(e), 1 == this.tabList.length && this.showTab(this.tabList[0])), !0);
                }
              }, {
                key: "removePlugin",
                value: function (e) {
                  e = (e + "").toLowerCase();
                  var t = this.pluginList[e];
                  if (void 0 === t) return console.debug("Plugin " + e + " does not exist."), !1;

                  if (t.trigger("remove"), this.isInited) {
                    var n = l.default.one("#__vc_tab_" + e);
                    n && n.parentNode.removeChild(n);

                    for (var o = l.default.all(".vc-topbar-" + e, this.$dom), r = 0; r < o.length; r++) o[r].parentNode.removeChild(o[r]);

                    var i = l.default.one("#__vc_log_" + e);
                    i && i.parentNode.removeChild(i);

                    for (var a = l.default.all(".vc-tool-" + e, this.$dom), c = 0; c < a.length; c++) a[c].parentNode.removeChild(a[c]);
                  }

                  var s = this.tabList.indexOf(e);
                  s > -1 && this.tabList.splice(s, 1);

                  try {
                    delete this.pluginList[e];
                  } catch (t) {
                    this.pluginList[e] = void 0;
                  }

                  return this.activedTab == e && this.tabList.length > 0 && this.showTab(this.tabList[0]), !0;
                }
              }, {
                key: "show",
                value: function () {
                  if (this.isInited) {
                    var e = this;
                    l.default.one(".vc-panel", this.$dom).style.display = "block", setTimeout(function () {
                      l.default.addClass(e.$dom, "vc-toggle"), e._triggerPluginsEvent("showConsole"), l.default.one(".vc-mask", e.$dom).style.display = "block";
                    }, 10);
                  }
                }
              }, {
                key: "hide",
                value: function () {
                  this.isInited && (l.default.removeClass(this.$dom, "vc-toggle"), this._triggerPluginsEvent("hideConsole"));
                }
              }, {
                key: "showSwitch",
                value: function () {
                  this.isInited && (l.default.one(".vc-switch", this.$dom).style.display = "block");
                }
              }, {
                key: "hideSwitch",
                value: function () {
                  this.isInited && (l.default.one(".vc-switch", this.$dom).style.display = "none");
                }
              }, {
                key: "showTab",
                value: function (e) {
                  if (this.isInited) {
                    var t = l.default.one("#__vc_log_" + e);
                    l.default.removeClass(l.default.all(".vc-tab", this.$dom), "vc-actived"), l.default.addClass(l.default.one("#__vc_tab_" + e), "vc-actived"), l.default.removeClass(l.default.all(".vc-logbox", this.$dom), "vc-actived"), l.default.addClass(t, "vc-actived");
                    var n = l.default.all(".vc-topbar-" + e, this.$dom);
                    l.default.removeClass(l.default.all(".vc-toptab", this.$dom), "vc-toggle"), l.default.addClass(n, "vc-toggle"), n.length > 0 ? l.default.addClass(l.default.one(".vc-content", this.$dom), "vc-has-topbar") : l.default.removeClass(l.default.one(".vc-content", this.$dom), "vc-has-topbar"), l.default.removeClass(l.default.all(".vc-tool", this.$dom), "vc-toggle"), l.default.addClass(l.default.all(".vc-tool-" + e, this.$dom), "vc-toggle"), this.activedTab && this._triggerPluginEvent(this.activedTab, "hide"), this.activedTab = e, this._triggerPluginEvent(this.activedTab, "show");
                  }
                }
              }, {
                key: "setOption",
                value: function (e, t) {
                  if (i.isString(e)) this.option[e] = t, this._triggerPluginsEvent("updateOption");else if (i.isObject(e)) {
                    for (var n in e) this.option[n] = e[n];

                    this._triggerPluginsEvent("updateOption");
                  } else console.debug("The first parameter of vConsole.setOption() must be a string or an object.");
                }
              }, {
                key: "destroy",
                value: function () {
                  if (this.isInited) {
                    for (var e = Object.keys(this.pluginList), t = e.length - 1; t >= 0; t--) this.removePlugin(e[t]);

                    this.$dom.parentNode.removeChild(this.$dom), this.isInited = !1;
                  }
                }
              }]) && O(t.prototype, n), e;
            }();

            E.VConsolePlugin = p.default, E.VConsoleLogPlugin = b.default, E.VConsoleDefaultPlugin = h.default, E.VConsoleSystemPlugin = m.default, E.VConsoleNetworkPlugin = g.default, E.VConsoleElementPlugin = y.default, E.VConsoleStoragePlugin = _.default;
            var T = E;
            n.default = T, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t) {
          !function (e) {
            var t = function (e, t) {
              this.element = e, this.type = t;
            };

            t.prototype = {
              add: function (e) {
                this.callback = e, this.element.addEventListener(this.type, this.callback, !1);
              },
              remove: function () {
                this.element.removeEventListener(this.type, this.callback, !1);
              }
            };

            var n = function (e) {
              this.element = e, this.transitionEnd = this.whichTransitionEnd(), this.event = new t(this.element, this.transitionEnd);
            };

            n.prototype = {
              whichTransitionEnd: function () {
                var e = {
                  WebkitTransition: "webkitTransitionEnd",
                  MozTransition: "transitionend",
                  OTransition: "oTransitionEnd otransitionend",
                  transition: "transitionend"
                };

                for (var t in e) if (void 0 !== this.element.style[t]) return e[t];
              },
              bind: function (e) {
                this.event.add(e);
              },
              unbind: function () {
                this.event.remove();
              }
            };
            var o = {
              list: [],
              getPosition: function (e) {
                if (Array.prototype.indexOf) return this.list.indexOf(e);

                for (var t = 0, n = this.list.length; t < n; t++) if (this.list[t] === e) return t;

                return -1;
              },
              insert: function (e) {
                var t = this.getPosition(e);
                return -1 !== t || (this.list.push(e), this.list.push(new n(e)), t = this.getPosition(e)), this.list[t + 1];
              }
            };

            e.transitionEnd = function (e) {
              if (!e) throw "You need to pass an element as parameter!";
              var t = e[0] || e;
              return o.insert(t);
            };
          }(window);
        }, function (e) {
          e.exports = JSON.parse('{"name":"vconsole","version":"3.4.0","description":"A lightweight, extendable front-end developer tool for mobile web page.","homepage":"https://github.com/Tencent/vConsole","main":"dist/vconsole.min.js","typings":"dist/vconsole.min.d.ts","scripts":{"test":"mocha","build":"webpack","dev":"webpack-dev-server --config webpack.dev.config"},"keywords":["console","debug","mobile"],"repository":{"type":"git","url":"git+https://github.com/Tencent/vConsole.git"},"dependencies":{"mutation-observer":"^1.0.3","transitionEnd":"^1.0.2"},"devDependencies":{"@babel/core":"^7.12.10","@babel/plugin-proposal-class-properties":"^7.12.1","@babel/plugin-proposal-export-namespace-from":"^7.12.1","@babel/plugin-proposal-object-rest-spread":"^7.12.1","@babel/preset-env":"^7.12.11","babel-loader":"^8.2.2","babel-plugin-add-module-exports":"^1.0.4","chai":"^4.2.0","copy-webpack-plugin":"^5.1.2","css-loader":"^3.6.0","html-loader":"^0.5.5","jsdom":"^15.2.1","json-loader":"^0.5.7","less":"^3.13.1","less-loader":"^5.0.0","mocha":"^5.2.0","style-loader":"^1.3.0","webpack":"^4.44.2","webpack-cli":"^3.3.12","webpack-dev-server":"^3.11.0","webpack-merge":"^4.2.2"},"author":"Tencent","license":"MIT"}');
        }, function (e, t, n) {
          var o, r, i;
          r = [t], void 0 === (i = "function" == typeof (o = function (n) {
            function o(e, t) {
              var n;

              if ("undefined" == typeof Symbol || null == e[Symbol.iterator]) {
                if (Array.isArray(e) || (n = function (e, t) {
                  if (e) {
                    if ("string" == typeof e) return r(e, t);
                    var n = Object.prototype.toString.call(e).slice(8, -1);
                    return "Object" === n && e.constructor && (n = e.constructor.name), "Map" === n || "Set" === n ? Array.from(e) : "Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n) ? r(e, t) : void 0;
                  }
                }(e)) || t && e && "number" == typeof e.length) {
                  n && (e = n);

                  var o = 0,
                      i = function () {};

                  return {
                    s: i,
                    n: function () {
                      return o >= e.length ? {
                        done: !0
                      } : {
                        done: !1,
                        value: e[o++]
                      };
                    },
                    e: function (e) {
                      throw e;
                    },
                    f: i
                  };
                }

                throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
              }

              var a,
                  l = !0,
                  c = !1;
              return {
                s: function () {
                  n = e[Symbol.iterator]();
                },
                n: function () {
                  var e = n.next();
                  return l = e.done, e;
                },
                e: function (e) {
                  c = !0, a = e;
                },
                f: function () {
                  try {
                    l || null == n.return || n.return();
                  } finally {
                    if (c) throw a;
                  }
                }
              };
            }

            function r(e, t) {
              (null == t || t > e.length) && (t = e.length);

              for (var n = 0, o = new Array(t); n < t; n++) o[n] = e[n];

              return o;
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = function (e, t, n) {
              var r = /\{\{([^\}]+)\}\}/g,
                  i = "",
                  a = "",
                  l = 0,
                  c = [],
                  s = function (e, t) {
                "" !== e && (t ? e.match(/^ ?else/g) ? i += "} " + e + " {\n" : e.match(/\/(if|for|switch)/g) ? i += "}\n" : e.match(/^ ?if|for|switch/g) ? i += e + " {\n" : e.match(/^ ?(break|continue) ?$/g) ? i += e + ";\n" : e.match(/^ ?(case|default)/g) ? i += e + ":\n" : i += "arr.push(" + e + ");\n" : i += 'arr.push("' + e.replace(/"/g, '\\"') + '");\n');
              };

              for (window.__mito_data = t, window.__mito_code = "", window.__mito_result = "", e = (e = e.replace(/(\{\{ ?switch(.+?)\}\})[\r\n\t ]+\{\{/g, "$1{{")).replace(/^[\r\n]/, "").replace(/\n/g, "\\\n").replace(/\r/g, "\\\r"), a = "(function(){\n", i = "var arr = [];\n"; c = r.exec(e);) s(e.slice(l, c.index), !1), s(c[1], !0), l = c.index + c[0].length;

              s(e.substr(l, e.length - l), !1), a += i = "with (__mito_data) {\n" + (i += '__mito_result = arr.join("");') + "\n}", a += "})();";
              var u,
                  d = "",
                  f = o(document.getElementsByTagName("script"));

              try {
                for (f.s(); !(u = f.n()).done;) {
                  var v = u.value;

                  if (v.nonce) {
                    d = v.nonce;
                    break;
                  }
                }
              } catch (e) {
                f.e(e);
              } finally {
                f.f();
              }

              var p = document.createElement("SCRIPT");
              p.innerHTML = a, p.setAttribute("nonce", d), document.documentElement.appendChild(p);
              var b = __mito_result;

              if (document.documentElement.removeChild(p), !n) {
                var h = document.createElement("DIV");
                h.innerHTML = b, b = h.children[0];
              }

              return b;
            }, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t, n) {
          var o = n(4),
              r = n(12);
          "string" == typeof (r = r.__esModule ? r.default : r) && (r = [[e.i, r, ""]]);
          var i = {
            insert: "head",
            singleton: !1
          };
          o(r, i);
          e.exports = r.locals || {};
        }, function (e, t, n) {
          (t = n(5)(!1)).push([e.i, '#__vconsole {\n  --VC-BG-0: #ededed;\n  --VC-BG-1: #f7f7f7;\n  --VC-BG-2: #fff;\n  --VC-BG-3: #f7f7f7;\n  --VC-BG-4: #4c4c4c;\n  --VC-BG-5: #fff;\n  --VC-FG-0: rgba(0, 0, 0, 0.9);\n  --VC-FG-HALF: rgba(0, 0, 0, 0.9);\n  --VC-FG-1: rgba(0, 0, 0, 0.5);\n  --VC-FG-2: rgba(0, 0, 0, 0.3);\n  --VC-FG-3: rgba(0, 0, 0, 0.1);\n  --VC-RED: #fa5151;\n  --VC-ORANGE: #fa9d3b;\n  --VC-YELLOW: #ffc300;\n  --VC-GREEN: #91d300;\n  --VC-LIGHTGREEN: #95ec69;\n  --VC-BRAND: #07c160;\n  --VC-BLUE: #10aeff;\n  --VC-INDIGO: #1485ee;\n  --VC-PURPLE: #6467f0;\n  --VC-LINK: #576b95;\n  --VC-TEXTGREEN: #06ae56;\n  --VC-FG: black;\n  --VC-BG: white;\n  --VC-BG-COLOR-ACTIVE: #ececec;\n  --VC-WARN-BG: #fff3cc;\n  --VC-WARN-BORDER: #ffe799;\n  --VC-ERROR-BG: #fedcdc;\n  --VC-ERROR-BORDER: #fdb9b9;\n  --VC-DOM-TAG-NAME-COLOR: #881280;\n  --VC-DOM-ATTRIBUTE-NAME-COLOR: #994500;\n  --VC-DOM-ATTRIBUTE-VALUE-COLOR: #1a1aa6;\n  --VC-CODE-KEY-FG: #881391;\n  --VC-CODE-PRIVATE-KEY-FG: #cfa1d3;\n  --VC-CODE-FUNC-FG: #0d22aa;\n  --VC-CODE-NUMBER-FG: #1c00cf;\n  --VC-CODE-STR-FG: #c41a16;\n  --VC-CODE-NULL-FG: #808080;\n  color: var(--VC-FG-0);\n  font-size: 13px;\n  font-family: Helvetica Neue, Helvetica, Arial, sans-serif;\n  -webkit-user-select: auto;\n  /* global */\n  /* compoment */\n}\n#__vconsole .vc-max-height {\n  max-height: 19.23076923em;\n}\n#__vconsole .vc-max-height-line {\n  max-height: 3.38461538em;\n}\n#__vconsole .vc-min-height {\n  min-height: 3.07692308em;\n}\n#__vconsole dd,\n#__vconsole dl,\n#__vconsole pre {\n  margin: 0;\n}\n#__vconsole .vc-switch {\n  display: block;\n  position: fixed;\n  right: 0.76923077em;\n  bottom: 0.76923077em;\n  color: #FFF;\n  background-color: var(--VC-BRAND);\n  line-height: 1;\n  font-size: 1.07692308em;\n  padding: 0.61538462em 1.23076923em;\n  z-index: 10000;\n  border-radius: 0.30769231em;\n  box-shadow: 0 0 0.61538462em rgba(0, 0, 0, 0.4);\n}\n#__vconsole .vc-mask {\n  display: none;\n  position: fixed;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background: rgba(0, 0, 0, 0);\n  z-index: 10001;\n  -webkit-transition: background 0.3s;\n  transition: background 0.3s;\n  -webkit-tap-highlight-color: transparent;\n  overflow-y: scroll;\n}\n#__vconsole .vc-panel {\n  display: none;\n  position: fixed;\n  min-height: 85%;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  z-index: 10002;\n  background-color: var(--VC-BG-0);\n  -webkit-transition: -webkit-transform 0.3s;\n  transition: -webkit-transform 0.3s;\n  transition: transform 0.3s;\n  transition: transform 0.3s, -webkit-transform 0.3s;\n  -webkit-transform: translate(0, 100%);\n  transform: translate(0, 100%);\n}\n#__vconsole .vc-tabbar {\n  border-bottom: 1px solid var(--VC-FG-3);\n  overflow-x: auto;\n  height: 3em;\n  width: auto;\n  white-space: nowrap;\n}\n#__vconsole .vc-tabbar .vc-tab {\n  display: inline-block;\n  line-height: 3em;\n  padding: 0 1.15384615em;\n  border-right: 1px solid var(--VC-FG-3);\n  text-decoration: none;\n  color: var(--VC-FG-0);\n  -webkit-tap-highlight-color: transparent;\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-tabbar .vc-tab:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-tabbar .vc-tab.vc-actived {\n  background-color: var(--VC-BG-1);\n}\n#__vconsole .vc-content {\n  background-color: var(--VC-BG-2);\n  overflow-x: hidden;\n  overflow-y: auto;\n  position: absolute;\n  top: 3.07692308em;\n  left: 0;\n  right: 0;\n  bottom: 3.07692308em;\n  -webkit-overflow-scrolling: touch;\n  margin-bottom: constant(safe-area-inset-bottom);\n  margin-bottom: env(safe-area-inset-bottom);\n}\n#__vconsole .vc-content.vc-has-topbar {\n  top: 5.46153846em;\n}\n#__vconsole .vc-topbar {\n  background-color: var(--VC-BG-1);\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-box-orient: horizontal;\n  -webkit-box-direction: normal;\n  -webkit-flex-direction: row;\n  -moz-box-orient: horizontal;\n  -moz-box-direction: normal;\n  -ms-flex-direction: row;\n  flex-direction: row;\n  -webkit-flex-wrap: wrap;\n  -ms-flex-wrap: wrap;\n  flex-wrap: wrap;\n  width: 100%;\n}\n#__vconsole .vc-topbar .vc-toptab {\n  display: none;\n  -webkit-box-flex: 1;\n  -webkit-flex: 1;\n  -moz-box-flex: 1;\n  -ms-flex: 1;\n  flex: 1;\n  line-height: 2.30769231em;\n  padding: 0 1.15384615em;\n  border-bottom: 1px solid var(--VC-FG-3);\n  text-decoration: none;\n  text-align: center;\n  color: var(--VC-FG-0);\n  -webkit-tap-highlight-color: transparent;\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-topbar .vc-toptab.vc-toggle {\n  display: block;\n}\n#__vconsole .vc-topbar .vc-toptab:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-topbar .vc-toptab.vc-actived {\n  border-bottom: 1px solid var(--VC-INDIGO);\n}\n#__vconsole .vc-logbox {\n  display: none;\n  position: relative;\n  min-height: 100%;\n}\n#__vconsole .vc-logbox i {\n  font-style: normal;\n}\n#__vconsole .vc-logbox .vc-log {\n  padding-bottom: 6em;\n  -webkit-tap-highlight-color: transparent;\n}\n#__vconsole .vc-logbox .vc-log:empty:before {\n  content: "Empty";\n  color: var(--VC-FG-1);\n  position: absolute;\n  top: 45%;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  font-size: 1.15384615em;\n  text-align: center;\n}\n#__vconsole .vc-logbox .vc-item {\n  margin: 0;\n  padding: 0.46153846em 0.61538462em;\n  overflow: hidden;\n  line-height: 1.3;\n  border-bottom: 1px solid var(--VC-FG-3);\n  word-break: break-word;\n}\n#__vconsole .vc-logbox .vc-item-info {\n  color: var(--VC-PURPLE);\n}\n#__vconsole .vc-logbox .vc-item-debug {\n  color: var(--VC-YELLOW);\n}\n#__vconsole .vc-logbox .vc-item-warn {\n  color: var(--VC-ORANGE);\n  border-color: var(--VC-WARN-BORDER);\n  background-color: var(--VC-WARN-BG);\n}\n#__vconsole .vc-logbox .vc-item-error {\n  color: var(--VC-RED);\n  border-color: var(--VC-ERROR-BORDER);\n  background-color: var(--VC-ERROR-BG);\n}\n#__vconsole .vc-logbox .vc-log.vc-log-partly .vc-item {\n  display: none;\n}\n#__vconsole .vc-logbox .vc-log.vc-log-partly-log .vc-item-log,\n#__vconsole .vc-logbox .vc-log.vc-log-partly-info .vc-item-info,\n#__vconsole .vc-logbox .vc-log.vc-log-partly-warn .vc-item-warn,\n#__vconsole .vc-logbox .vc-log.vc-log-partly-error .vc-item-error {\n  display: block;\n}\n#__vconsole .vc-logbox .vc-item.hide {\n  display: none;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-content {\n  margin-right: 4.61538462em;\n  display: inline-block;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-repeat {\n  display: inline-block;\n  margin-right: 0.30769231em;\n  padding: 0 6.5px;\n  color: #D7E0EF;\n  background-color: #42597F;\n  border-radius: 8.66666667px;\n}\n#__vconsole .vc-logbox .vc-item.vc-item-error .vc-item-repeat {\n  color: #901818;\n  background-color: var(--VC-RED);\n}\n#__vconsole .vc-logbox .vc-item.vc-item-warn .vc-item-repeat {\n  color: #987D20;\n  background-color: #F4BD02;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code {\n  display: block;\n  white-space: pre-wrap;\n  overflow: auto;\n  position: relative;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-input,\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-output {\n  padding-left: 0.92307692em;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-input:before,\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-output:before {\n  content: "›";\n  position: absolute;\n  top: -0.23076923em;\n  left: 0;\n  font-size: 1.23076923em;\n  color: #6A5ACD;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-output:before {\n  content: "‹";\n}\n#__vconsole .vc-logbox .vc-item .vc-fold {\n  display: block;\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer {\n  display: block;\n  font-style: italic;\n  padding-left: 0.76923077em;\n  position: relative;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer:active {\n  background-color: var(--VC-BG-COLOR-ACTIVE);\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer:before {\n  content: "";\n  position: absolute;\n  top: 0.30769231em;\n  left: 0.15384615em;\n  width: 0;\n  height: 0;\n  border: transparent solid 0.30769231em;\n  border-left-color: var(--VC-FG-1);\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer.vc-toggle:before {\n  top: 0.46153846em;\n  left: 0;\n  border-top-color: var(--VC-FG-1);\n  border-left-color: transparent;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-inner {\n  display: none;\n  margin-left: 0.76923077em;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-inner.vc-toggle {\n  display: block;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-inner .vc-code-key {\n  margin-left: 0.76923077em;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer .vc-code-key {\n  margin-left: 0;\n}\n#__vconsole .vc-logbox .vc-code-key {\n  color: var(--VC-CODE-KEY-FG);\n}\n#__vconsole .vc-logbox .vc-code-private-key {\n  color: var(--VC-CODE-PRIVATE-KEY-FG);\n}\n#__vconsole .vc-logbox .vc-code-function {\n  color: var(--VC-CODE-FUNC-FG);\n  font-style: italic;\n}\n#__vconsole .vc-logbox .vc-code-number,\n#__vconsole .vc-logbox .vc-code-boolean {\n  color: var(--VC-CODE-NUMBER-FG);\n}\n#__vconsole .vc-logbox .vc-code-string {\n  color: var(--VC-CODE-STR-FG);\n}\n#__vconsole .vc-logbox .vc-code-null,\n#__vconsole .vc-logbox .vc-code-undefined {\n  color: var(--VC-CODE-NULL-FG);\n}\n#__vconsole .vc-logbox .vc-cmd {\n  position: absolute;\n  height: 3.07692308em;\n  left: 0;\n  right: 0;\n  bottom: 41px;\n  border-top: 1px solid var(--VC-FG-3);\n  display: block!important;\n}\n#__vconsole .vc-logbox .vc-cmd.vc-filter {\n  bottom: 0;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-input-wrap {\n  display: block;\n  height: 2.15384615em;\n  margin-right: 3.07692308em;\n  padding: 0.46153846em 0.61538462em;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-input {\n  width: 100%;\n  border: none;\n  resize: none;\n  outline: none;\n  padding: 0;\n  font-size: 0.92307692em;\n  background-color: transparent;\n  color: var(--VC-FG-0);\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-input::-webkit-input-placeholder {\n  line-height: 2.15384615em;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-btn {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  width: 3.07692308em;\n  border: none;\n  background-color: var(--VC-BG-0);\n  color: var(--VC-FG-0);\n  outline: none;\n  -webkit-touch-callout: none;\n  font-size: 1em;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-btn:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-prompted {\n  position: fixed;\n  width: 100%;\n  background-color: var(--VC-BG-3);\n  border: 1px solid var(--VC-FG-3);\n  overflow-x: scroll;\n  display: none;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-prompted li {\n  list-style: none;\n  line-height: 30px;\n  padding: 0 0.46153846em;\n  border-bottom: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-group .vc-group-preview {\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-logbox .vc-group .vc-group-preview:active {\n  background-color: var(--VC-BG-COLOR-ACTIVE);\n}\n#__vconsole .vc-logbox .vc-group .vc-group-detail {\n  display: none;\n  padding: 0 0 0.76923077em 1.53846154em;\n  border-bottom: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-group.vc-actived .vc-group-detail {\n  display: block;\n  background-color: var(--VC-BG-1);\n}\n#__vconsole .vc-logbox .vc-group.vc-actived .vc-table-row {\n  background-color: var(--VC-BG-2);\n}\n#__vconsole .vc-logbox .vc-group.vc-actived .vc-group-preview {\n  background-color: var(--VC-BG-1);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row {\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-box-orient: horizontal;\n  -webkit-box-direction: normal;\n  -webkit-flex-direction: row;\n  -moz-box-orient: horizontal;\n  -moz-box-direction: normal;\n  -ms-flex-direction: row;\n  flex-direction: row;\n  -webkit-flex-wrap: wrap;\n  -ms-flex-wrap: wrap;\n  flex-wrap: wrap;\n  overflow: hidden;\n  border-bottom: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row.vc-left-border {\n  border-left: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col {\n  -webkit-box-flex: 1;\n  -webkit-flex: 1;\n  -moz-box-flex: 1;\n  -ms-flex: 1;\n  flex: 1;\n  padding: 0.23076923em 0.30769231em;\n  border-left: 1px solid var(--VC-FG-3);\n  overflow: auto;\n  white-space: pre-wrap;\n  word-break: break-word;\n  /*white-space: nowrap;\n        text-overflow: ellipsis;*/\n  -webkit-overflow-scrolling: touch;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col:first-child {\n  border: none;\n}\n#__vconsole .vc-logbox .vc-table .vc-small .vc-table-col {\n  padding: 0 0.30769231em;\n  font-size: 0.92307692em;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-2 {\n  -webkit-box-flex: 2;\n  -webkit-flex: 2;\n  -moz-box-flex: 2;\n  -ms-flex: 2;\n  flex: 2;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-3 {\n  -webkit-box-flex: 3;\n  -webkit-flex: 3;\n  -moz-box-flex: 3;\n  -ms-flex: 3;\n  flex: 3;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-4 {\n  -webkit-box-flex: 4;\n  -webkit-flex: 4;\n  -moz-box-flex: 4;\n  -ms-flex: 4;\n  flex: 4;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-5 {\n  -webkit-box-flex: 5;\n  -webkit-flex: 5;\n  -moz-box-flex: 5;\n  -ms-flex: 5;\n  flex: 5;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-6 {\n  -webkit-box-flex: 6;\n  -webkit-flex: 6;\n  -moz-box-flex: 6;\n  -ms-flex: 6;\n  flex: 6;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row-error {\n  border-color: var(--VC-ERROR-BORDER);\n  background-color: var(--VC-ERROR-BG);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row-error .vc-table-col {\n  color: var(--VC-RED);\n  border-color: var(--VC-ERROR-BORDER);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-title {\n  font-weight: bold;\n}\n#__vconsole .vc-logbox.vc-actived {\n  display: block;\n}\n#__vconsole .vc-toolbar {\n  border-top: 1px solid var(--VC-FG-3);\n  line-height: 3em;\n  position: absolute;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-box-orient: horizontal;\n  -webkit-box-direction: normal;\n  -webkit-flex-direction: row;\n  -moz-box-orient: horizontal;\n  -moz-box-direction: normal;\n  -ms-flex-direction: row;\n  flex-direction: row;\n}\n#__vconsole .vc-toolbar .vc-tool {\n  display: none;\n  text-decoration: none;\n  color: var(--VC-FG-0);\n  width: 50%;\n  -webkit-box-flex: 1;\n  -webkit-flex: 1;\n  -moz-box-flex: 1;\n  -ms-flex: 1;\n  flex: 1;\n  text-align: center;\n  position: relative;\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-toolbar .vc-tool.vc-toggle,\n#__vconsole .vc-toolbar .vc-tool.vc-global-tool {\n  display: block;\n}\n#__vconsole .vc-toolbar .vc-tool:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-toolbar .vc-tool:after {\n  content: " ";\n  position: absolute;\n  top: 0.53846154em;\n  bottom: 0.53846154em;\n  right: 0;\n  border-left: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-toolbar .vc-tool-last:after {\n  border: none;\n}\n@supports (bottom: constant(safe-area-inset-bottom)) or (bottom: env(safe-area-inset-bottom)) {\n  #__vconsole .vc-toolbar,\n  #__vconsole .vc-switch {\n    bottom: constant(safe-area-inset-bottom);\n    bottom: env(safe-area-inset-bottom);\n  }\n}\n#__vconsole.vc-toggle .vc-switch {\n  display: none;\n}\n#__vconsole.vc-toggle .vc-mask {\n  background: rgba(0, 0, 0, 0.6);\n  display: block;\n}\n#__vconsole.vc-toggle .vc-panel {\n  -webkit-transform: translate(0, 0);\n  transform: translate(0, 0);\n}\n@media (prefers-color-scheme: dark) {\n  #__vconsole:not([data-theme="light"]) {\n    --VC-BG-0: #191919;\n    --VC-BG-1: #1f1f1f;\n    --VC-BG-2: #232323;\n    --VC-BG-3: #2f2f2f;\n    --VC-BG-4: #606060;\n    --VC-BG-5: #2c2c2c;\n    --VC-FG-0: rgba(255, 255, 255, 0.8);\n    --VC-FG-HALF: rgba(255, 255, 255, 0.6);\n    --VC-FG-1: rgba(255, 255, 255, 0.5);\n    --VC-FG-2: rgba(255, 255, 255, 0.3);\n    --VC-FG-3: rgba(255, 255, 255, 0.05);\n    --VC-RED: #fa5151;\n    --VC-ORANGE: #c87d2f;\n    --VC-YELLOW: #c00;\n    --VC-GREEN: #74a800;\n    --VC-LIGHTGREEN: #28b561;\n    --VC-BRAND: #07c160;\n    --VC-BLUE: #10aeff;\n    --VC-INDIGO: #1196ff;\n    --VC-PURPLE: #8183ff;\n    --VC-LINK: #7d90a9;\n    --VC-TEXTGREEN: #259c5c;\n    --VC-FG: white;\n    --VC-BG: black;\n    --VC-BG-COLOR-ACTIVE: #282828;\n    --VC-WARN-BG: #332700;\n    --VC-WARN-BORDER: #664e00;\n    --VC-ERROR-BG: #321010;\n    --VC-ERROR-BORDER: #642020;\n    --VC-DOM-TAG-NAME-COLOR: #5DB0D7;\n    --VC-DOM-ATTRIBUTE-NAME-COLOR: #9BBBDC;\n    --VC-DOM-ATTRIBUTE-VALUE-COLOR: #f29766;\n    --VC-CODE-KEY-FG: #e36eec;\n    --VC-CODE-PRIVATE-KEY-FG: #f4c5f7;\n    --VC-CODE-FUNC-FG: #556af2;\n    --VC-CODE-NUMBER-FG: #9980ff;\n    --VC-CODE-STR-FG: #e93f3b;\n    --VC-CODE-NULL-FG: #808080;\n  }\n}\n#__vconsole[data-theme="dark"] {\n  --VC-BG-0: #191919;\n  --VC-BG-1: #1f1f1f;\n  --VC-BG-2: #232323;\n  --VC-BG-3: #2f2f2f;\n  --VC-BG-4: #606060;\n  --VC-BG-5: #2c2c2c;\n  --VC-FG-0: rgba(255, 255, 255, 0.8);\n  --VC-FG-HALF: rgba(255, 255, 255, 0.6);\n  --VC-FG-1: rgba(255, 255, 255, 0.5);\n  --VC-FG-2: rgba(255, 255, 255, 0.3);\n  --VC-FG-3: rgba(255, 255, 255, 0.05);\n  --VC-RED: #fa5151;\n  --VC-ORANGE: #c87d2f;\n  --VC-YELLOW: #c00;\n  --VC-GREEN: #74a800;\n  --VC-LIGHTGREEN: #28b561;\n  --VC-BRAND: #07c160;\n  --VC-BLUE: #10aeff;\n  --VC-INDIGO: #1196ff;\n  --VC-PURPLE: #8183ff;\n  --VC-LINK: #7d90a9;\n  --VC-TEXTGREEN: #259c5c;\n  --VC-FG: white;\n  --VC-BG: black;\n  --VC-BG-COLOR-ACTIVE: #282828;\n  --VC-WARN-BG: #332700;\n  --VC-WARN-BORDER: #664e00;\n  --VC-ERROR-BG: #321010;\n  --VC-ERROR-BORDER: #642020;\n  --VC-DOM-TAG-NAME-COLOR: #5DB0D7;\n  --VC-DOM-ATTRIBUTE-NAME-COLOR: #9BBBDC;\n  --VC-DOM-ATTRIBUTE-VALUE-COLOR: #f29766;\n  --VC-CODE-KEY-FG: #e36eec;\n  --VC-CODE-PRIVATE-KEY-FG: #f4c5f7;\n  --VC-CODE-FUNC-FG: #556af2;\n  --VC-CODE-NUMBER-FG: #9980ff;\n  --VC-CODE-STR-FG: #e93f3b;\n  --VC-CODE-NULL-FG: #808080;\n}\n', ""]), e.exports = t;
        }, function (e, t) {
          e.exports = '<div id="__vconsole" class="">\n  <div class="vc-switch">vConsole</div>\n  <div class="vc-mask">\n  </div>\n  <div class="vc-panel">\n    <div class="vc-tabbar">\n    </div>\n    <div class="vc-topbar">\n    </div>\n    <div class="vc-content">\n    </div>\n    <div class="vc-toolbar">\n      <a class="vc-tool vc-global-tool vc-tool-last vc-hide">Hide</a>\n    </div>\n  </div>\n</div>';
        }, function (e, t) {
          e.exports = '<a class="vc-tab" data-tab="{{id}}" id="__vc_tab_{{id}}">{{name}}</a>';
        }, function (e, t) {
          e.exports = '<div class="vc-logbox" id="__vc_log_{{id}}">\n  \n</div>';
        }, function (e, t) {
          e.exports = '<a class="vc-toptab vc-topbar-{{pluginID}}{{if (className)}} {{className}}{{/if}}">{{name}}</a>';
        }, function (e, t) {
          e.exports = '<a class="vc-tool vc-tool-{{pluginID}}">{{name}}</a>';
        }, function (e, t) {
          e.exports = '<div id="{{_id}}" class="vc-item vc-item-{{logType}} {{style}}">\n\t<div class="vc-item-content"></div>\n</div>';
        }, function (e, t) {
          e.exports = '<div class="vc-fold">\n  {{if (lineType == \'obj\')}}\n    <i class="vc-fold-outer">{{outer}}</i>\n    <div class="vc-fold-inner"></div>\n  {{else if (lineType == \'value\')}}\n    <i class="vc-code-{{valueType}}">{{value}}</i>\n  {{else if (lineType == \'kv\')}}\n    <i class="vc-code-key{{if (keyType)}} vc-code-{{keyType}}-key{{/if}}">{{key}}</i>: <i class="vc-code-{{valueType}}">{{value}}</i>\n  {{/if}}\n</div>';
        }, function (e, t) {
          e.exports = '<span>\n  <i class="vc-code-key{{if (keyType)}} vc-code-{{keyType}}-key{{/if}}">{{key}}</i>: <i class="vc-code-{{valueType}}">{{value}}</i>\n</span>';
        }, function (module, exports, __webpack_require__) {
          var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__, factory;

          factory = function (_exports, _query, tool, _log, _tabbox_default, _item_code) {
            function _getRequireWildcardCache() {
              if ("function" != typeof WeakMap) return null;
              var e = new WeakMap();
              return _getRequireWildcardCache = function () {
                return e;
              }, e;
            }

            function _interopRequireWildcard(e) {
              if (e && e.__esModule) return e;
              if (null === e || "object" !== _typeof(e) && "function" != typeof e) return {
                default: e
              };

              var t = _getRequireWildcardCache();

              if (t && t.has(e)) return t.get(e);
              var n = {},
                  o = Object.defineProperty && Object.getOwnPropertyDescriptor;

              for (var r in e) if (Object.prototype.hasOwnProperty.call(e, r)) {
                var i = o ? Object.getOwnPropertyDescriptor(e, r) : null;
                i && (i.get || i.set) ? Object.defineProperty(n, r, i) : n[r] = e[r];
              }

              return n.default = e, t && t.set(e, n), n;
            }

            function _interopRequireDefault(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function _createForOfIteratorHelper(e, t) {
              var n;

              if ("undefined" == typeof Symbol || null == e[Symbol.iterator]) {
                if (Array.isArray(e) || (n = _unsupportedIterableToArray(e)) || t && e && "number" == typeof e.length) {
                  n && (e = n);

                  var o = 0,
                      r = function () {};

                  return {
                    s: r,
                    n: function () {
                      return o >= e.length ? {
                        done: !0
                      } : {
                        done: !1,
                        value: e[o++]
                      };
                    },
                    e: function (e) {
                      throw e;
                    },
                    f: r
                  };
                }

                throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
              }

              var i,
                  a = !0,
                  l = !1;
              return {
                s: function () {
                  n = e[Symbol.iterator]();
                },
                n: function () {
                  var e = n.next();
                  return a = e.done, e;
                },
                e: function (e) {
                  l = !0, i = e;
                },
                f: function () {
                  try {
                    a || null == n.return || n.return();
                  } finally {
                    if (l) throw i;
                  }
                }
              };
            }

            function _unsupportedIterableToArray(e, t) {
              if (e) {
                if ("string" == typeof e) return _arrayLikeToArray(e, t);
                var n = Object.prototype.toString.call(e).slice(8, -1);
                return "Object" === n && e.constructor && (n = e.constructor.name), "Map" === n || "Set" === n ? Array.from(e) : "Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n) ? _arrayLikeToArray(e, t) : void 0;
              }
            }

            function _arrayLikeToArray(e, t) {
              (null == t || t > e.length) && (t = e.length);

              for (var n = 0, o = new Array(t); n < t; n++) o[n] = e[n];

              return o;
            }

            function _typeof(e) {
              return (_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
                return typeof e;
              } : function (e) {
                return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
              })(e);
            }

            function _classCallCheck(e, t) {
              if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
            }

            function _defineProperties(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            function _createClass(e, t, n) {
              return t && _defineProperties(e.prototype, t), n && _defineProperties(e, n), e;
            }

            function _get(e, t, n) {
              return (_get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get : function (e, t, n) {
                var o = _superPropBase(e, t);

                if (o) {
                  var r = Object.getOwnPropertyDescriptor(o, t);
                  return r.get ? r.get.call(n) : r.value;
                }
              })(e, t, n || e);
            }

            function _superPropBase(e, t) {
              for (; !Object.prototype.hasOwnProperty.call(e, t) && null !== (e = _getPrototypeOf(e)););

              return e;
            }

            function _inherits(e, t) {
              if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
              e.prototype = Object.create(t && t.prototype, {
                constructor: {
                  value: e,
                  writable: !0,
                  configurable: !0
                }
              }), t && _setPrototypeOf(e, t);
            }

            function _setPrototypeOf(e, t) {
              return (_setPrototypeOf = Object.setPrototypeOf || function (e, t) {
                return e.__proto__ = t, e;
              })(e, t);
            }

            function _createSuper(e) {
              var t = _isNativeReflectConstruct();

              return function () {
                var n,
                    o = _getPrototypeOf(e);

                if (t) {
                  var r = _getPrototypeOf(this).constructor;

                  n = Reflect.construct(o, arguments, r);
                } else n = o.apply(this, arguments);

                return _possibleConstructorReturn(this, n);
              };
            }

            function _possibleConstructorReturn(e, t) {
              return !t || "object" !== _typeof(t) && "function" != typeof t ? _assertThisInitialized(e) : t;
            }

            function _assertThisInitialized(e) {
              if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              return e;
            }

            function _isNativeReflectConstruct() {
              if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
              if (Reflect.construct.sham) return !1;
              if ("function" == typeof Proxy) return !0;

              try {
                return Date.prototype.toString.call(Reflect.construct(Date, [], function () {})), !0;
              } catch (e) {
                return !1;
              }
            }

            function _getPrototypeOf(e) {
              return (_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function (e) {
                return e.__proto__ || Object.getPrototypeOf(e);
              })(e);
            }

            Object.defineProperty(_exports, "__esModule", {
              value: !0
            }), _exports.default = void 0, _query = _interopRequireDefault(_query), tool = _interopRequireWildcard(tool), _log = _interopRequireDefault(_log), _tabbox_default = _interopRequireDefault(_tabbox_default), _item_code = _interopRequireDefault(_item_code);

            var filterText = "",
                checkFilterInLine = function (e) {
              return -1 === e.innerHTML.toUpperCase().indexOf(filterText.toUpperCase());
            },
                VConsoleDefaultTab = function (_VConsoleLogTab) {
              _inherits(VConsoleDefaultTab, _VConsoleLogTab);

              var _super = _createSuper(VConsoleDefaultTab);

              function VConsoleDefaultTab() {
                var e;

                _classCallCheck(this, VConsoleDefaultTab);

                for (var t = arguments.length, n = new Array(t), o = 0; o < t; o++) n[o] = arguments[o];

                return (e = _super.call.apply(_super, [this].concat(n))).tplTabbox = _tabbox_default.default, e;
              }

              return _createClass(VConsoleDefaultTab, [{
                key: "formatLine",
                value: function (e) {
                  return checkFilterInLine(e) ? _query.default.addClass(e, "hide") : _query.default.removeClass(e, "hide"), e;
                }
              }, {
                key: "onReady",
                value: function onReady() {
                  var that = this;

                  _get(_getPrototypeOf(VConsoleDefaultTab.prototype), "onReady", this).call(this);

                  var keyBlackList = ["webkitStorageInfo"];
                  window.winKeys = Object.getOwnPropertyNames(window).sort(), window.keyTypes = {};

                  for (var i = 0; i < winKeys.length; i++) keyBlackList.indexOf(winKeys[i]) > -1 || (keyTypes[winKeys[i]] = _typeof(window[winKeys[i]]));

                  var cacheObj = {},
                      ID_REGEX = /[a-zA-Z_0-9\$\-\u00A2-\uFFFF]/,
                      retrievePrecedingIdentifier = function (e, t, n) {
                    n = n || ID_REGEX;

                    for (var o = [], r = t - 1; r >= 0 && n.test(e[r]); r--) o.push(e[r]);

                    if (0 == o.length) {
                      n = /\./;

                      for (var i = t - 1; i >= 0 && n.test(e[i]); i--) o.push(e[i]);
                    }

                    if (0 === o.length) {
                      var a = e.match(/[\(\)\[\]\{\}]/gi) || [];
                      return a[a.length - 1];
                    }

                    return o.reverse().join("");
                  },
                      moveCursorToPos = function (e, t) {
                    e.setSelectionRange && e.setSelectionRange(t, t);
                  },
                      $input = _query.default.one(".vc-cmd-input");

                  _query.default.bind($input, "keyup", function (e) {
                    var isDeleteKeyCode = 8 === e.keyCode || 46 === e.keyCode,
                        $prompted = _query.default.one(".vc-cmd-prompted");

                    $prompted.style.display = "none", $prompted.innerHTML = "";
                    var tempValue = this.value,
                        value = retrievePrecedingIdentifier(this.value, this.value.length);

                    if (value && value.length > 0) {
                      if (/\(/.test(value) && !isDeleteKeyCode) return $input.value += ")", void moveCursorToPos($input, $input.value.length - 1);
                      if (/\[/.test(value) && !isDeleteKeyCode) return $input.value += "]", void moveCursorToPos($input, $input.value.length - 1);
                      if (/\{/.test(value) && !isDeleteKeyCode) return $input.value += "}", void moveCursorToPos($input, $input.value.length - 1);

                      if ("." === value) {
                        var key = retrievePrecedingIdentifier(tempValue, tempValue.length - 1);
                        if (!cacheObj[key]) try {
                          cacheObj[key] = Object.getOwnPropertyNames(eval("(" + key + ")")).sort();
                        } catch (e) {}

                        try {
                          for (var _i3 = 0; _i3 < cacheObj[key].length; _i3++) {
                            var $li = document.createElement("li"),
                                _key = cacheObj[key][_i3];
                            $li.innerHTML = _key, $li.onclick = function () {
                              $input.value = "", $input.value = tempValue + this.innerHTML, $prompted.style.display = "none";
                            }, $prompted.appendChild($li);
                          }
                        } catch (e) {}
                      } else if ("." !== value.substring(value.length - 1) && value.indexOf(".") < 0) {
                        for (var _i4 = 0; _i4 < winKeys.length; _i4++) if (winKeys[_i4].toLowerCase().indexOf(value.toLowerCase()) >= 0) {
                          var _$li = document.createElement("li");

                          _$li.innerHTML = winKeys[_i4], _$li.onclick = function () {
                            $input.value = "", $input.value = this.innerHTML, "function" == keyTypes[this.innerHTML] && ($input.value += "()"), $prompted.style.display = "none";
                          }, $prompted.appendChild(_$li);
                        }
                      } else {
                        var arr = value.split(".");

                        if (cacheObj[arr[0]]) {
                          cacheObj[arr[0]].sort();

                          for (var _i5 = 0; _i5 < cacheObj[arr[0]].length; _i5++) {
                            var _$li2 = document.createElement("li"),
                                _key3 = cacheObj[arr[0]][_i5];

                            _key3.indexOf(arr[1]) >= 0 && (_$li2.innerHTML = _key3, _$li2.onclick = function () {
                              $input.value = "", $input.value = tempValue + this.innerHTML, $prompted.style.display = "none";
                            }, $prompted.appendChild(_$li2));
                          }
                        }
                      }

                      if ($prompted.children.length > 0) {
                        var m = Math.min(200, 31 * $prompted.children.length);
                        $prompted.style.display = "block", $prompted.style.height = m + "px", $prompted.style.marginTop = -m + "px";
                      }
                    } else $prompted.style.display = "none";
                  }), _query.default.bind(_query.default.one(".vc-cmd", this.$tabbox), "submit", function (e) {
                    e.preventDefault();

                    var t = _query.default.one(".vc-cmd-input", e.target),
                        n = t.value;

                    t.value = "", "" !== n && that.evalCommand(n);

                    var o = _query.default.one(".vc-cmd-prompted");

                    o && (o.style.display = "none");
                  }), _query.default.bind(_query.default.one(".vc-cmd.vc-filter", this.$tabbox), "submit", function (e) {
                    e.preventDefault();

                    var t = _query.default.one(".vc-cmd.vc-filter .vc-cmd-input", e.target);

                    filterText = t.value, _query.default.all(".vc-log>.vc-item").forEach(function (e) {
                      checkFilterInLine(e) ? _query.default.addClass(e, "hide") : _query.default.removeClass(e, "hide");
                    });
                  });
                  var code = "";
                  code += "if (!!window) {", code += "window.__vConsole_cmd_result = undefined;", code += "window.__vConsole_cmd_error = false;", code += "}";

                  var scriptList = document.getElementsByTagName("script"),
                      nonce = "",
                      _iterator = _createForOfIteratorHelper(scriptList),
                      _step;

                  try {
                    for (_iterator.s(); !(_step = _iterator.n()).done;) {
                      var _script = _step.value;

                      if (_script.nonce) {
                        nonce = _script.nonce;
                        break;
                      }
                    }
                  } catch (e) {
                    _iterator.e(e);
                  } finally {
                    _iterator.f();
                  }

                  var script = document.createElement("SCRIPT");
                  script.innerHTML = code, script.setAttribute("nonce", nonce), document.documentElement.appendChild(script), document.documentElement.removeChild(script);
                }
              }, {
                key: "mockConsole",
                value: function () {
                  _get(_getPrototypeOf(VConsoleDefaultTab.prototype), "mockConsole", this).call(this);

                  var e = this;
                  tool.isFunction(window.onerror) && (this.windowOnError = window.onerror), window.onerror = function (t, n, o, r, i) {
                    var a = t;
                    n && (a += "\n" + n.replace(location.origin, "")), (o || r) && (a += ":" + o + ":" + r);
                    var l = !!i && !!i.stack && i.stack.toString() || "";
                    e.printLog({
                      logType: "error",
                      logs: [a, l],
                      noOrigin: !0
                    }), tool.isFunction(e.windowOnError) && e.windowOnError.call(window, t, n, o, r, i);
                  };
                }
              }, {
                key: "evalCommand",
                value: function (e) {
                  this.printLog({
                    logType: "log",
                    content: _query.default.render(_item_code.default, {
                      content: e,
                      type: "input"
                    }),
                    style: ""
                  });
                  var t,
                      n = void 0;

                  try {
                    n = eval.call(window, "(" + e + ")");
                  } catch (t) {
                    try {
                      n = eval.call(window, e);
                    } catch (e) {}
                  }

                  tool.isArray(n) || tool.isObject(n) ? t = this.getFoldedLine(n) : (tool.isNull(n) ? n = "null" : tool.isUndefined(n) ? n = "undefined" : tool.isFunction(n) ? n = "function()" : tool.isString(n) && (n = '"' + n + '"'), t = _query.default.render(_item_code.default, {
                    content: n,
                    type: "output"
                  })), this.printLog({
                    logType: "log",
                    content: t,
                    style: ""
                  }), window.winKeys = Object.getOwnPropertyNames(window).sort();
                }
              }]), VConsoleDefaultTab;
            }(_log.default),
                _default = VConsoleDefaultTab;

            _exports.default = _default, module.exports = exports.default;
          }, __WEBPACK_AMD_DEFINE_ARRAY__ = [exports, __webpack_require__(1), __webpack_require__(0), __webpack_require__(3), __webpack_require__(22), __webpack_require__(23)], void 0 === (__WEBPACK_AMD_DEFINE_RESULT__ = "function" == typeof (__WEBPACK_AMD_DEFINE_FACTORY__ = factory) ? __WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__) : __WEBPACK_AMD_DEFINE_FACTORY__) || (module.exports = __WEBPACK_AMD_DEFINE_RESULT__);
        }, function (e, t) {
          e.exports = '<div>\n  <div class="vc-log"></div>\n  <form class="vc-cmd">\n    <button class="vc-cmd-btn" type="submit">OK</button>\n    <ul class=\'vc-cmd-prompted\'></ul>\n    <div class="vc-cmd-input-wrap">\n      <textarea class="vc-cmd-input" placeholder="command..."></textarea>\n    </div>\n  </form>\n  <form class="vc-cmd vc-filter">\n    <button class="vc-cmd-btn" type="submit">filter</button>\n    <ul class=\'vc-cmd-prompted\'></ul>\n    <div class="vc-cmd-input-wrap">\n      <textarea class="vc-cmd-input" placeholder="filter..."></textarea>\n    </div>\n  </form>\n</div>\n';
        }, function (e, t) {
          e.exports = '<pre class="vc-item-code vc-item-code-{{type}}">{{content}}</pre>';
        }, function (e, t, n) {
          var o, r, i;

          function a(e) {
            return (a = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
              return typeof e;
            } : function (e) {
              return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
            })(e);
          }

          r = [t, n(3), n(25)], void 0 === (i = "function" == typeof (o = function (n, o, r) {
            function i(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function l(e, t) {
              if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
            }

            function c(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            function s(e, t, n) {
              return (s = "undefined" != typeof Reflect && Reflect.get ? Reflect.get : function (e, t, n) {
                var o = function (e, t) {
                  for (; !Object.prototype.hasOwnProperty.call(e, t) && null !== (e = v(e)););

                  return e;
                }(e, t);

                if (o) {
                  var r = Object.getOwnPropertyDescriptor(o, t);
                  return r.get ? r.get.call(n) : r.value;
                }
              })(e, t, n || e);
            }

            function u(e, t) {
              return (u = Object.setPrototypeOf || function (e, t) {
                return e.__proto__ = t, e;
              })(e, t);
            }

            function d(e) {
              var t = function () {
                if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
                if (Reflect.construct.sham) return !1;
                if ("function" == typeof Proxy) return !0;

                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function () {})), !0;
                } catch (e) {
                  return !1;
                }
              }();

              return function () {
                var n,
                    o = v(e);

                if (t) {
                  var r = v(this).constructor;
                  n = Reflect.construct(o, arguments, r);
                } else n = o.apply(this, arguments);

                return f(this, n);
              };
            }

            function f(e, t) {
              return !t || "object" !== a(t) && "function" != typeof t ? function (e) {
                if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return e;
              }(e) : t;
            }

            function v(e) {
              return (v = Object.setPrototypeOf ? Object.getPrototypeOf : function (e) {
                return e.__proto__ || Object.getPrototypeOf(e);
              })(e);
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, o = i(o), r = i(r);

            var p = function (e) {
              !function (e, t) {
                if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
                e.prototype = Object.create(t && t.prototype, {
                  constructor: {
                    value: e,
                    writable: !0,
                    configurable: !0
                  }
                }), t && u(e, t);
              }(a, e);
              var t,
                  n,
                  i = d(a);

              function a() {
                var e;
                l(this, a);

                for (var t = arguments.length, n = new Array(t), o = 0; o < t; o++) n[o] = arguments[o];

                return (e = i.call.apply(i, [this].concat(n))).tplTabbox = r.default, e.allowUnformattedLog = !1, e;
              }

              return t = a, (n = [{
                key: "onInit",
                value: function () {
                  s(v(a.prototype), "onInit", this).call(this), this.printSystemInfo();
                }
              }, {
                key: "printSystemInfo",
                value: function () {
                  var e = navigator.userAgent,
                      t = "";
                  console.info("[system]", "Location:", location.href);
                  var n = e.match(/(ipod).*\s([\d_]+)/i),
                      o = e.match(/(ipad).*\s([\d_]+)/i),
                      r = e.match(/(iphone)\sos\s([\d_]+)/i),
                      i = e.match(/(android)\s([\d\.]+)/i);
                  t = "Unknown", i ? t = "Android " + i[2] : r ? t = "iPhone, iOS " + r[2].replace(/_/g, ".") : o ? t = "iPad, iOS " + o[2].replace(/_/g, ".") : n && (t = "iPod, iOS " + n[2].replace(/_/g, "."));
                  var a = t,
                      l = e.match(/MicroMessenger\/([\d\.]+)/i);
                  t = "Unknown", l && l[1] ? (a += ", WeChat " + (t = l[1]), console.info("[system]", "System:", a)) : console.info("[system]", "System:", a);
                  var c = e.toLowerCase().match(/ nettype\/([^ ]+)/g);
                  t = "Unknown", c && c[0] && (t = (c = c[0].split("/"))[1], console.info("[system]", "Network:", t)), console.info("[system]", "UA:", e), setTimeout(function () {
                    var e = window.performance || window.msPerformance || window.webkitPerformance;

                    if (e && e.timing) {
                      var t = e.timing;
                      t.navigationStart && console.info("[system]", "navigationStart:", t.navigationStart), t.navigationStart && t.domainLookupStart && console.info("[system]", "navigation:", t.domainLookupStart - t.navigationStart + "ms"), t.domainLookupEnd && t.domainLookupStart && console.info("[system]", "dns:", t.domainLookupEnd - t.domainLookupStart + "ms"), t.connectEnd && t.connectStart && (t.connectEnd && t.secureConnectionStart ? console.info("[system]", "tcp (ssl):", t.connectEnd - t.connectStart + "ms (" + (t.connectEnd - t.secureConnectionStart) + "ms)") : console.info("[system]", "tcp:", t.connectEnd - t.connectStart + "ms")), t.responseStart && t.requestStart && console.info("[system]", "request:", t.responseStart - t.requestStart + "ms"), t.responseEnd && t.responseStart && console.info("[system]", "response:", t.responseEnd - t.responseStart + "ms"), t.domComplete && t.domLoading && (t.domContentLoadedEventStart && t.domLoading ? console.info("[system]", "domComplete (domLoaded):", t.domComplete - t.domLoading + "ms (" + (t.domContentLoadedEventStart - t.domLoading) + "ms)") : console.info("[system]", "domComplete:", t.domComplete - t.domLoading + "ms")), t.loadEventEnd && t.loadEventStart && console.info("[system]", "loadEvent:", t.loadEventEnd - t.loadEventStart + "ms"), t.navigationStart && t.loadEventEnd && console.info("[system]", "total (DOM):", t.loadEventEnd - t.navigationStart + "ms (" + (t.domComplete - t.navigationStart) + "ms)");
                    }
                  }, 0);
                }
              }]) && c(t.prototype, n), a;
            }(o.default);

            n.default = p, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t) {
          e.exports = '<div>\n  <div class="vc-log"></div>\n</div>';
        }, function (e, t, n) {
          var o, r, i;

          function a(e) {
            return (a = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
              return typeof e;
            } : function (e) {
              return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
            })(e);
          }

          r = [t, n(1), n(0), n(2), n(27), n(28), n(29)], void 0 === (i = "function" == typeof (o = function (n, o, r, i, l, c, s) {
            function u() {
              if ("function" != typeof WeakMap) return null;
              var e = new WeakMap();
              return u = function () {
                return e;
              }, e;
            }

            function d(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function f(e, t) {
              var n;

              if ("undefined" == typeof Symbol || null == e[Symbol.iterator]) {
                if (Array.isArray(e) || (n = function (e, t) {
                  if (e) {
                    if ("string" == typeof e) return v(e, t);
                    var n = Object.prototype.toString.call(e).slice(8, -1);
                    return "Object" === n && e.constructor && (n = e.constructor.name), "Map" === n || "Set" === n ? Array.from(e) : "Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n) ? v(e, t) : void 0;
                  }
                }(e)) || t && e && "number" == typeof e.length) {
                  n && (e = n);

                  var o = 0,
                      r = function () {};

                  return {
                    s: r,
                    n: function () {
                      return o >= e.length ? {
                        done: !0
                      } : {
                        done: !1,
                        value: e[o++]
                      };
                    },
                    e: function (e) {
                      throw e;
                    },
                    f: r
                  };
                }

                throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
              }

              var i,
                  a = !0,
                  l = !1;
              return {
                s: function () {
                  n = e[Symbol.iterator]();
                },
                n: function () {
                  var e = n.next();
                  return a = e.done, e;
                },
                e: function (e) {
                  l = !0, i = e;
                },
                f: function () {
                  try {
                    a || null == n.return || n.return();
                  } finally {
                    if (l) throw i;
                  }
                }
              };
            }

            function v(e, t) {
              (null == t || t > e.length) && (t = e.length);

              for (var n = 0, o = new Array(t); n < t; n++) o[n] = e[n];

              return o;
            }

            function p(e, t) {
              if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
            }

            function b(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            function h(e, t) {
              return (h = Object.setPrototypeOf || function (e, t) {
                return e.__proto__ = t, e;
              })(e, t);
            }

            function m(e) {
              var t = function () {
                if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
                if (Reflect.construct.sham) return !1;
                if ("function" == typeof Proxy) return !0;

                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function () {})), !0;
                } catch (e) {
                  return !1;
                }
              }();

              return function () {
                var n,
                    o = y(e);

                if (t) {
                  var r = y(this).constructor;
                  n = Reflect.construct(o, arguments, r);
                } else n = o.apply(this, arguments);

                return g(this, n);
              };
            }

            function g(e, t) {
              return !t || "object" !== a(t) && "function" != typeof t ? function (e) {
                if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return e;
              }(e) : t;
            }

            function y(e) {
              return (y = Object.setPrototypeOf ? Object.getPrototypeOf : function (e) {
                return e.__proto__ || Object.getPrototypeOf(e);
              })(e);
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, o = d(o), r = function (e) {
              if (e && e.__esModule) return e;
              if (null === e || "object" !== a(e) && "function" != typeof e) return {
                default: e
              };
              var t = u();
              if (t && t.has(e)) return t.get(e);
              var n = {},
                  o = Object.defineProperty && Object.getOwnPropertyDescriptor;

              for (var r in e) if (Object.prototype.hasOwnProperty.call(e, r)) {
                var i = o ? Object.getOwnPropertyDescriptor(e, r) : null;
                i && (i.get || i.set) ? Object.defineProperty(n, r, i) : n[r] = e[r];
              }

              return n.default = e, t && t.set(e, n), n;
            }(r), i = d(i), l = d(l), c = d(c), s = d(s);

            var _ = function (e) {
              !function (e, t) {
                if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
                e.prototype = Object.create(t && t.prototype, {
                  constructor: {
                    value: e,
                    writable: !0,
                    configurable: !0
                  }
                }), t && h(e, t);
              }(u, e);
              var t,
                  n,
                  a = m(u);

              function u() {
                var e;
                p(this, u);

                for (var t = arguments.length, n = new Array(t), r = 0; r < t; r++) n[r] = arguments[r];

                return (e = a.call.apply(a, [this].concat(n))).$tabbox = o.default.render(l.default, {}), e.$header = null, e.reqList = {}, e.domList = {}, e.isReady = !1, e.isShow = !1, e.isInBottom = !0, e._open = void 0, e._send = void 0, e._setRequestHeader = void 0, e.mockAjax(), e.mockFetch(), e;
              }

              return t = u, (n = [{
                key: "onRenderTab",
                value: function (e) {
                  e(this.$tabbox);
                }
              }, {
                key: "onAddTool",
                value: function (e) {
                  var t = this;
                  e([{
                    name: "Clear",
                    global: !1,
                    onClick: function (e) {
                      t.clearLog();
                    }
                  }]);
                }
              }, {
                key: "onReady",
                value: function () {
                  var e = this;
                  e.isReady = !0, this.renderHeader(), o.default.delegate(o.default.one(".vc-log", this.$tabbox), "click", ".vc-group-preview", function (t) {
                    var n = this.dataset.reqid,
                        r = this.parentNode;
                    o.default.hasClass(r, "vc-actived") ? (o.default.removeClass(r, "vc-actived"), e.updateRequest(n, {
                      actived: !1
                    })) : (o.default.addClass(r, "vc-actived"), e.updateRequest(n, {
                      actived: !0
                    })), t.preventDefault();
                  });
                  var t = o.default.one(".vc-content");

                  for (var n in o.default.bind(t, "scroll", function (n) {
                    e.isShow && (t.scrollTop + t.offsetHeight >= t.scrollHeight ? e.isInBottom = !0 : e.isInBottom = !1);
                  }), e.reqList) e.updateRequest(n, {});
                }
              }, {
                key: "onRemove",
                value: function () {
                  window.XMLHttpRequest && (window.XMLHttpRequest.prototype.open = this._open, window.XMLHttpRequest.prototype.send = this._send, window.XMLHttpRequest.prototype.setRequestHeader = this._setRequestHeader, this._open = void 0, this._send = void 0, this._setRequestHeader = void 0);
                }
              }, {
                key: "onShow",
                value: function () {
                  this.isShow = !0, 1 == this.isInBottom && this.scrollToBottom();
                }
              }, {
                key: "onHide",
                value: function () {
                  this.isShow = !1;
                }
              }, {
                key: "onShowConsole",
                value: function () {
                  1 == this.isInBottom && this.scrollToBottom();
                }
              }, {
                key: "scrollToBottom",
                value: function () {
                  var e = o.default.one(".vc-content");
                  e.scrollTop = e.scrollHeight - e.offsetHeight;
                }
              }, {
                key: "clearLog",
                value: function () {
                  for (var e in this.reqList = {}, this.domList) this.domList[e].parentNode.removeChild(this.domList[e]), this.domList[e] = void 0;

                  this.domList = {}, this.renderHeader();
                }
              }, {
                key: "renderHeader",
                value: function () {
                  var e = Object.keys(this.reqList).length,
                      t = o.default.render(c.default, {
                    count: e
                  }),
                      n = o.default.one(".vc-log", this.$tabbox);
                  this.$header ? this.$header.parentNode.replaceChild(t, this.$header) : n.parentNode.insertBefore(t, n), this.$header = t;
                }
              }, {
                key: "updateRequest",
                value: function (e, t) {
                  var n = Object.keys(this.reqList).length,
                      i = this.reqList[e] || {};

                  for (var a in t) i[a] = t[a];

                  if (this.reqList[e] = i, this.isReady) {
                    var l = {
                      id: e,
                      name: i.name,
                      url: i.url,
                      status: i.status,
                      method: i.method || "-",
                      costTime: i.costTime > 0 ? i.costTime + "ms" : "-",
                      header: i.header || null,
                      requestHeader: i.requestHeader || null,
                      getData: i.getData || null,
                      postData: i.postData || null,
                      response: null,
                      actived: !!i.actived
                    };

                    switch (i.responseType) {
                      case "":
                      case "text":
                        if (r.isString(i.response)) try {
                          l.response = JSON.parse(i.response), l.response = JSON.stringify(l.response, null, 1), l.response = r.htmlEncode(l.response);
                        } catch (e) {
                          l.response = r.htmlEncode(i.response);
                        } else void 0 !== i.response && (l.response = Object.prototype.toString.call(i.response));
                        break;

                      case "json":
                        void 0 !== i.response && (l.response = JSON.stringify(i.response, null, 1), l.response = r.htmlEncode(l.response));
                        break;

                      case "blob":
                      case "document":
                      case "arraybuffer":
                      default:
                        void 0 !== i.response && (l.response = Object.prototype.toString.call(i.response));
                    }

                    0 == i.readyState || 1 == i.readyState ? l.status = "Pending" : 2 == i.readyState || 3 == i.readyState ? l.status = "Loading" : 4 == i.readyState || (l.status = "Unknown");
                    var c = o.default.render(s.default, l),
                        u = this.domList[e];
                    i.status >= 400 && o.default.addClass(o.default.one(".vc-group-preview", c), "vc-table-row-error"), u ? u.parentNode.replaceChild(c, u) : o.default.one(".vc-log", this.$tabbox).insertAdjacentElement("beforeend", c), this.domList[e] = c, Object.keys(this.reqList).length != n && this.renderHeader(), this.isInBottom && this.scrollToBottom();
                  }
                }
              }, {
                key: "mockAjax",
                value: function () {
                  if (window.XMLHttpRequest) {
                    var e = this,
                        t = window.XMLHttpRequest.prototype.open,
                        n = window.XMLHttpRequest.prototype.send,
                        o = window.XMLHttpRequest.prototype.setRequestHeader;
                    e._open = t, e._send = n, e._setRequestHeader = o, window.XMLHttpRequest.prototype.open = function () {
                      var n = this,
                          o = [].slice.call(arguments),
                          r = o[0],
                          i = o[1],
                          a = e.getUniqueID(),
                          l = null;
                      n._requestID = a, n._method = r, n._url = i;

                      var c = n.onreadystatechange || function () {},
                          s = function () {
                        var t = e.reqList[a] || {};
                        if (t.readyState = n.readyState, t.status = 0, n.readyState > 1 && (t.status = n.status), t.responseType = n.responseType, 0 == n.readyState) t.startTime || (t.startTime = +new Date());else if (1 == n.readyState) t.startTime || (t.startTime = +new Date());else if (2 == n.readyState) {
                          t.header = {};

                          for (var o = n.getAllResponseHeaders() || "", r = o.split("\n"), i = 0; i < r.length; i++) {
                            var s = r[i];

                            if (s) {
                              var u = s.split(": "),
                                  d = u[0],
                                  f = u.slice(1).join(": ");
                              t.header[d] = f;
                            }
                          }
                        } else 3 == n.readyState || (4 == n.readyState ? (clearInterval(l), t.endTime = +new Date(), t.costTime = t.endTime - (t.startTime || t.endTime), t.response = n.response) : clearInterval(l));
                        return n._noVConsole || e.updateRequest(a, t), c.apply(n, arguments);
                      };

                      n.onreadystatechange = s;
                      var u = -1;
                      return l = setInterval(function () {
                        u != n.readyState && (u = n.readyState, s.call(n));
                      }, 10), t.apply(n, o);
                    }, window.XMLHttpRequest.prototype.setRequestHeader = function () {
                      var t = this,
                          n = [].slice.call(arguments),
                          r = e.reqList[t._requestID];
                      return r && (r.requestHeader || (r.requestHeader = {}), r.requestHeader[n[0]] = n[1]), o.apply(t, n);
                    }, window.XMLHttpRequest.prototype.send = function () {
                      var t = this,
                          o = [].slice.call(arguments),
                          i = o[0],
                          a = e.reqList[t._requestID] || {};
                      a.method = t._method ? t._method.toUpperCase() : "GET";
                      var l = t._url ? t._url.split("?") : [];

                      if (a.url = t._url || "", a.name = l.shift() || "", a.name = a.name.replace(new RegExp("[/]*$"), "").split("/").pop() || "", l.length > 0) {
                        a.name += "?" + l, a.getData = {};
                        var c,
                            s = f(l = (l = l.join("?")).split("&"));

                        try {
                          for (s.s(); !(c = s.n()).done;) {
                            var u = c.value;
                            u = u.split("="), a.getData[u[0]] = decodeURIComponent(u[1]);
                          }
                        } catch (e) {
                          s.e(e);
                        } finally {
                          s.f();
                        }
                      }

                      if ("POST" == a.method) if (r.isString(i)) {
                        var d = i.split("&");
                        a.postData = {};
                        var v,
                            p = f(d);

                        try {
                          for (p.s(); !(v = p.n()).done;) {
                            var b = v.value;
                            b = b.split("="), a.postData[b[0]] = b[1];
                          }
                        } catch (e) {
                          p.e(e);
                        } finally {
                          p.f();
                        }
                      } else r.isPlainObject(i) ? a.postData = i : a.postData = "[object Object]";
                      return t._noVConsole || e.updateRequest(t._requestID, a), n.apply(t, o);
                    };
                  }
                }
              }, {
                key: "mockFetch",
                value: function () {
                  var e = window.fetch;

                  if (e) {
                    var t = this;

                    window.fetch = function (n, o) {
                      var i = t.getUniqueID();
                      t.reqList[i] = {};
                      var a = t.reqList[i] || {},
                          l = [],
                          c = "",
                          s = "GET",
                          u = null;

                      if (r.isString(n) ? (s = o.method || "GET", c = n, u = o.headers) : (s = n.method || "GET", c = n.url, u = n.headers), l = c.split("?"), a.id = i, a.method = s, a.requestHeader = u, a.url = c, a.name = l.shift() || "", a.name = a.name.replace(new RegExp("[/]*$"), "").split("/").pop() || "", l.length > 0) {
                        a.name += "?" + l, a.getData = {};
                        var d,
                            v = f(l = (l = l.join("?")).split("&"));

                        try {
                          for (v.s(); !(d = v.n()).done;) {
                            var p = d.value;
                            p = p.split("="), a.getData[p[0]] = p[1];
                          }
                        } catch (e) {
                          v.e(e);
                        } finally {
                          v.f();
                        }
                      }

                      if ("POST" === a.method) if (r.isString(n)) {
                        if (r.isString(o.body)) {
                          var b = o.body.split("&");
                          a.postData = {};
                          var h,
                              m = f(b);

                          try {
                            for (m.s(); !(h = m.n()).done;) {
                              var g = h.value;
                              g = g.split("="), a.postData[g[0]] = g[1];
                            }
                          } catch (e) {
                            m.e(e);
                          } finally {
                            m.f();
                          }
                        } else r.isPlainObject(o.body) ? a.postData = o.body : a.postData = "[object Object]";
                      } else a.postData = "[object Object]";
                      return a.startTime || (a.startTime = +new Date()), e(c, o).then(function (e) {
                        return e.clone().json().then(function (t) {
                          a.endTime = +new Date(), a.costTime = a.endTime - (a.startTime || a.endTime), a.status = e.status, a.header = {};
                          var n,
                              o = f(e.headers.entries());

                          try {
                            for (o.s(); !(n = o.n()).done;) {
                              var r = n.value;
                              a.header[r[0]] = r[1];
                            }
                          } catch (e) {
                            o.e(e);
                          } finally {
                            o.f();
                          }

                          a.response = t, a.readyState = 4;
                          var i = e.headers.get("content-type");
                          return a.responseType = i.includes("application/json") ? "json" : i.includes("text/html") ? "text" : "", t;
                        }), t.updateRequest(i, a), e;
                      });
                    };
                  }
                }
              }, {
                key: "getUniqueID",
                value: function () {
                  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (e) {
                    var t = 16 * Math.random() | 0;
                    return ("x" == e ? t : 3 & t | 8).toString(16);
                  });
                }
              }]) && b(t.prototype, n), u;
            }(i.default);

            n.default = _, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t) {
          e.exports = '<div class="vc-table">\n  <div class="vc-log"></div>\n</div>';
        }, function (e, t) {
          e.exports = '<dl class="vc-table-row">\n  <dd class="vc-table-col vc-table-col-4">Name {{if (count > 0)}}({{count}}){{/if}}</dd>\n  <dd class="vc-table-col">Method</dd>\n  <dd class="vc-table-col">Status</dd>\n  <dd class="vc-table-col">Time</dd>\n</dl>';
        }, function (e, t) {
          e.exports = '<div class="vc-group {{actived ? \'vc-actived\' : \'\'}}">\n  <dl class="vc-table-row vc-group-preview" data-reqid="{{id}}">\n    <dd class="vc-table-col vc-table-col-4">{{name}}</dd>\n    <dd class="vc-table-col">{{method}}</dd>\n    <dd class="vc-table-col">{{status}}</dd>\n    <dd class="vc-table-col">{{costTime}}</dd>\n  </dl>\n  <div class="vc-group-detail">\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">General</dt>\n      </dl>\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">URL</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{url}}</div>\n      </div>\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">Method</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{method}}</div>\n      </div>\n    </div>\n    {{if (header !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Response Headers</dt>\n      </dl>\n      {{for (var key in header)}}\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">{{key}}</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{header[key]}}</div>\n      </div>\n      {{/for}}\n    </div>\n    {{/if}}\n    {{if (requestHeader !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Request Headers</dt>\n      </dl>\n      {{for (var key in requestHeader)}}\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">{{key}}</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{requestHeader[key]}}</div>\n      </div>\n      {{/for}}\n    </div>\n    {{/if}}\n    {{if (getData !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Query String Parameters</dt>\n      </dl>\n      {{for (var key in getData)}}\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">{{key}}</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{getData[key]}}</div>\n      </div>\n      {{/for}}\n    </div>\n    {{/if}}\n    {{if (postData !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Request Payload</dt>\n      </dl>\n      {{if (typeof postData === \'string\')}}\n        <div class="vc-table-row vc-left-border vc-small">\n          <pre class="vc-table-col">{{postData}}</pre>\n        </div>\n      {{else}}\n        {{for (var key in postData)}}\n        <div class="vc-table-row vc-left-border vc-small">\n          <div class="vc-table-col vc-table-col-2">{{key}}</div>\n          <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{postData[key]}}</div>\n        </div>\n        {{/for}}\n      {{/if}}\n    </div>\n    {{/if}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Response</dt>\n      </dl>\n      <div class="vc-table-row vc-left-border vc-small">\n        <pre class="vc-table-col vc-max-height vc-min-height">{{response || \'\'}}</pre>\n      </div>\n    </div>\n  </div>\n</div>';
        }, function (e, t, n) {
          var o, r, i;

          function a(e) {
            return (a = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
              return typeof e;
            } : function (e) {
              return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
            })(e);
          }

          r = [t, n(31), n(32), n(2), n(34), n(35), n(0), n(1)], void 0 === (i = "function" == typeof (o = function (n, o, r, i, l, c, s, u) {
            function d() {
              if ("function" != typeof WeakMap) return null;
              var e = new WeakMap();
              return d = function () {
                return e;
              }, e;
            }

            function f(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function v(e, t) {
              if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
            }

            function p(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            function b(e, t) {
              return (b = Object.setPrototypeOf || function (e, t) {
                return e.__proto__ = t, e;
              })(e, t);
            }

            function h(e) {
              var t = function () {
                if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
                if (Reflect.construct.sham) return !1;
                if ("function" == typeof Proxy) return !0;

                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function () {})), !0;
                } catch (e) {
                  return !1;
                }
              }();

              return function () {
                var n,
                    o = y(e);

                if (t) {
                  var r = y(this).constructor;
                  n = Reflect.construct(o, arguments, r);
                } else n = o.apply(this, arguments);

                return m(this, n);
              };
            }

            function m(e, t) {
              return !t || "object" !== a(t) && "function" != typeof t ? g(e) : t;
            }

            function g(e) {
              if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              return e;
            }

            function y(e) {
              return (y = Object.setPrototypeOf ? Object.getPrototypeOf : function (e) {
                return e.__proto__ || Object.getPrototypeOf(e);
              })(e);
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, o = f(o), i = f(i), l = f(l), c = f(c), s = function (e) {
              if (e && e.__esModule) return e;
              if (null === e || "object" !== a(e) && "function" != typeof e) return {
                default: e
              };
              var t = d();
              if (t && t.has(e)) return t.get(e);
              var n = {},
                  o = Object.defineProperty && Object.getOwnPropertyDescriptor;

              for (var r in e) if (Object.prototype.hasOwnProperty.call(e, r)) {
                var i = o ? Object.getOwnPropertyDescriptor(e, r) : null;
                i && (i.get || i.set) ? Object.defineProperty(n, r, i) : n[r] = e[r];
              }

              return n.default = e, t && t.set(e, n), n;
            }(s), u = f(u);

            var _ = function (e) {
              !function (e, t) {
                if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
                e.prototype = Object.create(t && t.prototype, {
                  constructor: {
                    value: e,
                    writable: !0,
                    configurable: !0
                  }
                }), t && b(e, t);
              }(a, e);
              var t,
                  n,
                  i = h(a);

              function a() {
                var e;
                v(this, a);

                for (var t = arguments.length, n = new Array(t), r = 0; r < t; r++) n[r] = arguments[r];

                var c = g(e = i.call.apply(i, [this].concat(n)));
                return c.isInited = !1, c.node = {}, c.$tabbox = u.default.render(l.default, {}), c.nodes = [], c.activedElem = {}, c.observer = new o.default(function (e) {
                  for (var t = 0; t < e.length; t++) {
                    var n = e[t];
                    c._isInVConsole(n.target) || c.onMutation(n);
                  }
                }), e;
              }

              return t = a, (n = [{
                key: "onRenderTab",
                value: function (e) {
                  e(this.$tabbox);
                }
              }, {
                key: "onAddTool",
                value: function (e) {
                  var t = this;
                  e([{
                    name: "Expand",
                    global: !1,
                    onClick: function (e) {
                      if (t.activedElem) if (u.default.hasClass(t.activedElem, "vc-toggle")) for (var n = 0; n < t.activedElem.childNodes.length; n++) {
                        var o = t.activedElem.childNodes[n];

                        if (u.default.hasClass(o, "vcelm-l") && !u.default.hasClass(o, "vcelm-noc") && !u.default.hasClass(o, "vc-toggle")) {
                          u.default.one(".vcelm-node", o).click();
                          break;
                        }
                      } else u.default.one(".vcelm-node", t.activedElem).click();
                    }
                  }, {
                    name: "Collapse",
                    global: !1,
                    onClick: function (e) {
                      t.activedElem && (u.default.hasClass(t.activedElem, "vc-toggle") ? u.default.one(".vcelm-node", t.activedElem).click() : t.activedElem.parentNode && u.default.hasClass(t.activedElem.parentNode, "vcelm-l") && u.default.one(".vcelm-node", t.activedElem.parentNode).click());
                    }
                  }]);
                }
              }, {
                key: "onShow",
                value: function () {
                  if (!this.isInited) {
                    this.isInited = !0, this.node = this.getNode(document.documentElement);
                    var e = this.renderView(this.node, u.default.one(".vc-log", this.$tabbox)),
                        t = u.default.one(".vcelm-node", e);
                    t && t.click && t.click(), this.observer.observe(document.documentElement, {
                      attributes: !0,
                      childList: !0,
                      characterData: !0,
                      subtree: !0
                    });
                  }
                }
              }, {
                key: "onRemove",
                value: function () {
                  this.observer.disconnect();
                }
              }, {
                key: "onMutation",
                value: function (e) {
                  switch (e.type) {
                    case "childList":
                      e.removedNodes.length > 0 && this.onChildRemove(e), e.addedNodes.length > 0 && this.onChildAdd(e);
                      break;

                    case "attributes":
                      this.onAttributesChange(e);
                      break;

                    case "characterData":
                      this.onCharacterDataChange(e);
                  }
                }
              }, {
                key: "onChildRemove",
                value: function (e) {
                  var t = e.target;

                  if (t.__vconsole_node) {
                    for (var n = 0; n < e.removedNodes.length; n++) {
                      var o = e.removedNodes[n].__vconsole_node;
                      o && o.view && o.view.parentNode.removeChild(o.view);
                    }

                    this.getNode(t);
                  }
                }
              }, {
                key: "onChildAdd",
                value: function (e) {
                  var t = e.target,
                      n = t.__vconsole_node;

                  if (n) {
                    this.getNode(t), n.view && u.default.removeClass(n.view, "vcelm-noc");

                    for (var o = 0; o < e.addedNodes.length; o++) {
                      var r = e.addedNodes[o].__vconsole_node;
                      if (r) if (null !== e.nextSibling) {
                        var i = e.nextSibling.__vconsole_node;
                        i.view && this.renderView(r, i.view, "insertBefore");
                      } else n.view && (n.view.lastChild ? this.renderView(r, n.view.lastChild, "insertBefore") : this.renderView(r, n.view));
                    }
                  }
                }
              }, {
                key: "onAttributesChange",
                value: function (e) {
                  var t = e.target.__vconsole_node;
                  t && (t = this.getNode(e.target)).view && this.renderView(t, t.view, !0);
                }
              }, {
                key: "onCharacterDataChange",
                value: function (e) {
                  var t = e.target.__vconsole_node;
                  t && (t = this.getNode(e.target)).view && this.renderView(t, t.view, !0);
                }
              }, {
                key: "renderView",
                value: function (e, t, n) {
                  var o = this,
                      r = new c.default(e).get();

                  switch (e.view = r, u.default.delegate(r, "click", ".vcelm-node", function (t) {
                    t.stopPropagation();
                    var n = this.parentNode;

                    if (!u.default.hasClass(n, "vcelm-noc")) {
                      o.activedElem = n, u.default.hasClass(n, "vc-toggle") ? u.default.removeClass(n, "vc-toggle") : u.default.addClass(n, "vc-toggle");

                      for (var r = -1, i = 0; i < n.children.length; i++) {
                        var a = n.children[i];
                        u.default.hasClass(a, "vcelm-l") && (r++, a.children.length > 0 || (e.childNodes[r] ? o.renderView(e.childNodes[r], a, "replace") : a.style.display = "none"));
                      }
                    }
                  }), n) {
                    case "replace":
                      t.parentNode.replaceChild(r, t);
                      break;

                    case "insertBefore":
                      t.parentNode.insertBefore(r, t);
                      break;

                    default:
                      t.appendChild(r);
                  }

                  return r;
                }
              }, {
                key: "getNode",
                value: function (e) {
                  if (!this._isIgnoredElement(e)) {
                    var t = e.__vconsole_node || {};
                    if (t.nodeType = e.nodeType, t.nodeName = e.nodeName, t.tagName = e.tagName || "", t.textContent = "", t.nodeType != e.TEXT_NODE && t.nodeType != e.DOCUMENT_TYPE_NODE || (t.textContent = e.textContent), t.id = e.id || "", t.className = e.className || "", t.attributes = [], e.hasAttributes && e.hasAttributes()) for (var n = 0; n < e.attributes.length; n++) t.attributes.push({
                      name: e.attributes[n].name,
                      value: e.attributes[n].value || ""
                    });
                    if (t.childNodes = [], e.childNodes.length > 0) for (var o = 0; o < e.childNodes.length; o++) {
                      var r = this.getNode(e.childNodes[o]);
                      r && t.childNodes.push(r);
                    }
                    return e.__vconsole_node = t, t;
                  }
                }
              }, {
                key: "_isIgnoredElement",
                value: function (e) {
                  return e.nodeType == e.TEXT_NODE && "" == e.textContent.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$|\n+/g, "");
                }
              }, {
                key: "_isInVConsole",
                value: function (e) {
                  for (var t = e; null != t;) {
                    if ("__vconsole" == t.id) return !0;
                    t = t.parentNode || void 0;
                  }

                  return !1;
                }
              }]) && p(t.prototype, n), a;
            }(i.default);

            n.default = _, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t) {
          var n = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver,
              o = window.WeakMap;

          if (void 0 === o) {
            var r = Object.defineProperty,
                i = Date.now() % 1e9;
            (o = function () {
              this.name = "__st" + (1e9 * Math.random() >>> 0) + i++ + "__";
            }).prototype = {
              set: function (e, t) {
                var n = e[this.name];
                return n && n[0] === e ? n[1] = t : r(e, this.name, {
                  value: [e, t],
                  writable: !0
                }), this;
              },
              get: function (e) {
                var t;
                return (t = e[this.name]) && t[0] === e ? t[1] : void 0;
              },
              delete: function (e) {
                var t = e[this.name];
                if (!t) return !1;
                var n = t[0] === e;
                return t[0] = t[1] = void 0, n;
              },
              has: function (e) {
                var t = e[this.name];
                return !!t && t[0] === e;
              }
            };
          }

          var a = new o(),
              l = window.msSetImmediate;

          if (!l) {
            var c = [],
                s = String(Math.random());
            window.addEventListener("message", function (e) {
              if (e.data === s) {
                var t = c;
                c = [], t.forEach(function (e) {
                  e();
                });
              }
            }), l = function (e) {
              c.push(e), window.postMessage(s, "*");
            };
          }

          var u = !1,
              d = [];

          function f() {
            u = !1;
            var e = d;
            d = [], e.sort(function (e, t) {
              return e.uid_ - t.uid_;
            });
            var t = !1;
            e.forEach(function (e) {
              var n = e.takeRecords();
              !function (e) {
                e.nodes_.forEach(function (t) {
                  var n = a.get(t);
                  n && n.forEach(function (t) {
                    t.observer === e && t.removeTransientObservers();
                  });
                });
              }(e), n.length && (e.callback_(n, e), t = !0);
            }), t && f();
          }

          function v(e, t) {
            for (var n = e; n; n = n.parentNode) {
              var o = a.get(n);
              if (o) for (var r = 0; r < o.length; r++) {
                var i = o[r],
                    l = i.options;

                if (n === e || l.subtree) {
                  var c = t(l);
                  c && i.enqueue(c);
                }
              }
            }
          }

          var p,
              b,
              h = 0;

          function m(e) {
            this.callback_ = e, this.nodes_ = [], this.records_ = [], this.uid_ = ++h;
          }

          function g(e, t) {
            this.type = e, this.target = t, this.addedNodes = [], this.removedNodes = [], this.previousSibling = null, this.nextSibling = null, this.attributeName = null, this.attributeNamespace = null, this.oldValue = null;
          }

          function y(e, t) {
            return p = new g(e, t);
          }

          function _(e) {
            return b || ((n = new g((t = p).type, t.target)).addedNodes = t.addedNodes.slice(), n.removedNodes = t.removedNodes.slice(), n.previousSibling = t.previousSibling, n.nextSibling = t.nextSibling, n.attributeName = t.attributeName, n.attributeNamespace = t.attributeNamespace, n.oldValue = t.oldValue, (b = n).oldValue = e, b);
            var t, n;
          }

          function w(e, t) {
            return e === t ? e : b && ((n = e) === b || n === p) ? b : null;
            var n;
          }

          function C(e, t, n) {
            this.observer = e, this.target = t, this.options = n, this.transientObservedNodes = [];
          }

          m.prototype = {
            observe: function (e, t) {
              var n;
              if (n = e, e = window.ShadowDOMPolyfill && window.ShadowDOMPolyfill.wrapIfNeeded(n) || n, !t.childList && !t.attributes && !t.characterData || t.attributeOldValue && !t.attributes || t.attributeFilter && t.attributeFilter.length && !t.attributes || t.characterDataOldValue && !t.characterData) throw new SyntaxError();
              var o,
                  r = a.get(e);
              r || a.set(e, r = []);

              for (var i = 0; i < r.length; i++) if (r[i].observer === this) {
                (o = r[i]).removeListeners(), o.options = t;
                break;
              }

              o || (o = new C(this, e, t), r.push(o), this.nodes_.push(e)), o.addListeners();
            },
            disconnect: function () {
              this.nodes_.forEach(function (e) {
                for (var t = a.get(e), n = 0; n < t.length; n++) {
                  var o = t[n];

                  if (o.observer === this) {
                    o.removeListeners(), t.splice(n, 1);
                    break;
                  }
                }
              }, this), this.records_ = [];
            },
            takeRecords: function () {
              var e = this.records_;
              return this.records_ = [], e;
            }
          }, C.prototype = {
            enqueue: function (e) {
              var t,
                  n = this.observer.records_,
                  o = n.length;

              if (n.length > 0) {
                var r = w(n[o - 1], e);
                if (r) return void (n[o - 1] = r);
              } else t = this.observer, d.push(t), u || (u = !0, l(f));

              n[o] = e;
            },
            addListeners: function () {
              this.addListeners_(this.target);
            },
            addListeners_: function (e) {
              var t = this.options;
              t.attributes && e.addEventListener("DOMAttrModified", this, !0), t.characterData && e.addEventListener("DOMCharacterDataModified", this, !0), t.childList && e.addEventListener("DOMNodeInserted", this, !0), (t.childList || t.subtree) && e.addEventListener("DOMNodeRemoved", this, !0);
            },
            removeListeners: function () {
              this.removeListeners_(this.target);
            },
            removeListeners_: function (e) {
              var t = this.options;
              t.attributes && e.removeEventListener("DOMAttrModified", this, !0), t.characterData && e.removeEventListener("DOMCharacterDataModified", this, !0), t.childList && e.removeEventListener("DOMNodeInserted", this, !0), (t.childList || t.subtree) && e.removeEventListener("DOMNodeRemoved", this, !0);
            },
            addTransientObserver: function (e) {
              if (e !== this.target) {
                this.addListeners_(e), this.transientObservedNodes.push(e);
                var t = a.get(e);
                t || a.set(e, t = []), t.push(this);
              }
            },
            removeTransientObservers: function () {
              var e = this.transientObservedNodes;
              this.transientObservedNodes = [], e.forEach(function (e) {
                this.removeListeners_(e);

                for (var t = a.get(e), n = 0; n < t.length; n++) if (t[n] === this) {
                  t.splice(n, 1);
                  break;
                }
              }, this);
            },
            handleEvent: function (e) {
              switch (e.stopImmediatePropagation(), e.type) {
                case "DOMAttrModified":
                  var t = e.attrName,
                      n = e.relatedNode.namespaceURI,
                      o = e.target;
                  (i = new y("attributes", o)).attributeName = t, i.attributeNamespace = n;
                  var r = null;
                  "undefined" != typeof MutationEvent && e.attrChange === MutationEvent.ADDITION || (r = e.prevValue), v(o, function (e) {
                    if (e.attributes && (!e.attributeFilter || !e.attributeFilter.length || -1 !== e.attributeFilter.indexOf(t) || -1 !== e.attributeFilter.indexOf(n))) return e.attributeOldValue ? _(r) : i;
                  });
                  break;

                case "DOMCharacterDataModified":
                  var i = y("characterData", o = e.target);
                  r = e.prevValue;
                  v(o, function (e) {
                    if (e.characterData) return e.characterDataOldValue ? _(r) : i;
                  });
                  break;

                case "DOMNodeRemoved":
                  this.addTransientObserver(e.target);

                case "DOMNodeInserted":
                  o = e.relatedNode;
                  var a,
                      l,
                      c = e.target;
                  "DOMNodeInserted" === e.type ? (a = [c], l = []) : (a = [], l = [c]);
                  var s = c.previousSibling,
                      u = c.nextSibling;
                  (i = y("childList", o)).addedNodes = a, i.removedNodes = l, i.previousSibling = s, i.nextSibling = u, v(o, function (e) {
                    if (e.childList) return i;
                  });
              }

              p = b = void 0;
            }
          }, n || (n = m), e.exports = n;
        }, function (e, t, n) {
          var o = n(4),
              r = n(33);
          "string" == typeof (r = r.__esModule ? r.default : r) && (r = [[e.i, r, ""]]);
          var i = {
            insert: "head",
            singleton: !1
          };
          o(r, i);
          e.exports = r.locals || {};
        }, function (e, t, n) {
          (t = n(5)(!1)).push([e.i, '/* color */\n.vcelm-node {\n  color: var(--VC-DOM-TAG-NAME-COLOR);\n}\n.vcelm-k {\n  color: var(--VC-DOM-ATTRIBUTE-NAME-COLOR);\n}\n.vcelm-v {\n  color: var(--VC-DOM-ATTRIBUTE-VALUE-COLOR);\n}\n/* layout */\n.vcelm-l {\n  padding-left: 8px;\n  position: relative;\n  word-wrap: break-word;\n  line-height: 1;\n}\n/*.vcelm-l.vcelm-noc {\n  padding-left: 0;\n}*/\n.vcelm-l.vc-toggle > .vcelm-node {\n  display: block;\n}\n.vcelm-l .vcelm-node:active {\n  background-color: var(--VC-BG-COLOR-ACTIVE);\n}\n.vcelm-l.vcelm-noc .vcelm-node:active {\n  background-color: transparent;\n}\n.vcelm-t {\n  white-space: pre-wrap;\n  word-wrap: break-word;\n}\n/* level */\n.vcelm-l .vcelm-l {\n  display: none;\n}\n.vcelm-l.vc-toggle > .vcelm-l {\n  margin-left: 4px;\n  display: block;\n}\n/* arrow */\n.vcelm-l:before {\n  content: "";\n  display: block;\n  position: absolute;\n  top: 6px;\n  left: 3px;\n  width: 0;\n  height: 0;\n  border: transparent solid 3px;\n  border-left-color: var(--VC-FG-1);\n}\n.vcelm-l.vc-toggle:before {\n  display: block;\n  top: 6px;\n  left: 0;\n  border-top-color: var(--VC-FG-1);\n  border-left-color: transparent;\n}\n.vcelm-l.vcelm-noc:before {\n  display: none;\n}\n', ""]), e.exports = t;
        }, function (e, t) {
          e.exports = '<div>\n  <div class="vc-log"></div>\n</div>';
        }, function (e, t, n) {
          var o, r, i;

          function a(e) {
            return (a = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
              return typeof e;
            } : function (e) {
              return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
            })(e);
          }

          r = [t, n(36), n(37), n(0), n(1)], void 0 === (i = "function" == typeof (o = function (n, o, r, i, l) {
            function c() {
              if ("function" != typeof WeakMap) return null;
              var e = new WeakMap();
              return c = function () {
                return e;
              }, e;
            }

            function s(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function u(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, o = s(o), r = s(r), i = function (e) {
              if (e && e.__esModule) return e;
              if (null === e || "object" !== a(e) && "function" != typeof e) return {
                default: e
              };
              var t = c();
              if (t && t.has(e)) return t.get(e);
              var n = {},
                  o = Object.defineProperty && Object.getOwnPropertyDescriptor;

              for (var r in e) if (Object.prototype.hasOwnProperty.call(e, r)) {
                var i = o ? Object.getOwnPropertyDescriptor(e, r) : null;
                i && (i.get || i.set) ? Object.defineProperty(n, r, i) : n[r] = e[r];
              }

              return n.default = e, t && t.set(e, n), n;
            }(i), l = s(l);

            var d = function () {
              function e(t) {
                !function (e, t) {
                  if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
                }(this, e), this.node = t, this.view = this._create(this.node);
              }

              var t, n;
              return t = e, (n = [{
                key: "get",
                value: function () {
                  return this.view;
                }
              }, {
                key: "_create",
                value: function (e, t) {
                  var n = document.createElement("DIV");

                  switch (l.default.addClass(n, "vcelm-l"), e.nodeType) {
                    case n.ELEMENT_NODE:
                      this._createElementNode(e, n);

                      break;

                    case n.TEXT_NODE:
                      this._createTextNode(e, n);

                      break;

                    case n.COMMENT_NODE:
                    case n.DOCUMENT_NODE:
                    case n.DOCUMENT_TYPE_NODE:
                    case n.DOCUMENT_FRAGMENT_NODE:
                  }

                  return n;
                }
              }, {
                key: "_createTextNode",
                value: function (e, t) {
                  l.default.addClass(t, "vcelm-t vcelm-noc"), e.textContent && t.appendChild(function (e) {
                    return document.createTextNode(e);
                  }(e.textContent.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "")));
                }
              }, {
                key: "_createElementNode",
                value: function (e, t) {
                  var n,
                      i = (n = (n = e.tagName) ? n.toLowerCase() : "", ["br", "hr", "img", "input", "link", "meta"].indexOf(n) > -1),
                      a = i;
                  0 == e.childNodes.length && (a = !0);
                  var c = l.default.render(o.default, {
                    node: e
                  }),
                      s = l.default.render(r.default, {
                    node: e
                  });
                  if (a) l.default.addClass(t, "vcelm-noc"), t.appendChild(c), i || t.appendChild(s);else {
                    t.appendChild(c);

                    for (var u = 0; u < e.childNodes.length; u++) {
                      var d = document.createElement("DIV");
                      l.default.addClass(d, "vcelm-l"), t.appendChild(d);
                    }

                    i || t.appendChild(s);
                  }
                }
              }]) && u(t.prototype, n), e;
            }();

            n.default = d, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t) {
          e.exports = '<span class="vcelm-node">&lt;{{node.tagName.toLowerCase()}}{{if (node.className || node.attributes.length)}}\n  <i class="vcelm-k">\n    {{for (var i = 0; i < node.attributes.length; i++)}}\n      {{if (node.attributes[i].value !== \'\')}}\n        {{node.attributes[i].name}}="<i class="vcelm-v">{{node.attributes[i].value}}</i>"{{else}}\n        {{node.attributes[i].name}}{{/if}}{{/for}}</i>{{/if}}&gt;</span>';
        }, function (e, t) {
          e.exports = '<span class="vcelm-node">&lt;/{{node.tagName.toLowerCase()}}&gt;</span>';
        }, function (e, t, n) {
          var o, r, i;

          function a(e) {
            return (a = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (e) {
              return typeof e;
            } : function (e) {
              return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
            })(e);
          }

          r = [t, n(2), n(39), n(40), n(0), n(1)], void 0 === (i = "function" == typeof (o = function (n, o, r, i, l, c) {
            function s() {
              if ("function" != typeof WeakMap) return null;
              var e = new WeakMap();
              return s = function () {
                return e;
              }, e;
            }

            function u(e) {
              return e && e.__esModule ? e : {
                default: e
              };
            }

            function d(e, t) {
              if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
            }

            function f(e, t) {
              for (var n = 0; n < t.length; n++) {
                var o = t[n];
                o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, o.key, o);
              }
            }

            function v(e, t) {
              return (v = Object.setPrototypeOf || function (e, t) {
                return e.__proto__ = t, e;
              })(e, t);
            }

            function p(e) {
              var t = function () {
                if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
                if (Reflect.construct.sham) return !1;
                if ("function" == typeof Proxy) return !0;

                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function () {})), !0;
                } catch (e) {
                  return !1;
                }
              }();

              return function () {
                var n,
                    o = h(e);

                if (t) {
                  var r = h(this).constructor;
                  n = Reflect.construct(o, arguments, r);
                } else n = o.apply(this, arguments);

                return b(this, n);
              };
            }

            function b(e, t) {
              return !t || "object" !== a(t) && "function" != typeof t ? function (e) {
                if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return e;
              }(e) : t;
            }

            function h(e) {
              return (h = Object.setPrototypeOf ? Object.getPrototypeOf : function (e) {
                return e.__proto__ || Object.getPrototypeOf(e);
              })(e);
            }

            Object.defineProperty(n, "__esModule", {
              value: !0
            }), n.default = void 0, o = u(o), r = u(r), i = u(i), l = function (e) {
              if (e && e.__esModule) return e;
              if (null === e || "object" !== a(e) && "function" != typeof e) return {
                default: e
              };
              var t = s();
              if (t && t.has(e)) return t.get(e);
              var n = {},
                  o = Object.defineProperty && Object.getOwnPropertyDescriptor;

              for (var r in e) if (Object.prototype.hasOwnProperty.call(e, r)) {
                var i = o ? Object.getOwnPropertyDescriptor(e, r) : null;
                i && (i.get || i.set) ? Object.defineProperty(n, r, i) : n[r] = e[r];
              }

              return n.default = e, t && t.set(e, n), n;
            }(l), c = u(c);

            var m = function (e) {
              !function (e, t) {
                if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
                e.prototype = Object.create(t && t.prototype, {
                  constructor: {
                    value: e,
                    writable: !0,
                    configurable: !0
                  }
                }), t && v(e, t);
              }(s, e);
              var t,
                  n,
                  a = p(s);

              function s() {
                var e;
                d(this, s);

                for (var t = arguments.length, n = new Array(t), o = 0; o < t; o++) n[o] = arguments[o];

                return (e = a.call.apply(a, [this].concat(n))).$tabbox = c.default.render(r.default, {}), e.currentType = "", e.typeNameMap = {
                  cookies: "Cookies",
                  localstorage: "LocalStorage",
                  sessionstorage: "SessionStorage"
                }, e;
              }

              return t = s, (n = [{
                key: "onRenderTab",
                value: function (e) {
                  e(this.$tabbox);
                }
              }, {
                key: "onAddTopBar",
                value: function (e) {
                  for (var t = this, n = ["Cookies", "LocalStorage", "SessionStorage"], o = [], r = 0; r < n.length; r++) o.push({
                    name: n[r],
                    data: {
                      type: n[r].toLowerCase()
                    },
                    className: "",
                    onClick: function () {
                      if (c.default.hasClass(this, "vc-actived")) return !1;
                      t.currentType = this.dataset.type, t.renderStorage();
                    }
                  });

                  o[0].className = "vc-actived", e(o);
                }
              }, {
                key: "onAddTool",
                value: function (e) {
                  var t = this;
                  e([{
                    name: "Refresh",
                    global: !1,
                    onClick: function (e) {
                      t.renderStorage();
                    }
                  }, {
                    name: "Clear",
                    global: !1,
                    onClick: function (e) {
                      t.clearLog();
                    }
                  }]);
                }
              }, {
                key: "onReady",
                value: function () {}
              }, {
                key: "onShow",
                value: function () {
                  "" == this.currentType && (this.currentType = "cookies", this.renderStorage());
                }
              }, {
                key: "clearLog",
                value: function () {
                  if (this.currentType && window.confirm && !window.confirm("Remove all " + this.typeNameMap[this.currentType] + "?")) return !1;

                  switch (this.currentType) {
                    case "cookies":
                      this.clearCookieList();
                      break;

                    case "localstorage":
                      this.clearLocalStorageList();
                      break;

                    case "sessionstorage":
                      this.clearSessionStorageList();
                      break;

                    default:
                      return !1;
                  }

                  this.renderStorage();
                }
              }, {
                key: "renderStorage",
                value: function () {
                  var e = [];

                  switch (this.currentType) {
                    case "cookies":
                      e = this.getCookieList();
                      break;

                    case "localstorage":
                      e = this.getLocalStorageList();
                      break;

                    case "sessionstorage":
                      e = this.getSessionStorageList();
                      break;

                    default:
                      return !1;
                  }

                  var t = c.default.one(".vc-log", this.$tabbox);
                  if (0 == e.length) t.innerHTML = "";else {
                    for (var n = 0; n < e.length; n++) e[n].name = l.htmlEncode(e[n].name), e[n].value = l.htmlEncode(e[n].value);

                    t.innerHTML = c.default.render(i.default, {
                      list: e
                    }, !0);
                  }
                }
              }, {
                key: "getCookieList",
                value: function () {
                  if (!document.cookie || !navigator.cookieEnabled) return [];

                  for (var e = [], t = document.cookie.split(";"), n = 0; n < t.length; n++) {
                    var o = t[n].split("="),
                        r = o.shift().replace(/^ /, ""),
                        i = o.join("=");

                    try {
                      r = decodeURIComponent(r), i = decodeURIComponent(i);
                    } catch (e) {}

                    e.push({
                      name: r,
                      value: i
                    });
                  }

                  return e;
                }
              }, {
                key: "getLocalStorageList",
                value: function () {
                  if (!window.localStorage) return [];

                  try {
                    for (var e = [], t = 0; t < localStorage.length; t++) {
                      var n = localStorage.key(t),
                          o = localStorage.getItem(n);
                      e.push({
                        name: n,
                        value: o
                      });
                    }

                    return e;
                  } catch (e) {
                    return [];
                  }
                }
              }, {
                key: "getSessionStorageList",
                value: function () {
                  if (!window.sessionStorage) return [];

                  try {
                    for (var e = [], t = 0; t < sessionStorage.length; t++) {
                      var n = sessionStorage.key(t),
                          o = sessionStorage.getItem(n);
                      e.push({
                        name: n,
                        value: o
                      });
                    }

                    return e;
                  } catch (e) {
                    return [];
                  }
                }
              }, {
                key: "clearCookieList",
                value: function () {
                  if (document.cookie && navigator.cookieEnabled) {
                    for (var e = window.location.hostname, t = this.getCookieList(), n = 0; n < t.length; n++) {
                      var o = t[n].name;
                      document.cookie = "".concat(o, "=;expires=Thu, 01 Jan 1970 00:00:00 GMT"), document.cookie = "".concat(o, "=;expires=Thu, 01 Jan 1970 00:00:00 GMT;path=/"), document.cookie = "".concat(o, "=;expires=Thu, 01 Jan 1970 00:00:00 GMT;path=/;domain=.").concat(e.split(".").slice(-2).join("."));
                    }

                    this.renderStorage();
                  }
                }
              }, {
                key: "clearLocalStorageList",
                value: function () {
                  if (window.localStorage) try {
                    localStorage.clear(), this.renderStorage();
                  } catch (e) {
                    alert("localStorage.clear() fail.");
                  }
                }
              }, {
                key: "clearSessionStorageList",
                value: function () {
                  if (window.sessionStorage) try {
                    sessionStorage.clear(), this.renderStorage();
                  } catch (e) {
                    alert("sessionStorage.clear() fail.");
                  }
                }
              }]) && f(t.prototype, n), s;
            }(o.default);

            n.default = m, e.exports = t.default;
          }) ? o.apply(t, r) : o) || (e.exports = i);
        }, function (e, t) {
          e.exports = '<div class="vc-table">\n  <div class="vc-log"></div>\n</div>';
        }, function (e, t) {
          e.exports = '<div>\n  <dl class="vc-table-row">\n    <dd class="vc-table-col">Name</dd>\n    <dd class="vc-table-col vc-table-col-2">Value</dd>\n  </dl>\n  {{for (var i = 0; i < list.length; i++)}}\n  <dl class="vc-table-row">\n    <dd class="vc-table-col">{{list[i].name}}</dd>\n    <dd class="vc-table-col vc-table-col-2">{{list[i].value}}</dd>\n  </dl>\n  {{/for}}\n</div>';
        }]);
      });
      /**
       * 注意：已把原脚本注释，由于脚本变动过大，转换的时候可能有遗落，需要自行手动转换
       */
      // /*!
      //  * vConsole v3.4.0 (https://github.com/Tencent/vConsole)
      //  * 
      //  * Tencent is pleased to support the open source community by making vConsole available.
      //  * Copyright (C) 2017 THL A29 Limited, a Tencent company. All rights reserved.
      //  * Licensed under the MIT License (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at
      //  * http://opensource.org/licenses/MIT
      //  * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
      //  */
      // !function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define("VConsole",[],t):"object"==typeof exports?exports.VConsole=t():e.VConsole=t()}(window,(function(){return function(e){var t={};function n(o){if(t[o])return t[o].exports;var r=t[o]={i:o,l:!1,exports:{}};return e[o].call(r.exports,r,r.exports,n),r.l=!0,r.exports}return n.m=e,n.c=t,n.d=function(e,t,o){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:o})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var o=Object.create(null);if(n.r(o),Object.defineProperty(o,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var r in e)n.d(o,r,function(t){return e[t]}.bind(null,r));return o},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=6)}([function(e,t,n){var o,r,i;"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t],void 0===(i="function"==typeof(o=function(e){"use strict";function t(e){return(t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function n(e){return"[object Number]"==Object.prototype.toString.call(e)}function o(e){return"[object String]"==Object.prototype.toString.call(e)}function r(e){return"[object Array]"==Object.prototype.toString.call(e)}function i(e){return"[object Boolean]"==Object.prototype.toString.call(e)}function a(e){return void 0===e}function l(e){return null===e}function c(e){return"[object Symbol]"==Object.prototype.toString.call(e)}function s(e){return!("[object Object]"!=Object.prototype.toString.call(e)&&(n(e)||o(e)||i(e)||r(e)||l(e)||u(e)||a(e)||c(e)))}function u(e){return"[object Function]"==Object.prototype.toString.call(e)}function d(e){var t=Object.prototype.toString.call(e);return"[object global]"==t||"[object Window]"==t||"[object DOMWindow]"==t}function f(e){if(!s(e)&&!r(e))return[];var t=[];for(var n in e)t.push(n);return t.sort()}Object.defineProperty(e,"__esModule",{value:!0}),e.getDate=function(e){var t=e>0?new Date(e):new Date,n=t.getDate()<10?"0"+t.getDate():t.getDate(),o=t.getMonth()<9?"0"+(t.getMonth()+1):t.getMonth()+1,r=t.getFullYear(),i=t.getHours()<10?"0"+t.getHours():t.getHours(),a=t.getMinutes()<10?"0"+t.getMinutes():t.getMinutes(),l=t.getSeconds()<10?"0"+t.getSeconds():t.getSeconds(),c=t.getMilliseconds()<10?"0"+t.getMilliseconds():t.getMilliseconds();return c<100&&(c="0"+c),{time:+t,year:r,month:o,day:n,hour:i,minute:a,second:l,millisecond:c}},e.isNumber=n,e.isString=o,e.isArray=r,e.isBoolean=i,e.isUndefined=a,e.isNull=l,e.isSymbol=c,e.isObject=s,e.isFunction=u,e.isElement=function(e){return"object"===("undefined"==typeof HTMLElement?"undefined":t(HTMLElement))?e instanceof HTMLElement:e&&"object"===t(e)&&null!==e&&1===e.nodeType&&"string"==typeof e.nodeName},e.isWindow=d,e.isPlainObject=function(e){var n,o=Object.prototype.hasOwnProperty;if(!e||"object"!==t(e)||e.nodeType||d(e))return!1;try{if(e.constructor&&!o.call(e,"constructor")&&!o.call(e.constructor.prototype,"isPrototypeOf"))return!1}catch(e){return!1}for(n in e);return void 0===n||o.call(e,n)},e.htmlEncode=function(e){return document.createElement("a").appendChild(document.createTextNode(e)).parentNode.innerHTML},e.JSONStringify=function(e){if(!s(e)&&!r(e))return JSON.stringify(e);var t="{",n="}";r(e)&&(t="[",n="]");for(var o=t,i=f(e),a=0;a<i.length;a++){var l=i[a],d=e[l];try{r(e)||(s(l)||r(l)||c(l)?o+=Object.prototype.toString.call(l):o+=l,o+=": "),r(d)?o+="Array["+d.length+"]":s(d)||c(d)||u(d)?o+=Object.prototype.toString.call(d):o+=JSON.stringify(d),a<i.length-1&&(o+=", ")}catch(e){continue}}return o+=n},e.getObjAllKeys=f,e.getObjName=function(e){return Object.prototype.toString.call(e).replace("[object ","").replace("]","")},e.setStorage=function(e,t){window.localStorage&&(e="vConsole_"+e,localStorage.setItem(e,t))},e.getStorage=function(e){if(window.localStorage)return e="vConsole_"+e,localStorage.getItem(e)}})?o.apply(t,r):o)||(e.exports=i)},function(e,t,n){var o,r,i;"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(0),n(10)],void 0===(i="function"==typeof(o=function(n,o,r){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,r=(i=r)&&i.__esModule?i:{default:i};var a={one:function(e,t){try{return(t||document).querySelector(e)||void 0}catch(e){return}},all:function(e,t){try{var n=(t||document).querySelectorAll(e);return[].slice.call(n)}catch(e){return[]}},addClass:function(e,t){if(e){(0,o.isArray)(e)||(e=[e]);for(var n=0;n<e.length;n++){var r=(e[n].className||"").split(" ");r.indexOf(t)>-1||(r.push(t),e[n].className=r.join(" "))}}},removeClass:function(e,t){if(e){(0,o.isArray)(e)||(e=[e]);for(var n=0;n<e.length;n++){for(var r=e[n].className.split(" "),i=0;i<r.length;i++)r[i]==t&&(r[i]="");e[n].className=r.join(" ").trim()}}},hasClass:function(e,t){return!(!e||!e.classList)&&e.classList.contains(t)},bind:function(e,t,n,r){e&&((0,o.isArray)(e)||(e=[e]),e.forEach((function(e){e.addEventListener(t,n,!!r)})))},delegate:function(e,t,n,o){e&&e.addEventListener(t,(function(t){var r=a.all(n,e);if(r)e:for(var i=0;i<r.length;i++)for(var l=t.target;l;){if(l==r[i]){o.call(l,t);break e}if((l=l.parentNode)==e)break}}),!1)}};a.render=r.default;var l=a;n.default=l,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t,n){var o,r,i;"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t],void 0===(i="function"==typeof(o=function(n){"use strict";function o(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function r(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var i=function(){function e(t){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"newPlugin";o(this,e),this.id=t,this.name=n,this.isReady=!1,this.eventList={}}var t,n,i;return t=e,(n=[{key:"on",value:function(e,t){return this.eventList[e]=t,this}},{key:"trigger",value:function(e,t){if("function"==typeof this.eventList[e])this.eventList[e].call(this,t);else{var n="on"+e.charAt(0).toUpperCase()+e.slice(1);"function"==typeof this[n]&&this[n].call(this,t)}return this}},{key:"id",get:function(){return this._id},set:function(e){if(!e)throw"Plugin ID cannot be empty";this._id=e.toLowerCase()}},{key:"name",get:function(){return this._name},set:function(e){if(!e)throw"Plugin name cannot be empty";this._name=e}},{key:"vConsole",get:function(){return this._vConsole||void 0},set:function(e){if(!e)throw"vConsole cannot be empty";this._vConsole=e}}])&&r(t.prototype,n),i&&r(t,i),e}();n.default=i,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t,n){var o,r,i;"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(0),n(1),n(2),n(18),n(19),n(20)],void 0===(i="function"==typeof(o=function(n,o,r,i,a,l,c){"use strict";function s(e){return e&&e.__esModule?e:{default:e}}function u(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return u=function(){return e},e}function d(e){return(d="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function f(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function v(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function p(e,t){return(p=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function b(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,o=m(e);if(t){var r=m(this).constructor;n=Reflect.construct(o,arguments,r)}else n=o.apply(this,arguments);return h(this,n)}}function h(e,t){return!t||"object"!==d(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function m(e){return(m=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,o=function(e){if(e&&e.__esModule)return e;if(null===e||"object"!==d(e)&&"function"!=typeof e)return{default:e};var t=u();if(t&&t.has(e))return t.get(e);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)){var i=o?Object.getOwnPropertyDescriptor(e,r):null;i&&(i.get||i.set)?Object.defineProperty(n,r,i):n[r]=e[r]}return n.default=e,t&&t.set(e,n),n}(o),r=s(r),i=s(i),a=s(a),l=s(l),c=s(c);var g=[],y={},_=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&p(e,t)}(u,e);var t,n,i,s=b(u);function u(){var e;f(this,u);for(var t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];return e=s.call.apply(s,[this].concat(n)),g.push(e.id),e.tplTabbox="",e.allowUnformattedLog=!0,e.isReady=!1,e.isShow=!1,e.$tabbox=null,e.console={},e.logList=[],e.isInBottom=!0,e.maxLogNumber=1e3,e.logNumber=0,e.mockConsole(),e}return t=u,(n=[{key:"onInit",value:function(){this.$tabbox=r.default.render(this.tplTabbox,{}),this.updateMaxLogNumber()}},{key:"onRenderTab",value:function(e){e(this.$tabbox)}},{key:"onAddTopBar",value:function(e){for(var t=this,n=["All","Log","Info","Warn","Error"],o=[],i=0;i<n.length;i++)o.push({name:n[i],data:{type:n[i].toLowerCase()},className:"",onClick:function(){if(r.default.hasClass(this,"vc-actived"))return!1;t.showLogType(this.dataset.type||"all")}});o[0].className="vc-actived",e(o)}},{key:"onAddTool",value:function(e){var t=this;e([{name:"Clear",global:!1,onClick:function(){t.clearLog(),t.vConsole.triggerEvent("clearLog")}}])}},{key:"onReady",value:function(){var e=this;e.isReady=!0;var t=r.default.all(".vc-subtab",e.$tabbox);r.default.bind(t,"click",(function(n){if(n.preventDefault(),r.default.hasClass(this,"vc-actived"))return!1;r.default.removeClass(t,"vc-actived"),r.default.addClass(this,"vc-actived");var o=this.dataset.type,i=r.default.one(".vc-log",e.$tabbox);r.default.removeClass(i,"vc-log-partly-log"),r.default.removeClass(i,"vc-log-partly-info"),r.default.removeClass(i,"vc-log-partly-warn"),r.default.removeClass(i,"vc-log-partly-error"),"all"==o?r.default.removeClass(i,"vc-log-partly"):(r.default.addClass(i,"vc-log-partly"),r.default.addClass(i,"vc-log-partly-"+o))}));var n=r.default.one(".vc-content");r.default.bind(n,"scroll",(function(t){e.isShow&&(n.scrollTop+n.offsetHeight>=n.scrollHeight?e.isInBottom=!0:e.isInBottom=!1)}));for(var o=0;o<e.logList.length;o++)e.printLog(e.logList[o]);e.logList=[]}},{key:"onRemove",value:function(){window.console.log=this.console.log,window.console.info=this.console.info,window.console.warn=this.console.warn,window.console.debug=this.console.debug,window.console.error=this.console.error,window.console.time=this.console.time,window.console.timeEnd=this.console.timeEnd,window.console.clear=this.console.clear,this.console={};var e=g.indexOf(this.id);e>-1&&g.splice(e,1)}},{key:"onShow",value:function(){this.isShow=!0,1==this.isInBottom&&this.autoScrollToBottom()}},{key:"onHide",value:function(){this.isShow=!1}},{key:"onShowConsole",value:function(){1==this.isInBottom&&this.autoScrollToBottom()}},{key:"onUpdateOption",value:function(){this.vConsole.option.maxLogNumber!=this.maxLogNumber&&(this.updateMaxLogNumber(),this.limitMaxLogs())}},{key:"updateMaxLogNumber",value:function(){this.maxLogNumber=this.vConsole.option.maxLogNumber||1e3,this.maxLogNumber=Math.max(1,this.maxLogNumber)}},{key:"limitMaxLogs",value:function(){if(this.isReady)for(;this.logNumber>this.maxLogNumber;){var e=r.default.one(".vc-item",this.$tabbox);if(!e)break;e.parentNode.removeChild(e),this.logNumber--}}},{key:"showLogType",value:function(e){var t=r.default.one(".vc-log",this.$tabbox);r.default.removeClass(t,"vc-log-partly-log"),r.default.removeClass(t,"vc-log-partly-info"),r.default.removeClass(t,"vc-log-partly-warn"),r.default.removeClass(t,"vc-log-partly-error"),"all"==e?r.default.removeClass(t,"vc-log-partly"):(r.default.addClass(t,"vc-log-partly"),r.default.addClass(t,"vc-log-partly-"+e))}},{key:"autoScrollToBottom",value:function(){this.vConsole.option.disableLogScrolling||this.scrollToBottom()}},{key:"scrollToBottom",value:function(){var e=r.default.one(".vc-content");e&&(e.scrollTop=e.scrollHeight-e.offsetHeight)}},{key:"mockConsole",value:function(){var e=this,t=this,n=["log","info","warn","debug","error"];window.console?(n.map((function(e){t.console[e]=window.console[e]})),t.console.time=window.console.time,t.console.timeEnd=window.console.timeEnd,t.console.clear=window.console.clear):window.console={},n.map((function(t){window.console[t]=function(){for(var n=arguments.length,o=new Array(n),r=0;r<n;r++)o[r]=arguments[r];e.printLog({logType:t,logs:o})}}));var o={};window.console.time=function(e){o[e]=Date.now()},window.console.timeEnd=function(e){var t=o[e];t?(console.log(e+":",Date.now()-t+"ms"),delete o[e]):console.log(e+": 0ms")},window.console.clear=function(){t.clearLog();for(var e=arguments.length,n=new Array(e),o=0;o<e;o++)n[o]=arguments[o];t.console.clear.apply(window.console,n)}}},{key:"clearLog",value:function(){r.default.one(".vc-log",this.$tabbox).innerHTML="",this.logNumber=0,y={}}},{key:"printOriginLog",value:function(e){"function"==typeof this.console[e.logType]&&this.console[e.logType].apply(window.console,e.logs)}},{key:"printLog",value:function(e){var t=e.logs||[];if(t.length||e.content){t=[].slice.call(t||[]);var n=/^\[(\w+)\]$/i,r="",i=!1;if(o.isString(t[0])){var a=t[0].match(n);null!==a&&a.length>0&&(r=a[1].toLowerCase(),i=g.indexOf(r)>-1)}if(r===this.id||!0!==i&&"default"===this.id)if(e._id||(e._id="__vc_"+Math.random().toString(36).substring(2,8)),e.date||(e.date=+new Date),this.isReady){o.isString(t[0])&&i&&(t[0]=t[0].replace(n,""),""===t[0]&&t.shift());for(var l={_id:e._id,logType:e.logType,logText:[],hasContent:!!e.content,count:1},c=0;c<t.length;c++)o.isFunction(t[c])?l.logText.push(t[c].toString()):o.isObject(t[c])||o.isArray(t[c])?l.logText.push(o.JSONStringify(t[c])):l.logText.push(t[c]);l.logText=l.logText.join(" "),l.hasContent||y.logType!==l.logType||y.logText!==l.logText?(this.printNewLog(e,t),y=l):this.printRepeatLog(),this.isInBottom&&this.isShow&&this.autoScrollToBottom(),e.noOrigin||this.printOriginLog(e)}else this.logList.push(e);else e.noOrigin||this.printOriginLog(e)}}},{key:"printRepeatLog",value:function(){var e=r.default.one("#"+y._id),t=r.default.one(".vc-item-repeat",e);t||((t=document.createElement("i")).className="vc-item-repeat",e.insertBefore(t,e.lastChild)),y.count,y.count++,t.innerHTML=y.count}},{key:"printNewLog",value:function(e,t){var n=r.default.render(a.default,{_id:e._id,logType:e.logType,style:e.style||""}),i=/(\%c )|( \%c)/g,l=[];if(o.isString(t[0])&&i.test(t[0])){for(var c=t[0].split(i).filter((function(e){return void 0!==e&&""!==e&&!/ ?\%c ?/.test(e)})),s=t[0].match(i),u=0;u<s.length;u++)o.isString(t[u+1])&&l.push(t[u+1]);for(var f=s.length+1;f<t.length;f++)c.push(t[f]);t=c}for(var v=r.default.one(".vc-item-content",n),p=0;p<t.length;p++){var b=void 0;try{if(""===t[p])continue;b=o.isFunction(t[p])?"<span> "+t[p].toString()+"</span>":o.isObject(t[p])||o.isArray(t[p])?this.getFoldedLine(t[p]):(l[p]?'<span style="'.concat(l[p],'"> '):"<span> ")+o.htmlEncode(t[p]).replace(/\n/g,"<br/>")+"</span>"}catch(e){b="<span> ["+d(t[p])+"]</span>"}b&&("string"==typeof b?v.insertAdjacentHTML("beforeend",b):v.insertAdjacentElement("beforeend",b))}o.isObject(e.content)&&v.insertAdjacentElement("beforeend",e.content),this.formatLine&&(n=this.formatLine(n)),r.default.one(".vc-log",this.$tabbox).insertAdjacentElement("beforeend",n),this.logNumber++,this.limitMaxLogs()}},{key:"getFoldedLine",value:function(e,t){var n=this;if(!t){var i=o.JSONStringify(e),a=i.substr(0,36);t=o.getObjName(e),i.length>36&&(a+="..."),t+=" "+a}var s=r.default.render(l.default,{outer:t,lineType:"obj"});return r.default.bind(r.default.one(".vc-fold-outer",s),"click",(function(t){t.preventDefault(),t.stopPropagation(),r.default.hasClass(s,"vc-toggle")?(r.default.removeClass(s,"vc-toggle"),r.default.removeClass(r.default.one(".vc-fold-inner",s),"vc-toggle"),r.default.removeClass(r.default.one(".vc-fold-outer",s),"vc-toggle")):(r.default.addClass(s,"vc-toggle"),r.default.addClass(r.default.one(".vc-fold-inner",s),"vc-toggle"),r.default.addClass(r.default.one(".vc-fold-outer",s),"vc-toggle"));var i=r.default.one(".vc-fold-inner",s);return setTimeout((function(){if(0==i.children.length&&e){for(var t=o.getObjAllKeys(e),a=0;a<t.length;a++){var s=void 0,u="undefined",d="";try{s=e[t[a]]}catch(e){continue}o.isString(s)?(u="string",s='"'+s+'"'):o.isNumber(s)?u="number":o.isBoolean(s)?u="boolean":o.isNull(s)?(u="null",s="null"):o.isUndefined(s)?(u="undefined",s="undefined"):o.isFunction(s)?(u="function",s="function()"):o.isSymbol(s)&&(u="symbol");var f=void 0;if(o.isArray(s)){var v=o.getObjName(s)+"["+s.length+"]";f=n.getFoldedLine(s,r.default.render(c.default,{key:t[a],keyType:d,value:v,valueType:"array"},!0))}else if(o.isObject(s)){var p=o.getObjName(s);f=n.getFoldedLine(s,r.default.render(c.default,{key:o.htmlEncode(t[a]),keyType:d,value:p,valueType:"object"},!0))}else{e.hasOwnProperty&&!e.hasOwnProperty(t[a])&&(d="private");var b={lineType:"kv",key:o.htmlEncode(t[a]),keyType:d,value:o.htmlEncode(s),valueType:u};f=r.default.render(l.default,b)}i.insertAdjacentElement("beforeend",f)}if(o.isObject(e)){var h,m=e.__proto__;h=o.isObject(m)?n.getFoldedLine(m,r.default.render(c.default,{key:"__proto__",keyType:"private",value:o.getObjName(m),valueType:"object"},!0)):r.default.render(c.default,{key:"__proto__",keyType:"private",value:"null",valueType:"null"}),i.insertAdjacentElement("beforeend",h)}}})),!1})),s}}])&&v(t.prototype,n),i&&v(t,i),u}(i.default);_.AddedLogID=[];var w=_;n.default=w,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t,n){"use strict";var o,r=function(){return void 0===o&&(o=Boolean(window&&document&&document.all&&!window.atob)),o},i=function(){var e={};return function(t){if(void 0===e[t]){var n=document.querySelector(t);if(window.HTMLIFrameElement&&n instanceof window.HTMLIFrameElement)try{n=n.contentDocument.head}catch(e){n=null}e[t]=n}return e[t]}}(),a=[];function l(e){for(var t=-1,n=0;n<a.length;n++)if(a[n].identifier===e){t=n;break}return t}function c(e,t){for(var n={},o=[],r=0;r<e.length;r++){var i=e[r],c=t.base?i[0]+t.base:i[0],s=n[c]||0,u="".concat(c," ").concat(s);n[c]=s+1;var d=l(u),f={css:i[1],media:i[2],sourceMap:i[3]};-1!==d?(a[d].references++,a[d].updater(f)):a.push({identifier:u,updater:h(f,t),references:1}),o.push(u)}return o}function s(e){var t=document.createElement("style"),o=e.attributes||{};if(void 0===o.nonce){var r=n.nc;r&&(o.nonce=r)}if(Object.keys(o).forEach((function(e){t.setAttribute(e,o[e])})),"function"==typeof e.insert)e.insert(t);else{var a=i(e.insert||"head");if(!a)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");a.appendChild(t)}return t}var u,d=(u=[],function(e,t){return u[e]=t,u.filter(Boolean).join("\n")});function f(e,t,n,o){var r=n?"":o.media?"@media ".concat(o.media," {").concat(o.css,"}"):o.css;if(e.styleSheet)e.styleSheet.cssText=d(t,r);else{var i=document.createTextNode(r),a=e.childNodes;a[t]&&e.removeChild(a[t]),a.length?e.insertBefore(i,a[t]):e.appendChild(i)}}function v(e,t,n){var o=n.css,r=n.media,i=n.sourceMap;if(r?e.setAttribute("media",r):e.removeAttribute("media"),i&&"undefined"!=typeof btoa&&(o+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(i))))," */")),e.styleSheet)e.styleSheet.cssText=o;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(o))}}var p=null,b=0;function h(e,t){var n,o,r;if(t.singleton){var i=b++;n=p||(p=s(t)),o=f.bind(null,n,i,!1),r=f.bind(null,n,i,!0)}else n=s(t),o=v.bind(null,n,t),r=function(){!function(e){if(null===e.parentNode)return!1;e.parentNode.removeChild(e)}(n)};return o(e),function(t){if(t){if(t.css===e.css&&t.media===e.media&&t.sourceMap===e.sourceMap)return;o(e=t)}else r()}}e.exports=function(e,t){(t=t||{}).singleton||"boolean"==typeof t.singleton||(t.singleton=r());var n=c(e=e||[],t);return function(e){if(e=e||[],"[object Array]"===Object.prototype.toString.call(e)){for(var o=0;o<n.length;o++){var r=l(n[o]);a[r].references--}for(var i=c(e,t),s=0;s<n.length;s++){var u=l(n[s]);0===a[u].references&&(a[u].updater(),a.splice(u,1))}n=i}}}},function(e,t,n){"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var n=function(e,t){var n=e[1]||"",o=e[3];if(!o)return n;if(t&&"function"==typeof btoa){var r=(a=o,l=btoa(unescape(encodeURIComponent(JSON.stringify(a)))),c="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(l),"/*# ".concat(c," */")),i=o.sources.map((function(e){return"/*# sourceURL=".concat(o.sourceRoot||"").concat(e," */")}));return[n].concat(i).concat([r]).join("\n")}var a,l,c;return[n].join("\n")}(t,e);return t[2]?"@media ".concat(t[2]," {").concat(n,"}"):n})).join("")},t.i=function(e,n,o){"string"==typeof e&&(e=[[null,e,""]]);var r={};if(o)for(var i=0;i<this.length;i++){var a=this[i][0];null!=a&&(r[a]=!0)}for(var l=0;l<e.length;l++){var c=[].concat(e[l]);o&&r[c[0]]||(n&&(c[2]?c[2]="".concat(n," and ").concat(c[2]):c[2]=n),t.push(c))}},t}},function(e,t,n){var o,r,i;"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(7)],void 0===(i="function"==typeof(o=function(n,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var r,i=(r=o,o=r&&r.__esModule?r:{default:r}).default;n.default=i,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t,n){var o,r,i;function a(e){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(8),n(9),n(0),n(1),n(11),n(13),n(14),n(15),n(16),n(17),n(2),n(3),n(21),n(24),n(26),n(30),n(38)],void 0===(i="function"==typeof(o=function(n,o,r,i,l,c,s,u,d,f,v,p,b,h,m,g,y,_){"use strict";function w(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return w=function(){return e},e}function C(e){return e&&e.__esModule?e:{default:e}}function x(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e)){var n=[],o=!0,r=!1,i=void 0;try{for(var a,l=e[Symbol.iterator]();!(o=(a=l.next()).done)&&(n.push(a.value),!t||n.length!==t);o=!0);}catch(e){r=!0,i=e}finally{try{o||null==l.return||l.return()}finally{if(r)throw i}}return n}}(e,t)||function(e,t){if(e){if("string"==typeof e)return k(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?k(e,t):void 0}}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function k(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,o=new Array(t);n<t;n++)o[n]=e[n];return o}function O(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,r=C(r),i=function(e){if(e&&e.__esModule)return e;if(null===e||"object"!==a(e)&&"function"!=typeof e)return{default:e};var t=w();if(t&&t.has(e))return t.get(e);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)){var i=o?Object.getOwnPropertyDescriptor(e,r):null;i&&(i.get||i.set)?Object.defineProperty(n,r,i):n[r]=e[r]}return n.default=e,t&&t.set(e,n),n}(i),l=C(l),s=C(s),u=C(u),d=C(d),f=C(f),v=C(v),p=C(p),b=C(b),h=C(h),m=C(m),g=C(g),y=C(y),_=C(_);var E=function(){function e(t){if(function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),l.default.one("#__vconsole"))console.debug("vConsole is already exists.");else{var n=this;if(this.version=r.default.version,this.$dom=null,this.isInited=!1,this.option={defaultPlugins:["system","network","element","storage"]},this.activedTab="",this.tabList=[],this.pluginList={},this.switchPos={hasMoved:!1,x:0,y:0,startX:0,startY:0,endX:0,endY:0},this.tool=i,this.$=l.default,i.isObject(t))for(var o in t)this.option[o]=t[o];this._addBuiltInPlugins();var a,c=function(){n.isInited||(n._render(),n._mockTap(),n._bindEvent(),n._autoRun())};if(void 0!==document)"loading"===document.readyState?l.default.bind(window,"DOMContentLoaded",c):c();else a=setTimeout((function e(){document&&"complete"==document.readyState?(a&&clearTimeout(a),c()):a=setTimeout(e,1)}),1)}}var t,n,o;return t=e,(n=[{key:"_addBuiltInPlugins",value:function(){this.addPlugin(new h.default("default","Log"));var e=this.option.defaultPlugins,t={system:{proto:m.default,name:"System"},network:{proto:g.default,name:"Network"},element:{proto:y.default,name:"Element"},storage:{proto:_.default,name:"Storage"}};if(e&&i.isArray(e))for(var n=0;n<e.length;n++){var o=t[e[n]];o?this.addPlugin(new o.proto(e[n],o.name)):console.debug("Unrecognized default plugin ID:",e[n])}}},{key:"_render",value:function(){if(!l.default.one("#__vconsole")){var e=document.createElement("div");e.innerHTML=s.default,document.documentElement.insertAdjacentElement("beforeend",e.children[0])}this.$dom=l.default.one("#__vconsole");var t=l.default.one(".vc-switch",this.$dom),n=1*i.getStorage("switch_x"),o=1*i.getStorage("switch_y"),r=x(this._getSwitchButtonSafeAreaXY(t,n,o),2);n=r[0],o=r[1],this.switchPos.x=n,this.switchPos.y=o,l.default.one(".vc-switch").style.right=n+"px",l.default.one(".vc-switch").style.bottom=o+"px";var a=window.devicePixelRatio||1,c=document.querySelector('[name="viewport"]');if(c&&c.content){var u=c.content.match(/initial\-scale\=\d+(\.\d+)?/);(u?parseFloat(u[0].split("=")[1]):1)<1&&(this.$dom.style.fontSize=13*a+"px")}l.default.one(".vc-mask",this.$dom).style.display="none",this.option.theme&&this.$dom.setAttribute("data-theme",this.option.theme)}},{key:"_getSwitchButtonSafeAreaXY",value:function(e,t,n){var o=Math.max(document.documentElement.offsetWidth,window.innerWidth),r=Math.max(document.documentElement.offsetHeight,window.innerHeight);return t+e.offsetWidth>o&&(t=o-e.offsetWidth),n+e.offsetHeight>r&&(n=r-e.offsetHeight),t<0&&(t=0),n<20&&(n=20),[t,n]}},{key:"_mockTap",value:function(){var e,t,n,o=!1,r=null;this.$dom.addEventListener("touchstart",(function(o){if(void 0===e){var i=o.targetTouches[0];t=i.pageX,n=i.pageY,e=o.timeStamp,r=o.target.nodeType===Node.TEXT_NODE?o.target.parentNode:o.target}}),!1),this.$dom.addEventListener("touchmove",(function(e){var r=e.changedTouches[0];(Math.abs(r.pageX-t)>10||Math.abs(r.pageY-n)>10)&&(o=!0)})),this.$dom.addEventListener("touchend",(function(t){if(!1===o&&t.timeStamp-e<700&&null!=r){var n=!1;switch(r.tagName.toLowerCase()){case"textarea":n=!0;break;case"input":switch(r.type){case"button":case"checkbox":case"file":case"image":case"radio":case"submit":n=!1;break;default:n=!r.disabled&&!r.readOnly}}if(n?r.focus():"function"==typeof window.getSelection&&getSelection().rangeCount||t.preventDefault(),!r.disabled&&!r.readOnly){var i=t.changedTouches[0],a=document.createEvent("MouseEvents");a.initMouseEvent("click",!0,!0,window,1,i.screenX,i.screenY,i.clientX,i.clientY,!1,!1,!1,!1,0,null),a.forwardedTouchEvent=!0,a.initEvent("click",!0,!0),r.dispatchEvent(a)}}e=void 0,o=!1,r=null}),!1)}},{key:"_bindEvent",value:function(){var e=this,t=l.default.one(".vc-switch",e.$dom);l.default.bind(t,"touchstart",(function(t){e.switchPos.startX=t.touches[0].pageX,e.switchPos.startY=t.touches[0].pageY,e.switchPos.hasMoved=!1})),l.default.bind(t,"touchend",(function(t){e.switchPos.hasMoved&&(e.switchPos.x=e.switchPos.endX,e.switchPos.y=e.switchPos.endY,e.switchPos.startX=0,e.switchPos.startY=0,e.switchPos.hasMoved=!1,i.setStorage("switch_x",e.switchPos.x),i.setStorage("switch_y",e.switchPos.y))})),l.default.bind(t,"touchmove",(function(n){if(!(n.touches.length<=0)){var o=n.touches[0].pageX-e.switchPos.startX,r=n.touches[0].pageY-e.switchPos.startY,i=Math.floor(e.switchPos.x-o),a=Math.floor(e.switchPos.y-r),l=x(e._getSwitchButtonSafeAreaXY(t,i,a),2);i=l[0],a=l[1],t.style.right=i+"px",t.style.bottom=a+"px",e.switchPos.endX=i,e.switchPos.endY=a,e.switchPos.hasMoved=!0,console.log(i,a),n.preventDefault()}})),l.default.bind(l.default.one(".vc-switch",e.$dom),"click",(function(){e.show()})),l.default.bind(l.default.one(".vc-hide",e.$dom),"click",(function(){e.hide()}));var n=l.default.one(".vc-mask",this.$dom),o=l.default.one(".vc-panel",this.$dom),r=window.transitionEnd(n).whichTransitionEnd(),a=function(){n.style.display="none",o.style.display="none"};r?l.default.bind(n,r,a):a(),l.default.bind(n,"click",(function(t){if(t.target!=l.default.one(".vc-mask"))return!1;e.hide()})),l.default.delegate(l.default.one(".vc-tabbar",e.$dom),"click",".vc-tab",(function(t){var n=this.dataset.tab;n!=e.activedTab&&e.showTab(n)}));var c=function(t){l.default.hasClass(e.$dom,"vc-toggle")||(t.style.display="none")};r?l.default.bind(o,r,(function(e){if(e.target!=o)return!1;c(e.target)})):c(o);var s=l.default.one(".vc-content",e.$dom),u=!1;l.default.bind(s,"touchstart",(function(e){var t=s.scrollTop,n=s.scrollHeight,o=t+s.offsetHeight;0===t?(s.scrollTop=1,0===s.scrollTop&&(l.default.hasClass(e.target,"vc-cmd-input")||(u=!0))):o===n&&(s.scrollTop=t-1,s.scrollTop===t&&(l.default.hasClass(e.target,"vc-cmd-input")||(u=!0)))})),l.default.bind(s,"touchmove",(function(e){u&&e.preventDefault()})),l.default.bind(s,"touchend",(function(e){u=!1}))}},{key:"_autoRun",value:function(){for(var e in this.isInited=!0,this.pluginList)this._initPlugin(this.pluginList[e]);this.tabList.length>0&&this.showTab(this.tabList[0]),this.triggerEvent("ready")}},{key:"triggerEvent",value:function(e,t){e="on"+e.charAt(0).toUpperCase()+e.slice(1),i.isFunction(this.option[e])&&this.option[e].apply(this,t)}},{key:"_initPlugin",value:function(e){var t=this;e.vConsole=this,e.trigger("init"),e.trigger("renderTab",(function(n){t.tabList.push(e.id);var o=l.default.render(u.default,{id:e.id,name:e.name});l.default.one(".vc-tabbar",t.$dom).insertAdjacentElement("beforeend",o);var r=l.default.render(d.default,{id:e.id});n&&(i.isString(n)?r.innerHTML+=n:i.isFunction(n.appendTo)?n.appendTo(r):i.isElement(n)&&r.insertAdjacentElement("beforeend",n)),l.default.one(".vc-content",t.$dom).insertAdjacentElement("beforeend",r)})),e.trigger("addTopBar",(function(n){if(n)for(var o=l.default.one(".vc-topbar",t.$dom),r=function(t){var r=n[t],a=l.default.render(f.default,{name:r.name||"Undefined",className:r.className||"",pluginID:e.id});if(r.data)for(var c in r.data)a.dataset[c]=r.data[c];i.isFunction(r.onClick)&&l.default.bind(a,"click",(function(t){!1===r.onClick.call(a)||(l.default.removeClass(l.default.all(".vc-topbar-"+e.id),"vc-actived"),l.default.addClass(a,"vc-actived"))})),o.insertAdjacentElement("beforeend",a)},a=0;a<n.length;a++)r(a)})),e.trigger("addTool",(function(n){if(n)for(var o=l.default.one(".vc-tool-last",t.$dom),r=function(t){var r=n[t],a=l.default.render(v.default,{name:r.name||"Undefined",pluginID:e.id});1==r.global&&l.default.addClass(a,"vc-global-tool"),i.isFunction(r.onClick)&&l.default.bind(a,"click",(function(e){r.onClick.call(a)})),o.parentNode.insertBefore(a,o)},a=0;a<n.length;a++)r(a)})),e.isReady=!0,e.trigger("ready")}},{key:"_triggerPluginsEvent",value:function(e){for(var t in this.pluginList)this.pluginList[t].isReady&&this.pluginList[t].trigger(e)}},{key:"_triggerPluginEvent",value:function(e,t){var n=this.pluginList[e];n&&n.isReady&&n.trigger(t)}},{key:"addPlugin",value:function(e){return void 0!==this.pluginList[e.id]?(console.debug("Plugin "+e.id+" has already been added."),!1):(this.pluginList[e.id]=e,this.isInited&&(this._initPlugin(e),1==this.tabList.length&&this.showTab(this.tabList[0])),!0)}},{key:"removePlugin",value:function(e){e=(e+"").toLowerCase();var t=this.pluginList[e];if(void 0===t)return console.debug("Plugin "+e+" does not exist."),!1;if(t.trigger("remove"),this.isInited){var n=l.default.one("#__vc_tab_"+e);n&&n.parentNode.removeChild(n);for(var o=l.default.all(".vc-topbar-"+e,this.$dom),r=0;r<o.length;r++)o[r].parentNode.removeChild(o[r]);var i=l.default.one("#__vc_log_"+e);i&&i.parentNode.removeChild(i);for(var a=l.default.all(".vc-tool-"+e,this.$dom),c=0;c<a.length;c++)a[c].parentNode.removeChild(a[c])}var s=this.tabList.indexOf(e);s>-1&&this.tabList.splice(s,1);try{delete this.pluginList[e]}catch(t){this.pluginList[e]=void 0}return this.activedTab==e&&this.tabList.length>0&&this.showTab(this.tabList[0]),!0}},{key:"show",value:function(){if(this.isInited){var e=this;l.default.one(".vc-panel",this.$dom).style.display="block",setTimeout((function(){l.default.addClass(e.$dom,"vc-toggle"),e._triggerPluginsEvent("showConsole"),l.default.one(".vc-mask",e.$dom).style.display="block"}),10)}}},{key:"hide",value:function(){this.isInited&&(l.default.removeClass(this.$dom,"vc-toggle"),this._triggerPluginsEvent("hideConsole"))}},{key:"showSwitch",value:function(){this.isInited&&(l.default.one(".vc-switch",this.$dom).style.display="block")}},{key:"hideSwitch",value:function(){this.isInited&&(l.default.one(".vc-switch",this.$dom).style.display="none")}},{key:"showTab",value:function(e){if(this.isInited){var t=l.default.one("#__vc_log_"+e);l.default.removeClass(l.default.all(".vc-tab",this.$dom),"vc-actived"),l.default.addClass(l.default.one("#__vc_tab_"+e),"vc-actived"),l.default.removeClass(l.default.all(".vc-logbox",this.$dom),"vc-actived"),l.default.addClass(t,"vc-actived");var n=l.default.all(".vc-topbar-"+e,this.$dom);l.default.removeClass(l.default.all(".vc-toptab",this.$dom),"vc-toggle"),l.default.addClass(n,"vc-toggle"),n.length>0?l.default.addClass(l.default.one(".vc-content",this.$dom),"vc-has-topbar"):l.default.removeClass(l.default.one(".vc-content",this.$dom),"vc-has-topbar"),l.default.removeClass(l.default.all(".vc-tool",this.$dom),"vc-toggle"),l.default.addClass(l.default.all(".vc-tool-"+e,this.$dom),"vc-toggle"),this.activedTab&&this._triggerPluginEvent(this.activedTab,"hide"),this.activedTab=e,this._triggerPluginEvent(this.activedTab,"show")}}},{key:"setOption",value:function(e,t){if(i.isString(e))this.option[e]=t,this._triggerPluginsEvent("updateOption");else if(i.isObject(e)){for(var n in e)this.option[n]=e[n];this._triggerPluginsEvent("updateOption")}else console.debug("The first parameter of vConsole.setOption() must be a string or an object.")}},{key:"destroy",value:function(){if(this.isInited){for(var e=Object.keys(this.pluginList),t=e.length-1;t>=0;t--)this.removePlugin(e[t]);this.$dom.parentNode.removeChild(this.$dom),this.isInited=!1}}}])&&O(t.prototype,n),o&&O(t,o),e}();E.VConsolePlugin=p.default,E.VConsoleLogPlugin=b.default,E.VConsoleDefaultPlugin=h.default,E.VConsoleSystemPlugin=m.default,E.VConsoleNetworkPlugin=g.default,E.VConsoleElementPlugin=y.default,E.VConsoleStoragePlugin=_.default;var T=E;n.default=T,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t){!function(e){"use strict";var t=function(e,t){this.element=e,this.type=t};t.prototype={add:function(e){this.callback=e,this.element.addEventListener(this.type,this.callback,!1)},remove:function(){this.element.removeEventListener(this.type,this.callback,!1)}};var n=function(e){this.element=e,this.transitionEnd=this.whichTransitionEnd(),this.event=new t(this.element,this.transitionEnd)};n.prototype={whichTransitionEnd:function(){var e={WebkitTransition:"webkitTransitionEnd",MozTransition:"transitionend",OTransition:"oTransitionEnd otransitionend",transition:"transitionend"};for(var t in e)if(void 0!==this.element.style[t])return e[t]},bind:function(e){this.event.add(e)},unbind:function(){this.event.remove()}};var o={list:[],getPosition:function(e){if(Array.prototype.indexOf)return this.list.indexOf(e);for(var t=0,n=this.list.length;t<n;t++)if(this.list[t]===e)return t;return-1},insert:function(e){var t=this.getPosition(e);return-1!==t||(this.list.push(e),this.list.push(new n(e)),t=this.getPosition(e)),this.list[t+1]}};e.transitionEnd=function(e){if(!e)throw"You need to pass an element as parameter!";var t=e[0]||e;return o.insert(t)}}(window)},function(e){e.exports=JSON.parse('{"name":"vconsole","version":"3.4.0","description":"A lightweight, extendable front-end developer tool for mobile web page.","homepage":"https://github.com/Tencent/vConsole","main":"dist/vconsole.min.js","typings":"dist/vconsole.min.d.ts","scripts":{"test":"mocha","build":"webpack","dev":"webpack-dev-server --config webpack.dev.config"},"keywords":["console","debug","mobile"],"repository":{"type":"git","url":"git+https://github.com/Tencent/vConsole.git"},"dependencies":{"mutation-observer":"^1.0.3","transitionEnd":"^1.0.2"},"devDependencies":{"@babel/core":"^7.12.10","@babel/plugin-proposal-class-properties":"^7.12.1","@babel/plugin-proposal-export-namespace-from":"^7.12.1","@babel/plugin-proposal-object-rest-spread":"^7.12.1","@babel/preset-env":"^7.12.11","babel-loader":"^8.2.2","babel-plugin-add-module-exports":"^1.0.4","chai":"^4.2.0","copy-webpack-plugin":"^5.1.2","css-loader":"^3.6.0","html-loader":"^0.5.5","jsdom":"^15.2.1","json-loader":"^0.5.7","less":"^3.13.1","less-loader":"^5.0.0","mocha":"^5.2.0","style-loader":"^1.3.0","webpack":"^4.44.2","webpack-cli":"^3.3.12","webpack-dev-server":"^3.11.0","webpack-merge":"^4.2.2"},"author":"Tencent","license":"MIT"}')},function(e,t,n){var o,r,i;"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t],void 0===(i="function"==typeof(o=function(n){"use strict";function o(e,t){var n;if("undefined"==typeof Symbol||null==e[Symbol.iterator]){if(Array.isArray(e)||(n=function(e,t){if(e){if("string"==typeof e)return r(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?r(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){n&&(e=n);var o=0,i=function(){};return{s:i,n:function(){return o>=e.length?{done:!0}:{done:!1,value:e[o++]}},e:function(e){throw e},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var a,l=!0,c=!1;return{s:function(){n=e[Symbol.iterator]()},n:function(){var e=n.next();return l=e.done,e},e:function(e){c=!0,a=e},f:function(){try{l||null==n.return||n.return()}finally{if(c)throw a}}}}function r(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,o=new Array(t);n<t;n++)o[n]=e[n];return o}Object.defineProperty(n,"__esModule",{value:!0}),n.default=function(e,t,n){var r=/\{\{([^\}]+)\}\}/g,i="",a="",l=0,c=[],s=function(e,t){""!==e&&(t?e.match(/^ ?else/g)?i+="} "+e+" {\n":e.match(/\/(if|for|switch)/g)?i+="}\n":e.match(/^ ?if|for|switch/g)?i+=e+" {\n":e.match(/^ ?(break|continue) ?$/g)?i+=e+";\n":e.match(/^ ?(case|default)/g)?i+=e+":\n":i+="arr.push("+e+");\n":i+='arr.push("'+e.replace(/"/g,'\\"')+'");\n')};for(window.__mito_data=t,window.__mito_code="",window.__mito_result="",e=(e=e.replace(/(\{\{ ?switch(.+?)\}\})[\r\n\t ]+\{\{/g,"$1{{")).replace(/^[\r\n]/,"").replace(/\n/g,"\\\n").replace(/\r/g,"\\\r"),a="(function(){\n",i="var arr = [];\n";c=r.exec(e);)s(e.slice(l,c.index),!1),s(c[1],!0),l=c.index+c[0].length;s(e.substr(l,e.length-l),!1),a+=i="with (__mito_data) {\n"+(i+='__mito_result = arr.join("");')+"\n}",a+="})();";var u,d="",f=o(document.getElementsByTagName("script"));try{for(f.s();!(u=f.n()).done;){var v=u.value;if(v.nonce){d=v.nonce;break}}}catch(e){f.e(e)}finally{f.f()}var p=document.createElement("SCRIPT");p.innerHTML=a,p.setAttribute("nonce",d),document.documentElement.appendChild(p);var b=__mito_result;if(document.documentElement.removeChild(p),!n){var h=document.createElement("DIV");h.innerHTML=b,b=h.children[0]}return b},e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t,n){var o=n(4),r=n(12);"string"==typeof(r=r.__esModule?r.default:r)&&(r=[[e.i,r,""]]);var i={insert:"head",singleton:!1};o(r,i);e.exports=r.locals||{}},function(e,t,n){(t=n(5)(!1)).push([e.i,'#__vconsole {\n  --VC-BG-0: #ededed;\n  --VC-BG-1: #f7f7f7;\n  --VC-BG-2: #fff;\n  --VC-BG-3: #f7f7f7;\n  --VC-BG-4: #4c4c4c;\n  --VC-BG-5: #fff;\n  --VC-FG-0: rgba(0, 0, 0, 0.9);\n  --VC-FG-HALF: rgba(0, 0, 0, 0.9);\n  --VC-FG-1: rgba(0, 0, 0, 0.5);\n  --VC-FG-2: rgba(0, 0, 0, 0.3);\n  --VC-FG-3: rgba(0, 0, 0, 0.1);\n  --VC-RED: #fa5151;\n  --VC-ORANGE: #fa9d3b;\n  --VC-YELLOW: #ffc300;\n  --VC-GREEN: #91d300;\n  --VC-LIGHTGREEN: #95ec69;\n  --VC-BRAND: #07c160;\n  --VC-BLUE: #10aeff;\n  --VC-INDIGO: #1485ee;\n  --VC-PURPLE: #6467f0;\n  --VC-LINK: #576b95;\n  --VC-TEXTGREEN: #06ae56;\n  --VC-FG: black;\n  --VC-BG: white;\n  --VC-BG-COLOR-ACTIVE: #ececec;\n  --VC-WARN-BG: #fff3cc;\n  --VC-WARN-BORDER: #ffe799;\n  --VC-ERROR-BG: #fedcdc;\n  --VC-ERROR-BORDER: #fdb9b9;\n  --VC-DOM-TAG-NAME-COLOR: #881280;\n  --VC-DOM-ATTRIBUTE-NAME-COLOR: #994500;\n  --VC-DOM-ATTRIBUTE-VALUE-COLOR: #1a1aa6;\n  --VC-CODE-KEY-FG: #881391;\n  --VC-CODE-PRIVATE-KEY-FG: #cfa1d3;\n  --VC-CODE-FUNC-FG: #0d22aa;\n  --VC-CODE-NUMBER-FG: #1c00cf;\n  --VC-CODE-STR-FG: #c41a16;\n  --VC-CODE-NULL-FG: #808080;\n  color: var(--VC-FG-0);\n  font-size: 13px;\n  font-family: Helvetica Neue, Helvetica, Arial, sans-serif;\n  -webkit-user-select: auto;\n  /* global */\n  /* compoment */\n}\n#__vconsole .vc-max-height {\n  max-height: 19.23076923em;\n}\n#__vconsole .vc-max-height-line {\n  max-height: 3.38461538em;\n}\n#__vconsole .vc-min-height {\n  min-height: 3.07692308em;\n}\n#__vconsole dd,\n#__vconsole dl,\n#__vconsole pre {\n  margin: 0;\n}\n#__vconsole .vc-switch {\n  display: block;\n  position: fixed;\n  right: 0.76923077em;\n  bottom: 0.76923077em;\n  color: #FFF;\n  background-color: var(--VC-BRAND);\n  line-height: 1;\n  font-size: 1.07692308em;\n  padding: 0.61538462em 1.23076923em;\n  z-index: 10000;\n  border-radius: 0.30769231em;\n  box-shadow: 0 0 0.61538462em rgba(0, 0, 0, 0.4);\n}\n#__vconsole .vc-mask {\n  display: none;\n  position: fixed;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background: rgba(0, 0, 0, 0);\n  z-index: 10001;\n  -webkit-transition: background 0.3s;\n  transition: background 0.3s;\n  -webkit-tap-highlight-color: transparent;\n  overflow-y: scroll;\n}\n#__vconsole .vc-panel {\n  display: none;\n  position: fixed;\n  min-height: 85%;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  z-index: 10002;\n  background-color: var(--VC-BG-0);\n  -webkit-transition: -webkit-transform 0.3s;\n  transition: -webkit-transform 0.3s;\n  transition: transform 0.3s;\n  transition: transform 0.3s, -webkit-transform 0.3s;\n  -webkit-transform: translate(0, 100%);\n  transform: translate(0, 100%);\n}\n#__vconsole .vc-tabbar {\n  border-bottom: 1px solid var(--VC-FG-3);\n  overflow-x: auto;\n  height: 3em;\n  width: auto;\n  white-space: nowrap;\n}\n#__vconsole .vc-tabbar .vc-tab {\n  display: inline-block;\n  line-height: 3em;\n  padding: 0 1.15384615em;\n  border-right: 1px solid var(--VC-FG-3);\n  text-decoration: none;\n  color: var(--VC-FG-0);\n  -webkit-tap-highlight-color: transparent;\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-tabbar .vc-tab:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-tabbar .vc-tab.vc-actived {\n  background-color: var(--VC-BG-1);\n}\n#__vconsole .vc-content {\n  background-color: var(--VC-BG-2);\n  overflow-x: hidden;\n  overflow-y: auto;\n  position: absolute;\n  top: 3.07692308em;\n  left: 0;\n  right: 0;\n  bottom: 3.07692308em;\n  -webkit-overflow-scrolling: touch;\n  margin-bottom: constant(safe-area-inset-bottom);\n  margin-bottom: env(safe-area-inset-bottom);\n}\n#__vconsole .vc-content.vc-has-topbar {\n  top: 5.46153846em;\n}\n#__vconsole .vc-topbar {\n  background-color: var(--VC-BG-1);\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-box-orient: horizontal;\n  -webkit-box-direction: normal;\n  -webkit-flex-direction: row;\n  -moz-box-orient: horizontal;\n  -moz-box-direction: normal;\n  -ms-flex-direction: row;\n  flex-direction: row;\n  -webkit-flex-wrap: wrap;\n  -ms-flex-wrap: wrap;\n  flex-wrap: wrap;\n  width: 100%;\n}\n#__vconsole .vc-topbar .vc-toptab {\n  display: none;\n  -webkit-box-flex: 1;\n  -webkit-flex: 1;\n  -moz-box-flex: 1;\n  -ms-flex: 1;\n  flex: 1;\n  line-height: 2.30769231em;\n  padding: 0 1.15384615em;\n  border-bottom: 1px solid var(--VC-FG-3);\n  text-decoration: none;\n  text-align: center;\n  color: var(--VC-FG-0);\n  -webkit-tap-highlight-color: transparent;\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-topbar .vc-toptab.vc-toggle {\n  display: block;\n}\n#__vconsole .vc-topbar .vc-toptab:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-topbar .vc-toptab.vc-actived {\n  border-bottom: 1px solid var(--VC-INDIGO);\n}\n#__vconsole .vc-logbox {\n  display: none;\n  position: relative;\n  min-height: 100%;\n}\n#__vconsole .vc-logbox i {\n  font-style: normal;\n}\n#__vconsole .vc-logbox .vc-log {\n  padding-bottom: 6em;\n  -webkit-tap-highlight-color: transparent;\n}\n#__vconsole .vc-logbox .vc-log:empty:before {\n  content: "Empty";\n  color: var(--VC-FG-1);\n  position: absolute;\n  top: 45%;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  font-size: 1.15384615em;\n  text-align: center;\n}\n#__vconsole .vc-logbox .vc-item {\n  margin: 0;\n  padding: 0.46153846em 0.61538462em;\n  overflow: hidden;\n  line-height: 1.3;\n  border-bottom: 1px solid var(--VC-FG-3);\n  word-break: break-word;\n}\n#__vconsole .vc-logbox .vc-item-info {\n  color: var(--VC-PURPLE);\n}\n#__vconsole .vc-logbox .vc-item-debug {\n  color: var(--VC-YELLOW);\n}\n#__vconsole .vc-logbox .vc-item-warn {\n  color: var(--VC-ORANGE);\n  border-color: var(--VC-WARN-BORDER);\n  background-color: var(--VC-WARN-BG);\n}\n#__vconsole .vc-logbox .vc-item-error {\n  color: var(--VC-RED);\n  border-color: var(--VC-ERROR-BORDER);\n  background-color: var(--VC-ERROR-BG);\n}\n#__vconsole .vc-logbox .vc-log.vc-log-partly .vc-item {\n  display: none;\n}\n#__vconsole .vc-logbox .vc-log.vc-log-partly-log .vc-item-log,\n#__vconsole .vc-logbox .vc-log.vc-log-partly-info .vc-item-info,\n#__vconsole .vc-logbox .vc-log.vc-log-partly-warn .vc-item-warn,\n#__vconsole .vc-logbox .vc-log.vc-log-partly-error .vc-item-error {\n  display: block;\n}\n#__vconsole .vc-logbox .vc-item.hide {\n  display: none;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-content {\n  margin-right: 4.61538462em;\n  display: inline-block;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-repeat {\n  display: inline-block;\n  margin-right: 0.30769231em;\n  padding: 0 6.5px;\n  color: #D7E0EF;\n  background-color: #42597F;\n  border-radius: 8.66666667px;\n}\n#__vconsole .vc-logbox .vc-item.vc-item-error .vc-item-repeat {\n  color: #901818;\n  background-color: var(--VC-RED);\n}\n#__vconsole .vc-logbox .vc-item.vc-item-warn .vc-item-repeat {\n  color: #987D20;\n  background-color: #F4BD02;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code {\n  display: block;\n  white-space: pre-wrap;\n  overflow: auto;\n  position: relative;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-input,\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-output {\n  padding-left: 0.92307692em;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-input:before,\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-output:before {\n  content: "›";\n  position: absolute;\n  top: -0.23076923em;\n  left: 0;\n  font-size: 1.23076923em;\n  color: #6A5ACD;\n}\n#__vconsole .vc-logbox .vc-item .vc-item-code.vc-item-code-output:before {\n  content: "‹";\n}\n#__vconsole .vc-logbox .vc-item .vc-fold {\n  display: block;\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer {\n  display: block;\n  font-style: italic;\n  padding-left: 0.76923077em;\n  position: relative;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer:active {\n  background-color: var(--VC-BG-COLOR-ACTIVE);\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer:before {\n  content: "";\n  position: absolute;\n  top: 0.30769231em;\n  left: 0.15384615em;\n  width: 0;\n  height: 0;\n  border: transparent solid 0.30769231em;\n  border-left-color: var(--VC-FG-1);\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer.vc-toggle:before {\n  top: 0.46153846em;\n  left: 0;\n  border-top-color: var(--VC-FG-1);\n  border-left-color: transparent;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-inner {\n  display: none;\n  margin-left: 0.76923077em;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-inner.vc-toggle {\n  display: block;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-inner .vc-code-key {\n  margin-left: 0.76923077em;\n}\n#__vconsole .vc-logbox .vc-item .vc-fold .vc-fold-outer .vc-code-key {\n  margin-left: 0;\n}\n#__vconsole .vc-logbox .vc-code-key {\n  color: var(--VC-CODE-KEY-FG);\n}\n#__vconsole .vc-logbox .vc-code-private-key {\n  color: var(--VC-CODE-PRIVATE-KEY-FG);\n}\n#__vconsole .vc-logbox .vc-code-function {\n  color: var(--VC-CODE-FUNC-FG);\n  font-style: italic;\n}\n#__vconsole .vc-logbox .vc-code-number,\n#__vconsole .vc-logbox .vc-code-boolean {\n  color: var(--VC-CODE-NUMBER-FG);\n}\n#__vconsole .vc-logbox .vc-code-string {\n  color: var(--VC-CODE-STR-FG);\n}\n#__vconsole .vc-logbox .vc-code-null,\n#__vconsole .vc-logbox .vc-code-undefined {\n  color: var(--VC-CODE-NULL-FG);\n}\n#__vconsole .vc-logbox .vc-cmd {\n  position: absolute;\n  height: 3.07692308em;\n  left: 0;\n  right: 0;\n  bottom: 41px;\n  border-top: 1px solid var(--VC-FG-3);\n  display: block!important;\n}\n#__vconsole .vc-logbox .vc-cmd.vc-filter {\n  bottom: 0;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-input-wrap {\n  display: block;\n  height: 2.15384615em;\n  margin-right: 3.07692308em;\n  padding: 0.46153846em 0.61538462em;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-input {\n  width: 100%;\n  border: none;\n  resize: none;\n  outline: none;\n  padding: 0;\n  font-size: 0.92307692em;\n  background-color: transparent;\n  color: var(--VC-FG-0);\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-input::-webkit-input-placeholder {\n  line-height: 2.15384615em;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-btn {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  width: 3.07692308em;\n  border: none;\n  background-color: var(--VC-BG-0);\n  color: var(--VC-FG-0);\n  outline: none;\n  -webkit-touch-callout: none;\n  font-size: 1em;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-btn:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-prompted {\n  position: fixed;\n  width: 100%;\n  background-color: var(--VC-BG-3);\n  border: 1px solid var(--VC-FG-3);\n  overflow-x: scroll;\n  display: none;\n}\n#__vconsole .vc-logbox .vc-cmd .vc-cmd-prompted li {\n  list-style: none;\n  line-height: 30px;\n  padding: 0 0.46153846em;\n  border-bottom: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-group .vc-group-preview {\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-logbox .vc-group .vc-group-preview:active {\n  background-color: var(--VC-BG-COLOR-ACTIVE);\n}\n#__vconsole .vc-logbox .vc-group .vc-group-detail {\n  display: none;\n  padding: 0 0 0.76923077em 1.53846154em;\n  border-bottom: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-group.vc-actived .vc-group-detail {\n  display: block;\n  background-color: var(--VC-BG-1);\n}\n#__vconsole .vc-logbox .vc-group.vc-actived .vc-table-row {\n  background-color: var(--VC-BG-2);\n}\n#__vconsole .vc-logbox .vc-group.vc-actived .vc-group-preview {\n  background-color: var(--VC-BG-1);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row {\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-box-orient: horizontal;\n  -webkit-box-direction: normal;\n  -webkit-flex-direction: row;\n  -moz-box-orient: horizontal;\n  -moz-box-direction: normal;\n  -ms-flex-direction: row;\n  flex-direction: row;\n  -webkit-flex-wrap: wrap;\n  -ms-flex-wrap: wrap;\n  flex-wrap: wrap;\n  overflow: hidden;\n  border-bottom: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row.vc-left-border {\n  border-left: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col {\n  -webkit-box-flex: 1;\n  -webkit-flex: 1;\n  -moz-box-flex: 1;\n  -ms-flex: 1;\n  flex: 1;\n  padding: 0.23076923em 0.30769231em;\n  border-left: 1px solid var(--VC-FG-3);\n  overflow: auto;\n  white-space: pre-wrap;\n  word-break: break-word;\n  /*white-space: nowrap;\n        text-overflow: ellipsis;*/\n  -webkit-overflow-scrolling: touch;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col:first-child {\n  border: none;\n}\n#__vconsole .vc-logbox .vc-table .vc-small .vc-table-col {\n  padding: 0 0.30769231em;\n  font-size: 0.92307692em;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-2 {\n  -webkit-box-flex: 2;\n  -webkit-flex: 2;\n  -moz-box-flex: 2;\n  -ms-flex: 2;\n  flex: 2;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-3 {\n  -webkit-box-flex: 3;\n  -webkit-flex: 3;\n  -moz-box-flex: 3;\n  -ms-flex: 3;\n  flex: 3;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-4 {\n  -webkit-box-flex: 4;\n  -webkit-flex: 4;\n  -moz-box-flex: 4;\n  -ms-flex: 4;\n  flex: 4;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-5 {\n  -webkit-box-flex: 5;\n  -webkit-flex: 5;\n  -moz-box-flex: 5;\n  -ms-flex: 5;\n  flex: 5;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-6 {\n  -webkit-box-flex: 6;\n  -webkit-flex: 6;\n  -moz-box-flex: 6;\n  -ms-flex: 6;\n  flex: 6;\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row-error {\n  border-color: var(--VC-ERROR-BORDER);\n  background-color: var(--VC-ERROR-BG);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-row-error .vc-table-col {\n  color: var(--VC-RED);\n  border-color: var(--VC-ERROR-BORDER);\n}\n#__vconsole .vc-logbox .vc-table .vc-table-col-title {\n  font-weight: bold;\n}\n#__vconsole .vc-logbox.vc-actived {\n  display: block;\n}\n#__vconsole .vc-toolbar {\n  border-top: 1px solid var(--VC-FG-3);\n  line-height: 3em;\n  position: absolute;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  display: -webkit-box;\n  display: -webkit-flex;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: flex;\n  -webkit-box-orient: horizontal;\n  -webkit-box-direction: normal;\n  -webkit-flex-direction: row;\n  -moz-box-orient: horizontal;\n  -moz-box-direction: normal;\n  -ms-flex-direction: row;\n  flex-direction: row;\n}\n#__vconsole .vc-toolbar .vc-tool {\n  display: none;\n  text-decoration: none;\n  color: var(--VC-FG-0);\n  width: 50%;\n  -webkit-box-flex: 1;\n  -webkit-flex: 1;\n  -moz-box-flex: 1;\n  -ms-flex: 1;\n  flex: 1;\n  text-align: center;\n  position: relative;\n  -webkit-touch-callout: none;\n}\n#__vconsole .vc-toolbar .vc-tool.vc-toggle,\n#__vconsole .vc-toolbar .vc-tool.vc-global-tool {\n  display: block;\n}\n#__vconsole .vc-toolbar .vc-tool:active {\n  background-color: rgba(0, 0, 0, 0.15);\n}\n#__vconsole .vc-toolbar .vc-tool:after {\n  content: " ";\n  position: absolute;\n  top: 0.53846154em;\n  bottom: 0.53846154em;\n  right: 0;\n  border-left: 1px solid var(--VC-FG-3);\n}\n#__vconsole .vc-toolbar .vc-tool-last:after {\n  border: none;\n}\n@supports (bottom: constant(safe-area-inset-bottom)) or (bottom: env(safe-area-inset-bottom)) {\n  #__vconsole .vc-toolbar,\n  #__vconsole .vc-switch {\n    bottom: constant(safe-area-inset-bottom);\n    bottom: env(safe-area-inset-bottom);\n  }\n}\n#__vconsole.vc-toggle .vc-switch {\n  display: none;\n}\n#__vconsole.vc-toggle .vc-mask {\n  background: rgba(0, 0, 0, 0.6);\n  display: block;\n}\n#__vconsole.vc-toggle .vc-panel {\n  -webkit-transform: translate(0, 0);\n  transform: translate(0, 0);\n}\n@media (prefers-color-scheme: dark) {\n  #__vconsole:not([data-theme="light"]) {\n    --VC-BG-0: #191919;\n    --VC-BG-1: #1f1f1f;\n    --VC-BG-2: #232323;\n    --VC-BG-3: #2f2f2f;\n    --VC-BG-4: #606060;\n    --VC-BG-5: #2c2c2c;\n    --VC-FG-0: rgba(255, 255, 255, 0.8);\n    --VC-FG-HALF: rgba(255, 255, 255, 0.6);\n    --VC-FG-1: rgba(255, 255, 255, 0.5);\n    --VC-FG-2: rgba(255, 255, 255, 0.3);\n    --VC-FG-3: rgba(255, 255, 255, 0.05);\n    --VC-RED: #fa5151;\n    --VC-ORANGE: #c87d2f;\n    --VC-YELLOW: #cc9c00;\n    --VC-GREEN: #74a800;\n    --VC-LIGHTGREEN: #28b561;\n    --VC-BRAND: #07c160;\n    --VC-BLUE: #10aeff;\n    --VC-INDIGO: #1196ff;\n    --VC-PURPLE: #8183ff;\n    --VC-LINK: #7d90a9;\n    --VC-TEXTGREEN: #259c5c;\n    --VC-FG: white;\n    --VC-BG: black;\n    --VC-BG-COLOR-ACTIVE: #282828;\n    --VC-WARN-BG: #332700;\n    --VC-WARN-BORDER: #664e00;\n    --VC-ERROR-BG: #321010;\n    --VC-ERROR-BORDER: #642020;\n    --VC-DOM-TAG-NAME-COLOR: #5DB0D7;\n    --VC-DOM-ATTRIBUTE-NAME-COLOR: #9BBBDC;\n    --VC-DOM-ATTRIBUTE-VALUE-COLOR: #f29766;\n    --VC-CODE-KEY-FG: #e36eec;\n    --VC-CODE-PRIVATE-KEY-FG: #f4c5f7;\n    --VC-CODE-FUNC-FG: #556af2;\n    --VC-CODE-NUMBER-FG: #9980ff;\n    --VC-CODE-STR-FG: #e93f3b;\n    --VC-CODE-NULL-FG: #808080;\n  }\n}\n#__vconsole[data-theme="dark"] {\n  --VC-BG-0: #191919;\n  --VC-BG-1: #1f1f1f;\n  --VC-BG-2: #232323;\n  --VC-BG-3: #2f2f2f;\n  --VC-BG-4: #606060;\n  --VC-BG-5: #2c2c2c;\n  --VC-FG-0: rgba(255, 255, 255, 0.8);\n  --VC-FG-HALF: rgba(255, 255, 255, 0.6);\n  --VC-FG-1: rgba(255, 255, 255, 0.5);\n  --VC-FG-2: rgba(255, 255, 255, 0.3);\n  --VC-FG-3: rgba(255, 255, 255, 0.05);\n  --VC-RED: #fa5151;\n  --VC-ORANGE: #c87d2f;\n  --VC-YELLOW: #cc9c00;\n  --VC-GREEN: #74a800;\n  --VC-LIGHTGREEN: #28b561;\n  --VC-BRAND: #07c160;\n  --VC-BLUE: #10aeff;\n  --VC-INDIGO: #1196ff;\n  --VC-PURPLE: #8183ff;\n  --VC-LINK: #7d90a9;\n  --VC-TEXTGREEN: #259c5c;\n  --VC-FG: white;\n  --VC-BG: black;\n  --VC-BG-COLOR-ACTIVE: #282828;\n  --VC-WARN-BG: #332700;\n  --VC-WARN-BORDER: #664e00;\n  --VC-ERROR-BG: #321010;\n  --VC-ERROR-BORDER: #642020;\n  --VC-DOM-TAG-NAME-COLOR: #5DB0D7;\n  --VC-DOM-ATTRIBUTE-NAME-COLOR: #9BBBDC;\n  --VC-DOM-ATTRIBUTE-VALUE-COLOR: #f29766;\n  --VC-CODE-KEY-FG: #e36eec;\n  --VC-CODE-PRIVATE-KEY-FG: #f4c5f7;\n  --VC-CODE-FUNC-FG: #556af2;\n  --VC-CODE-NUMBER-FG: #9980ff;\n  --VC-CODE-STR-FG: #e93f3b;\n  --VC-CODE-NULL-FG: #808080;\n}\n',""]),e.exports=t},function(e,t){e.exports='<div id="__vconsole" class="">\n  <div class="vc-switch">vConsole</div>\n  <div class="vc-mask">\n  </div>\n  <div class="vc-panel">\n    <div class="vc-tabbar">\n    </div>\n    <div class="vc-topbar">\n    </div>\n    <div class="vc-content">\n    </div>\n    <div class="vc-toolbar">\n      <a class="vc-tool vc-global-tool vc-tool-last vc-hide">Hide</a>\n    </div>\n  </div>\n</div>'},function(e,t){e.exports='<a class="vc-tab" data-tab="{{id}}" id="__vc_tab_{{id}}">{{name}}</a>'},function(e,t){e.exports='<div class="vc-logbox" id="__vc_log_{{id}}">\n  \n</div>'},function(e,t){e.exports='<a class="vc-toptab vc-topbar-{{pluginID}}{{if (className)}} {{className}}{{/if}}">{{name}}</a>'},function(e,t){e.exports='<a class="vc-tool vc-tool-{{pluginID}}">{{name}}</a>'},function(e,t){e.exports='<div id="{{_id}}" class="vc-item vc-item-{{logType}} {{style}}">\n\t<div class="vc-item-content"></div>\n</div>'},function(e,t){e.exports='<div class="vc-fold">\n  {{if (lineType == \'obj\')}}\n    <i class="vc-fold-outer">{{outer}}</i>\n    <div class="vc-fold-inner"></div>\n  {{else if (lineType == \'value\')}}\n    <i class="vc-code-{{valueType}}">{{value}}</i>\n  {{else if (lineType == \'kv\')}}\n    <i class="vc-code-key{{if (keyType)}} vc-code-{{keyType}}-key{{/if}}">{{key}}</i>: <i class="vc-code-{{valueType}}">{{value}}</i>\n  {{/if}}\n</div>'},function(e,t){e.exports='<span>\n  <i class="vc-code-key{{if (keyType)}} vc-code-{{keyType}}-key{{/if}}">{{key}}</i>: <i class="vc-code-{{valueType}}">{{value}}</i>\n</span>'},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__,factory;"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,factory=function(_exports,_query,tool,_log,_tabbox_default,_item_code){"use strict";function _getRequireWildcardCache(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return _getRequireWildcardCache=function(){return e},e}function _interopRequireWildcard(e){if(e&&e.__esModule)return e;if(null===e||"object"!==_typeof(e)&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache();if(t&&t.has(e))return t.get(e);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)){var i=o?Object.getOwnPropertyDescriptor(e,r):null;i&&(i.get||i.set)?Object.defineProperty(n,r,i):n[r]=e[r]}return n.default=e,t&&t.set(e,n),n}function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _createForOfIteratorHelper(e,t){var n;if("undefined"==typeof Symbol||null==e[Symbol.iterator]){if(Array.isArray(e)||(n=_unsupportedIterableToArray(e))||t&&e&&"number"==typeof e.length){n&&(e=n);var o=0,r=function(){};return{s:r,n:function(){return o>=e.length?{done:!0}:{done:!1,value:e[o++]}},e:function(e){throw e},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){n=e[Symbol.iterator]()},n:function(){var e=n.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==n.return||n.return()}finally{if(l)throw i}}}}function _unsupportedIterableToArray(e,t){if(e){if("string"==typeof e)return _arrayLikeToArray(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?_arrayLikeToArray(e,t):void 0}}function _arrayLikeToArray(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,o=new Array(t);n<t;n++)o[n]=e[n];return o}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function _createClass(e,t,n){return t&&_defineProperties(e.prototype,t),n&&_defineProperties(e,n),e}function _get(e,t,n){return(_get="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,n){var o=_superPropBase(e,t);if(o){var r=Object.getOwnPropertyDescriptor(o,t);return r.get?r.get.call(n):r.value}})(e,t,n||e)}function _superPropBase(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=_getPrototypeOf(e)););return e}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&_setPrototypeOf(e,t)}function _setPrototypeOf(e,t){return(_setPrototypeOf=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function _createSuper(e){var t=_isNativeReflectConstruct();return function(){var n,o=_getPrototypeOf(e);if(t){var r=_getPrototypeOf(this).constructor;n=Reflect.construct(o,arguments,r)}else n=o.apply(this,arguments);return _possibleConstructorReturn(this,n)}}function _possibleConstructorReturn(e,t){return!t||"object"!==_typeof(t)&&"function"!=typeof t?_assertThisInitialized(e):t}function _assertThisInitialized(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function _isNativeReflectConstruct(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return!1}}function _getPrototypeOf(e){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0,_query=_interopRequireDefault(_query),tool=_interopRequireWildcard(tool),_log=_interopRequireDefault(_log),_tabbox_default=_interopRequireDefault(_tabbox_default),_item_code=_interopRequireDefault(_item_code);var filterText="",checkFilterInLine=function(e){return-1===e.innerHTML.toUpperCase().indexOf(filterText.toUpperCase())},VConsoleDefaultTab=function(_VConsoleLogTab){_inherits(VConsoleDefaultTab,_VConsoleLogTab);var _super=_createSuper(VConsoleDefaultTab);function VConsoleDefaultTab(){var e;_classCallCheck(this,VConsoleDefaultTab);for(var t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];return(e=_super.call.apply(_super,[this].concat(n))).tplTabbox=_tabbox_default.default,e}return _createClass(VConsoleDefaultTab,[{key:"formatLine",value:function(e){return checkFilterInLine(e)?_query.default.addClass(e,"hide"):_query.default.removeClass(e,"hide"),e}},{key:"onReady",value:function onReady(){var that=this;_get(_getPrototypeOf(VConsoleDefaultTab.prototype),"onReady",this).call(this);var keyBlackList=["webkitStorageInfo"];window.winKeys=Object.getOwnPropertyNames(window).sort(),window.keyTypes={};for(var i=0;i<winKeys.length;i++)keyBlackList.indexOf(winKeys[i])>-1||(keyTypes[winKeys[i]]=_typeof(window[winKeys[i]]));var cacheObj={},ID_REGEX=/[a-zA-Z_0-9\$\-\u00A2-\uFFFF]/,retrievePrecedingIdentifier=function(e,t,n){n=n||ID_REGEX;for(var o=[],r=t-1;r>=0&&n.test(e[r]);r--)o.push(e[r]);if(0==o.length){n=/\./;for(var i=t-1;i>=0&&n.test(e[i]);i--)o.push(e[i])}if(0===o.length){var a=e.match(/[\(\)\[\]\{\}]/gi)||[];return a[a.length-1]}return o.reverse().join("")},moveCursorToPos=function(e,t){e.setSelectionRange&&e.setSelectionRange(t,t)},$input=_query.default.one(".vc-cmd-input");_query.default.bind($input,"keyup",(function(e){var isDeleteKeyCode=8===e.keyCode||46===e.keyCode,$prompted=_query.default.one(".vc-cmd-prompted");$prompted.style.display="none",$prompted.innerHTML="";var tempValue=this.value,value=retrievePrecedingIdentifier(this.value,this.value.length);if(value&&value.length>0){if(/\(/.test(value)&&!isDeleteKeyCode)return $input.value+=")",void moveCursorToPos($input,$input.value.length-1);if(/\[/.test(value)&&!isDeleteKeyCode)return $input.value+="]",void moveCursorToPos($input,$input.value.length-1);if(/\{/.test(value)&&!isDeleteKeyCode)return $input.value+="}",void moveCursorToPos($input,$input.value.length-1);if("."===value){var key=retrievePrecedingIdentifier(tempValue,tempValue.length-1);if(!cacheObj[key])try{cacheObj[key]=Object.getOwnPropertyNames(eval("("+key+")")).sort()}catch(e){}try{for(var _i3=0;_i3<cacheObj[key].length;_i3++){var $li=document.createElement("li"),_key=cacheObj[key][_i3];$li.innerHTML=_key,$li.onclick=function(){$input.value="",$input.value=tempValue+this.innerHTML,$prompted.style.display="none"},$prompted.appendChild($li)}}catch(e){}}else if("."!==value.substring(value.length-1)&&value.indexOf(".")<0){for(var _i4=0;_i4<winKeys.length;_i4++)if(winKeys[_i4].toLowerCase().indexOf(value.toLowerCase())>=0){var _$li=document.createElement("li");_$li.innerHTML=winKeys[_i4],_$li.onclick=function(){$input.value="",$input.value=this.innerHTML,"function"==keyTypes[this.innerHTML]&&($input.value+="()"),$prompted.style.display="none"},$prompted.appendChild(_$li)}}else{var arr=value.split(".");if(cacheObj[arr[0]]){cacheObj[arr[0]].sort();for(var _i5=0;_i5<cacheObj[arr[0]].length;_i5++){var _$li2=document.createElement("li"),_key3=cacheObj[arr[0]][_i5];_key3.indexOf(arr[1])>=0&&(_$li2.innerHTML=_key3,_$li2.onclick=function(){$input.value="",$input.value=tempValue+this.innerHTML,$prompted.style.display="none"},$prompted.appendChild(_$li2))}}}if($prompted.children.length>0){var m=Math.min(200,31*$prompted.children.length);$prompted.style.display="block",$prompted.style.height=m+"px",$prompted.style.marginTop=-m+"px"}}else $prompted.style.display="none"})),_query.default.bind(_query.default.one(".vc-cmd",this.$tabbox),"submit",(function(e){e.preventDefault();var t=_query.default.one(".vc-cmd-input",e.target),n=t.value;t.value="",""!==n&&that.evalCommand(n);var o=_query.default.one(".vc-cmd-prompted");o&&(o.style.display="none")})),_query.default.bind(_query.default.one(".vc-cmd.vc-filter",this.$tabbox),"submit",(function(e){e.preventDefault();var t=_query.default.one(".vc-cmd.vc-filter .vc-cmd-input",e.target);filterText=t.value,_query.default.all(".vc-log>.vc-item").forEach((function(e){checkFilterInLine(e)?_query.default.addClass(e,"hide"):_query.default.removeClass(e,"hide")}))}));var code="";code+="if (!!window) {",code+="window.__vConsole_cmd_result = undefined;",code+="window.__vConsole_cmd_error = false;",code+="}";var scriptList=document.getElementsByTagName("script"),nonce="",_iterator=_createForOfIteratorHelper(scriptList),_step;try{for(_iterator.s();!(_step=_iterator.n()).done;){var _script=_step.value;if(_script.nonce){nonce=_script.nonce;break}}}catch(e){_iterator.e(e)}finally{_iterator.f()}var script=document.createElement("SCRIPT");script.innerHTML=code,script.setAttribute("nonce",nonce),document.documentElement.appendChild(script),document.documentElement.removeChild(script)}},{key:"mockConsole",value:function(){_get(_getPrototypeOf(VConsoleDefaultTab.prototype),"mockConsole",this).call(this);var e=this;tool.isFunction(window.onerror)&&(this.windowOnError=window.onerror),window.onerror=function(t,n,o,r,i){var a=t;n&&(a+="\n"+n.replace(location.origin,"")),(o||r)&&(a+=":"+o+":"+r);var l=!!i&&!!i.stack&&i.stack.toString()||"";e.printLog({logType:"error",logs:[a,l],noOrigin:!0}),tool.isFunction(e.windowOnError)&&e.windowOnError.call(window,t,n,o,r,i)}}},{key:"evalCommand",value:function(e){this.printLog({logType:"log",content:_query.default.render(_item_code.default,{content:e,type:"input"}),style:""});var t,n=void 0;try{n=eval.call(window,"("+e+")")}catch(t){try{n=eval.call(window,e)}catch(e){}}tool.isArray(n)||tool.isObject(n)?t=this.getFoldedLine(n):(tool.isNull(n)?n="null":tool.isUndefined(n)?n="undefined":tool.isFunction(n)?n="function()":tool.isString(n)&&(n='"'+n+'"'),t=_query.default.render(_item_code.default,{content:n,type:"output"})),this.printLog({logType:"log",content:t,style:""}),window.winKeys=Object.getOwnPropertyNames(window).sort()}}]),VConsoleDefaultTab}(_log.default),_default=VConsoleDefaultTab;_exports.default=_default,module.exports=exports.default},__WEBPACK_AMD_DEFINE_ARRAY__=[exports,__webpack_require__(1),__webpack_require__(0),__webpack_require__(3),__webpack_require__(22),__webpack_require__(23)],void 0===(__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof(__WEBPACK_AMD_DEFINE_FACTORY__=factory)?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__)||(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)},function(e,t){e.exports='<div>\n  <div class="vc-log"></div>\n  <form class="vc-cmd">\n    <button class="vc-cmd-btn" type="submit">OK</button>\n    <ul class=\'vc-cmd-prompted\'></ul>\n    <div class="vc-cmd-input-wrap">\n      <textarea class="vc-cmd-input" placeholder="command..."></textarea>\n    </div>\n  </form>\n  <form class="vc-cmd vc-filter">\n    <button class="vc-cmd-btn" type="submit">filter</button>\n    <ul class=\'vc-cmd-prompted\'></ul>\n    <div class="vc-cmd-input-wrap">\n      <textarea class="vc-cmd-input" placeholder="filter..."></textarea>\n    </div>\n  </form>\n</div>\n'},function(e,t){e.exports='<pre class="vc-item-code vc-item-code-{{type}}">{{content}}</pre>'},function(e,t,n){var o,r,i;function a(e){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(3),n(25)],void 0===(i="function"==typeof(o=function(n,o,r){"use strict";function i(e){return e&&e.__esModule?e:{default:e}}function l(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function c(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function s(e,t,n){return(s="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,n){var o=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=v(e)););return e}(e,t);if(o){var r=Object.getOwnPropertyDescriptor(o,t);return r.get?r.get.call(n):r.value}})(e,t,n||e)}function u(e,t){return(u=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function d(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,o=v(e);if(t){var r=v(this).constructor;n=Reflect.construct(o,arguments,r)}else n=o.apply(this,arguments);return f(this,n)}}function f(e,t){return!t||"object"!==a(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function v(e){return(v=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,o=i(o),r=i(r);var p=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&u(e,t)}(a,e);var t,n,o,i=d(a);function a(){var e;l(this,a);for(var t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];return(e=i.call.apply(i,[this].concat(n))).tplTabbox=r.default,e.allowUnformattedLog=!1,e}return t=a,(n=[{key:"onInit",value:function(){s(v(a.prototype),"onInit",this).call(this),this.printSystemInfo()}},{key:"printSystemInfo",value:function(){var e=navigator.userAgent,t="";console.info("[system]","Location:",location.href);var n=e.match(/(ipod).*\s([\d_]+)/i),o=e.match(/(ipad).*\s([\d_]+)/i),r=e.match(/(iphone)\sos\s([\d_]+)/i),i=e.match(/(android)\s([\d\.]+)/i);t="Unknown",i?t="Android "+i[2]:r?t="iPhone, iOS "+r[2].replace(/_/g,"."):o?t="iPad, iOS "+o[2].replace(/_/g,"."):n&&(t="iPod, iOS "+n[2].replace(/_/g,"."));var a=t,l=e.match(/MicroMessenger\/([\d\.]+)/i);t="Unknown",l&&l[1]?(a+=", WeChat "+(t=l[1]),console.info("[system]","System:",a)):console.info("[system]","System:",a);var c=e.toLowerCase().match(/ nettype\/([^ ]+)/g);t="Unknown",c&&c[0]&&(t=(c=c[0].split("/"))[1],console.info("[system]","Network:",t)),console.info("[system]","UA:",e),setTimeout((function(){var e=window.performance||window.msPerformance||window.webkitPerformance;if(e&&e.timing){var t=e.timing;t.navigationStart&&console.info("[system]","navigationStart:",t.navigationStart),t.navigationStart&&t.domainLookupStart&&console.info("[system]","navigation:",t.domainLookupStart-t.navigationStart+"ms"),t.domainLookupEnd&&t.domainLookupStart&&console.info("[system]","dns:",t.domainLookupEnd-t.domainLookupStart+"ms"),t.connectEnd&&t.connectStart&&(t.connectEnd&&t.secureConnectionStart?console.info("[system]","tcp (ssl):",t.connectEnd-t.connectStart+"ms ("+(t.connectEnd-t.secureConnectionStart)+"ms)"):console.info("[system]","tcp:",t.connectEnd-t.connectStart+"ms")),t.responseStart&&t.requestStart&&console.info("[system]","request:",t.responseStart-t.requestStart+"ms"),t.responseEnd&&t.responseStart&&console.info("[system]","response:",t.responseEnd-t.responseStart+"ms"),t.domComplete&&t.domLoading&&(t.domContentLoadedEventStart&&t.domLoading?console.info("[system]","domComplete (domLoaded):",t.domComplete-t.domLoading+"ms ("+(t.domContentLoadedEventStart-t.domLoading)+"ms)"):console.info("[system]","domComplete:",t.domComplete-t.domLoading+"ms")),t.loadEventEnd&&t.loadEventStart&&console.info("[system]","loadEvent:",t.loadEventEnd-t.loadEventStart+"ms"),t.navigationStart&&t.loadEventEnd&&console.info("[system]","total (DOM):",t.loadEventEnd-t.navigationStart+"ms ("+(t.domComplete-t.navigationStart)+"ms)")}}),0)}}])&&c(t.prototype,n),o&&c(t,o),a}(o.default);n.default=p,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t){e.exports='<div>\n  <div class="vc-log"></div>\n</div>'},function(e,t,n){var o,r,i;function a(e){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(1),n(0),n(2),n(27),n(28),n(29)],void 0===(i="function"==typeof(o=function(n,o,r,i,l,c,s){"use strict";function u(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return u=function(){return e},e}function d(e){return e&&e.__esModule?e:{default:e}}function f(e,t){var n;if("undefined"==typeof Symbol||null==e[Symbol.iterator]){if(Array.isArray(e)||(n=function(e,t){if(e){if("string"==typeof e)return v(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?v(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){n&&(e=n);var o=0,r=function(){};return{s:r,n:function(){return o>=e.length?{done:!0}:{done:!1,value:e[o++]}},e:function(e){throw e},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){n=e[Symbol.iterator]()},n:function(){var e=n.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==n.return||n.return()}finally{if(l)throw i}}}}function v(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,o=new Array(t);n<t;n++)o[n]=e[n];return o}function p(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function b(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function h(e,t){return(h=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function m(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,o=y(e);if(t){var r=y(this).constructor;n=Reflect.construct(o,arguments,r)}else n=o.apply(this,arguments);return g(this,n)}}function g(e,t){return!t||"object"!==a(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function y(e){return(y=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,o=d(o),r=function(e){if(e&&e.__esModule)return e;if(null===e||"object"!==a(e)&&"function"!=typeof e)return{default:e};var t=u();if(t&&t.has(e))return t.get(e);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)){var i=o?Object.getOwnPropertyDescriptor(e,r):null;i&&(i.get||i.set)?Object.defineProperty(n,r,i):n[r]=e[r]}return n.default=e,t&&t.set(e,n),n}(r),i=d(i),l=d(l),c=d(c),s=d(s);var _=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&h(e,t)}(u,e);var t,n,i,a=m(u);function u(){var e;p(this,u);for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];return(e=a.call.apply(a,[this].concat(n))).$tabbox=o.default.render(l.default,{}),e.$header=null,e.reqList={},e.domList={},e.isReady=!1,e.isShow=!1,e.isInBottom=!0,e._open=void 0,e._send=void 0,e._setRequestHeader=void 0,e.mockAjax(),e.mockFetch(),e}return t=u,(n=[{key:"onRenderTab",value:function(e){e(this.$tabbox)}},{key:"onAddTool",value:function(e){var t=this;e([{name:"Clear",global:!1,onClick:function(e){t.clearLog()}}])}},{key:"onReady",value:function(){var e=this;e.isReady=!0,this.renderHeader(),o.default.delegate(o.default.one(".vc-log",this.$tabbox),"click",".vc-group-preview",(function(t){var n=this.dataset.reqid,r=this.parentNode;o.default.hasClass(r,"vc-actived")?(o.default.removeClass(r,"vc-actived"),e.updateRequest(n,{actived:!1})):(o.default.addClass(r,"vc-actived"),e.updateRequest(n,{actived:!0})),t.preventDefault()}));var t=o.default.one(".vc-content");for(var n in o.default.bind(t,"scroll",(function(n){e.isShow&&(t.scrollTop+t.offsetHeight>=t.scrollHeight?e.isInBottom=!0:e.isInBottom=!1)})),e.reqList)e.updateRequest(n,{})}},{key:"onRemove",value:function(){window.XMLHttpRequest&&(window.XMLHttpRequest.prototype.open=this._open,window.XMLHttpRequest.prototype.send=this._send,window.XMLHttpRequest.prototype.setRequestHeader=this._setRequestHeader,this._open=void 0,this._send=void 0,this._setRequestHeader=void 0)}},{key:"onShow",value:function(){this.isShow=!0,1==this.isInBottom&&this.scrollToBottom()}},{key:"onHide",value:function(){this.isShow=!1}},{key:"onShowConsole",value:function(){1==this.isInBottom&&this.scrollToBottom()}},{key:"scrollToBottom",value:function(){var e=o.default.one(".vc-content");e.scrollTop=e.scrollHeight-e.offsetHeight}},{key:"clearLog",value:function(){for(var e in this.reqList={},this.domList)this.domList[e].parentNode.removeChild(this.domList[e]),this.domList[e]=void 0;this.domList={},this.renderHeader()}},{key:"renderHeader",value:function(){var e=Object.keys(this.reqList).length,t=o.default.render(c.default,{count:e}),n=o.default.one(".vc-log",this.$tabbox);this.$header?this.$header.parentNode.replaceChild(t,this.$header):n.parentNode.insertBefore(t,n),this.$header=t}},{key:"updateRequest",value:function(e,t){var n=Object.keys(this.reqList).length,i=this.reqList[e]||{};for(var a in t)i[a]=t[a];if(this.reqList[e]=i,this.isReady){var l={id:e,name:i.name,url:i.url,status:i.status,method:i.method||"-",costTime:i.costTime>0?i.costTime+"ms":"-",header:i.header||null,requestHeader:i.requestHeader||null,getData:i.getData||null,postData:i.postData||null,response:null,actived:!!i.actived};switch(i.responseType){case"":case"text":if(r.isString(i.response))try{l.response=JSON.parse(i.response),l.response=JSON.stringify(l.response,null,1),l.response=r.htmlEncode(l.response)}catch(e){l.response=r.htmlEncode(i.response)}else void 0!==i.response&&(l.response=Object.prototype.toString.call(i.response));break;case"json":void 0!==i.response&&(l.response=JSON.stringify(i.response,null,1),l.response=r.htmlEncode(l.response));break;case"blob":case"document":case"arraybuffer":default:void 0!==i.response&&(l.response=Object.prototype.toString.call(i.response))}0==i.readyState||1==i.readyState?l.status="Pending":2==i.readyState||3==i.readyState?l.status="Loading":4==i.readyState||(l.status="Unknown");var c=o.default.render(s.default,l),u=this.domList[e];i.status>=400&&o.default.addClass(o.default.one(".vc-group-preview",c),"vc-table-row-error"),u?u.parentNode.replaceChild(c,u):o.default.one(".vc-log",this.$tabbox).insertAdjacentElement("beforeend",c),this.domList[e]=c,Object.keys(this.reqList).length!=n&&this.renderHeader(),this.isInBottom&&this.scrollToBottom()}}},{key:"mockAjax",value:function(){if(window.XMLHttpRequest){var e=this,t=window.XMLHttpRequest.prototype.open,n=window.XMLHttpRequest.prototype.send,o=window.XMLHttpRequest.prototype.setRequestHeader;e._open=t,e._send=n,e._setRequestHeader=o,window.XMLHttpRequest.prototype.open=function(){var n=this,o=[].slice.call(arguments),r=o[0],i=o[1],a=e.getUniqueID(),l=null;n._requestID=a,n._method=r,n._url=i;var c=n.onreadystatechange||function(){},s=function(){var t=e.reqList[a]||{};if(t.readyState=n.readyState,t.status=0,n.readyState>1&&(t.status=n.status),t.responseType=n.responseType,0==n.readyState)t.startTime||(t.startTime=+new Date);else if(1==n.readyState)t.startTime||(t.startTime=+new Date);else if(2==n.readyState){t.header={};for(var o=n.getAllResponseHeaders()||"",r=o.split("\n"),i=0;i<r.length;i++){var s=r[i];if(s){var u=s.split(": "),d=u[0],f=u.slice(1).join(": ");t.header[d]=f}}}else 3==n.readyState||(4==n.readyState?(clearInterval(l),t.endTime=+new Date,t.costTime=t.endTime-(t.startTime||t.endTime),t.response=n.response):clearInterval(l));return n._noVConsole||e.updateRequest(a,t),c.apply(n,arguments)};n.onreadystatechange=s;var u=-1;return l=setInterval((function(){u!=n.readyState&&(u=n.readyState,s.call(n))}),10),t.apply(n,o)},window.XMLHttpRequest.prototype.setRequestHeader=function(){var t=this,n=[].slice.call(arguments),r=e.reqList[t._requestID];return r&&(r.requestHeader||(r.requestHeader={}),r.requestHeader[n[0]]=n[1]),o.apply(t,n)},window.XMLHttpRequest.prototype.send=function(){var t=this,o=[].slice.call(arguments),i=o[0],a=e.reqList[t._requestID]||{};a.method=t._method?t._method.toUpperCase():"GET";var l=t._url?t._url.split("?"):[];if(a.url=t._url||"",a.name=l.shift()||"",a.name=a.name.replace(new RegExp("[/]*$"),"").split("/").pop()||"",l.length>0){a.name+="?"+l,a.getData={};var c,s=f(l=(l=l.join("?")).split("&"));try{for(s.s();!(c=s.n()).done;){var u=c.value;u=u.split("="),a.getData[u[0]]=decodeURIComponent(u[1])}}catch(e){s.e(e)}finally{s.f()}}if("POST"==a.method)if(r.isString(i)){var d=i.split("&");a.postData={};var v,p=f(d);try{for(p.s();!(v=p.n()).done;){var b=v.value;b=b.split("="),a.postData[b[0]]=b[1]}}catch(e){p.e(e)}finally{p.f()}}else r.isPlainObject(i)?a.postData=i:a.postData="[object Object]";return t._noVConsole||e.updateRequest(t._requestID,a),n.apply(t,o)}}}},{key:"mockFetch",value:function(){var e=window.fetch;if(e){var t=this;window.fetch=function(n,o){var i=t.getUniqueID();t.reqList[i]={};var a=t.reqList[i]||{},l=[],c="",s="GET",u=null;if(r.isString(n)?(s=o.method||"GET",c=n,u=o.headers):(s=n.method||"GET",c=n.url,u=n.headers),l=c.split("?"),a.id=i,a.method=s,a.requestHeader=u,a.url=c,a.name=l.shift()||"",a.name=a.name.replace(new RegExp("[/]*$"),"").split("/").pop()||"",l.length>0){a.name+="?"+l,a.getData={};var d,v=f(l=(l=l.join("?")).split("&"));try{for(v.s();!(d=v.n()).done;){var p=d.value;p=p.split("="),a.getData[p[0]]=p[1]}}catch(e){v.e(e)}finally{v.f()}}if("POST"===a.method)if(r.isString(n))if(r.isString(o.body)){var b=o.body.split("&");a.postData={};var h,m=f(b);try{for(m.s();!(h=m.n()).done;){var g=h.value;g=g.split("="),a.postData[g[0]]=g[1]}}catch(e){m.e(e)}finally{m.f()}}else r.isPlainObject(o.body)?a.postData=o.body:a.postData="[object Object]";else a.postData="[object Object]";return a.startTime||(a.startTime=+new Date),e(c,o).then((function(e){return e.clone().json().then((function(t){a.endTime=+new Date,a.costTime=a.endTime-(a.startTime||a.endTime),a.status=e.status,a.header={};var n,o=f(e.headers.entries());try{for(o.s();!(n=o.n()).done;){var r=n.value;a.header[r[0]]=r[1]}}catch(e){o.e(e)}finally{o.f()}a.response=t,a.readyState=4;var i=e.headers.get("content-type");return a.responseType=i.includes("application/json")?"json":i.includes("text/html")?"text":"",t})),t.updateRequest(i,a),e}))}}}},{key:"getUniqueID",value:function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,(function(e){var t=16*Math.random()|0;return("x"==e?t:3&t|8).toString(16)}))}}])&&b(t.prototype,n),i&&b(t,i),u}(i.default);n.default=_,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t){e.exports='<div class="vc-table">\n  <div class="vc-log"></div>\n</div>'},function(e,t){e.exports='<dl class="vc-table-row">\n  <dd class="vc-table-col vc-table-col-4">Name {{if (count > 0)}}({{count}}){{/if}}</dd>\n  <dd class="vc-table-col">Method</dd>\n  <dd class="vc-table-col">Status</dd>\n  <dd class="vc-table-col">Time</dd>\n</dl>'},function(e,t){e.exports='<div class="vc-group {{actived ? \'vc-actived\' : \'\'}}">\n  <dl class="vc-table-row vc-group-preview" data-reqid="{{id}}">\n    <dd class="vc-table-col vc-table-col-4">{{name}}</dd>\n    <dd class="vc-table-col">{{method}}</dd>\n    <dd class="vc-table-col">{{status}}</dd>\n    <dd class="vc-table-col">{{costTime}}</dd>\n  </dl>\n  <div class="vc-group-detail">\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">General</dt>\n      </dl>\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">URL</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{url}}</div>\n      </div>\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">Method</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{method}}</div>\n      </div>\n    </div>\n    {{if (header !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Response Headers</dt>\n      </dl>\n      {{for (var key in header)}}\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">{{key}}</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{header[key]}}</div>\n      </div>\n      {{/for}}\n    </div>\n    {{/if}}\n    {{if (requestHeader !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Request Headers</dt>\n      </dl>\n      {{for (var key in requestHeader)}}\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">{{key}}</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{requestHeader[key]}}</div>\n      </div>\n      {{/for}}\n    </div>\n    {{/if}}\n    {{if (getData !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Query String Parameters</dt>\n      </dl>\n      {{for (var key in getData)}}\n      <div class="vc-table-row vc-left-border vc-small">\n        <div class="vc-table-col vc-table-col-2">{{key}}</div>\n        <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{getData[key]}}</div>\n      </div>\n      {{/for}}\n    </div>\n    {{/if}}\n    {{if (postData !== null)}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Request Payload</dt>\n      </dl>\n      {{if (typeof postData === \'string\')}}\n        <div class="vc-table-row vc-left-border vc-small">\n          <pre class="vc-table-col">{{postData}}</pre>\n        </div>\n      {{else}}\n        {{for (var key in postData)}}\n        <div class="vc-table-row vc-left-border vc-small">\n          <div class="vc-table-col vc-table-col-2">{{key}}</div>\n          <div class="vc-table-col vc-table-col-4 vc-max-height-line">{{postData[key]}}</div>\n        </div>\n        {{/for}}\n      {{/if}}\n    </div>\n    {{/if}}\n    <div>\n      <dl class="vc-table-row vc-left-border">\n        <dt class="vc-table-col vc-table-col-title">Response</dt>\n      </dl>\n      <div class="vc-table-row vc-left-border vc-small">\n        <pre class="vc-table-col vc-max-height vc-min-height">{{response || \'\'}}</pre>\n      </div>\n    </div>\n  </div>\n</div>'},function(e,t,n){var o,r,i;function a(e){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(31),n(32),n(2),n(34),n(35),n(0),n(1)],void 0===(i="function"==typeof(o=function(n,o,r,i,l,c,s,u){"use strict";function d(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return d=function(){return e},e}function f(e){return e&&e.__esModule?e:{default:e}}function v(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function p(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function b(e,t){return(b=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function h(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,o=y(e);if(t){var r=y(this).constructor;n=Reflect.construct(o,arguments,r)}else n=o.apply(this,arguments);return m(this,n)}}function m(e,t){return!t||"object"!==a(t)&&"function"!=typeof t?g(e):t}function g(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function y(e){return(y=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,o=f(o),i=f(i),l=f(l),c=f(c),s=function(e){if(e&&e.__esModule)return e;if(null===e||"object"!==a(e)&&"function"!=typeof e)return{default:e};var t=d();if(t&&t.has(e))return t.get(e);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)){var i=o?Object.getOwnPropertyDescriptor(e,r):null;i&&(i.get||i.set)?Object.defineProperty(n,r,i):n[r]=e[r]}return n.default=e,t&&t.set(e,n),n}(s),u=f(u);var _=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&b(e,t)}(a,e);var t,n,r,i=h(a);function a(){var e;v(this,a);for(var t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];var c=g(e=i.call.apply(i,[this].concat(n)));return c.isInited=!1,c.node={},c.$tabbox=u.default.render(l.default,{}),c.nodes=[],c.activedElem={},c.observer=new o.default((function(e){for(var t=0;t<e.length;t++){var n=e[t];c._isInVConsole(n.target)||c.onMutation(n)}})),e}return t=a,(n=[{key:"onRenderTab",value:function(e){e(this.$tabbox)}},{key:"onAddTool",value:function(e){var t=this;e([{name:"Expand",global:!1,onClick:function(e){if(t.activedElem)if(u.default.hasClass(t.activedElem,"vc-toggle"))for(var n=0;n<t.activedElem.childNodes.length;n++){var o=t.activedElem.childNodes[n];if(u.default.hasClass(o,"vcelm-l")&&!u.default.hasClass(o,"vcelm-noc")&&!u.default.hasClass(o,"vc-toggle")){u.default.one(".vcelm-node",o).click();break}}else u.default.one(".vcelm-node",t.activedElem).click()}},{name:"Collapse",global:!1,onClick:function(e){t.activedElem&&(u.default.hasClass(t.activedElem,"vc-toggle")?u.default.one(".vcelm-node",t.activedElem).click():t.activedElem.parentNode&&u.default.hasClass(t.activedElem.parentNode,"vcelm-l")&&u.default.one(".vcelm-node",t.activedElem.parentNode).click())}}])}},{key:"onShow",value:function(){if(!this.isInited){this.isInited=!0,this.node=this.getNode(document.documentElement);var e=this.renderView(this.node,u.default.one(".vc-log",this.$tabbox)),t=u.default.one(".vcelm-node",e);t&&t.click&&t.click(),this.observer.observe(document.documentElement,{attributes:!0,childList:!0,characterData:!0,subtree:!0})}}},{key:"onRemove",value:function(){this.observer.disconnect()}},{key:"onMutation",value:function(e){switch(e.type){case"childList":e.removedNodes.length>0&&this.onChildRemove(e),e.addedNodes.length>0&&this.onChildAdd(e);break;case"attributes":this.onAttributesChange(e);break;case"characterData":this.onCharacterDataChange(e)}}},{key:"onChildRemove",value:function(e){var t=e.target;if(t.__vconsole_node){for(var n=0;n<e.removedNodes.length;n++){var o=e.removedNodes[n].__vconsole_node;o&&o.view&&o.view.parentNode.removeChild(o.view)}this.getNode(t)}}},{key:"onChildAdd",value:function(e){var t=e.target,n=t.__vconsole_node;if(n){this.getNode(t),n.view&&u.default.removeClass(n.view,"vcelm-noc");for(var o=0;o<e.addedNodes.length;o++){var r=e.addedNodes[o].__vconsole_node;if(r)if(null!==e.nextSibling){var i=e.nextSibling.__vconsole_node;i.view&&this.renderView(r,i.view,"insertBefore")}else n.view&&(n.view.lastChild?this.renderView(r,n.view.lastChild,"insertBefore"):this.renderView(r,n.view))}}}},{key:"onAttributesChange",value:function(e){var t=e.target.__vconsole_node;t&&(t=this.getNode(e.target)).view&&this.renderView(t,t.view,!0)}},{key:"onCharacterDataChange",value:function(e){var t=e.target.__vconsole_node;t&&(t=this.getNode(e.target)).view&&this.renderView(t,t.view,!0)}},{key:"renderView",value:function(e,t,n){var o=this,r=new c.default(e).get();switch(e.view=r,u.default.delegate(r,"click",".vcelm-node",(function(t){t.stopPropagation();var n=this.parentNode;if(!u.default.hasClass(n,"vcelm-noc")){o.activedElem=n,u.default.hasClass(n,"vc-toggle")?u.default.removeClass(n,"vc-toggle"):u.default.addClass(n,"vc-toggle");for(var r=-1,i=0;i<n.children.length;i++){var a=n.children[i];u.default.hasClass(a,"vcelm-l")&&(r++,a.children.length>0||(e.childNodes[r]?o.renderView(e.childNodes[r],a,"replace"):a.style.display="none"))}}})),n){case"replace":t.parentNode.replaceChild(r,t);break;case"insertBefore":t.parentNode.insertBefore(r,t);break;default:t.appendChild(r)}return r}},{key:"getNode",value:function(e){if(!this._isIgnoredElement(e)){var t=e.__vconsole_node||{};if(t.nodeType=e.nodeType,t.nodeName=e.nodeName,t.tagName=e.tagName||"",t.textContent="",t.nodeType!=e.TEXT_NODE&&t.nodeType!=e.DOCUMENT_TYPE_NODE||(t.textContent=e.textContent),t.id=e.id||"",t.className=e.className||"",t.attributes=[],e.hasAttributes&&e.hasAttributes())for(var n=0;n<e.attributes.length;n++)t.attributes.push({name:e.attributes[n].name,value:e.attributes[n].value||""});if(t.childNodes=[],e.childNodes.length>0)for(var o=0;o<e.childNodes.length;o++){var r=this.getNode(e.childNodes[o]);r&&t.childNodes.push(r)}return e.__vconsole_node=t,t}}},{key:"_isIgnoredElement",value:function(e){return e.nodeType==e.TEXT_NODE&&""==e.textContent.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$|\n+/g,"")}},{key:"_isInVConsole",value:function(e){for(var t=e;null!=t;){if("__vconsole"==t.id)return!0;t=t.parentNode||void 0}return!1}}])&&p(t.prototype,n),r&&p(t,r),a}(i.default);n.default=_,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t){var n=window.MutationObserver||window.WebKitMutationObserver||window.MozMutationObserver,o=window.WeakMap;if(void 0===o){var r=Object.defineProperty,i=Date.now()%1e9;(o=function(){this.name="__st"+(1e9*Math.random()>>>0)+i+++"__"}).prototype={set:function(e,t){var n=e[this.name];return n&&n[0]===e?n[1]=t:r(e,this.name,{value:[e,t],writable:!0}),this},get:function(e){var t;return(t=e[this.name])&&t[0]===e?t[1]:void 0},delete:function(e){var t=e[this.name];if(!t)return!1;var n=t[0]===e;return t[0]=t[1]=void 0,n},has:function(e){var t=e[this.name];return!!t&&t[0]===e}}}var a=new o,l=window.msSetImmediate;if(!l){var c=[],s=String(Math.random());window.addEventListener("message",(function(e){if(e.data===s){var t=c;c=[],t.forEach((function(e){e()}))}})),l=function(e){c.push(e),window.postMessage(s,"*")}}var u=!1,d=[];function f(){u=!1;var e=d;d=[],e.sort((function(e,t){return e.uid_-t.uid_}));var t=!1;e.forEach((function(e){var n=e.takeRecords();!function(e){e.nodes_.forEach((function(t){var n=a.get(t);n&&n.forEach((function(t){t.observer===e&&t.removeTransientObservers()}))}))}(e),n.length&&(e.callback_(n,e),t=!0)})),t&&f()}function v(e,t){for(var n=e;n;n=n.parentNode){var o=a.get(n);if(o)for(var r=0;r<o.length;r++){var i=o[r],l=i.options;if(n===e||l.subtree){var c=t(l);c&&i.enqueue(c)}}}}var p,b,h=0;function m(e){this.callback_=e,this.nodes_=[],this.records_=[],this.uid_=++h}function g(e,t){this.type=e,this.target=t,this.addedNodes=[],this.removedNodes=[],this.previousSibling=null,this.nextSibling=null,this.attributeName=null,this.attributeNamespace=null,this.oldValue=null}function y(e,t){return p=new g(e,t)}function _(e){return b||((n=new g((t=p).type,t.target)).addedNodes=t.addedNodes.slice(),n.removedNodes=t.removedNodes.slice(),n.previousSibling=t.previousSibling,n.nextSibling=t.nextSibling,n.attributeName=t.attributeName,n.attributeNamespace=t.attributeNamespace,n.oldValue=t.oldValue,(b=n).oldValue=e,b);var t,n}function w(e,t){return e===t?e:b&&((n=e)===b||n===p)?b:null;var n}function C(e,t,n){this.observer=e,this.target=t,this.options=n,this.transientObservedNodes=[]}m.prototype={observe:function(e,t){var n;if(n=e,e=window.ShadowDOMPolyfill&&window.ShadowDOMPolyfill.wrapIfNeeded(n)||n,!t.childList&&!t.attributes&&!t.characterData||t.attributeOldValue&&!t.attributes||t.attributeFilter&&t.attributeFilter.length&&!t.attributes||t.characterDataOldValue&&!t.characterData)throw new SyntaxError;var o,r=a.get(e);r||a.set(e,r=[]);for(var i=0;i<r.length;i++)if(r[i].observer===this){(o=r[i]).removeListeners(),o.options=t;break}o||(o=new C(this,e,t),r.push(o),this.nodes_.push(e)),o.addListeners()},disconnect:function(){this.nodes_.forEach((function(e){for(var t=a.get(e),n=0;n<t.length;n++){var o=t[n];if(o.observer===this){o.removeListeners(),t.splice(n,1);break}}}),this),this.records_=[]},takeRecords:function(){var e=this.records_;return this.records_=[],e}},C.prototype={enqueue:function(e){var t,n=this.observer.records_,o=n.length;if(n.length>0){var r=w(n[o-1],e);if(r)return void(n[o-1]=r)}else t=this.observer,d.push(t),u||(u=!0,l(f));n[o]=e},addListeners:function(){this.addListeners_(this.target)},addListeners_:function(e){var t=this.options;t.attributes&&e.addEventListener("DOMAttrModified",this,!0),t.characterData&&e.addEventListener("DOMCharacterDataModified",this,!0),t.childList&&e.addEventListener("DOMNodeInserted",this,!0),(t.childList||t.subtree)&&e.addEventListener("DOMNodeRemoved",this,!0)},removeListeners:function(){this.removeListeners_(this.target)},removeListeners_:function(e){var t=this.options;t.attributes&&e.removeEventListener("DOMAttrModified",this,!0),t.characterData&&e.removeEventListener("DOMCharacterDataModified",this,!0),t.childList&&e.removeEventListener("DOMNodeInserted",this,!0),(t.childList||t.subtree)&&e.removeEventListener("DOMNodeRemoved",this,!0)},addTransientObserver:function(e){if(e!==this.target){this.addListeners_(e),this.transientObservedNodes.push(e);var t=a.get(e);t||a.set(e,t=[]),t.push(this)}},removeTransientObservers:function(){var e=this.transientObservedNodes;this.transientObservedNodes=[],e.forEach((function(e){this.removeListeners_(e);for(var t=a.get(e),n=0;n<t.length;n++)if(t[n]===this){t.splice(n,1);break}}),this)},handleEvent:function(e){switch(e.stopImmediatePropagation(),e.type){case"DOMAttrModified":var t=e.attrName,n=e.relatedNode.namespaceURI,o=e.target;(i=new y("attributes",o)).attributeName=t,i.attributeNamespace=n;var r=null;"undefined"!=typeof MutationEvent&&e.attrChange===MutationEvent.ADDITION||(r=e.prevValue),v(o,(function(e){if(e.attributes&&(!e.attributeFilter||!e.attributeFilter.length||-1!==e.attributeFilter.indexOf(t)||-1!==e.attributeFilter.indexOf(n)))return e.attributeOldValue?_(r):i}));break;case"DOMCharacterDataModified":var i=y("characterData",o=e.target);r=e.prevValue;v(o,(function(e){if(e.characterData)return e.characterDataOldValue?_(r):i}));break;case"DOMNodeRemoved":this.addTransientObserver(e.target);case"DOMNodeInserted":o=e.relatedNode;var a,l,c=e.target;"DOMNodeInserted"===e.type?(a=[c],l=[]):(a=[],l=[c]);var s=c.previousSibling,u=c.nextSibling;(i=y("childList",o)).addedNodes=a,i.removedNodes=l,i.previousSibling=s,i.nextSibling=u,v(o,(function(e){if(e.childList)return i}))}p=b=void 0}},n||(n=m),e.exports=n},function(e,t,n){var o=n(4),r=n(33);"string"==typeof(r=r.__esModule?r.default:r)&&(r=[[e.i,r,""]]);var i={insert:"head",singleton:!1};o(r,i);e.exports=r.locals||{}},function(e,t,n){(t=n(5)(!1)).push([e.i,'/* color */\n.vcelm-node {\n  color: var(--VC-DOM-TAG-NAME-COLOR);\n}\n.vcelm-k {\n  color: var(--VC-DOM-ATTRIBUTE-NAME-COLOR);\n}\n.vcelm-v {\n  color: var(--VC-DOM-ATTRIBUTE-VALUE-COLOR);\n}\n/* layout */\n.vcelm-l {\n  padding-left: 8px;\n  position: relative;\n  word-wrap: break-word;\n  line-height: 1;\n}\n/*.vcelm-l.vcelm-noc {\n  padding-left: 0;\n}*/\n.vcelm-l.vc-toggle > .vcelm-node {\n  display: block;\n}\n.vcelm-l .vcelm-node:active {\n  background-color: var(--VC-BG-COLOR-ACTIVE);\n}\n.vcelm-l.vcelm-noc .vcelm-node:active {\n  background-color: transparent;\n}\n.vcelm-t {\n  white-space: pre-wrap;\n  word-wrap: break-word;\n}\n/* level */\n.vcelm-l .vcelm-l {\n  display: none;\n}\n.vcelm-l.vc-toggle > .vcelm-l {\n  margin-left: 4px;\n  display: block;\n}\n/* arrow */\n.vcelm-l:before {\n  content: "";\n  display: block;\n  position: absolute;\n  top: 6px;\n  left: 3px;\n  width: 0;\n  height: 0;\n  border: transparent solid 3px;\n  border-left-color: var(--VC-FG-1);\n}\n.vcelm-l.vc-toggle:before {\n  display: block;\n  top: 6px;\n  left: 0;\n  border-top-color: var(--VC-FG-1);\n  border-left-color: transparent;\n}\n.vcelm-l.vcelm-noc:before {\n  display: none;\n}\n',""]),e.exports=t},function(e,t){e.exports='<div>\n  <div class="vc-log"></div>\n</div>'},function(e,t,n){var o,r,i;function a(e){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(36),n(37),n(0),n(1)],void 0===(i="function"==typeof(o=function(n,o,r,i,l){"use strict";function c(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return c=function(){return e},e}function s(e){return e&&e.__esModule?e:{default:e}}function u(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,o=s(o),r=s(r),i=function(e){if(e&&e.__esModule)return e;if(null===e||"object"!==a(e)&&"function"!=typeof e)return{default:e};var t=c();if(t&&t.has(e))return t.get(e);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)){var i=o?Object.getOwnPropertyDescriptor(e,r):null;i&&(i.get||i.set)?Object.defineProperty(n,r,i):n[r]=e[r]}return n.default=e,t&&t.set(e,n),n}(i),l=s(l);var d=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.node=t,this.view=this._create(this.node)}var t,n,i;return t=e,(n=[{key:"get",value:function(){return this.view}},{key:"_create",value:function(e,t){var n=document.createElement("DIV");switch(l.default.addClass(n,"vcelm-l"),e.nodeType){case n.ELEMENT_NODE:this._createElementNode(e,n);break;case n.TEXT_NODE:this._createTextNode(e,n);break;case n.COMMENT_NODE:case n.DOCUMENT_NODE:case n.DOCUMENT_TYPE_NODE:case n.DOCUMENT_FRAGMENT_NODE:}return n}},{key:"_createTextNode",value:function(e,t){l.default.addClass(t,"vcelm-t vcelm-noc"),e.textContent&&t.appendChild(function(e){return document.createTextNode(e)}(e.textContent.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")))}},{key:"_createElementNode",value:function(e,t){var n,i=(n=(n=e.tagName)?n.toLowerCase():"",["br","hr","img","input","link","meta"].indexOf(n)>-1),a=i;0==e.childNodes.length&&(a=!0);var c=l.default.render(o.default,{node:e}),s=l.default.render(r.default,{node:e});if(a)l.default.addClass(t,"vcelm-noc"),t.appendChild(c),i||t.appendChild(s);else{t.appendChild(c);for(var u=0;u<e.childNodes.length;u++){var d=document.createElement("DIV");l.default.addClass(d,"vcelm-l"),t.appendChild(d)}i||t.appendChild(s)}}}])&&u(t.prototype,n),i&&u(t,i),e}();n.default=d,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t){e.exports='<span class="vcelm-node">&lt;{{node.tagName.toLowerCase()}}{{if (node.className || node.attributes.length)}}\n  <i class="vcelm-k">\n    {{for (var i = 0; i < node.attributes.length; i++)}}\n      {{if (node.attributes[i].value !== \'\')}}\n        {{node.attributes[i].name}}="<i class="vcelm-v">{{node.attributes[i].value}}</i>"{{else}}\n        {{node.attributes[i].name}}{{/if}}{{/for}}</i>{{/if}}&gt;</span>'},function(e,t){e.exports='<span class="vcelm-node">&lt;/{{node.tagName.toLowerCase()}}&gt;</span>'},function(e,t,n){var o,r,i;function a(e){return(a="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self&&self,r=[t,n(2),n(39),n(40),n(0),n(1)],void 0===(i="function"==typeof(o=function(n,o,r,i,l,c){"use strict";function s(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return s=function(){return e},e}function u(e){return e&&e.__esModule?e:{default:e}}function d(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function f(e,t){for(var n=0;n<t.length;n++){var o=t[n];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}function v(e,t){return(v=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function p(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return!1}}();return function(){var n,o=h(e);if(t){var r=h(this).constructor;n=Reflect.construct(o,arguments,r)}else n=o.apply(this,arguments);return b(this,n)}}function b(e,t){return!t||"object"!==a(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function h(e){return(h=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0,o=u(o),r=u(r),i=u(i),l=function(e){if(e&&e.__esModule)return e;if(null===e||"object"!==a(e)&&"function"!=typeof e)return{default:e};var t=s();if(t&&t.has(e))return t.get(e);var n={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)){var i=o?Object.getOwnPropertyDescriptor(e,r):null;i&&(i.get||i.set)?Object.defineProperty(n,r,i):n[r]=e[r]}return n.default=e,t&&t.set(e,n),n}(l),c=u(c);var m=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&v(e,t)}(s,e);var t,n,o,a=p(s);function s(){var e;d(this,s);for(var t=arguments.length,n=new Array(t),o=0;o<t;o++)n[o]=arguments[o];return(e=a.call.apply(a,[this].concat(n))).$tabbox=c.default.render(r.default,{}),e.currentType="",e.typeNameMap={cookies:"Cookies",localstorage:"LocalStorage",sessionstorage:"SessionStorage"},e}return t=s,(n=[{key:"onRenderTab",value:function(e){e(this.$tabbox)}},{key:"onAddTopBar",value:function(e){for(var t=this,n=["Cookies","LocalStorage","SessionStorage"],o=[],r=0;r<n.length;r++)o.push({name:n[r],data:{type:n[r].toLowerCase()},className:"",onClick:function(){if(c.default.hasClass(this,"vc-actived"))return!1;t.currentType=this.dataset.type,t.renderStorage()}});o[0].className="vc-actived",e(o)}},{key:"onAddTool",value:function(e){var t=this;e([{name:"Refresh",global:!1,onClick:function(e){t.renderStorage()}},{name:"Clear",global:!1,onClick:function(e){t.clearLog()}}])}},{key:"onReady",value:function(){}},{key:"onShow",value:function(){""==this.currentType&&(this.currentType="cookies",this.renderStorage())}},{key:"clearLog",value:function(){if(this.currentType&&window.confirm&&!window.confirm("Remove all "+this.typeNameMap[this.currentType]+"?"))return!1;switch(this.currentType){case"cookies":this.clearCookieList();break;case"localstorage":this.clearLocalStorageList();break;case"sessionstorage":this.clearSessionStorageList();break;default:return!1}this.renderStorage()}},{key:"renderStorage",value:function(){var e=[];switch(this.currentType){case"cookies":e=this.getCookieList();break;case"localstorage":e=this.getLocalStorageList();break;case"sessionstorage":e=this.getSessionStorageList();break;default:return!1}var t=c.default.one(".vc-log",this.$tabbox);if(0==e.length)t.innerHTML="";else{for(var n=0;n<e.length;n++)e[n].name=l.htmlEncode(e[n].name),e[n].value=l.htmlEncode(e[n].value);t.innerHTML=c.default.render(i.default,{list:e},!0)}}},{key:"getCookieList",value:function(){if(!document.cookie||!navigator.cookieEnabled)return[];for(var e=[],t=document.cookie.split(";"),n=0;n<t.length;n++){var o=t[n].split("="),r=o.shift().replace(/^ /,""),i=o.join("=");try{r=decodeURIComponent(r),i=decodeURIComponent(i)}catch(e){}e.push({name:r,value:i})}return e}},{key:"getLocalStorageList",value:function(){if(!window.localStorage)return[];try{for(var e=[],t=0;t<localStorage.length;t++){var n=localStorage.key(t),o=localStorage.getItem(n);e.push({name:n,value:o})}return e}catch(e){return[]}}},{key:"getSessionStorageList",value:function(){if(!window.sessionStorage)return[];try{for(var e=[],t=0;t<sessionStorage.length;t++){var n=sessionStorage.key(t),o=sessionStorage.getItem(n);e.push({name:n,value:o})}return e}catch(e){return[]}}},{key:"clearCookieList",value:function(){if(document.cookie&&navigator.cookieEnabled){for(var e=window.location.hostname,t=this.getCookieList(),n=0;n<t.length;n++){var o=t[n].name;document.cookie="".concat(o,"=;expires=Thu, 01 Jan 1970 00:00:00 GMT"),document.cookie="".concat(o,"=;expires=Thu, 01 Jan 1970 00:00:00 GMT;path=/"),document.cookie="".concat(o,"=;expires=Thu, 01 Jan 1970 00:00:00 GMT;path=/;domain=.").concat(e.split(".").slice(-2).join("."))}this.renderStorage()}}},{key:"clearLocalStorageList",value:function(){if(window.localStorage)try{localStorage.clear(),this.renderStorage()}catch(e){alert("localStorage.clear() fail.")}}},{key:"clearSessionStorageList",value:function(){if(window.sessionStorage)try{sessionStorage.clear(),this.renderStorage()}catch(e){alert("sessionStorage.clear() fail.")}}}])&&f(t.prototype,n),o&&f(t,o),s}(o.default);n.default=m,e.exports=t.default})?o.apply(t,r):o)||(e.exports=i)},function(e,t){e.exports='<div class="vc-table">\n  <div class="vc-log"></div>\n</div>'},function(e,t){e.exports='<div>\n  <dl class="vc-table-row">\n    <dd class="vc-table-col">Name</dd>\n    <dd class="vc-table-col vc-table-col-2">Value</dd>\n  </dl>\n  {{for (var i = 0; i < list.length; i++)}}\n  <dl class="vc-table-row">\n    <dd class="vc-table-col">{{list[i].name}}</dd>\n    <dd class="vc-table-col vc-table-col-2">{{list[i].value}}</dd>\n  </dl>\n  {{/for}}\n</div>'}])}));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRSocial.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRSocial', void 0);

      cclegacy._RF.push({}, "9ccf3RFbxpDGaHZibdlvWZa", "SRSocial", undefined);

      let SRSocial;

      (function (_SRSocial) {
        function getFriendsRank() {
          let req = new GameKit.ServerRequest("getFriendsRank");
          req.SetSilence(true);
          req.SetCallBack(res => {
            let data = res.list;
            let friends = Game.SUser.FriendsList();

            for (let i = 0; i < data.length; i++) {
              if (friends[data[i].userId]) friends[data[i].userId].updateData(data[i]);
            }
          });
          return req;
        }

        _SRSocial.getFriendsRank = getFriendsRank;

        function getCountryRank() {
          let req = new GameKit.ServerRequest("getCountryRank");
          req.SetRequestBody("country", Game.SUser.Country());
          req.SetSilence(true);
          return req;
        }

        _SRSocial.getCountryRank = getCountryRank;

        function getGlobalRank() {
          let req = new GameKit.ServerRequest("getGlobalRank");
          req.SetSilence(true);
          return req;
        }

        _SRSocial.getGlobalRank = getGlobalRank;

        function getGifts() {
          let req = new GameKit.ServerRequest("getGifts");
          req.SetSilence(true);
          return req;
        }

        _SRSocial.getGifts = getGifts;

        function giftsSpinSend(friendUserId) {
          let req = new GameKit.ServerRequest("giftsSpinSend");
          req.SetRequestBody("friendUserId", friendUserId);
          return req;
        }

        _SRSocial.giftsSpinSend = giftsSpinSend;

        function giftsCoinSend(friendUserId) {
          let req = new GameKit.ServerRequest("giftsCoinSend");
          req.SetRequestBody("friendUserId", friendUserId);
          return req;
        }

        _SRSocial.giftsCoinSend = giftsCoinSend;

        function giftsSpinCollect(friendUserId) {
          let req = new GameKit.ServerRequest("giftsSpinCollect");
          req.SetRequestBody("friendUserId", friendUserId);
          return req;
        }

        _SRSocial.giftsSpinCollect = giftsSpinCollect;

        function giftsCoinCollect(friendUserId) {
          let req = new GameKit.ServerRequest("giftsCoinCollect");
          req.SetRequestBody("friendUserId", friendUserId);
          return req;
        }

        _SRSocial.giftsCoinCollect = giftsCoinCollect;

        function giftsSpinAll(sendList, collectList) {
          let req = new GameKit.ServerRequest("giftsSpinAll");
          req.SetRequestBody("sendList", sendList);
          req.SetRequestBody("collectList", collectList);
          return req;
        }

        _SRSocial.giftsSpinAll = giftsSpinAll;

        function giftsCoinAll(sendList, collectList) {
          let req = new GameKit.ServerRequest("giftsCoinAll");
          req.SetRequestBody("sendList", sendList);
          req.SetRequestBody("collectList", collectList);
          return req;
        }

        _SRSocial.giftsCoinAll = giftsCoinAll;

        function giftsCardCollect(index) {
          let req = new GameKit.ServerRequest("giftsCardCollect");
          req.SetRequestBody("index", index);
          return req;
        }

        _SRSocial.giftsCardCollect = giftsCardCollect;
      })(SRSocial || (SRSocial = exports('SRSocial', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AnimOverDestroy.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Animation, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Animation = module.Animation;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class;

      cclegacy._RF.push({}, "9e4ccfiXDJG/J8g+SSnFVwQ", "AnimOverDestroy", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AnimOverDestroy = exports('default', ccclass(_class = class AnimOverDestroy extends CCE_Component {
        // LIFE-CYCLE CALLBACKS:
        // onLoad () {},
        start() {
          this.getComponent(Animation).on(Animation.EventType.FINISHED, function () {
            this.node.destroy();
          }, this);
        }

      }) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AttackAnim.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, CCE_Component, CCEaseTypes;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "9ea97JBxEJD86EQY2tkiLdl", "AttackAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AttackAnim = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class AttackAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "light", _descriptor, this);

          _initializerDefineProperty(this, "hammer", _descriptor2, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        play(cb) {
          var self = this;
          this.node.active = true;
          this.light.scaleX = 0;
          this.light.scaleY = 0;
          this.hammer.scaleX = 0;
          this.hammer.scaleY = 0;
          let seq1 = ccAction.sequence(ccAction.scaleTo(0.2, 1.2, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), ccAction.delayTime(0.4), ccAction.scaleTo(0.2, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)));
          this.light.runAction(seq1);
          let seq2 = ccAction.sequence(ccAction.scaleTo(0.2, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)), ccAction.delayTime(0.4), ccAction.scaleTo(0.2, 0, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)), ccAction.callFunc(function () {
            if (cb != null) {
              cb();
            }

            self.node.active = false;
          }));
          this.hammer.runAction(seq2);
        }

        stop() {
          this.light.stopAllActions();
          this.hammer.stopAllActions();
          this.node.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "light", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "hammer", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/md5.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "9efebrHJidOAo+73281e+Ln", "md5", undefined);
      /* hex output format. 0 - lowercase; 1 - uppercase        */


      var b64pad = "";
      /* base-64 pad character. "=" for strict RFC compliance   */

      var chrsz = 8;
      /* bits per input character. 8 - ASCII; 16 - Unicode      */

      /*
       * These are the functions you'll usually want to call
       * They take string arguments and return either hex or base-64 encoded strings
       */

      function hex_md5(s) {
        return binl2hex(core_md5(str2binl(s), s.length * chrsz));
      }

      function b64_md5(s) {
        return binl2b64(core_md5(str2binl(s), s.length * chrsz));
      }

      function str_md5(s) {
        return binl2str(core_md5(str2binl(s), s.length * chrsz));
      }

      function hex_hmac_md5(key, data) {
        return binl2hex(core_hmac_md5(key, data));
      }

      function b64_hmac_md5(key, data) {
        return binl2b64(core_hmac_md5(key, data));
      }

      function str_hmac_md5(key, data) {
        return binl2str(core_hmac_md5(key, data));
      }
      /*
       * Calculate the MD5 of an array of little-endian words, and a bit length
       */


      function core_md5(x, len) {
        /* append padding */
        x[len >> 5] |= 0x80 << len % 32;
        x[(len + 64 >>> 9 << 4) + 14] = len;
        var a = 1732584193;
        var b = -271733879;
        var c = -1732584194;
        var d = 271733878;

        for (var i = 0; i < x.length; i += 16) {
          var olda = a;
          var oldb = b;
          var oldc = c;
          var oldd = d;
          a = md5_ff(a, b, c, d, x[i + 0], 7, -680876936);
          d = md5_ff(d, a, b, c, x[i + 1], 12, -389564586);
          c = md5_ff(c, d, a, b, x[i + 2], 17, 606105819);
          b = md5_ff(b, c, d, a, x[i + 3], 22, -1044525330);
          a = md5_ff(a, b, c, d, x[i + 4], 7, -176418897);
          d = md5_ff(d, a, b, c, x[i + 5], 12, 1200080426);
          c = md5_ff(c, d, a, b, x[i + 6], 17, -1473231341);
          b = md5_ff(b, c, d, a, x[i + 7], 22, -45705983);
          a = md5_ff(a, b, c, d, x[i + 8], 7, 1770035416);
          d = md5_ff(d, a, b, c, x[i + 9], 12, -1958414417);
          c = md5_ff(c, d, a, b, x[i + 10], 17, -42063);
          b = md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
          a = md5_ff(a, b, c, d, x[i + 12], 7, 1804603682);
          d = md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
          c = md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
          b = md5_ff(b, c, d, a, x[i + 15], 22, 1236535329);
          a = md5_gg(a, b, c, d, x[i + 1], 5, -165796510);
          d = md5_gg(d, a, b, c, x[i + 6], 9, -1069501632);
          c = md5_gg(c, d, a, b, x[i + 11], 14, 643717713);
          b = md5_gg(b, c, d, a, x[i + 0], 20, -373897302);
          a = md5_gg(a, b, c, d, x[i + 5], 5, -701558691);
          d = md5_gg(d, a, b, c, x[i + 10], 9, 38016083);
          c = md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
          b = md5_gg(b, c, d, a, x[i + 4], 20, -405537848);
          a = md5_gg(a, b, c, d, x[i + 9], 5, 568446438);
          d = md5_gg(d, a, b, c, x[i + 14], 9, -1019803690);
          c = md5_gg(c, d, a, b, x[i + 3], 14, -187363961);
          b = md5_gg(b, c, d, a, x[i + 8], 20, 1163531501);
          a = md5_gg(a, b, c, d, x[i + 13], 5, -1444681467);
          d = md5_gg(d, a, b, c, x[i + 2], 9, -51403784);
          c = md5_gg(c, d, a, b, x[i + 7], 14, 1735328473);
          b = md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);
          a = md5_hh(a, b, c, d, x[i + 5], 4, -378558);
          d = md5_hh(d, a, b, c, x[i + 8], 11, -2022574463);
          c = md5_hh(c, d, a, b, x[i + 11], 16, 1839030562);
          b = md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
          a = md5_hh(a, b, c, d, x[i + 1], 4, -1530992060);
          d = md5_hh(d, a, b, c, x[i + 4], 11, 1272893353);
          c = md5_hh(c, d, a, b, x[i + 7], 16, -155497632);
          b = md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
          a = md5_hh(a, b, c, d, x[i + 13], 4, 681279174);
          d = md5_hh(d, a, b, c, x[i + 0], 11, -358537222);
          c = md5_hh(c, d, a, b, x[i + 3], 16, -722521979);
          b = md5_hh(b, c, d, a, x[i + 6], 23, 76029189);
          a = md5_hh(a, b, c, d, x[i + 9], 4, -640364487);
          d = md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
          c = md5_hh(c, d, a, b, x[i + 15], 16, 530742520);
          b = md5_hh(b, c, d, a, x[i + 2], 23, -995338651);
          a = md5_ii(a, b, c, d, x[i + 0], 6, -198630844);
          d = md5_ii(d, a, b, c, x[i + 7], 10, 1126891415);
          c = md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
          b = md5_ii(b, c, d, a, x[i + 5], 21, -57434055);
          a = md5_ii(a, b, c, d, x[i + 12], 6, 1700485571);
          d = md5_ii(d, a, b, c, x[i + 3], 10, -1894986606);
          c = md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
          b = md5_ii(b, c, d, a, x[i + 1], 21, -2054922799);
          a = md5_ii(a, b, c, d, x[i + 8], 6, 1873313359);
          d = md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
          c = md5_ii(c, d, a, b, x[i + 6], 15, -1560198380);
          b = md5_ii(b, c, d, a, x[i + 13], 21, 1309151649);
          a = md5_ii(a, b, c, d, x[i + 4], 6, -145523070);
          d = md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
          c = md5_ii(c, d, a, b, x[i + 2], 15, 718787259);
          b = md5_ii(b, c, d, a, x[i + 9], 21, -343485551);
          a = safe_add(a, olda);
          b = safe_add(b, oldb);
          c = safe_add(c, oldc);
          d = safe_add(d, oldd);
        }

        return Array(a, b, c, d);
      }
      /*
       * These functions implement the four basic operations the algorithm uses.
       */


      function md5_cmn(q, a, b, x, s, t) {
        return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b);
      }

      function md5_ff(a, b, c, d, x, s, t) {
        return md5_cmn(b & c | ~b & d, a, b, x, s, t);
      }

      function md5_gg(a, b, c, d, x, s, t) {
        return md5_cmn(b & d | c & ~d, a, b, x, s, t);
      }

      function md5_hh(a, b, c, d, x, s, t) {
        return md5_cmn(b ^ c ^ d, a, b, x, s, t);
      }

      function md5_ii(a, b, c, d, x, s, t) {
        return md5_cmn(c ^ (b | ~d), a, b, x, s, t);
      }
      /*
       * Calculate the HMAC-MD5, of a key and some data
       */


      function core_hmac_md5(key, data) {
        var bkey = str2binl(key);
        if (bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);
        var ipad = Array(16),
            opad = Array(16);

        for (var i = 0; i < 16; i++) {
          ipad[i] = bkey[i] ^ 0x36363636;
          opad[i] = bkey[i] ^ 0x5C5C5C5C;
        }

        var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
        return core_md5(opad.concat(hash), 512 + 128);
      }
      /*
       * Add integers, wrapping at 2^32. This uses 16-bit operations internally
       * to work around bugs in some JS interpreters.
       */


      function safe_add(x, y) {
        var lsw = (x & 0xFFFF) + (y & 0xFFFF);
        var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
        return msw << 16 | lsw & 0xFFFF;
      }
      /*
       * Bitwise rotate a 32-bit number to the left.
       */


      function bit_rol(num, cnt) {
        return num << cnt | num >>> 32 - cnt;
      }
      /*
       * Convert a string to an array of little-endian words
       * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
       */


      function str2binl(str) {
        var bin = Array();
        var mask = (1 << chrsz) - 1;

        for (var i = 0; i < str.length * chrsz; i += chrsz) bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << i % 32;

        return bin;
      }
      /*
       * Convert an array of little-endian words to a string
       */


      function binl2str(bin) {
        var str = "";
        var mask = (1 << chrsz) - 1;

        for (var i = 0; i < bin.length * 32; i += chrsz) str += String.fromCharCode(bin[i >> 5] >>> i % 32 & mask);

        return str;
      }
      /*
       * Convert an array of little-endian words to a hex string.
       */


      function binl2hex(binarray) {
        var hex_tab = "0123456789abcdef";
        var str = "";

        for (var i = 0; i < binarray.length * 4; i++) {
          str += hex_tab.charAt(binarray[i >> 2] >> i % 4 * 8 + 4 & 0xF) + hex_tab.charAt(binarray[i >> 2] >> i % 4 * 8 & 0xF);
        }

        return str;
      }
      /*
       * Convert an array of little-endian words to a base-64 string
       */


      function binl2b64(binarray) {
        var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+_";
        var str = "";

        for (var i = 0; i < binarray.length * 4; i += 3) {
          var triplet = (binarray[i >> 2] >> 8 * (i % 4) & 0xFF) << 16 | (binarray[i + 1 >> 2] >> 8 * ((i + 1) % 4) & 0xFF) << 8 | binarray[i + 2 >> 2] >> 8 * ((i + 2) % 4) & 0xFF;

          for (var j = 0; j < 4; j++) {
            if (i * 8 + j * 6 > binarray.length * 32) str += b64pad;else str += tab.charAt(triplet >> 6 * (3 - j) & 0x3F);
          }
        }

        return str;
      }

      var md5 = {
        hex_md5: hex_md5,
        b64_md5: b64_md5,
        str_md5: str_md5,
        hex_hmac_md5: hex_hmac_md5,
        b64_hmac_md5: b64_hmac_md5,
        str_hmac_md5: str_hmac_md5
      }; // export default md5

      Reflect.defineProperty(globalThis, "md5", {
        value: md5
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PeterOpenWindow.ts", ['cc', './UIWindow.ts'], function () {
  'use strict';

  var cclegacy, _decorator, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "9fc06JEMotJSpbhgAkCSsqz", "PeterOpenWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;

      let AutoSpinTipWindow = ccclass(_class = (_temp = _class2 = class AutoSpinTipWindow extends UIWindow {
        onShow(showParams) {}

        onClose() {}

        callClose() {
          this.closeAnim();
        }

      }, _defineProperty(_class2, "windowPath", "Other/PeterOpenWindow"), _temp)) || _class;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GuestConfirmWindow.ts", ['cc', './UIWindow.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, UIWindow, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a02c6LBtslHlYgO6Zy8PHBD", "GuestConfirmWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let GuestConfirmWindow = exports('default', (_dec = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class GuestConfirmWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "bgMask", _descriptor, this);

          _defineProperty(this, "guestCallback", void 0);

          _defineProperty(this, "connectCallback", void 0);
        }

        onShow(param) {
          this.bgMask.on(Node.EventType.TOUCH_START, () => {
            this.close();
          }, this);
          this.guestCallback = param.guestCallback;
          this.connectCallback = param.connectCallback;
          GameKit.BackKeyManager.registerBackEvent();
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        guest() {
          if (this.guestCallback) this.guestCallback();
          this.closeAnim();
        }

        connect() {
          if (this.connectCallback) this.connectCallback();
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Sys/NewGuestConfirmWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "bgMask", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameTools.ts", ['cc', './StaticGame.ts'], function (exports) {
  'use strict';

  var Vec2, cclegacy, Meta;
  return {
    setters: [function (module) {
      Vec2 = module.Vec2;
      cclegacy = module.cclegacy;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "a077aS9EIZJlJxVd67M4gUk", "MinigameTools", undefined);
      /**
       * minigame下的一些通用方法
       */


      class MinigameTools {
        /**
         * 获取列表中的随机一项，传入一个给定的概率列表
         * @param {any[]} list 
         * @param {number[]} prob_list 概率列表，如果为null，则概率相等
         */
        static get_random_item(list, prob_list = null) {
          if (!prob_list) {
            return list[Math.trunc(Math.random() * list.length)];
          } // 重构概率列表


          let sum = 0;
          prob_list = prob_list.map(v => {
            sum += v;
            return sum;
          }); // 计算概率

          let rn = Math.random();

          for (let i = 0; i < prob_list.length; i += 1) {
            if (rn < prob_list[i]) {
              return list[i];
            } else {
              continue;
            }
          }

          return list[list.length - 1];
        }
        /**
         * 获取节点的world-position
         * @param {cc.Node} node 
         */


        static get_node_world_position(node) {
          return node.convertToWorldSpaceAR(Vec2.ZERO);
        }
        /**
         * 将弧度转化为角度
         * @param {number} radian 
         */


        static trans_radian_to_angle(radian) {
          return radian / (Math.PI / 180);
        }
        /**
         * 将角度转化为弧度
         * @param {number} angle 
         */


        static trans_angle_to_radian(angle) {
          return angle * (Math.PI / 180);
        }
        /**
         * 获取一个随机整数，[min,max)，参数需要为整数
         * @param {number} min 
         * @param {number} max 
         */


        static get_random_int(min, max) {
          return Math.trunc(Math.random() * (max - min) + min);
        }
        /**
         * 数字随机浮动，[base_number-float_number,base_number+float_number)，参数需要为整数
         * @param {number} base_number 基础数字
         * @param {number} float_number 浮动数字
         */


        static number_float(base_number, float_number) {
          let min = base_number - float_number;
          let max = base_number + float_number;
          return Math.trunc(Math.random() * (max - min) + min);
        }
        /**
         * 保留数字的几位小数
         * - 将数字的后几位置为0，则count为负数
         * @param {number} number
         * @param {number} count 
         */


        static number_fixed(number, count) {
          return Math.trunc(number * 10 ** count) / 10 ** count;
        }
        /** 获取10个 */


        static get_10_fake_user() {
          return Meta.SystemUserMeta.getSeedRandomUsers(20);
        }

      }

      exports('default', MinigameTools);

      _defineProperty(MinigameTools, "FAKE_USER_DATA", []);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NumAnim.ts", ['cc', './CCE_Component.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, CCE_Component, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a10fc4CcX1GNrZg+8X5RXI9", "NumAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NumAnim = exports('default', (_dec = property(Label), ccclass(_class = (_class2 = (_temp = class NumAnim extends CCE_Component {
        constructor() {
          super();

          _initializerDefineProperty(this, "targetLabel", _descriptor, this);

          _defineProperty(this, "playing", void 0);

          _defineProperty(this, "fromValue", void 0);

          _defineProperty(this, "toValue", void 0);

          _defineProperty(this, "playTime", void 0);

          _defineProperty(this, "currentValue", void 0);

          _defineProperty(this, "duration", void 0);

          this.playing = false;
          this.fromValue = 0;
          this.toValue = 0;
          this.playTime = 0;
          this.currentValue = 0;
          this.duration = 0;
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        slowUpdate(dt) {
          if (this.playing == true) {
            this.playTime += dt;
            this.currentValue = Math.lerp(this.fromValue, this.toValue, this.playTime / this.duration);
            this.currentValue = Math.floor(this.currentValue);

            if (this.playTime >= this.duration) {
              this.playTime = this.duration;
              this.playing = false;
              this.currentValue = this.toValue;
            }

            this.setValue(this.currentValue);
          }
        }

        playAnim(from, to, duration) {
          from = from || this.currentValue;
          this.playing = true;
          this.fromValue = from;
          this.toValue = to;
          this.playTime = 0;
          this.duration = duration;
          this.setValue(from);
        }

        setValue(value) {
          this.targetLabel.string = GameKit.StringUtil.formatNumber(value);
        }

        getCurrentValue() {
          return this.currentValue;
        }

        setCurrentValue(v) {
          this.currentValue = v;
          this.setValue(this.currentValue);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "targetLabel", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotPet.ts", ['cc', './Constant.ts', './Pet.ts', './PetStateIdle.ts', './PetStateWander.ts', './PetStateLieDown.ts', './PetStateFollowing.ts', './PetStateGetUp.ts', './Player.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Tween, MyCustomEvent, Pet, PetStateIdle, PetStateWander, PetStateLieDown, PetStateFollowing, PetStateGetUp, Player, Game, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Tween = module.Tween;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      Pet = module.default;
    }, function (module) {
      PetStateIdle = module.default;
    }, function (module) {
      PetStateWander = module.default;
    }, function (module) {
      PetStateLieDown = module.default;
    }, function (module) {
      PetStateFollowing = module.default;
    }, function (module) {
      PetStateGetUp = module.default;
    }, function (module) {
      Player = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "a1155I2s5ZMoZudoY9/rxwB", "SlotPet", undefined);

      const {
        ccclass,
        property
      } = _decorator; // enum PetState {
      //     Idle,
      //     Wander,
      //     GetUp,
      //     Following,
      //     LieDown,
      // }

      let SlotPet = exports('default', (_dec = ccclass("SlotPet"), _dec(_class = (_temp = class SlotPet extends Pet {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "curState", void 0);

          _defineProperty(this, "offset", void 0);

          _defineProperty(this, "isSleeping", true);

          _defineProperty(this, "remainTime", void 0);

          _defineProperty(this, "curWanderTargetPoint", void 0);

          _defineProperty(this, "speed", 10);

          _defineProperty(this, "lastUpdateTime", void 0);

          _defineProperty(this, "lastDistance", 0);

          _defineProperty(this, "startFollowDistance", 0.2);

          _defineProperty(this, "timeSinceLastWandering", 0);

          _defineProperty(this, "timeSinceLastMoveInterval", 2);

          _defineProperty(this, "isPlayerAFK", false);

          _defineProperty(this, "afkTimeElapsed", 0);

          _defineProperty(this, "afkTimeinterval", 2);

          _defineProperty(this, "reachNewRoom", true);

          _defineProperty(this, "isPetFollowing", false);

          _defineProperty(this, "isPetReady", false);

          _defineProperty(this, "hasSetOffed", false);
        }

        onLoad() {
          super.onLoad();
          let selectId = Game.SUserServant.GetSelected();

          if (!selectId) {
            this.node.active = false;
            return;
          }

          this.updatePetTime(parseInt(selectId));
          eventCenter.on(MyCustomEvent.UpdatePetStatus, this.updatePetTime, this);
        }

        onDestroy() {
          eventCenter.off(MyCustomEvent.UpdatePetStatus, this.updatePetTime, this);
        }

        transitionTo(newState) {
          console.log("transitionTo", newState.constructor.name);
          this.curState && this.curState.onExit();
          this.curState = newState;
          this.curState.setContext(this);
          newState.onEnter();
        }

        update(dt) {
          if (!homeView.isGamePrepared) return;
          this.curState && this.curState.customUpdate(dt);
          let cTime = GameKit.TimeUtil.getCurrentTime();

          let _t = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;

          this.lastUpdateTime = cTime;

          if (this.remainTime) {
            this.remainTime -= _t;

            if (this.remainTime <= 0) {
              this.remainTime = null;
              this.isSleeping = true;
              this.updatePetTime(parseInt(Game.SUserServant.GetSelected()));
              return;
            }
          }

          this.afkTimeElapsed += dt;

          if (this.afkTimeElapsed > this.afkTimeinterval) {
            this.isPlayerAFK = true;
            let bo1 = !(this.curState instanceof PetStateWander);
            let bo2 = !(this.curState instanceof PetStateFollowing);
            let bo3 = !(this.curState instanceof PetStateGetUp);
            let bo4 = !(this.curState instanceof PetStateLieDown);
            let bo5 = !this.isSleeping; //2s不动进入wander状态

            if (bo1 && bo2 && bo3 && bo4 && bo5) {
              this.transitionTo(new PetStateWander());
            }
          } // this.timeSinceLastWandering += dt;
          // if (this.timeSinceLastWandering > this.timeSinceLastMoveInterval && !this.isSleeping && !this.isWandering && this.isPlayerAFK && this.reachNewRoom) {
          //     this.isWandering = true;
          //     this.wander();
          // }
          // const isPlayerMoving = Player.instance.isRunning;


          const target = Player.instance.petSlot;
          const dir = target.worldPosition.clone().subtract(this.node.worldPosition);
          const distance = dir.length();
          const isPlayerAheadOfPet = Player.instance.node.worldPosition.z + 3 < this.node.worldPosition.z; //拉开距离大于1的时候开始跟随

          if (!this.reachNewRoom && isPlayerAheadOfPet && distance > 1 && !this.hasSetOffed) {
            this.hasSetOffed = true;

            if (this.isSleeping) {
              if (!(this.curState instanceof PetStateGetUp)) {
                this.transitionTo(new PetStateGetUp());
              }
            } else {
              if (!(this.curState instanceof PetStateFollowing)) {
                this.transitionTo(new PetStateFollowing());
              }
            }
          }
        }

        updatePetTime(selectId) {
          let state = Game.SUserServant.Servant(selectId);

          let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

          if (time > 0) {
            this.isSleeping = false;
            this.remainTime = time;
            this.transitionTo(new PetStateIdle());
          } else {
            this.isSleeping = true;
            this.transitionTo(new PetStateIdle());
          }
        }

        onPlayerMoveStart() {
          this.isPlayerAFK = false;
          this.reachNewRoom = false;
          this.hasSetOffed = false;
          Tween.stopAllByTarget(this.node); // this.changeStateToIdle();
        }

        onPlayerMoveEnd() {
          // this.afkTimeElapsed = 0;
          // this.isWandering = false;
          this.timeSinceLastWandering = 0;
        } // petMoveStart() {
        //     this.isPetReady = false;
        //     if (this.isSleeping) {
        //         this.changeStateFromRestToIdle(() => {
        //             this.isPetReady = true;
        //             this.changeStateToRun();
        //         });
        //     } else {
        //         this.isPetReady = true;
        //         this.changeStateToRun();
        //     }
        // }
        // petMoveEnd() {
        //     this.reachNewRoom = true;
        //     if (this.isSleeping) {
        //         this.changeStateFromIdleToRest(() => {
        //             this.changeStateToRest();
        //         });
        //     } else {
        //         this.changeStateToIdle();
        //     }
        // }


        randomRange(min, max) {
          return Math.random() * (max - min) + min;
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/base64.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports('Base64', void 0);

      cclegacy._RF.push({}, "a1692jhxCJMEYtumpGasfiW", "base64", undefined);

      let Base64;

      (function (_Base) {
        const _keyStr = _Base._keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

        function encode(input) {
          var output = "";
          var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
          var i = 0;
          input = _utf8_encode(input);

          while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = (chr1 & 3) << 4 | chr2 >> 4;
            enc3 = (chr2 & 15) << 2 | chr3 >> 6;
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
              enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
              enc4 = 64;
            }

            output = output + _keyStr.charAt(enc1) + _keyStr.charAt(enc2) + _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
          }

          return output;
        }

        _Base.encode = encode;

        function decode(input) {
          var output = "";
          var chr1, chr2, chr3;
          var enc1, enc2, enc3, enc4;
          var i = 0;
          input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

          while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = enc1 << 2 | enc2 >> 4;
            chr2 = (enc2 & 15) << 4 | enc3 >> 2;
            chr3 = (enc3 & 3) << 6 | enc4;
            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
              output = output + String.fromCharCode(chr2);
            }

            if (enc4 != 64) {
              output = output + String.fromCharCode(chr3);
            }
          }

          output = _utf8_decode(output);
          return output;
        }

        _Base.decode = decode; // private method for UTF-8 encoding

        function _utf8_encode(string) {
          //string = string.replace(/\r\n/g,"\n");
          var utftext = "";

          for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);

            if (c < 128) {
              utftext += String.fromCharCode(c);
            } else if (c > 127 && c < 2048) {
              utftext += String.fromCharCode(c >> 6 | 192);
              utftext += String.fromCharCode(c & 63 | 128);
            } else {
              utftext += String.fromCharCode(c >> 12 | 224);
              utftext += String.fromCharCode(c >> 6 & 63 | 128);
              utftext += String.fromCharCode(c & 63 | 128);
            }
          }

          return utftext;
        } // private method for UTF-8 decoding


        function _utf8_decode(utftext) {
          var string = "";
          var i = 0;
          var c = 0;
          var c2 = 0;
          var c3 = 0;

          while (i < utftext.length) {
            c = utftext.charCodeAt(i);

            if (c < 128) {
              string += String.fromCharCode(c);
              i++;
            } else if (c > 191 && c < 224) {
              c2 = utftext.charCodeAt(i + 1);
              string += String.fromCharCode((c & 31) << 6 | c2 & 63);
              i += 2;
            } else {
              c2 = utftext.charCodeAt(i + 1);
              c3 = utftext.charCodeAt(i + 2);
              string += String.fromCharCode((c & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
              i += 3;
            }
          }

          return string;
        }
      })(Base64 || (Base64 = exports('Base64', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameBuyTicketWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Label, SoundManager, UIWindow, Meta, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Label = module.Label;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a3398hd8qBN8b5FS+qzzvSJ", "MinigameBuyTicketWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      const C = {
        shopIds: [6001, 6002]
      };
      /**
       * 一个通用的购买门票页面,供Minigame使用
       * - [使用方法]:UIRoot.instance.openChildWindow(MinigameBuyTicketWindow, {...})
       */

      let MinigameBuyTicketWindow = exports('default', (_dec = property({
        tooltip: "",
        type: Node
      }), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameBuyTicketWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "buy_item_list", _descriptor, this);
        }

        onShow() {
          this.load_page();
        }

        onClose() {}
        /** @type {cc.Node[]} */


        load_page() {
          this.buy_item_list.forEach((v, i) => {
            let shopmeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, C.shopIds[i]);
            let label_info = GameKit.ControllerTable.GetNode(v, "label-info").getComponent(Label);
            let label_price = GameKit.ControllerTable.GetNode(v, "label-price").getComponent(Label);
            let label_off = GameKit.ControllerTable.GetNode(v, "off_text").getComponent(Label);
            label_info.string = `${shopmeta.Content().Name()} *${shopmeta.Count()}`;
            label_price.string = shopmeta.PriceString();
            label_off.string = String.format(i18n.t("OffText"), Math.round(shopmeta.Off() * 100));
            label_off.node.parent.active = shopmeta.Off() != 0;
          });
        }

        event_close() {
          this.closeAnim();
        }
        /** 购买1张门票 */


        event_buy_1() {
          this.buy_item(C.shopIds[0]);
        }
        /** 购买10张门票 */


        event_buy_10() {
          this.buy_item(C.shopIds[1]);
        }

        buy_item(id) {
          let shopmeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, id);
          PaymentWrap.Pay(shopmeta.Name(), function (ok) {
            if (ok) {
              if (this.node) this.closeAnim();
              SoundManager.playSound("item_purchased");
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "items",
                name: shopmeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "items",
                name: shopmeta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "items",
            name: shopmeta.Name(),
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/minigame/MinigameBuyTicketWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "buy_item_list", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LabelShadow.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, color, Node, Label, RichText, instantiate, UITransform, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      color = module.color;
      Node = module.Node;
      Label = module.Label;
      RichText = module.RichText;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a33d1g3Fn9MNovvUhlCcnrQ", "LabelShadow", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let LabelShadow = exports('default', ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class LabelShadow extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_string", null);

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "shadowNode", void 0);

          _defineProperty(this, "nodeName", void 0);

          _defineProperty(this, "_color", color(255, 255, 255, 255));

          _defineProperty(this, "_opacity", 255);

          _defineProperty(this, "_dx", 0);

          _defineProperty(this, "_dy", 0);
        }

        set color(value) {
          this._color = value;

          this._updateRenderData();
        }

        get color() {
          return this._color;
        }

        set opacity(value) {
          this._opacity = value;

          this._updateRenderData();
        }

        get opacity() {
          return this._opacity;
        }

        set dx(value) {
          this._dx = value;

          this._updateRenderData();
        }

        get dx() {
          return this._dx;
        }

        set dy(value) {
          this._dy = value;

          this._updateRenderData();
        }

        get dy() {
          return this._dy;
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {}

        start() {
          this.node.on(Node.EventType.SIZE_CHANGED, () => {
            this._updateRenderData();
          }, this);
          this.node.on(Node.EventType.TRANSFORM_CHANGED, () => {
            this._updateRenderData();
          }, this); // this.node.on(cc.Node.EventType.POSITION_CHANGED, () => {
          //     this._updateRenderData()
          // }, this)
          // this.node.on(cc.Node.EventType.SCALE_CHANGED, () => {
          //     this._updateRenderData()
          // }, this)
          // this.node.on(cc.Node.EventType.ROTATION_CHANGED, () => {
          //     this._updateRenderData()
          // }, this)

          this.node.on(Node.EventType.COLOR_CHANGED, () => {
            this._updateRenderData();
          }, this);
          this.node.on(Node.EventType.ANCHOR_CHANGED, () => {
            this._updateRenderData();
          }, this); // if (this.getComponent(cc.Label)) {
          //     this.getComponent(cc.Label).onStringChanged = function() {
          //         this._updateRenderData();
          //     }.bind(this)
          // }
          // if (this.getComponent(cc.RichText)) {
          //     this.getComponent(cc.RichText).onStringChanged = function() {
          //         this._updateRenderData();
          //     }.bind(this)
          // }
        }

        slowUpdate() {
          if (!this.inited) {
            this._updateRenderData();

            this.inited = true;
          }

          if (CC_EDITOR) {
            if (this.shadowNode && this.nodeName != this.getUniName()) {
              this.nodeName = this.getUniName();
              this.shadowNode.name = "_LabelShadow_child_" + this.nodeName;
            }
          }

          if (this.getComponent(Label) && this._string !== this.getComponent(Label).string) {
            this._string = this.getComponent(Label).string;

            this._updateRenderData();
          }

          if (this.getComponent(RichText) && this._string !== this.getComponent(RichText).string) {
            this._string = this.getComponent(RichText).string;

            this._updateRenderData();
          }
        }

        getUniName() {
          // cc.log("this.node.name",this.node.name);
          return this.node.name;
        }

        _updateRenderData() {
          if (!this.node || !this.enabled) return;
          let child_t = this.node.parent.getChildByName("_LabelShadow_child_" + this.getUniName());

          if (!this.shadowNode && child_t) {
            this.shadowNode = child_t;
          }

          if (!this.shadowNode || !this.shadowNode["_active"] && CC_EDITOR) {
            if (CC_EDITOR) this.nodeName = this.getUniName();
            this.enabled = false;
            this.shadowNode = instantiate(this.node);
            this.shadowNode.getComponent(LabelShadow).destroy();
            this.shadowNode.name = CC_EDITOR ? "_LabelShadow_child_" + this.nodeName : "_LabelShadow_child_" + this.getUniName();
            this.shadowNode.parent = this.node.parent;
            let ind = this.node.getSiblingIndex();
            this.shadowNode.setSiblingIndex(ind);
            this.enabled = true;
          }

          this.shadowNode.x = this.node.x + this.dx;
          this.shadowNode.y = this.node.y + this.dy;
          this.shadowNode.color = this.color;
          this.shadowNode.opacity = this.opacity;
          this.shadowNode.getComponent(UITransform).setContentSize(this.node.getComponent(UITransform).contentSize);
          this.shadowNode.scaleX = this.node.scaleX;
          this.shadowNode.scaleY = this.node.scaleY;
          this.shadowNode.getComponent(UITransform).setAnchorPoint(this.node.getComponent(UITransform).anchorPoint);
          this.shadowNode.angle = this.node.angle;

          if (this.getComponent(Label)) {
            this.shadowNode.getComponent(Label).string = this.getComponent(Label).string;
            this.shadowNode.getComponent(Label).horizontalAlign = this.getComponent(Label).horizontalAlign;
            this.shadowNode.getComponent(Label).verticalAlign = this.getComponent(Label).verticalAlign;
            this.shadowNode.getComponent(Label).fontSize = this.getComponent(Label).fontSize;
            this.shadowNode.getComponent(Label).lineHeight = this.getComponent(Label).lineHeight;
          }

          if (this.getComponent(RichText)) {
            this.shadowNode.getComponent(RichText).string = this.getComponent(RichText).string;
            this.shadowNode.getComponent(RichText).horizontalAlign = this.getComponent(RichText).horizontalAlign;
            this.shadowNode.getComponent(RichText).fontSize = this.getComponent(RichText).fontSize;
            this.shadowNode.getComponent(RichText).lineHeight = this.getComponent(RichText).lineHeight;
          }
        }

      }, _temp), (_applyDecoratedDescriptor(_class2.prototype, "color", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "color"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "opacity", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "opacity"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "dx", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "dx"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "dy", [property], Object.getOwnPropertyDescriptor(_class2.prototype, "dy"), _class2.prototype)), _class2)) || _class) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LongScreenFit.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, view, Widget, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      view = module.view;
      Widget = module.Widget;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "a48511ssaZDl4zEQ1TM5nEF", "LongScreenFit", undefined);

      const {
        ccclass,
        property,
        executionOrder
      } = _decorator;
      let LongScreenFit = exports('default', (_dec = executionOrder(100), ccclass(_class = _dec(_class = (_temp = class LongScreenFit extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "over", void 0);
        }

        onLoad() {
          if (!this.enabled) return;
          if (this.over) return;
          let ssize = view.getVisibleSize();

          if (ssize.height / ssize.width > 1250 / 640) {
            let widget = this.getComponent(Widget);

            if (widget != null && widget.enabled) {
              widget.updateAlignment();
              widget.enabled = false;
            } //this.node.y -= 44

          }

          this.over = true;
        }

      }, _temp)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LoadingWindow.ts", ['cc', './global.ts', './BackKeyManager.ts', './UIWindow.ts', './UIRoot.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, G, BackKeyManager, UIWindow, UIRoot;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      BackKeyManager = module.BackKeyManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a4bb97PHVxMv41ycG7FlgX3", "LoadingWindow", undefined); //加载蒙板


      const {
        ccclass,
        property
      } = _decorator;
      let LoadingWindow = exports('LoadingWindow', (_dec = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class LoadingWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "sp", _descriptor, this);
        }

        onLoad() {
          LoadingWindow.instance = this;
        }

        onDestroy() {
          LoadingWindow.instance = null;
        }

        static Show(immediately = false) {
          if (LoadingWindow.isshow) {
            clearTimeout(LoadingWindow.timeId);
            LoadingWindow.timeId = setTimeout(() => {
              LoadingWindow.Hide();
            }, G.Constance.loadingTime * 1000);

            if (immediately) {
              LoadingWindow.instance.sp.active = true;
            }

            return;
          }

          LoadingWindow.isshow = true;
          this.immediately = immediately;
          UIRoot.instance.loadingWindow.active = true;
          LoadingWindow.timeId = setTimeout(() => {
            LoadingWindow.Hide();
          }, G.Constance.loadingTime * 1000);
          BackKeyManager.registerBackEvent();
        }

        static ShowAfterDelay(delay) {
          LoadingWindow.isshow = true;
          this.immediately = true;
          LoadingWindow.timeId = setTimeout(() => {
            if (LoadingWindow.isshow) {
              UIRoot.instance.loadingWindow.active = true;
              LoadingWindow.timeId = setTimeout(() => {
                LoadingWindow.Hide();
              }, G.Constance.loadingTime * 1000);
            } else {
              LoadingWindow.Hide();
            }
          }, delay);
          BackKeyManager.registerBackEvent();
        }

        static Hide() {
          if (!LoadingWindow.isshow) return;
          LoadingWindow.isshow = false;
          if (LoadingWindow.timeId >= 0) clearTimeout(LoadingWindow.timeId);
          LoadingWindow.timeId = -1;
          UIRoot.instance.loadingWindow.active = false;
          BackKeyManager.unregisterBackEvent();
        }

        onShow() {
          BackKeyManager.registerBackEvent();
        }

        onClose() {
          BackKeyManager.unregisterBackEvent();
        }

        onEnable() {
          this.sp.stopAllActions();
          this.sp.active = LoadingWindow.immediately;
        }

        onDisable() {
          LoadingWindow.isshow = false;
          LoadingWindow.timeId = -1;
        } // showModel() {
        // 	if (!this.sp.active) {
        // 		this.sp.active = true;
        // 		this.sp.opacity = 1;
        // 		this.sp.runAction(ccAction.fadeIn(0.3));
        // 	}
        // }


      }, _defineProperty(_class3, "windowPath", "Common/LoadingWindow"), _defineProperty(_class3, "isshow", false), _defineProperty(_class3, "timeId", -1), _defineProperty(_class3, "immediately", false), _defineProperty(_class3, "instance", void 0), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "sp", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardModel.ts", ['cc', './CCE_Component.ts', './_app.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Node, Sprite, Label, Layout, _decorator, Color, CCE_Component, cce, Meta, Game, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      Layout = module.Layout;
      _decorator = module._decorator;
      Color = module.Color;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a4e8foZJHxA2Iu2ulcHW30u", "CardModel", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        BASE_PATH: "res/Card",
        DEFAULT_COLOR: "#0dadfe"
      };
      /**
       * 单个card的显示状态
       * - [使用方法1] 挂载在某个节点上,拖入对应的node
       * - [使用方法2] 直接拖入prefab-CardModel
       */

      let CardModel = exports('default', (_dec = property(SpriteFrame), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Sprite), _dec7 = property(Label), _dec8 = property(Sprite), _dec9 = property(Layout), _dec10 = property(Label), _dec11 = property({
        tooltip: "lock组件,以label为父节点",
        type: Label
      }), _dec12 = property([SpriteFrame]), ccclass(_class = (_class2 = (_temp = class CardModel extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "card_meta", null);

          _defineProperty(this, "set_meta", null);

          _defineProperty(this, "type", void 0);

          _defineProperty(this, "goldTrade", void 0);

          _defineProperty(this, "cardId", null);

          _initializerDefineProperty(this, "ownedTitleBg", _descriptor, this);

          _initializerDefineProperty(this, "cardBg", _descriptor2, this);

          _initializerDefineProperty(this, "cardNotHave", _descriptor3, this);

          _initializerDefineProperty(this, "sp_border_normal", _descriptor4, this);

          _initializerDefineProperty(this, "sp_border_golden", _descriptor5, this);

          _initializerDefineProperty(this, "sp_card", _descriptor6, this);

          _defineProperty(this, "spf_reset_card", null);

          _initializerDefineProperty(this, "label_name", _descriptor7, this);

          _initializerDefineProperty(this, "sp_title_bg", _descriptor8, this);

          _initializerDefineProperty(this, "layout_rare", _descriptor9, this);

          _initializerDefineProperty(this, "label_more_count", _descriptor10, this);

          _initializerDefineProperty(this, "label_lock", _descriptor11, this);

          _initializerDefineProperty(this, "bgArr", _descriptor12, this);
        }
        /**
         * 显示单个card
         * @param {number} id
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";默认为"check"
         */


        show(id, type = "check") {
          // 获取数据
          this.cardId = id;
          this.type = type;
          this.card_meta = Meta.MetaManager.GetMeta(Meta.MetaType.Card, id);
          this.set_meta = Meta.MetaManager.GetMeta(Meta.MetaType.CardSets, this.card_meta.SetId()); // 修改样式

          this.show_border(type);
          this.show_card(type);
          this.show_name(type);
          this.show_rare(type);
          this.show_more_count(type);
          this.show_bg_title(type);
          this.show_lock(type);
          this.show_questionMark(type);
          this.show_bg(type);

          if (Game.SUserVillage.MapId() < this.card_meta.MinVillage()) {
            this.sp_card.node.active = false;
            this.cardBg.active = false;
            this.label_more_count.node.parent.active = false;
          }
        }
        /** 直接reset,无id传入 */


        reset() {
          this.show_border("reset");
          this.show_card("reset");
          this.show_name("reset");
          this.show_rare("reset");
          this.show_more_count("reset");
          this.show_bg_title("reset");
          this.show_lock("reset");
          this.show_questionMark("reset");
        }
        /** @type {cc.Node} */


        onClose() {// cce.releaseSpriteFrame(this.sp_card);
          // cce.releaseSpriteFrame(this.sp_title_bg);
        }
        /**
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";
         */


        show_border(type) {
          switch (type) {
            default:
            case "check":
            case "no-check":
              let f = this.card_meta.Golden();

              if (this.sp_border_normal) {
                this.sp_border_normal.active = !f;
              }

              if (this.sp_border_golden) {
                this.sp_border_golden.active = !!f;
              }

              break;

            case "reset":
              // "reset"状态下显示normal
              if (this.sp_border_normal) {
                this.sp_border_normal.active = true;
              }

              if (this.sp_border_golden) {
                this.sp_border_golden.active = false;
              }

              break;
          }
        }
        /** @type {cc.Sprite} */
        // 默认的card

        /**
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";
         */


        show_card(type) {
          if (!this.sp_card) {
            return;
          }

          if (!this.spf_reset_card) {
            this.spf_reset_card = this.sp_card.spriteFrame;
          }

          this.sp_card.node.active = true;

          const f = () => {
            let resName = `${C.BASE_PATH}/${this.card_meta.Data().icon}`;
            cce.loadRes(resName, SpriteFrame, (err, res) => {
              if (!err && this.sp_card) {
                this.sp_card.spriteFrame = res;
              }
            });
          }; // cce.releaseSpriteFrame(this.sp_card);


          this.sp_card.spriteFrame = null; // 初始化

          switch (type) {
            default:
            case "check":
              Game.SUserCard.HaveCard(this.card_meta.Id()) && f();
              break;

            case "no-check":
              f();
              break;

            case "reset":
              break;
          }
        }
        /** @type {cc.Label} Name() or Id() or Index() */

        /**
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";
         */


        show_name(type) {
          if (!this.label_name) {
            return;
          }

          switch (type) {
            default:
            case "check":
            case "no-check":
              this.label_name.string = `${this.card_meta.Name()}`;
              break;

            case "reset":
              this.label_name.string = "";
              break;
          }
        }
        /** @type {cc.Sprite} */

        /**
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";
         */


        show_bg_title(type) {
          if (!this.sp_title_bg) {
            return;
          } // bg颜色


          if (Game.SUserCard.HaveCard(this.card_meta.Id())) {
            this.sp_title_bg.node.color = new Color(this.set_meta.Color());
          } else {
            this.sp_title_bg.node.color = new Color(C.DEFAULT_COLOR);
          }
        }
        /** @type {cc.Layout} rare-star */

        /**
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";
         */


        show_rare(type) {
          if (!this.layout_rare) {
            return;
          }

          switch (type) {
            default:
            case "check":
            case "no-check":
              this.layout_rare.node.children.forEach((node, index) => {
                node.active = index < this.card_meta.Rare();
              });
              break;

            case "reset":
              this.layout_rare.node.children.forEach(node => {
                node.active = false;
              });
              break;
          }
        }
        /** @type {cc.Label} 额外个数 */

        /**
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";
         */


        show_more_count(type) {
          if (!this.label_more_count) {
            return;
          }

          this.label_more_count.node.parent.active = true;

          switch (type) {
            default:
            case "check":
              let count_check = Game.SUserCard.CardNum(this.card_meta.Id());
              this.label_more_count.node.parent.active = count_check > 1;
              this.label_more_count.string = `+${count_check - 1}`;
              break;

            case "no-check":
              // 在"no-check"状态下,直接显示当前个数
              let count_no_check = Game.SUserCard.CardNum(this.card_meta.Id());
              this.label_more_count.node.parent.active = true;
              this.label_more_count.string = `${count_no_check}`;
              break;

            case "reset":
              // 在"reset"状态下,直接隐藏
              this.label_more_count.string = "";
              this.label_more_count.node.parent.active = false;
              break;
          }
        }
        /** @type {cc.Label} */

        /**
         * @param {"check"|"no-check"|"reset"} type "check"表示根据实际状态验证;"no-check"表示跳过验证;"reset表示重置";
         */


        show_lock(type) {
          if (!this.label_lock) {
            return;
          }

          switch (type) {
            default:
            case "check":
              if (Game.SUserVillage.MapId() < this.card_meta.MinVillage()) {
                this.label_lock.string = String.format(i18n.t("CardAllSetWindowLock"), this.card_meta.MinVillage());
                this.label_lock.node.active = true;
              } else {
                this.label_lock.node.active = false;
              }

              break;

            case "no-check":
            case "reset":
              // no-check和reset状态下直接隐藏
              this.label_lock.node.active = false;
              break;
          }
        }

        show_questionMark(type) {
          if (!this.cardNotHave) {
            return;
          }

          if (Game.SUserVillage.MapId() >= this.card_meta.MinVillage() && !Game.SUserCard.HaveCard(this.card_meta.Id())) {
            this.cardNotHave.active = true;
          } else {
            this.cardNotHave.active = false;
          }
        }

        show_bg(type, isNewCard) {
          this.cardBg.active = true;

          switch (type) {
            default:
            case "check":
              if (isNewCard || Game.SUserCard.HaveCard(this.card_meta.Id()) && Game.SUserVillage.MapId() >= this.card_meta.MinVillage()) {
                this.cardBg.active = true;
                const res = "res/Card/card_bg";

                switch (this.card_meta.Bg()) {
                  case 1:
                    cce.loadRes(res + "1", SpriteFrame, (err, sp) => {
                      if (err) return;
                      this && this.cardBg && (this.cardBg.getComponent(Sprite).spriteFrame = sp);
                    });
                    break;

                  case 2:
                    cce.loadRes(res + "2", SpriteFrame, (err, sp) => {
                      if (err) return;
                      this && this.cardBg && (this.cardBg.getComponent(Sprite).spriteFrame = sp);
                    });
                    break;

                  case 3:
                    cce.loadRes(res + "3", SpriteFrame, (err, sp) => {
                      if (err) return;
                      this && this.cardBg && (this.cardBg.getComponent(Sprite).spriteFrame = sp);
                    });
                    break;
                } //TODO
                //change bg spriteFrame by excel

              } else {
                this.cardBg.active = false;
              }

              break;

            case "no-check":
            case "reset":
              // no-check和reset状态下直接隐藏
              this.cardBg.active = false;
              break;
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ownedTitleBg", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "cardBg", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "cardNotHave", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp_border_normal", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sp_border_golden", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "sp_card", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "label_name", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "sp_title_bg", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "layout_rare", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "label_more_count", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "label_lock", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "bgArr", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HelpButton.ts", ['cc', './CCE_Component.ts', './i18n.ts', './HelpWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Button, CCE_Component, i18n, HelpWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Button = module.Button;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      HelpWindow = module.HelpWindow;
    }],
    execute: function () {
      var _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a58f8v+GtJIIZNcbyGnBD2U", "HelpButton", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let HelpButton = exports('default', ccclass(_class = (_class2 = (_temp = class HelpButton extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "titleKey", _descriptor, this);

          _initializerDefineProperty(this, "helpKey", _descriptor2, this);
        } // onEnable() {
        // 	this.node.on(
        // 		cc.Node.EventType.TOUCH_END,
        // 		function () {
        // 			if (this.node.getComponent(cc.Button) && !this.node.getComponent(cc.Button).interactable) return;
        // 			HelpWindow.Show(i18n.t(this.titleKey), this.helpKey);
        // 		}.bind(this),
        // 		this
        // 	);
        // }
        // onDisable() {
        // 	this.node.targetOff(this.node);
        // }


        onClick() {
          if (this.node.getComponent(Button) && !this.node.getComponent(Button).interactable) return;
          HelpWindow.Show(i18n.t(this.titleKey), this.helpKey);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "titleKey", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "helpKey", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      })), _class2)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRItems.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRItems', void 0);

      cclegacy._RF.push({}, "a5905QCW1ZLboFcvCDoi2ZP", "SRItems", undefined);

      let SRItems;

      (function (_SRItems) {
        function getUserItems() {
          let req = new GameKit.ServerRequest("getUserItems");
          req.SetCallBack(function (res) {
            Game.SUserItems.updateData(res.userdata);
          });
          return req;
        }

        _SRItems.getUserItems = getUserItems;
      })(SRItems || (SRItems = exports('SRItems', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Rotate3D.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Quat;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Quat = module.Quat;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "a6ed5JuzTZAIYMYAFAtZPoV", "Rotate3D", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Rotate3D = exports('default', (_dec = ccclass("Rotate3D"), _dec(_class = (_temp = class Rotate3D extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "speed", -0.8);

          _defineProperty(this, "rotation", new Quat());

          _defineProperty(this, "rad", void 0);
        }

        onLoad() {
          this.rotation = this.node.rotation;
          this.rad = this.speed / 180 * Math.PI;
        }

        update(dt) {
          // this.node. += (360 / this.speed * dt) * this.duration;
          // this.node.
          Quat.rotateY(this.rotation, this.node.rotation, this.rad);
          this.node.rotation = this.rotation;
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BlackJackAssets.ts", ['cc', './CCE_Component.ts', './global.ts', './fixedSizeRatio.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, _decorator, Sprite, CCE_Component, G, fixedSizeRatio, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      Sprite = module.Sprite;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      fixedSizeRatio = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _dec27, _dec28, _dec29, _dec30, _dec31, _dec32, _dec33, _dec34, _dec35, _dec36, _dec37, _dec38, _dec39, _dec40, _dec41, _dec42, _dec43, _dec44, _dec45, _dec46, _dec47, _dec48, _dec49, _dec50, _dec51, _dec52, _dec53, _dec54, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _descriptor26, _descriptor27, _descriptor28, _descriptor29, _descriptor30, _descriptor31, _descriptor32, _descriptor33, _descriptor34, _descriptor35, _descriptor36, _descriptor37, _descriptor38, _descriptor39, _descriptor40, _descriptor41, _descriptor42, _descriptor43, _descriptor44, _descriptor45, _descriptor46, _descriptor47, _descriptor48, _descriptor49, _descriptor50, _descriptor51, _descriptor52, _descriptor53, _descriptor54, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a752dB//6lCVKuhOTo7hpDP", "BlackJackAssets", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BlackJackAssets = exports('default', (_dec = property(SpriteFrame), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(SpriteFrame), _dec5 = property(SpriteFrame), _dec6 = property(SpriteFrame), _dec7 = property(SpriteFrame), _dec8 = property(SpriteFrame), _dec9 = property(SpriteFrame), _dec10 = property(SpriteFrame), _dec11 = property(SpriteFrame), _dec12 = property(SpriteFrame), _dec13 = property(SpriteFrame), _dec14 = property(SpriteFrame), _dec15 = property(SpriteFrame), _dec16 = property(SpriteFrame), _dec17 = property(SpriteFrame), _dec18 = property(SpriteFrame), _dec19 = property(SpriteFrame), _dec20 = property(SpriteFrame), _dec21 = property(SpriteFrame), _dec22 = property(SpriteFrame), _dec23 = property(SpriteFrame), _dec24 = property(SpriteFrame), _dec25 = property(SpriteFrame), _dec26 = property(SpriteFrame), _dec27 = property(SpriteFrame), _dec28 = property(SpriteFrame), _dec29 = property(SpriteFrame), _dec30 = property(SpriteFrame), _dec31 = property(SpriteFrame), _dec32 = property(SpriteFrame), _dec33 = property(SpriteFrame), _dec34 = property(SpriteFrame), _dec35 = property(SpriteFrame), _dec36 = property(SpriteFrame), _dec37 = property(SpriteFrame), _dec38 = property(SpriteFrame), _dec39 = property(SpriteFrame), _dec40 = property(SpriteFrame), _dec41 = property(SpriteFrame), _dec42 = property(SpriteFrame), _dec43 = property(SpriteFrame), _dec44 = property(SpriteFrame), _dec45 = property(SpriteFrame), _dec46 = property(SpriteFrame), _dec47 = property(SpriteFrame), _dec48 = property(SpriteFrame), _dec49 = property(SpriteFrame), _dec50 = property(SpriteFrame), _dec51 = property(SpriteFrame), _dec52 = property(SpriteFrame), _dec53 = property(SpriteFrame), _dec54 = property(SpriteFrame), ccclass(_class = (_class2 = (_temp = class BlackJackAssets extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "sp11", _descriptor, this);

          _initializerDefineProperty(this, "sp12", _descriptor2, this);

          _initializerDefineProperty(this, "sp21", _descriptor3, this);

          _initializerDefineProperty(this, "sp22", _descriptor4, this);

          _initializerDefineProperty(this, "sp31", _descriptor5, this);

          _initializerDefineProperty(this, "sp32", _descriptor6, this);

          _initializerDefineProperty(this, "sp41", _descriptor7, this);

          _initializerDefineProperty(this, "sp42", _descriptor8, this);

          _initializerDefineProperty(this, "sp51", _descriptor9, this);

          _initializerDefineProperty(this, "sp52", _descriptor10, this);

          _initializerDefineProperty(this, "sp61", _descriptor11, this);

          _initializerDefineProperty(this, "sp62", _descriptor12, this);

          _initializerDefineProperty(this, "sp71", _descriptor13, this);

          _initializerDefineProperty(this, "sp72", _descriptor14, this);

          _initializerDefineProperty(this, "sp81", _descriptor15, this);

          _initializerDefineProperty(this, "sp82", _descriptor16, this);

          _initializerDefineProperty(this, "sp91", _descriptor17, this);

          _initializerDefineProperty(this, "sp92", _descriptor18, this);

          _initializerDefineProperty(this, "sp101", _descriptor19, this);

          _initializerDefineProperty(this, "sp102", _descriptor20, this);

          _initializerDefineProperty(this, "sp111", _descriptor21, this);

          _initializerDefineProperty(this, "sp112", _descriptor22, this);

          _initializerDefineProperty(this, "sp121", _descriptor23, this);

          _initializerDefineProperty(this, "sp122", _descriptor24, this);

          _initializerDefineProperty(this, "sp131", _descriptor25, this);

          _initializerDefineProperty(this, "sp132", _descriptor26, this);

          _initializerDefineProperty(this, "spB111", _descriptor27, this);

          _initializerDefineProperty(this, "spB112", _descriptor28, this);

          _initializerDefineProperty(this, "spB113", _descriptor29, this);

          _initializerDefineProperty(this, "spB114", _descriptor30, this);

          _initializerDefineProperty(this, "spB121", _descriptor31, this);

          _initializerDefineProperty(this, "spB122", _descriptor32, this);

          _initializerDefineProperty(this, "spB123", _descriptor33, this);

          _initializerDefineProperty(this, "spB124", _descriptor34, this);

          _initializerDefineProperty(this, "spB131", _descriptor35, this);

          _initializerDefineProperty(this, "spB132", _descriptor36, this);

          _initializerDefineProperty(this, "spB133", _descriptor37, this);

          _initializerDefineProperty(this, "spB134", _descriptor38, this);

          _initializerDefineProperty(this, "spBNormal", _descriptor39, this);

          _initializerDefineProperty(this, "spBBack", _descriptor40, this);

          _initializerDefineProperty(this, "spSuit1", _descriptor41, this);

          _initializerDefineProperty(this, "spSuit2", _descriptor42, this);

          _initializerDefineProperty(this, "spSuit3", _descriptor43, this);

          _initializerDefineProperty(this, "spSuit4", _descriptor44, this);

          _initializerDefineProperty(this, "spSuitB1", _descriptor45, this);

          _initializerDefineProperty(this, "spSuitB2", _descriptor46, this);

          _initializerDefineProperty(this, "spSuitB3", _descriptor47, this);

          _initializerDefineProperty(this, "spSuitB4", _descriptor48, this);

          _initializerDefineProperty(this, "spResultTitleBlackJack", _descriptor49, this);

          _initializerDefineProperty(this, "spResultTitleWin", _descriptor50, this);

          _initializerDefineProperty(this, "spResultTitlePush", _descriptor51, this);

          _initializerDefineProperty(this, "spResultTitleLose", _descriptor52, this);

          _initializerDefineProperty(this, "spResultTitleBust", _descriptor53, this);

          _initializerDefineProperty(this, "spResultTitleSurrender", _descriptor54, this);

          _defineProperty(this, "sprites", {});

          _defineProperty(this, "over10A", {});

          _defineProperty(this, "suits", {});
        }

        start() {
          this.Clear();
          this.sprites = {};

          for (let i = 1; i <= 13; i++) {
            let sps = {};
            sps[1] = this["sp" + i + "1"];
            sps[2] = this["sp" + i + "2"];
            sps[3] = this["sp" + i + "1"];
            sps[4] = this["sp" + i + "2"];
            this.sprites[i] = sps;
          }

          this.over10A = {
            11: "J",
            12: "Q",
            13: "K"
          };
        }

        Clear() {
          this.suits = {};
        }

        setCard(card, n) {
          let bg = GameKit.ControllerTable.GetComponent(card, "bg", Sprite);
          let num = GameKit.ControllerTable.GetComponent(card, "num", Sprite);
          let numB = GameKit.ControllerTable.GetComponent(card, "numB", Sprite);
          let suit = GameKit.ControllerTable.GetComponent(card, "suit", Sprite);

          if (n <= 0) {
            bg.spriteFrame = this.spBBack;
            return;
          }

          let csuit = this.getOneSuit(n);
          let spNum = this.sprites[n][csuit];

          if (n > 10) {
            bg.spriteFrame = this["spB" + n + csuit];
          } else {
            bg.spriteFrame = this.spBNormal;
            numB.spriteFrame = this["spSuitB" + csuit];
          }

          num.spriteFrame = spNum;
          fixedSizeRatio.fitByHeight(num);
          suit.spriteFrame = this["spSuit" + csuit];
        } //////////////////////////////////


        getOneSuit(n) {
          if (this.suits[n] == null) this.suits[n] = [];
          let s = G.getRandomInt(1, 5);
          let i = 0;

          while (this.suits[n].contains(s)) {
            s = G.getRandomInt(1, 5);
            i++;
            if (i > 100) break;
          }

          this.suits[n].push(s);
          return s;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sp11", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sp12", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "sp21", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp22", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sp31", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "sp32", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "sp41", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "sp42", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "sp51", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "sp52", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "sp61", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "sp62", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "sp71", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "sp72", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "sp81", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "sp82", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "sp91", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "sp92", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "sp101", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "sp102", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "sp111", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class2.prototype, "sp112", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class2.prototype, "sp121", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class2.prototype, "sp122", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class2.prototype, "sp131", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor26 = _applyDecoratedDescriptor(_class2.prototype, "sp132", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor27 = _applyDecoratedDescriptor(_class2.prototype, "spB111", [_dec27], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor28 = _applyDecoratedDescriptor(_class2.prototype, "spB112", [_dec28], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor29 = _applyDecoratedDescriptor(_class2.prototype, "spB113", [_dec29], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor30 = _applyDecoratedDescriptor(_class2.prototype, "spB114", [_dec30], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor31 = _applyDecoratedDescriptor(_class2.prototype, "spB121", [_dec31], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor32 = _applyDecoratedDescriptor(_class2.prototype, "spB122", [_dec32], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor33 = _applyDecoratedDescriptor(_class2.prototype, "spB123", [_dec33], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor34 = _applyDecoratedDescriptor(_class2.prototype, "spB124", [_dec34], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor35 = _applyDecoratedDescriptor(_class2.prototype, "spB131", [_dec35], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor36 = _applyDecoratedDescriptor(_class2.prototype, "spB132", [_dec36], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor37 = _applyDecoratedDescriptor(_class2.prototype, "spB133", [_dec37], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor38 = _applyDecoratedDescriptor(_class2.prototype, "spB134", [_dec38], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor39 = _applyDecoratedDescriptor(_class2.prototype, "spBNormal", [_dec39], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor40 = _applyDecoratedDescriptor(_class2.prototype, "spBBack", [_dec40], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor41 = _applyDecoratedDescriptor(_class2.prototype, "spSuit1", [_dec41], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor42 = _applyDecoratedDescriptor(_class2.prototype, "spSuit2", [_dec42], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor43 = _applyDecoratedDescriptor(_class2.prototype, "spSuit3", [_dec43], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor44 = _applyDecoratedDescriptor(_class2.prototype, "spSuit4", [_dec44], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor45 = _applyDecoratedDescriptor(_class2.prototype, "spSuitB1", [_dec45], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor46 = _applyDecoratedDescriptor(_class2.prototype, "spSuitB2", [_dec46], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor47 = _applyDecoratedDescriptor(_class2.prototype, "spSuitB3", [_dec47], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor48 = _applyDecoratedDescriptor(_class2.prototype, "spSuitB4", [_dec48], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor49 = _applyDecoratedDescriptor(_class2.prototype, "spResultTitleBlackJack", [_dec49], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor50 = _applyDecoratedDescriptor(_class2.prototype, "spResultTitleWin", [_dec50], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor51 = _applyDecoratedDescriptor(_class2.prototype, "spResultTitlePush", [_dec51], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor52 = _applyDecoratedDescriptor(_class2.prototype, "spResultTitleLose", [_dec52], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor53 = _applyDecoratedDescriptor(_class2.prototype, "spResultTitleBust", [_dec53], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor54 = _applyDecoratedDescriptor(_class2.prototype, "spResultTitleSurrender", [_dec54], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DailyBonusRewardMeta.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "a76e9wi9E1HOoJzeTSLxnTJ", "DailyBonusRewardMeta", undefined);

      class DailyBonusRewardMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new DailyBonusRewardMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        GetNormal(index) {
          return this._data["normal" + index.toString()];
        }

        GetGold(index) {
          return this._data["gold" + index.toString()];
        }

      }

      exports('DailyBonusRewardMeta', DailyBonusRewardMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TutorialMeta.ts", ['cc', './TutorialManager.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, TutorialManager, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "a7c9aeweoxEkLUXgAN1S32n", "TutorialMeta", undefined);

      class TutorialMeta {
        constructor() {
          _defineProperty(this, "_data", null);
        }

        static MakeEntity(data) {
          let meta = new TutorialMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = data;
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        } //组id


        GroupId() {
          return TutorialManager.GetGroupId(this.Id());
        } //类型


        Type() {
          return this._data.type;
        } //跳转id


        JumpId() {
          return this._data.jump_id;
        } //下一个id


        NextId() {
          return this._data.next_id;
        } //记录用id


        LogId() {
          return this._data.logId;
        } //目标窗口


        TriggerWindow() {
          return this._data.trigger_window || "";
        } //开始情况


        TriggerStart() {
          return this._data.trigger_start || "";
        } //结束情况


        TriggerEnd() {
          return this._data.trigger_end || "";
        } //箭头


        Arrow() {
          return this._data.arrow || "";
        } //箭头类型（1手，2手下滑，3箭头上,4箭头下）


        ArrowType() {
          return this._data.arrow_type || "";
        } //对话框位置


        DialogBox() {
          return this._data.dialog_box || "";
        } //对话框文本key


        DialogMsgKey() {
          return this._data.dialog_msg_key || "";
        } //对话框文本


        DialogMsg() {
          return i18n.t(this.DialogMsgKey()) || "";
        } //结束点击区域（1按钮,2全屏,3结束情况）


        TouchArea() {
          return this._data.touch_area || "";
        } //高亮类型（1节点,2范围,11slot特殊）


        HighlightMode() {
          return this._data.highlight_mode || "";
        } //高亮范围


        HighlightValue() {
          return this._data.highlight_value || "";
        } //蒙板类型（1全屏）


        Mask() {
          return this._data.mask || "";
        } //是否服务器记录


        Milestone() {
          return this._data.milestone || "";
        }

      }

      exports('TutorialMeta', TutorialMeta);

      _defineProperty(TutorialMeta, "Types", {
        Normal: 0,
        End: 200
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivityGameShowWindow.ts", ['cc', './Logs.ts', './_app.ts', './CCTools.ts', './UIWindow.ts', './DialogWindow.ts', './HomeView.ts', './VillageShopWindow.ts', './UIRoot.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, Label, RichText, _decorator, SpriteFrame, Logs, cce, CCTools, UIWindow, DialogWindow, HomeView, VillageShopWindow, UIRoot, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      RichText = module.RichText;
      _decorator = module._decorator;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      CCTools = module.CCTools;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      HomeView = module.HomeView;
    }, function (module) {
      VillageShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "a80c81DKpBNxYYCPyGKXatR", "ActivityGameShowWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivityGameShowWindow = exports('ActivityGameShowWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Sprite), _dec4 = property(Label), _dec5 = property(Label), _dec6 = property(RichText), _dec7 = property(RichText), ccclass(_class = (_class2 = (_temp = _class3 = class ActivityGameShowWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spClose", _descriptor, this);

          _initializerDefineProperty(this, "spButton", _descriptor2, this);

          _initializerDefineProperty(this, "spBg", _descriptor3, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor4, this);

          _initializerDefineProperty(this, "labelButton", _descriptor5, this);

          _initializerDefineProperty(this, "labelMessage", _descriptor6, this);

          _initializerDefineProperty(this, "labelMessageShadow", _descriptor7, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "metaParam", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "childWindowChain", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.metaParam = this.meta.Param();
          CCTools.SetNodeByParam(this.spClose, this.metaParam.close);
          CCTools.SetNodeByParam(this.labelButton, this.metaParam.labelButton);
          CCTools.SetNodeByParam(this.spButton, this.metaParam.button);
          CCTools.SetNodeByParam(this.labelTimer, this.metaParam.timer);
          CCTools.SetNodeByParam(this.labelMessage, this.metaParam.message);
          CCTools.SetNodeByParam(this.labelMessageShadow, this.metaParam.message_shadow);
          let img = this.meta.Image();

          if (img.startsWith("http")) {
            cce.loaderLoad({
              url: img,
              type: "png"
            }, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.spBg || !this.node) return;
              let sp = new SpriteFrame();
              sp.texture = v;
              this.spBg.spriteFrame = sp;
            }.bind(this));
          } else {
            let resName = "res/Activity/images/" + img;
            cce.loadRes(resName, SpriteFrame, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.spBg || !this.node) return;
              this.spBg.spriteFrame = v;
            }.bind(this));
          }

          this.leftTime = 0;
          this.slowUpdate(0);
        }

        onClose() {
          cce.releaseSpriteFrame(this.spBg);
        }

        slowUpdate(arg) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = 0;
            this.leftTime = this.meta.EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, true);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        close_window() {
          this.closeAnim();
        }

        callBuy() {
          if (this.childWindowChain) {
            this.clearOnCloseFunc();
            this.childWindowChain.end();
          }

          let meta = this.meta;

          if (!meta.IsActive()) {
            this.closeAnim(() => {
              DialogWindow.Show(i18n.t("ActivityCenterTimeEnd"), nullFunction);
            });
            return;
          }

          let icon_goto = meta.IconGoto();

          if (icon_goto == "panel") {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(meta.Panel(), {
                meta: meta
              });
            });
          } else if (icon_goto == "slot") {
            this.closeAnim(() => {
              homeView.changePage(HomeView.Pages.Slot);
            });
          } else if (icon_goto == "village") {
            this.closeAnim(() => {
              homeView.changePage(HomeView.Pages.Village);
            });
          } else if (icon_goto == "villageShop") {
            this.closeAnim(() => {
              homeView.changePage(HomeView.Pages.Village, () => {
                UIRoot.instance.openChildWindow(VillageShopWindow);
              });
            });
          } else if (icon_goto == "window") {
            this.closeAnim(() => {
              meta.Panel().Show(meta);
            });
          } else {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(icon_goto, {
                meta: meta
              });
            });
          }
        }

      }, _defineProperty(_class3, "windowPath", "Activity/ActivityGameShowWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spClose", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spButton", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spBg", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelButton", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelMessage", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelMessageShadow", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AdGetCoinMeta.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "a9eebrHlLdLkJ9KM5cxv0wB", "AdGetCoinMeta", undefined);

      class AdGetCoinMeta {
        constructor() {
          _defineProperty(this, "_data", {});
        }

        static MakeEntity(data) {
          let meta = new AdGetCoinMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        MapId() {
          return this._data.id;
        } //看广告获得的金币


        Coin() {
          return this._data.coin;
        } //在弹出的提示里看广告获得的金币


        CoinByTip() {
          return this._data.coinByTip;
        }

      }

      exports('AdGetCoinMeta', AdGetCoinMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardMeta.ts", ['cc', './ActivityManager.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, ActivityManager, Meta, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "ab57bKFIzVCx6OUFsCEaXfH", "CardMeta", undefined);

      class CardMeta {
        constructor() {
          _defineProperty(this, "_data", null);
        }

        static MakeEntity(data) {
          let meta = new CardMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = data; // this._data = {};
          // for (var key in data) {
          // 	this._data[key] = data[key];
          // }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        SetId() {
          return this._data.setId;
        }

        Index() {
          return this._data.index;
        }

        MinVillage() {
          return this._data.min_village;
        }

        Rare() {
          return this._data.rare;
        }

        Golden() {
          return this._data.golden;
        }

        CantSend() {
          let meta = ActivityManager.GetActiveOtherActivityByType(Meta.ActivityMeta.SubTypes.GoldTrade);

          if (meta) {
            if (this.Id() == meta.Param().cardId1 || this.Id() == meta.Param().cardId2) {
              return false;
            }
          }

          return this._data.golden;
        }

        Name() {
          return i18n.sel(this._data.name);
        }

        Bg() {
          return this._data.bg;
        }

      }

      exports('CardMeta', CardMeta);

      _defineProperty(CardMeta, "GetMeta", function (setId, index) {
        return Meta.MetaManager.GetMeta(Meta.MetaType.Card, setId * 100 + index);
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageNode.ts", ['cc', './Constant.ts', './CCE_Component.ts', './CharacterLevelEditor.ts', './_app.ts', './SoundManager.ts', './PlayAudio.ts', './ResourceLoader.ts', './CommonAssets.ts', './CardAllSetWindow.ts', './ContentCheck.ts', './VillageShopWindow.ts', './VillageAttackBtn.ts', './GameMainWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Camera, Node, BoxCollider, Vec3, Animation, tween, Vec2, view, geometry, PhysicsSystem, easing, instantiate, Button, SkeletalAnimation, Constant, MyCustomEvent, PlayerAnimName, TutorilaEvent, CCE_Component, CharacterLevelEditor, cce, SoundManager, PlayAudio, ResourceLoader, CommonAssets, CardAllSetWindow, ContentCheck, VillageShopWindow, VillageAttackBtn, GameMainWindow, SR, UIRoot, Game, Meta, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Camera = module.Camera;
      Node = module.Node;
      BoxCollider = module.BoxCollider;
      Vec3 = module.Vec3;
      Animation = module.Animation;
      tween = module.tween;
      Vec2 = module.Vec2;
      view = module.view;
      geometry = module.geometry;
      PhysicsSystem = module.PhysicsSystem;
      easing = module.easing;
      instantiate = module.instantiate;
      Button = module.Button;
      SkeletalAnimation = module.SkeletalAnimation;
    }, function (module) {
      Constant = module.Constant;
      MyCustomEvent = module.MyCustomEvent;
      PlayerAnimName = module.PlayerAnimName;
      TutorilaEvent = module.TutorilaEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CharacterLevelEditor = module.default;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      PlayAudio = module.default;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      CardAllSetWindow = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      VillageShopWindow = module.default;
    }, function (module) {
      VillageAttackBtn = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "acb7aJHbJtHMpgSe5zGm7CU", "VillageNode", undefined);

      const SE_build_loop = "item_build_loop";
      const SE_build_end = "item_build_end";
      const {
        ccclass,
        property
      } = _decorator;
      let VillageNode = exports('default', ccclass(_class = (_temp = class VillageNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "raidTargets", []);

          _defineProperty(this, "builds", []);

          _defineProperty(this, "animBuilds", void 0);

          _defineProperty(this, "building", void 0);

          _defineProperty(this, "_isBuilding", void 0);

          _defineProperty(this, "villageInfo", void 0);

          _defineProperty(this, "isSelf", void 0);

          _defineProperty(this, "homeView", void 0);

          _defineProperty(this, "mapId", void 0);

          _defineProperty(this, "btnFixes", void 0);

          _defineProperty(this, "attackTargets", void 0);

          _defineProperty(this, "interactionNode", void 0);

          _defineProperty(this, "attackNodes", []);

          _defineProperty(this, "fixNodes", []);

          _defineProperty(this, "camera", void 0);

          _defineProperty(this, "curshownMapId", 1);

          _defineProperty(this, "isCompleted", false);
        }

        static GetVillageName(mapID) {
          const totalCount = Constant.MaxLevel;
          const roomID = mapID % totalCount == 0 ? totalCount : mapID % totalCount;
          return `room${roomID}`;
        }

        static GetVillageIconName(type, level) {
          const iconName = "build" + type + "-" + level;
          return iconName;
        }

        static GetVillageResPath(villageName) {
          const url = `${villageName}/${villageName}`;
          return url;
        }

        initBuilds(info) {
          this.animBuilds = {};

          for (let i = 1; i <= 5; i++) {
            this.builds.push(this.node.getChildByName("build" + i));
          } //TEST
          // info.data.village[5] = 1;
          // info.data.village[6] = 1;
          // info.data.village[7] = 1;


          this.villageInfo = info;
          this.camera = this.getComponentInChildren(Camera);
          this.mapId = this.villageInfo.MapId();
          this.isSelf = this.villageInfo === Game.SUserVillage;
          this.homeView = homeView;
          this.btnFixes = {};
          this.attackTargets = {};
          this.showInfo(info);

          if (this.isSelf) {
            Reflect.defineProperty(globalThis, "myVillage", {
              value: this,
              configurable: true
            });
            this.curshownMapId = this.mapId;
            this.scheduleOnce(() => {
              if (homeView.villagePage.isTigerView) {
                this.toggleTigerView();
              }
            }, 0.1);
          }
        }

        onLoad() {
          eventCenter.on(MyCustomEvent.VillageAttack, this.onClickAttack, this);
          eventCenter.on(MyCustomEvent.OnPageTurnComplete, this.onPageTurn, this);
          this.animBuilds = {};
          this.building = {};
          this._isBuilding = 0;
          this.isCompleted = false;
          let node = new Node();
          node.addComponent(BoxCollider);
          node.position = new Vec3(0, -0.5, 0);
          node.scale = new Vec3(1000, 1, 1000);
          node.name = "ground";
          this.node.addChild(node);
        }

        onDestroy() {
          for (let i = 1; i <= 5; i++) {
            this.fixNodes[i - 1] && this.fixNodes[i - 1].destroy();
          }

          eventCenter.off(MyCustomEvent.VillageAttack, this.onClickAttack, this);
          eventCenter.off(MyCustomEvent.OnPageTurnComplete, this.onPageTurn, this);
        }

        toggleTigerView() {
          let camera = this.camera;
          let endPos = this.getRaycastPos();
          const offset = new Vec3(0, -0.5, -0.866).multiplyScalar(-8);
          let cameraEndPos = endPos.clone().add(offset);

          if (this.camera.getComponent(Animation)) {
            this.camera.getComponent(Animation).stop();
          }

          tween(camera.node).to(0.5, {
            worldPosition: cameraEndPos,
            eulerAngles: new Vec3(-25, 0, 0)
          }).start();
        }

        getRaycastPos() {
          let endPos = new Vec3();
          let camera = this.camera;
          let pos = new Vec2(view.getVisibleSize().x / 2, 280);
          console.log("raypos location", pos);
          let outRay = new geometry.Ray();
          camera.screenPointToRayWithTexture(pos.x, pos.y, outRay);
          let bo = PhysicsSystem.instance.raycast(outRay);
          console.log(bo);
          let result = PhysicsSystem.instance.raycastResults;
          result.sort((a, b) => a.distance - b.distance);
          if (result.length <= 0) return endPos;
          result.forEach(v => {
            if (v.collider.node.name === "ground") {
              endPos = v.hitPoint;
            }
          });
          return endPos;
        } //显示地图


        showInfo(info) {
          //5种建筑
          for (let i = 1; i <= 5; i++) {
            let type = i;
            this.showType(type);
          }
        }

        showType(type, isAttack = false, forceLevel = -1) {
          let build = this.builds[type - 1];
          let level = forceLevel < 0 ? this.villageInfo.GetLevel(type) : forceLevel;
          let isDestroyed = this.villageInfo.IsDestroyed(type); //等级1-5

          this.refreshBuild(type, build, level, isDestroyed, isAttack);
        }

        onPageTurn(pageIndex) {
          // console.log(pageIndex);
          if (pageIndex == 3) {
            this.refreshButtonFix(true);
          } else {
            this.refreshButtonFix(false);
          }
        }

        refreshButtonFix(show) {
          if (!this.isSelf) return;

          for (let type = 1; type <= 5; type++) {
            let build = this.builds[type - 1];
            let isDestroyed = this.villageInfo.IsDestroyed(type);
            let fixNode = this.fixNodes[type - 1];

            if (show && isDestroyed) {
              if (fixNode) {
                fixNode.active = true;
                tween(fixNode).set({
                  scale: Vec3.ZERO
                }).to(0.2, {
                  scale: Vec3.ONE
                }, {
                  easing: easing.sineOut
                }).start();
              } else {
                this.fixNodes[type - 1] = instantiate(CommonAssets.instance.pbFix);
                fixNode = this.fixNodes[type - 1];
                homeView.villagePage.node.addChild(fixNode);
                fixNode.getComponent(Button).node.on("click", () => {
                  this.onClickFix(null, type);
                }, this);
              }

              let fixPosNode = build.getChildByName("positions").getChildByName("fix");
              let worldPos = fixPosNode.getWorldPosition().clone();
              let pos = this.camera.convertToUINodeWithTexture(worldPos, homeView.villagePage.node);
              fixNode.setPosition(pos);
            } else {
              if (fixNode) {
                fixNode.active = false;
              }
            }
          }
        }

        refreshBuild(type, build, level, isDestroyed, isAttack = false) {
          if (!build) return;
          let characterCom = build.getComponentInChildren(CharacterLevelEditor);

          if (characterCom) {
            this.handleCharacter(characterCom, level, isDestroyed, isAttack);
          } else {
            this.handleBuilding(build, level, isDestroyed);
          }
        }

        handleCharacter(characterCom, level, isDestroyed, isAttack = false) {
          if (level == 0) {
            characterCom.node.active = false;
            return;
          }

          characterCom.node.active = true;
          const lastState = characterCom.destroyed;
          characterCom.destroyed = isDestroyed;
          characterCom.curLevel = level;
          let anim = characterCom.getComponent(SkeletalAnimation);

          if (isAttack) {
            //如果已经倒下不再播die动作
            if (lastState) {
              anim.play(PlayerAnimName.dead);
            } else {
              anim.play(PlayerAnimName.die);
            }
          } else {
            if (characterCom.initialized) {
              if (isDestroyed) {
                anim.play(PlayerAnimName.dead);
              } else {
                anim.play(PlayerAnimName.idle);
              }
            } else {
              characterCom.startCallBack = () => {
                if (isDestroyed) {
                  anim.play(PlayerAnimName.dead);
                } else {
                  anim.play(PlayerAnimName.idle);
                }
              };
            }
          }
        }

        async handleBuilding(build, level, isDestroyed) {
          //美术需要0等级的初始化场景
          let buildLevelZero = build.getChildByName("level0");

          if (buildLevelZero) {
            if (level === 0) {
              buildLevelZero.active = true;
            } else {
              buildLevelZero.active = false;
            }
          }

          for (let k = 1; k <= 5; k++) {
            let buildLevelNode = build.getChildByName("level" + k.toString());
            if (!buildLevelNode) continue;

            if (level === k) {
              buildLevelNode.active = true;
              let buildNormal = buildLevelNode.getChildByName("normal");
              let buildDamage = buildLevelNode.getChildByName("damage");
              buildNormal.active = !isDestroyed;
              buildDamage.active = isDestroyed;

              if (isDestroyed) {
                let smokeNode = buildDamage.getChildByName("smoke");

                if (smokeNode) {
                  smokeNode.destroyAllChildren();
                  let node = instantiate(await ResourceLoader.loadCommonPrefab("common/smoke", true));
                  node.layer = this.node.layer;
                  smokeNode.addChild(node);
                }
              }
            } else {
              buildLevelNode.active = false;
            }
          }
        }

        update() {// for (let type = 1; type <= 5; type++) {
          // 	let build = this.builds[type - 1];
          // 	// let level = this.villageInfo.GetLevel(type);
          // 	let isDestroyed = this.villageInfo.IsDestroyed(type);
          // 	this.handleButtonFix(type, build, isDestroyed);
          // }
          // let fixPosNode = this.builds[0].getChildByName("positions").getChildByName("fix");
          // if (fixPosNode) {
          // 	// console.log(fixPosNode.getWorldPosition());
          // }
        }

        GetHandle(type, level, isDestroyed) {
          let build = this.builds[type - 1];
          if (build == null) return null;
          let buildLevel = build.getChildByName("level" + level.toString());
          if (buildLevel == null) return null;

          if (isDestroyed) {
            return buildLevel.getChildByName("damage");
          } else {
            return buildLevel.getChildByName("normal");
          }
        }

        Flush() {
          this.showInfo(this.villageInfo);
        } //升级或者修复 进行更新


        BuildLevelUpOrFix(type) {
          type = parseInt(type + "");
          let build = this.builds[type - 1];
          if (this.animBuilds[type] != null) this.animBuilds[type].destroy();
          let animBuild = instantiate(homeView.animBuild);
          let pos = this.camera.convertToUINodeWithTexture(build.getWorldPosition(), homeView.villagePage.node);
          animBuild.position = pos;
          homeView.villagePage.node.addChild(animBuild);
          this.animBuilds[type] = animBuild;
          SoundManager.playSound(SE_build_loop);
          this.building[type] = true;
          this._isBuilding++;

          if (this.fixNodes[type - 1]) {
            this.fixNodes[type - 1].destroy();
            this.fixNodes[type - 1] = null;
          }

          this.BuildLevelUpOrFix2(type);
        }

        BuildLevelUpOrFix2(type) {
          let build = this.builds[type - 1];
          let level = this.villageInfo.GetLevel(type);
          this.scheduleOnce(() => {
            build.runAction(ccAction.sequence(ccAction.scaleTo(0.2, new Vec3(0.001, 0.001, 0.001)), ccAction.callFunc(() => {
              this.showType(type, false, level);
            }, this), ccAction.scaleTo(0.2, Vec3.ONE), ccAction.delayTime(1.2), ccAction.callFunc(() => {
              this.animBuilds[type] = null;
              let animBuildStar = instantiate(homeView.animBuildStar);
              const endNode = GameMainWindow.instance.labelStar.node.parent.getChildByName("iconStar");
              const endLocalPos = new Vec3();
              const pos = this.camera.convertToUINodeWithTexture(build.getWorldPosition(), GameMainWindow.instance.node);
              GameMainWindow.instance.node.inverseTransformPoint(endLocalPos, endNode.getWorldPosition());
              GameMainWindow.instance.node.addChild(animBuildStar);
              animBuildStar.position = pos;
              tween(animBuildStar).delay(0.5).to(1, {
                position: endLocalPos
              }, {
                easing: easing.quintOut
              }).delay(0.1).call(() => {
                animBuildStar.destroy();
                GameMainWindow.instance.showStar();
                this._isBuilding--;

                if (this._isBuilding <= 0) {
                  eventCenter.emit(MyCustomEvent.StarFinished);
                }

                if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                  eventCenter.emit(TutorilaEvent.BuildFinished);
                }
              }).start();
              SoundManager.playSound(SE_build_end);
            }, this)));
          }, 0.4);
        }

        BuildLevelUpOrFixOver(type) {
          this.building[type] = false;
          let swindow = UIRoot.instance.GetWindow("VillageShopWindow");

          if (swindow && swindow.enableButton) {
            swindow.enableButton(type);
          }

          if (this.isSelf && Game.SUserVillage.IsFinished() && Game.SUserVillage.HasNextVillage()) {
            this.isCompleted = true;
            let req = SR.SRVillage.askNextVillage();
            req.SetCallBack(res => {
              Game.SUserVillage.updateData(res.userVillage);
              homeView.cardContainer.getComponentInChildren(CardAllSetWindow).flushData();
              GameMainWindow.instance.OnMapFinished();
              eventCenter.emit(MyCustomEvent.NextVillage);
            });
            req.SetErrorCallBack(() => {
              console.error("ask next village failed");
            });
            req.Send();
          } //GameMainWindow.instance.showStar(Game.SUser.Star() - 1)

        } //点击建筑


        onClickBuild(e, type) {
          if (!this.isSelf) return;
          if (homeView.isChangeAnim()) return;
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;
          type = parseInt(type);
          let currentLevel = this.villageInfo.GetLevel(type);
          if (currentLevel <= 0) return;
          SoundManager.playSound("se_open");
          UIRoot.instance.openChildWindow(VillageShopWindow, {
            selectType: type
          });
          /*Game.SUserVillage.MakeLevelUp(type)
          this.BuildLevelUpOrFix(type)
          let buildOk = function() {
          	this.BuildLevelUpOrFixOver(type)
          }.bind(this)
          setTimeout(() => {
          	buildOk()
          }, 300);*/
        } //点击修复


        onClickFix(e, type) {
          if (!this.isSelf) return;
          type = parseInt(type);
          let currentLevel = this.villageInfo.GetLevel(type);
          let isDestroyed = this.villageInfo.IsDestroyed(type);
          let maxLevel = Meta.VillageShopMeta.GetMaxLevel(this.mapId, type);

          if (!isDestroyed) {
            this.refreshBuild(type, this.builds[type - 1], currentLevel, isDestroyed);
            return;
          }

          let oprice = Meta.VillageShopMeta.FindMetaPrice(this.mapId, type, currentLevel);

          if (oprice != null) {
            let price = oprice / 2;

            if (ContentCheck.CheckCoin(price)) {
              // this.btnFixes[type].avtive = false;
              Game.SUser.data.coin -= price;
              Game.SUserVillage.MakeFix(type);
              this.BuildLevelUpOrFix(type);
              let req = SR.SRVillage.fixVillage(type);
              req.SetCallBack(res => {
                this.BuildLevelUpOrFixOver(type);
              });
              req.Send();
            }
          }
        }

        isBuilding() {
          return this._isBuilding > 0;
        } //显示为攻击状态


        preShowAttack(container) {
          container.destroyAllChildren();

          for (let i = 1; i <= 5; i++) {
            let type = i;
            let build = this.builds[type - 1];
            let node = instantiate(CommonAssets.instance.pbAttack);
            let com = node.getComponent(VillageAttackBtn);
            let worldPosNode = build.getChildByName("positions").getChildByName("attack");
            node.position = this.camera.convertToUINodeWithTexture(worldPosNode.getWorldPosition(), container);
            com.setup(i);
            node.active = false;
            container.addChild(node);
            this.attackNodes.push(node);
          }
        }

        showAttack(interactionNode) {
          this.interactionNode = interactionNode; //5种建筑

          for (let i = 1; i <= 5; i++) {
            let type = i;
            let build = this.builds[type - 1]; // build.scaleX = 0.001;
            // build.scaleY = 0.001;
            // let attackTarget = GameKit.ControllerTable.GetNode(build, "attack");

            let attackTarget = this.attackNodes[type - 1];
            tween(build).sequence(tween().to(0.6, {
              scale: Vec3.ONE
            }, {
              easing: easing.elasticOut
            }), tween().call(() => {}));
            build.runAction(ccAction.sequence(ccAction.scaleTo(0.6, 1, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeElasticOut, 0.6)), ccAction.callFunc(() => {
              if (this.villageInfo.CanAttack(type)) {
                tween(attackTarget).set({
                  active: true,
                  opacity: 0,
                  scale: new Vec3(2, 2, 2)
                }).sequence(tween().delay(0.05 * type), tween().to(0.2, {
                  opacity: 255
                }), tween().to(0.2, {
                  scale: Vec3.ONE
                })).start();
              }
            }, this)));
          }
        } //点击攻击


        onClickAttack(type) {
          if (this.isSelf) return;
          if (!this.builds) return;
          console.log("onClickAttack", type); // type = parseInt(type)

          for (let i = 1; i <= 5; i++) {
            let type = i;
            let build = this.builds[type - 1]; // let attackTarget = GameKit.ControllerTable.GetNode(build, "attackTarget")

            let attackTarget = this.attackNodes[type - 1];

            if (attackTarget.active) {
              attackTarget.runAction(ccAction.fadeOut(0.2));
              attackTarget.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001), ccAction.callFunc(function () {
                attackTarget.active = false;
              }, this)));
            }
          }

          PlayAudio.playOk();
          this.interactionNode.doAttack(type);
        }

        destroyBuild(type) {
          this.villageInfo.destroyBuild(type);
          this.showType(type, true);
        } //显示为偷取状态


        showRaid(interactionNode) {
          this.interactionNode = interactionNode;

          for (let i = 0; i < this.raidTargets.length; i++) {
            let raidTarget = this.raidTargets[i];
            raidTarget.active = true;
            raidTarget.opacity = 1, raidTarget.runAction(ccAction.sequence(ccAction.delayTime(0.08 * i), ccAction.fadeIn(0.2)));
            raidTarget.scaleX = 2, raidTarget.scaleY = 2;
            raidTarget.runAction(ccAction.sequence(ccAction.delayTime(0.08 * i), ccAction.scaleTo(0.2, 1)));
          }
        } //点击偷取
        // onClickRaid(e, id) {
        // 	id = parseInt(id);
        // 	PlayAudio.playOk();
        // 	this.interactionNode.doRaid(id);
        // }
        // onClickRaidOk(id) {
        // 	let raidTarget = this.raidTargets[id - 1];
        // 	raidTarget.active = true;
        // 	raidTarget.runAction(ccAction.fadeOut(0.2));
        // 	raidTarget.runAction(
        // 		ccAction.sequence(
        // 			ccAction.scaleTo(0.2, 0.001),
        // 			ccAction.callFunc(function () {
        // 				raidTarget.active = false;
        // 			}, this)
        // 		)
        // 	);
        // }


      }, _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FuncTools.ts", ['cc', './global.ts'], function (exports) {
  'use strict';

  var cclegacy, v2, G;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v2 = module.v2;
    }, function (module) {
      G = module.G;
    }],
    execute: function () {
      exports('FuncTools', void 0);

      cclegacy._RF.push({}, "acbc4ODzjlG97AevvaihR11", "FuncTools", undefined);

      let FuncTools;

      (function (_FuncTools) {
        function GetNormalAngles(ang) {
          if (typeof ang === "object") return v2(FuncTools.GetNormalAngles(ang.x), FuncTools.GetNormalAngles(ang.y));

          if (typeof ang !== "number") {
            return 0;
          }

          if (ang > -180 && ang <= 180) {
            return ang;
          }

          if (ang < -180) ang += 360;
          if (ang > 180) ang -= 360;
          return FuncTools.GetNormalAngles(ang);
        }

        _FuncTools.GetNormalAngles = GetNormalAngles;

        function Vector2ToAngle(dx, dy) {
          if (typeof dx === "object") return FuncTools.Vector2ToAngle(dx.x, dx.y);

          if (typeof dx !== "number" || typeof dy !== "number") {
            return 0;
          }

          if (dx === 0 && dy < 0) return 180.0;
          if (dx === 0 && dy > 0) return 0;
          return -FuncTools.GetNormalAngles(Math.atan2(dy, dx) * 180.0 / Math.PI - 90.0);
        }

        _FuncTools.Vector2ToAngle = Vector2ToAngle;

        function getIndexByWeight(weights) {
          let allweight = 0;
          weights.forEach(x => {
            allweight += x;
          });
          let _w = 0;
          let re = G.getRandomFloat(0, allweight);
          let _i = 0;
          weights.some(w => {
            if (re < w + _w) {
              return true;
            }

            _w += w;
            _i++;
          });
          return _i;
        }

        _FuncTools.getIndexByWeight = getIndexByWeight;

        function getIdByWeight(idws) {
          let ids = [];
          let weights = [];

          for (let id in idws) {
            ids.push(id);
            weights.push(idws[id]);
          }

          let index = FuncTools.getIndexByWeight(weights);
          return ids[index];
        }

        _FuncTools.getIdByWeight = getIdByWeight;

        function getRandomCount(ids, count) {
          if (ids == null) return [];
          if (ids.length < count) return ids;
          var data = [];

          while (data.length < count) {
            let d = ids[G.getRandomInt(0, ids.length)];
            ids.remove(d);
            data.push(d);
          }

          return data;
        }

        _FuncTools.getRandomCount = getRandomCount;

        function getSeedRandomCount(ids, count, seed) {
          if (ids == null) return [];
          if (ids.length < count) return ids;
          if (seed != null) G.setSeed(seed);
          var data = [];

          while (data.length < count) {
            let d = ids[G.getSeededRandomInt(0, ids.length)];
            ids.remove(d);
            data.push(d);
          }

          return data;
        }

        _FuncTools.getSeedRandomCount = getSeedRandomCount;
      })(FuncTools || (FuncTools = exports('FuncTools', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Pet.ts", ['cc', './Constant.ts', './ResourceLoader.ts', './SwitchMaterial.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, SkeletalAnimation, AnimationClip, instantiate, MeshRenderer, Quat, tween, PetAnimName, ResourceLoader, SwitchMaterial;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      SkeletalAnimation = module.SkeletalAnimation;
      AnimationClip = module.AnimationClip;
      instantiate = module.instantiate;
      MeshRenderer = module.MeshRenderer;
      Quat = module.Quat;
      tween = module.tween;
    }, function (module) {
      PetAnimName = module.PetAnimName;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      SwitchMaterial = module.default;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "acd39/BeXRKxJhg6QvWxAP9", "Pet", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Pet = exports('default', (_dec = ccclass("Pet"), _dec(_class = (_temp = class Pet extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "anim", void 0);

          _defineProperty(this, "petName", void 0);

          _defineProperty(this, "isRunning", false);

          _defineProperty(this, "progress", 0);

          _defineProperty(this, "startPos", new Vec3());

          _defineProperty(this, "endPos", new Vec3());

          _defineProperty(this, "endPercent", 1);

          _defineProperty(this, "fxSleepNode", void 0);

          _defineProperty(this, "materialSwitcher", null);
        }

        onLoad() {
          this.anim = this.getComponent(SkeletalAnimation) || this.getComponentInChildren(SkeletalAnimation);
          this.anim.useBakedAnimation = false;
          this.petName = this.node.name;
          this.materialSwitcher = this.getComponentInChildren(SwitchMaterial); // this.setWrapMode(PetAnimName.Idle, true);
          // this.setWrapMode(PetAnimName.Run, true);
          // this.setWrapMode(PetAnimName.Walk, true);
          // this.setWrapMode(PetAnimName.Rest, true);
          // this.setWrapMode(PetAnimName.Rest2, true);
          // this.setWrapMode(PetAnimName.Attack, false);
          // this.setWrapMode(PetAnimName.Jump, false);
          // this.setWrapMode(PetAnimName.Eat, false);
          // this.setWrapMode(PetAnimName.LevelUp, false);
          // this.setWrapMode(PetAnimName.Fly, false);
        }

        setWrapMode(name, loop) {
          const state = this.anim.getState(this.getAnimName(name));

          if (state) {
            state.wrapMode = loop ? AnimationClip.WrapMode.Loop : AnimationClip.WrapMode.Normal;
          }
        }

        onChangeState() {
          if (this.fxSleepNode) {
            this.fxSleepNode.active = false;
          }

          this.anim.removeAll(SkeletalAnimation.EventType.FINISHED);
          this.anim.removeAll(SkeletalAnimation.EventType.STOP);
          this.anim.removeAll(SkeletalAnimation.EventType.LASTFRAME); // this.anim.stop();

          this.materialSwitcher && this.switchMaterial(0);
        }

        addFxSleepNode(name) {
          if (this.fxSleepNode) {
            this.fxSleepNode.active = true;
          } else {
            ResourceLoader.getCommonPrefab("common/" + name).then(pb => {
              if (!this.node || !this.node.isValid) return;
              this.fxSleepNode = instantiate(pb);
              this.fxSleepNode.getFlattedChildrenRecursively().forEach(v => v.layer = this.node.layer);
              this.node.addChild(this.fxSleepNode);
            });
          }
        }

        switchMaterial(index) {
          let cmp = this.materialSwitcher;
          let render = cmp.getComponent(MeshRenderer);

          if (cmp && render && cmp.materials[index]) {
            render.setMaterial(cmp.materials[index], 0);
          } else {
            console.warn("not exist", cmp, render, cmp.materials, index);
          }
        }

        getAnimName(name) {
          let ownAnimName = name + "_" + this.petName;
          let hasOwnAnim = this.anim.getState(ownAnimName);
          return hasOwnAnim ? ownAnimName : name;
        }

        playAnimation(name, loop = false, callback, speed = 1) {
          // console.log(this.uuid, "playAnimation", name);
          const wrapMode = loop ? AnimationClip.WrapMode.Loop : AnimationClip.WrapMode.Normal;
          let animState; //判断是否有专属动画

          let animName = this.getAnimName(name);
          animState = this.anim.getState(animName);

          if (!animState) {
            console.warn("anim state not exist", name);
            return;
          }

          animState.wrapMode = wrapMode;
          animState.speed = speed;
          this.anim.play(animName);

          if (callback) {
            if (!loop) {
              this.anim.once(SkeletalAnimation.EventType.FINISHED, () => {
                callback();
              });
            } else {
              this.anim.once(SkeletalAnimation.EventType.LASTFRAME, () => {
                callback();
              });
            }
          }
        }
        /**当前帧必须有动画在playing状态才能使用过渡动画！不然是瞬间过去的 */


        playCrossAnimation(name, crossTime, callback) {
          // console.log(this.uuid, "playCrossAnimation", name);
          let animName = this.getAnimName(name);
          this.anim.crossFade(animName, crossTime);
          this.anim.once(SkeletalAnimation.EventType.STOP, () => {
            callback && callback();
          });
        }

        changeStateToRun(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Run, true, callback, 2);
        }

        changeStateToWalk(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Walk, true, callback, 2);
        }

        changeStateToIdle(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Idle, true, callback, 1);
        }

        changeStateToAttack(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Attack, false, callback, 1);
        }

        changeStateToJump(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Jump, false, callback, 1);
        }

        changeStateToEat(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Eat, false, callback, 1);
        }

        changeStateToLevelUp(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.LevelUp, false, callback, 1);
        } // changeStateToSleep() {
        //     this.onChangeState();
        //     this.anim.getState(PetAnimName.Sleep).wrapMode = AnimationClip.WrapMode.Loop;
        //     this.anim.play(PetAnimName.Sleep);
        // }


        changeStateToRest(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Rest, true, callback, 1);
          this.addFxSleepNode("fx_sleep");
        }

        changeStateToRest2(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Rest2, true, callback, 1);
          this.materialSwitcher && this.switchMaterial(1);
          this.addFxSleepNode("fx_sleep_01");
        } // changeStateFromSleepToIdle(callback?: Function) {
        //     this.onChangeState();
        //     this.anim.getState(PetAnimName.FromSleepToIdle).wrapMode = AnimationClip.WrapMode.Normal;
        //     this.anim.play(PetAnimName.FromSleepToIdle);
        //     this.anim.once(SkeletalAnimation.EventType.FINISHED, () => {
        //         callback && callback();
        //     })
        // }
        // changeStateFromIdleToSleep(callback?: Function) {
        //     this.onChangeState();
        //     this.anim.getState(PetAnimName.FromIdleToSleep).wrapMode = AnimationClip.WrapMode.Normal;
        //     this.anim.play(PetAnimName.FromIdleToSleep);
        //     this.anim.once(SkeletalAnimation.EventType.FINISHED, () => {
        //         callback && callback();
        //     })
        // }


        changeStateFromRestToIdle(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Rest, true, null, 1);
          this.scheduleOnce(() => {
            this.playCrossAnimation(PetAnimName.Idle, 1, callback);
          }, 0);
        }

        changeStateFromRest2ToIdle(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Rest2, true, null, 1); //延迟一帧的作用：playCrossAnimation要监听STOP事件，切换动画会在下一帧发射事件，碰巧调用到刚刚挂上的用于回调的STOP事件

          this.scheduleOnce(() => {
            this.playCrossAnimation(PetAnimName.Idle, 1, callback);
          }, 0);
        }

        changeStateFromIdleToRest(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Idle, true, null, 1);
          this.scheduleOnce(() => {
            this.playCrossAnimation(PetAnimName.Rest, 1, () => {
              callback && callback();
              this.addFxSleepNode("fx_sleep");
            });
          }, 0);
        }

        changeStateFromIdleToRest2(callback) {
          this.onChangeState();
          this.playAnimation(PetAnimName.Idle, true, null, 1); //延迟一帧的作用：playCrossAnimation要监听STOP事件，切换动画会在下一帧发射事件，碰巧调用到刚刚挂上的用于回调的STOP事件

          this.scheduleOnce(() => {
            this.playCrossAnimation(PetAnimName.Rest2, 1, () => {
              callback && callback();
              this.materialSwitcher && this.switchMaterial(1);
              this.addFxSleepNode("fx_sleep_01");
            });
          }, 0);
        }

        turn(targetForward, duration, endCallback) {
          const startQuat = this.node.worldRotation.clone();
          const targetQuat = new Quat();
          Quat.fromViewUp(targetQuat, targetForward.multiplyScalar(-1).normalize());
          const newQuat = new Quat();
          const tweenTargetVec3 = new Vec3();
          tween(tweenTargetVec3).to(duration, Vec3.ONE, {
            onUpdate: (target, ratio) => {
              if (!this.node) return;
              Quat.slerp(newQuat, startQuat, targetQuat, ratio);
              this.node.setWorldRotation(newQuat);
            }
          }).call(() => {
            endCallback && endCallback();
          }).start();
        }

        run(endWorldPos, duration, endCallback, reverseForward) {
          this.changeStateToRun();
          const startWorldPos = this.node.getWorldPosition();
          const forward = endWorldPos.clone().subtract(startWorldPos).normalize();
          reverseForward && forward.multiplyScalar(-1);
          this.node.forward = forward;
          tween(this.node).set({
            worldPosition: startWorldPos
          }).to(duration, {
            worldPosition: endWorldPos
          }).call(() => {
            endCallback && endCallback();
          }).start();
        }
        /**实际结束时间比duration略长，为了动画圆滑加了转向时间 */


        jump(startWorldPos, endWorldPos, duration, useRotate = false, endCallback) {
          this.changeStateToIdle();
          const rotateTime = useRotate ? 0.2 : 0;
          const tweenTargetVec3 = new Vec3(); //用0.2s时间做一个转向的插值

          const lastPos = this.getCurvePosByPercent(endWorldPos, startWorldPos, 1);
          const curPos = this.getCurvePosByPercent(endWorldPos, startWorldPos, 1 - 0.01);
          const targetForward = curPos.subtract(lastPos).normalize();
          targetForward.y = 0;
          this.turn(targetForward, rotateTime);
          tween(tweenTargetVec3).delay(rotateTime).to(duration, Vec3.ONE, {
            onUpdate: (target, ratio) => {
              if (!this.node) return;
              const lastPos = this.getCurvePosByPercent(endWorldPos, startWorldPos, 1 - (ratio - 0.01));
              this.node.worldPosition = this.getCurvePosByPercent(endWorldPos, startWorldPos, 1 - ratio);
              const forward = this.node.worldPosition.clone().subtract(lastPos);
              forward.y = 0;
              this.node.forward = forward;
            }
          }).call(() => {
            endCallback && endCallback();
          }).start();
        }

        getCurvePosByPercent(startPos, endPos, percent) {
          percent = Math.clamp(percent, 0, 1);
          const outPos = new Vec3();
          const distanceY = endPos.y - startPos.y;
          let time = 1;
          const acceleration = 2 * distanceY / Math.pow(time, 2);
          outPos.x = Math.lerp(startPos.x, endPos.x, percent);
          outPos.z = Math.lerp(startPos.z, endPos.z, percent);
          outPos.y = startPos.y + 0.5 * acceleration * Math.pow(percent, 2);
          return outPos;
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivitySlotSymbolRankWindow.ts", ['cc', './ReuseItem.ts', './ReuseScrollView.ts', './UIWindow.ts', './Content.ts', './UserInfoModel.ts', './SlotCollectExtra.ts', './PlayerPrefs.ts', './ActivitySlotSymbolRankRewardWindow.ts', './SR.ts', './ActivityManager.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, Button, _decorator, ScrollView, Widget, RichText, v3, ResueItem, ReuseScrollView, UIWindow, Content, UserInfoModel, SlotCollectExtra, PlayerPrefs, ActivitySlotSymbolRankRewardWindow, SR, ActivityManager, Game, Meta, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      Button = module.Button;
      _decorator = module._decorator;
      ScrollView = module.ScrollView;
      Widget = module.Widget;
      RichText = module.RichText;
      v3 = module.v3;
    }, function (module) {
      ResueItem = module.ResueItem;
    }, function (module) {
      ReuseScrollView = module.ReuseScrollView;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      SlotCollectExtra = module.default;
    }, function (module) {
      PlayerPrefs = module.PlayerPrefs;
    }, function (module) {
      ActivitySlotSymbolRankRewardWindow = module.ActivitySlotSymbolRankRewardWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ad000uDsahHSI0mx0+CNK47", "ActivitySlotSymbolRankWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivitySlotSymbolRankWindow = exports('ActivitySlotSymbolRankWindow', (_dec = property(Node), _dec2 = property(Label), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(SlotCollectExtra), _dec7 = property(ReuseScrollView), _dec8 = property(Node), _dec9 = property(Button), _dec10 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class ActivitySlotSymbolRankWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "content", _descriptor, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor2, this);

          _initializerDefineProperty(this, "itemSelf", _descriptor3, this);

          _initializerDefineProperty(this, "getJoinNode", _descriptor4, this);

          _initializerDefineProperty(this, "infoModel", _descriptor5, this);

          _initializerDefineProperty(this, "infoPanel", _descriptor6, this);

          _initializerDefineProperty(this, "reuseScrollView", _descriptor7, this);

          _initializerDefineProperty(this, "rankItem", _descriptor8, this);

          _initializerDefineProperty(this, "btnContinue", _descriptor9, this);

          _initializerDefineProperty(this, "btnCloseNode", _descriptor10, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "data", void 0);

          _defineProperty(this, "metaParam", void 0);

          _defineProperty(this, "showParam", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "selfRank", void 0);

          _defineProperty(this, "_itemSelf", null);

          _defineProperty(this, "_viewTop", null);

          _defineProperty(this, "_viewBottom", null);
        }

        onEnable() {
          this.reuseScrollView.scrollView.node.on(ScrollView.EventType.SCROLLING, this._onScrolling, this);
        }

        onDisable() {
          this.reuseScrollView.scrollView.node.on(ScrollView.EventType.SCROLLING, this._onScrolling, this);
        }

        async onShow(showParams) {
          this.data = Game.SUserActivity.GetSymbolRankData();
          this.meta = showParams.meta || this.data.activityId && ActivityManager.GetMeta(this.data.activityId);

          if (this.meta == null) {
            this.close();
            return;
          }

          if (!this.meta.IsActive() && !this.data.collect) {
            this.close();
            SR.SRActivity.getUserActivity().Send();
            return;
          }

          this.metaParam = this.meta.Param();
          this.showParam = this.metaParam.__info;
          const isCollected = PlayerPrefs.GetBool(this.data.activityId + "lastTournamentCollected");

          if (!this.meta.IsActive() && this.data.collect && !isCollected) {
            this.content.getComponent(Widget).bottom = 130;
            this.content.getComponent(Widget).updateAlignment();
            this.onActivityEnded();
          } else if (this.data == null || this.data.activityId == null || this.data.activityId != this.meta.Id() || this.data.rank == null || Object.keys(this.data.rank).length == 0 || isCollected) {
            this.content.getComponent(Widget).bottom = 80;
            this.content.getComponent(Widget).updateAlignment();
            this.showJoinNode();
          } else {
            this.content.getComponent(Widget).bottom = 80;
            this.content.getComponent(Widget).updateAlignment();

            if (GameKit.TimeUtil.getCurrentTime() - this.data.updateTime > GameKit.TimeUtil.MinuteInSecond * 10) {
              let req = SR.SRActivity.getUserActivity();
              req.SetCallBack(() => {
                this.setRankItems();
              });
              req.Send();
            } else {
              this.setRankItems();
            }
          }

          this.infoPanel.Show(null, this.meta);
          this.leftTime = 0;
          this.slowUpdate(0);
        }

        onClose() {}

        slowUpdate(args) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = 0;
            this.leftTime = this.meta.EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, true);

            if (this.leftTime <= 0) {
              // this.labelTimer.string = i18n.t("ActivityCenterTimeEnd");
              this.labelTimer.node.active = false;
              this.leftTime = null;
            }
          }
        }

        close_window() {
          this.closeAnim();
        }

        setRankItems() {
          const uids = Object.keys(this.data.rank);
          uids.sort((a, b) => {
            return this.data.rank[b].score - this.data.rank[a].score;
          });
          this.selfRank = uids.indexOf(Game.SUser.UserId().toString()) + 1;
          const rankDatas = [];
          uids.forEach((uid, index) => {
            const rewards = Content.FromStrings(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollectRankReward, index + 1 || this.selfRank));
            let rankData;

            if (uid === Game.SUser.UserId().toString()) {
              rankData = {
                isSelf: true,
                photoUrl: Game.SUser.Avatar(),
                rank: this.selfRank,
                isVip: Game.SUser.IsVip(),
                name: Game.SUser.Name(),
                score: this.data.rank[uid].score,
                contents: rewards
              };
            } else {
              rankData = {
                isSelf: false,
                photoUrl: this.data.rank[uid].avatar,
                rank: index + 1,
                isVip: this.data.rank[uid].isVip,
                name: this.data.rank[uid].name,
                score: this.data.rank[uid].score,
                contents: rewards
              };
            }

            rankDatas.push(rankData);
          });
          if (!rankDatas.length) return;
          this.reuseScrollView.initScrollView(rankDatas, this.rankItem);

          this._updateItemSelf();

          this._onScrolling();
        }

        showJoinNode() {
          this.itemSelf.active = true;
          let userinfo = this.itemSelf.getComponentInChildren(UserInfoModel);
          let label_getjoin = this.itemSelf.getChildByName("bg").getChildByName("label_getjoin").getComponent(RichText);
          let rank = this.itemSelf.getChildByName("bg").getChildByName("index_label");
          let scoreNode = this.itemSelf.getChildByName("bg").getChildByName("symbol-ranking-numBox1");
          userinfo.show(Game.SUser);
          label_getjoin.node.active = true;
          label_getjoin.string = String.format(i18n.t("ActivitySlotCollectRankGetJoin"), this.metaParam.symbolId);
          rank.active = false;
          scoreNode.active = false;
          this.getJoinNode.active = true;
        }

        onActivityEnded() {
          this.setRankItems();
          this.btnContinue.node.active = true;
          this.btnCloseNode.active = false;
          this.scheduleOnce(() => {
            this._scrollToSpecificalIndex(this.selfRank);
          }, 0.5); // this.svt.DirectToIndex(this.selfRank);
        }

        openRankHelp() {
          this.infoPanel.node.active = true;
          this.infoPanel.node.scale = v3(0.001, 0.001, 1);
          this.infoPanel.node.runAction(ccAction.scaleTo(0.2, 1, 1));
          this.infoModel.active = true;
        }

        hideRankHelp() {
          this.infoPanel.node.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001, 0.001), ccAction.callFunc(() => {
            this.infoPanel.node.active = false;
            this.infoModel.active = false;
          })));
        }

        _onScrolling() {
          if (!this._itemSelf) {
            this._itemSelf = this.reuseScrollView.itmes.filter(item => item.getComponent(ResueItem)._data.isSelf === true)[0];
          }

          if (!this._viewBottom) {
            this._viewBottom = this.reuseScrollView.scrollView.node.getWorldPosition().y - this.reuseScrollView.scrollView.node.height / 2;
          }

          if (!this._viewTop) {
            this._viewTop = this.reuseScrollView.scrollView.node.getWorldPosition().y + this.reuseScrollView.scrollView.node.height / 2;
          }

          if ((this._itemSelf && this._itemSelf.getWorldPosition().y - this._itemSelf.height / 2) < this._viewTop && this._itemSelf.getWorldPosition().y + this._itemSelf.height / 2 > this._viewBottom) {
            this.itemSelf.active = false;
            this._itemSelf = null;
          } else {
            this.itemSelf.active = true;
            this._itemSelf = null;
          }
        }

        _updateItemSelf() {
          let userinfo = GameKit.ControllerTable.GetNode(this.itemSelf, "userinfo").getComponent(UserInfoModel);
          let score = GameKit.ControllerTable.GetNode(this.itemSelf, "level_label");
          let rank = GameKit.ControllerTable.GetNode(this.itemSelf, "index_label").getComponent(Label);
          score.getComponent(Label).string = "" + this.data.rank[Game.SUser.UserId()].score;
          userinfo.show(Game.SUser);
          rank.string = this.selfRank.toString();
        }

        _scrollToSpecificalIndex(index) {
          this.reuseScrollView.scrollView.content.height = (this.reuseScrollView.spacingY + this.rankItem.height) * Object.keys(this.data.rank).length;
          const offsetIndex = index <= this.reuseScrollView.MAX_REUSE / 2 ? index - 1 : index - this.reuseScrollView.MAX_REUSE / 2;
          const offset = v3(0, offsetIndex * (this.reuseScrollView.spacingY + this.rankItem.height), 0);
          this.reuseScrollView.scrollView.scrollToOffset(offset, 0.1 * offsetIndex);
        }

        onBtnContinueClick() {
          this.closeAnim(() => {
            uiRoot.openChildWindow(ActivitySlotSymbolRankRewardWindow);
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/normal/ActivitySlotSymbolRankWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "content", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "itemSelf", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "getJoinNode", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "infoModel", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "infoPanel", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "reuseScrollView", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "rankItem", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "btnContinue", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "btnCloseNode", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AttackKingExtra.ts", ['cc', './CCE_Component.ts', './ContentModel.ts', './Content.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, ProgressBar, _decorator, CCE_Component, ContentModel, Content, Game, Meta;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ad0a46HMiFBnr+8d9IWmP4R", "AttackKingExtra", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AttackKingExtra = exports('default', (_dec = property(Label), _dec2 = property(ProgressBar), _dec3 = property(ContentModel), ccclass(_class = (_class2 = (_temp = class AttackKingExtra extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelProgress", _descriptor, this);

          _initializerDefineProperty(this, "spProgress", _descriptor2, this);

          _initializerDefineProperty(this, "reward", _descriptor3, this);

          _defineProperty(this, "activityId", void 0);

          _defineProperty(this, "userdata", void 0);
        }

        Show(centerWindow, activityMeta) {
          this.activityId = activityMeta.Id();
          this.userdata = Game.SUserActivity.GetActivityData(this.activityId);
          let currentCount = this.userdata.currentCount || 0;
          let currentId = this.userdata.currentId || 1;
          let currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.AttackMaster, currentId);
          let currentGet = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.AttackMasterReward, currentId));
          this.labelProgress.string = currentCount.toString() + " / " + currentNeed;
          this.spProgress.progress = currentCount / currentNeed;
          this.reward.show(currentGet);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelProgress", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spProgress", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "reward", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BlackJackHelpWindow.ts", ['cc', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "ad43bwXfzFOeq1L00TwAm1z", "BlackJackHelpWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BlackJackHelpWindow = exports('BlackJackHelpWindow', ccclass(_class = (_temp = _class2 = class BlackJackHelpWindow extends UIWindow {
        onShow(showParams) {}

        onClose() {}

        callClose() {
          this.closeAnim();
        }

      }, _defineProperty(_class2, "windowPath", "Activity/blackjack/BlackJackHelpWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRUserData.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRUserData', void 0);

      cclegacy._RF.push({}, "ada38TW3dhK8a/EbsGS4Kqm", "SRUserData", undefined);

      let SRUserData;

      (function (_SRUserData) {
        function getData() {
          let req = new GameKit.ServerRequest("getUserData");
          req.SetCallBack(function (res) {
            Game.SUser.updateData(res.userdata);
          });
          return req;
        }

        _SRUserData.getData = getData;

        function finishVideoAp() {
          let req = new GameKit.ServerRequest("finishVideoAp");
          return req;
        }

        _SRUserData.finishVideoAp = finishVideoAp;

        function finishVideoCoin(byTip = false) {
          let req = new GameKit.ServerRequest("finishVideoCoin");
          req.SetRequestBody("byTip", !!byTip);
          return req;
        }

        _SRUserData.finishVideoCoin = finishVideoCoin;

        function finishVideoSlotCoin6() {
          let req = new GameKit.ServerRequest("finishVideoSlotCoin6");
          return req;
        }

        _SRUserData.finishVideoSlotCoin6 = finishVideoSlotCoin6;

        function finishVideoShield() {
          let req = new GameKit.ServerRequest("finishVideoShield");
          return req;
        }

        _SRUserData.finishVideoShield = finishVideoShield;

        function finishVideoPeterGift() {
          let req = new GameKit.ServerRequest("finishVideoPeterGift");
          return req;
        }

        _SRUserData.finishVideoPeterGift = finishVideoPeterGift;

        function finishVideoLuckyDraw() {
          let req = new GameKit.ServerRequest("finishVideoLuckyDraw");
          return req;
        }

        _SRUserData.finishVideoLuckyDraw = finishVideoLuckyDraw;

        function heartBeat() {
          let req = new GameKit.ServerRequest("heartBeat");
          req.SetSilence(true);
          return req;
        }

        _SRUserData.heartBeat = heartBeat;
      })(SRUserData || (SRUserData = exports('SRUserData', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NewMapWindow.ts", ['cc', './Logs.ts', './_app.ts', './UIWindow.ts', './MapItem.ts', './UIRoot.ts', './StaticGame.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Prefab, Node, Button, ScrollView, ScrollBar, _decorator, Vec3, Widget, instantiate, math, UITransform, view, Logs, cce, UIWindow, MapItem, UIRoot, Game, Meta, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Prefab = module.Prefab;
      Node = module.Node;
      Button = module.Button;
      ScrollView = module.ScrollView;
      ScrollBar = module.ScrollBar;
      _decorator = module._decorator;
      Vec3 = module.Vec3;
      Widget = module.Widget;
      instantiate = module.instantiate;
      math = module.math;
      UITransform = module.UITransform;
      view = module.view;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      MapItem = module.MapItem;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "aea8fLtoHJPPqvl2PeoNg3I", "NewMapWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NewMapWindow = exports('NewMapWindow', (_dec = ccclass('NewMapWindow'), _dec2 = property(Prefab), _dec3 = property(Node), _dec4 = property(Button), _dec5 = property(Node), _dec6 = property(ScrollView), _dec7 = property(ScrollBar), _dec(_class = (_class2 = (_temp = _class3 = class NewMapWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "mapItemPrefab", _descriptor, this);

          _initializerDefineProperty(this, "content", _descriptor2, this);

          _initializerDefineProperty(this, "btnClose", _descriptor3, this);

          _initializerDefineProperty(this, "nodeCommingSoon", _descriptor4, this);

          _initializerDefineProperty(this, "scrollView", _descriptor5, this);

          _initializerDefineProperty(this, "scrollBar", _descriptor6, this);

          _defineProperty(this, "_currentUnlockMapId", 0);

          _defineProperty(this, "_currentUnlockMapItem", null);

          _defineProperty(this, "_villagesDataIds", []);

          _defineProperty(this, "_maxReuse", 5);

          _defineProperty(this, "_firstItemMapId", 0);

          _defineProperty(this, "_lastItemMapId", 0);

          _defineProperty(this, "_isScrollUp", false);

          _defineProperty(this, "_previousOffset", new Vec3());

          _defineProperty(this, "_mapItems", []);

          _defineProperty(this, "_mapItemSize", void 0);

          _defineProperty(this, "_levelUP", false);
        }

        onLoad() {
          this.node.getChildByName("content").getComponent(Widget).top += AppMain.instance.statusBarHeight;
          homeView.mapWindow = this;
        }

        async onShow(showParams) {
          this._currentUnlockMapId = Game.SUserVillage.MapId();

          if (showParams.levelUp) {
            this._levelUP = true;
            UIRoot.instance.ShowCantClick(true); // 容错

            if (this._currentUnlockMapId < 2) {
              Logs.Error("[MapWindow]解锁地图失败：地图id溢出，已经重置地图id为2 [by:fy]");
              this._currentUnlockMapId = 2;
            }

            this._currentUnlockMapId -= 1;
            this.btnClose.node.active = false;
          }

          if (!!showParams.specificMap) {
            this._currentUnlockMapId = showParams.specificMap;
          }

          await this.setMapItems();
          await cce.wait(1000);

          if (showParams.levelUp) {
            this.unlockNextMap();
          }
        }

        onEnable() {
          this.scrollView.node.on(ScrollView.EventType.SCROLL_BEGAN, this.onScrollBegan, this);
          this.scrollView.node.on(ScrollView.EventType.SCROLLING, this.onScrolling, this);
          this.btnClose.node.on("click", this.onBtnCloseClick, this);
        }

        onDisable() {
          this.scrollView.node.off(ScrollView.EventType.SCROLL_BEGAN, this.onScrollBegan, this);
          this.scrollView.node.off(ScrollView.EventType.SCROLLING, this.onScrolling, this);
          this.btnClose.node.off("click", this.onBtnCloseClick, this);
        }

        async setMapItems() {
          this.getMaxReuse();
          const ids = this.getVillageDataIdsInrange();
          const tempItem = instantiate(this.mapItemPrefab);
          const size = new math.Size(tempItem.getComponent(UITransform).width, tempItem.getComponent(UITransform).height * (this._villagesDataIds.length + 1));
          this.content.getComponent(UITransform).setContentSize(size);
          this._mapItemSize = tempItem.getComponent(UITransform).contentSize;
          tempItem.destroy();
          this.scrollToMapById(this._currentUnlockMapId);
          const promiseAll = [];

          let setItem = id => {
            return new Promise(async resolve => {
              const newMapItem = instantiate(this.mapItemPrefab);

              this._mapItems.push(newMapItem);

              const mapItem = newMapItem.getComponent(MapItem);
              this.content.addChild(newMapItem);
              await mapItem.setItem(Meta.MetaManager.GetMeta(Meta.MetaType.Village, id), this);
              resolve(null);
              newMapItem.setPosition(0, -(id * this._mapItemSize.height), 0);
            });
          };

          for (let i = 0; i < ids.length; i++) {
            promiseAll.push(setItem(ids[i]));
          }

          return Promise.all(promiseAll);
        }

        async unlockNextMap() {
          this.scrollToMapById(this._currentUnlockMapId + 1, 1);

          this._mapItems.forEach(item => {
            if (item.getComponent(MapItem)._data.Id() === this._currentUnlockMapId + 1) {
              this._currentUnlockMapItem = item.getComponent(MapItem);
            }
          });

          await cce.wait(500);
          this._currentUnlockMapItem && this._currentUnlockMapItem.unlockMapItem();
        }

        getMaxReuse() {
          const newMapItem = instantiate(this.mapItemPrefab);
          newMapItem.active = false;
          this._maxReuse = Math.ceil(view.getVisibleSize().height / newMapItem.getComponent(UITransform).height) + 2;
          newMapItem.destroy();
        }

        getVillageDataIdsInrange() {
          let table = Meta.MetaManager.GetMetas(Meta.MetaType.Village);
          this._villagesDataIds = Object.keys(table).map(v => table[v].Id());
          let mapIds = [];

          if (this._villagesDataIds.length <= this._maxReuse) {
            mapIds = this._villagesDataIds;
          } else {
            const preCount = Math.floor(this._maxReuse / 2);

            for (let i = 1; i <= this._maxReuse; i++) {
              mapIds.push(this._currentUnlockMapId - preCount - 1 + i);
            }

            if (mapIds[0] < this._villagesDataIds[0]) {
              mapIds = mapIds.map(id => id + (1 - mapIds[0]));
            } else if (mapIds[mapIds.length - 1] > this._villagesDataIds[this._villagesDataIds.length - 1]) {
              mapIds = mapIds.map(id => id - (mapIds[mapIds.length - 1] - this._villagesDataIds[this._villagesDataIds.length - 1]));
            }
          }

          this._firstItemMapId = mapIds[0];
          this._lastItemMapId = mapIds[mapIds.length - 1];
          return mapIds;
        }

        onScrollBegan() {
          this._previousOffset = this.scrollView.getScrollOffset();
        }

        onScrolling() {
          const currentOffset = this.scrollView.getScrollOffset();
          const scrollViewBottomY = this.scrollView.node.getWorldPosition().y - this.scrollView.node.getComponent(UITransform).height / 2;
          const scrollViewTopY = this.scrollView.node.getWorldPosition().y + this.scrollView.node.getComponent(UITransform).height / 2; // const dbVillage = DB_village.getall();

          let table = Meta.MetaManager.GetMetas(Meta.MetaType.Village);
          const dbVillage = Object.keys(table).map(v => table[v]);
          const firstMapItem = this._mapItems[0];
          const firstMapItemY = firstMapItem.getWorldPosition().y + firstMapItem.getComponent(UITransform).height / 2 - 50;
          const lastMapItem = this._mapItems[this._mapItems.length - 1];
          const lastMapItemY = lastMapItem.getWorldPosition().y - lastMapItem.getComponent(UITransform).height / 2 + 50;
          this._isScrollUp = currentOffset.y > this._previousOffset.y;
          this._previousOffset = currentOffset;

          if (this._isScrollUp) {
            //往上滑, 当最后一个元素的底进入scrollView的下边界，把最上面的元素移动到列表的最下面
            if (lastMapItemY >= scrollViewBottomY) {
              this._lastItemMapId += 1;
              this._firstItemMapId += 1;

              if (this._lastItemMapId > dbVillage[dbVillage.length - 1].Id()) {
                this._lastItemMapId -= 1;
                this._firstItemMapId -= 1;
                return;
              }

              firstMapItem.active = false;
              const newPositonY = lastMapItem.getPosition().y - lastMapItem.getComponent(UITransform).height / 2 - firstMapItem.getComponent(UITransform).height / 2;
              firstMapItem.setPosition(new Vec3(0, newPositonY, 0));
              firstMapItem.getComponent(MapItem).setItem(Meta.MetaManager.GetMeta(Meta.MetaType.Village, this._lastItemMapId), this);
              firstMapItem.active = true;

              const tempItem = this._mapItems.shift();

              this._mapItems.push(tempItem);
            }
          } else {
            //往下滑，当第一个元素的顶进入scrollView的上边界，把最下面的元素移动到列表的最上面
            if (firstMapItemY <= scrollViewTopY) {
              this._firstItemMapId -= 1;
              this._lastItemMapId -= 1;

              if (this._firstItemMapId < dbVillage[0].Id()) {
                this._firstItemMapId += 1;
                this._lastItemMapId += 1;
                return;
              }

              lastMapItem.active = false;
              const newPositonY = firstMapItem.getPosition().y + lastMapItem.getComponent(UITransform).height / 2 + firstMapItem.getComponent(UITransform).height / 2;
              lastMapItem.setPosition(new Vec3(0, newPositonY, 0));
              lastMapItem.getComponent(MapItem).setItem(Meta.MetaManager.GetMeta(Meta.MetaType.Village, this._firstItemMapId), this);
              lastMapItem.active = true;

              const tempItem = this._mapItems.pop();

              this._mapItems.unshift(tempItem);
            }
          }
        }

        scrollToMapById(mapId, time = 0) {
          const offset = new Vec3(0, mapId * this._mapItemSize.height - this.scrollView.node.getComponent(UITransform).height / 2, 0);

          if (time <= 0) {
            this.scrollView.scrollToOffset(offset);
          } else {
            this.scrollView.scrollToOffset(offset, time);
          }
        }

        onBtnCloseClick(event, cb) {
          this.closeAnim(() => {
            cb && cb();
            homeView.mapWindow = null;
          });
        }

      }, _defineProperty(_class3, "windowPath", "Menu/NewMapWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "mapItemPrefab", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "content", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btnClose", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "nodeCommingSoon", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "scrollView", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "scrollBar", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NotificationWrap.ts", ['cc', './AppGame.ts', './SdkManager.ts', './ActivityManager.ts', './StaticGame.ts', './NativeWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, game, Game, AppGame, SdkManager, ActivityManager, Game$1, NativeWrap, GameKit, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      game = module.game;
      Game = module.Game;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game$1 = module.Game;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('NotificationWrap', void 0);

      cclegacy._RF.push({}, "af9de+08YRH6qUbwAHtZWiq", "NotificationWrap", undefined);

      let NotificationWrap;

      (function (_NotificationWrap) {
        let cid = 10;

        function Init() {
          if (SdkManager.IsNative()) {
            NativeWrap.call("NotificationClass", "Init", null, () => {});
          }

          game.on(Game.EVENT_SHOW, () => {
            NotificationWrap.CancelAll();
          });
          game.on(Game.EVENT_HIDE, () => {
            NotificationWrap.SetAll();
          });
          this.inited = true;
        }

        _NotificationWrap.Init = Init;

        function SetMessage(time, title, message) {
          let obj = {
            title: "",
            message: "",
            time: 0,
            id: 0
          };
          obj.title = title;
          obj.message = message;
          obj.time = time;
          obj.id = cid;
          cid++;

          if (SdkManager.IsNative()) {
            NativeWrap.call("NotificationClass", "SetMessage", obj, null);
          }
        }

        _NotificationWrap.SetMessage = SetMessage;

        function CancelAll() {
          if (!this.inited) return;

          if (SdkManager.IsNative()) {
            NativeWrap.call("NotificationClass", "CancelAll", null, null);
          } //NotificationWrap.cid = 1

        }

        _NotificationWrap.CancelAll = CancelAll;

        function SetAll() {
          if (!this.inited) return;
          if (!Game$1.SUser) return;
          if (!AppGame.instance.logined) return;
          let currentTime = GameKit.TimeUtil.getCurrentTime();
          let needTime = 0;
          needTime = Game$1.SUser.GetFullApTime();

          if (needTime > 0) {
            NotificationWrap.SetMessage(needTime, i18n.t("NotificationTitleApFull"), i18n.t("NotificationDesApFull"));
          }

          needTime = Game$1.SUserSlot.DailyBonusRemainTime();

          if (needTime > 0) {
            NotificationWrap.SetMessage(needTime, i18n.t("NotificationTitleDailyBonus"), i18n.t("NotificationDesDailyBonus"));
          }

          needTime = Game$1.SUserSlot.data.systemUserEffectTime[0] - currentTime;

          if (needTime > GameKit.TimeUtil.HourInSecond) {
            if (Game$1.SUserVillage.Score() > 0 || Game$1.SUser.Coin() > 300000) {
              NotificationWrap.SetMessage(needTime, i18n.t("NotificationTitleAttack"), i18n.t("NotificationDesAttack"));
            }
          }

          let shopActivity = ActivityManager.GetActiveShopActivity();
          let gameActivity = null;
          let activity = null;

          if (shopActivity != null && gameActivity == null) {
            activity = shopActivity;
          } else if (shopActivity == null && gameActivity != null) {
            activity = gameActivity;
          } else if (shopActivity != null && gameActivity != null) {
            activity = shopActivity.EndTime() < gameActivity.EndTime() ? shopActivity : gameActivity;
          }

          if (activity) {
            needTime = activity.EndTime() - GameKit.TimeUtil.HourInSecond * 1 - currentTime;

            if (needTime > 0) {
              NotificationWrap.SetMessage(needTime, i18n.t("NotificationTitleActivity"), String.format(i18n.t("NotificationDesActivity"), activity.Name()));
            }
          }

          NotificationWrap.SetMessage(GameKit.TimeUtil.DayInSecond * 3, i18n.t("NotificationTitleBack"), i18n.t("NotificationDesBack"));
          NotificationWrap.SetMessage(GameKit.TimeUtil.DayInSecond * 7, i18n.t("NotificationTitleBack2"), i18n.t("NotificationDesBack2"));
        }

        _NotificationWrap.SetAll = SetAll;
      })(NotificationWrap || (NotificationWrap = exports('NotificationWrap', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DailyBonusNode.ts", ['cc', './global.ts', './_app.ts', './EnterCloseAnim.ts', './SoundManager.ts', './UIWindow.ts', './PlayGetAnimation.ts', './AppCommentWindow.ts', './WheelNode.ts', './ChangeSceneManager.ts', './GameMainWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, ParticleSystem2D, Prefab, _decorator, Vec2, Widget, Vec3, v3, G, cce, EnterCloseAnim, SoundManager, UIWindow, PlayGetAnimation, AppCommentWindow, WheelNode, ChangeSceneManager, GameMainWindow, SR, UIRoot, Game, LogEventWrap, ADWrap, PaymentWrap, GameKit, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      ParticleSystem2D = module.ParticleSystem2D;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      Vec2 = module.Vec2;
      Widget = module.Widget;
      Vec3 = module.Vec3;
      v3 = module.v3;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      AppCommentWindow = module.default;
    }, function (module) {
      WheelNode = module.default;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "afca2WOdpBHJZFdLReqfdRd", "DailyBonusNode", undefined);

      const goldShopItemName = "ik.goldbonus";
      const goldShopItemNameFirst = "ik.goldbonusfirst";
      const SE_coin_loop = "db_coin_loop";
      const SE_collect = "db_collect_coins";
      const SE_number = "db_win_number";
      const SE_number_big = "db_win_number_big";
      const {
        ccclass,
        property
      } = _decorator;
      let DailyBonusNode = exports('default', (_dec = property(WheelNode), _dec2 = property(WheelNode), _dec3 = property(Node), _dec4 = property(Label), _dec5 = property(Node), _dec6 = property(Label), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Label), _dec10 = property(Node), _dec11 = property(Label), _dec12 = property(Label), _dec13 = property(Node), _dec14 = property([ParticleSystem2D]), _dec15 = property(Node), _dec16 = property(Node), _dec17 = property(Node), _dec18 = property(Prefab), ccclass(_class = (_class2 = (_temp = _class3 = class DailyBonusNode extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "normalWheelNode", _descriptor, this);

          _initializerDefineProperty(this, "goldWheelNode", _descriptor2, this);

          _initializerDefineProperty(this, "normalWheelSpinBtn", _descriptor3, this);

          _initializerDefineProperty(this, "labelNormalDis", _descriptor4, this);

          _initializerDefineProperty(this, "goldWheelSpinBtn", _descriptor5, this);

          _initializerDefineProperty(this, "goldWheelSpinBtnLabel", _descriptor6, this);

          _initializerDefineProperty(this, "centerNode", _descriptor7, this);

          _initializerDefineProperty(this, "frontNode", _descriptor8, this);

          _initializerDefineProperty(this, "freeSpinDesLabel", _descriptor9, this);

          _initializerDefineProperty(this, "normalBadge", _descriptor10, this);

          _initializerDefineProperty(this, "levelLabel", _descriptor11, this);

          _initializerDefineProperty(this, "resultCoin", _descriptor12, this);

          _initializerDefineProperty(this, "collectBtn", _descriptor13, this);

          _initializerDefineProperty(this, "coinAnim1", _descriptor14, this);

          _initializerDefineProperty(this, "firstGoldTip", _descriptor15, this);

          _initializerDefineProperty(this, "btnNormalToGold", _descriptor16, this);

          _initializerDefineProperty(this, "btnGoldToNormal", _descriptor17, this);

          _initializerDefineProperty(this, "coinPrefab", _descriptor18, this);

          _defineProperty(this, "dis2top", void 0);

          _defineProperty(this, "hidden", void 0);

          _defineProperty(this, "isGold", void 0);

          _defineProperty(this, "isShowResult", void 0);

          _defineProperty(this, "freeRemainTime", void 0);

          _defineProperty(this, "changeAnim", void 0);

          _defineProperty(this, "oldCoin", void 0);

          _defineProperty(this, "_curWheel", "gold");

          _defineProperty(this, "_isCompleted", true);

          _defineProperty(this, "touchStartTime", 0);

          _defineProperty(this, "touchStartLocation", new Vec2());
        }

        onShow() {
          this.levelLabel.string = String.format(i18n.t("DailyBonusLevel"), Game.SUserVillage.MapId());
          this.normalWheelNode.start();
          this.goldWheelNode.start();
          this.firstGoldTip.active = Game.SUserSlot.IsFirstGoldBonus();
          this.setPayButton();
        }

        onLoad() {
          this.hideAllWheel();
          this.stopCoinAnim1();
          this.node.on(Node.EventType.TOUCH_START, this.onTouchStart, this, true);
          this.node.on(Node.EventType.TOUCH_END, this.onTouchEnded, this, true);
          this.node.on(Node.EventType.TOUCH_CANCEL, this.onTouchEnded, this, true);
          this.node.getChildByName("content").getComponent(Widget).top += AppMain.instance.statusBarHeight;
        }

        onEnable() {
          if (!this.hidden) return;
          this.centerNode.stopAllActions();
          this.centerNode.scale = Vec3.ONE;
          this.frontNode.stopAllActions();
          this.frontNode.scale = Vec3.ONE;
          this.isGold = this.isGold != null ? this.isGold : !Game.SUserSlot.CanGetDailyBonus();

          if (!this.isGold) {
            this.scheduleOnce(this.showNormalWheel, 0.25);
          } else {
            this.scheduleOnce(this.showGoldWheel, 0.25);
          }

          this.updateNormalTime();
        }

        setPayButton() {
          let payname = goldShopItemName;
          if (Game.SUserSlot.IsFirstGoldBonus()) payname = goldShopItemNameFirst;
          let goldPayItem = PaymentWrap.GetItem(payname);
          if (goldPayItem) this.goldWheelSpinBtnLabel.string = String.format(i18n.t("DailyBonusGoldSpinBtn"), goldPayItem.PriceString());
        }

        slowUpdate(dt) {
          this.updateFreeSpinTime();
        }

        onDisable() {
          this.hideAllWheel();
        }

        Clear() {
          this.normalWheelNode.Clear();
          this.goldWheelNode.Clear();
          this.hideResult();
          this.isShowResult = false;
        }

        isRunning() {
          return this.normalWheelNode.isRunning() || this.goldWheelNode.isRunning() || this.isShowResult;
        } // Show


        showNormalWheel() {
          if (!ADWrap.AdEnabled()) {
            this.showGoldWheel();
            return;
          }

          this.normalWheelNode.showWheel();
          this.showNormalWheelUI();
          this.updateNormalTime();
        }

        showNormalWheelUI() {
          this._curWheel = "normal";
          this.normalWheelSpinBtn.active = true;
          this.normalWheelSpinBtn.scaleX = 1;
          this.normalWheelSpinBtn.scaleY = 1;
          this.normalWheelSpinBtn.getComponent(EnterCloseAnim).enterAnim();

          if (Game.SUserSlot.DailyBonusDid() > 0) {
            this.freeSpinDesLabel.node.scaleX = 1;
            this.freeSpinDesLabel.node.scaleY = 1;
            this.freeSpinDesLabel.getComponent(EnterCloseAnim).enterAnim();
          }

          this.btnNormalToGold.active = true;
          this.btnGoldToNormal.active = false;
          this.isGold = false;
        }

        updateNormalTime() {
          Game.SUserSlot.UpdateDailyBonus();
          this.labelNormalDis.string = `(${G.GameConstance.dailybonusMaxCount - Game.SUserSlot.DailyBonusDid()} / ${G.GameConstance.dailybonusMaxCount})`;
          this.normalWheelSpinBtn.getChildByName("flash").active = Game.SUserSlot.CanGetDailyBonus();
          this.freeRemainTime = Math.max(0, Game.SUserSlot.DailyBonusRemainTime());
          this.normalBadge.active = Game.SUserSlot.DailyBonusDid() < G.GameConstance.dailybonusMaxCount;
        }

        showGoldWheel() {
          if (ADWrap.AdEnabled() && !PaymentWrap.PayVisiable()) {
            this.showNormalWheel();
            return;
          }

          this.goldWheelNode.showWheel();
          this.showGoldWheelUI();
        }

        showGoldWheelUI() {
          this._curWheel = "gold";
          this.goldWheelSpinBtn.active = true;
          this.goldWheelSpinBtn.scaleX = 1;
          this.goldWheelSpinBtn.scaleY = 1;
          this.goldWheelSpinBtn.getComponent(EnterCloseAnim).enterAnim();
          this.btnNormalToGold.active = false;
          this.btnGoldToNormal.active = true;
          this.isGold = true;
        } // Change


        changeGoldToNormal() {
          if (this.isRunning() || this.changeAnim) return;
          if (!this.isGold) return;
          this.changeAnim = true;
          this.btnNormalToGold.active = false;
          this.btnGoldToNormal.active = false;
          this.goldWheelSpinBtn.active = false;
          let normal = this.normalWheelNode.node;
          let gold = this.goldWheelNode.node;
          normal.active = true;
          normal.x = -UIRoot.instance.winSize.width;
          let ny = normal.y;
          normal.stopAllActions();
          normal.runAction(ccAction.moveTo(0.5, 0, ny, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeSineInOut)));
          let gy = gold.y;
          gold.stopAllActions();
          gold.runAction(ccAction.sequence(ccAction.moveTo(0.5, UIRoot.instance.winSize.width, gy, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeSineInOut)), ccAction.callFunc(() => {
            gold.x = 0;
            gold.active = false;
            this.showNormalWheelUI();
            this.changeAnim = false;
          })));
        }

        changeNormalToGold() {
          if (this.isRunning() || this.changeAnim) return;
          if (this.isGold) return;
          this.changeAnim = true;
          this.btnNormalToGold.active = false;
          this.btnGoldToNormal.active = false;
          this.normalWheelSpinBtn.active = false;
          this.freeSpinDesLabel.node.scale = v3(0.001, 0.001, 1);
          let normal = this.normalWheelNode.node;
          let gold = this.goldWheelNode.node;
          gold.active = true;
          gold.x = UIRoot.instance.winSize.width;
          let gy = gold.y;
          gold.stopAllActions();
          gold.runAction(ccAction.moveTo(0.5, 0, gy, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeSineInOut)));
          let ny = normal.y;
          normal.stopAllActions();
          normal.runAction(ccAction.sequence(ccAction.moveTo(0.5, -UIRoot.instance.winSize.width, ny, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeSineInOut)), ccAction.callFunc(() => {
            normal.x = 0;
            normal.active = false;
            this.showGoldWheelUI();
            this.changeAnim = false;
          })));
        } // Complete


        onNormalSpinComplete() {
          this.updateNormalTime();
          this._isCompleted = true;

          if (Game.SUserSlot.CanGetDailyBonus()) {
            this.normalWheelSpinBtn.active = true;
            this.normalWheelSpinBtn.getComponent(EnterCloseAnim).enterAnim();

            if (Game.SUserSlot.DailyBonusDid() > 0) {
              this.freeSpinDesLabel.getComponent(EnterCloseAnim).enterAnim();
            }
          } else {
            this.changeNormalToGold();
          }
        }

        onGoldSpinComplete() {
          this._isCompleted = true; //this.showGoldWheel()

          this.goldWheelSpinBtn.active = true;
          this.goldWheelSpinBtn.getComponent(EnterCloseAnim).enterAnim();
        }

        hideAllWheel() {
          this.hidden = true;
          this.normalWheelNode.stopMove();
          this.normalWheelNode.node.active = false;
          this.goldWheelNode.stopMove();
          this.goldWheelNode.node.active = false;
          this.normalWheelSpinBtn.active = false;
          this.goldWheelSpinBtn.active = false;
          this.freeSpinDesLabel.node.scale = v3(0.001, 0.001, 1);
        }

        async onNormalSpinBtnClick() {
          if (!Game.SUserSlot.CanGetDailyBonus()) return;

          if (this.normalWheelNode.isRunning() == false) {
            this.oldCoin = Game.SUser.Coin();
            ADWrap.ShowVideo(() => {
              let req = SR.SRDailyBonus.doDailyBonus();
              req.SetCallBack(res => {
                if (GameMainWindow.instance != null) {
                  GameMainWindow.instance.userinfo.changeCoin(this.oldCoin, this.oldCoin, 0);
                }

                let spinCount = GameKit.DataCache.GetData("bonus_count");
                spinCount = spinCount || 0;
                spinCount++;
                GameKit.DataCache.SetData("bonus_count", spinCount);
                LogEventWrap.logEvent("CoinSpinDetail", {
                  result: spinCount,
                  operation: 0
                });
                this.normalWheelNode.stopAt(res.index);
              });
              req.Send();
              this.normalWheelNode.startRun(coinNum => {
                this.showResult(coinNum);
              });
              this.normalWheelSpinBtn.getComponent(EnterCloseAnim).closeAnim(() => {
                this.normalWheelSpinBtn.active = false;
              });
              if (Game.SUserSlot.DailyBonusDid() > 0) this.freeSpinDesLabel.getComponent(EnterCloseAnim).closeAnim();
            }, "watchDailyBonusAd");
          }
        }

        onGoldSpinBtnClick() {
          if (this.goldWheelNode.isRunning() == false) {
            this._isCompleted = false;
            let payname = goldShopItemName;
            if (Game.SUserSlot.IsFirstGoldBonus()) payname = goldShopItemNameFirst;
            this.oldCoin = Game.SUser.Coin();
            PaymentWrap.Pay(payname, (ok, res) => {
              if (ok) {
                SoundManager.playSound("item_purchased");
                Game.SUserSlot.data.slotData.dailyBonusCount.gold = Game.SUserSlot.data.slotData.dailyBonusCount.gold || 0;
                Game.SUserSlot.data.slotData.dailyBonusCount.gold += 1;

                if (GameMainWindow.instance != null) {
                  GameMainWindow.instance.userinfo.changeCoin(this.oldCoin, this.oldCoin, 0);
                }

                let spinCount = GameKit.DataCache.GetData("bonus_count");
                spinCount = spinCount || 0;
                spinCount++;
                GameKit.DataCache.SetData("bonus_count", spinCount);
                LogEventWrap.logEvent("CoinSpinDetail", {
                  result: spinCount,
                  operation: 1
                });
                setTimeout(() => {
                  this.goldWheelNode.stopAt(res.index);
                  this.firstGoldTip.active = false;
                  this.setPayButton();
                }, 2000);
                this.goldWheelNode.startRun(coinNum => {
                  this.showResult(coinNum);
                });
                this.goldWheelSpinBtn.getComponent(EnterCloseAnim).closeAnim(() => {
                  this.goldWheelSpinBtn.active = false;
                });
                this.freeSpinDesLabel.getComponent(EnterCloseAnim).closeAnim();
              } else {
                this._isCompleted = true;
              }
            });
          }
        }

        updateFreeSpinTime(dt) {
          if (this.freeRemainTime) {
            this.freeRemainTime = Math.max(0, Game.SUserSlot.DailyBonusRemainTime());
            this.freeSpinDesLabel.string = String.format(i18n.t("DailyBonusFreeSpinDes"), GameKit.TimeUtil.FormatRemainTimeSimple(this.freeRemainTime));

            if (this.freeRemainTime <= 0) {
              this.freeRemainTime = 0;
              this.updateNormalTime();
              if (Game.SUserSlot.DailyBonusDid() == 0) this.freeSpinDesLabel.getComponent(EnterCloseAnim).closeAnim();
            }
          }
        }

        showResult(coinNum) {
          this.isShowResult = true;
          this.resultCoin.string = GameKit.StringUtil.formatNumber(coinNum);
          this.resultCoin.node.active = true;
          this.resultCoin.getComponent(EnterCloseAnim).enterAnim();
          this.collectBtn.active = true;
          this.collectBtn.getComponent(EnterCloseAnim).enterAnim();
          this.playCoinAnim1();

          if (this.isGold) {
            SoundManager.playSound(SE_number_big);
          } else {
            SoundManager.playSound(SE_number);
          }
        }

        onCollectBtnClick() {
          if (this.isShowResult) {
            this.hideResult();
            PlayGetAnimation.playAnimation({
              startNode: this.node,
              endNode: GameMainWindow.instance.btnCoinAdd.node.getChildByName("iconCoin"),
              count: 200,
              prefab: this.coinPrefab,
              startCallback: () => {
                if (GameMainWindow.instance != null) {
                  GameMainWindow.instance.userinfo.changeCoin(this.oldCoin, Game.SUser.Coin(), 0.8);
                  this.scheduleOnce(() => {
                    this.isShowResult = false;

                    if (!this.isGold) {
                      this.scheduleOnce(this.onNormalSpinComplete, 0.1);
                    } else {
                      this.scheduleOnce(this.onGoldSpinComplete, 0.1);
                    }
                  }, 1);
                }
              } // complete: () => {
              // 	SoundManager.stopSound(SE_collect);
              // }

            });
            SoundManager.playSound(SE_collect);
            SoundManager.stopSound(SE_coin_loop);
            AppCommentWindow.TryShow();
          }
        }

        hideResult() {
          this.resultCoin.getComponent(EnterCloseAnim).closeAnim(() => {
            this.resultCoin.node.active = false;
          });
          this.collectBtn.getComponent(EnterCloseAnim).closeAnim(() => {
            this.collectBtn.active = false;
          });
          this.stopCoinAnim1();
          SoundManager.stopSound(SE_coin_loop);
        }

        playCoinAnim1() {
          // this.coinAnim1.node.active = true
          this.coinAnim1.forEach(x => {
            x.resetSystem();
          });
        }

        stopCoinAnim1() {
          this.coinAnim1.forEach(x => {
            x.stopSystem();
          }); // this.scheduleOnce(function() {
          //     this.coinAnim1.node.active = false
          // }, 1.5)
        }

        onCloseBtnClick() {
          if (!this.goldWheelNode.isRunning() && !this.normalWheelNode.isRunning() && this._isCompleted) {
            ChangeSceneManager.instance.show(() => {
              this.closeAnim(() => {
                ChangeSceneManager.instance.hide();
              });
            });
          }
        }

        onTouchStart(event) {
          this.touchStartLocation = event.getUILocation();
          this.touchStartTime = Date.now();
        }

        onTouchEnded(event) {
          const deltaMove = new Vec2();
          Vec2.subtract(deltaMove, event.getUILocation(), this.touchStartLocation);
          const delateTime = Date.now() - this.touchStartTime;
          const moveVelocityX = deltaMove.x / delateTime * 1000;

          if ((deltaMove.x < -(this.node.width / 2) || moveVelocityX < -200) && this._curWheel === "normal") {
            this.changeNormalToGold();
          } else if ((deltaMove.x > this.node.width / 2 || moveVelocityX > 200) && this._curWheel === "gold") {
            this.changeGoldToNormal();
          }
        }

        onTouchCancel(event) {
          const deltaMove = new Vec2();
          Vec2.subtract(deltaMove, event.getUILocation(), this.touchStartLocation);
          const delateTime = Date.now() - this.touchStartTime;
          const moveVelocityX = deltaMove.x / delateTime;

          if ((deltaMove.x < -(this.node.width / 2) || moveVelocityX < -300) && this._curWheel === "normal") {
            this.changeNormalToGold();
          } else if ((deltaMove.x > this.node.width / 2 || moveVelocityX > 300) && this._curWheel === "gold") {
            this.changeGoldToNormal();
          }
        }

      }, _defineProperty(_class3, "windowPath", "dailyBonus"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "normalWheelNode", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "goldWheelNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "normalWheelSpinBtn", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelNormalDis", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "goldWheelSpinBtn", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "goldWheelSpinBtnLabel", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "centerNode", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "frontNode", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "freeSpinDesLabel", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "normalBadge", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "levelLabel", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "resultCoin", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "collectBtn", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "coinAnim1", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "firstGoldTip", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "btnNormalToGold", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "btnGoldToNormal", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "coinPrefab", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/encryptCode.ts", ['cc', './base64.ts'], function (exports) {
  'use strict';

  var cclegacy, Base64;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Base64 = module.Base64;
    }],
    execute: function () {
      exports('encryptCode', void 0);

      cclegacy._RF.push({}, "b01favlJIRIs5TXfHIEFXTL", "encryptCode", undefined);

      let encryptCode;

      (function (_encryptCode) {
        function encrypt(code) {
          //对字符串进行加密
          if (code.length < 0) return "";
          var c = String.fromCharCode(code.charCodeAt(0) + code.length);

          for (var i = 1; i < code.length; i++) {
            c += String.fromCharCode(code.charCodeAt(i) + code.charCodeAt(i - 1));
          }

          return c;
        }

        _encryptCode.encrypt = encrypt;

        function decrypt(code) {
          if (code.length < 0) return "";
          var c = String.fromCharCode(code.charCodeAt(0) - code.length);

          for (var i = 1; i < code.length; i++) {
            c += String.fromCharCode(code.charCodeAt(i) - c.charCodeAt(i - 1));
          }

          return c;
        }

        _encryptCode.decrypt = decrypt;

        function stringToBytes(str) {
          var bytes = [];
          var len, c;
          len = str.length;

          for (var i = 0; i < len; i++) {
            c = str.charCodeAt(i);
            bytes.push(c);
          }

          return bytes;
        }

        _encryptCode.stringToBytes = stringToBytes;

        function stringToArrayBuffer(str) {
          var buf = new ArrayBuffer(str.length * 2); // 每个字符占用2个字节

          var bufView = new Uint16Array(buf);

          for (var i = 0, strLen = str.length; i < strLen; i++) {
            bufView[i] = str.charCodeAt(i);
          }

          return buf;
        }

        _encryptCode.stringToArrayBuffer = stringToArrayBuffer;

        function stringToUint8Array(str, by16bit = false) {
          var bytes = [];
          var len, c;
          len = str.length;

          for (var i = 0; i < len; i++) {
            c = str.charCodeAt(i);
            if (by16bit) bytes.push((c & 0xff00) >> 8);
            bytes.push(c & 0x00ff);
          }

          var uint8Array = new Uint8Array(bytes);
          return uint8Array;
        }

        _encryptCode.stringToUint8Array = stringToUint8Array;

        function bytesToString(arr) {
          if (typeof arr === 'string') {
            return arr;
          }

          var str = '',
              _arr = arr;

          for (var i = 0; i < _arr.length; i++) {
            str += String.fromCharCode(_arr[i]);
          }

          return str;
        }

        _encryptCode.bytesToString = bytesToString;

        function arrayBufferToString(arr) {
          let array = new Uint16Array(arr);
          var res = '';
          var chunk = 8 * 1024;
          var i;

          for (i = 0; i < array.length / chunk; i++) {
            res += String.fromCharCode.apply(null, array.subarray(i * chunk, (i + 1) * chunk));
          }

          res += String.fromCharCode.apply(null, array.subarray(i * chunk));
          return res;
        }

        _encryptCode.arrayBufferToString = arrayBufferToString;

        function Uint8ArrayToString(arr, by16bit = false) {
          var dataString = "";

          if (by16bit) {
            for (var i = 0; i < arr.length - 1; i += 2) {
              dataString += String.fromCharCode((arr[i] << 8) + arr[i + 1]);
            }
          } else {
            for (var i = 0; i < arr.length; i++) {
              dataString += String.fromCharCode(arr[i]);
            }
          }

          return dataString;
        }

        _encryptCode.Uint8ArrayToString = Uint8ArrayToString;

        function simplecode(str) {
          let bytes = this.stringToBytes(str);

          if (bytes == null) {
            return null;
          }

          let len = bytes.length;
          let key = [0x11, 0x48, 0x57, 0x69, 0x62, 0x39, 0x87, 0x71];

          for (let i = 0; i < len; i++) {
            bytes[i] ^= key[i % key.length];
          }

          return this.bytesToString(bytes);
        }

        _encryptCode.simplecode = simplecode;

        function simbas(r) {
          return encryptCode.simplecode(Base64.decode(r));
        }

        _encryptCode.simbas = simbas;

        function getCodedId(id) {
          var re = "";
          var i = 1;
          id.toString().split("").forEach(x => {
            re += String.fromCharCode(parseInt(x) * i + 33);
            i++;
          });
          return re;
        }

        _encryptCode.getCodedId = getCodedId;

        function decodedId(codedId) {
          var re = "";

          for (let i = 0; i < codedId.length; i++) {
            re += ((codedId.charCodeAt(i) - 33) / (i + 1)).toString();
          }

          return parseInt(re);
        }

        _encryptCode.decodedId = decodedId;
      })(encryptCode || (encryptCode = exports('encryptCode', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SwitchMaterial.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Material, _decorator, Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Material = module.Material;
      _decorator = module._decorator;
      Component = module.Component;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b04d2ubeJ9JNr7qb7iN+GIJ", "SwitchMaterial", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SwitchMaterial = exports('default', (_dec = ccclass("SwitchMaterial"), _dec2 = property(Material), _dec(_class = (_class2 = (_temp = class SwitchMaterial extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "materials", _descriptor, this);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "materials", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ContainerVillage.ts", ['cc', './Container3d.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Container3d;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      Container3d = module.default;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "b065140nARB8a7GWTrI+oxf", "ContainerVillage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ContainerVillage = exports('default', (_dec = ccclass("ContainerVillage"), _dec(_class = class ContainerVillage extends Container3d {
        onLoad() {}

        initCamera() {
          super.initCamera();
        }

        initLight() {
          super.initLight();
          homeView.refreshHomeLight(); // eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "home", 2, 1);
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageAttackBtn.ts", ['cc', './Constant.ts', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Button, _decorator, MyCustomEvent, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Button = module.Button;
      _decorator = module._decorator;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "b0a3di3ZalLK7kTRtwvC39q", "VillageAttackBtn", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let VillageAttackBtn = exports('default', (_dec = ccclass("VillageAttackBtn"), _dec(_class = class VillageAttackBtn extends CCE_Component {
        setup(type) {
          let btn = this.getComponent(Button);
          btn.node.once("click", () => {
            eventCenter.emit(MyCustomEvent.VillageAttack, type);
          }, this);
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRJigsaw.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRJigsaw', void 0);

      cclegacy._RF.push({}, "b0b6aadEw5Guq+JA0j4dH3E", "SRJigsaw", undefined);

      let SRJigsaw;

      (function (_SRJigsaw) {
        function activityJigsawUse(ids) {
          let req = new GameKit.ServerRequest("activityJigsawUse");
          req.SetRequestBody("ids", ids);
          return req;
        }

        _SRJigsaw.activityJigsawUse = activityJigsawUse;

        function activityJigsawCollectReward() {
          let req = new GameKit.ServerRequest("activityJigsawCollectReward");
          return req;
        }

        _SRJigsaw.activityJigsawCollectReward = activityJigsawCollectReward;

        function activityJigsawSend(friend_user_id, index) {
          let req = new GameKit.ServerRequest("activityJigsawSend");
          req.SetRequestBody("friendUserId", friend_user_id);
          req.SetRequestBody("index", index);
          return req;
        }

        _SRJigsaw.activityJigsawSend = activityJigsawSend;

        function useUniversalJigsaw(index) {
          let req = new GameKit.ServerRequest("useUniversalJigsaw");
          req.SetRequestBody("index", index);
          return req;
        }

        _SRJigsaw.useUniversalJigsaw = useUniversalJigsaw;
      })(SRJigsaw || (SRJigsaw = exports('SRJigsaw', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SuperShieldOpenWindow.ts", ['cc', './global.ts', './UIWindow.ts', './ShopWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, G, UIWindow, ShopWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "b0e92cB8rFPbKc8htfSda+V", "SuperShieldOpenWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SuperShieldOpenWindow = exports('default', ccclass(_class = (_temp = _class2 = class SuperShieldOpenWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "childWindowChain", void 0);
        }

        onShow(showParams) {}

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        callGo() {
          if (this.childWindowChain) {
            this.clearOnCloseFunc();
            this.childWindowChain.end();
          }

          this.closeAnim();
          homeView.pageViewController.moveToPage(G.Pages.Shop, true);
          homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.shield);
        }

      }, _defineProperty(_class2, "windowPath", "Shop/SuperShieldOpenWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/QuestCheckPage.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './Content.ts', './TouchTest.ts', './SR.ts', './StaticGame.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Button, Label, SpriteFrame, _decorator, UITransform, Sprite, v3, director, CCE_Component, CCEaseTypes, Content, TouchTest, SR, Meta, GameKit, BigNumber, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Button = module.Button;
      Label = module.Label;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      UITransform = module.UITransform;
      Sprite = module.Sprite;
      v3 = module.v3;
      director = module.director;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      TouchTest = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b179czhhoxP9IoSMoOpR9Ry", "QuestCheckPage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        FAKE_DATA: false,
        // 是否使用伪数据用来测试界面，不与服务器交互
        MONTH_DAYS: 28,
        BAR_MIN: 50,
        BAR_MAX: 440
      };
      let QuestCheckPage = exports('QuestCheckPage', (_dec = property([Node]), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Button), _dec5 = property(Label), _dec6 = property(SpriteFrame), _dec7 = property(SpriteFrame), _dec8 = property(SpriteFrame), _dec9 = property(SpriteFrame), _dec10 = property(SpriteFrame), ccclass(_class = (_class2 = (_temp = class QuestCheckPage extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "month_box", _descriptor, this);

          _initializerDefineProperty(this, "month_pb", _descriptor2, this);

          _initializerDefineProperty(this, "week_box", _descriptor3, this);

          _initializerDefineProperty(this, "btn", _descriptor4, this);

          _initializerDefineProperty(this, "btn_string", _descriptor5, this);

          _initializerDefineProperty(this, "week_box_yellow", _descriptor6, this);

          _initializerDefineProperty(this, "week_box_green", _descriptor7, this);

          _initializerDefineProperty(this, "week_box_gray", _descriptor8, this);

          _initializerDefineProperty(this, "iconAP", _descriptor9, this);

          _initializerDefineProperty(this, "iconCoin", _descriptor10, this);

          _defineProperty(this, "questCenterWindow", void 0);

          _defineProperty(this, "data", null);
        }

        show() {
          this.get_data().then(v => {
            if (!this.node) return;
            this.node.active = true;
            this.update_page(v);
          }, e => {});
        }
        /** 获取check-page所依赖的数据 */


        get_data() {
          return new Promise((res, rej) => {
            // old_data
            if (this.data) {
              res(this.data);
              return;
            }

            {
              // real-data
              let sr = SR.SRSign.getSignData();
              sr.SetCallBack(v => {
                res(v.sign);
              });
              sr.SetErrorCallBack(() => {
                rej();
              });
              sr.Send();
            }
          });
        }
        /** 更新签到页面 */


        update_page(data) {
          this.data = data; // 界面修改
          // month

          const w = Math.min(C.BAR_MAX, C.BAR_MIN + (C.BAR_MAX - C.BAR_MIN) * data.signMonthDay / C.MONTH_DAYS);
          const h = this.month_pb.getComponent(UITransform).contentSize.height;
          this.month_pb.getComponent(UITransform).setContentSize(w, h);

          for (let i = 0; i < this.month_box.length; i += 1) {
            let btn = this.month_box[i].getComponent(Button);
            let light = GameKit.ControllerTable.GetNode(this.month_box[i], "light");
            let sp_box = GameKit.ControllerTable.GetNode(this.month_box[i], "sp-box").getComponent(Sprite);
            let quest_bubble = GameKit.ControllerTable.GetNode(this.month_box[i], "quest-bubble");
            let bubble_award = GameKit.ControllerTable.GetNode(this.month_box[i], "rewardNode");
            let reward1 = GameKit.ControllerTable.GetNode(this.month_box[i], "item1");
            let reward2 = GameKit.ControllerTable.GetNode(this.month_box[i], "item2");
            light.active = false;
            let days = 7 + i * 7;

            if (data.signMonthRewards.includes(days)) {
              // 已经领取
              btn.interactable = false; // sp_box.setState(1)

              quest_bubble.active = false;
            } else {
              // 还未领取
              let canreceive = data.signMonthDay >= days; // sp_box.setState(0)

              quest_bubble.active = true; // 可以领取，+抖动动画

              if (canreceive) {
                sp_box.node.runAction(ccAction.sequence(ccAction.moveBy(0.3, 0, 5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeOut, 2)), ccAction.moveBy(0.5, 0, -5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBounceOut)), ccAction.moveBy(0.3, 0, 5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeOut, 2)), ccAction.moveBy(0.5, 0, -5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBounceOut)), ccAction.delayTime(1)).repeatForever());
                light.active = true;
              }
            }

            let rewards = Meta.SignMeta.GetByTypeDay(Meta.SignMeta.Types.Month, days.toString()).Reward(); // reward1.show(rewards[0]);
            // reward2.show(rewards[1]);

            this.setRewardItem(reward1, rewards[0]);
            this.setRewardItem(reward2, rewards[1]);
            bubble_award.active = false;
          } // week


          for (let i = 0; i < this.week_box.length; i += 1) {
            let meta = Meta.SignMeta.GetByTypeDay(Meta.SignMeta.Types.Week, (i + 1).toString());
            let award_icon = GameKit.ControllerTable.GetNode(this.week_box[i], "award-icon").getComponent(Sprite);
            let award_value = GameKit.ControllerTable.GetNode(this.week_box[i], "award-value-string").getComponent(Label);
            let received = GameKit.ControllerTable.GetNode(this.week_box[i], "received");
            meta.Reward()[0].Icon(award_icon);
            award_value.string = BigNumber.format(meta.Reward()[0].Count());
            received.active = i < data.signWeekRewards; // 背景修改

            let box_sp = this.week_box[i].getComponent(Sprite);
            box_sp.setState(received.active ? 1 : 0);
            box_sp.spriteFrame = data.signWeekDay > data.signWeekRewards && i === data.signWeekRewards ? this.week_box_green : this.week_box_yellow;
          } // sign-btn


          this.btn.interactable = data.signWeekDay > data.signWeekRewards;
          this.btn_string.string = data.signWeekDay > data.signWeekRewards ? i18n.t("quest_center_window_check_do") : i18n.t("quest_center_window_check_done");
        }
        /** 点击事件：获取月签到奖励宝箱 */


        event_get_month_box_reward(e, days) {
          if (this.data.signMonthDay >= days) {
            new Promise((res, rej) => {
              // old-data，本地缓存变动
              this.data.signMonthRewards.push(days);
              {
                // real-data
                let sr = SR.SRSign.receiveSignMonthReward(Number.parseInt(days));
                sr.SetCallBack(v => {
                  res(v);
                });
                sr.SetErrorCallBack(() => {
                  rej();
                });
                sr.Send();
              }
            }).then(() => {
              // 界面变动
              e.target.getComponent(Button).interactable = false;
              GameKit.ControllerTable.GetNode(e.target, "sp-box").getComponent(Sprite).setState(1);
              GameKit.ControllerTable.GetNode(e.target, "quest-bubble").active = false;
              GameKit.ControllerTable.GetNode(e.target, "rewardNode").active = false; // 取消抖动动画

              GameKit.ControllerTable.GetNode(e.target, "sp-box").stopAllActions();
              GameKit.ControllerTable.GetNode(e.target, "light").active = false; // 更新红点
              // this.questCenterWindow.updateCheckRedDot();
              // UIRoot.instance.openChildWindow(GetRewardWindow, {
              //     contents: Meta.SignMeta.GetByTypeDay(Meta.SignMeta.Types.Month, days).Reward()
              // })
            }, e => {});
          } else {
            let reward = GameKit.ControllerTable.GetNode(e.target, "rewardNode");

            if (reward.active) {
              reward.active = false;
            } else {
              reward.active = true;
              reward.scale = v3(0.001, 0.001, 1);
              reward.stopAllActions();
              reward.runAction(ccAction.scaleTo(0.15, 1, 1));

              let touchStart = event => {
                const isInRect = TouchTest.isTouchInRect(event, reward);

                if (!isInRect && reward.active === true && event.target !== GameKit.ControllerTable.GetNode(e.target, "sp-box")) {
                  reward.active = false;
                  director.getScene().off(Node.EventType.TOUCH_START, touchStart, this, true);
                }
              };

              if (reward.active) {
                director.getScene().on(Node.EventType.TOUCH_START, touchStart, this, true);
              }
            }
          }
        }
        /** 点击事件：当前签到 */


        event_sign() {
          new Promise((res, rej) => {
            // old-data，本地缓存变动
            this.data.signWeekRewards += 1;
            {
              // real-data
              let sr = SR.SRSign.receiveSignWeekReward(this.data.signWeekDay);
              sr.SetCallBack(v => {
                res(v);
              });
              sr.SetErrorCallBack(() => {
                rej();
              });
              sr.Send();
            }
          }).then(() => {
            // 样式修改
            this.btn.interactable = false;
            this.btn_string.string = i18n.t("quest_center_window_check_done"); // received动画

            let n = GameKit.ControllerTable.GetNode(this.week_box[this.data.signWeekDay - 1], "received");
            n.active = true;
            n.scale = v3(0, 0, 1); // n.opacity = 0

            n.runAction(ccAction.sequence(ccAction.spawn(ccAction.scaleTo(0.5, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeExponentialOut)), // ccAction.fadeIn(0.5),
            ccAction.callFunc(() => {
              let box_sp = this.week_box[this.data.signWeekDay - 1].getComponent(Sprite); // box_sp.setState(1);

              box_sp.spriteFrame = this.week_box_gray;
            })), // ccAction.delayTime(0.5),
            ccAction.callFunc(() => {// UIRoot.instance.openChildWindow(GetRewardWindow, {
              //     contents: Meta.SignMeta.GetByTypeDay(Meta.SignMeta.Types.Week, this.data.signWeekDay).Reward()
              // })
            }))); //更新红点
            // this.questCenterWindow.updateCheckRedDot();

            this.get_data().then(v => {
              this.update_page(v);
            }, e => {});
          }, e => {});
        }

        setRewardItem(reward, content) {
          const icon = reward.getComponentInChildren(Sprite);
          const label = reward.getComponentInChildren(Label);

          if (content.type === Content.Types.Ap) {
            icon.spriteFrame = this.iconAP;
            icon.node.setScale(1, 1, 1);
          } else if (content.type = Content.Types.Coin) {
            icon.spriteFrame = this.iconCoin;
            icon.node.setScale(0.7, 0.7, 1);
          }

          label.string = "x" + BigNumber.format(content.count);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "month_box", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "month_pb", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "week_box", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btn", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btn_string", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "week_box_yellow", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "week_box_green", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "week_box_gray", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "iconAP", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "iconCoin", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonData.ts", ['cc', './global.ts', './SR.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, v2, misc, G, SR, Game, Meta, GameKit, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v2 = module.v2;
      misc = module.misc;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "b1b731gZrtLj5hLyaJsMWx7", "CannonData", undefined);
      /** 砸雪球数据适配器类 */


      class CannonData {
        /** @type {ActivityMeta} */

        /**
         * 载入数据
         * @param {ActivityMeta} meta
         */
        static load_data(meta) {
          this.activityMeta = meta;
        }
        /** 清理数据 */


        static clear_data() {
          this.activityMeta = null;
        }
        /** @returns {ActivityMeta} */


        static get_activity_meta() {
          return this.activityMeta;
        }
        /** @returns {number} */


        static get_activity_meta_id() {
          return this.activityMeta.Id();
        }
        /** @returns {string} */


        static get_activity_time_str() {
          let t = GameKit.TimeUtil.FormatRemainTimeSimple(this.activityMeta.EndTime() - GameKit.TimeUtil.getCurrentTime(), false);
          return `${i18n.t("ActivityTimeleft")} ${t}`;
        }
        /** @returns {string} */


        static get_refresh_time_str() {
          let t2 = GameKit.TimeUtil.FormatRemainTimeSimple((1 - (GameKit.TimeUtil.getCurrentTime() + GameKit.TimeUtil.TimeZoneInSecond) / GameKit.TimeUtil.DayInSecond * 2 % 1) * GameKit.TimeUtil.DayInSecond / 2, false);
          return `${i18n.t("cannon_main_window_refresh_time")}${t2}`;
        }
        /** @returns {number} */


        static get_ball_count() {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).ballCount;
        }
        /** @returns {number} */


        static get_ball_ad_get_count() {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).ballAdGetCount;
        }
        /** @returns {boolean} */


        static is_watch_ad_get_ball() {
          return this.get_ball_count() < 20 && this.get_ball_ad_get_count() < G.GameConstance.watchGetCannonBallMax;
        }
        /** @returns {number} */


        static get_refresh_count() {
          return Game.SUserItems.getNum(6);
        }
        /** @returns {number} */


        static get_magic_item_count() {
          return Game.SUserItems.getNum(7);
        }
        /** @returns {number} */


        static get_item_count(item_index) {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).itemCountList[item_index];
        }
        /** @returns {number[]} */


        static get_item_count_list() {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).itemCountList;
        }
        /** @returns {number} 实际返回值为0或者1 */


        static get_box(box_index) {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).boxList[box_index];
        }
        /** @returns {number[]} */


        static get_box_list() {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).boxList;
        }
        /** @returns {number} 获取box的剩余个数 */


        static get_box_count() {
          let count = 0;
          this.get_box_list().forEach(v => {
            if (v > 0) {
              count += 1;
            }
          });
          return count;
        }
        /** @returns {any[]} */


        static get_message_list() {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).messageList;
        }
        /**
         * 获取兑换的要求,返回需要的item的index数组
         * @param {number} index 0~4
         * @returns {number[]}
         */


        static get_exchange_source(index) {
          return [0, 1, 2, 3, 4, 5].slice(0, 2 + index);
        }
        /**
         * 获取兑换的奖励,返回奖励string
         * @param {number} index
         * @returns {string}
         */


        static get_exchange_reward(index) {
          return Meta.ActivityParamsMeta.GetValue("cannon", index + 1); // 注意id从1开始
        }
        /**
         * 是否拥有item
         * @param  {...number} item_index_list
         * @returns {boolean}
         */


        static has_item(...item_index_list) {
          return !item_index_list.some(v => this.get_item_count(v) <= 0);
        }
        /** 申请自动刷新 */


        static ask_refresh() {
          return new Promise(res => {
            let sr = SR.SRActivityCannon.activityCannonAskRefresh(Game.SUser.UserId(), this.get_activity_meta_id());
            sr.SetSilence(false);
            sr.SetCallBack(res);
            sr.Send();
          });
        }
        /** 使用一次刷新次数 */


        static use_refresh() {
          return new Promise(res => {
            let sr = SR.SRActivityCannon.activityCannonUseItemRefresh(Game.SUser.UserId(), this.get_activity_meta_id());
            sr.SetSilence(false);
            sr.SetCallBack(res);
            sr.Send();
          });
        }
        /** 使用一次球
         * @param {number} box_index
         */


        static use_ball(box_index) {
          return new Promise(res => {
            let sr = SR.SRActivityCannon.activityCannonShootBall(Game.SUser.UserId(), this.get_activity_meta_id(), box_index);
            sr.SetSilence(false);
            sr.SetCallBack(res);
            sr.Send();
          });
        }
        /**
         * 兑换奖励
         * @param {number} index
         */


        static exchange_reward(index) {
          return new Promise(res => {
            let sr = SR.SRActivityCannon.activityCannonGetReward(Game.SUser.UserId(), this.get_activity_meta_id(), index);
            sr.SetSilence(false);
            sr.SetCallBack(res);
            sr.Send();
          });
        }
        /**
         * 赠送item
         * @param {number} friendUserId
         * @param {number} itemId
         */


        static send_item(friendUserId, itemId) {
          return new Promise(res => {
            let sr = SR.SRActivityCannon.activityCannonSendItem(Game.SUser.UserId(), this.get_activity_meta_id(), friendUserId, itemId);
            sr.SetSilence(false);
            sr.SetCallBack(res);
            sr.Send();
          });
        }

      }

      exports('default', CannonData);

      _defineProperty(CannonData, "activityMeta", null);

      _defineProperty(CannonData, "BALL_POSITION_LENGTH_MIN", 40);

      _defineProperty(CannonData, "BALL_POSITION_LENGTH_MAX", 220);

      _defineProperty(CannonData, "BALL_POSITION_LENGTH_NO_ACTION", 60);

      _defineProperty(CannonData, "TARGET_POSITION_LENGTH_MIN", 0);

      _defineProperty(CannonData, "TARGET_POSITION_LENGTH_MAX", 600);

      _defineProperty(CannonData, "BALL_POSITION_V2_MIN", v2(0, -40).rotate(misc.degreesToRadians(-45)));

      _defineProperty(CannonData, "BALL_POSITION_V2_MAX", v2(0, -220).rotate(misc.degreesToRadians(45)));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NestPageView.ts", ['cc', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, PageView, Vec3, Event, math, EventTouch, Node, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      PageView = module.PageView;
      Vec3 = module.Vec3;
      Event = module.Event;
      math = module.math;
      EventTouch = module.EventTouch;
      Node = module.Node;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "b244dgVBFJIzLDAAn/v0xSO", "NestPageView", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NestPageView = exports('NestPageView', (_dec = ccclass("NestPageView"), _dec(_class = (_temp = class NestPageView extends PageView {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_moveDirection", -1);

          _defineProperty(this, "_deltaMove", new Vec3());
        }

        _hasNestedViewGroup(event, captureListeners) {
          if (event.eventPhase !== Event.CAPTURING_PHASE) return; // // if (event.type === "touch-cancel") return false;
          // let touch = event;
          // if (!touch) return;
          // let deltaMove = touch.getDelta();
          // if (deltaMove.x > 7 || deltaMove.x < -7) {
          // 	event.propagationStopped = true;
          // 	return false;
          // }
          // // if (captureListeners.map((v) => v.name).indexOf("PageView") && event.type === "touch-cancel" && event.currentTarget === this.node && event.simulate === false) {
          // // 	return true;
          // // }
          // if (captureListeners) {
          // 	//captureListeners are arranged from child to parent
          // 	for (let i = 0; i < captureListeners.length; ++i) {
          // 		let item = captureListeners[i];
          // 		if (this.node === item) {
          // 			if ((event.target as Node).getComponent(ViewGroup)) {
          // 				return true;
          // 			}
          // 			return false;
          // 		}
          // 		if (item.getComponent(ViewGroup)) {
          // 			return true;
          // 		}
          // 	}
          // }

          return false;
        }

        _onTouchMoved(event, captureListeners) {
          if (homeView.isBusy()) return;
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;

          if (event.target === this.node) {
            super._onTouchMoved(event, captureListeners);

            return;
          }

          let _tempVec2 = new math.Vec2();

          let _tempVec2_1 = new math.Vec2();

          let totalMovement = new Vec3();

          if (!this.enabledInHierarchy || !this._content) {
            return;
          }

          const touch = event.touch;
          /**
           * this._moveDirection  0是左右滑动，1是上下滑动
           * @左右滑动, pageView处理move事件,事件停止传递
           * @上下滑动, scrollView处理move事件，上层的pageView不做任何处理
           */
          // console.log("direction: ", this._moveDirection);

          if (this._moveDirection === 1) {
            return;
          } else if (this._moveDirection === 0) {
            if (!this.cancelInnerEvents) {
              return;
            }

            this._handleMoveLogic(touch);

            const deltaMove = touch.getUILocation(_tempVec2);
            deltaMove.subtract(touch.getUIPreviousLocation(_tempVec2_1));

            if (deltaMove.length() > 7) {
              if (!this._touchMoved && event.target !== this.node) {
                // Simulate touch cancel for target node
                const cancelEvent = new EventTouch(event.getTouches(), event.bubbles);
                cancelEvent.type = Node.EventType.TOUCH_CANCEL;
                cancelEvent.touch = event.touch;
                cancelEvent.simulate = true;
                event.target.dispatchEvent(cancelEvent);
                this._touchMoved = true;
              }
            }

            this._stopPropagationIfTargetIsMe(event);

            event.propagationStopped = true;
          }
          /**
           * 当pageView收到touchMove事件后，根据touch事件的移动距离判断出方向
           */


          if (this._moveDirection === -1) {
            this._deltaMove.set(this._getLocalAxisAlignDelta(touch));

            this._gatherTouchMove(this._deltaMove);

            totalMovement = this._touchMoveDisplacements.reduce((a, b) => {
              a.add(b);
              return a;
            }, totalMovement);

            if (Math.abs(totalMovement.x) > 0.1 && Math.abs(totalMovement.x) >= Math.abs(totalMovement.y)) {
              this._moveDirection = 0; // this._touchMoveDisplacements = [];
            } else if (Math.abs(totalMovement.y) > 0.1 && Math.abs(totalMovement.y) >= Math.abs(totalMovement.x)) {
              this._moveDirection = 1; // this._touchMoveDisplacements = [];
            } // console.log("direction after: ", this._moveDirection);

          }
        }

        _onTouchEnded(event, captureListeners) {
          if (homeView.isBusy()) return;
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;

          if (this._moveDirection !== 1) {
            super._onTouchEnded(event, captureListeners);
          }

          this._moveDirection = -1; // console.log('ended');
        }

        _onTouchCancelled(event, captureListeners) {
          if (homeView.isBusy()) return;
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;

          if (this._moveDirection !== 1) {
            super._onTouchCancelled(event, captureListeners);
          }

          this._moveDirection = -1; // console.log('cancelled');
        }

        getOffsetWhenTouchUp() {
          const moveOffset = new Vec3();
          Vec3.subtract(moveOffset, this._touchBeganPosition, this._touchEndPosition);
          return moveOffset;
        }

        isScrollable(offset, index, nextIndex) {
          return this._isScrollable(offset, index, nextIndex);
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/EnterCloseAnim.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './CCTools.ts'], function (exports) {
  'use strict';

  var cclegacy, Enum, CCFloat, _decorator, v2, UIOpacity, UITransform, Sprite, Color, tween, v3, CCE_Component, CCEaseTypes, CCTools;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
      CCFloat = module.CCFloat;
      _decorator = module._decorator;
      v2 = module.v2;
      UIOpacity = module.UIOpacity;
      UITransform = module.UITransform;
      Sprite = module.Sprite;
      Color = module.Color;
      tween = module.tween;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      CCTools = module.CCTools;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _dec27, _dec28, _dec29, _dec30, _dec31, _dec32, _dec33, _dec34, _dec35, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _descriptor26, _descriptor27, _descriptor28, _descriptor29, _descriptor30, _descriptor31, _descriptor32, _descriptor33, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b39feMygshF7buVdkVrY77v", "EnterCloseAnim", undefined);

      var AnimType;

      (function (AnimType) {
        AnimType[AnimType["Disable"] = 0] = "Disable";
        AnimType[AnimType["Alpha"] = 1] = "Alpha";
        AnimType[AnimType["Scale"] = 2] = "Scale";
        AnimType[AnimType["Pos"] = 3] = "Pos";
        AnimType[AnimType["Size"] = 4] = "Size";
        AnimType[AnimType["Fill"] = 5] = "Fill";
        AnimType[AnimType["Rotation"] = 6] = "Rotation";
        AnimType[AnimType["ScaleAlpha"] = 21] = "ScaleAlpha";
        AnimType[AnimType["PosAlpha"] = 31] = "PosAlpha";
        AnimType[AnimType["PosScale"] = 32] = "PosScale";
        AnimType[AnimType["PosScaleAlpha"] = 321] = "PosScaleAlpha";
        AnimType[AnimType["SizeAlpha"] = 41] = "SizeAlpha";
        AnimType[AnimType["SizeScale"] = 42] = "SizeScale";
        AnimType[AnimType["SizePos"] = 43] = "SizePos";
        AnimType[AnimType["RotationAlpha"] = 61] = "RotationAlpha";
        AnimType[AnimType["RotationScale"] = 62] = "RotationScale";
        AnimType[AnimType["RotationPos"] = 63] = "RotationPos";
        AnimType[AnimType["CenterDiffuce"] = 1001] = "CenterDiffuce";
        AnimType[AnimType["angle"] = 1002] = "angle";
      })(AnimType || (AnimType = {}));

      const {
        ccclass,
        property,
        executionOrder,
        inspector
      } = _decorator;
      let EnterCloseAnim = exports('default', (_dec = executionOrder(-1), _dec2 = inspector("packages://entercloseanim/inspector.js"), _dec3 = property({
        animatable: false,
        displayName: "Enter Anim Type",
        tooltip: CC_DEV && "动画类型",
        type: Enum(AnimType)
      }), _dec4 = property({
        displayName: "Play Awake",
        tooltip: CC_DEV && "是否自动播放进入动画"
      }), _dec5 = property({
        type: CCFloat,
        displayName: "Anim Time",
        tooltip: CC_DEV && "动画播放时间"
      }), _dec6 = property({
        displayName: "Delay Time",
        tooltip: CC_DEV && "动画延迟时间"
      }), _dec7 = property({
        displayName: "Ease Type",
        animatable: false,
        tooltip: CC_DEV && "缓动类型",
        type: Enum(CCEaseTypes.Types)
      }), _dec8 = property({
        type: CCFloat,
        displayName: "Ease Rate",
        tooltip: CC_DEV && "部分ease类型需要参数 详细参考api文档"
      }), _dec9 = property({
        displayName: "Bezier p0",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p0"
      }), _dec10 = property({
        displayName: "Bezier p1",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p1"
      }), _dec11 = property({
        displayName: "Bezier p2",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p2"
      }), _dec12 = property({
        displayName: "Bezier p3",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p3"
      }), _dec13 = property({
        range: [0, 255, 1],
        slide: true,
        displayName: "Alpha From",
        tooltip: CC_DEV && "透明动画起始透明度（0-255）"
      }), _dec14 = property({
        displayName: "Scale From",
        tooltip: CC_DEV && "缩放动画起始缩放值"
      }), _dec15 = property({
        displayName: "DX",
        tooltip: CC_DEV && "位移动画起始相对坐标x"
      }), _dec16 = property({
        displayName: "DY",
        tooltip: CC_DEV && "位移动画起始相对坐标y"
      }), _dec17 = property({
        displayName: "Width From",
        tooltip: CC_DEV && "尺寸动画起始宽度"
      }), _dec18 = property({
        displayName: "Height From",
        tooltip: CC_DEV && "尺寸动画起始高度"
      }), _dec19 = property({
        displayName: "Rotation From",
        tooltip: CC_DEV && "旋转动画起始相对角度"
      }), _dec20 = property({
        animatable: false,
        displayName: "Close Anim Type",
        tooltip: CC_DEV && "动画类型",
        type: Enum(AnimType)
      }), _dec21 = property({
        displayName: "Anim Time",
        tooltip: CC_DEV && "动画播放时间"
      }), _dec22 = property({
        displayName: "Delay Time",
        tooltip: CC_DEV && "动画延迟时间"
      }), _dec23 = property({
        displayName: "Ease Type",
        animatable: false,
        tooltip: CC_DEV && "缓动类型",
        type: Enum(CCEaseTypes.Types)
      }), _dec24 = property({
        displayName: "Ease Rate",
        tooltip: CC_DEV && "部分ease类型需要参数 详细参考api文档"
      }), _dec25 = property({
        displayName: "Bezier p0",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p0"
      }), _dec26 = property({
        displayName: "Bezier p1",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p1"
      }), _dec27 = property({
        displayName: "Bezier p2",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p2"
      }), _dec28 = property({
        displayName: "Bezier p3",
        tooltip: CC_DEV && "贝塞尔曲线缓动坐标p3"
      }), _dec29 = property({
        range: [0, 255, 1],
        slide: true,
        displayName: "Alpha To",
        tooltip: CC_DEV && "透明动画目标透明度（0-255）"
      }), _dec30 = property({
        displayName: "Scale To",
        tooltip: CC_DEV && "缩放动画目标缩放值"
      }), _dec31 = property({
        displayName: "DX",
        tooltip: CC_DEV && "位移动画目标相对坐标x"
      }), _dec32 = property({
        displayName: "DY",
        tooltip: CC_DEV && "位移动画目标相对坐标y"
      }), _dec33 = property({
        displayName: "Width To",
        tooltip: CC_DEV && "尺寸动画目标宽度"
      }), _dec34 = property({
        displayName: "Height To",
        tooltip: CC_DEV && "尺寸动画目标高度"
      }), _dec35 = property({
        displayName: "Rotation To",
        tooltip: CC_DEV && "旋转动画目标相对角度"
      }), ccclass(_class = _dec(_class = _dec2(_class = (_class2 = (_temp = class EnterCloseAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "enterAnimType", _descriptor, this);

          _initializerDefineProperty(this, "e_playAwake", _descriptor2, this);

          _initializerDefineProperty(this, "e_AnimTime", _descriptor3, this);

          _initializerDefineProperty(this, "e_DelayTime", _descriptor4, this);

          _initializerDefineProperty(this, "e_easeType", _descriptor5, this);

          _initializerDefineProperty(this, "e_easeRate", _descriptor6, this);

          _initializerDefineProperty(this, "e_easeBezierP0", _descriptor7, this);

          _initializerDefineProperty(this, "e_easeBezierP1", _descriptor8, this);

          _initializerDefineProperty(this, "e_easeBezierP2", _descriptor9, this);

          _initializerDefineProperty(this, "e_easeBezierP3", _descriptor10, this);

          _initializerDefineProperty(this, "e_alpha", _descriptor11, this);

          _initializerDefineProperty(this, "e_scale", _descriptor12, this);

          _initializerDefineProperty(this, "e_dx", _descriptor13, this);

          _initializerDefineProperty(this, "e_dy", _descriptor14, this);

          _initializerDefineProperty(this, "e_width", _descriptor15, this);

          _initializerDefineProperty(this, "e_height", _descriptor16, this);

          _initializerDefineProperty(this, "e_rotAngle", _descriptor17, this);

          _initializerDefineProperty(this, "closeAnimType", _descriptor18, this);

          _initializerDefineProperty(this, "c_AnimTime", _descriptor19, this);

          _initializerDefineProperty(this, "c_DelayTime", _descriptor20, this);

          _initializerDefineProperty(this, "c_easeType", _descriptor21, this);

          _initializerDefineProperty(this, "c_easeRate", _descriptor22, this);

          _initializerDefineProperty(this, "c_easeBezierP0", _descriptor23, this);

          _initializerDefineProperty(this, "c_easeBezierP1", _descriptor24, this);

          _initializerDefineProperty(this, "c_easeBezierP2", _descriptor25, this);

          _initializerDefineProperty(this, "c_easeBezierP3", _descriptor26, this);

          _initializerDefineProperty(this, "c_alpha", _descriptor27, this);

          _initializerDefineProperty(this, "c_scale", _descriptor28, this);

          _initializerDefineProperty(this, "c_dx", _descriptor29, this);

          _initializerDefineProperty(this, "c_dy", _descriptor30, this);

          _initializerDefineProperty(this, "c_width", _descriptor31, this);

          _initializerDefineProperty(this, "c_height", _descriptor32, this);

          _initializerDefineProperty(this, "c_rotAngle", _descriptor33, this);

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "st_opacity", void 0);

          _defineProperty(this, "st_scaleX", void 0);

          _defineProperty(this, "st_scaleY", void 0);

          _defineProperty(this, "st_x", void 0);

          _defineProperty(this, "st_y", void 0);

          _defineProperty(this, "st_width", void 0);

          _defineProperty(this, "st_height", void 0);

          _defineProperty(this, "st_rotation", void 0);
        }

        static playEnter(node, callBack) {
          if (!node) return;
          node.getComponentsInChildren(EnterCloseAnim).forEach(x2 => {
            if (x2.enabled && x2.node.active) {
              x2.enterAnim(callBack);
            }
          });
        }

        static playEnterImmediately(node) {
          if (!node) return;
          CCTools.WidgetsUpdateAlignment(node);
          node.getComponentsInChildren(EnterCloseAnim).forEach(x2 => {
            if (x2.enabled && x2.node.active) {
              x2.init();
              let _t = x2.e_AnimTime;
              let _d = x2.e_DelayTime;
              x2.e_AnimTime = 0.001;
              x2.e_DelayTime = 0; //x2.enterAnim()

              let action = x2._enterAnim();

              x2.node.runAction(action); // action.step(0.0009);

              x2.e_AnimTime = _t;
              x2.e_DelayTime = _d;
            }
          }); //cc.director.getActionManager().update(0.001)
        }

        static playClose(node) {
          if (!node) return;
          node.getComponentsInChildren(EnterCloseAnim).forEach(x2 => {
            if (x2.enabled && x2.node.active) {
              x2.closeAnim();
            }
          });
        }

        static playCloseImmediately(node) {
          if (!node) return;
          CCTools.WidgetsUpdateAlignment(node);
          node.getComponentsInChildren(EnterCloseAnim).forEach(x2 => {
            if (x2.enabled && x2.node.active) {
              x2.init();
              let _t = x2.c_AnimTime;
              let _d = x2.c_DelayTime;
              x2.c_AnimTime = 0.001;
              x2.c_DelayTime = 0; //x2.closeAnim()

              let action = x2._closeAnim();

              x2.node.runAction(action); // action.step(0.0009)

              x2.c_AnimTime = _t;
              x2.c_DelayTime = _d;
            }
          });
        } //cc.director.getActionManager().update(0.0001)


        onLoad() {
          if (!this.enabled) return;
          this.init();
        }

        init() {
          if (this.inited) return;
          CCTools.WidgetsUpdateAlignment(this.node);
          this.st_opacity = this.node.getComponent(UIOpacity).opacity;
          this.st_scaleX = this.node.scale.x;
          this.st_scaleY = this.node.scale.y;
          this.st_x = this.node.position.x;
          this.st_y = this.node.position.y;
          this.st_width = this.node.getComponent(UITransform).width;
          this.st_height = this.node.getComponent(UITransform).height;
          this.st_rotation = this.node.angle;

          if (this.e_playAwake) {
            this.enterAnim();
          }

          this.inited = true;
        }

        start() {}

        enterAnim(callback) {
          if (!this.node || !this.node.isValid) return;
          this.node.stopAllActions();

          let action = this._enterAnim();

          if (action == null) {
            if (callback != null) callback();
            return;
          }

          if (callback != null) action = ccAction.sequence(action, ccAction.callFunc(function () {
            callback();
          }));
          this.node.runAction(action);
        }

        _enterAnim() {
          let list = [];
          let typeid = this.enterAnimType;

          if (typeid < 1000) {
            do {
              let type1 = typeid % 10;

              switch (type1) {
                case AnimType.Alpha:
                  this.node.getComponent(UIOpacity).opacity = this.st_opacity;
                  let st_opacity = this.node.getComponent(UIOpacity).opacity;
                  this.node.getComponent(UIOpacity).opacity = this.e_alpha;
                  list.push(this.getDelayAnim(this.e_DelayTime, ccAction.fadeTo(this.e_AnimTime, st_opacity, this.getEnterEasing())));
                  break;

                case AnimType.Scale:
                  this.node.scale = v3(this.st_scaleX, this.st_scaleY, 1);
                  let st_scaleX = this.node.scale.x;
                  let st_scaleY = this.node.scale.y;
                  let scaleX = this.e_scale.x === 0 ? 0.001 : this.e_scale.x;
                  let scaleY = this.e_scale.y === 0 ? 0.001 : this.e_scale.y;
                  this.node.scale = v3(scaleX, scaleY, 1);
                  list.push(this.getDelayAnim(this.e_DelayTime, ccAction.scaleTo(this.e_AnimTime, st_scaleX, st_scaleY, this.getEnterEasing())));
                  break;

                case AnimType.Pos:
                  this.node.setPosition(v3(this.st_x, this.st_y));
                  let st_x = this.node.x;
                  let st_y = this.node.y;
                  this.node.setPosition(v3(st_x + this.e_dx, st_y + this.e_dy));
                  list.push(this.getDelayAnim(this.e_DelayTime, ccAction.moveTo(this.e_AnimTime, st_x, st_y, this.getEnterEasing())));
                  break;

                case AnimType.Size:
                  this.node.getComponent(UITransform).width = this.st_width;
                  this.node.getComponent(UITransform).height = this.st_height;
                  let st_width = this.node.getComponent(UITransform).width;
                  let st_height = this.node.getComponent(UITransform).height;
                  this.node.getComponent(UITransform).width = this.e_width;
                  this.node.getComponent(UITransform).height = this.e_height;
                  list.push(this.getDelayAnim(this.e_DelayTime, tween(this.node.getComponent(UITransform)).to(this.e_AnimTime, {
                    width: st_width,
                    height: st_height
                  }, {
                    easing: this.getEnterEasing()
                  })));
                  break;

                case AnimType.Fill:
                  let sprite = this.node.getComponent(Sprite);

                  if (!!sprite) {
                    sprite.fillRange = 0;
                    sprite.color = new Color(sprite.color.r, sprite.color.g, sprite.color.b, 0);
                  }

                  list.push(this.getDelayAnim(this.e_DelayTime, tween().to(this.e_AnimTime, {
                    opacity: 255
                  }, {
                    easing: this.getEnterEasing()
                  })));
                  break;

                case AnimType.angle:
                  this.node.angle = this.st_rotation;
                  let st_rotation = this.node.angle;
                  this.node.angle += this.c_rotAngle;
                  list.push(this.getDelayAnim(this.e_DelayTime, ccAction.rotateBy(this.e_AnimTime, -this.c_rotAngle, this.getEnterEasing())));
                  break;
              }

              typeid = Math.floor(typeid / 10);
            } while (typeid > 0);
          } else {
            switch (this.enterAnimType) {
              case AnimType.CenterDiffuce:
                this.node.setPosition(v3(this.st_x, this.st_y));
                let st_x = this.node.position.x;
                let st_y = this.node.position.y;
                this.node.setPosition(v3(0, 0));
                list.push(this.getDelayAnim(this.e_DelayTime, ccAction.moveTo(this.e_AnimTime, st_x, st_y, this.getEnterEasing())));
                break;
            }
          }

          if (list.length < 2) return list[0];
          return ccAction.spawn(...list);
        }

        closeAnim(callback) {
          if (!this.node || !this.node.isValid) return;
          this.node.stopAllActions();

          let action = this._closeAnim();

          if (action == null) {
            if (callback != null) callback();
            return;
          }

          if (callback != null) action = ccAction.sequence(action, ccAction.callFunc(function () {
            callback();
          }, this));
          this.node.runAction(action);
        }

        _closeAnim() {
          let list = [];
          let typeid = this.closeAnimType;

          if (typeid < 1000) {
            do {
              let type1 = typeid % 10;

              switch (type1) {
                case AnimType.Alpha:
                  list.push(this.getDelayAnim(this.c_DelayTime, ccAction.fadeTo(this.c_AnimTime, this.c_alpha, this.getCloseEasing())));
                  break;

                case AnimType.Scale:
                  list.push(this.getDelayAnim(this.c_DelayTime, ccAction.scaleTo(this.c_AnimTime, this.c_scale.x === 0 ? 0.001 : this.c_scale.x, this.c_scale.y === 0 ? 0.001 : this.c_scale.y, this.getCloseEasing())));
                  break;

                case AnimType.Pos:
                  list.push(this.getDelayAnim(this.c_DelayTime, ccAction.moveBy(this.c_AnimTime, this.c_dx, this.c_dy, this.getCloseEasing())));
                  break;

                case AnimType.Size:
                  list.push(this.getDelayAnim(this.c_DelayTime, tween().to(this.c_AnimTime, {
                    width: this.c_width,
                    height: this.c_height
                  }, {
                    easing: this.getCloseEasing()
                  })));
                  break;

                case AnimType.Fill:
                  list.push(this.getDelayAnim(this.c_DelayTime, tween().to(this.c_AnimTime, {
                    opacity: 0
                  }, {
                    easing: this.getCloseEasing()
                  })));
                  break;

                case AnimType.angle:
                  list.push(this.getDelayAnim(this.c_DelayTime, ccAction.rotateBy(this.c_AnimTime, this.c_rotAngle, this.getCloseEasing())));
                  break;
              }

              typeid = Math.floor(typeid / 10);
            } while (typeid > 0);
          } else {
            switch (this.closeAnimType) {
              case AnimType.CenterDiffuce:
                list.push(this.getDelayAnim(this.c_DelayTime, ccAction.moveTo(this.c_AnimTime, 0, 0, this.getCloseEasing())));
                break;
            }
          }

          if (list.length < 2) return list[0];
          return ccAction.spawn(...list);
        }

        getDelayAnim(DelayTime, action) {
          if (DelayTime === 0) return action;
          return ccAction.sequence(ccAction.delayTime(DelayTime), action);
        }

        getEnterEasing() {
          return CCEaseTypes.GetEasing(this.e_easeType, this.e_easeRate, this.e_easeBezierP0, this.e_easeBezierP1, this.e_easeBezierP2, this.e_easeBezierP3);
        }

        getCloseEasing() {
          return CCEaseTypes.GetEasing(this.c_easeType, this.c_easeRate, this.c_easeBezierP0, this.c_easeBezierP1, this.c_easeBezierP2, this.c_easeBezierP3);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "enterAnimType", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "e_playAwake", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "e_AnimTime", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0.3;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "e_DelayTime", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "e_easeType", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return CCEaseTypes.Types.linear;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "e_easeRate", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "e_easeBezierP0", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "e_easeBezierP1", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "e_easeBezierP2", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "e_easeBezierP3", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "e_alpha", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "e_scale", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "e_dx", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "e_dy", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "e_width", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "e_height", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "e_rotAngle", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "closeAnimType", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return AnimType.Disable;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "c_AnimTime", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0.3;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "c_DelayTime", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "c_easeType", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return CCEaseTypes.Types.linear;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class2.prototype, "c_easeRate", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class2.prototype, "c_easeBezierP0", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class2.prototype, "c_easeBezierP1", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class2.prototype, "c_easeBezierP2", [_dec27], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor26 = _applyDecoratedDescriptor(_class2.prototype, "c_easeBezierP3", [_dec28], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor27 = _applyDecoratedDescriptor(_class2.prototype, "c_alpha", [_dec29], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor28 = _applyDecoratedDescriptor(_class2.prototype, "c_scale", [_dec30], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return v2(0, 0);
        }
      }), _descriptor29 = _applyDecoratedDescriptor(_class2.prototype, "c_dx", [_dec31], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor30 = _applyDecoratedDescriptor(_class2.prototype, "c_dy", [_dec32], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor31 = _applyDecoratedDescriptor(_class2.prototype, "c_width", [_dec33], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor32 = _applyDecoratedDescriptor(_class2.prototype, "c_height", [_dec34], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor33 = _applyDecoratedDescriptor(_class2.prototype, "c_rotAngle", [_dec35], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotNode.ts", ['cc', './Constant.ts', './CCE_Component.ts', './CCEaseTypes.ts', './ShieldAnim.ts', './global.ts', './Logs.ts', './EnterCloseAnim.ts', './SoundManager.ts', './CommonAssets.ts', './UserInfoModel.ts', './RoomManager.ts', './Player.ts', './SlotActivityNode.ts', './TutorialManager.ts', './CoinAnim.ts', './RaidAnim.ts', './ShieldBreakAnim.ts', './SpinAnim.ts', './SlotPeter.ts', './GameMainWindow.ts', './SR.ts', './SlotResultHandler.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Sprite, Node, _decorator, UITransform, Widget, Vec3, v3, MyCustomEvent, TutorilaEvent, SlotTypes, LoadEvent, CCE_Component, CCEaseTypes, ShieldAnim, G, Logs, EnterCloseAnim, SoundManager, CommonAssets, UserInfoModel, RoomManager, Player, SlotActivityNode, TutorialManager, CoinAnim, RaidAnim, ShieldBreakAnim, SpinAnim, SlotPeter, GameMainWindow, SR, SlotResultHandler, UIRoot, ActivityManager, Game, LogEventWrap, GameKit, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Sprite = module.Sprite;
      Node = module.Node;
      _decorator = module._decorator;
      UITransform = module.UITransform;
      Widget = module.Widget;
      Vec3 = module.Vec3;
      v3 = module.v3;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      TutorilaEvent = module.TutorilaEvent;
      SlotTypes = module.SlotTypes;
      LoadEvent = module.LoadEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      ShieldAnim = module.default;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      Player = module.default;
    }, function (module) {
      SlotActivityNode = module.default;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      CoinAnim = module.default;
    }, function (module) {
      RaidAnim = module.default;
    }, function (module) {
      ShieldBreakAnim = module.default;
    }, function (module) {
      SpinAnim = module.default;
    }, function (module) {
      SlotPeter = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      SlotResultHandler = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b5321FycHxKdZaOXfnotJNd", "SlotNode", undefined);

      var allBetNums = [1, 2, 3, 5, 10, 20, 40, 60];
      const {
        ccclass,
        property
      } = _decorator;
      let SlotNode = exports('default', (_dec = property(Label), _dec2 = property(RaidAnim), _dec3 = property(Sprite), _dec4 = property(SpinAnim), _dec5 = property([CoinAnim]), _dec6 = property([ShieldAnim]), _dec7 = property([ShieldBreakAnim]), _dec8 = property(Node), _dec9 = property(SlotActivityNode), _dec10 = property(SlotPeter), ccclass(_class = (_class2 = (_temp = class SlotNode extends CCE_Component {
        // slotCols: SlotColNode[];
        // toRaidUserNode: ToRaidUserNode;
        constructor() {
          super();

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "index1", void 0);

          _defineProperty(this, "index2", void 0);

          _defineProperty(this, "index3", void 0);

          _defineProperty(this, "atenType1", void 0);

          _defineProperty(this, "atenType2", void 0);

          _defineProperty(this, "atenType3", void 0);

          _defineProperty(this, "isSpining", void 0);

          _defineProperty(this, "hasSkin", void 0);

          _defineProperty(this, "skin", void 0);

          _defineProperty(this, "betNum", void 0);

          _defineProperty(this, "spinResult", void 0);

          _defineProperty(this, "oldCoin", void 0);

          _defineProperty(this, "dis2top", void 0);

          _defineProperty(this, "userinfo", void 0);

          _defineProperty(this, "useSymbol", void 0);

          _defineProperty(this, "symbolId", void 0);

          _defineProperty(this, "betMax", void 0);

          _defineProperty(this, "IbetMaxTip", void 0);

          _defineProperty(this, "isRewardTextShowing", void 0);

          _defineProperty(this, "oldShieldNum", void 0);

          _defineProperty(this, "oldAp", void 0);

          _defineProperty(this, "arIntLoad", void 0);

          _defineProperty(this, "slot", void 0);

          _defineProperty(this, "spinCallback", void 0);

          _defineProperty(this, "betBtnCallback", void 0);

          _initializerDefineProperty(this, "rewardText", _descriptor, this);

          _initializerDefineProperty(this, "raidAnim", _descriptor2, this);

          _initializerDefineProperty(this, "raidAnimSprite", _descriptor3, this);

          _initializerDefineProperty(this, "spinAnim", _descriptor4, this);

          _initializerDefineProperty(this, "coinAnims", _descriptor5, this);

          _initializerDefineProperty(this, "shieldAnims", _descriptor6, this);

          _initializerDefineProperty(this, "shieldBreakAnims", _descriptor7, this);

          _initializerDefineProperty(this, "spinAddNumAnim", _descriptor8, this);

          _initializerDefineProperty(this, "activityRoot", _descriptor9, this);

          _initializerDefineProperty(this, "slotPeter", _descriptor10, this);

          _defineProperty(this, "villageAttackedLoaded", false);

          this.inited = false;
          this.index1 = 0;
          this.index2 = 0;
          this.index3 = 0;
          this.atenType1 = 0;
          this.atenType2 = 0;
          this.atenType3 = 0;
          this.isSpining = false;
          this.hasSkin = false;
          this.skin = null;
          this.betNum = 0;
          this.spinResult = null;
          this.oldCoin = 0;
          this.dis2top = 0;
        }

        onLoad() {
          this.node.getComponent(UITransform).height = UIRoot.instance.winSize.height; // 计算动画节点距离顶部UI的距离

          let ssize = UIRoot.instance.winSize;
          this.dis2top = ssize.height / 2 + 34;

          if (ssize.height / ssize.width > 1250 / 640) {
            this.dis2top -= 44;
          }

          this.node.slotNode = this; // this.initSlot();
          // this.servantNode.Show();

          this.slotPeter.init();
          this.updatePeterPosition();
          this.rewardText.node.active = false;
          this.node.getComponent(Widget).top += AppMain.instance.statusBarHeight;
        }

        init() {
          this.userinfo = this.getComponent(UserInfoModel);
          this.userinfo.show(Game.SUser);
          homeView.pageViewController.setBet();
          var scmeta = ActivityManager.GetActiveSlotCollectActivity();

          if (scmeta) {
            this.useSymbol = true;
            this.symbolId = scmeta.Param().symbolId; // for (var i = 0; i < 3; i++) {
            // 	let sp = CommonAssets.instance.getByAtlas(CommonAssets.Atlases.SlotSymbol, this.symbolId.toString());
            // 	this.slotCols[i].setSymbol(sp);
            // }
          }

          this.activityRoot.collectRankScore = null;
          this.activityRoot.showActivity(); // 倍率设置

          this.betNum = GameKit.PlayerPrefs.GetInt("SlotBetNum", 1);

          if (this.betNum > this.betMax) {
            this.betNum = allBetNums[0];
          }

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            this.betNum = allBetNums[0];
          } // ToRaidUserNode的位置
          // let toRaidUserNew = this.toRaidUser.node;
          // //toRaidUserNew.parent = this.skin.getToRaidUserHolder()
          // //toRaidUserNew.y = 0
          // //this.toRaidUser.node.active = false
          // this.toRaidUserNode = toRaidUserNew.getComponent(ToRaidUserNode);
          // let user = new User();
          // user.updateData(Game.SUserSlot.ToraidUser());
          // this.toRaidUserNode.initBetValue(this.betNum);
          // this.toRaidUserNode.getComponent(UserInfoModel).show(user);
          // toRaidUserNew.active = true;

        }

        onDestroy() {
          if (this.IbetMaxTip) {
            clearInterval(this.IbetMaxTip);
            this.IbetMaxTip = null;
          }
        }

        Clear() {
          this.node.slotNode = null;
          this.raidAnim.stop();
          this.spinAnim.stop();

          for (let i = 0; i < this.coinAnims.length; i++) {
            this.coinAnims[i].stop();
          }

          for (let i = 0; i < this.shieldAnims.length; i++) {
            this.shieldAnims[i].stop();
          }

          for (let i = 0; i < this.shieldBreakAnims.length; i++) {
            this.shieldBreakAnims[i].stop();
          }

          this.reset();
          this.useSymbol = false; // for (var i = 0; i < 3; i++) {
          // 	this.slotCols[i].changeSprite();
          // 	this.slotCols[i].setSymbol();
          // }
          // this.raidAnimSprite.spriteFrame = null;

          this.activityRoot.hideAll();

          if (this.userinfo) {
            this.userinfo.onClose();
            this.userinfo = null;
          }

          GameKit.WebEvent.UnRegisterEvent(GameKit.WebEvent.EventName.ToraidEvent, "SlotNode");
          this.spinResult = null;
        }

        reset() {
          this.isSpining = false;
        } // initSlot() {
        // 	if (this.inited == false) {
        // 		this.slotCols = new Array(3);
        // 		var parent = this.slotColTemp.node.parent;
        // 		for (var i = 0; i < 3; i++) {
        // 			if (i == 0) {
        // 				this.slotCols[i] = this.slotColTemp;
        // 			} else {
        // 				var newNode = cc.instantiate(this.slotColTemp.node);
        // 				newNode.parent = parent;
        // 				this.slotCols[i] = newNode.getComponent(SlotColNode);
        // 			}
        // 			this.slotCols[i].node.setPosition(cc.v3(150 * (i - 1), 0));
        // 			this.slotCols[i].slot = this;
        // 		}
        // 		for (var i = 0; i < 3; i++) {
        // 			(this.slotCols[i] as SlotColNode).initCol();
        // 		}
        // 		this.inited = true;
        // 		//this.showNormalSpinBtn()
        // 		this.showHoldSpinBtn();
        // 	}
        // }
        // 返回状态，是否正在运行


        isRunning() {
          if (this.activityRoot.isAnim()) return true;
          return this.isSpining;
        } // 切换到待机状态


        makeIdle() {
          this.isSpining = false;
        }

        idle() {
          this.makeIdle();
          this.spinResult = null;
        } // Slot是否可以Spin，仅动画状态，不检查体力数量


        canSpin() {
          return !this.isRunning();
        }

        setPromise() {
          let promise1 = new Promise((resolve, reject) => {
            eventCenter.once(MyCustomEvent.OnSlotResult, () => {
              resolve(null);
            });
          });
          let promise2 = new Promise((resolve, reject) => {
            eventCenter.once(MyCustomEvent.PlayerRunEnd, () => {
              resolve(null);
            });
          });
          Promise.all([promise1, promise2]).then(async () => {
            await this.handleSlotResult();
            RoomManager.instance.curRoom.playRewardCollectAnim();
          });
        } // Slot Spin


        spin() {
          if (this.isSpining) return;
          if (!CommonAssets.instance.rewardLoaded) return;
          this.isSpining = true;
          Player.instance.startMove();
          this.setPromise();
          this.hideRewardText();
          Logs.Debug("Spin");
          SoundManager.playSound("slot_button");
          this.oldCoin = Game.SUser.Coin();
          this.oldShieldNum = Game.SUser.RawShield();
          this.oldAp = Game.SUser.Ap() - this.betNum; // SoundManager.playSound("slot_spin_loop", true);
          //tutorial

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            eventCenter.emit(TutorilaEvent.SpinStarted);
            SlotResultHandler.handleTutorial();
            return;
          }

          let req = SR.SRSlot.slotPlay(this.betNum);
          req.SetCallBack(res => {
            this.spinOk1(res);
            this.scheduleOnce(() => {
              this.spinOk2(res);
            }, 0.1);
            if (GameMainWindow.instance) homeView.slotPage.updateSpinAd();
          });
          req.SetErrorCallBack(res => {
            this.scheduleOnce(() => {
              this.reset(); // SoundManager.stopSound("slot_spin_loop");
            }, 0.5);
          });
          req.SetNetErrorCallBack(res => {
            this.scheduleOnce(() => {
              this.reset(); // SoundManager.stopSound("slot_spin_loop");
            }, 0.5);
          });
          req.Send();
        }

        spinOk1(res) {
          this.spinResult = res.slotResult;
          eventCenter.emit(MyCustomEvent.OnSlotResult, this.spinResult.type); // Player.instance.startMove(this.spinResult.type);

          if (this.spinResult.type !== SlotTypes.Spins) {
            eventCenter.emit(MyCustomEvent.CanChangeSpin);
          }

          if (this.spinResult.type === SlotTypes.Attack) {
            console.log(this.spinResult); // if (TutorialManager.IsFinished() && G.getRandomFloat(0, 1) < 0.4) {
            //     let friends = Game.SUser.FriendsList()
            //     let fdata = []
            //     for(let uid in friends) {
            //         fdata.push({userId:uid, isFriend:true})
            //     }
            //     if (fdata.length > 0) {
            //         let fu = fdata[G.getRandomInt(0, fdata.length)]
            //         let req = SR.SRVillage.getPeopleUserVillage(fu.userId)
            //         req.SetSilence(true)
            //         req.SetCallBack((res) => {
            //             let village = res.userVillage
            //             let userVillage = new UserVillage()
            //             userVillage.updateData(village)
            //             if (userVillage.Score() <= 0) {
            //                 homeView.interactionNode.loadVillage(self.spinResult.number, self.spinResult.userInfo, self.spinResult.village)
            //                 return
            //             }
            //             homeView.interactionNode.loadVillage(self.spinResult.number, fu, village)
            //             homeView.interactionNode.setAttackRandomUser(self.spinResult.userInfo, self.spinResult.village)
            //         })
            //         req.Send()
            //     } else {
            //         homeView.interactionNode.loadVillage(self.spinResult.number, self.spinResult.userInfo, self.spinResult.village)
            //     }
            // } else {
            //     homeView.interactionNode.loadVillage(self.spinResult.number, self.spinResult.userInfo, self.spinResult.village);
            // }

            eventCenter.once(LoadEvent.VillageLoaded, () => {
              this.villageAttackedLoaded = true;
            }, this); // homeView.interactionNode.loadVillage(this.spinResult.number, this.spinResult.userInfo, this.spinResult.village);

            this.activityRoot.stayReward();
          } else if (this.spinResult.type === SlotTypes.Raid) {
            // homeView.interactionNode.loadRaid(this.spinResult.number, this.spinResult.userInfo, this.spinResult.village);
            this.activityRoot.stayReward();
          } else if (this.spinResult.type === SlotTypes.Coin1 || this.spinResult.type === SlotTypes.Coin2 || this.spinResult.type === SlotTypes.Coin3 || this.spinResult.type === SlotTypes.Coin4 || this.spinResult.type === SlotTypes.Coin5 || this.spinResult.type === SlotTypes.Coin6) ;else if (this.spinResult.type == SlotTypes.Shield) {
            if (GameMainWindow.instance != null) {
              GameMainWindow.instance.userinfo.setShieldWithNum(this.oldShieldNum);
            }

            if (this.oldShieldNum + this.betNum > G.GameConstance.shieldMax) {
              homeView.pageViewController.stopApAt(this.oldAp);
            }
          } else if (this.spinResult.type == SlotTypes.Spins) {
            homeView.pageViewController.stopApAt(this.oldAp);
          } else if (this.spinResult.type == SlotTypes.Symbol) {
            this.activityRoot.stayReward();
          }

          if (!TutorialManager.IsFinished()) {
            TutorialManager.CallTrigger("do_spin");
          }

          let spinCount = GameKit.DataCache.GetData("spin_count");
          spinCount = spinCount || 0;
          spinCount++;
          GameKit.DataCache.SetData("spin_count", spinCount);
          LogEventWrap.logEvent("SpinDetail", {
            result: spinCount
          });
        }

        spinOk2(res) {
          this.spinResult = res.slotResult; // eventCenter.once(MyCustomEvent.PlayerRunEnd, this.onSlotStop, this);
        }

        hideRewardText() {
          if (this.isRewardTextShowing) {
            this.scheduleOnce(() => {
              this.isRewardTextShowing = false;
              this.rewardText.getComponent(EnterCloseAnim).closeAnim();
            }, 0.8);
          }
        }

        async handleSlotResult() {
          Logs.Debug("Spin Complete");

          if (this.spinCallback != null) {
            this.spinCallback();
          }

          if (this.spinResult != null) {
            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              switch (this.spinResult.type) {
                case SlotTypes.Shield:
                  await AppMain.instance.tutorialManager.tutorialStepItem(SlotTypes.Shield);
                  break;

                case SlotTypes.Attack:
                  await AppMain.instance.tutorialManager.tutorialStepItem(SlotTypes.Attack);
                  break;

                case SlotTypes.Raid:
                  await AppMain.instance.tutorialManager.tutorialStepItem(SlotTypes.Raid);
                  break;
              }
            }

            this.scheduleOnce(() => {
              if (this.spinResult.type === SlotTypes.Spins) {
                homeView.pageViewController.getEnergyAnimation(this.spinResult.number, () => {
                  eventCenter.emit(MyCustomEvent.CanChangeSpin);
                });
              }

              SlotResultHandler.distributeSlotResult(this.spinResult);
            }, 0.3);
          }
        }

        showSpinAddNumAnim(num, cb, noUpdate) {
          this.spinAddNumAnim.active = true;
          this.spinAddNumAnim.getComponent(Label).string = "+" + num.toString();
          let localPos = new Vec3();
          this.spinAddNumAnim.parent.inverseTransformPoint(localPos, homeView.pageViewController.labelApRemain.node.getWorldPosition());
          this.spinAddNumAnim.setPosition(localPos);
          this.spinAddNumAnim.scale = v3(0.001, 0.001, 0.001);
          this.spinAddNumAnim.runAction(ccAction.sequence(ccAction.moveTo(0.2, 158, -68, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeIn, 2)), ccAction.delayTime(1), ccAction.moveTo(0.3, localPos)));
          this.spinAddNumAnim.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 1, 1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeIn, 2)), ccAction.delayTime(1), ccAction.scaleTo(0.3, 0.001, 0.001), ccAction.callFunc(() => {
            if (cb) cb();
            this.spinAddNumAnim.getComponent(Label).string = "";
            this.spinAddNumAnim.active = false;
            if (!noUpdate) homeView.pageViewController._setAp();
          })));
        }

        updatePeterPosition() {
          var _targeNode, _targeNode2;

          const layout = homeView.slotPage.btnServant.node.parent;
          let targeNode = null;

          for (let i = 0; i < layout.children.length; i++) {
            if (!layout.children[i].active) {
              targeNode = layout.children[i - 1];
              break;
            }
          }

          if (!targeNode) return;
          let out = new Vec3();
          let localPos = this.node.inverseTransformPoint(out, (_targeNode = targeNode) === null || _targeNode === void 0 ? void 0 : _targeNode.getWorldPosition());
          localPos.y += ((_targeNode2 = targeNode) === null || _targeNode2 === void 0 ? void 0 : _targeNode2.height) / 2 + 10;
          this.slotPeter.node.setPosition(localPos);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "rewardText", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "raidAnim", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "raidAnimSprite", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spinAnim", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "coinAnims", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "shieldAnims", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "shieldBreakAnims", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spinAddNumAnim", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "activityRoot", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "slotPeter", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardNewFriendItem.ts", ['cc', './global.ts', './UIWindow.ts', './UserInfoModel.ts', './DialogWindow.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ShareWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, _decorator, G, UIWindow, UserInfoModel, DialogWindow, SR, UIRoot, Game, LogEventWrap, ShareWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b5bd32N49VBj6AkPuAfhoNU", "CardNewFriendItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CardNewFriendItem = exports('CardNewFriendItem', (_dec = ccclass("CardNewFriendItem"), _dec2 = property(Sprite), _dec3 = property(Label), _dec4 = property(Label), _dec(_class = (_class2 = (_temp = class CardNewFriendItem extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "avatar", _descriptor, this);

          _initializerDefineProperty(this, "labelName", _descriptor2, this);

          _initializerDefineProperty(this, "labelStar", _descriptor3, this);

          _defineProperty(this, "_friendData", void 0);

          _defineProperty(this, "_cardMeta", void 0);
        }

        setItem(friendData, cardMeta, parent) {
          this._friendData = friendData;
          this._cardMeta = cardMeta;
          UserInfoModel.SetAvatar(this.avatar, friendData);
          this.labelName.string = friendData.Name() || "Unknow";
          this.labelStar.string = friendData.Star() || "0";
        }

        onSendBtnClick() {
          // 通知服务器
          let sr = SR.SRCard.cardSend(this._friendData.UserId(), [this._cardMeta.Id()]);
          sr.SetCallBack(() => {
            // 修改本地数据,用于计算每日的送卡片数目限制
            let sendCardTime = GameKit.PlayerPrefs.GetInt("sendCardTime", 0);

            if (GameKit.TimeUtil.getCurrentDay() !== sendCardTime) {
              GameKit.PlayerPrefs.SetInt("sendCardCount", 0);
              GameKit.PlayerPrefs.SetInt("sendCardTime", GameKit.TimeUtil.getCurrentDay());
            }

            let count = GameKit.PlayerPrefs.GetInt("sendCardCount", 0);
            GameKit.PlayerPrefs.SetInt("sendCardCount", count + 1); // 修改临时数据
            //game.SUserCard.DeleteCard(v)
            // 刷新页面

            let w = UIRoot.instance.GetWindow("CardSingleSetWindow");
            if (w) w.load_page(w.single_set_meta); // 显示send成功并关闭页面

            DialogWindow.Show(i18n.t("CardSelectCardWindowSuccess"), () => {
              this.closeAnim();
            });
            LogEventWrap.logEvent("card_send", {
              num: 1
            });
          });

          if (G.GameConfig.closeGiftFbShare) {
            sr.Send();
          } else {
            ShareWrap.chooseOne(Game.SUser.FriendsList()[this._friendData.UserId()].ThirdId(), String.format(i18n.t("ShareSendCard"), Game.SUser.Name()), "share/share1", {
              type: "send_cards"
            }, () => {
              sr.Send();
            }, "send_cards", false);
          }
        }

        match(pattern) {
          this.node.active = new RegExp(`${pattern}`, "i").test(this._friendData.Name());
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "avatar", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelStar", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BetAnim.ts", ['cc', './CCE_Component.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, CCE_Component, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b5bd4iSDG1JOrpLYxOQbDDL", "BetAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BetAnim = exports('default', (_dec = property(Node), _dec2 = property(Label), ccclass(_class = (_class2 = (_temp = class BetAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "betRibbon", _descriptor, this);

          _initializerDefineProperty(this, "betText", _descriptor2, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        play(betValue, cb) {
          this.node.active = true;
          this.node.scaleX = 0.9;
          this.node.scaleY = 1;
          var self = this;
          let seq = ccAction.sequence(ccAction.scaleTo(1.5, 1, 1), ccAction.callFunc(function () {
            if (cb != null) {
              cb();
              self.node.active = false;
            }
          }));
          this.node.stopAllActions();
          this.node.runAction(seq);
          this.betText.string = String.format(i18n.t("BetRibbonText"), betValue);
          this.betRibbon.stopAllActions();
          this.betRibbon.opacity = 0;
          this.betRibbon.runAction(ccAction.fadeIn(0.35));
        }

        stop() {
          this.node.stopAllActions();
          this.betRibbon.stopAllActions();
          this.node.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "betRibbon", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "betText", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShowNodeArrayAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Enum, Node, _decorator, Sprite, tween, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
      Node = module.Node;
      _decorator = module._decorator;
      Sprite = module.Sprite;
      tween = module.tween;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b6c24nUaT9D6bTCD2Yi6KE8", "ShowNodeArrayAnim", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      const C = {
        TYPE: Enum({
          /** 间隔时间模式 */
          INTERVAL_TIME: 0,

          /** 总时间模式 */
          ALL_TIME: 1
        }),
        TOOLTIP: {
          PREVIEW: "点击后预览1次，预览完毕后设置为false；（executeInEditMode模式下不支持schedule，无法实现预览功能，因此只写入6个子节点）",
          NODE_ARRAY: "节点数组（请按照显示顺序摆放）；如果为空，则按照所有子节点的默认顺序",
          TYPE: "模式；分为时间间隔模式和总时间模式",
          TIME: "时间；时间间隔模式下为间隔时间，总时间模式下为总时间"
        }
      };
      /**
       * 逐一显示node_array
       * - 外部接口play_anim()，播放动画
       * - play_anim()返回一个promise
       */

      let ShowNodeArrayAnim = exports('ShowNodeArrayAnim', (_dec = property({
        tooltip: C.TOOLTIP.PREVIEW
      }), _dec2 = property({
        tooltip: C.TOOLTIP.NODE_ARRAY,
        type: Node
      }), _dec3 = property({
        tooltip: C.TOOLTIP.TYPE,
        type: C.TYPE
      }), _dec4 = property({
        tooltip: C.TOOLTIP.TIME
      }), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class ShowNodeArrayAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "preview", _descriptor, this);

          _initializerDefineProperty(this, "node_array", _descriptor2, this);

          _initializerDefineProperty(this, "type", _descriptor3, this);

          _initializerDefineProperty(this, "time", _descriptor4, this);
        }

        slowUpdate(dt) {
          if (this.preview) {
            this.preview = false; // this.play_anim() // executeInEditMode模式下不支持schedule，无法实现预览功能，因此只写入6个子节点

            if (this.node_array.length === 0) {
              this.node_array = Array.from(this.node.children);
            }
          }
        }
        /**
         * 播放动画
         * @returns {Promise}
         */


        play_anim() {
          return new Promise((resolve, reject) => {
            /*// 当node_array中没有节点时，采取默认情况，写入所有子节点
                     if (this.node_array.length === 0) {
                         this.node_array = Array.from(this.node.children)
                     }
                     // 容错
                     if (this.node_array.length === 0) { resolve(null) }
                     // 容错2：反向数组（应该去优化路径建立过程，不应该这样写）
                     if (this.node_array[0].position.y > this.node_array[this.node_array.length - 1].position.y) {
                         this.node_array.reverse()
                     }
                     // 隐藏所有节点
                     for (let node of this.node_array) {
                         node.active = false
                     }
                     // 逐一显示
                     let interval;
                     if (this.type === C.TYPE.INTERVAL_TIME) {
                         interval = this.time
                     } else {
                         interval = this.time / this.node_array.length
                     }
                     this.schedule(() => {
                         let node = this.node_array.shift()
                         node.active = true
                         if (this.node_array.length === 0) {
                             this.unscheduleAllCallbacks()
                             resolve(null)
                         }
                     }, interval)*/
            this.node_array.forEach(x => {
              x.getComponent(Sprite).fillRange = 0, x.runAction(tween().to(0.6, {
                opacity: 255
              }));
            });
            this.scheduleOnce(v => {
              resolve(v);
            }, 0.6);
          });
        }

        hide() {
          this.node_array.forEach(x => {
            x.getComponent(Sprite).fillRange = 0;
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "preview", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "node_array", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "type", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return C.TYPE.ALL_TIME;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 2;
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GiftsWindow.ts", ['cc', './Constant.ts', './global.ts', './fbIn_lib.ts', './UIWindow.ts', './LocalizedManager.ts', './InviteWindow.ts', './CommunityItem.ts', './CommunityCardItem.ts', './CommunityFriendWindow.ts', './SdkManager.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ShareWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, color, ToggleContainer, SpriteFrame, Node, Label, Button, Prefab, _decorator, Widget, UITransform, instantiate, math, Layout, view, MyCustomEvent, G, fbInTools, UIWindow, rigisterLabel, InviteWindow, CommunityItem, CommunityCardItem, CommunityFriendWindow, SdkManager, SR, UIRoot, Game, Meta, LogEventWrap, ShareWrap, GameKit, BigNumber, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      color = module.color;
      ToggleContainer = module.ToggleContainer;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      Label = module.Label;
      Button = module.Button;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      Widget = module.Widget;
      UITransform = module.UITransform;
      instantiate = module.instantiate;
      math = module.math;
      Layout = module.Layout;
      view = module.view;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      fbInTools = module.fbInTools;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      InviteWindow = module.InviteWindow;
    }, function (module) {
      CommunityItem = module.CommunityItem;
    }, function (module) {
      CommunityCardItem = module.CommunityCardItem;
    }, function (module) {
      CommunityFriendWindow = module.CommunityFriendWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b6decHYl69Jp6TWQmtHgEkQ", "GiftsWindow", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        /** 伪数据长度 */
        FAKE_DATA_LENGTH: 4,

        /** 伪等待时间 */
        FAKE_WAIT_TIME: 1,

        /** 载入sprite旋转一圈的时间 */
        LOADING_ROTATION_TIME: 0.5,

        /** 字体颜色：可点击 */
        FONT_COLOR_ABLE_SEND: color(0, 79, 132),
        FONT_COLOR_ABLE_COLLECT: color(7, 102, 15),

        /** 字体颜色：不可点击 */
        FONT_COLOR_UNABLE: color(60, 60, 60),
        // 一些测试默认值（以后需要从服务器/配置表中读取）
        DEFAULR_SPIN_SEND: 1,
        DEFAULR_SPIN_COLLECT: 1,
        DEFAULR_COIN_SEND: "15K",
        DEFAULR_COIN_COLLECT: "15K",

        /** 显示状态枚举 */
        TYPE: {
          SEND: "send",
          SENDED: "sended",
          COLLECT: "collect",
          COLLECTED: "collected"
        },

        /** 默认邀请时增加的 */
        DEFAULT_INVITE_ADD: 35
      };
      /**
       * Gifts界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let GiftsWindow = exports('GiftsWindow', (_dec = property(ToggleContainer), _dec2 = property(SpriteFrame), _dec3 = property(Node), _dec4 = property(Label), _dec5 = property(Button), _dec6 = property(Label), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Prefab), _dec10 = property(Prefab), _dec11 = property(Node), _dec12 = property(Node), _dec13 = property(Label), _dec14 = property(Label), _dec15 = property(Label), _dec16 = property(Label), _dec17 = property(Label), _dec18 = property(Node), _dec19 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class GiftsWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "toggleTabs", _descriptor, this);

          _initializerDefineProperty(this, "default_avatar_sf", _descriptor2, this);

          _initializerDefineProperty(this, "loading_circle", _descriptor3, this);

          _initializerDefineProperty(this, "collect_progress_note", _descriptor4, this);

          _initializerDefineProperty(this, "btn_collect_all", _descriptor5, this);

          _initializerDefineProperty(this, "label_collect_all", _descriptor6, this);

          _initializerDefineProperty(this, "anim_spin", _descriptor7, this);

          _initializerDefineProperty(this, "anim_coin", _descriptor8, this);

          _initializerDefineProperty(this, "communityItemPrefab", _descriptor9, this);

          _initializerDefineProperty(this, "communityCardItemPrefab", _descriptor10, this);

          _initializerDefineProperty(this, "content", _descriptor11, this);

          _initializerDefineProperty(this, "scrollView", _descriptor12, this);

          _initializerDefineProperty(this, "inviteName", _descriptor13, this);

          _initializerDefineProperty(this, "inviteTip", _descriptor14, this);

          _initializerDefineProperty(this, "iniviteAddTxt", _descriptor15, this);

          _initializerDefineProperty(this, "labelNoCard", _descriptor16, this);

          _initializerDefineProperty(this, "labelNoFriends", _descriptor17, this);

          _initializerDefineProperty(this, "sendCardNode", _descriptor18, this);

          _initializerDefineProperty(this, "inviteNode", _descriptor19, this);

          _defineProperty(this, "choose_tab", void 0);

          _defineProperty(this, "childWindowChain", void 0);

          _defineProperty(this, "dataMap", void 0);

          _defineProperty(this, "tab_node_array", void 0);

          _defineProperty(this, "_data_array", void 0);
        }

        onLoad() {
          this.node.getChildByName("rootNode").getComponent(Widget).top += AppMain.instance.statusBarHeight;
        }

        onShow() {
          this.label_collect_all.string = i18n.t("gifts_collect_all");
          rigisterLabel("gifts_collect_all", this.label_collect_all);
          if (fbInTools.usefbIn) this.label_collect_all.string = i18n.t("gifts_collect_all2");

          if (!G.GameConfig.closeShare && (this.toggleTabs.toggleItems[0].isChecked || this.toggleTabs.toggleItems[1].isChecked)) {
            this.inviteNode.active = true;
            this.setInviteItem();
            eventCenter.on(MyCustomEvent.NextVillage, () => {
              this.setInviteItem();
            });
          }

          if (fbInTools.usefbIn) {
            this.label_collect_all.string = i18n.t("gifts_collect_all2");
            rigisterLabel("gifts_collect_all2", this.label_collect_all);
          }

          this.onToggleSpinClick();
        }
        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        } //


        async onToggleSpinClick() {
          this.inviteNode.active = true;
          this.sendCardNode.active = false;
          this.labelNoCard.node.active = false;
          this.labelNoFriends.node.active = false;
          this.btn_collect_all.node.active = false;
          this.collect_progress_note.node.active = false;
          this.scrollView.getComponent(Widget).top = this.inviteNode.getComponent(Widget).top + this.inviteNode.getComponent(UITransform).height;
          this.scrollView.getComponent(Widget).bottom = this.btn_collect_all.getComponent(Widget).bottom + this.btn_collect_all.node.getComponent(UITransform).height + 40;
          this.content.destroyAllChildren();
          this.open_loading_anima();
          this.get_spins_data().then(v => {
            if (!this.node || !this.node.isValid) return;
            this.update_all_item(v);
            this.update_collect_progress();
            this.close_loading_anima();
          }, e => {});
        }

        onToggleCoinClick() {
          this.inviteNode.active = true;
          this.sendCardNode.active = false;
          this.labelNoCard.node.active = false;
          this.labelNoFriends.node.active = false;
          this.btn_collect_all.node.active = false;
          this.collect_progress_note.node.active = false;
          this.scrollView.getComponent(Widget).top = this.inviteNode.getComponent(Widget).top + this.inviteNode.getComponent(UITransform).height;
          this.scrollView.getComponent(Widget).bottom = this.btn_collect_all.getComponent(Widget).bottom + this.btn_collect_all.node.height + 40;
          this.content.destroyAllChildren();
          this.open_loading_anima();
          this.get_coins_data().then(v => {
            if (!this.node || !this.node.isValid) return;
            this.update_all_item(v);
            this.update_collect_progress();
            this.close_loading_anima();
          }, e => {});
        }

        onToggleCardClick() {
          this.inviteNode.active = false;
          this.btn_collect_all.node.active = false;
          this.labelNoCard.node.active = false;
          this.labelNoFriends.node.active = false;
          this.sendCardNode.active = true;
          this.collect_progress_note.node.active = false;
          this.scrollView.getComponent(Widget).top = this.toggleTabs.getComponent(UITransform).height + 10;
          this.scrollView.getComponent(Widget).bottom = this.sendCardNode.getComponent(Widget).bottom + this.sendCardNode.height + 40;
          this.content.destroyAllChildren();
          this.open_loading_anima();
          this.get_cards_data().then(v => {
            if (!this.node || !this.node.isValid) return;
            this.update_card_item(v);
            this.update_collect_progress();
            this.close_loading_anima();
          }, e => {});
        }
        /** 点击事件：打开invite界面 */


        event_invite() {
          // if (this.childWindowChain) {
          // 	this.clearOnCloseFunc();
          // 	this.childWindowChain.end();
          // }
          console.log("click invite");
          UIRoot.instance.openChildWindow(InviteWindow);
        }
        /**
         *
         * 点击从卡牌事件
         */


        event_sendCard() {
          if (!Game.SUserCard.CheckDailyLimit()) {
            return;
          }

          UIRoot.instance.openChildWindow(CommunityFriendWindow);
        }
        /** 点击事件：collect & send all */


        event_collect_all() {
          if (!this.dataMap) return;
          let sendList = [];
          let collectList = [];
          let req = null;

          let setList = function (list, max) {
            let count = 0;

            for (let uid in list) {
              if (list[uid].sended) ;

              if (list[uid].collected) {
                count++;
              }
            }

            for (let uid in list) {
              if (!list[uid].sended) {
                if (!fbInTools.usefbIn) {
                  sendList.push(parseInt(uid)); //count++
                }
              }

              if (!list[uid].collected && list[uid].canCollect && count < max) {
                collectList.push(parseInt(uid));
                count++;
              }

              if (count > max) return;
            }
          };

          if (this.toggleTabs.toggleItems[0].isChecked) {
            setList(this.dataMap.spinList, G.GameConstance.giftSpinMax);
            if (sendList.length + collectList.length <= 0) return;
            req = SR.SRSocial.giftsSpinAll(sendList, collectList);
          } else {
            setList(this.dataMap.coinList, G.GameConstance.giftCoinMax);
            if (sendList.length + collectList.length <= 0) return;
            req = SR.SRSocial.giftsCoinAll(sendList, collectList);
          }

          req.SetCallBack(() => {
            if (this.toggleTabs.toggleItems[0].isChecked) {
              sendList.forEach(x => this.dataMap.spinList[x].sended = true);
              collectList.forEach(x => this.dataMap.spinList[x].collected = true);
            } else {
              sendList.forEach(x => this.dataMap.coinList[x].sended = true);
              collectList.forEach(x => this.dataMap.coinList[x].collected = true);
            }

            if (collectList.length > 0) {
              let anim = null;
              let giftGetMeta = Meta.MetaManager.GetMeta(Meta.MetaType.GiftGet, Game.SUserVillage.MapId());

              if (this.toggleTabs.toggleItems[0].isChecked) {
                anim = instantiate(this.anim_spin);
                GameKit.ControllerTable.GetNode(anim, "label").getComponent(Label).string = "+" + (giftGetMeta.Spin() * collectList.length).toString();
              } else {
                anim = instantiate(this.anim_coin);
                GameKit.ControllerTable.GetNode(anim, "label").getComponent(Label).string = "+" + BigNumber.format(giftGetMeta.Coin() * collectList.length);
              }

              anim.parent = this.anim_spin.parent;
              anim.setWorldPosition(this.btn_collect_all.node.getWorldPosition());
              anim.active = true;
            }

            this.update_collect_progress();
            this.flushData();
            LogEventWrap.logEvent("gift_all");
          });

          if (sendList.length > 0 && SdkManager.IsNative() && Game.SUser.IsFacebook()) {
            if (G.GameConfig.closeGiftFbShare) {
              req.Send();
            } else {
              let ids = [];
              sendList.forEach(id => {
                ids.push(Game.SUser.FriendsList()[id].ThirdId());
              });
              let sstr = String.format(i18n.t("ShareInviteSendCoins"), Game.SUser.Name());
              if (this.toggleTabs.toggleItems[0].isChecked) sstr = String.format(i18n.t("ShareInviteSendSpin"), Game.SUser.Name());
              ShareWrap.chooseOne(ids, sstr, this.toggleTabs.toggleItems[0].isChecked ? "Texture/share_spin.png" : "Texture/share_coin.png", {
                type: this.toggleTabs.toggleItems[0].isChecked ? "send_spins_all" : "send_coins_all"
              }, () => {
                req.Send();
              }, this.toggleTabs.toggleItems[0].isChecked ? "send_spins" : "send_coins", true);
            }
          } else {
            req.Send();
          }
        }

        update_collect_progress() {
          if (!this.dataMap) return; // 还需要从服务器获取数据

          if (this.toggleTabs.toggleItems[0].isChecked) {
            this.collect_progress_note.node.active = true;
            this.btn_collect_all.node.active = true; // this.gift_tip.active = true;

            let count = 0;

            for (let uid in this.dataMap.spinList) {
              if (this.dataMap.spinList[uid].collected) {
                count++;
              }

              if (this.dataMap.spinList[uid].sended) ;
            }

            this.collect_progress_note.string = String.format(i18n.t("gifts_collect_spins"), count, G.GameConstance.giftSpinMax);
            rigisterLabel("gifts_collect_spins", this.collect_progress_note, count, G.GameConstance.giftSpinMax);
          } else if (this.toggleTabs.toggleItems[1].isChecked) {
            this.collect_progress_note.node.active = true;
            this.btn_collect_all.node.active = true; // this.gift_tip.active = true;

            let count = 0;

            for (let uid in this.dataMap.coinList) {
              if (this.dataMap.coinList[uid].collected) {
                count++;
              }

              if (this.dataMap.coinList[uid].sended) ;
            }

            this.collect_progress_note.string = String.format(i18n.t("gifts_collect_coins"), count, G.GameConstance.giftCoinMax);
          } else {
            this.collect_progress_note.node.active = false;
            this.btn_collect_all.node.active = false; // this.gift_tip.active = false;
          }
        }
        /** 刷新所有的item
         * @param {[{}]} data_array
         */


        update_all_item(data_array) {
          this._data_array = data_array;
          console.log("onToggle: ", Object.keys(data_array).length);

          for (let id in Game.SUser.FriendsList()) {
            let data = data_array[id];

            if (data == null) {
              data_array[id] = {
                sended: false,
                collected: false,
                canCollect: false
              };
            }
          } //this.svt.scrollView.scrollToTop(0.1)
          //this.svt.clear()


          let ranks = []; //let item_count = Object.keys(data_array).length + 1
          //for (let i = 0; i < item_count; i++) { ranks.push(i) }

          for (let uid in Game.SUser.FriendsList()) {
            ranks.push(uid);
          }

          this.labelNoFriends.node.active = !ranks.length;
          ranks.sort((a, b) => {
            if (data_array[a].canCollect && !data_array[a].collected && (!data_array[b].canCollect || data_array[b].collected)) return -1;
            if (data_array[b].canCollect && !data_array[b].collected && (!data_array[a].canCollect || data_array[a].collected)) return 1;
            if (!data_array[a].sended && data_array[b].sended) return -1;
            if (!data_array[b].sended && data_array[a].sended) return 1;
            return parseInt(a) - parseInt(b);
          }); // if (!G.GameConfig.closeShare) {
          // 	ranks.push(0);
          // }
          // this.svt.reuseSetInitFunc((index, id, itemHandle) => {
          // 	this.setItem(data_array[id], index, id, itemHandle);
          // });
          // this.svt.reuseSetData(ranks);

          this.content.destroyAllChildren();
          let itemSize = new math.Size();

          for (let i = 0; i < ranks.length; i++) {
            const newCommunityNode = instantiate(this.communityItemPrefab);
            i === 0 && (itemSize = newCommunityNode.getComponent(UITransform).contentSize);
            const commuityItem = newCommunityNode.getComponent(CommunityItem);
            this.content.addChild(newCommunityNode);

            if (parseInt(ranks[i]) > 0) {
              commuityItem.setItem(data_array[ranks[i]], ranks[i], this);
            }
          }

          const tempHeight = ranks.length * itemSize.height + (ranks.length - 1) * this.content.getComponent(Layout).spacingY + this.content.getComponent(Layout).paddingTop;
          this.content.getComponent(UITransform).setContentSize(view.getVisibleSize().width, tempHeight);
        }

        setInviteItem() {
          this.inviteName.string = i18n.t("gifts_default_name");
          this.inviteTip.string = i18n.t("gifts_default_explain");
          this.iniviteAddTxt.string = String.format(i18n.t("invite_addnumber_type0"), this.get_add_number());
        }
        /** 刷新卡片的item
         * @param {[{}]} data_array
         */


        update_card_item(data_array) {
          this._data_array = data_array;
          let ranks = [];

          for (let i = 0; i < data_array.length; i++) {
            ranks.push(i);
          }

          this.labelNoCard.node.active = !data_array.length; // this.svt.reuseSetInitFunc((index, id, itemHandle) => {
          // 	this.setCardItem(data_array, index, id, itemHandle);
          // });
          // this.svt.reuseSetData(ranks);

          this.content.destroyAllChildren();
          let itemSize = new math.Size();

          for (let i = 0; i < data_array.length; i++) {
            const newCardItemNode = instantiate(this.communityCardItemPrefab);
            i === 0 && (itemSize = newCardItemNode.getComponent(UITransform).contentSize);
            const communityCardItem = newCardItemNode.getComponent(CommunityCardItem);
            this.content.addChild(newCardItemNode);

            if (ranks[i] >= 0) {
              communityCardItem.setCardItem(data_array[ranks[i]], ranks[i], this);
            }
          }

          const tempHeight = data_array.length * itemSize.height + (data_array.length - 1) * this.content.getComponent(Layout).spacingY;
          this.content.getComponent(UITransform).setContentSize(view.getVisibleSize().width, tempHeight);
        }
        /**
         * 根据三种状态判定显示状态
         * - 三种初始状态分别对应三个参数
         * - 显示状态有3种：显示SEND按钮，显示COLLECT按钮，显示等待时间（或者不显示）；使用C.TYPE进行封装
         * - 优先collect
         * @param {boolean} sended
         * @param {boolean} collected
         * @param {boolean} canCollect
         * @return {string} C.TYPE
         */


        get_type(sended, collected, canCollect) {
          // test
          // return C.TYPE.SEND
          if (!collected && canCollect) {
            let isfull = false;

            if (this.toggleTabs.toggleItems[0].isChecked) {
              let count = 0;

              for (let uid in this.dataMap.spinList) {
                if (this.dataMap.spinList[uid].collected) {
                  count++;
                }
              }

              if (count >= G.GameConstance.giftSpinMax) {
                isfull = true;
              }
            } else if (this.toggleTabs.toggleItems[1].isChecked) {
              let count = 0;

              for (let uid in this.dataMap.coinList) {
                if (this.dataMap.coinList[uid].collected) {
                  count++;
                }
              }

              if (count >= G.GameConstance.giftCoinMax) {
                isfull = true;
              }
            }

            if (!isfull) return C.TYPE.COLLECT;
          }

          if (!sended) {
            return C.TYPE.SEND;
          } else if (!collected && !canCollect) {
            return C.TYPE.SENDED;
          }

          return C.TYPE.COLLECTED;
        }
        /** 获取free spins的数据 */


        get_spins_data() {
          return new Promise((resolve, reject) => {
            // if (this.dataMap) {
            // 	resolve(this.dataMap.spinList);
            // 	return;
            // }
            let sr = SR.SRSocial.getGifts();
            sr.SetCallBack(res => {
              // 保存数据
              this.dataMap = res;
              resolve(this.dataMap.spinList);
              GameKit.DataCache.RemoveData("GiftsNum");
              GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.GiftEvent, null);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          });
          /** 备注：消息格式 
          res.spinList = [
          	// 单条消息
          	{
          		userId: 0,
          		sended: false,                  // 是否送过了
          		collected: false,               // 是否收过了
          		canCollect: false,              // 是否有东西可以收集
          	},
          	// 一个消息列表
          	{}, {}, {},
          ]*/
        }
        /** 获取free coins的数据 */


        get_coins_data() {
          return new Promise((resolve, reject) => {
            // if (this.dataMap) {
            // 	resolve(this.dataMap.coinList);
            // 	return;
            // }
            let sr = SR.SRSocial.getGifts();
            sr.SetCallBack(res => {
              // 保存数据
              this.dataMap = res;
              resolve(this.dataMap.coinList);
              GameKit.DataCache.RemoveData("GiftsNum");
              GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.GiftEvent, null);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          });
          /** 备注：消息格式
          res.coinList = [
          	// 单条消息
          	{
          		userId: 0,
          		sended: false,                  // 是否送过了
          		collected: false,               // 是否收过了
          		canCollect: false,              // 是否有东西可以收集
          	},
          	// 一个消息列表
          	{}, {}, {},
          ] */
        }

        get_cards_data() {
          return new Promise((resolve, reject) => {
            // if (this.dataMap) {
            // 	resolve(this.dataMap.cardList);
            // 	return;
            // }
            let sr = SR.SRSocial.getGifts();
            sr.SetCallBack(res => {
              // 保存数据
              this.dataMap = res;
              resolve(this.dataMap.cardList);
              GameKit.DataCache.RemoveData("GiftsNum");
              GameKit.GameEvent.DispatcherEvent(GameKit.GameEvent.EventName.GiftEvent, null);
            });
            sr.SetErrorCallBack(() => {
              reject();
            });
            sr.Send();
          });
        }
        /** 打开loading动画 */


        open_loading_anima() {
          /*if (this.loading_anima === undefined) {
          	this.loading_anima = ccAction.rotateBy(C.LOADING_ROTATION_TIME, 360).repeatForever()
          	this.loading_circle.active = true
          	this.loading_circle.runAction(this.loading_anima)
          }*/
          this.loading_circle.active = true;
        }
        /** 关闭loading动画 */


        close_loading_anima() {
          this.loading_circle.active = false;
        }
        /**
         * 修改按钮禁用状态
         * - 请保证btn下的文字节点名称为title
         * - 请保证给btn添加ControllerTable组件并拖入title节点（必须，否则会直接报错）
         * @param {Button} btn
         * @param {boolean} is_able
         */


        able_btn(btn, is_able) {
          btn.enableAutoGrayEffect = true; // 注册变灰事件

          btn.interactable = is_able;

          if (is_able) {
            ///不知道颜色，先用collect的颜色
            GameKit.ControllerTable.GetNode(btn.node, "title").color = C.FONT_COLOR_ABLE_COLLECT; // GameKit.ControllerTable.GetNode(btn.node, "title").color = C.FONT_COLOR_ABLE
          } else {
            GameKit.ControllerTable.GetNode(btn.node, "title").color = C.FONT_COLOR_UNABLE;
          }
        }
        /** 获取增加的值（meta数据or服务器数据）
         * @returns {number}
         */


        get_add_number() {
          let data = G.GameConstance.spinsPerInvite;
          let mapId = Game.SUserVillage.MapId();
          let is = 0;

          for (let mid in data) {
            if (mapId >= parseInt(mid)) {
              is = data[mid];
            } else {
              break;
            }
          }

          return is;
        }

        flushData() {
          this.content.children.forEach(commuityNode => {
            const commuityItem = commuityNode.getComponent(CommunityItem);
            const id = commuityItem._Itemid;

            if (id && this._data_array[id] && id > 0) {
              commuityItem.setItem(this._data_array[id], id, this);
            } else {
              throw new Error("item id or data_array error");
            }
          });
        }

        reuseSetData(cardId) {
          this.content.children.forEach(cardNode => {
            const cardItem = cardNode.getComponent(CommunityCardItem);

            if (cardItem && cardItem._data.cardId === cardId) {
              cardNode.destroy();
            }
          });
        }

      }, _defineProperty(_class3, "windowPath", "Community/CommunityWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "toggleTabs", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "default_avatar_sf", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "loading_circle", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "collect_progress_note", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btn_collect_all", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "label_collect_all", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "anim_spin", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "anim_coin", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "communityItemPrefab", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "communityCardItemPrefab", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "content", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "scrollView", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "inviteName", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "inviteTip", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "iniviteAddTxt", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "labelNoCard", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "labelNoFriends", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "sendCardNode", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "inviteNode", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MapItem.ts", ['cc', './Constant.ts', './global.ts', './_app.ts', './SoundManager.ts', './ResourceLoader.ts', './ChangeSceneManager.ts', './UserVillage.ts', './VillageNode.ts', './DownloadingWindow.ts', './GameMainWindow.ts', './UIRoot.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Node, Label, Button, dragonBones, Material, _decorator, Component, tween, UITransform, Vec3, Animation, Constant, LoadEvent, G, cce, SoundManager, ResourceLoader, ChangeSceneManager, UserVillage, VillageNode, DownloadingWindow, GameMainWindow, UIRoot, Game, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Node = module.Node;
      Label = module.Label;
      Button = module.Button;
      dragonBones = module.dragonBones;
      Material = module.Material;
      _decorator = module._decorator;
      Component = module.Component;
      tween = module.tween;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
      Animation = module.Animation;
    }, function (module) {
      Constant = module.Constant;
      LoadEvent = module.LoadEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      UserVillage = module.UserVillage;
    }, function (module) {
      VillageNode = module.default;
    }, function (module) {
      DownloadingWindow = module.DownloadingWindow;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b7bb8fveOtMC5dO1FX89WN+", "MapItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let MapItem = exports('MapItem', (_dec = ccclass('MapItem'), _dec2 = property(Sprite), _dec3 = property(Node), _dec4 = property(Label), _dec5 = property([Sprite]), _dec6 = property(Button), _dec7 = property([Node]), _dec8 = property(dragonBones.ArmatureDisplay), _dec9 = property(Material), _dec10 = property(Material), _dec11 = property(Node), _dec(_class = (_class2 = (_temp = class MapItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "mapIcon", _descriptor, this);

          _initializerDefineProperty(this, "lockNode", _descriptor2, this);

          _initializerDefineProperty(this, "labelMapName", _descriptor3, this);

          _initializerDefineProperty(this, "roadPieces", _descriptor4, this);

          _initializerDefineProperty(this, "btnMap", _descriptor5, this);

          _initializerDefineProperty(this, "clouds", _descriptor6, this);

          _initializerDefineProperty(this, "dbLight", _descriptor7, this);

          _initializerDefineProperty(this, "materialGray", _descriptor8, this);

          _initializerDefineProperty(this, "normalMaterial", _descriptor9, this);

          _initializerDefineProperty(this, "loadingCircle", _descriptor10, this);

          _defineProperty(this, "_data", void 0);

          _defineProperty(this, "_mapWindow", void 0);

          _defineProperty(this, "_progress", "");
        }

        setItem(data, owner) {
          this._data = data;
          this._mapWindow = owner;
          const isLocal = Constant.LocalMapIds.contains(data.Id());
          let villageName = VillageNode.GetVillageName(data.ResId());
          let resPath = villageName + "/" + villageName + "/texture";
          this.loadingCircle.active = true;
          this.mapIcon.node.active = false;
          ResourceLoader.loadSpriteFrame(resPath, isLocal).then(spriteFrame => {
            this.mapIcon.spriteFrame = spriteFrame;
            this.loadingCircle.active = false;
            tween(this.mapIcon.node).set({
              opacity: 0,
              active: true
            }).to(0.3, {
              opacity: 255
            }).start();
          });

          if (data.Id() < (this._mapWindow._levelUP ? Game.SUserVillage.MapId() : Game.SUserVillage.MapId() + 1)) {
            this.lockNode.active = false;
            this.roadPieces.forEach(piece => {
              piece.fillRange = -1;
            });
            this.mapIcon.customMaterial = this.normalMaterial;
          } else {
            this.lockNode.active = true;
            this.roadPieces.forEach(piece => {
              piece.fillRange = 0;
            });
            this.mapIcon.customMaterial = this.materialGray;
          }

          this.dbLight.node.active = false;
          this.labelMapName.string = String.format(i18n.t("map_title"), data.Id(), data.ShowName());
          this.getComponent(UITransform).priority = data.Id();
        }

        onEnable() {
          this.btnMap.node.on("click", this.onMapItemClick, this);
        }

        onDisable() {
          this.btnMap.node.off("click", this.onMapItemClick, this);
        }

        async unlockMapItem() {
          let playRoadAnim = () => {
            return new Promise((resolve, reject) => {
              this.roadPieces.forEach((piece, index) => {
                piece.fillRange = 0;
                tween(piece).to(0.3, {
                  fillRange: -1
                }).call(() => {
                  if (index === this.roadPieces.length - 1) {
                    resolve(null);
                  }
                }).start();
              });
            });
          };

          let playUnlockAnim = () => {
            return new Promise((resolve, reject) => {
              this.dbLight.node.active = true;
              this.lockNode.active = true;
              tween(this.lockNode).sequence(tween(this.lockNode).to(0.3, {
                scale: new Vec3(1.5, 1.5, 1.5)
              }), tween(this.lockNode).to(0.3, {
                opacity: 0
              })).call(() => {
                this.dbLight.node.destroy();
                this.lockNode.destroy();
                this.mapIcon.customMaterial = this.normalMaterial;
                resolve(null);
              }).start();
              SoundManager.playSound("chest_card");
            });
          };

          await playRoadAnim();
          await playUnlockAnim();
          this.schedule(() => {
            if (homeView.villageLoaded) {
              this.unscheduleAllCallbacks();
              homeView.pageViewController.moveToPage(G.Pages.Village, true);

              this._mapWindow.onBtnCloseClick(null, async () => {
                var _homeView$shopWindow;

                homeView.slotPage.initPage();
                homeView.villagePage.initPage();
                homeView.villagePage.showBuildKing();
                (_homeView$shopWindow = homeView.shopWindow) === null || _homeView$shopWindow === void 0 ? void 0 : _homeView$shopWindow.initCoinPage(true);
                await cce.wait(100);
                SoundManager.playSound("slot_item_win");
                UIRoot.instance.CloseCantClick();
                homeView.checkSubTutorial();
              });
            }
          }, 0.1);
          eventCenter.on(LoadEvent.VillageProgressUpdate, porgress => {
            this._progress = (porgress * 80).toFixed(0) + "%";
          }, this);
          eventCenter.on(LoadEvent.SlotProgressUpdate, porgress => {
            this._progress = (80 + porgress * 20).toFixed(0) + "%";
          }, this);
          DownloadingWindow.Show(() => {
            return homeView.villageLoaded;
          }, () => {
            return this._progress;
          });
        }

        async onMapItemClick() {
          this.node.getComponent(Animation).play();

          if (this._data.Id() < 1 || this._data.Id() > Game.SUserVillage.MapId()) {
            this.lockNode.getComponent(Animation).play();
            return;
          }

          homeView.villagePage.previewMapId = this._data.Id();
          ChangeSceneManager.instance.show(async () => {
            homeView.slotNode.isSpining = true;
            GameMainWindow.instance.node.active = false;
            homeView.villagePage.node.getChildByName("container").getChildByName("UI").active = false;
            homeView.node.getChildByName("tabNode").active = false;
            homeView.villagePage.btnBackToMap.node.active = true; // homeView.mapWindow.node.active = false;

            cce.showToast("change to Map" + this._data.Id().toString());
            const tempUserVillage = new UserVillage();
            tempUserVillage.setData("mapId", this._data.Id());
            tempUserVillage.setData("village", [5, 5, 5, 5, 5, 0, 0, 0, 0, 0]);
            await homeView.loadVillage(tempUserVillage, false);
            await homeView.loadVillageIcon(tempUserVillage);
            homeView.pageViewController.moveToPage(G.Pages.Village, true);
            homeView.mapWindow.closeAnim(() => {
              ChangeSceneManager.instance.hide();
            });
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "mapIcon", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lockNode", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelMapName", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "roadPieces", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btnMap", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "clouds", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "dbLight", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "materialGray", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "normalMaterial", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "loadingCircle", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillagePage.ts", ['cc', './Constant.ts', './global.ts', './_app.ts', './EnterCloseAnim.ts', './SoundManager.ts', './ContentModel.ts', './CommonAssets.ts', './Content.ts', './MetaManager.ts', './PlayGetAnimation.ts', './ChangeSceneManager.ts', './ContainerVillage.ts', './TutorialManager.ts', './Page.ts', './TouchTest.ts', './VillageUpgradeBtn.ts', './VillageShopWindow.ts', './NewMapWindow.ts', './GameMainWindow.ts', './SR.ts', './SlotResultHandler.ts', './ShopWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Vec3, Node, Button, Label, Sprite, ProgressBar, EditBox, Toggle, Prefab, dragonBones, _decorator, Widget, assetManager, Texture2D, SpriteFrame, instantiate, director, tween, easing, MyCustomEvent, Constant, G, cce, EnterCloseAnim, SoundManager, ContentModel, CommonAssets, Content, MetaManager, PlayGetAnimation, ChangeSceneManager, ContainerVillage, TutorialManager, Page, TouchTest, VillageUpgradeBtn, VillageShopWindow, NewMapWindow, GameMainWindow, SR, SlotResultHandler, ShopWindow, UIRoot, ActivityManager, Game, Meta, LogEventWrap, ADWrap, PaymentWrap, GameKit, BigNumber, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Vec3 = module.Vec3;
      Node = module.Node;
      Button = module.Button;
      Label = module.Label;
      Sprite = module.Sprite;
      ProgressBar = module.ProgressBar;
      EditBox = module.EditBox;
      Toggle = module.Toggle;
      Prefab = module.Prefab;
      dragonBones = module.dragonBones;
      _decorator = module._decorator;
      Widget = module.Widget;
      assetManager = module.assetManager;
      Texture2D = module.Texture2D;
      SpriteFrame = module.SpriteFrame;
      instantiate = module.instantiate;
      director = module.director;
      tween = module.tween;
      easing = module.easing;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      Constant = module.Constant;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      ContainerVillage = module.default;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      Page = module.Page;
    }, function (module) {
      TouchTest = module.default;
    }, function (module) {
      VillageUpgradeBtn = module.default;
    }, function (module) {
      VillageShopWindow = module.default;
    }, function (module) {
      NewMapWindow = module.NewMapWindow;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      SlotResultHandler = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _dec27, _dec28, _dec29, _dec30, _dec31, _dec32, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _descriptor26, _descriptor27, _descriptor28, _descriptor29, _descriptor30, _descriptor31, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b8097UOwc5ML5cSr3tLJhf/", "VillagePage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const scaleConst1 = new Vec3(1.05, 1.05, 1.05);
      const scaleConst2 = new Vec3(0.95, 0.95, 0.95);
      let VillagePage = exports('default', (_dec = ccclass("VillagePage"), _dec2 = property(Node), _dec3 = property(Button), _dec4 = property(Node), _dec5 = property(Label), _dec6 = property(Sprite), _dec7 = property(Label), _dec8 = property(Label), _dec9 = property(ProgressBar), _dec10 = property(Label), _dec11 = property(ContentModel), _dec12 = property(ContentModel), _dec13 = property(Button), _dec14 = property(Button), _dec15 = property(Label), _dec16 = property(Node), _dec17 = property(Node), _dec18 = property(Label), _dec19 = property(Label), _dec20 = property(Node), _dec21 = property(Label), _dec22 = property(Button), _dec23 = property(EditBox), _dec24 = property(Toggle), _dec25 = property(Toggle), _dec26 = property(Prefab), _dec27 = property(Node), _dec28 = property(Node), _dec29 = property(Node), _dec30 = property(dragonBones.ArmatureDisplay), _dec31 = property(dragonBones.ArmatureDisplay), _dec32 = property(Node), _dec(_class = (_class2 = (_temp = class VillagePage extends Page {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "upgradeBtns", _descriptor, this);

          _initializerDefineProperty(this, "btnRewards", _descriptor2, this);

          _initializerDefineProperty(this, "rewardNodes", _descriptor3, this);

          _initializerDefineProperty(this, "txtRewards", _descriptor4, this);

          _initializerDefineProperty(this, "spAvatar", _descriptor5, this);

          _initializerDefineProperty(this, "txtName", _descriptor6, this);

          _initializerDefineProperty(this, "txtRoomName", _descriptor7, this);

          _initializerDefineProperty(this, "progressBar", _descriptor8, this);

          _initializerDefineProperty(this, "txtProgress", _descriptor9, this);

          _initializerDefineProperty(this, "rewardItem1", _descriptor10, this);

          _initializerDefineProperty(this, "rewardItem2", _descriptor11, this);

          _initializerDefineProperty(this, "btnMap", _descriptor12, this);

          _initializerDefineProperty(this, "btnAdCoin", _descriptor13, this);

          _initializerDefineProperty(this, "txtAdCoin", _descriptor14, this);

          _initializerDefineProperty(this, "spSuperShield", _descriptor15, this);

          _initializerDefineProperty(this, "spSuperShieldGold", _descriptor16, this);

          _initializerDefineProperty(this, "labelSliverSuperShieldTime", _descriptor17, this);

          _initializerDefineProperty(this, "labelGoldSuperShieldTime", _descriptor18, this);

          _initializerDefineProperty(this, "buildKingNode", _descriptor19, this);

          _initializerDefineProperty(this, "activityLeftTime", _descriptor20, this);

          _initializerDefineProperty(this, "btnBackToMap", _descriptor21, this);

          _initializerDefineProperty(this, "editBoxMapId", _descriptor22, this);

          _initializerDefineProperty(this, "toggleUI", _descriptor23, this);

          _initializerDefineProperty(this, "toggleTiger", _descriptor24, this);

          _initializerDefineProperty(this, "rewardItem", _descriptor25, this);

          _initializerDefineProperty(this, "splash", _descriptor26, this);

          _initializerDefineProperty(this, "itemContainer", _descriptor27, this);

          _initializerDefineProperty(this, "labelCollect", _descriptor28, this);

          _initializerDefineProperty(this, "dbBox", _descriptor29, this);

          _initializerDefineProperty(this, "dbHalo", _descriptor30, this);

          _initializerDefineProperty(this, "rewardNode", _descriptor31, this);

          _defineProperty(this, "activityTime", 0);

          _defineProperty(this, "lastUpdateTime", 0);

          _defineProperty(this, "coinadShowBtnI", void 0);

          _defineProperty(this, "oldStar", void 0);

          _defineProperty(this, "oldADShield", void 0);

          _defineProperty(this, "luckyDrawActiveI", 0);

          _defineProperty(this, "luckyDrawShowBtnI", 0);

          _defineProperty(this, "luckyDrawTimer", 0);

          _defineProperty(this, "shieldLastUpdateTime", void 0);

          _defineProperty(this, "villageContainer", null);

          _defineProperty(this, "containerVillage", null);

          _defineProperty(this, "backToSlotPage", true);

          _defineProperty(this, "previewMapId", null);

          _defineProperty(this, "isTigerView", false);

          _defineProperty(this, "p1", new Vec3(161.753, -53.048, 0));

          _defineProperty(this, "p2", new Vec3(0, -700));

          _defineProperty(this, "c1", new Vec3(161.753 * 0.84, (700 - 53.048) * 1.20 - 700));

          _defineProperty(this, "c2", new Vec3(0, (700 - 53.048) * 1.44 - 700));

          _defineProperty(this, "tempVec3", new Vec3());

          _defineProperty(this, "loopFrame", 0);
        }

        onLoad() {
          super.onLoad();
          this.btnRewards.node.on("click", this._onBtnRewardsClick, this);
          this.btnMap.node.on("click", this._onBtnMapClick, this);
          this.btnAdCoin.node.on("click", this.watchCoinAd, this);
          this.editBoxMapId.node.active = appGame.isDev;
          this.toggleUI.node.active = appGame.isDev;
          this.toggleTiger.node.active = appGame.isDev;
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.editBoxMapId.node.active = appGame.isDev;
            this.toggleUI.node.active = appGame.isDev;
            this.toggleTiger.node.active = appGame.isDev;
          });
          this.editBoxMapId.node.on("editing-did-ended", this.changeToMap, this);
          this.editBoxMapId.node.on("editing-did-began", () => {
            this.editBoxMapId.placeholder = "";
          }, this);
          this.editBoxMapId.placeholder = "输入地图ID";
          eventCenter.once(MyCustomEvent.GamePrepareOK, this.initPage, this);
          this.rewardNode.active = false;
          this.showBuildKing();
          this.node.getChildByName("container").getChildByName("UI").getComponent(Widget).top += AppMain.instance.statusBarHeight;
          this.node.getChildByName("container").getChildByName("rewardNode").getComponent(Widget).top += AppMain.instance.statusBarHeight;
        }

        init() {
          this.villageContainer = this.node.getChildByName("container").getChildByName("VillageContainer");
          this.containerVillage = this.villageContainer.getComponent(ContainerVillage);
        }

        slowUpdate(dt) {
          this.updateSuperShield();
          this.updateActivityTime(dt);
        }

        initPage() {
          this.initUpgradeBtns();
          eventCenter.on(MyCustomEvent.BuildLevelUpOrFixOver, () => {
            this.updateProgressBar();
          }); //show name

          this.updateName(this.txtName, Game.SUser); //show avatar

          this.updateAvatar(this.spAvatar, Game.SUser); //广告获取金币数

          this.updateAdCoin(); //show progressBar

          this.updateProgressBar(); //show room name

          this.updateRoomName();
        }

        updateName(nameLabel, User) {
          nameLabel.string = User.Name();
        }

        updateAvatar(sprite, User) {
          sprite.spriteFrame = CommonAssets.instance.avatar_default;
          let avatar = User.Avatar();

          if (avatar != null && avatar.length > 0) {
            assetManager.loadRemote(avatar, {
              ext: ".png"
            }, (err, res) => {
              let texture = new Texture2D();
              texture.image = res;
              let sf = new SpriteFrame();
              sf.texture = texture;
              sprite && (sprite.spriteFrame = sf);
            });
          }
        }

        initUpgradeBtns() {
          // console.log("initUpgradeBtns");
          if (this.upgradeBtns.children.length > 1) {
            this.upgradeBtns.children.forEach((v, i) => {
              let com = v.getComponent(Button);
              com.interactable = true;
            });
            return;
          }

          let buildCount = 5;

          for (let i = 1; i < buildCount; i++) {
            this.upgradeBtns.addChild(instantiate(this.upgradeBtns.children[0]));
          }

          this.upgradeBtns.children.forEach((v, i) => {
            let com = v.getComponent(VillageUpgradeBtn);
            com.initBtn(i + 1);
          });
        }

        _onBtnRewardsClick() {
          SoundManager.playSound("buildKingReward");
          this.rewardNodes.active = !this.rewardNodes.active; // this.activityLeftTime.node.active = !this.rewardNodes.active;

          let touchStart = event => {
            const isInRect = TouchTest.isTouchInRect(event, this.rewardNodes);

            if (!isInRect && this.rewardNodes.active === true && event.target !== this.rewardNodes.parent) {
              this.rewardNodes.active = false; // this.activityLeftTime.node.active = true;

              director.getScene().off(Node.EventType.TOUCH_START, touchStart, this, true);
            }
          };

          if (this.rewardNodes.active) {
            director.getScene().on(Node.EventType.TOUCH_START, touchStart, this, true);
          }
        }

        _onBtnMapClick() {
          LogEventWrap.logEvent("menu_map");
          UIRoot.instance.openChildWindow(NewMapWindow);
          this.backToSlotPage = false;
          this.previewMapId = null;
        }

        updateAdCoin() {
          let old_active = this.btnAdCoin.node.active;
          this.btnAdCoin.node.active = false;
          if (!ADWrap.AdEnabled()) return;
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) return;

          if (this.coinadShowBtnI) {
            clearInterval(this.coinadShowBtnI);
            this.coinadShowBtnI = null;
          }

          const mapId = Game.SUserVillage.MapId();
          let adGetCoinMeta = Meta.MetaManager.GetMeta(Meta.MetaType.AdGetCoin, mapId);
          this.txtAdCoin.string = BigNumber.format(adGetCoinMeta.Coin());
          let adCoinTime = GameKit.PlayerPrefs.GetInt("adCoinTime", 0);

          if (GameKit.TimeUtil.getCurrentHalfDay() !== adCoinTime) {
            GameKit.PlayerPrefs.SetInt("adCoinCount", 0);
            GameKit.PlayerPrefs.SetInt("adCoinTime", GameKit.TimeUtil.getCurrentHalfDay());
          }

          let adCoinCount = GameKit.PlayerPrefs.GetInt("adCoinCount", 0);

          if (adCoinCount < (PaymentWrap.PayEnabled() ? G.GameConfig.adCoinCount : G.GameConfig.adCoinCount * 2)) {
            var showBtn = () => {
              if (!this.node || !this.btnAdCoin) return;
              this.btnAdCoin.node.active = true;
              if (!old_active) EnterCloseAnim.playEnter(this.btnAdCoin);
            };

            if (ADWrap.IsVideoPrepared()) {
              showBtn();
            } else {
              old_active = false;
              this.coinadShowBtnI = setInterval(() => {
                if (ADWrap.IsVideoPrepared()) {
                  showBtn();
                  clearInterval(this.coinadShowBtnI);
                  this.coinadShowBtnI = null;
                }
              }, 3000);
            }
          }
        }

        updateProgressBar() {
          let maxProgress = 0;
          let progress = 0;
          const mapId = Game.SUserVillage.MapId();

          for (let i = 1; i <= 5; i++) {
            progress += Game.SUserVillage.GetLevel(i);
            maxProgress += Meta.VillageShopMeta.GetMaxLevel(mapId, i);
          }

          this.txtProgress.string = `${progress}/ ${maxProgress}`;
          this.progressBar.progress = progress / maxProgress;
        }

        updateRoomName() {
          const id = Game.SUserVillage.MapId();
          this.txtRoomName.string = String.format(i18n.t("map_title"), id, MetaManager.GetMeta(MetaManager.MetaType.Village, Game.SUserVillage.MapId()).ShowName());
        }

        watchCoinAd() {
          if (homeView.isBusy()) return;
          ADWrap.ShowVideo(() => {
            let oldCoin = Game.SUser.Coin();
            let req = SR.SRUserData.finishVideoCoin();
            req.SetCallBack(() => {
              let adCoinTime = GameKit.PlayerPrefs.GetInt("adCoinTime", 0);

              if (GameKit.TimeUtil.getCurrentHalfDay() !== adCoinTime) {
                GameKit.PlayerPrefs.SetInt("adCoinCount", 0);
                GameKit.PlayerPrefs.SetInt("adCoinTime", GameKit.TimeUtil.getCurrentHalfDay());
              }

              let adCoinCount = GameKit.PlayerPrefs.GetInt("adCoinCount", 0);
              GameKit.PlayerPrefs.SetInt("adCoinCount", adCoinCount + 1);
              this.updateAdCoin();

              if (GameMainWindow.instance) {
                GameMainWindow.instance.userinfo.changeCoin(oldCoin, oldCoin, 0); // this.playAddCoinAnim();

                GameMainWindow.instance.scheduleOnce(() => {
                  GameMainWindow.instance.userinfo.changeCoin(oldCoin, Game.SUser.Coin(), 0.8);
                }, 1);
              }
            });
            req.Send();
          }, "watchCoinAd");
        }

        openVillageShop() {
          if (!TutorialManager.IsFinished() && TutorialManager.GetCurrentId() >= 1000003) return;
          UIRoot.instance.openChildWindow(VillageShopWindow);
        }

        updateSuperShield() {
          if (!this.node) return;
          let cTime = GameKit.TimeUtil.getCurrentTime();

          if (!this.shieldLastUpdateTime || cTime - this.shieldLastUpdateTime > 1) {
            this.shieldLastUpdateTime = cTime;
            Game.SUser.superTimeShieldLeft = Game.SUser.SuperTimeShield();
            Game.SUser.UpdateSuperTimeShield();
            Game.SUser.UpdateTimeShield();
            this.spSuperShield.active = Game.SUser.TimeShield() > 0;
            this.labelSliverSuperShieldTime.string = Game.SUser.TimeShield() > 0 ? GameKit.TimeUtil.FormatRemainTimeSimple(Game.SUser.TimeShield(), false, true) : "";
            this.spSuperShieldGold.active = Game.SUser.SuperTimeShield() > 0;
            this.labelGoldSuperShieldTime.string = Game.SUser.SuperTimeShield() > 0 ? GameKit.TimeUtil.FormatRemainTimeSimple(Game.SUser.SuperTimeShield(), false, true) : "";
            this.spSuperShield.parent.getComponent(Widget).updateAlignment();
          }
        }

        OpenSuperShield() {
          homeView.pageViewController.moveToPage(G.Pages.Shop, true);
          homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.shield);
        }

        showBuildKing() {
          this.buildKingNode.active = false;

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            return;
          }

          let activityMeta = ActivityManager.GetActiveGameActivityByType(Meta.ActivityMeta.SubTypes.BuildMaster);

          if (activityMeta) {
            this.buildKingNode.active = true;
            this.activityTime = activityMeta.EndTime() - GameKit.TimeUtil.getCurrentTime();
            this.txtProgress.string = Game.SUserVillage.Score().toString() + " / " + Meta.VillageShopMeta.GetMaxStar(Game.SUserVillage.MapId());
            this.progressBar.progress = Game.SUserVillage.Score() / Meta.VillageShopMeta.GetMaxStar(Game.SUserVillage.MapId());
            let rewards = Content.FromStrings(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.BuildMaster, Game.SUserVillage.MapId() + 1));
            rewards = Content.Merge(rewards);
            this.rewardItem1.show(rewards[0]);
            this.rewardItem2.show(rewards[1]);
          }
        }

        updateActivityTime(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;

          if (this.activityTime) {
            this.activityTime -= dt;
            this.activityLeftTime.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.activityTime, false);
          }
        }

        backToMapWindow() {
          ChangeSceneManager.instance.show(async () => {
            GameMainWindow.instance.node.active = true;
            homeView.villagePage.node.getChildByName("container").getChildByName("UI").active = true;
            homeView.node.getChildByName("tabNode").active = true; // homeView.mapWindow.node.active = true;

            UIRoot.instance.openChildWindow(NewMapWindow, {
              specificMap: this.previewMapId
            });
            await homeView.loadUserData();

            if (this.backToSlotPage) {
              homeView.pageViewController.moveToPage(G.Pages.Slot, true);
            }

            ChangeSceneManager.instance.hide(() => {
              homeView.slotNode.makeIdle();
              this.btnBackToMap.node.active = false;
            });
          });
        } //debug map


        changeToMap(edixBox) {
          const resId = parseInt(edixBox.textLabel.string);

          if (resId < Constant.MaxLevel && resId > 0) {
            const allVillage = MetaManager.GetMetas(MetaManager.MetaType.Village);
            Object.keys(allVillage).forEach((id, indexe) => {
              if (allVillage[id]._data.resId === resId) {
                Game.SUserVillage.setData("mapId", allVillage[id]._data.id);
                homeView.loadUserData();
              }
            });
          } else {
            cce.showToast(`请输入合法的roomID，范围[1-${Constant.MaxLevel}]`);
            this.editBoxMapId.placeholder = "输入地图ID";
            return;
          }
        }

        onToggleUI() {
          let bo = this.toggleUI.isChecked;
          const uiNode = this.node.getChildByName("container").getChildByName("UI");
          uiNode.children.forEach(v => {
            if (v.name === "EditBox" || v.name === "ToggleUI" || v.name === "ToggleTigerView") return;
            v.active = bo;
          });
          homeView.node.getChildByName("tabNode").active = bo;
        }

        onToggleTiger() {
          this.isTigerView = this.toggleTiger.isChecked; // if (this.isTigerView) {
          // 	homeView.villageNode.toggleTigerView();
          // }
        }

        showBuildingKingReward(content) {
          this.rewardNode.getComponent(Widget).updateAlignment();
          return new Promise(resolve => {
            homeView.slotNode.isSpining = true;
            this.rewardNode.active = true;
            tween(this.splash).set({
              opacity: 0
            }).to(0.1, {
              opacity: 180
            }).start();
            tween(this.rewardNode.getChildByName("ProgressRoom")).set({
              opacity: 255
            }).to(0.5, {
              opacity: 0
            }).start();
            this.container.getChildByName("UI").active = false;
            homeView.node.getChildByName("tabNode").active = false;
            GameMainWindow.instance.node.active = false;
            this.dbBox.playAnimation("locked", 0);
            this.dbHalo.once(dragonBones.EventObject.COMPLETE, () => {
              tween(this.dbBox.node).parallel(tween().to(1, {
                position: this.p2
              }, {
                onUpdate: (target, t) => {
                  const temp = 1 - t;
                  this.tempVec3.x = this.p1.x * temp * temp * temp + 3 * this.c1.x * t * temp * temp + 3 * this.c2.x * t * t * temp + this.p2.x * t * t * t;
                  this.tempVec3.y = this.p1.y * temp * temp * temp + 3 * this.c1.y * t * temp * temp + 3 * this.c2.y * t * t * temp + this.p2.y * t * t * t;
                  target.setPosition(this.tempVec3);
                },
                easing: easing.quartIn
              }), tween().to(1, {
                scale: Vec3.ONE
              }, {
                easing: easing.quartIn
              })).call(async () => {
                this.dbBox.on(dragonBones.EventObject.COMPLETE, event => {
                  if (this.dbBox.animationName === "open") {
                    this.dbBox.armature().animation.gotoAndPlayByFrame("open", this.loopFrame, 1);
                  }
                }, this);
                this.dbBox.on(dragonBones.EventObject.FRAME_EVENT, event => {
                  if (event.name === "light") {
                    this.loopFrame = SlotResultHandler.getFrameEventFrame(this.dbBox.dragonAsset, this.dbBox.animationName, "light");
                  }
                }, this);
                this.dbBox.timeScale = 1;
                this.dbBox.playAnimation("open", 1);
                await this.playRewardAnim(content);
                this.labelCollect.active = true;
                this.splash.once(Node.EventType.TOUCH_END, () => {
                  this.resetReward();
                  this.dbBox.timeScale = 0;
                  this.playGetCoinOrApAnim(content, () => {
                    this.container.getChildByName("UI").active = true;
                    eventCenter.emit(MyCustomEvent.CanChangeSpin);
                    this.labelCollect.active = false;
                    homeView.slotNode.makeIdle();
                    resolve(null);
                  });
                }, this);
              }).start();
            }, this);
            this.dbHalo.playAnimation("gift_appear", 1);
          });
        }

        playRewardAnim(content) {
          return new Promise(async resolve => {
            this.itemContainer.active = true;
            this.itemContainer.destroyAllChildren();
            const contents = Content.Merge(content);
            const count = Math.min(3, contents.length);

            for (let i = 0; i < count; i++) {
              let content = Content.FromContent(contents[i]);
              let newItem = instantiate(this.rewardItem);
              this.itemContainer.addChild(newItem);
              newItem.setScale(0, 0, 0);
              const itemContent = newItem.getChildByName("content");
              let labelName = itemContent.getChildByName("labelName").getComponent(Label);
              let labelCount = itemContent.getChildByName("labelNum").getComponent(Label);
              let icon = itemContent.getChildByName("icon").getComponent(Sprite);
              labelCount.string = BigNumber.format(content.Count());
              labelName.string = content.Name();
              content.Icon(icon, nullFunction);
            }

            await cce.wait(1000);

            for (let i = 0; i < this.itemContainer.children.length; i++) {
              await this.playOnce(this.itemContainer.children[i]);

              if (i === this.itemContainer.children.length - 1) {
                await cce.wait(1000);
                resolve(null);
              }
            }
          });
        }

        resetReward() {
          GameMainWindow.instance.node.active = true;
          homeView.node.getChildByName("tabNode").active = true;
          this.rewardNode.active = false;
          this.itemContainer.destroyAllChildren();
          this.dbBox.node.setPosition(this.p1);
          this.dbBox.node.setScale(G.scale0_3);
          this.dbBox.playAnimation("locked", 0);
        }

        playOnce(rewardItem) {
          /**
           * phase1： 到达指定位置时，缩放比最终缩放要大一些，此时的缩放
           * phase2： 到达指定位置后，还需要缩小一次，此时的缩放
           */
          return new Promise((resolve, reject) => {
            let startPos = new Vec3();
            this.itemContainer.inverseTransformPoint(startPos, this.dbBox.node.getWorldPosition());
            const endPos = rewardItem.getPosition();
            tween(rewardItem).set({
              position: startPos,
              scale: Vec3.ZERO
            }).parallel(tween().to(0.3, {
              position: endPos
            }, {
              easing: easing.quartOut
            }), tween().to(0.2, {
              scale: G.scale1_05
            })).call(() => {
              resolve(null);
            }).to(0.1, {
              scale: G.scale0_95
            }).to(0.1, {
              scale: Vec3.ONE
            }).start();
          });
        }

        playGetCoinOrApAnim(content, cb) {
          const promiseAll = [];
          const contents = Content.Merge(content);
          contents.slice(0, 3).forEach(con => {
            let content = Content.FromContent(con);

            if (content.Type() === Content.Types.Coin) {
              promiseAll.push(PlayGetAnimation.playAnimation({
                startNode: uiRoot.node,
                endNode: GameMainWindow.instance.btnCoinAdd.node.getChildByName("iconCoin"),
                count: content.Count(),
                prefab: CommonAssets.instance.coinPrefab,
                startCallback: () => {
                  eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                }
              }));
            } else if (content.Type() === Content.Types.Ap) {
              promiseAll.push(PlayGetAnimation.playAnimation({
                startNode: uiRoot.node,
                endNode: homeView.pageViewController.btnSpin.node,
                count: content.Count(),
                prefab: CommonAssets.instance.energyPrefab
              }));
            }
          });
          Promise.all(promiseAll).then(() => {
            cb && cb();
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "upgradeBtns", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnRewards", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "rewardNodes", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "txtRewards", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spAvatar", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "txtName", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "txtRoomName", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "progressBar", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "txtProgress", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "rewardItem1", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "rewardItem2", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "btnMap", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "btnAdCoin", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "txtAdCoin", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "spSuperShield", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "spSuperShieldGold", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "labelSliverSuperShieldTime", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "labelGoldSuperShieldTime", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "buildKingNode", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "activityLeftTime", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "btnBackToMap", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class2.prototype, "editBoxMapId", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class2.prototype, "toggleUI", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class2.prototype, "toggleTiger", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class2.prototype, "rewardItem", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor26 = _applyDecoratedDescriptor(_class2.prototype, "splash", [_dec27], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor27 = _applyDecoratedDescriptor(_class2.prototype, "itemContainer", [_dec28], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor28 = _applyDecoratedDescriptor(_class2.prototype, "labelCollect", [_dec29], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor29 = _applyDecoratedDescriptor(_class2.prototype, "dbBox", [_dec30], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor30 = _applyDecoratedDescriptor(_class2.prototype, "dbHalo", [_dec31], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor31 = _applyDecoratedDescriptor(_class2.prototype, "rewardNode", [_dec32], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GameKit.ts", ['cc', './BackKeyManager.ts', './StringUtil.ts', './GameEvent.ts', './PlayerPrefs.ts', './ChildWindowChain.ts', './TimeUtil.ts', './ClockUtil.ts', './WebEvent.ts', './BatchRequest.ts', './DownloadRequest.ts', './NetRequest.ts', './ServerRequest.ts', './DataCache.ts', './FuncTools.ts', './ControllerTable.ts'], function (exports) {
  'use strict';

  var cclegacy, BackKeyManager, StringUtil, GameEvent, PlayerPrefs, ChildWindowChain, TimeUtil, ClockUtil, WebEvent, BatchRequest, DownloadRequest, NetRequest, ServerRequest, DataCache, FuncTools, ControllerTable;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      BackKeyManager = module.BackKeyManager;
    }, function (module) {
      StringUtil = module.StringUtil;
    }, function (module) {
      GameEvent = module.GameEvent;
    }, function (module) {
      PlayerPrefs = module.PlayerPrefs;
    }, function (module) {
      ChildWindowChain = module.default;
    }, function (module) {
      TimeUtil = module.TimeUtil;
    }, function (module) {
      ClockUtil = module.ClockUtil;
    }, function (module) {
      WebEvent = module.WebEvent;
    }, function (module) {
      BatchRequest = module.default;
    }, function (module) {
      DownloadRequest = module.default;
    }, function (module) {
      NetRequest = module.default;
    }, function (module) {
      ServerRequest = module.default;
    }, function (module) {
      DataCache = module.DataCache;
    }, function (module) {
      FuncTools = module.FuncTools;
    }, function (module) {
      ControllerTable = module.default;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "b84dau1nUpDa46GSkejv9Wi", "GameKit", undefined);

      class GameKit {}

      exports('GameKit', GameKit);

      _defineProperty(GameKit, "TimeUtil", TimeUtil);

      _defineProperty(GameKit, "ServerRequest", ServerRequest);

      _defineProperty(GameKit, "StringUtil", StringUtil);

      _defineProperty(GameKit, "PlayerPrefs", PlayerPrefs);

      _defineProperty(GameKit, "GameEvent", GameEvent);

      _defineProperty(GameKit, "ClockUtil", ClockUtil);

      _defineProperty(GameKit, "BackKeyManager", BackKeyManager);

      _defineProperty(GameKit, "NetRequest", NetRequest);

      _defineProperty(GameKit, "BatchRequest", BatchRequest);

      _defineProperty(GameKit, "WebEvent", WebEvent);

      _defineProperty(GameKit, "DownloadRequest", DownloadRequest);

      _defineProperty(GameKit, "DataCache", DataCache);

      _defineProperty(GameKit, "FuncTools", FuncTools);

      _defineProperty(GameKit, "ControllerTable", ControllerTable);

      _defineProperty(GameKit, "ChildWindowChain", ChildWindowChain);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AppUpdateWindow.ts", ['cc', './Constant.ts', './UIWindow.ts', './LogEventWrap.ts', './NativeWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Button, _decorator, MyCustomEvent, UIWindow, LogEventWrap, NativeWrap, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Button = module.Button;
      _decorator = module._decorator;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      NativeWrap = module.NativeWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "b931dltz4FNEarfyPSyDQGO", "AppUpdateWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AppUpdateWindow = exports('default', (_dec = property(Button), _dec2 = property(Button), _dec3 = property(Button), ccclass(_class = (_class2 = (_temp = _class3 = class AppUpdateWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "btnUpdate", _descriptor, this);

          _initializerDefineProperty(this, "btnWebsite", _descriptor2, this);

          _initializerDefineProperty(this, "btnClose", _descriptor3, this);

          _defineProperty(this, "closeCallback", null);
        }

        onShow(showParams) {
          // if (AppKit.NativeWrap.mustUpdateNewVersion()) {
          // 	this.btnClose.active = false;
          // }
          if (showParams.onClose) {
            this.closeCallback = showParams.onClose;
          }

          this.btnClose.node.active = appGame.isDev;
          this.btnWebsite.node.active = appGame.isDev;
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.btnClose.node.active = appGame.isDev;
            this.btnWebsite.node.active = appGame.isDev;
          }, this);

          if (!appGame.isDev) {
            this.btnUpdate.node.y -= 24;
          }

          GameKit.BackKeyManager.registerBackEvent();
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        callClose() {
          this.closeAnim();
          this.closeCallback && this.closeCallback();
          LogEventWrap.logEvent("app_update_close", {
            version: NativeWrap.getVersion()
          });
        }

        callGo() {
          NativeWrap.openMarket();
          LogEventWrap.logEvent("app_update_go", {
            version: NativeWrap.getVersion()
          });
        }

        callWebsite() {
          jsb["openURL"]("https://fay-res.oss-cn-beijing.aliyuncs.com/gameking/coin/bundles/index.html");
        }

      }, _defineProperty(_class3, "windowPath", "Sys/NewAppUpdateWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "btnUpdate", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btnWebsite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btnClose", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FullLoadingWindow.ts", ['cc', './UIWindow.ts', './ChangeSceneManager.ts', './UIRoot.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UIWindow, ChangeSceneManager, UIRoot, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "b9543IOE5NASYyL/1geINPA", "FullLoadingWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FullLoadingWindow = exports('FullLoadingWindow', ccclass(_class = (_temp = _class2 = class FullLoadingWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "showFunc", void 0);
        }

        static Show(cb) {
          UIRoot.instance.openModelWindow("FullLoadingWindow", {
            showFunc: cb
          });
        }

        static Hide() {
          UIRoot.instance.closeChildWindow("FullLoadingWindow");
        }

        onShow(showParams) {
          this.showFunc = globalThis.addFunction(this.showFunc, showParams.showFunc);
          if (FullLoadingWindow.isshow) return;
          FullLoadingWindow.isshow = true;
          ChangeSceneManager.instance.show(this.showFunc);
          GameKit.BackKeyManager.registerBackEvent();
        }

        onClose() {
          FullLoadingWindow.isshow = false;
          ChangeSceneManager.instance.hide();
          GameKit.BackKeyManager.unregisterBackEvent();
        }

      }, _defineProperty(_class2, "isshow", false), _defineProperty(_class2, "windowPath", "Common/FullLoadingWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ErrorCode.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      exports('ErrorCode', void 0);

      cclegacy._RF.push({}, "ba769llQWpDQZI+b7m1apFm", "ErrorCode", undefined);

      let ErrorCode;

      (function (_ErrorCode) {
        const PAYMENT_VERIFY_ERROR = _ErrorCode.PAYMENT_VERIFY_ERROR = 1703;
        const SUCCESS = _ErrorCode.SUCCESS = 0;
        const UNKNOWN = _ErrorCode.UNKNOWN = 1001;
        const UNKNOWN_CLIENT = _ErrorCode.UNKNOWN_CLIENT = 1002;
        const AD_TOOMANY_FAILED = 1114;

        function muteError(code) {
          switch (code) {
            /*case ErrorCode.USERDATA_NOT_ENOUGH:
            case ErrorCode.COIN_NOT_ENOUGH:
            case ErrorCode.AP_NOT_ENOUGH:
            {
                AppGame.instance.reqUserData()
                return true
            }*/
            case PAYMENT_VERIFY_ERROR:
              return true;
          }

          return false;
        }

        _ErrorCode.muteError = muteError;

        function tipError(code) {
          switch (code) {
            /*case ErrorCode.USERDATA_NOT_ENOUGH:
            case ErrorCode.COIN_NOT_ENOUGH:
            case ErrorCode.AP_NOT_ENOUGH:
            {
                AppGame.instance.reqUserData()
                return true
            }*/
            case AD_TOOMANY_FAILED:
              return true;
          }

          return false;
        }

        _ErrorCode.tipError = tipError;
      })(ErrorCode || (ErrorCode = exports('ErrorCode', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardItem.ts", ['cc', './CCE_Component.ts', './_app.ts', './MetaManager.ts', './LocalizedManager.ts', './CardSingleSetWindow.ts', './UIRoot.ts', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, Label, ProgressBar, _decorator, Button, SpriteFrame, CCE_Component, cce, MetaManager, rigisterLabel, CardSingleSetWindow, UIRoot, Game, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
      _decorator = module._decorator;
      Button = module.Button;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      rigisterLabel = module.rigisterLabel;
    }, function (module) {
      CardSingleSetWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "bbb8cMh3kZAKrzWJbOsDFFo", "CardItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        BASE_PATH: "res/Card",
        // set-icon的基础path
        SET_ICON_FILENAME: "set-icon"
      };
      let CardItem = exports('CardItem', (_dec = ccclass("CardItem"), _dec2 = property(Node), _dec3 = property(Sprite), _dec4 = property(Label), _dec5 = property(ProgressBar), _dec6 = property(Label), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Label), _dec(_class = (_class2 = (_temp = class CardItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "unlockedNode", _descriptor, this);

          _initializerDefineProperty(this, "sp_icon", _descriptor2, this);

          _initializerDefineProperty(this, "label_set_name", _descriptor3, this);

          _initializerDefineProperty(this, "pb", _descriptor4, this);

          _initializerDefineProperty(this, "label_pb", _descriptor5, this);

          _initializerDefineProperty(this, "completed", _descriptor6, this);

          _initializerDefineProperty(this, "lockNdoe", _descriptor7, this);

          _initializerDefineProperty(this, "label_lock", _descriptor8, this);

          _defineProperty(this, "_meta", void 0);
        }

        updatePanel(meta, index) {
          this._meta = meta; // 判定是否为lock

          const isLock = Game.SUserVillage.MapId() < meta.MinVillage(); // true表示被lock

          this.lockNdoe.active = isLock;
          this.unlockedNode.active = !isLock;

          if (isLock) {
            this.node.getComponent(Button).interactable = false;
            this.label_lock.string = String.format(i18n.t("CardAllSetWindowLock"), meta.MinVillage());
            rigisterLabel("CardAllSetWindowLock", this.label_lock, meta.MinVillage());
          } else {
            this.node.getComponent(Button).interactable = true;
            this.label_set_name.string = meta.Name();
            const card_meta = MetaManager.GetMeta(MetaManager.MetaType.Card, meta.Data().cover_card_id);
            const resPath = `${C.BASE_PATH}/${card_meta.Data().icon}`;
            cce.loadRes(resPath, SpriteFrame, (err, res) => {
              if (!err && this.sp_icon) {
                this.sp_icon.spriteFrame = res;
              }
            });
            let count = 0;

            for (let i = 1; i <= 9; i++) {
              count += Game.SUserCard.HaveCard(index * 100 + i) ? 1 : 0;
            }

            this.pb.progress = count / 9;
            this.label_pb.string = `${count} / 9`;
          } // 点击事件跳转


          this.node.on("click", () => {
            if (homeView.cardAllSetWindow.cardSingleWindowOpened) return;
            homeView.cardAllSetWindow.cardSingleWindowOpened = true;
            UIRoot.instance.openChildWindow(CardSingleSetWindow, {
              single_set_meta: meta,
              showCallback: win => {
                win.addOnCloseFunc(() => {
                  homeView.cardAllSetWindow.cardSingleWindowOpened = false;
                });
              }
            });
          });
          this.update_compelete();
        }
        /** 更新领奖后的completed的显示 */


        update_compelete() {
          let is_get_reward = Game.SUserCard.HasgotSetsReward(this._meta.Id());
          this.pb.node.active = !is_get_reward;
          this.completed.active = is_get_reward;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "unlockedNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sp_icon", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "label_set_name", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "pb", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "label_pb", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "completed", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "lockNdoe", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "label_lock", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Player.ts", ['cc', './Constant.ts', './SoundManager.ts', './ResourceLoader.ts', './CameraController3d.ts', './RoomManager.ts', './SlotPet.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, SkeletalAnimation, ParticleSystem, Node, instantiate, Tween, MyCustomEvent, PlayerAnimName, PetType, CameraLayers, SoundManager, ResourceLoader, CameraController3d, RoomManager, SlotPet, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      SkeletalAnimation = module.SkeletalAnimation;
      ParticleSystem = module.ParticleSystem;
      Node = module.Node;
      instantiate = module.instantiate;
      Tween = module.Tween;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      PlayerAnimName = module.PlayerAnimName;
      PetType = module.PetType;
      CameraLayers = module.CameraLayers;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      CameraController3d = module.default;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      SlotPet = module.default;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "bcfbclaCzpKpZW3iZ79cu0v", "Player", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Player = exports('default', (_dec = ccclass("Player"), _dec(_class = (_temp = _class2 = class Player extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "petSlot", void 0);

          _defineProperty(this, "pet", void 0);

          _defineProperty(this, "motionStreak", void 0);

          _defineProperty(this, "animation", null);

          _defineProperty(this, "isRunning", false);

          _defineProperty(this, "progress", 0);

          _defineProperty(this, "startPos", new Vec3());

          _defineProperty(this, "dstPos", new Vec3());

          _defineProperty(this, "moveTime", 2);
        }

        async onLoad() {
          Player.instance = this;
          Reflect.defineProperty(globalThis, "player", {
            value: this,
            configurable: true
          });
          eventCenter.on(MyCustomEvent.ChangePet, this.changePet, this);
          this.animation = this.getComponent(SkeletalAnimation);
          this.motionStreak = this.getComponentInChildren(ParticleSystem);
          this.motionStreak && (this.motionStreak.node.active = false);
          let petSlot = this.node.getChildByName("PetSlot");

          if (petSlot) {
            this.petSlot = petSlot;
          } else {
            this.petSlot = new Node();
            this.petSlot.name = "PetSlot";
            this.petSlot.position = new Vec3(-1.171, 0, -0.992);
            this.node.addChild(this.petSlot);
          }

          await this.changePet();
        }

        start() {
          console.log("Player Start");
          CameraController3d.instance.setTarget(this.node);
          this.animation && this.animation.play(PlayerAnimName.idle);
        }

        update(dt) {
          if (this.isRunning && this.progress <= 1) {
            this.progress += dt / this.moveTime;

            if (this.progress >= 1) {
              this.progress = 1;
              this.isRunning = false;
              this.onRunEnd();
            }

            this.node.position = Vec3.lerp(this.node.position, this.startPos, this.dstPos, this.progress);
          }
        }

        startMove() {
          if (this.isRunning) return;
          console.log("startMove");
          this.isRunning = true;
          this.animation && this.animation.play(PlayerAnimName.run);
          SoundManager.playSound("foot_step4", 1, true);
          this.pet && this.pet.onPlayerMoveStart();
          this.motionStreak && (this.motionStreak.node.active = true);
          this.progress = 0;
          this.startPos = this.node.position.clone();
          this.dstPos = this.startPos.clone().add(new Vec3(0, 0, RoomManager.interval));
          RoomManager.instance.nextRoom.setupEvent();
          eventCenter.emit(MyCustomEvent.PlayerRunStart);
        }

        onRunEnd() {
          console.log("onRunEnd");
          this.isRunning = false;
          SoundManager.stopSound("foot_step4");
          this.animation && this.animation.play(PlayerAnimName.idle);
          this.pet && this.pet.onPlayerMoveEnd();
          this.scheduleOnce(() => {
            this.motionStreak && (this.motionStreak.node.active = false);
          }, 0.5);
          RoomManager.instance.moveToward();
          RoomManager.instance.curRoom.onPlayerEnter();
          eventCenter.emit(MyCustomEvent.PlayerRunEnd);
        }

        async changePet() {
          const pets = [PetType.Pig, PetType.Tiger, PetType.Dog, PetType.Rabbit];
          const id = parseInt(Game.SUserServant.GetSelected());

          if (id > 0) {
            let petName = pets[id - 1];
            let resPath = `pet/${petName}`;
            let pb = await ResourceLoader.loadCommonPrefab(resPath);
            if (!pb) return;
            let petNode = instantiate(pb);
            this.node.parent.addChild(petNode);
            petNode.setWorldPosition(this.petSlot.worldPosition);
            petNode.getFlattedChildrenRecursively().forEach(v => v.layer = CameraLayers.slot3d); // petNode.layer = CameraLayers.slot3d;

            if (this.pet && this.pet.node) {
              Tween.stopAllByTarget(this.pet.node);
              this.pet.node.destroy();
            }

            this.pet = petNode.addComponent(SlotPet);
            this.pet.offset = this.petSlot.worldPosition.clone().subtract(this.node.worldPosition);
          }
        }

      }, _defineProperty(_class2, "instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AnimaSkiresorts.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts'], function (exports) {
  'use strict';

  var cclegacy, v3, Node, _decorator, CCE_Component, CCEaseTypes;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v3 = module.v3;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "bd10dZJGeJBh73Bmhovxd46", "AnimaSkiresorts", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        // 缆车动画配置
        // 缆车动画为先摆动10度，再摆回，再摆动30度，再摆回
        cable: {
          time1: 1,
          // 第1次摆动时间
          rotate1: 10,
          // 第1次摆动角度
          wait1: 0,
          // 第1次摆动后暂停时间
          time2: 2,
          // 第2次摆动时间
          rotate2: 20,
          // 第2次摆动角度
          wait2: 0.5 // 第2次摆动后暂停时间

        },
        cable_ease_go: CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut),
        cable_ease_back: CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn),
        // 缆车影子动画
        // 跟随缆车动画
        cable_shadow: {
          position_source: v3(0, -180),
          // 原位置
          position1: v3(-35, -170),
          // 第1次摆动后的影子位置
          position2: v3(-70, -145) // 第2次摆动后影子位置

        },
        // 雪人动画配置
        // 雪人动画为先x轴缩放到0.9/y轴缩放到1.1，在x轴缩放到1.1/y轴缩放到0.9，再缩回到1
        snowman: {
          time: 1,
          // 缩放时间
          scale1: 0.95,
          // 缩放倍数1
          scale2: 1.05,
          // 缩放倍数2
          wait: 1 // 缩放完成后的停留时间

        }
      };
      /**
       * map-skisorts动画
       */

      let AnimaSkisorts = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), ccclass(_class = (_class2 = (_temp = class AnimaSkisorts extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "cable_list", _descriptor, this);

          _initializerDefineProperty(this, "cable_shadow_list", _descriptor2, this);

          _initializerDefineProperty(this, "snowman_list", _descriptor3, this);
        }

        onLoad() {
          for (let cable of this.cable_list) {
            cable.runAction(ccAction.sequence(ccAction.rotateTo(C.cable.time1, C.cable.rotate1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut)), ccAction.rotateTo(C.cable.time1, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn)), ccAction.delayTime(C.cable.wait1), ccAction.rotateTo(C.cable.time2, C.cable.rotate2, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut)), ccAction.rotateTo(C.cable.time2, 0, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn)), ccAction.delayTime(C.cable.wait2)).repeatForever());
          }

          for (let cable_shadow of this.cable_shadow_list) {
            cable_shadow.runAction(ccAction.sequence(ccAction.moveTo(C.cable.time1, C.cable_shadow.position1, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut)), ccAction.moveTo(C.cable.time1, C.cable_shadow.position_source, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn)), ccAction.delayTime(C.cable.wait1), ccAction.moveTo(C.cable.time2, C.cable_shadow.position2, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut)), ccAction.moveTo(C.cable.time2, C.cable_shadow.position_source, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn)), ccAction.delayTime(C.cable.wait2)).repeatForever());
          }

          for (let snowman of this.snowman_list) {
            snowman.runAction(ccAction.sequence(ccAction.scaleTo(C.snowman.time, C.snowman.scale1, C.snowman.scale2), ccAction.scaleTo(C.snowman.time * 2, C.snowman.scale2, C.snowman.scale1), ccAction.scaleTo(C.snowman.time, 1), ccAction.delayTime(C.snowman.wait)).repeatForever());
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "cable_list", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "cable_shadow_list", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "snowman_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CCButtonAutoGreyLabel.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Color, _decorator, Button, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Color = module.Color;
      _decorator = module._decorator;
      Button = module.Button;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "be9081hypdA4LNCwPaq2n6X", "CCButtonAutoGreyLabel", undefined);

      const {
        ccclass,
        property,
        menu,
        executeInEditMode
      } = _decorator;
      let CCButtonAutoGreyLabel = exports('default', (_dec = menu("GameKit/extentions/CCButtonAutoGreyLabel"), _dec2 = property([Label]), _dec3 = property(Color), _dec4 = property(Color), ccclass(_class = _dec(_class = executeInEditMode(_class = (_class2 = (_temp = class CCButtonAutoGreyLabel extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labels", _descriptor, this);

          _initializerDefineProperty(this, "colorEnable", _descriptor2, this);

          _initializerDefineProperty(this, "colorDisable", _descriptor3, this);

          _defineProperty(this, "button", void 0);

          _defineProperty(this, "interactable", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        slowUpdate(dt) {
          if (!this.button) {
            this.button = this.getComponent(Button);
            if (!this.button) return;
          }

          if (!this.button.enableAutoGrayEffect) return;

          if (this.interactable == this.button.interactable) {
            return;
          }

          this.interactable = this.button.interactable;

          if (this.interactable) {
            this.labels.forEach(label => {
              label.node.color = this.colorEnable;
            });
          } else {
            this.labels.forEach(label => {
              label.node.color = this.colorDisable;
            });
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labels", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "colorEnable", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "colorDisable", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageMeta.ts", ['cc', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "bf86cME501Bd5/B17oTxqDj", "VillageMeta", undefined);

      class VillageMeta {
        constructor() {
          _defineProperty(this, "_data", void 0);
        }

        static MakeEntity(data) {
          let meta = new VillageMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = data;
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        Name() {
          return this._data.name;
        }

        ResId() {
          return this._data.resId;
        }

        ShowName() {
          return i18n.sel(this._data.showname);
        }

      }

      exports('VillageMeta', VillageMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/JigsawWindow.ts", ['cc', './PlayAudio.ts', './UIWindow.ts', './DialogWindow.ts', './JigsawNewsWindow.ts', './JigsawWindowGift.ts', './JigsawWindowMain.ts', './JigsawWindowPiece.ts', './UIRoot.ts', './StaticGame.ts', './ShareWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, PlayAudio, UIWindow, DialogWindow, JigsawNewsWindow, JigsawWindowGift, JigsawWindowMain, JigsawWindowPiece, UIRoot, Game, ShareWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      PlayAudio = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      JigsawNewsWindow = module.default;
    }, function (module) {
      JigsawWindowGift = module.default;
    }, function (module) {
      JigsawWindowMain = module.default;
    }, function (module) {
      JigsawWindowPiece = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "bfa17ybJJhAtYPWBl4/NxK9", "JigsawWindow", undefined);
      /** @author fengyong-2-26 */


      const {
        ccclass,
        property
      } = _decorator;
      let JigsawWindow = exports('default', (_dec = property(Label), _dec2 = property(JigsawWindowPiece), _dec3 = property(JigsawWindowMain), _dec4 = property(JigsawWindowGift), ccclass(_class = (_class2 = (_temp = _class3 = class JigsawWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "label_time_left", _descriptor, this);

          _initializerDefineProperty(this, "piece", _descriptor2, this);

          _initializerDefineProperty(this, "main", _descriptor3, this);

          _initializerDefineProperty(this, "gift", _descriptor4, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);
        }

        onShow(showParams) {
          JigsawWindow.ins = this;
          this.meta = showParams.meta;
          this.main.load_page();
          this.piece.load_page();
          this.gift.load_page();
          this.leftTime = this.meta.EndTime() - GameKit.TimeUtil.getCurrentTime();
          this.update_time(0);
          setTimeout(() => {
            homeView.node.active = false;
          }, 0.5);
          GameKit.BackKeyManager.registerBackEvent(() => {
            homeView.node.active = true;
            PlayAudio.playClose();
            this.closeAnim();
          });
        }

        onClose() {
          JigsawWindow.ins = null;
          GameKit.BackKeyManager.unregisterBackEvent();
          homeView.node.active = true;
          this.main.Clear();
          this.piece.Clear();
        }

        slowUpdate(dt) {
          this.update_time(dt);
        }
        /** 获取meta和data数据，组合为[data,meta.Param()]，需要通过解构赋值 */


        get_data_and_metaparam() {
          let data = Game.SUserActivity.GetActivityData(this.meta.Id());
          data = Object.keys(data).length != 0 ? data : {
            jigsawData: [0, 0, 0, 0, 0, 0, 0, 0, 0],
            pieceData: [0, 0, 0, 0, 0, 0, 0, 0, 0],
            pieceLock: [0, 0, 0, 0, 0, 0, 0, 0, 0],
            message: []
          };
          let metaparam = this.meta.Param();
          return [data, metaparam];
        }

        event_close() {
          homeView.node.active = true;
          this.closeAnim();
        }

        event_share() {
          ShareWrap.shareScreen(i18n.t("ShareJigsawTitle"), {
            x: 0,
            y: 20,
            width: 640,
            height: 960
          }, {}, null, "jigsaw");
        }

        event_message() {
          let [data, metaparam] = this.get_data_and_metaparam();
          UIRoot.instance.openChildWindow(JigsawNewsWindow, {
            msg_list: data.message
          });
        }

        update_time(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;

          if (this.leftTime != null) {
            this.leftTime -= dt;

            if (this.leftTime <= 0) {
              this.leftTime = null;
              homeView.node.active = true;
              this.closeAnim(() => {
                DialogWindow.Show(i18n.t("ActivityCenterTimeEnd"), nullFunction);
              });
              return;
            }

            this.label_time_left.string = String.format(i18n.t("ActivityCenterTime"), GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, true));
          }
        }

      }, _defineProperty(_class3, "windowPath", "Activity/Jigsaw/JigsawWindow"), _defineProperty(_class3, "res_path", "res/Activity/Jigsaw/"), _defineProperty(_class3, "ins", void 0), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "label_time_left", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "piece", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "main", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "gift", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DownloadingWindow.ts", ['cc', './UIWindow.ts', './UIRoot.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, ProgressBar, Label, _decorator, UIWindow, UIRoot, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      ProgressBar = module.ProgressBar;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "bffa41wfwpMypKWv3GwXtmJ", "DownloadingWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let DownloadingWindow = exports('DownloadingWindow', (_dec = property(Node), _dec2 = property(ProgressBar), _dec3 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class DownloadingWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "sp", _descriptor, this);

          _initializerDefineProperty(this, "progress", _descriptor2, this);

          _initializerDefineProperty(this, "labelProgress", _descriptor3, this);

          _defineProperty(this, "completeFunc", void 0);

          _defineProperty(this, "progressFunc", void 0);
        }

        static Show(completeFunc, progressFunc) {
          UIRoot.instance.openChildWindow(DownloadingWindow, {
            completeFunc: completeFunc,
            progressFunc: progressFunc
          });
        }

        onShow(showParams) {
          this.completeFunc = showParams.completeFunc;
          this.progressFunc = showParams.progressFunc;
          GameKit.BackKeyManager.registerBackEvent(); // this.scheduleOnce(this.showModel.bind(this), 2);

          this.scheduleOnce(this.showModel.bind(this), 0);
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        onEnable() {
          this.sp.stopAllActions();
          this.sp.active = false;
        }

        onDisable() {}

        showModel() {
          if (!this.sp.active) {
            this.sp.active = true;
            this.sp.opacity = 1;
            this.sp.runAction(ccAction.fadeIn(0.3));
          }
        }

        slowUpdate() {
          this.labelProgress.string = this.progressFunc ? this.progressFunc() : "";

          if (this.completeFunc && this.completeFunc()) {
            this.labelProgress.string = this.progressFunc ? "100%" : "";
            this.close();
          }
        }

      }, _defineProperty(_class3, "windowPath", "Common/DownloadingWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sp", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "progress", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelProgress", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LocalizationMeta.ts", ['cc', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "c01faKS6iZHCLeLdswUI8Dr", "LocalizationMeta", undefined);

      class LocalizationMeta {
        constructor() {
          _defineProperty(this, "_data", null);
        }

        static MakeEntity(data) {
          let meta = new LocalizationMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = data;
        }

        Id() {
          return this._data.id;
        }

        getDataByLocale(locale) {
          return this._data[locale];
        }

      }

      exports('LocalizationMeta', LocalizationMeta);

      _defineProperty(LocalizationMeta, "GetMeta", function (setId, index) {
        return Meta.MetaManager.GetMeta(Meta.MetaType.locale, setId * 100 + index);
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MoveAnim.ts", ['cc', './CCE_Component.ts', './_app.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, CCE_Component, cce;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      cce = module.cce;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c02a5xR6tdJs7YU86FCLSZ9", "MoveAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let MoveAnim = exports('default', (_dec = property(CCInteger), _dec2 = property(CCInteger), _dec3 = property(CCInteger), _dec4 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class MoveAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "dis", _descriptor, this);

          _initializerDefineProperty(this, "disx", _descriptor2, this);

          _initializerDefineProperty(this, "time", _descriptor3, this);

          _initializerDefineProperty(this, "delay", _descriptor4, this);

          _defineProperty(this, "playing", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          this.playing = true;
          this.scheduleOnce(function () {
            this.playing = false;
          }.bind(this), this.delay);
        }

        slowUpdate(dt) {
          if (this.playing) return;
          this.node.runAction(ccAction.sequence(ccAction.moveBy(this.time, this.disx, this.dis, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)), ccAction.moveBy(this.time, -this.disx, -this.dis, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)), ccAction.delayTime(this.delay) //ccAction.callFunc(function(){ this.playing = false }, this)
          ).repeatForever());
          this.playing = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "dis", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "disx", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "delay", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DotAnimLabel.ts", ['cc', './CCE_Component.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, CCString, _decorator, Label, RichText, CCE_Component, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCString = module.CCString;
      _decorator = module._decorator;
      Label = module.Label;
      RichText = module.RichText;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c0c506Qds9BMZEf1R7ZTvCn", "DotAnimLabel", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let DotAnimLabel = exports('default', (_dec = property(CCString), _dec2 = property({
        multiline: true,
        tooltip: 'Enter i18n key here'
      }), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class DotAnimLabel extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "delay", _descriptor, this);

          _initializerDefineProperty(this, "_textKey", _descriptor2, this);

          _initializerDefineProperty(this, "isBold", _descriptor3, this);

          _defineProperty(this, "dotCount", void 0);

          _defineProperty(this, "dotT", void 0);
        }

        set textKey(value) {
          this._textKey = value;
          this.onLoad();
        }

        get textKey() {
          return this._textKey;
        }

        onLoad() {
          let label = this.getComponent(Label);

          if (label != null) {
            label.string = i18n.t(this.textKey);
          }

          label = this.getComponent(RichText);

          if (label != null) {
            label.string = i18n.t(this.textKey);
            if (this.isBold) label.string = '<b>' + label.string + '</b>';
          }

          this.dotCount = 0;
          this.dotT = 0;
        }

        slowUpdate(dt) {
          this.dotT += dt;

          if (this.dotT >= this.delay) {
            this.dotCount++;
            if (this.dotCount > 3) this.dotCount -= 4;
            this.dotT = 0;
            let dotstr = "";

            for (let i = 0; i < this.dotCount; i++) {
              dotstr += ".";
            }

            let label = this.getComponent(Label);

            if (label != null) {
              label.string = i18n.t(this.textKey) + dotstr;
            }

            label = this.getComponent(RichText);

            if (label != null) {
              label.string = i18n.t(this.textKey);
              if (this.isBold) label.string = '<b>' + label.string + dotstr + '</b>';
            }
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "delay", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "_textKey", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "TEXT_KEY";
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "textKey", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "textKey"), _class2.prototype), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "isBold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BadgeItem.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c154et58+9G2ZrLz7AZUOmf", "BadgeItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BadgeItem = exports('default', (_dec = property(Label), ccclass(_class = (_class2 = (_temp = class BadgeItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "label", _descriptor, this);

          _defineProperty(this, "num", void 0);
        }

        onLoad() {
          this.num = 0;
        }

        SetNum(n) {
          this.label.string = n.toString();
          this.node.active = n > 0;
          this.num = n;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "label", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/OffsetAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Button, _decorator, Node, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Button = module.Button;
      _decorator = module._decorator;
      Node = module.Node;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c27f3NtfiZNLYUI4D54V6Dj", "OffsetAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let OffsetAnim = exports('default', (_dec = property(Button), ccclass(_class = (_class2 = (_temp = class OffsetAnim extends CCE_Component {
        constructor() {
          super();

          _initializerDefineProperty(this, "offsetX", _descriptor, this);

          _initializerDefineProperty(this, "offsetY", _descriptor2, this);

          _initializerDefineProperty(this, "button", _descriptor3, this);

          _defineProperty(this, "oldY", void 0);

          _defineProperty(this, "oldX", void 0);

          this.oldY = 0;
          this.oldX = 0;
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          var self = this;
          self.button.node.offsetAnim = self;
          self.oldY = this.node.y;
          self.oldX = this.node.x;
        }

        onEnable() {
          // 随着按钮按下和释放，偏移位置
          var self = this;
          self.button.node.on(Node.EventType.TOUCH_START, self.onButtonPress, this);
          self.button.node.on(Node.EventType.TOUCH_END, self.onButtonRelease, this);
          self.button.node.on(Node.EventType.TOUCH_CANCEL, self.onButtonRelease, this);
        }

        onDisable() {
          this.node.targetOff(this.node);
        }

        start() {}

        onButtonPress(event) {
          var self = this;
          self.node.x = self.oldX + self.offsetX;
          self.node.y = self.oldY + self.offsetY;
        }

        onButtonRelease(event) {
          if (!event.simulate) {
            var self = this;
            self.node.x = self.oldX;
            self.node.y = self.oldY;
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "offsetX", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "offsetY", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "button", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardSystemOpenWindow.ts", ['cc', './global.ts', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, G, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "c2e55gmOkRJDap0cBdM/t4A", "CardSystemOpenWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CardSystemOpenWindow = exports('CardSystemOpenWindow', ccclass(_class = (_temp = _class2 = class CardSystemOpenWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "childWindowChain", void 0);
        }

        onShow(showParams) {}

        onClose() {}

        callClose() {
          this.closeAnim(() => {
            homeView.checkSubTutorial();
          });
        }

        callGo() {
          if (this.childWindowChain) {
            this.clearOnCloseFunc();
            this.childWindowChain.end();
          }

          this.closeAnim();
          homeView.pageViewController.moveToPage(G.Pages.Collection, true);
          this.scheduleOnce(() => {
            homeView.checkSubTutorial();
          }, 2);
        }

      }, _defineProperty(_class2, "windowPath", "Card/NewCardSystemOpenWindow"), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MessageMailDetailWindow.ts", ['cc', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c2eabvhjHlDF6DBzIRJSV4U", "MessageMailDetailWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let MessageMailDetailWindow = exports('MessageMailDetailWindow', (_dec = property(Label), _dec2 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class MessageMailDetailWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelTitle", _descriptor, this);

          _initializerDefineProperty(this, "labelMsg", _descriptor2, this);
        }

        onShow(showParams) {
          if (!showParams.present) return;
          if (showParams.present.title) this.labelTitle.string = showParams.present.title;
          if (showParams.present.msg) this.labelMsg.string = showParams.present.msg;
        }

        call_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Menu/NewMessageMailDetailWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelTitle", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelMsg", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ObjsNode.ts", ['cc', './CCE_Component.ts', './SlotItemNode.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Node, _decorator, CCE_Component, SlotItemNode;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SlotItemNode = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c3af7iwmNlMlpRsQmyiXh5F", "ObjsNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ObjsNode = exports('default', (_dec = property([SlotItemNode]), _dec2 = property(Sprite), _dec3 = property(Sprite), _dec4 = property(Sprite), _dec5 = property(Sprite), _dec6 = property(Sprite), _dec7 = property(Sprite), _dec8 = property(Node), _dec9 = property(Sprite), ccclass(_class = (_class2 = (_temp = class ObjsNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "items", _descriptor, this);

          _initializerDefineProperty(this, "raidSprite", _descriptor2, this);

          _initializerDefineProperty(this, "raidBlurSprite", _descriptor3, this);

          _initializerDefineProperty(this, "coin2_1", _descriptor4, this);

          _initializerDefineProperty(this, "coin2_2", _descriptor5, this);

          _initializerDefineProperty(this, "coin2_1Blur", _descriptor6, this);

          _initializerDefineProperty(this, "coin2_2Blur", _descriptor7, this);

          _initializerDefineProperty(this, "spSymbol", _descriptor8, this);

          _initializerDefineProperty(this, "spriteSymbol", _descriptor9, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        showBlur() {
          this.items.forEach(function (e) {
            e.showBlur();
          });
        }

        showNormal() {
          this.items.forEach(function (e) {
            e.showNormal();
          });
        }

        changeSprite(sp1, sp2, sp3, sp4) {
          this.raidSprite.spriteFrame = sp1;
          this.coin2_1.spriteFrame = sp2;
          this.coin2_2.spriteFrame = sp2;
          this.raidBlurSprite.spriteFrame = sp3;
          this.coin2_1Blur.spriteFrame = sp4;
          this.coin2_2Blur.spriteFrame = sp4;
        }

        setSymbol(sp) {
          if (sp == null) {
            this.spSymbol.active = false;
            this.spriteSymbol.spriteFrame = null;
          } else {
            this.spSymbol.active = true;
            this.spriteSymbol.spriteFrame = sp;
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "items", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "raidSprite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "raidBlurSprite", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "coin2_1", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "coin2_2", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "coin2_1Blur", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "coin2_2Blur", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spSymbol", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "spriteSymbol", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fbIn_lib.ts", ['cc', './Logs.ts'], function (exports) {
  'use strict';

  var cclegacy, Logs;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Logs = module.Logs;
    }],
    execute: function () {
      exports('fbInTools', void 0);

      cclegacy._RF.push({}, "c3be5GqkzVP/oDvyjTX6LdJ", "fbIn_lib", undefined);

      let fbInTools; // if (export function usefbIn) {
      //     //pay
      //     export function pay = function(productID, developerPayload, callback) {
      //         FBInstant.payments.purchaseAsync({
      //             productID: productID,
      //             developerPayload: developerPayload,
      //         }).then(function (purchase) {
      //             Logs.Info(purchase);
      //             if (callback != null) callback(true, purchase, "SUCCESS")
      //         }).catch(e => {
      //             Logs.Log(productID, "pay fail", e)
      //             if (callback != null) callback(false, e.message, e.code)
      //         });
      //     }
      //     export function payAndConsume = function(productID, developerPayload, callback) {
      //         FBInstant.payments.purchaseAsync({
      //             productID: productID,
      //             developerPayload: developerPayload,
      //         }).then(function (purchase) {
      //             Logs.Info(purchase);
      //             if (callback != null) callback(true, purchase, "SUCCESS")
      //             FBInstant.payments.consumePurchaseAsync(purchase.purchaseToken).then(function (purchase) {
      //             }).catch(e => {
      //                 Logs.Log(productID, "pay consume fail", e)
      //             });
      //         }).catch(e => {
      //             Logs.Log(productID, "pay fail", e)
      //             if (callback != null) callback(false, e.message, e.code)
      //         });
      //     }
      //     //比较版本号
      //     export function SdkVersionOver = function(ver) {
      //         let s = FBInstant.getSDKVersion().split('.')
      //         let v = ver.split('.')
      //         let index = 0
      //         while(true) {
      //             if (s.length > index && v.length > index) {
      //                 if (parseInt(s[index]) > parseInt(v[index])) return 1;
      //                 if (parseInt(s[index]) < parseInt(v[index])) return -1;
      //             } else if (s.length > index && v.length <= index)
      //                 return 1;
      //             else if (s.length <= index && v.length > index)
      //                 return -1;
      //             else 
      //                 break;
      //             index ++;
      //         }
      //         return 0
      //     }
      //     export function PathToFBInPath = function(path) {
      //         return "res/raw-assets/" + path
      //     }
      // } else {
      // }
      // global.fbInTools = fbInTools

      (function (_fbInTools) {
        const usefbIn = _fbInTools.usefbIn = typeof FBInstant !== 'undefined';

        function pay(productID, developerPayload, callback) {
          FBInstant.payments.purchaseAsync({
            productID: productID,
            developerPayload: developerPayload
          }).then(function (purchase) {
            Logs.Info(purchase);
            if (callback != null) callback(true, purchase, "SUCCESS");
          }).catch(e => {
            Logs.Log(productID, "pay fail", e);
            if (callback != null) callback(false, e.message, e.code);
          });
        }

        _fbInTools.pay = pay;

        function payAndConsume(productID, developerPayload, callback) {
          FBInstant.payments.purchaseAsync({
            productID: productID,
            developerPayload: developerPayload
          }).then(function (purchase) {
            Logs.Info(purchase);
            if (callback != null) callback(true, purchase, "SUCCESS");
            FBInstant.payments.consumePurchaseAsync(purchase.purchaseToken).then(function (purchase) {}).catch(e => {
              Logs.Log(productID, "pay consume fail", e);
            });
          }).catch(e => {
            Logs.Log(productID, "pay fail", e);
            if (callback != null) callback(false, e.message, e.code);
          });
        }

        _fbInTools.payAndConsume = payAndConsume;

        function SdkVersionOver(ver) {
          let s = FBInstant.getSDKVersion().split('.');
          let v = ver.split('.');
          let index = 0;

          while (true) {
            if (s.length > index && v.length > index) {
              if (parseInt(s[index]) > parseInt(v[index])) return 1;
              if (parseInt(s[index]) < parseInt(v[index])) return -1;
            } else if (s.length > index && v.length <= index) return 1;else if (s.length <= index && v.length > index) return -1;else break;

            index++;
          }

          return 0;
        }

        _fbInTools.SdkVersionOver = SdkVersionOver;

        function PathToFBInPath(path) {
          return "res/raw-assets/" + path;
        }

        _fbInTools.PathToFBInPath = PathToFBInPath;
      })(fbInTools || (fbInTools = exports('fbInTools', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ko.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "c4a5ejDvHtJloKJPZwll/6W", "ko", undefined);

      let ko = exports('ko', {
        APPNAME: "금화의 왕",
        START: "시작",
        Score: "점수",
        Restart: "다시 시작",
        Loading: "잠깐만 기다려주세요",
        Cancel: "취소",
        Confirm: "확인",
        Retry: "다시 시도",
        Back: "복귀/돌아 가기",
        Accept: "억셉트",
        Level: "등급",
        ScoreRank: "단수",
        Rank: "순위표",
        ScorePoint: "점수",
        OK: "OK",
        YES: "네",
        NO: "아니요",
        Yes: "네",
        COLLECT: "수집",
        facebookF: "페이스북",
        Congratulation: "축하합니다",
        and: "",
        Reconnect: "Reconnect",
        PlayerDefaultName: "선수",
        PayDisable: "결제를 안 됩니다",
        PayEnabledAndroid: "안드로이드만 결제를 지원합니다.",
        PayDisableIos: "iOS는 결제를 지원하지 않습니다.",
        PayDisableFBIn: "the payment function is currently incompatible with your system. Please enter SlotsVille via Instant Games to complete purchase on a computer.,",
        PaySuccess: "구매해 주셔서 감사합니다.",
        PayFail: "결제 실패",
        PriceSymbol: "",
        AdNotReady: "동영상이 준비되지 않았습니다.",
        wxUserinfoDenyTitle: "허가 신청",
        wxUserinfoDenyDes: "게임이 기본 정보를 얻어야합니다.",
        wxUserinfoDenyConfirm: "방문 인증하십시오",
        wxVersionNoSupport: "현재 WeChat 버전이 지원되지 않습니다. WeChat을 업데이트하십시오.",
        ShareTitle: "해,이 게임은 슈퍼 재미, 나와 함께 놀러와.",
        ShareInviteNew: "예라，이 게임으로 재미도 있고 나랑 놀자",
        ShareInviteSendSpin: "너에게  에너지를 조금 줬어..",
        ShareInviteSendCoins: "너에게 금화를 보냈어요.",
        ShareInviteFinishVillage: "-D,               방금 토지를 만들었어.다들 와서 방문해라.",
        ShareInviteRaid: "-D,                            방금 {0} 금화를 훔쳤습니다. 너무 멋지다..",
        ShareDialogTitle: "공유",
        ShareInviteDialogTitle: "초청",
        ShareChooseDialogTitle: "발송",
        ShareJigsawTitle: "I need these. Help me!",
        ErrorRetry: "서버 연결에 실패했습니다. 다시 시도 하시겠습니까?",
        ErrorLogin: "서버 연결에 실패했습니다",
        ErrorNormal: "게임 오류",
        ErrorMsg0: "성공",
        ErrorMsg1703: "결제 실패",
        loadResError: "리소스를로드하지 못했습니다. 다시 시도 하시겠습니까?",
        CountYear: "년",
        CountMonth: "월",
        CountDay: "（日）    일",
        CountHour: "시간",
        CountMinute: "분",
        CountSecond: "초",
        FormatYear: "",
        FormatMonth: "",
        FormatDay: "",
        FormatHour: "",
        FormatMinute: "",
        FormatSecond: "",
        PastYear: "년 전",
        PastMonth: "개월 전",
        PastDay: "일 전",
        PastHour: "시간 전",
        PastMinute: "분 전",
        PastSecond: "초 전",
        PastZero: "방금",
        LoginWindowPlay: "게임 시작",
        LoginWindowGuest: "관광객",
        LoginWindowNeedUpdate: "There are some updates.",
        LoginWindowUpdating: "Updating",
        ContentNameCoin: "금화",
        ContentNameAp: "체력",
        ContentNameShield: "",
        ContentNameCard: "카드",
        ContentNameChest1: "목조 보물 상자",
        ContentNameChest2: "실버 보물 상자",
        ContentNameChest3: "금 보물 상자",
        ContentNamePack: "",
        ContentNameJigsaw: "퍼즐 조각",
        ContentNameUnknown: "",
        ChatSend: "보내기",
        ApRecoverIn: "",
        AutoSpining: "자동",
        ToRaidUserBet: "{0}배 수익을 올렸다",
        BetRibbonText: "",
        Bet: "배율",
        ApFull: "체력 충전되다.",
        ApPlus: "+{0}체력",
        Shield: "방패",
        Attack: "파괴",
        Spins: "체력+{0}",
        Raid: "훔치다",
        Help_sign: "1. You can get monthly\n      sign reward every\n      7 days in a month.\n2. Monthly sign will\n      refresh in next month.\n3. You can get weekly\n      sign reward every day\n      in a week.\n4. Weekly sign will\n      refresh in next week.",
        Help_jigsaw: "1. Collect 9 pieces then\n      get rewards.\n2. Pieces are collected in\n      slots and evolvement.\n3. Pieces will be cleared\n      when activity is end.\n4. Universal Jigsaw can\n      replace any piece.",
        SlotCoin6Video: "더블 금화를 얻기 위해 비디오보기",
        DailyBonusNormalSpinBtn: "시작",
        DailyBonusGoldSpinBtn: "유료 {0} 시작",
        DailyBonusFreeSpinDes: "{0} 후 무료",
        Now10XBetter: "이제 10 배 수입",
        DailyBonusCollect: "수취",
        DailyBonusLevel: "레벨 {0}",
        DailyBonusGoldFirst: "처음으로 25M 금화를 가져옵니다.",
        VillageShopTitle: "건설 시장",
        VillageShopBuy: "건설",
        VillageShopFix: "수리",
        VillageShopComplete: "완료 됨",
        NotEnoughCoinDes: "금화 부족",
        NotEnoughApDes: "체력이 달리다",
        NotEnoughApAdd: "+{0}체력",
        NotEnoughApWait: "또는 {1}이 (가) 체력이 {0} 일 때까지 기다립니다.",
        NotEnoughApWait2: "{1}이 (가) 체력이 {0} 인 것을 기다리는 중",
        NotEnoughOff: "{0}%\nMORE",
        menu_title: "메뉴",
        menu_0_play: "놀이",
        menu_1_village: "영지",
        menu_2_buy: "상점",
        menu_3_daily: "매일 장려",
        menu_4_shop: "",
        menu_5_news: "소식",
        menu_6_gifts: "선물",
        menu_7_card: "카드",
        menu_8_map: "지도",
        menu_9_leaderboard: "",
        menu_10_invite: "",
        menu_11_setting: "설정",
        setting_title: "설치",
        setting_sound: "음향 효과",
        setting_music: "음향",
        setting_notifications: "통지",
        setting_raid: "도둑질&파괴",
        setting_general: "일반",
        setting_language: "언어",
        setting_english: "",
        setting_likeus: "우리를 따르고, 최신 이벤트를 확인하고 선물을받습니다.",
        setting_like: "팔로우",
        setting_tutorial: "초보자 교습",
        setting_support: "고객 서비스",
        setting_privacy: "개인 정보 보호 계약",
        setting_terms: "제작진",
        setting_uuid: "",
        setting_language_title: "Language",
        setting_language_en: "English",
        setting_language_zh: "中文",
        setting_language_es: "Español",
        setting_language_de: "Deutsch",
        invite_title: "더 많은 체력을 원하십니까?",
        invite_addnumber_type0: "",
        invite_lineA: "",
        invite_lineApp: "",
        invite_invite: "",
        invite_note: "친구가 로그인하면 체력을 얻을 수 있습니다.",
        BindFacebookTitle: "",
        BindFacebookBtn: "",
        BindFacebookTip: "",
        BindFacebookFreespin: "",
        GuestConfirmTitle: "",
        GuestConfirmDes: "관광객은 친구와 놀 수 없습니다.",
        GuestConfirmGuest: "관광객이 시도",
        LeaderBoardWindowTabFriends: "친구",
        LeaderBoardWindowTabCountry: "전국",
        LeaderBoardWindowTabGlobal: "글로벌",
        InteractionBet: "",
        InteractionAttackName: "영토 {0}",
        InteractionAttackRevenge: "원수",
        InteractionAttackFriends: "",
        InteractionAttackResultBlock: "",
        InteractionAttackResultSuccess: "",
        InteractionRaidCoinMaster: "국왕",
        InteractionRaidName: "{0}의 보물",
        InteractionRaidStole: "{0} 훔쳐 갔다.",
        InteractionRaidResultLine: "",
        InteractionRaidPrefect: "완벽한 도둑질",
        InteractionRaidBrag: "자랑하다",
        gifts_title: "",
        gifts_tab0: "무료 체력",
        gifts_tab1: "무료 금화",
        gifts_tab2: "",
        gifts_invite: "",
        gifts_send: "증정",
        gifts_collect: "",
        gifts_note: "다른 사람에게 선물을 줄 때도 보상을받을 수 있습니다.",
        gifts_collect_all: "모든 증정 / 수령",
        gifts_collect_all2: "모든 증정",
        gifts_default_name: "친구 초대하기",
        gifts_default_explain: "무료 체력을 얻으십시오.",
        gifts_collect_spins: "오늘 {0} / {1} 호를 받았습니다.",
        gifts_collect_coins: "",
        gifts_explain_spin_send: "무료 체력을 준다.",
        gifts_explain_spin_collect: "너에게 {0} 체력을 준다.",
        gifts_explain_coin_send: "무료 금화을 준다.",
        gifts_explain_coin_collect: "너에게 {0} 금화을 준다.",
        gifts_explain_card_send: "친구에게 카드를 선물하다",
        gifts_explain_card_collect: "너에게 카드를 선물하다",
        gifts_explain_card_cantcollect: "이 카드를 얻으려면지도 {0}의 잠금을 해제해야합니다",
        ShopTitle: "",
        ShopSpins: "",
        ShopCoins: "",
        ShopSpinNum: "",
        ShopChests: "보물 상자",
        ShopAddPercent: "{0} % \n증가",
        ShopSpinPrice: "",
        ShopCoinPrice: "",
        CoinStore: "금화 전문점",
        CoinShopLevel: "{0}급",
        OffText: "",
        SaleMark: "",
        ShopChestDisable: "Chests Unlock at kingdom {0}",
        ShopPopular: "히트 상품",
        ShopBestValue: "가성비의 왕",
        village_news_title: "",
        village_news_log_hammer: "",
        village_news_log_shield: "",
        village_news_log_pig: "",
        village_news_log_invite: "",
        village_news_fox: "",
        village_news_tiger: "",
        village_news_rhino: "",
        map_title: "",
        map_comming_soon: "곧 출시 예정",
        revenge_title_revenge: "복수",
        revenge_title_attack: "친구를 공격하다",
        revenge_random: "랜덤 선수",
        revenge_revenge: "",
        revenge_attack: "파괴",
        watch_get: "비디오를 보면서 {0}를 얻으십시오.",
        watch_spin: "",
        watch_coin: "",
        watch_watch: "비디오보기",
        VillageCompleteTitle: "영토 건설 완료",
        VillageCompleteNext: "",
        NewUserInvitedTitle: "친구 보상",
        NewUserInvitedDes: "0} 새 마을을 열었습니다!  n 자유로운 체력 획득 {1}",
        NewUserInvitedDesApp: "0} 게임에 참여했습니다!  n {1} 무료 체력 얻었습니다.",
        TutorialDialogStar: "그것을 만들 때마다 별을 얻는다.",
        TutorialDialogGoSpin: "이제 금화로는 충분하지 않습니다 ...  n  n 일부 금화를 만들기 위해 화면을 아래로 슬라이드합니다.",
        TutorialDialogDoSpin: "아케이드를 공격하거나 다른 사람의 영토를 공격하거나 훔쳐서 금화를 얻을 수 있습니다.",
        TutorialDialogSlotAttack: "금화를 얻기 위해 다른 사람의 영토를 공격하다.",
        TutorialDialogSlotShield: "방패가 다른 사람들의 공격으로부터 영토를 보호합니다.",
        TutorialDialogSlotRaid: "다른 사람들의 영토에서 금화 훔치기",
        TutorialDialogSlotRaidMaster: "이 사람은 우리의 목표입니다.",
        TutorialStartTitle: "첫번째 너의 영지다.",
        TutorialStartDes: "환영합니다, 친구",
        TutorialTargetName: "목표",
        TutorialFinishTitle: "완료",
        TutorialFinishDes0: "보상",
        TutorialFinishDes1: "60개 무료 체력",
        TutorialFinishDes1bind: "20개 무료 체력",
        TutorialFinishDes2: "1백만 개 무료 금화",
        TutorialFinishDes3: "친구들과 게임하기",
        TutorialFinishDes4: "게임 진행 상황을 저장하십시오.",
        TutorialTargetName1: "Leyla",
        TutorialTargetAvatar1: "https://cdn.skyfoxgame.com/coinkings/icons/Leyla.jpg",
        TutorialTargetName2: "Mary",
        TutorialTargetAvatar2: "https://cdn.skyfoxgame.com/coinkings/icons/Mary.jpg",
        TutorialTargetName3: "Kevin",
        TutorialTargetAvatar3: "https://cdn.skyfoxgame.com/coinkings/icons/Kevin.jpg",
        AutoSpinTipWindowTitle: "",
        AutoSpinTipWindowDes: "즉시 시작하려면 버튼을 길게 누릅니다.",
        AutoSpinTipWindowButton: "",
        ActivitySpecialOfferTitle: "특별 선물",
        ActivityTimeleft: "남은 시간",
        ActivitySpecialOfferCoin: "",
        ActivitySpecialOfferSpin: "",
        ActivityShopDes: "할인 시간  {0} 남다",
        ActivityAttackMasterDes: " {1} 금화를 얻기 위해 {0} 번 공격하세요.日文",
        ActivityAttackMasterDesMore: "the bigger the</color> <outline  color=#9E5A05 width=2><color=#F7E150>REWARDS!</color></outline>,",
        ActivityAttackMasterFinal1: ",",
        ActivityAttackMasterFinal2: "",
        ActivityAttackMasterButtonTip: "더 많은 것을 얻기 위해 베팅을 늘리십시오.",
        ActivityAttackMasterButton: "",
        ActivityAttackMasterTimeleft: "남은 시간 {0}",
        ActivityRaidMasterDes: "{1} 금화를 얻기 위해 {0} 번을 훔칩니다.",
        ActivityBuildKingDes: "보상을 받기 위해 임무 완수",
        GetRewardWindowDes: "보상 획득{0}",
        CardAllSetWindowTitle: "CARD\nCOLLECTION",
        CardAllSetWindowCompleted: "Completed",
        CardAllSetWindowLock: "Unlocks at\nKingdom {0}",
        CardSingleSetWindowTip: "* Tap on a duplicate card to send it to a friend",
        CardSingleSetWindowCompleted: "- SET COMPELETED -",
        CardAsk: "Ask",
        CardSend: "Send",
        CardGoldenCannot: "This card is golden",
        CardAskCannot: "It cannot be asked from friends",
        CardSendCannot: "It cannot be sent to friends",
        CardSendLimit: "You reached the daily limit of cards you can send",
        CardCollectTitle: "AWESOME!",
        CardCollectDes: "Card {0}-{1}\nwas added to your album",
        CardCollectButton: "Check it out",
        CardSelectFriendWindowTitle: "SEND CARDS",
        CardSelectFriendWindowInfo: "Select 1 friend!",
        CardSelectFriendWindowBtn: "Select Card",
        CardSelectCardWindowTitle: "SEND CARDS",
        CardSelectCardWindowInfo: "Select up to 5 cards!",
        CardSelectCardWindowSelected: "Your selected cards:",
        FriendsModelPlaceHolder: "Search friend name",
        FriendsModelNoResult: "No Friends.",
        CardInfoWindowTitle: "Cards Info",
        CardInfoWindowPage0_0: "Collect cards through chests",
        CardInfoWindowPage0_1: "You can cards through chests",
        CardInfoWindowPage0_2: "Chests can be cards through chests cards through chests",
        CardInfoWindowPage1_0: "Owning 2 or more of the same card allows you to send them as a gift to your friends.",
        CardInfoWindowPage1_1: "Tap on the card in order to gift it",
        CardInfoWindowPage1_2: "You can also ask friends for missing cards.",
        CardInfoWindowPage2_0: "Stars indicate cards rarity",
        CardInfoWindowPage2_1: "= 1XP",
        CardInfoWindowPage2_2: "Each rarity star on a new collected card gives you 1XP",
        CardInfoWindowPage2_3: "Complete card sets and get amazing rewards!",
        CardInfoWindowCommon: "Common",
        CardInfoWindowRare: "Rare",
        CardChestInfoWindowTitle_1: "Wooden Chest",
        CardChestInfoWindowTitle_2: "Silver Chest",
        CardChestInfoWindowTitle_3: "Golden Chest",
        CardChestInfoWindowHigh: "High chance for:",
        ExtraRewardDes: "이 금화와 체력은 금화의 왕이 당신에게 주신 선물입니다.",
        quest_center_window_title: "임무 센터",
        quest_center_window_refresh_dialog: "이미 다음날~작업이 새로 고침되었습니다. 다시 열어 보세요.",
        quest_center_window_daily: "",
        quest_center_window_invite: "",
        quest_center_window_check: "",
        quest_center_window_month_box_7: "",
        quest_center_window_month_box_14: "",
        quest_center_window_month_box_21: "",
        quest_center_window_month_box_28: "",
        quest_center_window_day_1: "",
        quest_center_window_day_2: "",
        quest_center_window_day_3: "",
        quest_center_window_day_4: "",
        quest_center_window_day_5: "",
        quest_center_window_day_6: "",
        quest_center_window_day_7: "",
        quest_center_window_check_do: "체크인",
        quest_center_window_check_done: "체크인 함",
        quest_center_window_main_quest_name: "{0},   본선 업무",
        quest_center_window_main_quest_goal_reward: "{0}\nReward, {1},",
        quest_center_window_daily_get: "",
        quest_center_window_daily_go: "",
        quest_center_window_refreshin: "새로 고침",
        ActivityCenterTitle: "활동 센터",
        ActivityCenterTime: "{0},  활동 남은 시간  {0}",
        ActivityCenterTimeEnd: "이벤트가 끝났습니다.",
        jigsaw_window_title: "퍼즐",
        jigsaw_window_use: "사용",
        jigsaw_window_used: "사용됨",
        jigsaw_window_send: "",
        jigsaw_window_complete: "퍼즐 완성",
        jigsaw_window_universal_tip: "Choose one piece to replace",
        jigsaw_friends_window_title: "",
        jigsaw_friends_window_send: "",
        jigsaw_friends_window_no_friends: "친구가 없다.",
        jigsaw_friends_window_search_pre: "친구의 이름 검색",
        jigsaw_news_window_title: "",
        jigsaw_news_window_news_send: "",
        jigsaw_news_window_news_collect: "",
        jigsaw_news_window_no_news: "",
        GameMainWindowQuest: "임무",
        GameMainWindowActivity: "활동",
        NotificationTitleApFull: "당신의 체력이 꽉 찼습니다.",
        NotificationDesApFull: "우리는 금화를 얻을 수있는 충분한 육체적 힘을 가지고 있습니다.",
        NotificationTitleDailyBonus: "일일 보상을 수령 할 수 있습니다.",
        NotificationDesDailyBonus: "빨리 와서 행운의 무승부를 놀아 라.",
        NotificationTitleAttack: "우리는 복수하려고합니다.",
        NotificationDesAttack: "누군가 우리 영토를 파괴했다.",
        NotificationTitleActivity: "이벤트가 곧 끝났다",
        NotificationDesActivity: "한 시간 후에 끝날겁니다",
        NotificationTitleBack: "오래간만이에요.",
        NotificationDesBack: "우리는 당신에게 큰 선물을 준비했습니다.",
        NotificationTitleBack2: "함께 와서 놀아 라.",
        NotificationDesBack2: "우리는 당신을 위해 많은 선물을 준비했습니다.",
        mini_game_fail: "Game load fail, please try again.",
        mini_game_end: "Game End.",
        mini_game_rank_window_title: "RANKING",
        mini_game_rank_window_no_ranks: "No Ranks.",
        mini_game_coinhit_info: "A big trip to win\ncoins, spins and chests!",
        mini_game_coinhit_time: "Ends in {0}",
        mini_game_coinhit_go: "GO!",
        mini_game_coinhit_info_title: "INFO",
        mini_game_coinhit_manual_next_round: "Game stuck? Yes to go to the next round.",
        mini_game_coinhit_btn_next_round: "next round",
        mini_game_coinhit_manual_end: "Yes to get reward now! Get coin {0}, Get spin {1}.",
        mini_game_coinhit_btn_end: "get reward",
        mini_game_coinhit_rank_info: " Block Hit Count: {0}",
        AppUpdateTitle: "New Update",
        AppUpdateDes: "There is a new version available! Update now!",
        AppUpdateBtn: "UPDATE",
        AppUpdateNo: "No,thanks",
        AppCommentTitle: "Love Coin Kings?",
        AppCommentDes: "Please rate us 5 stars to make more updates~",
        AppCommentBtn: "RATE NOW",
        AppCommentNo: "No,thanks",
        AppHotUpdateFail: "Load resource failed. Try again?",
        FirstPurchaseButton: "GO!",
        FirstPurchaseDes1: "Make any purchase to",
        FirstPurchaseDes2: "GET REWARDS!",
        ServantUpgrade: "Upgrade",
        ServantSelect: "Select",
        ServantEffectDes1: "Increases raids reward",
        ServantEffectNum1: "● Increases reward by: {0}%",
        ServantEffectDes2: "Increases attacks reward",
        ServantEffectNum2: "● Increases reward by: {0}%",
        ServantEffectDes3: "Protects from attacks",
        ServantEffectNum3: "● Protection chance: {0}%",
        ServantEffectDes4: "Protects from raids",
        ServantEffectNum4: "● Protection chance: {0}%",
        ServantNextLevel: "● Next level: {0}% +",
        ServantName1: "Pigy",
        ServantName2: "Billy",
        ServantName3: "Doge",
        ServantName4: "Ruby",
        ServantOpenDes: "<color=#ffffff>Hire servants to get more<color=#ffe615>Coins</color> and <color=#0ce4fe>Spins</color></color>",
        ServantOpenDesS: "<color=#308ae6>Hire servants to get more<color=#e67b07>Coins</color> and <color=#006fd7>Spins</color></color>"
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ContainerServant.ts", ['cc', './Constant.ts', './ResourceLoader.ts', './Container3d.ts', './Pet.ts', './Rotate3D.ts', './ServantWindow.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, gfx, Color, view, UITransform, Vec3, tween, instantiate, MeshRenderer, MyCustomEvent, Constant, PetArr, ResourceLoader, Container3d, Pet, Rotate3D, ServantWindow, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      gfx = module.gfx;
      Color = module.Color;
      view = module.view;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
      tween = module.tween;
      instantiate = module.instantiate;
      MeshRenderer = module.MeshRenderer;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      Constant = module.Constant;
      PetArr = module.PetArr;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      Container3d = module.default;
    }, function (module) {
      Pet = module.default;
    }, function (module) {
      Rotate3D = module.default;
    }, function (module) {
      ServantWindow = module.ServantWindow;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c4acaOmkHdJsLSrpMcmOw3S", "ContainerServant", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ContainerServant = exports('default', (_dec = ccclass("ContainerServant"), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class ContainerServant extends Container3d {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "servantNode", _descriptor, this);

          _defineProperty(this, "servantWindow", null);

          _defineProperty(this, "intervalX", 4);

          _defineProperty(this, "petContainer", null);

          _defineProperty(this, "isPlayingAnimation", false);

          _defineProperty(this, "curPetContainer", void 0);
        }

        onLoad() {
          this.servantWindow = this.servantNode.getComponent(ServantWindow);
        }

        onDestroy() {
          super.onDestroy();
          eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "home", 2, 0);
        }

        initPet(id) {
          this.petContainer = this.newChild.getChildByName("petContainer");
          this.petContainer.destroyAllChildren();
          this.curPetContainer = this.generatePet(id);
        }

        initCamera() {
          super.initCamera();
          this.camera.clearFlags = gfx.ClearFlag.DEPTH;
          this.camera.clearColor = new Color(0, 0, 0, 0);
          const screenPixelRatio = Constant.useDeviceRatio ? view.getDevicePixelRatio() : 1;
          this.sprCamera.getComponent(UITransform).width = this.camera.targetTexture.width / screenPixelRatio;
          this.sprCamera.getComponent(UITransform).height = this.camera.targetTexture.height / screenPixelRatio;
          this.sprCamera.node.position = new Vec3(0, 50, 0);
        }

        moveLeft(id) {
          let oldPetContainer = this.curPetContainer;
          let newPetContainer = this.generatePet(id, this.intervalX);
          this.curPetContainer = newPetContainer;
          tween(oldPetContainer).by(0.3, {
            position: new Vec3(-this.intervalX, 0, 0)
          }).call(() => {
            if (oldPetContainer) {
              oldPetContainer.destroy();
            }
          }).start();
          tween(newPetContainer).by(0.3, {
            position: new Vec3(-this.intervalX, 0, 0)
          }).call(() => {}).start();
        }

        moveRight(id) {
          let oldPetContainer = this.curPetContainer;
          let newPetContainer = this.generatePet(id, -this.intervalX);
          this.curPetContainer = newPetContainer;
          tween(oldPetContainer).by(0.3, {
            position: new Vec3(this.intervalX, 0, 0)
          }).call(() => {
            if (oldPetContainer) {
              oldPetContainer.destroy();
            }
          }).start();
          tween(newPetContainer).by(0.3, {
            position: new Vec3(this.intervalX, 0, 0)
          }).call(() => {}).start();
        }

        generatePet(id, posX = 0) {
          let container = new Node();
          this.servantWindow.loadingNode.active = true;
          this.servantWindow.loadingLabel.string = "0%";
          ResourceLoader.loadCommonPrefab("pet/" + PetArr[id - 1], true, progress => {
            if (this.servantWindow.currentId !== id) return;
            this.servantWindow.loadingLabel.string = Math.round(progress * 100) + "%";
          }).then(pb => {
            if (!container || !container.isValid) return;
            this.servantWindow.loadingNode.active = false;
            const petNode = instantiate(pb);
            petNode.getFlattedChildrenRecursively().forEach(v => v.layer = this.layer);
            container.addChild(petNode);
            petNode.getComponentsInChildren(MeshRenderer).forEach(v => v.shadowCastingMode = 0);
            petNode.addComponent(Rotate3D);
            const petCom = petNode.addComponent(Pet);
            this.servantWindow.curPet = petCom; // petCom.changeStateToIdle();

            this.updateState(petCom);
          });
          container.position = new Vec3(posX, 0, 0);
          this.petContainer.addChild(container);
          return container;
        }

        updateState(pet) {
          let state = this.servantWindow.SUserServant.Servant(this.servantWindow.currentId);

          if (state == null || this.servantWindow.currentId != this.servantWindow.selectId) {
            pet.changeStateToRest2();
            return;
          }

          let time = state.time - (GameKit.TimeUtil.getCurrentTime() - state._ltime);

          if (time > 0) {
            pet.changeStateToIdle();
          } else {
            pet.changeStateToRest2();
          }
        } // getCurrentPet() {
        //     return this.curPetContainer.getComponentInChildren(Pet);
        // }


      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "servantNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ThirdMenuFit.ts", ['cc', './CCE_Component.ts', './wx_lib.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, view, Widget, CCE_Component, wxTools;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
      view = module.view;
      Widget = module.Widget;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      wxTools = module.wxTools;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c4bddNZjPVH9YNfsAuj/vV+", "ThirdMenuFit", undefined);

      const {
        ccclass,
        property,
        executionOrder
      } = _decorator;
      let ThirdMenuFit = exports('default', (_dec = executionOrder(101), _dec2 = property(CCInteger), ccclass(_class = _dec(_class = (_class2 = (_temp = class ThirdMenuFit extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "distance", _descriptor, this);

          _defineProperty(this, "over", void 0);
        }

        onLoad() {
          if (!this.enabled) return;
          if (this.over) return;
          let ssize = view.getVisibleSize();

          if (wxTools.usewx) {
            let widget = this.getComponent(Widget);

            if (widget != null && widget.enabled) {
              widget.updateAlignment();
              widget.enabled = false;
            }

            this.node.y -= this.distance;
          }

          this.over = true;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "distance", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 80;
        }
      }), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivityCenterWindow.ts", ['cc', './global.ts', './Logs.ts', './_app.ts', './UIWindow.ts', './DialogWindow.ts', './ScrollViewTool.ts', './UITabNode.ts', './UITabContainer.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts', './HelpButton.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, Node, _decorator, SpriteFrame, Prefab, instantiate, G, Logs, cce, UIWindow, DialogWindow, ScrollViewTool, UITabNode, UITabContainer, UIRoot, ActivityManager, Meta, Game, LogEventWrap, GameKit, i18n, HelpButton;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
      SpriteFrame = module.SpriteFrame;
      Prefab = module.Prefab;
      instantiate = module.instantiate;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      UITabNode = module.default;
    }, function (module) {
      UITabContainer = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      HelpButton = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c5194SPjlVHjKH49mx72ZW8", "ActivityCenterWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivityCenterWindow = exports('ActivityCenterWindow', (_dec = property(UITabContainer), _dec2 = property(ScrollViewTool), _dec3 = property(Sprite), _dec4 = property(Label), _dec5 = property(HelpButton), _dec6 = property(Label), _dec7 = property(Label), _dec8 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class ActivityCenterWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "tab_node_array", _descriptor, this);

          _initializerDefineProperty(this, "tab_scv", _descriptor2, this);

          _initializerDefineProperty(this, "page_image", _descriptor3, this);

          _initializerDefineProperty(this, "page_labelTime", _descriptor4, this);

          _initializerDefineProperty(this, "page_help", _descriptor5, this);

          _initializerDefineProperty(this, "page_name", _descriptor6, this);

          _initializerDefineProperty(this, "page_des", _descriptor7, this);

          _initializerDefineProperty(this, "page_extra", _descriptor8, this);

          _defineProperty(this, "goto", void 0);

          _defineProperty(this, "activities", void 0);

          _defineProperty(this, "activityIndex", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);
        }

        onShow(showParams) {
          this.goto = showParams.goto;
          this.activities = ActivityManager.GetActiveGameActivities();
          this.activities.sort((a, b) => {
            return Meta.ActivityMeta.GameSubTypesOrder[a.SubType()] - Meta.ActivityMeta.GameSubTypesOrder[b.SubType()];
          });
          let GoldTradeMeta = ActivityManager.GetActiveOtherActivityByType(Meta.ActivityMeta.SubTypes.GoldTrade);
          if (GoldTradeMeta) this.activities.push(GoldTradeMeta);
          let ids = [];
          let defaultIndex = 0;
          this.activities.forEach((meta, index) => {
            ids.push(meta.Id());

            if (this.goto && this.goto == meta.Id()) {
              defaultIndex = index;
            }
          });
          this.tab_scv.setItem(ids, (index, id, node) => {
            let meta = this.activities[index];
            let img = meta.Icon();

            if (img.startsWith("http")) {
              cce.loaderLoad({
                url: img,
                type: "png"
              }, function (err, v) {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!node || !this.node) return;
                let spf = new SpriteFrame();
                spf.texture = v;
                GameKit.ControllerTable.GetComponent(node, "icon1", Sprite).spriteFrame = spf;
                GameKit.ControllerTable.GetComponent(node, "icon2", Sprite).spriteFrame = spf;
              }.bind(this));
            } else {
              let resName = "res/Activity/icons/" + img;
              cce.loadRes(resName, SpriteFrame, function (err, v) {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!node || !this.node) return;
                GameKit.ControllerTable.GetComponent(node, "icon1", Sprite).spriteFrame = v;
                GameKit.ControllerTable.GetComponent(node, "icon2", Sprite).spriteFrame = v;
              }.bind(this));
            }

            GameKit.ControllerTable.GetComponent(node, "name1", Label).string = i18n.sel(meta.ShortName());
            GameKit.ControllerTable.GetComponent(node, "name2", Label).string = i18n.sel(meta.ShortName());
            this.updateBadge(index, node);
            this.tab_node_array.tabs.push(node.getComponent(UITabNode));
          }, {
            noLazy: true
          });
          this.tab_node_array.onShow((index, tab, first) => {
            this.updatePage(index);
          }, defaultIndex);
          LogEventWrap.logEvent("window_activitycenter");
        }

        slowUpdate(dt) {
          this.updateTime(dt);
        }

        close_window() {
          this.closeAnim();
        }

        updatePage(index) {
          this.activityIndex = index;
          let meta = this.activities[index];
          let img = meta.Image();

          if (img.startsWith("http")) {
            img = img.replace("image", "centerImages");
            cce.loaderLoad({
              url: img,
              type: "png"
            }, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.page_image || !this.page_image.node) return;
              let sp = new SpriteFrame();
              sp.texture = v;
              this.page_image.spriteFrame = sp;
            }.bind(this));
          } else {
            let resName = "res/Activity/centerImages/" + img;
            cce.loadRes(resName, SpriteFrame, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.page_image || !this.page_image.node) return;
              this.page_image.spriteFrame = v;
            }.bind(this));
          }

          this.page_help.node.active = false;

          if (meta.HelpKey()) {
            this.page_help.node.active = true;
            this.page_help.titleKey = i18n.sel(meta.Name());
            this.page_help.helpKey = meta.HelpKey();
          }

          this.page_name.string = i18n.sel(meta.Name());
          this.page_des.string = i18n.sel(meta.Description());
          this.leftTime = meta.EndTime() - GameKit.TimeUtil.getCurrentTime();
          this.updateTime(0);
          this.page_extra.destroyAllChildren();

          if (meta.Param().center_extra) {
            let resName = "res/Activity/extraPrefab/" + meta.Param().center_extra;
            cce.loadRes(resName, Prefab, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              let ex = instantiate(v);
              ex.parent = this.page_extra;
              ex.x = 0;
              ex.y = 0;
              ex.getComponent(meta.Param().center_extra).Show(this, meta);
            }.bind(this));
          }
        }

        updateTime(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;

          if (this.leftTime != null) {
            this.leftTime -= dt;
            if (this.leftTime <= 0) this.leftTime = 0;
            this.page_labelTime.string = String.format(i18n.t("ActivityCenterTime"), GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, true));
          }
        }

        click_Go() {
          let meta = this.activities[this.activityIndex];

          if (!meta.IsActive()) {
            this.closeAnim(() => {
              DialogWindow.Show(i18n.t("ActivityCenterTimeEnd"), nullFunction);
            });
            return;
          }

          let icon_goto = meta.IconGoto();

          if (icon_goto == "panel") {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(meta.Panel(), {
                meta: meta
              });
            });
          } else if (icon_goto == "slot") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Slot, true);
            });
          } else if (icon_goto == "village") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Village, true);
            });
          } else if (icon_goto == "villageShop") {
            this.closeAnim(() => {
              homeView.pageViewController.moveToPage(G.Pages.Village, true);
            });
          } else if (icon_goto == "window") {
            this.closeAnim(() => {
              meta.Panel().Show(meta);
            });
          } else {
            this.closeAnim(() => {
              UIRoot.instance.openChildWindow(icon_goto, {
                meta: meta
              });
            });
          }
        }

        updateBadge(index, tab) {
          let meta = this.activities[index];
          GameKit.ControllerTable.GetNode(tab, "badge").active = Game.SUserActivity.GetGameActivityBadgeStateByType(meta.SubType());
        }

      }, _defineProperty(_class3, "windowPath", "Activity/ActivityCenterWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "tab_node_array", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "tab_scv", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "page_image", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "page_labelTime", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "page_help", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "page_name", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "page_des", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "page_extra", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRVillage.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRVillage', void 0);

      cclegacy._RF.push({}, "c524ejvvelMIbrbsGb0oK+Y", "SRVillage", undefined);

      let SRVillage;

      (function (_SRVillage) {
        function getUserVillage() {
          let req = new GameKit.ServerRequest("getUserVillage");
          req.SetCallBack(function (res) {
            Game.SUserVillage.updateData(res.userVillage);
          });
          return req;
        }

        _SRVillage.getUserVillage = getUserVillage;

        function getPeopleUserVillage(uid) {
          let req = new GameKit.ServerRequest("getPeopleUserVillage");
          req.SetRequestBody("otherUserId", uid);
          return req;
        }

        _SRVillage.getPeopleUserVillage = getPeopleUserVillage;

        function levelUpVillage(type) {
          let req = new GameKit.ServerRequest("levelUpVillage");
          req.SetSilence(false);
          req.SetRequestBody("type", type);
          req.SetCallBack(function (res) {
            Game.SUserVillage.updateData(res.userVillage);
          });
          return req;
        }

        _SRVillage.levelUpVillage = levelUpVillage;

        function fixVillage(type) {
          let req = new GameKit.ServerRequest("fixVillage");
          req.SetSilence(false);
          req.SetRequestBody("type", type);
          req.SetCallBack(function (res) {
            Game.SUserVillage.updateData(res.userVillage);
          });
          return req;
        }

        _SRVillage.fixVillage = fixVillage;

        function askNextVillage() {
          let req = new GameKit.ServerRequest("askNextVillage");
          req.SetCallBack(function (res) {
            Game.SUserVillage.updateData(res.userVillage);
          });
          return req;
        }

        _SRVillage.askNextVillage = askNextVillage;

        function getVillageNews() {
          let req = new GameKit.ServerRequest("getVillageNews");
          return req;
        }

        _SRVillage.getVillageNews = getVillageNews;

        function getPresentList() {
          let req = new GameKit.ServerRequest("getPresentList");
          req.SetCallBack(function (res) {
            GameKit.DataCache.SetData("UserPresentList", res.list);
          });
          return req;
        }

        _SRVillage.getPresentList = getPresentList;

        function collectPresent(id) {
          let req = new GameKit.ServerRequest("collectPresent");
          req.SetRequestBody("presentId", id);
          req.SetCallBack(function (res) {
            let presentList = GameKit.DataCache.GetData("UserPresentList");

            if (presentList) {
              presentList[id].received = true;
              GameKit.DataCache.SetData("UserPresentList", presentList);
            }
          });
          return req;
        }

        _SRVillage.collectPresent = collectPresent;
      })(SRVillage || (SRVillage = exports('SRVillage', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShopPage.ts", ['cc', './Page.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Page;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      Page = module.Page;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "c588df9u4pL15udak4/Ybze", "ShopPage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopPage = exports('ShopPage', (_dec = ccclass('ShopPage'), _dec(_class = class ShopPage extends Page {}) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CutScrollViewDrawcall.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, ScrollView, Layout, Mask, UITransform, Rect;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      ScrollView = module.ScrollView;
      Layout = module.Layout;
      Mask = module.Mask;
      UITransform = module.UITransform;
      Rect = module.Rect;
    }],
    execute: function () {
      var _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "c5ddfFDIZBHY4XwLCS50j6N", "CutScrollViewDrawcall", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CutScrollViewDrawcall = exports('default', ccclass(_class = (_temp = class CutScrollViewDrawcall extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "scrollView", void 0);

          _defineProperty(this, "maskRect", void 0);

          _defineProperty(this, "childrenRects", new Map());

          _defineProperty(this, "inited", false);
        }

        onLoad() {
          this.scrollView = this.getComponent(ScrollView);
          this.scrollView.node.on(ScrollView.EventType.SCROLLING, event => {
            if (!this.inited) return;
            this.updateMaskRect();
            this.updateChildrenRects();
            this.updateCutDrawcall();
          });
        }

        start() {
          console.log("disable scrollView Layout");
          this.scrollView.content.getComponent(Layout).updateLayout(true);
          this.scheduleOnce(() => {
            this.inited = true;
            this.scrollView.content.getComponent(Layout).enabled = false;
            this.updateMaskRect();
            this.updateChildrenRects();
            this.updateCutDrawcall();
          }, 1);
        }

        updateMaskRect() {
          const maskUITransform = this.scrollView.getComponentInChildren(Mask).getComponent(UITransform);
          const maskAABB = maskUITransform.getComputeAABB();

          if (!this.maskRect) {
            this.maskRect = new Rect(maskAABB.center.x - maskAABB.halfExtents.x, maskAABB.center.y - maskAABB.halfExtents.y, maskAABB.halfExtents.x * 2, maskAABB.halfExtents.y * 2);
          } else {
            const rect = this.maskRect;
            rect.x = maskAABB.center.x - maskAABB.halfExtents.x;
            rect.y = maskAABB.center.y - maskAABB.halfExtents.y;
            rect.width = maskAABB.halfExtents.x * 2;
            rect.height = maskAABB.halfExtents.y * 2;
          }
        }

        updateChildrenRects() {
          this.scrollView.content.children.forEach(child => {
            const childUITransform = child.getComponent(UITransform);
            const childAABB = childUITransform.getComputeAABB();

            if (this.childrenRects.get(child)) {
              const rect = this.childrenRects.get(child);
              rect.x = childAABB.center.x - childAABB.halfExtents.x;
              rect.y = childAABB.center.y - childAABB.halfExtents.y;
              rect.width = childAABB.halfExtents.x * 2;
              rect.height = childAABB.halfExtents.y * 2;
            } else {
              const childRect = new Rect(childAABB.center.x - childAABB.halfExtents.x, childAABB.center.y - childAABB.halfExtents.y, childAABB.halfExtents.x * 2, childAABB.halfExtents.y * 2);
              this.childrenRects.set(child, childRect);
            }
          });
        }

        updateCutDrawcall() {
          this.childrenRects.forEach((rect, child) => {
            child.active = this.maskRect.intersects(rect);
          });
        }

      }, _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BlinkAnim.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, CCE_Component, CCEaseTypes;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "c6d04gQ2JZIQ5Igf5cLbd6D", "BlinkAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BlinkAnim = exports('default', (_dec = property(CCInteger), _dec2 = property(CCInteger), _dec3 = property(CCInteger), _dec4 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class BlinkAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "minAlpha", _descriptor, this);

          _initializerDefineProperty(this, "maxAlpha", _descriptor2, this);

          _initializerDefineProperty(this, "duration", _descriptor3, this);

          _initializerDefineProperty(this, "delay", _descriptor4, this);

          _defineProperty(this, "executingFlag", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          this.executingFlag = false;
        }

        slowUpdate(dt) {
          if (this.executingFlag) {
            return;
          }

          this.executingFlag = true;
          this.node.runAction(ccAction.sequence(ccAction.fadeTo(this.duration, this.minAlpha, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeQuadraticActionInOut)), ccAction.fadeTo(this.duration, this.maxAlpha, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeQuadraticActionInOut)), ccAction.delayTime(this.delay)).repeatForever());
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "minAlpha", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 75;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "maxAlpha", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 255;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "duration", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 1;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "delay", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DynamicPackMeta.ts", ['cc', './Content.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Content, Meta;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      Meta = module.Meta;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "c8dce83wXFEfpTSA1Anz6Fp", "DynamicPackMeta", undefined);

      class DynamicPackMeta {
        constructor() {
          _defineProperty(this, "_data", {});

          _defineProperty(this, "contents", void 0);
        }

        static MakeEntity(data) {
          let meta = new DynamicPackMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        RawPackId() {
          return this._data.rawPackId;
        }

        MapId() {
          return this._data.mapId;
        }

        PayId() {
          return this._data.payId;
        }

        Off() {
          return this._data.off;
        }

        OldPriceShopId() {
          return this._data.oldPriceShopId;
        }

        Name() {
          return Meta.MetaManager.GetMeta(Meta.MetaType.PackItem, this.RawPackId()).Name();
        }

        Items() {
          let is = this._data.items;
          let iss = is.split(";");
          return iss;
        }

        Contents() {
          if (!this.contents) {
            this.contents = Content.FromStrings(this._data.items);
          }

          return this.contents;
        }

        static GetMapId(mapId) {
          if (mapId <= 5) {
            return 0;
          } else if (mapId <= 10) {
            return 1;
          } else if (mapId <= 15) {
            return 2;
          } else if (mapId <= 20) {
            return 3;
          } else if (mapId <= 25) {
            return 4;
          } else if (mapId <= 30) {
            return 5;
          } else if (mapId <= 35) {
            return 6;
          } else if (mapId <= 40) {
            return 7;
          } else if (mapId <= 45) {
            return 8;
          }

          return 9;
        }

        static GetPayId(purchaseMoney) {
          if (purchaseMoney <= 0) {
            return 0;
          } else if (purchaseMoney <= 10) {
            return 1;
          } else if (purchaseMoney <= 25) {
            return 2;
          } else if (purchaseMoney <= 50) {
            return 3;
          } else if (purchaseMoney <= 100) {
            return 4;
          }

          return 5;
        }

        static CacheMeta() {
          DynamicPackMeta._CacheMeta = {};
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.DynamicPack);

          for (let id in metas) {
            let meta = metas[id];
            let rawPackId = meta.RawPackId();
            if (!DynamicPackMeta._CacheMeta[rawPackId]) DynamicPackMeta._CacheMeta[rawPackId] = {};
            let mapId = meta.MapId();
            if (!DynamicPackMeta._CacheMeta[rawPackId][mapId]) DynamicPackMeta._CacheMeta[rawPackId][mapId] = {};
            let payId = meta.PayId();
            DynamicPackMeta._CacheMeta[rawPackId][mapId][payId] = meta;
          }
        }

        static FindMeta(rawPackId, _mapId, purchaseMoney) {
          let mapId = DynamicPackMeta.GetMapId(_mapId);
          let payId = DynamicPackMeta.GetPayId(purchaseMoney);
          return DynamicPackMeta._CacheMeta[rawPackId][mapId][payId];
        }

      }

      exports('DynamicPackMeta', DynamicPackMeta);

      _defineProperty(DynamicPackMeta, "_CacheMeta", void 0);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardPage.ts", ['cc', './Page.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Page;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      Page = module.Page;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "c94bfVotxBFa4oCn2dzuLgp", "CardPage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CardPage = exports('CardPage', (_dec = ccclass('CardPage'), _dec(_class = class CardPage extends Page {}) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/QuestInvitePage.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class;

      cclegacy._RF.push({}, "c9512f6hehPyaUML3TXs3rV", "QuestInvitePage", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let QuestInvitePage = exports('QuestInvitePage', ccclass(_class = class QuestInvitePage extends CCE_Component {
        show() {
          this.get_data().then(v => {
            this.update_page(v);
            this.node.active = true;
          });
        }
        /** 获取invite-page依赖的数据 */


        get_data() {
          return new Promise((res, rej) => {
            res(null);
          });
        }
        /** 初始化任务页面 */


        update_page(data) {}

      }) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BatchRequest.ts", ['cc', './global.ts', './Logs.ts', './wx_lib.ts', './DialogWindow.ts', './AppGame.ts', './LoadingWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './ErrorCode.ts', './encryptCode.ts', './AppKit.ts', './WebEvent.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var sys, loader, cclegacy, G, Logs, wxTools, DialogWindow, AppGame, LoadingWindow, UIRoot, Game, LogEventWrap, ErrorCode, encryptCode, WebEvent, GameKit, i18n, AppMain;
  return {
    setters: [function (module) {
      sys = module.sys;
      loader = module.loader;
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      DialogWindow = module.DialogWindow;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      ErrorCode = module.ErrorCode;
    }, function (module) {
      encryptCode = module.encryptCode;
    }, function () {}, function (module) {
      WebEvent = module.WebEvent;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "c9d29p3e2ZDfKbqMKYKksyS", "BatchRequest", undefined);

      class BatchRequest {
        constructor(reqs, reqs2) {
          _defineProperty(this, "url", void 0);

          _defineProperty(this, "data", {});

          _defineProperty(this, "msgs", void 0);

          _defineProperty(this, "beforeMsgs", void 0);

          _defineProperty(this, "callback", void 0);

          _defineProperty(this, "errorCallback", void 0);

          _defineProperty(this, "someoneErrorCallback", void 0);

          _defineProperty(this, "silence", void 0);

          _defineProperty(this, "req", void 0);

          const isTestServer = !!parseInt(sys.localStorage.getItem("isTestServer"));
          this.url = (isTestServer ? G.GameConfig.testServer : G.GameConfig.formalServer) + "/portcol";
          this.data = {};
          this.msgs = reqs || [];
          this.beforeMsgs = reqs2 || [];
          this.SetRequestBody("msgs", []);
          this.SetRequestBody("beforeMsgs", []);
          this.SetRequestBody("userId", Game.SUser.UserId());
          this.SetRequestBody("rid", Game.SUser.GetRequestId());
          this.SetRequestBody("uuid", Game.SUser.Uuid());
          this.SetRequestBody("batch", true);
        }

        SetRequestBody(key, body) {
          this.data[key] = body;
        }

        AddRequest(req) {
          this.msgs.push(req);
        }

        AddBeforeRequest(req) {
          this.beforeMsgs.push(req);
        }

        SetCallBack(func) {
          this.callback = func;
        }

        SetErrorCallBack(func) {
          this.errorCallback = func;
        }

        SetSomeOneErrorCallBack(func) {
          this.someoneErrorCallback = func;
        }

        SetSilence(func) {
          this.silence = func;
        }

        Send() {
          Logs.Debug("BatchRequest req:", this);
          if (!this.silence) LoadingWindow.Show();
          this.msgs.forEach(function (m) {
            this.data.msgs.push(m.data);
          }.bind(this));
          this.beforeMsgs.forEach(function (m) {
            this.data.beforeMsgs.push(m.data);
          }.bind(this));

          if (wxTools.usewx) {
            wx.request({
              url: this.url,
              data: JSON.stringify({
                arr: encryptCode.stringToBytes(encryptCode.simplecode(pako.gzip(JSON.stringify(this.data), {
                  to: "string"
                })))
              }),
              header: {
                ["Content-Type"]: "application/json"
              },
              method: "POST",
              dataType: "json",
              responseType: "arraybuffer",
              success: res => {
                if (!this.silence) LoadingWindow.Hide();
                this.okCallback(JSON.parse(pako.ungzip(encryptCode.simplecode(encryptCode.arrayBufferToString(res.data)), {
                  to: "string"
                })));
              },
              fail: res => {
                if (!this.silence) LoadingWindow.Hide();

                if (this.errorCallback != null) {
                  this.errorCallback(res);
                }
              }
            });
          } else {
            this.req = loader.getXMLHttpRequest();
            this.req.responseType = "arraybuffer";
            this.req.open("POST", this.url, true);
            this.req.setRequestHeader("Content-Type", "application/json");

            this.req.onload = function (e) {
              e = e || {
                msg: "unknown"
              };
              if (!this.silence) LoadingWindow.Hide();

              if (this.req.readyState == 4 && this.req.status >= 200 && this.req.status < 400) {
                let rawRes = pako.ungzip(encryptCode.simplecode(encryptCode.arrayBufferToString(this.req.response)), {
                  to: "string"
                });
                let res = JSON.parse(rawRes);
                this.okCallback(res);
              } else {
                if (this.errorCallback != null) {
                  this.errorCallback(e);
                }

                LogEventWrap.logEvent("http_net_fail", {
                  url: this.url,
                  body: JSON.stringify(this.data),
                  header: this.req.getAllResponseHeaders(),
                  readyState: this.req.readyState,
                  code: this.req.status
                });
              }
            }.bind(this);

            this.req.ontimeout = function (e) {
              if (!this.silence) LoadingWindow.Hide();

              if (this.errorCallback != null) {
                this.errorCallback(e);
              }

              LogEventWrap.logEvent("http_net_fail", {
                url: this.url,
                body: JSON.stringify(this.data),
                code: 0,
                msg: "ontimeout"
              });
            }.bind(this);

            this.req.onerror = function (e) {
              e = e || {
                code: -1,
                msg: "unknown"
              };
              if (!this.silence) LoadingWindow.Hide();

              if (this.errorCallback != null) {
                this.errorCallback(e);
              }

              LogEventWrap.logEvent("http_net_fail", {
                url: this.url,
                body: JSON.stringify(this.data),
                header: this.req.getAllResponseHeaders(),
                code: e.code || -1,
                msg: "onerror" + e.toString()
              });
            }.bind(this);

            this.req.send(JSON.stringify({
              arr: encryptCode.stringToBytes(encryptCode.simplecode(pako.gzip(JSON.stringify(this.data), {
                to: "string"
              })))
            }));
          }
        }

        okCallback(res) {
          Logs.Debug("BatchRequest resp:", res);
          GameKit.TimeUtil.UpdateServerTime(res.timestamp);

          if (res.errorCode !== ErrorCode.SUCCESS) {
            if (res.errorCode == null) res.errorCode = ErrorCode.UNKNOWN_CLIENT;

            if (this.errorCallback != null) {
              this.errorCallback(res);
            }

            Logs.Warning("BatchRequest error " + "method:" + this.data.method + " msg:" + JSON.stringify(res.msg || "") + " code:" + res.errorCode); //AppMain.instance.logerror({msg:"BatchRequest error " + JSON.stringify(res.msg || "") + " msg:" + res.errorCode, url:"", line:""})

            let apis = [];

            for (let i = 0; i < this.beforeMsgs.length; i++) {
              apis.push(this.beforeMsgs[i].data.method);
            }

            for (let i = 0; i < this.msgs.length; i++) {
              apis.push(this.msgs[i].data.method);
            }

            LogEventWrap.logEvent("http_batch_fail", {
              apis: JSON.stringify(apis),
              code: res.errorCode,
              msg: "BatchRequest error " + JSON.stringify(res.msg || "")
            });

            if (!ErrorCode.muteError(res.errorCode)) {
              let ErrorMsgKey = "ErrorMsg" + res.errorCode.toString();
              let ErrorMsg = i18n.t(ErrorMsgKey);
              if (ErrorMsg === ErrorMsgKey) ErrorMsg = i18n.t("ErrorNormal");
              UIRoot.instance.openChildWindow(DialogWindow, {
                msg: ErrorMsg + " Code:" + res.errorCode.toString(),
                confirmFunc: function () {
                  AppGame.instance.logout();
                }
              });
            }

            return false;
          }

          if (res.events != null) {
            for (let type in res.events) {
              WebEvent.DispatcherEvent(type, res.events[type]);
            }
          }

          let results = {};
          res.result.forEach(function (x) {
            results[x.method] = x;
          });

          for (let i = 0; i < this.beforeMsgs.length; i++) {
            let msg = this.beforeMsgs[i];
            let method = msg.data.method;

            if (results.hasOwnProperty(method)) {
              let result = results[method];

              if (!msg.okCallback(result)) {
                if (this.someoneErrorCallback != null) {
                  res.method = method;
                  this.someoneErrorCallback(res);
                } //AppMain.instance.logerror({msg:"BatchRequest error " + "method:" + method + " msg:" + res.msg || "" + " code:" + res.errorCode, url:"", line:""})


                return false;
              }
            } else {
              if (this.errorCallback != null) {
                this.errorCallback(res);
              }

              AppMain.instance.logerror({
                msg: "BatchRequest error no method " + method + res.errorCode,
                url: "",
                line: ""
              });
              return false;
            }
          }

          for (let i = 0; i < this.msgs.length; i++) {
            let msg = this.msgs[i];
            let method = msg.data.method;

            if (results.hasOwnProperty(method)) {
              let result = results[method];

              if (!msg.okCallback(result)) {
                if (this.someoneErrorCallback != null) {
                  res.method = method;
                  this.someoneErrorCallback(res);
                } //AppMain.instance.logerror({msg:"BatchRequest error " + "method:" + method + " msg:" + res.msg || "" + " code:" + res.errorCode, url:"", line:""})


                return false;
              }
            } else {
              if (this.errorCallback != null) {
                this.errorCallback(res);
              }

              AppMain.instance.logerror({
                msg: "BatchRequest error no method " + method + res.errorCode,
                url: "",
                line: ""
              });
              return false;
            }
          }

          if (this.callback != null) {
            this.callback(res.result);
          }

          return true;
        }

      }

      exports('default', BatchRequest);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotColNode.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './SoundManager.ts', './ObjsNode.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, instantiate, CCE_Component, CCEaseTypes, SoundManager, ObjsNode;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ObjsNode = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ca19dywPfBKSbK7eDfRtp0x", "SlotColNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotColNode = exports('default', (_dec = property(ObjsNode), ccclass(_class = (_class2 = (_temp = class SlotColNode extends CCE_Component {
        constructor() {
          super();

          _defineProperty(this, "node", void 0);

          _defineProperty(this, "speed", void 0);

          _defineProperty(this, "startSpeed", void 0);

          _defineProperty(this, "blur", void 0);

          _defineProperty(this, "runFlag", void 0);

          _defineProperty(this, "leftDis", void 0);

          _defineProperty(this, "leftDis2", void 0);

          _defineProperty(this, "isAtten", void 0);

          _defineProperty(this, "attenType", void 0);

          _defineProperty(this, "minSpeed", void 0);

          _defineProperty(this, "attenDelay", void 0);

          _defineProperty(this, "attenRatio", void 0);

          _defineProperty(this, "callback", void 0);

          _defineProperty(this, "arg", void 0);

          _defineProperty(this, "objs1", void 0);

          _defineProperty(this, "objs2", void 0);

          _defineProperty(this, "useSymbol", void 0);

          _defineProperty(this, "colHeight", void 0);

          _defineProperty(this, "reachEnd", void 0);

          _defineProperty(this, "slot", void 0);

          _initializerDefineProperty(this, "objsTemp", _descriptor, this);

          this.speed = 0;
          this.startSpeed = 3500;
          this.blur = false;
          this.runFlag = false;
          this.leftDis = 0;
          this.leftDis2 = 0;
          this.isAtten = false;
          this.attenType = 0;
          this.minSpeed = 1500;
          this.attenDelay = 0;
          this.attenRatio = 0;
          this.callback = null;
          this.arg = null;
          this.objs1 = null;
          this.objs2 = null;
          this.useSymbol = false;
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {}

        start() {//this.startRun()
        }

        updateNode(dt) {
          if (this.runFlag) {
            this.run(dt);
          }
        }

        initCol() {
          this.objs1 = this.objsTemp;
          this.objs2 = instantiate(this.objsTemp.node).getComponent(ObjsNode);
          this.objs2.node.parent = this.objsTemp.node.parent;
          this.reset();
        }

        reset() {
          this.runFlag = false;
          this.node.stopAllActions();
          this.node.y = 0;
          var initY = Math.floor(Math.random() * 8) * 120;
          this.objs1.node.y = initY;
          this.colHeight = 120 * (this.useSymbol ? 9 : 8);

          if (this.objs1.node.y >= 480) {
            this.objs2.node.y = this.objs1.node.y - this.colHeight;
          } else {
            this.objs2.node.y = this.objs1.node.y + this.colHeight;
          }

          this.objs1.showNormal();
          this.objs2.showNormal();
        }

        changeSprite(sp1, sp2, sp3, sp4) {
          this.objs1.changeSprite(sp1, sp2, sp3, sp4);
          this.objs2.changeSprite(sp1, sp2, sp3, sp4);
        }

        setSymbol(sp) {
          this.useSymbol = !!sp;
          this.objs1.setSymbol(sp);
          this.objs2.setSymbol(sp);
          this.reset();
        }

        startRun() {
          this.runFlag = true;
          this.speed = this.startSpeed;
          this.blur = true;
          this.objs1.showBlur();
          this.objs2.showBlur();
          this.isAtten = false;
        }

        stopAt(index, type, callback, arg) {
          this.callback = callback;
          this.arg = arg;
          var objNode = null;

          if (this.objs1.node.position.y < this.objs2.node.position.y) {
            objNode = this.objs2.node;
          } else {
            objNode = this.objs1.node;
          }

          var targetY = objNode.y + this.colHeight * 1 - index * 120;
          this.leftDis = targetY - 0;
          this.isAtten = true; // var r = Math.random()

          if (type == 0) {
            this.attenType = 0;
            this.attenDelay = (this.leftDis - 500) / this.speed; //this.minSpeed = 600

            this.scheduleOnce(() => {
              SoundManager.playSound("slot_spin_1");
            }, 0.01);
          } else if (type == 1) {
            this.attenType = 1;
            this.attenRatio = 2.5;
            this.scheduleOnce(() => {
              SoundManager.playSound("slot_spin_2");
            }, 0.01);
          } else if (type == 2) {
            this.attenType = 2;
            this.attenRatio = 1;
            this.leftDis2 = 50 + Math.random() * 20;
            this.leftDis = this.leftDis - this.leftDis2;
            this.reachEnd = false;
            this.scheduleOnce(() => {
              SoundManager.playSound("slot_spin_3");
            }, 0.01);
          }
        }

        run(dt) {
          dt *= 1.2; // 减速

          if (this.isAtten) {
            switch (this.attenType) {
              case 0:
                this.attenSpeed0(dt);
                break;

              case 1:
                this.attenSpeed1(dt);
                break;

              case 2:
                this.attenSpeed2(dt);
            }
          } // 运动


          var rs = this.move(dt); // 运动结束，结尾效果动画

          if (rs == false) {
            switch (this.attenType) {
              case 0:
                this.attenEndAction0(this.speed);
                break;

              case 1:
                this.attenEndAction1(this.speed);
                break;

              case 2:
                this.attenEndAction2(this.speed);
                break;
            }
          }
        }

        move(dt) {
          var moveDelta = dt * this.speed;

          if (this.isAtten) {
            this.leftDis -= moveDelta;

            if ((this.leftDis < 240 || this.speed < 1400) && this.blur == true) {
              this.objs1.showNormal();
              this.objs2.showNormal();
              this.blur = false;
            }

            if (this.leftDis <= 0) {
              moveDelta -= 0 - this.leftDis;
              this.runFlag = false;
            }
          }

          this.objs1.node.y -= moveDelta;
          this.objs2.node.y -= moveDelta;

          if (this.objs1.node.y <= -480) {
            this.objs1.node.y = this.objs2.node.y + this.colHeight;
          }

          if (this.objs2.node.y <= -480) {
            this.objs2.node.y = this.objs1.node.y + this.colHeight;
          }

          return this.runFlag;
        }

        attenSpeed0(dt) {
          if (this.leftDis < 1000) {
            if (this.attenDelay > 0) {
              this.attenDelay -= dt;
            } else {
              this.speed *= Math.pow(0.95, Math.max(1, dt * 60));

              if (this.speed < this.minSpeed) {
                this.speed = this.minSpeed;
              }
            }
          }
        }

        attenEndAction0(speed) {
          var self = this;
          var ac1 = ccAction.moveBy(0.06, 0, -35, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineOut));
          var ac2 = ccAction.moveBy(0.08, 0, 40, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn));
          var ac22 = ccAction.moveBy(0.04, 0, -5, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineIn));
          var ac3 = ccAction.callFunc(function () {
            // 回调
            SoundManager.stopSound("slot_spin_1");
            SoundManager.stopSound("slot_spin_2");
            SoundManager.stopSound("slot_spin_3");
            SoundManager.playSound("slot_stop_1");

            if (self.callback != null) {
              self.callback(self.arg);
            }
          });
          var seq = ccAction.sequence(ac1, ac2, ac3, ac22);
          this.node.runAction(seq);
        }

        attenSpeed1(dt) {
          this.speed -= this.speed * this.attenRatio * dt;

          if (this.speed < this.leftDis + 120) {
            this.speed = this.leftDis + 120;
          }
        }

        attenEndAction1(speed) {
          // 回调
          var self = this;
          SoundManager.stopSound("slot_spin_1");
          SoundManager.stopSound("slot_spin_2");
          SoundManager.stopSound("slot_spin_3");
          SoundManager.playSound("slot_stop_2");

          if (self.callback != null) {
            self.callback(self.arg);
          }
        }

        attenSpeed2(dt) {
          if (this.reachEnd == false) {
            this.speed -= this.speed * this.attenRatio * dt;

            if (this.speed < this.leftDis + 150) {
              this.speed = this.leftDis + 150;
            }

            var moveDelta = dt * this.speed;

            if (this.leftDis <= moveDelta) {
              this.leftDis += this.leftDis2;
              this.reachEnd = true;
            }
          } else {
            this.speed += this.attenRatio * 150 * dt;
          }
        }

        attenEndAction2(speed) {
          // 回调
          var self = this;
          SoundManager.stopSound("slot_spin_1");
          SoundManager.stopSound("slot_spin_2");
          SoundManager.stopSound("slot_spin_3");
          SoundManager.playSound("slot_stop_3");

          if (self.callback != null) {
            self.callback(self.arg);
          }
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "objsTemp", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MultiplePurchaseWindow.ts", ['cc', './Constant.ts', './global.ts', './SoundManager.ts', './UIWindow.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, instantiate, MyCustomEvent, G, SoundManager, UIWindow, ActivityManager, Meta, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ca449J5WLpGer023nx69p38", "MultiplePurchaseWindow", undefined);

      var MultipleList = [4, 3, 2, 8, 3, 4, 2, 5, 4, 3, 2, 8, 3, 5, 2, 10];
      const {
        ccclass,
        property
      } = _decorator;
      let MultiplePurchaseWindow = exports('MultiplePurchaseWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Label), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Node), _dec8 = property(Label), _dec9 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class MultiplePurchaseWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spWheel", _descriptor, this);

          _initializerDefineProperty(this, "labelTimesItem", _descriptor2, this);

          _initializerDefineProperty(this, "labelDesPay", _descriptor3, this);

          _initializerDefineProperty(this, "spLabel", _descriptor4, this);

          _initializerDefineProperty(this, "btnSpin", _descriptor5, this);

          _initializerDefineProperty(this, "spResultClick", _descriptor6, this);

          _initializerDefineProperty(this, "spResult", _descriptor7, this);

          _initializerDefineProperty(this, "labelResult", _descriptor8, this);

          _initializerDefineProperty(this, "animRibbon", _descriptor9, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "indexRotation", void 0);

          _defineProperty(this, "spinTimes", void 0);

          _defineProperty(this, "w_rot", void 0);

          _defineProperty(this, "w_spining", void 0);

          _defineProperty(this, "w_targetRot", void 0);

          _defineProperty(this, "speed", void 0);

          _defineProperty(this, "soundCount", void 0);

          _defineProperty(this, "times", void 0);
        }

        static OpenMulti() {
          let activities = ActivityManager.GetAllActiveActivityList();

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Pay && meta.SubType() === Meta.ActivityMeta.SubTypes.Lucky10) return true;
          }

          return false;
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.labelDesPay.string = String.format(i18n.t("MultiplePurchaseDes3"), this.meta.PriceString());
          this.indexRotation = {};

          for (let i = 0; i < MultipleList.length; i++) {
            let labelItem = instantiate(this.labelTimesItem);
            labelItem.active = true;
            labelItem.parent = this.labelTimesItem.parent;
            labelItem.x = 0;
            labelItem.y = 0;
            labelItem.angle = (0.5 + i) * -22.5;
            labelItem.getComponent(Label).string = i18n.t("multiplyX") + MultipleList[i];
            this.indexRotation[i] = {
              min: i * 22.5 + 5,
              max: (i + 1) * 22.5 - 5
            };
          }

          this.spinTimes = 0;
          this.w_rot = 0;
          GameKit.BackKeyManager.registerBackEvent(() => {
            this.callClose();
          });
        }

        onClose() {
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        slowUpdate(dt) {
          this.updateWheel(dt);
        }

        callClose() {
          if (this.w_spining) return;
          this.closeAnim();
        }

        callSpin() {
          if (this.w_spining) return;
          this.spResult.runAction(ccAction.scaleTo(0.3, 0.001, 0.001));
          GameKit.DataCache.SetData("MultiplePurchase", true);
          PaymentWrap.Pay(this.meta.Name(), (ok, res) => {
            if (ok) {
              eventCenter.emit(MyCustomEvent.CanChangeSpin);
              this.spinTimes++;
              this.spLabel.runAction(ccAction.scaleTo(0.3, 0.001, 0.001));
              this.btnSpin.runAction(ccAction.scaleTo(0.3, 0.001, 0.001));
              SoundManager.playSound("item_purchased");
              this.times = res.times || 1;
              let index = -1;
              let start = G.getRandomInt(0, MultipleList.length);

              while (index < 0) {
                if (start < 0) {
                  index = 2;
                  break;
                }

                index = MultipleList.indexOf(this.times, start);
                start--;
              }

              this.ShowWheel(index);
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "multi",
                name: this.meta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "multi",
                name: this.meta.Name(),
                phase: -1
              });
            }
          });
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "multi",
            name: this.meta.Name(),
            phase: 0
          });
        } //Wheel


        ShowWheel(index) {
          this.w_targetRot = G.getRandomFloat(this.indexRotation[index].min, this.indexRotation[index].max) + 6 * 360;
          this.StartWheel();
        }

        updateWheel(dt) {
          if (!this.w_spining) return;

          if (this.w_rot >= this.w_targetRot - 6) {
            this.speed = Math.max(2, this.speed - 5 * dt);
          } else if (this.w_rot >= this.w_targetRot - 18) {
            this.speed = Math.max(3, this.speed - 1 * dt);
          } else if (this.w_rot >= this.w_targetRot - 1200) {
            this.speed = (this.w_targetRot - this.w_rot) / 0.8;
          } else {
            this.speed += dt * 450;
            if (this.speed > 600) this.speed = 600;
          }

          this.w_rot += this.speed * dt;

          if (this.w_rot >= this.w_targetRot) {
            this.w_rot = this.w_targetRot;
            this.StopWheel();
          }

          this.spWheel.angle = this.w_rot % 360;
          let soundCount = Math.floor(this.w_rot / 45);

          if (soundCount > this.soundCount) {
            SoundManager.playSound("multi_spin");
            this.soundCount = soundCount;
          }
        }

        StartWheel() {
          this.w_spining = true;
          this.speed = 0;
          this.w_rot %= 360;
          this.soundCount = Math.floor(this.w_rot / 50) - 1;
        }

        StopWheel() {
          this.w_spining = false;
          this.speed = 0;

          if (this.times > 1) {
            let ar = instantiate(this.animRibbon);
            ar.active = true;
            ar.parent = this.animRibbon.parent;
            ar.x = this.animRibbon.x;
            ar.y = this.animRibbon.y;
          }

          if (this.times > 1) {
            this.spResult.runAction(ccAction.scaleTo(0.3, 1, 1));
            SoundManager.playSound("multi_spin_over");
          } else SoundManager.playSound("chest_card");

          this.labelResult.string = i18n.t("multiplyX") + this.times;

          if (this.spinTimes < G.GameConstance.multiPurchaseMaxUse) {
            this.spLabel.runAction(ccAction.scaleTo(0.3, 1, 1));
            this.btnSpin.runAction(ccAction.scaleTo(0.3, 1, 1));
          }

          eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
        }

        closeResult() {
          this.spResult.runAction(ccAction.scaleTo(0.3, 0.001, 0.001));

          if (this.spinTimes >= G.GameConstance.multiPurchaseMaxUse) {
            this.scheduleOnce(() => {
              this.closeAnim();
            }, 0.5);
          }
        }

      }, _defineProperty(_class3, "windowPath", "Shop/NewMultiplePurchaseWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spWheel", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelTimesItem", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelDesPay", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spLabel", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "btnSpin", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "spResultClick", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spResult", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "labelResult", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "animRibbon", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ButtonSearch.ts", ['cc', './global.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, SpriteFrame, Node, dragonBones, _decorator, Component, G, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      dragonBones = module.dragonBones;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ca8efwt8bNGsLFxJ3aa8gNt", "ButtonSearch", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ButtonSearch = exports('ButtonSearch', (_dec = ccclass('ButtonSearch'), _dec2 = property(Sprite), _dec3 = property(Sprite), _dec4 = property(SpriteFrame), _dec5 = property(SpriteFrame), _dec6 = property(SpriteFrame), _dec7 = property(SpriteFrame), _dec8 = property(SpriteFrame), _dec9 = property(SpriteFrame), _dec10 = property(Node), _dec11 = property(dragonBones.ArmatureDisplay), _dec12 = property(dragonBones.ArmatureDisplay), _dec13 = property(SpriteFrame), _dec14 = property(SpriteFrame), _dec(_class = (_class2 = (_temp = class ButtonSearch extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "edge", _descriptor, this);

          _initializerDefineProperty(this, "filler", _descriptor2, this);

          _initializerDefineProperty(this, "sfEdgeUP", _descriptor3, this);

          _initializerDefineProperty(this, "sfEdgeDOwn", _descriptor4, this);

          _initializerDefineProperty(this, "sfFillerUp", _descriptor5, this);

          _initializerDefineProperty(this, "sfFillerDown", _descriptor6, this);

          _initializerDefineProperty(this, "sfEdgeGreen", _descriptor7, this);

          _initializerDefineProperty(this, "sfFillerGreen", _descriptor8, this);

          _initializerDefineProperty(this, "pressedLight", _descriptor9, this);

          _initializerDefineProperty(this, "dbSearch", _descriptor10, this);

          _initializerDefineProperty(this, "dbWater", _descriptor11, this);

          _initializerDefineProperty(this, "sfFillerBlueDown", _descriptor12, this);

          _initializerDefineProperty(this, "sfFillerBlueUp", _descriptor13, this);
        }

        onLoad() {
          this.idle(Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.AP() >= G.GameConstance.apMax);
        }

        click(isFull) {
          this.pressedLight.active = false;
          this.dbSearch.node.active = false;
          this.scheduleOnce(() => {
            this.edge.spriteFrame = this.sfEdgeDOwn;
            this.filler.spriteFrame = isFull ? this.sfFillerDown : this.sfFillerBlueDown;
            this.scheduleOnce(() => {
              this.idle(isFull);
            }, 0.1);
          }, 0.13);
        }

        hold(isFull) {
          this.pressedLight.active = false;
          this.dbSearch.node.active = false;
          this.edge.spriteFrame = this.sfEdgeDOwn;
          this.filler.spriteFrame = isFull ? this.sfFillerDown : this.sfFillerBlueDown;
          isFull ? this.dbWater.playAnimation("water_red", 0) : this.dbWater.playAnimation("water_blue", 0);
        }

        pressed(isFull) {
          this.pressedLight.active = true;
          this.dbSearch.node.active = true;
          this.dbSearch.playAnimation("pressed", 0);
          this.dbWater.playAnimation("water_green", 0);
          this.edge.spriteFrame = this.sfEdgeGreen;
          this.filler.spriteFrame = this.sfFillerGreen;
        }

        idle(isFull) {
          this.pressedLight.active = false;
          this.dbSearch.node.active = false;
          isFull ? this.dbWater.playAnimation("water_red", 0) : this.dbWater.playAnimation("water_blue", 0);
          this.edge.spriteFrame = this.sfEdgeUP;
          this.filler.spriteFrame = isFull ? this.sfFillerUp : this.sfFillerBlueUp;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "edge", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "filler", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "sfEdgeUP", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sfEdgeDOwn", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sfFillerUp", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "sfFillerDown", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "sfEdgeGreen", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "sfFillerGreen", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "pressedLight", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "dbSearch", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "dbWater", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "sfFillerBlueDown", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "sfFillerBlueUp", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LevelBonusMeta.ts", ['cc', './Content.ts'], function (exports) {
  'use strict';

  var cclegacy, Content;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "cac1ekrgkNBTpLYpmUgkWSO", "LevelBonusMeta", undefined);

      class LevelBonusMeta {
        constructor() {
          _defineProperty(this, "_data", {});

          _defineProperty(this, "reward", void 0);
        }

        static MakeEntity(data) {
          let meta = new LevelBonusMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        MapId() {
          return this._data.mapId;
        }

        Reward() {
          if (!this.reward) {
            this.reward = Content.FromString(this._data.reward);
          }

          return this.reward;
        }

      }

      exports('LevelBonusMeta', LevelBonusMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HeistData.ts", ['cc', './StaticGame.ts', './i18n.ts'], function (exports) {
  'use strict';

  var misc, cclegacy, Game, Meta, i18n;
  return {
    setters: [function (module) {
      misc = module.misc;
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "cad5dWtuwVLraazVao9AG1S", "HeistData", undefined);

      class HeistData {
        /** @type {ActivityMeta} */
        static load_data(activityMeta) {
          this.activityMeta = activityMeta;
        }
        /** @returns {ActivityMeta} */


        static get_activity_meta() {
          return this.activityMeta;
        }
        /** @returns {number} */


        static get_activity_meta_id() {
          return this.activityMeta.Id();
        }
        /** @returns {number} 获取总的购买次数 */


        static get_buy_count() {
          return Game.SUserActivity.GetActivityData(this.get_activity_meta_id()).buyCount || 0;
        }
        /**
         * 获取当前项目的购买状态
         * @param {number} index
         * @returns {"able-to-buy"|"buy-enough"|"no-able-to-buy"} 分别代表的含义是:允许购买,购买过,还不允许购买
         */


        static get_buy_state(index) {
          let count = this.get_buy_count() - this.get_buy_item_pre_count(index);

          if (count < 0) {
            return "no-able-to-buy";
          } else if (count < this.get_buy_item_count(index)) {
            return "able-to-buy";
          } else {
            return "buy-enough";
          }
        }
        /**
         * 判断是否允许购买
         * @param {number} index
         * @returns {boolean} */


        static is_buy(index) {
          let count = this.get_buy_count() - this.get_buy_item_pre_count(index);
          return count >= 0 && count < this.get_buy_item_count(index);
        }
        /**
         * 获取所有购买项的个数
         * @returns {number}
         */


        static get_buy_item_length() {
          return this.get_activity_meta().Param().items.length;
        }

        static get_buy_Count_length() {
          return this.get_activity_meta().Param().countAll;
        }
        /**
         * 获取当前购买项的shopId
         * @param {number} index
         * @returns {number}
         */


        static get_buy_item_shop_id(index) {
          let buyCount = this.get_buy_count();
          buyCount -= this.get_buy_item_pre_count(index);
          buyCount = Math.min(Math.max(0, buyCount), this.get_activity_meta().Param().items[index].length - 1);
          let s = this.get_activity_meta().Param().items[index][buyCount];
          return s.shopId;
        }
        /**
         * 获取当前购买项的packId
         * @param {number} index
         * @returns {number}
         */


        static get_buy_item_pack_id(index) {
          let buyCount = this.get_buy_count();
          buyCount -= this.get_buy_item_pre_count(index);
          buyCount = Math.min(Math.max(0, buyCount), this.get_activity_meta().Param().items[index].length - 1);
          let s = this.get_activity_meta().Param().items[index][buyCount];
          return s.packId;
        }
        /**
         * 获取当前购买项的可购买次数
         * @param {number} index
         * @returns {number}
         */


        static get_buy_item_count(index) {
          let s = this.get_activity_meta().Param().items[index];
          return s.length;
        }
        /**
         * 获取当前购买项前面所有的购买次数和
         * @param {number} index
         * @returns {number}
         */


        static get_buy_item_pre_count(index) {
          let count = 0;

          for (let i = 0; i < index; i += 1) {
            count += this.get_buy_item_count(i);
          }

          return count;
        }
        /**
         * 获取当前购买项的购买次数字符串
         * @param {number} index
         * @returns {string}
         */


        static get_buy_item_count_str(index) {
          return `${misc.clampf(this.get_buy_count() - this.get_buy_item_pre_count(index), 0, this.get_buy_item_count(index))}/${this.get_buy_item_count(index)}`;
        }
        /**
         * 获取当前购买项的价格字符串
         * @param {number} index
         * @returns {string}}
         */


        static get_buy_item_price_str(index) {
          let buyCount = this.get_buy_count();
          buyCount -= this.get_buy_item_pre_count(index);
          buyCount = Math.min(Math.max(0, buyCount), this.get_activity_meta().Param().items[index].length - 1);
          let s = this.get_activity_meta().Param().items[index][buyCount];
          return s.shopId ? Meta.MetaManager.GetMeta(Meta.MetaType.Shop, s.shopId).PriceString() : i18n.t("heist_main_window_free");
        }
        /**
         * 获取当前购买项的购买内容列表
         * @param {number} index
         * @returns {Content[]}
         */


        static get_buy_item_reward_list(index) {
          let buyCount = this.get_buy_count();
          buyCount -= this.get_buy_item_pre_count(index);
          buyCount = Math.min(Math.max(0, buyCount), this.get_activity_meta().Param().items[index].length - 1);
          let s = this.get_activity_meta().Param().items[index][buyCount];
          return s.shopId ? Meta.MetaManager.GetMeta(Meta.MetaType.Shop, s.shopId).Content().Contents() : Meta.MetaManager.GetMeta(Meta.MetaType.PackItem, s.packId).Contents();
        }
        /**
         * 获取当前购买项的类型
         * @param {number} index
         * @returns {"coin"|"money"|"free"}
         */


        static get_buy_item_type(index) {
          let s = this.get_activity_meta().Param().items[index][0];
          return s.shopId ? Meta.MetaManager.GetMeta(Meta.MetaType.Shop, s.shopId).Type() === Meta.ShopMeta.Types.CoinPack ? "coin" : "money" : "free";
        }

      }

      exports('default', HeistData);

      _defineProperty(HeistData, "activityMeta", null);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/wx_lib.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, sys;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sys = module.sys;
    }],
    execute: function () {
      exports('wxTools', void 0);

      cclegacy._RF.push({}, "cb18dUFX/5DA51v+h9ix1vD", "wx_lib", undefined);

      let wxTools;

      (function (_wxTools) {
        const usewx = _wxTools.usewx = sys.platform === sys.WECHAT_GAME;

        function SdkVersionOver(ver) {
          let s = wx.getSystemInfoSync().SDKVersion.split('.');
          let v = ver.split('.');
          let index = 0;

          while (true) {
            if (s.length > index && v.length > index) {
              if (parseInt(s[index]) > parseInt(v[index])) return 1;
              if (parseInt(s[index]) < parseInt(v[index])) return -1;
            } else if (s.length > index && v.length <= index) return 1;else if (s.length <= index && v.length > index) return -1;else break;

            index++;
          }

          return 0;
        }

        _wxTools.SdkVersionOver = SdkVersionOver;

        function OpenDataPostMessage(obj) {
          try {
            wx.triggerGC();
            wx.getOpenDataContext().postMessage(obj);
          } catch (e) {}
        }

        _wxTools.OpenDataPostMessage = OpenDataPostMessage;

        function OpenDataCanvas() {
          try {
            return wx.getOpenDataContext().canvas;
          } catch (e) {}

          return null;
        }

        _wxTools.OpenDataCanvas = OpenDataCanvas;

        function QueryObjectToString(obj) {
          let str = "";
          let index = 0;

          for (let key in obj) {
            if (index !== 0) str += '&';
            str += key.toString() + '=' + obj[key].toString();
            index += 1;
          }

          return str;
        }

        _wxTools.QueryObjectToString = QueryObjectToString;

        function ShareCommon(res) {
          let func = String.fromCharCode(115, 104, 97, 114, 101, 65, 112, 112, 77, 101, 115, 115, 97, 103, 101);
          wx[func](res);
        }

        _wxTools.ShareCommon = ShareCommon;

        function PathToWxPath(path) {
          return "res/raw-assets/" + path;
        }

        _wxTools.PathToWxPath = PathToWxPath;
      })(wxTools || (wxTools = exports('wxTools', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitPrefabMgr.ts", ['cc', './CCE_Component.ts', './MinigameTools.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, instantiate, CCE_Component, MinigameTools;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      MinigameTools = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "cb26eg6QsJG6bCZsVpzcqzJ", "MinigameCoinhitPrefabMgr", undefined); // @ts-check


      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        BLOCK_PROB_LIST: [0.5, 0.2, 0.2, 0.1]
      };
      /**
       * prefab管理器,避免出现n个prefab的形式
       * - [注意] 所有的get方法均会返回1个新的node,而不是当前的node
       */

      let MinigameCoinhitPrefabMgr = exports('default', (_dec = property({
        tooltip: "ball",
        type: Node
      }), _dec2 = property({
        tooltip: "ball-plus-one",
        type: Node
      }), _dec3 = property({
        tooltip: "block-list",
        type: Node
      }), _dec4 = property({
        tooltip: "box-list",
        type: Node
      }), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameCoinhitPrefabMgr extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "ball", _descriptor, this);

          _initializerDefineProperty(this, "ball_plus_one", _descriptor2, this);

          _initializerDefineProperty(this, "block_list", _descriptor3, this);

          _initializerDefineProperty(this, "box_list", _descriptor4, this);
        }

        onLoad() {
          MinigameCoinhitPrefabMgr.ins = this;
          this.node.active = false; // 隐藏
        }

        onDestroy() {
          MinigameCoinhitPrefabMgr.ins = null;
        }
        /** @type {cc.Node} */


        get_ball() {
          return instantiate(this.ball);
        }

        get_ball_plus_one() {
          return instantiate(this.ball_plus_one);
        }
        /** 根据C中配置的概率获取1个随机的block */


        get_random_block() {
          return instantiate(MinigameTools.get_random_item(this.block_list, C.BLOCK_PROB_LIST));
        }
        /**
         * 获取宝箱
         * @param {number} index 
         */


        get_box(index) {
          return instantiate(this.box_list[index]);
        }

      }, _defineProperty(_class3, "ins", void 0), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ball", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "ball_plus_one", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "block_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "box_list", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TimeDestroy.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "cbea9QGz8lJLZou4Qmi/m53", "TimeDestroy", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let TimeDestroy = exports('default', (_dec = property(CCInteger), ccclass(_class = (_class2 = (_temp = class TimeDestroy extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "t", _descriptor, this);
        }

        start() {
          this.scheduleOnce(() => {
            this.node.destroy();
          }, this.t);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "t", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRLogin.ts", ['cc', './global.ts', './AppGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, sys, G, AppGame, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sys = module.sys;
    }, function (module) {
      G = module.G;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRLogin', void 0);

      cclegacy._RF.push({}, "ce0d5vVk5ZP96rdmcF0I2Dc", "SRLogin", undefined);

      let SRLogin;

      (function (_SRLogin) {
        function login(accountId, from) {
          let req = new GameKit.ServerRequest("login");
          req.SetRequestBody("accountId", accountId);
          req.SetRequestBody("from", from);
          req.SetRequestBody("platform", sys.os);
          req.SetRequestBody("deviceId", G.deviceId);
          return req;
        }

        _SRLogin.login = login;

        function clearProgress() {
          let req = new GameKit.ServerRequest("clearProgress");
          req.SetCallBack(function (res) {
            AppGame.instance.logout();
          });
          return req;
        }

        _SRLogin.clearProgress = clearProgress;

        function bindAccount(accountId, from) {
          let req = new GameKit.ServerRequest("bindAccount");
          req.SetRequestBody("accountId", accountId);
          req.SetRequestBody("from", from);
          return req;
        }

        _SRLogin.bindAccount = bindAccount;
      })(SRLogin || (SRLogin = exports('SRLogin', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRTask.ts", ['cc', './GameMainWindow.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameMainWindow, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRTask', void 0);

      cclegacy._RF.push({}, "ce2128h/jRIAZ/EFy1net1x", "SRTask", undefined); // 获取任务列表


      let SRTask;

      (function (_SRTask) {
        function getTaskList() {
          let req = new GameKit.ServerRequest("getTaskList");
          req.SetCallBack(res => {
            GameKit.DataCache.SetData("UserTask", res.list);
            if (GameMainWindow.instance) homeView.slotPage.updateQuestBadge();
          });
          return req;
        }

        _SRTask.getTaskList = getTaskList;

        function receiveTaskReward(id) {
          let req = new GameKit.ServerRequest("receiveTaskReward");
          req.SetRequestBody("taskId", id);
          return req;
        }

        _SRTask.receiveTaskReward = receiveTaskReward;

        function clientCountTask(target, count) {
          let req = new GameKit.ServerRequest("clientCountTask");
          req.SetRequestBody("target", target);
          req.SetRequestBody("count", count);
          req.SetSilence(true);
          return req;
        }

        _SRTask.clientCountTask = clientCountTask;
      })(SRTask || (SRTask = exports('SRTask', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MenuWindow.ts", ['cc', './Constant.ts', './global.ts', './EnterCloseAnim.ts', './UIWindow.ts', './ChangeSceneManager.ts', './DailyBonusNode.ts', './UserInfoModel.ts', './CardAllSetWindow.ts', './AppGame.ts', './InviteWindow.ts', './GiftsWindow.ts', './VillageNewsWindow.ts', './ServantWindow.ts', './BadgeItem.ts', './SignInWindow.ts', './LeaderboardWindow.ts', './SettingWindow.ts', './NewMapWindow.ts', './SR.ts', './ShopWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './UserWrap.ts', './AppKit.ts', './GameKit.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, Label, Button, _decorator, Widget, v3, Vec2, sys, MyCustomEvent, G, EnterCloseAnim, UIWindow, ChangeSceneManager, DailyBonusNode, UserInfoModel, CardAllSetWindow, AppGame, InviteWindow, GiftsWindow, VillageNewsWindow, ServantWindow, BadgeItem, SignInWindow, LeaderboardWindow, SettingWindow, NewMapWindow, SR, ShopWindow, UIRoot, Game, Meta, LogEventWrap, UserWrap, GameKit, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      Button = module.Button;
      _decorator = module._decorator;
      Widget = module.Widget;
      v3 = module.v3;
      Vec2 = module.Vec2;
      sys = module.sys;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ChangeSceneManager = module.default;
    }, function (module) {
      DailyBonusNode = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      CardAllSetWindow = module.default;
    }, function (module) {
      AppGame = module.default;
    }, function (module) {
      InviteWindow = module.InviteWindow;
    }, function (module) {
      GiftsWindow = module.GiftsWindow;
    }, function (module) {
      VillageNewsWindow = module.VillageNewsWindow;
    }, function (module) {
      ServantWindow = module.ServantWindow;
    }, function (module) {
      BadgeItem = module.default;
    }, function (module) {
      SignInWindow = module.SignInWindow;
    }, function (module) {
      LeaderboardWindow = module.LeaderboardWindow;
    }, function (module) {
      SettingWindow = module.SettingWindow;
    }, function (module) {
      NewMapWindow = module.NewMapWindow;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      UserWrap = module.UserWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "cef8f7ghsNKIYayjWU3Fka8", "MenuWindow", undefined); //// let UIWindow = UIWindow
      // let BadgeItem = BadgeItem


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        /** 进入动画时间 */
        IN_ANIMATION_TIME: 0.4
      };
      /**
       * Menu界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let MenuWindow = exports('MenuWindow', (_dec = property(Node), _dec2 = property(BadgeItem), _dec3 = property(BadgeItem), _dec4 = property(Node), _dec5 = property(BadgeItem), _dec6 = property(Node), _dec7 = property(Sprite), _dec8 = property(Label), _dec9 = property(Button), _dec10 = property(Button), _dec11 = property(Button), _dec12 = property(Node), _dec13 = property(Node), _dec14 = property(Node), _dec15 = property(Label), _dec16 = property(Node), _dec17 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class MenuWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "btn_back", _descriptor, this);

          _initializerDefineProperty(this, "badge_dailybonus", _descriptor2, this);

          _initializerDefineProperty(this, "badge_villagenews", _descriptor3, this);

          _initializerDefineProperty(this, "badge_servant", _descriptor4, this);

          _initializerDefineProperty(this, "badge_signIn", _descriptor5, this);

          _initializerDefineProperty(this, "bindItem", _descriptor6, this);

          _initializerDefineProperty(this, "spAvatar", _descriptor7, this);

          _initializerDefineProperty(this, "labelName", _descriptor8, this);

          _initializerDefineProperty(this, "btnAddCoin", _descriptor9, this);

          _initializerDefineProperty(this, "btnAddAp", _descriptor10, this);

          _initializerDefineProperty(this, "btnCleanData", _descriptor11, this);

          _initializerDefineProperty(this, "gmNode", _descriptor12, this);

          _initializerDefineProperty(this, "servantNode", _descriptor13, this);

          _initializerDefineProperty(this, "content", _descriptor14, this);

          _initializerDefineProperty(this, "labelVersion", _descriptor15, this);

          _initializerDefineProperty(this, "GM", _descriptor16, this);

          _initializerDefineProperty(this, "vipIcon", _descriptor17, this);

          _defineProperty(this, "is_back_click", false);
        }
        /** UIWindow.unShow() */


        onLoad() {
          this.node.getChildByName("content_window").getComponent(Widget).top += AppMain.instance.statusBarHeight;
        }

        onShowBack() {
          this.getComponentsInChildren(EnterCloseAnim).forEach((enterCloseAnim, index) => {
            enterCloseAnim.enterAnim();
          });
          this.update_badge_array();
          this.node.getComponentsInChildren(Widget).forEach(widget => {
            widget.updateAlignment();
          });
          this.is_back_click = false;

          if (Game.SUser.IsGuest()) {
            this.bindItem.active = true;
          }

          this.GM.active = this.gmNode.active = appGame.isDev;
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.GM.active = this.gmNode.active = appGame.isDev;
          });
          UserInfoModel.SetAvatar(this.spAvatar, Game.SUser);
          UserInfoModel.SetName(this.labelName, Game.SUser);
          this.vipIcon.active = Game.SUser.IsVip();
          this.servantNode.active = Game.SUserVillage.MapId() >= G.GameConstance.servantSystemStartLevel;
          this.content.children.filter(child => child.active === true).forEach((node, index) => {
            node.getComponent(Sprite) && (node.getComponent(Sprite).enabled = index % 2 === 0);
          });
          this.updateLabelVersion();
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.updateLabelVersion();
          }, this);
        }

        onShow() {
          this.node.active = true;
          this.node.position = v3(Vec2.ZERO.x, Vec2.ZERO.y, 0);
          this.btn_back.active = true;
          this.update_badge_array();
          eventCenter.on(MyCustomEvent.SignInCollected, () => {
            this.update_badge_array();
          }, this); //let action = ccAction.moveBy(C.IN_ANIMATION_TIME, 450, 0)
          //UIRoot.instance.mainCamera.node.stopAllActions() // 停止所有动画
          //UIRoot.instance.mainCamera.node.runAction(action, ccAction.easeBackOut(1.4))
          //this.node.once(cc.Node.EventType.TOUCH_START, () => {
          //this.bg.active = false
          //this.event_back()
          //})

          if (Game.SUser.IsGuest()) {
            this.bindItem.active = true;
          }

          this.GM.active = this.gmNode.active = appGame.isDev;
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.GM.active = this.gmNode.active = appGame.isDev;
          });
          UserInfoModel.SetAvatar(this.spAvatar, Game.SUser);
          UserInfoModel.SetName(this.labelName, Game.SUser);
          this.vipIcon.active = Game.SUser.IsVip();
          this.servantNode.active = Game.SUserVillage.MapId() >= G.GameConstance.servantSystemStartLevel;
          this.content.children.filter(child => child.active === true).forEach((node, index) => {
            node.getComponent(Sprite) && (node.getComponent(Sprite).enabled = index % 2 === 0);
          });
          this.updateLabelVersion();
          eventCenter.on(MyCustomEvent.SwitchDebug, () => {
            this.updateLabelVersion();
          }, this);
          this.updateLabelServer();
        }

        onClose() {//GameMainWindow.instance.showUI()
        }

        updateLabelVersion() {
          if (!appGame.isDev) {
            this.labelVersion.node.active = false;
            return;
          }

          this.labelVersion.node.active = true;
          const text = `native_v:${$tp_version}\nhot_v:${versionConfig.hot_v}\nbundle_v:${versionConfig.bundle_v.split("_")[0]}\nmeta_v:${versionConfig.meta_v}\n`;
          this.labelVersion.string = text;
          this.labelVersion.getComponent(Widget).updateAlignment();
        }
        /** 更新所有的badge
         * - 未来需要传入相应的参数
         */


        update_badge_array() {
          this.badge_dailybonus.SetNum(G.GameConstance.dailybonusMaxCount - Game.SUserSlot.DailyBonusDid()); // if (GameMainWindow.instance) this.badge_villageshop.SetNum(homeView.villagePage.villageShopBadge.num);

          let NewMessageNum = GameKit.DataCache.GetData("NewMessageNum");
          if (NewMessageNum == null) NewMessageNum = 0;
          let presentNum = VillageNewsWindow.getPresentNum();
          this.badge_villagenews.SetNum(NewMessageNum + presentNum);
          let GiftsNum = GameKit.DataCache.GetData("GiftsNum");
          if (GiftsNum == null) GiftsNum = 0; // this.badge_gifts.SetNum(GiftsNum);

          const state = Game.SUserServant.Servant(Game.SUserServant.GetSelected() || 1);

          if (state) {
            const levelUpNeedExp = Meta.MetaManager.GetMeta(Meta.MetaType.ServantRank, state.rank).Exp(Game.SUserServant.GetSelected() || 1);
            this.badge_servant && (this.badge_servant.active = state.exp >= levelUpNeedExp);
          } else {
            this.badge_servant && (this.badge_servant.active = false);
          }

          this.badge_signIn.node.active = false;
          let signData = GameKit.DataCache.GetData("signData");

          if (signData) {
            let canSignWeek = false;
            let canSignMonth = false;
            canSignWeek = signData.signWeekDay > signData.signWeekRewards;

            for (let i = 7; i <= 28; i += 7) {
              if (signData.signMonthDay >= i && !signData.signMonthRewards.includes(i)) {
                canSignMonth = true;
                break;
              }
            }

            this.badge_signIn.node.active = canSignWeek || canSignMonth;
          }
        }
        /** 点击事件：back_btn */


        event_back(e, cb, time) {
          if (this.is_back_click) {
            return;
          }

          this.is_back_click = true; //let action = ccAction.moveTo(C.IN_ANIMATION_TIME, 0, 0)
          //UIRoot.instance.mainCamera.node.stopAllActions() // 停止所有动画
          //UIRoot.instance.mainCamera.node.runAction(action, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackIn)

          let anims = this.getComponentsInChildren(EnterCloseAnim);
          globalThis.uiRoot.ShowCantClick(true);

          for (let i = 0; i < anims.length; i++) {
            if (i === 0) {
              anims[i].closeAnim(() => {
                globalThis.uiRoot.CloseCantClick();
                if (cb != null) cb();
              });
            } else if (i === anims.length - 1) {
              anims[i].closeAnim(() => {
                this.node.active = false;
              });
            } else {
              anims[i].closeAnim();
            }
          }
        }
        /** 点击事件： */


        event_0_play() {
          this.event_back(null, () => {// homeView.changePage(HomeView.Pages.Slot);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_play");
        }
        /** 点击事件： */


        event_1_village() {
          this.event_back(null, () => {// homeView.changePage(HomeView.Pages.Village);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_village");
        }
        /** 点击事件： */


        event_2_buy() {
          this.event_back(null, () => {
            homeView.pageViewController.moveToPage(G.Pages.Shop, true);
            homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.coin);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_shop");
        }
        /** 点击事件： */


        event_3_bonus() {
          this.event_back(null, () => {
            if (homeView.isBusy()) return;
            ChangeSceneManager.instance.show(() => {
              UIRoot.instance.openChildWindow(DailyBonusNode, {
                showCallback: () => {
                  ChangeSceneManager.instance.hide();
                }
              }, UIRoot.instance.dailyBonusNode);
            });
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_dailybonus");
        }
        /** 点击事件： */


        event_4_shop() {
          this.event_back(null, () => {// homeView.changePage(HomeView.Pages.Village, () => {
            // 	UIRoot.instance.openChildWindow(VillageShopWindow);
            // });
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_villageshop");
        }
        /** 点击事件： */


        event_5_news() {
          this.event_back(null, () => {
            UIRoot.instance.openChildWindow(VillageNewsWindow);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_news");
        }
        /** 点击事件： */


        event_6_gifts() {
          this.event_back(null, () => {
            UIRoot.instance.openChildWindow(GiftsWindow);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_gift");
        }
        /** 点击事件： */


        event_7_card() {
          // test-RevengeWindow
          this.event_back(null, () => {
            UIRoot.instance.openChildWindow(CardAllSetWindow);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_card");
        }
        /** 点击事件： */


        event_8_map() {
          this.event_back(null, () => {
            UIRoot.instance.openChildWindow(NewMapWindow);
            homeView.villagePage.backToSlotPage = true;
            homeView.villagePage.previewMapId = null;
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_map");
        }
        /** 点击事件： */


        event_9_leaderboard() {
          this.event_back(null, () => {
            UIRoot.instance.openChildWindow(LeaderboardWindow);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_leaderboard");
        }
        /** 点击事件： */


        event_10_invite() {
          this.event_back(null, () => {
            UIRoot.instance.openChildWindow(InviteWindow);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_invite");
        }
        /** 点击事件： */


        event_11_setting() {
          this.event_back(null, () => {
            UIRoot.instance.openChildWindow(SettingWindow);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_setting");
        }
        /**点击事件 */


        event_12_servent() {
          this.event_back(null, () => {
            // UIRoot.instance.openWindow("ServantWindow")
            // UIRoot.instance.openChildWindow(ServantWindow);
            ServantWindow.Show();
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_servent");
        }

        event_13_signIn() {
          this.event_back(null, () => {
            uiRoot.openChildWindow(SignInWindow);
          }, C.IN_ANIMATION_TIME * 1000);
          LogEventWrap.logEvent("menu_signIn");
        }

        connectFacebook() {
          UserWrap.NativeFBLogin(() => {
            let req = SR.SRLogin.bindAccount(Game.SUser.accountId, Game.SUser.from);
            req.SetCallBack(() => {
              this.close();
              AppGame.instance.logout();
            });
            req.Send();
          });
          LogEventWrap.logEvent("menu_connect_Facebook");
        }

        updateLabelServer() {
          let serverLabel = this.GM.getChildByName("ChangeServer").getComponentInChildren(Label);
          const isTestServer = !!parseInt(sys.localStorage.getItem("isTestServer"));
          const mode = isTestServer ? "Test" : "Formal";
          const url = isTestServer ? G.GameConfig.testServer : G.GameConfig.formalServer;
          serverLabel.string = `ChangeServer\ncurrent(${mode}): \n${url} `;
        }

        onTapChangeServer() {
          const isTestServer = !!parseInt(sys.localStorage.getItem("isTestServer"));
          sys.localStorage.setItem("isTestServer", !isTestServer ? 1 : 0);
          this.updateLabelServer();
        }

      }, _defineProperty(_class3, "windowPath", "Menu/NewMenuWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "btn_back", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "badge_dailybonus", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "badge_villagenews", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "badge_servant", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "badge_signIn", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "bindItem", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spAvatar", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "btnAddCoin", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "btnAddAp", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "btnCleanData", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "gmNode", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "servantNode", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "content", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "labelVersion", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "GM", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "vipIcon", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HelpManager.ts", ['cc', './Logs.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Logs, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      exports('HelpManager', void 0);

      cclegacy._RF.push({}, "cf33ax8JQtIq4uzoZreiV0C", "HelpManager", undefined);

      let HelpManager;

      (function (_HelpManager) {
        function init(data) {
          this._data = {};

          try {
            for (let id in data) {
              let kvp = data[id];
              this._data[kvp.key] = kvp.value;
            }
          } catch (e) {
            Logs.Error("HelpManager.init", e.message);
          }
        }

        _HelpManager.init = init;

        function GetHelp(key) {
          return i18n.t("Help_" + key);
        }

        _HelpManager.GetHelp = GetHelp;
      })(HelpManager || (HelpManager = exports('HelpManager', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonShopWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './ContentModel.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Label, log, SoundManager, UIWindow, ContentModel, Meta, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Label = module.Label;
      log = module.log;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "cf5520hD0xB0ZRKNsOsbHA8", "CannonShopWindow", undefined); // const ContentModel = ContentModel


      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        shopIds: [906, 6003]
      };
      /**
       * cannon商店页面
       * - 功能类似于MinigameBuyTicketWindow,难以通用化
       */

      let CannonShopWindow = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class CannonShopWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "buy_item_0", _descriptor, this);

          _initializerDefineProperty(this, "buy_item_1", _descriptor2, this);
        }

        onShow() {
          this.load_page();
        }

        update_buy_item_0() {
          let shopmeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, C.shopIds[0]);
          let content = GameKit.ControllerTable.GetNode(this.buy_item_0, "content").getComponent(ContentModel);
          let label_info = GameKit.ControllerTable.GetNode(this.buy_item_0, "label-info").getComponent(Label);
          let label_price = GameKit.ControllerTable.GetNode(this.buy_item_0, "label-price").getComponent(Label);
          let label_off = GameKit.ControllerTable.GetNode(this.buy_item_0, "off_text").getComponent(Label);
          content.show(shopmeta.Content());
          label_info.string = `${shopmeta.Content().Name()} *${shopmeta.Count()}`;
          label_price.string = shopmeta.PriceString();
          label_off.string = String.format(i18n.t("OffText"), Math.round(shopmeta.Off() * 100));
          label_off.node.parent.active = shopmeta.Off() != 0;
        }

        update_buy_item_1() {
          let shopmeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, C.shopIds[1]);
          let content0 = GameKit.ControllerTable.GetNode(this.buy_item_1, "content-0").getComponent(ContentModel);
          let content1 = GameKit.ControllerTable.GetNode(this.buy_item_1, "content-1").getComponent(ContentModel);
          let label_price = GameKit.ControllerTable.GetNode(this.buy_item_1, "label-price").getComponent(Label);
          let label_off = GameKit.ControllerTable.GetNode(this.buy_item_1, "off_text").getComponent(Label);
          log(content1, shopmeta.Content().Contents()[1]);
          content0.show(shopmeta.Content().Contents()[0]);
          content1.show(shopmeta.Content().Contents()[1]);
          label_price.string = shopmeta.PriceString();
          label_off.string = String.format(i18n.t("OffText"), Math.round(shopmeta.Off() * 100));
          label_off.node.parent.active = shopmeta.Off() != 0;
        }

        load_page() {
          this.update_buy_item_0();
          this.update_buy_item_1();
        }

        event_close() {
          this.closeAnim();
        }

        event_buy(e, index) {
          index = Number.parseInt(index);
          this.buy_item(C.shopIds[index]);
        }

        buy_item(id) {
          let shopmeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, id);
          PaymentWrap.Pay(shopmeta.Name(), function (ok) {
            if (ok) {
              if (this.node) this.closeAnim();
              SoundManager.playSound("item_purchased");
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "items",
                name: shopmeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "items",
                name: shopmeta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "items",
            name: shopmeta.Name(),
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/cannon/CannonShopWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "buy_item_0", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "buy_item_1", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/GMTools.ts", ['cc', './Constant.ts', './global.ts', './SR.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, sys, MyCustomEvent, G, SR, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      sys = module.sys;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "cfd82u9W4hNMIeuG0+XKA5q", "GMTools", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let GMTools = exports('GMTools', (_dec = ccclass("GMTools"), _dec(_class = (_temp = class GMTools extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_url", "");

          _defineProperty(this, "userId", []);
        }

        onLoad() {
          this.userId.push(Game.SUser.UserId().toString());
          const isTestServer = !!parseInt(sys.localStorage.getItem("isTestServer"));
          this._url = (isTestServer ? G.GameConfig.testServer : G.GameConfig.formalServer) + "/__gm__/";
        }

        addAp() {
          const xhr = new XMLHttpRequest();
          xhr.open("POST", this._url, true);
          xhr.setRequestHeader("Content-Type", "application/json");

          xhr.onload = function () {
            console.log(xhr.response);
          };

          const body = {
            method: "addAp",
            userId: this.userId,
            num: 60
          };
          xhr.send(JSON.stringify(body));
          SR.SRChat.getLastChat().Send();
          appGame.scheduleOnce(() => {
            eventCenter.emit(MyCustomEvent.CanChangeSpin);
          }, 1);
        }

        addCoin() {
          const xhr = new XMLHttpRequest();
          xhr.open("POST", this._url, true);
          xhr.setRequestHeader("Content-Type", "application/json");

          xhr.onload = function () {
            console.log(xhr.response);
          };

          const body = {
            method: "addCoin",
            userId: this.userId,
            num: 100000000
          };
          console.log(JSON.stringify(body));
          xhr.send(JSON.stringify(body));
          SR.SRChat.getLastChat().Send();
          appGame.scheduleOnce(() => {
            eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
          }, 1);
        }

        add(event, index) {
          let type;

          switch (index) {
            case "1":
              type = "Coin1";
              break;

            case "2":
              type = "Coin2";
              break;

            case "3":
              type = "Coin3";
              break;

            case "4":
              type = "Coin4";
              break;

            case "5":
              type = "Coin5";
              break;

            case "6":
              type = "Coin6";
              break;

            case "7":
              type = "Shield";
              break;

            case "8":
              type = "Attack";
              break;

            case "9":
              type = "Raid";
              break;

            case "10":
              type = "Spins";
              break;

            case "11":
              type = "Symbol";
              break;

            case "12":
              type = "None";
              break;

            default:
              type = "Coin1";
              break;
          }

          const xhr = new XMLHttpRequest();
          xhr.open("POST", this._url, true);
          xhr.setRequestHeader("Content-Type", "application/json");

          xhr.onload = function () {
            console.log(xhr.response);
          };

          const body = {
            method: "nextSlot",
            userId: this.userId,
            type: type,
            count: 10
          };
          console.log(JSON.stringify(body));
          xhr.send(JSON.stringify(body));
          SR.SRChat.getLastChat().Send();
        }

        resetMap() {
          console.log("resetMap");
          sys.localStorage.clear();
          const xhr = new XMLHttpRequest();
          xhr.open("POST", this._url, true);
          xhr.setRequestHeader("Content-Type", "application/json");

          xhr.onload = function () {
            console.log(xhr.response);
            appGame.logout();
          };

          const body = {
            method: "resetMap",
            userId: this.userId
          };
          console.log(JSON.stringify(body));
          xhr.send(JSON.stringify(body));
        }

        resetAccount() {
          console.log("resetAccount"); // sys.localStorage.clear();

          const xhr = new XMLHttpRequest();
          xhr.open("POST", this._url, true);
          xhr.setRequestHeader("Content-Type", "application/json");

          xhr.onload = function () {
            console.log(xhr.response);
            appGame.logout();
          };

          const body = {
            method: "resetAccount",
            userId: this.userId
          };
          console.log(JSON.stringify(body));
          xhr.send(JSON.stringify(body));
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Bomb.ts", ['cc', './Constant.ts', './ResourceLoader.ts', './MetaManager.ts', './Pet.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, Camera, tween, SkeletalAnimation, instantiate, Animation, Vec2, view, geometry, PhysicsSystem, HandAnimName, PetAnimName, Constant, MyCustomEvent, ResourceLoader, MetaManager, Pet;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      Camera = module.Camera;
      tween = module.tween;
      SkeletalAnimation = module.SkeletalAnimation;
      instantiate = module.instantiate;
      Animation = module.Animation;
      Vec2 = module.Vec2;
      view = module.view;
      geometry = module.geometry;
      PhysicsSystem = module.PhysicsSystem;
    }, function (module) {
      HandAnimName = module.HandAnimName;
      PetAnimName = module.PetAnimName;
      Constant = module.Constant;
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      MetaManager = module.MetaManager;
    }, function (module) {
      Pet = module.default;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "d183c2k93ZF+Zf0z+dR7O1T", "Bomb", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Bomb = exports('default', (_dec = ccclass("Bomb"), _dec(_class = (_temp = class Bomb extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "handNode", void 0);

          _defineProperty(this, "bombParentNode", void 0);

          _defineProperty(this, "bombNode", void 0);

          _defineProperty(this, "tigerNode", void 0);

          _defineProperty(this, "animation", void 0);

          _defineProperty(this, "intercepted", false);

          _defineProperty(this, "isServantActive", false);

          _defineProperty(this, "timeShieldGoldActive", false);

          _defineProperty(this, "timeShieldActive", false);

          _defineProperty(this, "directionVec", new Vec3());

          _defineProperty(this, "totalDistance", 0);

          _defineProperty(this, "dogStartPos", void 0);

          _defineProperty(this, "dogEndPos", void 0);

          _defineProperty(this, "isRunning", false);

          _defineProperty(this, "progress", 0);

          _defineProperty(this, "startPos", new Vec3());

          _defineProperty(this, "endPos", new Vec3());

          _defineProperty(this, "endPercent", 1);

          _defineProperty(this, "interceptedPercent", 0.66);
        }

        init() {
          this.node.getComponent(Camera).destroy();
          this.node.resetPositionAndRotation();
        }

        reachoutHand() {
          // 伸手
          this.node.active = true;
          const pos = this.node.getPosition().clone();
          this.node.setPosition(new Vec3(pos.x, pos.y, pos.z * 2));
          tween(this.node).to(1, {
            position: pos
          }).start();
        }

        onLoad() {
          this.handNode = this.node.getChildByName("hand");
          this.animation = this.handNode.getComponent(SkeletalAnimation);
          this.bombParentNode = this.animation.sockets[0].target.children[0];
          this.bombNode = this.bombParentNode.getChildByName("boom");
          this.tigerNode = this.bombParentNode.getChildByName("Tiger");
          this.tigerNode.active = false;
          this.node.active = false; //关掉投影
          // let meshArr = this.node.getComponentsInChildren(MeshRenderer);
          // meshArr.forEach(v => v.shadowCastingMode = 0);
        }

        start() {
          this.animation.play(HandAnimName.idle);
          let state = this.animation.getState(HandAnimName.attack);
          state.wrapMode = 1;

          if (this.isServantActive) {
            let tigerAnim = this.tigerNode.getComponent(SkeletalAnimation);
            tigerAnim && tigerAnim.play(PetAnimName.Idle);
          }
        }

        update(dt) {
          // dt = Math.clamp(dt, 0, 0.017);
          if (this.isRunning && this.progress <= 1) {
            this.progress += dt / (this.totalDistance * 0.05 * Constant.boomSpeed);

            if (this.progress >= this.endPercent) {
              this.progress = this.endPercent;
              this.isRunning = false;
              this.onMoveEnd();
            }

            const lastPos = this.bombParentNode.worldPosition;
            const newPos = this.getCurvePosByPercent(this.startPos, this.endPos, this.progress);
            this.directionVec = newPos.clone().subtract(lastPos).normalize();
            this.bombParentNode.setWorldPosition(newPos);

            if (!this.intercepted && this.isServantActive) {
              //老虎运动
              this.tigerNode.forward = this.directionVec.multiplyScalar(-1);
            } else {
              //炸弹运动
              this.bombParentNode.forward = this.directionVec;
              this.bombNode.rotateEuler(new Vec3(Constant.boomRotateSpeed, 0, 0));
            }
          }
        }

        startAttack(targetWorldPos, intercepted, isServantActive = false, timeShieldGoldActive, timeShieldActive) {
          console.log("startAttack");
          this.startPos = this.bombParentNode.getWorldPosition().clone();
          this.endPos = targetWorldPos;
          this.intercepted = intercepted;
          this.isServantActive = isServantActive;
          this.timeShieldGoldActive = timeShieldGoldActive;
          this.timeShieldActive = timeShieldActive;
          this.endPercent = intercepted ? this.interceptedPercent : 1;

          if (intercepted) {
            //被格挡，宠物激活表示宠物格挡
            if (this.isServantActive) {
              // this.replaceWithTiger(() => {
              //     this.playAttackAnimation();
              // })
              this.playAttackAnimation();
            } else {
              this.playAttackAnimation();
            }
          } else {
            //没被格挡，宠物激活表示激活老虎
            if (this.isServantActive) {
              this.replaceWithTiger(() => {
                this.playAttackAnimation();
              });
            } else {
              this.playAttackAnimation();
            }
          }
        }

        replaceWithTiger(callback) {
          let animBuild = instantiate(homeView.animBuild);
          let pos = homeView.interactionNode.containerInteraction.camera.convertToUINodeWithTexture(this.bombNode.getWorldPosition(), homeView.interactionNode.node);
          animBuild.position = pos;
          animBuild.scale = animBuild.scale.multiplyScalar(2);
          homeView.interactionNode.node.addChild(animBuild);
          this.scheduleOnce(() => {
            animBuild && animBuild.destroy();
          }, 2);
          tween(this.bombNode).to(0.2, {
            scale: Vec3.ZERO
          }).call(() => {
            this.bombNode.active = false;
            this.tigerNode.active = true;
            let scale = this.tigerNode.scale.clone();
            tween(this.tigerNode).set({
              scale: Vec3.ZERO
            }).to(0.2, {
              scale: scale
            }).delay(0.5).call(() => {
              callback && callback();
            }).start();
          }).start();
        }

        playAttackAnimation() {
          this.animation.play(HandAnimName.attack);
          const totalTime = 1.17;
          const timeFromStartToThrow = 1.1;
          this.scheduleOnce(() => {
            this.throwBomb();
          }, timeFromStartToThrow);
          this.scheduleOnce(() => {
            let hand = this.handNode.getChildByName("hand1");
            hand && (hand.active = false);
          }, totalTime);
          let targetForwardDir = this.endPos.clone().subtract(this.bombParentNode.getWorldPosition());
          targetForwardDir.y = 0;
          targetForwardDir = targetForwardDir.normalize();
          let initialForward = this.handNode.forward.clone();
          tween(initialForward).to(0.5, targetForwardDir, {
            onUpdate: target => {
              this.handNode.forward = target;
            }
          }).start();
        }

        async throwBomb() {
          this.progress = 0;
          this.startPos = this.bombParentNode.getWorldPosition().clone();
          this.totalDistance = this.startPos.clone().subtract(this.endPos).length();

          if (this.intercepted) {
            if (this.isServantActive) {
              const pb = await ResourceLoader.getCommonPrefab("pet/Dog");
              let dogNode = instantiate(pb);
              let petCom = dogNode.addComponent(Pet);
              const offset = new Vec3(5, -2, -5);
              const a = homeView.interactionNode.containerInteraction.camera.node.eulerAngles.y / 180 * Math.PI;
              Vec3.rotateY(offset, offset, new Vec3(), a);
              this.dogEndPos = this.getCurvePosByPercent(this.startPos, this.endPos, this.interceptedPercent);
              this.dogStartPos = this.dogEndPos.clone().add(offset);
              dogNode.setWorldPosition(this.dogStartPos);
              dogNode.scale.multiplyScalar(2);
              dogNode.active = false;
              homeView.interactionNode.containerInteraction.newChild.addChild(dogNode);
              const time = this.totalDistance * 0.05 * Constant.boomSpeed * this.endPercent;
              this.scheduleOnce(() => {
                dogNode.active = true;
                petCom.changeStateToAttack();
                petCom.jump(this.dogStartPos, this.dogEndPos, time / 2, false, () => {
                  this.scheduleOnce(() => {
                    petCom.jump(this.dogEndPos, this.dogEndPos.clone().add(offset.multiplyScalar(-2)), time / 2, false, () => {
                      dogNode.active = false;
                    });
                  }, 1);
                });
              }, time / 2);
            } else {
              let pb;

              if (this.timeShieldGoldActive) {
                pb = ResourceLoader.resMap.get("common/dunpai03");
              } else if (this.timeShieldActive) {
                pb = ResourceLoader.resMap.get("common/dunpai02");
              } else {
                pb = ResourceLoader.resMap.get("common/dunpai");
              }

              let shieldNode = instantiate(pb);
              let lastPos = this.getCurvePosByPercent(this.startPos, this.endPos, this.interceptedPercent - 0.01);
              let newPos = this.getCurvePosByPercent(this.startPos, this.endPos, this.interceptedPercent);
              let directionVec = newPos.clone().subtract(lastPos).normalize();
              homeView.interactionNode.containerInteraction.initShield(shieldNode, newPos, directionVec);
            }
          }

          if (this.isServantActive) {
            let tigerAnim = this.tigerNode.getComponent(SkeletalAnimation);
            tigerAnim && tigerAnim.play(PetAnimName.Fly);
          }

          this.isRunning = true;
          this.unlinkSockets();
        }

        getCurvePosByPercent(startPos, endPos, percent) {
          const outPos = new Vec3();
          const distanceY = endPos.y - startPos.y;
          let time = 1;
          const acceleration = 2 * distanceY / Math.pow(time, 2);
          outPos.x = Math.lerp(startPos.x, endPos.x, percent);
          outPos.z = Math.lerp(startPos.z, endPos.z, percent);
          outPos.y = startPos.y + 0.5 * acceleration * Math.pow(percent, 2);
          return outPos;
        }

        unlinkSockets() {
          this.animation.sockets = [];
        }

        onMoveEnd() {
          console.log("onMoveEnd");

          if (this.intercepted) {
            if (this.isServantActive) {
              eventCenter.emit(MyCustomEvent.OnBombHitDog, this.bombParentNode.getWorldPosition(), this.directionVec);
              const fxPercent = 0.4;
              let shieldNode = instantiate(ResourceLoader.resMap.get("common/dunpai_dog"));
              let lastPos = this.getCurvePosByPercent(this.startPos, this.endPos, fxPercent - 0.01);
              let newPos = this.getCurvePosByPercent(this.startPos, this.endPos, fxPercent);
              let directionVec = newPos.clone().subtract(lastPos).normalize();
              homeView.interactionNode.containerInteraction.initFxShield(shieldNode, newPos, directionVec);
              const dir = this.dogEndPos.clone().subtract(this.dogStartPos).normalize();
              const bombEndPos = this.bombParentNode.getWorldPosition().clone().add(dir.multiplyScalar(10));
              tween(this.bombParentNode).to(0.4, {
                worldPosition: bombEndPos
              }).call(() => {
                homeView.interactionNode.containerInteraction.onHitTarget(bombEndPos);
                this.bombParentNode.active = false;
              }).start();
            } else {
              eventCenter.emit(MyCustomEvent.OnBombHitShield, this.bombParentNode.getWorldPosition(), this.directionVec);
              this.bombParentNode.active = false;
            }
          } else {
            eventCenter.emit(MyCustomEvent.OnBombHitTarget, this.endPos);
            const villageMeta = MetaManager.GetMeta(MetaManager.MetaType.Village, homeView.interactionNode.userVillage.MapId());
            let resId = villageMeta.ResId();
            const canShowTiger = !Constant.skipTigerAnimResIds.contains(resId);

            if (this.isServantActive && canShowTiger) {
              let cmp = this.tigerNode.addComponent(Pet);
              let camera = homeView.interactionNode.containerInteraction.camera;
              let startPos = this.tigerNode.getWorldPosition();
              let endPos = this.getRaycastPos();
              this.tigerNode.setWorldPosition(startPos.x, 0, startPos.z);
              const distance = endPos.clone().subtract(this.tigerNode.worldPosition).length();
              console.log(distance);
              const runTime = Math.clamp(distance / 5, 0.5, 2);
              const offset = new Vec3(0, -0.5, -0.866).multiplyScalar(-8);
              let cameraEndPos = endPos.clone().add(offset);
              console.log(endPos);
              cmp.changeStateToIdle();
              this.scheduleOnce(() => {
                console.log("tiger run start");
                cmp.changeStateToRun();
                cmp.run(endPos, runTime, () => {
                  console.log("tiger run end");
                  cmp.changeStateToIdle();
                  cmp.turn(new Vec3(0, 0, -1), 0.3);
                  eventCenter.emit(MyCustomEvent.OnTigerComeBack);
                }, true);
                const cmpAnim = camera.getComponent(Animation);

                if (cmpAnim) {
                  cmpAnim.stop();
                }

                tween(camera.node).to(runTime, {
                  worldPosition: cameraEndPos,
                  eulerAngles: new Vec3(-25, 0, 0)
                }).start();
              }, 0.5);
            } else {
              this.bombParentNode.active = false;
            }
          }
        }

        getRaycastPos() {
          let endPos = new Vec3();
          let camera = homeView.interactionNode.containerInteraction.camera;
          let pos = new Vec2(view.getVisibleSize().x / 2, 280);
          console.log("raypos location", pos);
          let outRay = new geometry.Ray();
          camera.screenPointToRayWithTexture(pos.x, pos.y, outRay);
          let bo = PhysicsSystem.instance.raycast(outRay);
          console.log(bo);
          let result = PhysicsSystem.instance.raycastResults;
          result.sort((a, b) => a.distance - b.distance);
          if (result.length <= 0) return endPos;
          result.forEach(v => {
            if (v.collider.node.name === "ground") {
              endPos = v.hitPoint;
            }
          });
          return endPos;
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/global.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Vec3;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Vec3 = module.Vec3;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "d1fcb11sWNJULKB0bLZAhet", "global", undefined);

      class G {}

      exports('G', G); //全局变量 函数

      _defineProperty(G, "query", {});

      _defineProperty(G, "shareTicket", void 0);

      _defineProperty(G, "deviceId", void 0);

      (function (_G) {
        function getRandomInt(min, max) {
          return Math.floor(Math.random() * (max - min)) + min;
        }

        _G.getRandomInt = getRandomInt;

        function getRandomFloat(min, max) {
          return Math.random() * (max - min) + min;
        }

        _G.getRandomFloat = getRandomFloat;

        function getRandomArrayObejct(array) {
          return array[this.getRandomInt(0, array.length)];
        }

        _G.getRandomArrayObejct = getRandomArrayObejct;
        let _rseed = 10;

        function setSeed(s) {
          _rseed = s;
        }

        _G.setSeed = setSeed;

        function getSeededRandom(min = 0, max = 1) {
          _rseed = (_rseed * 9301 + 49297) % 233280;
          var rnd = _rseed / 233280.0;
          return min + rnd * (max - min);
        }

        _G.getSeededRandom = getSeededRandom;

        function getSeededRandomInt(min, max) {
          return Math.floor(getSeededRandom() * (max - min)) + min;
        }

        _G.getSeededRandomInt = getSeededRandomInt;

        function generateUUID() {
          var d = new Date().getTime();
          var uuid = "xxxxxxxx-xxxx-2xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c == "x" ? r : r & 0x3 | 0x8).toString(16);
          });
          return uuid;
        }

        _G.generateUUID = generateUUID;

        function Try(func) {
          try {
            func();
          } catch (e) {}
        }

        _G.Try = Try;

        function ObjectCopy(o) {
          let no = {};

          for (let key in o) {
            no[key] = o[key];
          }

          return no;
        }

        _G.ObjectCopy = ObjectCopy;
        const GameConstance = _G.GameConstance = {
          apMax: 60,
          apRecoverSpins: 7,
          apRecover: 3600,
          vipApMax: 70,
          vipApRecoverSpins: 8,
          dailyBonusCD: 0,
          dailybonusMaxCount: 0,
          vipSlotActivityAdd: 0,
          dailyMaxSendCard: 0,
          coinNotEnoughShop: [],
          apNotEnoughShop: [],
          shieldMax: 3,
          slotSpinsGet: 0,
          watchGetCannonBallMax: 10,
          dailyFreeChestCount: 3,
          cardSystemStartLevel: 1,
          giftCoinMax: 100,
          giftSpinMax: 100,
          spinsPerInvite: {
            "1": 15,
            "5": 25,
            "9": 40
          },
          nextGetSpins: 30,
          initSpin: 8,
          initCoin: 50000,
          firstPurchaseReward: "6=1=1;11=7=1;2=0=20",
          multiPurchaseMaxUse: 5,
          servantFoodTime: 7200,
          servantSystemStartLevel: 2,
          vipDailyReward: "2=0=20;6=3=1;5=5=1",
          servantActiveExp: [40, 20, 100, 100]
        };
        const Constance = _G.Constance = {
          loadingTime: 60,
          AndroidBundleCall: "com/shell/impostorkings/android/"
        };
        const res_root = _G.res_root = "https://impostor-kings.oss-accelerate.aliyuncs.com/coin";
        const res_domain = _G.res_domain = "https://impostor-kings.conchgame.com/coin";
        const GameConfig = _G.GameConfig = {
          //portal: "http://127.0.0.1:3002/app_info",
          useYzAd: true,
          // server: "https://ig-dev.capjoy.com:60001",
          // server: "https://coin-impostor.herokuapp.com",
          testServer: "https://impostor-kings-test.capjoy.com",
          // formalServer: "https://impostor-kings-test.capjoy.com",
          formalServer: "https://impostor-kings.capjoy.com",
          // server: "http://3.18.45.0:3000",
          // meta_server: "https://fay.capjoy.com/gameking/coin/common/meta",
          // assetbundle_server: "https://fay.capjoy.com/gameking/coin/common/assets_bundle",
          meta_server: `${G.res_root}/common/meta`,
          assetbundle_server: `${G.res_root}/common/assets_bundle`,
          site_host: `${G.res_domain}/site`,
          redirectUrl: `${G.res_domain}/site/index.html?redirect=1`,
          email: "support@conchgame.com",
          appleId: "1574313742",
          version: "2.2.2",
          huversion: "99",
          adSpinCount: 4,
          adCoinCount: 8,
          wxad_enable: null,
          wxad_video: null,
          wxad_banner: null,
          closeAdvertisement: false,
          GAME_TEST: true,
          is_appkey_ios: "fe44ad39",
          is_appkey_android: "fe44ad39",
          // adsConfig: {
          // 	appId: SdkManager.IsIos()?GameConfig,
          // 	iads: [""],
          // 	rads: [""]
          // },
          fbad_rad_high: "",
          fbad_rad_low: "",
          fbad_rad_any: "",
          fbad_iad_high: "",
          fbad_iad_low: "",
          fbad_iad_any: "",
          review_max_version: 0,
          max_version: 0,
          closePurchase: false,
          wxOfferId: 0,
          min_version: 0,
          serverDown: {
            startTime: 0,
            endTime: 0,
            msg: ""
          },
          closeCoin6Ad: false,
          closeGiftFbShare: false,
          closeShare: false,
          closeVIP: false,
          metaVersion: 0,
          closeComment: false
        };
        let Pages;

        (function (Pages) {
          Pages[Pages["Community"] = 0] = "Community";
          Pages[Pages["Collection"] = 1] = "Collection";
          Pages[Pages["Slot"] = 2] = "Slot";
          Pages[Pages["Village"] = 3] = "Village";
          Pages[Pages["Shop"] = 4] = "Shop";
        })(Pages || (Pages = {}));

        _G.Pages = Pages;
        let zones;

        (function (zones) {
          zones[zones["vip"] = 0] = "vip";
          zones[zones["levelBonus"] = 1] = "levelBonus";
          zones[zones["spin"] = 2] = "spin";
          zones[zones["coin"] = 3] = "coin";
          zones[zones["shield"] = 4] = "shield";
          zones[zones["chest"] = 5] = "chest";
          zones[zones["treat"] = 6] = "treat";
        })(zones || (zones = {}));

        _G.zones = zones;
        let Platform;

        (function (Platform) {
          Platform["DEFAULT"] = "#platform#";
          Platform["WEB_DEV"] = "web_dev";
          Platform["APP_STROE"] = "app_store";
          Platform["GOOGLE_PLAY"] = "google_play";
        })(Platform || (Platform = {}));

        _G.Platform = Platform;
        const scale2 = _G.scale2 = new Vec3(2, 2, 2);
        const scale1_2 = _G.scale1_2 = new Vec3(1.2, 1.2, 1.2);
        const scale1_1 = _G.scale1_1 = new Vec3(1.1, 1.1, 1.1);
        const scale0_9 = _G.scale0_9 = new Vec3(0.9, 0.9, 0.9);
        const scale0_5 = _G.scale0_5 = new Vec3(0.5, 0.5, 0.5);
        const scale0_3 = _G.scale0_3 = new Vec3(0.3, 0.3, 0.3);
        const scale1_05 = _G.scale1_05 = new Vec3(1.05, 1.05, 1.05);
        const scale0_95 = _G.scale0_95 = new Vec3(0.95, 0.95, 0.95);
        const tips = `Loading_tips_0	寻找额外的体力?让你的朋友和你一起玩!	Looking for extra energies? Get your friends to play along!	여분의 에너지를 찾고 계십니까? 친구들과 함께 놀아주세요!	余分なエネルギーをお探しですか?友達に一緒に遊んでもらいましょう!	À la recherche d'énergies supplémentaires? Faites jouer vos amis !	Buscando energías extra? ¡Haz que tus amigos sigan el juego!	Auf der Suche nach zusätzlicher Energie?Lass deine Freunde mitspielen!	تبحث عن طاقات إضافية? احصل على أصدقاءك للعب على طول!
Loading_tips_1	通过Facebook连接保存你的游戏数据	Keep your progress by connecting through Facebook	Facebook을 통해 연결하여 진행 상황 유지	Facebook経由で接続して進捗状況を維持する	Continuez votre progression en vous connectant via Facebook	Mantenga su progreso conectándose a través de Facebook	Behalten Sie Ihren Fortschritt bei, indem Sie sich über Facebook verbinden	حافظ على تقدمك من خلال ربط من خلال الفيسبوك
Loading_tips_2	是真的......Impostor Kings 和朋友一起玩更有趣	It's true...Impostor Kings is WAY more fun with friends	사실입니다...Impostor Kings는 친구들과 함께 하는 것이 훨씬 더 재미있습니다.	それは本当です... ImpostorKingsは友達とずっと楽しいです	C'est vrai... Impostor Kings est BEAUCOUP plus amusant avec des amis	Es cierto ... Impostor Kings es MUCHO más divertido con amigos	Es ist wahr ... Impostor Kings macht mit Freunden VIEL mehr Spaß	هذا صحيح ... Impostor Kings هو أكثر متعة مع الأصدقاء
Loading_tips_3	你的倍数越高,你得到的回报就越多!	The higher you bet, the greater your rewards get!	더 많이 베팅할수록 더 많은 보상을 받을 수 있습니다!	賭け金が高ければ高いほど、報酬は大きくなります!	Plus vous misez, plus vos récompenses sont importantes !	¡Cuanto más alto apuestes, mayores serán tus recompensas!	Je höher Sie setzen, desto höher werden Ihre Belohnungen!	كلما زادت الرهان ، زادت مكافآتك!
Loading_tips_4	每天给你的朋友送体力和金币!	Send daily coins and energies to your friends!	매일 코인과 에너지를 친구에게 보내세요!	毎日のコインとエネルギーを友達に送ってください!	Envoyez des pièces et des énergies quotidiennes à vos amis !	¡Envía monedas y energías diarias a tus amigas!	Senden Sie täglich Münzen und Energien an Ihre Freunde!	إرسال العملات والطاقات اليومية إلى أصدقائك!
Loading_tips_5	如果你不使用你的金币,你可能会在一次突袭中失去它们!	If you don't use your coins, you might lose them in a raid!	코인을 사용하지 않으면 습격에서 잃어버릴 수 있습니다!	コインを使わないと、レイドで失う可能性があります!	Si vous n'utilisez pas vos pièces, vous risquez de les perdre dans un raid !	Si no usas tus monedas, ¡podrías perderlas en una redada!	Wenn Sie Ihre Münzen nicht verwenden, können Sie sie bei einem Überfall verlieren!	إذا لم تستخدم عملاتك المعدنية ، فقد تفقدها في غارة!
Loading_tips_6	你可以在复仇名单上查看你的仇人	You can check your enemies in the revenge list	복수 목록에서 적을 확인할 수 있습니다	あなたは復讐リストであなたの敵をチェックすることができます	Vous pouvez vérifier vos ennemis dans la liste de vengeance	Puedes comprobar a tus enemigos en la lista de venganza.	Du kannst deine Feinde in der Racheliste überprüfen	يمكنك التحقق من أعدائك في قائمة الانتقام
Loading_tips_7	每小时恢复7体力	7 energies are refilled per hour	시간당 7개의 에너지가 충전됩니다.	1時間に7つのエネルギーが補充されます	7 énergies sont rechargées par heure	Se recargan 7 energías por hora	7 Energien werden pro Stunde wieder aufgefüllt	يتم إعادة تعبئة 7 طاقات في الساعة
Loading_tips_8	宠物非常重要,看看他们都擅长什么!	Servants are important, check out what they are good at!	서번트가 중요하니 잘하는 것을 확인하라!	使用人は重要です、彼らが得意なことをチェックしてください!	Les serviteurs sont importants, vérifiez dans quoi ils sont bons !	Los sirvientes son importantes, ¡mira en qué son buenos!	Diener sind wichtig, sieh dir an, worin sie gut sind!	الخدم مهمون ، تحقق مما يجيدونه!`;
        const title = ["id", "zh", "en", "ko", "ja", "fr", "es", "de", "ar"];

        function getTips(index, la) {
          const result = [];
          const tipArr = tips.split("\n");
          tipArr.forEach(tip => {
            const signleTip = tip.split("\t");
            const newTip = {};

            for (let i = 0; i < title.length; i++) {
              newTip[title[i]] = signleTip[i];
            }

            result.push(newTip);
          });
          return result[index][la] || "";
        }

        _G.getTips = getTips;
      })(G || (G = exports('G', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRTutorial.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRTutorial', void 0);

      cclegacy._RF.push({}, "d2324hrJ11PT69N944HenDW", "SRTutorial", undefined);

      let SRTutorial;

      (function (_SRTutorial) {
        function getData() {
          let req = new GameKit.ServerRequest("getUserTutorial");
          req.SetCallBack(function (res) {
            Game.SUserTutorial.updateData(res.userTutorial);
          });
          return req;
        }

        _SRTutorial.getData = getData;

        function finishStep(id) {
          let req = new GameKit.ServerRequest("finishStep");
          req.SetSilence(true);
          req.SetRequestBody("tutorialId", id);
          return req;
        }

        _SRTutorial.finishStep = finishStep;
      })(SRTutorial || (SRTutorial = exports('SRTutorial', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RaidNode.ts", ['cc', './Constant.ts', './SoundManager.ts', './ResourceLoader.ts', './Pet.ts', './AppMain.ts', './ContainerInteraction.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Camera, Node, geometry, PhysicsSystem, SkeletalAnimation, instantiate, tween, Animation, Vec3, TutorilaEvent, MyCustomEvent, BoxAnimName, SoundManager, ResourceLoader, Pet, AppMain, ContainerInteraction;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Camera = module.Camera;
      Node = module.Node;
      geometry = module.geometry;
      PhysicsSystem = module.PhysicsSystem;
      SkeletalAnimation = module.SkeletalAnimation;
      instantiate = module.instantiate;
      tween = module.tween;
      Animation = module.Animation;
      Vec3 = module.Vec3;
    }, function (module) {
      TutorilaEvent = module.TutorilaEvent;
      MyCustomEvent = module.MyCustomEvent;
      BoxAnimName = module.BoxAnimName;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      Pet = module.default;
    }, function (module) {
      AppMain = module.AppMain;
    }, function (module) {
      ContainerInteraction = module.default;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "d38d8nL5C1Aka49K9y1SGiq", "RaidNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let RaidNode = exports('default', (_dec = ccclass("RaidNode"), _dec(_class = (_temp = class RaidNode extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "boxes", []);

          _defineProperty(this, "camera", void 0);

          _defineProperty(this, "curShakeIndex", 0);

          _defineProperty(this, "shakeInterval", 2);

          _defineProperty(this, "timeElapsed", 0);

          _defineProperty(this, "hasClickedOpen", false);

          _defineProperty(this, "lastClickedIndex", 0);

          _defineProperty(this, "pet", void 0);

          _defineProperty(this, "cameraEndPos", void 0);

          _defineProperty(this, "rabbitStartPosition", void 0);

          _defineProperty(this, "rabbitJumpPosition", void 0);

          _defineProperty(this, "PigStartPositions", []);

          _defineProperty(this, "PigEndPositions", []);
        }

        init() {
          this.camera = this.getComponentInChildren(Camera);
        }

        onLoad() {
          for (let i = 1; i <= 4; i++) {
            this.boxes[i - 1] = this.node.getChildByName("baoxiang0" + i);
          }

          for (let i = 1; i <= 4; i++) {
            let node = this.node.getChildByName("PigStartPos" + i);
            this.PigStartPositions[i - 1] = node;
            node && (node.active = false);
          }

          for (let i = 1; i <= 4; i++) {
            let node = this.node.getChildByName("PigEndPos" + i);
            this.PigEndPositions[i - 1] = node;
            node && (node.active = false);
          }

          this.rabbitStartPosition = this.node.getChildByName("RabbitStartPos");
          this.rabbitStartPosition && (this.rabbitStartPosition.active = false);
          this.rabbitJumpPosition = this.node.getChildByName("RabbitJumpPos");
          this.rabbitJumpPosition && (this.rabbitJumpPosition.active = false);
          let com = this.node.parent.getComponent(ContainerInteraction);

          if (com && com.sprCamera) {
            com.sprCamera.node.on(Node.EventType.TOUCH_START, this.onTouchStart, this);
          }

          this.scheduleOnce(() => {
            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              AppMain.instance.tutorialManager.tutorialStepRaidOnce(0);
            }
          }, 0);
        }

        update(dt) {
          if (this.hasClickedOpen) return;
          this.timeElapsed += dt;

          if (this.timeElapsed > this.shakeInterval) {
            this.timeElapsed = 0;
            this.shakeBox(this.curShakeIndex);
            this.curShakeIndex++;
            this.curShakeIndex = this.curShakeIndex % this.boxes.length;
          }
        }

        onDestroy() {
          let com = this.node.parent.getComponent(ContainerInteraction);

          if (com && com.sprCamera) {
            com.sprCamera.node.off(Node.EventType.TOUCH_START, this.onTouchStart, this);
          }
        }

        onTouchStart(event) {
          let pos = event.getLocation();
          let outRay = new geometry.Ray();
          this.camera.screenPointToRayWithTexture(pos.x, pos.y, outRay);
          let bo = PhysicsSystem.instance.raycast(outRay);
          let result = PhysicsSystem.instance.raycastResults;
          result.sort((a, b) => a.distance - b.distance);

          if (result.length > 0) {
            let closestItem = result[0].collider.node;
            const index = this.boxes.indexOf(closestItem);

            if (index > -1) {
              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                if (AppMain.instance.tutorialManager.boxIndex === index) {
                  eventCenter.emit(TutorilaEvent.SpinRaidStarted);
                  this.onBoxClicked(index);
                } else {
                  return;
                }
              } else {
                this.onBoxClicked(index);
              }
            }
          } // console.log(result);
          // console.log(pos, outRay, bo);

        }

        onBoxClicked(index) {
          const numbering = index + 1;
          console.log("box", numbering, "being clicked");
          this.hasClickedOpen = true;
          this.lastClickedIndex = index; // this.shakeBox(index);

          eventCenter.emit(MyCustomEvent.OpenRaidBox, numbering);
        }

        openBox(index) {
          let anim = this.boxes[index].getComponent(SkeletalAnimation);
          anim && anim.play(BoxAnimName.open);
          SoundManager.playSound("se_open");
        }

        shakeBox(index) {
          let anim = this.boxes[index].getComponent(SkeletalAnimation);
          anim && anim.play(BoxAnimName.shake);
        }

        showPetIncreaseRaidReward(leftIndex, afterOpenBoxCallback) {
          let pb = ResourceLoader.resMap.get("pet/Pig");
          let petNode = instantiate(pb);
          const startPos = this.PigStartPositions[leftIndex];
          const endPos = this.PigEndPositions[leftIndex];
          petNode.setWorldPosition(startPos.worldPosition);
          this.pet = petNode.addComponent(Pet);
          this.node.addChild(petNode);
          const offset = this.camera.node.forward.multiplyScalar(-8);
          this.cameraEndPos = endPos.worldPosition.clone().add(offset);
          this.pet.run(endPos.worldPosition, 0.8, () => {
            this.onPigMoveEnd(leftIndex, afterOpenBoxCallback);
          });
        }

        focusCameraOnTarget(pos) {
          tween(this.camera.node).to(1, {
            worldPosition: pos
          }).start();
        }

        onPigMoveEnd(leftBoxIndex, afterOpenBoxCallback) {
          this.pet.changeStateToIdle();
          this.scheduleOnce(() => {
            this.pet.changeStateToAttack();
            this.pet.anim.once(Animation.EventType.FINISHED, () => {
              const endForward = new Vec3(0, 0, 1);
              this.pet.turn(endForward, 0.5);
              this.pet.changeStateToIdle();
              this.openBox(leftBoxIndex);
              afterOpenBoxCallback();
              this.scheduleOnce(() => {
                this.focusCameraOnTarget(this.cameraEndPos);
              }, 0.7);
            }, this);
          }, 0.1);
        }

        async showPetProtect(afterRabbitAttackCallback) {
          let pb = await ResourceLoader.loadCommonPrefab("pet/Rabbit");
          let petNode = instantiate(pb);
          petNode.setWorldPosition(this.rabbitStartPosition.worldPosition);
          this.pet = petNode.addComponent(Pet);
          this.node.addChild(petNode);
          const jumpEndPos = this.boxes[this.lastClickedIndex].worldPosition.clone().add3f(0, 1.7, 0);
          const jumpDir = jumpEndPos.clone().subtract(this.rabbitJumpPosition.worldPosition);
          jumpDir.y = 0;
          const jumpDistance = jumpDir.length();
          this.pet.run(this.rabbitJumpPosition.worldPosition, 0.8, () => {
            this.pet.jump(this.rabbitJumpPosition.worldPosition, jumpEndPos, jumpDistance * 0.13, true, () => {
              this.onRabbitMoveEnd(afterRabbitAttackCallback);
            });
          });
        }

        onRabbitMoveEnd(attackCallback) {
          console.log("onRabbitMoveEnd");
          this.pet.changeStateToIdle();
          const initialForward = this.pet.node.forward.clone();
          const targetForwardDir = new Vec3(0, 0, 1);
          tween(initialForward).to(0.2, targetForwardDir, {
            onUpdate: target => {
              this.pet.node.forward = target;
            }
          }).delay(0.2).call(() => {
            this.pet.changeStateToAttack();
            this.pet.anim.once(Animation.EventType.FINISHED, () => {
              attackCallback();
            }, this);
          }).start();
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PlayAudio.ts", ['cc', './CCE_Component.ts', './SoundManager.ts'], function (exports) {
  'use strict';

  var cclegacy, Enum, _decorator, Node, Button, CCE_Component, SoundManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
      _decorator = module._decorator;
      Node = module.Node;
      Button = module.Button;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SoundManager = module.SoundManager;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d44abrGylRGcZmsl6/shyBM", "PlayAudio", undefined);

      var AudioType;

      (function (AudioType) {
        AudioType[AudioType["None"] = 0] = "None";
        AudioType[AudioType["OpenModal"] = 1] = "OpenModal";
        AudioType[AudioType["CloseModal"] = 2] = "CloseModal";
        AudioType[AudioType["TapButton"] = 3] = "TapButton";
        AudioType[AudioType["LargeTransition"] = 4] = "LargeTransition";
        AudioType[AudioType["SmallTransition"] = 5] = "SmallTransition";
        AudioType[AudioType["Cancel"] = 6] = "Cancel";
        AudioType[AudioType["Alert"] = 7] = "Alert";
        AudioType[AudioType["OK"] = 8] = "OK";
        AudioType[AudioType["Slider"] = 9] = "Slider";
      })(AudioType || (AudioType = {}));

      var Trigger; //在节点上用来检测节点事件 触发音效

      (function (Trigger) {
        Trigger[Trigger["OnClick"] = 0] = "OnClick";
        Trigger[Trigger["OnPress"] = 1] = "OnPress";
        Trigger[Trigger["OnDrag"] = 2] = "OnDrag";
      })(Trigger || (Trigger = {}));

      const {
        ccclass,
        property,
        executionOrder
      } = _decorator;
      let PlayAudio = exports('default', (_dec = executionOrder(-1), _dec2 = property({
        type: Enum(Trigger)
      }), _dec3 = property({
        type: Enum(AudioType)
      }), ccclass(_class = _dec(_class = (_class2 = (_temp = class PlayAudio extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "trigger", _descriptor, this);

          _initializerDefineProperty(this, "audioType", _descriptor2, this);
        }

        static playOpen() {
          SoundManager.playSound("se_open");
        }

        static playClose() {
          SoundManager.playSound("se_back");
        }

        static playOk() {
          SoundManager.playSound("se_ok");
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          if (this.trigger === Trigger.OnPress) {
            this.node.on(Node.EventType.TOUCH_START, () => {
              if (this.node.getComponent(Button) && !this.node.getComponent(Button).interactable) return;
              this.PlaySound();
            }, this);
          } else if (this.trigger === Trigger.OnClick) {
            this.node.on(Node.EventType.TOUCH_END, () => {
              if (this.node.getComponent(Button) && !this.node.getComponent(Button).interactable) return;
              this.PlaySound();
            }, this);
          } else if (this.trigger === Trigger.OnDrag) {
            this.node.on(Node.EventType.TOUCH_MOVE, () => {
              if (this.node.getComponent(Button) && !this.node.getComponent(Button).interactable) return;
              this.PlaySound();
            }, this);
          }
        }

        onDisable() {
          this.node.targetOff(this);
        }

        PlaySound() {
          let sn = this.GetSoundName(this.audioType);
          if (sn == null) return;
          SoundManager.playSound(sn);
        }

        GetSoundName(type) {
          switch (type) {
            case AudioType.OpenModal:
              return "se_open";

            case AudioType.CloseModal:
              return "se_back";

            case AudioType.TapButton:
              return "se_tap";

            case AudioType.LargeTransition:
              return "se_confirm";

            case AudioType.SmallTransition:
              return "se_ok";

            case AudioType.Cancel:
              return "se_back";

            case AudioType.Alert:
              return "se_alert";

            case AudioType.OK:
              return "se_ok";

            case AudioType.Slider:
              return "se_slider";
          }

          return null;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "trigger", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return Trigger.OnClick;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "audioType", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return AudioType.None;
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/InvitedNewUserWindow.ts", ['cc', './global.ts', './UIWindow.ts', './User.ts', './UserInfoModel.ts', './SdkManager.ts', './StaticGame.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, _decorator, G, UIWindow, User, UserInfoModel, SdkManager, Game, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      User = module.User;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      Game = module.Game;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d5f19yAw7tLeZodcPYOcIOI", "InvitedNewUserWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let InvitedNewUserWindow = exports('InvitedNewUserWindow', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class InvitedNewUserWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spAvatar", _descriptor, this);

          _initializerDefineProperty(this, "labelSpin", _descriptor2, this);

          _initializerDefineProperty(this, "labelDes", _descriptor3, this);
        }

        onShow(showParams) {
          let data = showParams.data;
          UserInfoModel.SetAvatar(this.spAvatar, new User().updateData(data["user"]));
          let add = this.get_add_number();
          this.labelSpin.string = "+" + add.toString();
          let strkey = "NewUserInvitedDes";
          if (SdkManager.IsNative()) strkey = "NewUserInvitedDesApp";
          this.labelDes.string = String.format(i18n.t(strkey), data["user"]["name"], add.toString());
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        get_add_number() {
          let data = G.GameConstance.spinsPerInvite;
          let mapId = Game.SUserVillage.MapId();
          let is = 0;

          for (let mid in data) {
            if (mapId >= parseInt(mid)) {
              is = data[mid];
            } else {
              break;
            }
          }

          return is;
        }

      }, _defineProperty(_class3, "windowPath", "Menu/InvitedNewUserWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spAvatar", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelSpin", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelDes", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ServantSystemOpenWindow.ts", ['cc', './UIWindow.ts', './ServantWindow.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, RichText, _decorator, UIWindow, ServantWindow, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      RichText = module.RichText;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ServantWindow = module.ServantWindow;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d5fd4ffFlhP0a7Qw21aN8qF", "ServantSystemOpenWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ServantSystemOpenWindow = exports('ServantSystemOpenWindow', (_dec = property(RichText), ccclass(_class = (_class2 = (_temp = _class3 = class ServantSystemOpenWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "message", _descriptor, this);
        }

        onShow(showParams) {
          this.message.string = String.format(i18n.t("ServantOpenDes"));
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        callGo() {
          this.closeAnim();
          ServantWindow.Show();
        }

      }, _defineProperty(_class3, "windowPath", "Servant/NewServantSystemOpenWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "message", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ReuseScrollView.ts", ['cc', './ReuseItem.ts'], function (exports) {
  'use strict';

  var cclegacy, ScrollView, CCInteger, _decorator, Component, Vec3, UITransform, Node, instantiate, ResueItem;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      ScrollView = module.ScrollView;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      UITransform = module.UITransform;
      Node = module.Node;
      instantiate = module.instantiate;
    }, function (module) {
      ResueItem = module.ResueItem;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d75e3Yuk6BBQqO0KJN9ZjdG", "ReuseScrollView", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ReuseScrollView = exports('ReuseScrollView', (_dec = ccclass("ReuseScrollView"), _dec2 = property(ScrollView), _dec3 = property(CCInteger), _dec4 = property(CCInteger), _dec5 = property(CCInteger), _dec6 = property(CCInteger), _dec7 = property(CCInteger), _dec8 = property(CCInteger), _dec(_class = (_class2 = (_temp = class ReuseScrollView extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "scrollView", _descriptor, this);

          _initializerDefineProperty(this, "spacingX", _descriptor2, this);

          _initializerDefineProperty(this, "spacingY", _descriptor3, this);

          _initializerDefineProperty(this, "topGap", _descriptor4, this);

          _initializerDefineProperty(this, "bottomGap", _descriptor5, this);

          _initializerDefineProperty(this, "leftGap", _descriptor6, this);

          _initializerDefineProperty(this, "rightGap", _descriptor7, this);

          _defineProperty(this, "_previousOffset", Vec3.ZERO);

          _defineProperty(this, "_items", []);

          _defineProperty(this, "_isScrollUp", void 0);

          _defineProperty(this, "_isScrollToLeft", void 0);

          _defineProperty(this, "scrollViewLowerLimb", 0);

          _defineProperty(this, "scrollViewUpperLimb", 0);

          _defineProperty(this, "scrollViewLeftLimb", 0);

          _defineProperty(this, "scrollViewRightLimb", 0);

          _defineProperty(this, "MAX_REUSE", 5);

          _defineProperty(this, "_firstItemIndex", 0);

          _defineProperty(this, "_lastItemIndex", 0);

          _defineProperty(this, "_currentOffset", null);

          _defineProperty(this, "_firstItem", null);

          _defineProperty(this, "_firstItemUpperLimbWorldPos", 0);

          _defineProperty(this, "_firstItemLeftEdgeWorldPos", 0);

          _defineProperty(this, "_lastItem", null);

          _defineProperty(this, "_lastItemLowerEdgeWorldPos", 0);

          _defineProperty(this, "_lastItemRightEdgeWorldPos", 0);

          _defineProperty(this, "_canAutoScroll", true);

          _defineProperty(this, "_data", void 0);

          _defineProperty(this, "_prefab", null);
        }

        get itmes() {
          return this._items;
        }

        onLoad() {
          const worldPos = this.scrollView.node.getWorldPosition();
          const contentSize = this.scrollView.getComponent(UITransform).contentSize;
          this.scrollViewLowerLimb = worldPos.y - contentSize.height / 2;
          this.scrollViewUpperLimb = worldPos.y + contentSize.height / 2;
          this.scrollViewLeftLimb = worldPos.x - contentSize.width / 2;
          this.scrollViewRightLimb = worldPos.x + contentSize.width / 2;
        }

        onEnable() {
          this.scrollView.node.on(ScrollView.EventType.SCROLL_BEGAN, this.onScrollBegan, this);
          this.scrollView.node.on(ScrollView.EventType.SCROLLING, this.onScrolling, this);
          this.scrollView.node.on(Node.EventType.TOUCH_START, this.onScrollViewTouchStart, this);
          this.scrollView.node.on(Node.EventType.TOUCH_END, this.onScrollViewTouchEnded, this);
          this.scrollView.node.on(Node.EventType.TOUCH_CANCEL, this.onScrollViewTouchCancel, this);
        }

        onDisable() {
          this.scrollView.node.off(ScrollView.EventType.SCROLL_BEGAN, this.onScrollBegan, this);
          this.scrollView.node.off(ScrollView.EventType.SCROLLING, this.onScrolling, this);
          this.scrollView.node.off(Node.EventType.TOUCH_START, this.onScrollViewTouchStart, this);
          this.scrollView.node.off(Node.EventType.TOUCH_END, this.onScrollViewTouchEnded, this);
          this.scrollView.node.off(Node.EventType.TOUCH_CANCEL, this.onScrollViewTouchCancel, this);
        }
        /**
         * @param data 数据列表
         * @param prefab scrollView的item，节点或者prefab
         * @returns 
         */


        initScrollView(data, prefab) {
          this._data = data;
          this._prefab = prefab;
          const newItem = instantiate(prefab);

          if (this.scrollView.vertical) {
            this.MAX_REUSE = Math.ceil(this.scrollView.node.getChildByName("view").height / (newItem.height + this.spacingY)) + 2;
          } else {
            this.MAX_REUSE = Math.ceil(this.scrollView.node.getChildByName("view").width / (newItem.width + this.spacingX)) + 2;
          }

          this._firstItemIndex = 0;
          this._lastItemIndex = Math.min(this.MAX_REUSE - 1, data.length - 1);

          for (let i = this._firstItemIndex; i <= this._lastItemIndex; i++) {
            this.addNewItemToScrollView(i);
          }

          this._firstItem = this._items[this._firstItemIndex];
          this._lastItem = this._items[this._lastItemIndex];
        }

        addNewItemToScrollView(index) {
          var _newItem$getComponent;

          const newItem = instantiate(this._prefab);
          this.scrollView.content.addChild(newItem);
          newItem.active = true;
          (_newItem$getComponent = newItem.getComponent(ResueItem)) === null || _newItem$getComponent === void 0 ? void 0 : _newItem$getComponent.setData(this._data[index]);

          this._items.push(newItem);

          if (this.scrollView.vertical) {
            newItem.setPosition(0, -(this.topGap + this.spacingY * index + newItem.height * (index + 0.5)), 0);
            this.scrollView.content.width = newItem.width;
            const allItemHeight = this.topGap + this.bottomGap + (index + 1) * newItem.height + index * this.spacingY;
            this.scrollView.content.height = Math.max(this.scrollView.content.height, allItemHeight);
          } else {
            newItem.setPosition(this.leftGap + this.spacingX * index + newItem.width * (index + 0.5), 0, 0);
            this.scrollView.content.height = newItem.height;
            const allItemWidth = this.leftGap + this.rightGap + (index + 1) * newItem.width + index * this.spacingX;
            this.scrollView.content.width = Math.max(this.scrollView.content.width, allItemWidth);
          }
        }

        onScrollBegan() {
          this._previousOffset = this.scrollView.getScrollOffset();
        }

        onScrolling() {
          if (!this._items.length) return;
          this._currentOffset = this.scrollView.getScrollOffset();
          this._firstItem = this._items[0];
          this._firstItemUpperLimbWorldPos = this._firstItem.getWorldPosition().y + this._firstItem.getComponent(UITransform).height / 2;
          this._firstItemLeftEdgeWorldPos = this._firstItem.getWorldPosition().x - this._firstItem.getComponent(UITransform).width / 2;
          this._lastItem = this._items[this._items.length - 1];
          this._lastItemLowerEdgeWorldPos = this._lastItem.getWorldPosition().y - this._lastItem.getComponent(UITransform).height / 2;
          this._lastItemRightEdgeWorldPos = this._lastItem.getWorldPosition().x + this._lastItem.getComponent(UITransform).width / 2;
          this._isScrollUp = this._currentOffset.y > this._previousOffset.y;
          this._isScrollToLeft = this._currentOffset.x < this._previousOffset.x;
          this._previousOffset = this._currentOffset;

          if (this.scrollView.vertical) {
            if (this._isScrollUp) {
              //往上滑, 当最后一个元素的底进入scrollView的下边界，把最上面的元素移动到列表的最下面
              if (this._lastItemLowerEdgeWorldPos >= this.scrollViewLowerLimb) {
                if (this._lastItemIndex >= this._data.length - 1) return;
                const newPositonY = this._lastItem.getPosition().y - this._lastItem.getComponent(UITransform).height / 2 - this._firstItem.getComponent(UITransform).height / 2 - this.spacingY;

                this._firstItem.setPosition(new Vec3(0, newPositonY, 0));

                this._firstItemIndex += 1;
                this._lastItemIndex += 1;

                const tempItem = this._items.shift();

                this._items.push(tempItem);

                tempItem.getComponent(ResueItem).setData(this._data[this._lastItemIndex]);
                const allItemHeight = this.topGap + this.bottomGap + (this._lastItemIndex + 1) * this._firstItem.height + this._lastItemIndex * this.spacingY;
                this.scrollView.content.height = Math.max(this.scrollView.content.height, allItemHeight);
              }
            } else {
              //往下滑，当第一个元素的顶进入scrollView的上边界，把最下面的元素移动到列表的最上面
              if (this._firstItemUpperLimbWorldPos <= this.scrollViewUpperLimb) {
                if (this._firstItemIndex <= 0) return;
                const newPositonY = this._firstItem.getPosition().y + this._lastItem.getComponent(UITransform).height / 2 + this._firstItem.getComponent(UITransform).height / 2 + this.spacingY;

                this._lastItem.setPosition(new Vec3(0, newPositonY, 0));

                this._firstItemIndex -= 1;
                this._lastItemIndex -= 1;

                const tempItem = this._items.pop();

                tempItem.getComponent(ResueItem).setData(this._data[this._firstItemIndex]);

                this._items.unshift(tempItem);
              }
            }
          } else if (this.scrollView.horizontal) {
            if (this._isScrollToLeft) {
              //往左滑, 当最右边元素的右边进入scrollView的右边界，把最左边面的元素移动到列表的最右边
              if (this._lastItemRightEdgeWorldPos <= this.scrollViewRightLimb) {
                if (this._lastItemIndex >= this._data.length - 1) return;
                const newPositonX = this._lastItem.getPosition().x + this._lastItem.getComponent(UITransform).width / 2 + this._firstItem.getComponent(UITransform).width / 2 + this.spacingX;

                this._firstItem.setPosition(new Vec3(newPositonX, 0, 0));

                this._firstItemIndex += 1;
                this._lastItemIndex += 1;

                const tempItem = this._items.shift();

                this._items.push(tempItem);

                tempItem.getComponent(ResueItem).setData(this._data[this._lastItemIndex]);
                const allItemWidth = this.leftGap + this.rightGap + (this._lastItemIndex + 1) * this._firstItem.width + this._lastItemIndex * this.spacingX;
                this.scrollView.content.width = Math.max(this.scrollView.content.width, allItemWidth);
              }
            } else {
              //往右滑，当最左边元素的左侧进入scrollView的左边界，把最右边的元素移动到列表的最左侧
              if (this._firstItemLeftEdgeWorldPos >= this.scrollViewLeftLimb) {
                if (this._firstItemIndex <= 0) return;
                const newPositonX = this._firstItem.getPosition().x - this._lastItem.getComponent(UITransform).width / 2 - this._firstItem.getComponent(UITransform).width / 2 - this.spacingX;

                this._lastItem.setPosition(new Vec3(newPositonX, 0, 0));

                this._firstItemIndex -= 1;
                this._lastItemIndex -= 1;

                const tempItem = this._items.pop();

                tempItem.getComponent(ResueItem).setData(this._data[this._firstItemIndex]);

                this._items.unshift(tempItem);
              }
            }
          }
        }

        onScrollViewTouchStart() {
          this._canAutoScroll = false;
        }

        onScrollViewTouchEnded() {
          this._canAutoScroll = true;
        }

        onScrollViewTouchCancel() {
          this._canAutoScroll = true;
        }

        autoScroll() {
          if (!this._canAutoScroll) return;

          if (this._lastItemIndex < this.MAX_REUSE) {
            this._lastItemIndex += 1;
            this.addNewItemToScrollView(this._lastItemIndex);
          } else if (this._lastItemIndex >= this._data.length - 2) {
            if (this.scrollView.vertical) {
              this.scrollView.content.height += this.scrollView.content.children[0].height + this.spacingY;
              this.scrollView.scrollToBottom(0.01);
            } else {
              this.scrollView.content.width += this.scrollView.content.children[0].width + this.spacingY;
              this.scrollView.scrollToRight(0.01);
            }
          }
        }

        clear() {
          this.scrollView.content.destroyAllChildren();
          this.scrollView.content.height = 0;
          this.scrollView.content.width = 0;
          this._previousOffset = Vec3.ZERO;
          this._items = [];
          this._isScrollUp = false;
          this._isScrollToLeft = false;
          this._firstItemIndex = 0;
          this._lastItemIndex = 0;
          this._currentOffset = null;
          this._firstItem = null;
          this._firstItemUpperLimbWorldPos = 0;
          this._firstItemLeftEdgeWorldPos = 0;
          this._lastItem = null;
          this._lastItemLowerEdgeWorldPos = 0;
          this._lastItemRightEdgeWorldPos = 0;
          this._canAutoScroll = false;
          this._data = [];
          this._prefab = null;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "scrollView", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spacingX", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 10;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spacingY", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 10;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "topGap", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "bottomGap", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "leftGap", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "rightGap", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Room.ts", ['cc', './Constant.ts', './global.ts', './ResourceLoader.ts', './NodeRecovery.ts', './RoomManager.ts', './Player.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, MeshRenderer, instantiate, tween, Vec3, easing, LoadEvent, MyCustomEvent, SlotTypes, G, ResourceLoader, NodeRecovery, RoomManager, Player;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      MeshRenderer = module.MeshRenderer;
      instantiate = module.instantiate;
      tween = module.tween;
      Vec3 = module.Vec3;
      easing = module.easing;
    }, function (module) {
      LoadEvent = module.LoadEvent;
      MyCustomEvent = module.MyCustomEvent;
      SlotTypes = module.SlotTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      ResourceLoader = module.ResourceLoader;
    }, function (module) {
      NodeRecovery = module.default;
    }, function (module) {
      RoomManager = module.default;
    }, function (module) {
      Player = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "d7f8eArCpFIV4mz5lgzcbS3", "Room", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Room = exports('default', (_dec = ccclass("Room"), _dec(_class = (_temp = _class2 = class Room extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "rewardType", void 0);

          _defineProperty(this, "rewardNode", void 0);

          _defineProperty(this, "isPlayerEntered", false);

          _defineProperty(this, "raidTextureRenderer", void 0);
        }

        onLoad() {
          this.updateToRaidUserBoard();
          eventCenter.once(LoadEvent.UserAvatarLoaded, () => {
            this.updateToRaidUserBoard();
          });
          eventCenter.on(MyCustomEvent.BetChanged, () => {
            this.updateToRaidUserBoard();
          });
        }

        updateToRaidUserBoard() {
          let nodeArr = this.node.getFlattedChildrenRecursively();
          let raidTextureNode = nodeArr.find(v => v.name == "RaidTexture" && v.getComponent(MeshRenderer));

          if (raidTextureNode) {
            this.raidTextureRenderer = raidTextureNode.getComponent(MeshRenderer);
            homeView.slotPage.renderUIToModel.updateTargetModel(this.raidTextureRenderer, 0.5);
          }
        }

        static initializePool() {
          const nameArr = ["gold01", "gold02", "gold03", "gold04", "gold05", "gold06", "battery", "boom", "yaoshi", "dunpai"];
          nameArr.forEach(async name => {
            const node = await Room.getOneReward(name);
            Room.recycleReward(node);
          });
        }

        static async getOneReward(name) {
          let node;
          let rewardArr = Room.rewardPool.get(name);

          if (rewardArr && rewardArr.length > 0) {
            node = rewardArr.pop();
            Room.recoveryNodeState(node);
          } else {
            let pb = await ResourceLoader.getCommonPrefab("reward/" + name);
            node = instantiate(pb);
            node.name = name;
            Room.saveNodeState(node);
          }

          return node;
        }

        static recycleReward(node) {
          if (!node) return;
          let rewardArr = Room.rewardPool.get(node.name);

          if (!rewardArr) {
            rewardArr = [];
            Room.rewardPool.set(node.name, rewardArr);
          }

          node.active = false;
          Room.recoveryNodeState(node);
          node.removeFromParent();
          rewardArr.push(node);
        }
        /**记录节点的矩阵信息，旋转和缩放信息 */


        static saveNodeState(node) {
          let nodeArr = node.getFlattedChildrenRecursively();
          nodeArr.forEach(v => {
            let cmp = v.getOrAddComponent(NodeRecovery);
            !cmp.inited && cmp.init();
          });
        }

        static recoveryNodeState(node) {
          let nodeArr = node.getFlattedChildrenRecursively();
          nodeArr.forEach(v => {
            let cmp = v.getComponent(NodeRecovery);
            cmp.reset();
          });
        }

        setupEvent() {
          eventCenter.once(MyCustomEvent.OnSlotResult, this.setupReward, this);
        }

        onPlayerEnter() {
          this.isPlayerEntered = true;
          console.log("onPlayerEnter");

          if (!this.rewardType || !this.rewardNode) {
            console.warn("room not init");
            return;
          }
        }

        async setupReward(type) {
          console.log("setupReward", type); // this.initReward(type);

          this.rewardType = type;
          let rewardName = "";

          switch (type) {
            case SlotTypes.Coin1:
              rewardName = "gold01";
              break;

            case SlotTypes.Coin2:
              rewardName = "gold02";
              break;

            case SlotTypes.Coin3:
              rewardName = "gold03";
              break;

            case SlotTypes.Coin4:
              rewardName = "gold04";
              break;

            case SlotTypes.Coin5:
              rewardName = "gold05";
              break;

            case SlotTypes.Coin6:
              rewardName = "gold06";
              break;

            case SlotTypes.Spins:
              rewardName = "battery";
              break;

            case SlotTypes.Attack:
              rewardName = "boom";
              break;

            case SlotTypes.Raid:
              rewardName = "yaoshi";
              break;

            case SlotTypes.Shield:
              rewardName = "dunpai";
              break;

            case SlotTypes.Symbol:
              rewardName = "shuibei";
              break;
          }

          if (rewardName == "") {
            console.warn("unknown type", type);
            return;
          }

          this.rewardNode = await Room.getOneReward(rewardName);
          this.node.addChild(this.rewardNode); // this.rewardNode.resetPositionAndRotation();
        }

        playRewardCollectAnim() {
          // console.log(this.rewardNode);
          if (this.rewardType == SlotTypes.Coin1 || this.rewardType == SlotTypes.Coin2 || this.rewardType == SlotTypes.Coin3 || this.rewardType == SlotTypes.Coin4 || this.rewardType == SlotTypes.Coin5 || this.rewardType == SlotTypes.Coin6) {
            const playerPos = Player.instance.node.getWorldPosition().clone().subtract(RoomManager.instance.curRoom.node.getWorldPosition());
            const targetPos = playerPos.clone().add3f(0, 2, 0);
            let maxTime = 0;
            const scaleTime = 0.3;
            this.rewardNode.children.forEach((v, i) => {
              const scale = v.scale.x;
              const distance = v.getWorldPosition().clone().subtract(Player.instance.node.getWorldPosition()).length();
              const time = distance * 0.03;

              if (time > maxTime) {
                maxTime = time;
              } // console.log(distance);


              tween(v).to(scaleTime, {
                scale: new Vec3(1.2 * scale, 1.2 * scale, 1.2 * scale),
                position: v.position.clone().add3f(0, 0.5, 0)
              }, {
                easing: easing.cubicOut
              }).to(time, {
                scale: new Vec3(0 * scale, 0 * scale, 0 * scale),
                position: targetPos
              }, {
                easing: easing.cubicIn
              }).call(() => {// v.active = false;
              }).start();
            });
            this.scheduleOnce(() => {
              eventCenter.emit(MyCustomEvent.CoinFlyEnd);
              Room.recycleReward(this.rewardNode);
            }, maxTime + scaleTime);
          } else {
            tween(this.rewardNode).to(0.3, {
              scale: G.scale1_2
            }, {
              easing: easing.cubicOut
            }).to(0.3, {
              scale: Vec3.ZERO
            }, {
              easing: easing.cubicIn
            }).call(() => {
              this.rewardNode.active = false;
              eventCenter.emit(MyCustomEvent.CoinFlyEnd);
              Room.recycleReward(this.rewardNode);
            }).start();
          }
        }

      }, _defineProperty(_class2, "rewardPool", new Map()), _temp)) || _class));
      window["Room"] = Room;

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotActivityNode.ts", ['cc', './Constant.ts', './CCE_Component.ts', './global.ts', './_app.ts', './SoundManager.ts', './ContentModel.ts', './fixedSizeRatio.ts', './CommonAssets.ts', './Content.ts', './GetRewardWindow.ts', './ActivitySlotSymbolRankWindow.ts', './SdkManager.ts', './GameMainWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './AppKit.ts', './GameKit.ts', './BigNumber.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, ProgressBar, Label, Sprite, SpriteFrame, _decorator, Vec3, instantiate, tween, easing, Animation, v3, dragonBones, MyCustomEvent, CCE_Component, G, cce, SoundManager, ContentModel, fixedSizeRatio, CommonAssets, Content, GetRewardWindow, ActivitySlotSymbolRankWindow, SdkManager, GameMainWindow, UIRoot, ActivityManager, Meta, Game, GameKit, BigNumber, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      ProgressBar = module.ProgressBar;
      Label = module.Label;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
      tween = module.tween;
      easing = module.easing;
      Animation = module.Animation;
      v3 = module.v3;
      dragonBones = module.dragonBones;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      fixedSizeRatio = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      GetRewardWindow = module.GetRewardWindow;
    }, function (module) {
      ActivitySlotSymbolRankWindow = module.ActivitySlotSymbolRankWindow;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d825d7nXgZI5q8EAYQz8VJg", "SlotActivityNode", undefined);

      const RewardNodePos = {
        x: 115,
        y: 225,
        scaleX: 0.5,
        scaleY: 0.5
      };
      const {
        ccclass,
        property
      } = _decorator;
      let SlotActivityNode = exports('default', (_dec = property(Node), _dec2 = property(ProgressBar), _dec3 = property(Label), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Label), _dec7 = property(Node), _dec8 = property(Node), _dec9 = property(Sprite), _dec10 = property(SpriteFrame), _dec11 = property(SpriteFrame), _dec12 = property(SpriteFrame), _dec13 = property(SpriteFrame), _dec14 = property(SpriteFrame), _dec15 = property(SpriteFrame), _dec16 = property(Node), _dec17 = property(Node), _dec18 = property(Node), _dec19 = property(Node), _dec20 = property(Node), ccclass(_class = (_class2 = (_temp = class SlotActivityNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "activityNode", _descriptor, this);

          _initializerDefineProperty(this, "progressBar", _descriptor2, this);

          _initializerDefineProperty(this, "progressLabel", _descriptor3, this);

          _initializerDefineProperty(this, "rewardNode", _descriptor4, this);

          _initializerDefineProperty(this, "rewardLight", _descriptor5, this);

          _initializerDefineProperty(this, "rewardLabel", _descriptor6, this);

          _initializerDefineProperty(this, "itemFlyAimNode", _descriptor7, this);

          _initializerDefineProperty(this, "flyItem", _descriptor8, this);

          _initializerDefineProperty(this, "activityIcon", _descriptor9, this);

          _initializerDefineProperty(this, "iconAttack", _descriptor10, this);

          _initializerDefineProperty(this, "iconRaid", _descriptor11, this);

          _initializerDefineProperty(this, "iconSymbol", _descriptor12, this);

          _initializerDefineProperty(this, "iconBomb", _descriptor13, this);

          _initializerDefineProperty(this, "iconKey", _descriptor14, this);

          _initializerDefineProperty(this, "iconCup", _descriptor15, this);

          _initializerDefineProperty(this, "raidMaster", _descriptor16, this);

          _initializerDefineProperty(this, "slotCollect", _descriptor17, this);

          _initializerDefineProperty(this, "rewardPanel", _descriptor18, this);

          _initializerDefineProperty(this, "vipRewardPanel", _descriptor19, this);

          _initializerDefineProperty(this, "animHammerRank", _descriptor20, this);

          _defineProperty(this, "_preHave", void 0);

          _defineProperty(this, "_preId", void 0);

          _defineProperty(this, "_preNeed", void 0);

          _defineProperty(this, "_preReward", void 0);

          _defineProperty(this, "_currentHave", void 0);

          _defineProperty(this, "_currentId", void 0);

          _defineProperty(this, "_isFirstUpdate", true);

          _defineProperty(this, "_metaType", void 0);

          _defineProperty(this, "_rewardType", void 0);

          _defineProperty(this, "activityMeta", void 0);

          _defineProperty(this, "slotNode", void 0);

          _defineProperty(this, "scActivityMeta", void 0);

          _defineProperty(this, "playAnim", void 0);

          _defineProperty(this, "userdata", void 0);

          _defineProperty(this, "rewardNewReward", void 0);

          _defineProperty(this, "rewardReward", void 0);

          _defineProperty(this, "oldAp", void 0);

          _defineProperty(this, "oldCoin", void 0);

          _defineProperty(this, "rewardCallback", void 0);

          _defineProperty(this, "playRewardAnim", void 0);

          _defineProperty(this, "collectRankScore", null);

          _defineProperty(this, "_lastRank", Number.MAX_VALUE);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {}

        onEnable() {
          eventCenter.on(MyCustomEvent.NextVillage, () => {
            this.updateReward();
          }, this);
        }

        onDisable() {
          eventCenter.off(MyCustomEvent.NextVillage, () => {
            this.updateReward();
          }, this);
        }

        hideAll() {
          this.activityMeta = null;
          this.activityNode.active = false;
          this.raidMaster.active = false;
          this.slotCollect.active = false;
          this.rewardPanel.active = false;
          this.vipRewardPanel.active = false; //GameKit.GameEvent.UnRegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "SlotActivityNode")
        }

        showActivity() {
          this.hideAll();
          this.slotNode = homeView.slotNode;
          this.updateActivity(); //GameKit.GameEvent.RegisterEvent(GameKit.GameEvent.EventName.ActivityEvent, "SlotActivityNode", function(data) {
          //this.updateActivity()
          //}.bind(this))
        } // initActivity() {
        // 	const meta = ActivityManager.GetActiveSlotActivity();
        // 	if (meta) {
        // 		this.activityMeta = meta;
        // 		this.userdata = Game.SUserActivity.GetActivityData(this.activityMeta.Id());
        // 		this._preHave = this.userdata.currentCount;
        // 		this._preId = this.userdata.currentId;
        // 		this._currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.AttackMaster, this._preId);
        // 		const currentReward = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.AttackMasterReward, this._preId)).Contents()[0];
        // 		this._initReward(currentReward);
        // 		if (meta.SubType() === Meta.ActivityMeta.SubTypes.AttackMaster) {
        // 			this.attackMaster.active = true;
        // 			this.amProgressLabel.string = `${this._preHave}/${this._currentNeed}`;
        // 			this.amProgressBar.progress = this._preHave / this._currentNeed;
        // 		} else if (meta.SubType() === Meta.ActivityMeta.SubTypes.RaidMaster) {
        // 			this.raidMaster.active = true;
        // 		} else if (meta.SubType() === Meta.ActivityMeta.SubTypes.SlotCollect) {
        // 			this.slotCollect.active = true;
        // 		}
        // 	}
        // }


        async updateActivity() {
          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            return;
          }

          const meta = ActivityManager.GetActiveSlotActivity();

          if (meta) {
            this.activityMeta = meta;

            if (this.activityMeta.SubType() === Meta.ActivityMeta.SubTypes.AttackMaster) {
              this.flyItem.getComponent(Sprite).spriteFrame = this.iconBomb;
              this.activityIcon.spriteFrame = this.iconAttack;
              this._metaType = Meta.ActivityParamsMeta.Types.AttackMaster;
              this._rewardType = Meta.ActivityParamsMeta.Types.AttackMasterReward;
              await this.doActivity();
            } else if (this.activityMeta.SubType() === Meta.ActivityMeta.SubTypes.RaidMaster) {
              this.flyItem.getComponent(Sprite).spriteFrame = this.iconKey;
              this.activityIcon.spriteFrame = this.iconRaid;
              this._metaType = Meta.ActivityParamsMeta.Types.RaidMaster;
              this._rewardType = Meta.ActivityParamsMeta.Types.RaidMasterReward;
              await this.doActivity();
            } else if (this.activityMeta.SubType() === Meta.ActivityMeta.SubTypes.SlotCollect) {
              this.flyItem.getComponent(Sprite).spriteFrame = this.iconSymbol;
              this.activityIcon.spriteFrame = this.iconCup;
              this._metaType = Meta.ActivityParamsMeta.Types.SlotCollect;
              this._rewardType = Meta.ActivityParamsMeta.Types.SlotCollectReward;
              await this.doActivity(); // this.showSlotCollect();
            }
          }

          const scmeta = ActivityManager.GetActiveSlotCollectActivity();

          if (scmeta) {
            if (scmeta.SubType() === Meta.ActivityMeta.SubTypes.SlotCollectRank) {
              this.scActivityMeta = scmeta;
              this.updateCollectRank();
            } else {
              this.collectRankScore = 0;
            }
          } else {
            this.collectRankScore = 0;
          }
        }

        isAnim() {
          return this.playAnim;
        }

        animOver() {
          this.playAnim = false;
        }

        async _flyItems(count, startNode, endNode, type) {
          const flyStep = Math.ceil(count / 20);
          const flyTimes = Math.ceil(count / flyStep);
          let out = new Vec3();
          const out1 = new Vec3();
          this.activityNode.inverseTransformPoint(out, endNode.getWorldPosition());
          this.activityNode.parent.inverseTransformPoint(out1, startNode.getWorldPosition());
          const newStableItem = instantiate(this.flyItem);
          newStableItem.active = true;
          newStableItem.setScale(1.5, 1.5, 1.5);
          this.activityNode.parent.addChild(newStableItem);
          newStableItem.setPosition(out1);

          for (let i = 0; i < flyTimes - 1; i++) {
            await new Promise(resolve => {
              const newBomb = instantiate(this.flyItem);
              newBomb.setPosition(startNode.position);
              newBomb.active = true;
              this.activityNode.addChild(newBomb);
              tween(newBomb).parallel(tween().delay(0.07).call(resolve), tween().to(0.8, {
                angle: 360
              }), tween().to(0.8, {
                x: out.x
              }), tween().to(0.8, {
                y: out.y
              }, {
                easing: easing.backIn
              })).call(() => {
                this.activityIcon.getComponent(Animation).play("bombShake");
                newBomb.destroy();
              }).start();
            });
          }

          this.activityNode.parent.inverseTransformPoint(out, endNode.getWorldPosition());
          tween(newStableItem).parallel(tween().to(0.8, {
            angle: 360
          }), tween().to(0.8, {
            scale: Vec3.ONE
          }), tween().to(0.8, {
            x: out.x
          }), tween().to(0.8, {
            y: out.y
          }, {
            easing: easing.backIn
          })).call(() => {
            this.activityIcon.getComponent(Animation).play("bombShake");
            newStableItem.destroy();
            this.rewardLabel.string = "+" + count;
            this.rewardLabel.node.active = true;
            this.rewardLabel.getComponent(Animation).play();
            this.rewardLabel.getComponent(Animation).on(Animation.EventType.FINISHED, () => {
              this.rewardLabel.node.active = false;
            }, this);
          }).start();
        }

        async _updateProgress(need, have, delta) {
          tween(this.progressBar).to(0.05 * delta, {
            progress: (have + delta) / need
          }).start();

          for (let i = 0; i < delta; i++) {
            await new Promise(resolve => {
              this.progressLabel.string = `${++have}/${need}`;
              setTimeout(() => {
                resolve(null);
              }, 50);
            });
          }
        }

        async _showReward(reward) {
          await new Promise(resolve => {
            this.rewardLight.active = true;
            tween(this.rewardNode).by(0.6, {
              position: new Vec3(-120, -300, 0)
            }).call(() => {
              resolve(null);
            }).start();
          });
          return new Promise(resolve => {
            UIRoot.instance.openChildWindow(GetRewardWindow, {
              contents: [reward],
              showCallback: () => {
                this.rewardNode.active = false;
              },
              closeCallback: () => {
                if (Game.SUserStatus.IsVip()) {
                  resolve(this._showVipReward(reward));
                } else {
                  resolve(null);
                }
              }
            });
          });
        }

        async _showVipReward(reward) {
          let vipReward = Content.FromContent(reward);

          if (vipReward.Type() == Content.Types.Ap) {
            vipReward.SetCount(Math.floor(vipReward.Count() * G.GameConstance.vipSlotActivityAdd));
          } else if (vipReward.Type() == Content.Types.Coin) {
            vipReward.SetCount(Content.RoundCoin(vipReward.Count() * G.GameConstance.vipSlotActivityAdd));
          }

          return new Promise(resolve => {
            UIRoot.instance.openChildWindow(GetRewardWindow, {
              contents: [vipReward],
              showTitle: true,
              vip: true,
              closeCallback: resolve
            });
          });
        }

        _initReward(currentReward, currentId, currentHave, isFirstInit = false) {
          return new Promise(resolve => {
            let currentNeed = Meta.ActivityParamsMeta.GetValue(this._metaType, currentId);
            this.progressLabel.string = `${currentHave}/${currentNeed}`;
            this.progressBar.progress = currentHave / currentNeed;
            this.rewardNode.getComponent(ContentModel).show(currentReward);
            this.rewardLight.active = false;
            this.rewardNode.active = true;

            if (isFirstInit) {
              this.rewardNode.x += 120;
              this.rewardNode.y += 300;
              resolve(null);
            } else {
              tween(this.rewardNode).delay(0.2).by(0.6, {
                position: new Vec3(120, 300, 0)
              }).call(resolve).start();
            }
          });
        }

        updateReward() {
          if (!this._rewardType || !this._preId) return;
          const newReward = Content.FromString(Meta.ActivityParamsMeta.GetValue(this._rewardType, this._preId)).Contents()[0];
          this.rewardNode.getComponent(ContentModel).show(newReward);
        } //Attack Master


        async doActivity() {
          this.slotNode.isSpining = true;
          this.userdata = Game.SUserActivity.GetActivityData(this.activityMeta.Id());
          this._currentHave = this.userdata.currentCount || 0;
          this._currentId = this.userdata.currentId || 1;
          this.activityNode.active = true;

          if (this._isFirstUpdate) {
            this._isFirstUpdate = false;
            this._preId = this._currentId;
            this._preHave = this._currentHave;
            this._preNeed = Meta.ActivityParamsMeta.GetValue(this._metaType, this._preId);
            this._preReward = Content.FromString(Meta.ActivityParamsMeta.GetValue(this._rewardType, this._preId)).Contents()[0];
            this.progressBar.progress = this._currentHave / this._preNeed;
            this.progressLabel.string = `${this._currentHave} / ${this._preNeed}`;
            await this._initReward(this._preReward, this._preId, this._preHave, true);
            this.slotNode.makeIdle();
            return;
          }

          if (this._currentId === ActivityManager.Constance.attackMasterMaxId && this._currentHave >= this._preNeed) {
            this.activityNode.active = false;
            this.slotNode.makeIdle();
            return;
          }

          if (this._currentHave === this._preHave && this._preId === this._currentId) {
            this.slotNode.makeIdle();
            return;
          }

          let delta = 0;
          await this._flyItems(this.slotNode.betNum, this.flyItem, this.itemFlyAimNode, Meta.ActivityMeta.SubTypes.AttackMaster);

          while (this._currentId > this._preId) {
            this._preNeed = Meta.ActivityParamsMeta.GetValue(this._metaType, this._preId);
            this._preReward = Content.FromString(Meta.ActivityParamsMeta.GetValue(this._rewardType, this._preId)).Contents()[0];
            delta = this._preNeed - this._preHave;
            await cce.wait(500);
            await this._updateProgress(this._preNeed, this._preHave, delta);
            await cce.wait(500);
            await this._showReward(this._preReward);
            this._preHave = 0;
            this._preId += 1;
            this._preReward = Content.FromString(Meta.ActivityParamsMeta.GetValue(this._rewardType, this._preId)).Contents()[0];
            await this._initReward(this._preReward, this._preId, this._preHave);
          }

          delta = this._currentHave - this._preHave;

          if (delta <= 0) {
            this.slotNode.makeIdle();
            return;
          }

          await cce.wait(500);
          this._preNeed = Meta.ActivityParamsMeta.GetValue(this._metaType, this._preId);
          await this._updateProgress(this._preNeed, this._preHave, delta);
          this._preHave = this._currentHave;
          this.slotNode.makeIdle();
        }

        showSlotCollect() {
          this.slotCollect.active = true;
          this.userdata = Game.SUserActivity.GetActivityData(this.activityMeta.Id());
          let currentCount = this.userdata.currentCount || 0;
          let currentId = this.userdata.currentId || 1;
          let currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollect, currentId);
          let currentGet = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollectReward, currentId)).Contents()[0];

          if ((!this._preId || this._preId == currentId) && (!this._preHave || this._preHave == currentCount) && currentId === ActivityManager.Constance.slotCollectMaxId && currentCount === currentNeed) {
            this.slotCollect.active = false;
            return;
          }

          let itemHandle = this.slotCollect;
          let labelProgress = GameKit.ControllerTable.GetNode(itemHandle, "labelProgressNode").getComponent(Label);
          let spProgress = GameKit.ControllerTable.GetNode(itemHandle, "spProgressNode").getComponent(ProgressBar);
          let spSymbol = GameKit.ControllerTable.GetComponent(itemHandle, "spSymbol", Sprite);
          let animHammer = GameKit.ControllerTable.GetNode(itemHandle, "animHammer");
          let rewardNode = GameKit.ControllerTable.GetNode(this.rewardPanel, "rewardNode").getComponent(ContentModel);
          let labelVipReward = GameKit.ControllerTable.GetNode(this.rewardPanel, "labelVipReward").getComponent(Label);
          const worldPos = this.slotCollect.getChildByName("bar").getChildByName('bg').getWorldPosition();
          this.initReward(worldPos);
          let symbolId = this.activityMeta.Param().symbolId;
          let sp = CommonAssets.instance.getByAtlas(CommonAssets.Atlases.SlotSymbol, symbolId.toString());
          spSymbol.spriteFrame = sp;
          animHammer.getComponent(Sprite).spriteFrame = sp;
          fixedSizeRatio.fitByHeight(spSymbol);
          fixedSizeRatio.fitByHeight(animHammer);

          var _showSlotCollect = function () {
            if (this.currentId == currentId && currentId === ActivityManager.Constance.slotCollectMaxId && currentCount === currentNeed) {
              this.slotCollect.active = false;
              this.currentCount = null;
              this.currentId = null;
              return;
            }

            labelProgress.string = currentCount.toString() + " / " + currentNeed;
            spProgress.progress = currentCount / currentNeed;
            rewardNode.show(currentGet);
            this.rewardReward = currentGet;
          }.bind(this);

          var _playAnim = (animCount, cuCount, need) => {
            this.playAnim = true;
            let cct = cuCount;
            let animStep = Math.ceil(animCount / 20);
            let animTimes = Math.ceil(animCount / animStep);
            let animDelay = Math.max(0.1, 0.3 - Math.max(0, animCount - 5) * 0.03);

            for (let i = 0; i < animTimes; i++) {
              this.scheduleOnce(() => {
                let newAnimHammer = instantiate(animHammer);
                newAnimHammer.parent = animHammer.parent;
                newAnimHammer.x = 0;
                newAnimHammer.y = 0;
                newAnimHammer.active = true;
                SoundManager.playSound("HammersThrow-01");
              }, i * animDelay);
              this.scheduleOnce(() => {
                let cc1 = Math.min(cct + (i + 1) * animStep, need);
                labelProgress.string = cc1.toString() + " / " + need;
                spProgress.progress = cc1 / need;
              }, (i + 1) * animDelay + 0.3);
            }

            return animTimes * animDelay + 0.3;
          };

          let oldCurrentId = this._preId;
          let oldCurrentCount = this._preHave;

          var showAdd = () => {
            if (oldCurrentId != null && (oldCurrentId !== currentId || oldCurrentId == currentId && currentCount == currentNeed)) {
              let lastNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollect, oldCurrentId);
              let animCount = lastNeed - oldCurrentCount;

              let animTime = _playAnim(animCount, oldCurrentCount, lastNeed);

              this.scheduleOnce(() => {
                this.playAnim = false;
                oldCurrentId++;
                oldCurrentCount = 0;

                if (oldCurrentId === ActivityManager.Constance.slotCollectMaxId) {
                  this.rewardNewReward = null;
                } else {
                  let nextGet = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollectReward, oldCurrentId)).Contents()[0];
                  this.rewardNewReward = nextGet;
                }

                this.ShowReward(() => {
                  let need = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollect, oldCurrentId);
                  labelProgress.string = "0 / " + need;
                  spProgress.progress = 0;
                  this.rewardReward = this.rewardNewReward;
                  showAdd();
                });
              }, animTime);
            } else if (oldCurrentCount != null && oldCurrentCount !== currentCount) {
              let animCount = currentCount - oldCurrentCount;

              let animTime = _playAnim(animCount, oldCurrentCount, currentNeed);

              this.scheduleOnce(() => {
                this.playAnim = false;

                _showSlotCollect();
              }, animTime);
            } else {
              _showSlotCollect();
            }
          };

          showAdd();
          this._preHave = currentCount;
          this._preId = currentId;
          this.slotCollect.active = true;
        }

        initReward(worldPos) {
          let itemHandle = this.rewardPanel;
          let spReward = GameKit.ControllerTable.GetNode(itemHandle, "spReward");
          let spRewardFx = GameKit.ControllerTable.GetNode(itemHandle, "spRewardFx");
          let spBg = GameKit.ControllerTable.GetNode(itemHandle, "spBg");
          let spDes = GameKit.ControllerTable.GetNode(itemHandle, "spDes");
          let spBtn = GameKit.ControllerTable.GetNode(itemHandle, "spBtn");
          let vipNode = GameKit.ControllerTable.GetNode(itemHandle, "vipNode");
          let labelVipReward = GameKit.ControllerTable.GetNode(itemHandle, "labelVipReward").getComponent(Label);
          const localPos = new Vec3();
          spReward.parent.inverseTransformPoint(localPos, worldPos);
          spReward.active = true;
          spReward.x = localPos.x + 120;
          spReward.y = localPos.y;
          spReward.scaleX = RewardNodePos.scaleX;
          spReward.scaleY = RewardNodePos.scaleY;
          spRewardFx.active = false;
          spBg.active = false;
          spDes.active = false;
          spBtn.active = false;
          vipNode.active = false;
          labelVipReward.string = "";
          this.rewardPanel.active = true;
        }

        stayReward() {
          if (!this.activityMeta) return;
          this.userdata = Game.SUserActivity.GetActivityData(this.activityMeta.Id()) || {};
          let currentId = this.userdata.currentId || 1;
          let currentCount = this.userdata.currentCount || 0;
          this.oldAp = null;
          this.oldCoin = null;

          if (this._preId != null && this._preId !== currentId) {
            let rewards = [];
            let oldCurrentId = this._preId;
            let currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollect, oldCurrentId);

            while (oldCurrentId < currentId || oldCurrentId == currentId && oldCurrentId === ActivityManager.Constance.slotCollectMaxId && currentCount == currentNeed) {
              let rewardReward = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.AttackMasterReward, oldCurrentId)).Contents()[0];
              rewards.push(rewardReward);
              oldCurrentId++;
              currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollect, oldCurrentId);
            }

            rewards = Content.Merge(rewards);
            rewards.forEach(rewardReward => {
              let fReward = this.GetAfterVipReward(rewardReward);

              if (fReward.Type() == Content.Types.Ap) {
                this.oldAp = Game.SUser.Ap() - fReward.Count();
                if (homeView) homeView.pageViewController.stopApAt(this.oldAp);
              } else if (fReward.Type() == Content.Types.Coin) {
                this.oldCoin = Game.SUser.Coin() - fReward.Count();
                if (GameMainWindow.instance) GameMainWindow.instance.userinfo.changeCoin(this.oldCoin, this.oldCoin, 0);
              }
            });
          }
        }

        ShowReward(callback) {
          // UIRoot.instance.openChildWindow(GetRewardWindow, this.rewardReward);
          let itemHandle = this.rewardPanel;
          let spReward = GameKit.ControllerTable.GetNode(itemHandle, "spReward");
          let rewardNode = GameKit.ControllerTable.GetNode(itemHandle, "rewardNode").getComponent(ContentModel);
          let spBg = GameKit.ControllerTable.GetNode(itemHandle, "spBg");
          let spDes = GameKit.ControllerTable.GetNode(itemHandle, "spDes");
          let spBtn = GameKit.ControllerTable.GetNode(itemHandle, "spBtn");
          let spRewardFx = GameKit.ControllerTable.GetNode(itemHandle, "spRewardFx");
          let vipNode = GameKit.ControllerTable.GetNode(itemHandle, "vipNode");
          let labelVipReward = GameKit.ControllerTable.GetNode(itemHandle, "labelVipReward").getComponent(Label);
          spBg.active = false;
          spDes.active = false;
          spBtn.active = false;
          vipNode.active = false;
          this.playAnim = true; // spReward.runAction(ccAction.jumpTo(0.7, 0, 0, 200, 1))

          spReward.runAction(ccAction.moveTo(0.7, 0, 0));
          spReward.runAction(ccAction.sequence(ccAction.scaleTo(0.7, 1, 1), ccAction.callFunc(() => {
            this.SetVipRewardLabel(labelVipReward, this.rewardReward);

            if (Game.SUserStatus.IsVip() && labelVipReward.string != "") {
              vipNode.active = true;
              vipNode.scale = v3(0.001, 0.001, 1);
              vipNode.runAction(ccAction.scaleTo(0.2, 1, 1));
            }

            spRewardFx.active = true;
            UIRoot.instance.openChildWindow(GetRewardWindow, {
              contents: this.rewardReward
            });
            const getRewardWindow = UIRoot.instance.GetWindow("GetRewardWindow");
            getRewardWindow.addOnCloseFunc(this.GetRewardOk); // spBg.stopAllActions();
            // spBg.active = true;
            // spBg.opacity = 150;
            // spDes.stopAllActions();
            // spDes.active = true;
            // spDes.scale = cc.Vec3.ONE;
            // spBtn.stopAllActions();
            // spBtn.active = true;
            // spBtn.scale = cc.Vec3.ONE;

            SoundManager.playSound("congratulations_01");
          }, this)));
          this.rewardCallback = callback;
        }

        GetRewardOk() {
          if (this.playRewardAnim) return;
          let itemHandle = this.rewardPanel;
          let spReward = GameKit.ControllerTable.GetNode(itemHandle, "spReward");
          let rewardNode = GameKit.ControllerTable.GetNode(itemHandle, "rewardNode").getComponent(ContentModel);
          let spBg = GameKit.ControllerTable.GetNode(itemHandle, "spBg");
          let spDes = GameKit.ControllerTable.GetNode(itemHandle, "spDes");
          let spBtn = GameKit.ControllerTable.GetNode(itemHandle, "spBtn");
          let spRewardFx = GameKit.ControllerTable.GetNode(itemHandle, "spRewardFx");
          let vipNode = GameKit.ControllerTable.GetNode(itemHandle, "vipNode");
          let labelVipReward = GameKit.ControllerTable.GetNode(itemHandle, "labelVipReward");
          this.playAnim = true;
          this.playRewardAnim = true;
          let animTime = 0.1;
          let fReward = this.GetAfterVipReward(this.rewardReward);

          if (fReward.Type() == Content.Types.Ap) {
            if (homeView) {
              homeView.slotNode.showSpinAddNumAnim(fReward.Count(), true);
              this.oldAp += fReward.Count();
              animTime = 1.5;
              this.scheduleOnce(() => {
                if (homeView) homeView.pageViewController.stopApAt(this.oldAp);
              }, animTime);
            }
          } else if (fReward.Type() == Content.Types.Coin) {
            if (GameMainWindow.instance) {
              // homeView.villagePage.playAddCoinAnim();
              GameMainWindow.instance.scheduleOnce(() => {
                GameMainWindow.instance.userinfo.changeCoin(this.oldCoin, this.oldCoin + fReward.Count(), 0.8);
                this.oldCoin += fReward.Count();
              }, 1);
              animTime = 1.5;
            }
          }

          spDes.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001, 0.001), ccAction.callFunc(() => {
            spDes.scale = Vec3.ONE;
            spDes.active = false;
          }, this)));
          spBtn.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001, 0.001), ccAction.callFunc(() => {
            spBtn.scale = Vec3.ONE;
            spBtn.active = false;
          }, this)));

          if (vipNode.active) {
            vipNode.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001, 0.001), ccAction.callFunc(() => {
              vipNode.scale = Vec3.ONE;
              vipNode.active = false;
            }, this)));
          }

          spBg.runAction(ccAction.sequence(ccAction.fadeTo(0.2, 1), ccAction.callFunc(() => {
            spBg.opacity = 150;
            spBg.active = false;
          }, this)));
          spReward.runAction(ccAction.sequence(ccAction.scaleTo(0.3, 0.001, 0.001), ccAction.callFunc(() => {
            spReward.scale = Vec3.ONE;

            if (!Game.SUserStatus.IsVip() && SdkManager.IsNative() && (this.rewardReward.Type() == Content.Types.Ap || this.rewardReward.Type() == Content.Types.Coin)) {
              spReward.scale = v3(0.001, 0.001, 1);
              this.ShowVipReward(animTime);
            } else {
              this.ShowNext(animTime);
            }
          }, this)));
        }

        ShowNext(animTime = 0.1) {
          let itemHandle = this.rewardPanel;
          let spReward = GameKit.ControllerTable.GetNode(itemHandle, "spReward");
          let rewardNode = GameKit.ControllerTable.GetNode(itemHandle, "rewardNode").getComponent(ContentModel);
          let spBg = GameKit.ControllerTable.GetNode(itemHandle, "spBg");
          let spDes = GameKit.ControllerTable.GetNode(itemHandle, "spDes");
          let spBtn = GameKit.ControllerTable.GetNode(itemHandle, "spBtn");
          let spRewardFx = GameKit.ControllerTable.GetNode(itemHandle, "spRewardFx");
          let vipNode = GameKit.ControllerTable.GetNode(itemHandle, "vipNode");
          let labelVipReward = GameKit.ControllerTable.GetNode(itemHandle, "labelVipReward").getComponent(Label);
          labelVipReward.string = "";

          if (this.rewardNewReward) {
            rewardNode.show(this.rewardNewReward);
            this.SetVipRewardLabel(labelVipReward, this.rewardNewReward);
          } else {
            if (this.rewardCallback) this.rewardCallback();
            return;
          }

          spReward.scale = v3(0.001, 0.001, 1);
          const localPos = new Vec3();
          const worldPos = this.activityNode.getChildByName("progressBar").getWorldPosition();
          spReward.parent.inverseTransformPoint(localPos, worldPos);
          this.scheduleOnce(() => {
            spReward.runAction(ccAction.sequence(ccAction.scaleTo(0.4, 1, 1), ccAction.delayTime(1), ccAction.callFunc(() => {
              if (this.rewardNewReward) {
                // spReward.runAction(ccAction.jumpTo(0.7, RewardNodePos.x, RewardNodePos.y, 200, 1))
                spReward.runAction(ccAction.moveTo(0.7, localPos.x + 120, localPos.y));
                spReward.runAction(ccAction.sequence(ccAction.scaleTo(0.7, 0.5, 0.5), ccAction.callFunc(() => {
                  if (this.rewardCallback) this.rewardCallback();
                  this.playAnim = false;
                  this.playRewardAnim = false;
                  spRewardFx.active = false;
                }, this)));
              }
            }, this)));
            SoundManager.playSound("new_reward_added_to_Bar_01");
          }, animTime);
        }

        SetVipRewardLabel(labelVipReward, content) {
          if (!Game.SUserStatus.IsVip()) return;

          if (content.Type() == Content.Types.Ap) {
            labelVipReward.string = "+ " + BigNumber.format(Math.floor(content.Count() * G.GameConstance.vipSlotActivityAdd));
          } else if (content.Type() == Content.Types.Coin) {
            labelVipReward.string = "+ " + BigNumber.format(Content.RoundCoin(content.Count() * G.GameConstance.vipSlotActivityAdd));
          } else {
            labelVipReward.string = "";
          }
        }

        GetAfterVipReward(reward) {
          if (!Game.SUserStatus.IsVip()) return reward;
          let vipReward = Content.FromContent(reward);

          if (vipReward.Type() == Content.Types.Ap) {
            vipReward.SetCount(vipReward.Count() + Math.floor(vipReward.Count() * G.GameConstance.vipSlotActivityAdd));
          } else if (vipReward.Type() == Content.Types.Coin) {
            vipReward.SetCount(vipReward.Count() + Content.RoundCoin(vipReward.Count() * G.GameConstance.vipSlotActivityAdd));
          }

          return vipReward;
        }

        ShowVipReward(animTime = 0.1) {
          let spReward = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spReward");
          let rewardNode = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "rewardNode").getComponent(ContentModel);
          let spBg = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spBg");
          let spDes = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spDes");
          let spBtn = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spBtn");
          let spRewardFx = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spRewardFx");
          this.vipRewardPanel.active = true;
          let vipReward = Content.FromContent(this.rewardReward);

          if (vipReward.Type() == Content.Types.Ap) {
            vipReward.SetCount(Math.floor(vipReward.Count() * G.GameConstance.vipSlotActivityAdd));
          } else if (vipReward.Type() == Content.Types.Coin) {
            vipReward.SetCount(Content.RoundCoin(vipReward.Count() * G.GameConstance.vipSlotActivityAdd));
          }

          rewardNode.show(vipReward);
          spReward.x = 0;
          spReward.y = 0;
          this.vipRewardPanel.active = false;
          this.scheduleOnce(() => {
            this.vipRewardPanel.active = true;
            spReward.scale = v3(0.001, 0.001, 1);
            spReward.runAction(ccAction.scaleTo(0.2, 1, 1));
            spBg.active = true;
            spBg.opacity = 1;
            spBg.runAction(ccAction.fadeTo(0.2, 150));
            spDes.active = true;
            spDes.scale = v3(0.001, 0.001, 1);
            spDes.runAction(ccAction.scaleTo(0.2, 1, 1));
            spBtn.active = true;
            spBtn.scale = v3(0.001, 0.001, 1);
            spBtn.runAction(ccAction.scaleTo(0.2, 1, 1));
            spRewardFx.active = true;
            SoundManager.playSound("chest_card");
          }, animTime);
        }

        GetVipOk() {
          let spReward = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spReward");
          let rewardNode = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "rewardNode").getComponent(ContentModel);
          let spBg = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spBg");
          let spDes = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spDes");
          let spBtn = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spBtn");
          let spRewardFx = GameKit.ControllerTable.GetNode(this.vipRewardPanel, "spRewardFx");
          spRewardFx.active = false;
          spDes.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001, 0.001), ccAction.callFunc(() => {
            spDes.scale = Vec3.ONE;
            spDes.active = false;
          }, this)));
          spBtn.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001, 0.001), ccAction.callFunc(() => {
            spBtn.scale = Vec3.ONE;
            spBtn.active = false;
          }, this)));
          spBg.runAction(ccAction.sequence(ccAction.fadeTo(0.2, 1), ccAction.callFunc(() => {
            spBg.opacity = 150;
            spBg.active = false;
          }, this)));
          let dis = homeView.slotPage.vipNode.getWorldPosition().subtract(spReward.getWorldPosition()); // spReward.runAction(ccAction.jumpBy(0.7, dis.x, dis.y, 200, 1))

          spReward.runAction(ccAction.moveBy(0.7, dis.x, dis.y));
          spReward.runAction(ccAction.sequence(ccAction.scaleTo(0.7, 0.2, 0.2), ccAction.callFunc(() => {
            spReward.scale = Vec3.ONE;
            this.vipRewardPanel.active = false;
            this.ShowNext();
          }, this)));
        }

        async updateCollectRank() {
          const rankData = Game.SUserActivity.GetSymbolRankData();
          const tournamentAnim = homeView.slotPage.btnSlotSymbolRank.node.getComponentInChildren(Animation);
          const dbToutnament = homeView.slotPage.btnSlotSymbolRank.node.getComponentInChildren(dragonBones.ArmatureDisplay);
          const rankLabel = homeView.slotPage.btnSlotSymbolRank.node.getChildByName("icon").getChildByName("labelRank"); //init

          if (this.collectRankScore == null) {
            if (rankData.activityId && !rankData.collect) {
              this.collectRankScore = rankData.rank[Game.SUser.UserId()].score;
            } else {
              this.collectRankScore = 0;
            }

            return;
          }

          if (!rankData.rank) return;
          let add = rankData.rank[Game.SUser.UserId()].score - this.collectRankScore;
          if (add <= 0) return;
          const oldScore = this.collectRankScore;
          this.collectRankScore = rankData.rank[Game.SUser.UserId()].score;
          const animStep = Math.ceil(add / 20);
          const animTimes = Math.ceil(add / animStep);
          const endPos = new Vec3();
          const animDelay = Math.max(0.1, 0.3 - Math.max(0, add - 5) * 0.03);
          await cce.wait(300);
          this.playAnim = true;
          uiRoot.ShowCantClick();
          uiRoot.node.inverseTransformPoint(endPos, homeView.slotPage.btnSlotSymbolRank.node.getWorldPosition());

          for (let i = 0; i < animTimes; i++) {
            await new Promise(resolve => {
              const newCup = instantiate(this.animHammerRank);
              newCup.active = true;
              uiRoot.node.addChild(newCup);
              SoundManager.playSound("HammersThrow-01");
              tween(newCup).parallel(tween().to(0.5, {
                angle: 360,
                scale: new Vec3(0.4, 0.4, 0.4),
                opacity: 100,
                position: endPos
              }).call(() => {
                newCup.destroy();
              }), tween().delay(animDelay).call(resolve)).start();
            });
          }

          if (oldScore !== 0) {
            this.playAnim = false;
            uiRoot.CloseCantClick();
          } // await cce.wait(1000);


          let uids = Object.keys(rankData.rank);
          uids.sort((a, b) => {
            return rankData.rank[b].score - rankData.rank[a].score;
          });
          const selfRank = uids.indexOf(Game.SUser.UserId().toString()) + 1;

          if (selfRank < this._lastRank) {
            this._lastRank = selfRank;
            dbToutnament.on(dragonBones.EventObject.COMPLETE, () => {
              tournamentAnim.play();
              dbToutnament.node.active = false;
            }, this);
            tween(rankLabel).to(0.04, {
              scale: new Vec3(1.5, 1.5, 1.5)
            }).delay(0.15).to(0.02, {
              scale: new Vec3(0.8, 0.8, 0.8)
            }).call(() => {
              rankLabel.getComponent(Label).string = selfRank.toString();
              dbToutnament.node.active = true;
              dbToutnament.playAnimation("gift_appear", 1);
            }).to(0.02, {
              scale: Vec3.ONE
            }).start();
            tournamentAnim.once(Animation.EventType.FINISHED, () => {
              if (oldScore == 0) {
                UIRoot.instance.openChildWindow(ActivitySlotSymbolRankWindow, {
                  showCallback: wnd => {
                    if (wnd) {
                      uiRoot.CloseCantClick();
                      wnd === null || wnd === void 0 ? void 0 : wnd.addOnCloseFunc(() => {
                        this.playAnim = false;
                      });
                    } else {
                      this.playAnim = false;
                    }
                  }
                });
              }
            }, this);
          } else {
            this.playAnim = false;
            uiRoot.CloseCantClick();
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "activityNode", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "progressBar", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "progressLabel", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "rewardNode", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "rewardLight", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "rewardLabel", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "itemFlyAimNode", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "flyItem", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "activityIcon", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "iconAttack", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "iconRaid", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "iconSymbol", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "iconBomb", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "iconKey", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "iconCup", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "raidMaster", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "slotCollect", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "rewardPanel", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "vipRewardPanel", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "animHammerRank", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UpdatePanel.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Label, ProgressBar, Node, _decorator, Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d896fFhBk9A57gLMvEj3KZ7", "UpdatePanel", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let UpdatePanel = exports('UpdatePanel', (_dec = ccclass('UpdatePanel'), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Label), _dec6 = property(ProgressBar), _dec7 = property(Label), _dec8 = property(ProgressBar), _dec9 = property(Label), _dec10 = property(Node), _dec11 = property(Node), _dec12 = property(Node), _dec13 = property(Node), _dec(_class = (_class2 = (_temp = class UpdatePanel extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "title", _descriptor, this);

          _initializerDefineProperty(this, "appVersion", _descriptor2, this);

          _initializerDefineProperty(this, "manifestVersion", _descriptor3, this);

          _initializerDefineProperty(this, "info", _descriptor4, this);

          _initializerDefineProperty(this, "fileProgress", _descriptor5, this);

          _initializerDefineProperty(this, "fileLabel", _descriptor6, this);

          _initializerDefineProperty(this, "byteProgress", _descriptor7, this);

          _initializerDefineProperty(this, "byteLabel", _descriptor8, this);

          _initializerDefineProperty(this, "close", _descriptor9, this);

          _initializerDefineProperty(this, "checkBtn", _descriptor10, this);

          _initializerDefineProperty(this, "retryBtn", _descriptor11, this);

          _initializerDefineProperty(this, "updateBtn", _descriptor12, this);
        }

        onLoad() {
          if (Reflect.get(globalThis, "$tp_version")) {
            this.appVersion.string = "appVersion: " + $tp_version;
          }

          const storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() : '/') + 'hotupdate-asset';
          const am = new jsb.AssetsManager('', storagePath);

          if (am.getState() === jsb.AssetsManager.State.UNINITED) {
            let url = "project.manifest";
            am.loadLocalManifest(url);
          }

          const manifestVersion = am.getLocalManifest().getVersion();
          this.manifestVersion.string = "" + manifestVersion;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "title", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "appVersion", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "manifestVersion", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "info", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "fileProgress", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "fileLabel", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "byteProgress", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "byteLabel", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "close", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "checkBtn", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "retryBtn", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "updateBtn", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/HoldSpinBtn.ts", ['cc', './CCE_Component.ts', './SlotNode.ts', './ContentCheck.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, SpriteFrame, CCInteger, _decorator, v3, UIOpacity, CCE_Component, SlotNode, ContentCheck, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
      v3 = module.v3;
      UIOpacity = module.UIOpacity;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      SlotNode = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d9533HWHBRIRIvJELxqRxVz", "HoldSpinBtn", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let HoldSpinBtn = exports('default', (_dec = property(Node), _dec2 = property(Sprite), _dec3 = property(SpriteFrame), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(CCInteger), _dec7 = property(Node), _dec8 = property(Node), ccclass(_class = (_class2 = (_temp = class HoldSpinBtn extends CCE_Component {
        constructor() {
          super();

          _defineProperty(this, "oldY", void 0);

          _defineProperty(this, "oldX", void 0);

          _defineProperty(this, "holding", void 0);

          _defineProperty(this, "isPressed", void 0);

          _defineProperty(this, "pressedTime", void 0);

          _defineProperty(this, "holdTip", void 0);

          _defineProperty(this, "action", void 0);

          _initializerDefineProperty(this, "slotNode", _descriptor, this);

          _initializerDefineProperty(this, "targetSprite", _descriptor2, this);

          _initializerDefineProperty(this, "spinSprite", _descriptor3, this);

          _initializerDefineProperty(this, "normalSprite", _descriptor4, this);

          _initializerDefineProperty(this, "stopSprite", _descriptor5, this);

          _initializerDefineProperty(this, "holdTime", _descriptor6, this);

          _initializerDefineProperty(this, "flash", _descriptor7, this);

          _initializerDefineProperty(this, "autoNode", _descriptor8, this);

          this.oldY = 0;
          this.oldX = 0;
          this.holding = false;
          this.isPressed = false;
          this.pressedTime = 0;
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          var node = this.node;
          this.oldY = node.position.y;
          this.oldX = node.position.x;
          this.holdTip = GameKit.PlayerPrefs.GetBool("AUTO_SPIN_TIP", false);
          this.autoNode.active = false;
        }

        onEnable() {
          this.node.on(Node.EventType.TOUCH_START, this.onButtonPress, this);
          this.node.on(Node.EventType.TOUCH_MOVE, this.onButtonMove, this);
          this.node.on(Node.EventType.TOUCH_END, this.onButtonRelease, this);
          this.node.on(Node.EventType.TOUCH_CANCEL, this.onButtonRelease, this);
        }

        onDisable() {
          this.node.off(Node.EventType.TOUCH_START, this.onButtonPress, this);
          this.node.off(Node.EventType.TOUCH_MOVE, this.onButtonMove, this);
          this.node.off(Node.EventType.TOUCH_END, this.onButtonRelease, this);
          this.node.off(Node.EventType.TOUCH_CANCEL, this.onButtonRelease, this);
        }

        start() {}

        onButtonPress(event) {
          if (this.holding == false) {
            if (this.slotNode.getComponent(SlotNode).canSpin() && !homeView.isChangeAnim()) {
              if (ContentCheck.CheckAp(this.slotNode.getComponent(SlotNode).getBet())) {
                this.pressedTime = 0;
                this.isPressed = true;
                this.slotNode.getComponent(SlotNode).spin();
                this.node.stopAllActions();
                this.action = this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY - 30));
              } else {
                this.node.stopAllActions();
                this.action = this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY - 8));
              }
            } else {
              this.node.stopAllActions();
              this.action = this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY - 8));
            }
          } else {
            this.holding = false;
            this.changeNormalSprite();
            this.node.stopAllActions();
            this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY));
            this.autoNode.active = false;
          }

          event.propagationStopped = true;
        }

        onButtonMove(event) {
          event.propagationStopped = true;
        }

        onButtonRelease(event) {
          if (!event.simulate) {
            if (this.holding == false) {
              this.node.stopAllActions();

              if (this.isPressed) {
                this.node.setPosition(v3(this.node.position.x, this.oldY - 30));
              } else {
                this.node.setPosition(v3(this.node.position.x, this.oldY - 8));
              }

              this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY));
            }

            this.isPressed = false;
            event.propagationStopped = true; // if (!this.holdTip && !this.holding) {
            // 	UIRoot.instance.openChildWindow(AutoSpinTipWindow);
            // 	GameKit.PlayerPrefs.SetBool("AUTO_SPIN_TIP", true);
            // 	this.holdTip = true;
            // }
          }
        }

        changeNormalSprite() {
          ///this.normalSprite.active = true
          this.stopSprite.active = false; //this.targetSprite.spriteFrame = this.spinSprite

          this.flash.active = true;
        }

        changeHoldSprite() {
          ///this.normalSprite.active = false
          this.stopSprite.active = true; //this.targetSprite.spriteFrame = this.stopSprite

          this.flash.active = false;
        }

        slowUpdate(dt) {
          if (this.holding == false) {
            if (this.isPressed == true) {
              this.pressedTime += dt;

              if (this.pressedTime > this.holdTime) {
                this.holding = true;
                this.autoNode.active = true;
                this.autoNode.stopAllActions();
                this.autoNode.getComponent(UIOpacity).opacity = 30;
                this.autoNode.runAction(ccAction.fadeTo(0.4, 255));
                this.changeHoldSprite();

                if (!this.holdTip) {
                  GameKit.PlayerPrefs.SetBool("AUTO_SPIN_TIP", true);
                  this.holdTip = true;
                }
              }
            }
          } else {
            if (this.slotNode.getComponent(SlotNode).canSpin()) {
              if (ContentCheck.CheckAp(this.slotNode.getComponent(SlotNode).getBet())) {
                this.slotNode.getComponent(SlotNode).spin();
              } else {
                this.cancelHold();
              }
            }
          }
        } // 是否是持续状态


        isHolding() {
          return this.holding;
        } // 取消持续状态


        cancelHold() {
          this.holding = false;
          this.isPressed = false;
          this.pressedTime = 0;
          this.changeNormalSprite();
          this.node.stopAllActions();
          this.node.runAction(ccAction.moveTo(0.1, this.oldX, this.oldY));
          this.autoNode.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "slotNode", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "targetSprite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spinSprite", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "normalSprite", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "stopSprite", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "holdTime", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "flash", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "autoNode", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RevengeWindow.ts", ['cc', './Logs.ts', './EnterCloseAnim.ts', './UIWindow.ts', './User.ts', './UserInfoModel.ts', './UserVillage.ts', './ScrollViewTool.ts', './SR.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Node, _decorator, Label, Sprite, Button, Logs, EnterCloseAnim, UIWindow, User, UserInfoModel, UserVillage, ScrollViewTool, SR, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      _decorator = module._decorator;
      Label = module.Label;
      Sprite = module.Sprite;
      Button = module.Button;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      User = module.User;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      UserVillage = module.UserVillage;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "d955cagXuFNmrUdhYaw48pm", "RevengeWindow", undefined); // //let UIWindow = UIWindow
      // let ScrollViewTool = require('ScrollViewTool')
      // let UserInfoModel = UserInfoModel


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        /** 伪数据长度 */
        FAKE_DATA_LENGTH: 0,

        /** 伪等待时间 */
        FAKE_WAIT_TIME: 1,

        /** 载入sprite旋转一圈的时间 */
        LOADING_ROTATION_TIME: 0.5,

        /** 页面类型：外部使用string传入参数 */
        PAGE_TYPE: {
          REVENGE: "revenge",
          FRIENDS: "friends"
        }
      };
      /**
       * Revenge界面
       * - 包含各类按钮的点击事件处理
       * - 调用的时候需要传入页面类型参数（string），否则默认为"revenge"
       * @class
       */

      let RevengeWindow = exports('RevengeWindow', (_dec = property(SpriteFrame), _dec2 = property(ScrollViewTool), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(SpriteFrame), ccclass(_class = (_class2 = (_temp = _class3 = class RevengeWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "default_avatar_sf", _descriptor, this);

          _initializerDefineProperty(this, "svt", _descriptor2, this);

          _initializerDefineProperty(this, "loading_circle", _descriptor3, this);

          _initializerDefineProperty(this, "noFriendsNode", _descriptor4, this);

          _initializerDefineProperty(this, "spGray", _descriptor5, this);

          _defineProperty(this, "type", void 0);
        }

        onShow(showParams) {
          switch (showParams.type) {
            case C.PAGE_TYPE.REVENGE:
              this.type = C.PAGE_TYPE.REVENGE;
              break;

            case C.PAGE_TYPE.FRIENDS:
              this.type = C.PAGE_TYPE.FRIENDS;
              break;

            default:
              Logs.Warning("传入了一个错误参数[页面类型]，showParams=", showParams);
              this.type = C.PAGE_TYPE.REVENGE;
              break;
          }

          this.event_update_data();
          EnterCloseAnim.playEnter(this.node);
        }

        onShowBack(showParams) {
          switch (showParams.type) {
            case C.PAGE_TYPE.REVENGE:
              this.type = C.PAGE_TYPE.REVENGE;
              break;

            case C.PAGE_TYPE.FRIENDS:
              this.type = C.PAGE_TYPE.FRIENDS;
              break;

            default:
              Logs.Warning("传入了一个错误参数[页面类型]，showParams=", showParams);
              this.type = C.PAGE_TYPE.REVENGE;
              break;
          }

          this.event_update_data(); // EnterCloseAnim.playEnter(this.node);
        }
        /** 点击事件：close */


        event_close() {
          this.node.parent.emit("close");
          this.closeAnim();
        }
        /** 事件，动态更新数据
         * - 可以供给外部调用
         */


        event_update_data() {
          // 加载动画
          this.open_loading_anima();

          switch (this.type) {
            case C.PAGE_TYPE.REVENGE:
              // [this.title_revenge.active, this.title_attack.active] = [true, false];
              this.update_all_item(this.get_revenge_data());
              this.close_loading_anima();
              break;

            case C.PAGE_TYPE.FRIENDS:
              // [this.title_revenge.active, this.title_attack.active] = [false, true];
              this.update_all_item(this.get_friend_data());
              this.close_loading_anima();
              break;
          }
        }
        /** 刷新所有的item
         * @param {[{}]} data_array
         */


        update_all_item(data_array = []) {
          this.noFriendsNode.active = !data_array.length;
          this.svt.ScrollToIndex(0);
          this.svt.clear();
          let item_count = data_array.length;
          let ranks = [];

          for (let i = 0; i < item_count; i++) {
            ranks.push(i);
          }

          this.svt.setItem(ranks,
          /**
           * @param {cc.Node} itemHandle item节点
           */
          (index, id, itemHandle) => {
            // 获取对应组件（node）
            // 注意各个子节点的名称正确
            // 注意要把对应的节点拖入ControllerTables下面
            let userinfo = GameKit.ControllerTable.GetNode(itemHandle, "userinfo").getComponent(UserInfoModel);
            let stat_label = GameKit.ControllerTable.GetNode(itemHandle, "star_label").getComponent(Label);
            let btn_random = GameKit.ControllerTable.GetNode(itemHandle, "btn_random");
            let btn_revenge = GameKit.ControllerTable.GetNode(itemHandle, "btn_revenge");
            let btn_attack = GameKit.ControllerTable.GetNode(itemHandle, "btn_attack"); // 根据数据写入

            let data = data_array[index]; ///? index?id?

            if (data === undefined) ;else {
              // 有数据
              // 采用User信息数据域的方式显示
              userinfo.show(new User().updateData(data["user"])); // 不同界面的信息域内容不同，因此要根据界面调整User信息域与界面信息的处理
              //stat_label.string = data["star"]

              switch (this.type) {
                case C.PAGE_TYPE.REVENGE:
                  [btn_random.active, btn_revenge.active, btn_attack.active] = [data.isRandom, !data.isRandom, false];

                  if (homeView.interactionNode.user.UserId() === data.userId) {
                    if (btn_random.active) {
                      btn_random.getComponentInChildren(Sprite).spriteFrame = this.spGray;
                      btn_random.getComponent(Button).interactable = false;
                    } else if (btn_revenge.active) {
                      btn_revenge.getComponentInChildren(Sprite).spriteFrame = this.spGray;
                      btn_revenge.getComponent(Button).interactable = false;
                    }
                  }

                  break;

                case C.PAGE_TYPE.FRIENDS:
                  [btn_random.active, btn_revenge.active, btn_attack.active] = [false, false, true];
                  break;
              }
            } // 绑定2个点击事件
            //

            btn_random.on("click", () => {
              this.changeAttackTarget(data);
            }, this);
            btn_revenge.on("click", () => {
              this.changeAttackTarget(data);
            }, this);
            btn_attack.on("click", () => {
              this.changeAttackTarget(data);
            }, this);
          });
        }
        /** 获取revenge_data的数据 */


        get_revenge_data() {
          return homeView.interactionNode.revenge_data_array;
        }
        /** 获取friend_data的数据 */


        get_friend_data() {
          return homeView.interactionNode.friendList;
        }
        /** 打开loading动画 */


        open_loading_anima() {
          /*if (this.loading_anima === undefined) {
          	this.loading_anima = ccAction.rotateBy(C.LOADING_ROTATION_TIME, 360).repeatForever()
          	this.loading_circle.active = true
          	this.loading_circle.runAction(this.loading_anima)
          }*/
          this.loading_circle.active = true;
        }
        /** 关闭loading动画 */


        close_loading_anima() {
          this.loading_circle.active = false;
        }
        /** 更换攻击目标 */


        changeAttackTarget(data) {
          if (data.isFriend && !data.village) {
            let req = SR.SRVillage.getPeopleUserVillage(data.userId);
            req.SetCallBack(res => {
              data.village = res.userVillage;

              this._changeAttackTarget(data);
            });
            req.Send();
          } else {
            this._changeAttackTarget(data);
          }
        }

        _changeAttackTarget(data) {
          this.node.parent.emit("close");
          this.closeAnim(() => {
            let interactionNode = homeView.interactionNode;
            interactionNode.user = new User();
            interactionNode.user.updateData(data.user);
            interactionNode.userVillage = new UserVillage();
            interactionNode.userVillage.updateData(data.village);
            interactionNode.attackUserId = data.userId;
            interactionNode.changeAttackTarget();
          });
        }

      }, _defineProperty(_class3, "windowPath", "Village/RevengeWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "default_avatar_sf", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "loading_circle", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "noFriendsNode", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spGray", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivityManager.ts", ['cc', './global.ts', './Logs.ts', './_app.ts', './HeistData.ts', './GameMainWindow.ts', './UIRoot.ts', './ActivityBadge.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Prefab, instantiate, G, Logs, cce, HeistData, GameMainWindow, UIRoot, ActivityBadge, Meta, Game, LogEventWrap, PaymentWrap, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Prefab = module.Prefab;
      instantiate = module.instantiate;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      HeistData = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityBadge = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('ActivityManager', void 0);

      cclegacy._RF.push({}, "d95932E0yRFZKtk6wHYP9aa", "ActivityManager", undefined);

      let ActivityManager;

      (function (_ActivityManager) {
        const Constance = _ActivityManager.Constance = {};
        let localData = null;

        function Clear() {
          // Constance = {}
          localData = null;
        }

        _ActivityManager.Clear = Clear;

        function logined() {
          let activities = GetAllShowActivityList();
          activities.sort((a, b) => {
            if (a.Type() == b.Type()) {
              return a.SubType() - b.SubType();
            }

            return a.Type() - b.Type();
          });
          activities.forEach(meta => {
            setLocalActivityIcon(meta);
          });
        }

        _ActivityManager.logined = logined;

        function GetConstance(data) {
          try {
            for (let id in data) {
              let kvp = data[id];
              Constance[kvp.key] = kvp.value;

              if (typeof kvp.value === "string") {
                if (kvp.value.startsWith("[") && kvp.value.endsWith("]") || kvp.value.startsWith("{") && kvp.value.endsWith("}")) {
                  Constance[kvp.key] = JSON.parse(kvp.value);
                }
              }
            }
          } catch (e) {
            Logs.Error("ActivityManager.GetConstance", e.message);
          }
        }

        _ActivityManager.GetConstance = GetConstance;

        function GetLocalData() {
          if (!localData) {
            localData = GameKit.PlayerPrefs.GetObject("activity_local_data", {});
          }

          return localData;
        }

        _ActivityManager.GetLocalData = GetLocalData;

        function FlushLocalData() {
          GameKit.PlayerPrefs.SetObject("activity_local_data", localData);
        }

        _ActivityManager.FlushLocalData = FlushLocalData;

        function setLocalActivityIcon(meta) {
          /* CoinHit Special!! */
          if (meta.Type() == Meta.ActivityMeta.Types.Game && meta.SubType() == Meta.ActivityMeta.SubTypes.Minigame && meta.Param().game == "coinhit") {
            let resName = "res/Activity/badge/CoinHitBadge";
            cce.loadRes(resName, Prefab, (err, winPre) => {
              if (err || !winPre) return;
              let wnd = instantiate(winPre);
              let badge = wnd.getComponent(ActivityBadge);
              badge.setMeta(meta);
              setTimeout(() => {
                if (GameMainWindow.instance) {
                  homeView.slotPage.SetActivityBadge(badge);
                }
              }, 100);
            });
            return;
          }

          if (meta.Type() == Meta.ActivityMeta.Types.Other && meta.SubType() == Meta.ActivityMeta.SubTypes.BlackJack) {
            let resName = "res/Activity/badge/" + meta.Icon();
            cce.loadRes(resName, Prefab, function (err, winPre) {
              if (err || !winPre) return;
              let wnd = instantiate(winPre);
              let badge = wnd.getComponent(ActivityBadge);
              badge.setMeta(meta);
              setTimeout(() => {
                if (GameMainWindow.instance) {
                  homeView.slotPage.SetActivityBadge(badge);
                }
              }, 100);
            });
            return;
          }

          if (meta.Type() == Meta.ActivityMeta.Types.Pay) {
            if (meta.SubType() == Meta.ActivityMeta.SubTypes.LadderPack) {
              HeistData.load_data(meta);

              if (HeistData.get_buy_Count_length() <= HeistData.get_buy_count()) {
                return;
              }
            }

            let badgeName = meta.Icon();

            if (badgeName) {
              if (badgeName.startsWith("http")) {
                let resName = "res/Activity/badge/ActivityDaysSaleBadge";
                cce.loadRes(resName, Prefab, function (err, winPre) {
                  if (err || !winPre) return;
                  let wnd = instantiate(winPre);
                  let badge = wnd.getComponent(ActivityBadge);
                  badge.setMeta(meta);
                });
              } else {
                let resName = "res/Activity/badge/" + badgeName;
                cce.loadRes(resName, Prefab, function (err, winPre) {
                  if (err || !winPre) return;
                  let wnd = instantiate(winPre);
                  let badge = wnd.getComponent(ActivityBadge);
                  badge.setMeta(meta);

                  if (GameMainWindow.instance) {
                    homeView.slotPage.SetActivityBadge(badge);
                  }
                });
              }
            }
          }
        }

        _ActivityManager.setLocalActivityIcon = setLocalActivityIcon;

        function activeLocalActivity(activityId) {
          let meta = GetMeta(activityId);
          let localdata = localData[activityId] || {};
          localdata.isActive = true;
          localdata.startTime = GameKit.TimeUtil.getCurrentTime();
          localData[activityId] = localdata;
          FlushLocalData();
          setLocalActivityIcon(meta);
          UIRoot.instance.openChildWindow(meta.Panel(), {
            meta: meta
          });
        }

        _ActivityManager.activeLocalActivity = activeLocalActivity;

        function disableLocalActivity(activityId) {
          let localdata = localData[activityId] || {};
          localdata.isActive = false;
          localData[activityId] = localdata;
          FlushLocalData();
          if (GameMainWindow.instance) homeView.slotPage.RemoveActivityBadge(activityId);
        }

        _ActivityManager.disableLocalActivity = disableLocalActivity;

        function checkLocalActivity() {
          let localData = GetLocalData();
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.Activity); //let result = []

          for (let activityId in metas) {
            let meta = metas[activityId];

            if (meta.IsActive()) {
              if (meta.IsUserTime()) {
                if (!CheckEnable(meta)) continue;
                if (localData[activityId] != null) continue;
                if (meta.IsInManyTimesCd()) continue;
                if (meta.Type() === Meta.ActivityMeta.Types.Pay && meta.SubType() === Meta.ActivityMeta.SubTypes.SpecialOffer) continue; //result.push(meta)

                ActivityManager.activeLocalActivity(meta.Id());
              }
            }
          }
        }

        _ActivityManager.checkLocalActivity = checkLocalActivity;

        function GetMeta(activityId) {
          return Meta.MetaManager.GetMeta(Meta.MetaType.Activity, activityId);
        }

        _ActivityManager.GetMeta = GetMeta;

        function GetAllShowActivityList() {
          //获取正在开启的本地活动
          GetLocalData();
          checkLocalActivity();
          let currentTime = GameKit.TimeUtil.getCurrentTime();

          for (let activityId in localData) {
            if (localData[activityId].isActive) {
              let meta = GetMeta(activityId);

              if (!meta) {
                localData[activityId].isActive = false;
              } else {
                if (currentTime > localData[activityId].startTime + meta.UserTime()) {
                  localData[activityId].isActive = false;
                }
              }
            }
          }

          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.Activity);
          let result = [];

          for (let activityId in metas) {
            //for (let i = 0; i < list.length; i++) {
            let meta = metas[activityId];

            if (meta.IsShowing()) {
              if (!CheckEnable(meta)) continue;

              if (meta.IsUserTime()) {
                if (!localData[activityId] || !localData[activityId].isActive) {
                  continue;
                }
              }

              result.push(meta);
            }
          }

          return result;
        }

        _ActivityManager.GetAllShowActivityList = GetAllShowActivityList;

        function GetAllActiveActivityList() {
          let list = GetAllShowActivityList();
          let result = [];

          for (let i = 0; i < list.length; i++) {
            let meta = list[i];

            if (meta.IsActive()) {
              result.push(meta);
            }
          }

          return result;
        }

        _ActivityManager.GetAllActiveActivityList = GetAllActiveActivityList;

        function CheckEnable(meta) {
          if (meta.Type() == Meta.ActivityMeta.Types.Pay) {
            if (!PaymentWrap.PayVisiable()) return false;
          }

          let enableTriggers = meta.EnableTrigger();

          for (let i = 0; i < enableTriggers.length; i++) {
            let trig = enableTriggers[i];

            if (trig.indexOf(">=") > -1) {
              let strs = trig.split(">=");
              if (!CheckTrigger(strs[0], ">=", strs[1])) return false;
            } else if (trig.indexOf("<=") > -1) {
              let strs = trig.split("<=");
              if (!CheckTrigger(strs[0], "<=", strs[1])) return false;
            } else if (trig.indexOf("!=") > -1) {
              let strs = trig.split("!=");
              if (!CheckTrigger(strs[0], "!=", strs[1])) return false;
            } else if (trig.indexOf("=") > -1) {
              let strs = trig.split("=");
              if (!CheckTrigger(strs[0], "=", strs[1])) return false;
            } else if (trig.indexOf(">") > -1) {
              let strs = trig.split(">");
              if (!CheckTrigger(strs[0], ">", strs[1])) return false;
            } else if (trig.indexOf("<") > -1) {
              let strs = trig.split("<");
              if (!CheckTrigger(strs[0], "<", strs[1])) return false;
            }
          }

          return true;
        }

        _ActivityManager.CheckEnable = CheckEnable;

        function CheckTrigger(key, operator, _value) {
          let userValue = 0;
          let value = _value;

          if (key === "mapId") {
            userValue = Game.SUserVillage.MapId();
            value = parseInt(_value);
          } else if (key === "userGroup") {
            let sets = _value.split("/");

            userValue = Game.SUser.UserId() % parseInt(sets[1]);
            value = parseInt(sets[0]);
          } else if (key === "buyItem") {
            value = parseInt(_value);
            let purchasedActivityId = GameKit.PlayerPrefs.GetObject("purchasedActivityId", []);

            if (operator === "!=") {
              return !purchasedActivityId.contains(value);
            }

            return purchasedActivityId.contains(value);
          } else if (key === "purchaseMoney") {
            value = parseFloat(_value);
            userValue = Game.SUserRecord.GetPurchaseMoney();
          } else if (key === "purchaseMoneyAvg") {
            value = parseFloat(_value);
            userValue = Game.SUserRecord.GetPurchaseMoneyAvg();
          }

          if (operator === ">=") {
            return userValue >= value;
          } else if (operator === "<=") {
            return userValue <= value;
          } else if (operator === "!=") {
            return userValue != value;
          } else if (operator === "=") {
            return userValue == value;
          } else if (operator === ">") {
            return userValue > value;
          } else if (operator === "<") {
            return userValue < value;
          }

          return true;
        }

        _ActivityManager.CheckTrigger = CheckTrigger;

        function GetActiveShopActivity() {
          let activities = ActivityManager.GetAllActiveActivityList();

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Pay && meta.ShopIds()) return meta;
          }

          return null;
        }

        _ActivityManager.GetActiveShopActivity = GetActiveShopActivity;

        function GetActiveShopActivityByType(subtype) {
          let activities = ActivityManager.GetAllActiveActivityList();

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Pay && meta.SubType() == subtype) return meta;
          }

          return null;
        }

        _ActivityManager.GetActiveShopActivityByType = GetActiveShopActivityByType;

        function GetActiveGameActivities() {
          let activities = ActivityManager.GetAllActiveActivityList();
          let result = [];

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Game) result.push(meta);
          }

          return result;
        }

        _ActivityManager.GetActiveGameActivities = GetActiveGameActivities;

        function GetActiveSlotActivity() {
          let activities = ActivityManager.GetAllActiveActivityList();

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Game && (meta.SubType() == Meta.ActivityMeta.SubTypes.AttackMaster || meta.SubType() == Meta.ActivityMeta.SubTypes.RaidMaster || meta.SubType() == Meta.ActivityMeta.SubTypes.SlotCollect)) return meta;
          }

          return null;
        }

        _ActivityManager.GetActiveSlotActivity = GetActiveSlotActivity;

        function GetActiveSlotCollectActivity() {
          let activities = ActivityManager.GetAllActiveActivityList();

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Game && (meta.SubType() == Meta.ActivityMeta.SubTypes.SlotCollect || meta.SubType() == Meta.ActivityMeta.SubTypes.SlotCollectRank)) return meta;
          }

          return null;
        }

        _ActivityManager.GetActiveSlotCollectActivity = GetActiveSlotCollectActivity;

        function GetActiveGameActivityByType(subtype) {
          let activities = ActivityManager.GetAllActiveActivityList();

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Game && meta.SubType() == subtype) return meta;
          }

          return null;
        }

        _ActivityManager.GetActiveGameActivityByType = GetActiveGameActivityByType;

        function GetActiveOtherActivityByType(subtype) {
          let activities = ActivityManager.GetAllActiveActivityList();

          for (let i = 0; i < activities.length; i++) {
            let meta = activities[i];
            if (meta.Type() === Meta.ActivityMeta.Types.Other && meta.SubType() == subtype) return meta;
          }

          return null;
        }

        _ActivityManager.GetActiveOtherActivityByType = GetActiveOtherActivityByType;

        function ActivityOver(activityId) {
          let meta = GetMeta(activityId);

          if (meta.IsUserTime()) {
            ActivityManager.disableLocalActivity(activityId);
          }

          if (GameMainWindow.instance) homeView.slotPage.RemoveActivityBadge(activityId);

          if (homeView.slotNode) {
            let slotActivityRoot = homeView.slotNode.activityRoot;

            if (slotActivityRoot.activityMeta && slotActivityRoot.activityMeta.Id() === activityId) {
              slotActivityRoot.hideAll();
            }
          }
        }

        _ActivityManager.ActivityOver = ActivityOver;

        function checkSpecialOffer() {
          let localData = GetLocalData();

          for (let activityId in localData) {
            if (localData[activityId].isActive) {
              let meta = GetMeta(activityId);

              if (meta.Type() === Meta.ActivityMeta.Types.Pay && meta.SubType() === Meta.ActivityMeta.SubTypes.SpecialOffer) {
                return;
              }
            }
          }

          if (ActivityManager.GetActiveShopActivity()) return;
          if (G.getRandomFloat(0, 1) < 0.8) return;
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.Activity);
          let result = [];
          let weights = [];

          for (let activityId in metas) {
            let meta = metas[activityId];

            if (meta.IsActive()) {
              if (meta.Type() === Meta.ActivityMeta.Types.Pay && meta.SubType() === Meta.ActivityMeta.SubTypes.SpecialOffer) {
                if (!CheckEnable(meta)) {
                  continue;
                }

                if (meta.IsInManyTimesCd()) continue;
                result.push(meta);
                weights.push(meta.Param().ratio);
              }
            }
          }

          if (result.length <= 0) return;
          let activityMeta = result[GameKit.FuncTools.getIndexByWeight(weights)];
          ActivityManager.activeLocalActivity(activityMeta.Id());
          LogEventWrap.logEvent("activity_activelocal_specialoffer", {
            id: activityMeta.Id()
          });
          return true;
        }

        _ActivityManager.checkSpecialOffer = checkSpecialOffer;
      })(ActivityManager || (ActivityManager = exports('ActivityManager', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/vconsole.min2.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      /**
       * 注意：已把原脚本注释，由于脚本变动过大，转换的时候可能有遗落，需要自行手动转换
       */
      cclegacy._RF.push({}, "d9ce1INH7hL87tFsIqsxuvh", "vconsole.min", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UserCard.ts", ['cc', './global.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Meta, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "da10fHUtMtOULJNXGK3isxg", "UserCard", undefined); //用户金币


      class UserCard {
        constructor(userId) {
          _defineProperty(this, "data", void 0);

          this.data = {
            userId: userId,
            cardData: {},
            //卡片数据 id:num
            rewardData: {},
            //领奖数据 setId:bool
            freeCount: 0,
            freeTime: 0
          };
          let CLOSE_Card = false;
          Object.defineProperty(window, "CLOSE_Card", {
            get: () => CLOSE_Card,
            configurable: true
          });
        }

        createNew(dbdata) {} //更新数据


        updateData(data) {
          for (var key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
        }

        UserId() {
          return this.data.userId;
        }

        CardData() {
          return this.data.cardData;
        }

        CardNum(id) {
          return this.data.cardData[id] || 0;
        }

        HaveCard(id) {
          return this.data.cardData[id] && this.data.cardData[id] > 0;
        }

        AddCard(id) {
          let num = this.data.cardData[id] || 0;
          this.data.cardData[id] = num + 1;
        }

        DeleteCard(id) {
          let num = this.data.cardData[id] || 1;
          this.data.cardData[id] = num - 1;
        }

        HasgotSetsReward(setId) {
          return !!this.data.rewardData[setId];
        }

        GetSetsReward(setId) {
          this.data.rewardData[setId] = true;
        }

        Star() {
          let star = 0;

          for (let id in this.data.cardData) {
            if (this.data.cardData[id] <= 0) continue;
            star += Meta.MetaManager.GetMeta(Meta.MetaType.Card, id).Rare();
          }

          return star;
        }

        CheckDailyLimit() {
          let sendCardTime = GameKit.PlayerPrefs.GetInt("sendCardTime", 0);

          if (GameKit.TimeUtil.getCurrentDay() !== sendCardTime) {
            GameKit.PlayerPrefs.SetInt("sendCardCount", 0);
            GameKit.PlayerPrefs.SetInt("sendCardTime", GameKit.TimeUtil.getCurrentDay());
          }

          let sendCardCount = GameKit.PlayerPrefs.GetInt("sendCardCount", 0);

          if (sendCardCount >= G.GameConstance.dailyMaxSendCard) {
            return false;
          }

          return true;
        }
        /** 获取当前天剩余的count */


        GetDailyCount() {
          let sendCardTime = GameKit.PlayerPrefs.GetInt("sendCardTime", 0);

          if (GameKit.TimeUtil.getCurrentDay() !== sendCardTime) {
            GameKit.PlayerPrefs.SetInt("sendCardCount", 0);
            GameKit.PlayerPrefs.SetInt("sendCardTime", GameKit.TimeUtil.getCurrentDay());
          }

          let sendCardCount = GameKit.PlayerPrefs.GetInt("sendCardCount", 0);
          return G.GameConstance.dailyMaxSendCard - sendCardCount;
        }

      }

      exports('UserCard', UserCard);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ShakeAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "da751J4RCNFRpPKzy/4pD5+", "ShakeAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShakeAnim = exports('default', (_dec = property(CCInteger), _dec2 = property(CCInteger), _dec3 = property(CCInteger), _dec4 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class ShakeAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "time", _descriptor, this);

          _initializerDefineProperty(this, "wait", _descriptor2, this);

          _initializerDefineProperty(this, "delay", _descriptor3, this);

          _initializerDefineProperty(this, "degree", _descriptor4, this);

          _defineProperty(this, "playing", void 0);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {},


        start() {
          this.playing = true;
          this.scheduleOnce(function () {
            this.playing = false;
          }.bind(this), this.delay);
        }

        slowUpdate(dt) {
          if (this.playing) return;
          this.node.runAction(ccAction.sequence(ccAction.rotateTo(this.time / 8, -this.degree), ccAction.rotateTo(this.time / 4, this.degree), ccAction.rotateTo(this.time / 4, -this.degree), ccAction.rotateTo(this.time / 4, this.degree), ccAction.rotateTo(this.time / 8, 0), ccAction.delayTime(this.wait)).repeatForever());
          this.playing = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "time", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "wait", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "delay", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "degree", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 5;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/FlashEffect.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Sprite;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Sprite = module.Sprite;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "dafb0Ep57NAdIC4Dv2M9Eoz", "FlashEffect", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let FlashEffect = exports('default', (_dec = ccclass('FlashEffect'), _dec(_class = executeInEditMode(_class = (_temp = class FlashEffect extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "img", null);

          _defineProperty(this, "material", null);

          _defineProperty(this, "startTime", void 0);

          _defineProperty(this, "time", 0);
        }

        onLoad() {
          var _this$img, _this$material;

          this.img = this.getComponent(Sprite);
          this.material = (_this$img = this.img) === null || _this$img === void 0 ? void 0 : _this$img.sharedMaterial;
          (_this$material = this.material) === null || _this$material === void 0 ? void 0 : _this$material.setProperty("flashLen", 0.08);
        }

        update(dt) {
          var _this$material2;

          this.time += dt;

          if (this.time >= 2) {
            this.time -= 2;
          }

          (_this$material2 = this.material) === null || _this$material2 === void 0 ? void 0 : _this$material2.setProperty("time", this.time / 2);
        }

      }, _temp)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SystemUserMeta.ts", ['cc', './global.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, G, Meta, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "dafe7qjg4lLO7xf0oxUiMq6", "SystemUserMeta", undefined);

      class SystemUserMeta {
        constructor() {
          _defineProperty(this, "_data", {});

          _defineProperty(this, "number", 2165);
        }

        static MakeEntity(data) {
          let meta = new SystemUserMeta();
          meta.UpdateData(data);
          return meta;
        }

        static CacheUser() {
          SystemUserMeta.result = {};
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.SystemUser);

          for (let id in metas) {
            let meta = metas[id];
            let mapId = meta.MapId();
            if (!SystemUserMeta.result.hasOwnProperty(mapId)) SystemUserMeta.result[mapId] = [];
            SystemUserMeta.result[mapId].push(meta);
          }
        }

        static GetUser(mapId, lastUserId) {
          let result = SystemUserMeta.result[mapId];
          if (!result || result.length <= 0) return null;
          let r = result[G.getRandomInt(0, result.length)];

          if (r.UserId() === lastUserId) {
            return SystemUserMeta.GetUser(mapId, lastUserId);
          }

          return r;
        }

        static getRandomUsers(count) {
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.SystemUser);
          let uniIds = [];

          for (let i = SystemUserMeta.uniIdStart; i <= SystemUserMeta.uniIdEnd; i++) {
            uniIds.push(i);
          }

          let ids = GameKit.FuncTools.getRandomCount(uniIds, count);
          let data = {};
          ids.forEach(id => {
            data[id] = metas[id];
          });
          return data;
        }

        static getSeedRandomUsers(count, seed) {
          let metas = Meta.MetaManager.GetMetas(Meta.MetaType.SystemUser);
          let uniIds = [];

          for (let i = SystemUserMeta.uniIdStart; i <= SystemUserMeta.uniIdEnd; i++) {
            uniIds.push(i);
          }

          let ids = GameKit.FuncTools.getSeedRandomCount(uniIds, count, seed);
          let data = {};
          ids.forEach(id => {
            data[id] = metas[id];
          });
          return data;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        UserId() {
          return this._data.id;
        }

        MapId() {
          return this._data.mapId;
        }

        Name() {
          return this._data.name;
        }

        Avatar() {
          return this._data.avatar;
        }

        IsVip() {
          return this._data.isVip;
        }

        UserInfo() {
          return {
            userId: this.UserId(),
            name: this.Name(),
            avatar: this.Avatar(),
            isVip: this.IsVip()
          };
        }

      }

      exports('SystemUserMeta', SystemUserMeta);

      _defineProperty(SystemUserMeta, "uniIdStart", void 0);

      _defineProperty(SystemUserMeta, "uniIdEnd", 2328);

      _defineProperty(SystemUserMeta, "result", void 0);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRStatus.ts", ['cc', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Game, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRStatus', void 0);

      cclegacy._RF.push({}, "db504Aw191GcqL3BHOmHZfe", "SRStatus", undefined);

      let SRStatus;

      (function (_SRStatus) {
        function getUserStatus() {
          let req = new GameKit.ServerRequest("getUserStatus");
          req.SetCallBack(function (res) {
            Game.SUserStatus.updateData(res.userdata);

            if (res.vipDailyReward) {
              GameKit.DataCache.SetData("vipDailyReward", res.vipDailyReward);
            }
          });
          return req;
        }

        _SRStatus.getUserStatus = getUserStatus;

        function getLevelBonusReward(id) {
          let req = new GameKit.ServerRequest("getLevelBonusReward");
          req.SetRequestBody("rewardId", id);
          return req;
        }

        _SRStatus.getLevelBonusReward = getLevelBonusReward;
      })(SRStatus || (SRStatus = exports('SRStatus', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SlotCollectExtra.ts", ['cc', './CCE_Component.ts', './ContentModel.ts', './fixedSizeRatio.ts', './CommonAssets.ts', './Content.ts', './ActivityManager.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, ProgressBar, Node, _decorator, v3, CCE_Component, ContentModel, fixedSizeRatio, CommonAssets, Content, ActivityManager, Game, Meta;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
      Node = module.Node;
      _decorator = module._decorator;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      fixedSizeRatio = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "db506GpO6pE56Fuiw4U9T/i", "SlotCollectExtra", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SlotCollectExtra = exports('default', (_dec = property(Sprite), _dec2 = property(Label), _dec3 = property(ProgressBar), _dec4 = property(ContentModel), _dec5 = property(Node), _dec6 = property(Label), _dec7 = property(Label), _dec8 = property(Label), _dec9 = property(Label), _dec10 = property(Label), ccclass(_class = (_class2 = (_temp = class SlotCollectExtra extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spSymbol", _descriptor, this);

          _initializerDefineProperty(this, "labelProgress", _descriptor2, this);

          _initializerDefineProperty(this, "spProgress", _descriptor3, this);

          _initializerDefineProperty(this, "reward", _descriptor4, this);

          _initializerDefineProperty(this, "spHelp", _descriptor5, this);

          _initializerDefineProperty(this, "labelHelpNum1", _descriptor6, this);

          _initializerDefineProperty(this, "labelHelpNum2", _descriptor7, this);

          _initializerDefineProperty(this, "labelHelpNum3", _descriptor8, this);

          _initializerDefineProperty(this, "labelHelpNum4", _descriptor9, this);

          _initializerDefineProperty(this, "labelHelpNum5", _descriptor10, this);

          _defineProperty(this, "activityId", void 0);

          _defineProperty(this, "userdata", void 0);
        }

        Show(centerWindow, activityMeta) {
          //this.spHelp.active = false
          this.activityId = activityMeta.Id();
          this.userdata = Game.SUserActivity.GetActivityData(this.activityId);
          let currentCount = this.userdata.currentCount || 0;
          let currentId = this.userdata.currentId || 1;
          let currentNeed = Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollect, currentId);
          let currentGet = Content.FromString(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.SlotCollectReward, currentId));
          let symbolId = activityMeta.Param().symbolId;
          this.spSymbol.spriteFrame = CommonAssets.instance.getByAtlas(CommonAssets.Atlases.SlotSymbol, symbolId.toString());
          fixedSizeRatio.fitByHeight(this.spSymbol);
          this.labelProgress.string = currentCount.toString() + " / " + currentNeed;
          this.spProgress.progress = currentCount / currentNeed;
          this.reward.show(currentGet);
          let symbolSp = CommonAssets.instance.getByAtlas(CommonAssets.Atlases.SlotSymbol, symbolId.toString() + "_s"); // this.spHelpSymbols.forEach((x) => {
          // 	x.spriteFrame = symbolSp;
          // 	fixedSizeRatio.fitByHeight(x);
          // });

          this.labelHelpNum1.string = ActivityManager.Constance.slotCollectAttack.toString();
          this.labelHelpNum2.string = ActivityManager.Constance.slotCollectBlock.toString();
          this.labelHelpNum3.string = ActivityManager.Constance.slotCollectRaid.toString();
          this.labelHelpNum4.string = ActivityManager.Constance.slotCollectPRaid.toString();
          this.labelHelpNum5.string = ActivityManager.Constance.slotCollectSymbol.toString();
        }

        openHelp() {
          if (this.spHelp.active) {
            this.spHelp.stopAllActions();
            this.spHelp.runAction(ccAction.sequence(ccAction.scaleTo(0.2, 0.001, 0.001), ccAction.callFunc(() => {
              this.spHelp.active = false;
            })));
          } else {
            this.spHelp.active = true;
            this.spHelp.scale = v3(0.001, 0.001, 1);
            this.spHelp.stopAllActions();
            this.spHelp.runAction(ccAction.scaleTo(0.2, 1, 1));
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spSymbol", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelProgress", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spProgress", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "reward", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spHelp", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelHelpNum1", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelHelpNum2", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "labelHelpNum3", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "labelHelpNum4", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "labelHelpNum5", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ChangeSceneManager.ts", ['cc', './CCE_Component.ts', './EnterCloseAnim.ts', './SoundManager.ts', './UIRoot.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, UITransform, CCE_Component, EnterCloseAnim, SoundManager, UIRoot;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      UITransform = module.UITransform;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIRoot = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "dbd83qhOnZO94JuakjjhxN0", "ChangeSceneManager", undefined);

      const {
        ccclass,
        property,
        executionOrder
      } = _decorator;
      let ChangeSceneManager = exports('default', (_dec = executionOrder(-10), ccclass(_class = _dec(_class = (_temp = _class2 = class ChangeSceneManager extends CCE_Component {
        onLoad() {
          ChangeSceneManager.instance = this;
          this.node.getComponent(UITransform).width = UIRoot.instance.winSize.width;
          this.node.getComponent(UITransform).height = UIRoot.instance.winSize.height;
          EnterCloseAnim.playCloseImmediately(this.node);
          this.node.active = false;
        }

        start() {}

        show(callback) {
          this.node.active = true;
          UIRoot.instance.ShowCantClick(true);
          EnterCloseAnim.playEnter(this.node);
          this.scheduleOnce(() => {
            if (callback && typeof callback == "function") callback();
          }, 0.3);
          SoundManager.playSound("swipe_clouds");
        }

        hide(callback) {
          UIRoot.instance.CloseCantClick();
          EnterCloseAnim.playClose(this.node);
          this.scheduleOnce(() => {
            if (callback && typeof callback == "function") callback();
            this.node.active = false;
          }, 0.25);
          SoundManager.playSound("swipe_clouds_open");
        }

      }, _defineProperty(_class2, "instance", null), _temp)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonGetRewardWindow.ts", ['cc', './UIWindow.ts', './ContentModel.ts', './Content.ts', './CannonData.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Layout, Button, _decorator, instantiate, UIWindow, ContentModel, Content, CannonData;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Layout = module.Layout;
      Button = module.Button;
      _decorator = module._decorator;
      instantiate = module.instantiate;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      CannonData = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "dbec3lH6bFH95xM6aQUmJ9e", "CannonGetRewardWindow", undefined); // const ContentModel = ContentModel


      const {
        ccclass,
        property
      } = _decorator;
      let CannonGetRewardWindow = exports('default', (_dec = property(Node), _dec2 = property(Layout), _dec3 = property(Button), ccclass(_class = (_class2 = (_temp = _class3 = class CannonGetRewardWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "index", void 0);

          _initializerDefineProperty(this, "reward_item", _descriptor, this);

          _initializerDefineProperty(this, "reward_layout", _descriptor2, this);

          _initializerDefineProperty(this, "btn_exchange", _descriptor3, this);
        }

        onShow(params) {
          this.index = params.index; // 奖励内容

          let reward = Content.Merge(Content.FromStrings(CannonData.get_exchange_reward(this.index)));
          this.reward_item.active = false; // TODO:超过4个reward则会超过返回,需要调整layout的space和item的大小

          reward.forEach(v => {
            let n = instantiate(this.reward_item);
            n.active = true;
            n.parent = this.reward_layout.node;
            n.getComponent(ContentModel).show(v);
          }); // 是否可以兑换

          let is_able_to_exchange = CannonData.has_item(...CannonData.get_exchange_source(this.index));
          this.btn_exchange.interactable = is_able_to_exchange;
        }
        /** @type {cc.Node} */


        event_close() {
          this.closeAnim();
        }

        event_exchange() {
          this.closeAnim();
          CannonData.exchange_reward(this.index);
        }

      }, _defineProperty(_class3, "windowPath", "Activity/cannon/CannonGetRewardWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "reward_item", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "reward_layout", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btn_exchange", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PageViewController.ts", ['cc', './Constant.ts', './CCE_Component.ts', './global.ts', './PlayGetAnimation.ts', './User.ts', './UserInfoModel.ts', './SdkManager.ts', './BetAnimationScript.ts', './ButtonSearch.ts', './NestPageView.ts', './ButtonScaleScript.ts', './ContentCheck.ts', './GameMainWindow.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, dragonBones, Button, SpriteFrame, Label, ProgressBar, Prefab, _decorator, Vec3, PageView, view, UITransform, v3, Sprite, color, Color, Tween, tween, easing, MyCustomEvent, TutorilaEvent, CCE_Component, G, PlayGetAnimation, User, UserInfoModel, SdkManager, BetAnimationScript, ButtonSearch, NestPageView, ButtonScaleScript, ContentCheck, GameMainWindow, Game, GameKit, i18n, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      dragonBones = module.dragonBones;
      Button = module.Button;
      SpriteFrame = module.SpriteFrame;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      Vec3 = module.Vec3;
      PageView = module.PageView;
      view = module.view;
      UITransform = module.UITransform;
      v3 = module.v3;
      Sprite = module.Sprite;
      color = module.color;
      Color = module.Color;
      Tween = module.Tween;
      tween = module.tween;
      easing = module.easing;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
      TutorilaEvent = module.TutorilaEvent;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      User = module.User;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      BetAnimationScript = module.BetAnimationScript;
    }, function (module) {
      ButtonSearch = module.ButtonSearch;
    }, function (module) {
      NestPageView = module.NestPageView;
    }, function (module) {
      ButtonScaleScript = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _dec23, _dec24, _dec25, _dec26, _dec27, _dec28, _dec29, _dec30, _dec31, _dec32, _dec33, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19, _descriptor20, _descriptor21, _descriptor22, _descriptor23, _descriptor24, _descriptor25, _descriptor26, _descriptor27, _descriptor28, _descriptor29, _descriptor30, _descriptor31, _descriptor32, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "dc693hB9MxN0rXZnF77hPRw", "PageViewController", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const betMaxLimit = {
        0: 3,
        80: 5,
        200: 10,
        350: 20,
        500: 40,
        1000: 60
      };
      var btnStates;

      (function (btnStates) {
        btnStates["TouchStarted"] = "touchstarted";
        btnStates["Pressed"] = "pressed";
        btnStates["TouchEnded"] = "touchEnded";
      })(btnStates || (btnStates = {}));

      const allBetNums = [1, 2, 3, 5, 10, 20, 40, 60];
      let PageViewController = exports('PageViewController', (_dec = ccclass("PageViewController"), _dec2 = property(NestPageView), _dec3 = property([ButtonScaleScript]), _dec4 = property(Node), _dec5 = property(ButtonSearch), _dec6 = property(dragonBones.ArmatureDisplay), _dec7 = property(dragonBones.ArmatureDisplay), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Node), _dec12 = property(Node), _dec13 = property(Button), _dec14 = property(Node), _dec15 = property(SpriteFrame), _dec16 = property(SpriteFrame), _dec17 = property(Label), _dec18 = property(Label), _dec19 = property(Node), _dec20 = property(ProgressBar), _dec21 = property(Node), _dec22 = property(Node), _dec23 = property(SpriteFrame), _dec24 = property(SpriteFrame), _dec25 = property(Label), _dec26 = property(Button), _dec27 = property(SpriteFrame), _dec28 = property(SpriteFrame), _dec29 = property(Label), _dec30 = property(Label), _dec31 = property(Node), _dec32 = property(Node), _dec33 = property(Prefab), _dec(_class = (_class2 = (_temp = class PageViewController extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "pageView", _descriptor, this);

          _initializerDefineProperty(this, "btns", _descriptor2, this);

          _initializerDefineProperty(this, "selectedBg", _descriptor3, this);

          _initializerDefineProperty(this, "btnSearch", _descriptor4, this);

          _initializerDefineProperty(this, "dbHalo", _descriptor5, this);

          _initializerDefineProperty(this, "dbWater", _descriptor6, this);

          _initializerDefineProperty(this, "iconFriend", _descriptor7, this);

          _initializerDefineProperty(this, "iconCard", _descriptor8, this);

          _initializerDefineProperty(this, "iconSearch", _descriptor9, this);

          _initializerDefineProperty(this, "iconBuild", _descriptor10, this);

          _initializerDefineProperty(this, "iconShop", _descriptor11, this);

          _initializerDefineProperty(this, "btnSpin", _descriptor12, this);

          _initializerDefineProperty(this, "halo", _descriptor13, this);

          _initializerDefineProperty(this, "sfHaloBlue", _descriptor14, this);

          _initializerDefineProperty(this, "sfHaloRed", _descriptor15, this);

          _initializerDefineProperty(this, "labelAp", _descriptor16, this);

          _initializerDefineProperty(this, "labelApRemain", _descriptor17, this);

          _initializerDefineProperty(this, "iconNode", _descriptor18, this);

          _initializerDefineProperty(this, "betProgress", _descriptor19, this);

          _initializerDefineProperty(this, "betLight", _descriptor20, this);

          _initializerDefineProperty(this, "betToast", _descriptor21, this);

          _initializerDefineProperty(this, "betToastMaxSF", _descriptor22, this);

          _initializerDefineProperty(this, "betToastSF", _descriptor23, this);

          _initializerDefineProperty(this, "betLabelToast", _descriptor24, this);

          _initializerDefineProperty(this, "betBtn", _descriptor25, this);

          _initializerDefineProperty(this, "betSFGreen", _descriptor26, this);

          _initializerDefineProperty(this, "betSFRed", _descriptor27, this);

          _initializerDefineProperty(this, "betTxt", _descriptor28, this);

          _initializerDefineProperty(this, "betMaxTxt", _descriptor29, this);

          _initializerDefineProperty(this, "spinIcon", _descriptor30, this);

          _initializerDefineProperty(this, "energyNode", _descriptor31, this);

          _initializerDefineProperty(this, "energyPrefab", _descriptor32, this);

          _defineProperty(this, "curLeftIndex", void 0);

          _defineProperty(this, "curPageRate", void 0);

          _defineProperty(this, "_curBtnIndex", 0);

          _defineProperty(this, "btnIcons", []);

          _defineProperty(this, "_isPageTurn", false);

          _defineProperty(this, "_isTouching", false);

          _defineProperty(this, "_isScrollBegan", false);

          _defineProperty(this, "_isAutoSpining", false);

          _defineProperty(this, "_isTouchUp", false);

          _defineProperty(this, "_spinTouchTime", 0);

          _defineProperty(this, "totalTouchTime", 1);

          _defineProperty(this, "_haloDuration", 2 / 3);

          _defineProperty(this, "_haloDelay", 1 / 3);

          _defineProperty(this, "_betNum", 0);

          _defineProperty(this, "betMax", 0);

          _defineProperty(this, "apRemainTime", 0);

          _defineProperty(this, "apStop", false);

          _defineProperty(this, "showAp", 0);

          _defineProperty(this, "btnIconLeftPosArr", []);

          _defineProperty(this, "btnIconMiddlePosArr", []);

          _defineProperty(this, "btnIconRightPosArr", []);

          _defineProperty(this, "localPos", new Vec3());

          _defineProperty(this, "_cancelClick", false);

          _defineProperty(this, "betAnim", null);

          _defineProperty(this, "_betTouchDuration", 0);

          _defineProperty(this, "_betProgressActiveGap", 0.3);

          _defineProperty(this, "_betProgressFullTime", 0.7);

          _defineProperty(this, "_isBetTouchEnded", true);

          _defineProperty(this, "btnBetShowPosition", new Vec3(0, 159, 0));

          _defineProperty(this, "btnBetHidePosition", new Vec3(0, 16, 0));
        }

        get betNum() {
          return this._betNum;
        }

        set betNum(value) {
          this._betNum = value;
          homeView.slotNode && (homeView.slotNode.betNum = value);
        }

        onLoad() {
          this.node.on(PageView.EventType.SCROLL_BEGAN, this._onScrollBegan, this);
          this.node.on(PageView.EventType.SCROLLING, this._onScrolling, this);
          this.node.on(PageView.EventType.TOUCH_UP, this._onPageViewTouchUp, this);
          this.node.on(PageView.EventType.PAGE_TURNING, this._onPageViewTurning, this);
          this.node.on(PageView.EventType.SCROLL_ENDED, () => {
            uiRoot.CloseCantClick();
            eventCenter.emit(MyCustomEvent.OnPageTurnComplete, this.pageView.getCurrentPageIndex());
            eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "home", this.pageView.getCurrentPageIndex(), 0);
          }, this);
          this.btnSpin.node.on(Node.EventType.TOUCH_START, this.onBtnSpinTouchStart, this);
          this.btnSpin.node.on(Node.EventType.TOUCH_CANCEL, this.onBtnSpinTouchCancel, this);
          this.btnSpin.node.on(Node.EventType.TOUCH_END, this.onBtnSpinTouchEnd, this);
          this.pageView.content.children.forEach((page, index) => {// page.getComponent(UITransform).setContentSize(view.getVisibleSize().width, view.getVisibleSize().height);
            // page.x = (index + 0.5) * page.width;
          }); //TODO这两个看起来和pageView关联不大，可以挪到别的地方去

          eventCenter.on(MyCustomEvent.GamePrepareOK, this.setBet, this);
          eventCenter.on(MyCustomEvent.GamePrepareOK, this.setAp, this);
          const width = view.getVisibleSize().width;
          this.btns.forEach((btn, index) => {
            btn.node.getComponent(UITransform).setContentSize(width / 6, 119);

            if (index === 2) {
              btn.node.getComponent(UITransform).setContentSize(width / 3, 119);
            }

            btn.node.y = 0;
          });
          this.selectedBg.getComponent(UITransform).setContentSize(width / 3 - 4, 119);
          this.btnIcons = [this.iconFriend, this.iconCard, this.iconSearch, this.iconBuild, this.iconShop];
          this.setBtnIconPositions();
          this.iconFriend.position = this.btnIconLeftPosArr[0];
          this.iconCard.position = this.btnIconLeftPosArr[1];
          this.iconSearch.position = this.btnIconMiddlePosArr[2].add(v3(0, 20, 0));
          this.iconBuild.position = this.btnIconRightPosArr[3];
          this.iconShop.position = this.btnIconRightPosArr[4];
          this.dbHalo.node.active = false;
        }

        onEnable() {
          this.betBtn.node.on(Node.EventType.TOUCH_START, this._onBtnBetTouchStart, this);
          this.betBtn.node.on(Node.EventType.TOUCH_END, this._onBtnBetTouchEnd, this);
          this.betBtn.node.on(Node.EventType.TOUCH_CANCEL, this._onBtnBetTouchCancel, this);
        }

        slowUpdate(dt) {
          this.updateAp(dt);
          this.updateBet(dt);
          this.updateSpin(dt);
        }

        setAp() {
          this._setAp();

          GameKit.WebEvent.RegisterEvent(GameKit.WebEvent.EventName.ApEvent, this.uuid, msg => {
            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              eventCenter.once(MyCustomEvent.CanChangeSpin, () => {
                this._setAp();
              }, this);
            } else if (msg && msg.ap) {
              eventCenter.once(MyCustomEvent.CanChangeSpin, () => {
                this._setAp();
              }, this);
            } else {
              this._setAp();
            }
          });
        }

        _setAp() {
          this.apStop = false;
          Game.SUser.UpdateApTime();
          let apNum = Game.SUser.Ap();
          this.setBet();
          this.setApWithNum(apNum);

          if (!this._isAutoSpining) {
            const apMax = Game.SUser.IsVip() ? G.GameConstance.vipApMax : G.GameConstance.apMax;
            this.btnSearch.node.getChildByName("filler").getComponent(Sprite).spriteFrame = Game.SUser.AP() >= apMax ? this.btnSearch.sfFillerUp : this.btnSearch.sfFillerBlueUp;
            this.dbWater.playAnimation(Game.SUser.AP() >= apMax ? "water_red" : "water_blue", 0);
          }

          this.btnSearch.node.getChildByName("filler").getComponent(Sprite).fillRange = Math.clamp(Game.SUser.Ap() / G.GameConstance.apMax, 0, 1);
          this.localPos.y = this.btnSearch.node.getChildByName("filler").height * (apNum / G.GameConstance.apMax - 0.5) + 4;
          this.btnSearch.node.getChildByName("Mask").getChildByName("dbWater").active = apNum > 0;
          this.btnSearch.node.getChildByName("Mask").getChildByName("dbWater").setPosition(this.localPos);
        }

        stopApAt(ap) {
          this.apStop = true;
          this.showAp = ap;
          this.setApWithNum(ap);
        }

        updateAp(dt) {
          if (this.apRemainTime != null) {
            let apRecoverSpins = G.GameConstance.apRecoverSpins;

            if (Game.SUserStatus.IsVip()) {
              G.GameConstance.apMax = G.GameConstance.vipApMax;
              apRecoverSpins = G.GameConstance.vipApRecoverSpins;

              if (this.labelAp) {
                this.labelAp.string = `${Game.SUser.Ap()}/${G.GameConstance.apMax}`;
              }
            }

            if (this._curBtnIndex === G.Pages.Slot && Game.SUser.Ap() < G.GameConstance.apMax && AppMain.instance.tutorialManager.isTutorilaFinished) {
              this.labelApRemain.node.active = true;
            } else {
              this.labelApRemain.node.active = false;
            }

            if (this.apStop) {
              if (this.showAp < G.GameConstance.apMax) {
                this.apRemainTime -= dt;

                if (this.apRemainTime <= 0) {
                  this.showAp += apRecoverSpins;
                  this.setApWithNum(this.showAp);
                } else {
                  if (this.labelApRemain) this.labelApRemain.string = String.format(i18n.t("ApRecoverIn"), apRecoverSpins, GameKit.TimeUtil.FormatRemainTimeSimple(this.apRemainTime));
                }
              }
            } else {
              if (Game.SUser.Ap() < G.GameConstance.apMax) {
                this.apRemainTime -= dt;

                if (this.apRemainTime <= 0) {
                  this._setAp();
                } else {
                  if (this.labelApRemain) this.labelApRemain.string = String.format(i18n.t("ApRecoverIn"), apRecoverSpins, GameKit.TimeUtil.FormatRemainTimeSimple(this.apRemainTime));
                }
              }
            }
          }
        }

        setApWithNum(apNum) {
          let apMax = G.GameConstance.apMax;
          let apRecoverSpins = G.GameConstance.apRecoverSpins;

          if (Game.SUserStatus.IsVip()) {
            apMax = G.GameConstance.vipApMax;
            apRecoverSpins = G.GameConstance.vipApRecoverSpins;
          }

          this.apRemainTime = G.GameConstance.apRecover - (Game.SUser.ApRecover() + GameKit.TimeUtil.getCurrentTime() - 1 - Game.SUser.ApRecoverLast());

          if (this.labelAp) {
            this.labelAp.string = `${apNum}/${apMax}`;
          }

          if (apNum < apMax) {
            this.labelApRemain.string = String.format(i18n.t("ApRecoverIn"), apRecoverSpins, GameKit.TimeUtil.FormatRemainTimeSimple(this.apRemainTime));
          }
        }

        setBet() {
          var _homeView$slotPage, _homeView$slotPage2; // 倍率设置


          this.updateBetMax();
          this.betNum = GameKit.PlayerPrefs.GetInt("SlotBetNum", 1);

          if (this.betNum > this.betMax) {
            this.betNum = allBetNums[0];
          }

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            this.betNum = allBetNums[0];
          }

          this.setBetValue(this.betNum);
          let user = new User();
          user.updateData(Game.SUserSlot.ToraidUser());
          (_homeView$slotPage = homeView.slotPage) === null || _homeView$slotPage === void 0 ? void 0 : _homeView$slotPage.toRaidUserNode.initBetValue(this.betNum);
          (_homeView$slotPage2 = homeView.slotPage) === null || _homeView$slotPage2 === void 0 ? void 0 : _homeView$slotPage2.toRaidUserNode.getComponent(UserInfoModel).show(user);
        }

        updateBetMax(showTip) {
          if (!this.node) return;
          let oldBetMax = GameKit.DataCache.GetData("ThisSlotBetMax");
          let uap = Game.SUser.Ap();

          for (let nap in betMaxLimit) {
            if (uap >= nap) this.betMax = betMaxLimit[nap];
          }

          this.betMax = Math.max(this.betMax, oldBetMax || 0);

          if (oldBetMax && this.betMax > oldBetMax) {
            this.betAnim = this.betBtn.getComponent(BetAnimationScript);
            this.betAnim.betMaxToNormal();
          }

          GameKit.DataCache.SetData("ThisSlotBetMax", this.betMax);
        } // 设置Bet显示


        setBetValue(value) {
          this.betBtn.node.getChildByName("betBg").getComponent(Sprite).spriteFrame = value < this.betMax ? this.betSFGreen : this.betSFRed;
          this.betTxt.color = value < this.betMax ? color("#ffffff") : color("#fff60b");
          this.betTxt.string = String.format(i18n.t("Bet") + i18n.t("multiplyx") + value.toString());
          this.betMaxTxt.string = i18n.t("betMaxBet") + this.betMax;
        }

        onBetClick() {
          if (!homeView.slotNode.canSpin()) return;
          if (this._cancelClick) return;
          this.betMaxTxt.node.parent.active = true;
          let betNumIndex = allBetNums.indexOf(this.betNum) + 1;
          if (betNumIndex >= allBetNums.length) betNumIndex = 0;
          this.betNum = allBetNums[betNumIndex];

          if (this.betNum > this.betMax) {
            this.betNum = allBetNums[0];
          }

          GameKit.PlayerPrefs.SetInt("SlotBetNum", this.betNum);
          this.setBetValue(this.betNum);

          if (this.betNum === allBetNums[0]) {
            this.betAnim.betMaxToNormal();
          } else if (this.betNum === this.betMax) {
            this.betAnim.betNormalToMax();
          } else {
            this.betAnim.betNormalToNormal();
          }

          this.betLabelToast.string = String.format(i18n.t("BetRibbonText"), this.betNum);
          this.betToast.active = true;

          if (this.betNum === this.betMax) {
            this.betToast.getComponent(Sprite).spriteFrame = this.betToastMaxSF;
            this.betLabelToast.color = new Color("#ffea00");
          } else {
            this.betToast.getComponent(Sprite).spriteFrame = this.betToastSF;
            this.betLabelToast.color = new Color("5fff3d");
          }

          this.betAnim.betShowToast();
          homeView.slotPage.toRaidUserNode.setBetValue(this.betNum);
          homeView.slotPage.toRaidUserNode.showBet();
          eventCenter.emit(MyCustomEvent.BetChanged);
        }

        updateBet(dt) {
          if (this._isBetTouchEnded) {
            this.betProgress.node.active = false;
            this.betLight.active = false;
            this.betLight.x = -80;
            return;
          }

          this._betTouchDuration += dt;

          if (this._betTouchDuration >= this._betProgressActiveGap) {
            this.betProgress.node.active = true;
            this.betProgress.progress = (this._betTouchDuration - this._betProgressActiveGap) / this._betProgressFullTime;
          }

          if (this.betProgress.progress >= 0.6) {
            this.betLight.active = true;
            this.betLight.x += 120 / 0.4 * dt;
          }

          if (this.betProgress.progress >= 1) {
            this.betProgress.node.active = false;
            this.betLight.active = false;
            this.betLight.x = -80;
            this._isBetTouchEnded = true;
            this._cancelClick = true;

            this._changeToMaxDirectly();
          }
        }

        _onBtnBetTouchStart() {
          this.betAnim = this.betBtn.getComponent(BetAnimationScript);
          this.betProgress.progress = 0;
          this._isBetTouchEnded = false;
          this._cancelClick = false;
        }

        _onBtnBetTouchEnd() {
          this._isBetTouchEnded = true;
          this._betTouchDuration = 0;
        }

        _onBtnBetTouchCancel() {
          this._isBetTouchEnded = true;
          this._betTouchDuration = 0;
        }

        _changeToMaxDirectly() {
          this.betNum = this.betMax;
          this.betMaxTxt.node.parent.active = true;
          GameKit.PlayerPrefs.SetInt("SlotBetNum", this.betNum);
          this.setBetValue(this.betNum);
          this.betAnim.betNormalToMax();
          this.betLabelToast.string = String.format(i18n.t("BetRibbonText"), this.betNum);
          this.betAnim.betShowToast();
          this.betToast.getComponent(Sprite).spriteFrame = this.betToastMaxSF;
          this.betLabelToast.color = new Color("#ffea00");
          homeView.slotPage.toRaidUserNode.setBetValue(this.betNum);
          homeView.slotPage.toRaidUserNode.showBet();
          eventCenter.emit(MyCustomEvent.BetChanged);
        }

        setBtnIconPositions() {
          const unitWidth = view.getVisibleSize().width / 12;

          for (let i = 0; i < this.btns.length; i++) {
            const middlePos = unitWidth * (i * 2 - 4);
            this.btnIconLeftPosArr.push(v3(middlePos - unitWidth, 0, 0));
            this.btnIconMiddlePosArr.push(v3(middlePos, 0, 0));
            this.btnIconRightPosArr.push(v3(middlePos + unitWidth, 0, 0));
          }
        }

        _onScrollBegan() {
          this._isPageTurn = false;
          this._isScrollBegan = true;
          this._isTouchUp = false;

          if (this._curBtnIndex !== G.Pages.Shop) {
            uiRoot.ShowCantClick();
          }
        }

        _onScrolling() {
          this.curLeftIndex = Math.floor(Math.abs(this.pageView.getScrollOffset().x) / this.node.getComponent(UITransform).width);
          this.curPageRate = Math.abs(this.pageView.getScrollOffset().x) % this.node.getComponent(UITransform).width / this.node.getComponent(UITransform).width;
          eventCenter.emit(MyCustomEvent.UpdateGlobalConfigAndLight, "home", this.curLeftIndex, this.curPageRate);
          eventCenter.emit(MyCustomEvent.OnPageScrolling, this.curLeftIndex + this.curPageRate); // console.log(this.curLeftIndex + this.curPageRate);

          if (this._isPageTurn) return;
          const rate = this.pageView.getScrollOffset().x / this.pageView.getMaxScrollOffset().x;
          if (rate >= 0 || rate <= -1) return;
          let endPosX = (Math.abs(rate) - 0.5) * 4 * view.getVisibleSize().width / 6;
          this.selectedBg.x = endPosX;
        }

        _onPageViewTurning() {
          if (this._isTouchUp) return;
          this._isPageTurn = true;
          const nextBtnIndex = this.pageView.curPageIdx;
          console.log("auto page turn move to page: ", nextBtnIndex);
          this.moveToPage(nextBtnIndex);
        }

        _onPageViewTouchUp() {
          this._isTouchUp = false;
          if (!this._isScrollBegan) return;
          const moveOffset = this.pageView.getOffsetWhenTouchUp();
          const touchMoveVelocity = this.pageView["_calculateTouchMoveVelocity"]();
          const nextBtnIndex = moveOffset.x > 0 ? this._curBtnIndex + 1 : this._curBtnIndex - 1;

          if (this.pageView.isScrollable(moveOffset, this._curBtnIndex, nextBtnIndex)) {
            this._isPageTurn = true;
            this._isTouchUp = true;
            this._isScrollBegan = false;
            console.log("offset move to page: ", nextBtnIndex);
            this.moveToPage(nextBtnIndex);
          } else if (Math.abs(touchMoveVelocity.x) > this.pageView.autoPageTurningThreshold) {
            const nextBtnIndex1 = touchMoveVelocity.x < 0 ? this._curBtnIndex + 1 : this._curBtnIndex - 1;
            this._isPageTurn = true;
            this._isTouchUp = true;
            this._isScrollBegan = false;
            console.log("velocity move to page: ", nextBtnIndex1);
            this.moveToPage(nextBtnIndex1);
          }
        }

        onBtnsClick(event) {
          if (homeView.isBusy()) return;
          uiRoot.ShowCantClick();
          const nextBtnIndex = this.btns.indexOf(event.target.getComponent(ButtonScaleScript));

          if (this._curBtnIndex === nextBtnIndex) {
            uiRoot.CloseCantClick();
            return;
          }

          this.pageView.setCurrentPageIndex(nextBtnIndex);
          this._isPageTurn = true;

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            eventCenter.emit(TutorilaEvent.GoRoomStarted);
          }

          this.moveToPage(nextBtnIndex);
        }

        selectedBgMoveAnimation(pageIndex) {
          Tween.stopAllByTarget(this.selectedBg);
          const endPosX = (pageIndex - 2) * view.getVisibleSize().width / 6;
          tween(this.selectedBg).to(0.7, {
            x: endPosX
          }, {
            easing: easing.quartOut
          }).start();
        }

        moveToPage(pageIndex, needSetPageIndex = false) {
          if (this._curBtnIndex === pageIndex) return;
          if (pageIndex >= this.btns.length || pageIndex < 0) return;
          this.selectedBgMoveAnimation(pageIndex);
          this.updateAllBtnIconPos(pageIndex);
          needSetPageIndex && this.pageView.scrollToPage(pageIndex, Math.abs(this._curBtnIndex - pageIndex) * 0.5);
          this.btns[this._curBtnIndex].selected = false;
          this.btns[pageIndex].selected = true;
          this._curBtnIndex = pageIndex;
          homeView.currentPageIndex = pageIndex;

          if (pageIndex === G.Pages.Collection) {
            GameMainWindow.instance.hideUserInfoNode();
          } else {
            GameMainWindow.instance.showUserInfoNode();
          }
        }

        updateAllBtnIconPos(nextBtnIndex) {
          let start = Math.min(nextBtnIndex, this._curBtnIndex);
          let end = Math.max(nextBtnIndex, this._curBtnIndex);

          for (let i = start; i <= end; i++) {
            const iconNode = this.btnIcons[i];
            const labelNode = iconNode.getChildByName("txt1");
            Tween.stopAllByTarget(labelNode);
            Tween.stopAllByTarget(iconNode);

            if (i !== nextBtnIndex) {
              tween(iconNode).to(0.4, {
                x: nextBtnIndex > i ? this.btnIconLeftPosArr[i].x : this.btnIconRightPosArr[i].x,
                y: 0,
                scale: v3(0.8, 0.8, 0.8)
              }, {
                easing: easing.quartOut
              }).start();

              if (labelNode) {
                tween(labelNode).set({
                  opacity: 255
                }).parallel(tween().to(0.3, {
                  opacity: 0
                }, {
                  easing: easing.sineOut
                }), tween().to(0.3, {
                  y: -75
                }, {
                  easing: easing.sineOut
                })).start();
              }

              if (i === 2 && i === this._curBtnIndex) {
                this.hideBtnSpin();
              }
            } else {
              tween(iconNode).to(0.4, {
                x: this.btnIconMiddlePosArr[i].x,
                y: 20,
                scale: Vec3.ONE
              }, {
                easing: easing.quartOut
              }).start();

              if (labelNode) {
                tween(labelNode).set({
                  opacity: 0
                }).parallel(tween().to(0.3, {
                  opacity: 255
                }, {
                  easing: easing.sineOut
                }), tween().to(0.3, {
                  y: -55
                }, {
                  easing: easing.sineOut
                })).start();
              }

              if (i === 2) {
                this.showBtnSpin();
              }
            }
          }
        }

        showBtnSpin() {
          this.iconSearch.active = false;
          this.betBtn.node.active = Game.SUserVillage.MapId() >= 2;
          this.betMaxTxt.node.parent.active = Game.SUserVillage.MapId() >= 2 && this.betNum !== this.betMax;
          this.betMaxTxt.node.parent.opacity = 0;
          const duration = 0.7; // this._setAp();

          Tween.stopAllByTarget(this.btnSpin.node);
          this.btnSpin.node.parent.active = true;
          tween(this.btnSpin.node).set({
            opacity: 0
          }).to(duration, {
            y: 21.6,
            opacity: 255,
            scale: Vec3.ONE
          }, {
            easing: easing.quartOut,
            onUpdate: (target, ratio) => {
              if (SdkManager.IsNative()) {
                //ios平台龙骨scale不会变化的bug
                // this.btnSearch["syncTransform"]();
                this.dbHalo["syncTransform"]();
                this.dbWater["syncTransform"](); //ios平台龙骨opacity不会变化的bug
                // this.btnSearch.color = new Color(255, 255, 255, ratio * 255);

                this.dbHalo.color = new Color(255, 255, 255, ratio * 255);
                this.dbWater.color = new Color(255, 255, 255, ratio * 255);
              }
            }
          }).call(() => {
            Tween.stopAllByTarget(this.betMaxTxt);
            tween(this.betMaxTxt.node.parent).to(0.4, {
              opacity: 255
            }, {
              easing: easing.quartOut
            }).start();

            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              eventCenter.emit(TutorilaEvent.GoRoomFinished);
            }

            this.btnSpin.interactable = true;
          }).start();
          Tween.stopAllByTarget(this.betBtn.node);
          tween(this.betBtn.node).parallel(tween().to(duration, {
            position: this.btnBetShowPosition
          }, {
            easing: easing.quartOut
          }), tween().to(duration, {
            scale: Vec3.ONE
          }, {
            easing: easing.quartOut
          })).start();
        }

        hideBtnSpin() {
          this.betBtn.node.active = false;
          this.iconSearch.active = true;
          this.betMaxTxt.node.parent.active = false;
          this.btnSpin.interactable = false;
          const duration = 0.5;
          Tween.stopAllByTarget(this.btnSpin.node);
          tween(this.btnSpin.node).set({
            opacity: 255
          }).to(duration, {
            y: 0,
            opacity: 0,
            scale: v3(0.5, 0.5, 0.5)
          }, {
            easing: easing.quartOut,
            onUpdate: (target, ratio) => {
              if (SdkManager.IsNative()) {
                //ios平台龙骨scale不会变化的bug
                // this.btnSearch["syncTransform"]();
                this.dbHalo["syncTransform"]();
                this.dbWater["syncTransform"](); //ios平台龙骨opacity不会变化的bug
                // this.btnSearch.color = new Color(255, 255, 255, 255 - ratio * 255);

                this.dbHalo.color = new Color(255, 255, 255, 255 - ratio * 255);
                this.dbWater.color = new Color(255, 255, 255, 255 - ratio * 255);
              }
            }
          }).call(() => {
            this.btnSpin.node.parent.active = false;
          }).start();
          Tween.stopAllByTarget(this.betBtn.node);
          tween(this.betBtn.node).parallel(tween().to(duration, {
            position: this.btnBetHidePosition
          }, {
            easing: easing.quartOut
          }), tween().to(duration, {
            scale: v3(0.01, 0.01, 0.01)
          }, {
            easing: easing.quartOut
          })).start();
        }

        updateSpin(dt) {
          if (this._isTouching) {
            this._spinTouchTime += dt;

            if (this._spinTouchTime >= this._haloDelay) {
              this.halo.active = true;
              const isFull = Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.Ap() >= G.GameConstance.apMax;
              this.halo.getComponent(Sprite).spriteFrame = isFull ? this.sfHaloRed : this.sfHaloBlue;
              const fillRange = -(this._spinTouchTime - this._haloDelay) / this._haloDuration;
              this.halo.getComponent(Sprite).fillRange = fillRange;
            }

            if (this._spinTouchTime >= this.totalTouchTime && AppMain.instance.tutorialManager.isTutorilaFinished) {
              this._isAutoSpining = true;
              this.halo.active = false;
              this.btnSearch.pressed(Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.AP() >= G.GameConstance.apMax); // this.onBtnSpinTouchEnd();
            }
          }

          if (this._isAutoSpining) {
            this.spin();
          }
        }

        onBtnSpinTouchStart(event) {
          this._spinTouchTime = 0;
          if (!this.btnSpin.interactable) return;

          if (!this._isAutoSpining) {
            this._isTouching = true;
            this.btnSearch.hold(Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.AP() >= G.GameConstance.apMax);
            Tween.stopAllByTarget(this.iconNode);
            tween(this.iconNode).to(0.15, {
              y: 0
            }).start();
            this.dbHalo.node.active = true;
            this.dbHalo.playAnimation("halo", 1);
          } else {
            this._isAutoSpining = false;
            this._isTouching = false;
          }
        }

        onBtnSpinTouchEnd() {
          this._isTouching = false;
          this.halo.active = false;

          if (this._isAutoSpining && AppMain.instance.tutorialManager.isTutorilaFinished) {
            this.btnSearch.pressed(Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.AP() >= G.GameConstance.apMax);
          } else {
            this.spin();
            this.btnSearch.idle(Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.AP() >= G.GameConstance.apMax);
            Tween.stopAllByTarget(this.iconNode);
            tween(this.iconNode).to(0.15, {
              y: 4
            }).start();
          }

          this._spinTouchTime = 0;
        }

        onBtnSpinTouchCancel(event) {
          this.halo.active = false;
          this._isTouching = false;
          this.btnSearch.click(Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.AP() >= G.GameConstance.apMax);
        }

        spin() {
          if (homeView.slotNode.canSpin() && !homeView.isChangeAnim() && this.btnSpin.interactable) {
            //新手引导
            if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
              homeView.slotNode.spin();
            } else if (ContentCheck.CheckAp(homeView.slotNode.betNum)) {
              homeView.slotNode.spin();
            } else {
              homeView.slotNode.isSpining = false;
              this._isAutoSpining = false;
              this._isTouching = false;
              this.btnSearch.click(Game.SUser.IsVip() ? Game.SUser.AP() >= G.GameConstance.vipApMax : Game.SUser.AP() >= G.GameConstance.apMax);
            }
          }
        }

        spinIconAni() {
          tween(this.spinIcon).to(0.04, {
            scale: G.scale1_1
          }, {
            easing: easing.quartOut
          }).to(0.08, {
            scale: G.scale0_9
          }, {
            easing: easing.quartOut
          }).to(0.04, {
            scale: Vec3.ONE
          }, {
            easing: easing.quartOut
          }).union().repeatForever().start();
        }

        async getEnergyByShieldAnimation(count) {
          this.spinIconAni();
          let obj = {
            value: Game.SUser.AP() - count
          };
          tween(obj).to(0.3, {
            value: Game.SUser.AP()
          }, {
            onUpdate: () => {
              this.setApWithNum(Math.min(Game.SUser.AP(), Math.floor(obj.value)));
            }
          }).call(() => {
            this._setAp();

            Tween.stopAllByTarget(this.spinIcon);
          }).start();
        }

        getEnergyAnimation(count, callback) {
          return new Promise(resolve => {
            let oldCount = Game.SUser.AP() - count;
            PlayGetAnimation.playAnimation({
              startNode: this.energyNode,
              endNode: this.btnSpin.node,
              count: count,
              prefab: this.energyPrefab,
              perComplete: perCount => {
                oldCount += perCount;
                this.setApWithNum(oldCount);
              },
              complete: () => {
                this._setAp();

                Tween.stopAllByTarget(this.spinIcon);
                resolve(null);

                if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                  eventCenter.emit(TutorilaEvent.SpinFinished);
                }
              },
              startCallback: () => {
                this.spinIconAni();
                callback && callback();
              }
            });
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "pageView", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btns", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "selectedBg", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btnSearch", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "dbHalo", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "dbWater", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "iconFriend", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "iconCard", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "iconSearch", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "iconBuild", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "iconShop", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "btnSpin", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "halo", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "sfHaloBlue", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "sfHaloRed", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "labelAp", [_dec17], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, "labelApRemain", [_dec18], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, "iconNode", [_dec19], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, "betProgress", [_dec20], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor20 = _applyDecoratedDescriptor(_class2.prototype, "betLight", [_dec21], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor21 = _applyDecoratedDescriptor(_class2.prototype, "betToast", [_dec22], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor22 = _applyDecoratedDescriptor(_class2.prototype, "betToastMaxSF", [_dec23], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor23 = _applyDecoratedDescriptor(_class2.prototype, "betToastSF", [_dec24], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor24 = _applyDecoratedDescriptor(_class2.prototype, "betLabelToast", [_dec25], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor25 = _applyDecoratedDescriptor(_class2.prototype, "betBtn", [_dec26], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor26 = _applyDecoratedDescriptor(_class2.prototype, "betSFGreen", [_dec27], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor27 = _applyDecoratedDescriptor(_class2.prototype, "betSFRed", [_dec28], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor28 = _applyDecoratedDescriptor(_class2.prototype, "betTxt", [_dec29], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor29 = _applyDecoratedDescriptor(_class2.prototype, "betMaxTxt", [_dec30], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor30 = _applyDecoratedDescriptor(_class2.prototype, "spinIcon", [_dec31], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor31 = _applyDecoratedDescriptor(_class2.prototype, "energyNode", [_dec32], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor32 = _applyDecoratedDescriptor(_class2.prototype, "energyPrefab", [_dec33], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardChestMeta.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "dd2d9KPcD5Dj7hYfxuPypBf", "CardChestMeta", undefined);

      class CardChestMeta {
        constructor() {
          _defineProperty(this, "_data", void 0);
        }

        static MakeEntity(data) {
          let meta = new CardChestMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = {};

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        CardNum() {
          return this._data.cardNum;
        }

        Rare1() {
          return this._data.rare1;
        }

        Rare2() {
          return this._data.rare2;
        }

        LeastRare() {
          return this._data.leastRare;
        }

      }

      exports('CardChestMeta', CardChestMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AddPrefab.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Prefab, _decorator, instantiate, v3, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "dd550ws6+tFAY1zSBQE6Gny", "AddPrefab", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AddPrefab = exports('default', (_dec = property(Prefab), ccclass(_class = (_class2 = (_temp = class AddPrefab extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "prefab", _descriptor, this);

          _defineProperty(this, "preNode", void 0);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.preNode = instantiate(this.prefab);
          this.preNode.parent = this.node;
          this.preNode.setPosition(v3(0, 0));
        }

        start() {}

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "prefab", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ParticleAnim.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, ParticleSystem2D, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      ParticleSystem2D = module.ParticleSystem2D;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "dde62Ab9JNHcpwVU7+j/zRV", "ParticleAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ParticleAnim = exports('default', (_dec = property(ParticleSystem2D), ccclass(_class = (_class2 = (_temp = class ParticleAnim extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "anim", _descriptor, this);

          _defineProperty(this, "completeCallback", void 0);

          _defineProperty(this, "completeCb", void 0);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.node.active = false;
          this.anim.stopSystem();
          this.completeCallback = null;
        }

        start() {}

        play(x, y, delay, cb) {
          var self = this;
          self.node.active = true;
          self.completeCb = cb;
          self.node.x = x;
          self.node.y = y;
          self.scheduleOnce(function () {
            self.anim.resetSystem();
          }, delay);
          self.scheduleOnce(function () {
            if (self.completeCb != null) {
              self.completeCb();
            }

            self.node.active = false;
          }, this.anim.duration + this.anim.life + this.anim.lifeVar);
        }

        stop() {
          this.unscheduleAllCallbacks();
          this.node.active = false;
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "anim", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AppKit.ts", ['cc', './SdkManager.ts', './LogEventWrap.ts', './ADWrap.ts', './LeaderBoardWrap.ts', './NativeWrap.ts', './NotificationWrap.ts', './PaymentWrap.ts', './ShareWrap.ts', './UserWrap.ts'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      exports('SdkManager', module.SdkManager);
    }, function (module) {
      exports('LogEventWrap', module.LogEventWrap);
    }, function (module) {
      exports('ADWrap', module.ADWrap);
    }, function (module) {
      exports('LeaderBoardWrap', module.LeaderBoardWrap);
    }, function (module) {
      exports('NativeWrap', module.NativeWrap);
    }, function (module) {
      exports('NotificationWrap', module.NotificationWrap);
    }, function (module) {
      exports('PaymentWrap', module.PaymentWrap);
    }, function (module) {
      exports('ShareWrap', module.ShareWrap);
    }, function (module) {
      exports('UserWrap', module.UserWrap);
    }],
    execute: function () {
      cclegacy._RF.push({}, "de841qLWaxOULzj3NqBQrSG", "AppKit", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Constant.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Enum;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
    }],
    execute: function () {
      exports({
        BoxAnimName: void 0,
        BundleNames: void 0,
        CameraLayers: void 0,
        Constant: void 0,
        HandAnimName: void 0,
        LoadEvent: void 0,
        MyCustomEvent: void 0,
        PetAnimName: void 0,
        PetType: void 0,
        PlayerAnimName: void 0,
        SlotTypes: void 0,
        TutorilaEvent: void 0,
        VersionScheme: void 0
      });

      cclegacy._RF.push({}, "dfb81yxomZCU5Ek+0GoxHpp", "Constant", undefined);

      let Constant;

      (function (_Constant) {
        const MaxLevel = _Constant.MaxLevel = 60;
        const boomSpeed = _Constant.boomSpeed = 1;
        const boomRotateSpeed = _Constant.boomRotateSpeed = -30;
        const useDeviceRatio = _Constant.useDeviceRatio = true;
        const skipTigerAnimResIds = _Constant.skipTigerAnimResIds = [39, 54, 56];
        const LocalMapIds = _Constant.LocalMapIds = [1, 2, 3];
      })(Constant || (Constant = exports('Constant', {})));

      let LoadEvent;

      (function (LoadEvent) {
        LoadEvent["SlotProgressUpdate"] = "SlotProgressUpdate";
        LoadEvent["SlotLoaded"] = "SlotLoaded";
        LoadEvent["VillageProgressUpdate"] = "VillageProgressUpdate";
        LoadEvent["VillageLoaded"] = "VillageLoaded";
        LoadEvent["VillageIconProgressUpdate"] = "VillageIconProgressUpdate";
        LoadEvent["VillageIconLoaded"] = "VillageIconLoaded";
        LoadEvent["RaidProgressUpdate"] = "RaidProgressUpdate";
        LoadEvent["RaidLoaded"] = "RaidLoaded";
        LoadEvent["UserAvatarLoaded"] = "UserAvatarLoaded";
      })(LoadEvent || (LoadEvent = exports('LoadEvent', {})));

      let MyCustomEvent;

      (function (MyCustomEvent) {
        MyCustomEvent["SwitchDebug"] = "SwitchDebug";
        MyCustomEvent["GamePrepareOK"] = "GamePrepareOK";
        MyCustomEvent["VillageAttack"] = "VillageAttack";
        MyCustomEvent["EnterNewVillage"] = "EnterNewVillage";
        MyCustomEvent["OpenRaidBox"] = "OpenRaidBox";
        MyCustomEvent["OnPageTurnComplete"] = "OnPageTurnComplete";
        MyCustomEvent["UpdateGlobalConfigAndLight"] = "UpdateGlobalConfigAndLight";
        MyCustomEvent["OnPageScrolling"] = "OnPageScrolling";
        MyCustomEvent["PlayerRunStart"] = "PlayerRunStart";
        MyCustomEvent["PlayerRunEnd"] = "PlayerRunEnd";
        MyCustomEvent["CoinFlyEnd"] = "CoinFlyEnd";
        MyCustomEvent["OnBombHitTarget"] = "OnBombHitTarget";
        MyCustomEvent["OnBombHitShield"] = "OnBombHitShield";
        MyCustomEvent["OnBombHitDog"] = "OnBombHitDog";
        MyCustomEvent["ChangePet"] = "ChangePet";
        MyCustomEvent["UpdatePetStatus"] = "UpdatePetStatus";
        MyCustomEvent["StarFinished"] = "StarFinished";
        MyCustomEvent["OnSlotResult"] = "OnSlotResult";
        MyCustomEvent["ReadyChangeCoin"] = "ReadyChangeCoin";
        MyCustomEvent["ConsoleNewLog"] = "ConsoleNewLog";
        MyCustomEvent["OnTigerComeBack"] = "OnTigerComeBack";
        MyCustomEvent["NextVillage"] = "NextVillage";
        MyCustomEvent["WatchAdForChest"] = "WatchAdForChest";
        MyCustomEvent["CanChangeSpin"] = "CanChangeSpin";
        MyCustomEvent["BetChanged"] = "BetChanged";
        MyCustomEvent["BuildLevelUpOrFixOver"] = "BuildLevelUpOrFixOver";
        MyCustomEvent["NativeLogDetail"] = "NativeLogDetail";
        MyCustomEvent["SignInCollected"] = "SignInCollected";
      })(MyCustomEvent || (MyCustomEvent = exports('MyCustomEvent', {})));

      let BundleNames;

      (function (BundleNames) {
        BundleNames["rooms"] = "rooms";
        BundleNames["roomsLocal"] = "roomsLocal";
      })(BundleNames || (BundleNames = exports('BundleNames', {})));

      let VersionScheme;

      (function (VersionScheme) {
        VersionScheme["review"] = "review";
        VersionScheme["online"] = "online";
        VersionScheme["test"] = "test";
      })(VersionScheme || (VersionScheme = exports('VersionScheme', {})));

      let PetType;

      (function (PetType) {
        PetType["Pig"] = "Pig";
        PetType["Tiger"] = "Tiger";
        PetType["Dog"] = "Dog";
        PetType["Rabbit"] = "Rabbit";
      })(PetType || (PetType = exports('PetType', {})));

      const PetArr = exports('PetArr', [PetType.Pig, PetType.Tiger, PetType.Dog, PetType.Rabbit]);
      let PetAnimName;

      (function (PetAnimName) {
        PetAnimName["Idle"] = "Idle";
        PetAnimName["Run"] = "Run";
        PetAnimName["Attack"] = "Attack";
        PetAnimName["Jump"] = "Jump";
        PetAnimName["Eat"] = "Eat";
        PetAnimName["Walk"] = "Walk";
        PetAnimName["Sleep"] = "sleep";
        PetAnimName["Rest"] = "sleep2";
        PetAnimName["Rest2"] = "sleep3";
        PetAnimName["LevelUp"] = "level_up";
        PetAnimName["Fly"] = "fly";
      })(PetAnimName || (PetAnimName = exports('PetAnimName', {})));

      let PlayerAnimName;

      (function (PlayerAnimName) {
        PlayerAnimName["idle"] = "idle";
        PlayerAnimName["run"] = "run_2";
        PlayerAnimName["die"] = "die_2";
        PlayerAnimName["dead"] = "dead_2";
      })(PlayerAnimName || (PlayerAnimName = exports('PlayerAnimName', {})));

      let BoxAnimName;

      (function (BoxAnimName) {
        BoxAnimName["shake"] = "baoxiang_dou2";
        BoxAnimName["open"] = "baoxiang_kai2";
      })(BoxAnimName || (BoxAnimName = exports('BoxAnimName', {})));

      let HandAnimName;

      (function (HandAnimName) {
        HandAnimName["idle"] = "hand_idle";
        HandAnimName["attack"] = "hand_attack";
      })(HandAnimName || (HandAnimName = exports('HandAnimName', {})));

      let SlotTypes;

      (function (SlotTypes) {
        SlotTypes["Coin1"] = "coin1";
        SlotTypes["Coin2"] = "coin2";
        SlotTypes["Coin3"] = "coin3";
        SlotTypes["Coin4"] = "coin4";
        SlotTypes["Coin5"] = "coin5";
        SlotTypes["Coin6"] = "coin6";
        SlotTypes["Shield"] = "shield";
        SlotTypes["Attack"] = "attack";
        SlotTypes["Raid"] = "raid";
        SlotTypes["Spins"] = "spins";
        SlotTypes["Symbol"] = "symbol";
        SlotTypes["None"] = "none";
      })(SlotTypes || (SlotTypes = exports('SlotTypes', {})));

      let CameraLayers;

      (function (CameraLayers) {
        CameraLayers[CameraLayers["top"] = 16] = "top";
        CameraLayers[CameraLayers["slot3d"] = 32] = "slot3d";
        CameraLayers[CameraLayers["village3d"] = 64] = "village3d";
        CameraLayers[CameraLayers["interaction3d"] = 128] = "interaction3d";
        CameraLayers[CameraLayers["capture"] = 256] = "capture";
        CameraLayers[CameraLayers["pet3d"] = 512] = "pet3d";
        CameraLayers[CameraLayers["tutorial"] = 1024] = "tutorial";
        CameraLayers[CameraLayers["UI2D"] = 33554432] = "UI2D";
      })(CameraLayers || (CameraLayers = exports('CameraLayers', {})));

      let TutorilaEvent;

      (function (TutorilaEvent) {
        TutorilaEvent["BuildStarted"] = "BuildStarted";
        TutorilaEvent["BuildFinished"] = "buildFinished";
        TutorilaEvent["StarFinished"] = "StarFinished";
        TutorilaEvent["GoRoomStarted"] = "GoRoomStarted";
        TutorilaEvent["GoRoomFinished"] = "GoRoomFinished";
        TutorilaEvent["SpinStarted"] = "SpinStarted";
        TutorilaEvent["SpinFinished"] = "SpinFinished";
        TutorilaEvent["SpinRaidStarted"] = "SpinRaidStarted";
        TutorilaEvent["SpinRaidOnceFinished"] = "SpinRaidOnceFinished";
        TutorilaEvent["SpinRaidFinished"] = "SpinRaidFinished";
        TutorilaEvent["SpinAttackStarted"] = "SpinAttackStarted";
        TutorilaEvent["SpinAttackFinished"] = "SpinAttackFinished";
      })(TutorilaEvent || (TutorilaEvent = exports('TutorilaEvent', {})));

      Enum(CameraLayers);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardSetsMeta.ts", ['cc', './Content.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Content, i18n;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "e058fuSsaxPd5puwVnRx6ko", "CardSetsMeta", undefined);

      class CardSetsMeta {
        constructor() {
          _defineProperty(this, "_data", void 0);

          _defineProperty(this, "reward", void 0);
        }

        static MakeEntity(data) {
          let meta = new CardSetsMeta();
          meta.UpdateData(data);
          return meta;
        }

        UpdateData(data) {
          this._data = data;

          for (var key in data) {
            this._data[key] = data[key];
          }
        }

        Data() {
          return this._data;
        }

        Id() {
          return this._data.id;
        }

        Res() {
          return this._data.res;
        }

        Name() {
          return i18n.sel(this._data.name);
        }

        MinVillage() {
          return this._data.min_village;
        }

        Reward() {
          if (!this.reward) {
            this.reward = Content.FromStrings(this._data.reward);
            this.reward = Content.Merge(this.reward);
          }

          return this.reward;
        }

        SetIconIndex() {
          return this._data.setIcon_index;
        }

        Color() {
          return this._data.color;
        }

      }

      exports('CardSetsMeta', CardSetsMeta);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NetRequest.ts", ['cc', './Logs.ts', './wx_lib.ts', './LoadingWindow.ts', './LogEventWrap.ts', './encryptCode.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Logs, wxTools, LoadingWindow, LogEventWrap, encryptCode;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      wxTools = module.wxTools;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      encryptCode = module.encryptCode;
    }, function () {}],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "e0bebjpttNJmp0vM9CWhShH", "NetRequest", undefined);

      class NetRequest {
        constructor(server) {
          _defineProperty(this, "data", void 0);

          _defineProperty(this, "callbacks", void 0);

          _defineProperty(this, "errorCallbacks", void 0);

          _defineProperty(this, "url", void 0);

          _defineProperty(this, "useEncrypt", void 0);

          _defineProperty(this, "silence", void 0);

          _defineProperty(this, "req", void 0);

          this.data = {
            method: null
          };
          this.callbacks = [];
          this.errorCallbacks = [];
          this.url = server;
          this.useEncrypt = true;
        }

        SetRequestBody(key, body) {
          this.data[key] = body;
        }

        SetCallBack(func) {
          this.callbacks.push(func);
        }

        ClearCallBack() {
          this.callbacks = [];
        }

        SetErrorCallBack(func) {
          this.errorCallbacks.push(func);
        }

        SetSilence(bo) {
          this.silence = bo;
        }

        SetEncrypt(n) {
          this.useEncrypt = n;
        }

        Send() {
          Logs.Debug("NetRequest req:", this);
          if (!this.silence) LoadingWindow.Show();

          if (wxTools.usewx) {
            wx.request({
              url: this.url,
              data: this.useEncrypt ? JSON.stringify({
                arr: encryptCode.stringToBytes(encryptCode.simplecode(pako.gzip(JSON.stringify(this.data), {
                  to: "string"
                })))
              }) : this.data,
              header: {
                ["Content-Type"]: this.useEncrypt ? "application/json" : "application/json"
              },
              method: "POST",
              dataType: "json",
              responseType: "arraybuffer",
              success: res => {
                if (!this.silence) LoadingWindow.Hide();
                this.okCallback(this.useEncrypt ? JSON.parse(pako.ungzip(encryptCode.simplecode(encryptCode.arrayBufferToString(res.data)), {
                  to: "string"
                })) : res.data);
              },
              fail: res => {
                if (!this.silence) LoadingWindow.Hide();
                this.errorCallbacks.forEach(function (x) {
                  if (x != null) x(res);
                });
              }
            });
          } else {
            this.req = new XMLHttpRequest();
            this.req.responseType = this.useEncrypt ? "arraybuffer" : "json";
            this.req.open('POST', this.url, true);
            this.req.setRequestHeader("Content-Type", this.useEncrypt ? "application/json" : "application/json");

            this.req.onload = e => {
              e = e || {
                msg: "unknown"
              };
              if (!this.silence) LoadingWindow.Hide();

              if (this.req.readyState == 4 && this.req.status >= 200 && this.req.status < 400) {
                let res = this.useEncrypt ? JSON.parse(pako.ungzip(encryptCode.simplecode(encryptCode.arrayBufferToString(this.req.response)), {
                  to: "string"
                })) : this.req.response;
                this.okCallback(res);
              } else {
                this.errorCallbacks.forEach(function (x) {
                  if (x != null) x(e);
                });
                LogEventWrap.logEvent("http_net_fail", {
                  url: this.url,
                  body: JSON.stringify(this.data),
                  header: this.req.getAllResponseHeaders(),
                  readyState: this.req.readyState,
                  code: this.req.status
                });
              }
            };

            this.req.ontimeout = e => {
              if (!this.silence) LoadingWindow.Hide();
              this.errorCallbacks.forEach(function (x) {
                if (x != null) x(e);
              });
              LogEventWrap.logEvent("http_net_fail", {
                url: this.url,
                body: JSON.stringify(this.data),
                code: 0,
                msg: "ontimeout"
              });
            };

            this.req.onerror = e => {
              e = e || {
                code: -1,
                msg: "unknown"
              };
              if (!this.silence) LoadingWindow.Hide();
              this.errorCallbacks.forEach(function (x) {
                if (x != null) x(e);
              });
              LogEventWrap.logEvent("http_net_fail", {
                url: this.url,
                body: JSON.stringify(this.data),
                header: this.req.getAllResponseHeaders(),
                code: e.code || -1,
                msg: "onerror" + e.toString()
              });
            };

            this.req.send(this.useEncrypt ? JSON.stringify({
              arr: encryptCode.stringToBytes(encryptCode.simplecode(pako.gzip(JSON.stringify(this.data), {
                to: "string"
              })))
            }) : JSON.stringify(this.data));
          }
        }

        okCallback(res) {
          this.callbacks.forEach(function (x) {
            if (x != null) x(res);
          });
          return true;
        }

      }

      exports('default', NetRequest);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DownloadRequest.ts", ['cc', './Logs.ts', './LoadingWindow.ts', './LogEventWrap.ts', './base64.ts', './encryptCode.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Logs, LoadingWindow, LogEventWrap, Base64, encryptCode;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      LoadingWindow = module.LoadingWindow;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      Base64 = module.Base64;
    }, function (module) {
      encryptCode = module.encryptCode;
    }, function () {}],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "e1a7bO1E6JBg43p8MgTe8qa", "DownloadRequest", undefined);

      class DownloadRequest {
        constructor(server) {
          _defineProperty(this, "callbacks", void 0);

          _defineProperty(this, "errorCallbacks", void 0);

          _defineProperty(this, "url", void 0);

          _defineProperty(this, "useEncrypt", void 0);

          _defineProperty(this, "req", void 0);

          this.callbacks = [];
          this.errorCallbacks = [];
          this.url = server;
          this.useEncrypt = false;
        }

        SetCallBack(func) {
          this.callbacks.push(func);
        }

        SetErrorCallBack(func) {
          this.errorCallbacks.push(func);
        }

        SetEncrypt(n) {
          this.useEncrypt = n;
        }

        Send() {
          Logs.Debug("DownloadRequest req:", this);
          this.req = new XMLHttpRequest();
          this.req.open('GET', this.url, true);

          this.req.onload = function (e) {
            e = e || {
              msg: "unknown"
            };

            if (this.req.readyState == 4 && this.req.status >= 200 && this.req.status < 400) {
              this.okCallback(this.useEncrypt ? encryptCode.simplecode(Base64.decode(this.req.response)) : this.req.response);
            } else {
              this.errorCallbacks.forEach(function (x) {
                if (x != null) x(e);
              });
              LogEventWrap.logEvent("http_net_fail", {
                url: this.url,
                body: JSON.stringify(this.data),
                header: this.req.getAllResponseHeaders(),
                readyState: this.req.readyState,
                code: this.req.status
              });
            }
          }.bind(this);

          this.req.ontimeout = function (e) {
            if (!this.silence) LoadingWindow.Hide();
            this.errorCallbacks.forEach(function (x) {
              if (x != null) x(e);
            });
            LogEventWrap.logEvent("http_net_fail", {
              url: this.url,
              body: JSON.stringify(this.data),
              code: 0,
              msg: "ontimeout"
            });
          }.bind(this);

          this.req.onerror = function (e) {
            e = e || {
              code: -1,
              msg: "unknown"
            };
            if (!this.silence) LoadingWindow.Hide();
            this.errorCallbacks.forEach(function (x) {
              if (x != null) x(e);
            });
            LogEventWrap.logEvent("http_net_fail", {
              url: this.url,
              body: JSON.stringify(this.data),
              header: this.req.getAllResponseHeaders(),
              code: e.code || -1,
              msg: "onerror" + e.toString()
            });
          }.bind(this);

          this.req.send();
        }

        okCallback(res) {
          console.log("callback");
          this.callbacks.forEach(function (x) {
            if (x != null) x(res);
          });
          return true;
        }

      }

      exports('default', DownloadRequest);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameCoinhitInfoWindow.ts", ['cc', './UIWindow.ts', './MinigameCoinhitMainWindow.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Node, CCBoolean, _decorator, instantiate, Sprite, Label, UIWindow, MinigameCoinhitMainWindow, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Node = module.Node;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      Sprite = module.Sprite;
      Label = module.Label;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      MinigameCoinhitMainWindow = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e2591XaCaRAO6AY9hl2DwRY", "MinigameCoinhitInfoWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      let MinigameCoinhitInfoWindow = exports('default', (_dec = property(SpriteFrame), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(CCBoolean), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameCoinhitInfoWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "icon_list", _descriptor, this);

          _initializerDefineProperty(this, "item_parent", _descriptor2, this);

          _initializerDefineProperty(this, "item", _descriptor3, this);

          _initializerDefineProperty(this, "item_list", _descriptor4, this);
        }

        onShow() {
          this.update_item_list();
        }
        /** @type {cc.SpriteFrame[]} 奖励icon列表 */


        get preview() {
          return false;
        }

        set preview(v) {
          CC_EDITOR && this.create_item_list();
        }

        create_item_list() {
          this.item_parent.destroyAllChildren();
          this.item_list = [];

          for (let i = 0; i < this.icon_list.length; i += 1) {
            let n = instantiate(this.item);
            n.parent = this.item_parent;
            n.active = true;
            let sp_icon = GameKit.ControllerTable.GetNode(n, "sp-reward-icon").getComponent(Sprite);
            sp_icon.spriteFrame = this.icon_list[i];
            this.item_list.push(n);
          }
        }

        update_item_list() {
          for (let i = 0; i < this.item_list.length; i += 1) {
            let reward = MinigameCoinhitMainWindow.ins.data.get_reward(i);
            let n = this.item_list[i];
            let label_coin = GameKit.ControllerTable.GetNode(n, "label-reward-coin").getComponent(Label);
            label_coin.string = reward[0];
            label_coin.node.active = reward[0] > 0;
            let label_spin = GameKit.ControllerTable.GetNode(n, "label-reward-spin").getComponent(Label);
            label_spin.string = reward[1];
            label_spin.node.active = reward[1] > 0;
          }
        }

        event_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Activity/minigame/coinhit/MinigameCoinhitInfoWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "icon_list", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "item_parent", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "item_list", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "preview", [_dec5], Object.getOwnPropertyDescriptor(_class2.prototype, "preview"), _class2.prototype)), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AutoSize.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Component, UITransform, size, Size, Vec2, _decorator;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Component = module.Component;
      UITransform = module.UITransform;
      size = module.size;
      Size = module.Size;
      Vec2 = module.Vec2;
      _decorator = module._decorator;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "e286dRCg0hMoIi2SzOYOwWW", "AutoSize", undefined);

      const {
        ccclass,
        property,
        executeInEditMode,
        menu
      } = _decorator;
      let AutoSize = exports('default', (_dec = ccclass("AutoSize"), _dec(_class = executeInEditMode(_class = class AutoSize extends Component {
        onLoad() {
          const child = this.node.children[0];
          const childContentSize = child.getComponent(UITransform).contentSize;
          const childScale = size(child.scale.x, child.scale.y);
          const nodeSize = new Size();
          Vec2.multiply(nodeSize, childContentSize, childScale);
          this.node.getComponent(UITransform).setContentSize(nodeSize);
        }

      }) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CurrencyCodeInfo.ts", ['cc'], function () {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      /**
       * 注意：已把原脚本注释，由于脚本变动过大，转换的时候可能有遗落，需要自行手动转换
       */
      cclegacy._RF.push({}, "e2cfdhXYtpKm4ndZUFfB30J", "CurrencyCodeInfo", undefined);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AutomaticDoor.ts", ['cc', './SoundManager.ts'], function (exports) {
  'use strict';

  var cclegacy, Enum, _decorator, Component, Tween, tween, SoundManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
      _decorator = module._decorator;
      Component = module.Component;
      Tween = module.Tween;
      tween = module.tween;
    }, function (module) {
      SoundManager = module.SoundManager;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e339aVfN6JCj4NoB7jWXJhq", "AutomaticDoor", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let DoorDirection = Enum({
        left: 0,
        right: 1
      });
      let AutomaticDoor = exports('default', (_dec = ccclass("AutomaticDoor"), _dec2 = property({
        type: Enum(DoorDirection)
      }), _dec(_class = (_class2 = (_temp = _class3 = class AutomaticDoor extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "direction", _descriptor, this);

          _initializerDefineProperty(this, "moveDistance", _descriptor2, this);

          _initializerDefineProperty(this, "alarmDistance", _descriptor3, this);

          _initializerDefineProperty(this, "moveTime", _descriptor4, this);

          _defineProperty(this, "target", void 0);

          _defineProperty(this, "initialPosition", void 0);

          _defineProperty(this, "lastDistance", Infinity);
        }

        onLoad() {
          this.initialPosition = this.node.position.clone();
        }

        setTarget(target) {
          this.target = target;
        }

        update() {
          if (!this.target) return;
          let distance = Math.abs(this.node.getWorldPosition().z - this.target.getWorldPosition().z);

          if (this.lastDistance > this.alarmDistance && distance < this.alarmDistance) {
            // console.log("enter");
            this.onPlayerEnter();
          }

          if (this.lastDistance < this.alarmDistance && distance > this.alarmDistance) {
            // console.log("exit");
            this.onPlayerExit();
          }

          this.lastDistance = distance;
        }

        onPlayerEnter() {
          SoundManager.playSound("doorOpen");
          this.moveDistance = 6;
          Tween.stopAllByTarget(this.node);
          let endPos = this.direction == DoorDirection.left ? this.initialPosition.clone().add3f(-this.moveDistance, 0, 0) : this.initialPosition.clone().add3f(this.moveDistance, 0, 0);
          tween(this.node).to(this.moveTime, {
            position: endPos
          }, {
            easing: 'sineOut'
          }).start();
        }

        onPlayerExit() {
          // SoundManager.playSound("door");
          Tween.stopAllByTarget(this.node); // let endZ = this.direction == DoorDirection.left ? this.initialPosition : this.initialPosition;

          tween(this.node).to(this.moveTime, {
            position: this.initialPosition
          }, {
            easing: 'sineOut'
          }).start();
        }

      }, _defineProperty(_class3, "AutoDoors", []), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "direction", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return DoorDirection.left;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "moveDistance", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 3;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "alarmDistance", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 3;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "moveTime", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0.25;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonCommonAsset.ts", ['cc', './CCE_Component.ts', './global.ts'], function (exports) {
  'use strict';

  var cclegacy, Prefab, SpriteFrame, _decorator, CCE_Component, G;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Prefab = module.Prefab;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      G = module.G;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e4315s6tWVPdKORHogRMRxh", "CannonCommonAsset", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      /** cannon活动下的通用资源 */

      let CannonCommomAsset = exports('default', (_dec = property({
        tooltip: "宝箱的prefab数组",
        type: Prefab
      }), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(SpriteFrame), ccclass(_class = (_class2 = (_temp = _class3 = class CannonCommomAsset extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "box_prefab_list", _descriptor, this);

          _initializerDefineProperty(this, "item_spf_list", _descriptor2, this);

          _initializerDefineProperty(this, "item_shadow_spf_list", _descriptor3, this);

          _initializerDefineProperty(this, "item_big_spf_list", _descriptor4, this);
        }

        onLoad() {
          CannonCommomAsset.ins = this;
        }

        onDestroy() {
          CannonCommomAsset.ins = null;
        }
        /**
         * 获取随机的宝箱spf
         * @returns {cc.Prefab}
         */


        get_random_box_prefab() {
          return this.box_prefab_list[G.getRandomInt(0, this.box_prefab_list.length)];
        }
        /** @type {cc.SpriteFrame[]} */

        /**
         * @param {number} index
         * @returns {cc.SpriteFrame}
         */


        get_item_spf(index) {
          return this.item_spf_list[index];
        }
        /** @type {cc.SpriteFrame[]} */

        /**
         * @param {number} index
         * @returns {cc.SpriteFrame}
         */


        get_item_shadow_spf(index) {
          return this.item_shadow_spf_list[index];
        }
        /** @type {cc.SpriteFrame[]} */

        /**
         * @param {number} index
         * @returns {cc.SpriteFrame}
         */


        get_item_big_spf(index) {
          return this.item_big_spf_list[index];
        }

      }, _defineProperty(_class3, "ins", void 0), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "box_prefab_list", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "item_spf_list", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "item_shadow_spf_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "item_big_spf_list", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LabelLocalized.ts", ['cc', './CCE_Component.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, CCBoolean, _decorator, Label, RichText, CCE_Component, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      Label = module.Label;
      RichText = module.RichText;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e4f88adp3hERoJ48DZ2PSAl", "LabelLocalized", undefined);

      const {
        ccclass,
        property,
        executeInEditMode,
        menu
      } = _decorator;
      let LabelLocalized = exports('default', (_dec = menu("GameKit/ui/LabelLocalized"), _dec2 = property({
        multiline: true,
        tooltip: 'Enter i18n key here'
      }), _dec3 = property(CCBoolean), ccclass(_class = _dec(_class = executeInEditMode(_class = (_class2 = (_temp = class LabelLocalized extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "__textKey", _descriptor, this);

          _initializerDefineProperty(this, "isBold", _descriptor2, this);
        }

        set textKey(text) {
          this.__textKey = text;
          this.onLoad();
        }

        get textKey() {
          return this.__textKey;
        }

        onLoad() {
          let label = null;
          label = this.getComponent(Label);

          if (label != null) {
            label.string = i18n.t(this.textKey);
            label.cacheMode = Label["CacheMode"].BITMAP;
          }

          label = this.getComponent(RichText);

          if (label != null) {
            label.string = i18n.t(this.textKey);
            if (this.isBold) label.string = '<b>' + label.string + '</b>';
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "__textKey", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "TEXT_KEY";
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "textKey", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "textKey"), _class2.prototype), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "isBold", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageShopWindow.ts", ['cc', './UIWindow.ts', './Content.ts', './VillageShopItem.ts', './ActivityManager.ts', './StaticGame.ts', './GameKit.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Label, ProgressBar, UIWindow, Content, VillageShopItem, ActivityManager, Meta, Game, GameKit, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Label = module.Label;
      ProgressBar = module.ProgressBar;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      VillageShopItem = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e5c3bjLwkxBsIEa72SibAQp", "VillageShopWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let VillageShopWindow = exports('default', (_dec = property(Node), _dec2 = property([Node]), _dec3 = property([Node]), _dec4 = property(Node), _dec5 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class VillageShopWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "itemPre", _descriptor, this);

          _initializerDefineProperty(this, "sps", _descriptor2, this);

          _initializerDefineProperty(this, "spitems", _descriptor3, this);

          _initializerDefineProperty(this, "btnClose", _descriptor4, this);

          _initializerDefineProperty(this, "buildKingNode", _descriptor5, this);

          _defineProperty(this, "items", void 0);

          _defineProperty(this, "activityTime", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);
        }

        onShow(showParams) {
          let selectType = showParams.selectType;
          this.itemPre.active = false;
          this.items = {};

          for (let i = 0; i < 5; i++) {
            //let newItem = cc.instantiate(this.itemPre)
            //newItem.parent = this.sps[i]
            //newItem.x=0,newItem.y=0
            //newItem.active = true
            let newItem = this.spitems[i];
            let item = newItem.getComponent(VillageShopItem);
            let type = i + 1;
            this.items[type] = item;
            item.updatePanel(this, type, type === selectType);
          }

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            this.btnClose.active = false;
          }

          this.showBuildKing();
        }

        onClose() {}

        slowUpdate(dt) {
          this.updateActivityTime(dt);
        }

        callClose() {
          this.closeAnim();
        }

        enableButton(type) {
          this.items[type].enableButton();
        }

        showBuildKing() {
          this.buildKingNode.active = false;

          if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
            return;
          }

          let activityMeta = ActivityManager.GetActiveGameActivityByType(Meta.ActivityMeta.SubTypes.BuildMaster);

          if (activityMeta) {
            this.buildKingNode.active = true;
            let count = GameKit.ControllerTable.GetComponent(this.buildKingNode, "count", Label);
            let progress = GameKit.ControllerTable.GetComponent(this.buildKingNode, "progress", ProgressBar);
            let content1 = GameKit.ControllerTable.GetComponent(this.buildKingNode, "content1", "ContentModel");
            let content2 = GameKit.ControllerTable.GetComponent(this.buildKingNode, "content2", "ContentModel");
            this.activityTime = activityMeta.EndTime() - GameKit.TimeUtil.getCurrentTime();
            count.string = Game.SUserVillage.Score().toString() + " / " + Meta.VillageShopMeta.GetMaxStar(Game.SUserVillage.MapId());
            progress.progress = Game.SUserVillage.Score() / Meta.VillageShopMeta.GetMaxStar(Game.SUserVillage.MapId());
            let rewards = Content.FromStrings(Meta.ActivityParamsMeta.GetValue(Meta.ActivityParamsMeta.Types.BuildMaster, Game.SUserVillage.MapId() + 1));
            rewards = Content.Merge(rewards);
            content1.show(rewards[0]);
            content2.show(rewards[1]);
          }
        }

        updateActivityTime(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;

          if (this.activityTime) {
            this.activityTime -= dt;
            let time = GameKit.ControllerTable.GetComponent(this.buildKingNode, "time", Label);
            time.string = GameKit.TimeUtil.FormatRemainTimeSimple(this.activityTime, false);
          }
        }

      }, _defineProperty(_class3, "windowPath", "Village/VillageShopWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "itemPre", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sps", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spitems", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btnClose", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "buildKingNode", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ServantNode.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, sp, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      sp = module.sp;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e875exfRihMkZucq6dng5Io", "ServantNode", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ServantNode = exports('default', (_dec = property(sp.Skeleton), _dec2 = property("idle"), _dec3 = property("eat"), _dec4 = property("level_up"), _dec5 = property("effect"), _dec6 = property("sleep"), _dec7 = property("wake"), _dec8 = property("fall_sleep"), ccclass(_class = (_class2 = (_temp = class ServantNode extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "ske", _descriptor, this);

          _initializerDefineProperty(this, "nameIdle", _descriptor2, this);

          _initializerDefineProperty(this, "nameEat", _descriptor3, this);

          _initializerDefineProperty(this, "nameLevelUp", _descriptor4, this);

          _initializerDefineProperty(this, "nameEffect", _descriptor5, this);

          _initializerDefineProperty(this, "nameSleep", _descriptor6, this);

          _initializerDefineProperty(this, "nameWake", _descriptor7, this);

          _initializerDefineProperty(this, "nameFallSleep", _descriptor8, this);
        }

        start() {} // Anim


        playIdle() {
          this.ske.setAnimation(0, this.nameIdle, true);
        }

        playSleep() {
          this.ske.setAnimation(0, this.nameSleep, true);
        } // Wake/Sleep


        playWake() {
          this.ske.setAnimation(0, this.nameWake, false);
          this.ske.addAnimation(0, this.nameIdle, true);
        }

        playFallSleep() {
          this.ske.setAnimation(0, this.nameFallSleep, false);
          this.ske.addAnimation(0, this.nameSleep, true);
        } // Eat


        playEat() {
          this.ske.setAnimation(0, this.nameEat, false);
          this.ske.addAnimation(0, this.nameIdle, true);
        }

        playEatWake() {
          this.ske.setAnimation(0, this.nameWake, false);
          this.ske.addAnimation(0, this.nameEat, false);
          this.ske.addAnimation(0, this.nameIdle, true);
        }

        playEat_inSleep() {
          this.ske.setAnimation(0, this.nameWake, false);
          this.ske.addAnimation(0, this.nameEat, false);
          this.ske.addAnimation(0, this.nameFallSleep, false);
          this.ske.addAnimation(0, this.nameSleep, true);
        } // Level Up


        playLevelUp() {
          this.ske.setAnimation(0, this.nameLevelUp, false);
          this.ske.addAnimation(0, this.nameIdle, true);
        }

        playLevelUp_inSleep() {
          this.ske.setAnimation(0, this.nameWake, false);
          this.ske.addAnimation(0, this.nameLevelUp, false);
          this.ske.addAnimation(0, this.nameFallSleep, false);
          this.ske.addAnimation(0, this.nameSleep, true);
        }

        playEffect() {
          this.ske.setAnimation(0, this.nameEffect, true);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ske", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "nameIdle", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "nameEat", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "nameLevelUp", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "nameEffect", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "nameSleep", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "nameWake", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "nameFallSleep", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardAskSendWindow.ts", ['cc', './UIWindow.ts', './CardModel.ts', './CardNewFriendsWindow.ts', './UIRoot.ts', './StaticGame.ts', './ShareWrap.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Button, Label, _decorator, Sprite, UIWindow, CardModel, CardNewFriendsWindow, UIRoot, Game, ShareWrap, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Button = module.Button;
      Label = module.Label;
      _decorator = module._decorator;
      Sprite = module.Sprite;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      CardNewFriendsWindow = module.CardNewFriendsWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      ShareWrap = module.ShareWrap;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e8768ta21dG/qAuSrB4IUon", "CardAskSendWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      let CardAskSendWindow = exports('default', (_dec = property(SpriteFrame), _dec2 = property(CardModel), _dec3 = property(Button), _dec4 = property(Button), _dec5 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class CardAskSendWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "card_meta", null);

          _initializerDefineProperty(this, "sfGray", _descriptor, this);

          _initializerDefineProperty(this, "card", _descriptor2, this);

          _initializerDefineProperty(this, "btn_ask", _descriptor3, this);

          _initializerDefineProperty(this, "btn_send", _descriptor4, this);

          _initializerDefineProperty(this, "label_cannot_reason", _descriptor5, this);
        }

        onShow(showParams) {
          // 获取数据
          this.card_meta = showParams.card_meta; // 更新样式

          this.card.show(this.card_meta.Id());
          this.btn_ask.node.active = Game.SUserCard.CardNum(this.card_meta.Id()) <= 0;
          this.btn_send.node.active = Game.SUserCard.CardNum(this.card_meta.Id()) > 0;
          let enableBtn = true;

          if (this.btn_send.node.active) {
            if (this.card_meta.CantSend()) {
              this.label_cannot_reason.string = i18n.t("CardSendCannot");

              if (this.card_meta.Golden()) {
                this.label_cannot_reason.string = i18n.t("CardSendCannotGolden");
              }

              enableBtn = false;
            }

            if (!Game.SUserCard.CheckDailyLimit()) {
              this.label_cannot_reason.string = i18n.t("CardSendCannotLimit");
              enableBtn = false;
            }

            if (Game.SUserCard.CardNum(this.card_meta.Id()) <= 1) {
              this.label_cannot_reason.string = i18n.t("CardSendCannotLeast");
              enableBtn = false;
            }

            if (!enableBtn) {
              this.btn_send.getComponent(Sprite).spriteFrame = this.sfGray;
              this.btn_send.interactable = false;
              this.label_cannot_reason.node.active = true;
            }
          } else {
            if (this.card_meta.CantSend()) {
              this.btn_ask.getComponent(Sprite).spriteFrame = this.sfGray;
              this.btn_ask.interactable = false;
              this.label_cannot_reason.node.active = true;
              this.label_cannot_reason.string = i18n.t("CardAskCannot");

              if (this.card_meta.Golden()) {
                this.label_cannot_reason.string = i18n.t("CardAskCannotGolden");
              }
            }
          }
        }

        onClose() {
          this.card.onClose();
        }
        /** @type {CardModel} */


        event_close() {
          this.closeAnim();
        }

        event_ask() {
          this.closeAnim(); // AppKit.ShareWrap.shareScreen(i18n.t("ShareJigsawTitle"), { x: 0, y: 0, width: 640, height: 1136 }, {}, null, "cardask", false, null, this.node);

          ShareWrap.share(i18n.t("ShareJigsawTitle"), "share/share1", {
            intent: "SHARE",
            type: "cardask"
          }, null, "cardask");
        }

        event_send() {
          this.closeAnim();
          UIRoot.instance.openChildWindow(CardNewFriendsWindow, {
            cardMeta: this.card_meta
          });
        }

      }, _defineProperty(_class3, "windowPath", "Card/CardAskSendWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sfGray", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "card", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "btn_ask", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btn_send", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "label_cannot_reason", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Container3d.ts", ['cc', './Constant.ts', './ShakeCamera.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, _decorator, Component, assetManager, Camera, Layers, view, RenderTexture, UITransform, SpriteFrame, DirectionalLight, Vec3, CameraLayers, Constant, ShakeCamera;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      _decorator = module._decorator;
      Component = module.Component;
      assetManager = module.assetManager;
      Camera = module.Camera;
      Layers = module.Layers;
      view = module.view;
      RenderTexture = module.RenderTexture;
      UITransform = module.UITransform;
      SpriteFrame = module.SpriteFrame;
      DirectionalLight = module.DirectionalLight;
      Vec3 = module.Vec3;
    }, function (module) {
      CameraLayers = module.CameraLayers;
      Constant = module.Constant;
    }, function (module) {
      ShakeCamera = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e88deqCZwFDaLoN+Gtn02L/", "Container3d", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Container3d = exports('default', (_dec = ccclass("Container3d"), _dec2 = property({
        type: CameraLayers
      }), _dec3 = property(Sprite), _dec(_class = (_class2 = (_temp = _class3 = class Container3d extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "layer", _descriptor, this);

          _initializerDefineProperty(this, "sprCamera", _descriptor2, this);

          _defineProperty(this, "renderTex", null);

          _defineProperty(this, "camera", void 0);

          _defineProperty(this, "directionLight", void 0);

          _defineProperty(this, "globalConfig", void 0);

          _defineProperty(this, "newChild", void 0);
        }
        /**因为destroyChildren方法会延迟到当前帧渲染结束前才执行，所以要传入newChild */


        init(newChild, globalConfig) {
          this.newChild = newChild;
          globalConfig && (this.globalConfig = globalConfig);
          this.initCamera();
          this.initLight();
          this.initChildrenLayer();
          this.initPosition();
        }

        onDestroy() {
          assetManager.releaseAsset(this.renderTex);
        }

        reset() {
          this.camera && (this.camera.targetTexture = null);
          this.camera = null;
          this.renderTex = null;
          this.sprCamera.spriteFrame = null;
          this.directionLight = null;
          this.globalConfig = null;
          this.newChild = null;
        }

        shake() {
          let com = this.camera.getOrAddComponent(ShakeCamera);
          com && (com.enabled = true);
          {
            jsb["device"]["vibrate"](0.2);
          }
        }

        initCamera() {
          this.camera = this.newChild.getComponentInChildren(Camera); //影子在DEFAULT层

          let defaultLayer = Layers.BitMask.DEFAULT;
          this.camera.visibility = this.layer + defaultLayer;
          let width = view.getVisibleSize().width + 50;
          let height = view.getVisibleSize().height;
          const screenPixelRatio = Constant.useDeviceRatio ? view.getDevicePixelRatio() : 1;
          this.renderTex && assetManager.releaseAsset(this.renderTex);
          this.renderTex = new RenderTexture(); // this.renderTex = Container3d.getOneRenderTexture();

          this.renderTex.reset({
            width: width * screenPixelRatio,
            height: height * screenPixelRatio // colorFormat: RenderTexture.PixelFormat.RGBA8888,
            // depthStencilFormat: RenderTexture.DepthStencilFormat.DEPTH_24_STENCIL_8

          });

          if (this.renderTex && this.sprCamera) {
            this.sprCamera.getComponent(UITransform).width = width;
            this.sprCamera.getComponent(UITransform).height = height;
            const sp = new SpriteFrame();
            this.camera.targetTexture = this.renderTex;
            sp.texture = this.renderTex;
            this.sprCamera.spriteFrame = sp;
          }
        }

        initLight() {
          this.directionLight = this.newChild.getComponentInChildren(DirectionalLight);
          this.directionLight.node.active = false;
        }

        initChildrenLayer() {
          let flattedNodes = this.newChild.getFlattedChildrenRecursively();
          flattedNodes.forEach(v => v.layer = this.layer);
        }

        initPosition() {
          this.node.setWorldPosition(Vec3.ZERO);
        }

      }, _defineProperty(_class3, "renderTexturePool", []), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "layer", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return CameraLayers.village3d;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sprCamera", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/villageTextureLoader.ts", ['cc', './ResourceTextureLoader.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, ResourceTextureLoader;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      ResourceTextureLoader = module.default;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "e8cf0fWhvNPAZwj6tM1GbIY", "villageTextureLoader", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let villageTextureLoader = exports('default', (_dec = property(""), ccclass(_class = (_class2 = (_temp = class villageTextureLoader extends ResourceTextureLoader {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "village", _descriptor, this);
        }

        onEnable() {
          this.vload();
        }

        vload() {
          this.path = "res/village/" + this.village + "/res/" + this.node.name;
          this.load();
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "village", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/UIWindow.ts", ['cc', './CCE_Component.ts', './EnterCloseAnim.ts', './BackKeyManager.ts', './PlayAudio.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, CCE_Component, EnterCloseAnim, BackKeyManager, PlayAudio;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      BackKeyManager = module.BackKeyManager;
    }, function (module) {
      PlayAudio = module.default;
    }],
    execute: function () {
      var _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ea30bB6NXhLYJM4x1k11NM/", "UIWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let UIWindow = exports('default', ccclass(_class = (_class2 = (_temp = _class3 = class UIWindow extends CCE_Component {
        constructor() {
          super();

          _initializerDefineProperty(this, "_windowName", _descriptor, this);

          _defineProperty(this, "childWindows", void 0);

          _defineProperty(this, "isChild", void 0);

          _defineProperty(this, "parentWindow", void 0);

          _defineProperty(this, "closeFuncs", void 0);

          _defineProperty(this, "onHide", void 0);

          _defineProperty(this, "closing", void 0);

          this.childWindows = [];
          this.isChild = false;
          this.parentWindow = null;
          this.closeFuncs = [];
        } //第一次显示时调用


        onShow(showParams) {} //隐藏后又显示时调用 或者已经有一个又显示时调用


        onShowBack(showParams) {} //关闭时调用


        onClose() {}

        show(showParams) {
          if (this.node != null) this.node.active = true;
          if (this.onShowBack != null) this.onShowBack(showParams);
        }

        hide() {
          if (this.node != null) this.node.active = false;
          if (this.onHide != null) this.onHide();
        } //关闭窗口


        close() {
          if (!this.node) return;
          if (this.onClose != null) this.onClose();

          for (let i = this.childWindows.length - 1; i >= 0; i--) {
            let x = this.childWindows[i];
            if (x) x.close();
          }

          let closeFuncs = this.closeFuncs;

          this._onWindowClose();

          this.node.removeFromParent();
          this.node.destroy();

          for (let i = closeFuncs.length - 1; i >= 0; i--) {
            let x = closeFuncs[i];
            if (x != null) x();
          }
        } //关闭所有子窗口


        closeAllChildren() {
          let childWindows = this.childWindows;

          for (let i = childWindows.length - 1; i >= 0; i--) {
            let x = childWindows[i];
            x.closeAnim();
          }
        }

        _onAddChildWindow(wnd) {
          this.childWindows.push(wnd);
        }

        _onRemoveChildWindow(wnd) {
          this.childWindows.splice(this.childWindows.indexOf(wnd), 1);
        }

        GetChildWindows() {
          return this.childWindows;
        }

        _onWindowShow(showParams) {
          if (this.isChild) {
            BackKeyManager.registerBackEvent(() => {
              PlayAudio.playClose();
              this.closeAnim();
            });
          } else if (showParams.isFirst !== false) {
            BackKeyManager.registerBackEvent();
          }

          if (this.onShow != null) this.onShow(showParams);
        }

        _onWindowClose() {
          BackKeyManager.unregisterBackEvent();
          globalThis.uiRoot.windowInstance[this._windowName] = null;

          if (this.isChild && this.parentWindow != null && this.parentWindow.isValid) {
            this.parentWindow._onRemoveChildWindow(this);
          }
        } //添加窗口关闭回调


        addOnCloseFunc(func) {
          this.closeFuncs.push(func);
        }

        clearOnCloseFunc() {
          this.closeFuncs = [];
        }

        closeAnim(callback) {
          if (!this.node) return;
          if (this.closing) return;
          this.closing = true;
          let anims = this.getComponentsInChildren(EnterCloseAnim);
          globalThis.uiRoot.ShowCantClick(true);

          for (let i = 0; i < anims.length; i++) {
            if (i === 0) anims[i].closeAnim(function () {
              this.close();
              globalThis.uiRoot.CloseCantClick();
              if (callback != null) callback();
            }.bind(this));else anims[i].closeAnim();
          }

          if (anims.length <= 0) {
            this.close();
            globalThis.uiRoot.CloseCantClick();
            if (callback != null) callback();
          }
        }

      }, _defineProperty(_class3, "windowPath", void 0), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "_windowName", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return "";
        }
      }), _class2)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardSingleSetWindow.ts", ['cc', './UIWindow.ts', './Content.ts', './CardModel.ts', './CardAskSendWindow.ts', './CardItem.ts', './SR.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, SpriteFrame, Sprite, Label, _decorator, Color, instantiate, UITransform, Button, UIWindow, Content, CardModel, CardAskSendWindow, CardItem, SR, UIRoot, Meta, Game, LogEventWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      SpriteFrame = module.SpriteFrame;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
      Color = module.Color;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
      Button = module.Button;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      CardAskSendWindow = module.default;
    }, function (module) {
      CardItem = module.CardItem;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ea8f3nZuc9EArP16eyIZNjj", "CardSingleSetWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow

      /**
       * 单个卡片集合中的9张卡片列表界面
       */

      let CardSingleSetWindow = exports('default', (_dec = property(Node), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(Node), _dec5 = property(SpriteFrame), _dec6 = property(Sprite), _dec7 = property(Label), _dec8 = property(Node), _dec9 = property(Label), _dec10 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class CardSingleSetWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "single_set_meta", void 0);

          _defineProperty(this, "card_meta_list", []);

          _defineProperty(this, "card_list", []);

          _defineProperty(this, "max_set_id", void 0);

          _initializerDefineProperty(this, "rewardItem", _descriptor, this);

          _initializerDefineProperty(this, "sfSpin", _descriptor2, this);

          _initializerDefineProperty(this, "sfItem", _descriptor3, this);

          _initializerDefineProperty(this, "rewardLayout", _descriptor4, this);

          _initializerDefineProperty(this, "defaultSetTitlebg", _descriptor5, this);

          _initializerDefineProperty(this, "sp_set_name", _descriptor6, this);

          _initializerDefineProperty(this, "label_set_name", _descriptor7, this);

          _initializerDefineProperty(this, "item_card", _descriptor8, this);

          _initializerDefineProperty(this, "label_reward", _descriptor9, this);

          _initializerDefineProperty(this, "label_set_done", _descriptor10, this);

          _defineProperty(this, "_leftHadClicked", false);

          _defineProperty(this, "_rightHadClicked", false);
        }

        onShow(showParams) {
          // 获取在min-village限制下的最大set-id
          let all_set_meta = Meta.MetaManager.GetMetas(Meta.MetaType.CardSets);
          this.max_set_id = 1;
          let i = 0;

          while (true) {
            i += 1;

            if (!all_set_meta[i]) {
              break;
            }

            if (all_set_meta[i].MinVillage() > Game.SUserVillage.MapId()) {
              break;
            }
          }

          this.max_set_id = i - 1; // 刷新页面

          this.load_page(showParams.single_set_meta);
        }

        onClose() {
          this.releaseMeta();
          this.card_list.forEach(x => {
            x.onClose();
          });
        }
        /**
         * 载入界面,可以反复使用
         * @param {CardSetsMeta} set_meta
         */


        load_page(set_meta) {
          // 获取奖励
          this.get_set_reward(set_meta); // 重新获取数据

          this.single_set_meta = set_meta;

          for (let i = 0; i < 9; i += 1) {
            this.card_meta_list[i] = Meta.MetaManager.GetMeta(Meta.MetaType.Card, this.single_set_meta.Id() * 100 + i + 1);
          } //卡牌名称颜色


          this.sp_set_name.node.color = new Color(this.single_set_meta.Color());
          this.label_set_name.string = this.single_set_meta.Name(); // 刷新9个card

          this.create_card(); // 刷新process

          if (Game.SUserCard.HasgotSetsReward(this.single_set_meta.Id())) {
            this.label_set_done.node.parent.active = true;
            this.label_reward.node.parent.active = false;
          } else {
            this.label_set_done.node.parent.active = false;
            this.label_reward.node.parent.active = true;
            let contents = Content.Merge(this.single_set_meta.Reward());
            this.rewardLayout.destroyAllChildren();

            for (let i = 0; i < contents.length; i++) {
              const newItemNode = instantiate(this.rewardItem);
              newItemNode.parent = this.rewardLayout;
              newItemNode.active = true;
              const sp = newItemNode.getComponentInChildren(Sprite);
              const label = newItemNode.getComponentInChildren(Label);
              label.string = `×${contents[i].Count()}`;

              if (contents[i].Type() === Content.Types.Item) {
                sp.sizeMode = Sprite.SizeMode.CUSTOM;
                sp.node.getComponent(UITransform).setContentSize(31, 55.5);
                sp.spriteFrame = this.sfItem;
              } // sp.node.setPosition(-label.node.getComponent(cc.UITransform).width / 2, 0);
              // label.node.setPosition(sp.node.getComponent(cc.UITransform).width / 2, 0);
              // newItemNode.getComponent(cc.UITransform).width = sp.node.width + label.node.width;

            }

            this.label_reward.string = i18n.t("CardSingleSetWindowReward");
          }
        }

        releaseMeta(res) {// cce.releaseSpriteFrame(this.sp_set_name, res);
        }
        /**
         * 判定并获取set的奖励
         * @param {CardSetsMeta} set_meta
         */


        get_set_reward(set_meta) {
          // 是否领过
          if (Game.SUserCard.HasgotSetsReward(set_meta.Id())) {
            return;
          } // 是否满足领的条件


          for (let i = 1; i <= 9; i += 1) {
            if (!Game.SUserCard.HaveCard(100 * set_meta.Id() + i)) {
              return;
            }
          } // 领奖


          let sr = SR.SRCard.getCardReward(set_meta.Id());
          sr.SetSilence(false);
          sr.SetCallBack(() => {
            Game.SUserCard.GetSetsReward(set_meta.Id());

            if (homeView.cardAllSetWindow) {
              homeView.cardAllSetWindow.getComponentsInChildren(CardItem).forEach(cardItem => cardItem.update_compelete());
            }

            this.label_set_done.node.parent.active = true;
            this.label_reward.node.parent.active = false;
            LogEventWrap.logEvent("card_reward", {
              id: set_meta.Id()
            });
          });
          sr.Send();
        }
        /** @type {cc.Sprite} */

        /** 创建9个card-item */


        create_card() {
          // 如果已经创建,则直接刷新
          if (this.card_list.length != 0) {
            this.card_list.forEach((v, i) => {
              v.show(this.card_meta_list[i].Id()); // 如果被锁住则不可点击

              v.node.parent.getComponent(Button).interactable = Game.SUserVillage.MapId() >= this.card_meta_list[i].MinVillage();
              v.goldTrade.active = this.card_meta_list[i].Golden() && !this.card_meta_list[i].CantSend();
            });
            return;
          } // 创建


          this.item_card.active = false;

          for (let i = 0; i < 9; i += 1) {
            // 创建新node
            let node = instantiate(this.item_card);
            node.parent = this.item_card.parent;
            node.active = true; // 刷新显示

            let card_model = GameKit.ControllerTable.GetNode(node, "NewCardModel").getComponent(CardModel);
            card_model.show(this.card_meta_list[i].Id());
            card_model.goldTrade = GameKit.ControllerTable.GetNode(node, "goldTrade");
            card_model.goldTrade.active = this.card_meta_list[i].Golden() && !this.card_meta_list[i].CantSend();
            node.getComponent(Button).interactable = Game.SUserVillage.MapId() >= this.card_meta_list[i].MinVillage();
            this.card_list.push(card_model); // 绑定点击事件

            node.on("click", () => {
              UIRoot.instance.openChildWindow(CardAskSendWindow, {
                card_meta: this.card_meta_list[i]
              });
            });
          }
        }
        /** @type {cc.Label} */

        /** 点击事件:上一个set */


        event_left() {
          if (this._rightHadClicked) return;
          this._leftHadClicked = true;
          this.scheduleOnce(() => {
            this._leftHadClicked = false;
          }, 0.5);
          let new_set_meta_id = this.single_set_meta.Id() - 1 - 1;
          new_set_meta_id = (new_set_meta_id + this.max_set_id) % this.max_set_id + 1; // 注意setid从1开始

          this.load_page(Meta.MetaManager.GetMeta(Meta.MetaType.CardSets, new_set_meta_id));
        }
        /** 点击事件:下一个set */


        event_right() {
          if (this._leftHadClicked) return;
          this._rightHadClicked = true;
          this.scheduleOnce(() => {
            this._rightHadClicked = false;
          }, 0.5);
          let new_set_meta_id = this.single_set_meta.Id() + 1 - 1;
          new_set_meta_id = (new_set_meta_id + this.max_set_id) % this.max_set_id + 1; // 注意setid从1开始

          this.load_page(Meta.MetaManager.GetMeta(Meta.MetaType.CardSets, new_set_meta_id));
        }

        event_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Card/CardSingleSetWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "rewardItem", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sfSpin", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "sfItem", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "rewardLayout", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "defaultSetTitlebg", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "sp_set_name", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "label_set_name", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "item_card", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "label_reward", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "label_set_done", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fixedSizeRatio.ts", ['cc', './CCE_Component.ts', './CCTools.ts'], function (exports) {
  'use strict';

  var cclegacy, CCInteger, CCBoolean, _decorator, UITransform, Sprite, CCE_Component, CCTools;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCInteger = module.CCInteger;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      UITransform = module.UITransform;
      Sprite = module.Sprite;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCTools = module.CCTools;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "eaf7biyckBAmoIBQIv0xFA8", "fixedSizeRatio", undefined);

      var ratioType;

      (function (ratioType) {
        ratioType[ratioType["free"] = 0] = "free";
        ratioType[ratioType["width"] = 1] = "width";
        ratioType[ratioType["height"] = 2] = "height";
      })(ratioType || (ratioType = {}));

      const {
        ccclass,
        property,
        executionOrder,
        executeInEditMode
      } = _decorator;
      let fixedSizeRatio = exports('default', (_dec = executionOrder(-1), _dec2 = property(CCInteger), _dec3 = property(CCBoolean), ccclass(_class = _dec(_class = (_class2 = (_temp = class fixedSizeRatio extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "width", void 0);

          _defineProperty(this, "height", void 0);

          _defineProperty(this, "inited", void 0);

          _defineProperty(this, "sprite", void 0);

          _defineProperty(this, "spriteFrame", void 0);

          _defineProperty(this, "_type", ratioType.free);

          _initializerDefineProperty(this, "keepRawRatio", _descriptor, this);
        }

        set type(type) {
          this._type = type;
          this.width = this.node.getComponent(UITransform).width;
          this.height = this.node.getComponent(UITransform).height;
        }

        get type() {
          return this._type;
        }

        start() {
          if (this.inited) return;
          this.width = this.node.getComponent(UITransform).width;
          this.height = this.node.getComponent(UITransform).height;
          this.sprite = this.getComponent(Sprite);
          if (this.sprite) this.spriteFrame = this.sprite.spriteFrame;
          this.inited = true;

          if (this.sprite && (this.sprite._sizeMode == 1 || this.sprite._sizeMode == 2)) {
            this.sprite._sizeMode = 0;
            this.keepRawRatio = true;
          }

          if (CCTools.WidgetUpdateAlignment(this.node)) {
            this.slowUpdate(0);
          }
        }

        slowUpdate(dt) {
          if (this.type === ratioType.free) return;

          if (this.sprite && this.spriteFrame != this.sprite.spriteFrame) {
            this.spriteFrame = this.sprite.spriteFrame;

            if (this.type === ratioType.width) {
              let rwidth = this.width;
              if (this.keepRawRatio && this.sprite) CCTools.ResizeSprite(this.sprite);
              this.setWidth();
              this.node.getComponent(UITransform).width = rwidth;
            } else {
              let rheight = this.height;
              if (this.keepRawRatio && this.sprite) CCTools.ResizeSprite(this.sprite);
              this.setHeight();
              this.node.getComponent(UITransform).height = rheight;
            }
          }

          if (this.width !== this.node.getComponent(UITransform).width || this.height !== this.node.getComponent(UITransform).height) {
            if (this.type === ratioType.width) {
              this.node.getComponent(UITransform).height = this.node.getComponent(UITransform).width * this.height / this.width;
            } else {
              this.node.getComponent(UITransform).width = this.node.getComponent(UITransform).height * this.width / this.height;
            }

            this.width = this.node.getComponent(UITransform).width;
            this.height = this.node.getComponent(UITransform).height;
          }
        }

        setWidth() {
          this.type = ratioType.width;
          this.width = this.node.getComponent(UITransform).width;
          this.height = this.node.getComponent(UITransform).height;
          this.sprite = this.getComponent(Sprite);
          if (this.sprite) this.spriteFrame = this.sprite.spriteFrame;
          this.inited = true;
        }

        setHeight() {
          this.type = ratioType.height;
          this.width = this.node.getComponent(UITransform).width;
          this.height = this.node.getComponent(UITransform).height;
          this.sprite = this.getComponent(Sprite);
          if (this.sprite) this.spriteFrame = this.sprite.spriteFrame;
          this.inited = true;
        } //将图片限制在指定尺寸内进行等比缩放


        static fitSpriteInRange(sprite, range) {
          sprite = sprite.node;
          let fix = sprite.getComponent(fixedSizeRatio);

          if (fix && fix.keepRawRatio) {
            fix.sprite = fix.getComponent(Sprite);
            if (fix.sprite) CCTools.ResizeSprite(fix.sprite);
          }

          if (sprite.width > range.x || sprite.height > range.y) {
            let isWidth = sprite.width / range.x > sprite.height / range.y ? true : false;
            if (fix == null) fix = sprite.addComponent(fixedSizeRatio);

            if (isWidth) {
              fix.setWidth();
              sprite.width = range.x;
            } else {
              fix.setHeight();
              sprite.height = range.y;
            }

            fix.slowUpdate(0);
          }
        }

        static fitByHeight(sprite, height) {
          if (!sprite || !sprite.node) return;
          sprite = sprite.node;
          if (height == null) height = sprite.getComponent(UITransform).height;
          CCTools.ResizeSprite(sprite);
          if (sprite.getComponent(Sprite)) sprite.getComponent(Sprite).sizeMode = Sprite.SizeMode.RAW;
          let fix = sprite.getComponent(fixedSizeRatio);
          if (fix == null) fix = sprite.addComponent(fixedSizeRatio);
          fix.setHeight();
          sprite.getComponent(UITransform).height = height;
          fix.slowUpdate(0);
        }

      }, _temp), (_applyDecoratedDescriptor(_class2.prototype, "type", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "type"), _class2.prototype), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "keepRawRatio", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/JigsawWindowMain.ts", ['cc', './CCE_Component.ts', './Logs.ts', './_app.ts', './JigsawWindow.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Layout, Node, Sprite, CCBoolean, _decorator, instantiate, v2, Label, SpriteFrame, CCE_Component, Logs, cce, JigsawWindow, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Layout = module.Layout;
      Node = module.Node;
      Sprite = module.Sprite;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      v2 = module.v2;
      Label = module.Label;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      JigsawWindow = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "eca83uJniNJ3Z37aOTHRm37", "JigsawWindowMain", undefined);
      /** @author fengyong-2-26 */


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let JigsawWindowMain = exports('default', (_dec = property(Layout), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Sprite), _dec5 = property(CCBoolean), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class JigsawWindowMain extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "layout", _descriptor, this);

          _initializerDefineProperty(this, "item_piece", _descriptor2, this);

          _initializerDefineProperty(this, "item_list", _descriptor3, this);

          _initializerDefineProperty(this, "sp_complete", _descriptor4, this);

          _initializerDefineProperty(this, "preview", _descriptor5, this);
        }

        slowUpdate() {
          if (this.preview) {
            this.preview = false;
            this.add_item();
          }
        }
        /** @type {cc.Layout} */

        /** 在编辑器中创建9个item并保存
         * - 说明1:item_piece为基础节点,修改后点击preview会修改item-list为9个新节点
         * - 说明2:main脚本在万能拼图界面中被复制,因此需要将9个item保留在脚本中
         */


        add_item() {
          this.item_list = [];
          this.layout.node.destroyAllChildren();

          for (let i = 0; i < 9; i += 1) {
            let n = instantiate(this.item_piece);
            n.parent = this.layout.node;
            n.position = v2(0, 0);
            n.active = true;
            GameKit.ControllerTable.GetNode(n, "text").getComponent(Label).string = (i + 1).toString();
            this.item_list.push(n);
          }
        }
        /** 载入界面 */


        load_page() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();

          for (let i = 0; i < this.item_list.length; i += 1) {
            if (metaparam.jigsawSetPath.startsWith("http")) {
              let resName = `${metaparam.jigsawSetPath}/${i}.png`;
              cce.loaderLoad({
                url: resName,
                type: "png"
              }, function (err, v) {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!this.item_list || !this.item_list[i]) return;
                let sp = GameKit.ControllerTable.GetNode(this.item_list[i], "sp-raw").getComponent(Sprite);
                if (!sp) return;
                let sps = new SpriteFrame();
                sps.texture = v;
                sp.spriteFrame = sps;
              }.bind(this));
            } else {
              let resName = `${JigsawWindow.res_path}${metaparam.jigsawSetPath}/${i}`;
              cce.loadRes(resName, SpriteFrame, (err, res) => {
                if (err != null) {
                  Logs.Warning(err);
                  return;
                }

                if (!this.item_list || !this.item_list[i]) return;
                let sp = GameKit.ControllerTable.GetNode(this.item_list[i], "sp-raw").getComponent(Sprite);
                if (!sp) return;
                sp.spriteFrame = res;
              });
            }
          }

          if (metaparam.jigsawSetPath.startsWith("http")) {
            let resName = `${metaparam.jigsawSetPath}/complete.png`;
            cce.loaderLoad({
              url: resName,
              type: "png"
            }, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.sp_complete) return;
              let sp = new SpriteFrame();
              sp.texture = v;
              this.sp_complete.spriteFrame = sp;
            }.bind(this));
          } else {
            let resName = `${JigsawWindow.res_path}${metaparam.jigsawSetPath}/complete`;
            cce.loadRes(resName, SpriteFrame, (err, res) => {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.sp_complete) return;
              this.sp_complete.spriteFrame = res;
            });
          }

          this.update_page();
        }
        /** 清理界面 */


        Clear() {
          for (let i = 0; i < this.item_list.length; i += 1) {
            let sp = GameKit.ControllerTable.GetNode(this.item_list[i], "sp-raw").getComponent(Sprite);
            cce.releaseSpriteFrame(sp);
          }

          cce.releaseSpriteFrame(this.sp_complete);
        }
        /** 刷新页面数据 */


        update_page() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();

          for (let i = 0; i < this.item_list.length; i += 1) {
            let sp = GameKit.ControllerTable.GetNode(this.item_list[i], "sp-raw").getComponent(Sprite);
            sp.setState(data.jigsawData[i] === 1 ? 0 : 1);
            GameKit.ControllerTable.GetNode(this.item_list[i], "text").active = data.jigsawData[i] === 0;
          }

          this.update_complete();
        }
        /** 针对piece-complete动画的特殊情况，更改具体的一块 */


        update_single_piece(i) {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();
          let sp = GameKit.ControllerTable.GetNode(this.item_list[i], "sp-raw").getComponent(Sprite);
          sp.setState(data.jigsawData[i] === 1 ? 0 : 1);
          GameKit.ControllerTable.GetNode(this.item_list[i], "text").active = data.jigsawData[i] === 0;
        }
        /** 针对piece-complete动画的特殊情况，更改complete */


        update_complete() {
          let [data, metaparam] = JigsawWindow.ins.get_data_and_metaparam();

          if (!data.jigsawData.includes(0)) {
            if (!this.sp_complete.node.active) {
              this.sp_complete.node.opacity = 0;
              this.sp_complete.node.active = true;
              this.sp_complete.node.runAction(ccAction.fadeIn(1));
            }
          } else {
            this.sp_complete.node.active = false;
          }
        }

        get_sp_world_position(index) {
          return this.item_list[index].getWorldPosition();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "layout", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "item_piece", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "item_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sp_complete", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "preview", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SimpleItemBuyWindow.ts", ['cc', './SoundManager.ts', './UIWindow.ts', './ContentModel.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, SoundManager, UIWindow, ContentModel, Meta, LogEventWrap, PaymentWrap;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ecf49HgWJ1Il7Df9eFsJwzy", "SimpleItemBuyWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SimpleItemBuyWindow = exports('default', (_dec = property(ContentModel), _dec2 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class SimpleItemBuyWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "contentModel", _descriptor, this);

          _initializerDefineProperty(this, "labelPrice", _descriptor2, this);

          _defineProperty(this, "itemId", void 0);

          _defineProperty(this, "shopMeta", void 0);
        }

        onShow(showParams) {
          this.itemId = showParams.itemId;
          let shopMetaId = Meta.ShopMeta.Types.Item * 100 + this.itemId;
          this.shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, shopMetaId);

          if (!this.shopMeta) {
            this.close();
            return;
          }

          this.labelPrice.string = this.shopMeta.PriceString();
          this.contentModel.show(this.shopMeta.Content());
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        callBuy() {
          PaymentWrap.Pay(this.shopMeta.Name(), function (ok) {
            if (ok) {
              this.closeAnim();
              SoundManager.playSound("item_purchased");
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "item",
                name: this.shopMeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "item",
                name: this.shopMeta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "item",
            name: this.shopMeta.Name(),
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "Shop/SimpleItemBuyWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "contentModel", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelPrice", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/WheelNode.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './global.ts', './Logs.ts', './EnterCloseAnim.ts', './SoundManager.ts', './StaticGame.ts', './GameKit.ts', './BigNumber.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, CCBoolean, Label, _decorator, view, CCE_Component, CCEaseTypes, G, Logs, EnterCloseAnim, SoundManager, Game, Meta, GameKit, BigNumber;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      CCBoolean = module.CCBoolean;
      Label = module.Label;
      _decorator = module._decorator;
      view = module.view;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      G = module.G;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      BigNumber = module.BigNumber;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ed617ksMw5D/KHErPInGrBX", "WheelNode", undefined);

      const SE_spin_start = "db_wheel_spin_start";
      const SE_spin_loop = "db_wheel_spin_loop";
      const SE_spin_end = "db_wheel_spin_end";
      const {
        ccclass,
        property
      } = _decorator;
      let WheelNode = exports('default', (_dec = property(Node), _dec2 = property(CCBoolean), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property([Label]), ccclass(_class = (_class2 = (_temp = class WheelNode extends CCE_Component {
        constructor() {
          super();

          _defineProperty(this, "node", void 0);

          _defineProperty(this, "running", void 0);

          _defineProperty(this, "maxSpeed", void 0);

          _defineProperty(this, "acce", void 0);

          _defineProperty(this, "speed", void 0);

          _defineProperty(this, "isAtten", void 0);

          _defineProperty(this, "leftDegree", void 0);

          _defineProperty(this, "moveAction", void 0);

          _defineProperty(this, "oldY", void 0);

          _defineProperty(this, "completeCallback", void 0);

          _defineProperty(this, "readyStop", void 0);

          _defineProperty(this, "resultCoinNum", void 0);

          _initializerDefineProperty(this, "rotationRoot", _descriptor, this);

          _initializerDefineProperty(this, "isGold", _descriptor2, this);

          _initializerDefineProperty(this, "pendant", _descriptor3, this);

          _initializerDefineProperty(this, "goldenWingLeft", _descriptor4, this);

          _initializerDefineProperty(this, "goldenWingRight", _descriptor5, this);

          _initializerDefineProperty(this, "nums", _descriptor6, this);

          this.running = false;
          this.maxSpeed = 800;
          this.acce = 0;
          this.speed = 0;
          this.isAtten = false;
          this.leftDegree = 0;
          this.moveAction = null;
          this.oldY = 104;
          this.completeCallback = null;
        }

        onLoad() {
          if (view.getVisibleSize().height < view._designResolutionSize.height) ;
        }

        start() {
          let mapId = Game.SUserVillage.MapId();
          let rewardMeta = Meta.MetaManager.GetMeta(Meta.MetaType.DailyBonusReward, mapId);

          for (let i = 0; i < this.nums.length; i++) {
            let nums = this.isGold ? rewardMeta.GetGold(i) : rewardMeta.GetNormal(i);
            this.nums[i].string = BigNumber.format(nums);
          }
        }

        Clear() {
          this.running = false;
          this.speed = 0;
          this.rotationRoot.angle = 3 / this.nums.length * 360;
        }

        update(dt) {
          if (this.running) {
            this.run(dt);
          }
        }

        startRun(cb) {
          if (this.running == false) {
            this.running = true;
            this.completeCallback = cb; // 停止上下浮动
            //this.stopMove()
            // 移动回起始位置
            //this.resetPos()

            this.speed = 1;
            this.acce = 0;
            this.readyStop = false;
            this.isAtten = false;
            Logs.Info("bonus start"); //this.scheduleOnce(this.stopRandom, 3)

            SoundManager.playSound(SE_spin_start);
            this.scheduleOnce(() => {
              SoundManager.playSound(SE_spin_loop, 1, true);
            }, 1);
          }
        }

        stopRandom() {
          var index = Math.floor(Math.random() * this.nums.length);
          this.stopAt(index);
        }

        stopAt(index) {
          this.leftDegree = index * 45 + (Math.random() - 0.5) * 2 * 15 + 360 * G.getRandomInt(8, 12);
          let mapId = Game.SUserVillage.MapId();
          let rewardMeta = Meta.MetaManager.GetMeta(Meta.MetaType.DailyBonusReward, mapId);
          this.resultCoinNum = this.isGold == true ? rewardMeta.GetGold(index) : rewardMeta.GetNormal(index);
          this.readyStop = true;
        }

        run(dt) {
          if (this.isAtten) {
            this.speed -= this.speed * dt * 0.9795;

            if (this.speed < 1 * this.leftDegree + 1) {
              this.speed = 1 * this.leftDegree + 1;
            }
          } else {
            if (this.speed < this.maxSpeed) {
              this.speed += this.acce * dt * 2;
              this.acce += 180 * dt;

              if (this.speed >= this.maxSpeed) {
                this.speed = this.maxSpeed;
              }
            } else if (this.readyStop && this.speed >= this.maxSpeed) {
              let rot = this.rotationRoot.angle;
              this.leftDegree -= GameKit.FuncTools.GetNormalAngles(rot);
              this.isAtten = true;
              this.scheduleOnce(() => {
                SoundManager.stopSound(SE_spin_loop);
                SoundManager.playSound(SE_spin_end);
              }, 2.5);
              return;
            }
          }

          let rotateDelta = this.speed * dt;

          if (this.isAtten) {
            if (this.leftDegree < rotateDelta) {
              rotateDelta = this.leftDegree;
              this.running = false;

              if (this.completeCallback != null) {
                this.completeCallback(this.resultCoinNum);
              }
            } else {
              this.leftDegree -= rotateDelta;
            }
          }

          this.rotationRoot.angle = GameKit.FuncTools.GetNormalAngles(this.rotationRoot.angle + rotateDelta);
        }

        showWheel() {
          this.node.active = true;
          this.node.y = this.oldY;
          this.rotationRoot.angle = 3 / this.nums.length * 360;

          if (this.pendant != null) {
            this.pendant.active = false;
          }

          this.getComponent(EnterCloseAnim).enterAnim(() => {
            this.showPendant();
            this.startMove();
          }); //if (this.isGold) {SoundManager.playSound(SE_gold_in)}
        }

        showPendant() {
          if (this.pendant != null) {
            this.pendant.active = true;
            this.pendant.getComponent(EnterCloseAnim).enterAnim();
          }

          if (this.goldenWingLeft != null) {
            this.goldenWingLeft.stopAllActions();
            this.goldenWingLeft.angle = 45;
            this.goldenWingLeft.runAction(ccAction.sequence(ccAction.delayTime(0.3), ccAction.rotateBy(0.3, -45, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut))));
          }

          if (this.goldenWingRight != null) {
            this.goldenWingRight.stopAllActions();
            this.goldenWingRight.angle = -45;
            this.goldenWingRight.runAction(ccAction.sequence(ccAction.delayTime(0.3), ccAction.rotateBy(0.3, 45, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut))));
          }
        }

        hideWheel(callback) {
          this.stopMove();
          this.getComponent(EnterCloseAnim).closeAnim(() => {
            this.node.active = false;

            if (callback) {
              callback();
            }
          });
        }

        startMove() {
          /*if(this.running) return
          if (this.moveAction != null) {
          	this.node.stopAction(this.moveAction)
          }
          this.moveAction = this.node.runAction(ccAction.sequence(
          	ccAction.moveBy(2.5, 0, 8, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)),
          	ccAction.moveBy(2.5, 0, -8, cce.CCEaseTypes.GetEasing(cce.CCEaseTypes.Types.easeInOut)),
          ).repeatForever())*/
        }

        stopMove() {
          this.node.stopAllActions();

          if (this.moveAction != null) {
            this.node.stopAction(this.moveAction);
            this.moveAction = null;
          }
        }

        resetPos() {
          this.node.runAction(ccAction.moveTo(Math.abs(this.node.y - this.oldY) / 15, this.node.x, this.oldY));
        }

        isRunning() {
          return this.running;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "rotationRoot", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "isGold", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "pendant", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "goldenWingLeft", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "goldenWingRight", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "nums", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BackKeyManager.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, systemEvent, SystemEvent, macro;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      systemEvent = module.systemEvent;
      SystemEvent = module.SystemEvent;
      macro = module.macro;
    }],
    execute: function () {
      exports('BackKeyManager', void 0);

      cclegacy._RF.push({}, "ee85bbf5YhDVozqRvnUM4Pj", "BackKeyManager", undefined);

      let BackKeyManager;

      (function (_BackKeyManager) {
        let callbacks = [];

        function init() {
          systemEvent.on(SystemEvent.EventType.KEY_UP, e => {
            if (e.keyCode == macro.KEY.back || e.keyCode == macro.KEY.escape) {
              BackKeyManager.callEvnet();
            }
          });
        }

        _BackKeyManager.init = init;

        function Clear() {
          callbacks = [];
        }

        _BackKeyManager.Clear = Clear;

        function registerBackEvent(callback) {
          callbacks.push(callback);
        }

        _BackKeyManager.registerBackEvent = registerBackEvent;

        function unregisterBackEvent() {
          if (callbacks.length <= 0) return;
          callbacks.pop();
        }

        _BackKeyManager.unregisterBackEvent = unregisterBackEvent;

        function callEvnet() {
          if (callbacks.length <= 0) return;
          let call = callbacks[callbacks.length - 1];
          if (call) call();
        }

        _BackKeyManager.callEvnet = callEvnet;
      })(BackKeyManager || (BackKeyManager = exports('BackKeyManager', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SRActivityHeist.ts", ['cc', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, GameKit;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      exports('SRActivityHeist', void 0);

      cclegacy._RF.push({}, "ee910ggorVJL6DNg5U0Givx", "SRActivityHeist", undefined);

      let SRActivityHeist;

      (function (_SRActivityHeist) {
        function activityHeistAddBuyCount(activityMetaId, count) {
          let sr = new GameKit.ServerRequest("activityHeistAddBuyCount");
          sr.SetRequestBody("activityMetaId", activityMetaId);
          sr.SetRequestBody("count", count);
          return sr;
        }

        _SRActivityHeist.activityHeistAddBuyCount = activityHeistAddBuyCount;

        function activityHeistFreeBuy(activityMetaId, packId) {
          let sr = new GameKit.ServerRequest("activityHeistFreeBuy");
          sr.SetRequestBody("activityMetaId", activityMetaId);
          sr.SetRequestBody("packId", packId);
          return sr;
        }

        _SRActivityHeist.activityHeistFreeBuy = activityHeistFreeBuy;
      })(SRActivityHeist || (SRActivityHeist = exports('SRActivityHeist', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CCE_Component.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, sys, director;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      sys = module.sys;
      director = module.director;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "ef862kexgdDlr8ZRnvv15FB", "CCE_Component", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CCE_Component = exports('CCE_Component', (_dec = ccclass("CCE_Component"), _dec(_class = (_temp = class CCE_Component extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "CCE_SLOWUPDATE_FRAME", 1 / 30);

          _defineProperty(this, "__dt", void 0);

          _defineProperty(this, "slowLateUpdate", void 0);

          _defineProperty(this, "__ldt", void 0);
        }

        onLoad() {
          if (sys.os === sys.OS_IOS) this.CCE_SLOWUPDATE_FRAME = 1 / 20;
        }

        update(dt) {
          if (!this.slowUpdate == null) {
            director["_compScheduler"].updateInvoker.remove(this);
            this.update = null;
            return;
          }

          this.__dt = (this.__dt || 0) + dt;

          if (this.__dt >= this.CCE_SLOWUPDATE_FRAME) {
            if (this.slowUpdate != null) this.slowUpdate(this.__dt);
            this.__dt = 0;
          }
        }

        slowUpdate(dt) {}

        lateUpdate(dt) {
          if (!this.slowLateUpdate == null) {
            director["_compScheduler"].lateUpdateInvoker.remove(this);
            this.lateUpdate = null;
            return;
          }

          this.__ldt = (this.__ldt || 0) + dt;

          if (this.__ldt >= this.CCE_SLOWUPDATE_FRAME) {
            if (this.slowLateUpdate != null) this.slowLateUpdate(this.__ldt);
            this.__ldt = 0;
          }
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PaySuccessWindow.ts", ['cc', './Constant.ts', './UIWindow.ts', './CardChestOpenWindow.ts', './UIRoot.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, MyCustomEvent, UIWindow, CardChestOpenWindow, UIRoot, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CardChestOpenWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f078dJHHExIVLkvLdfLvMz8", "PaySuccessWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let PaySuccessWindow = exports('PaySuccessWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class PaySuccessWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spCoin", _descriptor, this);

          _initializerDefineProperty(this, "spSpin", _descriptor2, this);

          _initializerDefineProperty(this, "spPack", _descriptor3, this);

          _initializerDefineProperty(this, "spTreat", _descriptor4, this);

          _initializerDefineProperty(this, "spShield", _descriptor5, this);
        }

        onShow(showParams) {
          this.spCoin.active = showParams.from == "coin";
          this.spSpin.active = showParams.from == "spin";
          this.spPack.active = showParams.from == "pack";
          this.spTreat.active = showParams.from == "treat";
          this.spShield.active = showParams.from == "shield";
          let chest = GameKit.DataCache.GetData("UserCardChest");

          if (chest) {
            UIRoot.instance.openChildWindow(CardChestOpenWindow, {
              chest: chest
            });
            GameKit.DataCache.RemoveData("UserCardChest");
          }
        }

        onClose() {}

        callClose() {
          this.closeAnim();
          eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
        }

      }, _defineProperty(_class3, "windowPath", "Shop/PaySuccessWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spCoin", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spSpin", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spPack", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spTreat", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spShield", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivitySalePackWindow.ts", ['cc', './Logs.ts', './_app.ts', './CCTools.ts', './SoundManager.ts', './UIWindow.ts', './ContentModel.ts', './Content.ts', './PaySuccessWindow.ts', './UIRoot.ts', './ActivityManager.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, Sprite, _decorator, UITransform, SpriteFrame, Logs, cce, CCTools, SoundManager, UIWindow, ContentModel, Content, PaySuccessWindow, UIRoot, ActivityManager, Meta, Game, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      Sprite = module.Sprite;
      _decorator = module._decorator;
      UITransform = module.UITransform;
      SpriteFrame = module.SpriteFrame;
    }, function (module) {
      Logs = module.Logs;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      CCTools = module.CCTools;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      ActivityManager = module.ActivityManager;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f117dwvEzlDVLpfpVemVrNJ", "ActivitySalePackWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivitySalePackWindow = exports('ActivitySalePackWindow', (_dec = property([Node]), _dec2 = property([ContentModel]), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Label), _dec6 = property(Label), _dec7 = property(Sprite), _dec8 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class ActivitySalePackWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "nodes", _descriptor, this);

          _initializerDefineProperty(this, "items", _descriptor2, this);

          _initializerDefineProperty(this, "labelPrice", _descriptor3, this);

          _initializerDefineProperty(this, "labelOldPrice", _descriptor4, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor5, this);

          _initializerDefineProperty(this, "labelOff", _descriptor6, this);

          _initializerDefineProperty(this, "spBg", _descriptor7, this);

          _initializerDefineProperty(this, "spDecoration", _descriptor8, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "metaParam", void 0);

          _defineProperty(this, "shopId", void 0);

          _defineProperty(this, "shopMeta", void 0);

          _defineProperty(this, "contents", void 0);

          _defineProperty(this, "leftTime", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.metaParam = this.meta.Param();
          this.shopId = this.meta.ShopId();
          this.shopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.shopId);
          this.contents = Content.Merge(this.shopMeta.Content().Contents());
          this.items.forEach((x, i) => {
            x.show(this.contents[i]);
          });
          this.labelPrice.string = this.shopMeta.PriceString();

          if (this.shopMeta.Type() == Meta.ShopMeta.Types.DynamicPack) {
            let packMeta = Meta.DynamicPackMeta.FindMeta(this.shopMeta.Content().Id(), Game.SUserVillage.MapId(), Game.SUserRecord.GetPurchaseMoney());

            if (packMeta.OldPriceShopId()) {
              let oldPriceShopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, packMeta.OldPriceShopId());

              if (oldPriceShopMeta) {
                this.labelOldPrice.string = oldPriceShopMeta.PriceString();
              } else {
                if (!this.metaParam.oldPriceLine) this.metaParam.oldPriceLine = {};
                this.metaParam.oldPriceLine.width = 0;
                this.labelOldPrice.string = "";
              }
            } else {
              if (!this.metaParam.oldPriceLine) this.metaParam.oldPriceLine = {};
              this.metaParam.oldPriceLine.width = 0;
              this.labelOldPrice.string = "";
            }
          } else {
            if (this.metaParam.oldPriceShopId) {
              let oldPriceShopMeta = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, this.metaParam.oldPriceShopId);

              if (oldPriceShopMeta) {
                this.labelOldPrice.string = oldPriceShopMeta.PriceString();
              } else {
                if (!this.metaParam.oldPriceLine) this.metaParam.oldPriceLine = {};
                this.metaParam.oldPriceLine.width = 0;
                this.labelOldPrice.string = "";
              }
            } else {
              if (!this.metaParam.oldPriceLine) this.metaParam.oldPriceLine = {};
              this.metaParam.oldPriceLine.width = 0;
              this.labelOldPrice.string = "";
            }
          }

          let rawNames = [];
          this.nodes.forEach(x => {
            CCTools.SetNodeByParam(x, this.metaParam[x.name]);
            rawNames.push(x.name);
          });

          for (let name in this.metaParam) {
            if (rawNames.contains(name)) continue;
            if (name == "badgeTime" || name == "oldPriceShopId") continue;
            let nnode = new Node(name);
            nnode.addComponent(UITransform);
            nnode.parent = this.spDecoration;
            CCTools.SetNodeByParam(nnode, this.metaParam[name]);
          }

          if (this.shopMeta.Type() == Meta.ShopMeta.Types.DynamicPack) {
            let packMeta = Meta.DynamicPackMeta.FindMeta(this.shopMeta.Content().Id(), Game.SUserVillage.MapId(), Game.SUserRecord.GetPurchaseMoney());
            this.labelOff.string = Math.round(packMeta.Off() * 100).toString() + "%";
          } else {
            this.labelOff.string = Math.round(this.shopMeta.Off() * 100).toString() + "%";
          }

          let img = this.meta.Image();

          if (img.startsWith("http")) {
            cce.loaderLoad({
              url: img,
              type: "png"
            }, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.spBg || !this.node) return;
              let sp = new SpriteFrame();
              sp.texture = v;
              this.spBg.spriteFrame = sp;
            }.bind(this));
          } else {
            let resName = "res/Activity/images/" + img;
            cce.loadRes(resName, SpriteFrame, function (err, v) {
              if (err != null) {
                Logs.Warning(err);
                return;
              }

              if (!this.spBg || !this.node) return;
              this.spBg.spriteFrame = v;
            }.bind(this));
          }

          this.leftTime = 0;
          this.slowUpdate(0);
        }

        slowUpdate(arg) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = this.meta.EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        close_window() {
          this.closeAnim();
        }

        callBuy() {
          let shopmeta = this.shopMeta;
          PaymentWrap.Pay(shopmeta.Name(), function (ok) {
            if (ok) {
              SoundManager.playSound("item_purchased");
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "pack",
                showCallback: wnd => {
                  wnd.addOnCloseFunc(() => {
                    if (this.node) this.closeAnim();
                  });
                }
              });
              let purchasedActivityId = GameKit.PlayerPrefs.GetObject("purchasedActivityId", []);
              purchasedActivityId.push(this.meta.Id());
              GameKit.PlayerPrefs.SetObject("purchasedActivityId", purchasedActivityId);
              homeView.slotPage.RemoveActivityBadge(this.meta.Id());
              ActivityManager.logined();
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "pack",
                name: shopmeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "pack",
                name: shopmeta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "pack",
            name: shopmeta.Name(),
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/ActivitySalePackWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "nodes", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "items", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelPrice", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelOldPrice", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelOff", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spBg", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spDecoration", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Page.ts", ['cc', './Constant.ts', './UIWindow.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, MyCustomEvent, UIWindow;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      UIWindow = module.default;
    }],
    execute: function () {
      var _dec, _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "f2c88rPVAhATp3ryikFv/ag", "Page", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Page = exports('Page', (_dec = ccclass('Page'), _dec(_class = (_temp = class Page extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "pageIndex", 0);

          _defineProperty(this, "container", void 0);
        }

        setPageIndex(index) {
          this.pageIndex = index;
        }

        onLoad() {
          this.container = this.node.getChildByName("container");
          eventCenter.on(MyCustomEvent.OnPageScrolling, this.OnPageScrolling, this);
          eventCenter.on(MyCustomEvent.OnPageTurnComplete, this.OnPageTurnComplete, this);
        }

        onDestroy() {
          eventCenter.off(MyCustomEvent.OnPageScrolling, this.OnPageScrolling, this);
          eventCenter.off(MyCustomEvent.OnPageTurnComplete, this.OnPageTurnComplete, this);
        } // abstract onLeftPage(): void;
        // onLeftPage() {
        // }
        // onEnterPage() {
        // }


        OnPageScrolling(ratio) {
          let isExposed = false;
          const leftIndex = Math.floor(ratio);
          const rightIndex = Math.ceil(ratio);

          if (this.pageIndex === leftIndex || this.pageIndex === rightIndex) {
            isExposed = true;
          }

          this.container.active = isExposed;
        }

        OnPageTurnComplete(index) {
          this.container.active = this.pageIndex === index;
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ApNotEnoughWindow.ts", ['cc', './global.ts', './UIWindow.ts', './MultiplePurchaseWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, G, UIWindow, MultiplePurchaseWindow, UIRoot, Game, LogEventWrap, PaymentWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      MultiplePurchaseWindow = module.MultiplePurchaseWindow;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f3420wo1DdLz7EocPz4ks+n", "ApNotEnoughWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ApNotEnoughWindow = exports('ApNotEnoughWindow', (_dec = property(Label), _dec2 = property(Label), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class ApNotEnoughWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelAp", _descriptor, this);

          _initializerDefineProperty(this, "labelPrice", _descriptor2, this);

          _initializerDefineProperty(this, "labelWait", _descriptor3, this);

          _initializerDefineProperty(this, "labelWait2", _descriptor4, this);

          _initializerDefineProperty(this, "spPay", _descriptor5, this);

          _initializerDefineProperty(this, "spPlay", _descriptor6, this);

          _initializerDefineProperty(this, "labelOff", _descriptor7, this);

          _defineProperty(this, "shopMeta", void 0);

          _defineProperty(this, "apRemainTime", void 0);

          _defineProperty(this, "lastUpdateTime", void 0);
        }

        onShow(showParams) {
          this.shopMeta = showParams.meta;
          this.labelAp.string = "+" + this.shopMeta.Count().toString();
          this.labelPrice.string = this.shopMeta.PriceString();
          this.spPay.active = PaymentWrap.PayEnabled();
          this.spPlay.active = !PaymentWrap.PayEnabled();
          this.apRemainTime = G.GameConstance.apRecover - (Game.SUser.ApRecover() + GameKit.TimeUtil.getCurrentTime() - 1 - Game.SUser.ApRecoverLast());
          this.labelOff.string = String.format(i18n.t("NotEnoughOff"), 100 * this.shopMeta.Off());
        }

        onClose() {}

        slowUpdate(dt) {
          let cTime = GameKit.TimeUtil.getCurrentTime();
          dt = this.lastUpdateTime ? cTime - this.lastUpdateTime : dt;
          this.lastUpdateTime = cTime;
          this.apRemainTime -= dt;

          if (this.apRemainTime <= 0) {
            this.closeAnim();
            return;
          }

          let apRecoverSpins = G.GameConstance.apRecoverSpins;

          if (Game.SUserStatus.IsVip()) {
            apRecoverSpins = G.GameConstance.vipApRecoverSpins;
          }

          this.labelWait.string = String.format(i18n.t("NotEnoughApWait"), apRecoverSpins, GameKit.TimeUtil.FormatRemainTimeSimple(this.apRemainTime));
          this.labelWait2.string = String.format(i18n.t("NotEnoughApWait2"), apRecoverSpins, GameKit.TimeUtil.FormatRemainTimeSimple(this.apRemainTime));
        }

        callClose() {
          this.closeAnim();
        }

        callBuy() {
          PaymentWrap.Pay(this.shopMeta.Name(), function (ok) {
            if (ok) {
              this.closeAnim();
              if (MultiplePurchaseWindow.OpenMulti()) UIRoot.instance.openChildWindow(MultiplePurchaseWindow, {
                meta: this.shopMeta
              });
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "spin",
                name: this.shopMeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "spin",
                name: this.shopMeta.Name(),
                phase: -1
              });
            }
          }.bind(this));
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "spin",
            name: this.shopMeta.Name(),
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "Shop/ApNotEnoughWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelAp", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelPrice", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelWait", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelWait2", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spPay", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "spPlay", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelOff", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/WatchGetCoinWindow.ts", ['cc', './UIWindow.ts', './CommonAssets.ts', './PlayGetAnimation.ts', './GameMainWindow.ts', './SR.ts', './StaticGame.ts', './ADWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, _decorator, UIWindow, CommonAssets, PlayGetAnimation, GameMainWindow, SR, Game, Meta, ADWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CommonAssets = module.default;
    }, function (module) {
      PlayGetAnimation = module.PlayGetAnimation;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      ADWrap = module.ADWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f38c04uIvJKdK3sv9sbMD/k", "WatchGetCoinWindow", undefined); // let UIRoot = window.UIRoot
      //// let UIWindow = UIWindow
      // let ScrollViewTool = require('ScrollViewTool')
      // let UserInfoModel = UserInfoModel


      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 界面配置参数 */

      const C = {
        /** 默认的spin_add */
        DEFAULT_COIN_ADD: 210000
      };
      /**
       * WatchGetSpin界面
       * - 包含各类按钮的点击事件处理
       * @class
       */

      let WatchGetCoinWindow = exports('WatchGetCoinWindow', (_dec = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class WatchGetCoinWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "add_label", _descriptor, this);
        }

        onShow() {
          this.add_label.string = String.format(i18n.t("watch_coin"), GameKit.StringUtil.formatNumber(this.get_coin_add_number()));
        }
        /** 点击事件：close */


        event_close() {
          this.closeAnim();
        }
        /** 点击事件：watch */


        event_watch() {
          ADWrap.ShowVideo(() => {
            let oldCoin = Game.SUser.Coin();
            let req = SR.SRUserData.finishVideoCoin(true);
            req.SetCallBack(() => {
              this.closeAnim(() => {
                let adCoinTime = GameKit.PlayerPrefs.GetInt("adCoinTime", 0);

                if (GameKit.TimeUtil.getCurrentHalfDay() !== adCoinTime) {
                  GameKit.PlayerPrefs.SetInt("adCoinCount", 0);
                  GameKit.PlayerPrefs.SetInt("adCoinTime", GameKit.TimeUtil.getCurrentHalfDay());
                }

                let adCoinCount = GameKit.PlayerPrefs.GetInt("adCoinCount", 0);
                GameKit.PlayerPrefs.SetInt("adCoinCount", adCoinCount + 1);
                GameKit.PlayerPrefs.SetInt("adCoinTipCount", -5);
                PlayGetAnimation.playAnimation({
                  startNode: GameMainWindow.instance.node,
                  endNode: GameMainWindow.instance.btnCoinAdd.node.getChildByName("iconCoin"),
                  count: C.DEFAULT_COIN_ADD,
                  prefab: CommonAssets.instance.coinPrefab,
                  startCallback: () => {
                    if (GameMainWindow.instance) {
                      homeView.villagePage.updateAdCoin();
                      GameMainWindow.instance.userinfo.changeCoin(oldCoin, Game.SUser.Coin(), 0.8);
                    }
                  }
                });
              });
            });
            req.Send();
          }, "WatchGetCoinWindow");
        }
        /** 获取coin_add的值
         * @returns {number}
         */


        get_coin_add_number() {
          let adGetCoinMeta = Meta.MetaManager.GetMeta(Meta.MetaType.AdGetCoin, Game.SUserVillage.MapId());
          return adGetCoinMeta.CoinByTip();
        }

      }, _defineProperty(_class3, "windowPath", "Other/WatchGetCoinWindow"), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "add_label", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BackGroundManager.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class, _class2, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "f47a3ktRBtIU4d4lfRdEaXF", "BackGroundManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BackGroundManager = exports('default', ccclass(_class = (_temp = _class2 = class BackGroundManager extends CCE_Component {
        onLoad() {
          BackGroundManager.instance = this;
        }

        showMenu() {}

        showGame() {}

      }, _defineProperty(_class2, "instance", null), _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CannonSendItemWindow.ts", ['cc', './UIWindow.ts', './UserInfoModel.ts', './CannonCommonAsset.ts', './CannonData.ts', './FriendsModel.ts', './StaticGame.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Button, _decorator, UIWindow, UserInfoModel, CannonCommomAsset, CannonData, FriendsModel, Game;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Button = module.Button;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      CannonCommomAsset = module.default;
    }, function (module) {
      CannonData = module.default;
    }, function (module) {
      FriendsModel = module.default;
    }, function (module) {
      Game = module.Game;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f4bddlQZ69Hyb4xul9b2nCW", "CannonSendItemWindow", undefined); // const UserInfoModel = UserInfoModel


      const {
        ccclass,
        property
      } = _decorator;
      /** 赠送item,选择friend界面 */

      let CannonSendItemWindow = exports('default', (_dec = property(FriendsModel), _dec2 = property(Sprite), _dec3 = property(UserInfoModel), _dec4 = property(Button), ccclass(_class = (_class2 = (_temp = _class3 = class CannonSendItemWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "item_id", void 0);

          _defineProperty(this, "friend_data", void 0);

          _initializerDefineProperty(this, "friends_model", _descriptor, this);

          _initializerDefineProperty(this, "sp_choosed_item", _descriptor2, this);

          _initializerDefineProperty(this, "choosed_friend", _descriptor3, this);

          _initializerDefineProperty(this, "btn_send", _descriptor4, this);
        }

        onShow(params) {
          this.item_id = params.item_id;
          this.sp_choosed_item.spriteFrame = CannonCommomAsset.ins.get_item_spf(this.item_id);
          this.choosed_friend.node.active = false;
          this.btn_send.interactable = false;
          this.friends_model.init((index, id, node, friend_data) => {
            node.on("click", () => {
              this.friend_data = friend_data;
              this.choosed_friend.node.active = true;
              this.choosed_friend.show(this.friend_data);
              this.btn_send.interactable = true;
            });
          }, Game.SUser.FriendsList());
        }
        /** @type {FriendsModel} friend搜索model */


        event_close() {
          this.closeAnim();
        }

        event_send() {
          if (!this.friend_data) {
            return;
          }

          CannonData.send_item(this.friend_data.UserId(), this.item_id).then(() => {
            this.closeAnim();
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/cannon/CannonSendItemWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "friends_model", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sp_choosed_item", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "choosed_friend", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btn_send", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PetStateFollowing.ts", ['cc', './PetStateMachine.ts', './PetStateIdle.ts', './PetStateLieDown.ts', './Player.ts'], function (exports) {
  'use strict';

  var Tween, Quat, Vec3, cclegacy, PetStateMachine, PetStateIdle, PetStateLieDown, Player;
  return {
    setters: [function (module) {
      Tween = module.Tween;
      Quat = module.Quat;
      Vec3 = module.Vec3;
      cclegacy = module.cclegacy;
    }, function (module) {
      PetStateMachine = module.default;
    }, function (module) {
      PetStateIdle = module.default;
    }, function (module) {
      PetStateLieDown = module.default;
    }, function (module) {
      Player = module.default;
    }],
    execute: function () {
      cclegacy._RF.push({}, "f4d0aNZ2CJCbKUG07Jk5mAI", "PetStateFollowing", undefined);

      class PetStateFollowing extends PetStateMachine {
        onEnter() {
          this.context.changeStateToRun();
          Tween.stopAllByTarget(this.context.node);
        }

        onExit() {}

        customUpdate(dt) {
          this.followingTarget(dt);
        }

        followingTarget(dt) {
          const target = Player.instance.petSlot;
          const dir = target.worldPosition.clone().subtract(this.context.node.worldPosition);
          let distance = dir.length(); // let moveDir = dir.normalize().multiplyScalar(dt * this.context.speed);
          // let targetPosition = this.context.node.worldPosition.clone().add(moveDir);
          // if (targetPosition.z < target.worldPosition.z) {
          //     targetPosition = new Vec3(targetPosition.x, targetPosition.y, target.worldPosition.z + 0.01);
          // }
          // this.context.node.worldPosition = targetPosition;
          // this.context.node.forward = dir;

          let curWorldRotation = this.context.node.worldRotation;
          let targetWorldRotation = new Quat();
          let newQuat = new Quat();
          Quat.fromViewUp(targetWorldRotation, dir.multiplyScalar(-1).normalize());
          Quat.slerp(newQuat, curWorldRotation, targetWorldRotation, dt * 10);
          this.context.node.worldRotation = newQuat;
          let newFroward = this.context.node.forward; // newQuat.getEulerAngles(newFroward);
          // newFroward = newFroward.multiplyScalar(-1);
          // newFroward.y = 0;

          let moveDir = newFroward.normalize().multiplyScalar(dt * this.context.speed);
          let targetPosition = this.context.node.worldPosition.clone().add(moveDir);

          if (targetPosition.z < target.worldPosition.z) {
            targetPosition = new Vec3(targetPosition.x, targetPosition.y, target.worldPosition.z + 0.01);
          }

          this.context.node.worldPosition = targetPosition;
          this.checkDistance(distance);
        }

        checkDistance(distance) {
          //防止中途穿过的情况
          if (!Player.instance.isRunning && distance < 0.1) {
            this.context.reachNewRoom = true;
            this.context.afkTimeElapsed = 0;

            if (this.context.isSleeping) {
              if (!(this.context.curState instanceof PetStateLieDown)) {
                this.context.transitionTo(new PetStateLieDown());
              }
            } else {
              if (!(this.context.curState instanceof PetStateIdle)) {
                this.context.transitionTo(new PetStateIdle());
              }
            }
          }
        }

      }

      exports('default', PetStateFollowing);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AnimaLittlematch.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts'], function (exports) {
  'use strict';

  var cclegacy, v3, Node, _decorator, v2, CCE_Component, CCEaseTypes;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v3 = module.v3;
      Node = module.Node;
      _decorator = module._decorator;
      v2 = module.v2;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f5729kdIWJB65byYqri5PkX", "AnimaLittlematch", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const C = {
        FLOAT_TIME: 2,
        // 单次浮动的时间
        EASE: CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineInOut),
        LEFT: v3(-5, 10),
        RIGHT: v3(5, 10)
      };
      /**
       * map-Littlematch中的浮动动画
       */

      let AnimaLittlematch = exports('AnimaLittlematch', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), ccclass(_class = (_class2 = (_temp = class AnimaLittlematch extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "fire_list", _descriptor, this);

          _initializerDefineProperty(this, "tree_list", _descriptor2, this);

          _initializerDefineProperty(this, "food_list", _descriptor3, this);
        }

        onLoad() {
          this.set_anima_float();
        }
        /** 设置item的浮动动画 */


        set_anima_float() {
          this.fire_list.forEach(v => {
            this.anima_float(v, v.getPosition(), v.getPosition().add(C.LEFT), v.getPosition().add(C.RIGHT));
          });
          this.tree_list.forEach(v => {
            let position = v2(v.position.x, v.position.y);
            this.anima_float(v, v.getPosition(), v.getPosition().add(C.RIGHT), v.getPosition().add(C.LEFT));
          });
          this.food_list.forEach(v => {
            this.anima_float(v, v.getPosition(), v.getPosition().add(C.LEFT), v.getPosition().add(C.RIGHT));
          });
        }
        /**
         * 浮动动画
         * @param node
         * @param p_list 坐标数组
         */


        anima_float(node, ...p_list) {
          let source_active = node.active;
          node.active = true;
          node.runAction(ccAction.sequence(ccAction.moveTo(C.FLOAT_TIME, p_list[0], CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineInOut)), ccAction.moveTo(C.FLOAT_TIME, p_list[1], CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineInOut)), ccAction.moveTo(C.FLOAT_TIME, p_list[2], CCEaseTypes.GetEasing(CCEaseTypes.Types.easeSineInOut))).repeatForever());
          node.active = source_active;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "fire_list", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "tree_list", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "food_list", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VillageShopItem.ts", ['cc', './CCE_Component.ts', './fixedSizeRatio.ts', './villageTextureLoader.ts', './ContentCheck.ts', './SR.ts', './StaticGame.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './AppMain.ts'], function (exports) {
  'use strict';

  var cclegacy, v2, Node, Sprite, Label, Button, _decorator, CCE_Component, fixedSizeRatio, villageTextureLoader, ContentCheck, SR, Game, Meta, LogEventWrap, GameKit, AppMain;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      v2 = module.v2;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      Button = module.Button;
      _decorator = module._decorator;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      fixedSizeRatio = module.default;
    }, function (module) {
      villageTextureLoader = module.default;
    }, function (module) {
      ContentCheck = module.ContentCheck;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
      Meta = module.Meta;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      AppMain = module.AppMain;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f6b1eo/eLBBGqdL5TbTL4uY", "VillageShopItem", undefined);

      var iconSizeMax = v2(120, 95);
      var startDis = 50;
      const {
        ccclass,
        property
      } = _decorator;
      let VillageShopItem = exports('default', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Sprite), _dec5 = property(Sprite), _dec6 = property(Sprite), _dec7 = property([Node]), _dec8 = property([Node]), _dec9 = property([Node]), _dec10 = property([Node]), _dec11 = property(Label), _dec12 = property(Node), _dec13 = property(Button), _dec14 = property(Button), ccclass(_class = (_class2 = (_temp = class VillageShopItem extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "bgSelect", _descriptor, this);

          _initializerDefineProperty(this, "spOne", _descriptor2, this);

          _initializerDefineProperty(this, "spTwo", _descriptor3, this);

          _initializerDefineProperty(this, "spIcon", _descriptor4, this);

          _initializerDefineProperty(this, "spIcon1", _descriptor5, this);

          _initializerDefineProperty(this, "spIcon2", _descriptor6, this);

          _initializerDefineProperty(this, "lineEmpty", _descriptor7, this);

          _initializerDefineProperty(this, "lineFull", _descriptor8, this);

          _initializerDefineProperty(this, "starEmpty", _descriptor9, this);

          _initializerDefineProperty(this, "starFull", _descriptor10, this);

          _initializerDefineProperty(this, "labelCost", _descriptor11, this);

          _initializerDefineProperty(this, "spComplete", _descriptor12, this);

          _initializerDefineProperty(this, "btnBuy", _descriptor13, this);

          _initializerDefineProperty(this, "btnFix", _descriptor14, this);

          _defineProperty(this, "window", void 0);

          _defineProperty(this, "type", void 0);

          _defineProperty(this, "selected", void 0);

          _defineProperty(this, "homeView", void 0);

          _defineProperty(this, "mapId", void 0);

          _defineProperty(this, "currentLevel", void 0);

          _defineProperty(this, "isDestroyed", void 0);

          _defineProperty(this, "maxLevel", void 0);
        }

        onLoad() {}

        updatePanel(window, type, selected) {
          this.window = window;
          this.type = type;
          this.selected = selected;
          this.homeView = homeView;
          this.mapId = Game.SUserVillage.MapId();
          this.currentLevel = Game.SUserVillage.GetLevel(this.type);
          this.isDestroyed = Game.SUserVillage.IsDestroyed(this.type);
          this.maxLevel = Meta.VillageShopMeta.GetMaxLevel(this.mapId, this.type);
          this.bgSelect.active = this.selected; //显示建筑icon图片

          if (this.homeView.villageIconItem) {
            if (this.currentLevel === 0 || this.currentLevel === this.maxLevel || this.isDestroyed) {
              this.spOne.active = true;
              this.spTwo.active = false;
              this.spIcon.spriteFrame = this.homeView.villageIconItem.getSprite(this.type, this.currentLevel + (this.currentLevel === 0 ? 1 : 0));
              fixedSizeRatio.fitSpriteInRange(this.spIcon, iconSizeMax);
            } else {
              this.spOne.active = false;
              this.spTwo.active = true;
              this.spIcon1.spriteFrame = this.homeView.villageIconItem.getSprite(this.type, this.currentLevel);
              this.spIcon2.spriteFrame = this.homeView.villageIconItem.getSprite(this.type, this.currentLevel + 1);
              fixedSizeRatio.fitSpriteInRange(this.spIcon1, iconSizeMax);
              fixedSizeRatio.fitSpriteInRange(this.spIcon2, iconSizeMax);
            }
          } //显示星级进度


          if (this.maxLevel === 4) {
            for (let i = 0; i < 5; i++) {
              if (i === 4) {
                this.lineEmpty[i].active = false;
                this.lineFull[i].active = false;
                this.starEmpty[i].active = false;
                this.starFull[i].active = false;
              } else {
                this.lineEmpty[i].x += startDis / 2;
                this.lineFull[i].x += startDis / 2;
                this.starEmpty[i].x += startDis / 2;
                this.starFull[i].x += startDis / 2;
              }
            }
          }

          let starLevel = this.currentLevel;
          if (this.isDestroyed) starLevel -= 1;

          for (let i = 0; i < 5; i++) {
            this.lineFull[i].active = starLevel > i;
            this.starFull[i].active = starLevel > i;
          } //显示价格状态 信息按钮


          if (this.isDestroyed) {
            let price = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel);

            if (price != null) {
              this.labelCost.string = GameKit.StringUtil.formatNumber(price / 2);
            }
          } else {
            let price = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel + 1);

            if (price != null) {
              this.labelCost.string = GameKit.StringUtil.formatNumber(price);
            }
          }

          this.labelCost.node.active = this.currentLevel < this.maxLevel && !this.isDestroyed || this.isDestroyed;
          this.spComplete.active = this.currentLevel === this.maxLevel && !this.isDestroyed;
          this.btnBuy.node.active = this.currentLevel < this.maxLevel && !this.isDestroyed;
          this.btnFix.node.active = this.isDestroyed;

          if (this.homeView.villageNode.building[this.type]) {
            this.btnBuy.interactable = false;
            this.btnFix.interactable = false;
          }

          if (this.type != 1 && !AppMain.instance.tutorialManager.isTutorilaFinished) {
            this.btnBuy.interactable = false;
          }
        }

        onBuy() {
          let price = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel + 1);

          if (price != null) {
            if (ContentCheck.CheckCoin(price)) {
              this.btnBuy.interactable = false;
              Game.SUserVillage.MakeLevelUp(this.type);
              this.homeView.villageNode.BuildLevelUpOrFix(this.type);
              this.window.close();
              let handle = this.homeView.villageNode.GetHandle(this.type, this.currentLevel + 1, false);
              if (handle != null) handle.getComponentsInChildren(villageTextureLoader).forEach(x => {
                x.vload();
              });

              let buildOk = () => {
                this.homeView.villageNode.BuildLevelUpOrFixOver(this.type); //this.btnBuy.interactable = true
                //this.updatePanel(this.window, this.type, this.selected)

                let star = Game.SUser.Star();

                if (star > 100) {
                  star = Math.floor((star - 100) / 5) * 5 + 100;
                }

                LogEventWrap.logEvent("StarDetail", {
                  count: star
                });
              };

              GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
                coin: Game.SUser.Coin() - price
              }); //tutorial

              if (!AppMain.instance.tutorialManager.isTutorilaFinished) {
                GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.VillageEvent, {
                  village: [1, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                });
                buildOk();
                return;
              }

              let req = SR.SRVillage.levelUpVillage(this.type);
              req.SetCallBack(function (res) {
                buildOk();
              }.bind(this));
              req.Send();
            }
          }
        }

        onFix() {
          if (!this.isDestroyed) {
            this.updatePanel(this.window, this.type, this.selected);
            return;
          }

          let oprice = Meta.VillageShopMeta.FindMetaPrice(this.mapId, this.type, this.currentLevel);

          if (oprice != null) {
            let price = oprice / 2;

            if (ContentCheck.CheckCoin(price)) {
              this.btnFix.interactable = false;
              Game.SUserVillage.MakeFix(this.type);
              GameKit.WebEvent.DispatcherEvent(GameKit.WebEvent.EventName.CoinEvent, {
                coin: Game.SUser.Coin() - price
              });
              this.homeView.villageNode.BuildLevelUpOrFix(this.type);
              this.window.close();
              let req = SR.SRVillage.fixVillage(this.type);
              req.SetCallBack(res => {
                homeView.villageNode.BuildLevelUpOrFixOver(this.type); //this.btnFix.interactable = true
                //this.updatePanel(this.window, this.type, this.selected)
              });
              req.Send();
            }
          }
        }

        enableButton() {
          this.btnBuy.interactable = true;
          this.btnFix.interactable = true;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "bgSelect", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spOne", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spTwo", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spIcon1", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "spIcon2", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "lineEmpty", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "lineFull", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "starEmpty", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "starFull", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "labelCost", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "spComplete", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "btnBuy", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "btnFix", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PetStateLieDown.ts", ['cc', './PetStateMachine.ts', './PetStateIdle.ts'], function (exports) {
  'use strict';

  var cclegacy, PetStateMachine, PetStateIdle;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      PetStateMachine = module.default;
    }, function (module) {
      PetStateIdle = module.default;
    }],
    execute: function () {
      cclegacy._RF.push({}, "f6d25p5bKhBcYfkqWvp/G4r", "PetStateLieDown", undefined);

      class PetStateLieDown extends PetStateMachine {
        onEnter() {
          this.context.changeStateFromIdleToRest(() => {
            this.context.transitionTo(new PetStateIdle());
          });
        }

        onExit() {}

        customUpdate(dt) {}

      }

      exports('default', PetStateLieDown);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardChestOpenWindow.ts", ['cc', './_app.ts', './SoundManager.ts', './UIWindow.ts', './GameEvent.ts', './CardModel.ts', './GameMainWindow.ts', './SlotResultHandler.ts', './CardModelChestOpen.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Vec3, Label, Node, dragonBones, _decorator, UITransform, Size, Layout, Vec2, size, instantiate, tween, easing, v3, UIOpacity, cce, SoundManager, UIWindow, GameEvent, CardModel, GameMainWindow, SlotResultHandler, CardModelChestOpen, Meta, Game, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Vec3 = module.Vec3;
      Label = module.Label;
      Node = module.Node;
      dragonBones = module.dragonBones;
      _decorator = module._decorator;
      UITransform = module.UITransform;
      Size = module.Size;
      Layout = module.Layout;
      Vec2 = module.Vec2;
      size = module.size;
      instantiate = module.instantiate;
      tween = module.tween;
      easing = module.easing;
      v3 = module.v3;
      UIOpacity = module.UIOpacity;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      GameEvent = module.GameEvent;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      GameMainWindow = module.default;
    }, function (module) {
      SlotResultHandler = module.default;
    }, function (module) {
      CardModelChestOpen = module.CardModelChestOpen;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f7907lZM7JM9pj2nLmmVuW1", "CardChestOpenWindow", undefined);

      var State;

      (function (State) {
        State["pre"] = "pre";
        State["show"] = "show";
        State["end"] = "end";
      })(State || (State = {}));

      const scaleConst1 = new Vec3(1.05, 1.05, 1.05);
      const scaleConst2 = new Vec3(0.95, 0.95, 0.95);
      /**
       * 卡牌宝箱打开页面
       * - [注意] 暂时支持的(界面合理的)打开个数:1,2,4,8
       */

      const {
        ccclass,
        property
      } = _decorator;
      let CardChestOpenWindow = exports('default', (_dec = property(Label), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property({
        tooltip: "card-item",
        type: Node
      }), _dec5 = property(Node), _dec6 = property(Label), _dec7 = property(Node), _dec8 = property(dragonBones.ArmatureDisplay), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Node), _dec12 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class CardChestOpenWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelStar", _descriptor, this);

          _initializerDefineProperty(this, "newCardMask", _descriptor2, this);

          _initializerDefineProperty(this, "cardContainer", _descriptor3, this);

          _initializerDefineProperty(this, "cardItem", _descriptor4, this);

          _initializerDefineProperty(this, "card_count", _descriptor5, this);

          _initializerDefineProperty(this, "label_card_count", _descriptor6, this);

          _initializerDefineProperty(this, "cardBornNode", _descriptor7, this);

          _initializerDefineProperty(this, "dbOpenChest", _descriptor8, this);

          _initializerDefineProperty(this, "bgGold", _descriptor9, this);

          _initializerDefineProperty(this, "starPrefab", _descriptor10, this);

          _initializerDefineProperty(this, "starEndNode", _descriptor11, this);

          _initializerDefineProperty(this, "labelCollectNode", _descriptor12, this);

          _defineProperty(this, "_state", State.pre);

          _defineProperty(this, "chest_meta", void 0);

          _defineProperty(this, "chest_index", void 0);

          _defineProperty(this, "cardMetaIDArr", void 0);

          _defineProperty(this, "cardMetaCount", void 0);

          _defineProperty(this, "scaleFor1", new Vec3(1.1, 1.1, 1.1));

          _defineProperty(this, "scaleFor2", new Vec3(0.86, 0.86, 0.86));

          _defineProperty(this, "scaleFor4", new Vec3(0.75, 0.75, 0.75));

          _defineProperty(this, "scaleFor8", new Vec3(0.74, 0.74, 0.74));

          _defineProperty(this, "scaleForNewCard", new Vec3(1.5, 1.5, 1.5));

          _defineProperty(this, "freeChestDBResPath", "dragonBones/freeChest");

          _defineProperty(this, "basicChestDBResPath", "dragonBones/basicChest");

          _defineProperty(this, "deluxeChestDBResPath", "dragonBones/deluxeChest");

          _defineProperty(this, "legendChestDBResPath", "dragonBones/legendChest");

          _defineProperty(this, "allCards", []);

          _defineProperty(this, "_showParams", null);

          _defineProperty(this, "_isStopAction", false);
        }

        async onShow(showParams) {
          this._showParams = showParams;
          GameKit.BackKeyManager.registerBackEvent();
          const chest = showParams.chest;
          const type = chest.type;
          const cards = chest.cards;
          this.cardItem.active = false;
          this.card_count.active = false; // 预先获取一些数据

          this.chest_meta = Meta.MetaManager.GetMeta(Meta.MetaType.CardChest, type);
          this.chest_index = this.chest_meta.Id() - 1; // 当前chest的index

          this.cardMetaIDArr = cards;
          this.cardMetaCount = {};
          this.cardMetaIDArr.forEach(metaId => {
            this.cardMetaCount[metaId] = this.cardMetaCount[metaId] || 0;
            this.cardMetaCount[metaId]++;
          });
          let star = Game.SUser.Star();
          cards.forEach((cardMeta_id, index) => {
            const isNew = Game.SUserCard.CardNum(cardMeta_id) <= this.cardMetaCount[cardMeta_id];

            if (isNew) {
              star -= Meta.MetaManager.GetMeta(Meta.MetaType.Card, cardMeta_id).Rare();
            }
          });
          this.labelStar.string = star.toString();
          let dbPath = "";

          switch (type) {
            case 1:
              dbPath = this.basicChestDBResPath;
              break;

            case 2:
              dbPath = this.deluxeChestDBResPath;
              break;

            case 3:
              dbPath = this.legendChestDBResPath;
              break;

            case 4:
            case 5:
              dbPath = this.freeChestDBResPath;
              break;

            default:
              dbPath = "";
              break;
          } // 加载所需龙骨资源


          if (dbPath === "") {
            console.log("no such type of chest");
            return;
          }

          await cce.loadDragonBones(dbPath, assets => {
            assets.forEach(asset => {
              if (asset instanceof dragonBones.DragonBonesAsset) {
                this.dbOpenChest.dragonAsset = asset;
              }

              if (asset instanceof dragonBones.DragonBonesAtlasAsset) {
                this.dbOpenChest.dragonAtlasAsset = asset;
              }
            });
          }); // 创建并显示动画

          await this.create_all_card();
          this._state = State.show;
          this.anima_open_chest();
          await cce.wait(1200);
          this.showAllCard().then(() => {
            this._state = State.end;
            this.labelCollectNode.active = true;
          });
        }

        onClose() {
          if (GameMainWindow.instance) GameMainWindow.instance.showStar(Game.SUser.Star());
          GameKit.BackKeyManager.unregisterBackEvent();
          this.cardContainer.getComponentsInChildren(CardModel).forEach(v => v.onClose());
        }

        create_all_card() {
          const newCard = this.cardItem.getChildByName("NewCardModel");
          const newCardContentSize = newCard.getComponent(UITransform).contentSize;
          let itemSize = new Size();
          let count = this.cardMetaIDArr.length;
          const layout = this.cardContainer.getComponent(Layout);

          if (count === 1) {
            newCard.setScale(this.scaleFor1);
            Vec2.multiply(itemSize, newCardContentSize, size(this.scaleFor1.x, this.scaleFor1.y));
            this.cardItem.getComponent(UITransform).setContentSize(itemSize);
            layout.type = Layout.Type.NONE;
          } else if (count <= 2) {
            newCard.setScale(this.scaleFor2);
            Vec2.multiply(itemSize, newCardContentSize, size(this.scaleFor2.x, this.scaleFor2.y));
            this.cardItem.getComponent(UITransform).setContentSize(itemSize);
            layout.type = Layout.Type.HORIZONTAL;
            layout.resizeMode = Layout.ResizeMode.CONTAINER;
            layout.spacingX = 28;
          } else if (count <= 4) {
            newCard.setScale(this.scaleFor4);
            Vec2.multiply(itemSize, newCardContentSize, size(this.scaleFor4.x, this.scaleFor4.y));
            this.cardItem.getComponent(UITransform).setContentSize(itemSize);
            layout.type = Layout.Type.GRID;
            layout.paddingLeft = layout.paddingRight = layout.paddingBottom = layout.paddingTop = 0;
            layout.spacingX = 11;
            layout.spacingY = 14;
            layout.node.getComponent(UITransform).setContentSize(new Size(itemSize.width * 2 + layout.spacingX, itemSize.height * 2 + layout.spacingY));
          } else {
            newCard.setScale(this.scaleFor8);
            Vec2.multiply(itemSize, newCardContentSize, size(this.scaleFor8.x, this.scaleFor8.y));
            this.cardItem.getComponent(UITransform).setContentSize(itemSize);
            layout.type = Layout.Type.GRID;
            layout.paddingLeft = layout.paddingRight = layout.paddingBottom = layout.paddingTop = 0;
            layout.spacingX = 13;
            layout.spacingY = 14;
            layout.node.getComponent(UITransform).setContentSize(new Size(itemSize.width * 4 + layout.spacingX * 3, itemSize.height * 4 + layout.spacingY * 3));
          }

          layout.spacingX = 10;
          layout.spacingY = 10; // 创建

          this.cardMetaIDArr.forEach(cardMeta_id => {
            const newCardItem = instantiate(this.cardItem);
            newCardItem.parent = this.cardContainer;
            newCardItem.setScale(new Vec3(0.001, 0.001, 0.001)); // let _localPos: Vec3 = new Vec3();
            // this.cardContainer.inverseTransformPoint(_localPos, this.cardBornNode.getWorldPosition())
            // newCardItem.setPosition(_localPos);

            newCardItem.active = true;
            newCardItem.getComponentInChildren(CardModelChestOpen).show(cardMeta_id, "check", true);
            const isNew = Game.SUserCard.CardNum(cardMeta_id) <= this.cardMetaCount[cardMeta_id];

            if (isNew) {
              this.cardMetaCount[cardMeta_id] = 0;
            }

            newCardItem.getComponentInChildren(CardModelChestOpen).show_iconNew(isNew);
            const card = {
              card: newCardItem,
              isNew: isNew
            };
            this.allCards.push(card);
          });
        }

        anima_open_chest() {
          this.dbOpenChest.armatureName = "box_ad";
          this.dbOpenChest.animationName = "open";
          let loopFrame = 0;
          this.dbOpenChest.once(dragonBones.EventObject.FRAME_EVENT, event => {
            if (event.name === "light") {
              loopFrame = SlotResultHandler.getFrameEventFrame(this.dbOpenChest.dragonAsset, this.dbOpenChest.animationName, "light");
              console.log("lootTime: ", loopFrame); // loopTime = +event.time || 0;
            }
          }, this);
          this.dbOpenChest.on(dragonBones.EventObject.COMPLETE, () => {
            if (this.dbOpenChest.animationName === "open") {
              this.dbOpenChest.armature().animation.gotoAndPlayByFrame("open", loopFrame, 1);
            }
          }, this);
          this.dbOpenChest.playAnimation("open", 1);
          this.scheduleOnce(() => {
            SoundManager.playSound("chest_open");
          }, 1.1);
        }

        async showAllCard() {
          this.card_count.active = true;

          let showCard = i => {
            return new Promise(async resolve => {
              if (!this.allCards[i].isNew) {
                const promise = this.playCardAnim(this.allCards[i]);

                if (this.allCards[i + 1]) {
                  await cce.wait(100);
                  resolve(null);
                } else {
                  promise.then(resolve);
                }
              } else {
                this.playNewCardAnim(this.allCards[i], i).then(() => {
                  resolve(null);
                },
                /**
                 * 新卡被打断后，重新当做已有卡牌处理
                 */
                async () => {
                  const promise = this.playCardAnim(this.allCards[i]);
                  const cardModel = this.allCards[i].card.getComponentInChildren(CardModelChestOpen);
                  console.log("locateRare-CardModel: ", this.allCards, i, cardModel);
                  let startIndex = cardModel._resumeIndex;
                  promise.then(async () => {
                    await cce.wait(100);

                    for (let index = cardModel._resumeIndex; index < cardModel.card_meta.Rare(); index++) {
                      await cardModel.starBlinkAnim(index);
                    }

                    cardModel.starFlyAnim(this.node, this.starEndNode, startIndex, cardModel.card_meta.Rare(), this);
                  });

                  if (this.allCards[i + 1]) {
                    await cce.wait(100);
                    resolve(null);
                  } else {
                    promise.then(resolve);
                  }
                });
              }
            });
          };

          for (let index = 0; index < this.allCards.length; index++) {
            this.label_card_count.string = (this.allCards.length - index - 1).toString();
            await showCard(index);
          }

          this.card_count.active = false;
          GameEvent.DispatcherEvent(GameEvent.EventName.StarEvent);
        }

        playCardAnim(cardObj) {
          /**
           * phase1： 到达指定位置时，缩放比最终缩放要大一些，此时的缩放
           * phase2： 到达指定位置后，还需要缩小一次，此时的缩放
           * phase3： 最终缩放
           */
          if (cardObj.card.getComponentInChildren(CardModelChestOpen).card_meta.Golden()) {
            SoundManager.playSound("chest_card_golden");
          } else {
            SoundManager.playSound("chest_card");
          }

          return new Promise((resolve, reject) => {
            cardObj.card.angle = -30;
            let startPos = new Vec3();
            this.cardContainer.inverseTransformPoint(startPos, this.cardBornNode.getWorldPosition());
            const endPos = cardObj.card.getPosition();
            tween(cardObj.card).set({
              position: startPos,
              scale: new Vec3(0.4, 0.4, 0.4)
            }).parallel(tween().to(0.3, {
              position: endPos
            }, {
              easing: easing.quartOut
            }), tween().to(0.2, {
              scale: scaleConst1
            }), tween().to(0.4, {
              angle: 0
            }), tween().call(() => {
              cardObj.card.getComponentInChildren(CardModelChestOpen).showHighLight();
            })).call(() => {
              resolve(null);
            }).to(0.1, {
              scale: scaleConst2
            }).to(0.1, {
              scale: Vec3.ONE
            }).call(() => {
              cardObj.card.getComponentInChildren(CardModelChestOpen).hideHighLight();
            }).start();
          });
        }

        async playNewCardAnim(cardObj, index) {
          this._isStopAction = false;

          if (cardObj.card.getComponentInChildren(CardModelChestOpen).card_meta.Golden()) {
            SoundManager.playSound("chest_card_golden");
          } else {
            SoundManager.playSound("chest_card_new");
          }

          return new Promise(async (resolve, reject) => {
            // 移动到指定位置后的缩放
            let startPos = new Vec3();
            this.cardContainer.inverseTransformPoint(startPos, this.cardBornNode.getWorldPosition());
            const endPos = cardObj.card.getPosition();
            const cardModle = cardObj.card.getComponentInChildren(CardModelChestOpen); // 提前监听屏幕点击事件，打断新卡动画

            const oldPos = cardObj.card.position.clone();
            const oldScale = cardObj.card.scale.clone();

            let onClick = () => {
              cardObj.card.stopAllActions();
              cardObj.card.setScale(oldScale);
              cardObj.card.setPosition(oldPos);
              this._isStopAction = true;
              this.hideNewCardMask();
              cardModle.hideNewCardBgLight();
              reject();
            };

            this.node.once(Node.EventType.TOUCH_END, onClick, this, true);
            await this.showNewCardMask(cardModle);
            if (this._isStopAction) return;
            await new Promise(resolve => {
              tween(cardObj.card).set({
                position: startPos
              }).parallel(tween().by(0.4, {
                y: 300
              }, {
                easing: easing.quartOut
              }), tween().to(0.4, {
                scale: scaleConst2
              })).to(0.15, {
                scale: this.scaleForNewCard
              }).call(() => {
                cardModle.showNewCardBgLight();
              }).call(resolve).delay(1).start();
            });

            for (let index = 0; index < cardModle.card_meta.Rare(); index++) {
              await cardModle.starBlinkAnim(index);

              if (this._isStopAction) {
                break;
              }
            }

            await cardModle.starFlyAnim(this.node, this.starEndNode, 0, cardModle._resumeIndex, this);

            if (this._isStopAction) {
              this.node.off(Node.EventType.TOUCH_END, onClick, this, true);
              return;
            }

            this.node.off(Node.EventType.TOUCH_END, onClick, this, true);
            await cce.wait(800);
            this.hideNewCardMask();
            cardModle.hideNewCardBgLight();
            tween(cardObj.card).parallel(tween().to(0.3, {
              position: endPos
            }, {
              easing: easing.quartOut
            }), tween().to(0.3, {
              scale: Vec3.ONE
            })).call(() => {
              resolve(null);
            }).start();
          });
        }
        /** 点击事件:显示或者关闭界面 */


        event_show() {
          if (this._state === State.end) {
            if (this._showParams.closeCallback) {
              this._showParams.closeCallback();
            }

            this.closeAnim();
          }
        }

        playStarCountIncreaseAnim() {
          let star = Game.SUser.Star();
          GameMainWindow.instance.oldStar += 1;
          this.labelStar.string = GameKit.StringUtil.formatNumber(GameMainWindow.instance.oldStar < star ? GameMainWindow.instance.oldStar : star);
          tween(this.labelStar.node).to(0.15, {
            scale: v3(1.2, 1.2, 1.2)
          }).to(0.15, {
            scale: Vec3.ONE
          }).start();
        }

        showNewCardMask(cardModel) {
          return new Promise(resolve => {
            this.bgGold.active = !!cardModel.card_meta.Golden();
            this.newCardMask.active = true;
            tween(this.newCardMask.getComponent(UIOpacity)).set({
              opacity: 0
            }).to(0.05, {
              opacity: 200
            }).call(resolve).start();
            this.labelStar.string = "" + GameMainWindow.instance.oldStar;
          });
        }

        hideNewCardMask() {
          this.bgGold.active = false;
          tween(this.newCardMask.getComponent(UIOpacity)).to(0.1, {
            opacity: 0
          }).call(() => {
            this.newCardMask.active = false;
          }).start();
        }

      }, _defineProperty(_class3, "windowPath", "Card/NewCardChestOpenWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelStar", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "newCardMask", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "cardContainer", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "cardItem", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "card_count", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "label_card_count", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "cardBornNode", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "dbOpenChest", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "bgGold", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "starPrefab", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "starEndNode", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "labelCollectNode", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/TutorialWindow.ts", ['cc', './CCTools.ts', './UIWindow.ts', './TutorialManager.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, Mask, _decorator, v2, Animation, v3, UITransform, CCTools, UIWindow, TutorialManager, Meta, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      Mask = module.Mask;
      _decorator = module._decorator;
      v2 = module.v2;
      Animation = module.Animation;
      v3 = module.v3;
      UITransform = module.UITransform;
    }, function (module) {
      CCTools = module.CCTools;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      TutorialManager = module.TutorialManager;
    }, function (module) {
      Meta = module.Meta;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f7f85OFDdZGGaKvody0g27i", "TutorialWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let TutorialWindow = exports('TutorialWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Label), _dec6 = property(Node), _dec7 = property(Label), _dec8 = property(Node), _dec9 = property(Mask), _dec10 = property([Node]), _dec11 = property(Node), _dec12 = property(Node), _dec13 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class TutorialWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "arrow1", _descriptor, this);

          _initializerDefineProperty(this, "arrow2", _descriptor2, this);

          _initializerDefineProperty(this, "arrow3", _descriptor3, this);

          _initializerDefineProperty(this, "dialog", _descriptor4, this);

          _initializerDefineProperty(this, "dialogLabel", _descriptor5, this);

          _initializerDefineProperty(this, "dialog2", _descriptor6, this);

          _initializerDefineProperty(this, "dialog2Label", _descriptor7, this);

          _initializerDefineProperty(this, "dialog2Btn", _descriptor8, this);

          _initializerDefineProperty(this, "highLightMask", _descriptor9, this);

          _initializerDefineProperty(this, "highLightSpecial", _descriptor10, this);

          _initializerDefineProperty(this, "clickFullScreen", _descriptor11, this);

          _initializerDefineProperty(this, "startTitle", _descriptor12, this);

          _initializerDefineProperty(this, "guide", _descriptor13, this);

          _defineProperty(this, "guidepos", void 0);

          _defineProperty(this, "meta", void 0);
        }

        onShow() {
          TutorialManager.mainWindow = this;
          CCTools.WidgetUpdateAlignment(this.guide);
          this.guidepos = v2(this.guide.position.x, this.guide.position.y);
          this.guide.x -= 400;
          GameKit.BackKeyManager.registerBackEvent();
        }

        onClose() {
          TutorialManager.mainWindow = null;
          GameKit.BackKeyManager.unregisterBackEvent();
        }

        slowUpdate(dt) {
          TutorialManager.update(dt);
        }

        Clear() {
          this.arrow1.active = false;
          this.arrow2.active = false;
          this.arrow3.active = false;
          this.dialog.active = false;
          this.dialog2.active = false;
          this.highLightMask.enabled = false;
          this.highLightMask.node.active = false;
          this.highLightSpecial.forEach(x => {
            x.active = false;
          });
          this.clickFullScreen.active = false;
          this.startTitle.active = false;

          if (this.guide.active) {
            this.guide.stopAllActions();
            this.guide.runAction(ccAction.sequence(ccAction.moveTo(0.3, this.guidepos.x - 400, this.guidepos.y), ccAction.callFunc(() => {
              this.guide.active = false;
            }, this)));
          }
        }

        showMeta(metaId) {
          this.meta = Meta.MetaManager.GetMeta(Meta.MetaType.Tutorial, metaId);
          this.Clear();
          if (this.meta == null) return;
          this.showArrow();
          this.showDialog();
          this.showClickFullScreen();
          this.showMaskAndHighLight();

          if (metaId === 1000001 || this.meta.DialogBox()) {
            this.guide.active = true;
            this.guide.stopAllActions();
            this.guide.runAction(ccAction.moveTo(0.35, this.guidepos.x, this.guidepos.y));
          }

          if (metaId === 1000001) this.startTitle.active = true;
        }

        showArrow() {
          if (this.meta && this.meta.Arrow()) {
            let arrowType = this.meta.ArrowType();
            let pos = TutorialManager.getArrowPosition(this.meta);

            switch (arrowType) {
              case 1:
                {
                  this.arrow1.active = true; // this.arrow1.x = pos.x; this.arrow1.y = pos.y

                  this.arrow1.setPosition(this.node.getWorldPosition());
                  this.arrow1.getComponent(Animation).getState("tutorialHand").setTime(0);
                  break;
                }

              case 2:
                {
                  this.arrow2.active = true;
                  this.arrow2.x = pos.x;
                  this.arrow2.y = pos.y;
                  this.arrow2.getComponent(Animation).getState("tutorialHandSwipeDown").setTime(0);
                  break;
                }

              case 3:
                {
                  this.arrow3.active = true;
                  this.arrow3.x = pos.x;
                  this.arrow3.y = pos.y;
                  this.arrow3.angle = 0;
                  break;
                }

              case 4:
                {
                  this.arrow3.active = true;
                  this.arrow3.x = pos.x;
                  this.arrow3.y = pos.y;
                  this.arrow3.angle = 180;
                  break;
                }

              case 5:
                {
                  this.arrow3.active = true;
                  this.arrow3.x = pos.x;
                  this.arrow3.y = pos.y;
                  this.arrow3.angle = -90;
                  break;
                }

              case 6:
                {
                  this.arrow3.active = true;
                  this.arrow3.x = pos.x;
                  this.arrow3.y = pos.y;
                  this.arrow3.angle = 90;
                  break;
                }
            }
          }
        }

        showDialog() {
          if (this.meta.DialogBox()) {
            let dialog = this.dialog;
            let dialogLabel = this.dialogLabel;

            if (this.meta.TouchArea() == 2) {
              dialog = this.dialog2;
              dialogLabel = this.dialog2Label;
            }

            let poses = this.meta.DialogBox().split(",");
            dialog.active = true;
            dialog.x = parseInt(poses[0]);
            dialog.y = parseInt(poses[1]);
            dialog.width = parseInt(poses[2]);
            dialog.height = parseInt(poses[3]);
            dialogLabel.string = this.meta.DialogMsg();
            dialog.scale = v3(0.001, 0.001, 1);
            dialog.stopAllActions();
            dialog.runAction(ccAction.scaleTo(0.2, 1, 1));
          }
        }

        showClickFullScreen() {
          if (this.meta.TouchArea() === 2) {
            if (this.meta.DialogBox()) ;else {
              this.clickFullScreen.active = true;
            }
          }
        }

        showMaskAndHighLight() {
          if (this.meta.Mask() === 1) {
            this.highLightMask.node.active = true;
          }

          let highlightMode = this.meta.HighlightMode();

          if (highlightMode === 1 || highlightMode === 2) {
            this.highLightMask.enabled = true;
            let poses = TutorialManager.getHighLightPosition(this.meta);

            if (poses.isAbs) {
              this.highLightMask.node.x = poses.x;
              this.highLightMask.node.y = poses.y;
            } else {
              this.highLightMask.node.setWorldPosition(v3(poses.x, poses.y));
            }

            this.highLightMask.node.getComponent(UITransform).width = poses.width;
            this.highLightMask.node.getComponent(UITransform).height = poses.height;
          } else if (highlightMode) {
            this.highLightSpecial.some(x => {
              if (x.name.contains(highlightMode.toString())) {
                x.active = true;
                return true;
              }
            });
          }
        }

        addFullScreenOnClick(cb) {
          if (this.meta.DialogBox()) {
            this.dialog2Btn.once("click", cb);
          } else {
            this.clickFullScreen.once("click", cb);
          }
        }

        showWelcome() {}

      }, _defineProperty(_class3, "windowPath", "Other/TutorialWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "arrow1", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "arrow2", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "arrow3", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "dialog", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "dialogLabel", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "dialog2", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "dialog2Label", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "dialog2Btn", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "highLightMask", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "highLightSpecial", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "clickFullScreen", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "startTitle", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "guide", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AnimaBeachsoccer.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, v3, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      v3 = module.v3;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "f86d8PUb/hLhZJf9bzUWnE5", "AnimaBeachsoccer", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AnimaBeachsoccer = exports('AnimaBeachsoccer', (_dec = property(Node), ccclass(_class = (_class2 = (_temp = class AnimaBeachsoccer extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "soccer", _descriptor, this);
        }

        onLoad() {
          let time = 3;
          let start_positon = v3(-100, -20);
          let end_position = v3(100, 190);
          this.soccer.position = v3(start_positon.x, start_positon.y, 0);
          this.soccer.active = true;
          this.soccer.runAction(ccAction.sequence(ccAction.moveTo(time, end_position), ccAction.moveTo(time, start_positon)).repeatForever());
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "soccer", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/DamageParticle.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, ParticleSystem2D, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      ParticleSystem2D = module.ParticleSystem2D;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _class, _temp;

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "f8cbecyuMtOWo7dpzb4Ig2t", "DamageParticle", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let DamageParticle = exports('default', ccclass(_class = (_temp = class DamageParticle extends CCE_Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "particle", void 0);
        } // properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },
        // }
        // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.particle = this.getComponent(ParticleSystem2D); //TODO
          // this.particle.positionType = cc.ParticleSystem2D.PositionType.GROUPED
        }

        start() {}

        onEnable() {
          if (this.particle != null) {
            this.scheduleOnce(() => {//this.particle.enabled = true
              //this.particle.resetSystem()
            }, 0.25);
          }
        }

        onDisable() {
          if (this.particle != null) ;
        }

        stopParticle() {
          if (this.particle != null) ;
        }

      }, _temp)) || _class);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RenderUIToModel.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Size, _decorator, Component, Camera, RenderTexture, assetManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Size = module.Size;
      _decorator = module._decorator;
      Component = module.Component;
      Camera = module.Camera;
      RenderTexture = module.RenderTexture;
      assetManager = module.assetManager;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fa4990BSXBBFa5OZt4MMXQh", "RenderUIToModel", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let RenderUIToModel = exports('RenderUIToModel', (_dec = ccclass("RenderUIToModel"), _dec2 = property(Size), _dec(_class = (_class2 = (_temp = class RenderUIToModel extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "renderSize", _descriptor, this);

          _defineProperty(this, "model", null);

          _defineProperty(this, "renderTexture", null);

          _defineProperty(this, "camera", void 0);

          _defineProperty(this, "_closeCameraHandle", null);
        }

        start() {
          this.camera = this.getComponentInChildren(Camera); // const canvas = this.getComponent(Canvas);
          // console.log(canvas);

          const tex = new RenderTexture();
          tex.name = 'render-ui-to-model'; // const size = view.getVisibleSize();

          tex.reset({
            width: this.renderSize.width,
            height: this.renderSize.height
          });
          this.renderTexture = tex;
          this.camera.targetTexture = this.renderTexture; // canvas.cameraComponent.targetTexture = tex;
        }

        onDestroy() {
          if (this.renderTexture) {
            assetManager.releaseAsset(this.renderTexture);
            this.renderTexture.destroy();
            this.renderTexture = null;
          }
        }
        /**将texture渲染到model上，delay后相机自动停用 */


        updateTargetModel(model, delay = 0) {
          this.node.active = true;
          this.camera.enabled = true;

          if (this._closeCameraHandle) {
            clearTimeout(this._closeCameraHandle);
            this._closeCameraHandle = null;
          }

          this.model = model;

          if (this.model && this.model.sharedMaterial && this.renderTexture) {
            const mat = this.model.sharedMaterial;
            mat.setProperty('mainTexture', this.renderTexture);
          }

          this._closeCameraHandle = setTimeout(() => {
            this.camera.enabled = false;
            this.node.active = false;
          }, delay * 1000);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "renderSize", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Action.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Vec3, tween, v3, easing;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Vec3 = module.Vec3;
      tween = module.tween;
      v3 = module.v3;
      easing = module.easing;
    }],
    execute: function () {
      exports('Action', void 0);

      cclegacy._RF.push({}, "fabeaoDkilDuZ31sT4jeJPl", "Action", undefined);

      let Action;

      (function (_Action) {
        function moveTo(duration, xOrVec, yOrEase, easing) {
          let tween$1;

          if (xOrVec instanceof Vec3 && typeof yOrEase !== "number") {
            tween$1 = tween().to(duration, {
              position: xOrVec
            }, {
              easing: yOrEase
            });
          } else if (typeof xOrVec === "number" && typeof yOrEase === "number") {
            tween$1 = tween().to(duration, {
              position: v3(xOrVec, yOrEase)
            }, {
              easing: easing
            });
          } else if (typeof xOrVec === "number" && typeof yOrEase !== "number") {
            tween$1 = tween().to(duration, {
              position: v3(xOrVec, xOrVec)
            }, {
              easing: yOrEase
            });
          }

          return tween$1;
        }

        _Action.moveTo = moveTo;

        function moveBy(duration, xOrVec, yOrEase, easing) {
          let tween$1;

          if (xOrVec instanceof Vec3 && yOrEase !== null && typeof yOrEase !== "number") {
            tween$1 = tween().parallel(tween().by(duration, {
              x: xOrVec.x
            }, {
              easing: yOrEase
            }), tween().by(duration, {
              y: xOrVec.y
            }, {
              easing: yOrEase
            }), tween().by(duration, {
              z: xOrVec.z
            }, {
              easing: yOrEase
            }));
          } else if (typeof xOrVec === "number" && typeof yOrEase === "number") {
            tween$1 = tween().parallel(tween().by(duration, {
              x: xOrVec
            }, {
              easing: easing
            }), tween().by(duration, {
              y: yOrEase
            }, {
              easing: easing
            }));
          } else if (typeof xOrVec === "number" && yOrEase !== null && typeof yOrEase !== "number") {
            tween$1 = tween().parallel(tween().by(duration, {
              x: xOrVec
            }, {
              easing: yOrEase
            }), tween().by(duration, {
              y: xOrVec
            }, {
              easing: yOrEase
            }), tween().by(duration, {
              z: xOrVec
            }, {
              easing: yOrEase
            }));
          }

          return tween$1;
        }

        _Action.moveBy = moveBy;

        function scaleTo(duration, scaleXOrScale, scaleYOrEase, easing) {
          let tween$1;

          if (scaleXOrScale instanceof Vec3 && typeof scaleYOrEase !== "number") {
            tween$1 = tween().to(duration, {
              scale: v3(scaleXOrScale.x, scaleXOrScale.y, scaleXOrScale.z)
            }, {
              easing: scaleYOrEase
            });
          } else if (typeof scaleXOrScale === "number" && typeof scaleYOrEase === "number") {
            tween$1 = tween().to(duration, {
              scale: v3(scaleXOrScale, scaleYOrEase, 1)
            }, {
              easing: easing
            });
          } else if (typeof scaleXOrScale === "number" && typeof scaleYOrEase !== "number") {
            tween$1 = tween().to(duration, {
              scale: v3(scaleXOrScale, scaleXOrScale, 1)
            }, {
              easing: scaleYOrEase
            });
          }

          return tween$1;
        }

        _Action.scaleTo = scaleTo;

        function scaleBy(duration, scaleXOrScale, scaleYOrEase, easing) {
          let tween$1;

          if (scaleXOrScale instanceof Vec3 && typeof scaleYOrEase !== "number") {
            tween$1 = tween().by(duration, {
              scale: v3(scaleXOrScale.x, scaleXOrScale.y, 1)
            }, {
              easing: scaleYOrEase
            });
          } else if (typeof scaleXOrScale === "number" && typeof scaleYOrEase === "number") {
            tween$1 = tween().by(duration, {
              scale: v3(scaleXOrScale, scaleYOrEase, 1)
            }, {
              easing: easing
            });
          } else if (typeof scaleXOrScale === "number" && typeof scaleYOrEase !== "number") {
            tween$1 = tween().by(duration, {
              scale: v3(scaleXOrScale, scaleXOrScale, 1)
            }, {
              easing: scaleYOrEase
            });
          }

          return tween$1;
        }

        _Action.scaleBy = scaleBy;

        function sequence(...args) {
          return tween().sequence(...args);
        }

        _Action.sequence = sequence;

        function delayTime(delayTime) {
          return tween().delay(delayTime);
        }

        _Action.delayTime = delayTime;

        function callFunc(callback, owner) {
          return tween().call(() => {
            callback.call(owner);
          });
        }

        _Action.callFunc = callFunc;

        function fadeIn(duration, easing) {
          return tween().to(duration, {
            opacity: 255
          }, {
            easing: easing
          });
        }

        _Action.fadeIn = fadeIn;

        function fadeOut(duration, easing) {
          return tween().to(duration, {
            opacity: 0
          }, {
            easing: easing
          });
        }

        _Action.fadeOut = fadeOut;

        function fadeTo(duration, opacity, easing$1) {
          return tween().to(duration, {
            opacity: opacity
          }, {
            easing: easing.linear
          });
        }

        _Action.fadeTo = fadeTo;

        function rotateBy(duration, degree, easing) {
          return tween().by(duration, {
            angle: degree
          }, {
            easing: easing
          });
        }

        _Action.rotateBy = rotateBy;

        function rotateTo(duration, degree, easing) {
          return tween().to(duration, {
            angle: degree
          }, {
            easing: easing
          });
        }

        _Action.rotateTo = rotateTo;

        function spawn(...args) {
          return tween().parallel(...args);
        }

        _Action.spawn = spawn;

        function jumpTo(duration, position) {
          return tween().parallel(tween().to(duration, {
            position: position
          }), tween().to(duration / 2, {
            scale: new Vec3(1.5, 1.5, 1.5)
          }).to(duration / 2, {
            scale: Vec3.ONE
          }));
        }

        _Action.jumpTo = jumpTo;

        function jumpBy(...args) {
          return;
        }

        _Action.jumpBy = jumpBy;

        function place(positionX, positionY) {
          if (positionX instanceof Vec3 && positionX == null) {
            return tween().to(0, {
              x: positionX.x,
              y: positionX.y
            });
          } else if (typeof positionX === "number" && typeof positionY === "number") {
            return tween().to(0, {
              x: positionX,
              y: positionY
            });
          }
        }

        _Action.place = place;
      })(Action || (Action = exports('Action', {})));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LabelLocalizedFormat.ts", ['cc', './CCE_Component.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, CCString, CCBoolean, _decorator, Label, RichText, CCE_Component, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      CCString = module.CCString;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      Label = module.Label;
      RichText = module.RichText;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fac290UNMpDt7tXiqYh2Owy", "LabelLocalizedFormat", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let LabelLocalizedFormat = exports('default', (_dec = property({
        type: CCString,
        multiline: true,
        tooltip: 'Enter i18n key here'
      }), _dec2 = property(CCBoolean), _dec3 = property([CCString]), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class LabelLocalizedFormat extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "isBold", _descriptor, this);

          _defineProperty(this, "_args", []);
        }

        set textKey(text) {
          this.onLoad();
        }

        set args(param) {
          this.args = param;
          this.onLoad();
        }

        get args() {
          return this._args;
        }

        onLoad() {
          let label = null;
          label = this.getComponent(Label);

          if (label != null) {
            label.string = String.format(i18n.t(this.textKey), ...this.args);
            label.cacheMode = Label.CacheMode.BITMAP;
          }

          label = this.getComponent(RichText);

          if (label != null) {
            label.string = String.format(i18n.t(this.textKey), ...this.args);
            if (this.isBold) label.string = '<b>' + label.string + '</b>';
          }
        }

      }, _temp), (_applyDecoratedDescriptor(_class2.prototype, "textKey", [_dec], Object.getOwnPropertyDescriptor(_class2.prototype, "textKey"), _class2.prototype), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "isBold", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "args", [_dec3], Object.getOwnPropertyDescriptor(_class2.prototype, "args"), _class2.prototype)), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MinigameRankWindow.ts", ['cc', './UIWindow.ts', './User.ts', './UserInfoModel.ts', './ScrollViewTool.ts', './SR.ts', './StaticGame.ts', './GameKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Label, instantiate, Sprite, UIWindow, User, UserInfoModel, ScrollViewTool, SR, Game, GameKit;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Label = module.Label;
      instantiate = module.instantiate;
      Sprite = module.Sprite;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      User = module.User;
    }, function (module) {
      UserInfoModel = module.default;
    }, function (module) {
      ScrollViewTool = module.default;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fb975WyATVIxqXjwZKoK3c4", "MinigameRankWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator; //const UIWindow = UIWindow
      // const ScrollViewTool = ScrollViewTool
      // const ScrollViewItem = ScrollViewItem
      // const UserInfoModel = UserInfoModel

      const C = {
        COUNT: 20 // 最多20个

      };
      /**
       * 一个通用的rank界面，供Minigame使用
       * - [使用方法]:UIRoot.instance.openChildWindow(MinigameRankWindow, {...})
       */

      let MinigameRankWindow = exports('default', (_dec = property(Node), _dec2 = property(ScrollViewTool), _dec3 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class MinigameRankWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "selfScore", void 0);

          _initializerDefineProperty(this, "no_ranks", _descriptor, this);

          _initializerDefineProperty(this, "svt", _descriptor2, this);

          _initializerDefineProperty(this, "self_data_parent", _descriptor3, this);
        }

        onShow(showParams) {
          let activityMetaId = showParams.activityMetaId;
          let req = SR.SRMinigame.minigameGetRankList(Game.SUser.UserId(), activityMetaId);
          req.SetSilence(false);
          req.SetCallBack(result => {
            if (!this.node) return;
            let ranklist = [...showParams.fake_list, ...result.list]; // 排序ranklist:①过滤重复项目②过滤score不存在的项目③根据score排序

            let set_userid = new Set();
            this.selfScore = 0;
            ranklist = ranklist.filter(v => {
              if (set_userid.has(v.userId)) {
                return false;
              }

              if (!v.score) {
                return false;
              }

              set_userid.add(v.userId);
              if (v.userId == Game.SUser.UserId()) this.selfScore = v.score || 0;
              return true;
            });
            ranklist = ranklist.sort((a, b) => b.score - a.score); // count

            let count = Math.min(ranklist.length, C.COUNT); // 修改显示

            this.no_ranks.active = count <= 0;
            let id_list = [];

            for (let i = 0; i < count; i++) {
              id_list.push(i);
            }

            this.svt.setItem(id_list, (index, id, node) => {
              let userinfo = GameKit.ControllerTable.GetNode(node, "userinfo").getComponent(UserInfoModel);
              let label_index = GameKit.ControllerTable.GetNode(node, "label-index").getComponent(Label);
              let label_score = GameKit.ControllerTable.GetNode(node, "label-score").getComponent(Label);
              let user = new User().updateData(ranklist[index]);
              if (ranklist[index].userId == Game.SUser.UserId()) user = Game.SUser;
              userinfo.show(user);
              label_index.string = index + 1;
              label_score.string = ranklist[index].score;
            });
            this.setSelf();
          });
          req.Send();
        }
        /** @type {cc.Node} */


        setSelf() {
          let node = instantiate(this.svt.itemnode);
          node.active = true;
          node.parent = this.self_data_parent;
          node.x = 0;
          node.y = 0;
          let userinfo = GameKit.ControllerTable.GetNode(node, "userinfo").getComponent(UserInfoModel);
          let label_index = GameKit.ControllerTable.GetNode(node, "label-index").getComponent(Label);
          let label_score = GameKit.ControllerTable.GetNode(node, "label-score").getComponent(Label);
          node.children[0].getComponent(Sprite).enabled = false;
          userinfo.show(Game.SUser);
          label_index.string = "";
          label_score.string = this.selfScore.toString();
        }

        event_close() {
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Activity/minigame/MinigameRankWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "no_ranks", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "svt", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "self_data_parent", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ActivityDaysSaleWindow.ts", ['cc', './global.ts', './CCTools.ts', './UIWindow.ts', './ShopWindow.ts', './LogEventWrap.ts', './AppKit.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, RichText, _decorator, G, CCTools, UIWindow, ShopWindow, LogEventWrap, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      RichText = module.RichText;
      _decorator = module._decorator;
    }, function (module) {
      G = module.G;
    }, function (module) {
      CCTools = module.CCTools;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ShopWindow = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function () {}, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fd05a0vINVIaZrid9KaCBCV", "ActivityDaysSaleWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ActivityDaysSaleWindow = exports('ActivityDaysSaleWindow', (_dec = property(Node), _dec2 = property(Node), _dec3 = property(Label), _dec4 = property(Label), _dec5 = property(RichText), ccclass(_class = (_class2 = (_temp = _class3 = class ActivityDaysSaleWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spClose", _descriptor, this);

          _initializerDefineProperty(this, "spButton", _descriptor2, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor3, this);

          _initializerDefineProperty(this, "labelButton", _descriptor4, this);

          _initializerDefineProperty(this, "labelMessage", _descriptor5, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "metaParam", void 0);

          _defineProperty(this, "leftTime", void 0);

          _defineProperty(this, "childWindowChain", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          this.metaParam = this.meta.Param();
          CCTools.SetNodeByParam(this.spClose, this.metaParam.close);
          CCTools.SetNodeByParam(this.labelButton, this.metaParam.labelButton);
          CCTools.SetNodeByParam(this.spButton, this.metaParam.button);
          CCTools.SetNodeByParam(this.labelTimer, this.metaParam.timer);
          CCTools.SetNodeByParam(this.labelMessage, this.metaParam.message);
          this.leftTime = 0;
          this.slowUpdate(0);
        }

        slowUpdate(args) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = this.meta.EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

        close_window() {
          this.closeAnim();
        }

        callBuy() {
          if (this.childWindowChain) {
            this.clearOnCloseFunc();
            this.childWindowChain.end();
          }

          this.closeAnim(() => {
            homeView.pageViewController.moveToPage(G.Pages.Shop, true);
            homeView.shopContainer.getComponentInChildren(ShopWindow).scrollTo(G.zones.coin);
            LogEventWrap.logEvent("openshop_activitysale");
          });
        }

      }, _defineProperty(_class3, "windowPath", "Activity/ActivityDaysSaleWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spClose", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spButton", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelButton", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelMessage", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VIPGetWindow.ts", ['cc', './global.ts', './EnterCloseAnim.ts', './SoundManager.ts', './UIWindow.ts', './ContentModel.ts', './Content.ts', './SdkManager.ts', './VIPDailyRewardWindow.ts', './UIRoot.ts', './StaticGame.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, instantiate, Widget, sys, G, EnterCloseAnim, SoundManager, UIWindow, ContentModel, Content, SdkManager, VIPDailyRewardWindow, UIRoot, Meta, Game, LogEventWrap, PaymentWrap, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      Widget = module.Widget;
      sys = module.sys;
    }, function (module) {
      G = module.G;
    }, function (module) {
      EnterCloseAnim = module.default;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      ContentModel = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      SdkManager = module.SdkManager;
    }, function (module) {
      VIPDailyRewardWindow = module.default;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fdaceFPZXxJM49wNn/I65nF", "VIPGetWindow", undefined);

      const shopIdVIPWeek = 1101;
      const shopIdVIPMonth = 1102;
      const shopIdVIPYear = 1103;
      const {
        ccclass,
        property
      } = _decorator;
      let VIPGetWindow = exports('default', (_dec = property(Label), _dec2 = property(ContentModel), _dec3 = property(Node), _dec4 = property(Label), _dec5 = property(Label), _dec6 = property(Label), _dec7 = property(Label), _dec8 = property(Node), _dec9 = property(Node), _dec10 = property(Label), _dec11 = property(Label), _dec12 = property(Label), _dec13 = property(Label), _dec14 = property(Label), _dec15 = property(Label), _dec16 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class VIPGetWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelRewardRate", _descriptor, this);

          _initializerDefineProperty(this, "spDailyItem", _descriptor2, this);

          _initializerDefineProperty(this, "spDailyItemParent", _descriptor3, this);

          _initializerDefineProperty(this, "labelDailyApMax1", _descriptor4, this);

          _initializerDefineProperty(this, "labelDailyApMax2", _descriptor5, this);

          _initializerDefineProperty(this, "labelDailyApRec1", _descriptor6, this);

          _initializerDefineProperty(this, "labelDailyApRec2", _descriptor7, this);

          _initializerDefineProperty(this, "spButtonNormal", _descriptor8, this);

          _initializerDefineProperty(this, "spButtonTrial", _descriptor9, this);

          _initializerDefineProperty(this, "labelPriceWeek", _descriptor10, this);

          _initializerDefineProperty(this, "labelPriceMonth", _descriptor11, this);

          _initializerDefineProperty(this, "labelPriceYear", _descriptor12, this);

          _initializerDefineProperty(this, "labelPriceWeek2", _descriptor13, this);

          _initializerDefineProperty(this, "labelPriceMonth2", _descriptor14, this);

          _initializerDefineProperty(this, "labelPriceYear2", _descriptor15, this);

          _initializerDefineProperty(this, "descNode", _descriptor16, this);

          _defineProperty(this, "shopMetaWeek", void 0);

          _defineProperty(this, "shopMetaMonth", void 0);

          _defineProperty(this, "shopMetaYear", void 0);
        }

        onShow(showParams) {
          // this.labelReward100M.string = BigNumber.format(100000000);
          EnterCloseAnim.playEnter(this.node);
          this.labelRewardRate.string = "+" + Math.round(G.GameConstance.vipSlotActivityAdd * 100) + "%";
          this.spDailyItemParent.destroyAllChildren();
          let rewards = Content.FromStrings(G.GameConstance.vipDailyReward);
          rewards.forEach(reward => {
            let itemHandle = instantiate(this.spDailyItem.node);
            itemHandle.active = true;
            itemHandle.parent = this.spDailyItemParent;
            itemHandle.getComponent(ContentModel).show(reward);
          });
          this.labelDailyApMax1.string = G.GameConstance.apMax.toString();
          this.labelDailyApMax2.string = G.GameConstance.vipApMax.toString();
          this.labelDailyApRec1.string = G.GameConstance.apRecoverSpins.toString();
          this.labelDailyApRec2.string = G.GameConstance.vipApRecoverSpins.toString();
          this.shopMetaWeek = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, shopIdVIPWeek);
          this.shopMetaMonth = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, shopIdVIPMonth);
          this.shopMetaYear = Meta.MetaManager.GetMeta(Meta.MetaType.Shop, shopIdVIPYear);
          this.labelPriceWeek.string = this.shopMetaWeek.PriceString();
          this.labelPriceMonth.string = this.shopMetaMonth.PriceString();
          this.labelPriceYear.string = this.shopMetaYear.PriceString();
          this.labelPriceWeek2.string = this.shopMetaWeek.PriceString();
          this.labelPriceMonth2.string = String.format(i18n.t("VipGetTrialButtonDes2"), this.shopMetaMonth.PriceString());
          this.labelPriceYear2.string = this.shopMetaYear.PriceString();

          if (!SdkManager.IsNative() || !SdkManager.IsAndroid() || Game.SUserStatus.data.trial || Game.SUserStatus.data.vipToken != null && Game.SUserStatus.data.vipToken != "") {
            this.spButtonNormal.active = true;
            this.spButtonTrial.active = false;
            this.descNode.getComponent(Widget).bottom = 200;
          } else {
            this.spButtonNormal.active = false;
            this.spButtonTrial.active = true;
            this.descNode.getComponent(Widget).bottom = 257.5;
          }

          this.descNode.getComponent(Widget).updateAlignment();
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        onClickInfoSub() {
          if (SdkManager.IsIos()) sys.openURL(`${G.GameConfig.site_host}/scription_ios.html`);else sys.openURL(`${G.GameConfig.site_host}/scription_android.html`);
        }

        onClickInfoPri() {
          sys.openURL(`${G.GameConfig.site_host}/privacy.html`);
        }

        onClickWeek() {
          this.BuySubscription(this.shopMetaWeek.Name());
        }

        onClickMonth() {
          this.BuySubscription(this.shopMetaMonth.Name());
        }

        onClickYear() {
          this.BuySubscription(this.shopMetaYear.Name());
        }

        BuySubscription(id) {
          PaymentWrap.Pay(id, (ok, res) => {
            if (ok) {
              SoundManager.playSound("item_purchased");
              this.closeAnim();

              if (res.vipDailyReward) {
                UIRoot.instance.openChildWindow(VIPDailyRewardWindow, {
                  vipDailyReward: res.vipDailyReward
                });
              }

              LogEventWrap.logEvent("ShopDetail", {
                itemType: "vip",
                name: id,
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "vip",
                name: id,
                phase: -1
              });
            }
          });
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "vip",
            name: id,
            phase: 0
          });
        }

      }, _defineProperty(_class3, "windowPath", "VIP/NewVIPGetWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelRewardRate", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spDailyItem", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spDailyItemParent", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "labelDailyApMax1", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelDailyApMax2", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelDailyApRec1", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "labelDailyApRec2", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spButtonNormal", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "spButtonTrial", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "labelPriceWeek", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "labelPriceMonth", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "labelPriceYear", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "labelPriceWeek2", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, "labelPriceMonth2", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, "labelPriceYear2", [_dec15], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, "descNode", [_dec16], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ScrollViewTool.ts", ['cc', './CCE_Component.ts', './CCEaseTypes.ts', './ScrollViewItem.ts'], function (exports) {
  'use strict';

  var cclegacy, Prefab, CCInteger, CCBoolean, _decorator, ScrollView, UITransform, Layout, instantiate, v3, tween, CCE_Component, CCEaseTypes, ScrollViewItem;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Prefab = module.Prefab;
      CCInteger = module.CCInteger;
      CCBoolean = module.CCBoolean;
      _decorator = module._decorator;
      ScrollView = module.ScrollView;
      UITransform = module.UITransform;
      Layout = module.Layout;
      instantiate = module.instantiate;
      v3 = module.v3;
      tween = module.tween;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      CCEaseTypes = module.CCEaseTypes;
    }, function (module) {
      ScrollViewItem = module.default;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fdad6qhGHBNyqXWHsbidkn8", "ScrollViewTool", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ScrollViewTool = exports('default', (_dec = property(ScrollViewItem), _dec2 = property(Prefab), _dec3 = property(CCInteger), _dec4 = property(CCInteger), _dec5 = property(CCBoolean), _dec6 = property(CCInteger), ccclass(_class = (_class2 = (_temp = class ScrollViewTool extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "item", _descriptor, this);

          _initializerDefineProperty(this, "prefab", _descriptor2, this);

          _initializerDefineProperty(this, "startPos", _descriptor3, this);

          _initializerDefineProperty(this, "maxReuse", _descriptor4, this);

          _initializerDefineProperty(this, "centerOnChild", _descriptor5, this);

          _initializerDefineProperty(this, "testNumber", _descriptor6, this);

          _defineProperty(this, "scrollView", void 0);

          _defineProperty(this, "itemnode", void 0);

          _defineProperty(this, "items", []);

          _defineProperty(this, "data", void 0);

          _defineProperty(this, "initFunc", void 0);

          _defineProperty(this, "itemsContent", void 0);

          _defineProperty(this, "itemSize", void 0);

          _defineProperty(this, "reuseInited", void 0);

          _defineProperty(this, "reuseUpdateTimer", void 0);

          _defineProperty(this, "reuseBufferZoneUp", void 0);

          _defineProperty(this, "reuseBufferZoneDown", void 0);

          _defineProperty(this, "lastContentPos", void 0);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          this.scrollView = this.getComponent(ScrollView); // 隐藏初始item

          if (this.item) this.item.node.active = false;
          this.itemnode = this.item ? this.item.node : this.prefab.data;
          this.items = {};

          if (this.centerOnChild) {
            this.startPos = this.scrollView.node.getComponent(UITransform).width / 2;
            if (this.scrollView.vertical) this.startPos = -this.scrollView.node.getComponent(UITransform).height / 2;
          }

          this.node.on("scroll-ended", this.onScrollEnded, this);
        }

        start() {
          if (CC_DEV && this.testNumber > 0) {
            let a = [];

            for (let i = 0; i < this.testNumber; i++) a.push(i);

            this.setItem(a, nullFunction);
          }
        }

        slowUpdate(dt) {
          if (this.maxReuse > 0) {
            this.reuseUpdate(dt);
          }
        } //设置数据 data:[], initFunc:(index, id , node) => {}


        setItem(data, initFunc, options) {
          options = options || {};
          this.clear();
          this.data = data;
          this.initFunc = initFunc;
          let content = this.scrollView.content;

          if (content.getComponent(Layout) != null) {
            this.itemsContent = content;
            this.itemsContent.destroyAllChildren();
          }

          if (!this.itemsContent) {
            this.itemsContent = instantiate(content);
            this.itemsContent.parent = content;
            this.itemsContent.x = 0;
            this.itemsContent.y = 0;
            this.itemsContent.destroyAllChildren();
          }

          this.itemSize = 0;
          if (this.scrollView.vertical) this.itemSize = this.itemnode.getComponent(UITransform).height;else this.itemSize = this.itemnode.getComponent(UITransform).width;

          if (this.maxReuse > 0) {
            if (!this.reuseInited) {
              this.initializeReuse();
            }

            this.reuseSetInitFunc(initFunc);
            this.reuseSetData(data, options);
          } else {
            let index = 0;
            data.forEach(function (id) {
              let itemHandle = instantiate(this.item ? this.item.node : this.prefab);
              itemHandle.active = true;
              itemHandle.parent = this.itemsContent;
              this.items[index] = itemHandle;

              if (this.scrollView.vertical) {
                itemHandle.y = this.startPos - index * this.itemSize;
              } else {
                itemHandle.x = this.startPos + index * this.itemSize;
              }

              let scItem = itemHandle.getComponent(ScrollViewItem);
              scItem.index = index;
              scItem.id = id;
              scItem.scrollViewTool = this;
              scItem.noLazy = options.noLazy;
              scItem.registerInit(initFunc);
              if (!options.noImeUpdate) scItem.slowUpdate(0);
              index++;
            }.bind(this));
          }

          this.ResetContentSize();
        } //添加数据


        addItem(data, initFunc) {
          let index = this.data.length;
          this.data = this.data.concat(data);
          this.ResetContentSize();

          if (this.maxReuse > 0) {
            this.reuseUpdate(1);

            for (let i = 0; i < this.maxReuse; ++i) {
              let itemHandle = this.items[i];
              let scItem = itemHandle.getComponent(ScrollViewItem);
              scItem.setData(scItem.index, this.data[scItem.index]);
              scItem.slowUpdate(0);
            }

            return;
          }

          let content = this.scrollView.content;

          if (!this.itemsContent) {
            this.itemsContent = instantiate(content);
            this.itemsContent.parent = content;
            this.itemsContent.x = 0;
            this.itemsContent.y = 0;
            this.itemsContent.destroyAllChildren();
          }

          let itemSize = 0;
          if (this.scrollView.vertical) itemSize = this.itemnode.getComponent(UITransform).height;else itemSize = this.itemnode.getComponent(UITransform).width;
          data.forEach(function (id) {
            let itemHandle = instantiate(this.item ? this.item.node : this.prefab);
            itemHandle.active = true;
            itemHandle.parent = this.itemsContent;
            this.items[id] = itemHandle;

            if (this.scrollView.vertical) {
              itemHandle.y = this.startPos - index * this.itemSize;
            } else {
              itemHandle.x = this.startPos + index * this.itemSize;
            }

            let scItem = itemHandle.getComponent(ScrollViewItem);
            scItem.index = index;
            scItem.id = id;
            scItem.scrollViewTool = this;
            scItem.registerInit(initFunc);
            scItem.slowUpdate(0);
            index++;
          }.bind(this));
        } //清空列表


        clear() {
          this.items = {};
          this.data = [];
          this.reuseInited = false;
          let content = this.scrollView.content;
          if (this.itemsContent) this.itemsContent.destroyAllChildren();

          if (this.scrollView.vertical) {
            content.getComponent(UITransform).height = 0;
          } else {
            content.getComponent(UITransform).width = 0;
          }

          this.scrollView["_updateScrollBar"](v3(0, 0));
        }

        ResetContentSize() {
          if (this.scrollView.content.getComponent(Layout) != null) {
            return;
          }

          if (this.scrollView.vertical) {
            this.scrollView.content.getComponent(UITransform).height = -this.startPos + this.data.length * this.itemSize;

            if (this.centerOnChild) {
              this.scrollView.content.getComponent(UITransform).height -= this.itemSize - this.scrollView.node.getComponent(UITransform).height / 2;
            }
          } else {
            this.scrollView.content.getComponent(UITransform).width = this.startPos + this.data.length * this.itemSize;

            if (this.centerOnChild) {
              this.scrollView.content.getComponent(UITransform).width -= this.itemSize - this.scrollView.node.getComponent(UITransform).width / 2;
            }
          }

          this.scrollView["_updateScrollBar"](v3(0, 0));
        } //判断某个item是否在显示范围内 主要用来分步加载


        isItemInView(index) {
          if (this.maxReuse > 0) return true;
          let offset = this.scrollView.getScrollOffset();
          let min = -offset.x;
          let max = -offset.x + this.scrollView.node.getComponent(UITransform).width;

          if (this.scrollView.vertical) {
            max = -offset.y;
            min = -offset.y - this.scrollView.node.getComponent(UITransform).height;
          }

          let itemMin = this.items[index].x - this.itemnode.getComponent(UITransform).anchorX * this.itemSize;
          let itemMax = itemMin + this.itemSize;

          if (this.scrollView.vertical) {
            itemMax = this.items[index].y + (1 - this.itemnode.getComponent(UITransform).anchorY) * this.itemSize;
            itemMin = itemMax - this.itemSize;
          }

          let csize = 50;

          if (itemMax > min - csize && itemMin < max + csize) {
            return true;
          }

          return false;
        } //reuse


        initializeReuse() {
          for (let i = 0; i < this.maxReuse; ++i) {
            // spawn items, we only need to do this once
            let index = i;
            let itemHandle = instantiate(this.item ? this.item.node : this.prefab);
            itemHandle.active = true;
            itemHandle.parent = this.itemsContent;
            this.items[i] = itemHandle;

            if (this.scrollView.vertical) {
              itemHandle.y = this.startPos - index * this.itemSize;
            } else {
              itemHandle.x = this.startPos + index * this.itemSize;
            }

            let scItem = itemHandle.getComponent(ScrollViewItem);
            scItem.index = index;
            scItem.id = 0;
            scItem.scrollViewTool = this;
          }

          this.reuseInited = true;
          this.reuseUpdateTimer = 0;

          if (this.scrollView.vertical) {
            let _oy = this.scrollView.content.y;
            this.scrollView.content.y = 0;
            let dis = this.scrollView.content.parent.getWorldPosition().y + (1 - this.scrollView.content.parent.getComponent(UITransform).anchorY) * this.scrollView.content.parent.getComponent(UITransform).height - this.itemsContent.getWorldPosition().y;
            this.scrollView.content.y = _oy;
            this.reuseBufferZoneUp = this.itemSize + dis;
            this.reuseBufferZoneDown = -this.node.getComponent(UITransform).height + dis;
          } else {
            let _ox = this.scrollView.content.x;
            this.scrollView.content.x = 0;
            let dis = this.scrollView.content.parent.getWorldPosition().x - this.scrollView.content.parent.getComponent(UITransform).anchorX * this.scrollView.content.parent.getComponent(UITransform).width - this.itemsContent.getWorldPosition().x;
            this.scrollView.content.x = _ox;
            this.reuseBufferZoneUp = this.node.getComponent(UITransform).width + dis; //right

            this.reuseBufferZoneDown = -this.itemSize + dis; //left
          }
        }

        reuseSetInitFunc(initFunc) {
          this.initFunc = initFunc;

          for (let i = 0; i < this.maxReuse; ++i) {
            this.items[i].getComponent(ScrollViewItem).registerInit(initFunc);
          }
        }

        reuseSetData(data, options) {
          options = options || {};
          if (this.scrollView.horizontal) this.scrollView.content.x = 0;
          if (this.scrollView.vertical) this.scrollView.content.y = 0;
          this.data = data;

          for (let i = 0; i < this.maxReuse; ++i) {
            let itemHandle = this.items[i];

            if (this.scrollView.vertical) {
              itemHandle.y = this.startPos - i * this.itemSize;
            } else {
              itemHandle.x = this.startPos + i * this.itemSize;
            }

            let scItem = itemHandle.getComponent(ScrollViewItem);
            scItem.noLazy = options.noLazy;
            scItem.setData(i, data[i]);
            if (!options.noImeUpdate) scItem.slowUpdate(0);
          }

          this.ResetContentSize();
        }

        flushData() {
          for (let index in this.items) {
            this.items[index].getComponent(ScrollViewItem).refresh();
          }
        }

        getPositionInView(item) {
          let viewPos = this.scrollView.content.position.clone().add(item.position);
          if (this.scrollView.vertical) return viewPos.y + (1 - item.getComponent(UITransform).anchorY) * this.itemSize;
          return viewPos.x - item.getComponent(UITransform).anchorX * this.itemSize;
        }

        reuseUpdate(dt) {
          if (!this.reuseInited) return;
          this.reuseUpdateTimer += dt;

          if (this.reuseUpdateTimer < 0.1) {
            return; // we don't need to do the math every frame
          }

          this.reuseUpdateTimer = 0; //if (this.scrollView.vertical) { if (this.scrollView.content.y == this.lastContentPos) return }
          //else { if (this.scrollView.content.x == this.lastContentPos) return }

          let items = this.items; // 如果当前content的y坐标小于上次记录值，则代表往下滚动，否则往上。

          let isDown = this.scrollView.content.x > this.lastContentPos;
          if (this.scrollView.vertical) isDown = this.scrollView.content.y < this.lastContentPos; // 实际创建项占了多高（即它们的高度累加）

          let offset = this.itemSize * this.maxReuse;
          let newPos = 0;
          let changed = true;

          while (changed) {
            changed = false; // 遍历数组，更新item的位置和显示

            for (let i = 0; i < this.maxReuse; ++i) {
              let viewPos = this.getPositionInView(items[i]);

              if (this.scrollView.vertical) {
                if (isDown) {
                  // 提前计算出该item的新的y坐标
                  newPos = items[i].y + offset; // 如果往下滚动时item已经超出缓冲矩形，且newPos未超出content上边界，
                  // 则更新item的坐标（即上移了一个offset的位置），同时更新item的显示内容

                  if (viewPos <= this.reuseBufferZoneDown
                  /* && newPos <= 0*/
                  ) {
                      items[i].y = newPos;
                      let item = items[i].getComponent(ScrollViewItem);
                      let newIndex = item.index - this.maxReuse; // update item id

                      item.setData(newIndex, this.data[newIndex]);
                      changed = true;
                    }
                } else {
                  // 提前计算出该item的新的y坐标
                  newPos = items[i].y - offset; // 如果往上滚动时item已经超出缓冲矩形，且newPos未超出content下边界，
                  // 则更新item的坐标（即下移了一个offset的位置），同时更新item的显示内容

                  if (viewPos >= this.reuseBufferZoneUp
                  /* && newPos > -this.scrollView.content.height*/
                  ) {
                      items[i].y = newPos;
                      let item = items[i].getComponent(ScrollViewItem);
                      let newIndex = item.index + this.maxReuse;
                      item.setData(newIndex, this.data[newIndex]);
                      changed = true;
                    }
                }
              } else {
                if (isDown) {
                  // 提前计算出该item的新的y坐标
                  newPos = items[i].x + offset; // 如果往下滚动时item已经超出缓冲矩形，且newPos未超出content上边界，
                  // 则更新item的坐标（即上移了一个offset的位置），同时更新item的显示内容

                  if (viewPos >= this.reuseBufferZoneUp && newPos >= 0) {
                    items[i].x = newPos;
                    let item = items[i].getComponent(ScrollViewItem);
                    let newIndex = item.index - this.maxReuse; // update item id

                    item.setData(newIndex, this.data[newIndex]);
                    changed = true;
                  }
                } else {
                  // 提前计算出该item的新的y坐标
                  newPos = items[i].x - offset; // 如果往上滚动时item已经超出缓冲矩形，且newPos未超出content下边界，
                  // 则更新item的坐标（即下移了一个offset的位置），同时更新item的显示内容

                  if (viewPos <= this.reuseBufferZoneDown && newPos < this.scrollView.content.getComponent(UITransform).width) {
                    items[i].x = newPos;
                    let item = items[i].getComponent(ScrollViewItem);
                    let newIndex = item.index + this.maxReuse;
                    item.setData(newIndex, this.data[newIndex]);
                    changed = true;
                  }
                }
              }
            }

            for (let i = 0; i < this.maxReuse; ++i) {
              items[i].zIndex = items[i].getComponent(ScrollViewItem).index;
            }
          } // 更新lastContentPosY和总项数显示


          this.lastContentPos = this.scrollView.content.x;
          if (this.scrollView.vertical) this.lastContentPos = this.scrollView.content.y;
        }

        onScrollEnded() {
          if (this.centerOnChild) {
            let nearIndex = Math.round(this.scrollView.content.x / this.itemSize);
            if (this.scrollView.vertical) nearIndex = Math.round(this.scrollView.content.y / this.itemSize);
            this.ScrollToIndex(nearIndex);
          }
        }

        ScrollToIndex(index) {
          let targetpos = index * this.itemSize;
          let targetPos = v3(targetpos, this.scrollView.content.y);
          if (this.scrollView.vertical) targetPos = v3(this.scrollView.content.x, targetpos);
          this.scrollView.content.runAction(ccAction.moveTo(this.scrollView.bounceDuration, targetPos, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          this.scrollView.content.runAction(tween().to(this.scrollView.bounceDuration, {}, {
            onUpdate: () => {
              this.scrollView["_updateScrollBar"](this.scrollView["_getHowMuchOutOfBoundary"]());
            }
          }));
        }
        /** 直接去某一项 */


        DirectToIndex(index) {
          let targetpos = index * this.itemSize;
          let targetPos = v3(targetpos, this.scrollView.content.y);
          if (this.scrollView.vertical) targetPos = v3(this.scrollView.content.x, targetpos);
          this.scrollView.content.position = targetPos;
          this.scrollView["_updateScrollBar"](this.scrollView["_getHowMuchOutOfBoundary"]());

          if (this.maxReuse > 0) {
            this.reuseUpdate(1);
          }
        }
        /** 在time时间内滚动到某一项 */


        ScrollToIndexByTime(index, time) {
          let targetpos = index * this.itemSize;
          let targetPos = v3(targetpos, this.scrollView.content.y);
          if (this.scrollView.vertical) targetPos = v3(this.scrollView.content.x, targetpos);
          this.scrollView.content.runAction(ccAction.moveTo(time, targetPos, CCEaseTypes.GetEasing(CCEaseTypes.Types.easeBackOut)));
          this.scrollView.content.runAction(tween().to(time, {}, {
            onUpdate: () => {
              this.scrollView["_updateScrollBar"](this.scrollView["_getHowMuchOutOfBoundary"]());
            }
          }));
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "item", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "prefab", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "startPos", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "maxReuse", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 10;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "centerOnChild", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "testNumber", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CustomWidget.ts", ['cc', './CCE_Component.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, CCBoolean, CCInteger, _decorator, v3, UITransform, CCE_Component;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      CCBoolean = module.CCBoolean;
      CCInteger = module.CCInteger;
      _decorator = module._decorator;
      v3 = module.v3;
      UITransform = module.UITransform;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fdbdawVy8ZPwY9oBqUpdAg6", "CustomWidget", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let CustomWidget = exports('default', (_dec = property(Node), _dec2 = property(CCBoolean), _dec3 = property(CCInteger), _dec4 = property(CCInteger), _dec5 = property(CCInteger), _dec6 = property(CCInteger), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class CustomWidget extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "target", _descriptor, this);

          _initializerDefineProperty(this, "always", _descriptor2, this);

          _defineProperty(this, "_editoralways", void 0);

          _defineProperty(this, "_left", 0);

          _defineProperty(this, "_right", 0);

          _defineProperty(this, "_top", 0);

          _defineProperty(this, "_bottom", 0);
        }

        set left(value) {
          if (CC_EDITOR && this.always) {
            this._editoralways = true;
          }

          this._left = value;
          this.execute();
        }

        get left() {
          return this._left;
        }

        set right(value) {
          if (CC_EDITOR && this.always) {
            this._editoralways = true;
          }

          this._right = value;
          this.execute();
        }

        get right() {
          return this._right;
        }

        set top(value) {
          if (CC_EDITOR && this.always) {
            this._editoralways = true;
          }

          this._top = value;
          this.execute();
        }

        get top() {
          return this._top;
        }

        set bottom(value) {
          if (CC_EDITOR && this.always) {
            this._editoralways = true;
          }

          this._bottom = value;
          this.execute();
        }

        get bottom() {
          return this._bottom;
        }

        onLoad() {
          if (CC_EDITOR && this.always) {
            this._editoralways = true;
          }

          this.execute();
        }

        onEnable() {
          if (CC_EDITOR && this.always) {
            if (!this.target.isChildOf(this.node)) {
              this.node.setPosition(v3(0, 0));
            }

            this._editoralways = true;
          }

          this.execute();
        }

        slowUpdate(dt) {
          if (this.always) {
            this.execute();
          }
        }

        execute() {
          if (!this.target || !this.node) return;
          if (CC_EDITOR && !this._editoralways) return;
          if (CC_EDITOR && this._editoralways) this._editoralways = false;
          this.node.getComponent(UITransform).width = this.target.getComponent(UITransform).width - this.left - this.right;
          this.node.getComponent(UITransform).height = this.target.getComponent(UITransform).height - this.top - this.bottom;
          if (!this.target.isChildOf(this.node)) ;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "target", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "always", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return true;
        }
      }), _applyDecoratedDescriptor(_class2.prototype, "left", [_dec3], Object.getOwnPropertyDescriptor(_class2.prototype, "left"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "right", [_dec4], Object.getOwnPropertyDescriptor(_class2.prototype, "right"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "top", [_dec5], Object.getOwnPropertyDescriptor(_class2.prototype, "top"), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, "bottom", [_dec6], Object.getOwnPropertyDescriptor(_class2.prototype, "bottom"), _class2.prototype)), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CoinNotEnoughWindow.ts", ['cc', './Constant.ts', './SoundManager.ts', './UIWindow.ts', './PaySuccessWindow.ts', './MultiplePurchaseWindow.ts', './HomeView.ts', './UIRoot.ts', './LogEventWrap.ts', './PaymentWrap.ts', './AppKit.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, Node, _decorator, MyCustomEvent, SoundManager, UIWindow, PaySuccessWindow, MultiplePurchaseWindow, HomeView, UIRoot, LogEventWrap, PaymentWrap;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      Node = module.Node;
      _decorator = module._decorator;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      SoundManager = module.SoundManager;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      PaySuccessWindow = module.PaySuccessWindow;
    }, function (module) {
      MultiplePurchaseWindow = module.MultiplePurchaseWindow;
    }, function (module) {
      HomeView = module.HomeView;
    }, function (module) {
      UIRoot = module.default;
    }, function (module) {
      LogEventWrap = module.LogEventWrap;
    }, function (module) {
      PaymentWrap = module.PaymentWrap;
    }, function () {}],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fdd11KxtdhFloU4cAXjDrr9", "CoinNotEnoughWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CoinNotEnoughWindow = exports('CoinNotEnoughWindow', (_dec = property(Label), _dec2 = property(Label), _dec3 = property(Node), _dec4 = property(Node), ccclass(_class = (_class2 = (_temp = _class3 = class CoinNotEnoughWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "labelCoin", _descriptor, this);

          _initializerDefineProperty(this, "labelPrice", _descriptor2, this);

          _initializerDefineProperty(this, "spPay", _descriptor3, this);

          _initializerDefineProperty(this, "spPlay", _descriptor4, this);

          _defineProperty(this, "shopMeta", void 0);
        }

        onShow(showParams) {
          this.shopMeta = showParams.meta;
          this.labelCoin.string = "+" + this.shopMeta.Count().toString();
          this.labelPrice.string = this.shopMeta.PriceString();
          this.spPay.active = PaymentWrap.PayEnabled();
          this.spPlay.active = !PaymentWrap.PayEnabled();
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        callBuy() {
          const shopMeta = this.shopMeta;
          PaymentWrap.Pay(this.shopMeta.Name(), ok => {
            if (ok) {
              SoundManager.playSound("item_purchased");
              this.closeAnim(); // if (MultiplePurchaseWindow.OpenMulti()) UIRoot.instance.openChildWindow(MultiplePurchaseWindow, { meta: this.shopMeta });

              eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
              UIRoot.instance.openChildWindow(PaySuccessWindow, {
                from: "coin",
                showCallback: wnd => {
                  wnd.addOnCloseFunc(() => {
                    // UIRoot.instance.closeChildWindow("ShopWindow");
                    if (MultiplePurchaseWindow.OpenMulti()) UIRoot.instance.openChildWindow(MultiplePurchaseWindow, {
                      meta: shopMeta
                    });
                  });
                }
              });
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "coin",
                name: this.shopMeta.Name(),
                phase: 1
              });
            } else {
              LogEventWrap.logEvent("ShopDetail", {
                itemType: "coin",
                name: this.shopMeta.Name(),
                phase: -1
              });
            }
          });
          LogEventWrap.logEvent("ShopDetail", {
            itemType: "coin",
            name: this.shopMeta.Name(),
            phase: 0
          });
        }

        callPlay() {
          this.addOnCloseFunc(function () {
            homeView.pageViewController.moveToPage(HomeView.Pages.Slot); // GameMainWindow.instance.closeAllChildren();
          });
          this.closeAnim();
        }

      }, _defineProperty(_class3, "windowPath", "Shop/CoinNotEnoughWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "labelCoin", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "labelPrice", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spPay", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spPlay", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/SignInWindow.ts", ['cc', './Constant.ts', './global.ts', './_app.ts', './UIWindow.ts', './Content.ts', './SignMeta.ts', './AnimationUtils.ts', './SignInItem.ts', './SR.ts', './SlotResultHandler.ts', './BigNumber.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, ProgressBar, Sprite, SpriteFrame, Prefab, _decorator, Vec3, instantiate, Animation, tween, Label, easing, dragonBones, Tween, MyCustomEvent, G, cce, UIWindow, Content, SignMeta, AnimationUtils, SignInItem, SR, SlotResultHandler, BigNumber;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      ProgressBar = module.ProgressBar;
      Sprite = module.Sprite;
      SpriteFrame = module.SpriteFrame;
      Prefab = module.Prefab;
      _decorator = module._decorator;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
      Animation = module.Animation;
      tween = module.tween;
      Label = module.Label;
      easing = module.easing;
      dragonBones = module.dragonBones;
      Tween = module.Tween;
    }, function (module) {
      MyCustomEvent = module.MyCustomEvent;
    }, function (module) {
      G = module.G;
    }, function (module) {
      cce = module.cce;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      Content = module.Content;
    }, function (module) {
      SignMeta = module.SignMeta;
    }, function (module) {
      AnimationUtils = module.AnimationUtils;
    }, function (module) {
      SignInItem = module.SignInItem;
    }, function (module) {
      SR = module.SR;
    }, function (module) {
      SlotResultHandler = module.default;
    }, function (module) {
      BigNumber = module.BigNumber;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fe4a4SPKs5En7imq9ibymg0", "SignInWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const FAKE_DATA = exports('FAKE_DATA', false);
      const SIGN_DAY = 6;
      const SIGN_DAY_SPECIAL = 1;
      const ROW_MAX_ITEM = 3;
      const spacingX = 20;
      const spacingY = 20;
      const MONTH_DAYS = 28;
      const MONTH_REWARD_DAY = [7, 14, 21, 28];
      let SignInWindow = exports('SignInWindow', (_dec = ccclass('SignInWindow'), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Node), _dec7 = property(ProgressBar), _dec8 = property([Sprite]), _dec9 = property([SpriteFrame]), _dec10 = property(Prefab), _dec11 = property(Node), _dec12 = property([Prefab]), _dec13 = property(Node), _dec14 = property(Node), _dec(_class = (_class2 = (_temp = _class3 = class SignInWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "itemContainer", _descriptor, this);

          _initializerDefineProperty(this, "itemNormal", _descriptor2, this);

          _initializerDefineProperty(this, "itemSpecial", _descriptor3, this);

          _initializerDefineProperty(this, "topNode", _descriptor4, this);

          _initializerDefineProperty(this, "progressPoint", _descriptor5, this);

          _initializerDefineProperty(this, "progress", _descriptor6, this);

          _initializerDefineProperty(this, "giftBoxArr", _descriptor7, this);

          _initializerDefineProperty(this, "boxOpenedSF", _descriptor8, this);

          _initializerDefineProperty(this, "rewardItem", _descriptor9, this);

          _initializerDefineProperty(this, "rewardContainer", _descriptor10, this);

          _initializerDefineProperty(this, "dbBoxes", _descriptor11, this);

          _initializerDefineProperty(this, "btnCollectNode", _descriptor12, this);

          _initializerDefineProperty(this, "labelCollectNode", _descriptor13, this);

          _defineProperty(this, "signData", null);

          _defineProperty(this, "_allSignItem", []);

          _defineProperty(this, "_canCollect", false);

          _defineProperty(this, "upVec3", new Vec3(0, 5, 0));

          _defineProperty(this, "downVec3", new Vec3(0, -5, 0));

          _defineProperty(this, "nodeHadClicked", true);
        }

        onEnable() {
          this.node.on(Node.EventType.TOUCH_END, this._closeWindow, this, true);
        }

        onDisable() {
          this.node.off(Node.EventType.TOUCH_END, this._closeWindow, this, true);
        }

        async onShow(para) {
          await this._getSignInData();

          this._initItems();

          this._showEntrance();

          this._updateProgress();

          this.checkMonthRewards(null);
        }

        _getSignInData() {
          return new Promise((res, rej) => {
            // old_data
            if (this.signData) {
              res(this.signData);
              return;
            }

            {
              // real-data
              let sr = SR.SRSign.getSignData();
              sr.SetCallBack(v => {
                this.signData = v.sign;
                this._canCollect = this.signData.signWeekDay > this.signData.signWeekRewards;
                res(this.signData);
              });
              sr.SetErrorCallBack(() => {
                rej();
              });
              sr.Send();
            }
          });
        }

        _initItems() {
          if (!this.signData) return;
          let newItem;
          let signItem;
          let signInData;
          let meta;
          let row;
          let column;

          for (let i = 1; i <= SIGN_DAY + SIGN_DAY_SPECIAL; i++) {
            row = Math.floor((i - 1) / ROW_MAX_ITEM) - (ROW_MAX_ITEM - 2) / 2;
            column = (i - 1) % ROW_MAX_ITEM - (ROW_MAX_ITEM - 1) / 2;
            newItem = instantiate(i <= SIGN_DAY ? this.itemNormal : this.itemSpecial);
            newItem.parent = this.itemContainer;

            if (i <= SIGN_DAY) {
              newItem.setPosition((newItem.width + spacingX) * column, -(newItem.height + spacingY) * row, 0);
            } else {
              newItem.setPosition(0, -(newItem.height + spacingY) * row, 0);
            }

            newItem.active = true;
            newItem.opacity = 0;
            signItem = newItem.getComponent(SignInItem);
            meta = SignMeta.GetByTypeDay(SignMeta.Types.Week, i.toString());
            signInData = {
              days: i,
              canCollect: i === this.signData.signWeekDay && i > this.signData.signWeekRewards,
              isCollected: i < this.signData.signWeekDay || i <= this.signData.signWeekRewards,
              rewards: meta.Reward()
            };
            signItem.setData(signInData, this);

            this._allSignItem.push(newItem);
          }
        }

        async _showEntrance() {
          this.topNode.getComponent(Animation).play("signTop");
          this.topNode.getComponent(Animation).once(Animation.EventType.FINISHED, () => {
            this.schedule(() => {
              this.progressPoint.getComponent(Animation).play("signBadgeShake");
            }, 5);
          }, this);
          this.scheduleOnce(async () => {
            for (let i = 0; i < this._allSignItem.length; i++) {
              await this._allSignItem[i].getComponent(SignInItem).playShow();
            }

            tween(this.labelCollectNode).set({
              active: true,
              opacity: 0
            }).to(0.5, {
              opacity: 255
            }).start();
            this.nodeHadClicked = false;
          }, 0.17);
        }

        async showMarchOut() {
          this._updateProgress(1);

          for (let i = 0; i < this._allSignItem.length; i++) {
            await this._allSignItem[i].getComponent(SignInItem).playHide();
          }

          this.topNode.getComponent(Animation).play("signTopHide");
          await this.checkMonthRewards(null, this.signData.signMonthDay);
          tween(this.labelCollectNode).set({
            active: true,
            opacity: 255
          }).to(0.5, {
            opacity: 0
          }).call(() => {
            this.labelCollectNode.active = false;
          }).start();
          this.closeAnim();
        }

        async _updateProgress(delta) {
          if (delta) {
            const pro = {
              value: this.signData.signMonthDay - 1
            };
            tween(pro).to(0.25, {
              value: this.signData.signMonthDay
            }, {
              onUpdate: () => {
                this.progress.progress = pro.value / MONTH_DAYS;
              }
            }).start();
          } else if (this.signData.signWeekRewards >= this.signData.signWeekDay) {
            this.progress.progress = this.signData.signMonthDay / MONTH_DAYS;
          } else {
            this.progress.progress = (this.signData.signMonthDay - 1) / MONTH_DAYS;
          }
        }

        async checkMonthRewards(event, day) {
          day = typeof day === "number" ? day : parseInt(day);
          return new Promise(async (resolve, reject) => {
            if (!day) {
              resolve(null);
              this.giftBoxArr.forEach((box, index) => {
                if (this.signData.signMonthRewards.indexOf(MONTH_REWARD_DAY[index]) !== -1) {
                  box.spriteFrame = this.boxOpenedSF[index];
                } else if (this.signData.signMonthDay >= MONTH_REWARD_DAY[index]) {
                  tween(box.node).by(0.25, {
                    position: this.upVec3
                  }).by(0.35, {
                    position: this.downVec3
                  }).by(0.2, {
                    position: this.upVec3
                  }).by(0.3, {
                    position: this.downVec3
                  }).delay(1).union().repeatForever().start();
                }
              });
            } else {
              if (this.signData.signMonthDay >= day && MONTH_REWARD_DAY.indexOf(day) !== -1) {
                this.signData.signMonthRewards.push(day);
                {
                  // real-data
                  appGame.isSignInReward = true;
                  let sr = SR.SRSign.receiveSignMonthReward(day);
                  sr.SetCallBack(async v => {
                    await this._playBoxAnim(day);
                    await cce.wait(500);
                    resolve(v);
                  });
                  sr.SetErrorCallBack(() => {
                    reject();
                  });
                  sr.Send();
                }
              } else {
                resolve(null);
              }
            }
          });
        }

        _playCardFlyAnim(content, startNode) {
          return new Promise(async resolve => {
            this.rewardContainer.active = true;
            this.rewardContainer.destroyAllChildren();
            const contents = Content.Merge(content);

            for (let i = 0; i < contents.length; i++) {
              let content = Content.FromContent(contents[i]);
              let newItem = instantiate(this.rewardItem);
              this.rewardContainer.addChild(newItem);
              newItem.setScale(0, 0, 0);
              const itemContent = newItem.getChildByName("content");
              let labelName = itemContent.getChildByName("labelName").getComponent(Label);
              let labelCount = itemContent.getChildByName("labelNum").getComponent(Label);
              let icon = itemContent.getChildByName("icon").getComponent(Sprite);
              labelCount.string = BigNumber.format(content.Count());
              labelName.string = content.Name();
              content.Icon(icon, nullFunction);
            }

            await cce.wait(500);

            for (let i = 0; i < this.rewardContainer.children.length; i++) {
              await this.playOnce(this.rewardContainer.children[i], startNode);

              if (i === this.rewardContainer.children.length - 1) {
                await cce.wait(1000);
                resolve(null);
              }
            }
          });
        }

        playOnce(rewardItem, startNode) {
          /**
           * phase1： 到达指定位置时，缩放比最终缩放要大一些，此时的缩放
           * phase2： 到达指定位置后，还需要缩小一次，此时的缩放
           */
          return new Promise((resolve, reject) => {
            let startPos = new Vec3();
            this.rewardContainer.inverseTransformPoint(startPos, startNode.getWorldPosition());
            const endPos = rewardItem.getPosition();
            tween(rewardItem).set({
              position: startPos,
              scale: Vec3.ZERO
            }).parallel(tween().to(0.3, {
              position: endPos
            }, {
              easing: easing.quartOut
            }), tween().to(0.2, {
              scale: G.scale1_05
            })).call(() => {
              resolve(null);
            }).to(0.1, {
              scale: G.scale0_95
            }).to(0.1, {
              scale: Vec3.ONE
            }).start();
          });
        }

        _playBoxAnim(day) {
          return new Promise(resolve => {
            const box = instantiate(this.dbBoxes[MONTH_REWARD_DAY.indexOf(day)]);
            let loopFrame = 0;
            const dbBox = box.getComponent(dragonBones.ArmatureDisplay);
            this.node.addChild(box);
            Tween.stopAllByTarget(box);
            tween(box).set({
              scale: G.scale0_3,
              position: new Vec3(0, 200, 0)
            }).to(0.5, {
              scale: G.scale1_2,
              position: new Vec3(0, 150, 0)
            }).to(0.5, {
              scale: Vec3.ONE,
              position: new Vec3(0, -300, 0)
            }, {
              easing: easing.quartIn
            }).call(async () => {
              dbBox.on(dragonBones.EventObject.COMPLETE, event => {
                if (dbBox.animationName === "open") {
                  dbBox.armature().animation.gotoAndPlayByFrame("open", loopFrame, 1);
                }
              }, this);
              dbBox.on(dragonBones.EventObject.FRAME_EVENT, event => {
                if (event.name === "light") {
                  loopFrame = SlotResultHandler.getFrameEventFrame(dbBox.dragonAsset, dbBox.animationName, "light");
                }
              }, this);
              dbBox.timeScale = 1;
              dbBox.playAnimation("open", 1);
              await this._playCardFlyAnim(SignMeta.GetByTypeDay(SignMeta.Types.Month, day.toString()).Reward(), box);
              this.btnCollectNode.active = true;
              this.btnCollectNode.once("click", async () => {
                this.rewardContainer.destroy();
                this.btnCollectNode.active = false;
                await AnimationUtils.playGetRewardsAnim(SignMeta.GetByTypeDay(SignMeta.Types.Month, day.toString()).Reward());
                eventCenter.emit(MyCustomEvent.ReadyChangeCoin);
                eventCenter.emit(MyCustomEvent.CanChangeSpin);
                box.destroy();
                resolve(null);
              }, this);
            }).start();
          });
        }

        async _closeWindow() {
          if (this.nodeHadClicked) return;
          this.nodeHadClicked = true;

          if (this._canCollect) {
            this.nodeHadClicked = false;
            await this._allSignItem[this.signData.signWeekDay - 1].getComponent(SignInItem).onClick();
          } else {
            for (let i = 0; i < this._allSignItem.length; i++) {
              await this._allSignItem[i].getComponent(SignInItem).playHide();
            }

            this.topNode.getComponent(Animation).play("signTopHide");
            this.topNode.getComponent(Animation).once(Animation.EventType.FINISHED, () => {
              this.closeAnim();
            }, this);
          }
        }

        onClose() {
          this.nodeHadClicked = false;
        }

      }, _defineProperty(_class3, "windowPath", "Quest/SignInWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "itemContainer", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "itemNormal", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "itemSpecial", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "topNode", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "progressPoint", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "progress", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "giftBoxArr", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "boxOpenedSF", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "rewardItem", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "rewardContainer", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "dbBoxes", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "btnCollectNode", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "labelCollectNode", [_dec14], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/BezierDraw.ts", ['cc', './CCE_Component.ts', './FuncTools.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Vec2, Vec3, instantiate, v2, CCE_Component, FuncTools;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Vec2 = module.Vec2;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
      v2 = module.v2;
    }, function (module) {
      CCE_Component = module.CCE_Component;
    }, function (module) {
      FuncTools = module.FuncTools;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "fe721KRjgNJvakFQBw+ZYB+", "BezierDraw", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      /** 根据4个点绘制贝塞尔曲线，并使用图片填充
       * - 4个控制点
       * - 填充图片
       * - 填充间隔
       */

      let BezierDraw = exports('default', (_dec = property({
        tooltip: "起点"
      }), _dec2 = property({
        tooltip: "终点"
      }), _dec3 = property({
        tooltip: "靠近起点的控制点"
      }), _dec4 = property({
        tooltip: "靠近终点的控制点"
      }), _dec5 = property({
        type: Node,
        tooltip: "填充图片（使用节点封装，大小请在节点中改好）"
      }), _dec6 = property({
        tooltip: "填充个数"
      }), _dec7 = property({
        tooltip: "点击后刷新1次，刷新后自动为false"
      }), ccclass(_class = executeInEditMode(_class = (_class2 = (_temp = class BezierDraw extends CCE_Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "p_start", _descriptor, this);

          _initializerDefineProperty(this, "p_end", _descriptor2, this);

          _initializerDefineProperty(this, "p_start_control", _descriptor3, this);

          _initializerDefineProperty(this, "p_end_control", _descriptor4, this);

          _initializerDefineProperty(this, "sf_node", _descriptor5, this);

          _initializerDefineProperty(this, "fill_number", _descriptor6, this);

          _initializerDefineProperty(this, "UPDATE", _descriptor7, this);

          _defineProperty(this, "item_array", void 0);
        }

        slowUpdate(dt) {
          if (this.UPDATE) {
            this.UPDATE = false;
            this.create_all_item();
            this.change_all_item_rotation();
          }
        }
        /** 创建曲线并填充图片 */


        create_all_item() {
          // 清理
          this.node.destroyAllChildren();
          /** @type {[cc.Node]} 所有piece的数组 */

          this.item_array = Array.of(); // 创造

          for (let i = 0; i < this.fill_number; i++) {
            let node = instantiate(this.sf_node);
            node.active = true;
            node.parent = this.node;
            node.position = this.B(i / (this.fill_number - 1), this.p_start, this.p_start_control, this.p_end_control, this.p_end);
            this.item_array.push(node);
          }
        }
        /** 更改所有item的角度
         * - 优先寻找下一个点，如果没有下一个点，则寻找前一个点
         * - 计算两个点直接连线的角度
         */


        change_all_item_rotation() {
          for (let i = 0; i < this.item_array.length; i++) {
            let p = this.item_array[i].position;
            let pnext;

            if (this.item_array[i - 1] === undefined) {
              pnext = this.item_array[i + 1].position;
            } else {
              pnext = this.item_array[i - 1].position;
            }

            let psub = p.subtract(pnext);
            this.item_array[i].angle = FuncTools.Vector2ToAngle(psub.x, psub.y) + 90; // 注意+90，API的返回值是针对于Y轴的角度
          }
        }
        /**
         * 贝塞尔曲线公式
         * @param {number} t [0,1]
         * @param {cc.Vec2} p0 起点
         * @param {cc.Vec2} p1 控制点1
         * @param {cc.Vec2} p2 控制点2
         * @param {cc.Vec2} p3 终点
         * @returns {cc.Vec2} 曲线上的点
         */


        B(t, p0, p1, p2, p3) {
          let px = p0.x * Math.pow(1 - t, 3) + 3 * p1.x * t * Math.pow(1 - t, 2) + 3 * p2.x * Math.pow(t, 2) * (1 - t) + p3.x * Math.pow(t, 3);
          let py = p0.y * Math.pow(1 - t, 3) + 3 * p1.y * t * Math.pow(1 - t, 2) + 3 * p2.y * Math.pow(t, 2) * (1 - t) + p3.y * Math.pow(t, 3);
          return v2(px, py);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "p_start", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return Vec2.ZERO;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "p_end", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return Vec3.RIGHT;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "p_start_control", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return Vec3.UP;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "p_end_control", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return Vec3.UP.add(Vec3.RIGHT);
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sf_node", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "fill_number", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 8;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "UPDATE", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Item2.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      cclegacy._RF.push({}, "fee7fD7pjhMSLenqVLt2N5W", "Item", undefined); //道具


      class Item {
        constructor() {
          _defineProperty(this, "data", void 0);

          this.data = {
            itemId: 0
          };
        } //更新数据


        updateData(data) {
          if (data == null) return;

          for (let key in data) {
            this.data[key] = data[key];
          }

          return this;
        } //获得数据


        getData() {
          let data = {};

          for (var key in this.data) {
            data[key] = this.data[key];
          }

          return data;
        } //设置某项数据


        setData(key, value) {
          this.data[key] = value;
          return this;
        }

      }

      exports('Item', Item);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/CardGoldTradeWindow.ts", ['cc', './UIWindow.ts', './CardModel.ts', './StaticGame.ts', './GameKit.ts', './i18n.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, _decorator, UIWindow, CardModel, Meta, Game, GameKit, i18n;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      _decorator = module._decorator;
    }, function (module) {
      UIWindow = module.default;
    }, function (module) {
      CardModel = module.default;
    }, function (module) {
      Meta = module.Meta;
      Game = module.Game;
    }, function (module) {
      GameKit = module.GameKit;
    }, function (module) {
      i18n = module.i18n;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _class3, _temp;

      function _initializerDefineProperty(target, property, descriptor, context) {
        if (!descriptor) return;
        Object.defineProperty(target, property, {
          enumerable: descriptor.enumerable,
          configurable: descriptor.configurable,
          writable: descriptor.writable,
          value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
        });
      }

      function _defineProperty(obj, key, value) {
        if (key in obj) {
          Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
          });
        } else {
          obj[key] = value;
        }

        return obj;
      }

      function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
        var desc = {};
        Object.keys(descriptor).forEach(function (key) {
          desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;

        if ('value' in desc || desc.initializer) {
          desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function (desc, decorator) {
          return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0) {
          desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
          desc.initializer = undefined;
        }

        if (desc.initializer === void 0) {
          Object.defineProperty(target, property, desc);
          desc = null;
        }

        return desc;
      }

      cclegacy._RF.push({}, "ff70fbx+6VAKp9JT1xqziHN", "CardGoldTradeWindow", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CardGoldTradeWindow = exports('CardGoldTradeWindow', (_dec = property(CardModel), _dec2 = property(Node), _dec3 = property(CardModel), _dec4 = property(Node), _dec5 = property(Label), _dec6 = property(Label), ccclass(_class = (_class2 = (_temp = _class3 = class CardGoldTradeWindow extends UIWindow {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "card1", _descriptor, this);

          _initializerDefineProperty(this, "cardNew1", _descriptor2, this);

          _initializerDefineProperty(this, "card2", _descriptor3, this);

          _initializerDefineProperty(this, "cardNew2", _descriptor4, this);

          _initializerDefineProperty(this, "labelName", _descriptor5, this);

          _initializerDefineProperty(this, "labelTimer", _descriptor6, this);

          _defineProperty(this, "meta", void 0);

          _defineProperty(this, "leftTime", void 0);
        }

        onShow(showParams) {
          this.meta = showParams.meta;
          let cardId1 = this.meta.Param().cardId1;
          this.card1.show(cardId1, "no-check");
          this.card1.show_more_count("check");
          let cardMeta1 = Meta.MetaManager.GetMeta(Meta.MetaType.Card, cardId1);
          this.cardNew1.active = Game.SUserCard.CardNum(cardId1) <= 0;
          let cardId2 = this.meta.Param().cardId2;
          this.card2.show(cardId2, "no-check");
          this.card2.show_more_count("check");
          let cardMeta2 = Meta.MetaManager.GetMeta(Meta.MetaType.Card, cardId2);
          this.cardNew2.active = Game.SUserCard.CardNum(cardId2) <= 0;
          this.labelName.string = cardMeta1.Name() + " & " + cardMeta2.Name();
          this.leftTime = 0;
          this.slowUpdate(0);
        }

        onClose() {}

        callClose() {
          this.closeAnim();
        }

        slowUpdate(arg) {
          if (this.leftTime != null) {
            let currentTime = GameKit.TimeUtil.getCurrentTime();
            this.leftTime = this.meta.EndTime() - currentTime;
            this.labelTimer.string = i18n.t("ActivityTimeleft") + " " + GameKit.TimeUtil.FormatRemainTimeSimple(this.leftTime, false);

            if (this.leftTime <= 0) {
              this.leftTime = null;
            }
          }
        }

      }, _defineProperty(_class3, "windowPath", "Card/CardGoldTradeWindow"), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "card1", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "cardNew1", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "card2", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "cardNew2", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "labelName", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "labelTimer", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/main", ['./Constant.ts', './ReuseItem.ts', './ReuseScrollView.ts', './NativeLog.ts', './CCE_Component.ts', './EnergyFullAnim.ts', './LabelItem.ts', './CharacterLevelEditor.ts', './CCEaseTypes.ts', './ShieldAnim.ts', './global.ts', './Logs.ts', './fbIn_lib.ts', './wx_lib.ts', './yzAd.ts', './UICantClick.ts', './_app.ts', './BlinkAnim.ts', './EnterCloseAnim.ts', './LongScreenFit.ts', './LoopMoveAnim.ts', './MoveAnim.ts', './RotateAnim.ts', './ScaleAnim.ts', './ShakeAnim.ts', './SkewAnim.ts', './ThirdMenuFit.ts', './CCTools.ts', './BackKeyManager.ts', './audioEngine.ts', './SoundManager.ts', './PlayAudio.ts', './UIWindow.ts', './LabelTwoColor.ts', './SpriteGray.ts', './ContentModel.ts', './fixedSizeRatio.ts', './ResourceLoader.ts', './CommonAssets.ts', './Content.ts', './LocalizationMeta.ts', './ActivityParamsMeta.ts', './CardChestMeta.ts', './CardMeta.ts', './CardSetsMeta.ts', './DailyBonusRewardMeta.ts', './DynamicPackMeta.ts', './ItemMeta.ts', './PackItemMeta.ts', './SignMeta.ts', './TaskMeta.ts', './ServantRankMeta.ts', './ShopCardPriceMeta.ts', './ShopCoinMeta.ts', './ShopMeta.ts', './GiftGetMeta.ts', './LevelBonusMeta.ts', './AdGetCoinMeta.ts', './SystemUserMeta.ts', './VillageMeta.ts', './VillageShopMeta.ts', './MetaManager.ts', './PlayGetAnimation.ts', './StringUtil.ts', './SRJigsaw.ts', './SRActivity.ts', './SRActivityBlackJack.ts', './SRActivityCannon.ts', './SRActivityHeist.ts', './SRMinigame.ts', './SRMinigameCoinhit.ts', './SRCard.ts', './User.ts', './ChatMessage.ts', './ChatMgr.ts', './SRChat.ts', './SRDailyBonus.ts', './SRItems.ts', './AppCommentWindow.ts', './WheelNode.ts', './ChangeSceneManager.ts', './DailyBonusNode.ts', './GameEvent.ts', './NumAnim.ts', './UserInfoModel.ts', './InvitedNewUserWindow.ts', './UserVillage.ts', './CardInfoWindow.ts', './LocalizedManager.ts', './CardModel.ts', './DialogWindow.ts', './CardNewFriendItem.ts', './CardNewFriendsWindow.ts', './CardAskSendWindow.ts', './CardSingleSetWindow.ts', './CardItem.ts', './CardAllSetWindow.ts', './ResourceTextureLoader.ts', './villageTextureLoader.ts', './PaySuccessWindow.ts', './ActivitySalePackWindow.ts', './WatchGetCoinWindow.ts', './WatchGetSpinWindow.ts', './MultiplePurchaseWindow.ts', './ApNotEnoughWindow.ts', './CameraController3d.ts', './ShakeCamera.ts', './Container3d.ts', './ContainerVillage.ts', './AutomaticDoor.ts', './NodeRecovery.ts', './Room.ts', './RoomManager.ts', './SwitchMaterial.ts', './Pet.ts', './StateMachine.ts', './PetStateMachine.ts', './PetStateIdle.ts', './PetStateWander.ts', './PetStateLieDown.ts', './PetStateFollowing.ts', './PetStateGetUp.ts', './SlotPet.ts', './Player.ts', './SlotCollectExtra.ts', './PlayerPrefs.ts', './AnimationUtils.ts', './ChildWindowChain.ts', './GetRewardWindow.ts', './ActivitySlotSymbolRankRewardWindow.ts', './ActivitySlotSymbolRankWindow.ts', './SlotActivityNode.ts', './TutorialWindow.ts', './TutorialManager.ts', './CoinAnim.ts', './RaidAnim.ts', './ShieldBreakAnim.ts', './SpinAnim.ts', './SlotPeter.ts', './SlotNode.ts', './ActivityGameShowWindow.ts', './ActivitySlotSymbolRankInfoWindow.ts', './ActivitySlotSymbolShowWindow.ts', './HeistData.ts', './CardSystemOpenWindow.ts', './SimpleRewardWindow.ts', './UserActivity.ts', './UserCard.ts', './UserItems.ts', './UserRecord.ts', './UserServant.ts', './UserSlot.ts', './UserStatus.ts', './UserTutorial.ts', './AppGame.ts', './FacebookBindWindow.ts', './InviteWindow.ts', './CommunityItem.ts', './CardCollectWindow.ts', './CommunityCardItem.ts', './CommunityFriendWindow.ts', './GiftsWindow.ts', './ScrollViewItem.ts', './ScrollViewTool.ts', './UITabNode.ts', './UITabContainer.ts', './MessageMailDetailWindow.ts', './VillageNewsWindow.ts', './AutoSpinTipWindow.ts', './Page.ts', './CardPage.ts', './FriendPage.ts', './ShopPage.ts', './Rotate3D.ts', './ContainerServant.ts', './FullLoadingWindow.ts', './ServantWindow.ts', './ContainerSlot.ts', './RenderUIToModel.ts', './ToRaidUserNode.ts', './BadgeItem.ts', './TimeUtil.ts', './CustomToggle.ts', './NewActivityCenterWindow.ts', './SignInItem.ts', './SignInWindow.ts', './LeaderboardWindow.ts', './FollowWindow.ts', './TouchTest.ts', './SettingWindow.ts', './MenuWindow.ts', './LuckyDrawWindow.ts', './LevelBonusWindow.ts', './QuestCheckPage.ts', './LoadingWindow.ts', './QuestDailyPage.ts', './QuestInvitePage.ts', './QuestCenterWindow.ts', './ContentDesWindow.ts', './FirstPurchaseWindow.ts', './NewPlayerPackWindow.ts', './SlotPage.ts', './VillageUpgradeBtn.ts', './VillagePage.ts', './ServantSystemOpenWindow.ts', './SdkManager.ts', './BetAnimationScript.ts', './ButtonSearch.ts', './NestPageView.ts', './ButtonScaleScript.ts', './PageViewController.ts', './HomeView.ts', './CoinNotEnoughWindow.ts', './SimpleItemBuyWindow.ts', './ContentCheck.ts', './VillageShopItem.ts', './VillageShopWindow.ts', './VillageAttackBtn.ts', './VillageNode.ts', './DownloadingWindow.ts', './MapItem.ts', './NewMapWindow.ts', './VillageFinishWindow.ts', './GameMainWindow.ts', './SRSign.ts', './SRTask.ts', './SRRecord.ts', './SRServant.ts', './SRShop.ts', './SRInteraction.ts', './SRSlot.ts', './SRSocial.ts', './SRStatus.ts', './SRTutorial.ts', './SRLogin.ts', './SRUserData.ts', './SRUserInfo.ts', './SRVillage.ts', './SR.ts', './CountDownWindow.ts', './SlotResultHandler.ts', './CardModelChestOpen.ts', './CardChestOpenWindow.ts', './VIPDailyRewardWindow.ts', './VIPGetWindow.ts', './VIPExtraRewardWindow.ts', './CardChestInfoWindow.ts', './ShopChestItem.ts', './ShopCoinItem.ts', './ShopShieldItem.ts', './ShopSpinItem.ts', './ShopTreatItem.ts', './ShopWindow.ts', './ActivityDaysSaleWindow.ts', './ActivitySpecialOfferWindow.ts', './BlackJackAssets.ts', './BlackJackHelpWindow.ts', './BlackJackWatchWindow.ts', './BlackJackMainWindow.ts', './ClockUtil.ts', './CannonCommonAsset.ts', './CannonData.ts', './CannonGetRewardWindow.ts', './FriendsModel.ts', './CannonSendItemWindow.ts', './CannonUseMagicItemWindow.ts', './CannonItemWindow.ts', './CannonMessageWindow.ts', './CannonShopWindow.ts', './CannonTool.ts', './CannonMainWindow.ts', './HeistMainWindow.ts', './JigsawNewsWindow.ts', './JigsawWindowGift.ts', './JigsawWindowMain.ts', './JigsawFriendsWindow.ts', './JigsawWindowPiece.ts', './JigsawWindow.ts', './MinigameBuyTicketWindow.ts', './MinigameRankWindow.ts', './MinigameTools.ts', './MinigameCoinhitBall.ts', './MinigameCoinhitBlock.ts', './MinigameCoinhitPrefabMgr.ts', './MinigameCoinhitGameplay.ts', './MinigameCoinhitData.ts', './MinigameCoinhitInfoWindow.ts', './MinigameCoinhitMainWindow.ts', './CardGoldTradeWindow.ts', './UIRoot.ts', './ActivityBadge.ts', './ActivityManager.ts', './ActivityMeta.ts', './TutorialMeta.ts', './StaticGame.ts', './LogEventWrap.ts', './ADWrap.ts', './yzLeaderboard.ts', './LeaderBoardWrap.ts', './NativeWrap.ts', './NotificationWrap.ts', './ErrorCode.ts', './PayFailWindow.ts', './PaymentWrap.ts', './CocosHack.ts', './ShareWrap.ts', './HotUpdator.ts', './base64.ts', './encryptCode.ts', './AppUpdateWindow.ts', './GuestConfirmWindow.ts', './LZString.ts', './LoginWindow.ts', './UserWrap.ts', './AppKit.ts', './WebEvent.ts', './BatchRequest.ts', './DownloadRequest.ts', './NetRequest.ts', './ServerRequest.ts', './DataCache.ts', './FuncTools.ts', './Item.ts', './ControllerTable.ts', './GameKit.ts', './BigNumber.ts', './polyglot.ts', './i18n.ts', './NewTutorilaWindow.ts', './NewTutorialManager.ts', './AppMain.ts', './DamageParticle.ts', './Bomb.ts', './ContainerInteraction.ts', './RaidNode.ts', './ServantNode.ts', './RevengeWindow.ts', './InteractionUI.ts', './InteractionNode.ts', './HelpManager.ts', './HelpWindow.ts', './ja.ts', './StarBlink.ts', './BuildKingExtra.ts', './ar.ts', './CardSelectCardWindow.ts', './setZIndex.ts', './setAliasTexParameters.ts', './fr.ts', './ExecuteTime.ts', './SlotItemNode.ts', './ccExtention.ts', './LabelGradient.ts', './ExtraRewardWindow.ts', './AdvancedWidget.ts', './SlotSkinNode.ts', './EditorVillageChecker.ts', './DB.ts', './birdMgr.ts', './DebugScript.ts', './AdjustBuildPos.ts', './EditorVillageHelper.ts', './RaidKingExtra.ts', './SpinBtn.ts', './es.ts', './VillageIconNode.ts', './EventListener.ts', './remoteDownloader.ts', './JigsawWindowUniversal.ts', './Rotate.ts', './CannonGameplay.ts', './RichTextHandler.ts', './CardSelectFriendWindow.ts', './CheckSystemOpen.ts', './Action.ts', './CocosWrap.ts', './ActivitySlotSymbolRankItem.ts', './ShopIconNode.ts', './SlotServantNode.ts', './index.ts', './CardGoldTradeExtra.ts', './MinigameCoinhitDoorWindow.ts', './CCLabelMaxLines.ts', './CommunityFriendItem.ts', './MainTutorialFinishWindow.ts', './TestScene.ts', './ShopLevelBonusItem.ts', './SettingLanguageWindow.ts', './Test.ts', './VVConsole.ts', './zh.ts', './SpineAnim.ts', './SprCamera.ts', './de.ts', './tsExtention.ts', './en.ts', './FramesParticle.ts', './CCActionExtention.ts', './vconsole.min.ts', './AnimOverDestroy.ts', './AttackAnim.ts', './md5.ts', './PeterOpenWindow.ts', './LabelShadow.ts', './HelpButton.ts', './AttackKingExtra.ts', './SuperShieldOpenWindow.ts', './BetAnim.ts', './ShowNodeArrayAnim.ts', './AnimaSkiresorts.ts', './CCButtonAutoGreyLabel.ts', './DotAnimLabel.ts', './OffsetAnim.ts', './ObjsNode.ts', './ko.ts', './ActivityCenterWindow.ts', './CutScrollViewDrawcall.ts', './SlotColNode.ts', './TimeDestroy.ts', './GMTools.ts', './UpdatePanel.ts', './HoldSpinBtn.ts', './vconsole.min2.ts', './FlashEffect.ts', './AddPrefab.ts', './ParticleAnim.ts', './AutoSize.ts', './CurrencyCodeInfo.ts', './LabelLocalized.ts', './BackGroundManager.ts', './AnimaLittlematch.ts', './AnimaBeachsoccer.ts', './LabelLocalizedFormat.ts', './CustomWidget.ts', './BezierDraw.ts', './Item2.ts'], function () {
  'use strict';

  return {
    setters: [function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}, function () {}],
    execute: function () {}
  };
});

(function(r) {
  r('virtual:///prerequisite-imports/main', 'chunks:///_virtual/main'); 
})(function(mid, cid) {
    System.register(mid, [cid], function (_export, _context) {
    return {
        setters: [function(_m) {
            var _exportObj = {};

            for (var _key in _m) {
              if (_key !== "default" && _key !== "__esModule") _exportObj[_key] = _m[_key];
            }
      
            _export(_exportObj);
        }],
        execute: function () { }
    };
    });
});
//# sourceMappingURL=index.js.map